/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(J){for(var e=[],P=0,R=J.length;P<R;P++)e[P]=re[J[P]];return e};define(re[134],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(m,$,g){const h=R(m,$);if(h!==-1)return m[h]}e.$fb=P;function R(m,$,g=m.length-1){for(let h=g;h>=0;h--){const a=m[h];if($(a))return h}return-1}e.$gb=R;function s(m,$){const g=M(m,$);return g===-1?void 0:m[g]}e.$hb=s;function M(m,$,g=0,h=m.length){let a=g,E=h;for(;a<E;){const f=Math.floor((a+E)/2);$(m[f])?a=f+1:E=f}return a-1}e.$ib=M;function D(m,$){const g=S(m,$);return g===m.length?void 0:m[g]}e.$jb=D;function S(m,$,g=0,h=m.length){let a=g,E=h;for(;a<E;){const f=Math.floor((a+E)/2);$(m[f])?E=f:a=f+1}return a}e.$kb=S;function d(m,$,g=0,h=m.length){const a=S(m,$,g,h);return a===m.length?-1:a}e.$lb=d;class u{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(u.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!$(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const g=M(this.e,$,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=u;function p(m,$){if(m.length===0)return;let g=m[0];for(let h=1;h<m.length;h++){const a=m[h];$(a,g)>0&&(g=a)}return g}e.$nb=p;function v(m,$){if(m.length===0)return;let g=m[0];for(let h=1;h<m.length;h++){const a=m[h];$(a,g)>=0&&(g=a)}return g}e.$ob=v;function b(m,$){return p(m,(g,h)=>-$(g,h))}e.$pb=b;function l(m,$){if(m.length===0)return-1;let g=0;for(let h=1;h<m.length;h++){const a=m[h];$(a,m[g])>0&&(g=h)}return g}e.$qb=l;function y(m,$){for(const g of m){const h=$(g);if(h!==void 0)return h}}e.$rb=y}),define(re[135],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function P(D,S){const d=Object.create(null);for(const u of D){const p=S(u);let v=d[p];v||(v=d[p]=[]),v.push(u)}return d}e.$K=P;function R(D,S){const d=[],u=[];for(const p of D)S.has(p)||d.push(p);for(const p of S)D.has(p)||u.push(p);return{removed:d,added:u}}e.$L=R;function s(D,S){const d=[],u=[];for(const[p,v]of D)S.has(p)||d.push(v);for(const[p,v]of S)D.has(p)||u.push(v);return{removed:d,added:u}}e.$M=s;function M(D,S){const d=new Set;for(const u of S)D.has(u)&&d.add(u);return d}e.$N=M}),define(re[136],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=void 0;function P(S,d){const u=Math.pow(10,d);return Math.round(S*u)/u}class R{constructor(d,u,p,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=P(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.r===u.r&&d.g===u.g&&d.b===u.b&&d.a===u.a}}e.$7s=R;class s{constructor(d,u,p,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.l=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.l===u.l&&d.a===u.a}static fromRGBA(d){const u=d.r/255,p=d.g/255,v=d.b/255,b=d.a,l=Math.max(u,p,v),y=Math.min(u,p,v);let m=0,$=0;const g=(y+l)/2,h=l-y;if(h>0){switch($=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),l){case u:m=(p-v)/h+(p<v?6:0);break;case p:m=(v-u)/h+2;break;case v:m=(u-p)/h+4;break}m*=60,m=Math.round(m)}return new s(m,$,g,b)}static i(d,u,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?d+(u-d)*6*p:p<1/2?u:p<2/3?d+(u-d)*(2/3-p)*6:d}static toRGBA(d){const u=d.h/360,{s:p,l:v,a:b}=d;let l,y,m;if(p===0)l=y=m=v;else{const $=v<.5?v*(1+p):v+p-v*p,g=2*v-$;l=s.i(g,$,u+1/3),y=s.i(g,$,u),m=s.i(g,$,u-1/3)}return new R(Math.round(l*255),Math.round(y*255),Math.round(m*255),b)}}e.$8s=s;class M{constructor(d,u,p,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=P(Math.max(Math.min(1,u),0),3),this.v=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.v===u.v&&d.a===u.a}static fromRGBA(d){const u=d.r/255,p=d.g/255,v=d.b/255,b=Math.max(u,p,v),l=Math.min(u,p,v),y=b-l,m=b===0?0:y/b;let $;return y===0?$=0:b===u?$=((p-v)/y%6+6)%6:b===p?$=(v-u)/y+2:$=(u-p)/y+4,new M(Math.round($*60),m,b,d.a)}static toRGBA(d){const{h:u,s:p,v,a:b}=d,l=v*p,y=l*(1-Math.abs(u/60%2-1)),m=v-l;let[$,g,h]=[0,0,0];return u<60?($=l,g=y):u<120?($=y,g=l):u<180?(g=l,h=y):u<240?(g=y,h=l):u<300?($=y,h=l):u<=360&&($=l,h=y),$=Math.round(($+m)*255),g=Math.round((g+m)*255),h=Math.round((h+m)*255),new R($,g,h,b)}}e.$9s=M;class D{static fromHex(d){return D.Format.CSS.parseHex(d)||D.red}static equals(d,u){return!d&&!u?!0:!d||!u?!1:d.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof R)this.rgba=d;else if(d instanceof s)this.i=d,this.rgba=s.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&R.equals(this.rgba,d.rgba)&&s.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=D.k(this.rgba.r),u=D.k(this.rgba.g),p=D.k(this.rgba.b),v=.2126*d+.7152*u+.0722*p;return P(v,4)}static k(d){const u=d/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(d){const u=this.getRelativeLuminance(),p=d.getRelativeLuminance();return u>p?(u+.05)/(p+.05):(p+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const u=this.getRelativeLuminance(),p=d.getRelativeLuminance();return u>p}isDarkerThan(d){const u=this.getRelativeLuminance(),p=d.getRelativeLuminance();return u<p}lighten(d){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:u,g:p,b:v,a:b}=this.rgba;return new D(new R(u,p,v,b*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const u=d.rgba,p=this.rgba.a,v=u.a,b=p+v*(1-p);if(b<1e-6)return D.transparent;const l=this.rgba.r*p/b+u.r*v*(1-p)/b,y=this.rgba.g*p/b+u.g*v*(1-p)/b,m=this.rgba.b*p/b+u.b*v*(1-p)/b;return new D(new R(l,y,m,b))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:u,g:p,b:v,a:b}=this.rgba;return new D(new R(d.rgba.r-b*(d.rgba.r-u),d.rgba.g-b*(d.rgba.g-p),d.rgba.b-b*(d.rgba.b-v),1))}flatten(...d){const u=d.reduceRight((p,v)=>D.o(v,p));return D.o(this,u)}static o(d,u){const p=1-d.rgba.a;return new D(new R(p*u.rgba.r+d.rgba.a*d.rgba.r,p*u.rgba.g+d.rgba.a*d.rgba.g,p*u.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(d,u,p){if(d.isLighterThan(u))return d;p=p||.5;const v=d.getRelativeLuminance(),b=u.getRelativeLuminance();return p=p*(b-v)/b,d.lighten(p)}static getDarkerColor(d,u,p){if(d.isDarkerThan(u))return d;p=p||.5;const v=d.getRelativeLuminance(),b=u.getRelativeLuminance();return p=p*(v-b)/v,d.darken(p)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$0s=D,function(S){let d;(function(u){let p;(function(v){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:S.Format.CSS.formatRGBA(i)}v.formatRGB=b;function l(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}v.formatRGBA=l;function y(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(i)}v.formatHSL=y;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}v.formatHSLA=m;function $(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function g(i){return`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}`}v.formatHex=g;function h(i,o=!1){return o&&i.rgba.a===1?S.Format.CSS.formatHex(i):`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}${$(Math.round(i.rgba.a*255))}`}v.formatHexA=h;function a(i){return i.isOpaque()?S.Format.CSS.formatHex(i):S.Format.CSS.formatRGBA(i)}v.format=a;function E(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*f(i.charCodeAt(1))+f(i.charCodeAt(2)),t=16*f(i.charCodeAt(3))+f(i.charCodeAt(4)),n=16*f(i.charCodeAt(5))+f(i.charCodeAt(6));return new S(new R(r,t,n,1))}if(o===9){const r=16*f(i.charCodeAt(1))+f(i.charCodeAt(2)),t=16*f(i.charCodeAt(3))+f(i.charCodeAt(4)),n=16*f(i.charCodeAt(5))+f(i.charCodeAt(6)),c=16*f(i.charCodeAt(7))+f(i.charCodeAt(8));return new S(new R(r,t,n,c/255))}if(o===4){const r=f(i.charCodeAt(1)),t=f(i.charCodeAt(2)),n=f(i.charCodeAt(3));return new S(new R(16*r+r,16*t+t,16*n+n))}if(o===5){const r=f(i.charCodeAt(1)),t=f(i.charCodeAt(2)),n=f(i.charCodeAt(3)),c=f(i.charCodeAt(4));return new S(new R(16*r+r,16*t+t,16*n+n,(16*c+c)/255))}return null}v.parseHex=E;function f(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=u.CSS||(u.CSS={}))})(d=S.Format||(S.Format={}))}(D||(e.$0s=D={}))}),define(re[56],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function P(D){return(S,d,u)=>{let p=null,v=null;if(typeof u.value=="function"?(p="value",v=u.value):typeof u.get=="function"&&(p="get",v=u.get),!v)throw new Error("not supported");u[p]=D(v,d)}}function R(D,S,d){let u=null,p=null;if(typeof d.value=="function"?(u="value",p=d.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(u="get",p=d.get),!p)throw new Error("not supported");const v=`$memoize$${S}`;d[u]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,b)}),this[v]}}e.$sh=R;function s(D,S,d){return P((u,p)=>{const v=`$debounce$${p}`,b=`$debounce$result$${p}`;return function(...l){this[b]||(this[b]=d?d():void 0),clearTimeout(this[v]),S&&(this[b]=S(this[b],...l),l=[this[b]]),this[v]=setTimeout(()=>{u.apply(this,l),this[b]=d?d():void 0},D)}})}e.$th=s;function M(D,S,d){return P((u,p)=>{const v=`$throttle$timer$${p}`,b=`$throttle$result$${p}`,l=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...m){if(this[b]||(this[b]=d?d():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),S&&(this[b]=S(this[b],...m)),this[y])return;const $=this[l]+D;$<=Date.now()?(this[l]=Date.now(),u.apply(this,[this[b]]),this[b]=d?d():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[l]=Date.now(),u.apply(this,[this[b]]),this[b]=d?d():void 0},$-Date.now()))}})}e.$uh=M}),define(re[14],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=P,e.$X=new P;function R(f){e.$X.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function s(f){if(!f||typeof f!="object")return!1;const i=f;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(f){u(f)||e.$X.onUnexpectedError(f)}e.$1=M;function D(f){u(f)||e.$X.onUnexpectedExternalError(f)}e.$2=D;function S(f){if(f instanceof Error){const{name:i,message:o}=f,r=f.stacktrace||f.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:a.isErrorNoTelemetry(f)}}return f}e.$3=S;const d="Canceled";function u(f){return f instanceof p?!0:f instanceof Error&&f.name===d&&f.message===d}e.$4=u;class p extends Error{constructor(){super(d),this.name=this.message}}e.$5=p;function v(){const f=new Error(d);return f.name=f.message,f}e.$6=v;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.$7=b;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.$8=l;class y extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function m(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.$0=m;class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=$;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=g;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=h;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=a;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(re[23],oe([0,1,14,134]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(z,Z=0){return z[z.length-(1+Z)]}e.$sb=s;function M(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=M;function D(z,Z,W=(B,_)=>B===_){if(z===Z)return!0;if(!z||!Z||z.length!==Z.length)return!1;for(let B=0,_=z.length;B<_;B++)if(!W(z[B],Z[B]))return!1;return!0}e.$ub=D;function S(z,Z){const W=z.length-1;Z<W&&(z[Z]=z[W]),z.pop()}e.$vb=S;function d(z,Z,W){return u(z.length,B=>W(z[B],Z))}e.$wb=d;function u(z,Z){let W=0,B=z-1;for(;W<=B;){const _=(W+B)/2|0,ae=Z(_);if(ae<0)W=_+1;else if(ae>0)B=_-1;else return _}return-(W+1)}e.$xb=u;function p(z,Z,W){if(z=z|0,z>=Z.length)throw new TypeError("invalid index");const B=Z[Math.floor(Z.length*Math.random())],_=[],ae=[],ne=[];for(const $e of Z){const me=W($e,B);me<0?_.push($e):me>0?ae.push($e):ne.push($e)}return z<_.length?p(z,_,W):z<_.length+ne.length?ne[0]:p(z-(_.length+ne.length),ae,W)}e.$yb=p;function v(z,Z){const W=[];let B;for(const _ of z.slice(0).sort(Z))!B||Z(B[0],_)!==0?(B=[_],W.push(B)):B.push(_);return W}e.$zb=v;function*b(z,Z){let W,B;for(const _ of z)B!==void 0&&Z(B,_)?W.push(_):(W&&(yield W),W=[_]),B=_;W&&(yield W)}e.$Ab=b;function l(z,Z){for(let W=0;W<=z.length;W++)Z(W===0?void 0:z[W-1],W===z.length?void 0:z[W])}e.$Bb=l;function y(z,Z){for(let W=0;W<z.length;W++)Z(W===0?void 0:z[W-1],z[W],W+1===z.length?void 0:z[W+1])}e.$Cb=y;function m(z,Z,W){const B=[];function _($e,me,ye){if(me===0&&ye.length===0)return;const Se=B[B.length-1];Se&&Se.start+Se.deleteCount===$e?(Se.deleteCount+=me,Se.toInsert.push(...ye)):B.push({start:$e,deleteCount:me,toInsert:ye})}let ae=0,ne=0;for(;;){if(ae===z.length){_(ae,0,Z.slice(ne));break}if(ne===Z.length){_(ae,z.length-ae,[]);break}const $e=z[ae],me=Z[ne],ye=W($e,me);ye===0?(ae+=1,ne+=1):ye<0?(_(ae,1,[]),ae+=1):ye>0&&(_(ae,0,[me]),ne+=1)}return B}e.$Db=m;function $(z,Z,W){const B=m(z,Z,W),_=[],ae=[];for(const ne of B)_.push(...z.slice(ne.start,ne.start+ne.deleteCount)),ae.push(...ne.toInsert);return{removed:_,added:ae}}e.$Eb=$;function g(z,Z,W){if(W===0)return[];const B=z.slice(0,W).sort(Z);return a(z,Z,B,W,z.length),B}e.top=g;function h(z,Z,W,B,_){return W===0?Promise.resolve([]):new Promise((ae,ne)=>{(async()=>{const $e=z.length,me=z.slice(0,W).sort(Z);for(let ye=W,Se=Math.min(W+B,$e);ye<$e;ye=Se,Se=Math.min(Se+B,$e)){if(ye>W&&await new Promise(Le=>setTimeout(Le)),_&&_.isCancellationRequested)throw new P.$5;a(z,Z,me,ye,Se)}return me})().then(ae,ne)})}e.$Gb=h;function a(z,Z,W,B,_){for(const ae=W.length;B<_;B++){const ne=z[B];if(Z(ne,W[ae-1])<0){W.pop();const $e=(0,R.$kb)(W,me=>Z(ne,me)<0);W.splice($e,0,ne)}}}function E(z){return z.filter(Z=>!!Z)}e.$Hb=E;function f(z){let Z=0;for(let W=0;W<z.length;W++)z[W]&&(z[Z]=z[W],Z+=1);z.length=Z}e.$Ib=f;function i(z,Z,W){z.splice(W,0,z.splice(Z,1)[0])}e.$Jb=i;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function t(z,Z=W=>W){const W=new Set;return z.filter(B=>{const _=Z(B);return W.has(_)?!1:(W.add(_),!0)})}e.$Mb=t;function n(z){const Z=new Set;return W=>{const B=z(W);return Z.has(B)?!1:(Z.add(B),!0)}}e.$Nb=n;function c(z,Z){return z.length>0?z[0]:Z}e.$Ob=c;function w(z,Z){return z.length>0?z[z.length-1]:Z}e.$Pb=w;function A(z,Z,W=(B,_)=>B===_){let B=0;for(let _=0,ae=Math.min(z.length,Z.length);_<ae&&W(z[_],Z[_]);_++)B++;return B}e.$Qb=A;function I(z){return[].concat(...z)}e.$Rb=I;function k(z,Z){let W=typeof Z=="number"?z:0;typeof Z=="number"?W=z:(W=0,Z=z);const B=[];if(W<=Z)for(let _=W;_<Z;_++)B.push(_);else for(let _=W;_>Z;_--)B.push(_);return B}e.$Sb=k;function C(z,Z,W){return z.reduce((B,_)=>(B[Z(_)]=W?W(_):_,B),Object.create(null))}e.$Tb=C;function j(z,Z){return z.push(Z),()=>F(z,Z)}e.$Ub=j;function F(z,Z){const W=z.indexOf(Z);if(W>-1)return z.splice(W,1),Z}e.$Vb=F;function N(z,Z,W){const B=z.slice(0,Z),_=z.slice(Z);return B.concat(W,_)}e.$Wb=N;function Y(z,Z){let W;if(typeof Z=="number"){let B=Z;W=()=>{const _=Math.sin(B++)*179426549;return _-Math.floor(_)}}else W=Math.random;for(let B=z.length-1;B>0;B-=1){const _=Math.floor(W()*(B+1)),ae=z[B];z[B]=z[_],z[_]=ae}}e.$Xb=Y;function Q(z,Z){const W=z.indexOf(Z);W>-1&&(z.splice(W,1),z.unshift(Z))}e.$Yb=Q;function le(z,Z){const W=z.indexOf(Z);W>-1&&(z.splice(W,1),z.push(Z))}e.$Zb=le;function ce(z,Z){for(const W of Z)z.push(W)}e.$1b=ce;function ue(z,Z){return Array.isArray(z)?z.map(Z):Z(z)}e.$2b=ue;function K(z){return Array.isArray(z)?z:[z]}e.$3b=K;function X(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=X;function H(z,Z,W){const B=T(z,Z),_=z.length,ae=W.length;z.length=_+ae;for(let ne=_-1;ne>=B;ne--)z[ne+ae]=z[ne];for(let ne=0;ne<ae;ne++)z[ne+B]=W[ne]}e.$5b=H;function L(z,Z,W,B){const _=T(z,Z);let ae=z.splice(_,W);return ae===void 0&&(ae=[]),H(z,_,B),ae}e.$6b=L;function T(z,Z){return Z<0?Math.max(Z+z.length,0):Math.min(Z,z.length)}var V;(function(z){function Z(ae){return ae<0}z.isLessThan=Z;function W(ae){return ae<=0}z.isLessThanOrEqual=W;function B(ae){return ae>0}z.isGreaterThan=B;function _(ae){return ae===0}z.isNeitherLessOrGreaterThan=_,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function q(z,Z){return(W,B)=>Z(z(W),z(B))}e.$7b=q;function te(...z){return(Z,W)=>{for(const B of z){const _=B(Z,W);if(!V.isNeitherLessOrGreaterThan(_))return _}return V.neitherLessOrGreaterThan}}e.$8b=te;const he=(z,Z)=>z-Z;e.$9b=he;const G=(z,Z)=>(0,e.$9b)(z?1:0,Z?1:0);e.$0b=G;function O(z){return(Z,W)=>-z(Z,W)}e.$$b=O;class U{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let W=this.c;for(;W<this.g.length&&Z(this.g[W]);)W++;const B=W===this.c?null:this.g.slice(this.c,W);return this.c=W,B}takeFromEndWhile(Z){let W=this.d;for(;W>=0&&Z(this.g[W]);)W--;const B=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const W=this.g.slice(this.c,this.c+Z);return this.c+=Z,W}}e.$_b=U;class x{static{this.empty=new x(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(W=>(Z(W),!0))}toArray(){const Z=[];return this.iterate(W=>(Z.push(W),!0)),Z}filter(Z){return new x(W=>this.iterate(B=>Z(B)?W(B):!0))}map(Z){return new x(W=>this.iterate(B=>W(Z(B))))}some(Z){let W=!1;return this.iterate(B=>(W=Z(B),!W)),W}findFirst(Z){let W;return this.iterate(B=>Z(B)?(W=B,!1):!0),W}findLast(Z){let W;return this.iterate(B=>(Z(B)&&(W=B),!0)),W}findLastMaxBy(Z){let W,B=!0;return this.iterate(_=>((B||V.isGreaterThan(Z(_,W)))&&(B=!1,W=_),!0)),W}}e.$ac=x}),define(re[137],oe([0,1,14]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function R(d,u){if(!d)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=R;function s(d,u="Unreachable"){throw new Error(u)}e.$5c=s;function M(d){if(!d)throw new P.$cb("Assertion Failed")}e.$6c=M;function D(d){if(!d()){debugger;d(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$7c=D;function S(d,u){let p=0;for(;p<d.length-1;){const v=d[p],b=d[p+1];if(!u(v,b))return!1;p++}return!0}e.$8c=S}),define(re[84],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(R,s){const M=this;let D=!1,S;return function(){if(D)return S;if(D=!0,s)try{S=R.apply(M,arguments)}finally{s()}else S=R.apply(M,arguments);return S}}e.$db=P}),define(re[72],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(R){function s(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=s;const M=Object.freeze([]);function D(){return M}R.empty=D;function*S(f){yield f}R.single=S;function d(f){return s(f)?f:S(f)}R.wrap=d;function u(f){return f||M}R.from=u;function*p(f){for(let i=f.length-1;i>=0;i--)yield f[i]}R.reverse=p;function v(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=v;function b(f){return f[Symbol.iterator]().next().value}R.first=b;function l(f,i){for(const o of f)if(i(o))return!0;return!1}R.some=l;function y(f,i){for(const o of f)if(i(o))return o}R.find=y;function*m(f,i){for(const o of f)i(o)&&(yield o)}R.filter=m;function*$(f,i){let o=0;for(const r of f)yield i(r,o++)}R.map=$;function*g(...f){for(const i of f)yield*i}R.concat=g;function h(f,i,o){let r=o;for(const t of f)r=i(r,t);return r}R.reduce=h;function*a(f,i,o=f.length){for(i<0&&(i+=f.length),o<0?o+=f.length:o>f.length&&(o=f.length);i<o;i++)yield f[i]}R.slice=a;function E(f,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,f];const r=f[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,R.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}R.consume=E})(P||(e.Iterable=P={}))}),define(re[44],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(i,o=!1){let r=0;const t=i.length;let n="",c=0,w=16,A=0;function I(Q){let le=0,ce=0;for(;le<Q;){const ue=i.charCodeAt(r);if(ue>=48&&ue<=57)ce=ce*16+ue-48;else if(ue>=65&&ue<=70)ce=ce*16+ue-65+10;else if(ue>=97&&ue<=102)ce=ce*16+ue-97+10;else break;r++,le++}return le<Q&&(ce=-1),ce}function k(Q){r=Q,n="",c=0,w=16,A=0}function C(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&u(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&u(i.charCodeAt(r)))for(r++;r<i.length&&u(i.charCodeAt(r));)r++;else return A=3,i.substring(Q,r);let le=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&u(i.charCodeAt(r))){for(r++;r<i.length&&u(i.charCodeAt(r));)r++;le=r}else A=3;return i.substring(Q,le)}function j(){let Q="",le=r;for(;;){if(r>=t){Q+=i.substring(le,r),A=2;break}const ce=i.charCodeAt(r);if(ce===34){Q+=i.substring(le,r),r++;break}if(ce===92){if(Q+=i.substring(le,r),r++,r>=t){A=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const K=I(4);K>=0?Q+=String.fromCharCode(K):A=4;break}default:A=5}le=r;continue}if(ce>=0&&ce<=31)if(d(ce)){Q+=i.substring(le,r),A=2;break}else A=6;r++}return Q}function F(){if(n="",A=0,c=r,r>=t)return c=t,w=17;let Q=i.charCodeAt(r);if(S(Q)){do r++,n+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(S(Q));return w=15}if(d(Q))return r++,n+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),w=14;switch(Q){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,n=j(),w=10;case 47:{const le=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!d(i.charCodeAt(r));)r++;return n=i.substring(le,r),w=12}if(i.charCodeAt(r+1)===42){r+=2;const ce=t-1;let ue=!1;for(;r<ce;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,A=1),n=i.substring(le,r),w=13}return n+=String.fromCharCode(Q),r++,w=16}case 45:if(n+=String.fromCharCode(Q),r++,r===t||!u(i.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),w=11;default:for(;r<t&&N(Q);)r++,Q=i.charCodeAt(r);if(c!==r){switch(n=i.substring(c,r),n){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return n+=String.fromCharCode(Q),r++,w=16}}function N(Q){if(S(Q)||d(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let Q;do Q=F();while(Q>=12&&Q<=15);return Q}return{setPosition:k,getPosition:()=>r,scan:o?Y:F,getToken:()=>w,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>A}}e.$7m=D;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function u(i){return i>=48&&i<=57}var p;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(p||(p={}));function v(i,o){const r=[],t=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function A(I,k,C,j){c.value=I,c.offset=k,c.length=C,c.type=j,c.colonOffset=void 0,n=c}try{a(i,{onObjectBegin:(I,k)=>{if(o<=I)throw t;n=void 0,w=o>I,r.push("")},onObjectProperty:(I,k,C)=>{if(o<k||(A(I,k,C,"property"),r[r.length-1]=I,o<=k+C))throw t},onObjectEnd:(I,k)=>{if(o<=I)throw t;n=void 0,r.pop()},onArrayBegin:(I,k)=>{if(o<=I)throw t;n=void 0,r.push(0)},onArrayEnd:(I,k)=>{if(o<=I)throw t;n=void 0,r.pop()},onLiteralValue:(I,k,C)=>{if(o<k||(A(I,k,C,f(I)),o<=k+C))throw t},onSeparator:(I,k,C)=>{if(o<=k)throw t;if(I===":"&&n&&n.type==="property")n.colonOffset=k,w=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(w=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==t)throw I}return{path:r,previousNode:n,isAtPropertyKey:w,matches:I=>{let k=0;for(let C=0;k<I.length&&C<r.length;C++)if(I[k]===r[C]||I[k]==="*")k++;else if(I[k]!=="**")return!1;return k===I.length}}}e.$8m=v;function b(i,o=[],r=M.DEFAULT){let t=null,n=[];const c=[];function w(I){Array.isArray(n)?n.push(I):t!==null&&(n[t]=I)}return a(i,{onObjectBegin:()=>{const I={};w(I),c.push(n),n=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const I=[];w(I),c.push(n),n=I,t=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:w,onError:(I,k,C)=>{o.push({error:I,offset:k,length:C})}},r),n[0]}e.$9m=b;function l(i,o=[],r=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){t.type==="property"&&(t.length=I-t.offset,t=t.parent)}function c(I){return t.children.push(I),I}a(i,{onObjectBegin:I=>{t=c({type:"object",offset:I,length:-1,parent:t,children:[]})},onObjectProperty:(I,k,C)=>{t=c({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:I,offset:k,length:C,parent:t})},onObjectEnd:(I,k)=>{t.length=I+k-t.offset,t=t.parent,n(I+k)},onArrayBegin:(I,k)=>{t=c({type:"array",offset:I,length:-1,parent:t,children:[]})},onArrayEnd:(I,k)=>{t.length=I+k-t.offset,t=t.parent,n(I+k)},onLiteralValue:(I,k,C)=>{c({type:f(I),offset:k,length:C,parent:t,value:I}),n(k+C)},onSeparator:(I,k,C)=>{t.type==="property"&&(I===":"?t.colonOffset=k:I===","&&n(k))},onError:(I,k,C)=>{o.push({error:I,offset:k,length:C})}},r);const A=t.children[0];return A&&delete A.parent,A}e.$0m=l;function y(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===t){r=c.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$$m=y;function m(i){if(!i.parent||!i.parent.children)return[];const o=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$_m=m;function $(i){switch(i.type){case"array":return i.children.map($);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=$(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$an=$;function g(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$bn=g;function h(i,o,r=!1){if(g(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const c=h(t[n],o,r);if(c)return c}return i}}e.$cn=h;function a(i,o,r=M.DEFAULT){const t=D(i,!1);function n(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(q){return q?te=>q(te,t.getTokenOffset(),t.getTokenLength()):()=>!0}const w=n(o.onObjectBegin),A=c(o.onObjectProperty),I=n(o.onObjectEnd),k=n(o.onArrayBegin),C=n(o.onArrayEnd),j=c(o.onLiteralValue),F=c(o.onSeparator),N=n(o.onComment),Y=c(o.onError),Q=r&&r.disallowComments,le=r&&r.allowTrailingComma;function ce(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:Q||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:Q?ue(10):N();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,te=[],he=[]){if(Y(q),te.length+he.length>0){let G=t.getToken();for(;G!==17;){if(te.indexOf(G)!==-1){ce();break}else if(he.indexOf(G)!==-1)break;G=ce()}}}function K(q){const te=t.getTokenValue();return q?j(te):A(te),ce(),!0}function X(){switch(t.getToken()){case 11:{let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}j(q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ce(),!0}function H(){return t.getToken()!==10?(ue(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(F(":"),ce(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){w(),ce();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||ue(4,[],[]),F(","),ce(),t.getToken()===2&&le)break}else q&&ue(6,[],[]);H()||ue(4,[],[2,5]),q=!0}return I(),t.getToken()!==2?ue(7,[2],[]):ce(),!0}function T(){k(),ce();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||ue(4,[],[]),F(","),ce(),t.getToken()===4&&le)break}else q&&ue(6,[],[]);V()||ue(4,[],[4,5]),q=!0}return C(),t.getToken()!==4?ue(8,[4],[]):ce(),!0}function V(){switch(t.getToken()){case 3:return T();case 1:return L();case 10:return K(!0);default:return X()}}return ce(),t.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(t.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$dn=a;function E(i,o){const r=D(i),t=[];let n,c=0,w;do switch(w=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==w&&t.push(i.substring(c,w)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(n!==17);return t.join("")}e.$en=E;function f(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$fn=f}),define(re[138],oe([0,1,44]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PT=e.$OT=e.$NT=e.$MT=void 0;function R(u,p,v){let b,l,y,m,$;if(p){for(m=p.offset,$=m+p.length,y=m;y>0&&!d(u,y-1);)y--;let w=$;for(;w<u.length&&!d(u,w);)w++;l=u.substring(y,w),b=D(l,v)}else l=u,b=0,y=0,m=0,$=u.length;const g=S(v,u);let h=!1,a=0,E;v.insertSpaces?E=M(" ",v.tabSize||4):E="	";const f=(0,P.$7m)(l,!1);let i=!1;function o(){return g+M(E,b+a)}function r(){let w=f.scan();for(h=!1;w===15||w===14;)h=h||w===14,w=f.scan();return i=w===16||f.getTokenError()!==0,w}const t=[];function n(w,A,I){!i&&A<$&&I>m&&u.substring(A,I)!==w&&t.push({offset:A,length:I-A,content:w})}let c=r();if(c!==17){const w=f.getTokenOffset()+y,A=M(E,b);n(A,y,w)}for(;c!==17;){let w=f.getTokenOffset()+f.getTokenLength()+y,A=r(),I="";for(;!h&&(A===12||A===13);){const C=f.getTokenOffset()+y;n(" ",w,C),w=f.getTokenOffset()+f.getTokenLength()+y,I=A===12?o():"",A=r()}if(A===2)c!==1&&(a--,I=o());else if(A===4)c!==3&&(a--,I=o());else{switch(c){case 3:case 1:a++,I=o();break;case 5:case 12:I=o();break;case 13:h?I=o():I=" ";break;case 6:I=" ";break;case 10:if(A===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?I=" ":A!==5&&A!==17&&(i=!0);break;case 16:i=!0;break}h&&(A===12||A===13)&&(I=o())}const k=f.getTokenOffset()+y;n(I,w,k),c=A}return t}e.$MT=R;function s(u,p){const v=JSON.stringify(u,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?v.replace(/\r\n|\r|\n/g,p.eol):v}e.$NT=s;function M(u,p){let v="";for(let b=0;b<p;b++)v+=u;return v}function D(u,p){let v=0,b=0;const l=p.tabSize||4;for(;v<u.length;){const y=u.charAt(v);if(y===" ")b++;else if(y==="	")b+=l;else break;v++}return Math.floor(b/l)}function S(u,p){for(let v=0;v<p.length;v++){const b=p.charAt(v);if(b==="\r")return v+1<p.length&&p.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return u&&u.eol||`
`}e.$OT=S;function d(u,p){return`\r
`.indexOf(u.charAt(p))!==-1}e.$PT=d}),define(re[139],oe([0,1,44,138]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UT=e.$TT=e.$ST=e.$RT=e.$QT=void 0;function s(u,p,v){return M(u,p,void 0,v)}e.$QT=s;function M(u,p,v,b,l){const y=p.slice(),m=[],$=(0,P.$0m)(u,m);let g,h;for(;y.length>0&&(h=y.pop(),g=(0,P.$$m)($,y),g===void 0&&v!==void 0);)typeof h=="string"?v={[h]:v}:v=[v];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const a=(0,P.$$m)(g,[h]);if(a!==void 0)if(v===void 0){if(!a.parent)throw new Error("Malformed AST");const E=g.children.indexOf(a.parent);let f,i=a.parent.offset+a.parent.length;if(E>0){const o=g.children[E-1];f=o.offset+o.length}else f=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return D(u,{offset:f,length:i-f,content:""},b)}else return D(u,{offset:a.offset,length:a.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const E=`${JSON.stringify(h)}: ${JSON.stringify(v)}`,f=l?l(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(f>0){const o=g.children[f-1];i={offset:o.offset+o.length,length:0,content:","+E}}else g.children.length===0?i={offset:g.offset+1,length:0,content:E}:i={offset:g.offset+1,length:0,content:E+","};return D(u,i,b)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(v!==void 0){const a=`${JSON.stringify(v)}`;let E;if(g.children.length===0||h===0)E={offset:g.offset+1,length:0,content:g.children.length===0?a:a+","};else{const f=h===-1||h>g.children.length?g.children.length:h,i=g.children[f-1];E={offset:i.offset+i.length,length:0,content:","+a}}return D(u,E,b)}else{const a=h,E=g.children[a];let f;if(g.children.length===1)f={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===a){const i=g.children[a-1],o=i.offset+i.length,r=g.offset+g.length;f={offset:o,length:r-2-o,content:""}}else f={offset:E.offset,length:g.children[a+1].offset-E.offset,content:""};return D(u,f,b)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(u,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(v)},b)}}e.$RT=M;function D(u,p,v){let b=S(u,p),l=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;l>0&&!(0,R.$PT)(b,l-1);)l--;for(;y<b.length&&!(0,R.$PT)(b,y);)y++}const m=(0,R.$MT)(b,{offset:l,length:y-l},v);for(let g=m.length-1;g>=0;g--){const h=m[g];b=S(b,h),l=Math.min(l,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const $=u.length-(b.length-y)-l;return[{offset:l,length:$,content:b.substring(l,y)}]}e.$ST=D;function S(u,p){return u.substring(0,p.offset)+p.content+u.substring(p.offset+p.length)}e.$TT=S;function d(u,p){const v=p.slice(0).sort((l,y)=>{const m=l.offset-y.offset;return m===0?l.length-y.length:m});let b=u.length;for(let l=v.length-1;l>=0;l--){const y=v[l];if(y.offset+y.length<=b)u=S(u,y);else throw new Error("Overlapping edit");b=y.offset}return u}e.$UT=d}),define(re[62],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(re[101],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class R{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const u=this.b;this.b=S,S.prev=u,u.next=S}else{const u=this.a;this.a=S,S.next=u,u.prev=S}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$3c=R}),define(re[31],oe([0,1]),function(J,e){"use strict";var P,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(h,a,E){let f=h.get(a);return f===void 0&&(f=E,h.set(a,f)),f}e.$xc=M;function D(h){const a=[];return h.forEach((E,f)=>{a.push(`${f} => ${E}`)}),`Map(${h.size}) {${a.join(", ")}}`}e.$yc=D;function S(h){const a=[];return h.forEach(E=>{a.push(E)}),`Set(${h.size}) {${a.join(", ")}}`}e.$zc=S;class d{constructor(a,E){this.uri=a,this.value=E}}function u(h){return Array.isArray(h)}class p{static{this.a=a=>a.toString()}constructor(a,E){if(this[P]="ResourceMap",a instanceof p)this.b=new Map(a.b),this.c=E??p.a;else if(u(a)){this.b=new Map,this.c=E??p.a;for(const[f,i]of a)this.set(f,i)}else this.b=new Map,this.c=a??p.a}set(a,E){return this.b.set(this.c(a),new d(a,E)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,E){typeof E<"u"&&(a=a.bind(E));for(const[f,i]of this.b)a(i.value,i.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.$Ac=p;class v{constructor(a,E){this[R]="ResourceSet",!a||typeof a=="function"?this.a=new p(a):(this.a=new p(E),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,E){this.a.forEach((f,i)=>a.call(E,i,i,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var b;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,E=0){const f=this.a.get(a);if(f)return E!==0&&this.j(f,E),f.value}set(a,E,f=0){let i=this.a.get(a);if(i)i.value=E,f!==0&&this.j(i,f);else{switch(i={key:a,value:E,next:void 0,previous:void 0},f){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(a,i),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const E=this.a.get(a);if(E)return this.a.delete(a),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,E){const f=this.e;let i=this.b;for(;i;){if(E?a.bind(E)(i.value,i.key,this):a(i.value,i.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const a=this,E=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:f.key,done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}values(){const a=this,E=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:f.value,done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}entries(){const a=this,E=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:[f.key,f.value],done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let E=this.b,f=this.size;for(;E&&f>a;)this.a.delete(E.key),E=E.next,f--;this.b=E,this.d=f,E&&(E.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const E=a.next,f=a.previous;if(!E||!f)throw new Error("Invalid list");E.previous=f,f.next=E}a.next=void 0,a.previous=void 0,this.e++}j(a,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(a===this.b)return;const f=a.next,i=a.previous;a===this.c?(i.next=void 0,this.c=i):(f.previous=i,i.next=f),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(E===2){if(a===this.c)return;const f=a.next,i=a.previous;a===this.b?(f.previous=void 0,this.b=f):(f.previous=i,i.next=f),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((E,f)=>{a.push([f,E])}),a}fromJSON(a){this.clear();for(const[E,f]of a)this.set(E,f)}}e.$Cc=l;class y extends l{constructor(a,E=1){super(),this.k=a,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,E=2){return super.get(a,E)}peek(a){return super.get(a,0)}set(a,E){return super.set(a,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=y;class m{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let E=this.a.get(a)||0;return E===0?!1:(E--,E===0?this.a.delete(a):this.a.set(a,E),!0)}has(a){return this.a.has(a)}}e.$Ec=m;class ${constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[E,f]of a)this.set(E,f)}clear(){this.a.clear(),this.b.clear()}set(a,E){this.a.set(a,E),this.b.set(E,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const E=this.a.get(a);return E===void 0?!1:(this.a.delete(a),this.b.delete(E),!0)}forEach(a,E){this.a.forEach((f,i)=>{a.call(E,f,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=$;class g{constructor(){this.a=new Map}add(a,E){let f=this.a.get(a);f||(f=new Set,this.a.set(a,f)),f.add(E)}delete(a,E){const f=this.a.get(a);f&&(f.delete(E),f.size===0&&this.a.delete(a))}forEach(a,E){const f=this.a.get(a);f&&f.forEach(E)}get(a){const E=this.a.get(a);return E||new Set}}e.$Gc=g}),define(re[2],oe([0,1,23,135,31,84,72]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const S=!1;let d=null;class u{constructor(){this.b=new Map}static{this.a=0}c(j){let F=this.b.get(j);return F||(F={parent:null,source:null,isSingleton:!1,value:j,idx:u.a++},this.b.set(j,F)),F}trackDisposable(j){const F=this.c(j);F.source||(F.source=new Error().stack)}setParent(j,F){const N=this.c(j);N.parent=F}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,F){const N=F.get(j);if(N)return N;const Y=j.parent?this.f(this.c(j.parent),F):j;return F.set(j,Y),Y}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,j).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(j=10,F){let N;if(F)N=F;else{const ue=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,ue).isSingleton);if(K.length===0)return;const X=new Set(K.map(H=>H.value));if(N=K.filter(H=>!(H.parent&&X.has(H.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function Y(ue){function K(H,L){for(;H.length>0&&L.some(T=>typeof T=="string"?T===H[0]:H[0].match(T));)H.shift()}const X=ue.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const Q=new s.$Gc;for(const ue of N){const K=Y(ue);for(let X=0;X<=K.length;X++)Q.add(K.slice(0,X).join(`
`),ue)}N.sort((0,P.$7b)(ue=>ue.idx,P.$9b));let le="",ce=0;for(const ue of N.slice(0,j)){ce++;const K=Y(ue),X=[];for(let H=0;H<K.length;H++){let L=K[H];L=`(shared with ${Q.get(K.slice(0,H+1).join(`
`)).size}/${N.length} leaks) at ${L}`;const V=Q.get(K.slice(0,H).join(`
`)),q=(0,R.$K)([...V].map(te=>Y(te)[H]),te=>te);delete q[K[H]];for(const[te,he]of Object.entries(q))X.unshift(`    - stacktraces of ${he.length} other leaks continue with ${te}`);X.unshift(L)}le+=`


==================== Leaking disposable ${ce}/${N.length}: ${ue.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return N.length>j&&(le+=`


... and ${N.length-j} more leaking disposables

`),{leaks:N,details:le}}}e.$Hc=u;function p(C){d=C}if(e.$Ic=p,S){const C="__is_disposable_tracked__";p(new class{trackDisposable(j){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(F)},3e3)}setParent(j,F){if(j&&j!==i.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==i.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function v(C){return d?.trackDisposable(C),C}e.$Jc=v;function b(C){d?.markAsDisposed(C)}e.$Kc=b;function l(C,j){d?.setParent(C,j)}function y(C,j){if(d)for(const F of C)d.setParent(F,j)}function m(C){return d?.markAsSingleton(C),C}e.$Lc=m;function $(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Mc=$;function g(C){if(D.Iterable.is(C)){const j=[];for(const F of C)if(F)try{F.dispose()}catch(N){j.push(N)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Nc=g;function h(C){for(const j of C)$(j)&&j.dispose();return[]}e.$Oc=h;function a(...C){const j=E(()=>g(C));return y(C,j),j}e.$Pc=a;function E(C){const j=v({dispose:(0,M.$db)(()=>{b(j),C()})});return j}e.$Qc=E;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return l(j,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),l(j,null))}}e.$Rc=f;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,v(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Sc=i;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&l(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&l(j,null),j}}e.$Tc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=r;class t{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(j){let F=j;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,b(this))},this}}e.$Wc=n;class c{constructor(){this.a=new Map}acquire(j,...F){let N=this.a.get(j);N||(N={counter:0,object:this.b(j,...F)},this.a.set(j,N));const{object:Y}=N,Q=(0,M.$db)(()=>{--N.counter===0&&(this.c(j,N.object),this.a.delete(j))});return N.counter++,{object:Y,dispose:Q}}}e.$Xc=c;class w{constructor(j){this.a=j}async acquire(j,...F){const N=this.a.acquire(j,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(Y){throw N.dispose(),Y}}}e.$Yc=w;class A{constructor(j){this.object=j}dispose(){}}e.$Zc=A;function I(C){const j=new f;try{C(j)}finally{j.dispose()}}e.$1c=I;class k{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(j)?.dispose(),this.a.set(j,F)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=k}),define(re[85],oe([0,1,31]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=void 0;const R=new P.$Dc(1e4);function s(u){return d(u,"NFC",R)}e.$Al=s;const M=new P.$Dc(1e4);function D(u){return d(u,"NFD",M)}e.$Bl=D;const S=/[^\u0000-\u0080]/;function d(u,p,v){if(!u)return u;const b=v.get(u);if(b)return b;let l;return S.test(u)?l=u.normalize(p):l=u,v.set(u,l),l}e.$Cl=function(){const u=/[\u0300-\u036f]/g;return function(p){return D(p).replace(u,"")}}()}),define(re[140],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.rot=e.$1l=void 0;function P(S,d,u){return Math.min(Math.max(S,d),u)}e.$1l=P;function R(S,d){return(d+S%d)%d}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$3l=s;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$4l=M;class D{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const u=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$5l=D}),function(){function J(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(d){M.push(d,Date.now())}function S(){const d=[];for(let u=0;u<M.length;u+=2)d.push({name:M[u],startTime:M[u+1]});return d}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=P(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var R in P)(typeof exports=="object"?exports:J)[R]=P[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function P(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return J[R].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=J,P.c=e,P.d=function(R,s,M){P.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:M})},P.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},P.t=function(R,s){if(1&s&&(R=P(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)P.d(M,D,function(S){return R[S]}.bind(null,D));return M},P.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return P.d(s,"a",s),s},P.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},P.p="",P(P.s=0)}([function(J,e,P){(function(R){var s;e=J.exports=he,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],d=e.src=[],u=0,p=u++;d[p]="0|[1-9]\\d*";var v=u++;d[v]="[0-9]+";var b=u++;d[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=u++;d[l]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var y=u++;d[y]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var m=u++;d[m]="(?:"+d[p]+"|"+d[b]+")";var $=u++;d[$]="(?:"+d[v]+"|"+d[b]+")";var g=u++;d[g]="(?:-("+d[m]+"(?:\\."+d[m]+")*))";var h=u++;d[h]="(?:-?("+d[$]+"(?:\\."+d[$]+")*))";var a=u++;d[a]="[0-9A-Za-z-]+";var E=u++;d[E]="(?:\\+("+d[a]+"(?:\\."+d[a]+")*))";var f=u++,i="v?"+d[l]+d[g]+"?"+d[E]+"?";d[f]="^"+i+"$";var o="[v=\\s]*"+d[y]+d[h]+"?"+d[E]+"?",r=u++;d[r]="^"+o+"$";var t=u++;d[t]="((?:<|>)?=?)";var n=u++;d[n]=d[v]+"|x|X|\\*";var c=u++;d[c]=d[p]+"|x|X|\\*";var w=u++;d[w]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[g]+")?"+d[E]+"?)?)?";var A=u++;d[A]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[h]+")?"+d[E]+"?)?)?";var I=u++;d[I]="^"+d[t]+"\\s*"+d[w]+"$";var k=u++;d[k]="^"+d[t]+"\\s*"+d[A]+"$";var C=u++;d[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=u++;d[j]="(?:~>?)";var F=u++;d[F]="(\\s*)"+d[j]+"\\s+",S[F]=new RegExp(d[F],"g");var N=u++;d[N]="^"+d[j]+d[w]+"$";var Y=u++;d[Y]="^"+d[j]+d[A]+"$";var Q=u++;d[Q]="(?:\\^)";var le=u++;d[le]="(\\s*)"+d[Q]+"\\s+",S[le]=new RegExp(d[le],"g");var ce=u++;d[ce]="^"+d[Q]+d[w]+"$";var ue=u++;d[ue]="^"+d[Q]+d[A]+"$";var K=u++;d[K]="^"+d[t]+"\\s*("+o+")$|^$";var X=u++;d[X]="^"+d[t]+"\\s*("+i+")$|^$";var H=u++;d[H]="(\\s*)"+d[t]+"\\s*("+o+"|"+d[w]+")",S[H]=new RegExp(d[H],"g");var L=u++;d[L]="^\\s*("+d[w]+")\\s+-\\s+("+d[w]+")\\s*$";var T=u++;d[T]="^\\s*("+d[A]+")\\s+-\\s+("+d[A]+")\\s*$";var V=u++;d[V]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,d[q]),S[q]||(S[q]=new RegExp(d[q]));function te(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>M||!(fe?S[r]:S[f]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(ee,fe);s("SemVer",ee,fe),this.loose=fe;var ge=ee.trim().match(fe?S[r]:S[f]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Oe=+Ce;if(Oe>=0&&Oe<D)return Oe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ee,fe){var ge=te(ee,fe);return ge?ge.version:null},e.clean=function(ee,fe){var ge=te(ee.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ce=ee.prerelease[fe];if(s("prerelease compare",fe,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return O(ge,Ce)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new he(ee,ge).inc(fe,Ce).version}catch{return null}},e.diff=function(ee,fe){if(Z(ee,fe))return null;var ge=te(ee),Ce=te(fe);if(ge.prerelease.length||Ce.prerelease.length){for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Ce[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Ce[Oe])return Oe},e.compareIdentifiers=O;var G=/^[0-9]+$/;function O(ee,fe){var ge=G.test(ee),Ce=G.test(fe);return ge&&Ce&&(ee=+ee,fe=+fe),ge&&!Ce?-1:Ce&&!ge?1:ee<fe?-1:ee>fe?1:0}function U(ee,fe,ge){return new he(ee,ge).compare(new he(fe,ge))}function x(ee,fe,ge){return U(ee,fe,ge)>0}function z(ee,fe,ge){return U(ee,fe,ge)<0}function Z(ee,fe,ge){return U(ee,fe,ge)===0}function W(ee,fe,ge){return U(ee,fe,ge)!==0}function B(ee,fe,ge){return U(ee,fe,ge)>=0}function _(ee,fe,ge){return U(ee,fe,ge)<=0}function ae(ee,fe,ge,Ce){var Oe;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Oe=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Oe=ee!==ge;break;case"":case"=":case"==":Oe=Z(ee,ge,Ce);break;case"!=":Oe=W(ee,ge,Ce);break;case">":Oe=x(ee,ge,Ce);break;case">=":Oe=B(ee,ge,Ce);break;case"<":Oe=z(ee,ge,Ce);break;case"<=":Oe=_(ee,ge,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Oe}function ne(ee,fe){if(ee instanceof ne){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof ne))return new ne(ee,fe);s("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,fe){return O(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=U,e.compareLoose=function(ee,fe){return U(ee,fe,!0)},e.rcompare=function(ee,fe,ge){return U(fe,ee,ge)},e.sort=function(ee,fe){return ee.sort(function(ge,Ce){return e.compare(ge,Ce,fe)})},e.rsort=function(ee,fe){return ee.sort(function(ge,Ce){return e.rcompare(ge,Ce,fe)})},e.gt=x,e.lt=z,e.eq=Z,e.neq=W,e.gte=B,e.lte=_,e.cmp=ae,e.Comparator=ne;var $e={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof ne)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,fe,ge,Ce,Oe,Te,Me,Ve,Be,se,de,we,ke){return((fe=ye(ge)?"":ye(Ce)?">="+ge+".0.0":ye(Oe)?">="+ge+"."+Ce+".0":">="+fe)+" "+(Ve=ye(Be)?"":ye(se)?"<"+(+Be+1)+".0.0":ye(de)?"<"+Be+"."+(+se+1)+".0":we?"<="+Be+"."+se+"."+de+"-"+we:"<="+Ve)).trim()}function Le(ee,fe){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==$e&&ee[ge].semver.prerelease.length>0){var Ce=ee[ge].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function ve(ee,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(ee)}function pe(ee,fe,ge,Ce){var Oe,Te,Me,Ve,Be;switch(ee=new he(ee,Ce),fe=new me(fe,Ce),ge){case">":Oe=x,Te=_,Me=z,Ve=">",Be=">=";break;case"<":Oe=z,Te=B,Me=x,Ve="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ee,fe,Ce))return!1;for(var se=0;se<fe.set.length;++se){var de=fe.set[se],we=null,ke=null;if(de.forEach(function(De){De.semver===$e&&(De=new ne(">=0.0.0")),we=we||De,ke=ke||De,Oe(De.semver,we.semver,Ce)?we=De:Me(De.semver,ke.semver,Ce)&&(ke=De)}),we.operator===Ve||we.operator===Be||(!ke.operator||ke.operator===Ve)&&Te(ee,ke.semver)||ke.operator===Be&&Me(ee,ke.semver))return!1}return!0}ne.prototype.parse=function(ee){var fe=this.loose?S[K]:S[X],ge=ee.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=$e},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===$e||(typeof ee=="string"&&(ee=new he(ee,this.loose)),ae(ee,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ee,fe){if(!(ee instanceof ne))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(ee.value,fe),ve(this.value,ge,fe);if(ee.operator==="")return ge=new me(this.value,fe),ve(ee.semver,ge,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Te=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ve=ae(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=ae(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ce||Oe||Te&&Me||Ve||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),s("range",ee,fe);var ge=fe?S[T]:S[L];ee=ee.replace(ge,Se),s("hyphen replace",ee),ee=ee.replace(S[H],"$1$2$3"),s("comparator trim",ee,S[H]),ee=(ee=(ee=ee.replace(S[F],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var Ce=fe?S[K]:S[X],Oe=ee.split(" ").map(function(Te){return function(Me,Ve){return s("comp",Me),Me=function(Be,se){return Be.trim().split(/\s+/).map(function(de){return function(we,ke){s("caret",we,ke);var De=ke?S[ue]:S[ce];return we.replace(De,function(Fe,je,Ne,qe,Ge){var Je;return s("caret",we,Fe,je,Ne,qe,Ge),ye(je)?Je="":ye(Ne)?Je=">="+je+".0.0 <"+(+je+1)+".0.0":ye(qe)?Je=je==="0"?">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+".0 <"+(+je+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+qe+Ge+" <"+je+"."+Ne+"."+(+qe+1):">="+je+"."+Ne+"."+qe+Ge+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+qe+Ge+" <"+(+je+1)+".0.0"):(s("no pr"),Je=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+qe+" <"+je+"."+Ne+"."+(+qe+1):">="+je+"."+Ne+"."+qe+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+qe+" <"+(+je+1)+".0.0"),s("caret return",Je),Je})}(de,se)}).join(" ")}(Me,Ve),s("caret",Me),Me=function(Be,se){return Be.trim().split(/\s+/).map(function(de){return function(we,ke){var De=ke?S[Y]:S[N];return we.replace(De,function(Fe,je,Ne,qe,Ge){var Je;return s("tilde",we,Fe,je,Ne,qe,Ge),ye(je)?Je="":ye(Ne)?Je=">="+je+".0.0 <"+(+je+1)+".0.0":ye(qe)?Je=">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=">="+je+"."+Ne+"."+qe+Ge+" <"+je+"."+(+Ne+1)+".0"):Je=">="+je+"."+Ne+"."+qe+" <"+je+"."+(+Ne+1)+".0",s("tilde return",Je),Je})}(de,se)}).join(" ")}(Me,Ve),s("tildes",Me),Me=function(Be,se){return s("replaceXRanges",Be,se),Be.split(/\s+/).map(function(de){return function(we,ke){we=we.trim();var De=ke?S[k]:S[I];return we.replace(De,function(Fe,je,Ne,qe,Ge,Je){s("xRange",we,Fe,je,Ne,qe,Ge,Je);var _e=ye(Ne),Qe=_e||ye(qe),it=Qe||ye(Ge);return je==="="&&it&&(je=""),_e?Fe=je===">"||je==="<"?"<0.0.0":"*":je&&it?(Qe&&(qe=0),it&&(Ge=0),je===">"?(je=">=",Qe?(Ne=+Ne+1,qe=0,Ge=0):it&&(qe=+qe+1,Ge=0)):je==="<="&&(je="<",Qe?Ne=+Ne+1:qe=+qe+1),Fe=je+Ne+"."+qe+"."+Ge):Qe?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":it&&(Fe=">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0"),s("xRange return",Fe),Fe})}(de,se)}).join(" ")}(Me,Ve),s("xrange",Me),Me=function(Be,se){return s("replaceStars",Be,se),Be.trim().replace(S[V],"")}(Me,Ve),s("stars",Me),Me}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Te){return!!Te.match(Ce)})),Oe=Oe.map(function(Te){return new ne(Te,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ee.set.some(function(Oe){return Oe.every(function(Te){return Ce.intersects(Te,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],ee))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ee,fe,ge){var Ce=null,Oe=null;try{var Te=new me(fe,ge)}catch{return null}return ee.forEach(function(Me){Te.test(Me)&&(Ce&&Oe.compare(Me)!==-1||(Oe=new he(Ce=Me,ge)))}),Ce},e.minSatisfying=function(ee,fe,ge){var Ce=null,Oe=null;try{var Te=new me(fe,ge)}catch{return null}return ee.forEach(function(Me){Te.test(Me)&&(Ce&&Oe.compare(Me)!==1||(Oe=new he(Ce=Me,ge)))}),Ce},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,ge){return pe(ee,fe,"<",ge)},e.gtr=function(ee,fe,ge){return pe(ee,fe,">",ge)},e.outside=pe,e.prerelease=function(ee,fe){var ge=te(ee,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,fe,ge){return ee=new me(ee,ge),fe=new me(fe,ge),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(S[C]);return fe==null?null:te((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(J,e){var P,R,s=J.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S($){if(P===setTimeout)return setTimeout($,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout($,0);try{return P($,0)}catch{try{return P.call(null,$,0)}catch{return P.call(this,$,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var d,u=[],p=!1,v=-1;function b(){p&&d&&(p=!1,d.length?u=d.concat(u):v=-1,u.length&&l())}function l(){if(!p){var $=S(b);p=!0;for(var g=u.length;g;){for(d=u,u=[];++v<g;)d&&d[v].run();v=-1,g=u.length}d=null,p=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}($)}}function y($,g){this.fun=$,this.array=g}function m(){}s.nextTick=function($){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];u.push(new y($,g)),u.length!==1||p||S(l)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(re[141],oe([0,1]),function(J,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;class R{constructor(S,d,u){this.level=S,this.key=d,this.value=u,this.forward=[]}}const s=void 0;class M{constructor(S,d=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,d){return M.h(this,S,d,this.comparator)&&(this.f+=1),this}delete(S){const d=M.k(this,S,this.comparator);return d&&(this.f-=1),d}forEach(S,d){let u=this.e.forward[0];for(;u;)S.call(d,u.value,u.key,this),u=u.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",d=this.e.forward[0];for(;d;)S+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return S}static g(S,d,u){let p=S.e;for(let v=S.d-1;v>=0;v--)for(;p.forward[v]&&u(p.forward[v].key,d)<0;)p=p.forward[v];if(p=p.forward[0],p&&u(p.key,d)===0)return p}static h(S,d,u,p){const v=[];let b=S.e;for(let l=S.d-1;l>=0;l--){for(;b.forward[l]&&p(b.forward[l].key,d)<0;)b=b.forward[l];v[l]=b}if(b=b.forward[0],b&&p(b.key,d)===0)return b.value=u,!1;{const l=M.j(S);if(l>S.d){for(let y=S.d;y<l;y++)v[y]=S.e;S.d=l}b=new R(l,d,u);for(let y=0;y<l;y++)b.forward[y]=v[y].forward[y],v[y].forward[y]=b;return!0}}static j(S,d=.5){let u=1;for(;Math.random()<d&&u<S.c;)u+=1;return u}static k(S,d,u){const p=[];let v=S.e;for(let b=S.d-1;b>=0;b--){for(;v.forward[b]&&u(v.forward[b].key,d)<0;)v=v.forward[b];p[b]=v}if(v=v.forward[0],!v||u(v.key,d)!==0)return!1;for(let b=0;b<S.d&&p[b].forward[b]===v;b++)p[b].forward[b]=v.forward[b];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Kr=M}),define(re[73],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=R}),define(re[3],oe([0,1,14,84,2,101,73]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const S=!1,d=!1;var u;(function(I){I.None=()=>s.$Sc.None;function k(ae){if(d){const{onDidAddListener:ne}=ae,$e=y.create();let me=0;ae.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ne?.()}}}function C(ae,ne){return X(ae,()=>{},0,void 0,!0,void 0,ne)}I.defer=C;function j(ae){return(ne,$e=null,me)=>{let ye=!1,Se;return Se=ae(Le=>{if(!ye)return Se?Se.dispose():ye=!0,ne.call($e,Le)},null,me),ye&&Se.dispose(),Se}}I.once=j;function F(ae,ne,$e){return ue((me,ye=null,Se)=>ae(Le=>me.call(ye,ne(Le)),null,Se),$e)}I.map=F;function N(ae,ne,$e){return ue((me,ye=null,Se)=>ae(Le=>{ne(Le),me.call(ye,Le)},null,Se),$e)}I.forEach=N;function Y(ae,ne,$e){return ue((me,ye=null,Se)=>ae(Le=>ne(Le)&&me.call(ye,Le),null,Se),$e)}I.filter=Y;function Q(ae){return ae}I.signal=Q;function le(...ae){return(ne,$e=null,me)=>{const ye=(0,s.$Pc)(...ae.map(Se=>Se(Le=>ne.call($e,Le))));return K(ye,me)}}I.any=le;function ce(ae,ne,$e,me){let ye=$e;return F(ae,Se=>(ye=ne(ye,Se),ye),me)}I.reduce=ce;function ue(ae,ne){let $e;const me={onWillAddFirstListener(){$e=ae(ye.fire,ye)},onDidRemoveLastListener(){$e?.dispose()}};ne||k(me);const ye=new a(me);return ne?.add(ye),ye.event}function K(ae,ne){return ne instanceof Array?ne.push(ae):ne&&ne.add(ae),ae}function X(ae,ne,$e=100,me=!1,ye=!1,Se,Le){let ve,pe,ee,fe=0,ge;const Ce={leakWarningThreshold:Se,onWillAddFirstListener(){ve=ae(Te=>{fe++,pe=ne(pe,Te),me&&!ee&&(Oe.fire(pe),pe=void 0),ge=()=>{const Me=pe;pe=void 0,ee=void 0,(!me||fe>1)&&Oe.fire(Me),fe=0},typeof $e=="number"?(clearTimeout(ee),ee=setTimeout(ge,$e)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&fe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ve.dispose()}};Le||k(Ce);const Oe=new a(Ce);return Le?.add(Oe),Oe.event}I.debounce=X;function H(ae,ne=0,$e){return I.debounce(ae,(me,ye)=>me?(me.push(ye),me):[ye],ne,void 0,!0,void 0,$e)}I.accumulate=H;function L(ae,ne=(me,ye)=>me===ye,$e){let me=!0,ye;return Y(ae,Se=>{const Le=me||!ne(Se,ye);return me=!1,ye=Se,Le},$e)}I.latch=L;function T(ae,ne,$e){return[I.filter(ae,ne,$e),I.filter(ae,me=>!ne(me),$e)]}I.split=T;function V(ae,ne=!1,$e=[],me){let ye=$e.slice(),Se=ae(pe=>{ye?ye.push(pe):ve.fire(pe)});me&&me.add(Se);const Le=()=>{ye?.forEach(pe=>ve.fire(pe)),ye=null},ve=new a({onWillAddFirstListener(){Se||(Se=ae(pe=>ve.fire(pe)),me&&me.add(Se))},onDidAddFirstListener(){ye&&(ne?setTimeout(Le):Le())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return me&&me.add(ve),ve.event}I.buffer=V;function q(ae,ne){return(me,ye,Se)=>{const Le=ne(new he);return ae(function(ve){const pe=Le.evaluate(ve);pe!==te&&me.call(ye,pe)},void 0,Se)}}I.chain=q;const te=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push($e=>(ne($e),$e)),this}filter(ne){return this.f.push($e=>ne($e)?$e:te),this}reduce(ne,$e){let me=$e;return this.f.push(ye=>(me=ne(me,ye),me)),this}latch(ne=($e,me)=>$e===me){let $e=!0,me;return this.f.push(ye=>{const Se=$e||!ne(ye,me);return $e=!1,me=ye,Se?ye:te}),this}evaluate(ne){for(const $e of this.f)if(ne=$e(ne),ne===te)break;return ne}}function G(ae,ne,$e=me=>me){const me=(...ve)=>Le.fire($e(...ve)),ye=()=>ae.on(ne,me),Se=()=>ae.removeListener(ne,me),Le=new a({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Le.event}I.fromNodeEventEmitter=G;function O(ae,ne,$e=me=>me){const me=(...ve)=>Le.fire($e(...ve)),ye=()=>ae.addEventListener(ne,me),Se=()=>ae.removeEventListener(ne,me),Le=new a({onWillAddFirstListener:ye,onDidRemoveLastListener:Se});return Le.event}I.fromDOMEventEmitter=O;function U(ae){return new Promise(ne=>j(ae)(ne))}I.toPromise=U;function x(ae){const ne=new a;return ae.then($e=>{ne.fire($e)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}I.fromPromise=x;function z(ae,ne,$e){return ne($e),ae(me=>ne(me))}I.runAndSubscribe=z;function Z(ae,ne){let $e=null;function me(Se){$e?.dispose(),$e=new s.$Rc,ne(Se,$e)}me(void 0);const ye=ae(Se=>me(Se));return(0,s.$Qc)(()=>{ye.dispose(),$e?.dispose()})}I.runAndSubscribeWithStore=Z;class W{constructor(ne,$e){this._observable=ne,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};$e||k(me),this.emitter=new a(me),$e&&$e.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,$e){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(ae,ne){return new W(ae,ne).emitter.event}I.fromObservable=B;function _(ae){return(ne,$e,me)=>{let ye=0,Se=!1;const Le={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ae.reportChanges(),Se&&(Se=!1,ne.call($e)))},handlePossibleChange(){},handleChange(){Se=!0}};ae.addObserver(Le),ae.reportChanges();const ve={dispose(){ae.removeObserver(Le)}};return me instanceof s.$Rc?me.add(ve):Array.isArray(me)&&me.push(ve),ve}}I.fromObservableLight=_})(u||(e.Event=u={}));class p{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${p.f++}`,p.all.add(this)}start(k){this.g=new D.$Od,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Qd=p;let v=-1;function b(I){const k=v;return v=I,{dispose(){v=k}}}e.$Rd=b;class l{constructor(k,C=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=C,this.g=0}dispose(){this.f?.clear()}check(k,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const F=this.f.get(k.value)||0;if(this.f.set(k.value,F+1),this.g-=1,this.g<=0){this.g=j*.5;let N,Y=0;for(const[Q,le]of this.f)(!N||Y<le)&&(N=Q,Y=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${Y}):`),console.warn(N)}return()=>{const N=this.f.get(k.value)||0;this.f.set(k.value,N-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class ${constructor(k){this.value=k,this.id=m++}}const g=2,h=(I,k)=>{if(I instanceof $)k(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&k(j)}};class a{constructor(k){this.w=0,this.f=k,this.g=v>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const k=this.t;queueMicrotask(()=>{h(k,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;C&&(k=k.bind(C));const F=new $(k);let N,Y;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=y.create(),N=this.g.check(F.stack,this.w+1)),S&&(F.stack=Y??y.create()),this.t?this.t instanceof $?(this.u??=new f,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const Q=(0,s.$Qc)(()=>{N?.(),this.x(F)});return j instanceof s.$Rc?j.add(Q):Array.isArray(j)&&j.push(Q),Q},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const F=this.u.current===this;if(this.w*g<=C.length){let N=0;for(let Y=0;Y<C.length;Y++)C[Y]?C[N++]=C[Y]:F&&(this.u.end--,N<this.u.i&&this.u.i--);C.length=N}}y(k,C){if(!k)return;const j=this.f?.onListenerError||P.$1;if(!j){k.value(C);return}try{k.value(C)}catch(F){j(F)}}z(k){const C=k.current.t;for(;k.i<k.end;)this.y(C[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,k);else{const C=this.u;C.enqueue(this,k,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=a;const E=()=>new f;e.$Td=E;class f{constructor(){this.i=-1,this.end=0}enqueue(k,C,j){this.i=0,this.end=j,this.current=k,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends a{async fireAsync(k,C,j){if(this.t)for(this.h||(this.h=new M.$3c),h(this.t,F=>this.h.push([F.value,k]));this.h.size>0&&!C.isCancellationRequested;){const[F,N]=this.h.shift(),Y=[],Q={...N,token:C,waitUntil:le=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,F)),Y.push(le)}};try{F(Q)}catch(le){(0,P.$1)(le);continue}Object.freeze(Y),await Promise.allSettled(Y).then(le=>{for(const ce of le)ce.status==="rejected"&&(0,P.$1)(ce.reason)})}}}e.$Ud=i;class o extends a{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$3c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Vd=o;class r extends o{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Wd=r;class t extends a{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$Xd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const C={event:k,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const F=this.h.indexOf(C);this.h.splice(F,1)};return(0,s.$Qc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(C=>this.f.fire(C))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Yd=n;class c{constructor(k,C,j,F){this.f=new s.$Rc;const N=this.f.add(new n),Y=this.f.add(new s.$2c);function Q(le){Y.set(le,N.add(F(le)))}for(const le of k)Q(le);this.f.add(C(le=>{Q(le)})),this.f.add(j(le=>{Y.deleteAndDispose(le)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Zd=c;class w{constructor(){this.f=[]}wrapEvent(k){return(C,j,F)=>k(N=>{const Y=this.f[this.f.length-1];Y?Y.push(()=>C.call(j,N)):C.call(j,N)},void 0,F)}bufferEvents(k){const C=[];this.f.push(C);const j=k();return this.f.pop(),C.forEach(F=>F()),j}}e.$1d=w;class A{constructor(){this.f=!1,this.g=u.None,this.h=s.$Sc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=A}),define(re[22],oe([0,1,3]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const R=Object.freeze(function(S,d){const u=setTimeout(S.bind(d),0);return{dispose(){clearTimeout(u)}}});var s;(function(S){function d(u){return u===S.None||u===S.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}S.isCancellationToken=d,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new P.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$3d=D}),define(re[142],oe([0,1,22]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class R{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$3d,d=this.b(S.token);return this.a={promise:d,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Be=R;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const d=JSON.stringify(S);return this.b!==d&&(this.b=d,this.a=this.c(S)),this.a}}e.$Ce=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const d=this.b(S);return this.a.set(S,d),d}}e.$De=M}),define(re[63],oe([0,1,14,2]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function s(E){const f=E;return f?typeof f.read=="function":!1}e.$4d=s;function M(E){const f=E;return f?[f.on,f.pause,f.resume,f.destroy].every(i=>typeof i=="function"):!1}e.$5d=M;function D(E){const f=E;return f?M(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.$6d=D;function S(E,f){return new d(E,f)}e.$7d=S;class d{constructor(f,i){this.e=f,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(i=>i(f))}h(f){this.c.error.length===0?(0,P.$1)(f):this.c.error.slice(0).forEach(i=>i(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,i){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(f,i){if(this.a.destroyed)return;let o;switch(f){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(E,f){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return f(i)}e.$8d=u;function p(E,f,i){const o=[];let r;for(;(r=E.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return E.read()}}}e.$9d=p;function v(E,f){return new Promise((i,o)=>{const r=[];b(E,{onData:t=>{f&&r.push(t)},onError:t=>{f?o(t):i(void 0)},onEnd:()=>{i(f?f(r):void 0)}})})}e.$0d=v;function b(E,f,i){E.on("error",o=>{i?.isCancellationRequested||f.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||f.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||f.onData(o)})}e.$$d=b;function l(E,f){return new Promise((i,o)=>{const r=new R.$Rc,t=[],n=A=>{if(t.push(A),t.length>f)return r.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},c=A=>(r.dispose(),o(A)),w=()=>(r.dispose(),i({stream:E,buffer:t,ended:!0}));r.add((0,R.$Qc)(()=>E.removeListener("error",c))),E.on("error",c),r.add((0,R.$Qc)(()=>E.removeListener("end",w))),E.on("end",w),r.add((0,R.$Qc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$_d=l;function y(E,f){const i=S(f);return i.end(E),i}e.$ae=y;function m(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$be=m;function $(E){let f=!1;return{read:()=>f?null:(f=!0,E)}}e.$ce=$;function g(E,f,i){const o=S(i);return b(E,{onData:r=>o.write(f.data(r)),onError:r=>o.error(f.error?f.error(r):r),onEnd:()=>o.end()}),o}e.$de=g;function h(E,f,i){let o=!1;return{read:()=>{const r=f.read();return o?r:(o=!0,r!==null?i([E,r]):E)}}}e.$ee=h;function a(E,f,i){let o=!1;const r=S(i);return b(f,{onData:t=>o?r.write(t):(o=!0,r.write(i([E,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}e.$fe=a}),define(re[18],oe([0,1,62,63]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const s=typeof Buffer<"u",M=new P.$V(()=>new Uint8Array(256));let D,S;class d{static alloc(C){return s?new d(Buffer.allocUnsafe(C)):new d(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new d(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new d(Buffer.from(C)):(D||(D=new TextEncoder),new d(D.encode(C)))}static fromByteArray(C){const j=d.alloc(C.length);for(let F=0,N=C.length;F<N;F++)j.buffer[F]=C[F];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let Y=0,Q=C.length;Y<Q;Y++)j+=C[Y].byteLength}const F=d.alloc(j);let N=0;for(let Y=0,Q=C.length;Y<Q;Y++){const le=C[Y];F.set(le,N),N+=le.byteLength}return F}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=d.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(C,j){return new d(this.buffer.subarray(C,j))}set(C,j){if(C instanceof d)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return b(this.buffer,C)}writeUInt32BE(C,j){l(this.buffer,C,j)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,j){m(this.buffer,C,j)}readUInt8(C){return $(this.buffer,C)}writeUInt8(C,j){g(this.buffer,C,j)}indexOf(C,j=0){return u(this.buffer,C instanceof d?C.buffer:C,j)}}e.$ge=d;function u(k,C,j=0){const F=C.byteLength,N=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(C[0]);if(F>N-j)return-1;const Y=M.value;Y.fill(C.length);for(let ue=0;ue<C.length;ue++)Y[C[ue]]=C.length-ue-1;let Q=j+C.length-1,le=Q,ce=-1;for(;Q<N;)if(k[Q]===C[le]){if(le===0){ce=Q;break}Q--,le--}else Q+=Math.max(C.length-le,Y[k[Q]]),le=C.length-1;return ce}e.$he=u;function p(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0}e.$ie=p;function v(k,C,j){k[j+0]=C&255,C=C>>>8,k[j+1]=C&255}e.$je=v;function b(k,C){return k[C]*2**24+k[C+1]*2**16+k[C+2]*2**8+k[C+3]}e.$ke=b;function l(k,C,j){k[j+3]=C,C=C>>>8,k[j+2]=C,C=C>>>8,k[j+1]=C,C=C>>>8,k[j]=C}e.$le=l;function y(k,C){return k[C+0]<<0>>>0|k[C+1]<<8>>>0|k[C+2]<<16>>>0|k[C+3]<<24>>>0}e.$me=y;function m(k,C,j){k[j+0]=C&255,C=C>>>8,k[j+1]=C&255,C=C>>>8,k[j+2]=C&255,C=C>>>8,k[j+3]=C&255}e.$ne=m;function $(k,C){return k[C]}e.$oe=$;function g(k,C,j){k[j]=C}e.$pe=g;function h(k){return R.$8d(k,C=>d.concat(C))}e.$qe=h;function a(k){return R.$ce(k)}e.$re=a;function E(k){return R.$0d(k,C=>d.concat(C))}e.$se=E;async function f(k){return k.ended?d.concat(k.buffer):d.concat([...k.buffer,await E(k.stream)])}e.$te=f;function i(k){return R.$ae(k,C=>d.concat(C))}e.$ue=i;function o(k){return R.$de(k,{data:C=>typeof C=="string"?d.fromString(C):d.wrap(C)},C=>d.concat(C))}e.$ve=o;function r(k){return R.$7d(C=>d.concat(C),k)}e.$we=r;function t(k,C){return R.$ee(k,C,j=>d.concat(j))}e.$xe=t;function n(k,C){return R.$fe(k,C,j=>d.concat(j))}e.$ye=n;function c(k){let C=0,j=0,F=0;const N=new Uint8Array(Math.floor(k.length/4*3)),Y=le=>{switch(j){case 3:N[F++]=C|le,j=0;break;case 2:N[F++]=C|le>>>2,C=le<<6,j=3;break;case 1:N[F++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<k.length;le++){const ce=k.charCodeAt(le);if(ce>=65&&ce<=90)Y(ce-65);else if(ce>=97&&ce<=122)Y(ce-97+26);else if(ce>=48&&ce<=57)Y(ce-48+52);else if(ce===43||ce===45)Y(62);else if(ce===47||ce===95)Y(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${k[le]}`)}}const Q=F;for(;j>0;)Y(0);return d.wrap(N).slice(0,Q)}e.$ze=c;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:k},C=!0,j=!1){const F=j?A:w;let N="";const Y=k.byteLength%3;let Q=0;for(;Q<k.byteLength-Y;Q+=3){const le=k[Q+0],ce=k[Q+1],ue=k[Q+2];N+=F[le>>>2],N+=F[(le<<4|ce>>>4)&63],N+=F[(ce<<2|ue>>>6)&63],N+=F[ue&63]}if(Y===1){const le=k[Q+0];N+=F[le>>>2],N+=F[le<<4&63],C&&(N+="==")}else if(Y===2){const le=k[Q+0],ce=k[Q+1];N+=F[le>>>2],N+=F[(le<<4|ce>>>4)&63],N+=F[ce<<2&63],C&&(N+="=")}return N}e.$Ae=I}),define(re[25],oe([0,1,142,62]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cf=e.$Bf=e.$Af=e.$zf=e.GraphemeBreakType=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function s(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Ge=s;const M=/{(\d+)}/g;function D(se,...de){return de.length===0?se:se.replace(M,function(we,ke){const De=parseInt(ke,10);return isNaN(De)||De<0||De>=de.length?we:de[De]})}e.$He=D;const S=/{([^}]+)}/g;function d(se,de){return Object.keys(de).length===0?se:se.replace(S,(we,ke)=>de[ke]??we)}e.$Ie=d;function u(se){return se.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Je=u;function p(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=p;function v(se,de){let we=0;const ke=de.charCodeAt(0);for(let De=se.length-1;De>=0;De--)se.charCodeAt(De)===ke&&we++;return we}e.$Le=v;function b(se,de,we="\u2026"){return se.length<=de?se:`${se.substr(0,de)}${we}`}e.$Me=b;function l(se,de=" "){const we=y(se,de);return m(we,de)}e.$Ne=l;function y(se,de){if(!se||!de)return se;const we=de.length;if(we===0||se.length===0)return se;let ke=0;for(;se.indexOf(de,ke)===ke;)ke=ke+we;return se.substring(ke)}e.$Oe=y;function m(se,de){if(!se||!de)return se;const we=de.length,ke=se.length;if(we===0||ke===0)return se;let De=ke,Fe=-1;for(;Fe=se.lastIndexOf(de,De-1),!(Fe===-1||Fe+we!==De);){if(Fe===0)return"";De=Fe}return se.substring(0,De)}e.$Pe=m;function $(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Qe=$;function g(se){return se.replace(/\*/g,"")}e.$Re=g;function h(se,de,we={}){if(!se)throw new Error("Cannot create regex from empty string");de||(se=p(se)),we.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ke="";return we.global&&(ke+="g"),we.matchCase||(ke+="i"),we.multiline&&(ke+="m"),we.unicode&&(ke+="u"),new RegExp(se,ke)}e.$Se=h;function a(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Te=a;function E(se){return se.split(/\r\n|\r|\n/)}e.$Ue=E;function f(se){for(let de=0,we=se.length;de<we;de++){const ke=se.charCodeAt(de);if(ke!==32&&ke!==9)return de}return-1}e.$Ve=f;function i(se,de=0,we=se.length){for(let ke=de;ke<we;ke++){const De=se.charCodeAt(ke);if(De!==32&&De!==9)return se.substring(de,ke)}return se.substring(de,we)}e.$We=i;function o(se,de=se.length-1){for(let we=de;we>=0;we--){const ke=se.charCodeAt(we);if(ke!==32&&ke!==9)return we}return-1}e.$Xe=o;function r(se,de,we){const ke=[];let De=0;for(const Fe of se.matchAll(de)){if(ke.push(se.slice(De,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");De=Fe.index+Fe[0].length,ke.push(we(Fe[0],...Fe.slice(1),Fe.index,se,Fe.groups))}return ke.push(se.slice(De)),Promise.all(ke).then(Fe=>Fe.join(""))}e.$Ye=r;function t(se,de){return se<de?-1:se>de?1:0}e.$Ze=t;function n(se,de,we=0,ke=se.length,De=0,Fe=de.length){for(;we<ke&&De<Fe;we++,De++){const qe=se.charCodeAt(we),Ge=de.charCodeAt(De);if(qe<Ge)return-1;if(qe>Ge)return 1}const je=ke-we,Ne=Fe-De;return je<Ne?-1:je>Ne?1:0}e.$1e=n;function c(se,de){return w(se,de,0,se.length,0,de.length)}e.$2e=c;function w(se,de,we=0,ke=se.length,De=0,Fe=de.length){for(;we<ke&&De<Fe;we++,De++){let qe=se.charCodeAt(we),Ge=de.charCodeAt(De);if(qe===Ge)continue;if(qe>=128||Ge>=128)return n(se.toLowerCase(),de.toLowerCase(),we,ke,De,Fe);I(qe)&&(qe-=32),I(Ge)&&(Ge-=32);const Je=qe-Ge;if(Je!==0)return Je}const je=ke-we,Ne=Fe-De;return je<Ne?-1:je>Ne?1:0}e.$3e=w;function A(se){return se>=48&&se<=57}e.$4e=A;function I(se){return se>=97&&se<=122}e.$5e=I;function k(se){return se>=65&&se<=90}e.$6e=k;function C(se,de){return se.length===de.length&&w(se,de)===0}e.$7e=C;function j(se,de){const we=de.length;return de.length>se.length?!1:w(se,de,0,we)===0}e.$8e=j;function F(se,de){const we=Math.min(se.length,de.length);let ke;for(ke=0;ke<we;ke++)if(se.charCodeAt(ke)!==de.charCodeAt(ke))return ke;return we}e.$9e=F;function N(se,de){const we=Math.min(se.length,de.length);let ke;const De=se.length-1,Fe=de.length-1;for(ke=0;ke<we;ke++)if(se.charCodeAt(De-ke)!==de.charCodeAt(Fe-ke))return ke;return we}e.$0e=N;function Y(se){return 55296<=se&&se<=56319}e.$$e=Y;function Q(se){return 56320<=se&&se<=57343}e.$_e=Q;function le(se,de){return(se-55296<<10)+(de-56320)+65536}e.$af=le;function ce(se,de,we){const ke=se.charCodeAt(we);if(Y(ke)&&we+1<de){const De=se.charCodeAt(we+1);if(Q(De))return le(ke,De)}return ke}e.$bf=ce;function ue(se,de){const we=se.charCodeAt(de-1);if(Q(we)&&de>1){const ke=se.charCodeAt(de-2);if(Y(ke))return le(ke,we)}return we}class K{get offset(){return this.e}constructor(de,we=0){this.c=de,this.d=de.length,this.e=we}setOffset(de){this.e=de}prevCodePoint(){const de=ue(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=ce(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$cf=K;class X{get offset(){return this.c.offset}constructor(de,we=0){this.c=new K(de,we)}nextGraphemeLength(){const de=fe.getInstance(),we=this.c,ke=we.offset;let De=de.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Fe=we.offset,je=de.getGraphemeBreakType(we.nextCodePoint());if(pe(De,je)){we.setOffset(Fe);break}De=je}return we.offset-ke}prevGraphemeLength(){const de=fe.getInstance(),we=this.c,ke=we.offset;let De=de.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Fe=we.offset,je=de.getGraphemeBreakType(we.prevCodePoint());if(pe(je,De)){we.setOffset(Fe);break}De=je}return ke-we.offset}eol(){return this.c.eol()}}e.$df=X;function H(se,de){return new X(se,de).nextGraphemeLength()}e.$ef=H;function L(se,de){return new X(se,de).prevGraphemeLength()}e.$ff=L;function T(se,de){de>0&&Q(se.charCodeAt(de))&&de--;const we=de+H(se,de);return[we-L(se,we),we]}e.$gf=T;function V(se){const de=new X(se);let we=0;for(;!de.eol();)we++,de.nextGraphemeLength();return we}e.$hf=V;let q;function te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he(se){return q||(q=te()),q.test(se)}e.$if=he;const G=/^[\t\n\r\x20-\x7E]*$/;function O(se){return G.test(se)}e.$jf=O,e.$kf=/[\u2028\u2029]/;function U(se){return e.$kf.test(se)}e.$lf=U;function x(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$mf=x;function z(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$nf=z;function Z(se,de){if(se.length<de)return se;const we=/\b/g;let ke=0;for(;we.test(se)&&!(se.length-we.lastIndex<de);)ke=we.lastIndex,we.lastIndex+=1;return se.substring(ke).replace(/^\s/,"")}e.$of=Z;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,B=/\x1b\].*?\x07/g;function _(se){return se&&(se=se.replace(W,"").replace(B,"")),se}e.$pf=_,e.$qf=String.fromCharCode(65279);function ae(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$rf=ae;function ne(se){return ae(se)?se.substr(1):se}e.$sf=ne;function $e(se,de){if(!se||!de||se.length<de.length)return!1;const we=de.length,ke=se.toLowerCase();let De=0,Fe=-1;for(;De<we;){const je=ke.indexOf(de[De],Fe+1);if(je<0)return!1;Fe=je,De++}return!0}e.$tf=$e;function me(se,de=!1){return se?(de&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$uf=me;function ye(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$vf=ye;function Se(se,de=1){if(de===0)return"";let we=-1;do we=se.indexOf(`
`,we+1),de--;while(de>0&&we>=0);return we===-1?se:(se[we-1]==="\r"&&we--,se.substr(0,we))}e.$wf=Se;function Le(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$xf=Le;function ve(se){return fe.getInstance().getGraphemeBreakType(se)}e.$yf=ve;function pe(se,de){return se===0?de!==5&&de!==7:se===2&&de===3?!1:se===4||se===2||se===3||de===4||de===2||de===3?!0:!(se===8&&(de===8||de===9||de===11||de===12)||(se===11||se===9)&&(de===9||de===10)||(se===12||se===10)&&de===10||de===5||de===13||de===7||se===1||se===13&&de===14||se===6&&de===6)}var ee;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class fe{static{this.c=null}static getInstance(){return fe.c||(fe.c=new fe),fe.c}constructor(){this.d=ge()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const we=this.d,ke=we.length/3;let De=1;for(;De<=ke;)if(de<we[3*De])De=2*De;else if(de>we[3*De+1])De=2*De+1;else return we[3*De+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(se,de){if(se===0)return 0;const we=Oe(se,de);if(we!==void 0)return we;const ke=new K(de,se);return ke.prevCodePoint(),ke.offset}e.$zf=Ce;function Oe(se,de){const we=new K(de,se);let ke=we.prevCodePoint();for(;Te(ke)||ke===65039||ke===8419;){if(we.offset===0)return;ke=we.prevCodePoint()}if(!z(ke))return;let De=we.offset;return De>0&&we.prevCodePoint()===8205&&(De=we.offset),De}function Te(se){return 127995<=se&&se<=127999}var Me;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$Af="\xA0";class Ve{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$Ce(de=>{function we(Je){const _e=new Map;for(let Qe=0;Qe<Je.length;Qe+=2)_e.set(Je[Qe],Je[Qe+1]);return _e}function ke(Je,_e){const Qe=new Map(Je);for(const[it,st]of _e)Qe.set(it,st);return Qe}function De(Je,_e){if(!Je)return _e;const Qe=new Map;for(const[it,st]of Je)_e.has(it)&&Qe.set(it,st);return Qe}const Fe=this.c.value;let je=de.filter(Je=>!Je.startsWith("_")&&Je in Fe);je.length===0&&(je=["_default"]);let Ne;for(const Je of je){const _e=we(Fe[Je]);Ne=De(Ne,_e)}const qe=we(Fe._common),Ge=ke(qe,Ne);return new Ve(Ge)})}static getInstance(de){return Ve.d.get(Array.from(de))}static{this.e=new R.$V(()=>Object.keys(Ve.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Bf=Ve;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(de){return Be.e().has(de)}static get codePoints(){return Be.e()}}e.$Cf=Be}),define(re[45],oe([0,1,25]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=void 0;function R(g){return s(g,0)}e.$Oi=R;function s(g,h){switch(typeof g){case"object":return g===null?M(349,h):Array.isArray(g)?d(g,h):u(g,h);case"string":return S(g,h);case"boolean":return D(g,h);case"number":return M(g,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Pi=s;function M(g,h){return(h<<5)-h+g|0}e.$Qi=M;function D(g,h){return M(g?433:863,h)}function S(g,h){h=M(149417,h);for(let a=0,E=g.length;a<E;a++)h=M(g.charCodeAt(a),h);return h}e.$Ri=S;function d(g,h){return h=M(104579,h),g.reduce((a,E)=>s(E,a),h)}function u(g,h){return h=M(181387,h),Object.keys(g).sort().reduce((a,E)=>(a=S(E,a),s(g[E],a)),h)}class p{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Si=p;var v;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(g,h,a=32){const E=a-h,f=~((1<<E)-1);return(g<<h|(f&g)>>>E)>>>0}function l(g,h=0,a=g.byteLength,E=0){for(let f=0;f<a;f++)g[h+f]=E}function y(g,h,a="0"){for(;g.length<h;)g=a+g;return g}function m(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(a=>a.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),h/4)}e.$Ti=m;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const a=h.length;if(a===0)return;const E=this.p;let f=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=h.charCodeAt(0),r=0);;){let t=o;if(P.$$e(o))if(r+1<a){const n=h.charCodeAt(r+1);P.$_e(n)?(r++,t=P.$af(o,n)):t=65533}else{i=o;break}else P.$_e(o)&&(t=65533);if(f=this.w(E,f,t),r++,r<a)o=h.charCodeAt(r);else break}this.r=f,this.u=i}w(h,a,E){return E<128?h[a++]=E:E<2048?(h[a++]=192|(E&1984)>>>6,h[a++]=128|(E&63)>>>0):E<65536?(h[a++]=224|(E&61440)>>>12,h[a++]=128|(E&4032)>>>6,h[a++]=128|(E&63)>>>0):(h[a++]=240|(E&1835008)>>>18,h[a++]=128|(E&258048)>>>12,h[a++]=128|(E&4032)>>>6,h[a++]=128|(E&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,a=this.q;for(let w=0;w<64;w+=4)h.setUint32(w,a.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)h.setUint32(w,b(h.getUint32(w-12,!1)^h.getUint32(w-32,!1)^h.getUint32(w-56,!1)^h.getUint32(w-64,!1),1),!1);let E=this.h,f=this.l,i=this.m,o=this.n,r=this.o,t,n,c;for(let w=0;w<80;w++)w<20?(t=f&i|~f&o,n=1518500249):w<40?(t=f^i^o,n=1859775393):w<60?(t=f&i|f&o|i&o,n=2400959708):(t=f^i^o,n=3395469782),c=b(E,5)+t+r+n+h.getUint32(w*4,!1)&4294967295,r=o,o=i,i=b(f,30),f=E,E=c;this.h=this.h+E&4294967295,this.l=this.l+f&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Ui=$}),define(re[74],oe([0,1,25]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const M="error",D="warning",S="warn",d="info",u="ignore";function p(b){return b?P.$7e(M,b)?s.Error:P.$7e(D,b)||P.$7e(S,b)?s.Warning:P.$7e(d,b)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function v(b){switch(b){case s.Error:return M;case s.Warning:return D;case s.Info:return d;default:return u}}s.toString=v}(R||(R={})),e.default=R}),define(re[143],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(re[57],oe([0,1,23,25]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class s{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const y=l.charCodeAt(0),m=this.b.charCodeAt(this.c);return y-m}value(){return this.b[this.c]}}e.$3h=s;class M{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,R.$1e)(l,this.b,0,l.length,this.c,this.d):(0,R.$3e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=M;class D{constructor(l=!0,y=!0){this.f=l,this.g=y}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let y=l.length-1;y>=0;y--,this.c--){const m=this.b.charCodeAt(y);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,R.$1e)(l,this.b,0,l.length,this.d,this.e):(0,R.$3e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=D;var S;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(S||(S={}));class d{constructor(l,y){this.f=l,this.g=y,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,R.$2e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,R.$2e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,R.$Ze)(l,this.c.query);if(this.d[this.e]===5)return(0,R.$Ze)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=d;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(p||(p={}));class v{static forUris(l=()=>!1,y=()=>!1){return new v(new d(l,y))}static forPaths(l=!1){return new v(new D(void 0,!l))}static forStrings(){return new v(new s)}static forConfigKeys(){return new v(new M)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,y){if(y){const m=y.slice(0);(0,P.$Xb)(m);for(const $ of m)this.set($,l)}else{const m=l.slice(0);(0,P.$Xb)(m);for(const $ of m)this.set($[0],$[1])}}set(l,y){const m=this.b.reset(l);let $;this.c||(this.c=new u,this.c.segment=m.value());const g=[];for($=this.c;;){const a=m.cmp($.segment);if(a>0)$.left||($.left=new u,$.left.segment=m.value()),g.push([-1,$]),$=$.left;else if(a<0)$.right||($.right=new u,$.right.segment=m.value()),g.push([1,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new u,$.mid.segment=m.value()),g.push([0,$]),$=$.mid;else break}const h=$.value;$.value=y,$.key=l;for(let a=g.length-1;a>=0;a--){const E=g[a][1];E.updateHeight();const f=E.balanceFactor();if(f<-1||f>1){const i=g[a][0],o=g[a+1][0];if(i===1&&o===1)g[a][1]=E.rotateLeft();else if(i===-1&&o===-1)g[a][1]=E.rotateRight();else if(i===1&&o===-1)E.right=g[a+1][1]=g[a+1][1].rotateRight(),g[a][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=g[a+1][1]=g[a+1][1].rotateLeft(),g[a][1]=E.rotateRight();else throw new Error;if(a>0)switch(g[a-1][0]){case-1:g[a-1][1].left=g[a][1];break;case 1:g[a-1][1].right=g[a][1];break;case 0:g[a-1][1].mid=g[a][1];break}else this.c=g[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const y=this.b.reset(l);let m=this.c;for(;m;){const $=y.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(y.hasNext())y.next(),m=m.mid;else break}return m}has(l){const y=this.d(l);return!(y?.value===void 0&&y?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,y){const m=this.b.reset(l),$=[];let g=this.c;for(;g;){const h=m.cmp(g.segment);if(h>0)$.push([-1,g]),g=g.left;else if(h<0)$.push([1,g]),g=g.right;else if(m.hasNext())m.next(),$.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this.f(g.right);if(h.key){const{key:a,value:E,segment:f}=h;this.e(h.key,!1),g.key=a,g.value=E,g.segment=f}}else{const h=g.left??g.right;if($.length>0){const[a,E]=$[$.length-1];switch(a){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this.c=h}for(let h=$.length-1;h>=0;h--){const a=$[h][1];a.updateHeight();const E=a.balanceFactor();if(E>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),$[h][1]=a.rotateLeft()):E<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),$[h][1]=a.rotateRight()),h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const y=this.b.reset(l);let m=this.c,$;for(;m;){const g=y.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(y.hasNext())y.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(l){return this.g(l,!1)}g(l,y){const m=this.b.reset(l);let $=this.c;for(;$;){const g=m.cmp($.segment);if(g>0)$=$.left;else if(g<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):y?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[y,m]of this)l(m,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const y=[];return this.j(l,y),y[Symbol.iterator]()}j(l,y){l&&(l.left&&this.j(l.left,y),l.value&&y.push([l.key,l.value]),l.mid&&this.j(l.mid,y),l.right&&this.j(l.right,y))}_isBalanced(){const l=y=>{if(!y)return!0;const m=y.balanceFactor();return m<-1||m>1?!1:l(y.left)&&l(y.right)};return l(this.c)}}e.$7h=v}),define(re[12],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=void 0;function P(f){return typeof f=="string"}e.$Df=P;function R(f){return Array.isArray(f)&&f.every(i=>P(i))}e.$Ef=R;function s(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.$Ff=s;function M(f){const i=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof i}e.$Gf=M;function D(f){return typeof f=="number"&&!isNaN(f)}e.$Hf=D;function S(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.$If=S;function d(f){return f===!0||f===!1}e.$Jf=d;function u(f){return typeof f>"u"}e.$Kf=u;function p(f){return!v(f)}e.$Lf=p;function v(f){return u(f)||f===null}e.$Mf=v;function b(f,i){if(!f)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Nf=b;function l(f){if(v(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.$Of=l;function y(...f){const i=[];for(let o=0;o<f.length;o++){const r=f[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Pf=y;const m=Object.prototype.hasOwnProperty;function $(f){if(!s(f))return!1;for(const i in f)if(m.call(f,i))return!1;return!0}e.$Qf=$;function g(f){return typeof f=="function"}e.$Rf=g;function h(...f){return f.length>0&&f.every(g)}e.$Sf=h;function a(f,i){const o=Math.min(f.length,i.length);for(let r=0;r<o;r++)E(f[r],i[r])}e.$Tf=a;function E(f,i){if(P(i)){if(typeof f!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(f instanceof i)return}catch{}if(!v(f)&&f.constructor===i||i.length===1&&i.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Uf=E}),define(re[75],oe([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=e.$5j=void 0;const R=Object.create(null);function s(S,d){if((0,P.$Df)(d)){const u=R[d];if(u===void 0)throw new Error(`${S} references an unknown codicon: ${d}`);d=u}return R[S]=d,{id:S}}function M(){return R}e.$5j=M;function D(){return Object.values(e.$7j)}e.$6j=D,e.$7j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(re[38],oe([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([a,E])=>{h[a]=E&&typeof E=="object"?R(E):E}),h}e.$gn=R;function s(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const a=h.shift();Object.freeze(a);for(const E in a)if(M.call(a,E)){const f=a[E];typeof f=="object"&&!Object.isFrozen(f)&&!(0,P.$Gf)(f)&&h.push(f)}}return g}e.$hn=s;const M=Object.prototype.hasOwnProperty;function D(g,h){return S(g,h,new Set)}e.$in=D;function S(g,h,a){if((0,P.$Mf)(g))return g;const E=h(g);if(typeof E<"u")return E;if(Array.isArray(g)){const f=[];for(const i of g)f.push(S(i,h,a));return f}if((0,P.$Ff)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const f={};for(const i in g)M.call(g,i)&&(f[i]=S(g[i],h,a));return a.delete(g),f}return g}function d(g,h,a=!0){return(0,P.$Ff)(g)?((0,P.$Ff)(h)&&Object.keys(h).forEach(E=>{E in g?a&&((0,P.$Ff)(g[E])&&(0,P.$Ff)(h[E])?d(g[E],h[E],a):g[E]=h[E]):g[E]=h[E]}),g):h}e.$jn=d;function u(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let a,E;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(a=0;a<g.length;a++)if(!u(g[a],h[a]))return!1}else{const f=[];for(E in g)f.push(E);f.sort();const i=[];for(E in h)i.push(E);if(i.sort(),!u(f,i))return!1;for(a=0;a<f.length;a++)if(!u(g[f[a]],h[f[a]]))return!1}return!0}e.$kn=u;function p(g){const h=new Set;return JSON.stringify(g,(a,E)=>{if((0,P.$Ff)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.$ln=p;function v(g,h){const a=Object.create(null);return!g||!h||Object.keys(h).forEach(f=>{const i=g[f],o=h[f];u(i,o)||(a[f]=o)}),a}e.$mn=v;function b(g,h){const a=h.toLowerCase(),E=Object.keys(g).find(f=>f.toLowerCase()===a);return E?g[E]:g[h]}e.$nn=b;function l(g,h){const a=Object.create(null);for(const[E,f]of Object.entries(g))h(E,f)&&(a[E]=f);return a}e.$on=l;function y(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.$pn=y;function m(g){const h=[];for(const a of y(g))typeof g[a]=="function"&&h.push(a);return h}e.$qn=m;function $(g,h){const a=f=>function(){const i=Array.prototype.slice.call(arguments,0);return h(f,i)},E={};for(const f of g)E[f]=a(f);return E}e.$rn=$}),define(re[102],oe([0,1,75]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$8j=e.ThemeColor=void 0;var R;(function(D){function S(d){return d&&typeof d=="object"&&typeof d.id=="string"}D.isThemeColor=S})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$8j=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function d(h){const a=S.exec(h.id);if(!a)return d(P.$7j.error);const[,E,f]=a,i=["codicon","codicon-"+E];return f&&i.push("codicon-modifier-"+f.substring(1)),i}D.asClassNameArray=d;function u(h){return d(h).join(" ")}D.asClassName=u;function p(h){return"."+d(h).join(".")}D.asCSSSelector=p;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}D.isThemeIcon=v;const b=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function l(h){const a=b.exec(h);if(!a)return;const[,E]=a;return{id:E}}D.fromString=l;function y(h){return{id:h}}D.fromId=y;function m(h,a){let E=h.id;const f=E.lastIndexOf("~");return f!==-1&&(E=E.substring(0,f)),a&&(E=`${E}~${a}`),{id:E}}D.modify=m;function $(h){const a=h.id.lastIndexOf("~");if(a!==-1)return h.id.substring(a+1)}D.getModifier=$;function g(h,a){return h.id===a.id&&h.color?.id===a.color?.id}D.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(re[32],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return P.test(s)}e.$kg=R,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let d=0;d<S.length;d++)S[d]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,u="";return u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u}}()}),define(re[144],oe([0,1,86,46,84]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0T=void 0;async function M(D,S){if(await new Promise((p,v)=>{const b=R.createReadStream(D),l=P.createHash("sha1");b.pipe(l);const y=(0,s.$db)((m,$)=>{b.removeAllListeners(),l.removeAllListeners(),m?v(m):p($)});b.once("error",y),b.once("end",y),l.once("error",y),l.once("data",m=>y(void 0,m.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$0T=M}),define(re[145],oe([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!R.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const d=D[S];if(d){for(const{mac:u}of d)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$3m=M}),define(re[103],oe([0,1,87]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=e.$ng=void 0;function R(S,d,u,p=1){let v=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!v)return v=!0,b(0)},u);s(S,d,p,y=>{if(!v)return v=!0,clearTimeout(l),b(y)})})}e.$ng=R;function s(S,d,u,p){if(d===0)return p(0);const v=new P.Socket;v.once("connect",()=>(D(v),s(S+u,d-1,u,p))),v.once("data",()=>{}),v.once("error",b=>(D(v),b.code!=="ECONNREFUSED"?s(S+u,d-1,u,p):p(S))),v.connect(S,"127.0.0.1")}e.$og={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,d,u,p="127.0.0.1"){let v=!1,b,l=1;const y=P.createServer({pauseOnConnect:!0});function m($,g){v||(v=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),g($))}return new Promise($=>{b=setTimeout(()=>{m(0,$)},u),y.on("listening",()=>{m(S,$)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&l<d?(S++,l++,y.listen(S,p)):m(0,$)}),y.on("close",()=>{m(0,$)}),y.listen(S,p)})}e.$pg=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(d){console.error(d)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function P(d){const u=new Set;if(Array.isArray(d))for(const p of d)typeof p=="string"&&u.add(p);return Array.from(u)}function R(){const d=e();return d?Array.from(d):[]}function s(d){if(process.platform!=="win32")return;const u=e();if(u)if(typeof d=="string")u.add(d.toLowerCase());else for(const p of P(d))s(p)}function M(d){if(typeof d!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const v of u){if(d.indexOf(v)!==0)continue;const l=d.indexOf("\\",v.length);if(l===-1)continue;const y=d.substring(v.length,l);if(y){p=y;break}}return p}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[146],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bU=e.$aU=void 0,e.$aU="vscode:contextmenu",e.$bU="vscode:onCloseContextMenu"}),define(re[147],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iU=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$iU=P}),define(re[148],oe([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(re[149],oe([0,1,148]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0;const R=60,s=R*60,M=s*24,D=M*7,S=M*30,d=M*365;function u(v,b,l,y){typeof v!="number"&&(v=v.getTime());const m=Math.round((new Date().getTime()-v)/1e3);if(m<-30)return(0,P.localize)(0,null,u(new Date().getTime()+m*1e3,!1));if(!y&&m<30)return(0,P.localize)(1,null);let $;return m<R?($=m,b?$===1?l?(0,P.localize)(2,null,$):(0,P.localize)(3,null,$):l?(0,P.localize)(4,null,$):(0,P.localize)(5,null,$):$===1?l?(0,P.localize)(6,null,$):(0,P.localize)(7,null,$):l?(0,P.localize)(8,null,$):(0,P.localize)(9,null,$)):m<s?($=Math.floor(m/R),b?$===1?l?(0,P.localize)(10,null,$):(0,P.localize)(11,null,$):l?(0,P.localize)(12,null,$):(0,P.localize)(13,null,$):$===1?l?(0,P.localize)(14,null,$):(0,P.localize)(15,null,$):l?(0,P.localize)(16,null,$):(0,P.localize)(17,null,$)):m<M?($=Math.floor(m/s),b?$===1?l?(0,P.localize)(18,null,$):(0,P.localize)(19,null,$):l?(0,P.localize)(20,null,$):(0,P.localize)(21,null,$):$===1?l?(0,P.localize)(22,null,$):(0,P.localize)(23,null,$):l?(0,P.localize)(24,null,$):(0,P.localize)(25,null,$)):m<D?($=Math.floor(m/M),b?$===1?(0,P.localize)(26,null,$):(0,P.localize)(27,null,$):$===1?(0,P.localize)(28,null,$):(0,P.localize)(29,null,$)):m<S?($=Math.floor(m/D),b?$===1?l?(0,P.localize)(30,null,$):(0,P.localize)(31,null,$):l?(0,P.localize)(32,null,$):(0,P.localize)(33,null,$):$===1?l?(0,P.localize)(34,null,$):(0,P.localize)(35,null,$):l?(0,P.localize)(36,null,$):(0,P.localize)(37,null,$)):m<d?($=Math.floor(m/S),b?$===1?l?(0,P.localize)(38,null,$):(0,P.localize)(39,null,$):l?(0,P.localize)(40,null,$):(0,P.localize)(41,null,$):$===1?l?(0,P.localize)(42,null,$):(0,P.localize)(43,null,$):l?(0,P.localize)(44,null,$):(0,P.localize)(45,null,$)):($=Math.floor(m/d),b?$===1?l?(0,P.localize)(46,null,$):(0,P.localize)(47,null,$):l?(0,P.localize)(48,null,$):(0,P.localize)(49,null,$):$===1?l?(0,P.localize)(50,null,$):(0,P.localize)(51,null,$):l?(0,P.localize)(52,null,$):(0,P.localize)(53,null,$))}e.$pm=u;function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$qm=p}),define(re[150],oe([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(re[50],oe([0,1,23,12,150]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function M(v,b){return b&&(v.stack||v.stacktrace)?s.localize(0,null,S(v),D(v.stack)||D(v.stacktrace)):S(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?s.localize(1,null,v.message):v.message||s.localize(2,null)}function d(v=null,b=!1){if(!v)return s.localize(3,null);if(Array.isArray(v)){const l=P.$Hb(v),y=d(l[0],b);return l.length>1?s.localize(4,null,y,l.length):y}if(R.$Df(v))return v;if(v.detail){const l=v.detail;if(l.error)return M(l.error,b);if(l.exception)return M(l.exception,b)}return v.stack?M(v,b):v.message?v.message:s.localize(5,null)}e.$Li=d;function u(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.$Mi=u;function p(v,b){let l;return typeof v=="string"?l=new Error(v):l=v,l.actions=b,l}e.$Ni=p}),define(re[151],oe([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(re[152],oe([0,1,151]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;function R(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Ip=R}),define(re[153],oe([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,153]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,s=!1,M=!1,D=!1,S=!1,d=!1,u=!1,p=!1,v=!1,b=!1,l,y=e.$g,m=e.$g,$,g;const h=globalThis;let a;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?a=h.vscode.process:typeof process<"u"&&(a=process);const E=typeof a?.versions?.electron=="string",f=E&&a?.type==="renderer";if(typeof navigator=="object"&&!f)g=navigator.userAgent,R=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,b=g?.indexOf("Mobi")>=0,d=!0,l=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,y=l,m=navigator.language;else if(typeof a=="object"){R=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",D=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,u=E,v=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,y=e.$g;const k=a.env.VSCODE_NLS_CONFIG;if(k)try{const C=JSON.parse(k),j=C.availableLanguages["*"];l=C.locale,m=C.osLocale,y=j||e.$g,$=C._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:R?r=3:M&&(r=2),e.$i=R,e.$j=s,e.$k=M,e.$l=D,e.$m=S,e.$n=u,e.$o=d,e.$p=d&&typeof h.importScripts=="function",e.$q=e.$p?h.origin:void 0,e.$r=p,e.$s=b,e.$t=v,e.$u=r,e.$v=g,e.$w=y;var t;(function(k){function C(){return e.$w}k.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=j;function F(){return e.$w==="en"}k.isDefault=F})(t||(e.Language=t={})),e.$x=l,e.$y=m,e.$z=$,e.$A=typeof h.postMessage=="function"&&!h.importScripts,e.$B=(()=>{if(e.$A){const k=[];h.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let F=0,N=k.length;F<N;F++){const Y=k[F];if(Y.id===j.data.vscodeScheduleAsyncWork){k.splice(F,1),Y.callback();return}}});let C=0;return j=>{const F=++C;k.push({id:F,callback:j}),h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return k=>setTimeout(k)})();var n;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||p?2:R?1:3;let c=!0,w=!1;function A(){if(!w){w=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,c=new Uint16Array(k.buffer)[0]===(2<<8)+1}return c}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(k){return parseFloat(k)>=20}e.$J=I}),define(re[35],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(re[9],oe([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,M=90,D=122,S=46,d=47,u=92,p=58,v=63;class b extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${c} ${n} of type ${r}`;w+=`. Received type ${typeof t}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new b(o,"Object",i)}function y(i,o){if(typeof i!="string")throw new b(o,"string",i)}const m=P.$dc==="win32";function $(i){return i===d||i===u}function g(i){return i===d}function h(i){return i>=R&&i<=M||i>=s&&i<=D}function a(i,o,r,t){let n="",c=0,w=-1,A=0,I=0;for(let k=0;k<=i.length;++k){if(k<i.length)I=i.charCodeAt(k);else{if(t(I))break;I=d}if(t(I)){if(!(w===k-1||A===1))if(A===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",c=0):(n=n.slice(0,C),c=n.length-1-n.lastIndexOf(r)),w=k,A=0;continue}else if(n.length!==0){n="",c=0,w=k,A=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${i.slice(w+1,k)}`:n=i.slice(w+1,k),c=k-w-1;w=k,A=0}else I===S&&A!==-1?++A:A=-1}return n}function E(i,o){l(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$fc={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let c;if(n>=0){if(c=i[n],y(c,"path"),c.length===0)continue}else o.length===0?c=P.cwd():(c=P.env[`=${o}`]||P.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const w=c.length;let A=0,I="",k=!1;const C=c.charCodeAt(0);if(w===1)$(C)&&(A=1,k=!0);else if($(C))if(k=!0,$(c.charCodeAt(1))){let j=2,F=j;for(;j<w&&!$(c.charCodeAt(j));)j++;if(j<w&&j!==F){const N=c.slice(F,j);for(F=j;j<w&&$(c.charCodeAt(j));)j++;if(j<w&&j!==F){for(F=j;j<w&&!$(c.charCodeAt(j));)j++;(j===w||j!==F)&&(I=`\\\\${N}\\${c.slice(F,j)}`,A=j)}}}else A=1;else h(C)&&c.charCodeAt(1)===p&&(I=c.slice(0,2),A=2,w>2&&$(c.charCodeAt(2))&&(k=!0,A=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(t){if(o.length>0)break}else if(r=`${c.slice(A)}\\${r}`,t=k,k&&o.length>0)break}return r=a(r,!t,"\\",$),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){y(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const c=i.charCodeAt(0);if(o===1)return g(c)?"\\":i;if($(c))if(n=!0,$(i.charCodeAt(1))){let A=2,I=A;for(;A<o&&!$(i.charCodeAt(A));)A++;if(A<o&&A!==I){const k=i.slice(I,A);for(I=A;A<o&&$(i.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!$(i.charCodeAt(A));)A++;if(A===o)return`\\\\${k}\\${i.slice(I)}\\`;A!==I&&(t=`\\\\${k}\\${i.slice(I,A)}`,r=A)}}}else r=1;else h(c)&&i.charCodeAt(1)===p&&(t=i.slice(0,2),r=2,o>2&&$(i.charCodeAt(2))&&(n=!0,r=3));let w=r<o?a(i.slice(r),!n,"\\",$):"";return w.length===0&&!n&&(w="."),w.length>0&&$(i.charCodeAt(o-1))&&(w+="\\"),t===void 0?n?`\\${w}`:w:n?`${t}\\${w}`:`${t}${w}`},isAbsolute(i){y(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return $(r)||o>2&&h(r)&&i.charCodeAt(1)===p&&$(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let c=0;c<i.length;++c){const w=i[c];y(w,"path"),w.length>0&&(o===void 0?o=r=w:o+=`\\${w}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const c=r.length;c>1&&$(r.charCodeAt(1))&&(++n,c>2&&($(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&$(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o)return"";const r=e.$fc.resolve(i),t=e.$fc.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===u;)n++;let c=i.length;for(;c-1>n&&i.charCodeAt(c-1)===u;)c--;const w=c-n;let A=0;for(;A<o.length&&o.charCodeAt(A)===u;)A++;let I=o.length;for(;I-1>A&&o.charCodeAt(I-1)===u;)I--;const k=I-A,C=w<k?w:k;let j=-1,F=0;for(;F<C;F++){const Y=i.charCodeAt(n+F);if(Y!==o.charCodeAt(A+F))break;Y===u&&(j=F)}if(F!==C){if(j===-1)return t}else{if(k>C){if(o.charCodeAt(A+F)===u)return t.slice(A+F+1);if(F===2)return t.slice(A+F)}w>C&&(i.charCodeAt(n+F)===u?j=F:F===2&&(j=3)),j===-1&&(j=0)}let N="";for(F=n+j+1;F<=c;++F)(F===c||i.charCodeAt(F)===u)&&(N+=N.length===0?"..":"\\..");return A+=j,N.length>0?`${N}${t.slice(A,I)}`:(t.charCodeAt(A)===u&&++A,t.slice(A,I))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const r=o.charCodeAt(2);if(r!==v&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return i},dirname(i){y(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return $(n)?i:".";if($(n)){if(r=t=1,$(i.charCodeAt(1))){let A=2,I=A;for(;A<o&&!$(i.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&$(i.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!$(i.charCodeAt(A));)A++;if(A===o)return i;A!==I&&(r=t=A+1)}}}}else h(n)&&i.charCodeAt(1)===p&&(r=o>2&&$(i.charCodeAt(2))?3:2,t=r);let c=-1,w=!0;for(let A=o-1;A>=t;--A)if($(i.charCodeAt(A))){if(!w){c=A;break}}else w=!1;if(c===-1){if(r===-1)return".";c=r}return i.slice(0,c)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,c;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===p&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let w=o.length-1,A=-1;for(c=i.length-1;c>=r;--c){const I=i.charCodeAt(c);if($(I)){if(!n){r=c+1;break}}else A===-1&&(n=!1,A=c+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(t=c):(w=-1,t=A))}return r===t?t=A:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=r;--c)if($(i.charCodeAt(c))){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=0,r=-1,t=0,n=-1,c=!0,w=0;i.length>=2&&i.charCodeAt(1)===p&&h(i.charCodeAt(0))&&(o=t=2);for(let A=i.length-1;A>=o;--A){const I=i.charCodeAt(A);if($(I)){if(!c){t=A+1;break}continue}n===-1&&(c=!1,n=A+1),I===S?r===-1?r=A:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||n===-1||w===0||w===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:E.bind(null,"\\"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return $(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if($(n)){if(t=1,$(i.charCodeAt(1))){let j=2,F=j;for(;j<r&&!$(i.charCodeAt(j));)j++;if(j<r&&j!==F){for(F=j;j<r&&$(i.charCodeAt(j));)j++;if(j<r&&j!==F){for(F=j;j<r&&!$(i.charCodeAt(j));)j++;j===r?t=j:j!==F&&(t=j+1)}}}}else if(h(n)&&i.charCodeAt(1)===p){if(r<=2)return o.root=o.dir=i,o;if(t=2,$(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let c=-1,w=t,A=-1,I=!0,k=i.length-1,C=0;for(;k>=t;--k){if(n=i.charCodeAt(k),$(n)){if(!I){w=k+1;break}continue}A===-1&&(I=!1,A=k+1),n===S?c===-1?c=k:C!==1&&(C=1):c!==-1&&(C=-1)}return A!==-1&&(c===-1||C===0||C===1&&c===A-1&&c===w+1?o.base=o.name=i.slice(w,A):(o.name=i.slice(w,c),o.base=i.slice(w,A),o.ext=i.slice(c,A))),w>0&&w!==t?o.dir=i.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(m){const i=/\\/g;return()=>{const o=P.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:f();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===d)}return o=a(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d,r=i.charCodeAt(i.length-1)===d;return i=a(i,!o,"/",g),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return y(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,c=1,w=o.length-c,A=n<w?n:w;let I=-1,k=0;for(;k<A;k++){const j=i.charCodeAt(r+k);if(j!==o.charCodeAt(c+k))break;j===d&&(I=k)}if(k===A)if(w>A){if(o.charCodeAt(c+k)===d)return o.slice(c+k+1);if(k===0)return o.slice(c+k)}else n>A&&(i.charCodeAt(r+k)===d?I=k:k===0&&(I=0));let C="";for(k=r+I+1;k<=t;++k)(k===t||i.charCodeAt(k)===d)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(c+I)}`},toNamespacedPath(i){return i},dirname(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===d){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let w=o.length-1,A=-1;for(c=i.length-1;c>=0;--c){const I=i.charCodeAt(c);if(I===d){if(!n){r=c+1;break}}else A===-1&&(n=!1,A=c+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(t=c):(w=-1,t=A))}return r===t?t=A:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===d){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=-1,r=0,t=-1,n=!0,c=0;for(let w=i.length-1;w>=0;--w){const A=i.charCodeAt(w);if(A===d){if(!n){r=w+1;break}continue}t===-1&&(n=!1,t=w+1),A===S?o===-1?o=w:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||t===-1||c===0||c===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:E.bind(null,"/"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===d;let t;r?(o.root="/",t=1):t=0;let n=-1,c=0,w=-1,A=!0,I=i.length-1,k=0;for(;I>=t;--I){const C=i.charCodeAt(I);if(C===d){if(!A){c=I+1;break}continue}w===-1&&(A=!1,w=I+1),C===S?n===-1?n=I:k!==1&&(k=1):n!==-1&&(k=-1)}if(w!==-1){const C=c===0&&r?1:c;n===-1||k===0||k===1&&n===w-1&&n===c+1?o.base=o.name=i.slice(C,w):(o.name=i.slice(C,n),o.base=i.slice(C,w),o.ext=i.slice(n,w))}return c>0?o.dir=i.slice(0,c-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(re[33],oe([0,1,9,4,25,12]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function D(c){return c===47||c===92}e.$Vf=D;function S(c){return c.replace(/[\\/]/g,P.$gc.sep)}e.$Wf=S;function d(c){return c.indexOf("/")===-1&&(c=S(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Xf=d;function u(c,w=P.$gc.sep){if(!c)return"";const A=c.length,I=c.charCodeAt(0);if(D(I)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let C=3;const j=C;for(;C<A&&!D(c.charCodeAt(C));C++);if(j!==C&&!D(c.charCodeAt(C+1))){for(C+=1;C<A;C++)if(D(c.charCodeAt(C)))return c.slice(0,C+1).replace(/[\\/]/g,w)}}return w}else if(g(I)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+w:c.slice(0,2);let k=c.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(D(c.charCodeAt(k)))return c.slice(0,k+1)}return""}e.$Yf=u;function p(c){if(!R.$i||!c||c.length<5)return!1;let w=c.charCodeAt(0);if(w!==92||(w=c.charCodeAt(1),w!==92))return!1;let A=2;const I=A;for(;A<c.length&&(w=c.charCodeAt(A),w!==92);A++);return!(I===A||(w=c.charCodeAt(A+1),isNaN(w)||w===92))}e.$Zf=p;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,w=R.$i){const A=w?v:b;return!(!c||c.length===0||/^\s+$/.test(c)||(A.lastIndex=0,A.test(c))||w&&l.test(c)||c==="."||c===".."||w&&c[c.length-1]==="."||w&&c.length!==c.trim().length||c.length>255)}e.$1f=y;function m(c,w,A){const I=c===w;return!A||I?I:!c||!w?!1:(0,s.$7e)(c,w)}e.$2f=m;function $(c,w,A,I=P.sep){if(c===w)return!0;if(!c||!w||w.length>c.length)return!1;if(A){if(!(0,s.$8e)(c,w))return!1;if(w.length===c.length)return!0;let C=w.length;return w.charAt(w.length-1)===I&&C--,c.charAt(C)===I}return w.charAt(w.length-1)!==I&&(w+=I),c.indexOf(w)===0}e.$3f=$;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.$4f=g;function h(c,w){return R.$i&&c.endsWith(":")&&(c+=P.sep),(0,P.$ic)(c)||(c=(0,P.$jc)(w,c)),c=(0,P.$hc)(c),R.$i?(c=(0,s.$Pe)(c,P.sep),c.endsWith(":")&&(c+=P.sep)):(c=(0,s.$Pe)(c,P.sep),c||(c=P.sep)),c}e.$5f=h;function a(c){const w=(0,P.$hc)(c);return R.$i?c.length>3?!1:E(w)&&(c.length===2||w.charCodeAt(2)===92):w===P.$gc.sep}e.$6f=a;function E(c,w=R.$i){return w?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$7f=E;function f(c,w=R.$i){return E(c,w)?c[0]:void 0}e.$8f=f;function i(c,w,A){return w.length>c.length?-1:c===w?0:(A&&(c=c.toLowerCase(),w=w.toLowerCase()),c.indexOf(w))}e.$9f=i;function o(c){const w=c.split(":");let A,I,k;for(const C of w){const j=Number(C);(0,M.$Hf)(j)?I===void 0?I=j:k===void 0&&(k=j):A=A?[A,C].join(":"):C}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:I!==void 0?I:void 0,column:k!==void 0?k:I!==void 0?1:void 0}}e.$0f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,w,A=8){let I="";for(let C=0;C<A;C++){let j;C===0&&R.$i&&!w&&(A===3||A===4)?j=t:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let k;return w?k=`${w}-${I}`:k=I,c?(0,P.$jc)(c,k):k}e.$$f=n}),define(re[76],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...d){const u=d.reduce((b,l)=>(b[l]=!0,b),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(b=>!u[b]).forEach(b=>{for(let l=0;l<p.length;l++)if(b.search(p[l])!==-1){delete S[b];break}})}e.$Ll=M;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$Ml=D}),define(re[7],oe([0,1,9,4]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(t,n){return!t&&!n?"file":t}function u(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const p="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,w,A,I,k=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=d(n,k),this.authority=c||p,this.path=u(this.scheme,w||p),this.query=A||p,this.fragment=I||p,S(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:w,path:A,query:I,fragment:k}=n;return c===void 0?c=this.scheme:c===null&&(c=p),w===void 0?w=this.authority:w===null&&(w=p),A===void 0?A=this.path:A===null&&(A=p),I===void 0?I=this.query:I===null&&(I=p),k===void 0?k=this.fragment:k===null&&(k=p),c===this.scheme&&w===this.authority&&A===this.path&&I===this.query&&k===this.fragment?this:new $(c,w,A,I,k)}static parse(n,c=!1){const w=b.exec(n);return w?new $(w[2]||p,r(w[4]||p),r(w[5]||p),r(w[7]||p),r(w[9]||p),c):new $(p,p,p,p,p)}static file(n){let c=p;if(R.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const w=n.indexOf(v,2);w===-1?(c=n.substring(2),n=v):(c=n.substring(2,w),n=n.substring(w)||v)}return new $("file",c,n,p,p)}static from(n,c){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return R.$i&&n.scheme==="file"?w=l.file(P.$fc.join(E(n,!0),...c)).path:w=P.$gc.join(n.path,...c),n.with({path:w})}toString(n=!1){return f(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const c=new $(n);return c._formatted=n.external??null,c._fsPath=n._sep===m?n.fsPath??null:null,c}}else return n}}e.URI=l;function y(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=y;const m=R.$i?1:void 0;class $ extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,n,c){let w,A=-1;for(let I=0;I<t.length;I++){const k=t.charCodeAt(I);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||c&&k===91||c&&k===93||c&&k===58)A!==-1&&(w+=encodeURIComponent(t.substring(A,I)),A=-1),w!==void 0&&(w+=t.charAt(I));else{w===void 0&&(w=t.substr(0,I));const C=g[k];C!==void 0?(A!==-1&&(w+=encodeURIComponent(t.substring(A,I)),A=-1),w+=C):A===-1&&(A=I)}}return A!==-1&&(w+=encodeURIComponent(t.substring(A))),w!==void 0?w:t}function a(t){let n;for(let c=0;c<t.length;c++){const w=t.charCodeAt(c);w===35||w===63?(n===void 0&&(n=t.substr(0,c)),n+=g[w]):n!==void 0&&(n+=t[c])}return n!==void 0?n:t}function E(t,n){let c;return t.authority&&t.path.length>1&&t.scheme==="file"?c=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?c=t.path.substr(1):c=t.path[1].toLowerCase()+t.path.substr(2):c=t.path,R.$i&&(c=c.replace(/\//g,"\\")),c}e.$wc=E;function f(t,n){const c=n?a:h;let w="",{scheme:A,authority:I,path:k,query:C,fragment:j}=t;if(A&&(w+=A,w+=":"),(I||A==="file")&&(w+=v,w+=v),I){let F=I.indexOf("@");if(F!==-1){const N=I.substr(0,F);I=I.substr(F+1),F=N.lastIndexOf(":"),F===-1?w+=c(N,!1,!1):(w+=c(N.substr(0,F),!1,!1),w+=":",w+=c(N.substr(F+1),!1,!0)),w+="@"}I=I.toLowerCase(),F=I.lastIndexOf(":"),F===-1?w+=c(I,!1,!0):(w+=c(I.substr(0,F),!1,!0),w+=I.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}w+=c(k,!0,!1)}return C&&(w+="?",w+=c(C,!1,!1)),j&&(w+="#",w+=n?j:h(j,!1,!1)),w}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(re[154],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$_p=e.$$p=e.$0p=void 0;function R(u){const p=u;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.$0p=R;function s(u){const p=[];let v;try{const b=JSON.parse(u.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),v=l.__$stack),p.push(...b)}catch{p.push("Unable to log remote console arguments",u.arguments)}return{args:p,stack:v}}e.$$p=s;function M(u){if(typeof u!="string")return M(s(u).stack);const p=u;if(p){const v=D(p),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:P.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$_p=M;function D(u){if(!u)return u;const p=u.indexOf(`
`);return p===-1?u:u.substring(0,p)}function S(u,p){const{args:v,stack:b}=s(u),l=typeof v[0]=="string"&&v.length===1;let y=D(b);y&&(y=`(${y.trim()})`);let m=[];if(typeof v[0]=="string"?y&&l?m=[`%c[${p}] %c${v[0]} %c${y}`,d("blue"),d(""),d("grey")]:m=[`%c[${p}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:m=[`%c[${p}]%`,d("blue"),...v],y&&!l&&m.push(y),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,m)}e.log=S;function d(u){return`color: ${u}`}}),define(re[77],oe([0,1,18,7]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function s(d){return JSON.stringify(d,D)}e.$vh=s;function M(d){let u=JSON.parse(d);return u=S(u),u}e.$wh=M;function D(d,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function S(d,u=0){if(!d||u>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return R.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof P.$ge||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let p=0;p<d.length;++p)d[p]=S(d[p],u+1);else for(const p in d)Object.hasOwnProperty.call(d,p)&&(d[p]=S(d[p],u+1))}return d}e.$xh=S}),define(re[13],oe([0,1,14,4,25,7]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(b,l){return M.URI.isUri(b)?(0,s.$7e)(b.scheme,l):(0,s.$8e)(b,l+":")}e.$_f=S;function d(b,...l){return l.some(y=>S(b,y))}e.$ag=d,e.$bg="vscode-tkn",e.$cg="tkn";class u{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${D.vscodeRemoteResource}`}set(l,y,m){this.a[l]=y,this.b[l]=m}setConnectionToken(l,y){this.c[l]=y}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(a){return P.$1(a),l}const y=l.authority;let m=this.a[y];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const $=this.b[y],g=this.c[y];let h=`path=${encodeURIComponent(l.path)}`;return typeof g=="string"&&(h+=`&${e.$cg}=${encodeURIComponent(g)}`),M.URI.from({scheme:R.$o?this.d:D.vscodeRemoteResource,authority:`${m}:${$}`,path:this.f,query:h})}}e.$dg=new u,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class p{static{this.a=e.$ig}asBrowserUri(l){const y=this.b(l,J);return this.uriToBrowserUri(y)}uriToBrowserUri(l){return l.scheme===D.vscodeRemote?e.$dg.rewrite(l):l.scheme===D.file&&(R.$m||R.$q===`${D.vscodeFileResource}://${p.a}`)?l.with({scheme:D.vscodeFileResource,authority:l.authority||p.a,query:null,fragment:null}):l}asFileUri(l){const y=this.b(l,J);return this.uriToFileUri(y)}uriToFileUri(l){return l.scheme===D.vscodeFileResource?l.with({scheme:D.file,authority:l.authority!==p.a?l.authority:null,query:null,fragment:null}):l}b(l,y){return M.URI.isUri(l)?l:M.URI.parse(y.toUrl(l))}}e.$jg=new p;var v;(function(b){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(l.get("3"));const y="vscode-coi";function m(g){let h;typeof g=="string"?h=new URL(g).searchParams:g instanceof URL?h=g.searchParams:M.URI.isUri(g)&&(h=new URL(g.toString(!0)).searchParams);const a=h?.get(y);if(a)return l.get(a)}b.getHeadersFromQuery=m;function $(g,h,a){if(!globalThis.crossOriginIsolated)return;const E=h&&a?"3":a?"2":"1";g instanceof URLSearchParams?g.set(y,E):g[y]=E}b.addSearchParam=$})(v||(e.COI=v={}))}),define(re[19],oe([0,1,33,13,9,4,25,7]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function d(l){return(0,S.$wc)(l,!0)}e.$qg=d;class u{constructor(y){this.a=y}compare(y,m,$=!1){return y===m?0:(0,D.$Ze)(this.getComparisonKey(y,$),this.getComparisonKey(m,$))}isEqual(y,m,$=!1){return y===m?!0:!y||!m?!1:this.getComparisonKey(y,$)===this.getComparisonKey(m,$)}getComparisonKey(y,m=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,m,$=!1){if(y.scheme===m.scheme){if(y.scheme===R.Schemas.file)return P.$3f(d(y),d(m),this.a(y))&&y.query===m.query&&($||y.fragment===m.fragment);if((0,e.$Hg)(y.authority,m.authority))return P.$3f(y.path,m.path,this.a(y),"/")&&y.query===m.query&&($||y.fragment===m.fragment)}return!1}joinPath(y,...m){return S.URI.joinPath(y,...m)}basenameOrAuthority(y){return(0,e.$zg)(y)||y.authority}basename(y){return s.$gc.basename(y.path)}extname(y){return s.$gc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let m;return y.scheme===R.Schemas.file?m=S.URI.file(s.$mc(d(y))).path:(m=s.$gc.dirname(y.path),y.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),m="/")),y.with({path:m})}normalizePath(y){if(!y.path.length)return y;let m;return y.scheme===R.Schemas.file?m=S.URI.file(s.$hc(d(y))).path:m=s.$gc.normalize(y.path),y.with({path:m})}relativePath(y,m){if(y.scheme!==m.scheme||!(0,e.$Hg)(y.authority,m.authority))return;if(y.scheme===R.Schemas.file){const h=s.$lc(d(y),d(m));return M.$i?P.$Wf(h):h}let $=y.path||"/";const g=m.path||"/";if(this.a(y)){let h=0;for(const a=Math.min($.length,g.length);h<a&&!($.charCodeAt(h)!==g.charCodeAt(h)&&$.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);$=g.substr(0,h)+$.substr(h)}return s.$gc.relative($,g)}resolvePath(y,m){if(y.scheme===R.Schemas.file){const $=S.URI.file(s.$kc(d(y),m));return y.with({authority:$.authority,path:$.path})}return m=P.$Xf(m),y.with({path:s.$gc.resolve(y.path,m)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,m){return y===m||y!==void 0&&m!==void 0&&(0,D.$7e)(y,m)}hasTrailingPathSeparator(y,m=s.sep){if(y.scheme===R.Schemas.file){const $=d(y);return $.length>P.$Yf($).length&&$[$.length-1]===m}else{const $=y.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,m=s.sep){return(0,e.$Ig)(y,m)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,m=s.sep){let $=!1;if(y.scheme===R.Schemas.file){const g=d(y);$=g!==void 0&&g.length===P.$Yf(g).length&&g[g.length-1]===m}else{m="/";const g=y.path;$=g.length===1&&g.charCodeAt(g.length-1)===47}return!$&&!(0,e.$Ig)(y,m)?y.with({path:y.path+"/"}):y}}e.$rg=u,e.$sg=new u(()=>!1),e.$tg=new u(l=>l.scheme===R.Schemas.file?!M.$k:!0),e.$ug=new u(l=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function p(l,y){const m=[];for(let $=0;$<l.length;$++){const g=y(l[$]);l.some((h,a)=>a===$?!1:(0,e.$wg)(g,y(h)))||m.push(l[$])}return m}e.$Lg=p;var v;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function y(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[E,f]=a.split(":");E&&f&&$.set(E,f)});const h=m.path.substring(0,m.path.indexOf(";"));return h&&$.set(l.META_DATA_MIME,h),$}l.parseMetaData=y})(v||(e.DataUri=v={}));function b(l,y,m){if(y){let $=l.path;return $&&$[0]!==s.$gc.sep&&($=s.$gc.sep+$),l.with({scheme:m,authority:y,path:$})}return l.with({scheme:m})}e.$Mg=b}),define(re[8],oe([0,1,22,14,3,2,19,4,143,62]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function p(W){return!!W&&typeof W.then=="function"}e.$Ng=p;function v(W){const B=new P.$3d,_=W(B.token),ae=new Promise((ne,$e)=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),B.dispose(),$e(new R.$5)});Promise.resolve(_).then(ye=>{me.dispose(),B.dispose(),ne(ye)},ye=>{me.dispose(),B.dispose(),$e(ye)})});return new class{cancel(){B.cancel()}then(ne,$e){return ae.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return ae.finally(ne)}}}e.$Og=v;function b(W,B,_){return new Promise((ae,ne)=>{const $e=B.onCancellationRequested(()=>{$e.dispose(),ae(_)});W.then(ae,ne).finally(()=>$e.dispose())})}e.$Pg=b;function l(W,B){return new Promise((_,ae)=>{const ne=B.onCancellationRequested(()=>{ne.dispose(),ae(new R.$5)});W.then(_,ae).finally(()=>ne.dispose())})}e.$Qg=l;async function y(W){let B=-1;const _=W.map((ae,ne)=>ae.then($e=>(B=ne,$e)));try{return await Promise.race(_)}finally{W.forEach((ae,ne)=>{ne!==B&&ae.cancel()})}}e.$Rg=y;function m(W,B,_){let ae;const ne=setTimeout(()=>{ae?.(void 0),_?.()},B);return Promise.race([W.finally(()=>clearTimeout(ne)),new Promise($e=>ae=$e)])}e.$Sg=m;function $(W){return new Promise((B,_)=>{const ae=W();p(ae)?ae.then(B,_):B(ae)})}e.$Tg=$;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const _=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(_,_).then(ae)})}return new Promise((_,ae)=>{this.b.then(_,ae)})}return this.a=B(),new Promise((_,ae)=>{this.a.then(ne=>{this.a=null,_(ne)},ne=>{this.a=null,ae(ne)})})}dispose(){this.f=!0}}e.$Ug=g;class h{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Vg=h;class a{constructor(){this.a=new Map}queue(B,_){const ne=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(B)===ne&&this.a.delete(B)});return this.a.set(B,ne),ne}}e.$Wg=a;const E=(W,B)=>{let _=!0;const ae=setTimeout(()=>{_=!1,B()},W);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ae),_=!1}}},f=W=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,W())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class i{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,_=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=_===d.$Pd?f(ae):E(_,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=i;class o{constructor(B){this.a=new i(B),this.b=new g}trigger(B,_){return this.a.trigger(()=>this.b.queue(B),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=o;class r{constructor(){this.a=!1,this.b=new Promise((B,_)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=r;class t extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$1g=t;function n(W,B){return B?new Promise((_,ae)=>{const ne=setTimeout(()=>{$e.dispose(),_()},W),$e=B.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),ae(new R.$5)})}):v(_=>n(W,_))}e.$2g=n;function c(W,B=0,_){const ae=setTimeout(()=>{W(),_&&ne.dispose()},B),ne=(0,M.$Qc)(()=>{clearTimeout(ae),_?.deleteAndLeak(ne)});return _?.add(ne),ne}e.$3g=c;function w(W){const B=[];let _=0;const ae=W.length;function ne(){return _<ae?W[_++]():null}function $e(me){me!=null&&B.push(me);const ye=ne();return ye?ye.then($e):Promise.resolve(B)}return Promise.resolve(null).then($e)}e.$4g=w;function A(W,B=ae=>!!ae,_=null){let ae=0;const ne=W.length,$e=()=>{if(ae>=ne)return Promise.resolve(_);const me=W[ae++];return Promise.resolve(me()).then(Se=>B(Se)?Promise.resolve(Se):$e())};return $e()}e.$5g=A;function I(W,B=ae=>!!ae,_=null){if(W.length===0)return Promise.resolve(_);let ae=W.length;const ne=()=>{ae=-1;for(const $e of W)$e.cancel?.()};return new Promise(($e,me)=>{for(const ye of W)ye.then(Se=>{--ae>=0&&B(Se)?(ne(),$e(Se)):ae===0&&$e(_)}).catch(Se=>{--ae>=0&&(ne(),me(Se))})})}e.$6g=I;class k{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new s.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((_,ae)=>{this.f.push({factory:B,c:_,e:ae}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const _=B.factory();_.then(B.c,B.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=k;class C extends k{constructor(){super(1)}}e.$8g=C;class j{constructor(){this.a=new L,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$9g=j;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new q;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,_=D.$sg){const ae=_.getComparisonKey(B);let ne=this.a.get(ae);if(!ne){ne=new C;const $e=this.f++,me=s.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$2c),this.d.set($e,me),this.a.set(ae,ne)}return ne}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=F;class N{constructor(B,_){this.a=-1,typeof B=="function"&&typeof _=="number"&&this.setIfNotSet(B,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},_)}setIfNotSet(B,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},_))}}e.$$g=N;class Y{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,_,ae=globalThis){this.cancel();const ne=ae.setInterval(()=>{B()},_);this.d=(0,M.$Qc)(()=>{ae.clearInterval(ne),this.d=void 0})}dispose(){this.cancel()}}e.$_g=Y;class Q{constructor(B,_){this.b=-1,this.a=B,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=Q;class le{constructor(B,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=B,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=le;class ce extends Q{constructor(B,_){super(B,_),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$ch=ce;class ue extends M.$Sc{constructor(B,_){super(),this.g=B,this.h=_,this.a=[],this.b=this.B(new M.$Tc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of B)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(W,B)=>{(0,S.$B)(()=>{if(_)return;const ae=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$fh=(W,B,_)=>{const ae=W.requestIdleCallback(B,typeof _=="number"?{timeout:_}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,W.cancelIdleCallback(ae))}}},e.$eh=W=>(0,e.$fh)(globalThis,W)}();class K{constructor(B,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$fh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=K;class X extends K{constructor(B){super(globalThis,B)}}e.$hh=X;async function H(W,B,_){let ae;for(let ne=0;ne<_;ne++)try{return await W()}catch($e){ae=$e,await n(B)}throw ae}e.$ih=H;class L{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,_,ae){return this.a={taskId:B,cancel:()=>ae?.(),promise:_},_.then(()=>this.d(B),()=>this.d(B)),_}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let _,ae;const ne=new Promise(($e,me)=>{_=$e,ae=me});this.b={run:B,promise:ne,promiseResolve:_,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=L;class T{constructor(B,_=()=>Date.now()){this.d=B,this.f=_,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$kh=T;var V;(function(W){W[W.Resolved=0]="Resolved",W[W.Rejected=1]="Rejected"})(V||(V={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,_)=>{this.a=B,this.b=_})}complete(B){return new Promise(_=>{this.a(B),this.d={outcome:0,value:B},_()})}error(B){return new Promise(_=>{this.b(B),this.d={outcome:1,value:B},_()})}cancel(){return this.error(new R.$5)}}e.$lh=q;var te;(function(W){async function B(ae){let ne;const $e=await Promise.all(ae.map(me=>me.then(ye=>ye,ye=>{ne||(ne=ye)})));if(typeof ne<"u")throw ne;return $e}W.settled=B;function _(ae){return new Promise(async(ne,$e)=>{try{await ae(ne,$e)}catch(me){$e(me)}})}W.withAsyncBody=_})(te||(e.Promises=te={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=he;class G{constructor(B){this.b=B,this.a=new u.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=G;var O;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(O||(O={}));class U{static fromArray(B){return new U(_=>{_.emitMany(B)})}static fromPromise(B){return new U(async _=>{_.emitMany(await B)})}static fromPromises(B){return new U(async _=>{await Promise.all(B.map(async ae=>_.emitOne(await ae)))})}static merge(B){return new U(async _=>{await Promise.all(B.map(async ae=>{for await(const ne of ae)_.emitOne(ne)}))})}static{this.EMPTY=U.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new s.$Sd,queueMicrotask(async()=>{const _={emitOne:ae=>this.g(ae),emitMany:ae=>this.h(ae),reject:ae=>this.k(ae)};try{await Promise.resolve(B(_)),this.j()}catch(ae){this.k(ae)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(B,_){return new U(async ae=>{for await(const ne of B)ae.emitOne(_(ne))})}map(B){return U.map(this,B)}static filter(B,_){return new U(async ae=>{for await(const ne of B)_(ne)&&ae.emitOne(ne)})}filter(B){return U.filter(this,B)}static coalesce(B){return U.filter(B,_=>!!_)}coalesce(){return U.coalesce(this)}static async toPromise(B){const _=[];for await(const ae of B)_.push(ae);return _}toPromise(){return U.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$oh=U;class x extends U{constructor(B,_){super(_),this.l=B}cancel(){this.l.cancel()}}e.$ph=x;function z(W){const B=new P.$3d,_=W(B.token);return new x(B,async ae=>{const ne=B.token.onCancellationRequested(()=>{ne.dispose(),B.dispose(),ae.reject(new R.$5)});try{for await(const $e of _){if(B.token.isCancellationRequested)return;ae.emitOne($e)}ne.dispose(),B.dispose()}catch($e){ne.dispose(),B.dispose(),ae.reject($e)}})}e.$qh=z;class Z{constructor(){this.a=new q,this.b=new U(ae=>{if(B){ae.reject(B);return}return _&&ae.emitMany(_),this.d=ne=>ae.reject(ne),this.f=ne=>ae.emitOne(ne),this.a.p});let B,_;this.f=ae=>{_||(_=[]),_.push(ae)},this.d=ae=>{B||(B=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$rh=Z}),define(re[104],oe([0,1,23,8,33,31,9,4,25]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;function u(){return Object.create(null)}e.$Cj=u,e.$Dj="**",e.$Ej="/";const p="[/\\\\]",v="[^/\\\\]",b=/\//g;function l(X,H){switch(X){case 0:return"";case 1:return`${v}*?`;default:return`(?:${p}|${v}+${p}${H?`|${p}${v}+`:""})*?`}}function y(X,H){if(!X)return[];const L=[];let T=!1,V=!1,q="";for(const te of X){switch(te){case H:if(!T&&!V){L.push(q),q="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=te}return q&&L.push(q),L}e.$Fj=y;function m(X){if(!X)return"";let H="";const L=y(X,e.$Ej);if(L.every(T=>T===e.$Dj))H=".*";else{let T=!1;L.forEach((V,q)=>{if(V===e.$Dj){if(T)return;H+=l(2,q===L.length-1)}else{let te=!1,he="",G=!1,O="";for(const U of V){if(U!=="}"&&te){he+=U;continue}if(G&&(U!=="]"||!O)){let x;U==="-"?x=U:(U==="^"||U==="!")&&!O?x="^":U===e.$Ej?x="":x=(0,d.$Ke)(U),O+=x;continue}switch(U){case"{":te=!0;continue;case"[":G=!0;continue;case"}":{const z=`(?:${y(he,",").map(Z=>m(Z)).join("|")})`;H+=z,te=!1,he="";break}case"]":{H+="["+O+"]",G=!1,O="";break}case"?":H+=v;continue;case"*":H+=l(1);continue;default:H+=(0,d.$Ke)(U)}}q<L.length-1&&(L[q+1]!==e.$Dj||q+2<L.length)&&(H+=p)}T=V===e.$Dj})}return H}const $=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function t(X,H){if(!X)return r;let L;typeof X!="string"?L=X.pattern:L=X,L=L.trim();const T=`${L}_${!!H.trimForExclusions}`;let V=i.get(T);if(V)return n(V,X);let q;return $.test(L)?V=w(L.substr(4),L):(q=g.exec(c(L,H)))?V=A(q[1],L):(H.trimForExclusions?a:h).test(L)?V=I(L,H):(q=E.exec(c(L,H)))?V=k(q[1].substr(1),L,!0):(q=f.exec(c(L,H)))?V=k(q[1],L,!1):V=C(L),i.set(T,V),n(V,X)}function n(X,H){if(typeof H=="string")return X;const L=function(T,V){return(0,s.$3f)(T,H.base,!S.$k)?X((0,d.$Oe)(T.substr(H.base.length),D.sep),V):null};return L.allBasenames=X.allBasenames,L.allPaths=X.allPaths,L.basenames=X.basenames,L.patterns=X.patterns,L}function c(X,H){return H.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function w(X,H){return function(L,T){return typeof L=="string"&&L.endsWith(X)?H:null}}function A(X,H){const L=`/${X}`,T=`\\${X}`,V=function(te,he){return typeof te!="string"?null:he?he===X?H:null:te===X||te.endsWith(L)||te.endsWith(T)?H:null},q=[X];return V.basenames=q,V.patterns=[H],V.allBasenames=q,V}function I(X,H){const L=ue(X.slice(1,-1).split(",").map(he=>t(he,H)).filter(he=>he!==r),X),T=L.length;if(!T)return r;if(T===1)return L[0];const V=function(he,G){for(let O=0,U=L.length;O<U;O++)if(L[O](he,G))return X;return null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,G)=>G.allPaths?he.concat(G.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function k(X,H,L){const T=D.sep===D.$gc.sep,V=T?X:X.replace(b,D.sep),q=D.sep+V,te=D.$gc.sep+X;let he;return L?he=function(G,O){return typeof G=="string"&&(G===V||G.endsWith(q)||!T&&(G===X||G.endsWith(te)))?H:null}:he=function(G,O){return typeof G=="string"&&(G===V||!T&&G===X)?H:null},he.allPaths=[(L?"*/":"./")+X],he}function C(X){try{const H=new RegExp(`^${m(X)}$`);return function(L){return H.lastIndex=0,typeof L=="string"&&H.test(L)?X:null}}catch{return r}}function j(X,H,L){return!X||typeof H!="string"?!1:F(X)(H,void 0,L)}e.$Gj=j;function F(X,H={}){if(!X)return o;if(typeof X=="string"||N(X)){const L=t(X,H);if(L===r)return o;const T=function(V,q){return!!L(V,q)};return L.allBasenames&&(T.allBasenames=L.allBasenames),L.allPaths&&(T.allPaths=L.allPaths),T}return le(X,H)}e.$Hj=F;function N(X){const H=X;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Ij=N;function Y(X){return X.allBasenames||[]}e.$Jj=Y;function Q(X){return X.allPaths||[]}e.$Kj=Q;function le(X,H){const L=ue(Object.getOwnPropertyNames(X).map(he=>ce(he,X[he],H)).filter(he=>he!==r)),T=L.length;if(!T)return r;if(!L.some(he=>!!he.requiresSiblings)){if(T===1)return L[0];const he=function(U,x){let z;for(let Z=0,W=L.length;Z<W;Z++){const B=L[Z](U,x);if(typeof B=="string")return B;(0,R.$Ng)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const Z of z){const W=await Z;if(typeof W=="string")return W}return null})():null},G=L.find(U=>!!U.allBasenames);G&&(he.allBasenames=G.allBasenames);const O=L.reduce((U,x)=>x.allPaths?U.concat(x.allPaths):U,[]);return O.length&&(he.allPaths=O),he}const V=function(he,G,O){let U,x;for(let z=0,Z=L.length;z<Z;z++){const W=L[z];W.requiresSiblings&&O&&(G||(G=(0,D.$nc)(he)),U||(U=G.substr(0,G.length-(0,D.$oc)(he).length)));const B=W(he,G,U,O);if(typeof B=="string")return B;(0,R.$Ng)(B)&&(x||(x=[]),x.push(B))}return x?(async()=>{for(const z of x){const Z=await z;if(typeof Z=="string")return Z}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,G)=>G.allPaths?he.concat(G.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function ce(X,H,L){if(H===!1)return r;const T=t(X,L);if(T===r)return r;if(typeof H=="boolean")return T;if(H){const V=H.when;if(typeof V=="string"){const q=(te,he,G,O)=>{if(!O||!T(te,he))return null;const U=V.replace("$(basename)",()=>G),x=O(U);return(0,R.$Ng)(x)?x.then(z=>z?X:null):x?X:null};return q.requiresSiblings=!0,q}}return T}function ue(X,H){const L=X.filter(he=>!!he.basenames);if(L.length<2)return X;const T=L.reduce((he,G)=>{const O=G.basenames;return O?he.concat(O):he},[]);let V;if(H){V=[];for(let he=0,G=T.length;he<G;he++)V.push(H)}else V=L.reduce((he,G)=>{const O=G.patterns;return O?he.concat(O):he},[]);const q=function(he,G){if(typeof he!="string")return null;if(!G){let U;for(U=he.length;U>0;U--){const x=he.charCodeAt(U-1);if(x===47||x===92)break}G=he.substr(U)}const O=T.indexOf(G);return O!==-1?V[O]:null};q.basenames=T,q.patterns=V,q.allBasenames=T;const te=X.filter(he=>!he.basenames);return te.push(q),te}function K(X,H){return(0,P.$ub)(X,H,(L,T)=>typeof L=="string"&&typeof T=="string"?L===T:typeof L!="string"&&typeof T!="string"?L.base===T.base&&L.pattern===T.pattern:!1)}e.$Lj=K}),define(re[47],oe([0,1,23,33,9,4,19,25]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=void 0;function d(t,n){const{os:c,tildify:w,relative:A}=n;if(A){const C=u(t,A,c);if(typeof C=="string")return C}let I=t.fsPath;if(c===1&&!M.$i?I=I.replace(/\//g,"\\"):c!==1&&M.$i&&(I=I.replace(/\\/g,"/")),c!==1&&w?.userHome){const C=w.userHome.fsPath;let j;t.scheme!==w.userHome.scheme&&t.path[0]===s.$gc.sep&&t.path[1]!==s.$gc.sep?j=w.userHome.with({path:t.path}).fsPath:j=I,I=b(j,C,c)}return(c===1?s.$fc:s.$gc).normalize(p(I,c===1))}e.$Fv=d;function u(t,n,c){const w=c===1?s.$fc:s.$gc,A=c===3?D.$sg:D.$ug,I=n.getWorkspace(),k=(0,P.$Ob)(I.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path[0]===s.$gc.sep&&t.path[1]!==s.$gc.sep&&(t=k.uri.with({path:t.path}));const C=n.getWorkspaceFolder(t);if(!C)return;let j;if(A.isEqual(C.uri,t)?j="":j=A.relativePath(C.uri,t)??"",j&&(j=w.normalize(j)),I.folders.length>1&&!n.noPrefix){const F=C.name?C.name:A.basenameOrAuthority(C.uri);j=j?`${F} \u2022 ${j}`:F}return j}function p(t,n=M.$i){return(0,R.$7f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$Gv=p;let v=Object.create(null);function b(t,n,c=M.OS){if(c===1||!t||!n)return t;let w=v.original===n?v.normalized:void 0;w||(w=n,M.$i&&(w=(0,R.$Wf)(w)),w=`${(0,S.$Pe)(w,s.$gc.sep)}${s.$gc.sep}`,v={original:n,normalized:w});let A=t;return M.$i&&(A=(0,R.$Wf)(A)),(c===3?A.startsWith(w):(0,S.$8e)(A,w))?`~/${A.substr(w.length)}`:t}e.$Hv=b;function l(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Iv=l;const y="\u2026",m="\\\\",$="~";function g(t,n=s.sep){const c=new Array(t.length);let w=!1;for(let A=0;A<t.length;A++){const I=t[A];if(I===""){c[A]=`.${n}`;continue}if(!I){c[A]=I;continue}w=!0;let k="",C=I;C.indexOf(m)===0?(k=C.substr(0,C.indexOf(m)+m.length),C=C.substr(C.indexOf(m)+m.length)):C.indexOf(n)===0?(k=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf($)===0&&(k=C.substr(0,C.indexOf($)+$.length),C=C.substr(C.indexOf($)+$.length));const j=C.split(n);for(let F=1;w&&F<=j.length;F++)for(let N=j.length-F;w&&N>=0;N--){w=!1;let Y=j.slice(N,N+F).join(n);for(let Q=0;!w&&Q<t.length;Q++)if(Q!==A&&t[Q]&&t[Q].indexOf(Y)>-1){const le=N+F===j.length,ce=N>0&&t[Q].indexOf(n)>-1?n+Y:Y,ue=t[Q].endsWith(ce);w=!le||ue}if(!w){let Q="";(j[0].endsWith(":")||k!=="")&&(N===1&&(N=0,F++,Y=j[0]+n+Y),N>0&&(Q=j[0]+n),Q=k+Q),N>0&&(Q=Q+y+n),Q=Q+Y,N+F<j.length&&(Q=Q+n+y),c[A]=Q}}w&&(c[A]=I)}return c}e.$Jv=g;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(t,n=Object.create(null)){const c=[];let w=!1,A="";for(const I of t)if(I==="$"||w&&I==="{")A&&c.push({value:A,type:h.TEXT}),A="",w=!0;else if(I==="}"&&w){const k=n[A];if(typeof k=="string")k.length&&c.push({value:k,type:h.VARIABLE});else if(k){const C=c[c.length-1];(!C||C.type!==h.SEPARATOR)&&c.push({value:k.label,type:h.SEPARATOR})}A="",w=!1}else A+=I;return A&&!w&&c.push({value:A,type:h.TEXT}),c.filter((I,k)=>{if(I.type===h.SEPARATOR){const C=c[k-1],j=c[k+1];return[C,j].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Kv=a;function E(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Lv=E;function f(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,""):M.$i?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Mv=f;function i(t){return t.replace(/&/g,"&&")}e.$Nv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const c=r(t.substring(0,n));return{name:c.name,parentPath:c.parentPath+t.substring(n)}}}return r(t)}e.$Ov=o;function r(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,c=n.basename(t),w=n.dirname(t);return c.length?{name:c,parentPath:w}:{name:w,parentPath:""}}}),define(re[155],oe([0,1,18,7]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function s(v){return v.toJSON()}class M{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:s(R.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:s(R.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:R.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Xm=M,e.$Ym=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,b,l){if(!v||l>200)return null;if(typeof v=="object"){if(v instanceof R.URI)return b.transformOutgoing(v);for(const y in v)if(Object.hasOwnProperty.call(v,y)){const m=D(v[y],b,l+1);m!==null&&(v[y]=m)}}return null}function S(v,b){const l=D(v,b,0);return l===null?v:l}e.$Zm=S;function d(v,b,l,y){if(!v||y>200)return null;if(typeof v=="object"){if(v.$mid===1)return l?R.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof P.$ge)return null;for(const m in v)if(Object.hasOwnProperty.call(v,m)){const $=d(v[m],b,l,y+1);$!==null&&(v[m]=$)}}return null}function u(v,b){const l=d(v,b,!1,0);return l===null?v:l}e.$1m=u;function p(v,b){const l=d(v,b,!0,0);return l===null?v:l}e.$2m=p}),define(re[88],oe([0,1,26,57,32,145,4]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=void 0,e.$4m=new class{c(b){return this.a||(this.a=R.$7h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const y=(0,P.networkInterfaces)();for(const m in y){const $=y[m];if($)for(const{mac:g,internal:h}of $)h||(l+=1,this.c(g.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let S;async function d(b){return S||(S=(async()=>await u(b)||s.$lg())()),S}e.$5m=d;async function u(b){try{const l=await new Promise((m,$)=>{J(["crypto"],m,$)}),y=(0,M.$3m)();return l.createHash("sha256").update(y,"utf8").digest("hex")}catch(l){b(l);return}}const p="Software\\Microsoft\\SQMClient";async function v(b){if(D.$i){const l=await new Promise((y,m)=>{J(["@vscode/windows-registry"],y,m)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",p,"MachineId")||""}catch(y){return b(y),""}}return""}e.$6m=v}),define(re[21],oe([0,1,46,26,156,8,33,85,9,4,19,7]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(ce){ce[ce.UNLINK=0]="UNLINK",ce[ce.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(ce,ue=b.UNLINK,K){if((0,D.$6f)(ce))throw new Error("rimraf - will refuse to recursively delete root");return ue===b.UNLINK?m(ce):y(ce,K)}async function y(ce,ue=(0,D.$$f)((0,R.tmpdir)())){try{try{await P.promises.rename(ce,ue)}catch(K){return K.code==="ENOENT"?void 0:m(ce)}m(ue).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function m(ce){return(0,s.promisify)(P.rm)(ce,{recursive:!0,force:!0,maxRetries:3})}function $(ce){if((0,D.$6f)(ce))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ce,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function g(ce,ue){return E(await(ue?h(ce):(0,s.promisify)(P.readdir)(ce)))}async function h(ce){try{return await(0,s.promisify)(P.readdir)(ce,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],K=await g(ce);for(const X of K){let H=!1,L=!1,T=!1;try{const V=await e.Promises.lstat((0,d.$jc)(ce,X));H=V.isFile(),L=V.isDirectory(),T=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:X,isFile:()=>H,isDirectory:()=>L,isSymbolicLink:()=>T})}return ue}function a(ce){return E(P.readdirSync(ce))}e.readdirSync=a;function E(ce){return ce.map(ue=>typeof ue=="string"?u.$j?(0,S.$Al)(ue):ue:(ue.name=u.$j?(0,S.$Al)(ue.name):ue.name,ue))}async function f(ce){const ue=await g(ce),K=[];for(const X of ue)await o.existsDirectory((0,d.$jc)(ce,X))&&K.push(X);return K}function i(ce,ue=1e3){return new Promise(K=>{let X=!1;const H=setInterval(()=>{X||(X=!0,P.access(ce,L=>{X=!1,L&&(clearInterval(H),K(void 0))}))},ue)})}e.whenDeleted=i;var o;(function(ce){async function ue(H){let L;try{if(L=await e.Promises.lstat(H),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(u.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw V}throw T}}ce.stat=ue;async function K(H){try{const{stat:L,symbolicLink:T}=await ce.stat(H);return L.isFile()&&T?.dangling!==!0}catch{}return!1}ce.existsFile=K;async function X(H){try{const{stat:L,symbolicLink:T}=await ce.stat(H);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}ce.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const r=new M.$0g;function t(ce,ue,K){return r.queueFor(v.URI.file(ce),p.$tg).queue(()=>{const X=I(K);return new Promise((H,L)=>w(ce,ue,X,T=>T?L(T):H()))})}let n=!0;function c(ce){n=ce}e.configureFlushOnWrite=c;function w(ce,ue,K,X){if(!n)return P.writeFile(ce,ue,{mode:K.mode,flag:K.flag},X);P.open(ce,K.flag,K.mode,(H,L)=>{if(H)return X(H);P.writeFile(L,ue,T=>{if(T)return P.close(L,()=>X(T));P.fdatasync(L,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),c(!1)),P.close(L,q=>X(q))))})})}function A(ce,ue,K){const X=I(K);if(!n)return P.writeFileSync(ce,ue,{mode:X.mode,flag:X.flag});const H=P.openSync(ce,X.flag,X.mode);try{P.writeFileSync(H,ue);try{P.fdatasyncSync(H)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),c(!1)}}finally{P.closeSync(H)}}e.writeFileSync=A;function I(ce){return ce?{mode:typeof ce.mode=="number"?ce.mode:438,flag:typeof ce.flag=="string"?ce.flag:"w"}:{mode:438,flag:"w"}}async function k(ce,ue,K=6e4){if(ce!==ue)try{u.$i&&typeof K=="number"?await C(ce,ue,Date.now(),K):await(0,s.promisify)(P.rename)(ce,ue)}catch(X){if(ce.toLowerCase()!==ue.toLowerCase()&&X.code==="EXDEV"||ce.endsWith("."))await j(ce,ue,{preserveSymlinks:!1}),await l(ce,b.MOVE);else throw X}}async function C(ce,ue,K,X,H=0){try{return await(0,s.promisify)(P.rename)(ce,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-K>=X)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${L}`),L;if(H===0){let T=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(T=!0)}catch{}if(T)throw L}return await(0,M.$2g)(Math.min(100,H*10)),C(ce,ue,K,X,H+1)}}async function j(ce,ue,K){return N(ce,ue,{root:{source:ce,target:ue},options:K,handledSourcePaths:new Set})}const F=511;async function N(ce,ue,K){if(K.handledSourcePaths.has(ce))return;K.handledSourcePaths.add(ce);const{stat:X,symbolicLink:H}=await o.stat(ce);if(H){if(K.options.preserveSymlinks)try{return await le(ce,ue,K)}catch{}if(H.dangling)return}return X.isDirectory()?Y(ce,ue,X.mode&F,K):Q(ce,ue,X.mode&F)}async function Y(ce,ue,K,X){await e.Promises.mkdir(ue,{recursive:!0,mode:K});const H=await g(ce);for(const L of H)await N((0,d.$jc)(ce,L),(0,d.$jc)(ue,L),X)}async function Q(ce,ue,K){await e.Promises.copyFile(ce,ue),await e.Promises.chmod(ue,K)}async function le(ce,ue,K){let X=await e.Promises.readlink(ce);(0,D.$3f)(X,K.root.source,!u.$k)&&(X=(0,d.$jc)(K.root.target,X.substr(K.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ce,ue,K,X,H)=>new Promise((L,T)=>{P.read(ce,ue,K,X,H,(V,q,te)=>V?T(V):L({bytesRead:q,buffer:te}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ce,ue,K,X,H)=>new Promise((L,T)=>{P.write(ce,ue,K,X,H,(V,q,te)=>V?T(V):L({bytesWritten:q,buffer:te}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ce){try{return await e.Promises.access(ce),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return f}get writeFile(){return t}get rm(){return l}get rename(){return k}get copy(){return j}}}),define(re[105],oe([0,1,46,9,4,25,21]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.$eq=void 0;function S(b){if(s.$k)return b;const l=(0,R.$mc)(b);if(b===l)return b;const y=((0,R.$nc)(b)||b).toLowerCase();try{const $=(0,D.readdirSync)(l).filter(g=>g.toLowerCase()===y);if($.length===1){const g=S(l);if(g)return(0,R.$jc)(g,$[0])}else if($.length>1){const g=$.indexOf(y);if(g>=0){const h=S(l);if(h)return(0,R.$jc)(h,$[g])}}}catch{}return null}e.$eq=S;async function d(b){if(s.$k)return b;const l=(0,R.$mc)(b);if(b===l)return b;const y=((0,R.$nc)(b)||b).toLowerCase();try{const $=(await D.Promises.readdir(l)).filter(g=>g.toLowerCase()===y);if($.length===1){const g=await d(l);if(g)return(0,R.$jc)(g,$[0])}else if($.length>1){const g=$.indexOf(y);if(g>=0){const h=await d(l);if(h)return(0,R.$jc)(h,$[g])}}}catch{}return null}e.$fq=d;async function u(b){try{return await D.Promises.realpath(b)}catch{const y=v(b);return await D.Promises.access(y,P.constants.R_OK),y}}e.$gq=u;function p(b){try{return P.realpathSync(b)}catch{const y=v(b);return P.accessSync(y,P.constants.R_OK),y}}e.$hq=p;function v(b){return(0,M.$Pe)((0,R.$hc)(b),R.sep)}}),define(re[106],oe([0,1,26,9,21]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var d;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(d||(d={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class v{constructor(f,i,o){this.exePath=f,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:E=!1}={}){return E?u===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:E=!1,findPreview:f=!1}={}){const i=b({useAlternateBitness:E});if(!i)return null;const o=R.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const w of await s.Promises.readdir(o)){let A=-1;if(f){const k=w.indexOf("-");if(k<0)continue;const C=w.substring(0,k);if(!M.test(C)||w.substring(k+1)!=="preview")continue;A=parseInt(C,10)}else{if(!M.test(w))continue;A=parseInt(w,10)}if(A<=r)continue;const I=R.$jc(o,w,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(t=I,r=A)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",c=f?" Preview":"";return new v(t,`PowerShell${c}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const f=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(f))if(i.test(r)){const t=R.$jc(f,r,"pwsh.exe");return new v(t,o)}return null}function m(){const E=R.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function $(){const E=R.$jc(process.env.windir,u===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*g(){let E=await l();E&&(yield E),E=await l({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=m(),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await l({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=$(),E&&(yield E)}async function*h(){for await(const E of g())await E.exists()&&(yield E)}e.$Jl=h;async function a(){for await(const E of h())return E;return null}e.$Kl=a}),define(re[89],oe([0,1,9,4,35,76,12,21]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(v=s.env){return v.comspec||"cmd.exe"}e.$Nl=d;function u(v){let b=[],l=!1;const y=function(m){if(l){b.push(m);return}(!v.send(m,g=>{if(g&&console.error(g),l=!1,b.length>0){const h=b.slice(0);b=[],h.forEach(a=>y(a))}})||R.$i)&&(l=!0)};return{send:y}}e.$Ol=u;var p;(function(v){async function b(l,y,m){if(P.$ic(l))return l;if(y===void 0&&(y=s.cwd()),P.$mc(l)!=="."||(m===void 0&&D.$Df(s.env.PATH)&&(m=s.env.PATH.split(P.$tc)),m===void 0||m.length===0))return P.$jc(y,l);async function g(h){if(await S.Promises.exists(h)){let a;try{a=await S.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(a=await S.Promises.lstat(h))}return a?!a.isDirectory():!1}return!1}for(const h of m){let a;if(P.$ic(h)?a=P.$jc(h,l):a=P.$jc(y,h,l),await g(a))return a;let E=a+".com";if(await g(E)||(E=a+".exe",await g(E)))return E}return P.$jc(y,l)}v.findExecutable=b})(p||(e.win32=p={}))}),define(re[107],oe([0,1,48,13]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;function s(D){return new Promise((S,d)=>{let u;const p=new Map;function v(l,y,m,$,g){const h=p.get(y);if(l===D||h){const a={name:b(m),cmd:m,pid:l,ppid:y,load:$,mem:g};p.set(l,a),l===D&&(u=a),h&&(h.children||(h.children=[]),h.children.push(a),h.children.length>1&&(h.children=h.children.sort((E,f)=>E.pid-f.pid)))}}function b(l){const y=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,a=/--type=([a-zA-Z-]+)/;if($.exec(l))return"electron-crash-reporter";if(g.exec(l))return"winpty-agent";if(h.exec(l))return"conpty-agent";let E=a.exec(l);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(l)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const f=/[a-zA-Z-]+\.js/g;let i="";do E=f.exec(l),E&&(i+=E+" ");while(E);return i&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,m)=>{J(["@vscode/windows-process-tree"],y,m)}).then(y=>{y.getProcessList(D,m=>{if(!m){d(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(m,$=>{const g=new Map;$.forEach(h=>{const a=l(h.commandLine||"");g.set(h.pid,{name:b(a),cmd:a,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),u=g.get(D),u?(g.forEach(h=>{const a=g.get(h.ppid);a&&(a.children||(a.children=[]),a.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((a,E)=>a.pid-E.pid))}),S(u)):d(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let l=function(){let y=[u];const m=[];for(;y.length;){const g=y.shift();g&&(m.push(g.pid),g.children&&(y=y.concat(g.children)))}let $=JSON.stringify(R.$jg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+m.join(" "),(0,P.exec)($,{},(g,h,a)=>{if(g||a)d(g||new Error(a.toString()));else{const E=h.toString().split(`
`);for(let f=0;f<m.length;f++){const i=p.get(m[f]);i.load=parseFloat(E[f])}if(!u){d(new Error(`Root process ${D} not found`));return}S(u)}})};(0,P.exec)("which ps",{},(y,m,$)=>{if(y||$)if(process.platform!=="linux")d(y||new Error($.toString()));else{const g=JSON.stringify(R.$jg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(h,a,E)=>{h||E?d(h||new Error(E.toString())):(M(a,v),l())})}else{const g=m.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,E,f)=>{a||f&&!f.includes("screen size is bogus")?d(a||new Error(f.toString())):(M(E,v),process.platform==="linux"?l():u?S(u):d(new Error(`Root process ${D} not found`)))})}})}})}e.$Or=s;function M(D,S){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=D.toString().split(`
`);for(const p of u){const v=d.exec(p.trim());v&&v.length===6&&S(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(re[108],oe([0,1,26,4,106,89]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0;async function D(v,b){return v===1?R.$i?p():M.$Nl(b):d(v,b)}e.$Pl=D;let S=null;function d(v,b){if(R.$k&&v===2||R.$j&&v===3)return"/bin/bash";if(!S){let l;if(R.$i)l="/bin/bash";else{if(l=b.SHELL,!l)try{l=(0,P.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}S=l}return S}let u=null;async function p(){return u||(u=(await(0,s.$Kl)()).exePath),u}});var Ee=this&&this.__decorate||function(J,e,P,R){var s=arguments.length,M=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,P):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,P,R);else for(var S=J.length-1;S>=0;S--)(D=J[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(re[42],oe([0,1,23,8,18,22,56,14,3,2,77,25,12]),function(J,e,P,R,s,M,D,S,d,u,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.ProxyChannel=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.RequestInitiator=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0;var l;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(l||(l={}));function y(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m||(m={}));function $(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(g||(g={}));function h(H){let L=0;for(let T=0;;T+=7){const V=H.read(1);if(L|=(V.buffer[0]&127)<<T,!(V.buffer[0]&128))return L}}const a=r(0);function E(H,L){if(L===0){H.write(a);return}let T=0;for(let q=L;q!==0;q=q>>>7)T++;const V=s.$ge.alloc(T);for(let q=0;L!==0;q++)V.buffer[q]=L&127,L=L>>>7,L>0&&(V.buffer[q]|=128);H.write(V)}class f{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}e.$yh=f;class i{constructor(){this.a=[]}get buffer(){return s.$ge.concat(this.a)}write(L){this.a.push(L)}}e.$zh=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function r(H){const L=s.$ge.alloc(1);return L.writeUInt8(H,0),L}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function c(H,L){if(typeof L>"u")H.write(t.Undefined);else if(typeof L=="string"){const T=s.$ge.fromString(L);H.write(t.String),E(H,T.byteLength),H.write(T)}else if(n&&Buffer.isBuffer(L)){const T=s.$ge.wrap(L);H.write(t.Buffer),E(H,T.byteLength),H.write(T)}else if(L instanceof s.$ge)H.write(t.VSBuffer),E(H,L.byteLength),H.write(L);else if(Array.isArray(L)){H.write(t.Array),E(H,L.length);for(const T of L)c(H,T)}else if(typeof L=="number"&&(L|0)===L)H.write(t.Uint),E(H,L);else{const T=s.$ge.fromString(JSON.stringify(L));H.write(t.Object),E(H,T.byteLength),H.write(T)}}e.$Ah=c;function w(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(h(H)).toString();case o.Buffer:return H.read(h(H)).buffer;case o.VSBuffer:return H.read(h(H));case o.Array:{const T=h(H),V=[];for(let q=0;q<T;q++)V.push(w(H));return V}case o.Object:return JSON.parse(H.read(h(H)).toString());case o.Int:return h(H)}}e.$Bh=w;class A{constructor(L,T,V=null,q=1e3){this.h=L,this.j=T,this.k=V,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const T=this.o([L.type]);this.k?.logOutgoing(T,0,1,$(L.type));return}case 201:case 202:case 204:case 203:{const T=this.o([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,$(L.type),L.data);return}}}o(L,T=void 0){const V=new i;return c(V,L),c(V,T),this.p(V.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const T=new f(L),V=w(T),q=w(T),te=V[0];switch(te){case 100:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}: ${V[2]}.${V[3]}`,q),this.s({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}: ${V[2]}.${V[3]}`,q),this.t({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}`),this.u({type:te,id:V[1]});case 103:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}`),this.u({type:te,id:V[1]})}}s(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const V=new M.$3d;let q;try{q=T.call(this.j,L.name,L.arg,V.token)}catch(G){q=Promise.reject(G)}const te=L.id;q.then(G=>{this.m({id:te,data:G,type:201})},G=>{G instanceof Error?this.m({id:te,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:te,data:G,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,u.$Qc)(()=>V.cancel());this.d.set(L.id,he)}t(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const V=L.id,te=T.listen(this.j,L.name,L.arg)(he=>this.m({id:V,data:he,type:204}));this.d.set(L.id,te)}u(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}v(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:V})}w(L){const T=this.g.get(L);if(T){for(const V of T)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Nc)(this.d.values()),this.d.clear()}}e.$Ch=A;var I;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class k{constructor(L,T=null){this.l=L,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=T}getChannel(L){const T=this;return{call(V,q,te){return T.a?Promise.reject(new S.$5):T.m(L,V,q,te)},listen(V,q){return T.a?d.Event.None:T.o(L,V,q)}}}m(L,T,V,q=M.CancellationToken.None){const te=this.g++,G={id:te,type:100,channelName:L,name:T,arg:V};if(q.isCancellationRequested)return Promise.reject(new S.$5);let O;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new S.$5);const Z=()=>{const ae=ne=>{switch(ne.type){case 201:this.f.delete(te),x(ne.data);break;case 202:{this.f.delete(te);const $e=new Error(ne.data.message);$e.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,$e.name=ne.data.name,z($e);break}case 203:this.f.delete(te),z(ne.data);break}};this.f.set(te,ae),this.p(G)};let W=null;this.b===g.Idle?Z():(W=(0,R.$Og)(ae=>this.u()),W.then(()=>{W=null,Z()}));const B=()=>{W?(W.cancel(),W=null):this.p({id:te,type:101}),z(new S.$5)},_=q.onCancellationRequested(B);O=(0,u.$Pc)((0,u.$Qc)(B),_),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,T,V){const q=this.g++,he={id:q,type:102,channelName:L,name:T,arg:V};let G=null;const O=new d.$Sd({onWillAddFirstListener:()=>{G=(0,R.$Og)(x=>this.u()),G.then(()=>{G=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(O),this.p({id:q,type:103}))}}),U=x=>O.fire(x.data);return this.f.set(q,U),O.event}p(L){switch(L.type){case 100:case 102:{const T=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${y(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.q([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,y(L.type));return}}}q(L,T=void 0){const V=new i;return c(V,L),c(V,T),this.r(V.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const T=new f(L),V=w(T),q=w(T),te=V[0];switch(te){case 200:return this.j?.logIncoming(L.byteLength,0,0,$(te)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,V[1],0,$(te),q),this.t({type:V[0],id:V[1],data:q})}}t(L){if(L.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=k,Ee([D.$sh],k.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new d.$Sd,this.onDidAddConnection=this.g.event,this.h=new d.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new u.$Rc,this.j.add(L(({protocol:T,onDidClientDisconnect:V})=>{const q=d.Event.once(T.onMessage);this.j.add(q(te=>{const he=new f(te),G=w(he),O=new A(T,G),U=new k(T);this.a.forEach((z,Z)=>O.registerChannel(Z,z));const x={channelServer:O,channelClient:U,ctx:G};this.f.add(x),this.g.fire(x),this.j.add(V(()=>{O.dispose(),U.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,T){const V=this;return{call(q,te,he){let G;if((0,b.$Rf)(T)){const U=(0,P.$4b)(V.connections.filter(T));G=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(V.onDidAddConnection,T))}else G=T.routeCall(V,q,te);const O=G.then(U=>U.channelClient.getChannel(L));return F(O).call(q,te,he)},listen(q,te){if((0,b.$Rf)(T))return V.k(L,T,q,te);const he=T.routeEvent(V,q,te).then(G=>G.channelClient.getChannel(L));return F(he).listen(q,te)}}}k(L,T,V,q){const te=this;let he;const G=new d.$Sd({onWillAddFirstListener:()=>{he=new u.$Rc;const O=new d.$Yd,U=new Map,x=Z=>{const B=Z.channelClient.getChannel(L).listen(V,q),_=O.add(B);U.set(Z,_)},z=Z=>{const W=U.get(Z);W&&(W.dispose(),U.delete(Z))};te.connections.filter(T).forEach(x),d.Event.filter(te.onDidAddConnection,T)(x,void 0,he),te.onDidRemoveConnection(z,void 0,he),O.event(G.fire,G,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return G.event}registerChannel(L,T){this.a.set(L,T);for(const V of this.f)V.channelServer.registerChannel(L,T)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Eh=C;class j{constructor(L,T,V=null){const q=new i;c(q,T),L.send(q.buffer),this.a=new k(L,V),this.d=new A(L,T,V)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Fh=j;function F(H){return{call(L,T,V){return H.then(q=>q.call(L,T,V))},listen(L,T){const V=new d.$2d;return H.then(q=>V.input=q.listen(L,T)),V.event}}}e.$Gh=F;function N(H){let L=!1;return{call(T,V,q){return L?H.call(T,V,q):(0,R.$2g)(0).then(()=>L=!0).then(()=>H.call(T,V,q))},listen(T,V){if(L)return H.listen(T,V);const q=new d.$2d;return(0,R.$2g)(0).then(()=>L=!0).then(()=>q.input=H.listen(T,V)),q.event}}}e.$Hh=N;class Y{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await d.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Ih=Y;var Q;(function(H){function L(te,he,G){const O=te,U=G&&G.disableMarshalling,x=new Map;for(const z in O)V(z)&&x.set(z,d.Event.buffer(O[z],!0,void 0,he));return new class{listen(z,Z,W){const B=x.get(Z);if(B)return B;if(q(Z)){const _=O[Z];if(typeof _=="function")return _.call(O,W)}throw new S.$bb(`Event not found: ${Z}`)}call(z,Z,W){const B=O[Z];if(typeof B=="function"){if(!U&&Array.isArray(W))for(let ae=0;ae<W.length;ae++)W[ae]=(0,p.$xh)(W[ae]);let _=B.apply(O,W);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new S.$bb(`Method not found: ${Z}`)}}}H.fromService=L;function T(te,he){const G=he&&he.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return he?.properties?.has(U)?he.properties.get(U):q(U)?function(x){return te.listen(U,x)}:V(U)?te.listen(U):async function(...x){let z;he&&!(0,b.$Mf)(he.context)?z=[he.context,...x]:z=x;const Z=await te.call(U,z);return G?Z:(0,p.$xh)(Z)};throw new S.$bb(`Property not found: ${String(U)}`)}})}H.toService=T;function V(te){return te[0]==="o"&&te[1]==="n"&&v.$6e(te.charCodeAt(2))}function q(te){return/^onDynamic/.test(te)&&v.$6e(te.charCodeAt(9))}})(Q||(e.ProxyChannel=Q={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const L=H.toString();if(L!=="[object Object]")return L}return H}function ue(H){return Array.isArray(H)?H.map(ce):ce(H)}function K(H,L,T,V,q,te,he){he=ue(he);const G=le[q],O=G[V%G.length];let U=[`%c[${H}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(te)?(U=U.concat(he),U.push(")")):U.push(he),console.log.apply(console,U)}class X{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,V,q,te){this.b+=L,K(this.d,this.b,L,T,V,q,te)}logIncoming(L,T,V,q,te){this.a+=L,K(this.f,this.a,L,T,V,q,te)}}e.$Jh=X}),define(re[157],oe([0,1,18,3,42]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=void 0;class M{constructor(d){this.a=d,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",u=>P.$ge.wrap(u.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$fU=M;class D extends s.$Fh{constructor(d,u){const p=new M(d);super(p,u),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$gU=D}),define(re[109],oe([0,1,18,3,2,42]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.ProtocolConstants=e.$Kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let c=0;function w(I,k){if(!n.has(I)){const C=String(++c);n.set(I,C)}return n.get(I)}function A(I,k,C,j){if(!t.enableDiagnostics)return;const F=w(I,k);if(j instanceof P.$ge||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const N=P.$ge.alloc(j.byteLength);N.set(j),t.records.push({timestamp:Date.now(),id:F,label:k,type:C,buff:N})}else t.records.push({timestamp:Date.now(),id:F,label:k,type:C,data:j})}t.traceSocketEvent=A})(S||(e.SocketDiagnostics=S={}));var d;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let u=null;function p(){return u||(u=P.$ge.alloc(0)),u}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return p();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return c&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const w=P.$ge.alloc(n);let A=0,I=0;for(;n>0;){const k=this.a[I];if(k.byteLength>n){const C=k.slice(0,n);w.set(C,A),A+=n,c&&(this.a[I]=k.slice(n),this.b-=n),n-=n}else w.set(k,A),A+=k.byteLength,c?(this.a.shift(),this.b-=k.byteLength):I++,n-=k.byteLength}return w}}e.$Kh=v;var b;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class m{constructor(n,c,w,A){this.type=n,this.id=c,this.ack=w,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Sc{constructor(n){super(),this.f=this.B(new R.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,A=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new m(w,A,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=P.$ge.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const w=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,w}h(){const n=P.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Sc{constructor(n){super(),this.f=new R.$Sd,this.onMessage=this.f.event,this.g=new R.$Sd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Lh=h;class a extends M.$Fh{static fromSocket(n,c){return new a(new h(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,w=null){super(n,c,w),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Mh=a;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Nh=E;class f{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,w=this.a;for(;w;)n[c++]=w.data,w=w.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new f(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<o.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+o.a)*1e3;let w=0;for(let A=0;A<o.a;A++)n-this.c[A]<=c&&w++;return 1-w/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,p());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,p());this.p.write(n)}sendResume(){const n=new m(8,0,0,p());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,p());this.p.write(n);const c=this.b.toArray();for(let w=0,A=c.length;w<A;w++)this.p.write(c[w]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new m(6,0,0,p())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let w=0,A=c.length;w<A;w++)this.p.write(c[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const w=new m(1,c,this.h,n);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(n){const c=new m(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,w=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(c>=2e4&&w>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:w});return}const I=Math.max(2e4-c,2e4-w,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,p());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,p());this.p.write(n)}}e.$Oh=r}),define(re[36],oe([0,1,15,14,13]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cU=void 0;class M{constructor(){this.a=new WeakMap}on(S,d){const u=(p,...v)=>{this.b(S,p)&&d(p,...v)};return this.a.set(d,u),P.ipcMain.on(S,u),this}once(S,d){return P.ipcMain.once(S,(u,...p)=>{this.b(S,u)&&d(u,...p)}),this}handle(S,d){return P.ipcMain.handle(S,(u,...p)=>this.b(S,u)?d(u,...p):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,d){const u=this.a.get(d);return u&&(P.ipcMain.removeListener(S,u),this.a.delete(d)),this}b(S,d){if(!S||!S.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const u=d.senderFrame,p=u.url;if(!p||p==="about:blank")return!0;let v="unknown";try{v=new URL(p).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${p}'.`),!1}return v!==s.$ig?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${v}'.`),!1):u.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$cU=new M}),define(re[158],oe([0,1,15,36,146]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dU=void 0;function M(){R.$cU.on(s.$aU,(S,d,u,p,v)=>{const b=D(S,p,u);b.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{b&&S.sender.send(s.$bU,d)}})})}e.$dU=M;function D(S,d,u){const p=new P.Menu;return u.forEach(v=>{let b;v.type==="separator"?b=new P.MenuItem({type:v.type}):Array.isArray(v.submenu)?b=new P.MenuItem({submenu:D(S,d,v.submenu),label:v.label}):b=new P.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(l,y,m)=>S.sender.send(d,v.id,m)}),p.append(b)}),p}}),define(re[159],oe([0,1,36,18,3,2,42,147]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jU=void 0;function d(p,v){const b=s.Event.fromNodeEventEmitter(P.$cU,v,(y,m)=>({event:y,message:m})),l=s.Event.filter(b,({event:y})=>y.sender.id===p);return s.Event.map(l,({message:y})=>y&&R.$ge.wrap(y))}class u extends D.$Eh{static{this.b=new Map}static d(){const v=s.Event.fromNodeEventEmitter(P.$cU,"vscode:hello",({sender:b})=>b);return s.Event.map(v,b=>{const l=b.id;u.b.get(l)?.dispose();const m=new s.$Sd;u.b.set(l,(0,M.$Qc)(()=>m.fire()));const $=d(l,"vscode:message"),g=s.Event.any(s.Event.signal(d(l,"vscode:disconnect")),m.event);return{protocol:new S.$iU(b,$),onDidClientDisconnect:g}})}constructor(){super(u.d())}}e.$jU=u}),define(re[110],oe([0,1,36,3,32,157]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lU=e.$kU=void 0;class D extends M.$gU{constructor(u,p){super({addEventListener:(v,b)=>u.addListener(v,b),removeEventListener:(v,b)=>u.removeListener(v,b),postMessage:v=>u.postMessage(v),start:()=>u.start(),close:()=>u.close()},p)}}e.$kU=D;async function S(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.$lg)();d.webContents.send("vscode:createMessageChannel",u);const p=R.Event.fromNodeEventEmitter(P.$cU,"vscode:createMessageChannelResult",(b,l)=>({nonce:l,port:b.ports[0]})),{port:v}=await R.Event.toPromise(R.Event.once(R.Event.filter(p,b=>b.nonce===u)));return v}e.$lU=S}),define(re[160],oe([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class y extends l.$Ch{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>s.$ge.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$bq=y;class m{constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new d.$Sd,this.onDidProcessExit=this.h.event;const a=h&&h.timeout?h.timeout:6e4;this.b=new R.$Xg(a),this.d=null,this.f=null}getChannel(g){const h=this;return{call(a,E,f){return h.k(g,a,E,f)},listen(a,E){return h.l(g,a,E)}}}k(g,h,a,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const f=this.n(g),i=(0,R.$Og)(t=>f.call(h,a,t)),o=E.onCancellationRequested(()=>i.cancel()),r=(0,u.$Qc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,h,a){if(!this.b)return d.Event.None;this.b.cancel();let E;const f=new d.$Sd({onWillAddFirstListener:()=>{E=this.n(g).listen(h,a)(f.fire,f),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,p.$gn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,b.$Ml)(h.env),this.d=(0,P.fork)(this.i,g,h);const a=new d.$Sd;d.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$0p)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}a.fire(s.$ge.wrap(Buffer.from(n,"base64")))});const f=this.j.useQueue?(0,v.$Ol)(this.d):this.d,i=n=>this.d&&this.d.connected&&f.send(n.buffer.toString("base64")),o=a.event,r={send:i,onMessage:o};this.f=new l.$Dh(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",t),this.c.forEach(w=>(0,u.$Nc)(w)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cq=m}),define(re[111],oe([0,1,8,3,2,77,12]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.StorageState=e.$ap=e.StorageHint=void 0;var S;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function d(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$ap=d;var u;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(u||(e.StorageState=u={}));class p extends s.$Sc{static{this.a=100}constructor(l,y=Object.create(null)){super(),this.r=l,this.s=y,this.b=this.B(new R.$Vd),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new P.$Yg(p.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((y,m)=>this.w(m,y)),l.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(l,y){if(this.c===u.Closed)return;let m=!1;(0,D.$Mf)(y)?m=this.f.delete(l):this.f.get(l)!==y&&(this.f.set(l,y),m=!0),m&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,y){const m=this.f.get(l);return(0,D.$Mf)(m)?y:m}getBoolean(l,y){const m=this.get(l);return(0,D.$Mf)(m)?y:m==="true"}getNumber(l,y){const m=this.get(l);return(0,D.$Mf)(m)?y:parseInt(m,10)}getObject(l,y){const m=this.get(l);return(0,D.$Mf)(m)?y:(0,M.$wh)(m)}async set(l,y,m=!1){if(this.c===u.Closed)return;if((0,D.$Mf)(y))return this.delete(l,m);const $=(0,D.$Ff)(y)||Array.isArray(y)?(0,M.$vh)(y):String(y);if(this.f.get(l)!==$)return this.f.set(l,$),this.j.set(l,$),this.h.delete(l),this.b.fire({key:l,external:m}),this.D()}async delete(l,y=!1){if(!(this.c===u.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:y}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$bp=p;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((y,m)=>this.a.set(m,y)),l.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$cp=v}),define(re[161],oe([0,1,8,3,31,9,21]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HU=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,v=Object.create(null)){this.g=p,this.h=v,this.c=(0,M.$nc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,v=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(l=>v.set(l.key,l.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(p){const v=await this.f;return this.j(v,p)}j(p,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,s.$yc)(v.insert):"0"}), delete(${v.delete?(0,s.$zc)(v.delete):"0"})`),this.t(p,()=>{const b=v.insert,l=v.delete;if(b&&b.size>0){const y=[];y.push([]);let m=0;b.forEach(($,g)=>{let h=y[m];h.length>S.b&&(m++,h=[],y.push(h)),h.push(g,$)}),y.forEach($=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,g=>g.run($),()=>{const g=[];let h=0;return b.forEach((a,E)=>{g.push(E),h+=a.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(l&&l.size){const y=[];y.push([]);let m=0;l.forEach($=>{let g=y[m];g.length>S.b&&(m++,g=[],y.push(g)),g.push($)}),y.forEach($=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,g=>g.run($),()=>{const g=[];return l.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,p)}k(p,v){return new Promise((b,l)=>{p.db.close(y=>(y&&this.o(p,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?b():!p.isErroneous&&!p.isInMemory?this.l().then(b,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),b())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const $=()=>this.k(m,void 0);return this.j(m,{insert:v()}).then(()=>$(),g=>($(),Promise.reject(g)))})).then(b,l):l(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return D.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const v=await this.f,b=await this.r(v,p?"PRAGMA integrity_check":"PRAGMA quick_check"),l=p?b.integrity_check:b.quick_check;return v.isErroneous?`${l} (last error: ${v.lastError})`:v.isInMemory?`${l} (in-memory!)`:l}async n(p,v=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${v})`);try{return await this.p(p)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,P.$2g)(S.a),this.n(p,!1);try{await D.Promises.unlink(p);try{await D.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(l){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${l}`),this.p(S.IN_MEMORY_PATH)}}}o(p,v){p.isErroneous=!0,p.lastError=v,this.d.error(v)}p(p){return new Promise((v,b)=>{new Promise((l,y)=>{J(["@vscode/sqlite3"],l,y)}).then(l=>{const y={db:new(this.d.isTracing?l.verbose().Database:l.Database)(p,m=>m?y.db&&m.code!=="SQLITE_CANTOPEN"?y.db.close(()=>b(m)):b(m):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(y),$=>y.db.close(()=>b($)))),isInMemory:p===S.IN_MEMORY_PATH};y.db.on("error",m=>this.o(y,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&y.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},b)})}q(p,v){return new Promise((b,l)=>{p.db.exec(v,y=>y?(this.o(p,`[storage ${this.c}] exec(): ${y}`),l(y)):b())})}r(p,v){return new Promise((b,l)=>{p.db.get(v,(y,m)=>y?(this.o(p,`[storage ${this.c}] get(): ${y}`),l(y)):b(m))})}s(p,v){return new Promise((b,l)=>{p.db.all(v,(y,m)=>y?(this.o(p,`[storage ${this.c}] all(): ${y}`),l(y)):b(m))})}t(p,v){return new Promise((b,l)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),v(),p.db.run("END TRANSACTION",y=>y?(this.o(p,`[storage ${this.c}] transaction(): ${y}`),l(y)):b())})})}u(p,v,b,l){const y=p.db.prepare(v),m=$=>{this.o(p,`[storage ${this.c}] prepare(): ${$} (${v}). Details: ${l()}`)};y.on("error",m),b(y),y.finalize($=>{$&&m($),y.removeListener("error",m)})}}e.$HU=S;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[d.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(re[162],oe([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(re[163],oe([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[164],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(re[165],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(re[166],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(re[167],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[168],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(re[169],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(re[170],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[171],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[172],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[173],oe([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[174],oe([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[175],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(re[176],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(re[177],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(re[178],oe([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[179],oe([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[180],oe([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[181],oe([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[182],oe([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[183],oe([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(re[184],oe([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(re[185],oe([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[186],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[187],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[188],oe([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(re[189],oe([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[190],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[191],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[192],oe([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(re[193],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[194],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[195],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acb=e.$_bb=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$_bb=P;function R(s){return s&&s.hasOwnProperty("workspace")}e.$acb=R}),define(re[196],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=e.$c9b=e.$b9b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$b9b=R;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(d=>({workspace:{id:d.id,configPath:P.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return S}e.$c9b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(d=>({folderUri:P.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return S}e.$d9b=M}),define(re[197],oe([0,1,14,165]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...u){switch(u.length){case 1:return(0,R.localize)(0,null,u[0]);case 2:return(0,R.localize)(1,null,u[0],u[1]);case 3:return(0,R.localize)(2,null,u[0],u[1],u[2]);default:return}}const D=(0,R.localize)(3,null),S=(0,R.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const v=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:v,lexeme:b,additionalInfo:p}),this.f.push(l)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const v=this.c.substring(this.d,this.e),b=d.b.get(v);b?this.k(b):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,v=!1,b=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(S);return}const y=this.c.charCodeAt(p);if(v)v=!1;else if(y===47&&!b){p++;break}else y===91?b=!0:y===92?v=!0:y===93&&(b=!1);p++}for(;p<this.c.length&&d.a.has(this.c.charCodeAt(p));)p++;this.e=p;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=d}),define(re[198],oe([0,1,3,2]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=e.$Yn=void 0;class s{constructor(){this.a=new P.$Sd,this.b=new P.$Sd,this.c=new P.$Sd,this.d=new P.$Sd}static{this.ChannelName="extensionhostdebugservice"}call(S,d,u){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(S,d,u){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Yn=s;class M extends R.$Sc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,d,u){this.b.call("attach",[S,d,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,d){this.b.call("terminate",[S,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,d){return this.b.call("openExtensionDevelopmentHostWindow",[S,d])}}e.$Zn=M}),define(re[199],oe([0,1,149,56,13,9,35,19,7]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=void 0,e.$rm=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,M.$mc)(s.$jg.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Cg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Cg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,P.$qm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",l)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Cg)(d.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Cg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Cg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Cg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?d.URI.file((0,M.$jc)(l,"argv.json")):(0,S.$Cg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,M.$kc)(l):(0,M.$hc)((0,M.$jc)(s.$jg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?d.URI.file((0,M.$kc)(l)):d.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,M.$kc)(l);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const m=D.env.VSCODE_PORTABLE;return m?(0,M.$jc)(m,"extensions"):(0,S.$Cg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(y=>/^[^:/?#]+?:\/\//.test(y)?d.URI.parse(y):d.URI.file((0,M.$hc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?d.URI.parse(l):d.URI.file((0,M.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$rm.test(l))}get extensionLogLevel(){const l=[];for(const y of this.args.log||[]){const m=e.$rm.exec(y);m&&m[1]&&m[2]&&l.push([m[1],m[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,S.$Cg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?d.URI.file((0,M.$jc)(l,"policy.json")):(0,S.$Cg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,y,m){this.a=l,this.b=y,this.c=m,this.editSessionId=this.args.editSessionId}}e.$sm=u,Ee([R.$sh],u.prototype,"appRoot",null),Ee([R.$sh],u.prototype,"userHome",null),Ee([R.$sh],u.prototype,"userDataPath",null),Ee([R.$sh],u.prototype,"appSettingsHome",null),Ee([R.$sh],u.prototype,"tmpDir",null),Ee([R.$sh],u.prototype,"cacheHome",null),Ee([R.$sh],u.prototype,"stateResource",null),Ee([R.$sh],u.prototype,"userRoamingDataHome",null),Ee([R.$sh],u.prototype,"userDataSyncHome",null),Ee([R.$sh],u.prototype,"sync",null),Ee([R.$sh],u.prototype,"machineSettingsResource",null),Ee([R.$sh],u.prototype,"workspaceStorageHome",null),Ee([R.$sh],u.prototype,"localHistoryHome",null),Ee([R.$sh],u.prototype,"keyboardLayoutResource",null),Ee([R.$sh],u.prototype,"argvResource",null),Ee([R.$sh],u.prototype,"isExtensionDevelopment",null),Ee([R.$sh],u.prototype,"untitledWorkspacesHome",null),Ee([R.$sh],u.prototype,"builtinExtensionsPath",null),Ee([R.$sh],u.prototype,"extensionsPath",null),Ee([R.$sh],u.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$sh],u.prototype,"extensionDevelopmentKind",null),Ee([R.$sh],u.prototype,"extensionTestsLocationURI",null),Ee([R.$sh],u.prototype,"debugExtensionHost",null),Ee([R.$sh],u.prototype,"logLevel",null),Ee([R.$sh],u.prototype,"extensionLogLevel",null),Ee([R.$sh],u.prototype,"serviceMachineIdResource",null),Ee([R.$sh],u.prototype,"disableTelemetry",null),Ee([R.$sh],u.prototype,"disableWorkspaceTrust",null),Ee([R.$sh],u.prototype,"useInMemorySecretStorage",null),Ee([R.$sh],u.prototype,"policyFile",null);function p(b,l){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$tm=p;function v(b,l,y,m,$,g){const a=Number(l||b)||(m?null:y),E=a?!!l:!1;let f;if(g)try{f=JSON.parse(g)}catch{}return{port:a,break:E,debugId:$,env:f}}e.$um=v}),define(re[112],oe([0,1,309,4,168]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Ql=["tunnel","serve-web"],e.$Rl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(m,$,g=D){const h=m.find(c=>c.length>0&&c[0]!=="-"),a={},E=["_"],f=[],i={};let o;for(const c in $){const w=$[c];w.type==="subcommand"?c===h&&(o=w):(w.alias&&(a[c]=w.alias),w.type==="string"||w.type==="string[]"?(E.push(c),w.deprecates&&E.push(...w.deprecates)):w.type==="boolean"&&(f.push(c),w.deprecates&&f.push(...w.deprecates)),w.global&&(i[c]=w))}if(o&&h){const c=i;for(const k in o.options)c[k]=o.options[k];const w=m.filter(k=>k!==h),A=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,I=S(w,c,A);return{[h]:I,_:[]}}const r=P(m,{string:E,boolean:f,alias:a}),t={},n=r;t._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in $){const w=$[c];if(w.type==="subcommand")continue;w.alias&&delete n[w.alias];let A=n[c];if(w.deprecates)for(const I of w.deprecates)n.hasOwnProperty(I)&&(A||(A=n[I],A&&g.onDeprecatedOption(I,w.deprecationMessage||(0,s.localize)(37,null,c))),delete n[I]);if(typeof A<"u"){if(w.type==="string[]"){if(Array.isArray(A)||(A=[A]),!w.allowEmptyValue){const I=A.filter(k=>k.length>0);I.length!==A.length&&(g.onEmptyValue(c),A=I.length>0?I:void 0)}}else w.type==="string"&&(Array.isArray(A)?(A=A.pop(),g.onMultipleValues(c,A)):!A&&!w.allowEmptyValue&&(g.onEmptyValue(c),A=void 0));t[c]=A,w.deprecationMessage&&g.onDeprecatedOption(c,w.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return t}e.$Sl=S;function d(m,$){let g="";return $.args&&(Array.isArray($.args)?g=` <${$.args.join("> <")}>`:g=` <${$.args}>`),$.alias?`-${$.alias} --${m}${g}`:`--${m}${g}`}function u(m,$){const g=[];for(const h in m){const a=m[h],E=d(h,a);g.push([E,a.description])}return p(g,$)}e.$Tl=u;function p(m,$){const h=m.reduce((f,i)=>Math.max(f,i[0].length),12)+2+1;if($-h<25)return m.reduce((f,i)=>f.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=$-h-1,E=[];for(const f of m){const i=f[0],o=b(f[1],a),r=v(h-i.length-2);E.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)E.push(v(h)+o[t])}return E}function v(m){return" ".repeat(m)}function b(m,$){const g=[];for(;m.length;){const h=m.length<$?m.length:m.lastIndexOf(" ",$),a=m.slice(0,h).trim();m=m.slice(h),g.push(a)}return g}function l(m,$,g,h,a){const E=process.stdout.isTTY&&process.stdout.columns||80,f=a?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${g}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${f}`),i.push(""),a?.noPipe!==!0&&(R.$i?i.push((0,s.localize)(41,null,$)):i.push((0,s.localize)(42,null,$)),i.push(""));const o={},r=[];for(const t in h){const n=h[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[t]=n}}for(const t in o){const n=t,c=o[n];c&&(i.push(M[n]),i.push(...u(c,E)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...p(r.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Ul=l;function y(m,$){return`${m||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$Vl=y}),define(re[200],oe([0,1,87,198,112]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0;class M extends R.$Yn{constructor(S){super(),this.f=S}call(S,d,u){return d==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(S,d,u)}async g(S,d){const u=(0,s.$Sl)(S,s.$Rl);u.debugRenderer=d;const p=u.extensionDevelopmentPath;if(!p)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!d)return{success:!0};const b=v.win;if(!b)return{success:!0};const l=b.webContents.debugger;let y=l.isAttached()?1/0:0;const m=(0,P.createServer)($=>{y++===0&&l.attach();let g=!1;const h=f=>{g||$.write(JSON.stringify(f)+"\0")},a=(f,i,o,r)=>h({method:i,params:o,sessionId:r});b.on("close",()=>{l.removeListener("message",a),$.end(),g=!0}),l.addListener("message",a);let E=Buffer.alloc(0);$.on("data",f=>{E=Buffer.concat([E,f]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let o;try{const r=E.slice(0,i).toString("utf8");E=E.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}l.sendCommand(o.method,o.params,o.sessionId).then(r=>h({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",f=>{console.error("error on cdp pipe:",f)}),$.on("close",()=>{g=!0,--y===0&&l.detach()})});return await new Promise($=>m.listen(0,$)),b.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$E9b=M}),define(re[64],oe([0,1,310,169,112]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0;function M(v,b){const l=(a,E)=>{console.warn((0,R.localize)(0,null,a,E))},y=a=>{console.warn((0,R.localize)(1,null,a))},m=(a,E)=>{console.warn((0,R.localize)(2,null,a,E))},$=a=>({onUnknownOption:E=>{s.$Ql.includes(a)||console.warn((0,R.localize)(3,null,E,a))},onMultipleValues:l,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:s.$Ql.includes(a)?$:void 0}),g={onUnknownOption:a=>{console.warn((0,R.localize)(4,null,a))},onMultipleValues:l,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:$},h=(0,s.$Sl)(v,s.$Rl,b?g:void 0);return h.goto&&h._.forEach(a=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(a),(0,R.localize)(5,null))),h}function D(v){const b=v.findIndex(l=>!/^-/.test(l));if(b>-1)return[...v.slice(0,b),...v.slice(b+1)]}function S(v){let[,...b]=v;process.env.VSCODE_DEV&&(b=D(b)||[]);const l=!p(process.env);return M(b,l)}e.$Wl=S;function d(v){let[,,...b]=v;return process.env.VSCODE_DEV&&(b=D(b)||[]),M(b,!0)}e.$Xl=d;function u(v,...b){const l=v.indexOf("--");return l===-1?v.push(...b):v.splice(l,0,...b),v}e.$Yl=u;function p(v){return v.VSCODE_CLI==="1"}e.$Zl=p}),function(){"use strict";function J(e,P,R){function s(D,S){const d=M(D,S),u=[d];return e.isAbsolute(d)||u.unshift(R),e.resolve(...u)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const p=D["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(v,"AppData","Roaming")}break;case"darwin":u=e.join(P.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:s}}if(typeof define=="function")define(re[201],oe([113,26,35]),function(e,P,R){return J(e,P,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=J(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[90],oe([0,1,26,199,201]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=void 0;class M extends R.$sm{constructor(u,p){super(u,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,p.nameShort)},p)}}e.$vm=M;function D(d,u){return(0,R.$um)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,u,d.extensionEnvironment)}e.$wm=D;function S(d,u){return(0,R.$um)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,u,d.extensionEnvironment)}e.$xm=S}),define(re[202],oe([0,1,46,26,33]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0b=void 0;function M(D){const S=(0,s.$$f)((0,R.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(d){D&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$W0b=M}),define(re[203],oe([0,1,12,171]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function s(D,S,d,u){try{M(D,S,d,u)}catch(p){D.error(p?.message??p)}return S}e.$Jp=s;function M(D,S,d,u){const p=(v,b,l)=>{const y=v[b];if((0,P.$Df)(y)){const m=y,$=m.length;if($>1&&m[0]==="%"&&m[$-1]==="%"){const g=m.substr(1,$-2);let h=d[g];h===void 0&&u&&(h=u[g]);const a=typeof h=="string"?h:h?.message,E=u?.[g],f=typeof E=="string"?E:E?.message;if(!a){f||D.warn(`[${S.name}]: ${(0,R.localize)(0,null,g)}`);return}if(l&&(b==="title"||b==="category")&&f&&f!==a){const i={value:a,original:f};v[b]=i}else v[b]=a}}else if((0,P.$Ff)(y))for(const m in y)y.hasOwnProperty(m)&&(m==="commands"?p(y,m,!0):p(y,m,l));else if(Array.isArray(y))for(let m=0;m<y.length;m++)p(y,m,l)};for(const v in S)S.hasOwnProperty(v)&&p(S,v)}}),define(re[204],oe([0,1,19,74,173,205]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||D.test(g)}e.$Xo=d;function u(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Yo=u;function p(g){if(!g)return null;const h=g.majorBase,a=g.majorMustEqual,E=g.minorBase;let f=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(h===0||(f=!1),o=!1);let r=0;if(g.preRelease){const t=S.exec(g.preRelease);if(t){const[,n,c,w]=t;r=Date.UTC(Number(n),Number(c)-1,Number(w))}}return{majorBase:h,majorMustEqual:a,minorBase:E,minorMustEqual:f,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$Zo=p;function v(g,h,a){let E;typeof g=="string"?E=p(u(g)):E=g;let f;h instanceof Date?f=h.getTime():typeof h=="string"&&(f=new Date(h).getTime());let i;if(typeof a=="string"?i=p(u(a)):i=a,!E||!i)return!1;const o=E.majorBase,r=E.minorBase,t=E.patchBase;let n=i.majorBase,c=i.minorBase,w=i.patchBase;const A=i.notBefore;let I=i.majorMustEqual,k=i.minorMustEqual,C=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>c?!0:r<c||f&&f<A?!1:t>=w:(o===1&&n===0&&(!I||!k||!C)&&(n=1,c=0,w=0,I=!0,k=!1,C=!1),o<n?!1:o>n?!I:r<c?!1:r>c?!k:t<w?!1:t>w?!C:!(f&&f<A))}e.$1o=v;function b(g,h,a,E,f){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([R.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([R.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([R.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([R.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([R.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!$(E.extensionDependencies))return i.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!$(E.activationEvents))return i.push([R.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([R.default.Error,s.localize(9,null,"main")]),i;{const t=(0,P.$Cg)(a,E.main);(0,P.$wg)(t,a)||i.push([R.default.Warning,s.localize(10,null,t.path,a.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([R.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,P.$Cg)(a,E.browser);(0,P.$wg)(t,a)||i.push([R.default.Warning,s.localize(12,null,t.path,a.path)])}}if(!M.valid(E.version))return i.push([R.default.Error,s.localize(13,null)]),i;const o=[];if(!l(g,h,E,f,o))for(const t of o)i.push([R.default.Error,t]);return i}e.$2o=b;function l(g,h,a,E,f){return E||typeof a.main>"u"&&typeof a.browser>"u"?!0:m(g,h,a.engines.vscode,f)}e.$3o=l;function y(g,h,a){return g==="*"||m(h,a,g)}e.$4o=y;function m(g,h,a,E=[]){const f=p(u(a));if(!f)return E.push(s.localize(14,null,a)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return E.push(s.localize(15,null,a)),!1}else if(!f.majorMustEqual)return E.push(s.localize(16,null,a)),!1;return v(g,h,f)?!0:(E.push(s.localize(17,null,g,a)),!1)}function $(g){if(!Array.isArray(g))return!1;for(let h=0,a=g.length;h<a;h++)if(typeof g[h]!="string")return!1;return!0}}),define(re[206],oe([0,1,18,32]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;async function s(M,D,S){let d=S&&S.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const p=(await D.readFile(M.serviceMachineIdResource)).value.toString();d=(0,R.$kg)(p)?p:null}catch{d=null}if(!d){d=(0,R.$lg)();try{await D.writeFile(M.serviceMachineIdResource,P.$ge.fromString(d))}catch{}}return S?.store("storage.serviceMachineId",d,-1,1),d}e.$lp=s}),define(re[78],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$Xh=P}),define(re[207],oe([0,1,78]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.InstantiationType=void 0;const R=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,d,u){d instanceof P.$Xh||(d=new P.$Xh(d,[],!!u)),R.push([S,d])}e.$Ir=M;function D(){return R}e.$Jr=D}),define(re[208],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$nq=P;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(D);S.outgoing.set(d.key,d),d.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),d=this.c(D,S);if(d)return d}}c(M,D){for(const[S,d]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const u=this.c(d,D);if(u)return u;D.delete(S)}}}e.$oq=R}),define(re[6],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(d){return d[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$Zh=s("instantiationService");function R(D,S,d){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:d}):(S[P.DI_DEPENDENCIES]=[{id:D,index:d}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(d,u,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,d,p)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$1h=s;function M(D){return D}e.$2h=M}),define(re[65],oe([0,1,13,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=e.$w9b=void 0,e.$w9b=(0,R.$1h)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${P.Schemas.vscodeFileResource}://${P.$ig}/`)}e.$x9b=s}),define(re[66],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=void 0,e.$e9b=(0,P.$1h)("backupMainService")}),define(re[17],oe([0,1,12,7,6]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,s.$1h)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof R.URI)}e.$vi=M;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof R.URI)}e.$wi=D;var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function d(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=d;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$yi=u;function p(g,h){const a=Object.create(null);for(const E in g)v(a,E,g[E],h);return a}e.$zi=p;function v(g,h,a,E){const f=h.split("."),i=f.pop();let o=g;for(let r=0;r<f.length;r++){const t=f[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${f.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{E(`Ignoring ${h} as ${f.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${h} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.$Ai=v;function b(g,h){const a=h.split(".");l(g,a)}e.$Bi=b;function l(g,h){const a=h.shift();if(h.length===0){delete g[a];return}if(Object.keys(g).indexOf(a)!==-1){const E=g[a];typeof E=="object"&&!Array.isArray(E)&&(l(E,h),Object.keys(E).length===0&&delete g[a])}}function y(g,h,a){function E(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const f=h.split("."),i=E(g,f);return typeof i>"u"?a:i}e.$Ci=y;function m(g,h,a){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in g?P.$Ff(g[E])&&P.$Ff(h[E])?m(g[E],h[E],a):a&&(g[E]=h[E]):g[E]=h[E])})}e.$Di=m;function $(g){return g.replace(/[\[\]]/g,"")}e.$Ei=$}),define(re[114],oe([0,1,4,25,197,6,164,14]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",P.$j),d.set("isLinux",P.$k),d.set("isWindows",P.$i),d.set("isWeb",P.$o),d.set("isMacNative",P.$j&&!P.$o),d.set("isEdge",P.$H),d.set("isFirefox",P.$F),d.set("isChrome",P.$E),d.set("isSafari",P.$G);function u(G,O){if(d.get(G)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(G,O)}e.$Wi=u;const p=Object.prototype.hasOwnProperty;var v;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const b={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),y=(0,D.localize)(1,null),m=(0,D.localize)(2,null),$=(0,D.localize)(3,null),g=(0,D.localize)(4,null),h=(0,D.localize)(5,null),a=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=b){this.k=O,this.d=new s.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const x=this.D(),z=x.type===17?h:void 0;throw this.h.push({message:g,offset:x.offset,lexeme:s.$Vi.getLexeme(x),additionalInfo:z}),f.c}return U}catch(U){if(U!==f.c)throw U;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const U=this.o();O.push(U)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const U=this.s();O.push(U)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,$),U?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const U=this.l();return this.A(1,$),U}case 17:{const U=O.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Z=z.lexeme,W=Z.lastIndexOf("/"),B=W===Z.length-1?void 0:this.w(Z.substring(W+1));let _;try{_=new RegExp(Z.substring(1,W),B)}catch{throw this.B("REGEX",z)}return ce.create(U,_)}switch(z.type){case 10:case 19:{const Z=[z.lexeme];this.z();let W=this.D(),B=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let me=0;me<W.lexeme.length;me++)W.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--}if(B<0)break;Z.push(s.$Vi.getLexeme(W)),this.z(),W=this.D()}const _=Z.join(""),ae=_.lastIndexOf("/"),ne=ae===_.length-1?void 0:this.w(_.substring(ae+1));let $e;try{$e=new RegExp(_.substring(1,ae),ne)}catch{throw this.B("REGEX",z)}return i.regex(U,$e)}case 18:{const Z=z.lexeme;this.z();let W=null;if(!(0,R.$Ge)(Z)){const B=Z.indexOf("/"),_=Z.lastIndexOf("/");if(B!==_&&B>=0){const ae=Z.slice(B+1,_),ne=Z[_+1]==="i"?"i":"";try{W=new RegExp(ae,ne)}catch{throw this.B("REGEX",z)}}}if(W===null)throw this.B("REGEX",z);return ce.create(U,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const z=this.u();return i.notIn(U,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return i.equals(U,z);switch(z){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return i.notEquals(U,z);switch(z){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,z)}}case 5:return this.z(),Q.create(U,this.u());case 6:return this.z(),le.create(U,this.u());case 7:return this.z(),N.create(U,this.u());case 8:return this.z(),Y.create(U,this.u());case 13:return this.z(),i.in(U,this.u());default:return i.has(U)}}case 20:throw this.h.push({message:a,offset:O.offset,lexeme:"",additionalInfo:E}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,U){if(this.C(O))return this.z();throw this.B(U,this.D())}B(O,U,x){const z=(0,D.localize)(8,null,O,s.$Vi.getLexeme(U)),Z=U.offset,W=s.$Vi.getLexeme(U);return this.h.push({message:z,offset:Z,lexeme:W,additionalInfo:x}),f.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=f;class i{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(O){return w.create(O)}static equals(O,U){return A.create(O,U)}static notEquals(O,U){return C.create(O,U)}static regex(O,U){return ce.create(O,U)}static in(O,U){return I.create(O,U)}static notIn(O,U){return k.create(O,U)}static not(O){return j.create(O)}static and(...O){return X.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,U){return N.create(O,U)}static greaterEquals(O,U){return Y.create(O,U)}static smaller(O,U){return Q.create(O,U)}static smallerEquals(O,U){return le.create(O,U)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Yi=i;function o(G){const O=new f({regexParsingWithErrorRecovery:!1});return G.map(U=>(O.parse(U),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$Zi=o;function r(G,O){const U=G?G.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!U&&!x?!0:!U||!x?!1:U.equals(x)}e.$1i=r;function t(G,O){return G.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return c.INSTANCE}}e.$2i=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$3i=c;class w{static create(O,U=null){const x=d.get(O);return typeof x=="boolean"?x?c.INSTANCE:n.INSTANCE:new w(O,U)}constructor(O,U){this.key=O,this.c=U,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:T(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=d.get(this.key);return typeof O=="boolean"?O?c.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$4i=w;class A{static create(O,U,x=null){if(typeof U=="boolean")return U?w.create(O,x):j.create(O,x);const z=d.get(O);return typeof z=="boolean"?U===(z?"true":"false")?c.INSTANCE:n.INSTANCE:new A(O,U,x)}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?c.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$5i=A;class I{static create(O,U){return new I(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:V(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(U)?U.includes(x):typeof x=="string"&&typeof U=="object"&&U!==null?p.call(U,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$6i=I;class k{static create(O,U){return new k(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=11,this.c=I.create(O,U)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=k;class C{static create(O,U,x=null){if(typeof U=="boolean")return U?j.create(O,x):w.create(O,x);const z=d.get(O);return typeof z=="boolean"?U===(z?"true":"false")?n.INSTANCE:c.INSTANCE:new C(O,U,x)}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?n.INSTANCE:c.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$8i=C;class j{static create(O,U=null){const x=d.get(O);return typeof x=="boolean"?x?n.INSTANCE:c.INSTANCE:new j(O,U)}constructor(O,U){this.c=O,this.d=U,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:T(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=d.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:c.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$9i=j;function F(G,O){if(typeof G=="string"){const U=parseFloat(G);isNaN(U)||(G=U)}return typeof G=="string"||typeof G=="number"?O(G):n.INSTANCE}class N{static create(O,U,x=null){return F(U,z=>new N(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$0i=N;class Y{static create(O,U,x=null){return F(U,z=>new Y(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$$i=Y;class Q{static create(O,U,x=null){return F(U,z=>new Q(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$_i=Q;class le{static create(O,U,x=null){return F(U,z=>new le(O,z,x))}constructor(O,U,x){this.c=O,this.d=U,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$aj=le;class ce{static create(O,U){return new ce(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const U=this.f?this.f.source:"",x=O.f?O.f.source:"";return U<x?-1:U>x?1:0}equals(O){if(O.type===this.type){const U=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&U===x}return!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$bj=ce;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$cj=ue;function K(G){let O=null;for(let U=0,x=G.length;U<x;U++){const z=G[U].substituteConstants();if(G[U]!==z&&O===null){O=[];for(let Z=0;Z<U;Z++)O[Z]=G[Z]}O!==null&&(O[U]=z)}return O===null?G:O}class X{static create(O,U,x){return X.d(O,U,x)}constructor(O,U){this.expr=O,this.c=U,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=t(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:X.create(O,this.c,!1)}evaluate(O){for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].evaluate(O))return!1;return!0}static d(O,U,x){const z=[];let Z=!1;for(const W of O)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&Z)return c.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(t);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const B=z.pop(),_=z.length===0,ae=H.create(W.expr.map(ne=>X.create([ne,B],null,x)),null,_);ae&&(z.push(ae),z.sort(t))}if(z.length===1)return z[0];if(x){for(let W=0;W<z.length;W++)for(let B=W+1;B<z.length;B++)if(z[W].negate().equals(z[B]))return n.INSTANCE;if(z.length===1)return z[0]}return new X(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new X(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());this.c=H.create(O,this,!0)}return this.c}}e.$dj=X;class H{static create(O,U,x){return H.d(O,U,x)}constructor(O,U){this.expr=O,this.c=U,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=t(this.expr[U],O.expr[U]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let U=0,x=this.expr.length;U<x;U++)if(this.expr[U].evaluate(O))return!0;return!1}static d(O,U,x){let z=[],Z=!1;if(O){for(let W=0,B=O.length;W<B;W++){const _=O[W];if(_){if(_.type===0){Z=!0;continue}if(_.type===1)return c.INSTANCE;if(_.type===9){z=z.concat(_.expr);continue}z.push(_)}}if(z.length===0&&Z)return n.INSTANCE;z.sort(t)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(x){for(let W=0;W<z.length;W++)for(let B=W+1;B<z.length;B++)if(z[W].negate().equals(z[B]))return c.INSTANCE;if(z.length===1)return z[0]}return new H(z,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new H(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());for(;O.length>1;){const U=O.shift(),x=O.shift(),z=[];for(const Z of he(U))for(const W of he(x))z.push(X.create([Z,W],null,!1));O.unshift(H.create(z,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$ej=H;class L extends w{static{this.d=[]}static all(){return L.d.values()}constructor(O,U,x){super(O,null),this.f=U,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:U!=null?typeof U:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return A.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$fj=L,e.$gj=(0,M.$1h)("contextKeyService");function T(G,O){return G<O?-1:G>O?1:0}function V(G,O,U,x){return G<U?-1:G>U?1:O<x?-1:O>x?1:0}function q(G,O){if(G.type===0||O.type===1)return!0;if(G.type===9)return O.type===9?te(G.expr,O.expr):!1;if(O.type===9){for(const U of O.expr)if(q(G,U))return!0;return!1}if(G.type===6){if(O.type===6)return te(O.expr,G.expr);for(const U of G.expr)if(q(U,O))return!0;return!1}return G.equals(O)}e.$hj=q;function te(G,O){let U=0,x=0;for(;U<G.length&&x<O.length;){const z=G[U].cmp(O[x]);if(z<0)return!1;z===0&&U++,x++}return U===G.length}function he(G){return G.type===9?G.expr:[G]}}),define(re[91],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.ID=void 0,e.ID="diagnosticsService",e.$Cm=(0,P.$1h)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.$Dm=R;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Em=s}),define(re[115],oe([0,1,19,74,166,6,47,4,38]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.ConfirmResult=e.$Rv=e.$Qv=e.$Pv=void 0,e.$Pv=(0,M.$1h)("dialogService");var u;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(u||(u={}));class p{a($){return this.d($,u.Confirmation)}b($){return this.d($,u.Prompt)}c($){return this.d($,u.Input)}d($,g){const h=[];switch(g){case u.Confirmation:{const a=$;a.primaryButton?h.push(a.primaryButton):h.push((0,s.localize)(0,null)),a.cancelButton?h.push(a.cancelButton):h.push((0,s.localize)(1,null));break}case u.Prompt:{const a=$;Array.isArray(a.buttons)&&a.buttons.length>0&&h.push(...a.buttons.map(E=>E.label)),a.cancelButton&&(a.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof a.cancelButton=="string"?h.push(a.cancelButton):a.cancelButton.label?h.push(a.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case u.Input:{const a=$;a.primaryButton?h.push(a.primaryButton):h.push((0,s.localize)(5,null)),a.cancelButton?h.push(a.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===R.default.Info?"info":$===R.default.Error?"error":$===R.default.Warning?"warning":"none"}f($,g,h){const a=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&a.push($.cancelButton);let E=a[g]?.run({checkboxChecked:h});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:h}}}e.$Qv=p,e.$Rv=(0,M.$1h)("fileDialogService");var v;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const b=10;function l(m){const $=[];return $.push(...m.slice(0,b).map(g=>typeof g=="string"?g:(0,P.$zg)(g))),m.length>b&&(m.length-b===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,m.length-b))),$.push(""),$.join(`
`)}e.$Sv=l;function y(m,$){const g=(0,d.$gn)(m);let h=(g.buttons??[]).map(i=>(0,D.$Mv)(i)),a=(m.buttons||[]).map((i,o)=>o),E=0,f=g.cancelId??h.length-1;if(h.length>1){const i=typeof f=="number"?h[f]:void 0;if(S.$k||S.$j){if(typeof i=="string"&&h.length>1&&f!==1){h.splice(f,1),h.splice(1,0,i);const o=a[f];a.splice(f,1),a.splice(1,0,o),f=1}S.$k&&h.length>1&&(h=h.reverse(),a=a.reverse(),E=h.length-1,typeof i=="string"&&(f=E-1))}else if(S.$i&&typeof i=="string"&&h.length>1&&f!==h.length-1){h.splice(f,1),h.push(i);const o=a[f];a.splice(f,1),a.push(o),f=h.length-1}}return g.buttons=h,g.defaultId=E,g.cancelId=f,g.noLink=!0,g.title=g.title||$.nameLong,{options:g,buttonIndeces:a}}e.$Tv=y}),define(re[116],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZU=e.$YU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$XU=e.$WU=void 0,e.$WU=(0,P.$1h)("encryptionService"),e.$XU=(0,P.$1h)("encryptionMainService");var R;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$YU=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$ZU=D}),define(re[37],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,P.$1h)("environmentService"),e.$9h=(0,P.$2h)(e.$8h)}),define(re[117],oe([0,1,170,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$jo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0,e.$0n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$n=new RegExp(e.$0n),e.$_n="__web_extension",e.$ao="skipWalkthrough",e.$bo="extensionsSync",e.$co="dependecyOrPackExtensionInstall";function s(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$do=s;function M(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$eo=M;function D(g,h){switch(g){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$fo=D;function S(g,h){return h==="web"&&!g.includes("web")}e.$go=S;function d(g,h,a){return S(h,a)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===a}e.$ho=d;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.$io=u;var p;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var v;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var b;(function(g){g.Install="install",g.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var l;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$jo=(0,R.$1h)("extensionGalleryService");var y;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var m;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class $ extends Error{constructor(h,a){super(h),this.code=a,this.name=a}}e.$ko=$,e.$lo=(0,R.$1h)("extensionManagementService"),e.$mo="extensionsIdentifiers/disabled",e.$no="extensionsIdentifiers/enabled",e.$oo=(0,R.$1h)("IGlobalExtensionEnablementService"),e.$po=(0,R.$1h)("IExtensionTipsService"),e.$qo=(0,P.localize)(0,null),e.$ro={value:e.$qo,original:"Extensions"},e.$so={value:(0,P.localize)(1,null),original:"Preferences"}}),define(re[209],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=e.$L9b=void 0,e.$L9b=(0,P.$1h)("extensionHostStarter"),e.$M9b="extensionHostStarter"}),define(re[210],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U1b=e.$T1b=void 0,e.$T1b=(0,P.$1h)("externalTerminal"),e.$U1b="Terminal.app"}),define(re[211],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0,e.$O9b=(0,P.$1h)("externalTerminal")}),define(re[212],oe([0,1,48,13,9,4,76,21,89,174,210]),function(J,e,P,R,s,M,D,S,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=e.$P9b=void 0;const v=u.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends b{static{this.b="cmd.exe"}openTerminal(E,f){return this.spawnTerminal(P,E,d.$Nl(),f)}spawnTerminal(E,f,i,o){const r=f.windowsExec||l.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$nc(r,".exe").toLowerCase();if(t==="cmder")return E.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((c,w)=>{const A=$(process),I=E.spawn(i,n,{cwd:o,env:A});I.on("error",w),I.on("exit",()=>c())})}runInTerminal(E,f,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:l.getDefaultTerminalWindows();return new Promise((n,c)=>{const w=`"${f} - ${v}"`,A=`""${i.join('" "')}" & pause"`,I=Object.assign({},$(process),o);Object.keys(I).filter(N=>I[N]===null).forEach(N=>delete I[N]);const k={cwd:f,env:I,windowsVerbatimArguments:!0};let C,j;s.$nc(t,".exe")==="wt"?(C=t,j=["-d",".",l.b,"/c",A]):(C=l.b,j=["/c","start",w,"/wait",t,"/c",A]),P.spawn(C,j,k).on("error",N=>{c(g(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!l.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return l.d}}e.$P9b=l;class y extends b{static{this.b="/usr/bin/osascript"}openTerminal(E,f){return this.spawnTerminal(P,E,f)}runInTerminal(E,f,i,o,r){const t=r.osxExec||p.$U1b;return new Promise((n,c)=>{if(t===p.$U1b||t==="iTerm.app"){const w=t===p.$U1b?"TerminalHelper":"iTermHelper",I=[R.$jg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",E||v,"-w",f];for(const j of i)I.push("-a"),I.push(j);if(o){const j=Object.assign({},$(process),o);for(const F in j){const N=j[F];N===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${N}`))}}let k="";const C=P.spawn(y.b,I);C.on("error",j=>{c(g(j))}),C.stderr.on("data",j=>{k+=j.toString()}),C.on("exit",j=>{if(j===0)n(void 0);else if(k){const F=k.split(`
`,1);c(new Error(F[0]))}else c(new Error(u.localize(1,null,w,j)))})}else c(new Error(u.localize(2,null,t)))})}spawnTerminal(E,f,i){const o=f.osxExec||p.$U1b;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const c=$(process),w=E.spawn("/usr/bin/open",n,{cwd:i,env:c});w.on("error",t),w.on("exit",()=>r())})}}e.$Q9b=y;class m extends b{static{this.b=u.localize(3,null)}openTerminal(E,f){return this.spawnTerminal(P,E,f)}runInTerminal(E,f,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const w=[];t.then(A=>{A.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const I=`${h(i)}; echo; read -p "${m.b}" -n1;`;w.push(`''${I}''`);const k=Object.assign({},$(process),o);Object.keys(k).filter(N=>k[N]===null).forEach(N=>delete k[N]);const C={cwd:f,env:k};let j="";const F=P.spawn(A,w,C);F.on("error",N=>{c(g(N))}),F.stderr.on("data",N=>{j+=N.toString()}),F.on("exit",N=>{if(N===0)n(void 0);else if(j){const Y=j.split(`
`,1);c(new Error(Y[0]))}else c(new Error(u.localize(4,null,A,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");m.d=new Promise(f=>{E?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return m.d}spawnTerminal(E,f,i){const o=f.linuxExec?Promise.resolve(f.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const c=$(process),w=E.spawn(n,[],{cwd:i,env:c});w.on("error",t),w.on("exit",()=>r())})})}}e.$R9b=m;function $(a){const E={...a.env};return(0,D.$Ll)(E),E}function g(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(u.localize(5,null,a.path)):a}function h(a){let E="";for(const f of a)f.indexOf(" ")>=0?E+='"'+f+'"':E+=f,E+=" ";return E}}),define(re[16],oe([0,1,57,9,25,12,7,176,6,4,13,62]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileKind=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileOperationResult=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileChangeType=e.$Ck=e.FileOperation=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileSystemProviderErrorCode=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderCapabilities=e.$mk=e.FilePermission=e.FileType=e.$lk=e.$kk=void 0,e.$kk=(0,d.$1h)("fileService");function b(q){return q.create===!0}e.$lk=b;var l;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function m(q){const te=q;return!!te&&typeof te.onDidChange=="function"}e.$mk=m;var $;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function g(q){return!!(q.capabilities&2)}e.$nk=g;function h(q){return!!(q.capabilities&8)}e.$ok=h;function a(q){return!!(q.capabilities&131072)}e.$pk=a;function E(q){return!!(q.capabilities&4)}e.$qk=E;function f(q){return!!(q.capabilities&16)}e.$rk=f;function i(q){return g(q)?!!(q.capabilities&16384):!1}e.$sk=i;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.$tk=o;function r(q){return!!(q.capabilities&65536)}e.$uk=r;function t(q){return!!(q.capabilities&2048)}e.$vk=t;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(te,he){const G=new c(te.toString(),he);return I(G,he),G}constructor(te,he){super(te),this.code=he}}e.$wk=c;function w(q,te){return c.create(q,te)}e.$xk=w;function A(q){return q||w((0,S.localize)(0,null),n.Unknown)}e.$yk=A;function I(q,te){return q.name=te?`${te} (FileSystemError)`:"FileSystemError",q}e.$zk=I;function k(q){if(!q)return n.Unknown;if(q instanceof c)return q.code;const te=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Ak=k;function C(q){if(q instanceof le)return q.fileOperationResult;switch(k(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Bk=C;var j;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class F{constructor(te,he,G){this.resource=te,this.operation=he,this.target=G}isOperation(te){return this.operation===te}}e.$Ck=F;var N;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class Y{static{this.a=null}constructor(te,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const G=P.$7h.forUris(()=>this.c);return G.fill(this.rawAdded.map(O=>[O,!0])),G}),this.f=new v.$V(()=>{const G=P.$7h.forUris(()=>this.c);return G.fill(this.rawUpdated.map(O=>[O,!0])),G}),this.g=new v.$V(()=>{const G=P.$7h.forUris(()=>this.c);return G.fill(this.rawDeleted.map(O=>[O,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of te){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==Y.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(te,...he){return this.h(te,{includeChildren:!1},...he)}affects(te,...he){return this.h(te,{includeChildren:!0},...he)}h(te,he,...G){if(!te)return!1;const O=G.length>0;return!!((!O||G.includes(1))&&(this.d.value.get(te)||he.includeChildren&&this.d.value.findSuperstr(te))||(!O||G.includes(0))&&(this.f.value.get(te)||he.includeChildren&&this.f.value.findSuperstr(te))||(!O||G.includes(2))&&(this.g.value.findSubstr(te)||he.includeChildren&&this.g.value.findSuperstr(te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(te){return this.b===te}hasCorrelation(){return typeof this.b=="number"}}e.$Dk=Y;function Q(q,te,he){return!q||!te||q===te||te.length>q.length?!1:(te.charAt(te.length-1)!==R.sep&&(te+=R.sep),he?(0,s.$8e)(q,te):q.indexOf(te)===0)}e.$Ek=Q;class le extends Error{constructor(te,he,G){super(te),this.fileOperationResult=he,this.options=G}}e.$Fk=le;class ce extends le{constructor(te,he,G,O){super(te,he,O),this.fileOperationResult=he,this.size=G}}e.$Gk=ce;class ue extends le{constructor(te,he,G){super(te,2,G),this.stat=he}}e.$Hk=ue;var K;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$Ik={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Jk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Kk="files.associations",e.$Lk="files.exclude",e.$Mk="files.readonlyInclude",e.$Nk="files.readonlyExclude",e.$Ok="files.readonlyFromPermissions";var X;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Pk="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Qk=H;async function L(q,te){if(!te.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(he=>{const G=te.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(G.dispose(),he())})})}e.$Rk=L;class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(te){return(0,M.$Hf)(te)||(te=0),te<T.KB?(0,S.localize)(1,null,te.toFixed(0)):te<T.MB?(0,S.localize)(2,null,(te/T.KB).toFixed(2)):te<T.GB?(0,S.localize)(3,null,(te/T.MB).toFixed(2)):te<T.TB?(0,S.localize)(4,null,(te/T.GB).toFixed(2)):(0,S.localize)(5,null,(te/T.TB).toFixed(2))}}e.$Sk=T;function V(q){const te=typeof q=="string"||q?.scheme===p.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===p.Schemas.file?1024*T.MB:te?10*T.MB:u.$o?50*T.MB:1024*T.MB}e.$Tk=V}),define(re[118],oe([0,1,18,14,177,16]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;async function D(p,v,b,l,y,m){let $;try{await S(p,v,b,l,y,m)}catch(g){$=g}finally{$&&y.errorTransformer&&($=y.errorTransformer($)),typeof $<"u"&&b.error($),b.end()}}e.$Yp=D;async function S(p,v,b,l,y,m){d(m);const $=await p.open(v,{create:!1});try{d(m);let g=0,h=0,a=y&&typeof y.length=="number"?y.length:void 0,E=P.$ge.alloc(Math.min(y.bufferSize,typeof a=="number"?a:y.bufferSize)),f=y&&typeof y.position=="number"?y.position:0,i=0;do h=await p.read($,f,E.buffer,i,E.byteLength-i),f+=h,i+=h,g+=h,typeof a=="number"&&(a-=h),i===E.byteLength&&(await b.write(l(E)),E=P.$ge.alloc(Math.min(y.bufferSize,typeof a=="number"?a:y.bufferSize)),i=0);while(h>0&&(typeof a!="number"||a>0)&&d(m)&&u(g,y));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),b.write(l(E.slice(0,o)))}}catch(g){throw(0,M.$yk)(g)}finally{await p.close($)}}function d(p){if(p.isCancellationRequested)throw(0,R.$6)();return!0}function u(p,v){if(typeof v?.limits?.size=="number"&&p>v.limits.size)throw(0,M.$xk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[67],oe([0,1,104,2,9,4,7,16]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=void 0;function d(g){return g.recursive===!0}e.$1p=d;class u extends R.$Sc{static{this.a=5}constructor(h,a,E,f){super(),this.h=h,this.j=a,this.m=E,this.n=f,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const h=new R.$Rc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(a=>this.h(a))),h.add(this.b.onDidLogMessage(a=>this.j(a))),h.add(this.b.onDidError(a=>this.t(a)))}t(h){this.n.restartOnError?this.g<u.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$2p=u;class p extends u{constructor(h,a,E){super(h,a,E,{type:"node.js",restartOnError:!1})}}e.$3p=p;class v extends u{constructor(h,a,E){super(h,a,E,{type:"universal",restartOnError:!0})}}e.$4p=v;function b(g){return g.map(h=>({type:h.type,resource:D.URI.revive(h.resource),cId:h.cId}))}e.$5p=b;function l(g){const h=new $;for(const a of g)h.processEvent(a);return h.coalesce()}e.$6p=l;function y(g,h){return typeof h=="string"&&!h.startsWith(P.$Dj)&&!(0,s.$ic)(h)?{base:g,pattern:h}:h}e.$7p=y;function m(g,h){const a=[];for(const E of h)a.push((0,P.$Hj)(y(g,E)));return a}e.$8p=m;class ${constructor(){this.a=new Set,this.b=new Map}c(h){return M.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const a=this.b.get(this.c(h));let E=!1;if(a){const f=a.type,i=h.type;a.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?E=!0:f===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(a)):f===2&&i===1?a.type=0:f===1&&i===0||(a.type=i)}else E=!0;E&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],a=[];return Array.from(this.a).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,f)=>E.resource.fsPath.length-f.resource.fsPath.length).filter(E=>a.some(f=>(0,S.$Ek)(E.resource.fsPath,f,!M.$k))?!1:(a.push(E.resource.fsPath),!0)).concat(h)}}}),define(re[213],oe([0,1,18,50,14,3,2,63,32,16,67]),function(J,e,P,R,s,M,D,S,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0,e.$TN="localFilesystem";class v extends D.$Sc{constructor(l,y){super(),this.a=l,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Sd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Sd),this.onDidWatchError=this.g.event,this.h=(0,d.$lg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,y){const{buffer:m}=await this.a.call("readFile",[l,y]);return m}readFileStream(l,y,m){const $=(0,S.$7d)(h=>P.$ge.concat(h.map(a=>P.$ge.wrap(a))).buffer),g=new D.$Rc;return g.add(this.a.listen("readFileStream",[l,y])(h=>{if(h instanceof P.$ge)$.write(h.buffer);else{if(h==="end")$.end();else{let a;if(h instanceof Error)a=h;else{const E=h;a=(0,u.$xk)(E.message??(0,R.$Li)(E),E.code??u.FileSystemProviderErrorCode.Unknown)}$.error(a),$.end()}g.dispose()}})),g.add(m.onCancellationRequested(()=>{$.error((0,s.$6)()),$.end(),g.dispose()})),$}writeFile(l,y,m){return this.a.call("writeFile",[l,P.$ge.wrap(y),m])}open(l,y){return this.a.call("open",[l,y])}close(l){return this.a.call("close",[l])}async read(l,y,m,$,g){const[h,a]=await this.a.call("read",[l,y,g]);return m.set(h.buffer.slice(0,a),$),a}write(l,y,m,$,g){return this.a.call("write",[l,y,P.$ge.wrap(m),$,g])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,y){return this.a.call("delete",[l,y])}rename(l,y,m){return this.a.call("rename",[l,y,m])}copy(l,y,m){return this.a.call("copy",[l,y,m])}cloneFile(l,y){return this.a.call("cloneFile",[l,y])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const y=l;this.f.fire((0,p.$5p)(y))}else{const y=l;this.g.fire(y)}}))}watch(l,y){const m=(0,d.$lg)();return this.a.call("watch",[this.h,m,l,y]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$UN=v}),define(re[214],oe([0,1,46,8,22,33,2,85,9,4,19,7,105,21,67]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;class m extends D.$Sc{static{this.a=100}static{this.b=75}constructor(h,a,E,f){super(),this.m=h,this.n=a,this.r=E,this.s=f,this.c=this.B(new R.$dh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new R.$ch(i=>this.z(i),m.b)),this.g=(0,y.$8p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$8p)(this.m.path,this.m.includes):void 0,this.j=new s.$3d,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const a=await l.Promises.stat(h);this.B(await this.w(h,a.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let a=h.path;try{a=await l.Promises.realpath(h.path),h.path===a&&(a=await(0,b.$fq)(h.path)??h.path),h.path!==a&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${a})`)}catch{}return a}async w(h,a){if(u.$j&&(0,M.$3f)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const E=new s.$3d(this.j.token),f=new D.$Rc;try{const i=v.URI.file(this.m.path),o=(0,d.$nc)(h),r=(0,P.watch)(h);f.add((0,D.$Qc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${h}'`);const t=new Set;if(a)try{for(const c of await l.Promises.readdir(h))t.add(c)}catch(c){this.D(c)}const n=new Map;f.add((0,D.$Qc)(()=>{for(const[,c]of n)c.dispose();n.clear()})),r.on("error",(c,w)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${c}, ${w})`),this.dispose()}),r.on("change",(c,w)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${w}`);let A="";if(w&&(A=w.toString(),u.$j&&(A=(0,S.$Al)(A))),!(!A||c!=="change"&&c!=="rename"))if(a)if(c==="rename"){n.get(A)?.dispose();const I=setTimeout(async()=>{if(n.delete(A),A===o&&!await l.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,d.$jc)(h,A));if(E.token.isCancellationRequested)return;let C;k?t.has(A)?C=0:(C=1,t.add(A)):(t.delete(A),C=2),this.y({resource:(0,p.$Cg)(i,A),type:C,cId:this.m.correlationId})},m.a);n.set(A,(0,D.$Qc)(()=>clearTimeout(I)))}else{let I;t.has(A)?I=0:(I=1,t.add(A)),this.y({resource:(0,p.$Cg)(i,A),type:I,cId:this.m.correlationId})}else if(c==="rename"||A!==o){const I=setTimeout(async()=>{const k=await l.Promises.exists(h);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),f.add(await this.w(h,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);f.clear(),f.add((0,D.$Qc)(()=>clearTimeout(I)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await l.Promises.exists(h)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${i.toString()})`)}return(0,D.$Qc)(()=>{E.dispose(!0),f.dispose()})}y(h,a=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!a&&this.g.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!a&&this.h&&this.h.length>0&&!this.h.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const a=(0,y.$6p)(h);if(a.length>0){if(this.s)for(const f of a)this.G(` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`);this.c.work(a)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(u.$k)return l.Promises.exists(h);try{const a=(0,d.$nc)(h);return(await l.Promises.readdir((0,d.$mc)(h))).some(f=>f===a)}catch(a){return this.G(a),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$iq=m;async function $(g,h,a,E,f=512){const i=await l.Promises.open(g,"r"),o=Buffer.allocUnsafe(f),r=new s.$3d(E);let t,n=!1;const c={path:g,excludes:[],recursive:!1},w=new m(c,A=>{(async()=>{for(const{type:I}of A)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await l.Promises.read(i,o,0,f,null);if(!k||r.token.isCancellationRequested)break;h(o.slice(0,k))}}catch(k){t=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await w.ready,a(),new Promise((A,I)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await l.Promises.close(i)}catch(k){t=new Error(k)}t?I(t):A()})})}e.$jq=$}),define(re[215],oe([0,1,3,104,2,4,214]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class S extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new P.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(u){const p=this.j(u),v=p.filter(l=>{const y=this.c.get(l.path);return y?!(0,R.$Lj)(y.request.excludes,l.excludes)||!(0,R.$Lj)(y.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!p.find(y=>y.path===l.path&&(0,R.$Lj)(y.excludes,l.excludes)&&(0,R.$Lj)(y.includes,l.includes))).map(({request:l})=>l.path);v.length&&this.m(`Request to start watching: ${v.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of v)this.g(l)}g(u){const p=new D.$iq(u,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:u,instance:p};this.c.set(u.path,v)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const p=this.c.get(u);p&&(this.c.delete(u),p.instance.dispose())}j(u){const p=new Map;for(const v of u){const b=M.$k?v.path:v.path.toLowerCase();let l=p.get(v.correlationId);l||(l=new Map,p.set(v.correlationId,l)),l.set(b,v)}return Array.from(p.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(u){this.f=u;for(const[,p]of this.c)p.instance.setVerboseLogging(u)}m(u){this.f&&this.b.fire({type:"trace",message:this.n(u)})}n(u,p){return p?`[File Watcher (node.js)] ${u} (path: ${p.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$kq=S}),define(re[216],oe([0,1,67,215]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class s extends P.$3p{constructor(D,S,d){super(D,S,d),this.s()}r(D){return D.add(new R.$kq)}}e.$lq=s}),define(re[217],oe([0,1,13,42,160,67]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class D extends M.$4p{constructor(d,u,p){super(d,u,p),this.s()}r(d){const u=d.add(new s.$cq(P.$jg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(u.onDidProcessExit(({code:p,signal:v})=>this.t(`terminated by itself with code ${p}, signal: ${v}`))),R.ProxyChannel.toService((0,R.$Hh)(u.getChannel("watcher")))}}e.$dq=D}),define(re[92],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Yh=P}),define(re[218],oe([0,1,8,14,2,78,208,6,92,101]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;const p=!1;class v extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class b{constructor($=new d.$Yh,g=!1,h,a=p){this.f=$,this.g=g,this.h=h,this.i=a,this.o=new Set,this.f.set(S.$Zh,this),this._globalGraph=a?h?._globalGraph??new D.$oq(E=>E):void 0}createChild($){return new b($,this.g,this,this.i)}invokeFunction($,...g){const h=y.traceInvocation(this.i,$);let a=!1;try{return $({get:f=>{if(a)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(f,h);if(!i)throw new Error(`[invokeFunction] unknown service '${f}'`);return i}},...g)}finally{a=!0,h.stop()}}createInstance($,...g){let h,a;return $ instanceof M.$Xh?(h=y.traceCreation(this.i,$.ctor),a=this.j($.ctor,$.staticArguments.concat(g),h)):(h=y.traceCreation(this.i,$),a=this.j($,g,h)),h.stop(),a}j($,g=[],h){const a=S._util.getServiceDependencies($).sort((i,o)=>i.index-o.index),E=[];for(const i of a){const o=this.m(i.id,h);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const f=a.length>0?a[0].index:g.length;if(g.length!==f){console.trace(`[createInstance] First service dependency of ${$.name} at position ${f+1} conflicts with ${g.length} static arguments`);const i=f-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,f)}return Reflect.construct($,g.concat(E))}k($,g){if(this.f.get($)instanceof M.$Xh)this.f.set($,g);else if(this.h)this.h.k($,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const g=this.f.get($);return!g&&this.h?this.h.l($):g}m($,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof M.$Xh?this.q($,h,g.branch($,!0)):(g.branch($,!1),h)}q($,g,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,g,h)}finally{this.o.delete($)}}r($,g,h){const a=new D.$oq(i=>i.id.toString());let E=0;const f=[{id:$,desc:g,_trace:h}];for(;f.length;){const i=f.pop();if(a.lookupOrInsertNode(i),E++>1e3)throw new v(a);for(const o of S._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof M.$Xh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};a.insertEdge(i,t),f.push(t)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new v(a);break}for(const{data:o}of i){if(this.l(o.id)instanceof M.$Xh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}a.removeNode(o)}}return this.l($)}s($,g,h=[],a,E){if(this.f.get($)instanceof M.$Xh)return this.t($,g,h,a,E);if(this.h)return this.h.s($,g,h,a,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t($,g,h=[],a,E){if(a){const f=new b(void 0,this.g,this,this.i);f.c=String($);const i=new Map,o=new P.$hh(()=>{const r=f.j(g,h,E);for(const[t,n]of i){const c=r[t];if(typeof c=="function")for(const w of n)c.apply(r,w)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let w=i.get(t);return w||(w=new u.$3c,i.set(t,w)),(I,k,C)=>{const j=w.push([I,k,C]);return(0,s.$Qc)(j)}}if(t in r)return r[t];const n=o.value;let c=n[t];return typeof c!="function"||(c=c.bind(n),r[t]=c),c},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,h,E)}u($,g){if(g&&console.warn($),this.g)throw new Error($)}}e.$pq=b;var l;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(l||(l={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,g){return $?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation($,g){return $?new y(1,g.name):y.c}static{this.f=0}constructor($,g){this.type=$,this.name=g,this.g=Date.now(),this.h=[]}branch($,g){const h=new y(3,$.toString());return this.h.push([$,g,h]),h}stop(){const $=Date.now()-this.g;y.f+=$;let g=!1;function h(E,f){const i=[],o=new Array(E+1).join("	");for(const[r,t,n]of f.h)if(t&&n){g=!0,i.push(`${o}CREATES -> ${r}`);const c=h(E+1,n);c&&i.push(c)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];($>2||g)&&y.all.add(a.join(`
`))}}e.$qq=y}),define(re[219],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5yb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$5yb=(0,P.$1h)("issueService")}),define(re[5],oe([0,1,50,3,45,2,31,4,19,12,7,114,6]),function(J,e,P,R,s,M,D,S,d,u,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,b.$1h)("logService"),e.$jj=(0,b.$1h)("loggerService");function l(){return new Date().toISOString()}function y(I){return(0,u.$Hf)(I)}e.$kj=y;var m;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$lj=m.Info;function $(I,k,C){switch(k){case m.Trace:I.trace(C);break;case m.Debug:I.debug(C);break;case m.Info:I.info(C);break;case m.Warning:I.warn(C);break;case m.Error:I.error(C);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=$;function g(I,k=!1){let C="";for(let j=0;j<I.length;j++){let F=I[j];if(F instanceof Error&&(F=(0,P.$Li)(F,k)),typeof F=="object")try{F=JSON.stringify(F)}catch{}C+=(j>0?" ":"")+F}return C}class h extends M.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new R.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$nj=h;class a extends h{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...C){this.f(m.Trace)&&this.g(m.Trace,g([k,...C],!0))}debug(k,...C){this.f(m.Debug)&&this.g(m.Debug,g([k,...C]))}info(k,...C){this.f(m.Info)&&this.g(m.Info,g([k,...C]))}warn(k,...C){this.f(m.Warning)&&this.g(m.Warning,g([k,...C]))}error(k,...C){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,g(j))}else this.g(m.Error,g([k,...C]))}flush(){}}e.$oj=a;class E extends h{constructor(k=e.$lj){super(),this.setLevel(k),this.g=!S.$i}trace(k,...C){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}debug(k,...C){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}info(k,...C){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,k,...C):console.log(`[main ${l()}]`,k,...C))}warn(k,...C){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,k,...C):console.warn(`[main ${l()}]`,k,...C))}error(k,...C){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,k,...C):console.error(`[main ${l()}]`,k,...C))}dispose(){}flush(){}}e.$pj=E;class f extends h{constructor(k=e.$lj,C=!0){super(),this.g=C,this.setLevel(k)}trace(k,...C){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...C):console.log(k,...C))}debug(k,...C){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...C):console.log(k,...C))}info(k,...C){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...C):console.log(k,...C))}warn(k,...C){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...C):console.log(k,...C))}error(k,...C){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...C):console.error(k,...C))}dispose(){}flush(){}}e.$qj=f;class i extends h{constructor(k,C=e.$lj){super(),this.g=k,this.setLevel(C)}trace(k,...C){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...C])}debug(k,...C){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...C])}info(k,...C){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...C])}warn(k,...C){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...C])}error(k,...C){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...C])}h(k){return typeof k=="string"?k:(0,P.$Li)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$rj=i;class o extends h{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const C of this.g)C.setLevel(k);super.setLevel(k)}trace(k,...C){for(const j of this.g)j.trace(k,...C)}debug(k,...C){for(const j of this.g)j.debug(k,...C)}info(k,...C){for(const j of this.g)j.info(k,...C)}warn(k,...C){for(const j of this.g)j.warn(k,...C)}error(k,...C){for(const j of this.g)j.error(k,...C)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$sj=o;class r extends M.$Sc{constructor(k,C,j){if(super(),this.h=k,this.j=C,this.b=new D.$Ac,this.c=this.B(new R.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Sd),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(k){return(0,u.$Df)(k)?[...this.b.values()].find(C=>C.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,C){const j=this.n(k),F=(0,u.$Df)(k)?k:C?.id??(0,s.$Oi)(j.toString()).toString(16);let N=this.b.get(j)?.logger;const Y=C?.logLevel==="always"?m.Trace:C?.logLevel;N||(N=this.s(j,Y??this.getLogLevel(j)??this.h,{...C,id:F}));const Q={logger:N,info:{resource:j,id:F,logLevel:Y,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(Q.info),this.b.set(j,Q),N}n(k){return(0,u.$Df)(k)?(0,d.$Cg)(this.j,`${k}.log`):k}setLogLevel(k,C){if(p.URI.isUri(k)){const j=k,F=C,N=this.b.get(j);N&&F!==N.info.logLevel&&(N.info.logLevel=F===this.h?void 0:F,N.logger?.setLevel(F),this.b.set(N.info.resource,N),this.f.fire([j,F]))}else{this.h=k;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,C){const j=this.m(k);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(k){let C;return k&&(C=this.b.get(k)?.info.logLevel),C??this.h}registerLogger(k){const C=this.b.get(k.resource);C?C.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const C=this.b.get(k);C&&(C.logger&&C.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=r;class t{constructor(){this.onDidChangeLogLevel=new R.$Sd().event}setLevel(k){}getLevel(){return m.Info}trace(k,...C){}debug(k,...C){}info(k,...C){}warn(k,...C){}error(k,...C){}critical(k,...C){}dispose(){}flush(){}}e.$uj=t;class n extends t{}e.$vj=n;function c(I){if(I.verbose)return m.Trace;if(typeof I.logLevel=="string"){const k=A(I.logLevel.toLowerCase());if(k!==void 0)return k}return e.$lj}e.$wj=c;function w(I){switch(I){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$xj=w;function A(I){switch(I){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$yj=A,e.$zj=new v.$fj("logLevel",w(m.Info))});var ie=this&&this.__param||function(J,e){return function(P,R){e(P,R,J)}};define(re[220],oe([0,1,15,4,5]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;const M=P.safeStorage;let D=class{constructor(d){this.a=d,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(d){let u;try{if(u=JSON.parse(d),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const p=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=M.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$K9b=D,e.$K9b=D=Ee([ie(0,s.$ij)],D)}),define(re[221],oe([0,1,23,8,14,3,2,9,67,5]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class p extends D.$Sc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new M.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Yg(0)),this.w=[],this.y=this.B(new R.$Yg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const y={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},m=(0,P.$Ub)(this.j,y);return this.r(),(0,D.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,s.$1)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,d.$5p)(l)),l=>this.G(l),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,d.$1p)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,d.$1p)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const y={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},m=(0,P.$Ub)(this.w,y);return this.C(),(0,D.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,s.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,d.$5p)(b)),b=>this.G(b),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,S.$hc)(b.fsPath)}}e.$9p=p}),define(re[222],oe([0,1,23,8,18,22,3,45,72,2,57,13,68,19,63,175,16,118,5,14]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;let f=class extends u.$Sc{static{E=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Sd),this.Y=this.B(new D.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$0g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const t=new u.$Rc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const c=new $.$Dk(n,!this.S(r));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,u.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,u.$Nc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,l.$Gg)(o))throw new $.$Fk((0,m.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new a.$bb;throw t.message=(0,m.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,$.$qk)(r)||(0,$.$nk)(r)||(0,$.$rk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,$.$qk)(r)||(0,$.$nk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,$.$Ak)(t)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Fk((0,m.localize)(2,null,this.sb(o)),1):(0,$.$yk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),c=r?.resolveTo,w=r?.resolveSingleChildDescendants,A=r?.resolveMetadata,I=await t.stat(o);let k;return this.t(t,o,I,void 0,!!A,(C,j)=>(k||(k=p.$7h.forUris(()=>!n),k.set(o,!0),c&&k.fill(!0,c)),k.get(C.resource)||k.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&w?j===1:!1))}async t(o,r,t,n,c,w){const{providerExtUri:A}=this.R(o),I={resource:r,name:A.basename(r),isFile:(t.type&$.FileType.File)!==0,isDirectory:(t.type&$.FileType.Directory)!==0,isSymbolicLink:(t.type&$.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Qk)({mtime:t.mtime,size:t.size}),children:void 0};if(I.isDirectory&&w(I,n)){try{const k=await o.readdir(r),C=await R.Promises.settled(k.map(async([j,F])=>{try{const N=A.joinPath(r,j),Y=c?await o.stat(N):{type:F};return await this.t(o,N,Y,k.length,c,w)}catch(N){return this.b.trace(N),null}}));I.children=(0,P.$Hb)(C)}catch(k){this.b.trace(k),I.children=[]}return I}return I}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new $.$Fk((0,m.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ge.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new $.$Ck(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(n);let w=t;if((0,$.$tk)(n)&&!w?.atomic){const A=n.enforceAtomicWriteFile?.(o);A&&(w={...t,atomic:A})}try{await this.w(n,o,w)||await this.U(n,c.dirname(o));let I;if((0,$.$nk)(n)&&!(r instanceof s.$ge))if((0,y.$5d)(r)){const k=await(0,y.$_d)(r,3);k.ended?I=s.$ge.concat(k.buffer):I=k}else I=(0,y.$9d)(r,k=>s.$ge.concat(k),3);else I=r;!(0,$.$qk)(n)||(0,$.$nk)(n)&&I instanceof s.$ge||(0,$.$nk)(n)&&(0,$.$tk)(n)&&w?.atomic?await this.hb(n,o,w,I):await this.db(n,o,w,I instanceof s.$ge?(0,s.$re)(I):I),this.r.fire(new $.$Ck(o,4))}catch(A){throw new $.$Fk((0,m.localize)(4,null,this.sb(o),(0,$.$yk)(A).toString()),(0,$.$Bk)(A),w)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let w;try{w=await o.stat(r)}catch{return}if(w.type&$.FileType.Directory)throw new $.$Fk((0,m.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,w),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==$.$Pk&&typeof w.mtime=="number"&&typeof w.size=="number"&&t.mtime<w.mtime&&t.etag!==(0,$.$Qk)({mtime:t.mtime,size:w.size}))throw new $.$Fk((0,m.localize)(10,null),3,t);return w}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((c,w)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const A=await this.C(o,r,t,n);c(A)}catch(A){w(A)}})})}async C(o,r,t,n){const c=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...c,value:await(0,s.$se)(c.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const c=new M.$3d(n);let w=t;(0,$.$sk)(o)&&o.enforceAtomicReadFile?.(r)&&(w={...t,atomic:!0});const A=this.J(r,w).then(k=>k,k=>{throw c.dispose(!0),k});let I;try{return typeof w?.etag=="string"&&w.etag!==$.$Pk&&await A,w?.atomic&&(0,$.$sk)(o)||!((0,$.$qk)(o)||(0,$.$rk)(o))||(0,$.$nk)(o)&&w?.preferUnbuffered?I=this.I(o,r,w):(0,$.$rk)(o)?I=this.G(o,r,c.token,w):I=this.H(o,r,c.token,w),I.on("end",()=>c.dispose()),I.on("error",()=>c.dispose()),{...await A,value:I}}catch(k){throw I&&await(0,y.$0d)(I),this.F(k,r,w)}}F(o,r,t){const n=(0,m.localize)(11,null,this.sb(r),(0,$.$yk)(o).toString());return o instanceof $.$Hk?new $.$Hk(n,o.stat,t):o instanceof $.$Gk?new $.$Gk(n,o.fileOperationResult,o.size,o.options):new $.$Fk(n,(0,$.$Bk)(o),t)}G(o,r,t,n=Object.create(null)){const c=o.readFileStream(r,n,t);return(0,y.$de)(c,{data:w=>w instanceof s.$ge?w:s.$ge.wrap(w),error:w=>this.F(w,r,n)},w=>s.$ge.concat(w))}H(o,r,t,n=Object.create(null)){const c=(0,s.$we)();return(0,g.$Yp)(o,r,c,w=>w,{...n,bufferSize:this.a,errorTransformer:w=>this.F(w,r,n)},t),c}I(o,r,t){const n=(0,y.$7d)(c=>s.$ge.concat(c));return(async()=>{try{let c;t?.atomic&&(0,$.$sk)(o)?c=await o.readFile(r,{atomic:!0}):c=await o.readFile(r),typeof t?.position=="number"&&(c=c.slice(t.position)),typeof t?.length=="number"&&(c=c.slice(0,t.length)),this.L(r,c.byteLength,t),n.end(s.$ge.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new $.$Fk((0,m.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==$.$Pk&&r.etag===t.etag)throw new $.$Hk((0,m.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new $.$Gk((0,m.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const c=t==="move"?this.qb(await this.n(o),o):await this.m(o),w=this.qb(await this.n(r),r);await this.Q(c,o,w,r,t,n)}catch(c){return c}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),c=this.qb(await this.n(r),r),w=await this.N(n,o,c,r,"move",!!t),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Ck(o,w==="move"?2:3,A)),A}async copy(o,r,t){const n=await this.m(o),c=this.qb(await this.n(r),r),w=await this.N(n,o,c,r,"copy",!!t),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Ck(o,w==="copy"?3:2,A)),A}async N(o,r,t,n,c,w){if(r.toString()===n.toString())return c;const{exists:A,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,t,n,c,w);if(A&&!I&&w&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),c==="copy"){if(o===t&&(0,$.$ok)(o))await o.copy(r,n,{overwrite:w});else{const k=await this.resolve(r);k.isDirectory?await this.P(o,k,t,n):await this.O(o,r,t,n)}return c}else return o===t?(await o.rename(r,n,{overwrite:w}),c):(await this.N(o,r,t,n,"copy",w),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,$.$qk)(o)&&(0,$.$qk)(t))return this.jb(o,r,t,n);if((0,$.$qk)(o)&&(0,$.$nk)(t))return this.pb(o,r,t,n);if((0,$.$nk)(o)&&(0,$.$qk)(t))return this.nb(o,r,t,n);if((0,$.$nk)(o)&&(0,$.$nk)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async c=>{const w=this.R(t).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),t,w):this.O(o,c.resource,t,w)}))}async Q(o,r,t,n,c,w){let A=!1;if(o===t){const{providerExtUri:k,isPathCaseSensitive:C}=this.R(o);if(C||(A=k.isEqual(r,n)),A&&c==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!A&&k.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!A){if(!w)throw new $.$Fk((0,m.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:A}}R(o){const r=this.S(o);return{providerExtUri:r?l.$sg:l.$ug,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Ck(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&$.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(c){if((0,$.$Ak)(c)!==$.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(n.basename(r)),r=n.dirname(r)}for(let c=t.length-1;c>=0;c--){r=n.joinPath(r,t[c]);try{await o.mkdir(r)}catch(w){if((0,$.$Ak)(w)!==$.FileSystemProviderErrorCode.FileExists)throw w}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(o)));const c=r?.atomic;if(c&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(o)));if(n&&c)throw new Error((0,m.localize)(22,null,this.sb(o)));let w;try{w=await t.stat(o)}catch{}if(w)this.rb(o,w);else throw new $.$Fk((0,m.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,$.$uk)(t)&&!n?.atomic){const I=t.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const c=!!n?.useTrash,w=!!n?.recursive,A=n?.atomic??!1;await t.delete(o,{recursive:w,useTrash:c,atomic:A}),this.r.fire(new $.$Ck(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,$.$pk)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const c=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,$.$ok)(t)?c.queue(()=>t.copy(o,r,{overwrite:!0})):c.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new u.$Rc;let n=!1,c=()=>{n=!0};t.add((0,u.$Qc)(()=>c())),(async()=>{try{const A=await this.bb(o,r);n?(0,u.$Nc)(A):c=()=>(0,u.$Nc)(A)}catch(A){this.b.error(A)}})();const w=r.correlationId;if(typeof w=="number"){const A=t.add(new D.$Sd);return t.add(this.X.event(k=>{k.correlates(w)&&A.fire(k)})),{onDidChange:A.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,S.$Oi)([this.R(t).providerExtUri.getComparisonKey(o),r]);let c=this.$.get(n);return c||(c={count:0,disposable:t.watch(o,r)},this.$.set(n,c)),c.count+=1,(0,u.$Qc)(()=>{c&&(c.count--,c.count===0&&((0,u.$Nc)(c.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,u.$Nc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const c=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,y.$5d)(n)||(0,y.$6d)(n)?await this.eb(o,c,n):await this.fb(o,c,n)}catch(w){throw(0,$.$yk)(w)}finally{await o.close(c)}})}async eb(o,r,t){let n=0,c;if((0,y.$6d)(t)){if(t.buffer.length>0){const w=s.$ge.concat(t.buffer);await this.gb(o,r,w,w.byteLength,n,0),n+=w.byteLength}if(t.ended)return;c=t.stream}else c=t;return new Promise((w,A)=>{(0,y.$$d)(c,{onData:async I=>{c.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(k){return A(k)}n+=I.byteLength,setTimeout(()=>c.resume())},onError:I=>A(I),onEnd:()=>w()})})}async fb(o,r,t){let n=0,c;for(;(c=t.read())!==null;)await this.gb(o,r,c,c.byteLength,n,0),n+=c.byteLength}async gb(o,r,t,n,c,w){let A=0;for(;A<n;){const I=await o.write(r,c+A,t.buffer,w+A,n-A);A+=I}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let c;n instanceof s.$ge?c=n:(0,y.$5d)(n)?c=await(0,s.$se)(n):(0,y.$6d)(n)?c=await(0,s.$te)(n):c=(0,s.$qe)(n),await o.writeFile(r,c.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let c,w;try{c=await o.open(r,{create:!1}),w=await t.open(n,{create:!0,unlock:!1});const A=s.$ge.alloc(this.a);let I=0,k=0,C=0;do C=await o.read(c,I,A.buffer,k,A.byteLength-k),await this.gb(t,w,A,C,I,k),I+=C,k+=C,k===A.byteLength&&(k=0);while(C>0)}catch(A){throw(0,$.$yk)(A)}finally{await R.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof w=="number"?t.close(w):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const c=await t.open(n,{create:!0,unlock:!1});try{const w=await o.readFile(r);await this.gb(t,c,s.$ge.wrap(w),w.byteLength,0,0)}catch(w){throw(0,$.$yk)(w)}finally{await t.close(c)}}async pb(o,r,t,n){const c=await(0,s.$se)(this.H(o,r,M.CancellationToken.None));await this.hb(t,n,void 0,c)}qb(o,r){if(o.capabilities&2048)throw new $.$Fk((0,m.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&$.FilePermission.Readonly)throw new $.$Fk((0,m.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$Zp=f,e.$Zp=f=E=Ee([ie(0,h.$ij)],f)}),define(re[93],oe([0,1,46,311,8,31,18,3,33,2,9,4,19,63,21,179,16,118,221,50,217,216]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0,(()=>{try{(0,R.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.$Li)(o)}`)}})();class i extends h.$9p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$Ac(n=>b.$tg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:$.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async c=>{try{let w;c.isSymbolicLink()?w=(await this.stat((0,b.$Cg)(r,c.name))).type:w=this.M(c),n.push([c.name,w])}catch(w){this.a.trace(w)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,t&&(n|=$.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const c=new s.$Zg;return this.N.set(r,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,u.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),c.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const c=this.H(r);return await y.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const c=(0,l.$7d)(w=>D.$ge.concat(w.map(A=>D.$ge.wrap(A))).buffer);return(0,g.$Yp)(this,r,c,w=>w.buffer,{...t,bufferSize:256*1024},n),c}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,b.$Cg)((0,b.$Bg)(r),`${(0,b.$zg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,c){const w=new u.$Rc;try{w.add(await this.O(r)),w.add(await this.O(t)),await this.S(t,n,c,!0);try{await this.rename(t,r,{overwrite:!0})}catch(A){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{w.dispose()}}async S(r,t,n,c){let w;try{const A=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(A)){if(!n.overwrite)throw(0,$.$xk)((0,m.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$xk)((0,m.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:n.unlock},c),await this.write(w,0,t,0,t.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof w=="number"&&await this.close(w)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const c=this.H(r);let w;(0,$.$lk)(t)&&!n&&(w=await this.O(r));let A;try{if((0,$.$lk)(t)&&t.unlock)try{const{stat:k}=await y.SymlinkSupport.stat(c);k.mode&128||await y.Promises.chmod(c,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let I;if((0,$.$lk)(t)){if(v.$i)try{await y.Promises.truncate(c,0),I="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}I||(I="w")}else I="r";A=await y.Promises.open(c,I)}catch(I){throw w?.dispose(),(0,$.$lk)(t)?await this.gb(r,I):this.fb(I)}if(this.U.set(A,0),(0,$.$lk)(t)&&this.X.set(A,r),w){const I=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${c})`),this.W.set(A,w),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${c})`),I.dispose())}return A}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await y.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,c,w){const A=this.Z(r,t);let I=null;try{I=(await y.Promises.read(r,n,c,w,A)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,A,I)}return I}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const c=this.U.get(r);typeof c=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,c+n):this.U.delete(r)))}async write(r,t,n,c,w){return(0,s.$ih)(()=>this.ab(r,t,n,c,w),100,3)}async ab(r,t,n,c,w){const A=this.Z(r,t);let I=null;try{I=(await y.Promises.write(r,n,c,w,A)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,A,I)}return I}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let c;t?.atomic!==!1&&t.atomic.postfix&&(c=(0,p.$jc)((0,p.$mc)(n),`${(0,p.$nc)(n)}${t.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,c)}else try{await y.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let w=!1;try{const{stat:A,symbolicLink:I}=await y.SymlinkSupport.stat(n);w=A.isDirectory()&&!I}catch{}if(w)await y.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.fb(n)}}async rename(r,t,n){const c=this.H(r),w=this.H(t);if(c!==w)try{await this.bb(r,t,"move",n.overwrite),await y.Promises.rename(c,w)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(2,null,(0,p.$nc)(c),(0,p.$nc)((0,p.$mc)(w)),A.toString()))),this.fb(A)}}async copy(r,t,n){const c=this.H(r),w=this.H(t);if(c!==w)try{await this.bb(r,t,"copy",n.overwrite),await y.Promises.copy(c,w,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(3,null,(0,p.$nc)(c),(0,p.$nc)((0,p.$mc)(w)),A.toString()))),this.fb(A)}}async bb(r,t,n,c){const w=this.H(r),A=this.H(t);let I=!1;if(!!(this.capabilities&1024)||(I=(0,d.$2f)(w,A,!0)),I){if(n==="copy")throw(0,$.$xk)((0,m.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,$.$xk)((0,m.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!c)throw(0,$.$xk)((0,m.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);C.type&$.FileType.File&&j.type&$.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const c=this.H(r),w=this.H(t),A=!!(this.capabilities&1024);if((0,d.$2f)(c,w,!A))return;const I=new u.$Rc;try{I.add(await this.O(r)),I.add(await this.O(t)),n&&await y.Promises.mkdir((0,p.$mc)(w),{recursive:!0}),await y.Promises.copyFile(c,w)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(k)}finally{I.dispose()}}t(r,t,n){return new E.$dq(c=>r(c),c=>t(c),n)}F(r,t,n){return new f.$lq(c=>r(c),c=>t(c),n)}fb(r){if(r instanceof $.$wk)return r;let t=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$xk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.H(r));c.mode&128||(n=(0,$.$xk)(t,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$mq=i}),define(re[223],oe([0,1,3,93,2,18,63,22]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0;class d extends s.$Sc{constructor(v,b){super(),this.a=v,this.b=b,this.F=new Map,this.G=new Map}call(v,b,l){const y=this.c(v);switch(b){case"stat":return this.g(y,l[0]);case"readdir":return this.h(y,l[0]);case"open":return this.r(y,l[0],l[1]);case"close":return this.s(l[0]);case"read":return this.t(l[0],l[1],l[2]);case"readFile":return this.j(y,l[0],l[1]);case"write":return this.u(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.n(y,l[0],l[1],l[2]);case"rename":return this.z(y,l[0],l[1],l[2]);case"copy":return this.C(y,l[0],l[1],l[2]);case"cloneFile":return this.D(y,l[0],l[1]);case"mkdir":return this.w(y,l[0]);case"delete":return this.y(y,l[0],l[1]);case"watch":return this.I(y,l[0],l[1],l[2],l[3]);case"unwatch":return this.J(l[0],l[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,l){const y=this.c(v);switch(b){case"fileChange":return this.H(y,l[0]);case"readFileStream":return this.m(y,l[0],l[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const l=this.f(v,b,!0);return this.a.stat(l)}h(v,b){const l=this.f(v,b);return this.a.readdir(l)}async j(v,b,l){const y=this.f(v,b,!0),m=await this.a.readFile(y,l);return M.$ge.wrap(m)}m(v,b,l){const y=this.f(v,b,!0),m=new S.$3d,$=new P.$Sd({onDidRemoveLastListener:()=>{m.cancel()}}),g=this.a.readFileStream(y,l,m.token);return(0,D.$$d)(g,{onData:h=>$.fire(M.$ge.wrap(h)),onError:h=>$.fire(h),onEnd:()=>{$.fire("end"),$.dispose(),m.dispose()}}),$.event}n(v,b,l,y){const m=this.f(v,b);return this.a.writeFile(m,l.buffer,y)}r(v,b,l){const y=this.f(v,b,!0);return this.a.open(y,l)}s(v){return this.a.close(v)}async t(v,b,l){const y=M.$ge.alloc(l),m=0,$=await this.a.read(v,b,y.buffer,m,l);return[y,$]}u(v,b,l,y,m){return this.a.write(v,b,l.buffer,y,m)}w(v,b){const l=this.f(v,b);return this.a.mkdir(l)}y(v,b,l){const y=this.f(v,b);return this.a.delete(y,l)}z(v,b,l,y){const m=this.f(v,b),$=this.f(v,l);return this.a.rename(m,$,y)}C(v,b,l,y){const m=this.f(v,b),$=this.f(v,l);return this.a.copy(m,$,y)}D(v,b,l){const y=this.f(v,b),m=this.f(v,l);return this.a.cloneFile(y,m)}H(v,b){const l=new P.$Sd({onWillAddFirstListener:()=>{this.F.set(b,this.L(v,l))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(b)),this.F.delete(b)}});return l.event}async I(v,b,l,y,m){const $=this.F.get(b);if($){const g=this.f(v,y),h=$.watch(l,g,m);this.G.set(b+l,h)}}async J(v,b){const l=v+b,y=this.G.get(l);y&&((0,s.$Nc)(y),this.G.delete(l))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$Ur=d;class u extends s.$Sc{constructor(v,b,l,y){super(),this.c=v,this.f=l,this.g=y,this.a=new Map,this.b=this.B(new R.$mq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(b)}h(v){const b=this.B(new P.$Sd);this.B(b.event(l=>{v.fire(l.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this.B(this.b.onDidChangeFile(l=>b.fire(l))),this.B(this.b.onDidWatchError(l=>v.fire(l)))}j(v){}m(v){}watch(v,b,l){const y=this.m(this.g);return Array.isArray(y)&&(l.excludes=[...l.excludes,...y]),this.a.set(v,this.b.watch(b,l)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$Vr=u}),define(re[224],oe([0,1,15,178,4,7,16,9,223,155]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=void 0;class p extends d.$Ur{constructor(l,y,m){super(l,y),this.M=m}c(l){return u.$Ym}f(l,y){return M.URI.revive(y)}async y(l,y,m){if(!m.useTrash)return super.y(l,y,m);const $=this.f(l,y),g=(0,S.$hc)($.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,D.$xk)(s.$i?(0,R.localize)(0,null,(0,S.$nc)(g)):(0,R.localize)(1,null,(0,S.$nc)(g)),D.FileSystemProviderErrorCode.Unknown)}}L(l,y){return new v(l,y,this.b,this.M)}}e.$S9b=p;class v extends d.$Vr{watch(l,y,m){if(m.recursive)throw(0,D.$xk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(l,y,m)}}}),define(re[225],oe([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class R extends P.$oj{constructor(M=P.$lj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$G6b=R}),define(re[226],oe([0,1,7,3,5,2]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=void 0;class D extends s.$tj{constructor(v,b,l,y,m){super(b,l,y),this.r=v,this.t=m,this.B(m.listen("onDidChangeLogLevel",v)($=>{(0,s.$kj)($)?super.setLogLevel($):super.setLogLevel(P.URI.revive($[0]),$[1])})),this.B(m.listen("onDidChangeVisibility",v)(([$,g])=>super.setVisibility(P.URI.revive($),g))),this.B(m.listen("onDidChangeLoggers",v)(({added:$,removed:g})=>{for(const h of $)super.registerLogger({...h,resource:P.URI.revive(h.resource)});for(const h of g)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$rj({log:(v,b)=>{this.t.call("consoleLog",[v,b])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,b){super.setLogLevel(v,b),this.t.call("setLogLevel",[v,b])}setVisibility(v,b){super.setVisibility(v,b),this.t.call("setVisibility",[this.n(v),b])}s(v,b,l){return new S(this.t,v,b,l,this.r)}static setLogLevel(v,b,l){return v.call("setLogLevel",[b,l])}}e.$kr=D;class S extends s.$oj{constructor(v,b,l,y,m){super(y?.logLevel==="always"),this.r=v,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,y,m]).then(()=>{this.u(this.n),this.m=!0})}g(v,b){const l=[[v,b]];this.m?this.u(l):this.n.push(...l)}u(v){this.r.call("log",[this.s,v])}}class d{constructor(v,b){this.a=v,this.b=b}listen(v,b){const l=this.b(v);switch(b){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(m=>this.c(m,l)),removed:[...y.removed].map(m=>this.c(m,l))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,y=>[l.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$kj)(y)?y:[l.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${b}`)}async call(v,b,l){const y=this.b(v);switch(b){case"setLogLevel":return(0,s.$kj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,y)))}throw new Error(`Call not found: ${b}`)}c(v,b){return{...v,resource:b.transformOutgoingURI(v.resource)}}}e.$lr=d;class u extends M.$Sc{constructor(v,b){super(),b.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const y of l)v.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,y])=>v.setVisibility(P.URI.revive(l),y))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:y})=>{for(const m of l)v.registerLogger({...m,resource:P.URI.revive(m.resource)});for(const m of y)v.deregisterLogger(m.resource)}))}}e.$mr=u}),define(re[227],oe([0,1,2,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;class s extends P.$Sc{constructor(D,S=[]){super(),this.a=new R.$sj([D,...S]),this.B(D.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$_N=s}),define(re[228],oe([0,1,31,7,5]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=void 0;class M{constructor(S){this.b=S,this.a=new P.$Ac}listen(S,d,u){switch(d){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(S,d,u){switch(d){case"createLogger":this.c(R.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(R.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.$kj)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(R.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:R.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(u[0]))}throw new Error(`Call not found: ${d}`)}c(S,d,u){this.a.set(S,this.b.createLogger(S,d,u))}d(S,d){let u=console.log;switch(S){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...d)}e(S,d){const u=this.a.get(S);if(!u)throw new Error("Create the logger before logging");for(const[p,v]of d)(0,s.log)(u,p,v)}}e.$M0b=M}),define(re[229],oe([0,1,16,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function M(u,p,v,b,l){try{const y=await new Promise(($,g)=>{J(["@vscode/spdlog"],$,g)});y.setFlushOn(s.Trace);const m=await y.createAsyncRotatingLogger(u,p,v,b);return l?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(y){console.error(y)}return null}function D(u,p,v){switch(p){case R.LogLevel.Trace:u.trace(v);break;case R.LogLevel.Debug:u.debug(v);break;case R.LogLevel.Info:u.info(v);break;case R.LogLevel.Warning:u.warn(v);break;case R.LogLevel.Error:u.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function S(u,p){switch(p){case R.LogLevel.Trace:u.setLevel(s.Trace);break;case R.LogLevel.Debug:u.setLevel(s.Debug);break;case R.LogLevel.Info:u.setLevel(s.Info);break;case R.LogLevel.Warning:u.setLevel(s.Warning);break;case R.LogLevel.Error:u.setLevel(s.Error);break;case R.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class d extends R.$oj{constructor(p,v,b,l,y){super(),this.m=[],this.setLevel(y),this.n=this.s(p,v,b,l),this.B(this.onDidChangeLogLevel(m=>{this.r&&S(this.r,m)}))}async s(p,v,b,l){const y=b?6:1,m=30/y*P.$Sk.MB,$=await M(p,v,m,y,l);if($){this.r=$,S(this.r,this.getLevel());for(const{level:g,message:h}of this.m)D(this.r,g,h);this.m=[]}}g(p,v){this.r?D(this.r,p,v):this.getLevel()<=p&&this.m.push({level:p,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$1N=d}),define(re[230],oe([0,1,32,5,229]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class M extends R.$tj{s(S,d,u){return new s.$1N((0,P.$lg)(),S.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,d)}}e.$2N=M}),define(re[69],oe([0,1,31,3,6,5,230]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s9b=e.$r9b=void 0,e.$r9b=(0,s.$2h)(M.$jj);class S extends D.$2N{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(u,p,v){v!==void 0&&this.u.set(this.n(u),v);try{return super.createLogger(u,p)}catch(b){throw this.u.delete(this.n(u)),b}}registerLogger(u,p){p!==void 0&&this.u.set(u.resource,p),super.registerLogger(u)}deregisterLogger(u){this.u.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const p=[];for(const v of super.getRegisteredLoggers())u===this.u.get(v.resource)&&p.push(v);return p}getOnDidChangeLogLevelEvent(u){return R.Event.filter(this.onDidChangeLogLevel,p=>(0,M.$kj)(p)||this.w(p[0],u))}getOnDidChangeVisibilityEvent(u){return R.Event.filter(this.onDidChangeVisibility,([p])=>this.w(p,u))}getOnDidChangeLoggersEvent(u){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(b=>this.w(b.resource,u)),removed:[...p.removed].filter(b=>this.w(b.resource,u))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(u){for(const[p,v]of this.u)v===u&&this.deregisterLogger(p)}w(u,p){const v=this.u.get(u);return v===void 0||v===p}dispose(){super.dispose(),this.u.clear()}}e.$s9b=S}),define(re[231],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=e.$79b=e.$69b=e.$59b=void 0;function P(D){return D.submenu!==void 0}e.$59b=P;function R(D){return D.id==="vscode.menubar.separator"}e.$69b=R;function s(D){return D.uri!==void 0}e.$79b=s;function M(D){return!P(D)&&!R(D)&&!s(D)}e.$89b=M}),define(re[39],oe([0,1,3,72,2,6]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=void 0,e.$un=(0,M.$1h)("policy");class D extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const p=Object.keys(this.f).length;return this.f={...u,...this.f},p!==Object.keys(this.f).length&&await this.j(u),R.Iterable.reduce(this.g.entries(),(v,[b,l])=>({...v,[b]:l}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(u,[p,v])=>({...u,[p]:{definition:v,value:this.g.get(p)}}),{})}}e.$vn=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$wn=S}),define(re[232],oe([0,1,8,3,72,12,16,5,39]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$60b=void 0;function u(v,b){const l=[];for(const y of new Set(s.Iterable.concat(v.keys(),b.keys())))v.get(y)!==b.get(y)&&l.push(y);return l}let p=class extends d.$vn{constructor(b,l,y){super(),this.m=b,this.n=l,this.s=y,this.c=this.B(new P.$Yg(500));const m=R.Event.filter(l.onDidFilesChange,$=>$.affects(b));this.B(l.watch(b)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const b=new Map;try{const l=await this.n.readFile(this.m),y=JSON.parse(l.value.toString());if(!(0,M.$Ff)(y))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(y))this.f[m]&&b.set(m,y[m])}catch(l){l.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",l)}return b}async w(){const b=await this.u(),l=u(this.g,b);this.g=b,l.length>0&&this.h.fire(l)}};e.$60b=p,e.$60b=p=Ee([ie(1,D.$kk),ie(2,S.$ij)],p)}),define(re[233],oe([0,1,3,2,39]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=e.$D0b=void 0;class M{constructor(d){this.b=d,this.a=new R.$Rc}listen(d,u){switch(u){case"onDidChange":return P.Event.map(this.b.onDidChange,p=>p.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(d,u,p){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$D0b=M;class D extends s.$vn{constructor(d,u){super(),this.a=u;for(const p in d){const{definition:v,value:b}=d[p];this.f[p]=v,b!==void 0&&this.g.set(p,b)}this.a.listen("onDidChange")(p=>{for(const v in p){const b=p[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(p))})}async j(d){const u=await this.a.call("updatePolicyDefinitions",d);for(const p in u)this.g.set(p,u[p])}}e.$E0b=D}),define(re[234],oe([0,1,39,8,2,5]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;let D=class extends P.$vn{constructor(d,u){super(),this.m=d,this.n=u,this.a=new R.$Ug,this.b=this.B(new s.$Tc)}async j(d){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`);const{createWatcher:u}=await new Promise((p,v)=>{J(["@vscode/policy-watcher"],p,v)});await this.a.queue(()=>new Promise((p,v)=>{try{this.b.value=u(this.n,d,b=>{this.t(b),p()})}catch(b){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}t(d){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const u in d){const p=d[u];p===void 0?this.g.delete(u):this.g.set(u,p)}this.h.fire(Object.keys(d))}};e.$50b=D,e.$50b=D=Ee([ie(0,M.$ij)],D)}),define(re[79],oe([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(re[27],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,P.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"}),define(re[235],oe([0,1,8,5]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=void 0;let s=class{constructor(D,S,d){this.a=D,this.b=S,this.c=d}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$2g)(D);const d=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$V9b=s,e.$V9b=s=Ee([ie(2,R.$ij)],s)}),define(re[80],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0,e.$h9b=(0,P.$1h)("protocolMainService")}),define(re[43],oe([0,1,137,12]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(R.$Df(D)),P.ok(R.$Ff(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$sn=new s}),define(re[236],oe([0,1,3,43]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0,e.$tn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,u){this.a[s(d)]=u,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;R.$sn.add(e.$tn.JSONContribution,D)}),define(re[58],oe([0,1,23,3,12,163,17,236,43]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.ConfigurationScope=e.$xn=e.EditPresentationTypes=void 0;var u;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$xn={Configuration:"base.contributions.configuration"};var p;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En="vscode://schemas/settings/resourceLanguage",e.$Fn="vscode://schemas/settings/configurationDefaults";const v=d.$sn.as(S.$tn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.$Sd,this.onDidSchemaChange=this.i.event,this.j=new R.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$En,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),v.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),v.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),v.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const c in t)if(o.add(c),e.$Hn.test(c)){const w=this.a.get(c),A=w?.valuesSources??new Map;if(n)for(const j of Object.keys(t[c]))A.set(j,n);const I={...w?.value||{},...t[c]};this.a.set(c,{source:n,value:I,valuesSources:A});const k=(0,D.$Ei)(c),C={type:"object",default:I,description:M.localize(1,null,k),$ref:e.$En,defaultDefaultValue:I,source:s.$Df(n)?void 0:n,defaultValueSource:n};r.push(...m(c)),this.d[c]=C,this.b.properties[c]=C}else{this.a.set(c,{value:t[c],source:n});const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const c=this.a.get(n),w=s.$Df(t)?t:t?.id,A=s.$Df(c?.source)?c?.source:c?.source?.id;if(w===A)if(o.add(n),this.a.delete(n),e.$Hn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,c){n=s.$Mf(i.scope)?n:i.scope;const w=i.properties;if(w)for(const I in w){const k=w[I];if(o&&a(I,k)){delete w[I];continue}if(k.source=r,k.defaultDefaultValue=w[I].default,this.w(I,k),e.$Hn.test(I)?k.scope=void 0:(k.scope=s.$Mf(k.scope)?n:k.scope,k.restricted=s.$Mf(k.restricted)?!!t?.includes(I):k.restricted),w[I].hasOwnProperty("included")&&!w[I].included){this.f[I]=w[I],delete w[I];continue}else this.d[I]=w[I],w[I].policy?.name&&this.e.set(w[I].policy.name,I);!w[I].deprecationMessage&&w[I].markdownDeprecationMessage&&(w[I].deprecationMessage=w[I].markdownDeprecationMessage),c.add(I)}const A=i.allOf;if(A)for(const I of A)this.p(I,o,r,t,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const c in t)this.r(c,t[c]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$yn.properties[i]=o,o.scope){case 1:e.$zn.properties[i]=o;break;case 2:e.$An.properties[i]=o;break;case 6:e.$Bn.properties[i]=o;break;case 3:e.$Cn.properties[i]=o;break;case 4:e.$Dn.properties[i]=o;break;case 5:e.$Dn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$yn.properties[i],o.scope){case 1:delete e.$zn.properties[i];break;case 2:delete e.$An.properties[i];break;case 6:delete e.$Bn.properties[i];break;case 3:delete e.$Cn.properties[i];break;case 4:case 5:delete e.$Dn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$En};this.w(o,r),e.$yn.properties[o]=r,e.$zn.properties[o]=r,e.$An.properties[o]=r,e.$Bn.properties[o]=r,e.$Cn.properties[o]=r,e.$Dn.properties[o]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$En};e.$yn.patternProperties[e.$Gn]=i,e.$zn.patternProperties[e.$Gn]=i,e.$An.patternProperties[e.$Gn]=i,e.$Bn.patternProperties[e.$Gn]=i,e.$Cn.patternProperties[e.$Gn]=i,e.$Dn.patternProperties[e.$Gn]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Kf(t)&&(t=o.defaultDefaultValue,n=void 0),s.$Kf(t)&&(t=g(o.type)),o.default=t,o.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",y=new RegExp(l,"g");e.$Gn=`^(${l})+$`,e.$Hn=new RegExp(e.$Gn);function m(f){const i=[];if(e.$Hn.test(f)){let o=y.exec(f);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=y.exec(f)}}return(0,P.$Mb)(i)}e.$In=m;function $(f){return f.reduce((i,o)=>`${i}[${o}]`,"")}e.$Jn=$;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Kn=g;const h=new b;d.$sn.add(e.$xn.Configuration,h);function a(f,i){return f.trim()?e.$Hn.test(f)?M.localize(7,null,f):h.getConfigurationProperties()[f]!==void 0?M.localize(8,null,f):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,f,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Ln=a;function E(){const f=[],i=h.getConfigurationProperties();for(const o of Object.keys(i))f.push([o,i[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.$Mn=E}),define(re[119],oe([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(J,e,P,R,s,M,D,S,d,u,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0;function l(o){return Object.isFrozen(o)?o:S.$hn(o)}class y{constructor(r={},t=[],n=[],c){this.b=r,this.c=t,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof y)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$Ci)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),c=t?this.rawConfiguration.getOverrideValue(r,t):void 0,w=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:c,merged:w}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,p.$Ci)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return P.$Mb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return P.$Mb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=S.$gn(this.contents),n=S.$gn(this.overrides),c=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const A of r)if(w.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(t,A.contents);for(const I of A.overrides){const[k]=n.filter(C=>P.$ub(C.identifiers,I.identifiers));k?(this.h(k.contents,I.contents),k.keys.push(...I.keys),k.keys=P.$Mb(k.keys)):n.push(S.$gn(I))}for(const I of A.keys)c.indexOf(I)===-1&&c.push(I)}return new y(t,c,n,w.every(A=>A instanceof y)?void 0:w)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const c of P.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let w=this.contents[c];const A=t[c];A&&(typeof w=="object"&&typeof A=="object"?(w=S.$gn(w),this.h(w,A)):w=A),n[c]=w}return new y(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&d.$Ff(r[n])&&d.$Ff(t[n])){this.h(r[n],t[n]);continue}r[n]=S.$gn(t[n])}}i(r){let t=null,n=null;const c=w=>{w&&(n?this.h(n,w):n=S.$gn(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?t=w.contents:w.identifiers.includes(r)&&c(w.contents);return c(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,p.$Bi)(this.contents,r),v.$Hn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,v.$In)(r))),1))}j(r,t,n){(0,p.$Ai)(this.contents,r,t,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$Hn.test(r)&&this.overrides.push({identifiers:(0,v.$In)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$zi)(this.contents[r],c=>console.error(c))})}}e.$Nn=y;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!d.$Mf(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:c,overrides:w,restricted:A,hasExcludedProperties:I}=this.h(r,t);this.b=new y(n,c,w,I?[r]:void 0),this.c=A||[]}g(r){let t={},n=null,c=[];const w=[],A=[];function I(C){Array.isArray(c)?c.push(C):n!==null&&(c[n]=C)}const k={onObjectBegin:()=>{const C={};I(C),w.push(c),c=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{c=w.pop()},onArrayBegin:()=>{const C=[];I(C),w.push(c),c=C,n=null},onArrayEnd:()=>{c=w.pop()},onLiteralValue:I,onError:(C,j,F)=>{A.push({error:C,offset:j,length:F})}};if(r)try{s.$dn(r,k),t=c[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return t}h(r,t){const n=b.$sn.as(v.$xn.Configuration).getConfigurationProperties(),c=this.i(r,n,!0,t);r=c.raw;const w=(0,p.$zi)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),A=Object.keys(r),I=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:w,keys:A,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,t,n,c){let w=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const A={},I=[];for(const k in r)if(v.$Hn.test(k)&&n){const C=this.i(r[k],t,!1,c);A[k]=C.raw,w=w||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=t[k],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(k),!c.exclude?.includes(k)&&(c.include?.includes(k)||(j===void 0||c.scopes===void 0||c.scopes.includes(j))&&!(c.skipRestricted&&C?.restricted))?A[k]=r[k]:w=!0}return{raw:A,restricted:I,hasExcludedProperties:w}}j(r,t){const n=[];for(const c of Object.keys(r))if(v.$Hn.test(c)){const w={};for(const A in r[c])w[A]=r[c][A];n.push({identifiers:(0,v.$In)(c),keys:Object.keys(w),contents:(0,p.$zi)(w,t)})}return n}}e.$On=m;class $ extends M.$Sc{constructor(r,t,n,c){super(),this.c=r,this.f=t,this.g=c,this.b=this.B(new R.$Sd),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&n.isEqual(w.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Pn=$;class g{constructor(r,t,n,c,w,A,I,k,C,j,F,N,Y){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=c,this.d=w,this.f=A,this.g=I,this.h=k,this.i=C,this.j=j,this.k=F,this.l=N,this.m=Y}get value(){return l(this.c)}n(r,t,n){const c=r.inspect(t,n);return{get value(){return l(c.value)},get override(){return l(c.override)},get merged(){return l(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,t,n,c,w=new y,A=new y,I=new D.$Ac,k=new y,C=new D.$Ac){this.c=r,this.d=t,this.f=n,this.g=c,this.h=w,this.i=A,this.j=I,this.l=k,this.m=C,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,t,n){return this.p(r,t,n).getValue(r)}updateValue(r,t,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new y,this.m.set(n.resource,c))):c=this.l,t===void 0?c.removeValue(r):c.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const c=this.p(r,t,n),w=this.t(t.resource,n),A=t.resource?this.m.get(t.resource)||this.l:this.l,I=new Set;for(const k of c.overrides)for(const C of k.identifiers)c.getOverrideValue(r,C)!==void 0&&I.add(C);return new g(r,t,c.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,w||void 0,A)}keys(r){const t=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:c,updated:w,removed:A}=f(this.c,r);t=[...c,...w,...A]}for(const c of t)for(const w of(0,v.$In)(c)){const A=this.c.getKeysForOverrideIdentifier(w),I=r.getKeysForOverrideIdentifier(w),k=[...I.filter(C=>A.indexOf(C)===-1),...A.filter(C=>I.indexOf(C)===-1),...A.filter(C=>!S.$kn(this.c.override(w).getValue(C),r.override(w).getValue(C)))];n.push([w,k])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:c}=f(this.d,r),w=[...t,...n,...c];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:c,overrides:w}=f(this.applicationConfiguration,r),A=[...t,...n,...c];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:w}=f(this.localUserConfiguration,r),A=[...t,...n,...c];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:w}=f(this.remoteUserConfiguration,r),A=[...t,...n,...c];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:c,overrides:w}=f(this.workspaceConfiguration,r),A=[...t,...n,...c];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:w}}compareAndUpdateFolderConfiguration(r,t){const n=this.folderConfigurations.get(r),{added:c,updated:w,removed:A,overrides:I}=f(n,t),k=[...c,...w,...A];return(k.length||!n)&&this.updateFolderConfiguration(r,t),{keys:k,overrides:I}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:w,overrides:A}=f(t,void 0);return{keys:[...n,...c,...w],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,t,n){let c=this.q(t,n);return t.overrideIdentifier&&(c=c.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}q({resource:r},t){let n=this.r();if(t&&r){const c=t.getFolder(r);c&&(n=this.s(c.uri)||n);const w=this.m.get(r);w&&(n=n.merge(w))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let t=this.b.get(r);if(!t){const n=this.r(),c=this.j.get(r);c?(t=n.merge(c),this.b.set(r,t)):t=n}return t}t(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:c,keys:w}=this.j.get(t);return r.push([t,{contents:n,overrides:c,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>t.add(c))),[...t.values()]}static parse(r){const t=this.w(r.defaults),n=this.w(r.policy),c=this.w(r.application),w=this.w(r.user),A=this.w(r.workspace),I=r.folders.reduce((k,C)=>(k.set(u.URI.revive(C[0]),this.w(C[1])),k),new D.$Ac);return new h(t,n,c,w,new y,A,I,new y,new D.$Ac)}static w(r){return new y(r.contents,r.keys,r.overrides)}}e.$Qn=h;function a(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const c of o)c.keys.forEach(w=>r.add(w)),c.overrides.forEach(([w,A])=>{const I=(0,D.$xc)(t,w,new Set);A.forEach(k=>I.add(k))});const n=[];return t.forEach((c,w)=>n.push([w,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.$Rn=a;class E{constructor(r,t,n,c){this.change=r,this.f=t,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const A of w)this.affectedKeys.add(A);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,c=this.d.indexOf(n);if(c<0)return!1;const w=c+n.length;if(w>=this.d.length)return!1;const A=this.d.charCodeAt(w);if(A!==this.b&&A!==this.c)return!1;if(t){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,k=this.g.getValue(r,t,this.h);return!S.$kn(I,k)}return!0}}e.$Sn=E;function f(o,r){const{added:t,removed:n,updated:c}=i(r?.rawConfiguration,o?.rawConfiguration),w=[],A=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const k=I.filter(C=>!A.includes(C));for(const C of k)w.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const k=A.filter(C=>!I.includes(C));for(const C of k)w.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const k of A)if(I.includes(k)){const C=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});w.push([k,[...C.added,...C.removed,...C.updated]])}}return{added:t,removed:n,updated:c,overrides:w}}function i(o,r){const t=o?r?o.keys.filter(w=>r.keys.indexOf(w)===-1):[...o.keys]:[],n=r?o?r.keys.filter(w=>o.keys.indexOf(w)===-1):[...r.keys]:[],c=[];if(o&&r){for(const w of r.keys)if(o.keys.indexOf(w)!==-1){const A=(0,p.$Ci)(r.contents,w),I=(0,p.$Ci)(o.contents,w);S.$kn(A,I)||c.push(w)}}return{added:t,removed:n,updated:c}}}),define(re[237],oe([0,1,23,3,2,38,12,119,58,5,39,43]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=void 0;class b extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Nn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$sn.as(d.$xn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:g})=>this.c(Array.from($),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,g){this.h($,v.$sn.as(d.$xn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new S.$Nn;const $=v.$sn.as(d.$xn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,g){const h=this.f();for(const a of $){const E=h[a],f=g[a];E!==void 0?this.b.addValue(a,E):f?this.b.addValue(a,f.default):this.b.removeValue(a)}}}e.$Tn=b;class l{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.$Nn}async initialize(){return this.configurationModel}}e.$Un=l;let y=class extends s.$Sc{get configurationModel(){return this.b}constructor($,g,h){super(),this.c=$,this.f=g,this.g=h,this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Nn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const g={},h=[],a=v.$sn.as(d.$xn.Configuration).getConfigurationProperties();for(const E of $){const f=a[E];if(!f){h.push(E);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}h.push(E),g[f.policy.name]={type:f.type}}}return(0,D.$Qf)(g)||await this.f.updatePolicyDefinitions(g),h}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const g=v.$sn.as(d.$xn.Configuration).getPolicyConfigurations(),h=(0,P.$Hb)($.map(a=>g.get(a)));this.m(h,!0)}m($,g){this.g.trace("PolicyConfiguration#update",$);const h=v.$sn.as(d.$xn.Configuration).getConfigurationProperties(),a=[],E=this.b.isEmpty();for(const f of $){const i=h[f]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(E?o!==void 0:!(0,M.$kn)(this.b.getValue(f),o))&&a.push([f,o])}else this.b.getValue(f)!==void 0&&a.push([f,void 0])}if(a.length){this.g.trace("PolicyConfiguration#changed",a);const f=this.b;this.b=new S.$Nn;for(const i of f.keys)this.b.setValue(i,f.getValue(i));for(const[i,o]of a)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);g&&this.a.fire(this.b)}}};e.$Vn=y,e.$Vn=y=Ee([ie(1,p.$un),ie(2,u.$ij)],y)}),define(re[238],oe([0,1,8,3,2,19,17,119,237,39]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0;class p extends s.$Sc{constructor(b,l,y,m){super(),this.j=b,this.h=this.B(new R.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Tn),this.c=y instanceof u.$wn?new d.$Un:this.B(new d.$Vn(this.b,y,m)),this.f=this.B(new S.$Pn(this.j,{},M.$tg,l)),this.a=new S.$Qn(this.b.configurationModel,this.c.configurationModel,new S.$Nn,new S.$Nn),this.g=this.B(new P.$ah(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:g})=>this.n($,g))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$Qn(b,l,new S.$Nn,y)}getConfigurationData(){return this.a.toData()}getValue(b,l){const y=typeof b=="string"?b:void 0,m=(0,D.$vi)(b)?b:(0,D.$vi)(l)?l:{};return this.a.getValue(y,m,void 0)}updateValue(b,l,y,m){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(y,l,2)}n(b,l){const y=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(m,y,7)}r(b){const l=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(b);this.s(y,l,7)}s(b,l,y){const m=new S.$Sn(b,{data:l},this.a);m.source=y,m.sourceConfig=this.t(y),this.h.fire(m)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Wn=p}),define(re[239],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T0b=e.$S0b=e.$R0b=void 0,e.$R0b="request",e.$S0b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$R0b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const d=s.connections.find(u=>u.ctx===S.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$T0b=P}),define(re[240],oe([0,1,14,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.RemoteAuthorityResolverErrorCode=e.$4k=e.$3k=e.RemoteConnectionType=e.$2k=void 0,e.$2k=(0,R.$1h)("remoteAuthorityResolverService");var s;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$3k=M;class D{constructor(v,b){this.host=v,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$4k=D;var S;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class d extends P.$bb{static isNotAvailable(v){return v instanceof d&&v._code===S.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof d&&v._code===S.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof d&&v._code===S.NoResolverFound}static isInvalidAuthority(v){return v instanceof d&&v._code===S.InvalidAuthority}static isHandled(v){return v instanceof d&&v.isHandled}constructor(v,b=S.Unknown,l){super(v),this._message=v,this._code=b,this._detail=l,this.isHandled=b===S.NotAvailable&&l===!0,Object.setPrototypeOf(this,d.prototype)}}e.$5k=d;function u(p){const v=p.indexOf("+");return v===-1?p:p.substring(0,v)}e.$6k=u}),define(re[59],oe([0,1,13]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0;function R(u){return u.scheme===P.Schemas.vscodeRemote?u.authority:void 0}e.$7k=R;function s(u){if(!u)return;const p=u.indexOf("+");return p<0?u:u.substr(0,p)}e.$8k=s;function M(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$9k=M;function D(u){const{host:p,port:v}=d(u);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:v}}e.$0k=D;function S(u,p){let{host:v,port:b}=d(u);return typeof b>"u"&&(b=p),{host:v,port:b}}e.$$k=S;function d(u){const p=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const v=u.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=u.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:u,port:void 0}}}),define(re[120],oe([0,1,25,6,59]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.TargetPlatform=e.ExtensionType=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l="extensions.user.cache",e.$am="extensions.builtin.cache",e.$bm="undefined_publisher",e.$cm=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$dm=M,e.$em=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class d{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,g){if(typeof $>"u"||$===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof $=="string"||typeof g=="string"){const h=typeof $=="string"?$:$.value,a=typeof g=="string"?g:g.value;return P.$7e(h,a)}return $._lower===g._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$fm=d;class u{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const g of $)this.add(g)}add($){this.c.add(d.toKey($))}delete($){return this.c.delete(d.toKey($))}has($){return this.c.has(d.toKey($))}}e.$gm=u;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(d.toKey($))}get($){return this.c.get(d.toKey($))}has($){return this.c.has(d.toKey($))}set($,g){this.c.set(d.toKey($),g)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$hm=p;function v(m){return b(m)}e.$im=v;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$jm=b;function l(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$km=l;function y(m,$){if($){const g=`onResolveRemoteAuthority:${(0,s.$8k)($)}`;return!!m.activationEvents?.includes(g)}return!1}e.$lm=y,e.$mm=(0,R.$1h)("IBuiltinExtensionsScannerService")}),define(re[241],oe([0,1,8,18,22,14,3,2,68,73,32,109,240,59]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.PersistentConnectionEventType=e.$fl=e.$el=e.$dl=e.ConnectionType=void 0;const y=30*1e3;var m;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function $(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(G){const O=new s.$3d;return setTimeout(()=>O.cancel(),G),O.token}function h(G,O){if(G.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.$3d;return G.onCancellationRequested(()=>U.cancel()),O.onCancellationRequested(()=>U.cancel()),U.token}class a{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Rc,this.promise=new Promise((U,x)=>{this.f=U,this.g=x}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(G,O){const U=new a(O);return U.registerDisposable(G.onControlMessage(x=>{const z=JSON.parse(x.toString()),Z=L(z);Z?U.reject(Z):U.resolve(z)})),U.promise}function f(G,O,U,x,z,Z,W,B){const _=new a(B),ae=u.$Od.create(!1);return G.info(`Creating a socket (${W})...`),d.mark(`code/willCreateSocket/${Z}`),O.connect(U,x,z,W).then(ne=>{_.didTimeout?(d.mark(`code/didCreateSocketError/${Z}`),G.info(`Creating a socket (${W}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ne?.dispose()):(d.mark(`code/didCreateSocketOK/${Z}`),G.info(`Creating a socket (${W}) was successful after ${ae.elapsed()} ms.`),_.resolve(ne))},ne=>{d.mark(`code/didCreateSocketError/${Z}`),G.info(`Creating a socket (${W}) returned an error after ${ae.elapsed()} ms.`),G.error(ne),_.reject(ne)}),_.promise}function i(G,O){const U=new a(O);return G.then(x=>{U.didTimeout||U.resolve(x)},x=>{U.didTimeout||U.reject(x)}),U.promise}async function o(G,O,U,x){const z=te(G,O);G.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await f(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,l.$9k)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${G.reconnectionToken}`,x)}catch(ne){throw G.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ne),ne}G.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let W,B;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(Z,null),W=G.reconnectionProtocol,B=!1):(W=new v.$Oh({socket:Z}),B=!0),G.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const _=await i(G.signService.createNewMessage((0,p.$lg)()),x),ae={type:"auth",auth:G.connectionToken||"00000000000000000000",data:_.data};W.sendControl(R.$ge.fromString(JSON.stringify(ae)));try{const ne=await E(W,h(x,g(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(G.logService.trace(`${z} 4/6. received SignRequest control message.`),!await i(G.signService.validate(_,ne.signedData),x)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await i(G.signService.sign(ne.data),x),ye={type:"connectionType",commit:G.commit,signedData:me,desiredConnectionType:O};return U&&(ye.args=U),G.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(R.$ge.fromString(JSON.stringify(ye))),{protocol:W,ownsProtocol:B}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(G.logService.error(`${z} the handshake timed out. Error:`),G.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${z} received error control message when negotiating connection. Error:`),G.logService.error(ne)),B&&H(W),ne}}async function r(G,O,U,x){const z=Date.now(),Z=te(G,O),{protocol:W,ownsProtocol:B}=await o(G,O,U,x),_=new a(x);return _.registerDisposable(W.onControlMessage(ae=>{const ne=JSON.parse(ae.toString()),$e=L(ne);$e?(G.logService.error(`${Z} received error control message when negotiating connection. Error:`),G.logService.error($e),B&&H(W),_.reject($e)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${he(z)}!`),_.resolve({protocol:W,firstMessage:ne}))})),_.promise}async function t(G,O){const{protocol:U}=await r(G,1,void 0,O);return{protocol:U}}async function n(G,O,U){const{protocol:x,firstMessage:z}=await r(G,2,O,U),Z=z&&z.debugPort;return{protocol:x,debugPort:Z}}async function c(G,O,U){const x=Date.now(),z=te(G,3),{protocol:Z}=await o(G,3,O,U);return G.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Z}async function w(G,O,U){const{connectTo:x,connectionToken:z}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:x,connectionToken:z,reconnectionToken:O,reconnectionProtocol:U,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function A(G,O,U){return k(G,async x=>{const{protocol:z}=await t(x,s.CancellationToken.None);return new K(G,O,U,x.reconnectionToken,z)})}e.$dl=A;async function I(G,O){return k(G,async U=>{const{protocol:x,debugPort:z}=await n(U,O,s.CancellationToken.None);return new X(G,O,U.reconnectionToken,x,z)})}e.$el=I;async function k(G,O){for(let x=1;;x++)try{const z=(0,p.$lg)(),Z=await w(G,z,null);return await O(Z)}catch(z){if(x<5)G.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(z);else throw G.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(z),ue.triggerPermanentFailure(0,0,b.$5k.isHandled(z)),z}}async function C(G,O,U){const x=await w(G,(0,p.$lg)(),null);return await c(x,{host:O,port:U},s.CancellationToken.None)}e.$fl=C;function j(G){return(0,P.$Og)(O=>new Promise((U,x)=>{const z=setTimeout(U,G*1e3);O.onCancellationRequested(()=>{clearTimeout(z),U()})}))}var F;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(O,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.type=0}}e.$gl=N;class Y{constructor(O,U,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$hl=Y;class Q{constructor(O,U,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=2}}e.$il=Q;class le{constructor(O,U,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=4}}e.$jl=le;class ce{constructor(O,U,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=U,this.attempt=x,this.handled=z,this.type=3}}e.$kl=ce;class ue extends S.$Sc{static triggerPermanentFailure(O,U,x){this._permanentFailure=!0,this.f=O,this.g=U,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,U,x,z,Z){super(),this.t=O,this.u=U,this.reconnectionToken=x,this.protocol=z,this.w=Z,this.m=this.B(new D.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(W=>{const B=q(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${B} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${B} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${B} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(W=>{const B=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,S.$Qc)(()=>{const W=ue.j.indexOf(this);W>=0&&ue.j.splice(W,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<U.length?U[x]:U[U.length-1];try{if(z>0){const W=j(z);this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,W)),this.u.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const Z=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Z.connectTo}...`),await this.G(Z,g(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(b.$5k.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,M.$4)(Z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof b.$5k){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,b.$5k.isHandled(Z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,U,x){this.w?ue.triggerPermanentFailure(O,U,x):this.D(O,U,x)}D(O,U,x){this.m.fire(new ce(this.reconnectionToken,O,U,x)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ll=ue;class K extends ue{constructor(O,U,x,z,Z){super(1,O,z,Z,!0),this.client=this.B(new v.$Mh(Z,{remoteAuthority:U,clientId:x},O.ipcLogger))}async G(O,U){await t(O,U)}}e.$ml=K;class X extends ue{constructor(O,U,x,z,Z){super(2,O,x,z,!1),this.H=U,this.debugPort=Z}async G(O,U){await n(O,this.H,U)}}e.$nl=X;function H(G){try{G.acceptDisconnect();const O=G.getSocket();G.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(G){if(G&&G.type==="error"){const O=new Error(`Connection error: ${G.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function T(G,O){for(;G.length<O;)G+=" ";return G}function V(G,O){return`[remote-connection][${T($(G),13)}][${O.substr(0,5)}\u2026]`}function q(G,O,U){return`${V(G,O)}[${U?"reconnect":"initial"}]`}function te(G,O){return`${q(O,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function he(G){return`${Date.now()-G} ms`}}),define(re[242],oe([0,1,2,6]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0,e.$_k=(0,R.$1h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$Qc)(()=>{const d=this.a[D]?.indexOf(S);typeof d=="number"&&d>=0&&this.a[D]?.splice(d,1)})}b(D){return(this.a[D.type]||[]).find(d=>d.supports(D))}connect(D,S,d,u){const p=this.b(D);if(!p)throw new Error(`No socket factory found for ${D}`);return p.connect(D,S,d,u)}}e.$al=s}),define(re[243],oe([0,1,26,48,21,113]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=void 0;let D;async function S(l=!1){return(D===void 0||l)&&(D=d()),D}e.$U9b=S;async function d(){const l=u();if(l===void 0)return!1;if(l>=22e3){const y=v();if(y)return new Promise(m=>{R.execFile(y,["--status"],$=>m(!$))})}else{const y=b();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function u(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(l)return parseInt(l[3])}function p(l){const y=process.env.SystemRoot;if(y){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,m?"Sysnative":"System32",l)}}function v(){return p("wsl.exe")}function b(){return p("lxss\\LxssManager.dll")}}),define(re[51],oe([0,1,18,14,2,183,58,6,5,43]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=void 0,e.$5o=(0,S.$1h)("requestService");class p{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?f[i]="*****":f[i]=this.b[i];this.a=f}return this.a}}class v extends s.$Sc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,M.localize)(0,null),when:d.$zj.isEqualTo((0,d.$xj)(d.LogLevel.Trace)).serialize()})}async c(f,i,o){const r=`${f} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new p(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,R.$0)(t)),t}}}e.$6o=v;function b(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$7o=b;function l(E){return E.res.statusCode===204}e.$8o=l;async function y(E){return l(E)?null:(await(0,P.$se)(E.stream)).toString()}e.$9o=y;async function m(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$0o=m;async function $(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);if(l(E))return null;const i=(await(0,P.$se)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$$o=$;function g(E){a(E)}e.$_o=g;let h;function a(E){const f=u.$sn.as(D.$xn.Configuration),i=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[h],remove:i?[i]:[]})}a(1)}),define(re[244],oe([0,1,18,22]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class s{constructor(S){this.a=S}listen(S,d){throw new Error("Invalid listen")}call(S,d,u,p=R.CancellationToken.None){switch(d){case"request":return this.a.request(u[0],p).then(async({res:v,stream:b})=>{const l=await(0,P.$se)(b);return[{statusCode:v.statusCode,headers:v.headers},l]});case"resolveProxy":return this.a.resolveProxy(u[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$8q=s;class M{constructor(S){this.a=S}async request(S,d){const[u,p]=await this.a.call("request",[S],d);return{res:u,stream:(0,P.$ue)(p)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$9q=M}),define(re[245],oe([0,1,246,12]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,d={}){const u=(0,P.parse)(D),p=d.proxyUrl||s(u,S);if(!p)return null;const v=(0,P.parse)(p);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,R.$Jf)(d.strictSSL)?d.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((l,y)=>{J(["http-proxy-agent"],l,y)})).HttpProxyAgent(p,b):new(await new Promise((l,y)=>{J(["https-proxy-agent"],l,y)})).HttpsProxyAgent(p,b)}e.$0q=M}),define(re[247],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=e.$c0b=e.$b0b=void 0,e.$b0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$c0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$d0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[94],oe([0,1,48,9,184,22,50,14,4,32,108,64,8,140]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=void 0;let y;async function m(g,h,a,E){return a["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Zl)(E)&&!a["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Zl)(E)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=b.Promises.withAsyncBody(async(f,i)=>{const o=new M.$3d;let r=1e4;const t=g.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,l.$1l)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{f(await $(h,o.token))}catch(c){!(0,S.$4)(c)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,D.$Li)(c)))):f({})}finally{clearTimeout(n),o.dispose()}})),y)}e.$6l=m;async function $(g,h){const a=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",a);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const f=(0,u.$lg)().replace(/-/g,"").substr(0,12),i=new RegExp(f+"({.*})"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,p.$Pl)(d.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(h.isCancellationRequested)return n(new S.$5);const c=(0,R.$nc)(r);let w,A;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(w=`& '${process.execPath}' ${I} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,A=["-Login","-Command"]):c==="nu"?(w=`^'${process.execPath}' ${I} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,A=["-i","-l","-c"]):(w=`'${process.execPath}' ${I} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,c==="tcsh"||c==="csh"?A=["-ic"]:A=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),w);const k=(0,P.spawn)(r,[...A,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(k.kill(),n(new S.$5))),k.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Li)(F)),n(F)});const C=[];k.stdout.on("data",F=>C.push(F));const j=[];k.stderr.on("data",F=>j.push(F)),k.on("close",(F,N)=>{const Y=Buffer.concat(C).toString("utf8");g.trace("getUnixShellEnvironment#raw",Y);const Q=Buffer.concat(j).toString("utf8");if(Q.trim()&&g.trace("getUnixShellEnvironment#stderr",Q),F||N)return n(new Error((0,s.localize)(2,null,F,N)));const le=i.exec(Y),ce=le?le[1]:"{}";try{const ue=JSON.parse(ce);a?ue.ELECTRON_RUN_AS_NODE=a:delete ue.ELECTRON_RUN_AS_NODE,E?ue.ELECTRON_NO_ATTACH_CONSOLE=E:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),t(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,D.$Li)(ue)),n(ue)}})})}}),define(re[248],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$95b=P}),define(re[95],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=void 0,e.$bl="signService",e.$cl=(0,P.$1h)(e.$bl)}),define(re[249],oe([0,1,248]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=void 0;class R extends P.$95b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>J(["vsda"],M,D))}}e.$40b=R}),define(re[34],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=void 0,e.$3N=(0,P.$1h)("stateReadService"),e.$4N=(0,P.$1h)("stateService")}),define(re[121],oe([0,1,8,18,2,12,37,16,5]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=e.$6N=e.$5N=e.SaveStrategy=void 0;var u;(function(l){l[l.IMMEDIATE=0]="IMMEDIATE",l[l.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class p extends s.$Sc{constructor(y,m,$,g){super(),this.h=y,this.j=m,this.m=$,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new P.$Yg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,m){const $=this.a[y];return(0,M.$Mf)($)?m:$}setItem(y,m){this.setItems([{key:y,data:m}])}setItems(y){let m=!1;for(const{key:$,data:g}of y)this.a[$]!==g&&((0,M.$Mf)(g)?(0,M.$Kf)(this.a[$])||(this.a[$]=void 0,m=!0):(this.a[$]=g,m=!0));m&&this.s()}removeItem(y){(0,M.$Kf)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,R.$ge.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(m){this.m.error(m)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$5N=p;let v=class extends s.$Sc{constructor(y,m,$,g){super(),this.a=this.B(new p(m.stateResource,y,$,g))}async init(){await this.a.init()}getItem(y,m){return this.a.getItem(y,m)}};e.$6N=v,e.$6N=v=Ee([ie(1,D.$8h),ie(2,d.$ij),ie(3,S.$kk)],v);class b extends v{setItem(y,m){this.a.setItem(y,m)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$7N=b}),define(re[122],oe([0,1,4,35,32]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=void 0;function M(d){if(P.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function D(d,u,p,v,b,l,y,m,$){const g=Object.create(null);g["common.machineId"]=l,g["common.sqmId"]=y,g.sessionID=(0,s.$lg)()+Date.now(),g.commitHash=v,g.version=b,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,P.$h)(P.$u),g["common.nodePlatform"]=R.$dc,g["common.nodeArch"]=p,g["common.product"]=$||"desktop",m&&(g["common.msftInternal"]=m);let h=0;const a=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),P.$l&&(g["common.snap"]="true");const E=M(u);return E&&(g["common.platformDetail"]=E),g}e.$to=D;function S(d){const u=R.env.USERDNSDOMAIN;if(!u)return!1;const p=u.toLowerCase();return d.some(v=>p===v)}e.$uo=S}),define(re[28],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=void 0,e.$ol=(0,P.$1h)("telemetryService"),e.$pl=(0,P.$1h)("customEndpointTelemetryService"),e.$ql="telemetry.currentSessionDate",e.$rl="telemetry.firstSessionDate",e.$sl="telemetry.lastSessionDate",e.$tl="telemetry.machineId",e.$ul="telemetry.sqmId",e.$vl="telemetry",e.$wl="telemetry.telemetryLevel",e.$xl="telemetry.enableCrashReporter",e.$yl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(re[250],oe([0,1,26,8,44,13,9,4,7,88,21,107,91,16,27,28]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0;const $=new Map;async function g(i,o){const r=`${i}::${o.join(":")}`,t=$.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,w=new Map,A=2e4;function I(C,j,F,N){const Y=j.substring(C.length+1);return R.Promises.withAsyncBody(async Q=>{let le;try{le=await p.Promises.readdir(j,{withFileTypes:!0})}catch{Q();return}if(N.count>=A){N.count+=le.length,N.maxReached=!0,Q();return}let ce=le.length;if(ce===0){Q();return}let ue=le;N.count+le.length>A&&(N.maxReached=!0,ce=A-N.count,ue=le.slice(0,ce)),N.count+=le.length;for(const K of ue)if(K.isDirectory()){if(F.includes(K.name)||await I(C,(0,D.$jc)(j,K.name),F,N),--ce===0){Q();return}}else{const X=K.name.lastIndexOf(".");if(X>=0){const H=K.name.substring(X+1);H&&c.set(H,(c.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(Y)!==!1&&H.filePattern.test(K.name)&&w.set(H.tag,(w.get(H.tag)??0)+1);if(--ce===0){Q();return}}})}const k=R.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(i,i,o,j);const F=await E(i);C({configFiles:h(w),fileTypes:h(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F})});return $.set(r,k),k}e.$Pr=g;function h(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function a(){const i={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/l.$Sk.GB).toFixed(2)}GB (${(P.freemem()/l.$Sk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$4m.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Qr=a;async function E(i){try{const o=new Map,r=(0,D.$jc)(i,".vscode","launch.json"),t=await p.Promises.readFile(r),n=[],c=(0,s.$9m)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$fn)(c)==="object"&&c.configurations)for(const w of c.configurations){const A=w.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return h(o)}catch{return[]}}e.$Rr=E;let f=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const t=P.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/l.$Sk.GB).toFixed(2)}GB (${(P.freemem()/l.$Sk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(u.$4m.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$Or)(o.mainPID),this.k(o)]).then(async t=>{let[n,c]=t,w=this.m(o,n);return r.forEach(A=>{if((0,b.$Dm)(A))w+=`
${A.errorMessage}`,c+=`
${A.errorMessage}`;else if(w+=`

Remote: ${A.hostName}`,A.processes&&(w+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){c+=`
|  Remote: ${A.hostName}`;for(const I of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[I];let C=`${k.fileCount} files`;k.maxFilesReached&&(C=`more than ${C}`),c+=`|    Folder (${I}): ${C}`,c+=this.h(k)}}}),{processInfo:w,workspaceInfo:c}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:c,cpus:w}=a(),A={os:c,memory:t,cpus:w,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(A.load=`${P.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,r){const t=[];return(0,v.$Or)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(c=>{if((0,b.$Dm)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.f(c.machineInfo)),c.processes&&t.push(this.m(o,c.processes)),c.workspaceMetadata)for(const w of Object.keys(c.workspaceMetadata)){const A=c.workspaceMetadata[w];let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),t.push(`Folder (${w}): ${I}`),t.push(this.h(A))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const c=(k,C)=>{const j=` ${k}(${C})`;n+j.length>60?(r.push(w),w="|                 ",n=w.length):n+=j.length,w+=j};let w="|      File types:";const A=10,I=o.fileTypes.length>A?A:o.fileTypes.length;for(let k=0;k<I;k++){const C=o.fileTypes[k];c(C.name,C.count)}if(r.push(w),o.configFiles.length>=0&&(w="|      Conf files:",n=0,o.configFiles.forEach(k=>{c(k.name,k.count)}),r.push(w)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;k+=j}),r.push(k)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const w=d.URI.revive(c);if(w.scheme===M.Schemas.file){const A=w.fsPath;t.push(g(A,["node_modules",".git"]).then(I=>{let k=`${I.fileCount} files`;I.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,D.$nc)(A)}): ${k}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${I.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(c=>t.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:w})=>t.set(c,w));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,c){const w=c===0;let A;w?A=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(c)} ${n.name}`;const I=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/l.$Sk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(o,r,t,k,c+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=d.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=d.URI.revive(r);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const c=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(w=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),c.launchConfigFiles.forEach(w=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),c.configFiles.forEach(w=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};e.$Sr=f,e.$Sr=f=Ee([ie(0,m.$ol),ie(1,y.$Aj)],f)}),define(re[251],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=e.$g0b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:d}){return this.b.forEach(u=>u.log(S,d)),Promise.resolve(null)}}e.$g0b=P;class R{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$h0b=R}),define(re[52],oe([0,1,38,12,3,17,59,122,28]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;class u{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$vo=u;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wo=p,e.$xo=new p;class v{async publicLog(n,c,w){}async publicLogError(n,c,w){}}e.$yo=v,e.$zo="telemetry",e.$Ao="extensionTelemetryLog",e.$Bo={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(w,A)=>{const I=w?new Set([...w.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:I}},1e3,!0)(w=>{w.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$xi)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.$Co=b;function l(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$Do=l;function y(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Eo=y;function m(t){const n=t.getValue(d.$wl),c=t.getValue(d.$xl);if(t.getValue(d.$yl)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Fo=m;function $(t){const n={},c={},w={};a(t,w);for(let A in w){A=A.length>150?A.substr(A.length-149):A;const I=w[A];typeof I=="number"?c[A]=I:typeof I=="boolean"?c[A]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${I.length}`),n[A]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[A]=I)}return{properties:n,measurements:c}}e.$Go=$;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,D.$8k)(t);return g.has(n)?n:"other"}e.$Ho=h;function a(t,n,c=0,w){if(t)for(const A of Object.getOwnPropertyNames(t)){const I=t[A],k=w?w+A:A;Array.isArray(I)?n[k]=(0,P.$ln)(I):I instanceof Date?n[k]=I.toISOString():(0,R.$Ff)(I)?c<2?a(I,n,c+1,k+"."):n[k]=(0,P.$ln)(I):n[k]=I}}function E(t,n){const c=t.msftInternalDomains||[],w=n.getValue("telemetry.internalTesting");return(0,S.$uo)(c)||w}e.$Io=E;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Jo=f;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const w=[];for(const C of n)for(;;){const j=C.exec(t);if(!j)break;w.push([j.index,C.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(c="";;){const C=I.exec(t);if(!C)break;const j=w.some(([F,N])=>C.index<N&&F<I.lastIndex);!A.test(C[0])&&!j&&(c+=t.substring(k,C.index)+"<REDACTED: user-file-path>",k=I.lastIndex)}return k<t.length&&(c+=t.substr(k)),c}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function r(t,n){return(0,P.$in)(t,c=>{if(c instanceof u||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let w=c.replaceAll("%20"," ");w=i(w,n);for(const A of n)w=w.replace(A,"");return w=o(w),w}})}e.$Ko=r}),define(re[123],oe([0,1,25,117,120,4,7,14,35,52]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;function p(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$2e)(r.id,t.id)===0}e.$Lo=p;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const n=t.manifest?t.manifest.version:t.version,c=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,n,c)}static parse(t){const n=v.exec(t);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?p(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Mo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=l.exec(r);return t&&t[1]?[$(t[1]),t[2]]:[$(r),void 0]}e.$No=y;function m(r,t){return`${r}.${t}`}e.$Oo=m;function $(r){return r.toLowerCase()}e.$Po=$;function g(r,t){return $(m(r??s.$bm,t))}e.$Qo=g;function h(r,t){const n=[],c=w=>{for(const A of n)if(A.some(I=>p(t(I),t(w))))return A;return null};for(const w of r){const A=c(w);A?A.push(w):n.push([w])}return n}e.$Ro=h;function a(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$So=a;function E(r){return{id:new u.$vo(r.identifier.id),name:new u.$vo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$To=E,e.$Uo=new s.$fm("pprice.better-merge");function f(r,t){const n=[],c=t.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const w=c.shift();if(w&&n.every(A=>!p(A.identifier,{id:w}))){const A=r.filter(I=>p(I.identifier,{id:w}));A.length===1&&(n.push(A[0]),c.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Vo=f;async function i(r,t){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){t.debug("Error while getting the os-release file.",(0,S.$0)(w))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),c=(0,R.$fo)(n?"alpine":M.$u,d.$ec);return t.debug("ComputeTargetPlatform:",c),c}e.$Wo=o}),define(re[252],oe([0,1,206,52]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;async function s(M,D,S,d,u,p,v){const b={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,R.$Do)(D,S)&&(0,R.$Fo)(d)===3){const l=await(0,P.$lp)(S,u,p);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=v.machineId||l}return b}e.$mp=s}),define(re[253],oe([0,1,2,38,4,25,185,17,58,79,27,43,28,52]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,h,a){this.k=h,this.l=a,this.d={},this.i=new P.$Rc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Ke)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ke)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(b.$wl)||E.affectsConfiguration(b.$yl)||E.affectsConfiguration(b.$xl))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,l.$Fo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const a=h.usage?3:h.error?2:0;g=Math.min(g,a)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,a){this.g<h||(a=(0,R.$jn)(a,this.d),a=(0,l.$Ko)(a,this.j),a=(0,R.$jn)(a,this.c),this.b.forEach(E=>E.log(g,a)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){this.h&&this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};e.$ar=y,e.$ar=y=Ee([ie(1,S.$ui),ie(2,p.$Aj)],y);function m(){const $=(0,D.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,D.localize)(3,null),a=(0,D.localize)(4,null),E=(0,D.localize)(5,null),f=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${a} | ${E} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${$} ${g} ${h}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}v.$sn.as(d.$xn.Configuration).registerConfiguration({id:b.$vl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[b.$wl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$sn.as(d.$xn.Configuration).registerConfiguration({id:b.$vl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[b.$yl]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,D.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,D.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${b.$wl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[254],oe([0,1,4,88,28]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=void 0;async function M(S,d){let u=S.getItem(s.$tl);return(typeof u!="string"||P.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,R.$5m)(d.error.bind(d))),u}e.$I0b=M;async function D(S,d){let u=S.getItem(s.$ul);return typeof u!="string"&&(u=await(0,R.$6m)(d.error.bind(d))),u}e.$J0b=D}),define(re[255],oe([0,1,28,254]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=e.$K0b=void 0;async function s(D,S){const d=await(0,R.$I0b)(D,S);return D.setItem(P.$tl,d),d}e.$K0b=s;async function M(D,S){const d=await(0,R.$J0b)(D,S);return D.setItem(P.$ul,d),d}e.$L0b=M}),define(re[124],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(re[256],oe([0,1,4,124]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((v,b)=>{this.d(v,b);const l=v.map.entries();let y=l.next();for(;!y.done;){const m=y.value[1],$=y.value[0];let g=this.a.get($);if(g||(g=[],this.a.set($,g)),g.length>0&&g[0].type===R.EnvironmentVariableMutatorType.Replace){y=l.next();continue}const h={extensionIdentifier:b,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};h.scope||delete h.scope,g.unshift(h),y=l.next()}})}async applyToProcessEnvironment(p,v,b){let l;P.$i&&(l={},Object.keys(p).forEach(y=>l[y.toLowerCase()]=y));for(const[y,m]of this.getVariableMap(v)){const $=P.$i&&l[y.toLowerCase()]||y;for(const g of m){const h=b?await b(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case R.EnvironmentVariableMutatorType.Append:p[$]=(p[$]||"")+h;break;case R.EnvironmentVariableMutatorType.Prepend:p[$]=h+(p[$]||"");break;case R.EnvironmentVariableMutatorType.Replace:p[$]=h;break}if(g.options?.applyAtShellIntegration??!1){const a=`VSCODE_ENV_${s.get(g.type)}`;p[a]=(p[a]?p[a]+":":"")+y+"="+this.c(h)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,v){const b=new Map,l=new Map,y=new Map;if(p.getVariableMap(v).forEach((m,$)=>{const g=this.getVariableMap(v).get($),h=S(m,g);h&&b.set($,h)}),this.getVariableMap(v).forEach((m,$)=>{const g=p.getVariableMap(v).get($),h=S(m,g);h&&y.set($,h)}),this.getVariableMap(v).forEach((m,$)=>{const g=p.getVariableMap(v).get($),h=d(m,g);h&&l.set($,h)}),!(b.size===0&&l.size===0&&y.size===0))return{added:b,changed:l,removed:y}}getVariableMap(p){const v=new Map;for(const b of this.a.values()){const l=b.filter(y=>D(y,p));l.length>0&&v.set(l[0].variable,l)}return v}getDescriptionMap(p){const v=new Map;for(const b of this.b.values()){const l=b.filter(y=>D(y,p,!0));for(const y of l)v.set(y.extensionIdentifier,y.description)}return v}d(p,v){if(!p.descriptionMap)return;const b=p.descriptionMap.entries();let l=b.next();for(;!l.done;){const y=l.value[1],m=l.value[0];let $=this.b.get(m);$||($=[],this.b.set(m,$));const g={extensionIdentifier:v,scope:y.scope,description:y.description};g.scope||delete g.scope,$.push(g),l=b.next()}}}e.$Cr=M;function D(u,p,v=!1){return u.scope?!!(u.scope.workspaceFolder&&p?.workspaceFolder&&u.scope.workspaceFolder.index===p.workspaceFolder.index):v?p===u.scope:!0}function S(u,p){if(!p)return u;const v=new Set;p.forEach(l=>v.add(l.extensionIdentifier));const b=[];return u.forEach(l=>{v.has(l.extensionIdentifier)||b.push(l)}),b.length===0?void 0:b}function d(u,p){if(!p)return;const v=new Map;p.forEach(l=>v.set(l.extensionIdentifier,l));const b=[];return u.forEach(l=>{const y=v.get(l.extensionIdentifier);y&&(l.type!==y.type||l.value!==y.value||l.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&b.push(y)}),b.length===0?void 0:b}}),define(re[257],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=void 0;function P(d){return[...d.entries()]}e.$wr=P;function R(d){return d?[...d.entries()]:[]}e.$xr=R;function s(d){return new Map(d)}e.$yr=s;function M(d){return new Map(d??[])}e.$zr=M;function D(d){return Array.from(d.entries()).map(u=>[u[0],P(u[1].map),R(u[1].descriptionMap)])}e.$Ar=D;function S(d){return new Map(d.map(u=>[u[0],{map:s(u[1]),descriptionMap:M(u[2])}]))}e.$Br=S}),define(re[258],oe([0,1,8,22,3,2,5]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;let S=class extends M.$Sc{constructor(u,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Sd),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$Qc)(()=>{for(const v of this.f.values())(0,M.$Nc)(v)}))}createRequest(u){return new Promise((p,v)=>{const b=++this.a;this.c.set(b,p),this.g.fire({requestId:b,...u});const l=new R.$3d;(0,P.$2g)(this.b,l.token).then(()=>v(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,M.$Qc)(()=>l.cancel())])})}acceptReply(u,p){const v=this.c.get(u);v?(this.c.delete(u),(0,M.$Nc)(this.f.get(u)||[]),this.f.delete(u),v(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$nr=S,e.$nr=S=Ee([ie(1,D.$ij)],S)}),define(re[125],oe([0,1,6,114,43]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fr=void 0,e.$fr=new R.$fj("terminalTabFocusMode",!1,!0);var M;(function(f){f.AutomationProfile="terminal.integrated.automationProfile.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(f){f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorStyleInactive="terminal.integrated.cursorStyleInactive",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.HideOnStartup="terminal.integrated.hideOnStartup",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.EnableImages="terminal.integrated.enableImages",f.SmoothScrolling="terminal.integrated.smoothScrolling",f.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",f.FocusAfterRun="terminal.integrated.focusAfterRun",f.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",f.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",f.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",f.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",f.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",f.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",f.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(S||(e.PosixShellType=S={}));var d;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var u;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var p;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.PtyHostWindow="ptyHostWindow",f.Logger="logger",f.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var v;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$gr=(0,P.$1h)("ptyService");var b;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var l;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var y;(function(f){f.TerminalView="view",f.Editor="editor"})(y||(e.TerminalLocationString=y={}));var m;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var $;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var g;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var h;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var a;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.$hr={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$sn.add(e.$hr.Backend,new E),e.$ir=(0,P.$1h)("localPtyService"),e.$jr=(0,P.$1h)("terminalLogService")}),define(re[259],oe([0,1,75,7,187,102]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=e.$or=void 0;function D(b,l){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...b.map(m=>({name:m.profileName,description:S(m)}))),l&&y.push(...l.map(m=>({name:m.title,description:d(m)}))),{values:y.map(m=>m.name),markdownDescriptions:y.map(m=>m.description)}}e.$or=D;function S(b){let l=`$(${M.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:P.$7j.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?l+=`
- args: "${b.args}"`:l+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(l+=`
- overrideName: ${b.overrideName}`),b.color&&(l+=`
- color: ${b.color}`),b.env&&(l+=`
- env: ${JSON.stringify(b.env)}`),l}function d(b){return`$(${M.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:P.$7j.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function u(b,l){if(!b&&!l)return!0;if(typeof b=="string"&&typeof l=="string")return b===l;if(Array.isArray(b)&&Array.isArray(l)){if(b.length!==l.length)return!1;for(let y=0;y<b.length;y++)if(b[y]!==l[y])return!1;return!0}return!1}e.$pr=u;function p(b,l){if(!b&&!l)return!0;if(!b||!l)return!1;if(M.ThemeIcon.isThemeIcon(b)&&M.ThemeIcon.isThemeIcon(l))return b.id===l.id&&b.color===l.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof l=="object"&&"light"in l&&"dark"in l){const y=b,m=l;if((R.URI.isUri(y.light)||v(y.light))&&(R.URI.isUri(y.dark)||v(y.dark))&&(R.URI.isUri(m.light)||v(m.light))&&(R.URI.isUri(m.dark)||v(m.dark)))return y.light.path===m.light.path&&y.dark.path===m.dark.path}if(R.URI.isUri(b)&&R.URI.isUri(l)||v(b)||v(l)){const y=b,m=l;return y.path===m.path&&y.scheme===m.scheme}return!1}e.$qr=p;function v(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.$rr=v}),define(re[260],oe([0,1,75,4,186,58,43,259]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=void 0,e.$sr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$tr={type:"string",enum:Array.from((0,P.$6j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,P.$6j)(),$=>`$(${$.id})`)};const d={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$tr},color:{description:(0,s.localize)(3,null),...e.$sr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},p={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function v($){const g=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)($),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){D.$sn.as(M.$xn.Configuration).registerConfiguration(b),m()}e.$ur=l;let y;function m($,g){const h=D.$sn.as(M.$xn.Configuration);let a;$&&(a=(0,S.$or)($?.profiles,g));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?a?.values:void 0,markdownEnumDescriptions:$?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?a?.values:void 0,markdownEnumDescriptions:$?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?a?.values:void 0,markdownEnumDescriptions:$?.os===1?a?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$vr=m}),define(re[261],oe([0,1,26,13,38,9,4,35,25,12,21,124,257,256]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.$Dr=void 0;function y(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$Dr=y;async function m(t,n,c,w=S.env,A=p.Promises.exists){if(M.$ic(t))return await A(t)?t:void 0;if(n===void 0&&(n=S.cwd()),M.$mc(t)!=="."){const j=M.$jc(n,t);return await A(j)?j:void 0}const k=(0,s.$nn)(w,"PATH");if(c===void 0&&(0,u.$Df)(k)&&(c=k.split(M.$tc)),c===void 0||c.length===0){const j=M.$jc(n,t);return await A(j)?j:void 0}for(const j of c){let F;if(M.$ic(j)?F=M.$jc(j,t):F=M.$jc(n,j,t),await A(F))return F;if(D.$i){let N=F+".com";if(await A(N)||(N=F+".exe",await A(N)))return N}}const C=M.$jc(n,t);return await A(C)?C:void 0}e.$Er=m;function $(t,n,c,w,A){const I=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||I)return;const k=t.args,C=S.$dc==="win32"?M.$nc(t.executable).toLowerCase():M.$nc(t.executable),j=M.$mc(R.$jg.asFileUri("").fsPath);let F;const N={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(N.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!k||o(k)?F=a.get(h.WindowsPwsh):i(k)&&(F=a.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.$He)(F[F.length-1],j,""),{newArgs:F,envMixin:N}):void 0;w.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(C){case"bash":return!k||k.length===0?F=a.get(h.Bash):r(k)&&(N.VSCODE_SHELL_LOGIN="1",g(n,N),F=a.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,d.$He)(F[F.length-1],j),{newArgs:F,envMixin:N}):void 0;case"fish":{const Y=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return N.XDG_DATA_DIRS=`${Y}:${Q}`,g(n,N),{newArgs:void 0,envMixin:N}}case"pwsh":return!k||o(k)?F=a.get(h.Pwsh):i(k)&&(F=a.get(h.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.$He)(F[F.length-1],j,""),{newArgs:F,envMixin:N}):void 0;case"zsh":{if(!k||k.length===0?F=a.get(h.Zsh):r(k)?(F=a.get(h.ZshLogin),g(n,N)):(k===a.get(h.Zsh)||k===a.get(h.ZshLogin))&&(F=k),!F)return;F=[...F],F[F.length-1]=(0,d.$He)(F[F.length-1],j);let Y;try{Y=P.userInfo().username}catch{Y="unknown"}const Q=M.$jc(P.tmpdir(),`${Y}-${A.applicationName}-zsh`);N.ZDOTDIR=Q;const le=c?.ZDOTDIR??P.homedir()??"~";N.USER_ZDOTDIR=le;const ce=[];return ce.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(Q,".zshrc")}),ce.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(Q,".zprofile")}),ce.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(Q,".zshenv")}),ce.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(Q,".zlogin")}),{newArgs:F,envMixin:N,filesToCopy:ce}}}w.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$Fr=$;function g(t,n){if(D.$j&&t.environmentVariableCollections){const c=(0,b.$Br)(t.environmentVariableCollections),A=new l.$Cr(c).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),I=[];if(A)for(const k of A)k.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(k.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var h;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(h||(h={}));const a=new Map;a.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),a.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),a.set(h.Zsh,["-i"]),a.set(h.ZshLogin,["-il"]),a.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],f=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(f.includes(t[0].toLowerCase())||f.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?f.includes(t.toLowerCase()):t.length===0||t?.length===1&&f.includes(t[0].toLowerCase())}function r(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(re[262],oe([0,1,48,75,9,4,12,21,106,261,113]),function(J,e,P,R,s,M,D,S,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;var v;(function(c){c.UnixShellsPath="/etc/shells"})(v||(v={}));let b,l=!0;function y(c,w,A,I,k=process.env,C,j,F,N){return C=C||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?m(A,C,k,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:I.getValue("terminal.integrated.profiles.windows"),typeof w=="string"?w:I.getValue("terminal.integrated.defaultProfile.windows"),N,F):r(C,j,A,c&&typeof c=="object"?{...c}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof w=="string"?w:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,F,k)}e.$Gr=y;async function m(c,w,A,I,k,C,j,F,N){const Y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Q=`${process.env.windir}\\${Y?"Sysnative":"System32"}`;let le=!1;(0,u.$Dr)()>=16299&&(le=!0),await a(F);const ce=new Map;if(c){ce.set("PowerShell",{source:"PowerShell",icon:R.$7j.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${Q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$7j.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${Q}\\cmd.exe`,icon:R.$7j.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$7j.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${Q}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}t(C,ce);const ue=await $(ce.entries(),j,w,A,I,N);if(c&&k)try{const K=await i(`${Q}\\${le?"wsl":"bash"}.exe`,j);for(const X of K)(!C||!(X.profileName in C))&&ue.push(X)}catch{l&&(I?.info("WSL is not installed, so could not detect WSL profiles"),l=!1)}return ue}async function $(c,w,A,I=process.env,k,C){const j=[];for(const[F,N]of c)j.push(g(F,N,w,A,I,k,C));return(await Promise.all(j)).filter(F=>!!F)}async function g(c,w,A,I,k=process.env,C,j){if(w===null)return;let F,N,Y;if("source"in w&&!("path"in w)){const ue=b?.get(w.source);if(!ue)return;F=ue.paths,N=w.args||ue.args,w.icon?Y=h(w.icon):ue.icon&&(Y=ue.icon)}else F=Array.isArray(w.path)?w.path:[w.path],N=M.$i||Array.isArray(w.args)?w.args:void 0,Y=h(w.icon);let Q;if(j){const ue=F.map(X=>typeof X=="string"?X:X.path),K=await j(ue);Q=new Array(F.length);for(let X=0;X<F.length;X++)typeof F[X]=="string"?Q[X]=K[X]:Q[X]={path:K[X],isUnsafe:!0}}else Q=F.slice();let le;if(w.requiresPath){let ue;if((0,D.$Df)(w.requiresPath)?ue=w.requiresPath:(ue=w.requiresPath.path,w.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const ce=await n(c,A,Q,I,k,N,w.env,w.overrideName,w.isAutoDetected,le);if(!ce){C?.debug("Terminal profile not validated",c,F);return}return ce.isAutoDetected=w.isAutoDetected,ce.icon=Y,ce.color=w.color,ce}function h(c){return typeof c=="string"?{id:c}:c}async function a(c){if(b&&!c)return;const[w,A]=await Promise.all([E(),c||f()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:w,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:A,icon:R.$7j.terminalPowershell})}async function E(){const c=new Set,w=await(0,u.$Er)("git.exe");if(w){const k=(0,p.dirname)(w);c.add((0,p.resolve)(k,"../.."))}function A(k,C){C&&k.add(C)}A(c,process.env.ProgramW6432),A(c,process.env.ProgramFiles),A(c,process.env["ProgramFiles(X86)"]),A(c,`${process.env.LocalAppData}\\Program`);const I=[];for(const k of c)I.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function f(){const c=[];for await(const w of(0,d.$Jl)())c.push(w.exePath);return c}async function i(c,w){const A=[],I=await new Promise((j,F)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,Y)=>{if(N)return F("Problem occurred when getting wsl distros");j(Y)})});if(!I)return[];const k=new RegExp(/[\r?\n]/),C=I.split(k).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const F=`${j} (WSL)`,N={profileName:F,path:c,args:["-d",`${j}`],isDefault:F===w,icon:o(j),isAutoDetected:!1};A.push(N)}return A}function o(c){return c.includes("Ubuntu")?R.$7j.terminalUbuntu:c.includes("Debian")?R.$7j.terminalDebian:R.$7j.terminalLinux}async function r(c,w,A,I,k,C,j,F){const N=new Map;if(A&&await c.existsFile("/etc/shells")){const Y=(await c.readFile("/etc/shells")).toString(),Q=(C||Y.split(`
`)).map(ce=>{const ue=ce.indexOf("#");return ue===-1?ce:ce.substring(0,ue)}).filter(ce=>ce.trim().length>0),le=new Map;for(const ce of Q){let ue=(0,s.$nc)(ce),K=le.get(ue)||0;K++,K>1&&(ue=`${ue} (${K})`),le.set(ue,K),N.set(ue,{path:ce,isAutoDetected:!0})}}return t(I,N),await $(N.entries(),k,c,F,w,j)}function t(c,w){if(c)for(const[A,I]of Object.entries(c))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?w.delete(A):(I.icon=I.icon||w.get(A)?.icon,w.set(A,I))}async function n(c,w,A,I,k,C,j,F,N,Y){if(A.length===0)return Promise.resolve(void 0);const Q=A.shift();if(Q==="")return n(c,w,A,I,k,C,j,F,N);const le=typeof Q!="string"&&Q.isUnsafe,ce=typeof Q=="string"?Q:Q.path,ue={profileName:c,path:ce,args:C,env:j,overrideName:F,isAutoDetected:N,isDefault:c===w,isUnsafePath:le,requiresUnsafePath:Y};if((0,s.$nc)(ce)===ce){const X=k.PATH?k.PATH.split(s.$tc):void 0,H=await(0,u.$Er)(ce,void 0,X,void 0,I.existsFile);return H?(ue.path=H,ue.isFromPath=!0,ue):n(c,w,A,I,k,C)}return await I.existsFile((0,s.$hc)(ce))?ue:n(c,w,A,I,k,C,j,F,N)}}),define(re[263],oe([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;var $;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})($||($={}));let g=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(a,E,f,i){super(),this.M=a,this.N=E,this.O=f,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Sd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Sd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Sd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Sd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Sd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Sd),this.onProcessData=this.D.event,this.F=this.B(new P.$Sd),this.onProcessReady=this.F.event,this.G=this.B(new P.$Sd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Sd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Sd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Sd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Sd),this.onProcessExit=this.L.event,(0,b.$ur)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new p.$nr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,u.$6l)(this.N,this.O,{_:[]},process.env)}catch(a){return this.O.error("ptyHost was unable to resolve shell environment",a),{}}}U(){const a=this.M.start(),E=a.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(a.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$mr(this.P,E.getChannel(v.TerminalIpcChannels.Logger))),this.a=a,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[a,i]}async createProcess(a,E,f,i,o,r,t,n,c,w,A){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(a,E,f,i,o,r,t,n,c,w,A);return clearTimeout(I),k}updateTitle(a,E,f){return this.f.updateTitle(a,E,f)}updateIcon(a,E,f,i){return this.f.updateIcon(a,E,f,i)}attachToProcess(a){return this.f.attachToProcess(a)}detachFromProcess(a,E){return this.f.detachFromProcess(a,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(a){return this.f.start(a)}shutdown(a,E){return this.f.shutdown(a,E)}input(a,E){return this.f.input(a,E)}processBinary(a,E){return this.f.processBinary(a,E)}resize(a,E,f){return this.f.resize(a,E,f)}clearBuffer(a){return this.f.clearBuffer(a)}acknowledgeDataEvent(a,E){return this.f.acknowledgeDataEvent(a,E)}setUnicodeVersion(a,E){return this.f.setUnicodeVersion(a,E)}getInitialCwd(a){return this.f.getInitialCwd(a)}getCwd(a){return this.f.getCwd(a)}async getLatency(){const a=new m.$Od,E=await this.f.getLatency();return a.stop(),[{label:"ptyhostservice<->ptyhost",latency:a.elapsed()},...E]}orphanQuestionReply(a){return this.f.orphanQuestionReply(a)}installAutoReply(a,E){return this.f.installAutoReply(a,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(a){return this.f.uninstallAutoReply(a)}getDefaultSystemShell(a){return this.g?.getDefaultSystemShell(a)??(0,y.$Pl)(a??s.OS,process.env)}async getProfiles(a,E,f,i=!1){const o=await this.S();return(0,l.$Gr)(E,f,i,this.N,o,void 0,this.O,this.bb.bind(this,a))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(a,E){return this.f.getWslPath(a,E)}getRevivedPtyNewId(a,E){return this.f.getRevivedPtyNewId(a,E)}setTerminalLayoutInfo(a){return this.f.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return this.g?.getTerminalLayoutInfo(a)}async requestDetachInstance(a,E){return this.f.requestDetachInstance(a,E)}async acceptDetachInstanceReply(a,E){return this.f.acceptDetachInstanceReply(a,E)}async freePortKillProcess(a){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(a)}async serializeTerminalState(a){return this.f.serializeTerminalState(a)}async reviveTerminalProcesses(a,E,f){return this.f.reviveTerminalProcesses(a,E,f)}async refreshProperty(a,E){return this.f.refreshProperty(a,E)}async updateProperty(a,E,f){return this.f.updateProperty(a,E,f)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(a){this.ab(),this.s=setTimeout(()=>this.Y(),a?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(a,E){return this.j.createRequest({workspaceId:a,originalText:E})}async acceptPtyHostResolvedVariables(a,E){this.j.acceptReply(a,E)}};e.$Hr=g,e.$Hr=g=Ee([ie(1,D.$ui),ie(2,S.$ij),ie(3,S.$jj)],g)}),define(re[70],oe([0,1,15,3,2,4,17,6,34]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=e.$_8b=void 0;const u="#FFFFFF",p="#1E1E1E",v="#000000",b="#FFFFFF",l="theme",y="themeBackground",m="windowSplash";e.$_8b=(0,S.$1h)("themeMainService");let $=class extends s.$Sc{constructor(h,a){super(),this.b=h,this.c=a,this.a=this.B(new R.$Sd),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?v:b;let a=this.b.getItem(y,null);if(!a)switch(this.b.getItem(l,"vs-dark").split(" ")[0]){case"vs":a=u;break;case"hc-black":a=v;break;case"hc-light":a=b;break;default:a=p}return M.$j&&a.toUpperCase()===p&&(a="#171717"),a}saveWindowSplash(h,a){this.b.setItems([{key:l,data:a.baseTheme},{key:y,data:a.colorInfo.background},{key:m,data:a}]),typeof h=="number"&&this.f(h,a)}f(h,a){for(const E of P.BrowserWindow.getAllWindows())if(E.id===h){E.setBackgroundColor(a.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$a9b=$,e.$a9b=$=Ee([ie(0,d.$4N),ie(1,D.$ui)],$)}),define(re[126],oe([0,1,3,17,6,5]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.ProvidedOnAutoForward=e.$mv=e.TunnelPrivacyId=e.TunnelProtocol=e.$lv=e.$kv=void 0,e.$kv=(0,s.$1h)("tunnelService"),e.$lv=(0,s.$1h)("sharedTunnelsService");var D;(function($){$.Http="http",$.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(S||(e.TunnelPrivacyId=S={}));function d($){return!!$.forwardPort}e.$mv=d;var u;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function p($){if($.scheme!=="http"&&$.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(g)return{address:g[1],port:+g[2]}}e.$nv=p,e.$ov=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v($){return e.$ov.indexOf($)>=0}e.$pv=v,e.$qv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b($){return e.$qv.indexOf($)>=0}e.$rv=b;function l($,g,h,a){if(h===1)return!1;if(h===2&&b(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(E?.length===4&&parseInt(E[1])>=18)return!1}return $<1024}e.$sv=l;class y{constructor(g,h,a){this.remoteAddress=g,this.localAddress=h,this.b=a,this.a=new P.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$tv=y;let m=class{constructor(g,h){this.j=g,this.k=h,this.a=new P.$Sd,this.onTunnelOpened=this.a.event,this.b=new P.$Sd,this.onTunnelClosed=this.b.event,this.c=new P.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],h=Array.from(this.e.values());for(const a of h){const E=Array.from(a.values());for(const f of E){const i=await f.value;i&&typeof i!="string"&&g.push(i)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:h}of g.values())await h.then(a=>typeof a!="string"?a?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,h,a,E,f){this.p(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:a,privacy:E,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(b(g)||v(g))&&(g=e.$ov[0]);const a=this.r(g,h);if(a)return++a.refcount,a.value}openTunnel(g,h,a,E,f,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${a} on local port ${f}.`);const t=this.f??g;if(!t)return;if(h||(h="localhost"),E||(E=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,h,a,E,f,i,o,r);return n?n.then(c=>{if(c){if(typeof c=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,a),c}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.n(c);return(c.tunnelRemoteHost!==h||c.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this.e.get(g.tunnelRemoteHost);if(h){const a=h.get(g.tunnelRemotePort);a&&(a.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,a))}}}}async o(g,h,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const E=a.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(h),E}}async closeTunnel(g,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const a=this.e.get(g);if(a&&a.has(h)){const E=a.get(h);E.refcount=0,await this.o(g,h,E)}}p(g,h,a){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(h,{refcount:1,value:a})}async q(g,h){const a=this.e.get(g);if(a){const E=a.get(h),f=E?await E.value:void 0;(!f||typeof f=="string")&&a.delete(h),a.size===0&&this.e.delete(g)}}r(g,h){const a=[g];v(g)?(a.push(...e.$ov),a.push(...e.$qv)):b(g)&&a.push(...e.$qv);const E=a.map(f=>this.e.get(f));for(const f of E){const i=f?.get(h);if(i)return i}}canTunnel(g){return!!p(g)}t(g,h,a,E,f,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${a} on local port ${E}.`);const r=a;this.i.add(r);const t=E===void 0?a:E,n={elevationRequired:f?this.isPortPrivileged(t):!1},c={remoteAddress:{host:h,port:a},localAddressPort:E,privacy:i,public:i?i!==S.Private:void 0,protocol:o},w=g.forwardPort(c,n);return w?(this.p(h,a,w),w.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),w}};e.$uv=m,e.$uv=m=Ee([ie(0,M.$ij),ie(1,R.$ui)],m)}),define(re[49],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bV=e.$aV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$aV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$bV=(0,P.$1h)("updateService")}),define(re[264],oe([0,1,4,188,58,43]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$sn.as(s.$xn.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[265],oe([0,1,3,49]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0b=e.$i0b=void 0;class s{constructor(S){this.a=S}listen(S,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(S,d,u){switch(d){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${d}`)}}e.$i0b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Sd,this.onStateChange=this.a.event,this.b=R.$aV.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$j0b=M}),define(re[40],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=void 0,e.$Uk=(0,P.$1h)("IUriIdentityService")}),define(re[266],oe([0,1,40,207,16,19,141,3,2]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class u{static{this._clock=0}constructor(b){this.uri=b,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let p=class{constructor(b){this.g=b,this.c=new d.$Rc,this.f=2**16;const l=new Map,y=m=>{let $=l.get(m.scheme);return $===void 0&&($=b.hasProvider(m)&&!this.g.hasCapability(m,1024),l.set(m.scheme,$)),$};this.c.add(S.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(m=>{l.delete(m.scheme)})),this.extUri=new M.$rg(y),this.d=new D.$Kr((m,$)=>this.extUri.compare(m,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,M.$Dg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new u(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((y,m)=>y[1].time<m[1].time?1:y[1].time>m[1].time?-1:0);u._clock=0,this.d.clear();const l=this.f*.5;for(let y=0;y<l;y++)this.d.set(b[y][0],b[y][1].touch())}};e.$Lr=p,e.$Lr=p=Ee([ie(0,s.$kk)],p),(0,R.$Ir)(P.$Uk,p,1)}),define(re[127],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4U=void 0,e.$4U=(0,P.$1h)("urlService")}),define(re[267],oe([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=e.$q0b=void 0;class R{constructor(S){this.a=S}listen(S,d){throw new Error(`Event not found: ${d}`)}call(S,d,u){switch(d){case"handleURL":return this.a.handleURL(P.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${d}`)}}e.$q0b=R;class s{constructor(S){this.a=S}handleURL(S,d){return this.a.call("handleURL",[S.toJSON(),d])}}e.$r0b=s;class M{constructor(S,d){this.a=S,this.b=d}async routeCall(S,d,u,p){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(u)&&u.length>0){const v=P.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const l=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${l}"`,v.toString(!0));const y=new RegExp(`window:${l}`),m=S.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),y.test($.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,d,u,p)}routeEvent(S,d){throw new Error(`Event not found: ${d}`)}}e.$s0b=M}),define(re[268],oe([0,1,8,2,7,27]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6U=e.$5U=void 0;class D extends R.$Sc{constructor(){super(...arguments),this.a=new Set}open(u,p){const v=[...this.a.values()];return(0,P.$5g)(v.map(b=>()=>b.handleURL(u,p)),void 0,!1).then(b=>b||!1)}registerHandler(u){return this.a.add(u),(0,R.$Qc)(()=>this.a.delete(u))}}e.$5U=D;let S=class extends D{constructor(u){super(),this.b=u}create(u){let{authority:p,path:v,query:b,fragment:l}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&v&&v.indexOf("/")!==0&&(v=`/${v}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:v,query:b,fragment:l})}};e.$6U=S,e.$6U=S=Ee([ie(0,M.$Aj)],S)}),define(re[269],oe([0,1,15,8,3,2,4,7]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0b=void 0;class d extends M.$Sc{constructor(p,v,b,l,y,m){if(super(),this.c=v,this.f=m,this.a=[],this.b=0,p&&(m.trace("ElectronURLListener initialUrisToHandle:",p.map(h=>h.originalUrl)),this.a=p),D.$i){const h=l.isBuilt?[]:[`"${l.appRoot}"`];h.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const $=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(h,a)=>({event:h,url:a})),({event:h,url:a})=>(h.preventDefault(),a));this.B($(h=>{const a=this.g(h);a&&this.c.open(a,{originalUrl:h})})),b.getWindows().filter(h=>h.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(b.onDidSignalReadyWindow)(()=>this.h())))}g(p){try{return S.URI.parse(p)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),p.push(v));p.length!==0&&(this.a=p,(0,R.$3g)(()=>this.h(),500,this.q))}}e.$t0b=d}),define(re[270],oe([0,1,3,2,16,57,31]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=void 0;class S extends R.$Sc{constructor(u,p,v,b,l,y){super(),this.f=u,this.g=p,this.h=v,this.j=b,this.m=l,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Sd),this.onDidChangeFile=this.a.event,this.b=M.$7h.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,p){return this.g.open(this.t(u),p)}close(u){return this.g.close(u)}read(u,p,v,b,l){return this.g.read(u,p,v,b,l)}write(u,p,v,b,l){return this.g.write(u,p,v,b,l)}watch(u,p){this.b.set(u,u);const v=this.g.watch(this.t(u),p);return(0,R.$Qc)(()=>{this.b.delete(u),v.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,p,v){return this.g.rename(this.t(u),this.t(p),v)}readFile(u,p){return this.g.readFile(this.t(u),p)}readFileStream(u,p,v){return this.g.readFileStream(this.t(u),p,v)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,p,v){return this.g.writeFile(this.t(u),p,v)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,p){return this.g.delete(this.t(u),p)}copy(u,p,v){if((0,s.$ok)(this.g))return this.g.copy(this.t(u),this.t(p),v);throw new Error("copy not supported")}cloneFile(u,p){if((0,s.$pk)(this.g))return this.g.cloneFile(this.t(u),this.t(p));throw new Error("clone not supported")}s(u){const p=[];for(const v of u){if(v.resource.scheme!==this.f)continue;const b=this.u(v.resource);this.b.findSubstr(b)&&p.push({resource:b,type:v.type,cId:v.cId})}p.length&&(this.n.debug("User data changed"),this.a.fire(p))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$70b=S}),define(re[271],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0,e.$N0b="utilityProcessWorker"}),define(re[272],oe([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=void 0,e.$u0b=(0,P.$1h)("webviewManagerService")}),define(re[273],oe([0,1,15,2,13,7]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=void 0;class D extends R.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,d)}b(d,u){try{const p=M.URI.parse(d.url),v=D.a.get(p.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,l=s.$jg.asFileUri(b);return u({path:l.fsPath,headers:{...s.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$v0b=D}),define(re[60],oe([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=e.$vC=e.$uC=e.$tC=void 0,e.$tC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(b){return typeof b.parentId=="number"}e.$uC=R;function s(b){return!!b.workspaceUri}e.$vC=s;function M(b){return!!b.folderUri}e.$wC=M;function D(b){return!!b.fileUri}e.$xC=D;function S(b){const l=d(b),y=b.getValue("window.menuBarVisibility");return y==="default"||l==="native"&&y==="compact"||P.$j&&P.$m?"classic":y}e.$yC=S;function d(b){if(P.$o)return"custom";const l=b.getValue("window");if(l){if(P.$j&&l.nativeTabs===!0||P.$j&&l.nativeFullScreen===!1)return"native";const $=l.titleBarStyle;if($==="native"||$==="custom")return $}return P.$k?"native":"custom"}e.$zC=d;function u(b){return!(!P.$i||P.$o||d(b)==="native")}e.$AC=u;function p(b){const l=b.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}e.$BC=p;function v(b=0){return Math.pow(1.2,b)}e.$CC=v}),define(re[128],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$W8b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var R;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$W8b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(re[274],oe([0,1,8,3,2]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=void 0;class M extends s.$Sc{constructor({onDidOpenMainWindow:S,onDidFocusMainWindow:d,getActiveWindowId:u}){super(),this.a=this.B(new s.$Rc),R.Event.latch(R.Event.any(S,d))(this.f,this,this.a),this.b=(0,P.$Og)(()=>u()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$B0b=M}),define(re[30],oe([0,1,192,9,57,19,7,6,13]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,S.$1h)("contextService");function u(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$$h=u;function p(t){return typeof t?.id=="string"&&!u(t)&&!b(t)}e.$_h=p,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function v(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,R.$nc)(t)}:n?e.$ai:e.$bi;const c=t;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$ci=v;function b(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$di=b;function l(t){const n=t;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const c=t;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(t?.id)return{id:t.id}}e.$ei=l;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$fi=m;function $(t){const n=t;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$gi=$;class g{constructor(n,c,w,A,I){this.h=n,this.j=w,this.k=A,this.l=I,this.c=s.$7h.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$7h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=g;class h{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Cg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=h;function a(t){return new h({uri:t,index:0,name:(0,M.$yg)(t)},{uri:t.toString()})}e.$ji=a,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,P.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function E(t,n){return M.$tg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$oi=E;function f(t){let n;return D.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===d.Schemas.tmp}e.$pi=f,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$qi}e.$ri=i;function o(t,n){return!E(t,n)&&!f(t)}e.$si=o;function r(t){return(typeof t=="string"?(0,R.$oc)(t):(0,M.$Ag)(t))===e.$li}e.$ti=r}),define(re[53],oe([0,1,15,8,45,47,2,85,4,21,167,115,6,5,27,30]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=e.$f9b=void 0,e.$f9b=(0,b.$1h)("dialogMainService");let $=class{constructor(h,a){this.d=h,this.e=a,this.a=new Map,this.b=new Map,this.c=new R.$8g}pickFileFolder(h,a){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},a)}pickFolder(h,a){return this.f({...h,pickFolders:!0,title:(0,p.localize)(1,null)},a)}pickFile(h,a){return this.f({...h,pickFiles:!0,title:(0,p.localize)(2,null)},a)}pickWorkspace(h,a){const E=(0,p.localize)(3,null),f=(0,M.$Mv)((0,p.localize)(4,null)),i=m.$mi;return this.f({...h,pickFiles:!0,title:E,filters:i,buttonLabel:f},a)}async f(h,a){const E={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(E.properties=void 0,h.pickFiles&&h.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&E.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(E,(a||P.BrowserWindow.getFocusedWindow())??void 0);if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}g(h){if(h){let a=this.b.get(h.id);return a||(a=new R.$8g,this.b.set(h.id,a)),a}else return this.c}showMessageBox(h,a){return this.g(a).queue(async()=>{const{options:E,buttonIndeces:f}=(0,v.$Tv)(h,this.e);let i;return a?i=await P.dialog.showMessageBox(a,E):i=await P.dialog.showMessageBox(E),{response:f[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(h,a){const E=this.j(h,a);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(a).queue(async()=>{let f;return a?f=await P.dialog.showSaveDialog(a,h):f=await P.dialog.showSaveDialog(h),f.filePath=this.h(f.filePath),f})}finally{(0,D.$Nc)(E)}}h(h){return h&&d.$j&&(h=(0,S.$Al)(h)),h}i(h){return h.map(a=>this.h(a))}async showOpenDialog(h,a){h.defaultPath&&(await u.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const E=this.j(h,a);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(a).queue(async()=>{let f;return a?f=await P.dialog.showOpenDialog(a,h):f=await P.dialog.showOpenDialog(h),f.filePaths=this.i(f.filePaths),f})}finally{(0,D.$Nc)(E)}}j(h,a){if(!a)return D.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let E=this.a.get(a.id);E||(E=new Set,this.a.set(a.id,E));const f=(0,s.$Oi)(h);if(!E.has(f))return this.d.trace("[DialogMainService]: new file dialog lock created",h),E.add(f),(0,D.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),E?.delete(f),E?.size===0&&this.a.delete(a.id)})}};e.$g9b=$,e.$g9b=$=Ee([ie(0,l.$ij),ie(1,y.$Aj)],$)}),define(re[275],oe([0,1,3,2,77,30]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;class D extends R.$Sc{static{this.a=100}constructor(d,u){super(),this.f=d,this.g=u,this.b=this.B(new P.$Sd),this.c=new Map,this.h(u.applicationStorage,this.b)}h(d,u){this.B(P.Event.debounce(d.onDidChangeStorage,(p,v)=>(p?p.push(v):p=[v],p),D.a)(p=>{p.length&&u.fire(this.j(p,d))}))}j(d,u){const p=new Map,v=new Set;return d.forEach(b=>{const l=u.get(b.key);typeof l=="string"?p.set(b.key,l):v.add(b.key)}),{changed:Array.from(p.entries()),deleted:Array.from(v.values())}}listen(d,u,p){switch(u){case"onDidChangeStorage":{const v=p.profile?(0,s.$xh)(p.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.B(new P.$Sd),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${u}`)}async call(d,u,p){const v=p.profile?(0,s.$xh)(p.profile):void 0,b=(0,M.$ei)(p.workspace),l=await this.m(v,b);switch(u){case"getItems":return Array.from(l.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[m,$]of y.insert)l.set(m,$);y.delete?.forEach(m=>l.delete(m));break}case"optimize":return l.optimize();case"isUsed":{const y=p.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${u}`)}}async m(d,u){let p;u?p=this.g.workspaceStorage(u):d?p=this.g.profileStorage(d):p=this.g.applicationStorage;try{await p.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":d?"profile":"application"} storage due to ${v}`)}return p}}e.$f0b=D}),define(re[41],oe([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,25,12]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.ProfileResourceType=void 0;var a;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(a||(e.ProfileResourceType=a={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Vk=E,e.$Wk=(0,p.$1h)("IUserDataProfilesService");function f(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Xk=f;function i(t,n,c,w,A,I){return{id:t,name:n,location:c,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:I&&A?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Cg)(c,"globalStorage"),settingsResource:I&&A?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Cg)(c,"settings.json"),keybindingsResource:I&&A?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Cg)(c,"keybindings.json"),tasksResource:I&&A?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Cg)(c,"tasks.json"),snippetsHome:I&&A?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Cg)(c,"snippets"),extensionsResource:I&&A?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Cg)(c,"extensions.json"),cacheHome:(0,M.$Cg)(w,t),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Yk=i;let o=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,c,w,A){super(),this.t=n,this.u=c,this.w=w,this.y=A,this.f=!0,this.h=this.B(new R.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Cg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Cg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),c=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,h.$Df)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}c.push(i((0,M.$zg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const w=new l.$Ac,A=new Map;if(c.length)try{const I=this.Q();if(I.workspaces)for(const[k,C]of Object.entries(I.workspaces)){const j=D.URI.parse(k),F=c.find(N=>N.id===C);F&&w.set(j,F)}if(I.emptyWindows)for(const[k,C]of Object.entries(I.emptyWindows)){const j=c.find(F=>F.id===C);j&&A.set(k,j)}}catch(I){this.y.error(I)}this.z={profiles:c,workspaces:w,emptyWindows:A}}return this.z}D(){const n=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",w=new RegExp(`${(0,g.$Ke)(c)}\\s(\\d+)`);let A=0;for(const k of this.profiles){const C=w.exec(k.name),j=C?parseInt(C[1]):0;A=j>A?j:A}const I=`${c} ${A+1}`;return this.createProfile((0,P.$Oi)((0,$.$lg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,c,w){return this.createProfile((0,P.$Oi)((0,$.$lg)()).toString(16),n,c,w)}async createProfile(n,c,w,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,c,w);return A&&await this.setProfileForWorkspace(A,I),I}async F(n,c,w){if(!(0,h.$Df)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(c);return A||(A=(async()=>{try{const I=this.profiles.find(j=>j.name===c||j.id===n);if(I)return I;const k=i(n,c,(0,M.$Cg)(this.profilesHome,n),this.g,w,this.defaultProfile);await this.u.createFolder(k.location);const C=[];return this.j.fire({profile:k,join(j){C.push(j)}}),await m.Promises.settled(C),this.I([k],[],[]),k}finally{this.r.delete(c)}})(),this.r.set(c,A)),A}async updateProfile(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(A=>A.id===n.id);if(!w)throw new Error(`Profile '${n.name}' does not exist`);return w=i(w.id,c.name??w.name,w.location,this.g,{shortName:c.shortName??w.shortName,icon:c.icon===null?void 0:c.icon??w.icon,transient:c.transient??w.isTransient,useDefaultFlags:c.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(A=>A.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const w=[];this.m.fire({profile:c,join(A){w.push(A)}});try{await Promise.allSettled(w)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(A){(0,u.$Bk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(A=>A.id===c.id);if(!w)throw new Error(`Profile '${c.name}' does not exist`);this.L(n,w)}unsetWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.G(n);return D.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(n){return(0,b.$$h)(n)?n.uri:(0,b.$di)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location)))}I(n,c,w){const A=[...this.profiles,...n],I=[];this.s.profiles=[];for(let k of A)k.isDefault||c.some(C=>k.id===C.id)||(k=w.find(C=>k.id===C.id)??k,k.isTransient?this.s.profiles.push(k):I.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,c,w)}J(n,c,w){this.h.fire({added:n,removed:c,updated:w,all:this.profiles})}L(n,c,w){w=c?.isTransient?!0:w,w||this.L(n,void 0,!0);const A=this.G(n),I=w?this.s:this.C;D.URI.isUri(A)?(I.workspaces.delete(A),c&&I.workspaces.set(A,c)):(I.emptyWindows.delete(A),c&&I.emptyWindows.set(A,c)),w||this.M()}M(){const n={};for(const[w,A]of this.C.workspaces.entries())n[w.toString()]=A.id;const c={};for(const[w,A]of this.C.emptyWindows.entries())c[w.toString()]=A.id;this.R({workspaces:n,emptyWindows:c}),this.z=void 0}N(n){const c={},w=this.D();if(n.workspaces)for(const[I,k]of Object.entries(n.workspaces)){const C=D.URI.parse(k);c[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}const A={};if(n.emptyWindows)for(const[I,k]of Object.entries(n.emptyWindows)){const C=D.URI.parse(k);A[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}return{workspaces:c,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Zk=o,e.$Zk=o=Ee([ie(0,d.$8h),ie(1,u.$kk),ie(2,y.$Uk),ie(3,v.$ij)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$1k=r}),define(re[81],oe([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,28]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class a extends Error{constructor(r,t){super(r),this.code=t}}e.$Fp=a,e.$Gp=(0,v.$1h)("IExtensionsProfileScannerService");let E=class extends s.$Sc{constructor(r,t,n,c,w,A){super(),this.j=r,this.m=t,this.n=n,this.r=c,this.s=w,this.t=A,this.b=this.B(new M.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],c=[];try{return await this.u(t,w=>{const A=[];for(const I of w)r.some(([k])=>(0,u.$Lo)(k.identifier,I.identifier)&&k.manifest.version!==I.version)?n.push(I):A.push(I);for(const[I,k]of r){const C=A.findIndex(F=>(0,u.$Lo)(F.identifier,I.identifier)&&F.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:k};C===-1?(c.push(j),A.push(j)):A.splice(C,1,j)}return c.length&&this.b.fire({extensions:c,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),A}),c.length&&this.c.fire({extensions:c,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),c}catch(w){throw c.length&&this.c.fire({extensions:c,error:w,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:w,profileLocation:t}),w}}async updateMetadata(r,t){const n=[];return await this.u(t,c=>{const w=[];for(const A of c){const I=r.find(([k])=>(0,u.$Lo)(k.identifier,A.identifier)&&k.manifest.version===A.version);I&&(A.metadata={...A.metadata,...I[1]},n.push(A)),w.push(A)}return w}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,c=>{const w=[];for(const A of c)(0,u.$Lo)(A.identifier,r.identifier)?n.push(A):w.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:t}),w}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:t}),c}}async u(r,t,n){return this.F(r).queue(async()=>{let c=[],w;try{const A=await this.m.readFile(r);w=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,p.$Bk)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(w=await this.D()),!w&&n?.bailOutWhenFileNotFound)throw new a((0,$.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(w){Array.isArray(w)||this.w(r);let A=!1;for(const I of w){f(I)||this.w(r);let k;if((0,m.$Df)(I.relativeLocation)&&I.relativeLocation)k=this.z(I.relativeLocation);else if((0,m.$Df)(I.location))k=this.z(I.location),A=!0,I.relativeLocation=I.location,I.location=k.toJSON();else{k=S.URI.revive(I.location);const C=this.y(k);C&&(A=!0,I.relativeLocation=C)}c.push({identifier:I.identifier,location:k,version:I.version,metadata:I.metadata})}A&&await this.m.writeFile(r,R.$ge.fromString(JSON.stringify(w)))}if(t){c=t(c);const A=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,R.$ge.fromString(JSON.stringify(A)))}return c})}w(r){const t=new a(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(w){if((0,p.$Bk)(w)===1)return;throw w}this.t.info("Migrating extensions from old default profile location",r.toString());let c;try{const w=JSON.parse(n);Array.isArray(w)&&w.every(A=>f(A))?c=w:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",w)}catch(w){this.t.error(w)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ge.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(w){if((0,p.$Bk)(w)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw w}try{await this.m.del(r)}catch(w){(0,p.$Bk)(w)!==1&&this.t.error(w)}try{await this.m.del(t)}catch(w){(0,p.$Bk)(w)!==1&&this.t.error(w)}return c})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$8g,this.h.set(r,t)),t}};e.$Hp=E,e.$Hp=E=Ee([ie(1,p.$kk),ie(2,l.$Wk),ie(3,y.$Uk),ie(4,g.$ol),ie(5,b.$ij)],E);function f(o){return(0,m.$Ff)(o)&&(0,d.$io)(o.identifier)&&(i(o.location)||(0,m.$Df)(o.location)&&o.location)&&((0,m.$Kf)(o.relativeLocation)||(0,m.$Df)(o.relativeLocation))&&o.version&&(0,m.$Df)(o.version)}function i(o){return o?(0,m.$Df)(o.path)&&(0,m.$Df)(o.scheme):!1}}),define(re[129],oe([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,27,3,77,81,41,40,203]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.Translations=void 0;var j;(function(ue){function K(X,H){if(X===H)return!0;const L=Object.keys(X),T=new Set;for(const V of Object.keys(H))T.add(V);if(L.length!==T.size)return!1;for(const V of L){if(X[V]!==H[V])return!1;T.delete(V)}return T.size===0}ue.equals=K})(j||(e.Translations=j={})),e.$Kp=(0,r.$1h)("IExtensionsScannerService");let F=class extends u.$Sc{constructor(K,X,H,L,T,V,q,te,he,G,O,U){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=X,this.r=H,this.s=L,this.t=T,this.u=V,this.w=q,this.y=te,this.z=he,this.C=G,this.D=O,this.F=U,this.g=this.B(new c.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,l.$Cg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Q,this.s,this.h)),this.m=this.B(this.F.createInstance(Q,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Wo)(this.w,this.y)),this.G}async scanAllExtensions(K,X,H){const[L,T]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(X)]),V=H?await this.scanExtensionsUnderDevelopment(K,[...L,...T]):[];return this.L(L,T,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const X=[];X.push(this.M(!!K.useCache,K.language)),X.push(this.N(K.language,!!K.checkControlFile));const[H,L]=await Promise.all(X);return this.J([...H,...L],0,K,!1)}async scanUserExtensions(K){const X=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const H=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(X,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,H),T=K.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let V;try{V=await T.scanExtensions(L)}catch(q){if(q instanceof A.$Fp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await T.scanExtensions(L);else throw q}return V=await this.J(V,1,K,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(K,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===p.Schemas.file).map(async L=>{const T=await this.P(L,!1,1,!0,K.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(q=>(q.type=X.find(te=>(0,E.$Lo)(te.identifier,q.identifier))?.type??q.type,this.n.validate(q,T)))}))).flat();return this.J(H,"development",K,!0)}return[]}async scanExistingExtension(K,X,H){const L=await this.P(K,!1,X,!0,H.language,!0,void 0),T=await this.n.scanExtension(L);return!T||!H.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(K,X,H){const L=await this.P(K,!1,X,!0,H.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(L);return this.J(T,X,H,!0)}async scanMetadata(K){const X=(0,l.$Cg)(K,"package.json"),H=(await this.w.readFile(X)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(K,X){const H=(0,l.$Cg)(K,"package.json"),L=(await this.w.readFile(H)).value.toString(),T=JSON.parse(L);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,T.__metadata={...T.__metadata,...X},await this.w.writeFile((0,l.$Cg)(K,"package.json"),M.$ge.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof A.$Fp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ge.fromString(JSON.stringify([])))}catch(X){(0,o.$Bk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,X,H,L){return H.includeAllVersions||(K=this.L(X===0?K:void 0,X===1?K:void 0,X==="development"?K:void 0,await this.getTargetPlatform(),L)),H.includeInvalid||(K=K.filter(T=>T.isValid)),K.sort((T,V)=>{const q=v.$nc(T.location.fsPath),te=v.$nc(V.location.fsPath);return q<te?-1:q>te?1:0})}L(K,X,H,L,T){const V=(te,he,G)=>{if(te.isValid&&!he.isValid)return!1;if(te.isValid===he.isValid){if(T&&y.gt(te.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(y.eq(te.manifest.version,he.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${te.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${he.location.path}.`),!0},q=new f.$hm;return K?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),X?.forEach(te=>{const he=q.get(te.identifier.id);if(!he&&K&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),H?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!0))&&q.set(te.identifier.id,te),q.set(te.identifier.id,te)}),[...q.values()]}async M(K,X){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),T=await(K&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",T.length),T}async N(K,X){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const L=X?await this.O():{},T=[],V=g.URI.file(v.$hc(v.$jc(p.$jg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const he=L[te.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":T.push((0,l.$Cg)(V,te.name));break;default:T.push(g.URI.file(he));break}}const q=await Promise.all(T.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,K,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Hb)(q)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,X,H,L,T,V,q){const te=await this.f(T??b.$w),he=await this.Q(K),G=X&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=G?await this.Q(G):void 0;return new N(K,he,G,O,X,q,H,L,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,te)}async Q(K){try{const X=await this.w.stat(K);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Lp=F,e.$Lp=F=Ee([ie(4,I.$Wk),ie(5,A.$Gp),ie(6,o.$kk),ie(7,t.$ij),ie(8,a.$8h),ie(9,n.$Aj),ie(10,k.$Uk),ie(11,r.$Zh)],F);class N{constructor(K,X,H,L,T,V,q,te,he,G,O,U,x,z,Z){this.location=K,this.mtime=X,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=L,this.profile=T,this.profileScanOptions=V,this.type=q,this.excludeObsolete=te,this.validate=he,this.productVersion=G,this.productDate=O,this.productCommit=U,this.devMode=x,this.language=z,this.translations=Z}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,X){return(0,l.$vg)(K.location,X.location)&&K.mtime===X.mtime&&(0,l.$vg)(K.applicationExtensionslocation,X.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&K.profile===X.profile&&s.$kn(K.profileScanOptions,X.profileScanOptions)&&K.type===X.type&&K.excludeObsolete===X.excludeObsolete&&K.validate===X.validate&&K.productVersion===X.productVersion&&K.productDate===X.productDate&&K.productCommit===X.productCommit&&K.devMode===X.devMode&&K.language===X.language&&j.equals(K.translations,X.translations)}}e.$Mp=N;let Y=class extends u.$Sc{constructor(K,X,H,L,T){super(),this.f=K,this.g=X,this.h=H,this.j=L,this.m=T}async scanExtensions(K){const X=K.profile?await this.r(K):await this.n(K);let H={};if(K.excludeObsolete&&K.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(L)}catch{}return(0,$.$Qf)(H)?X:X.filter(L=>!H[E.$Mo.create(L).toString()])}async n(K){const X=await this.j.resolve(K.location);if(!X.children?.length)return[];const H=await Promise.all(X.children.map(async L=>{if(!L.isDirectory||K.type===1&&(0,l.$zg)(L.resource).indexOf(".")===0)return null;const T=new N(L.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(T)}));return(0,P.$Hb)(H).sort((L,T)=>L.location.path<T.location.path?-1:1)}async r(K){let X=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){X=X.filter(L=>!L.metadata?.isApplicationScoped);const H=await this.s(K.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,K);X.push(...H)}return X}async s(K,X,H){const L=await this.g.scanProfileExtensions(K,H.profileScanOptions);if(!L.length)return[];const T=await Promise.all(L.map(async V=>{if(X(V)){const q=new N(V.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(q,V.metadata)}return null}));return(0,P.$Hb)(T)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,l.$Cg)(K.location,"package.json"))){const X=await this.scanExtension(K);return X?[X]:[]}else return await this.scanExtensions(K)}catch(X){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,D.$0)(X)),[]}}async scanExtension(K,X){try{let H=await this.scanExtensionManifest(K.location);if(H){H.publisher||(H.publisher=f.$bm),X=X??H.__metadata,delete H.__metadata;const L=(0,E.$Qo)(H.publisher,H.name),T=X?.id?{id:L,uuid:X.id}:{id:L},V=X?.isSystem?0:K.type,q=V===0||!!X?.isBuiltin;H=await this.t(K.location,H,N.createNlsConfiguration(K));const te={type:V,identifier:T,manifest:H,location:K.location,isBuiltin:q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return K.validate?this.validate(te,K):te}}catch(H){K.type!==0&&this.m.error(H)}return null}validate(K,X){let H=!0;const L=(0,i.$2o)(X.productVersion,X.productDate,X.location,K.manifest,K.isBuiltin);for(const[T,V]of L)T===m.default.Error&&(H=!1,this.m.error(this.z(X.location,V)));return K.isValid=H,K.validations=L,K}async scanExtensionManifest(K){const X=(0,l.$Cg)(K,"package.json");let H;try{H=(await this.j.readFile(X)).value.toString()}catch(T){return(0,o.$Bk)(T)!==1&&this.m.error(this.z(K,(0,h.localize)(0,null,X.path,T.message))),null}let L;try{L=JSON.parse(H)}catch{const V=[];(0,S.$9m)(H,V);for(const q of V)this.m.error(this.z(K,(0,h.localize)(1,null,X.path,q.offset,q.length,(0,d.$Ip)(q.error))));return null}return(0,S.$fn)(L)!=="object"?(this.m.error(this.z(K,(0,h.localize)(2,null,X.path))),null):L}async t(K,X,H){const L=await this.u(K,X,H);if(L)try{const T=[],V=await this.w(L.default,T);if(T.length>0)return T.forEach(te=>{this.m.error(this.z(K,(0,h.localize)(3,null,L.default?.path,(0,d.$Ip)(te.error))))}),X;if((0,S.$fn)(L)!=="object")return this.m.error(this.z(K,(0,h.localize)(4,null,L.default?.path))),X;const q=L.values||Object.create(null);return(0,C.$Jp)(this.m,X,q,V)}catch{}return X}async u(K,X,H){const L=(0,l.$Cg)(K,"package.nls.json"),T=(he,G)=>{G.forEach(O=>{this.m.error(this.z(K,(0,h.localize)(5,null,he?.path,(0,d.$Ip)(O.error))))})},V=he=>{this.m.error(this.z(K,(0,h.localize)(6,null,he?.path)))},q=`${X.publisher}.${X.name}`,te=H.translations[q];if(te)try{const he=g.URI.file(te),G=(await this.j.readFile(he)).value.toString(),O=[],U=(0,S.$9m)(G,O);return O.length>0?(T(he,O),{values:void 0,default:L}):(0,S.$fn)(U)!=="object"?(V(he),{values:void 0,default:L}):{values:U.contents?U.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let G;try{G=await this.y(K,H)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const O=(await this.j.readFile(G.localized)).value.toString(),U=[],x=(0,S.$9m)(O,U);return U.length>0?(T(G.localized,U),{values:void 0,default:G.original}):(0,S.$fn)(x)!=="object"?(V(G.localized),{values:void 0,default:G.original}):{values:x,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(K,X){if(K)try{const H=(await this.j.readFile(K)).value.toString();return(0,S.$9m)(H,X)}catch{}}y(K,X){return new Promise((H,L)=>{const T=V=>{const q=(0,l.$Cg)(K,`package.nls.${V}.json`);this.j.exists(q).then(te=>{te&&H({localized:q,original:(0,l.$Cg)(K,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?H({localized:(0,l.$Cg)(K,"package.nls.json"),original:null}):(V=V.substring(0,he),T(V))})};if(X.devMode||X.pseudo||!X.language)return H({localized:(0,l.$Cg)(K,"package.nls.json"),original:null});T(X.language)})}z(K,X){return`[${K.path}]: ${X}`}};Y=Ee([ie(1,A.$Gp),ie(2,k.$Uk),ie(3,o.$kk),ie(4,t.$ij)],Y);let Q=class extends Y{constructor(K,X,H,L,T,V,q){super(X,L,T,V,q),this.G=K,this.H=H,this.D=this.B(new R.$Yg(3e3)),this.F=this.B(new c.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(K){const X=this.M(K),H=await this.I(X);if(this.C=K,H&&H.input&&N.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),H.result.map(T=>(T.location=g.URI.revive(T.location),T));const L=await super.scanExtensions(K);return await this.J(X,{input:K,result:L}),L}async I(K){try{const X=await this.j.readFile(K),H=JSON.parse(X.value.toString());return{result:H.result,input:(0,w.$xh)(H.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",K.path,(0,D.$0)(X))}return null}async J(K,X){try{await this.j.writeFile(K,M.$ge.fromString(JSON.stringify(X)))}catch(H){this.m.debug("Error while writing the extension cache file:",K.path,(0,D.$0)(H))}}async L(){if(!this.C)return;const K=this.M(this.C),X=await this.I(K);if(!X)return;const H=X.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$kn(L,H))try{this.m.info("Invalidating Cache",H,L),await this.j.del(K),this.F.fire()}catch(T){this.m.error(T)}}M(K){const X=this.N(K);return this.h.extUri.joinPath(X.cacheHome,K.type===0?f.$am:f.$_l)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(K.location,X.extensionsResource))??this.G:this.H.defaultProfile}};Q=Ee([ie(2,I.$Wk),ie(3,A.$Gp),ie(4,k.$Uk),ie(5,o.$kk),ie(6,t.$ij)],Q);function le(ue,K){const X=(0,E.$Oo)(ue.manifest.publisher,ue.manifest.name);return{id:X,identifier:new f.$fm(X),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:K,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$Np=le;class ce extends F{constructor(K,X,H,L,T,V,q,te,he,G,O,U){super(K,X,(0,l.$Cg)(H,".vscode-oss-dev","extensions","control.json"),L,T,V,q,te,he,G,O,U),this.R=(async()=>{if(b.$z)try{const x=await this.w.readFile(g.URI.file(b.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(K){return this.R}}e.$Op=ce}),define(re[276],oe([0,1,5,41,40,28,81,16,37,7]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;let p=class extends D.$Hp{constructor(b,l,y,m,$,g){super(u.URI.file(b.extensionsPath),l,y,m,$,g)}};e.$$N=p,e.$$N=p=Ee([ie(0,d.$9h),ie(1,S.$kk),ie(2,R.$Wk),ie(3,s.$Uk),ie(4,M.$ol),ie(5,P.$ij)],p)}),define(re[277],oe([0,1,7,37,81,129,16,6,5,27,40,41]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0;let b=class extends M.$Op{constructor(y,m,$,g,h,a,E,f){super(P.URI.file(h.builtinExtensionsPath),P.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,m,$,g,h,a,E,f)}};e.$F0b=b,e.$F0b=b=Ee([ie(0,v.$Wk),ie(1,s.$Gp),ie(2,D.$kk),ie(3,d.$ij),ie(4,R.$9h),ie(5,u.$Aj),ie(6,p.$Uk),ie(7,S.$Zh)],b)}),define(re[278],oe([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=void 0;let y=class extends R.$Sc{constructor($,g,h){super(),this.c=$,this.f=h,this.a=S.$7h.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=P.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,h)=>this.j(g,h)),$.protocol.interceptFileProtocol(s.Schemas.file,(g,h)=>this.h(g,h)),this.B((0,R.$Qc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const g=(0,M.$hc)($);return this.a.get(g)?R.$Sc.None:(this.a.set(g,!0),(0,R.$Qc)(()=>this.a.delete(g)))}h($,g){const h=d.URI.parse($.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),g({error:-3})}j($,g){const h=this.m($);let a;return this.c.crossOriginIsolated&&((0,M.$nc)(h)==="workbench.html"||(0,M.$nc)(h)==="workbench-dev.html"?a=s.COI.CoopAndCoep:a=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(h)?g({path:h,headers:a}):this.b.has((0,M.$oc)(h).toLowerCase())?g({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),g({error:-3}))}m($){const g=d.URI.parse($.url),h=s.$jg.uriToFileUri(g);return(0,M.$hc)(h.fsPath)}createIPCObjectUrl(){let $;const g=d.URI.from({scheme:"vscode",path:(0,u.$lg)()}),h=g.toString(),a=async()=>$;return p.$cU.handle(h,a),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:E=>$=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),p.$cU.removeHandler(h)}}}};e.$X0b=y,e.$X0b=y=Ee([ie(0,v.$9h),ie(1,l.$Wk),ie(2,b.$ij)],y)}),define(re[96],oe([0,1,8,3,2,68,12,111,6,41]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fp=e.$ep=e.$dp=void 0,e.$dp="__$__isNewStorageMarker",e.$ep="__$__targetStorageMarker",e.$fp=(0,d.$1h)("storageService");var p;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var b;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(h){const a=h.get(e.$ep);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.$gp=l;class y extends s.$Sc{static{this.a=60*1e3}constructor(a={flushInterval:y.a}){super(),this.m=a,this.b=this.B(new R.$Vd),this.c=this.B(new R.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$ah(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(a,E,f){return R.Event.filter(this.b.event,i=>i.scope===a&&(E===void 0||i.key===E),f)}n(){this.j.value=(0,P.$eh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(a,E){const{key:f,external:i}=E;if(f===e.$ep){switch(a){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:a})}else this.b.fire({scope:a,key:f,target:this.J(a)[f],external:i})}w(a){this.f.fire({reason:a})}get(a,E,f){return this.P(E)?.get(a,f)}getBoolean(a,E,f){return this.P(E)?.getBoolean(a,f)}getNumber(a,E,f){return this.P(E)?.getNumber(a,f)}getObject(a,E,f){return this.P(E)?.getObject(a,f)}storeAll(a,E){this.y(()=>{for(const f of a)this.store(f.key,f.value,f.scope,f.target,E)})}store(a,E,f,i,o=!1){if((0,D.$Mf)(E)){this.remove(a,f,o);return}this.y(()=>{this.z(a,f,i),this.P(f)?.set(a,E,o)})}remove(a,E,f=!1){this.y(()=>{this.z(a,E,void 0),this.P(E)?.delete(a,f)})}y(a){this.b.pause(),this.c.pause();try{a()}finally{this.b.resume(),this.c.resume()}}keys(a,E){const f=[],i=this.J(a);for(const o of Object.keys(i))i[o]===E&&f.push(o);return f}z(a,E,f,i=!1){const o=this.J(E);typeof f=="number"?o[a]!==f&&(o[a]=f,this.P(E)?.set(e.$ep,JSON.stringify(o),i)):typeof o[a]=="number"&&(delete o[a],this.P(E)?.set(e.$ep,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(a){switch(a){case-1:return this.I;case 0:return this.G;default:return this.D}}L(a){const E=this.P(a);return E?l(E):Object.create(null)}isNew(a){return this.getBoolean(e.$dp,a)===!0}async flush(a=p.NONE){this.f.fire({reason:a});const E=this.P(-1),f=this.P(0),i=this.P(1);switch(a){case p.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return g(a,E,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(a){return await this.flush(),this.P(a)?.optimize()}async switch(a,E){return this.w(p.NONE),(0,u.$Vk)(a)?this.R(a,E):this.S(a,E)}M(a,E){return!(a.id===E.id||m(E)&&m(a))}N(a,E,f){this.y(()=>{const i=new Set;for(const[o,r]of a)i.add(o),E.get(o)!==r&&this.u(f,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.u(f,{key:o,external:!0})})}}e.$hp=y;function m(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$ip=m;class $ extends y{constructor(){super(),this.U=this.B(new S.$bp(new S.$cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$bp(new S.$cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$bp(new S.$cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(a=>this.u(1,a))),this.B(this.W.onDidChangeStorage(a=>this.u(0,a))),this.B(this.U.onDidChangeStorage(a=>this.u(-1,a)))}P(a){switch(a){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(a){return!1}}e.$jp=$;async function g(h,a,E,f,i,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;h.forEach((j,F)=>{t.set(F,j),n.set(F,r(j))});const c=new Map,w=new Map;a.forEach((j,F)=>{c.set(F,j),w.set(F,r(j))});const A=new Map,I=new Map;E.forEach((j,F)=>{A.set(F,j),I.set(F,r(j))}),console.group(f!==i?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const k=[];if(t.forEach((j,F)=>{k.push({key:F,value:j})}),console.table(k),console.groupEnd(),console.log(n),f!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];c.forEach((F,N)=>{j.push({key:N,value:F})}),console.table(j),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${o})`);const C=[];A.forEach((j,F)=>{C.push({key:F,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$kp=g}),define(re[279],oe([0,1,23,8,3,2,9,73,7,21,111,161,5,96,28,30,13]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=e.$48b=e.$38b=e.$28b=void 0;class g extends M.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Sd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Sd),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$bp(new p.$cp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$lh,this.whenInit=this.h.p,this.j=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===p.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(l.$dp);t===void 0?r.set(l.$dp,!0):t&&r.set(l.$dp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=p.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===b.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Od(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,P.top)(Array.from(this.f.items.entries()).map(([c,w])=>({key:c,length:w.length})),(c,w)=>w.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=p.StorageState.Closed,await this.f.close()}}class h extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,h.y)}constructor(r,t,n,c){super(n,c),this.z=r,this.C=t}async t(){return new p.$bp(new v.$HU(this.path??v.$HU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class a extends h{constructor(r,t,n,c){super(r,t,n,c)}}e.$28b=a;class E extends h{constructor(r,t,n,c){super(t.defaultProfile,r,n,c)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$rl,void 0)===void 0&&r.set(y.$rl,new Date().toUTCString());const n=r.get(y.$ql,void 0),c=new Date().toUTCString();r.set(y.$sl,typeof n>"u"?null:n),r.set(y.$ql,c)}}e.$38b=E;class f extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,f.y)}constructor(r,t,n,c,w){super(n,w),this.C=r,this.D=t,this.F=c}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new p.$bp(new v.$HU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:t?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$HU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),t=(0,D.$jc)(r,f.y);return await u.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await u.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,m.$$h)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$di)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,D.$jc)(r,f.z);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$48b=f;class i extends g{get path(){}async t(){return new p.$bp(new p.$cp,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$58b=i}),define(re[280],oe([0,1,3,2,96]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=void 0;class M extends R.$Sc{constructor(S,d,u){super(),this.b=S,this.c=d,this.f=u;const p=this.B(new R.$Tc);this.a=this.B(new P.$Sd({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new R.$Rc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,u)=>(d?d.push(u.key):d=[u.key],d),100)(d=>this.h(d))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(d,u)=>{d||(d=new Map);let p=d.get(u.profile.id);return p||d.set(u.profile.id,p={profile:u.profile,keys:[],storage:u.storage}),p.keys.push(u.key),d},100)(d=>this.j(d))),S}h(S){const d=S.includes(s.$ep)?[this.c.defaultProfile]:[],u=[];if(S=S.filter(p=>p!==s.$ep),S.length){const p=(0,s.$gp)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:S.map(v=>({key:v,scope:0,target:p[v]}))})}this.m(d,u)}j(S){const d=[],u=new Map;for(const[p,v]of S.entries()){v.keys.includes(s.$ep)&&d.push(v.profile);const b=v.keys.filter(l=>l!==s.$ep);if(b.length){const l=(0,s.$gp)(v.storage.storage);u.set(p,{profile:v.profile,changes:b.map(y=>({key:y,scope:0,target:l[y]}))})}}this.m(d,[...u.values()])}m(S,d){(S.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:S})}listen(S,d,u){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(S,d){throw new Error(`Call not found: ${d}`)}}e.$H0b=M}),define(re[281],oe([0,1,7,37,16,5,34,40,41,12,121]),function(J,e,P,R,s,M,D,S,d,u,p){"use strict";var v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=e.$8N=void 0;let l=class extends d.$Zk{static{v=this}static{this.a="profileAssociationsMigration"}constructor(g,h,a,E,f){super(a,E,h,f),this.U=g,this.W=a}O(){return this.U.getItem(v.b,[]).map(h=>({...h,location:(0,u.$Df)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):P.URI.revive(h.location)}))}Q(){const g=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$8N=l,e.$8N=l=v=Ee([ie(0,D.$3N),ie(1,S.$Uk),ie(2,R.$9h),ie(3,s.$kk),ie(4,M.$ij)],l);let y=b=class extends l{constructor(g,h,a,E,f){super(g,h,a,E,f),this.$=g}P(g){g.length?this.$.setItem(b.b,g.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(b.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(b.c,g):this.$.removeItem(b.c)}Q(){const g="workspaceAndProfileInfo",h=this.$.getItem(g,void 0);if(h){this.$.removeItem(g);const E=h.reduce((f,{workspace:i,profile:o})=>(f[P.URI.revive(i).toString()]=P.URI.revive(o).toString(),f),{});this.$.setItem(b.c,{workspaces:E})}const a=super.Q();return this.$.getItem(b.a,!1)||(this.R(a),this.$.setItem(b.a,!0)),a}};e.$9N=y,e.$9N=y=b=Ee([ie(0,D.$4N),ie(1,S.$Uk),ie(2,R.$9h),ie(3,s.$kk),ie(4,M.$ij)],y);let m=class extends y{constructor(g,h,a,E){super(new p.$7N(0,h,E,a),g,h,a,E)}async init(){return await this.$.init(),super.init()}};e.$0N=m,e.$0N=m=Ee([ie(0,S.$Uk),ie(1,R.$9h),ie(2,s.$kk),ie(3,M.$ij)],m)}),define(re[54],oe([0,1,37,16,6,5,40,41,281,34]),function(J,e,P,R,s,M,D,S,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$78b=e.$68b=void 0,e.$68b=(0,s.$2h)(S.$Wk);let p=class extends d.$9N{constructor(b,l,y,m,$){super(b,l,y,m,$)}getAssociatedEmptyWindows(){const b=[];for(const l of this.C.emptyWindows.keys())b.push({id:l});return b}};e.$78b=p,e.$78b=p=Ee([ie(0,u.$4N),ie(1,D.$Uk),ie(2,P.$9h),ie(3,R.$kk),ie(4,M.$ij)],p)}),define(re[130],oe([0,1,19,7,30]),function(J,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=e.$j9b=e.$i9b=void 0;async function M(d,u,p){for(const b of d){const l=b.openedWorkspace;if((0,s.$di)(l)){const y=await p(l);if(y){if(y.folders.some(m=>P.$tg.isEqualOrParent(u,m.uri)))return b}else if(P.$tg.isEqualOrParent(u,l.configPath))return b}}const v=d.filter(b=>(0,s.$$h)(b.openedWorkspace)&&P.$tg.isEqualOrParent(u,b.openedWorkspace.uri));if(v.length)return v.sort((b,l)=>-(b.openedWorkspace.uri.path.length-l.openedWorkspace.uri.path.length))[0]}e.$i9b=M;function D(d,u){for(const p of d)if((0,s.$di)(p.openedWorkspace)&&P.$tg.isEqual(p.openedWorkspace.configPath,u)||(0,s.$$h)(p.openedWorkspace)&&P.$tg.isEqual(p.openedWorkspace.uri,u))return p}e.$j9b=D;function S(d,u){const p=v=>u.some(b=>P.$tg.isEqual(R.URI.file(b),R.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(b=>p(b)))return v}e.$k9b=S}),define(re[97],oe([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcb=e.$jcb=e.$icb=e.$hcb=e.$gcb=e.$fcb=e.$ecb=e.$dcb=e.$ccb=e.$bcb=void 0,e.$bcb=(0,v.$1h)("workspacesService");function y(I){return I.hasOwnProperty("workspace")}e.$ccb=y;function m(I){return I.hasOwnProperty("folderUri")}e.$dcb=m;function $(I){return I.hasOwnProperty("fileUri")}e.$ecb=$;function g(I){return h(I)||a(I)}e.$fcb=g;function h(I){const k=I;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function a(I){const k=I;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(I,k,C,j,F){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let N=k?void 0:F.relativePath(j,I);if(N!==void 0)N.length===0?N=".":d.$i&&(N=f(N));else if(I.scheme===D.Schemas.file)N=I.fsPath,d.$i&&(N=f(N));else if(F.isEqualAuthority(I.authority,j.authority))N=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:N}}e.$gcb=E;function f(I){return I=(0,M.$Gv)(I),(0,P.$Zf)(I)||(I=(0,P.$Wf)(I)),I}function i(I,k,C){const j=[],F=new Set,N=C.dirname(k);for(const Y of I){let Q;if(h(Y))Y.path&&(Q=C.resolvePath(N,Y.path));else if(a(Y))try{Q=p.URI.parse(Y.uri),Q.path[0]!==S.$gc.sep&&(Q=Q.with({path:S.$gc.sep+Q.path}))}catch(le){console.warn(le)}if(Q){const le=C.getComparisonKey(Q);if(!F.has(le)){F.add(le);const ce=Y.name||C.basenameOrAuthority(Q);j.push(new l.$ii({uri:Q,name:ce,index:j.length},Y))}}}return j}e.$hcb=i;function o(I,k,C,j,F){const N=r(k,I),Y=F.dirname(k),Q=F.dirname(j),le=[];for(const X of N.folders){const H=h(X)?F.resolvePath(Y,X.path):p.URI.parse(X.uri);let L;C?L=!1:L=!h(X)||(0,S.$ic)(X.path),le.push(E(H,L,X.name,Q,F))}const ce={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ue=s.$RT(I,["folders"],le,ce);let K=s.$UT(I,ue);return(0,u.$Hg)(N.remoteAuthority,(0,b.$7k)(j))&&(K=s.$UT(K,s.$QT(K,["remoteAuthority"],ce))),K}e.$icb=o;function r(I,k){const C=R.$9m(k);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>g(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function t(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function w(I,k){const C={workspaces:[],files:[]};if(I){const j=function(N,Y){for(let Q=0;Q<N.length;Q++)try{Y(N[Q],Q)}catch(le){k.warn(`Error restoring recent entry ${JSON.stringify(N[Q])}: ${le.toString()}. Skip entry.`)}},F=I;Array.isArray(F.entries)&&j(F.entries,N=>{const Y=N.label,Q=N.remoteAuthority;t(N)?C.workspaces.push({label:Y,remoteAuthority:Q,workspace:{id:N.workspace.id,configPath:p.URI.parse(N.workspace.configPath)}}):n(N)?C.workspaces.push({label:Y,remoteAuthority:Q,folderUri:p.URI.parse(N.folderUri)}):c(N)&&C.files.push({label:Y,remoteAuthority:Q,fileUri:p.URI.parse(N.fileUri)})})}return C}e.$jcb=w;function A(I){const k={entries:[]};for(const C of I.workspaces)m(C)?k.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):k.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)k.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return k}e.$kcb=A}),define(re[98],oe([0,1,86,13,4,19]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=e.$m9b=e.$l9b=void 0,e.$l9b=128/4;function D(u){function p(){let v=u.scheme===R.Schemas.file?(0,M.$qg)(u):u.toString();return s.$k||(v=v.toLowerCase()),(0,P.createHash)("md5").update(v).digest("hex")}return{id:p(),configPath:u}}e.$m9b=D;function S(u,p){function v(){if(u.scheme!==R.Schemas.file)return(0,P.createHash)("md5").update(u.toString()).digest("hex");if(!p)return;let l;return s.$k?l=p.ino:s.$j?l=p.birthtime.getTime():s.$i&&(typeof p.birthtimeMs=="number"?l=Math.floor(p.birthtimeMs):l=p.birthtime.getTime()),(0,P.createHash)("md5").update(u.fsPath).update(l?String(l):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:u}}e.$n9b=S;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$o9b=d}),define(re[99],oe([0,1,86,87,26,282,18,14,3,2,9,4,32,42,109]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class m{traceSocketEvent(k,C){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,C)}constructor(k,C=""){this.f=!0,this.debugLabel=C,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const C=j=>{this.traceSocketEvent("read",j),k(D.$ge.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(k){const C=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(k){const C=()=>{k()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Ph=m;var $;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class h extends u.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,C){this.socket.traceSocketEvent(k,C)}constructor(k,C,j,F){super(),this.f=this.B(new d.$Sd),this.g=this.B(new d.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new a(this,C,j,F,this.f,(N,Y)=>this.m(N,Y))),this.B(this.a.onError(N=>{console.error(N),(0,S.$1)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new y.$Kh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let C=0;for(;C<k.byteLength;)this.a.writeMessage(k.slice(C,Math.min(C+262144,k.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(k,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let F=2;k.byteLength<126?F+=0:k.byteLength<2**16?F+=2:F+=8;const N=D.$ge.alloc(F),Y=C?64:0,Q=j&15;if(N.writeUInt8(128|Y|Q,0),k.byteLength<126)N.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){N.writeUInt8(126,1);let le=1;N.writeUInt8(k.byteLength>>>8&255,++le),N.writeUInt8(k.byteLength>>>0&255,++le)}else{N.writeUInt8(127,1);let le=1;N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(0,++le),N.writeUInt8(k.byteLength>>>24&255,++le),N.writeUInt8(k.byteLength>>>16&255,++le),N.writeUInt8(k.byteLength>>>8&255,++le),N.writeUInt8(k.byteLength>>>0&255,++le)}this.socket.write(D.$ge.concat([N,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),F=(j&128)>>>7,N=(j&64)>>>6,Y=j&15,Q=C.readUInt8(1),le=(Q&128)>>>7,ce=Q&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(ce===126?2:0)+(ce===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),F=(j&128)>>>7;let N=j&127,Y=1;N===126?N=C.readUInt8(++Y)*2**8+C.readUInt8(++Y):N===127&&(N=C.readUInt8(++Y)*0+C.readUInt8(++Y)*0+C.readUInt8(++Y)*0+C.readUInt8(++Y)*0+C.readUInt8(++Y)*2**24+C.readUInt8(++Y)*2**16+C.readUInt8(++Y)*2**8+C.readUInt8(++Y));let Q=0;F&&(Q=C.readUInt8(++Y)*2**24+C.readUInt8(++Y)*2**16+C.readUInt8(++Y)*2**8+C.readUInt8(++Y)),this.j.state=3,this.j.readLen=N,this.j.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),i(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Qh=h;class a extends u.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ge.alloc(0)}constructor(k,C,j,F,N,Y){super(),this.n=k,this.r=N,this.s=Y,this.a=this.B(new d.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new E(this.n,F,j,{windowBits:15})),this.f=this.B(new f(this.n,{windowBits:15})),this.B(this.b.onError(Q=>this.a.fire(Q))),this.B(this.f.onError(Q=>this.a.fire(Q)))):(this.b=null,this.f=null)}writeMessage(k,C){this.g.push({data:k,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,k);this.s(j,C)}else this.s(k,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,C){return new Promise((j,F)=>{k.write(C),k.flush(N=>j(N))})}acceptFrame(k,C,j){this.h.push({data:k,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const C=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,C,j){return new Promise((F,N)=>{k.write(C),j&&k.write(D.$ge.fromByteArray([0,0,255,255])),k.flush(Y=>F(Y))})}}class E extends u.$Sc{get recordedInflateBytes(){return this.j?D.$ge.concat(this.f):D.$ge.alloc(0)}constructor(k,C,j,F){super(),this.h=k,this.j=C,this.a=this.B(new d.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(F),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(D.$ge.wrap(N))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$ge.concat(this.g);this.g.length=0,k(C)})}}class f extends u.$Sc{constructor(k,C){super(),this.g=k,this.a=this.B(new d.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$ge.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$ge.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),k(C)})}}function i(I,k){if(k===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const ce=I.readUInt32BE(le*4);I.writeUInt32BE(ce^k,le*4)}const j=C*4,F=I.byteLength-j,N=k>>>24&255,Y=k>>>16&255,Q=k>>>8&255;F>=1&&I.writeUInt8(I.readUInt8(j)^N,j),F>=2&&I.writeUInt8(I.readUInt8(j+1)^Y,j+1),F>=3&&I.writeUInt8(I.readUInt8(j+2)^Q,j+2)}e.$Rh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,b.$lg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const k=process.platform!=="darwin"&&e.$Rh?e.$Rh:(0,s.tmpdir)(),C=(0,p.$jc)(k,`vscode-ipc-${I}.sock`);return n(C),C}e.$Sh=r;function t(I,k,C){const j=(0,P.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${C}-${k}-sock`;const F=C.substr(0,4),N=k.substr(0,6),Y=j.substr(0,8);let Q;return process.platform!=="darwin"&&e.$Rh&&!process.env.VSCODE_PORTABLE?Q=(0,p.$jc)(e.$Rh,`vscode-${Y}-${F}-${N}.sock`):Q=(0,p.$jc)(I,`${F}-${N}.sock`),n(Q),Q}e.$Th=t;function n(I){const k=o[v.$u];typeof k=="number"&&I.length>=k&&console.warn(`WARNING: IPC handle "${I}" is longer than ${k} chars, try a shorter --user-data-dir`)}class c extends l.$Eh{static b(k){const C=d.Event.fromNodeEventEmitter(k,"connection");return d.Event.map(C,j=>({protocol:new y.$Lh(new m(j,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(c.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Uh=c;function w(I){return new Promise((k,C)=>{const j=(0,R.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),k(new c(j))})})}e.$Vh=w;function A(I,k){return new Promise((C,j)=>{const F=(0,R.createConnection)(I,()=>{F.removeListener("error",j),C(y.$Mh.fromSocket(new m(F,`ipc-client${k}`),k))});F.once("error",j)})}e.$Wh=A}),define(re[24],oe([0,1,56,9,4,99,37,90,6]),function(J,e,P,R,s,M,D,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=e.$X8b=void 0,e.$X8b=(0,d.$2h)(D.$8h);class u extends S.$vm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Th)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const b=v.slice(0,-17);if(this.d[b])continue;process.env[b]&&(this.d[b]=process.env[b]),process.env[v]?process.env[b]=process.env[v]:delete process.env[b]}}}restoreSnapExportedVariables(){if(s.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$Y8b=u,Ee([P.$sh],u.prototype,"cachedLanguagesPath",null),Ee([P.$sh],u.prototype,"backupHome",null),Ee([P.$sh],u.prototype,"mainIPCHandle",null),Ee([P.$sh],u.prototype,"mainLockfile",null),Ee([P.$sh],u.prototype,"disableUpdates",null),Ee([P.$sh],u.prototype,"crossOriginIsolated",null),Ee([P.$sh],u.prototype,"codeCachePath",null),Ee([P.$sh],u.prototype,"useCodeCache",null)}),define(re[283],oe([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$D9b=void 0;let a=class{static{h=this}static{this.a="backupWorkspaces"}constructor(f,i,o,r){this.j=f,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$tg,this.i={isEqual:(t,n)=>(0,R.$2f)(t,n,!D.$k)}}async initialize(){const f=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(f.emptyWindows),this.d=await this.u((0,u.$c9b)(f)),this.e=await this.v((0,u.$d9b)(f)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==l.$Jk.OFF}q(){return this.s()===l.$Jk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||l.$Jk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(f,i){this.d.some(r=>f.workspace.id===r.workspace.id)||(this.d.push(f),this.C());const o=(0,M.$jc)(this.c,f.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(f,i){if(await d.Promises.exists(f)&&await this.z(f),await d.Promises.exists(i))try{await d.Promises.rename(i,f,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(f){return this.e.some(i=>this.h.isEqual(f.folderUri,i.folderUri))||(this.e.push(f),this.C()),(0,M.$jc)(this.c,this.D(f))}registerEmptyWindowBackup(f){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,f.backupFolder))||(this.g.push(f),this.C()),(0,M.$jc)(this.c,f.backupFolder)}async u(f){if(!Array.isArray(f))return[];const i=new Set,o=[];for(const r of f){const t=r.workspace;if(!(0,$.$di)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await d.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(f){if(!Array.isArray(f))return[];const i=[],o=new Set;for(const r of f){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const c=(0,M.$jc)(this.c,this.D(r));await this.B(c)?t.scheme!==s.Schemas.file||await d.Promises.exists(t.fsPath)?i.push(r):await this.z(c):await this.x(c)}}return i}async w(f){if(!Array.isArray(f))return[];const i=[],o=new Set;for(const r of f){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,M.$jc)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(f){try{await d.Promises.rm(f,d.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let f=(0,g.$o9b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,f.id));)f=(0,g.$o9b)();return{backupFolder:f.id}}async z(f){const i=this.y(),o=(0,M.$jc)(this.c,i.backupFolder);try{await d.Promises.rename(f,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const f=[];for(const i of this.d)await this.A(i)&&f.push(i);for(const i of this.e)await this.A(i)&&f.push(i);return f}A(f){let i;return(0,u.$b9b)(f)?i=(0,M.$jc)(this.c,f.backupFolder):(0,m.$_bb)(f)?i=(0,M.$jc)(this.c,this.D(f)):i=(0,M.$jc)(this.c,f.workspace.id),this.B(i)}async B(f){try{const i=await d.Promises.readdir(f);for(const o of i)try{if((await d.Promises.readdir((0,M.$jc)(f,o))).length>0)return!0}catch{}}catch{}return!1}C(){const f={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(h.a,f)}D(f){const i=f.folderUri;let o;return i.scheme===s.Schemas.file?o=D.$k?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$D9b=a,e.$D9b=a=h=Ee([ie(0,v.$X8b),ie(1,p.$ui),ie(2,y.$ij),ie(3,b.$4N)],a)}),define(re[20],oe([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=e.LifecycleMainPhase=e.ShutdownReason=e.$Z8b=void 0,e.$Z8b=(0,p.$1h)("lifecycleMainService");var m;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var $;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let g=class extends D.$Sc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(a,E,f){super(),this.F=a,this.G=E,this.H=f,this.c=this.B(new M.$Sd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Sd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Sd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Sd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const a=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",a);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",f=>{this.S("Lifecycle#app.on(will-quit) - begin"),f.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",a),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(a){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const f=[];return this.f.fire({reason:a,join(i,o){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),f.push(o.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(f)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===a)return;this.S(`lifecycle (main): phase changed (value: ${a})`),this.n=a;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(a){if(a<=this.n)return;let E=this.C.get(a);E||(E=new s.$Zg,this.C.set(a,E)),await E.wait()}registerWindow(a){const E=new D.$Rc;this.t++,E.add(a.onWillLoad(i=>this.g.fire({window:a,workspace:i.workspace,reason:i.reason})));const f=(0,u.$Of)(a.win);f.on("close",i=>{const o=a.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${a.id}`),i.preventDefault(),this.unload(a,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(a),a.close()})}),f.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.t--,E.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}async reload(a,E){await this.unload(a,3)||a.reload(E)}unload(a,E){const f=this.z.get(a.id);if(f)return f;const i=this.M(a,E).finally(()=>{this.z.delete(a.id)});return this.z.set(a.id,i),i}async M(a,E){if(!a.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${a.id}`);const f=this.j?2:E,i=await this.P(a,f);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.N(i)):(await this.Q(a,f),!1)}N(a){return a?(this.O(!0),this.j=!1,!0):!1}O(a){this.w&&(this.w(a),this.w=void 0,this.u=void 0)}P(a,E){return new Promise(f=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;R.$cU.once(o,()=>{f(!1)}),R.$cU.once(r,()=>{f(!0)}),a.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:E})})}Q(a,E){return new Promise(f=>{const o=`vscode:reply${this.s++}`;R.$cU.once(o,()=>f()),a.send("vscode:onWillUnload",{replyChannel:o,reason:E})})}quit(a){return this.R(a).then(E=>{if(!E&&a)try{if(S.$i){const f=(0,d.cwd)();f!==process.cwd()&&process.chdir(f)}}catch(f){this.F.error(f)}return E})}R(a){return this.S(`Lifecycle#quit() - begin (willRestart: ${a})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(a&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(a){this.H.args["enable-smoke-test-driver"]?this.F.info(a):this.F.trace(a)}setRelaunchHandler(a){this.D=a}async relaunch(a){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(a?.addArgs&&E.push(...a.addArgs),a?.removeArgs)for(const o of a.removeArgs){const r=E.indexOf(o);r>=0&&E.splice(r,1)}const f=()=>{this.D?.handleRelaunch(a)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",f),await this.quit(!0)&&P.app.removeListener("quit",f)}async kill(a){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$2g)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let f;E.webContents&&!E.webContents.isDestroyed()?f=new Promise(i=>E.once("closed",i)):f=Promise.resolve(),E.destroy(),await f}})()]),P.app.exit(a)}};e.$18b=g,e.$18b=g=y=Ee([ie(0,v.$ij),ie(1,b.$4N),ie(2,l.$X8b)],g)}),define(re[284],oe([0,1,4,3,2,6,20]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0,e.$Z9b=(0,M.$1h)("keyboardLayoutMainService");let S=class extends s.$Sc{constructor(p){super(),this.a=this.B(new R.$Sd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((v,b)=>{J(["native-keymap"],v,b)});this.c=d(p),P.$t||p.onDidChangeKeyboardLayout(()=>{this.c=d(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$19b=S,e.$19b=S=Ee([ie(0,D.$Z8b)],S);function d(u){const p=u.getKeyMap(),v=u.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:v}}}),define(re[285],oe([0,1,246,8,18,14,12,17,37,94,5,51,245,282]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0;let y=class extends v.$6o{constructor(h,a,E,f){super(f),this.m=h,this.n=a,this.r=E,this.s(),this.B(h.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,a){const{f:E,g:f}=this;let i;try{i=await(0,u.$6l)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(t)))}const o={...process.env,...i},r=h.agent?h.agent:await(0,b.$0q)(h.url||"",o,{proxyUrl:E,strictSSL:f});return h.agent=r,h.strictSSL=f,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,a))}async resolveProxy(h){}async loadCertificates(){return(await new Promise((a,E)=>{J(["@vscode/proxy-agent"],a,E)})).loadSystemCertificates({log:this.r})}};e.$$q=y,e.$$q=y=Ee([ie(0,S.$ui),ie(1,d.$9h),ie(2,p.$ij),ie(3,p.$jj)],y);async function m(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((E,f)=>{J(["https"],E,f)}):await new Promise((E,f)=>{J(["http"],E,f)})).request}async function $(g,h){return R.Promises.withAsyncBody(async(a,E)=>{const f=(0,P.parse)(g.url),i=g.getRawRequest?g.getRawRequest(g):await m(g),o={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.$Jf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=i(o,t=>{const n=(0,D.$Hf)(g.followRedirects)?g.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)$({...g,url:t.headers.location,followRedirects:n-1},h).then(a,E);else{let c=t;!g.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(c=t.pipe((0,l.createGunzip)())),a({res:t,stream:(0,s.$ve)(c)})}});r.on("error",E),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),h.onCancellationRequested(()=>{r.abort(),E(new M.$5)})})}e.$_q=$}),define(re[286],oe([0,1,15,285]),function(J,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=void 0;function s(D){return P.net.request}class M extends R.$$q{request(S,d){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},d)}}e.$30b=M}),define(re[82],oe([0,1,7,3,2,37,16,6,20,5,96,279,41,54,40,13]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=e.$08b=e.$98b=e.$88b=void 0,e.$88b=(0,S.$1h)("storageMainService");let $=class extends s.$Sc{constructor(a,E,f,i,o,r){super(),this.c=a,this.f=E,this.g=f,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$Sd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(a=>{a.window.profile&&this.profileStorage(a.window.profile).init(),a.workspace&&this.workspaceStorage(a.workspace).init()})),this.B(this.h.onWillShutdown(a=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=a.reason,a.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)a.join("profileStorage",E.close());for(const[,E]of this.w)a.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(a=>{a.join((async()=>{await this.j.exists(a.profile.globalStorageHome)||await this.j.createFolder(a.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(a=>{const E=this.t.get(a.profile.id);E&&a.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const a=new v.$38b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(a.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),a}profileStorage(a){if((0,p.$ip)(a))return this.applicationStorage;let E=this.t.get(a.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${a.name})`),E=this.B(this.u(a)),this.t.set(a.id,E);const f=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:a})));this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${a.name})`),this.t.delete(a.id),f.dispose()}))}return E}u(a){return this.a===2?new v.$58b(this.c,this.j):new v.$28b(a,this.n(),this.c,this.j)}workspaceStorage(a){let E=this.w.get(a.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${a.id})`),E=this.B(this.y(a)),this.w.set(a.id,E),this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${a.id})`),this.w.delete(a.id)}))),E}y(a){return this.a===2?new v.$58b(this.c,this.j):new v.$48b(a,this.n(),this.c,this.f,this.j)}isUsed(a){const E=P.URI.file(a);for(const f of[this.applicationStorage,...this.t.values(),...this.w.values()])if(f.path&&this.m.extUri.isEqualOrParent(P.URI.file(f.path),E))return!0;return!1}};e.$98b=$,e.$98b=$=Ee([ie(0,u.$ij),ie(1,M.$8h),ie(2,l.$68b),ie(3,d.$Z8b),ie(4,D.$kk),ie(5,y.$Uk)],$),e.$08b=(0,S.$1h)("applicationStorageMainService");let g=class extends p.$hp{constructor(a,E){super(),this.s=a,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(a){if(a===-1)return this.U.applicationStorage.storage}Q(a){if(a===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$$8b=g,e.$$8b=g=Ee([ie(0,b.$Wk),ie(1,e.$88b)],g)}),define(re[287],oe([0,1,87,26,103,99,8,2,4,17,5,27,241,242,95,126,18]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.$10b=e.$Z0b=e.$Y0b=void 0;async function g(i,o,r,t,n){let c;for(let w=3;w&&(c?.dispose(),c=await new h(i,o,r,t,n).waitForReady(),!(n&&s.$og[n]||!s.$og[c.tunnelLocalPort]));w--);return c}class h extends S.$Sc{constructor(o,r,t,n,c){super(),this.m=r,this.n=c,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new D.$Zg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,m.$rv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$pg)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,m.$pv)(this.tunnelRemoteHost)||(0,m.$rv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,b.$fl)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),c=t.readEntireBuffer();t.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Ph?n.socket.destroy():n.end()}),n instanceof M.$Ph?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write($.$ge.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$Y0b=h;let a=class extends m.$uv{constructor(o,r,t,n,c){super(r,c),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,m.$sv)(o,this.l,d.OS,R.release())}s(o,r,t,n,c,w,A,I){const k=this.r(r,t);if(k)return++k.refcount,k.value;if((0,m.$mv)(o))return this.t(o,r,t,c,w,A,I);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${c}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=g(C,n,r,t,c);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,j),j}}};e.$Z0b=a,e.$Z0b=a=Ee([ie(0,l.$_k),ie(1,p.$ij),ie(2,y.$cl),ie(3,v.$Aj),ie(4,u.$ui)],a);let E=class extends a{constructor(o,r,t,n,c){super(o,r,t,n,c)}};e.$10b=E,e.$10b=E=Ee([ie(0,l.$_k),ie(1,p.$ij),ie(2,y.$cl),ie(3,v.$Aj),ie(4,u.$ui)],E);let f=class extends S.$Sc{constructor(o,r,t,n,c){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=c,this.a=new Map}async openTunnel(o,r,t,n,c,w,A,I,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${w}.`),!this.a.has(o)){const C=new E(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,c,w,A,I,k)}};e.$20b=f,e.$20b=f=Ee([ie(0,l.$_k),ie(1,p.$ij),ie(2,v.$Aj),ie(3,y.$cl),ie(4,u.$ui)],f)}),define(re[100],oe([0,1,8,22,3,17,24,20,5,27,51,49]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=e.$k0b=void 0;function b(y,m,$){return`${$.updateUrl}/api/update/${y}/${m}/${$.commit}`}e.$k0b=b;let l=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,$,g,h,a,E){this.f=m,this.g=$,this.h=g,this.i=h,this.j=a,this.k=E,this.b=v.$aV.Uninitialized,this.c=new s.$Sd,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$aV.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$aV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$aV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),$=this.m(m);if(!$){this.d(v.$aV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(v.$aV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(v.$aV.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,P.$2g)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$l0b=l,e.$l0b=l=Ee([ie(0,S.$Z8b),ie(1,M.$ui),ie(2,D.$X8b),ie(3,p.$5o),ie(4,d.$ij),ie(5,u.$Aj)],l)}),define(re[288],oe([0,1,15,56,3,45,2,17,24,20,5,27,51,28,49,100]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m0b=void 0;let $=class extends m.$l0b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(h,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(h,a,E)=>({url:a,version:E,productVersion:E}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(h,a,E,f)=>({releaseNotes:a,version:E,productVersion:E,date:f}))}constructor(h,a,E,f,i,o,r){super(h,a,f,i,o,r),this.z=E,this.u=new D.$Rc,h.setRelaunchHandler(this)}handleRelaunch(h){return h?.addArgs||h?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(h){this.z.publicLog2("update:error",{messageHash:String((0,M.$Oi)(String(h)))}),this.j.error("UpdateService error:",h);const a=this.state.type==="checking for updates"&&this.state.explicit?h:void 0;this.d(y.$aV.Idle(1,a))}s(h){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,m.$k0b)(a,h,this.k);try{P.autoUpdater.setFeedURL({url:E})}catch(f){this.j.error("Failed to set update feed URL",f);return}return E}t(h){this.d(y.$aV.CheckingForUpdates(h)),P.autoUpdater.checkForUpdates()}E(h){this.state.type==="checking for updates"&&this.d(y.$aV.Downloading(h))}F(h){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:h.version}),this.d(y.$aV.Ready(h)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(y.$aV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$m0b=$,Ee([R.$sh],$.prototype,"v",null),Ee([R.$sh],$.prototype,"w",null),Ee([R.$sh],$.prototype,"x",null),Ee([R.$sh],$.prototype,"y",null),e.$m0b=$=Ee([ie(0,u.$Z8b),ie(1,S.$ui),ie(2,l.$ol),ie(3,d.$X8b),ie(4,b.$5o),ie(5,p.$ij),ie(6,v.$Aj)],$)}),define(re[289],oe([0,1,48,46,8,3,9,24,20,5,28,49]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o0b=void 0;let b=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,$,g){if(this.f=m,this.g=g,this.a=v.$aV.Uninitialized,this.b=new M.$Sd,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$aV.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(m=60*60*1e3){return(0,s.$2g)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};b=Ee([ie(0,d.$Z8b),ie(1,S.$X8b),ie(2,u.$ij)],b);let l=class extends b{constructor(m,$,g,h,a,E){super(g,h,a),this.o=m,this.p=$,this.q=E;const f=(0,R.watch)(D.$mc(this.o)),i=M.Event.fromNodeEventEmitter(f,"change",(n,c)=>c),o=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{t.dispose(),f.close()})}m(){this.d(v.$aV.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(v.$aV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$aV.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$aV.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise((g,h)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(a,E)=>a?h(a):g(E))),$=D.$nc(m);return this.p!==$}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$o0b=l,e.$o0b=l=Ee([ie(2,d.$Z8b),ie(3,S.$X8b),ie(4,u.$ij),ie(5,p.$ol)],l)}),define(re[29],oe([0,1,4,6,60,70,27,17,24,9,65,136]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=e.$A9b=e.$z9b=e.OpenContext=e.$y9b=void 0,e.$y9b=(0,R.$1h)("windowsMainService");var b;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(b||(e.OpenContext=b={}));function l($,g,h){const a=$.get(M.$_8b),E=$.get(D.$Aj),f=$.get(S.$ui),i=$.get(d.$X8b),o=f.getValue("window"),r={backgroundColor:a.getBackgroundColor(),minWidth:s.$tC.WIDTH,minHeight:s.$tC.HEIGHT,title:E.nameLong,...h,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$CC)(o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(g&&(r.x=g.x,r.y=g.y,r.width=g.width,r.height=g.height),P.$k?r.icon=(0,u.$jc)(i.appRoot,"resources/linux/code.png"):P.$i&&!i.isBuilt&&(r.icon=(0,u.$jc)(i.appRoot,"resources/win32/code_150x150.png")),P.$j&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),P.$j&&!(0,s.$BC)(f)&&(r.fullscreenable=!1),P.$j&&o?.nativeTabs===!0&&(r.tabbingIdentifier=E.nameShort),(0,s.$zC)(f)==="custom"&&(r.titleBarStyle="hidden",P.$j||(r.frame=!1),(0,s.$AC)(f))){const c=a.getWindowSplash()?.colorInfo.titleBarBackground??a.getBackgroundColor(),w=v.$0s.fromHex(c).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:c,symbolColor:w}}return r}e.$z9b=l;function y($){const g=$.get(e.$y9b),h=$.get(p.$w9b),a=g.getFocusedWindow()??h.getFocusedWindow();if(a)return a;const E=g.getLastActiveWindow(),f=h.getLastActiveWindow();return E&&f?E.lastFocusTime<f.lastFocusTime?f:E:E??f}e.$A9b=y;function m($){let g,h=Number.MIN_VALUE;for(const a of $)a.lastFocusTime>h&&(h=a.lastFocusTime,g=a);return g}e.$B9b=m}),define(re[290],oe([0,1,15,22,3,45,2,32,116,5,82,29]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C9b=void 0;var b;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let l=class extends D.$Sc{constructor(m,$,g,h){super(),this.g=m,this.h=$,this.j=g,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=b.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(P.app,"login",($,g,h,a,E)=>({event:$,webContents:g,req:h,authInfo:a,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:$,req:g,callback:h}){if(!$.isProxy)return;if(!this.b&&this.c===b.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let a;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{a=await this.b}finally{this.b=void 0}}h(a?.username,a?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(m);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const $=String((0,M.$Oi)({scheme:m.scheme,host:m.host,port:m.port}));let g,h;try{const i=this.m.get(this.a+$,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));g=o.username,h=o.password}}catch(i){this.g.error(i)}if(this.c!==b.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=b.StoredCredentialsUsed,{username:g,password:h};const a=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!a){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??g,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,S.$lg)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.c=b.LoginDialogShown;const f=await new Promise(i=>{const o=async(r,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const w=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+$,w,-1,1)}else this.m.remove(this.a+$,-1)}catch(w){this.g.error(w)}i({username:c.username,password:c.password})}else i(void 0)};a.win?.webContents.on("ipc-message",o)});return this.f=f,f}};e.$C9b=l,e.$C9b=l=Ee([ie(0,u.$ij),ie(1,v.$y9b),ie(2,d.$XU),ie(3,p.$08b)],l)}),define(re[291],oe([0,1,15,23,4,7,21,17,64,6,5,127,29]),function(J,e,P,R,s,M,D,S,d,u,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=e.$39b=e.ID=void 0,e.ID="launchMainService",e.$39b=(0,u.$1h)(e.ID);let l=class{constructor(m,$,g,h){this.a=m,this.b=$,this.c=g,this.d=h}async start(m,$){this.a.trace("Received data from other instance: ",m,$),s.$j&&P.app.focus({steal:!0});const g=this.e(m);if(g.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const a=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));a&&(h=a.ready())}h.then(()=>{for(const{uri:a,originalUrl:E}of g)this.c.open(a,{originalUrl:E})})}else return this.f(m,$)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,R.$Hb)(m._urls.map($=>{try{return{uri:M.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(m,$){const g=(0,d.$Zl)($)?0:4;let h=[];const a=m.wait&&m.waitMarkerFilePath?M.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,f={context:g,cli:m,userEnv:$,waitMarkerFileURI:a,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,f);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||f.forceProfile||f.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$j}if(i)h=await this.b.open({...f,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,f),h=[o]):h=await this.b.open({...f,forceEmpty:!0})}}else h=await this.b.open({...f,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(a&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$49b=l,e.$49b=l=Ee([ie(0,p.$ij),ie(1,b.$y9b),ie(2,v.$4U),ie(3,S.$ui)],l)}),define(re[292],oe([0,1,2,20,54,30,8,29]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G0b=void 0;let d=class extends P.$Sc{constructor(p,v,b){super(),this.a=v,this.b=b,this.B(p.onWillLoadWindow(l=>{l.reason===2&&this.c(l.window)})),this.B(p.onBeforeCloseWindow(l=>this.c(l))),this.B(new D.$ah(()=>this.g(),30*1e3)).schedule()}async c(p){const v=this.f(p),b=this.a.getProfileForWorkspace(v);b?.isTransient&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,M.$ci)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of p)v.some(l=>l.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.$G0b=d,e.$G0b=d=Ee([ie(0,R.$Z8b),ie(1,s.$68b),ie(2,S.$y9b)],d)}),define(re[61],oe([0,1,15,2,3,5,312,8,13,29,74,28,20,76,38,4,131]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=void 0;function h(f){return typeof f.responseWindowId=="number"}let a=class extends R.$Sc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(i,o,r){super(),this.u=i,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Sd),this.onStdout=this.f.event,this.g=this.B(new s.$Sd),this.onStderr=this.g.event,this.h=this.B(new s.$Sd),this.onMessage=this.h.event,this.j=this.B(new s.$Sd),this.onSpawn=this.j.event,this.m=this.B(new s.$Sd),this.onExit=this.m.event,this.n=this.B(new s.$Sd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(i,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`,o){case p.default.Error:this.u.error(r);break;case p.default.Warning:this.u.warn(r);break;case p.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(i){const o=this.D(i);return o&&i.payload&&this.postMessage(i.payload),o}D(i){if(!this.C())return!1;this.t=i;const o=`${this.t.type}-${this.c}`,r=d.$jg.asFileUri("bootstrap-fork.js").fsPath,t=this.t.args??[],n=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,A="pipe",I=this.F(i);return this.z("creating new...",p.default.Info),this.r=P.utilityProcess.fork(r,t,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:w,stdio:A}),this.G(this.r,this.t,o),!0}F(i){const o=i.env?{...i.env}:{...(0,y.$gn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$i&&((0,$.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,l.$Ml)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(i,o,r){if(i.stdout){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.s=i.pid,typeof i.pid=="number"&&g.b.set(i.pid,{pid:i.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",p.default.Info),this.j.fire(i.pid)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.z(`received exit event with code ${t}`,p.default.Info),this.m.fire({pid:this.s,code:t,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.z(`crashed with code ${t.exitCode} and reason '${t.reason}'`,p.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.n.fire({pid:this.s,code:t.exitCode,reason:t.reason}),this.H())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.r&&this.r.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",p.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",p.default.Info),this.r.kill()?(this.z("successfully killed the process",p.default.Info),this.H()):this.z("unable to kill the process",p.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(i){this.r&&(this.z("waiting to exit...",p.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$2g)(i)]),this.r&&(this.z(`did not exit within ${i}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$F9b=a,e.$F9b=a=g=Ee([ie(0,M.$ij),ie(1,v.$ol),ie(2,b.$Z8b)],a);let E=class extends a{constructor(i,o,r,t){super(i,r,t),this.I=o}start(i){const o=this.I.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.D(i))return!1;this.J(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}J(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$G9b=E,e.$G9b=E=Ee([ie(0,M.$ij),ie(1,u.$y9b),ie(2,v.$ol),ie(3,b.$Z8b)],E)}),define(re[293],oe([0,1,14,3,5,20,8,61,29,28]),function(J,e,P,R,s,M,D,S,d,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;let v=class{static{p=this}static{this.a=0}constructor(l,y,m,$){this.d=l,this.f=y,this.g=m,this.h=$,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(l){const y=this.b.get(l);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(l){return this.i(l).onStdout}onDynamicStderr(l){return this.i(l).onStderr}onDynamicMessage(l){return this.i(l).onMessage}onDynamicExit(l){return this.i(l).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const l=String(++p.a),y=new S.$G9b(this.d,this.g,this.h,this.f);return this.b.set(l,y),y.onExit(({pid:m,code:$,signal:g})=>{this.d.info(`Extension host with pid ${m} exited with code: ${$}, signal: ${g}.`),setTimeout(()=>{y.dispose(),this.b.delete(l)}),setTimeout(()=>{try{process.kill(m,0),this.d.error(`Extension host with pid ${m} still exists, forcefully killing it...`),process.kill(m)}catch{}},1e3)}),{id:l}}async start(l,y){if(this.c)throw(0,P.$6)();const m=this.i(l);return m.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await R.Event.toPromise(m.onSpawn)}}async enableInspectPort(l){if(this.c)throw(0,P.$6)();const y=this.b.get(l);return y?y.enableInspectPort():!1}async kill(l){if(this.c)throw(0,P.$6)();const y=this.b.get(l);y&&y.kill()}async _killAllNow(){for(const[,l]of this.b)l.kill()}async _waitForAllExit(l){const y=[];for(const[,m]of this.b)y.push(m.waitForExit(l));return D.Promises.settled(y).then(()=>{})}};e.$N9b=v,e.$N9b=v=p=Ee([ie(0,s.$ij),ie(1,M.$Z8b),ie(2,d.$y9b),ie(3,u.$ol)],v)}),define(re[294],oe([0,1,36,8,2,24,20,5,41,39,69,61,52,90,12,247]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;let $=class extends s.$Sc{constructor(h,a,E,f,i,o,r,t){super(),this.c=h,this.f=a,this.g=E,this.h=f,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new R.$Zg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$cU.on(m.$c0b.request,(h,a)=>this.t(h,a,m.$c0b.response)),P.$cU.on(m.$d0b.request,(h,a)=>this.t(h,a,m.$d0b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,a,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const f=await this.connect(E);if(h.sender.isDestroyed())return f.close();h.sender.postMessage(E,a,[f])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$b0b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new R.$lh;this.b?this.b.once(m.$b0b.initDone,()=>h.complete()):P.$cU.once(m.$b0b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new R.$lh;this.b?this.b.once(m.$b0b.ipcReady,()=>h.complete()):P.$cU.once(m.$b0b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$F9b(this.m,b.$xo,this.j));const h=(0,l.$xm)(this.g.args,this.g.isBuilt);let a;h.port&&(a=["--nolazy"],h.break?a.push(`--inspect-brk=${h.port}`):a.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:a})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,y.$Of)(this.b).connect(h)}};e.$e0b=$,e.$e0b=$=Ee([ie(2,M.$X8b),ie(3,d.$Wk),ie(4,D.$Z8b),ie(5,S.$ij),ie(6,p.$r9b),ie(7,u.$un)],$)}),define(re[295],oe([0,1,24,90,20,5,52,61,110,36,2,3,38,17,13]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=void 0;let m=class extends p.$Sc{constructor(g,h,a,E,f){super(),this.f=g,this.g=h,this.h=a,this.j=E,this.m=f,this.a=void 0,this.b=new v.$Sd,this.onRequestConnection=this.b.event,this.c=new v.$Sd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),u.$cU.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,p.$Qc)(()=>{u.$cU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$F9b(this.m,D.$xo,this.j);const g=(0,R.$wm)(this.h.args,this.h.isBuilt),h=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const a=this.a.connect(),E=new d.$kU(a,"ptyHost"),f=new p.$Rc;return f.add(E),f.add((0,p.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:f,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,b.$gn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(g.VSCODE_LATENCY=String(h));const a=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return a&&typeof a=="number"&&(g.VSCODE_STARTUP_DELAY=String(a)),this.h.restoreSnapExportedVariables(),g}r(g,h){this.b.fire();const a=this.a.connect();if(g.sender.isDestroyed()){a.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[a])}};e.$Q0b=m,e.$Q0b=m=Ee([ie(1,l.$ui),ie(2,P.$X8b),ie(3,s.$Z8b),ie(4,M.$ij)],m)}),define(re[296],oe([0,1,2,6,5,29,61,28,45,3,8,20]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P0b=e.$O0b=void 0,e.$O0b=(0,R.$1h)("utilityProcessWorker");let b=class extends P.$Sc{constructor(m,$,g,h){super(),this.b=m,this.c=$,this.f=g,this.g=h,this.a=new Map}async createWorker(m){const $=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const g=this.h(m);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(m));const h=new l(this.b,this.c,this.f,this.g,m);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,h);const a=new p.$lh;return u.Event.once(h.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(g),a.complete({reason:E})}),a.p}h(m){return(0,d.$Oi)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const $=this.h(m),g=this.a.get($);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),g.kill(),this.a.delete($))}};e.$P0b=b,e.$P0b=b=Ee([ie(0,s.$ij),ie(1,M.$y9b),ie(2,S.$ol),ie(3,v.$Z8b)],b);let l=class extends P.$Sc{constructor(m,$,g,h,a){super(),this.c=m,this.f=$,this.g=g,this.h=h,this.j=a,this.a=this.B(new u.$Sd),this.onDidTerminate=this.a.event,this.b=new D.$G9b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};l=Ee([ie(0,s.$ij),ie(1,M.$y9b),ie(2,S.$ol),ie(3,v.$Z8b)],l)}),define(re[297],oe([0,1,15,3,2,273,29]),function(J,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0b=void 0;let S=class extends s.$Sc{constructor(u){super(),this.b=u,this.a=this.B(new R.$Sd),this.onFoundInFrame=this.a.event,this.B(new M.$v0b)}async setIgnoreMenuShortcuts(u,p){let v;if(typeof u.windowId=="number"){const{windowId:b}=u,l=this.b.getWindowById(b);if(!l?.win)throw new Error(`Invalid windowId: ${b}`);v=l.win.webContents}else{const{webContentsId:b}=u;if(v=P.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(p)}async findInFrame(u,p,v,b){const y=this.c(u,p);if(typeof y.findInFrame=="function"){y.findInFrame(v,{findNext:b.findNext,forward:b.forward});const m=($,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",m))};y.on("found-in-frame",m)}}async stopFindInFrame(u,p,v){const l=this.c(u,p);typeof l.stopFindInFrame=="function"&&l.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(u,p){const v=this.b.getWindowById(u.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${u}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(l=>l.name===p);if(!b)throw new Error(`Unknown frame: ${p}`);return b}};e.$w0b=S,e.$w0b=S=Ee([ie(0,D.$y9b)],S)}),define(re[298],oe([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=e.$y0b=e.$x0b=void 0;let m=class extends R.$Sc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(f,i,o,r,t){super(),this.g=f,this.h=i,this.j=o,this.m=r,this.n=t,this.b=$(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(f=>this.u(f)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(f=>this.u(f))}s(){this.f=!0,this.t()}t(){const f=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&f.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(f.has(n.uiState.display)?s.$j&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):f.add(n.uiState.display)),n}));const r=h(i);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(f){if(this.j.quitRequested)return;const i=this.w(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,l.$di)(f.openedWorkspace)&&o.workspace?.id===f.openedWorkspace.id,t=(0,l.$$h)(f.openedWorkspace)&&o.folderUri&&M.$tg.isEqual(o.folderUri,f.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(f){return{windowId:f.id,workspace:(0,l.$di)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,l.$$h)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const i=this.z(f),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(f){const i=this.g.getLastActiveWindow();if(!f.extensionTestsPath){if(f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const w=f.workspace;if((0,l.$di)(w)){const I=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===w.id).map(k=>k.uiState);if(I.length)return I[0]}if((0,l.$$h)(w)){const I=this.state.openedWindows.filter(k=>k.folderUri&&M.$tg.isEqual(k.folderUri,w.uri)).map(k=>k.uiState);if(I.length)return I[0]}else if(f.backupPath){const I=this.state.openedWindows.filter(k=>k.backupPath===f.backupPath).map(k=>k.uiState);if(I.length)return I[0]}const A=this.c||this.state.lastActiveWindow;if(!i&&A)return A.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const w=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(w)}!o&&i&&(o=P.screen.getDisplayMatching(i.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let t=(0,b.$W8b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const w=i.serializeWindowState();w.mode===3?t.mode=3:t=w,c=t.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(t=this.C(t)),t.hasDefaultState=!0,t}C(f){if(this.g.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===f.x||o.y===f.y);)f.x+=30,f.y+=30;return f}};e.$x0b=m,e.$x0b=m=y=Ee([ie(0,v.$y9b),ie(1,p.$4N),ie(2,d.$Z8b),ie(3,u.$ij),ie(4,S.$ui)],m);function $(E){const f={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(f.lastActiveWindow=g(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=g(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(f.openedWindows=i.openedWindows.map(o=>g(o))),f}e.$y0b=$;function g(E){const f={uiState:E.uiState};return E.backupPath&&(f.backupPath=E.backupPath),E.remoteAuthority&&(f.remoteAuthority=E.remoteAuthority),E.folder&&(f.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(f.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),f}function h(E){return{lastActiveWindow:E.lastActiveWindow&&a(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&a(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(f=>a(f))}}e.$z0b=h;function a(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(re[55],oe([0,1,15,3,44,2,13,9,19,21,194,66,53,24,6,5,54,130,30,97,98]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=e.$p9b=void 0,e.$p9b=(0,y.$1h)("workspacesManagementMainService");let f=class extends M.$Sc{constructor(o,r,t,n,c){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=c,this.a=this.B(new R.$Sd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Sd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await u.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,d.$Cg)(this.c,r,h.$ni));for(const r of o){const t=(0,E.$m9b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>u.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,h.$oi)(o,this.g)||(0,h.$ti)(o)}t(o,r){try{const t=this.u(o,r),n=(0,E.$m9b)(o);return{id:n.id,configPath:n.configPath,folders:(0,a.$hcb)(t.folders,n.configPath,d.$tg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$9m)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,a.$fcb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),c=t.configPath.fsPath;return await u.Promises.mkdir((0,S.$mc)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.$Cg)(this.c,t),c=(0,d.$Cg)(n,h.$ni),w=[];for(const A of o)w.push((0,a.$gcb)(A.uri,!0,A.name,n,d.$tg));return{workspace:(0,E.$m9b)(c),storedWorkspace:{folders:w,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,E.$m9b)(o)}isUntitledWorkspace(o){return(0,h.$oi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$qg)(o.configPath);try{await u.Promises.rm((0,S.$mc)(r));const t=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await u.Promises.exists(t)&&await u.Promises.writeFile((0,S.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const c=await this.C(o,(0,E.$m9b)(t));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,r,t){return t?(0,h.$di)(o.openedWorkspace)&&d.$tg.isEqual(o.openedWorkspace.configPath,t)?!1:(0,g.$j9b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,d.$zg)(t)),detail:(0,p.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,h.$di)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$q9b=f,e.$q9b=f=Ee([ie(0,l.$X8b),ie(1,m.$ij),ie(2,$.$68b),ie(3,v.$e9b),ie(4,b.$f9b)],f)}),define(re[132],oe([0,1,15,36,22,6,29,30,55,12,5,61]),function(J,e,P,R,s,M,D,S,d,u,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=e.ID=void 0,e.ID="diagnosticsMainService",e.$I9b=(0,M.$1h)(e.ID);let b=class{constructor(y,m,$){this.a=y,this.b=m,this.c=$}async getRemoteDiagnostics(y){const m=this.a.getWindows();return(await Promise.all(m.map(async g=>{const h=g.remoteAuthority;if(!h)return;const a=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(f=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:a,args:E}),R.$cU.once(a,(i,o)=>{o||f({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),f(o)}),setTimeout(()=>{f({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const $ of P.BrowserWindow.getAllWindows()){const g=this.a.getWindowById($.id);g?y.push(await this.d(g)):y.push(this.e($))}const m=[];for(const{pid:$,name:g}of v.$F9b.getAll())m.push({pid:$,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:m,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const m=await this.f(y),$=(0,u.$Of)(y.win);return this.e($,m,y.remoteAuthority)}e(y,m=[],$){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:m,remoteAuthority:$}}async f(y){const m=[],$=y.openedWorkspace;if((0,S.$$h)($))m.push($.uri);else if((0,S.$di)($)){const g=await this.b.resolveLocalWorkspace($.configPath);g&&g.folders.forEach(a=>{m.push(a.uri)})}return m}};e.$J9b=b,e.$J9b=b=Ee([ie(0,D.$y9b),ie(1,d.$p9b),ie(2,p.$ij)],b)}),define(re[71],oe([0,1,48,15,26,156,56,3,2,13,9,4,7,105,88,21,103,182,53,24,6,20,5,27,70,29,30,55,18,243,235,65]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=e.$W9b=void 0,e.$W9b=(0,E.$1h)("nativeHostMainService");let C=class extends d.$Sc{constructor(F,N,Y,Q,le,ce,ue,K,X,H){super(),this.a=F,this.b=N,this.c=Y,this.f=Q,this.g=le,this.h=ce,this.j=ue,this.m=K,this.n=X,this.r=H,this.onDidOpenMainWindow=S.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:T,y:V})=>({windowId:L.id,x:T,y:V})),({windowId:L})=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:V})=>({windowId:L.id,x:T,y:V})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,T)=>T),L=>(0,k.$x9b)(L.webContents)),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,T)=>T),L=>(0,k.$x9b)(L.webContents)),L=>L.id)),this.onDidResumeOS=S.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Sd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,T,V)=>V),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),S.Event.fromNodeEventEmitter(R.screen,"display-added"),S.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,N){const Y=this.a.getWindows().map(le=>({id:le.id,workspace:le.openedWorkspace??(0,n.$ci)(le.backupPath,le.isExtensionDevelopmentHost),title:le.win?.getTitle()??"",filename:le.getRepresentedFilename(),dirty:le.isDocumentEdited()})),Q=[];return N.includeAuxiliaryWindows&&Q.push(...this.b.getWindows().map(le=>({id:le.id,parentId:le.parentId,title:le.win?.getTitle()??"",filename:le.getRepresentedFilename()}))),[...Y,...Q]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const N=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(F,N,Y){return Array.isArray(N)?this.t(F,N,Y):this.u(F,N)}async t(F,N,Y=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:N,cli:this.g.args,forceNewWindow:Y.forceNewWindow,forceReuseWindow:Y.forceReuseWindow,preferNewWindow:Y.preferNewWindow,diffMode:Y.diffMode,mergeMode:Y.mergeMode,addMode:Y.addMode,gotoLineMode:Y.gotoLineMode,noRecentEntry:Y.noRecentEntry,waitMarkerFileURI:Y.waitMarkerFileURI,remoteAuthority:Y.remoteAuthority||void 0,forceProfile:Y.forceProfile,forceTempProfile:Y.forceTempProfile})}async u(F,N){await this.a.openEmptyWindow({context:5,contextWindowId:F},N)}async toggleFullScreen(F,N){this.D(N?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,N){this.D(N?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const N=R.screen.getCursorScreenPoint(),Y=R.screen.getDisplayNearestPoint(N);return{point:N,display:Y.bounds}}async isMaximized(F,N){return this.D(N?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,N){this.D(N?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,N){this.D(N?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,N,Y){const Q=this.D(Y?.targetWindowId,F);if(Q?.win){if(Q.win.isFullScreen()){const le=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(Q.win,"leave-full-screen")));Q.win.setFullScreen(!1),await le}Q.win.setBounds(N)}}async updateWindowControls(F,N){this.D(N?.targetWindowId,F)?.updateWindowControls(N)}async focusWindow(F,N){this.D(N?.targetWindowId,F)?.focus({force:N?.force??!1})}async setMinimumSize(F,N,Y){const Q=this.F(F);if(Q?.win){const[le,ce]=Q.win.getSize(),[ue,K]=Q.win.getMinimumSize(),[X,H]=[N??ue,Y??K],[L,T]=[Math.max(le,X),Math.max(ce,H)];(ue!==X||K!==H)&&Q.win.setMinimumSize(X,H),(le!==L||ce!==T)&&Q.win.setSize(L,T)}}async saveWindowSplash(F,N){this.m.saveWindowSplash(F,N)}async installShellCommand(F){const{source:N,target:Y}=await this.w();try{const{symbolicLink:Q}=await m.SymlinkSupport.stat(N);if(Q&&!Q.dangling){const le=await(0,l.$gq)(N);if(Y===le)return}await m.Promises.unlink(N)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await m.Promises.symlink(Y,N)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(le===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Y}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ce)}catch{throw new Error((0,g.localize)(3,null,N))}}}async uninstallShellCommand(F){const{source:N}=await this.w();try{await m.Promises.unlink(N)}catch(Y){switch(Y.code){case"EACCES":{const{response:Q}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(Q===0)try{const le=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(le)}catch{throw new Error((0,g.localize)(7,null,N))}break}case"ENOENT":break;default:throw Y}}}async w(){const F=(0,p.$kc)(this.g.appRoot,"bin","code"),N=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(F))throw new Error((0,g.localize)(8,null,F));return{source:N,target:F}}async showMessageBox(F,N){const Y=this.H(F);return this.c.showMessageBox(N,Y?.win??void 0)}async showSaveDialog(F,N){const Y=this.H(F);return this.c.showSaveDialog(N,Y?.win??void 0)}async showOpenDialog(F,N){const Y=this.H(F);return this.c.showOpenDialog(N,Y?.win??void 0)}async pickFileFolderAndOpen(F,N){const Y=await this.c.pickFileFolder(N);Y&&await this.z(await Promise.all(Y.map(async Q=>await m.SymlinkSupport.existsDirectory(Q)?{folderUri:b.URI.file(Q)}:{fileUri:b.URI.file(Q)})),N,F)}async pickFolderAndOpen(F,N){const Y=await this.c.pickFolder(N);Y&&await this.z(Y.map(Q=>({folderUri:b.URI.file(Q)})),N,F)}async pickFileAndOpen(F,N){const Y=await this.c.pickFile(N);Y&&await this.z(Y.map(Q=>({fileUri:b.URI.file(Q)})),N,F)}async pickWorkspaceAndOpen(F,N){const Y=await this.c.pickWorkspace(N);Y&&await this.z(Y.map(Q=>({workspaceUri:b.URI.file(Q)})),N,F)}async z(F,N,Y){await this.a.open({context:3,contextWindowId:Y,cli:this.g.args,urisToOpen:F,forceNewWindow:N.forceNewWindow})}async showItemInFolder(F,N){R.shell.showItemInFolder(N)}async setRepresentedFilename(F,N,Y){this.D(Y?.targetWindowId,F)?.setRepresentedFilename(N)}async setDocumentEdited(F,N,Y){this.D(Y?.targetWindowId,F)?.setDocumentEdited(N)}async openExternal(F,N){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(N),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,N){return R.shell.trashItem(N)}async isAdmin(){let F;return v.$i?F=(await new Promise((N,Y)=>{J(["native-is-elevated"],N,Y)}))():F=process.getuid?.()===0,F}async writeElevated(F,N,Y,Q){const le=await new Promise((ce,ue)=>{J(["@vscode/sudo-prompt"],ce,ue)});return new Promise((ce,ue)=>{const K=[`"${this.C}"`];Q?.unlock&&K.push("--file-chmod"),K.push("--file-write",`"${N.fsPath}"`,`"${Y.fsPath}"`);const X={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,p.$jc)((0,p.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};le.exec(K.join(" "),X,(H,L,T)=>{L&&this.h.trace(`[sudo-prompt] received stdout: ${L}`),T&&this.h.trace(`[sudo-prompt] received stderr: ${T}`),H?ue(H):ce(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:R.app.runningUnderARM64Translation}get C(){return v.$i?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.$jc)(this.g.appRoot,"bin","code"):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$4m.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,A.$U9b)()}async killProcess(F,N,Y){process.kill(N,Y)}async readClipboardText(F,N){return R.clipboard.readText(N)}async writeClipboardText(F,N,Y){return R.clipboard.writeText(N,Y)}async readClipboardFindText(F){return R.clipboard.readFindText()}async writeClipboardFindText(F,N){return R.clipboard.writeFindText(N)}async writeClipboardBuffer(F,N,Y,Q){return R.clipboard.writeBuffer(N,Buffer.from(Y.buffer),Q)}async readClipboardBuffer(F,N){return w.$ge.wrap(R.clipboard.readBuffer(N))}async hasClipboard(F,N,Y){return R.clipboard.has(N,Y)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,N){this.F(F)?.updateTouchBar(N)}async notifyReady(F){this.F(F)?.setReady()}async relaunch(F,N){return this.f.relaunch(N)}async reload(F,N){const Y=this.F(F);if(Y){if((0,n.$di)(Y.openedWorkspace)){const Q=Y.openedWorkspace.configPath;if(Q.scheme===u.Schemas.file&&(await this.n.resolveLocalWorkspace(Q))?.transient)return this.openWindow(Y.id,{forceReuseWindow:!0})}return this.f.reload(Y,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(F,N){return this.D(N?.targetWindowId,F)?.win?.close()}async quit(F){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.f.quit()}async exit(F,N){await this.f.kill(N)}async resolveProxy(F,N){return this.F(F)?.win?.webContents?.session?.resolveProxy(N)}async loadCertificates(F){return(await new Promise((Y,Q)=>{J(["@vscode/proxy-agent"],Y,Q)})).loadSystemCertificates({log:this.h})}findFreePort(F,N,Y,Q,le=1){return(0,$.$ng)(N,Y,Q,le)}async openDevTools(F,N){this.H(F)?.win?.webContents.openDevTools(N)}async toggleDevTools(F){this.H(F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,N,Y){const Q=this.F(F);if(!Q||!Q.win)throw new Error;return await new I.$V9b(Q.win,N,this.h).inspect(Y)}async windowsGetStringRegKey(F,N,Y,Q){if(!v.$i)return;const le=await new Promise((ce,ue)=>{J(["@vscode/windows-registry"],ce,ue)});try{return le.GetStringRegKey(N,Y,Q)}catch{return}}D(F,N){return this.F(F)??this.G(F)??this.F(N)}F(F){if(typeof F=="number")return this.a.getWindowById(F)}G(F){if(typeof F=="number")return this.b.getWindowById(F)}H(F){let N=this.r.invokeFunction(t.$A9b);return N||(N=this.D(F)),N}};e.$X9b=C,Ee([D.$sh],C.prototype,"C",null),e.$X9b=C=Ee([ie(0,t.$y9b),ie(1,k.$w9b),ie(2,h.$f9b),ie(3,f.$Z8b),ie(4,a.$X8b),ie(5,i.$ij),ie(6,o.$Aj),ie(7,r.$_8b),ie(8,c.$p9b),ie(9,E.$Zh)],C)}),define(re[299],oe([0,1,15,26,8,22,33,2,13,4,7,107,36,180,91,132,53,24,5,71,79,27,80,34,61,60,29]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=void 0;const w="issue.processExplorerWindowState";let A=class{static{c=this}static{this.a="#1E1E1E"}constructor(C,j,F,N,Y,Q,le,ce,ue,K,X){this.g=C,this.h=j,this.i=F,this.j=N,this.k=Y,this.l=Q,this.m=le,this.n=ce,this.o=ue,this.p=K,this.q=X,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){b.$cU.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,l.localize)(0,null),rootProcess:await(0,v.$Or)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(N=>{(0,y.$Dm)(N)?j.push({name:N.hostName,rootProcess:N}):N.processes&&j.push({name:N.hostName,rootProcess:N.processes})})}catch(F){this.i.error(`Listing processes failed: ${F}`)}this.t(C,"vscode:listProcessesResponse",j)}),b.$cU.on("vscode:workbenchCommand",(C,j)=>{const{id:F,from:N,args:Y}=j;let Q;switch(N){case"processExplorer":Q=this.f;break;default:throw new Error(`Unexpected command source: ${N}`)}Q?.webContents.send("vscode:runAction",{id:F,from:N,args:Y})}),b.$cU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),b.$cU.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),F=[];for(const N of j.windows)F.push([N.pid,`window [${N.id}] (${N.title})`]);for(const{pid:N,name:Y}of r.$F9b.getAll())F.push([N,Y]);this.t(C,"vscode:pidToNameResponse",F)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const j=new S.$Rc,F=j.add(this.n.createIPCObjectUrl()),N=this.v(this.c,700,800);this.b=this.u(N,F,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:E.default}),this.b.loadURL(d.$jg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const j=new S.$Rc,F=j.add(this.n.createIPCObjectUrl()),N=this.p.getItem(w,void 0),Y=I(N)?N:this.v(this.f,800,500);this.d=this.u(Y,F,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:E.default}),this.d.loadURL(d.$jg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const Q=()=>{if(!this.d)return;const le=this.d.getSize(),ce=this.d.getPosition();if(!le||!ce)return;const ue={width:le[0],height:le[1],x:ce[0],y:ce[1]};this.p.setItem(w,ue)};this.d.on("moved",Q),this.d.on("resized",Q)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,D.$$f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,C),buttons:[(0,l.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),F=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(N,Y)=>{const Q=new M.$3d;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",Q.token,{replyChannel:F,extensionId:C}),b.$cU.once(F,(le,ce)=>{N(p.URI.parse(ce))});try{await(0,s.$2g)(5e3),Q.cancel(),Y(new Error("Timed out waiting for issue reporter URI"))}finally{b.$cU.removeHandler(F)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async N=>{const Y=new M.$3d;j.sendWhenReady("vscode:triggerIssueDataProvider",Y.token,{replyChannel:F,extensionId:C}),b.$cU.once(F,(Q,le)=>{N(le)});try{await(0,s.$2g)(5e3),Y.cancel(),N("Error: Extension timed out waiting for issue reporter data")}finally{b.$cU.removeHandler(F)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async N=>{const Y=new M.$3d;j.sendWhenReady("vscode:triggerIssueDataTemplate",Y.token,{replyChannel:F,extensionId:C}),b.$cU.once(F,(Q,le)=>{N(le)});try{await(0,s.$2g)(5e3),Y.cancel(),N("Error: Extension timed out waiting for issue reporter template")}finally{b.$cU.removeHandler(F)}})}async $getReporterStatus(C,j){const F=[!1,!1],N=this.issueReporterWindowCheck(),Y="vscode:triggerReporterStatus",Q=new M.$3d;return N.sendWhenReady(Y,Q.token,{replyChannel:Y,extensionId:C,extensionName:j}),await(0,s.$Sg)(new Promise(ce=>b.$cU.once("vscode:triggerReporterStatusResponse",(ue,K)=>ce(K))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),Q.cancel()})??F}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...F){C.sender.isDestroyed()||C.sender.send(j,...F)}u(C,j,F,N){const Y=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:F.title,backgroundColor:F.backgroundColor||c.a,webPreferences:{preload:d.$jg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$CC)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return Y.setMenuBarVisibility(!1),Y}v(C,j,F){let N;const Y=P.screen.getAllDisplays();if(Y.length===1)N=Y[0];else{if(u.$j){const ce=P.screen.getCursorScreenPoint();N=P.screen.getDisplayNearestPoint(ce)}!N&&C&&(N=P.screen.getDisplayMatching(C.getBounds())),N||(N=P.screen.getPrimaryDisplay()||Y[0])}const Q=N.bounds,le={width:j,height:F,x:Q.x+Q.width/2-j/2,y:Q.y+Q.height/2-F/2};return Q.width>0&&Q.height>0&&(le.x<Q.x&&(le.x=Q.x),le.y<Q.y&&(le.y=Q.y),le.x>Q.x+Q.width&&(le.x=Q.x),le.y>Q.y+Q.height&&(le.y=Q.y),le.width>Q.width&&(le.width=Q.width),le.height>Q.height&&(le.height=Q.height)),le}};e.$Y9b=A,e.$Y9b=A=c=Ee([ie(1,g.$X8b),ie(2,h.$ij),ie(3,y.$Cm),ie(4,m.$I9b),ie(5,$.$f9b),ie(6,a.$W9b),ie(7,i.$h9b),ie(8,f.$Aj),ie(9,o.$4N),ie(10,n.$y9b)],A);function I(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(re[300],oe([0,1,22,17,24,20,5,71,27,51,28,49,100]),function(J,e,P,R,s,M,D,S,d,u,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n0b=void 0;let l=class extends b.$l0b{constructor(m,$,g,h,a,E,f,i){super(m,$,h,a,E,i),this.e=g,this.u=f}s(m){return(0,b.$k0b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(v.$aV.CheckingForUpdates(m)),this.i.request({url:this.a},P.CancellationToken.None).then(u.$$o).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(v.$aV.Idle(1))):this.d(v.$aV.AvailableForDownload($))}).then(void 0,$=>{this.j.error($);const g=m?$.message||$:void 0;this.d(v.$aV.Idle(1,g))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(v.$aV.Idle(1))}};e.$n0b=l,e.$n0b=l=Ee([ie(0,M.$Z8b),ie(1,R.$ui),ie(2,p.$ol),ie(3,s.$X8b),ie(4,u.$5o),ie(5,D.$ij),ie(6,S.$W9b),ie(7,d.$Aj)],l)}),define(re[301],oe([0,1,48,46,26,8,22,56,45,9,7,144,21,17,24,16,20,5,71,27,51,28,49,100]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p0b=void 0;async function r(w,A=1e3){for(;!w();)await(0,M.$2g)(A)}let t;function n(){return typeof t>"u"&&(t=R.existsSync(u.$jc(u.$mc(process.execPath),"unins000.exe"))?0:1),t}let c=class extends o.$l0b{get cachePath(){const A=u.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(A,{recursive:!0}).then(()=>A)}constructor(A,I,k,C,j,F,N,Y,Q){super(A,I,C,j,F,Q),this.u=k,this.v=N,this.w=Y,A.setRelaunchHandler(this)}handleRelaunch(A){return A?.addArgs||A?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(i.$aV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(A){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$k0b)(I,A,this.k)}t(A){this.a&&(this.d(i.$aV.CheckingForUpdates(A)),this.i.request({url:this.a},D.CancellationToken.None).then(E.$$o).then(I=>{const k=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!A}),this.d(i.$aV.Idle(k)),Promise.resolve(null)):k===1?(this.d(i.$aV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(i.$aV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>b.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const F=I.url,N=I.hash,Y=`${C}.tmp`;return this.i.request({url:F},D.CancellationToken.None).then(Q=>this.v.writeFile(p.URI.file(Y),Q.stream)).then(N?()=>(0,v.$0T)(Y,I.hash):()=>{}).then(()=>b.Promises.rename(Y,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(i.$aV.Downloaded(I)):this.d(i.$aV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$Oi)(String(I)))}),this.j.error(I);const k=A?I.message||I:void 0;this.d(i.$aV.Idle(n(),k))}))}async o(A){A.update.url&&this.w.openExternal(void 0,A.update.url),this.d(i.$aV.Idle(n()))}async B(A){const I=await this.cachePath;return u.$jc(I,`CodeSetup-${this.k.quality}-${A}.exe`)}async C(A=null){const I=A?F=>!new RegExp(`${this.k.quality}-${A}\\.exe$`).test(F):()=>!0,k=await this.cachePath,j=(await b.Promises.readdir(k)).filter(I).map(async F=>{try{await b.Promises.unlink(u.$jc(k,F))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const A=this.state.update;this.d(i.$aV.Updating(A));const I=await this.cachePath;this.e.updateFilePath=u.$jc(I,`CodeSetup-${this.k.quality}-${A.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(i.$aV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((F,N)=>{J(["@vscode/windows-mutex"],F,N)});r(()=>j.isActive(C)).then(()=>this.d(i.$aV.Ready(A)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(A){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown"};this.d(i.$aV.Downloading(k)),this.e={packagePath:A},I?this.k.target==="user"?this.p():this.d(i.$aV.Downloaded(k)):this.d(i.$aV.Ready(k))}};e.$p0b=c,Ee([S.$sh],c.prototype,"cachePath",null),e.$p0b=c=Ee([ie(0,$.$Z8b),ie(1,l.$ui),ie(2,f.$ol),ie(3,y.$X8b),ie(4,E.$5o),ie(5,g.$ij),ie(6,m.$kk),ie(7,h.$W9b),ie(8,a.$Aj)],c)}),define(re[133],oe([0,1,15,8,22,50,3,2,13,68,4,7,190,26,66,17,53,24,64,16,20,5,27,80,252,82,28,102,70,60,29,30,55,128,39,34,54,69,23,6]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k,C,j,F,N,Y,Q,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u9b=e.$t9b=void 0;var ue;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(ue||(ue={}));class K extends S.$Sc{get lastFocusTime(){return this.g}get win(){return this.h}j(L){this.h=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.g=Date.now()}));const T=(0,A.$zC)(this.m)==="custom";if(p.$j&&T&&L.setSheetOffset((0,p.$J)((0,l.release)())?28:22),T&&(p.$i&&(0,A.$AC)(this.m)||p.$j)){const V=this.n.getItem(K.u);V&&this.updateWindowControls({height:V})}p.$i&&T&&L.hookWindowMessage(278,()=>{const[q,te]=L.getPosition(),he=P.screen.getCursorScreenPoint(),G=he.x-q,O=he.y-te;return(()=>!(G>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35)))()||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:G,y:O})),0}),this.r.args["open-devtools"]===!0&&L.webContents.openDevTools()}constructor(L,T,V){super(),this.m=L,this.n=T,this.r=V,this.a=this.B(new D.$Sd),this.onDidClose=this.a.event,this.b=this.B(new D.$Sd),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Sd),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Sd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=Date.now(),this.h=null,this.w=(0,A.$AC)(this.m),this.z=void 0,this.C=void 0}setRepresentedFilename(L){p.$j?this.win?.setRepresentedFilename(L):this.s=L}getRepresentedFilename(){return p.$j?this.win?.getRepresentedFilename():this.s}setDocumentEdited(L){p.$j&&this.win?.setDocumentEdited(L),this.t=L}isDocumentEdited(){return p.$j?!!this.win?.isDocumentEdited():!!this.t}focus(L){p.$j&&L?.force&&P.app.focus({steal:!0});const T=this.win;T&&(T.isMinimized()&&T.restore(),T.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(p.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.u="windowControlHeight"}updateWindowControls(L){const T=this.win;if(T){if(L.height&&this.n.setItem(X.u,L.height),p.$i&&this.w)T.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(p.$j&&L.height!==void 0){const V=(L.height-15)/2;V?T.setWindowButtonPosition({x:V,y:V}):T.setWindowButtonPosition(null)}}}toggleFullScreen(){this.D(!this.isFullScreen)}D(L){(0,A.$BC)(this.m)?this.F(L):this.H(L)}get isFullScreen(){if(p.$j&&typeof this.z=="boolean")return this.z;const L=this.win,T=L?.isFullScreen(),V=L?.isSimpleFullScreen();return!!(T||V)}F(L){const T=this.win;T?.isSimpleFullScreen()&&T?.setSimpleFullScreen(!1),this.G(L)}G(L){p.$j&&(this.z=L,this.C=new R.$lh,Promise.race([this.C.p,(0,R.$2g)(1e4)]).finally(()=>{this.z=void 0})),this.win?.setFullScreen(L)}H(L){const T=this.win;T?.isFullScreen()&&this.G(!1),T?.setSimpleFullScreen(L),T?.webContents.focus()}dispose(){super.dispose(),this.h=null}}e.$t9b=K;let X=class extends K{get id(){return this.M}get backupPath(){return this.O?.backupPath}get openedWorkspace(){return this.O?.workspace}get profile(){if(!this.config)return;const L=this.db.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.db.getProfileForWorkspace(this.config.workspace??(0,k.$ci)(this.backupPath,this.isExtensionDevelopmentHost))??this.db.defaultProfile}get remoteAuthority(){return this.O?.remoteAuthority}get config(){return this.O}get isExtensionDevelopmentHost(){return!!this.O?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.O?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.O?.debugId}constructor(L,T,V,q,te,he,G,O,U,x,z,Z,W,B,_,ae,ne,$e,me,ye,Se){super(x,ye,q),this.$=T,this.ab=V,this.bb=te,this.db=he,this.eb=G,this.fb=O,this.gb=U,this.hb=z,this.ib=Z,this.jb=W,this.kb=B,this.lb=_,this.mb=ae,this.nb=ne,this.ob=$e,this.pb=me,this.I=this.B(new D.$Sd),this.onWillLoad=this.I.event,this.J=this.B(new D.$Sd),this.onDidSignalReady=this.J.event,this.L=this.B(new D.$Sd),this.onDidDestroy=this.L.event,this.R=[],this.S=[],this.U=void 0,this.W=void 0,this.X=this.B(this.ob.createIPCObjectUrl()),this.Z=!1,this.qb=0;{const[Le,ve]=this.Ab(L.state);this.P=Le,this.$.trace("window#ctor: using window state",Le);const pe=this.P.mode===0||this.P.mode===3,ee=Se.invokeFunction(I.$z9b,this.P,{show:!pe,webPreferences:{preload:d.$jg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.X.resource.toString()}`],v8CacheOptions:this.r.useCodeCache?"bypassHeatCheck":"none"}});(0,u.mark)("code/willCreateCodeBrowserWindow"),this.h=new P.BrowserWindow(ee),(0,u.mark)("code/didCreateCodeBrowserWindow"),this.M=this.h.id,this.j(this.h);const fe=this.m.getValue("window"),ge=p.$j&&fe?.nativeTabs===!0;(p.$j||p.$i)&&ve&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.P.width,this.P.height,this.P.x,this.P.y].every(Ce=>typeof Ce=="number")&&this.h.setBounds({width:this.P.width,height:this.P.height,x:this.P.x,y:this.P.y}),pe&&((0,u.mark)("code/willMaximizeCodeWindow"),this.h.maximize(),this.P.mode===3&&this.D(!0),this.h.show(),(0,u.mark)("code/didMaximizeCodeWindow")),this.g=Date.now()}this.xb(),this.Hb(),this.rb()}setReady(){for(this.$.trace(`window#load: window reported ready (id: ${this.M})`),this.qb=2;this.R.length;)this.R.pop()(this);this.J.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.R.push(L)})}get isReady(){return this.qb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){V.dispose(),q.dispose(),L()}const V=this.onDidClose(()=>T()),q=this.onWillLoad(()=>T())})}rb(){this.h.on("unresponsive",()=>this.ub(1)),this.h.webContents.on("render-process-gone",(T,V)=>this.ub(2,{...V})),this.h.webContents.on("did-fail-load",(T,V,q)=>this.ub(3,{reason:q,exitCode:V})),this.h.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.h.webContents.on("did-finish-load",()=>{this.Y&&(this.O=this.Y,this.Y=void 0)}),this.B(this.onDidMaximize(()=>{this.O&&(this.O.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.O&&(this.O.maximized=!1)})),this.B(D.Event.fromNodeEventEmitter(this.h,"enter-full-screen")(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.C?.complete(),this.C=void 0})),this.B(D.Event.fromNodeEventEmitter(this.h,"leave-full-screen")(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.C?.complete(),this.C=void 0})),this.B(this.m.onDidChangeConfiguration(T=>this.xb(T))),this.B(this.ib.onDidDeleteUntitledWorkspace(T=>this.wb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.h.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,V)=>{const q=await this.tb();V({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,q)})})}tb(){return this.sb||(this.sb=(0,r.$mp)(this.nb.version,this.nb,this.r,this.m,this.eb,this.fb,this.kb)),this.sb}async ub(L,T){switch(L){case 2:this.$.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.$.error("CodeWindow: detected unresponsive");break;case 3:this.$.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.kb.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.mb.kill(1);return}if(this.r.args["enable-smoke-test-driver"]){await this.vb(!1,!1),this.mb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.h&&this.h.webContents&&this.h.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:q}=await this.lb.showMessageBox({type:"warning",buttons:[(0,b.localize)(0,null),(0,b.localize)(1,null),(0,b.localize)(2,null)],message:(0,b.localize)(3,null),detail:(0,b.localize)(4,null),checkboxLabel:this.O?.workspace?(0,b.localize)(5,null):void 0},this.h);if(V!==2){const te=V===0;await this.vb(te,q)}}else if(L===2){let V;T?V=(0,b.localize)(7,null,T.reason,T.exitCode??"<unknown>"):V=(0,b.localize)(6,null);const{response:q,checkboxChecked:te}=await this.lb.showMessageBox({type:"warning",buttons:[this.O?.workspace?(0,b.localize)(8,null):(0,b.localize)(9,null),(0,b.localize)(10,null)],message:V,detail:this.O?.workspace?(0,b.localize)(11,null):(0,b.localize)(12,null),checkboxLabel:this.O?.workspace?(0,b.localize)(13,null):void 0},this.h),he=q===0;await this.vb(he,te)}break}}async vb(L,T){const V=this.O?.workspace;if(T&&V)try{const q=this.gb.workspaceStorage(V);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.$.error(q)}if(this.L.fire(),this.h?.destroy(),L&&this.O){let q,te;(0,k.$$h)(V)?q={folderUri:V.uri}:(0,k.$di)(V)?q={workspaceUri:V.configPath}:te=!0,(0,le.$Ob)(await this.pb.open({context:5,userEnv:this.O.userEnv,cli:{...this.r.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:te,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}wb(L){this.O?.workspace?.id===L.id&&(this.O.workspace=void 0)}xb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const T=this.Eb();T!==this.Q&&(this.Q=T,this.Fb(T))}if(!L||L.affectsConfiguration("http.proxy")){let T=(this.m.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.U||V!==this.W)){this.U=T,this.W=V;const q=T||"",te=V?`${V},<local>`:"<local>";this.$.trace(`Setting proxy to '${q}', bypassing '${te}'`),this.h.webContents.session.setProxy({proxyRules:q,proxyBypassRules:te,pacScript:""})}}}addTabbedWindow(L){p.$j&&L.win&&this.h.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.$.trace(`window#load: attempt to load window (id: ${this.M})`),this.isDocumentEdited()&&(!T.isReload||!this.jb.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.h.setTitle(this.nb.nameLong)),this.yb(L,T),this.qb===0?this.O=L:this.Y=L,this.qb=1,this.h.loadURL(d.$jg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.r.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.Z;this.Z=!0,!this.r.isBuilt&&!this.r.extensionTestsLocationURI&&this.B(new R.$ah(()=>{this.h&&!this.h.isVisible()&&!this.h.isMinimized()&&(this.h.show(),this.focus({force:!0}),this.h.webContents.openDevTools())},1e4)).schedule(),this.I.fire({workspace:L.workspace,reason:T.isReload?3:V?2:1})}yb(L,T){const V=(this.O??this.Y)?.userEnv;if(V){const q=(0,h.$Zl)(V)&&!(0,h.$Zl)(L.userEnv),te=this.isExtensionDevelopmentHost;(q||te)&&(L.userEnv={...V,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.h.isMaximized(),L.partsSplash=this.hb.getWindowSplash(),(0,u.mark)("code/willOpenNewWindow"),L.perfMarks=(0,u.getMarks)(),this.X.update(L)}async reload(L){const T=Object.assign({},this.O);T.workspace=await this.zb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.bb.serialize(),T.continueOn=this.r.continueOn,T.profiles={all:this.db.profiles,profile:this.profile||this.db.defaultProfile,home:this.db.profilesHome},T.logLevel=this.ab.getLogLevel(),T.loggers={window:this.ab.getRegisteredLoggers(this.id),global:this.ab.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async zb(L){if((0,k.$di)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===d.Schemas.file&&!await this.eb.exists(T))return}else if((0,k.$$h)(L.workspace)){const T=L.workspace.uri;if(T.scheme===d.Schemas.file&&!await this.eb.exists(T))return}return L.workspace}serializeWindowState(){if(!this.h)return(0,j.$W8b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,j.$W8b)();return{mode:3,display:V?V.id:void 0,width:this.P.width||q.width,height:this.P.height||q.height,x:this.P.x||0,y:this.P.y||0}}const L=Object.create(null);let T;if(!p.$j&&this.h.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let V;T===1?V=this.getBounds():V=this.h.getNormalBounds(),L.x=V.x,L.y=V.y,L.width=V.width,L.height=V.height}return L}Ab(L){(0,u.mark)("code/willRestoreCodeWindowState");let T=!1;if(L)try{const V=P.screen.getAllDisplays();T=V.length>1,L=this.Bb(L,V)}catch(V){this.$.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,u.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$W8b)(),T]}Bb(L,T){if(this.$.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.$.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.$.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const te=this.Cb(T[0]);if(te){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!te||(L.x<te.x&&(L.x=te.x),L.y<te.y&&(L.y=te.y))};this.$.trace("window#validateWindowState: 1 monitor working area",te),he(),L.width>te.width&&(L.width=te.width),L.height>te.height&&(L.height=te.height),L.x>te.x+te.width-128&&(L.x=te.x+te.width-L.width),L.y>te.y+te.height-128&&(L.y=te.y+te.height-L.height),he()}return L}if(L.display&&L.mode===3){const te=T.find(he=>he.id===L.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.$.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,j.$W8b)(3);return he.x=te.bounds.x,he.y=te.bounds.y,he}}let V,q;try{V=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),q=this.Cb(V)}catch{}if(V&&q&&L.x+L.width>q.x&&L.y+L.height>q.y&&L.x<q.x+q.width&&L.y<q.y+q.height)return this.$.trace("window#validateWindowState: multi-monitor working area",q),L}Cb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,T]=this.h.getPosition(),[V,q]=this.h.getSize();return{x:L,y:T,width:V,height:q}}D(L){super.D(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.Q&&this.Fb(this.Q,!1)}Eb(){let L=(0,A.$yC)(this.m);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Fb(L,T=!0){p.$j||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,b.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Gb(L)}):this.Gb(L))}Gb(L){const T=this.isFullScreen;switch(L){case"classic":this.h.setMenuBarVisibility(!T),this.h.autoHideMenuBar=T;break;case"visible":this.h.setMenuBarVisibility(!0),this.h.autoHideMenuBar=!1;break;case"toggle":this.h.setMenuBarVisibility(!1),this.h.autoHideMenuBar=!0;break;case"hidden":this.h.setMenuBarVisibility(!1),this.h.autoHideMenuBar=!1;break}}close(){this.h?.close()}sendWhenReady(L,T,...V){this.isReady?this.send(L,...V):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...V)})}send(L,...T){if(this.h){if(this.h.isDestroyed()||this.h.webContents.isDestroyed()){this.$.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.h.webContents.send(L,...T)}catch(V){this.$.warn(`Error sending IPC message to channel '${L}' of window ${this.M}: ${(0,M.$Li)(V)}`)}}}updateTouchBar(L){p.$j&&this.S.forEach((T,V)=>{const q=L[V];T.segments=this.Jb(q)})}Hb(){if(p.$j){for(let L=0;L<10;L++){const T=this.Ib();this.S.push(T)}this.h.setTouchBar(new P.TouchBar({items:this.S}))}}Ib(L=[]){const T=this.Jb(L),V=new P.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[q].id,from:"touchbar"})}});return V}Jb(L=[]){return L.map(V=>{let q;V.icon&&!c.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===d.Schemas.file&&(q=P.nativeImage.createFromPath(v.URI.revive(V.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let te;return typeof V.title=="string"?te=V.title:te=V.title.value,{id:V.id,label:q?void 0:te,icon:q}})}dispose(){super.dispose(),this.ab.deregisterLoggers(this.id)}};e.$u9b=X,e.$u9b=X=Ee([ie(1,f.$ij),ie(2,Q.$r9b),ie(3,g.$X8b),ie(4,F.$un),ie(5,Y.$68b),ie(6,a.$kk),ie(7,t.$08b),ie(8,t.$88b),ie(9,m.$ui),ie(10,w.$_8b),ie(11,C.$p9b),ie(12,y.$e9b),ie(13,n.$ol),ie(14,$.$f9b),ie(15,E.$Z8b),ie(16,i.$Aj),ie(17,o.$h9b),ie(18,I.$y9b),ie(19,N.$4N),ie(20,ce.$Zh)],X)}),define(re[302],oe([0,1,15,17,24,5,34,133]),function(J,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=void 0;let d=class extends S.$t9b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(p,v,b,l,y){super(l,y,v),this.I=p,this.J=b,this.id=this.I.id,this.parentId=-1,p.removeAllListeners("devtools-reload-page"),this.tryClaimWindow()}tryClaimWindow(){if(this.h||this.q.isDisposed||this.I.isDestroyed())return;const p=P.BrowserWindow.fromWebContents(this.I);p&&(this.J.trace("[aux window] Claimed browser window instance"),this.j(p),p.setMenu(null))}};e.$v9b=d,e.$v9b=d=Ee([ie(1,s.$X8b),ie(2,M.$ij),ie(3,R.$ui),ie(4,D.$4N)],d)}),define(re[303],oe([0,1,15,3,2,13,36,302,6,5,29]),function(J,e,P,R,s,M,D,S,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;let v=class extends s.$Sc{constructor(l,y){super(),this.g=l,this.h=y,this.a=this.B(new R.$Sd),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$Sd),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$Sd),this.onDidTriggerSystemContextMenu=this.c.event,this.f=new Map,this.j()}j(){P.app.on("browser-window-created",(l,y)=>{const m=this.getWindowById(y.id);m&&(this.h.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),m.tryClaimWindow())}),D.$cU.handle("vscode:registerAuxiliaryWindow",async(l,y)=>{const m=this.getWindowById(l.sender.id);return m&&(this.h.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),m.parentId=y),l.sender.id})}createWindow(){return this.g.invokeFunction(p.$z9b,void 0,{webPreferences:{preload:M.$jg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(l){const y=new s.$Rc,m=this.g.createInstance(S.$v9b,l);this.f.set(m.id,m),y.add((0,s.$Qc)(()=>this.f.delete(m.id))),y.add(m.onDidMaximize(()=>this.a.fire(m))),y.add(m.onDidUnmaximize(()=>this.b.fire(m))),y.add(m.onDidTriggerSystemContextMenu(({x:$,y:g})=>this.c.fire({window:m,x:$,y:g}))),R.Event.once(m.onDidClose)(()=>y.dispose())}getWindowById(l){return this.f.get(l)}getFocusedWindow(){const l=P.BrowserWindow.getFocusedWindow();if(l)return this.getWindowById(l.id)}getLastActiveWindow(){return(0,p.$B9b)(Array.from(this.f.values()))}getWindows(){return Array.from(this.f.values())}};e.$U0b=v,e.$U0b=v=Ee([ie(0,d.$Zh),ie(1,u.$ij)],v)}),define(re[83],oe([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,55,31,53]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$09b=e.$99b=void 0,e.$99b=(0,y.$1h)("workspacesHistoryMainService");let r=class extends S.$Sc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,c,w,A,I){super(),this.f=n,this.g=c,this.h=w,this.j=A,this.m=I,this.c=this.B(new M.$Sd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$Yg(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],w=[];for(const I of n)if((0,h.$ccb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(c,I.workspace)&&c.push(I);else if((0,h.$dcb)(I))this.y(c,I.folderUri)||c.push(I);else{const k=this.z(w,I.fileUri),C=I.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,p.$zg)(I.fileUri))>=0;!k&&!C&&(w.push(I),u.$i&&I.fileUri.scheme===d.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const A=await this.r({workspaces:c,files:w});c=A.workspaces,w=A.files,c.length>o.a&&(c.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:c,files:w}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const c=k=>{const C=this.u(k);for(const j of n)if(p.$tg.isEqual(j,C))return!1;return!0},w=await this.getRecentlyOpened(),A=w.workspaces.filter(c),I=w.files.filter(c);(A.length!==w.workspaces.length||I.length!==w.files.length)&&(await this.t({files:I,workspaces:A}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,l.localize)(0,null),(0,l.localize)(1,null)],message:(0,l.localize)(2,null),detail:(0,l.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const c=new f.$Ac(I=>p.$tg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)c.set(this.u(I),I);const w=new f.$Ac(I=>p.$tg.getComparisonKey(I));if(n?.files)for(const I of n.files)w.set(this.u(I),I);const A=await this.s();for(const I of A.workspaces){const k=c.get(this.u(I));k?k.label=k.label??I.label:c.set(this.u(I),I)}for(const I of A.files){const k=w.get(this.u(I));k?k.label=k.label??I.label:w.set(this.u(I),I)}return{workspaces:[...c.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let n;const c=this.j.get(o.b,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,h.$jcb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,h.$kcb)(n)),-1,1)}u(n){return(0,h.$dcb)(n)?n.folderUri:(0,h.$ecb)(n)?n.fileUri:n.workspace.configPath}w(n,c){return!!n.find(w=>(0,h.$ccb)(w)&&w.workspace.id===c.id)}y(n,c){return!!n.find(w=>(0,h.$dcb)(w)&&p.$tg.isEqual(w.folderUri,c))}z(n,c){return!!n.find(w=>p.$tg.isEqual(w.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){u.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!u.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,l.localize)(4,null),description:(0,l.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const I of P.app.getJumpListSettings().removedItems){const k=I.args;if(k){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(k);C&&c.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(c);let w=!1;const A=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const k=(0,h.$ccb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(k,I.label);let F;return v.URI.isUri(k)?F=`--folder-uri "${k.toString()}"`:(w=!0,F=`--file-uri "${k.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&n.push({type:"custom",name:w?(0,l.localize)(6,null):(0,l.localize)(7,null),items:A})}n.push({type:"recent"});try{const c=P.app.setJumpList(n);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(n,c){if(c)return{title:(0,D.$Ov)(c).name,description:c};if(v.URI.isUri(n))return{title:(0,p.$zg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,l.localize)(8,null),description:""};let w=(0,p.$zg)(n.configPath);return w.endsWith(a.$ki)&&(w=w.substr(0,w.length-a.$ki.length-1)),{title:(0,l.localize)(9,null,w),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Gv)(n.fsPath):n.toString()}async N(){if(!u.$j)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let w=0;for(let I=0;I<n.workspaces.length&&w<o.C;I++){const k=this.u(n.workspaces[I]);if(k.scheme===d.Schemas.file){const C=(0,p.$qg)(k);await b.Promises.exists(C)&&(c.push(C),w++)}}const A=[];for(let I=0;I<n.files.length&&w<o.D;I++){const k=this.u(n.files[I]);if(k.scheme===d.Schemas.file){const C=(0,p.$qg)(k);if(o.G.includes((0,p.$zg)(k))||c.includes(C))continue;await b.Promises.exists(C)&&(A.push(C),w++)}}A.reverse().forEach(I=>P.app.addRecentDocument(I)),c.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$09b=r,e.$09b=r=o=Ee([ie(0,$.$ij),ie(1,E.$p9b),ie(2,m.$Z8b),ie(3,g.$08b),ie(4,i.$f9b)],r)}),define(re[304],oe([0,1,15,8,22,47,4,7,181,65,17,24,20,5,231,71,27,34,28,49,60,29,83]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,A,I,k,C,j,F,N,Y,Q,le,ce){this.n=w,this.o=A,this.p=I,this.q=k,this.r=C,this.s=j,this.t=F,this.u=N,this.v=Y,this.w=Q,this.x=le,this.y=ce,this.m=Object.create(null),this.g=new R.$ah(()=>this.F(),0),this.h=new R.$ah(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,E.$zC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const w=this.t.getItem(o.a);w&&(w.menus&&(this.k=w.menus),w.keybindings&&(this.l=w.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,F,N)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:F?.id})},this.m["workbench.action.newWindow"]=(j,F,N)=>this.p.openEmptyWindow({context:2,contextWindowId:F?.id}),this.m["workbench.action.files.openFileFolder"]=(j,F,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,F,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,F,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const w=this.x.youTubeUrl;w&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(w,"openYouTubeUrl"));const A=this.x.requestFeatureUrl;A&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(A,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const k=this.x.licenseUrl;k&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const j=k.indexOf("?")>0?"&":"?";this.ab(`${k}${j}lang=${D.$w}`,"openLicenseUrl")}else this.ab(k,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&k&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(w=>this.G(w)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const w=this.o.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get D(){if(!D.$j)return!1;const w=this.o.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,A){this.k=w.menus,this.l=w.keybindings,this.t.setItem(o.a,w),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(w){D.$j&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.d=w.newCount===0,this.E())}H(){if(!D.$j)return;const w=P.BrowserWindow.getFocusedWindow();this.f=!w||!!this.y.getWindowById(w.id),this.E()}I(){const w=P.Menu.getApplicationMenu();if(w&&this.j.push(w),Object.keys(this.k).length===0){this.J(D.$j?new P.Menu:null);return}const A=new P.Menu;let I;if(D.$j){const C=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),A.append(I)}if(D.$j&&!this.c){this.c=!0;const C=new P.Menu;C.append(new P.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(C)}if(this.M("File")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(1,null)),submenu:C});this.O(C,"File"),A.append(j)}if(this.M("Edit")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(2,null)),submenu:C});this.O(C,"Edit"),A.append(j)}if(this.M("Selection")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(3,null)),submenu:C});this.O(C,"Selection"),A.append(j)}if(this.M("View")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(4,null)),submenu:C});this.O(C,"View"),A.append(j)}if(this.M("Go")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(5,null)),submenu:C});this.O(C,"Go"),A.append(j)}if(this.M("Run")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(6,null)),submenu:C});this.O(C,"Run"),A.append(j)}if(this.M("Terminal")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(7,null)),submenu:C});this.O(C,"Terminal"),A.append(j)}let k;if(this.M("Window")){const C=new P.Menu;k=new P.MenuItem({label:this.cb(d.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(k&&A.append(k),this.M("Help")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(d.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),A.append(j)}A.items&&A.items.length>0?this.J(A):this.J(null),this.h.schedule()}J(w){if(P.Menu.setApplicationMenu(w),w)for(const A of this.y.getWindows())A.win?.setMenu(null)}K(w){const A=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let k;if(this.M("Preferences")){const ce=new P.Menu;this.O(ce,"Preferences"),k=new P.MenuItem({label:this.cb(d.localize(11,null)),submenu:ce})}const C=new P.Menu,j=new P.MenuItem({label:d.localize(12,null),role:"services",submenu:C}),F=new P.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new P.MenuItem({label:d.localize(15,null),role:"unhide"}),Q=new P.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(ce,ue,K)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||X?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),le=[A];le.push(...I),k&&le.push(n(),k),le.push(n(),j,n(),F,N,Y,n(),Q),le.forEach(ce=>w.append(ce))}async L(w){if(this.p.getWindowCount()===0)return!0;const A=this.o.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.S(w)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return I===0}return!0}M(w){if(!D.$j&&(0,E.$zC)(this.o)==="custom")return!1;switch(w){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[w];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[w]}}N(w,A){A.forEach(I=>{if((0,y.$69b)(I))w.append(n());else if((0,y.$59b)(I)){const k=new P.Menu,C=new P.MenuItem({label:this.cb(I.label),submenu:k});this.N(k,I.submenu.items),w.append(C)}else(0,y.$79b)(I)?w.append(this.Q(I)):(0,y.$89b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(w),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?w.append(new P.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):w.append(this.W(I.label,I.id,!1,I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(w,A){this.k&&this.k[A]&&this.N(w,this.k[A].items)}P(w){const A=this.V();A.length&&(A.forEach(I=>w.append(I)),w.append(n()))}Q(w){const A=S.URI.revive(w.uri),I=w.id,k=I==="openRecentFile"?{fileUri:A}:I==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new P.MenuItem(this.$(I,{label:w.label,click:async(C,j,F)=>{const N=this.R(F);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[k],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([A])}},!1))}R(w){return!!(w&&(!D.$j&&(w.ctrlKey||w.shiftKey)||D.$j&&(w.metaKey||w.altKey)))}S(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}T(w,A,I){const k={label:this.cb(w),role:I,enabled:!0};return new P.MenuItem(this.Z(A,k))}U(w){const A=new P.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),k=new P.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(d.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,I,n(),C,...j,n(),k].forEach(F=>w.append(F))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(w,A,I,k){const C=this.cb(w),j=typeof A=="function"?A:(le,ce,ue)=>{const K=le?le.userSettingsLabel:null;let X=A;Array.isArray(A)&&(X=this.R(ue)?A[1]:A[0]),K&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:X})},F=typeof I=="boolean"?I:this.p.getWindowCount()>0,N=typeof k=="boolean"?k:!1,Y={label:C,click:j,enabled:F};N&&(Y.type="checkbox",Y.checked=N);let Q;return typeof A=="string"?Q=A:Array.isArray(A)&&(Q=A[0]),D.$j&&(Q==="editor.action.clipboardCutAction"?Y.role="cut":Q==="editor.action.clipboardCopyAction"?Y.role="copy":Q==="editor.action.clipboardPasteAction"&&(Y.role="paste"),Q==="undo"?Y.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?Y.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(Y.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(Q,Y))}X(w,A){return(I,k,C)=>{const j=P.BrowserWindow.getFocusedWindow();if(!j)return A.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return A.inDevTools(j.webContents.devToolsWebContents);w(I,k||j,C)}}Y(w){let A=P.BrowserWindow.getFocusedWindow();if(A){const k=this.y.getWindowById(A.id);k&&(A=this.p.getWindowById(k.parentId)?.win??null)}if(!A){const k=this.p.getLastActiveWindow();k?.win?.isMinimized()&&(A=k.win)}const I=A?this.p.getWindowById(A.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",w),D.$j&&!this.q.isBuilt&&!I.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const k={id:w.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,k)}else{const k={userSettingsLabel:w.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,k)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",w),!1}Z(w,A){const I=typeof w=="string"?this.l[w]:void 0;if(I?.label){if(I.isNative!==!1)A.accelerator=I.label,A.userSettingsLabel=I.userSettingsLabel;else if(typeof A.label=="string"){const k=A.label.indexOf("[");k>=0?A.label=`${A.label.substr(0,k)} [${I.label}]`:A.label=`${A.label} [${I.label}]`}}else A.accelerator=void 0;return A}$(w,A,I=!A.accelerator){I&&(A=this.Z(w,A));const k=A.click;return A.click=(C,j,F)=>{this.bb(w),k?.(C,j,F)},A}ab(w,A){this.w.openExternal(void 0,w),this.bb(A)}bb(w){this.r.publicLog2("workbenchActionExecuted",{id:w,from:r})}cb(w){return(0,M.$Lv)(w,!this.C)}};e.$$9b=t,e.$$9b=t=o=Ee([ie(0,a.$bV),ie(1,p.$ui),ie(2,f.$y9b),ie(3,v.$X8b),ie(4,h.$ol),ie(5,i.$99b),ie(6,g.$4N),ie(7,b.$Z8b),ie(8,l.$ij),ie(9,m.$W9b),ie(10,$.$Aj),ie(11,u.$w9b)],t);function n(){return new P.MenuItem({type:"separator"})}}),define(re[305],oe([0,1,6,20,5,304]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a0b=e.$_9b=void 0,e.$_9b=(0,P.$1h)("menubarMainService");let D=class{constructor(d,u,p){this.b=d,this.c=u,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$$9b)}async updateMenubar(d,u){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(u,d)}};e.$a0b=D,e.$a0b=D=Ee([ie(0,P.$Zh),ie(1,R.$Z8b),ie(2,s.$ij)],D)}),define(re[306],oe([0,1,15,21,131,26,23,22,3,33,47,2,13,9,68,4,35,19,12,7,191,66,17,53,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,55,70,39,54,69,65]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k,C,j,F,N,Y,Q,le,ce,ue,K,X,H,L,T,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=void 0;function q(G){return(0,le.$di)(G?.workspace)}function te(G){return(0,le.$$h)(G?.workspace)}let he=class extends v.$Sc{constructor(O,U,x,z,Z,W,B,_,ae,ne,$e,me,ye,Se,Le,ve,pe,ee,fe,ge){super(),this.r=O,this.s=U,this.t=x,this.u=z,this.w=Z,this.z=W,this.C=B,this.D=_,this.F=ae,this.G=ne,this.H=$e,this.I=me,this.J=ye,this.L=Se,this.M=Le,this.N=ve,this.O=pe,this.P=ee,this.Q=fe,this.R=ge,this.a=this.B(new d.$Sd),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$Sd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$Sd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$Sd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$Sd),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new d.$Sd),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new d.$Sd),this.onDidTriggerSystemContextMenu=this.j.event,this.m=new Map,this.n=this.B(new Q.$x0b(this,this.z,this.G,this.u,this.I)),this.S()}S(){this.B(this.L.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const U=new v.$Rc;if(U.add(d.Event.any(O.onDidClose,O.onDidDestroy)(()=>U.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)U.add(this.P.addValidFileRoot(x));O.config.extensionTestsPath&&U.add(this.P.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,U){const x=this.D.args,z=U?.remoteAuthority||void 0,Z=!0,W=U?.forceReuseWindow,B=!W;return this.open({...O,cli:x,forceEmpty:Z,forceNewWindow:B,forceReuseWindow:W,remoteAuthority:z})}openExistingWindow(O,U){O.focus(),this.U(U,[O])}async open(O){this.u.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const U=[],x=[],z=[],Z=[],W=[];let B,_=0;const ae=await this.bb(O);this.u.trace("windowsManager#open pathsToOpen",ae);for(const Se of ae)te(Se)?O.addMode?U.push(Se):x.push(Se):q(Se)?z.push(Se):Se.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),B.filesToOpenOrCreate.push(Se)):Se.backupPath?W.push({backupFolder:(0,l.$nc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):_++;O.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),O.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&O.waitMarkerFileURI&&(B.filesToWait={paths:(0,D.$Hb)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Z.push(...this.L.getUntitledWorkspaces()),z.push(...Z),W.push(...this.H.getEmptyWindowBackups())):W.length=0;const{windows:ne,filesOpenedInWindow:$e}=await this.W(O,z,x,W,_,B,U);if(this.u.trace(`windowsManager#open used window count ${ne.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${W.length}, emptyToOpen: ${_})`),ne.length>1)if($e)$e.focus();else{const Se=this.n.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ve=!0;if(Se){const pe=ne.filter(ee=>this.n.state.lastActiveWindow&&ee.backupPath===this.n.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ve=!1)}if(Le)for(let pe=ne.length-1;pe>=0;pe--){const ee=ne[pe];if(!(ee.openedWorkspace&&Z.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&W.some(fe=>ee.backupPath&&fe.backupFolder===(0,l.$nc)(ee.backupPath)))){ee.focus(),ve=!1;break}}ve&&ne[ne.length-1].focus()}const me=B&&B.filesToDiff.length>0,ye=B&&B.filesToMerge.length>0;if(!ne.some(Se=>Se.isExtensionDevelopmentHost)&&!me&&!ye&&!O.noRecentEntry){const Se=[];for(const Le of ae)q(Le)&&!Le.transient?Se.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):te(Le)?Se.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Se.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.J.addRecentlyOpened(Se)}return this.U(O,ne),ne}U(O,U){const x=O.waitMarkerFileURI;O.context===0&&x&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.O.del(x)}catch{}})()}async W(O,U,x,z,Z,W,B){const _=[];let ae;function ne(pe,ee){_.push(pe),ee&&(ae=pe,W=void 0)}let{openFolderInNewWindow:$e,openFilesInNewWindow:me}=this.nb(O);if(!O.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,ee=this.sb(pe);ee&&ne(this.Z(ee,B.map(fe=>fe.workspace.uri)))}const ye=x.length+U.length+z.length;if(W&&ye===0){const pe=W.filesToOpenOrCreate[0]||W.filesToDiff[0]||W.filesToMerge[3],ee=this.getWindows().filter(ge=>W&&(0,g.$Hg)(ge.remoteAuthority,W.remoteAuthority));let fe;pe?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,Y.$i9b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===b.Schemas.file?this.L.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.tb(ee))),fe?(0,le.$di)(fe.openedWorkspace)?U.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$$h)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ne(this.X(O,fe,W),!0):ne(await this.ob({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,D.$Mb)(U,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,D.$Hb)(Se.map(ee=>(0,Y.$j9b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],fe=(0,g.$Hg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;ne(this.X(O,ee,fe),!!fe),$e=!0}for(const ee of Se){if(pe.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,ge=(0,g.$Hg)(W?.remoteAuthority,fe)?W:void 0;ne(await this.ab(O,ee,$e,ge),!!ge),$e=!0}}const Le=(0,D.$Mb)(x,pe=>g.$tg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(ee=>(0,Y.$j9b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],fe=(0,g.$Hg)(W?.remoteAuthority,ee.remoteAuthority)?W:void 0;ne(this.X(O,ee,fe),!!fe),$e=!0}for(const ee of Le){if(pe.some(Ce=>(0,le.$$h)(Ce.openedWorkspace)&&g.$tg.isEqual(Ce.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,ge=(0,g.$Hg)(W?.remoteAuthority,fe)?W:void 0;ne(await this.ab(O,ee,$e,ge),!!ge),$e=!0}}const ve=(0,D.$Mb)(z,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const ee=pe.remoteAuthority,fe=(0,g.$Hg)(W?.remoteAuthority,ee)?W:void 0;ne(await this.$(O,!0,ee,fe,pe),!!fe),$e=!0}if(_.length===0||W){W&&!Z&&Z++;const pe=W?W.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<Z;ee++)ne(await this.$(O,$e,pe,W),!!W),$e=!0}return{windows:(0,D.$Mb)(_),filesOpenedInWindow:ae}}X(O,U,x){this.u.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Y(U);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",S.CancellationToken.None,z),U}Y(O){let U=O;const x=P.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const z=this.R.getWindowById(x.id);z&&z.parentId===O.id&&(U=z)}U.focus()}Z(O,U){this.u.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),O.focus();const x={foldersToAdd:U};return O.sendWhenReady("vscode:addFolders",S.CancellationToken.None,x),O}$(O,U,x,z,Z){this.u.trace("windowsManager#doOpenEmpty",{restore:!!Z,remoteAuthority:x,filesToOpen:z,forceNewWindow:U});let W;return!U&&typeof O.contextWindowId=="number"&&(W=this.getWindowById(O.contextWindowId)),this.ob({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:U,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:W,emptyWindowBackupInfo:Z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}ab(O,U,x,z,Z){return this.u.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:z}),!x&&!Z&&typeof O.contextWindowId=="number"&&(Z=this.getWindowById(O.contextWindowId)),this.ob({workspace:U.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:Z,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async bb(O){let U,x=!1,z=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(U=await this.cb(O),x=!0):O.forceEmpty?U=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(U=await this.db(O.cli),U.length===0&&U.push(Object.create(null)),x=!0):(U=await this.fb(),U.length===0&&U.push(Object.create(null)),z=!0),!O.addMode&&x){const Z=U.filter(W=>te(W));if(Z.length>1){const W=Z[0].remoteAuthority;if(Z.every(B=>(0,g.$Hg)(B.remoteAuthority,W))){const B=await this.L.createUntitledWorkspace(Z.map(_=>({uri:_.workspace.uri})));U.push({workspace:B,remoteAuthority:W}),U=U.filter(_=>!te(_))}}}if(O.initialStartup&&!z&&this.I.getValue("window")?.restoreWindows==="preserve"){const Z=await this.fb();U.unshift(...Z.filter(W=>q(W)||te(W)||W.backupPath))}return U}async cb(O){const U={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,D.$Hb)(O.urisToOpen||[]).map(async z=>{const Z=await this.hb(z,U);if(Z)return Z.label=z.label,Z;const W=this.jb(z);this.N.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:W.scheme===b.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:W.scheme===b.Schemas.file?(0,E.localize)(3,null,(0,p.$Fv)(W,{os:m.OS,tildify:this.D})):(0,E.localize)(4,null,W.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(x)}async db(O){const U=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},z=O["folder-uri"];if(z){const B=await Promise.all(z.map(_=>{const ae=this.eb(_);if(ae)return this.hb({folderUri:ae},x)}));U.push(...(0,D.$Hb)(B))}const Z=O["file-uri"];if(Z){const B=await Promise.all(Z.map(_=>{const ae=this.eb(_);if(ae)return this.hb((0,le.$ti)(_)?{workspaceUri:ae}:{fileUri:ae},x)}));U.push(...(0,D.$Hb)(B))}const W=await Promise.all(O._.map(B=>x.remoteAuthority?this.mb(B,x):this.kb(B,x)));return U.push(...(0,D.$Hb)(W)),U}eb(O){try{const U=a.URI.parse(O);if(!U.scheme){this.u.error(`Invalid URI input string, scheme missing: ${O}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.u.error(`Invalid URI input string: ${O}, ${U.message}`)}}async fb(){const O=this.gb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];O!=="one"&&U.push(...this.n.state.openedWindows),this.n.state.lastActiveWindow&&U.push(this.n.state.lastActiveWindow);const x=await Promise.all(U.map(async z=>{if(z.workspace){const Z=await this.hb({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(Z))return Z}else if(z.folderUri){const Z=await this.hb({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(te(Z))return Z}else if(O!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.$Hb)(x)}}}gb(){let O;return this.G.wasRestarted?O="all":(O=this.I.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async hb(O,U=Object.create(null)){const x=this.jb(O);return x.scheme===b.Schemas.file?((0,j.$xC)(O)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.kb(x.fsPath,U)):this.ib(O,U)}ib(O,U){let x=this.jb(O);const z=(0,k.$7k)(x)||U.remoteAuthority;if(x=(0,g.$Jg)((0,g.$Dg)(x)),(0,j.$xC)(O)){if(U.gotoLineMode){const{path:Z,line:W,column:B}=(0,u.$0f)(x.path);return{fileUri:x.with({path:Z}),options:{selection:W?{startLineNumber:W,startColumn:B||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,j.$vC)(O))return{workspace:(0,ce.$m9b)(x),remoteAuthority:z};return{workspace:(0,ce.$n9b)(x),remoteAuthority:z}}jb(O){return(0,j.$vC)(O)?O.workspaceUri:(0,j.$wC)(O)?O.folderUri:O.fileUri}async kb(O,U,x){let z,Z;U.gotoLineMode&&({path:O,line:z,column:Z}=(0,u.$0f)(O)),O=(0,u.$5f)((0,l.$hc)(O),(0,$.cwd)());try{const W=await R.Promises.stat(O);if(W.isFile()){if(!U.forceOpenWorkspaceAsFile){const B=await this.L.resolveLocalWorkspace(a.URI.file(O));if(B)return B.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:t.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Z||1}:void 0}}}else{if(W.isDirectory())return{workspace:(0,ce.$n9b)(a.URI.file(O),W),type:t.FileType.Directory,exists:!0};if(!m.$i&&O==="/dev/null")return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0}}}catch(W){if(W.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.lb(O,U);const B=a.URI.file(O);if(this.J.removeRecentlyOpened([B]),U.ignoreFileNotFound)return{fileUri:B,type:t.FileType.File,exists:!1}}}async lb(O,U){const x=a.URI.file(O),{response:z,checkboxChecked:Z}=await this.N.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,x.authority),detail:(0,E.localize)(9,null,(0,p.$Fv)(x,{os:m.OS,tildify:this.D})),checkboxLabel:(0,E.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,s.addUNCHostToAllowlist)(x.authority),Z){const W={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(W.channel,W.args),this.sendToOpeningWindow(W.channel,W.args)}return this.kb(O,U,!0)}if(z===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.lb(O,U)}mb(O,U){const x=O.charCodeAt(0),z=U.remoteAuthority;let Z,W;U.gotoLineMode&&({path:O,line:Z,column:W}=(0,u.$0f)(O)),x!==47&&((0,u.$4f)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,u.$Wf)(O)),O=`/${O}`);const B=a.URI.from({scheme:b.Schemas.vscodeRemote,authority:z,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$ti)(O))return U.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:Z?{startLineNumber:Z,startColumn:W||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,ce.$m9b)(B),remoteAuthority:z};if(U.gotoLineMode||l.$gc.basename(O).indexOf(".")!==-1)return{fileUri:B,options:{selection:Z?{startLineNumber:Z,startColumn:W||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.$n9b)(B),remoteAuthority:z}}nb(O){const U=this.I.getValue("window"),x=U?.openFoldersInNewWindow||"default",z=U?.openFilesInNewWindow||"off";let Z=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(Z=x==="on");let W=!1;return O.forceNewWindow||O.forceReuseWindow?W=!!O.forceNewWindow&&!O.forceReuseWindow:(m.$j?O.context===1&&(W=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!O.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(W=z==="on")),{openFolderInNewWindow:!!Z,openFilesInNewWindow:W}}async openExtensionDevelopmentHostWindow(O,U){const x=(0,Y.$k9b)(this.getWindows(),O);if(x)return this.G.reload(x,U.cli),x.focus(),[x];let z=U.cli["folder-uri"]||[],Z=U.cli["file-uri"]||[],W=U.cli._;if(!W.length&&!z.length&&!Z.length&&!U.cli.extensionTestsPath){const ae=this.n.state.lastPluginDevelopmentHostWindow,ne=ae?.workspace??ae?.folderUri;ne&&(a.URI.isUri(ne)?ne.scheme===b.Schemas.file?W=[ne.fsPath]:z=[ne.toString()]:ne.configPath.scheme===b.Schemas.file?W=[(0,g.$qg)(ne.configPath)]:Z=[ne.configPath.toString()])}let B=U.remoteAuthority;for(const ae of O)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=a.URI.parse(ae),$e=(0,k.$7k)(ne);$e&&(B?(0,g.$Hg)($e,B)||this.u.error("more than one extension development path authority"):B=$e)}W=W.filter(ae=>{const ne=a.URI.file(ae);return(0,Y.$j9b)(this.getWindows(),ne)?!1:(0,g.$Hg)((0,k.$7k)(ne),B)}),z=z.filter(ae=>{const ne=this.eb(ae);return ne&&(0,Y.$j9b)(this.getWindows(),ne)?!1:ne?(0,g.$Hg)((0,k.$7k)(ne),B):!1}),Z=Z.filter(ae=>{const ne=this.eb(ae);return ne&&(0,Y.$j9b)(this.getWindows(),ne)?!1:ne?(0,g.$Hg)((0,k.$7k)(ne),B):!1}),U.cli._=W,U.cli["folder-uri"]=z,U.cli["file-uri"]=Z;const _={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!W.length&&!z.length&&!Z.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:B,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(_)}async ob(O){const U=this.I.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.F.defaultProfile;let Z;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Z=O.windowToUse||x,Z&&Z.focus());const W={...this.D.args,...O.cli,machineId:this.r,sqmId:this.s,windowId:-1,mainPid:process.pid,appRoot:this.D.appRoot,execPath:process.execPath,codeCachePath:this.D.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,l.$jc)(this.D.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.F.profilesHome,all:this.F.profiles,profile:z},homeDir:this.D.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.D.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.D.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.t,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.w.getLogLevel(),loggers:{window:[],global:this.w.getRegisteredLoggers()},logsPath:this.D.logsHome.with({scheme:b.Schemas.file}).fsPath,product:A.default,isInitialStartup:O.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof U?.zoomLevel=="number"?U.zoomLevel:void 0,autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.Q.getColorScheme(),policiesData:this.C.serialize(),continueOn:this.D.continueOn};if(Z){const B=Z.config;!W.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(W.extensionDevelopmentPath=B.extensionDevelopmentPath,W.extensionDevelopmentKind=B.extensionDevelopmentKind,W["enable-proposed-api"]=B["enable-proposed-api"],W.verbose=B.verbose,W["inspect-extensions"]=B["inspect-extensions"],W["inspect-brk-extensions"]=B["inspect-brk-extensions"],W.debugId=B.debugId,W.extensionEnvironment=B.extensionEnvironment,W["extensions-dir"]=B["extensions-dir"],W["disable-extensions"]=B["disable-extensions"]),W.loggers={global:W.loggers.global,window:B?.loggers.window??W.loggers.window}}else{const B=this.n.getNewWindowState(W);(0,y.mark)("code/willCreateCodeWindow");const _=Z=this.M.createInstance(F.$u9b,{state:B,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(_),this.m.set(_.id,_),this.a.fire(_),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ae=new v.$Rc;ae.add(_.onDidSignalReady(()=>this.b.fire(_))),ae.add(d.Event.once(_.onDidClose)(()=>this.rb(_,ae))),ae.add(d.Event.once(_.onDidDestroy)(()=>this.c.fire(_))),ae.add(_.onDidMaximize(()=>this.g.fire(_))),ae.add(_.onDidUnmaximize(()=>this.h.fire(_))),ae.add(_.onDidTriggerSystemContextMenu(({x:$e,y:me})=>this.j.fire({window:_,x:$e,y:me})));const ne=(0,h.$Of)(_.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.G.reload(_)),this.G.registerWindow(_)}return W.windowId=Z.id,Z.isReady?this.G.unload(Z,4).then(async B=>{B||await this.pb(Z,W,O,z)}):await this.pb(Z,W,O,z),Z}async pb(O,U,x,z){if(U.extensionDevelopmentPath||((0,le.$di)(U.workspace)?U.backupPath=this.H.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,le.$$h)(U.workspace)?U.backupPath=this.H.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.H.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,ce.$o9b)().id,remoteAuthority:U.remoteAuthority})),this.F.isEnabled()){const Z=U.workspace??(0,le.$ci)(U.backupPath,!1),W=this.qb(x,Z,z),B=W instanceof Promise?await W:W;U.profiles.profile=B,U.extensionDevelopmentPath||await this.F.setProfileForWorkspace(Z,B)}O.load(U)}qb(O,U,x){return O.forceProfile?this.F.profiles.find(z=>z.name===O.forceProfile)??this.F.createNamedProfile(O.forceProfile):O.forceTempProfile?this.F.createTransientProfile():this.F.getProfileForWorkspace(U)??x}rb(O,U){this.m.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.tb(this.getWindows())}sb(O){return this.tb(this.getWindows().filter(U=>(0,g.$Hg)(U.remoteAuthority,O)))}tb(O){return(0,N.$B9b)(O)}sendToFocused(O,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,S.CancellationToken.None,...U)}sendToOpeningWindow(O,...U){this.B(d.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,S.CancellationToken.None,...U)}))}sendToAll(O,U,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(O,S.CancellationToken.None,U)}getWindows(){return Array.from(this.m.values())}getWindowCount(){return this.m.size}getWindowById(O){return this.m.get(O)}getWindowByWebContents(O){const U=P.BrowserWindow.fromWebContents(O);if(U)return this.getWindowById(U.id)}};e.$A0b=he,e.$A0b=he=Ee([ie(3,w.$ij),ie(4,T.$r9b),ie(5,C.$4N),ie(6,H.$un),ie(7,r.$X8b),ie(8,L.$68b),ie(9,c.$Z8b),ie(10,f.$e9b),ie(11,i.$ui),ie(12,ue.$99b),ie(13,K.$p9b),ie(14,n.$Zh),ie(15,o.$f9b),ie(16,t.$kk),ie(17,I.$h9b),ie(18,X.$_8b),ie(19,V.$w9b)],he)}),define(re[307],oe([0,1,66,29,83,55]),function(J,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=void 0;let D=class{constructor(d,u,p,v){this.a=d,this.b=u,this.c=p,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,u){const p=this.b.getWindowById(d);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),u)}createUntitledWorkspace(d,u,p){return this.a.createUntitledWorkspace(u,p)}deleteUntitledWorkspace(d,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(d,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(d,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$C0b=D,e.$C0b=D=Ee([ie(0,M.$p9b),ie(1,R.$y9b),ie(2,s.$99b),ie(3,P.$e9b)],D)}),define(re[308],oe([0,1,15,131,36,26,18,50,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,290,162,66,283,17,200,91,132,53,116,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,122,28,251,253,52,49,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,55,39,233,54,244,51,81,129,277,292,280,8,255,276,228,69,296,271,23,125,295,263,239,62,65,303]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k,C,j,F,N,Y,Q,le,ce,ue,K,X,H,L,T,V,q,te,he,G,O,U,x,z,Z,W,B,_,ae,ne,$e,me,ye,Se,Le,ve,pe,ee,fe,ge,Ce,Oe,Te,Me,Ve,Be,se,de,we,ke,De,Fe,je,Ne,qe,Ge,Je,_e,Qe,it,st,rt,bt,pt,yt,vt,kt,Et,St,ot,dt,Pt,It,Ct,at,Dt,gt,ct,At,Rt,lt,Ot,ut,Mt){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let ft=class extends l.$Sc{static{ht=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Re,be,Ae,ze,He,Xe,Ue,We,Ke,Ze){super(),this.g=Pe,this.h=Ie,this.j=Re,this.m=be,this.n=Ae,this.s=ze,this.t=He,this.u=Xe,this.w=Ue,this.y=We,this.z=Ke,this.C=Ze,this.D(),this.F()}D(){const Pe=Ue=>Ue?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ue,We,Ke,Ze)=>Pe(Ze.requestingUrl)?Ke(Ie.has(We)):Ke(!1)),P.session.defaultSession.setPermissionCheckHandler((Ue,We,Ke,Ze)=>Pe(Ze.requestingUrl)?Ie.has(We):!1);const Re=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),be=Ue=>{for(let We=Ue;We;We=We.parent)if(We.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ae=Ue=>Ue.resourceType==="xhr"||be(Ue.frame),ze=Ue=>{const We=Ue.frame;if(!We||!this.b)return!1;const Ke=P.BrowserWindow.getAllWindows();for(const Ze of Ke)if(We.processId===Ze.webContents.mainFrame.processId)return!0;return!1},He=(Ue,We)=>{if(Ue.path!=="/index.html")return!0;const Ke=We.frame;if(!Ke||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Ke.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ue,We)=>{const Ke=h.URI.parse(Ue.url);return Ke.scheme===y.Schemas.vscodeWebview&&!He(Ke,Ue)?(this.m.error("Blocked vscode-webview request",Ue.url),We({cancel:!0})):Ke.scheme===y.Schemas.vscodeFileResource&&!ze(Ue)?(this.m.error("Blocked vscode-file request",Ue.url),We({cancel:!0})):Ke.path.endsWith(".svg")&&!Re.has(Ke.scheme)?We({cancel:!Ae(Ue)}):We({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ue,We)=>{const Ke=Ue.responseHeaders,Ze=Ke["content-type"]||Ke["Content-Type"];if(Ze&&Array.isArray(Ze)){const Ye=h.URI.parse(Ue.url);if(Ye.path.endsWith(".svg")&&Re.has(Ye.scheme))return Ke["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Ke});if(!Ye.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ze.some(et=>et.toLowerCase().includes("image/svg")))return We({cancel:!Ae(Ue)})}return We({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.s.codeCachePath&&Xe.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),$.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,d.$Z)(Re)||(0,d.$1)(Re)}),process.on("unhandledRejection",Re=>(0,d.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$dU)(),P.app.on("accessibility-support-changed",(Re,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),P.app.on("activate",async(Re,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Re,be)=>{(0,ut.$x9b)(be)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),be.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Pe=[],Ie;P.app.on("open-file",(Re,be)=>{this.m.trace("app#open-file: ",be),Re.preventDefault(),Pe.push((0,qe.$ti)(be)?{workspaceUri:h.URI.file(be)}:{fileUri:h.URI.file(be)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$cU.handle("vscode:fetchShellEnv",Re=>{const be=this.b?.getWindowByWebContents(Re.sender);let Ae,ze;return be?.config?(Ae=be.config,ze={...process.env,...be.config.userEnv}):(Ae=this.s.args,ze=process.env),this.X(Ae,ze,!1)}),s.$cU.handle("vscode:writeNlsFile",(Re,be,Ae)=>{const ze=this.G([be]);if(!ze||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,D.$ge.fromString(Ae))}),s.$cU.handle("vscode:readNlsFile",async(Re,...be)=>{const Ae=this.G(be);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$cU.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),s.$cU.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),s.$cU.on("vscode:reloadWindow",Re=>Re.sender.reload())}G(Pe){let Ie;for(const Re of Pe)typeof Re=="string"&&(typeof Ie!="string"?Ie=Re:Ie=(0,m.$jc)(Ie,Re));if(!(typeof Ie!="string"||!(0,m.$ic)(Ie)||!(0,u.$3f)(Ie,this.s.cachedLanguagesPath,!$.$k)))return h.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;$.$i&&Pe&&P.app.setAppUserModelId(Pe);try{$.$j&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Ie=new i.$jU;this.t.onWillShutdown(We=>{We.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,be]=await Promise.all([(0,dt.$K0b)(this.w,this.m),(0,dt.$L0b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Ae,sharedProcessClient:ze}=this.P(Re,be),He=await this.Q(Re,be,Ae);this.B(He.createInstance(r.$C9b)),this.B(He.createInstance(Et.$G0b)),He.invokeFunction(We=>this.R(We,Ie,ze));const Xe=await He.invokeFunction(We=>this.I(We,Ie));this.J(Ie),this.t.phase=2,await He.invokeFunction(We=>this.S(We,Xe)),this.t.phase=3,this.U(),this.B(new ot.$ah(()=>{this.B((0,ot.$eh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const Re=this.b=Pe.get(Fe.$y9b),be=Pe.get(Ve.$4U),Ae=this.f=Pe.get(W.$W9b),ze=Pe.get(C.$f9b),He=this;be.registerHandler({async handleURL(Ye,et){return He.O(Re,ze,be,Ye,et)}});const Xe=this.B(new Ne.$B0b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ue=new f.$Ih(Ye=>Xe.getActiveClientId().then(et=>Ye===et)),We=new Be.$s0b(Ue,this.m),Ke=Ie.getChannel("urlHandler",We);be.registerHandler(new Be.$r0b(Ke));const Ze=await this.L(Re,ze);return this.B(new de.$t0b(Ze?.urls,be,Re,this.s,this.z,this.m)),Ze}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Re=new Ot.$V(()=>Pe.getChannel(lt.$S0b,new lt.$T0b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(be,Ae)=>{const ze=h.URI.parse(be.url);if(!ze.authority.startsWith("window:"))return Ae(Ie());Re.value.call(lt.$R0b,[ze]).then(He=>Ae({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),Ae({statusCode:500,data:String(He)})})})}async L(Pe,Ie){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Re.length+be.length===0)return;const Ae=[...Re,...be].map(Xe=>{try{return{uri:h.URI.parse(Xe),originalUrl:Xe}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Xe);return}}),ze=[],He=[];for(const Xe of Ae){if(!Xe)continue;const Ue=this.N(Xe.uri);if(Ue)if(await this.M(Ue,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Xe.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Xe.uri.toString(!0),Ue),ze.push(Ue);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Xe.uri.toString(!0)),He.push(Xe)}return{urls:He,openables:ze}}async M(Pe,Ie,Re){let be,Ae;if((0,De.$vC)(Pe)?(be=Pe.workspaceUri,Ae=(0,t.localize)(0,null,be.scheme===y.Schemas.file?(0,b.$Fv)(be,{os:$.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,De.$wC)(Pe)?(be=Pe.folderUri,Ae=(0,t.localize)(1,null,be.scheme===y.Schemas.file?(0,b.$Fv)(be,{os:$.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=Pe.fileUri,Ae=(0,t.localize)(2,null,be.scheme===y.Schemas.file?(0,b.$Fv)(be,{os:$.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==y.Schemas.file&&be.scheme!==y.Schemas.vscodeRemote||this.u.getValue(ht.a[be.scheme])===!1)return!1;const{response:He,checkboxChecked:Xe}=await Re.showMessageBox({type:"warning",buttons:[(0,t.localize)(3,null),(0,t.localize)(4,null)],message:Ae,detail:(0,t.localize)(5,null),checkboxLabel:be.scheme===y.Schemas.file?(0,t.localize)(6,null):(0,t.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Xe){const Ue={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===y.Schemas.file?"local":"remote"};Ie.sendToFocused(Ue.channel,Ue.args),Ie.sendToOpeningWindow(Ue.channel,Ue.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Ie=h.URI.file(Pe.fsPath);return(0,qe.$ti)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===y.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(m.$gc.sep,1);if(Ie!==-1){const Re=Pe.path.substring(1,Ie),be=Pe.path.substring(Ie);let Ae=Pe.query;const ze=new URLSearchParams(Pe.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ae=ze.toString());const He=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Re,path:be,query:Ae,fragment:Pe.fragment});return(0,qe.$ti)(be)?{workspaceUri:He}:/:[\d]+$/.test(be)?{fileUri:He}:{folderUri:He}}}}}async O(Pe,Ie,Re,be,Ae){this.m.trace("app#handleProtocolUrl():",be.toString(!0),Ae),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:h.URI.parse(be.query).path,query:""}));let ze=!1;const He=new URLSearchParams(be.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),He.delete("windowId"),be=be.with({query:He.toString()}),ze=!0):$.$j&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),ze=!0);const Xe=He.get("continueOn");Xe!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),He.delete("continueOn"),be=be.with({query:He.toString()}),this.s.continueOn=Xe??void 0);const Ue=this.N(be);return Ue?await this.M(Ue,Pe,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ue,be.toString(!0)),(0,gt.$Ob)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[Ue],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,gt.$Ob)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,_.$7k)(be)}))?.ready(),Re.open(be,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ae),!1)}P(Pe,Ie){const Re=this.B(this.j.createInstance(ae.$e0b,Pe,Ie)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$kU(ze,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),be))(),sharedProcessClient:be}}async Q(Pe,Ie,Re){const be=new te.$Yh;switch(process.platform){case"win32":be.set(fe.$bV,new V.$Xh(Me.$p0b));break;case"linux":$.$l?be.set(fe.$bV,new V.$Xh(Te.$o0b,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$bV,new V.$Xh(Oe.$n0b));break;case"darwin":be.set(fe.$bV,new V.$Xh(Ce.$m0b));break}be.set(Fe.$y9b,new V.$Xh(je.$A0b,[Pe,Ie,this.h],!1)),be.set(ut.$w9b,new V.$Xh(Mt.$U0b,void 0,!1));const Ae=new C.$g9b(this.m,this.z);be.set(C.$f9b,Ae),be.set(U.$39b,new V.$Xh(U.$49b,void 0,!1)),be.set(k.$I9b,new V.$Xh(k.$J9b,void 0,!1)),be.set(I.$Cm,f.ProxyChannel.toService((0,f.$Gh)(Re.then(We=>We.getChannel("diagnostics"))))),be.set(he.$5yb,new V.$Xh(G.$Y9b,[this.h])),be.set(j.$XU,new V.$Xh(F.$K9b)),be.set(O.$Z9b,new V.$Xh(O.$19b)),be.set(W.$W9b,new V.$Xh(W.$X9b,void 0,!1)),be.set(we.$u0b,new V.$Xh(ke.$w0b)),be.set(Z.$_9b,new V.$Xh(Z.$a0b)),be.set(le.$L9b,new V.$Xh(ce.$N9b)),be.set(ye.$88b,new V.$Xh(ye.$98b)),be.set(ye.$08b,new V.$Xh(ye.$$8b));const ze=new At.$Q0b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new Rt.$Hr(ze,this.u,this.m,this.n);be.set(ct.$ir,He),$.$i?be.set(ue.$O9b,new V.$Xh(K.$P9b)):$.$j?be.set(ue.$O9b,new V.$Xh(K.$Q9b)):$.$k&&be.set(ue.$O9b,new V.$Xh(K.$R9b));const Xe=new c.$D9b(this.s,this.u,this.m,this.w);be.set(n.$e9b,Xe);const Ue=new Qe.$q9b(this.s,this.m,this.C,Xe,Ae);if(be.set(Qe.$p9b,Ue),be.set(Ge.$bcb,new V.$Xh(_e.$C0b,void 0,!1)),be.set(Je.$99b,new V.$Xh(Je.$09b,void 0,!1)),be.set(Ve.$4U,new V.$Xh(se.$6U,void 0,!1)),(0,ee.$Do)(this.z,this.s)){const We=(0,ee.$Io)(this.z,this.u),Ke=(0,f.$Gh)(Re.then(nt=>nt.getChannel("telemetryAppender"))),Ze=new ve.$h0b(Ke),Ye=(0,Se.$to)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,We),et=(0,ee.$Jo)(this.s),tt={appenders:[Ze],commonProperties:Ye,piiPaths:et,sendErrorTelemetry:!0};be.set(Le.$ol,new V.$Xh(pe.$ar,[tt],!1))}else be.set(Le.$ol,ee.$xo);return be.set(yt.$Gp,new V.$Xh(Pt.$$N,void 0,!0)),be.set(vt.$Kp,new V.$Xh(kt.$F0b,void 0,!0)),be.set(at.$O0b,new V.$Xh(at.$P0b,void 0,!0)),await ot.Promises.settled([Xe.initialize(),Ue.initialize()]),this.j.createChild(be)}R(Pe,Ie,Re){const be=this.B(new l.$Rc),Ae=f.ProxyChannel.fromService(Pe.get(U.$39b),be,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const ze=f.ProxyChannel.fromService(Pe.get(k.$I9b),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const He=new st.$D0b(Pe.get(it.$un));Ie.registerChannel("policy",He),Re.then(xe=>xe.registerChannel("policy",He));const Xe=this.y.getProvider(y.Schemas.file);(0,g.$Nf)(Xe instanceof T.$mq);const Ue=new L.$S9b(Xe,this.m,this.s);Ie.registerChannel(X.$TN,Ue),Re.then(xe=>xe.registerChannel(X.$TN,Ue));const We=f.ProxyChannel.fromService(Pe.get(rt.$68b),be);Ie.registerChannel("userDataProfiles",We),Re.then(xe=>xe.registerChannel("userDataProfiles",We));const Ke=new bt.$8q(Pe.get(pt.$5o));Re.then(xe=>xe.registerChannel("request",Ke));const Ze=new ge.$i0b(Pe.get(fe.$bV));Ie.registerChannel("update",Ze);const Ye=f.ProxyChannel.fromService(Pe.get(he.$5yb),be);Ie.registerChannel("issue",Ye);const et=f.ProxyChannel.fromService(Pe.get(j.$XU),be);Ie.registerChannel("encryption",et);const tt=f.ProxyChannel.fromService(Pe.get(ne.$cl),be);Ie.registerChannel("sign",tt);const nt=f.ProxyChannel.fromService(Pe.get(O.$Z9b),be);Ie.registerChannel("keyboardLayout",nt),this.f=Pe.get(W.$W9b);const $t=f.ProxyChannel.fromService(this.f,be);Ie.registerChannel("nativeHost",$t),Re.then(xe=>xe.registerChannel("nativeHost",$t));const jt=f.ProxyChannel.fromService(Pe.get(Ge.$bcb),be);Ie.registerChannel("workspaces",jt);const Lt=f.ProxyChannel.fromService(Pe.get(Z.$_9b),be);Ie.registerChannel("menubar",Lt);const Ft=f.ProxyChannel.fromService(Pe.get(Ve.$4U),be);Ie.registerChannel("url",Ft);const Ut=f.ProxyChannel.fromService(Pe.get(we.$u0b),be);Ie.registerChannel("webview",Ut);const mt=this.B(new me.$f0b(this.m,Pe.get(ye.$88b)));Ie.registerChannel("storage",mt),Re.then(xe=>xe.registerChannel("storage",mt));const Nt=this.B(new St.$H0b(Pe.get(ye.$88b),Pe.get(rt.$68b),this.m));Re.then(xe=>xe.registerChannel("profileStorageListener",Nt));const Wt=f.ProxyChannel.fromService(Pe.get(ct.$ir),be);Ie.registerChannel(ct.TerminalIpcChannels.LocalPty,Wt);const Tt=f.ProxyChannel.fromService(Pe.get(ue.$O9b),be);Ie.registerChannel("externalTerminal",Tt);const wt=new It.$M0b(Pe.get(Ct.$r9b));Ie.registerChannel("logger",wt),Re.then(xe=>xe.registerChannel("logger",wt));const zt=new A.$E9b(Pe.get(Fe.$y9b));Ie.registerChannel("extensionhostdebugservice",zt);const Bt=f.ProxyChannel.fromService(Pe.get(le.$L9b),be);Ie.registerChannel(le.$M9b,Bt);const qt=f.ProxyChannel.fromService(Pe.get(at.$O0b),be);Ie.registerChannel(Dt.$N0b,qt)}async S(Pe,Ie){const Re=this.b=Pe.get(Fe.$y9b);this.c=Pe.get(ut.$w9b);const be=(0,Y.$Zl)(process.env)?0:4,Ae=this.s.args;if(Ie){if(Ie.openables.length>0)return Re.open({context:be,cli:Ae,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const nt=new URLSearchParams(tt.uri.query);if(nt.get("windowId")==="_blank")return nt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:nt.toString()}),Re.open({context:be,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,He=Ae._.length,Xe=!!Ae["folder-uri"],Ue=!!Ae["file-uri"],We=Ae["skip-add-to-recently-opened"]===!0,Ke=Ae.wait&&Ae.waitMarkerFilePath?h.URI.file(Ae.waitMarkerFilePath):void 0,Ze=Ae.remote||void 0,Ye=Ae.profile,et=Ae["profile-temp"];if(!He&&!Xe&&!Ue){if(Ae["new-window"]||Ye||et)return Re.open({context:be,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Ze,forceProfile:Ye,forceTempProfile:et});if(ze.length)return Re.open({context:1,cli:Ae,urisToOpen:ze.map(tt=>(0,qe.$ti)(tt)?{workspaceUri:h.URI.file(tt)}:{fileUri:h.URI.file(tt)}),noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0})}return Re.open({context:be,cli:Ae,forceNewWindow:Ae["new-window"]||!He&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:We,waitMarkerFileURI:Ke,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:Ye,forceTempProfile:et})}U(){this.W(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),$.$j&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if($.$i&&Pe)try{const Ie=await new Promise((be,Ae)=>{J(["@vscode/windows-mutex"],be,Ae)}),Re=new Ie.Mutex(Pe);p.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,Re){try{return await(0,Q.$6l)(this.u,this.m,Pe,Ie)}catch(be){const Ae=(0,S.$Li)(be);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,v.$en)(Ie)),Ae=(0,ee.$Fo)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,a.$lg)()}"`,"}"],He=Ie.substring(0,Ie.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,D.$ge.fromString(He))}else{const ze=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);ze!==Ie&&await this.y.writeFile(this.s.argvResource,D.$ge.fromString(ze))}}catch(Pe){this.m.error(Pe)}}};e.$V0b=ft,e.$V0b=ft=ht=Ee([ie(2,q.$Zh),ie(3,z.$ij),ie(4,z.$jj),ie(5,N.$X8b),ie(6,x.$Z8b),ie(7,w.$ui),ie(8,$e.$4N),ie(9,H.$kk),ie(10,B.$Aj),ie(11,rt.$68b)],ft)}),define(re[313],oe([0,1,15,46,7,23,8,50,14,33,3,47,13,9,68,4,35,25,21,42,99,308,10,17,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,126,287,51,286,95,249,34,52,70,54,39,234,232,2,40,266,69,227,115,121,270,264]),function(J,e,P,R,s,M,D,S,d,u,p,v,b,l,y,m,$,g,h,a,E,f,i,o,r,t,n,c,w,A,I,k,C,j,F,N,Y,Q,le,ce,ue,K,X,H,L,T,V,q,te,he,G,O,U,x,z,Z,W,B,_,ae,ne,$e,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(ve){console.error(ve.message),P.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ve,pe,ee,fe,ge,Ce,Oe,Te]=this.b();try{try{await this.d(ee,Te,fe,ge,Oe)}catch(Me){throw this.f(ee,Oe,Me),Me}await ve.invokeFunction(async Me=>{const Ve=Me.get(Q.$ij),Be=Me.get(N.$Z8b),se=Me.get(A.$kk),de=Me.get(Q.$jj),we=await this.e(Ve,ee,Be,ve,Oe,!0);return h.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(ke=>{Ve.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Ce.logger=de.createLogger("main",{name:(0,i.localize)(0,null)}),p.Event.once(Be.onWillShutdown)(ke=>{se.dispose(),fe.dispose(),ke.join("instanceLockfile",h.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ve.createInstance(f.$V0b,we,pe).startup()})}catch(Me){ve.invokeFunction(this.i,Me)}}b(){const ve=new F.$Yh,pe=new Z.$Rc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...le.default};ve.set(ce.$Aj,ee);const fe=new n.$Y8b(this.j(),ee),ge=this.c(fe);ve.set(n.$X8b,fe);const Ce=new _.$s9b((0,Q.$wj)(fe),fe.logsHome);ve.set(_.$r9b,Ce);const Oe=new Y.$G6b(Ce.getLogLevel()),Te=pe.add(new ae.$_N(Oe,[new Q.$pj(Ce.getLogLevel())]));ve.set(Q.$ij,Te);const Me=new I.$Zp(Te);ve.set(A.$kk,Me);const Ve=new k.$mq(Te);Me.registerProvider(b.Schemas.file,Ve);const Be=new B.$Lr(Me);ve.set(W.$Uk,Be);const se=new $e.$7N(1,fe,Te,Me);ve.set(te.$3N,se),ve.set(te.$4N,se);const de=new O.$78b(se,Be,fe,Me,Te);ve.set(O.$68b,de),Me.registerProvider(b.Schemas.vscodeUserData,new me.$70b(b.Schemas.file,Ve,b.Schemas.vscodeUserData,de,Be,Te));const we=m.$i&&ee.win32RegValueName?pe.add(new x.$50b(Te,ee.win32RegValueName)):fe.policyFile?pe.add(new z.$60b(fe.policyFile,Me,Te)):new U.$wn;ve.set(U.$un,we);const ke=new r.$Wn(de.defaultProfile.settingsResource,Me,we,Te);return ve.set(o.$ui,ke),ve.set(N.$Z8b,new C.$Xh(N.$18b,void 0,!1)),ve.set(L.$5o,new C.$Xh(T.$30b,void 0,!0)),ve.set(G.$_8b,new C.$Xh(G.$a9b)),ve.set(V.$cl,new C.$Xh(q.$40b,void 0,!1)),ve.set(X.$kv,new C.$Xh(H.$10b)),ve.set(ue.$h9b,new K.$X0b(fe,de,Te)),[new j.$pq(ve,!0),ge,fe,ke,se,Oe,ee,de]}c(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const fe=process.env[ee];typeof fe=="string"&&(pe[ee]=fe)}),Object.assign(process.env,pe),pe}async d(ve,pe,ee,fe,ge){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:b.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:b.Schemas.file}).fsPath,ve.backupHome].map(Ce=>Ce?h.Promises.mkdir(Ce,{recursive:!0}):void 0)),fe.init(),ee.initialize()]),pe.init()}async e(ve,pe,ee,fe,ge,Ce){let Oe;try{(0,y.mark)("code/willStartMainServer"),Oe=await(0,E.$Vh)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),p.Event.once(ee.onWillShutdown)(()=>Oe.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.f(pe,ge,Te),Te;let Me;try{Me=await(0,E.$Wh)(pe.mainIPCHandle,"main")}catch(de){if(!Ce||m.$i||de.code!=="ECONNREFUSED")throw de.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),de;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch(we){throw ve.warn("Could not delete obsolete instance handle",we),we}return this.e(ve,pe,ee,fe,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const de=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ve.error(de),Me.dispose(),new Error(de)}let Ve;!pe.args.wait&&!pe.args.status&&(Ve=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const Be=a.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),se=a.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const de=new t.$Sr(he.$xo,ge),we=await se.getMainDiagnostics(),ke=await se.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await de.getDiagnostics(we,ke);throw console.log(De),new d.$ab});throw m.$i&&await this.h(Be,ve),ve.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Me.dispose(),Ve&&clearTimeout(Ve),new d.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new d.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Oe}f(ve,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const fe=(0,M.$Hb)([ve.userDataPath,ve.extensionsPath,E.$Rh]).map(ge=>(0,v.$Fv)(s.URI.file(ge),{os:m.OS,tildify:ve}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,S.$Li)(ee),fe.join(`
`)),pe)}}g(ve,pe,ee){P.dialog.showMessageBoxSync((0,ne.$Tv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:ve,detail:pe},ee).options)}async h(ve,pe){if(m.$i){const ee=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((fe,ge)=>{J(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(ee)}catch(fe){pe.error(fe)}}}i(ve,pe){const ee=ve.get(Q.$ij),fe=ve.get(N.$Z8b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),fe.kill(ge)}j(){const ve=this.k((0,c.$Wl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,w.$W0b)(ve.verbose);pe&&((0,c.$Yl)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.l(ve._,ve.goto);ve._=pe}return ve}l(ve,pe){const ee=(0,$.cwd)(),fe=ve.map(Oe=>{let Te=String(Oe),Me;pe&&(Me=(0,u.$0f)(Te),Te=Me.path),Te&&(Te=this.m(ee,Te));const Ve=(0,u.$5f)(Te,ee),Be=(0,l.$nc)(Ve);return Be&&!(0,u.$1f)(Be)?null:pe&&Me?(Me.path=Ve,this.n(Me)):Ve}),ge=m.$i||m.$j,Ce=(0,M.$Mb)(fe,Oe=>Oe&&ge?Oe.toLowerCase():Oe||"");return(0,M.$Hb)(Ce)}m(ve,pe){return m.$i&&(pe=(0,g.$Pe)(pe,'"')),pe=(0,g.$Ne)((0,g.$Ne)(pe," "),"	"),m.$i&&(pe=(0,l.$kc)(ve,pe),pe=(0,g.$Pe)(pe,".")),pe}n(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42053f37e98a2dbaa0d108807491e716105dccd2/core/vs/code/electron-main/main.js.map
