/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],he=function(oe){for(var e=[],w=0,L=oe.length;w<L;w++)e[w]=le[oe[w]];return e};define(le[40],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function w(h,a,r){const n=L(h,a);if(n!==-1)return h[n]}e.$fb=w;function L(h,a,r=h.length-1){for(let n=r;n>=0;n--){const i=h[n];if(a(i))return n}return-1}e.$gb=L;function k(h,a){const r=M(h,a);return r===-1?void 0:h[r]}e.$hb=k;function M(h,a,r=0,n=h.length){let i=r,l=n;for(;i<l;){const t=Math.floor((i+l)/2);a(h[t])?i=t+1:l=t}return i-1}e.$ib=M;function R(h,a){const r=E(h,a);return r===h.length?void 0:h[r]}e.$jb=R;function E(h,a,r=0,n=h.length){let i=r,l=n;for(;i<l;){const t=Math.floor((i+l)/2);a(h[t])?l=t:i=t+1}return i}e.$kb=E;function f(h,a,r=0,n=h.length){const i=E(h,a,r,n);return i===h.length?-1:i}e.$lb=f;class u{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(u.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!a(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const r=M(this.e,a,this.c);return this.c=r+1,r===-1?void 0:this.e[r]}}e.$mb=u;function S(h,a){if(h.length===0)return;let r=h[0];for(let n=1;n<h.length;n++){const i=h[n];a(i,r)>0&&(r=i)}return r}e.$nb=S;function g(h,a){if(h.length===0)return;let r=h[0];for(let n=1;n<h.length;n++){const i=h[n];a(i,r)>=0&&(r=i)}return r}e.$ob=g;function y(h,a){return S(h,(r,n)=>-a(r,n))}e.$pb=y;function s(h,a){if(h.length===0)return-1;let r=0;for(let n=1;n<h.length;n++){const i=h[n];a(i,h[r])>0&&(r=n)}return r}e.$qb=s;function m(h,a){for(const r of h){const n=a(r);if(n!==void 0)return n}}e.$rb=m}),define(le[41],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function w(R,E){const f=Object.create(null);for(const u of R){const S=E(u);let g=f[S];g||(g=f[S]=[]),g.push(u)}return f}e.$K=w;function L(R,E){const f=[],u=[];for(const S of R)E.has(S)||f.push(S);for(const S of E)R.has(S)||u.push(S);return{removed:f,added:u}}e.$L=L;function k(R,E){const f=[],u=[];for(const[S,g]of R)E.has(S)||f.push(g);for(const[S,g]of E)R.has(S)||u.push(g);return{removed:f,added:u}}e.$M=k;function M(R,E){const f=new Set;for(const u of E)R.has(u)&&f.add(u);return f}e.$N=M}),define(le[14],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function w(R){return(E,f,u)=>{let S=null,g=null;if(typeof u.value=="function"?(S="value",g=u.value):typeof u.get=="function"&&(S="get",g=u.get),!g)throw new Error("not supported");u[S]=R(g,f)}}function L(R,E,f){let u=null,S=null;if(typeof f.value=="function"?(u="value",S=f.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",S=f.get),!S)throw new Error("not supported");const g=`$memoize$${E}`;f[u]=function(...y){return this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,y)}),this[g]}}e.$sh=L;function k(R,E,f){return w((u,S)=>{const g=`$debounce$${S}`,y=`$debounce$result$${S}`;return function(...s){this[y]||(this[y]=f?f():void 0),clearTimeout(this[g]),E&&(this[y]=E(this[y],...s),s=[this[y]]),this[g]=setTimeout(()=>{u.apply(this,s),this[y]=f?f():void 0},R)}})}e.$th=k;function M(R,E,f){return w((u,S)=>{const g=`$throttle$timer$${S}`,y=`$throttle$result$${S}`,s=`$throttle$lastRun$${S}`,m=`$throttle$pending$${S}`;return function(...h){if(this[y]||(this[y]=f?f():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...h)),this[m])return;const a=this[s]+R;a<=Date.now()?(this[s]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0):(this[m]=!0,this[g]=setTimeout(()=>{this[m]=!1,this[s]=Date.now(),u.apply(this,[this[y]]),this[y]=f?f():void 0},a-Date.now()))}})}e.$uh=M}),define(le[6],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class w{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?i.isErrorNoTelemetry(o)?new i(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(p=>{p(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$W=w,e.$X=new w;function L(t){e.$X.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function k(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$Z=k;function M(t){u(t)||e.$X.onUnexpectedError(t)}e.$1=M;function R(t){u(t)||e.$X.onUnexpectedExternalError(t)}e.$2=R;function E(t){if(t instanceof Error){const{name:o,message:p}=t,I=t.stacktrace||t.stack;return{$isError:!0,name:o,message:p,stack:I,noTelemetry:i.isErrorNoTelemetry(t)}}return t}e.$3=E;const f="Canceled";function u(t){return t instanceof S?!0:t instanceof Error&&t.name===f&&t.message===f}e.$4=u;class S extends Error{constructor(){super(f),this.name=this.message}}e.$5=S;function g(){const t=new Error(f);return t.name=t.message,t}e.$6=g;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$7=y;function s(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$8=s;class m extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function h(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$0=h;class a extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$$=a;class r extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$_=r;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof i)return o;const p=new i;return p.message=o.message,p.stack=o.stack,p}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$bb=i;class l extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.$cb=l}),define(le[16],he([0,1,6,40]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function k(j,Y=0){return j[j.length-(1+Y)]}e.$sb=k;function M(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.$tb=M;function R(j,Y,N=(O,V)=>O===V){if(j===Y)return!0;if(!j||!Y||j.length!==Y.length)return!1;for(let O=0,V=j.length;O<V;O++)if(!N(j[O],Y[O]))return!1;return!0}e.$ub=R;function E(j,Y){const N=j.length-1;Y<N&&(j[Y]=j[N]),j.pop()}e.$vb=E;function f(j,Y,N){return u(j.length,O=>N(j[O],Y))}e.$wb=f;function u(j,Y){let N=0,O=j-1;for(;N<=O;){const V=(N+O)/2|0,X=Y(V);if(X<0)N=V+1;else if(X>0)O=V-1;else return V}return-(N+1)}e.$xb=u;function S(j,Y,N){if(j=j|0,j>=Y.length)throw new TypeError("invalid index");const O=Y[Math.floor(Y.length*Math.random())],V=[],X=[],G=[];for(const re of Y){const ce=N(re,O);ce<0?V.push(re):ce>0?X.push(re):G.push(re)}return j<V.length?S(j,V,N):j<V.length+G.length?G[0]:S(j-(V.length+G.length),X,N)}e.$yb=S;function g(j,Y){const N=[];let O;for(const V of j.slice(0).sort(Y))!O||Y(O[0],V)!==0?(O=[V],N.push(O)):O.push(V);return N}e.$zb=g;function*y(j,Y){let N,O;for(const V of j)O!==void 0&&Y(O,V)?N.push(V):(N&&(yield N),N=[V]),O=V;N&&(yield N)}e.$Ab=y;function s(j,Y){for(let N=0;N<=j.length;N++)Y(N===0?void 0:j[N-1],N===j.length?void 0:j[N])}e.$Bb=s;function m(j,Y){for(let N=0;N<j.length;N++)Y(N===0?void 0:j[N-1],j[N],N+1===j.length?void 0:j[N+1])}e.$Cb=m;function h(j,Y,N){const O=[];function V(re,ce,me){if(ce===0&&me.length===0)return;const be=O[O.length-1];be&&be.start+be.deleteCount===re?(be.deleteCount+=ce,be.toInsert.push(...me)):O.push({start:re,deleteCount:ce,toInsert:me})}let X=0,G=0;for(;;){if(X===j.length){V(X,0,Y.slice(G));break}if(G===Y.length){V(X,j.length-X,[]);break}const re=j[X],ce=Y[G],me=N(re,ce);me===0?(X+=1,G+=1):me<0?(V(X,1,[]),X+=1):me>0&&(V(X,0,[ce]),G+=1)}return O}e.$Db=h;function a(j,Y,N){const O=h(j,Y,N),V=[],X=[];for(const G of O)V.push(...j.slice(G.start,G.start+G.deleteCount)),X.push(...G.toInsert);return{removed:V,added:X}}e.$Eb=a;function r(j,Y,N){if(N===0)return[];const O=j.slice(0,N).sort(Y);return i(j,Y,O,N,j.length),O}e.top=r;function n(j,Y,N,O,V){return N===0?Promise.resolve([]):new Promise((X,G)=>{(async()=>{const re=j.length,ce=j.slice(0,N).sort(Y);for(let me=N,be=Math.min(N+O,re);me<re;me=be,be=Math.min(be+O,re)){if(me>N&&await new Promise(ve=>setTimeout(ve)),V&&V.isCancellationRequested)throw new w.$5;i(j,Y,ce,me,be)}return ce})().then(X,G)})}e.$Gb=n;function i(j,Y,N,O,V){for(const X=N.length;O<V;O++){const G=j[O];if(Y(G,N[X-1])<0){N.pop();const re=(0,L.$kb)(N,ce=>Y(G,ce)<0);N.splice(re,0,G)}}}function l(j){return j.filter(Y=>!!Y)}e.$Hb=l;function t(j){let Y=0;for(let N=0;N<j.length;N++)j[N]&&(j[Y]=j[N],Y+=1);j.length=Y}e.$Ib=t;function o(j,Y,N){j.splice(N,0,j.splice(Y,1)[0])}e.$Jb=o;function p(j){return!Array.isArray(j)||j.length===0}e.$Kb=p;function I(j){return Array.isArray(j)&&j.length>0}e.$Lb=I;function b(j,Y=N=>N){const N=new Set;return j.filter(O=>{const V=Y(O);return N.has(V)?!1:(N.add(V),!0)})}e.$Mb=b;function C(j){const Y=new Set;return N=>{const O=j(N);return Y.has(O)?!1:(Y.add(O),!0)}}e.$Nb=C;function v(j,Y){return j.length>0?j[0]:Y}e.$Ob=v;function D(j,Y){return j.length>0?j[j.length-1]:Y}e.$Pb=D;function H(j,Y,N=(O,V)=>O===V){let O=0;for(let V=0,X=Math.min(j.length,Y.length);V<X&&N(j[V],Y[V]);V++)O++;return O}e.$Qb=H;function W(j){return[].concat(...j)}e.$Rb=W;function c(j,Y){let N=typeof Y=="number"?j:0;typeof Y=="number"?N=j:(N=0,Y=j);const O=[];if(N<=Y)for(let V=N;V<Y;V++)O.push(V);else for(let V=N;V>Y;V--)O.push(V);return O}e.$Sb=c;function $(j,Y,N){return j.reduce((O,V)=>(O[Y(V)]=N?N(V):V,O),Object.create(null))}e.$Tb=$;function P(j,Y){return j.push(Y),()=>T(j,Y)}e.$Ub=P;function T(j,Y){const N=j.indexOf(Y);if(N>-1)return j.splice(N,1),Y}e.$Vb=T;function A(j,Y,N){const O=j.slice(0,Y),V=j.slice(Y);return O.concat(N,V)}e.$Wb=A;function z(j,Y){let N;if(typeof Y=="number"){let O=Y;N=()=>{const V=Math.sin(O++)*179426549;return V-Math.floor(V)}}else N=Math.random;for(let O=j.length-1;O>0;O-=1){const V=Math.floor(N()*(O+1)),X=j[O];j[O]=j[V],j[V]=X}}e.$Xb=z;function ee(j,Y){const N=j.indexOf(Y);N>-1&&(j.splice(N,1),j.unshift(Y))}e.$Yb=ee;function ie(j,Y){const N=j.indexOf(Y);N>-1&&(j.splice(N,1),j.push(Y))}e.$Zb=ie;function Q(j,Y){for(const N of Y)j.push(N)}e.$1b=Q;function se(j,Y){return Array.isArray(j)?j.map(Y):Y(j)}e.$2b=se;function ue(j){return Array.isArray(j)?j:[j]}e.$3b=ue;function fe(j){return j[Math.floor(Math.random()*j.length)]}e.$4b=fe;function J(j,Y,N){const O=Z(j,Y),V=j.length,X=N.length;j.length=V+X;for(let G=V-1;G>=O;G--)j[G+X]=j[G];for(let G=0;G<X;G++)j[G+O]=N[G]}e.$5b=J;function B(j,Y,N,O){const V=Z(j,Y);let X=j.splice(V,N);return X===void 0&&(X=[]),J(j,V,O),X}e.$6b=B;function Z(j,Y){return Y<0?Math.max(Y+j.length,0):Math.min(Y,j.length)}var te;(function(j){function Y(X){return X<0}j.isLessThan=Y;function N(X){return X<=0}j.isLessThanOrEqual=N;function O(X){return X>0}j.isGreaterThan=O;function V(X){return X===0}j.isNeitherLessOrGreaterThan=V,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function q(j,Y){return(N,O)=>Y(j(N),j(O))}e.$7b=q;function _(...j){return(Y,N)=>{for(const O of j){const V=O(Y,N);if(!te.isNeitherLessOrGreaterThan(V))return V}return te.neitherLessOrGreaterThan}}e.$8b=_;const ge=(j,Y)=>j-Y;e.$9b=ge;const K=(j,Y)=>(0,e.$9b)(j?1:0,Y?1:0);e.$0b=K;function d(j){return(Y,N)=>-j(Y,N)}e.$$b=d;class F{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let N=this.c;for(;N<this.g.length&&Y(this.g[N]);)N++;const O=N===this.c?null:this.g.slice(this.c,N);return this.c=N,O}takeFromEndWhile(Y){let N=this.d;for(;N>=0&&Y(this.g[N]);)N--;const O=N===this.d?null:this.g.slice(N+1,this.d+1);return this.d=N,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const N=this.g.slice(this.c,this.c+Y);return this.c+=Y,N}}e.$_b=F;class ne{static{this.empty=new ne(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(N=>(Y(N),!0))}toArray(){const Y=[];return this.iterate(N=>(Y.push(N),!0)),Y}filter(Y){return new ne(N=>this.iterate(O=>Y(O)?N(O):!0))}map(Y){return new ne(N=>this.iterate(O=>N(Y(O))))}some(Y){let N=!1;return this.iterate(O=>(N=Y(O),!N)),N}findFirst(Y){let N;return this.iterate(O=>Y(O)?(N=O,!1):!0),N}findLast(Y){let N;return this.iterate(O=>(Y(O)&&(N=O),!0)),N}findLastMaxBy(Y){let N,O=!0;return this.iterate(V=>((O||te.isGreaterThan(Y(V,N)))&&(O=!1,N=V),!0)),N}}e.$ac=ne}),define(le[42],he([0,1,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function L(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=L;function k(f,u="Unreachable"){throw new Error(u)}e.$5c=k;function M(f){if(!f)throw new w.$cb("Assertion Failed")}e.$6c=M;function R(f){if(!f()){debugger;f(),(0,w.$1)(new w.$cb("Assertion Failed"))}}e.$7c=R;function E(f,u){let S=0;for(;S<f.length-1;){const g=f[S],y=f[S+1];if(!u(g,y))return!1;S++}return!0}e.$8c=E}),define(le[29],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function w(L,k){const M=this;let R=!1,E;return function(){if(R)return E;if(R=!0,k)try{E=L.apply(M,arguments)}finally{k()}else E=L.apply(M,arguments);return E}}e.$db=w}),define(le[43],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function R(){return M}L.empty=R;function*E(t){yield t}L.single=E;function f(t){return k(t)?t:E(t)}L.wrap=f;function u(t){return t||M}L.from=u;function*S(t){for(let o=t.length-1;o>=0;o--)yield t[o]}L.reverse=S;function g(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=g;function y(t){return t[Symbol.iterator]().next().value}L.first=y;function s(t,o){for(const p of t)if(o(p))return!0;return!1}L.some=s;function m(t,o){for(const p of t)if(o(p))return p}L.find=m;function*h(t,o){for(const p of t)o(p)&&(yield p)}L.filter=h;function*a(t,o){let p=0;for(const I of t)yield o(I,p++)}L.map=a;function*r(...t){for(const o of t)yield*o}L.concat=r;function n(t,o,p){let I=p;for(const b of t)I=o(I,b);return I}L.reduce=n;function*i(t,o,p=t.length){for(o<0&&(o+=t.length),p<0?p+=t.length:p>t.length&&(p=t.length);o<p;o++)yield t[o]}L.slice=i;function l(t,o=Number.POSITIVE_INFINITY){const p=[];if(o===0)return[p,t];const I=t[Symbol.iterator]();for(let b=0;b<o;b++){const C=I.next();if(C.done)return[p,L.empty()];p.push(C.value)}return[p,{[Symbol.iterator](){return I}}]}L.consume=l})(w||(e.Iterable=w={}))}),define(le[22],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class w{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=w}),define(le[44],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class w{static{this.Undefined=new w(void 0)}constructor(M){this.element=M,this.next=w.Undefined,this.prev=w.Undefined}}class L{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let M=this.a;for(;M!==w.Undefined;){const R=M.next;M.prev=w.Undefined,M.next=w.Undefined,M=R}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,R){const E=new w(M);if(this.a===w.Undefined)this.a=E,this.b=E;else if(R){const u=this.b;this.b=E,E.prev=u,u.next=E}else{const u=this.a;this.a=E,E.next=u,u.prev=E}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(E))}}shift(){if(this.a!==w.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==w.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==w.Undefined&&M.next!==w.Undefined){const R=M.prev;R.next=M.next,M.next.prev=R}else M.prev===w.Undefined&&M.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):M.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):M.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==w.Undefined;)yield M.element,M=M.next}}e.$3c=L}),define(le[25],he([0,1]),function(oe,e){"use strict";var w,L,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(n,i,l){let t=n.get(i);return t===void 0&&(t=l,n.set(i,t)),t}e.$xc=M;function R(n){const i=[];return n.forEach((l,t)=>{i.push(`${t} => ${l}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.$yc=R;function E(n){const i=[];return n.forEach(l=>{i.push(l)}),`Set(${n.size}) {${i.join(", ")}}`}e.$zc=E;class f{constructor(i,l){this.uri=i,this.value=l}}function u(n){return Array.isArray(n)}class S{static{this.a=i=>i.toString()}constructor(i,l){if(this[w]="ResourceMap",i instanceof S)this.b=new Map(i.b),this.c=l??S.a;else if(u(i)){this.b=new Map,this.c=l??S.a;for(const[t,o]of i)this.set(t,o)}else this.b=new Map,this.c=i??S.a}set(i,l){return this.b.set(this.c(i),new f(i,l)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,l){typeof l<"u"&&(i=i.bind(l));for(const[t,o]of this.b)i(o.value,o.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$Ac=S;class g{constructor(i,l){this[L]="ResourceSet",!i||typeof i=="function"?this.a=new S(i):(this.a=new S(l),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,l){this.a.forEach((t,o)=>i.call(l,o,o,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=g;var y;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class s{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,l=0){const t=this.a.get(i);if(t)return l!==0&&this.j(t,l),t.value}set(i,l,t=0){let o=this.a.get(i);if(o)o.value=l,t!==0&&this.j(o,t);else{switch(o={key:i,value:l,next:void 0,previous:void 0},t){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(i,o),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const l=this.a.get(i);if(l)return this.a.delete(i),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,l){const t=this.e;let o=this.b;for(;o;){if(l?i.bind(l)(o.value,o.key,this):i(o.value,o.key,this),this.e!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,l=this.e;let t=this.b;const o={[Symbol.iterator](){return o},next(){if(i.e!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:t.key,done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return o}values(){const i=this,l=this.e;let t=this.b;const o={[Symbol.iterator](){return o},next(){if(i.e!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:t.value,done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return o}entries(){const i=this,l=this.e;let t=this.b;const o={[Symbol.iterator](){return o},next(){if(i.e!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:[t.key,t.value],done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return o}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let l=this.b,t=this.size;for(;l&&t>i;)this.a.delete(l.key),l=l.next,t--;this.b=l,this.d=t,l&&(l.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const l=i.next,t=i.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}i.next=void 0,i.previous=void 0,this.e++}j(i,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(i===this.b)return;const t=i.next,o=i.previous;i===this.c?(o.next=void 0,this.c=o):(t.previous=o,o.next=t),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(l===2){if(i===this.c)return;const t=i.next,o=i.previous;i===this.b?(t.previous=void 0,this.b=t):(t.previous=o,o.next=t),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((l,t)=>{i.push([t,l])}),i}fromJSON(i){this.clear();for(const[l,t]of i)this.set(l,t)}}e.$Cc=s;class m extends s{constructor(i,l=1){super(),this.k=i,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,l=2){return super.get(i,l)}peek(i){return super.get(i,0)}set(i,l){return super.set(i,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=m;class h{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let l=this.a.get(i)||0;return l===0?!1:(l--,l===0?this.a.delete(i):this.a.set(i,l),!0)}has(i){return this.a.has(i)}}e.$Ec=h;class a{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[l,t]of i)this.set(l,t)}clear(){this.a.clear(),this.b.clear()}set(i,l){this.a.set(i,l),this.b.set(l,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const l=this.a.get(i);return l===void 0?!1:(this.a.delete(i),this.b.delete(l),!0)}forEach(i,l){this.a.forEach((t,o)=>{i.call(l,t,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=a;class r{constructor(){this.a=new Map}add(i,l){let t=this.a.get(i);t||(t=new Set,this.a.set(i,t)),t.add(l)}delete(i,l){const t=this.a.get(i);t&&(t.delete(l),t.size===0&&this.a.delete(i))}forEach(i,l){const t=this.a.get(i);t&&t.forEach(l)}get(i){const l=this.a.get(i);return l||new Set}}e.$Gc=r}),define(le[2],he([0,1,16,41,25,29,43]),function(oe,e,w,L,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const E=!1;let f=null;class u{constructor(){this.b=new Map}static{this.a=0}c(P){let T=this.b.get(P);return T||(T={parent:null,source:null,isSingleton:!1,value:P,idx:u.a++},this.b.set(P,T)),T}trackDisposable(P){const T=this.c(P);T.source||(T.source=new Error().stack)}setParent(P,T){const A=this.c(P);A.parent=T}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,T){const A=T.get(P);if(A)return A;const z=P.parent?this.f(this.c(P.parent),T):P;return T.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,A])=>A.source!==null&&!this.f(A,P).isSingleton).flatMap(([A])=>A)}computeLeakingDisposables(P=10,T){let A;if(T)A=T;else{const se=new Map,ue=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,se).isSingleton);if(ue.length===0)return;const fe=new Set(ue.map(J=>J.value));if(A=ue.filter(J=>!(J.parent&&fe.has(J.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function z(se){function ue(J,B){for(;J.length>0&&B.some(Z=>typeof Z=="string"?Z===J[0]:J[0].match(Z));)J.shift()}const fe=se.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return ue(fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),fe.reverse()}const ee=new k.$Gc;for(const se of A){const ue=z(se);for(let fe=0;fe<=ue.length;fe++)ee.add(ue.slice(0,fe).join(`
`),se)}A.sort((0,w.$7b)(se=>se.idx,w.$9b));let ie="",Q=0;for(const se of A.slice(0,P)){Q++;const ue=z(se),fe=[];for(let J=0;J<ue.length;J++){let B=ue[J];B=`(shared with ${ee.get(ue.slice(0,J+1).join(`
`)).size}/${A.length} leaks) at ${B}`;const te=ee.get(ue.slice(0,J).join(`
`)),q=(0,L.$K)([...te].map(_=>z(_)[J]),_=>_);delete q[ue[J]];for(const[_,ge]of Object.entries(q))fe.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${_}`);fe.unshift(B)}ie+=`


==================== Leaking disposable ${Q}/${A.length}: ${se.value.constructor.name} ====================
${fe.join(`
`)}
============================================================

`}return A.length>P&&(ie+=`


... and ${A.length-P} more leaking disposables

`),{leaks:A,details:ie}}}e.$Hc=u;function S($){f=$}if(e.$Ic=S,E){const $="__is_disposable_tracked__";S(new class{trackDisposable(P){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[$]||console.log(T)},3e3)}setParent(P,T){if(P&&P!==o.None)try{P[$]=!0}catch{}}markAsDisposed(P){if(P&&P!==o.None)try{P[$]=!0}catch{}}markAsSingleton(P){}})}function g($){return f?.trackDisposable($),$}e.$Jc=g;function y($){f?.markAsDisposed($)}e.$Kc=y;function s($,P){f?.setParent($,P)}function m($,P){if(f)for(const T of $)f.setParent(T,P)}function h($){return f?.markAsSingleton($),$}e.$Lc=h;function a($){return typeof $.dispose=="function"&&$.dispose.length===0}e.$Mc=a;function r($){if(R.Iterable.is($)){const P=[];for(const T of $)if(T)try{T.dispose()}catch(A){P.push(A)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}e.$Nc=r;function n($){for(const P of $)a(P)&&P.dispose();return[]}e.$Oc=n;function i(...$){const P=l(()=>r($));return m($,P),P}e.$Pc=i;function l($){const P=g({dispose:(0,M.$db)(()=>{y(P),$()})});return P}e.$Qc=l;class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,g(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return s(P,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),s(P,null))}}e.$Rc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,g(this),s(this.q,this)}dispose(){y(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Sc=o;class p{constructor(){this.b=!1,g(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&s(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&s(P,null),P}}e.$Tc=p;class I{constructor(P){this.a=new p,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=I;class b{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=b;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,g(this)}set(P){let T=P;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,y(this))},this}}e.$Wc=C;class v{constructor(){this.a=new Map}acquire(P,...T){let A=this.a.get(P);A||(A={counter:0,object:this.b(P,...T)},this.a.set(P,A));const{object:z}=A,ee=(0,M.$db)(()=>{--A.counter===0&&(this.c(P,A.object),this.a.delete(P))});return A.counter++,{object:z,dispose:ee}}}e.$Xc=v;class D{constructor(P){this.a=P}async acquire(P,...T){const A=this.a.acquire(P,...T);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(z){throw A.dispose(),z}}}e.$Yc=D;class H{constructor(P){this.object=P}dispose(){}}e.$Zc=H;function W($){const P=new t;try{$(P)}finally{P.dispose()}}e.$1c=W;class c{constructor(){this.a=new Map,this.b=!1,g(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,T,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(P)?.dispose(),this.a.set(P,T)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=c}),define(le[45],he([0,1,25]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=void 0;const L=new w.$Dc(1e4);function k(u){return f(u,"NFC",L)}e.$Al=k;const M=new w.$Dc(1e4);function R(u){return f(u,"NFD",M)}e.$Bl=R;const E=/[^\u0000-\u0080]/;function f(u,S,g){if(!u)return u;const y=g.get(u);if(y)return y;let s;return E.test(u)?s=u.normalize(S):s=u,g.set(u,s),s}e.$Cl=function(){const u=/[\u0300-\u036f]/g;return function(S){return R(S).replace(u,"")}}()}),function(){function oe(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function R(f){M.push(f,Date.now())}function E(){const f=[];for(let u=0;u<M.length;u+=2)f.push({name:M[u],startTime:M[u+1]});return f}return{mark:R,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(k+R.startTime)});return M}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(le[46],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const w=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(M){return new L(M)}constructor(M){this.c=w&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=L}),define(le[4],he([0,1,6,29,2,44,46]),function(oe,e,w,L,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const E=!1,f=!1;var u;(function(W){W.None=()=>k.$Sc.None;function c(X){if(f){const{onDidAddListener:G}=X,re=m.create();let ce=0;X.onDidAddListener=()=>{++ce===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),G?.()}}}function $(X,G){return fe(X,()=>{},0,void 0,!0,void 0,G)}W.defer=$;function P(X){return(G,re=null,ce)=>{let me=!1,be;return be=X(ve=>{if(!me)return be?be.dispose():me=!0,G.call(re,ve)},null,ce),me&&be.dispose(),be}}W.once=P;function T(X,G,re){return se((ce,me=null,be)=>X(ve=>ce.call(me,G(ve)),null,be),re)}W.map=T;function A(X,G,re){return se((ce,me=null,be)=>X(ve=>{G(ve),ce.call(me,ve)},null,be),re)}W.forEach=A;function z(X,G,re){return se((ce,me=null,be)=>X(ve=>G(ve)&&ce.call(me,ve),null,be),re)}W.filter=z;function ee(X){return X}W.signal=ee;function ie(...X){return(G,re=null,ce)=>{const me=(0,k.$Pc)(...X.map(be=>be(ve=>G.call(re,ve))));return ue(me,ce)}}W.any=ie;function Q(X,G,re,ce){let me=re;return T(X,be=>(me=G(me,be),me),ce)}W.reduce=Q;function se(X,G){let re;const ce={onWillAddFirstListener(){re=X(me.fire,me)},onDidRemoveLastListener(){re?.dispose()}};G||c(ce);const me=new i(ce);return G?.add(me),me.event}function ue(X,G){return G instanceof Array?G.push(X):G&&G.add(X),X}function fe(X,G,re=100,ce=!1,me=!1,be,ve){let pe,Ce,Ae,Se=0,Ie;const Ue={leakWarningThreshold:be,onWillAddFirstListener(){pe=X(Be=>{Se++,Ce=G(Ce,Be),ce&&!Ae&&(Re.fire(Ce),Ce=void 0),Ie=()=>{const ze=Ce;Ce=void 0,Ae=void 0,(!ce||Se>1)&&Re.fire(ze),Se=0},typeof re=="number"?(clearTimeout(Ae),Ae=setTimeout(Ie,re)):Ae===void 0&&(Ae=0,queueMicrotask(Ie))})},onWillRemoveListener(){me&&Se>0&&Ie?.()},onDidRemoveLastListener(){Ie=void 0,pe.dispose()}};ve||c(Ue);const Re=new i(Ue);return ve?.add(Re),Re.event}W.debounce=fe;function J(X,G=0,re){return W.debounce(X,(ce,me)=>ce?(ce.push(me),ce):[me],G,void 0,!0,void 0,re)}W.accumulate=J;function B(X,G=(ce,me)=>ce===me,re){let ce=!0,me;return z(X,be=>{const ve=ce||!G(be,me);return ce=!1,me=be,ve},re)}W.latch=B;function Z(X,G,re){return[W.filter(X,G,re),W.filter(X,ce=>!G(ce),re)]}W.split=Z;function te(X,G=!1,re=[],ce){let me=re.slice(),be=X(Ce=>{me?me.push(Ce):pe.fire(Ce)});ce&&ce.add(be);const ve=()=>{me?.forEach(Ce=>pe.fire(Ce)),me=null},pe=new i({onWillAddFirstListener(){be||(be=X(Ce=>pe.fire(Ce)),ce&&ce.add(be))},onDidAddFirstListener(){me&&(G?setTimeout(ve):ve())},onDidRemoveLastListener(){be&&be.dispose(),be=null}});return ce&&ce.add(pe),pe.event}W.buffer=te;function q(X,G){return(ce,me,be)=>{const ve=G(new ge);return X(function(pe){const Ce=ve.evaluate(pe);Ce!==_&&ce.call(me,Ce)},void 0,be)}}W.chain=q;const _=Symbol("HaltChainable");class ge{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(re=>(G(re),re)),this}filter(G){return this.f.push(re=>G(re)?re:_),this}reduce(G,re){let ce=re;return this.f.push(me=>(ce=G(ce,me),ce)),this}latch(G=(re,ce)=>re===ce){let re=!0,ce;return this.f.push(me=>{const be=re||!G(me,ce);return re=!1,ce=me,be?me:_}),this}evaluate(G){for(const re of this.f)if(G=re(G),G===_)break;return G}}function K(X,G,re=ce=>ce){const ce=(...pe)=>ve.fire(re(...pe)),me=()=>X.on(G,ce),be=()=>X.removeListener(G,ce),ve=new i({onWillAddFirstListener:me,onDidRemoveLastListener:be});return ve.event}W.fromNodeEventEmitter=K;function d(X,G,re=ce=>ce){const ce=(...pe)=>ve.fire(re(...pe)),me=()=>X.addEventListener(G,ce),be=()=>X.removeEventListener(G,ce),ve=new i({onWillAddFirstListener:me,onDidRemoveLastListener:be});return ve.event}W.fromDOMEventEmitter=d;function F(X){return new Promise(G=>P(X)(G))}W.toPromise=F;function ne(X){const G=new i;return X.then(re=>{G.fire(re)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}W.fromPromise=ne;function j(X,G,re){return G(re),X(ce=>G(ce))}W.runAndSubscribe=j;function Y(X,G){let re=null;function ce(be){re?.dispose(),re=new k.$Rc,G(be,re)}ce(void 0);const me=X(be=>ce(be));return(0,k.$Qc)(()=>{me.dispose(),re?.dispose()})}W.runAndSubscribeWithStore=Y;class N{constructor(G,re){this._observable=G,this.f=0,this.g=!1;const ce={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};re||c(ce),this.emitter=new i(ce),re&&re.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,re){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function O(X,G){return new N(X,G).emitter.event}W.fromObservable=O;function V(X){return(G,re,ce)=>{let me=0,be=!1;const ve={beginUpdate(){me++},endUpdate(){me--,me===0&&(X.reportChanges(),be&&(be=!1,G.call(re)))},handlePossibleChange(){},handleChange(){be=!0}};X.addObserver(ve),X.reportChanges();const pe={dispose(){X.removeObserver(ve)}};return ce instanceof k.$Rc?ce.add(pe):Array.isArray(ce)&&ce.push(pe),pe}}W.fromObservableLight=V})(u||(e.Event=u={}));class S{static{this.all=new Set}static{this.f=0}constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${S.f++}`,S.all.add(this)}start(c){this.g=new R.$Od,this.listenerCount=c}stop(){if(this.g){const c=this.g.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.g=void 0}}}e.$Qd=S;let g=-1;function y(W){const c=g;return g=W,{dispose(){g=c}}}e.$Rd=y;class s{constructor(c,$=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=$,this.g=0}dispose(){this.f?.clear()}check(c,$){const P=this.threshold;if(P<=0||$<P)return;this.f||(this.f=new Map);const T=this.f.get(c.value)||0;if(this.f.set(c.value,T+1),this.g-=1,this.g<=0){this.g=P*.5;let A,z=0;for(const[ee,ie]of this.f)(!A||z<ie)&&(A=ee,z=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${$} listeners already. MOST frequent listener (${z}):`),console.warn(A)}return()=>{const A=this.f.get(c.value)||0;this.f.set(c.value,A-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class a{constructor(c){this.value=c,this.id=h++}}const r=2,n=(W,c)=>{if(W instanceof a)c(W);else for(let $=0;$<W.length;$++){const P=W[$];P&&c(P)}};class i{constructor(c){this.w=0,this.f=c,this.g=g>0||this.f?.leakWarningThreshold?new s(this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const c=this.t;queueMicrotask(()=>{n(c,$=>$.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(c,$,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.$Sc.None;if(this.m)return k.$Sc.None;$&&(c=c.bind($));const T=new a(c);let A,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=m.create(),A=this.g.check(T.stack,this.w+1)),E&&(T.stack=z??m.create()),this.t?this.t instanceof a?(this.u??=new t,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,k.$Qc)(()=>{A?.(),this.x(T)});return P instanceof k.$Rc?P.add(ee):Array.isArray(P)&&P.push(ee),ee},this.q}x(c){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const $=this.t,P=$.indexOf(c);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,$[P]=void 0;const T=this.u.current===this;if(this.w*r<=$.length){let A=0;for(let z=0;z<$.length;z++)$[z]?$[A++]=$[z]:T&&(this.u.end--,A<this.u.i&&this.u.i--);$.length=A}}y(c,$){if(!c)return;const P=this.f?.onListenerError||w.$1;if(!P){c.value($);return}try{c.value($)}catch(T){P(T)}}z(c){const $=c.current.t;for(;c.i<c.end;)this.y($[c.i++],c.value);c.reset()}fire(c){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,c);else{const $=this.u;$.enqueue(this,c,this.t.length),this.z($)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=i;const l=()=>new t;e.$Td=l;class t{constructor(){this.i=-1,this.end=0}enqueue(c,$,P){this.i=0,this.end=P,this.current=c,this.value=$}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends i{async fireAsync(c,$,P){if(this.t)for(this.h||(this.h=new M.$3c),n(this.t,T=>this.h.push([T.value,c]));this.h.size>0&&!$.isCancellationRequested;){const[T,A]=this.h.shift(),z=[],ee={...A,token:$,waitUntil:ie=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(ie=P(ie,T)),z.push(ie)}};try{T(ee)}catch(ie){(0,w.$1)(ie);continue}Object.freeze(z),await Promise.allSettled(z).then(ie=>{for(const Q of ie)Q.status==="rejected"&&(0,w.$1)(Q.reason)})}}}e.$Ud=o;class p extends i{get isPaused(){return this.h!==0}constructor(c){super(c),this.h=0,this.s=new M.$3c,this.A=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.A(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.w&&(this.h!==0?this.s.push(c):super.fire(c))}}e.$Vd=p;class I extends p{constructor(c){super(c),this.k=c.delay??100}fire(c){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(c)}}e.$Wd=I;class b extends i{constructor(c){super(c),this.h=[],this.k=c?.merge}fire(c){this.hasListeners()&&(this.h.push(c),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach($=>super.fire($)),this.h=[]}))}}e.$Xd=b;class C{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(c){const $={event:c,listener:null};this.h.push($),this.g&&this.m($);const P=()=>{this.g&&this.o($);const T=this.h.indexOf($);this.h.splice(T,1)};return(0,k.$Qc)((0,L.$db)(P))}j(){this.g=!0,this.h.forEach(c=>this.m(c))}k(){this.g=!1,this.h.forEach(c=>this.o(c))}m(c){c.listener=c.event($=>this.f.fire($))}o(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.f.dispose()}}e.$Yd=C;class v{constructor(c,$,P,T){this.f=new k.$Rc;const A=this.f.add(new C),z=this.f.add(new k.$2c);function ee(ie){z.set(ie,A.add(T(ie)))}for(const ie of c)ee(ie);this.f.add($(ie=>{ee(ie)})),this.f.add(P(ie=>{z.deleteAndDispose(ie)})),this.event=A.event}dispose(){this.f.dispose()}}e.$Zd=v;class D{constructor(){this.f=[]}wrapEvent(c){return($,P,T)=>c(A=>{const z=this.f[this.f.length-1];z?z.push(()=>$.call(P,A)):$.call(P,A)},void 0,T)}bufferEvents(c){const $=[];this.f.push($);const P=c();return this.f.pop(),$.forEach(T=>T()),P}}e.$1d=D;class H{constructor(){this.f=!1,this.g=u.None,this.h=k.$Sc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(c){this.g=c,this.f&&(this.h.dispose(),this.h=c(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=H}),define(le[17],he([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const L=Object.freeze(function(E,f){const u=setTimeout(E.bind(f),0);return{dispose(){clearTimeout(u)}}});var k;(function(E){function f(u){return u===E.None||u===E.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}E.isCancellationToken=f,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k||(e.CancellationToken=k={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new w.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=k.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=k.None}}e.$3d=R}),define(le[47],he([0,1,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class L{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new w.$3d,f=this.b(E.token);return this.a={promise:f,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Be=L;class k{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const f=JSON.stringify(E);return this.b!==f&&(this.b=f,this.a=this.c(E)),this.a}}e.$Ce=k;class M{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const f=this.b(E);return this.a.set(E,f),f}}e.$De=M}),define(le[48],he([0,1,6,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function k(l){const t=l;return t?typeof t.read=="function":!1}e.$4d=k;function M(l){const t=l;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}e.$5d=M;function R(l){const t=l;return t?M(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}e.$6d=R;function E(l,t){return new f(l,t)}e.$7d=E;class f{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,w.$1)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let p;switch(t){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const I=p.indexOf(o);I>=0&&p.splice(I,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(l,t){const o=[];let p;for(;(p=l.read())!==null;)o.push(p);return t(o)}e.$8d=u;function S(l,t,o){const p=[];let I;for(;(I=l.read())!==null&&p.length<o;)p.push(I);return I===null&&p.length>0?t(p):{read:()=>{if(p.length>0)return p.shift();if(typeof I<"u"){const b=I;return I=void 0,b}return l.read()}}}e.$9d=S;function g(l,t){return new Promise((o,p)=>{const I=[];y(l,{onData:b=>{t&&I.push(b)},onError:b=>{t?p(b):o(void 0)},onEnd:()=>{o(t?t(I):void 0)}})})}e.$0d=g;function y(l,t,o){l.on("error",p=>{o?.isCancellationRequested||t.onError(p)}),l.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),l.on("data",p=>{o?.isCancellationRequested||t.onData(p)})}e.$$d=y;function s(l,t){return new Promise((o,p)=>{const I=new L.$Rc,b=[],C=H=>{if(b.push(H),b.length>t)return I.dispose(),l.pause(),o({stream:l,buffer:b,ended:!1})},v=H=>(I.dispose(),p(H)),D=()=>(I.dispose(),o({stream:l,buffer:b,ended:!0}));I.add((0,L.$Qc)(()=>l.removeListener("error",v))),l.on("error",v),I.add((0,L.$Qc)(()=>l.removeListener("end",D))),l.on("end",D),I.add((0,L.$Qc)(()=>l.removeListener("data",C))),l.on("data",C)})}e.$_d=s;function m(l,t){const o=E(t);return o.end(l),o}e.$ae=m;function h(){const l=E(()=>{throw new Error("not supported")});return l.end(),l}e.$be=h;function a(l){let t=!1;return{read:()=>t?null:(t=!0,l)}}e.$ce=a;function r(l,t,o){const p=E(o);return y(l,{onData:I=>p.write(t.data(I)),onError:I=>p.error(t.error?t.error(I):I),onEnd:()=>p.end()}),p}e.$de=r;function n(l,t,o){let p=!1;return{read:()=>{const I=t.read();return p?I:(p=!0,I!==null?o([l,I]):l)}}}e.$ee=n;function i(l,t,o){let p=!1;const I=E(o);return y(t,{onData:b=>p?I.write(b):(p=!0,I.write(o([l,b]))),onError:b=>I.error(b),onEnd:()=>{p||(p=!0,I.write(l)),I.end()}}),I}e.$fe=i}),define(le[18],he([0,1,22,48]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const k=typeof Buffer<"u",M=new w.$V(()=>new Uint8Array(256));let R,E;class f{static alloc($){return k?new f(Buffer.allocUnsafe($)):new f(new Uint8Array($))}static wrap($){return k&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new f($)}static fromString($,P){return!(P?.dontUseNodeBuffer||!1)&&k?new f(Buffer.from($)):(R||(R=new TextEncoder),new f(R.encode($)))}static fromByteArray($){const P=f.alloc($.length);for(let T=0,A=$.length;T<A;T++)P.buffer[T]=$[T];return P}static concat($,P){if(typeof P>"u"){P=0;for(let z=0,ee=$.length;z<ee;z++)P+=$[z].byteLength}const T=f.alloc(P);let A=0;for(let z=0,ee=$.length;z<ee;z++){const ie=$[z];T.set(ie,A),A+=ie.byteLength}return T}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=f.alloc(this.byteLength);return $.set(this),$}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice($,P){return new f(this.buffer.subarray($,P))}set($,P){if($ instanceof f)this.buffer.set($.buffer,P);else if($ instanceof Uint8Array)this.buffer.set($,P);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),P);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return y(this.buffer,$)}writeUInt32BE($,P){s(this.buffer,$,P)}readUInt32LE($){return m(this.buffer,$)}writeUInt32LE($,P){h(this.buffer,$,P)}readUInt8($){return a(this.buffer,$)}writeUInt8($,P){r(this.buffer,$,P)}indexOf($,P=0){return u(this.buffer,$ instanceof f?$.buffer:$,P)}}e.$ge=f;function u(c,$,P=0){const T=$.byteLength,A=c.byteLength;if(T===0)return 0;if(T===1)return c.indexOf($[0]);if(T>A-P)return-1;const z=M.value;z.fill($.length);for(let se=0;se<$.length;se++)z[$[se]]=$.length-se-1;let ee=P+$.length-1,ie=ee,Q=-1;for(;ee<A;)if(c[ee]===$[ie]){if(ie===0){Q=ee;break}ee--,ie--}else ee+=Math.max($.length-ie,z[c[ee]]),ie=$.length-1;return Q}e.$he=u;function S(c,$){return c[$+0]<<0>>>0|c[$+1]<<8>>>0}e.$ie=S;function g(c,$,P){c[P+0]=$&255,$=$>>>8,c[P+1]=$&255}e.$je=g;function y(c,$){return c[$]*2**24+c[$+1]*2**16+c[$+2]*2**8+c[$+3]}e.$ke=y;function s(c,$,P){c[P+3]=$,$=$>>>8,c[P+2]=$,$=$>>>8,c[P+1]=$,$=$>>>8,c[P]=$}e.$le=s;function m(c,$){return c[$+0]<<0>>>0|c[$+1]<<8>>>0|c[$+2]<<16>>>0|c[$+3]<<24>>>0}e.$me=m;function h(c,$,P){c[P+0]=$&255,$=$>>>8,c[P+1]=$&255,$=$>>>8,c[P+2]=$&255,$=$>>>8,c[P+3]=$&255}e.$ne=h;function a(c,$){return c[$]}e.$oe=a;function r(c,$,P){c[P]=$}e.$pe=r;function n(c){return L.$8d(c,$=>f.concat($))}e.$qe=n;function i(c){return L.$ce(c)}e.$re=i;function l(c){return L.$0d(c,$=>f.concat($))}e.$se=l;async function t(c){return c.ended?f.concat(c.buffer):f.concat([...c.buffer,await l(c.stream)])}e.$te=t;function o(c){return L.$ae(c,$=>f.concat($))}e.$ue=o;function p(c){return L.$de(c,{data:$=>typeof $=="string"?f.fromString($):f.wrap($)},$=>f.concat($))}e.$ve=p;function I(c){return L.$7d($=>f.concat($),c)}e.$we=I;function b(c,$){return L.$ee(c,$,P=>f.concat(P))}e.$xe=b;function C(c,$){return L.$fe(c,$,P=>f.concat(P))}e.$ye=C;function v(c){let $=0,P=0,T=0;const A=new Uint8Array(Math.floor(c.length/4*3)),z=ie=>{switch(P){case 3:A[T++]=$|ie,P=0;break;case 2:A[T++]=$|ie>>>2,$=ie<<6,P=3;break;case 1:A[T++]=$|ie>>>4,$=ie<<4,P=2;break;default:$=ie<<2,P=1}};for(let ie=0;ie<c.length;ie++){const Q=c.charCodeAt(ie);if(Q>=65&&Q<=90)z(Q-65);else if(Q>=97&&Q<=122)z(Q-97+26);else if(Q>=48&&Q<=57)z(Q-48+52);else if(Q===43||Q===45)z(62);else if(Q===47||Q===95)z(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ie]}`)}}const ee=T;for(;P>0;)z(0);return f.wrap(A).slice(0,ee)}e.$ze=v;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:c},$=!0,P=!1){const T=P?H:D;let A="";const z=c.byteLength%3;let ee=0;for(;ee<c.byteLength-z;ee+=3){const ie=c[ee+0],Q=c[ee+1],se=c[ee+2];A+=T[ie>>>2],A+=T[(ie<<4|Q>>>4)&63],A+=T[(Q<<2|se>>>6)&63],A+=T[se&63]}if(z===1){const ie=c[ee+0];A+=T[ie>>>2],A+=T[ie<<4&63],$&&(A+="==")}else if(z===2){const ie=c[ee+0],Q=c[ee+1];A+=T[ie>>>2],A+=T[(ie<<4|Q>>>4)&63],A+=T[Q<<2&63],$&&(A+="=")}return A}e.$Ae=W}),define(le[11],he([0,1,47,22]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cf=e.$Bf=e.$Af=e.$zf=e.GraphemeBreakType=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function k(U){return!U||typeof U!="string"?!0:U.trim().length===0}e.$Ge=k;const M=/{(\d+)}/g;function R(U,...x){return x.length===0?U:U.replace(M,function(ae,de){const we=parseInt(de,10);return isNaN(we)||we<0||we>=x.length?ae:x[we]})}e.$He=R;const E=/{([^}]+)}/g;function f(U,x){return Object.keys(x).length===0?U:U.replace(E,(ae,de)=>x[de]??ae)}e.$Ie=f;function u(U){return U.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}e.$Je=u;function S(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=S;function g(U,x){let ae=0;const de=x.charCodeAt(0);for(let we=U.length-1;we>=0;we--)U.charCodeAt(we)===de&&ae++;return ae}e.$Le=g;function y(U,x,ae="\u2026"){return U.length<=x?U:`${U.substr(0,x)}${ae}`}e.$Me=y;function s(U,x=" "){const ae=m(U,x);return h(ae,x)}e.$Ne=s;function m(U,x){if(!U||!x)return U;const ae=x.length;if(ae===0||U.length===0)return U;let de=0;for(;U.indexOf(x,de)===de;)de=de+ae;return U.substring(de)}e.$Oe=m;function h(U,x){if(!U||!x)return U;const ae=x.length,de=U.length;if(ae===0||de===0)return U;let we=de,ye=-1;for(;ye=U.lastIndexOf(x,we-1),!(ye===-1||ye+ae!==we);){if(ye===0)return"";we=ye}return U.substring(0,we)}e.$Pe=h;function a(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Qe=a;function r(U){return U.replace(/\*/g,"")}e.$Re=r;function n(U,x,ae={}){if(!U)throw new Error("Cannot create regex from empty string");x||(U=S(U)),ae.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let de="";return ae.global&&(de+="g"),ae.matchCase||(de+="i"),ae.multiline&&(de+="m"),ae.unicode&&(de+="u"),new RegExp(U,de)}e.$Se=n;function i(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}e.$Te=i;function l(U){return U.split(/\r\n|\r|\n/)}e.$Ue=l;function t(U){for(let x=0,ae=U.length;x<ae;x++){const de=U.charCodeAt(x);if(de!==32&&de!==9)return x}return-1}e.$Ve=t;function o(U,x=0,ae=U.length){for(let de=x;de<ae;de++){const we=U.charCodeAt(de);if(we!==32&&we!==9)return U.substring(x,de)}return U.substring(x,ae)}e.$We=o;function p(U,x=U.length-1){for(let ae=x;ae>=0;ae--){const de=U.charCodeAt(ae);if(de!==32&&de!==9)return ae}return-1}e.$Xe=p;function I(U,x,ae){const de=[];let we=0;for(const ye of U.matchAll(x)){if(de.push(U.slice(we,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");we=ye.index+ye[0].length,de.push(ae(ye[0],...ye.slice(1),ye.index,U,ye.groups))}return de.push(U.slice(we)),Promise.all(de).then(ye=>ye.join(""))}e.$Ye=I;function b(U,x){return U<x?-1:U>x?1:0}e.$Ze=b;function C(U,x,ae=0,de=U.length,we=0,ye=x.length){for(;ae<de&&we<ye;ae++,we++){const Pe=U.charCodeAt(ae),Le=x.charCodeAt(we);if(Pe<Le)return-1;if(Pe>Le)return 1}const Ee=de-ae,Me=ye-we;return Ee<Me?-1:Ee>Me?1:0}e.$1e=C;function v(U,x){return D(U,x,0,U.length,0,x.length)}e.$2e=v;function D(U,x,ae=0,de=U.length,we=0,ye=x.length){for(;ae<de&&we<ye;ae++,we++){let Pe=U.charCodeAt(ae),Le=x.charCodeAt(we);if(Pe===Le)continue;if(Pe>=128||Le>=128)return C(U.toLowerCase(),x.toLowerCase(),ae,de,we,ye);W(Pe)&&(Pe-=32),W(Le)&&(Le-=32);const ke=Pe-Le;if(ke!==0)return ke}const Ee=de-ae,Me=ye-we;return Ee<Me?-1:Ee>Me?1:0}e.$3e=D;function H(U){return U>=48&&U<=57}e.$4e=H;function W(U){return U>=97&&U<=122}e.$5e=W;function c(U){return U>=65&&U<=90}e.$6e=c;function $(U,x){return U.length===x.length&&D(U,x)===0}e.$7e=$;function P(U,x){const ae=x.length;return x.length>U.length?!1:D(U,x,0,ae)===0}e.$8e=P;function T(U,x){const ae=Math.min(U.length,x.length);let de;for(de=0;de<ae;de++)if(U.charCodeAt(de)!==x.charCodeAt(de))return de;return ae}e.$9e=T;function A(U,x){const ae=Math.min(U.length,x.length);let de;const we=U.length-1,ye=x.length-1;for(de=0;de<ae;de++)if(U.charCodeAt(we-de)!==x.charCodeAt(ye-de))return de;return ae}e.$0e=A;function z(U){return 55296<=U&&U<=56319}e.$$e=z;function ee(U){return 56320<=U&&U<=57343}e.$_e=ee;function ie(U,x){return(U-55296<<10)+(x-56320)+65536}e.$af=ie;function Q(U,x,ae){const de=U.charCodeAt(ae);if(z(de)&&ae+1<x){const we=U.charCodeAt(ae+1);if(ee(we))return ie(de,we)}return de}e.$bf=Q;function se(U,x){const ae=U.charCodeAt(x-1);if(ee(ae)&&x>1){const de=U.charCodeAt(x-2);if(z(de))return ie(de,ae)}return ae}class ue{get offset(){return this.e}constructor(x,ae=0){this.c=x,this.d=x.length,this.e=ae}setOffset(x){this.e=x}prevCodePoint(){const x=se(this.c,this.e);return this.e-=x>=65536?2:1,x}nextCodePoint(){const x=Q(this.c,this.d,this.e);return this.e+=x>=65536?2:1,x}eol(){return this.e>=this.d}}e.$cf=ue;class fe{get offset(){return this.c.offset}constructor(x,ae=0){this.c=new ue(x,ae)}nextGraphemeLength(){const x=Se.getInstance(),ae=this.c,de=ae.offset;let we=x.getGraphemeBreakType(ae.nextCodePoint());for(;!ae.eol();){const ye=ae.offset,Ee=x.getGraphemeBreakType(ae.nextCodePoint());if(Ce(we,Ee)){ae.setOffset(ye);break}we=Ee}return ae.offset-de}prevGraphemeLength(){const x=Se.getInstance(),ae=this.c,de=ae.offset;let we=x.getGraphemeBreakType(ae.prevCodePoint());for(;ae.offset>0;){const ye=ae.offset,Ee=x.getGraphemeBreakType(ae.prevCodePoint());if(Ce(Ee,we)){ae.setOffset(ye);break}we=Ee}return de-ae.offset}eol(){return this.c.eol()}}e.$df=fe;function J(U,x){return new fe(U,x).nextGraphemeLength()}e.$ef=J;function B(U,x){return new fe(U,x).prevGraphemeLength()}e.$ff=B;function Z(U,x){x>0&&ee(U.charCodeAt(x))&&x--;const ae=x+J(U,x);return[ae-B(U,ae),ae]}e.$gf=Z;function te(U){const x=new fe(U);let ae=0;for(;!x.eol();)ae++,x.nextGraphemeLength();return ae}e.$hf=te;let q;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ge(U){return q||(q=_()),q.test(U)}e.$if=ge;const K=/^[\t\n\r\x20-\x7E]*$/;function d(U){return K.test(U)}e.$jf=d,e.$kf=/[\u2028\u2029]/;function F(U){return e.$kf.test(U)}e.$lf=F;function ne(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}e.$mf=ne;function j(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}e.$nf=j;function Y(U,x){if(U.length<x)return U;const ae=/\b/g;let de=0;for(;ae.test(U)&&!(U.length-ae.lastIndex<x);)de=ae.lastIndex,ae.lastIndex+=1;return U.substring(de).replace(/^\s/,"")}e.$of=Y;const N=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,O=/\x1b\].*?\x07/g;function V(U){return U&&(U=U.replace(N,"").replace(O,"")),U}e.$pf=V,e.$qf=String.fromCharCode(65279);function X(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}e.$rf=X;function G(U){return X(U)?U.substr(1):U}e.$sf=G;function re(U,x){if(!U||!x||U.length<x.length)return!1;const ae=x.length,de=U.toLowerCase();let we=0,ye=-1;for(;we<ae;){const Ee=de.indexOf(x[we],ye+1);if(Ee<0)return!1;ye=Ee,we++}return!0}e.$tf=re;function ce(U,x=!1){return U?(x&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}e.$uf=ce;function me(U){return U.charAt(0).toUpperCase()+U.slice(1)}e.$vf=me;function be(U,x=1){if(x===0)return"";let ae=-1;do ae=U.indexOf(`
`,ae+1),x--;while(x>0&&ae>=0);return ae===-1?U:(U[ae-1]==="\r"&&ae--,U.substr(0,ae))}e.$wf=be;function ve(U){return U=U%(2*26),U<26?String.fromCharCode(97+U):String.fromCharCode(65+U-26)}e.$xf=ve;function pe(U){return Se.getInstance().getGraphemeBreakType(U)}e.$yf=pe;function Ce(U,x){return U===0?x!==5&&x!==7:U===2&&x===3?!1:U===4||U===2||U===3||x===4||x===2||x===3?!0:!(U===8&&(x===8||x===9||x===11||x===12)||(U===11||U===9)&&(x===9||x===10)||(U===12||U===10)&&x===10||x===5||x===13||x===7||U===1||U===13&&x===14||U===6&&x===6)}var Ae;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ie()}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const ae=this.d,de=ae.length/3;let we=1;for(;we<=de;)if(x<ae[3*we])we=2*we;else if(x>ae[3*we+1])we=2*we+1;else return ae[3*we+2];return 0}}function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(U,x){if(U===0)return 0;const ae=Re(U,x);if(ae!==void 0)return ae;const de=new ue(x,U);return de.prevCodePoint(),de.offset}e.$zf=Ue;function Re(U,x){const ae=new ue(x,U);let de=ae.prevCodePoint();for(;Be(de)||de===65039||de===8419;){if(ae.offset===0)return;de=ae.prevCodePoint()}if(!j(de))return;let we=ae.offset;return we>0&&ae.prevCodePoint()===8205&&(we=ae.offset),we}function Be(U){return 127995<=U&&U<=127999}var ze;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$Af="\xA0";class Ne{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new w.$Ce(x=>{function ae(ke){const Oe=new Map;for(let De=0;De<ke.length;De+=2)Oe.set(ke[De],ke[De+1]);return Oe}function de(ke,Oe){const De=new Map(ke);for(const[Te,qe]of Oe)De.set(Te,qe);return De}function we(ke,Oe){if(!ke)return Oe;const De=new Map;for(const[Te,qe]of ke)Oe.has(Te)&&De.set(Te,qe);return De}const ye=this.c.value;let Ee=x.filter(ke=>!ke.startsWith("_")&&ke in ye);Ee.length===0&&(Ee=["_default"]);let Me;for(const ke of Ee){const Oe=ae(ye[ke]);Me=we(Me,Oe)}const Pe=ae(ye._common),Le=de(Pe,Me);return new Ne(Le)})}static getInstance(x){return Ne.d.get(Array.from(x))}static{this.e=new L.$V(()=>Object.keys(Ne.c.value).filter(x=>!x.startsWith("_")))}static getLocales(){return Ne.e.value}constructor(x){this.f=x}isAmbiguous(x){return this.f.has(x)}getPrimaryConfusable(x){return this.f.get(x)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Bf=Ne;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(x){return Fe.e().has(x)}static get codePoints(){return Fe.e()}}e.$Cf=Fe}),define(le[49],he([0,1,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=void 0;function L(r){return k(r,0)}e.$Oi=L;function k(r,n){switch(typeof r){case"object":return r===null?M(349,n):Array.isArray(r)?f(r,n):u(r,n);case"string":return E(r,n);case"boolean":return R(r,n);case"number":return M(r,n);case"undefined":return M(937,n);default:return M(617,n)}}e.$Pi=k;function M(r,n){return(n<<5)-n+r|0}e.$Qi=M;function R(r,n){return M(r?433:863,n)}function E(r,n){n=M(149417,n);for(let i=0,l=r.length;i<l;i++)n=M(r.charCodeAt(i),n);return n}e.$Ri=E;function f(r,n){return n=M(104579,n),r.reduce((i,l)=>k(l,i),n)}function u(r,n){return n=M(181387,n),Object.keys(r).sort().reduce((i,l)=>(i=E(l,i),k(r[l],i)),n)}class S{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=k(n,this.g),this.g}}e.$Si=S;var g;(function(r){r[r.BLOCK_SIZE=64]="BLOCK_SIZE",r[r.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function y(r,n,i=32){const l=i-n,t=~((1<<l)-1);return(r<<n|(t&r)>>>l)>>>0}function s(r,n=0,i=r.byteLength,l=0){for(let t=0;t<i;t++)r[n+t]=l}function m(r,n,i="0"){for(;r.length<n;)r=i+r;return r}function h(r,n=32){return r instanceof ArrayBuffer?Array.from(new Uint8Array(r)).map(i=>i.toString(16).padStart(2,"0")).join(""):m((r>>>0).toString(16),n/4)}e.$Ti=h;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const l=this.p;let t=this.r,o=this.u,p,I;for(o!==0?(p=o,I=-1,o=0):(p=n.charCodeAt(0),I=0);;){let b=p;if(w.$$e(p))if(I+1<i){const C=n.charCodeAt(I+1);w.$_e(C)?(I++,b=w.$af(p,C)):b=65533}else{o=p;break}else w.$_e(p)&&(b=65533);if(t=this.w(l,t,b),I++,I<i)p=n.charCodeAt(I);else break}this.r=t,this.u=o}w(n,i,l){return l<128?n[i++]=l:l<2048?(n[i++]=192|(l&1984)>>>6,n[i++]=128|(l&63)>>>0):l<65536?(n[i++]=224|(l&61440)>>>12,n[i++]=128|(l&4032)>>>6,n[i++]=128|(l&63)>>>0):(n[i++]=240|(l&1835008)>>>18,n[i++]=128|(l&258048)>>>12,n[i++]=128|(l&4032)>>>6,n[i++]=128|(l&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,s(this.p,this.r),this.r>56&&(this.y(),s(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=a.g,i=this.q;for(let D=0;D<64;D+=4)n.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)n.setUint32(D,y(n.getUint32(D-12,!1)^n.getUint32(D-32,!1)^n.getUint32(D-56,!1)^n.getUint32(D-64,!1),1),!1);let l=this.h,t=this.l,o=this.m,p=this.n,I=this.o,b,C,v;for(let D=0;D<80;D++)D<20?(b=t&o|~t&p,C=1518500249):D<40?(b=t^o^p,C=1859775393):D<60?(b=t&o|t&p|o&p,C=2400959708):(b=t^o^p,C=3395469782),v=y(l,5)+b+I+C+n.getUint32(D*4,!1)&4294967295,I=p,p=o,o=y(t,30),t=l,l=v;this.h=this.h+l&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+p&4294967295,this.o=this.o+I&4294967295}}e.$Ui=a}),define(le[50],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(le[51],he([0,1,16,11]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class k{constructor(){this.b="",this.c=0}reset(s){return this.b=s,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(s){const m=s.charCodeAt(0),h=this.b.charCodeAt(this.c);return m-h}value(){return this.b[this.c]}}e.$3h=k;class M{constructor(s=!0){this.e=s}reset(s){return this.b=s,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let s=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(s)this.c++;else break;else s=!1;return this}cmp(s){return this.e?(0,L.$1e)(s,this.b,0,s.length,this.c,this.d):(0,L.$3e)(s,this.b,0,s.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=M;class R{constructor(s=!0,m=!0){this.f=s,this.g=m}reset(s){this.d=0,this.e=0,this.b=s,this.c=s.length;for(let m=s.length-1;m>=0;m--,this.c--){const h=this.b.charCodeAt(m);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let s=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(s)this.d++;else break;else s=!1}return this}cmp(s){return this.g?(0,L.$1e)(s,this.b,0,s.length,this.d,this.e):(0,L.$3e)(s,this.b,0,s.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=R;var E;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(s,m){this.f=s,this.g=m,this.d=[],this.e=0}reset(s){return this.c=s,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(s)),this.b.reset(s.path),this.b.value()&&this.d.push(3)),this.g(s)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(s){if(this.d[this.e]===1)return(0,L.$2e)(s,this.c.scheme);if(this.d[this.e]===2)return(0,L.$2e)(s,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(s);if(this.d[this.e]===4)return(0,L.$Ze)(s,this.c.query);if(this.d[this.e]===5)return(0,L.$Ze)(s,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(S||(S={}));class g{static forUris(s=()=>!1,m=()=>!1){return new g(new f(s,m))}static forPaths(s=!1){return new g(new R(void 0,!s))}static forStrings(){return new g(new k)}static forConfigKeys(){return new g(new M)}constructor(s){this.b=s}clear(){this.c=void 0}fill(s,m){if(m){const h=m.slice(0);(0,w.$Xb)(h);for(const a of h)this.set(a,s)}else{const h=s.slice(0);(0,w.$Xb)(h);for(const a of h)this.set(a[0],a[1])}}set(s,m){const h=this.b.reset(s);let a;this.c||(this.c=new u,this.c.segment=h.value());const r=[];for(a=this.c;;){const i=h.cmp(a.segment);if(i>0)a.left||(a.left=new u,a.left.segment=h.value()),r.push([-1,a]),a=a.left;else if(i<0)a.right||(a.right=new u,a.right.segment=h.value()),r.push([1,a]),a=a.right;else if(h.hasNext())h.next(),a.mid||(a.mid=new u,a.mid.segment=h.value()),r.push([0,a]),a=a.mid;else break}const n=a.value;a.value=m,a.key=s;for(let i=r.length-1;i>=0;i--){const l=r[i][1];l.updateHeight();const t=l.balanceFactor();if(t<-1||t>1){const o=r[i][0],p=r[i+1][0];if(o===1&&p===1)r[i][1]=l.rotateLeft();else if(o===-1&&p===-1)r[i][1]=l.rotateRight();else if(o===1&&p===-1)l.right=r[i+1][1]=r[i+1][1].rotateRight(),r[i][1]=l.rotateLeft();else if(o===-1&&p===1)l.left=r[i+1][1]=r[i+1][1].rotateLeft(),r[i][1]=l.rotateRight();else throw new Error;if(i>0)switch(r[i-1][0]){case-1:r[i-1][1].left=r[i][1];break;case 1:r[i-1][1].right=r[i][1];break;case 0:r[i-1][1].mid=r[i][1];break}else this.c=r[0][1]}}return n}get(s){return this.d(s)?.value}d(s){const m=this.b.reset(s);let h=this.c;for(;h;){const a=m.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else break}return h}has(s){const m=this.d(s);return!(m?.value===void 0&&m?.mid===void 0)}delete(s){return this.e(s,!1)}deleteSuperstr(s){return this.e(s,!0)}e(s,m){const h=this.b.reset(s),a=[];let r=this.c;for(;r;){const n=h.cmp(r.segment);if(n>0)a.push([-1,r]),r=r.left;else if(n<0)a.push([1,r]),r=r.right;else if(h.hasNext())h.next(),a.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:i,value:l,segment:t}=n;this.e(n.key,!1),r.key=i,r.value=l,r.segment=t}}else{const n=r.left??r.right;if(a.length>0){const[i,l]=a[a.length-1];switch(i){case-1:l.left=n;break;case 0:l.mid=n;break;case 1:l.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const i=a[n][1];i.updateHeight();const l=i.balanceFactor();if(l>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),a[n][1]=i.rotateLeft()):l<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),a[n][1]=i.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(s){for(;s.left;)s=s.left;return s}findSubstr(s){const m=this.b.reset(s);let h=this.c,a;for(;h;){const r=m.cmp(h.segment);if(r>0)h=h.left;else if(r<0)h=h.right;else if(m.hasNext())m.next(),a=h.value||a,h=h.mid;else break}return h&&h.value||a}findSuperstr(s){return this.g(s,!1)}g(s,m){const h=this.b.reset(s);let a=this.c;for(;a;){const r=h.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(h.hasNext())h.next(),a=a.mid;else return a.mid?this.h(a.mid):m?a.value:void 0}}hasElementOrSubtree(s){return this.g(s,!0)!==void 0}forEach(s){for(const[m,h]of this)s(h,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(s){const m=[];return this.j(s,m),m[Symbol.iterator]()}j(s,m){s&&(s.left&&this.j(s.left,m),s.value&&m.push([s.key,s.value]),s.mid&&this.j(s.mid,m),s.right&&this.j(s.right,m))}_isBalanced(){const s=m=>{if(!m)return!0;const h=m.balanceFactor();return h<-1||h>1?!1:s(m.left)&&s(m.right)};return s(this.c)}}e.$7h=g}),define(le[8],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=void 0;function w(t){return typeof t=="string"}e.$Df=w;function L(t){return Array.isArray(t)&&t.every(o=>w(o))}e.$Ef=L;function k(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}e.$Ff=k;function M(t){const o=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof o}e.$Gf=M;function R(t){return typeof t=="number"&&!isNaN(t)}e.$Hf=R;function E(t){return!!t&&typeof t[Symbol.iterator]=="function"}e.$If=E;function f(t){return t===!0||t===!1}e.$Jf=f;function u(t){return typeof t>"u"}e.$Kf=u;function S(t){return!g(t)}e.$Lf=S;function g(t){return u(t)||t===null}e.$Mf=g;function y(t,o){if(!t)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.$Nf=y;function s(t){if(g(t))throw new Error("Assertion Failed: argument is undefined or null");return t}e.$Of=s;function m(...t){const o=[];for(let p=0;p<t.length;p++){const I=t[p];if(g(I))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);o.push(I)}return o}e.$Pf=m;const h=Object.prototype.hasOwnProperty;function a(t){if(!k(t))return!1;for(const o in t)if(h.call(t,o))return!1;return!0}e.$Qf=a;function r(t){return typeof t=="function"}e.$Rf=r;function n(...t){return t.length>0&&t.every(r)}e.$Sf=n;function i(t,o){const p=Math.min(t.length,o.length);for(let I=0;I<p;I++)l(t[I],o[I])}e.$Tf=i;function l(t,o){if(w(o)){if(typeof t!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(r(o)){try{if(t instanceof o)return}catch{}if(!g(t)&&t.constructor===o||o.length===1&&o.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Uf=l}),define(le[30],he([0,1,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function L(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const n=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([i,l])=>{n[i]=l&&typeof l=="object"?L(l):l}),n}e.$gn=L;function k(r){if(!r||typeof r!="object")return r;const n=[r];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const l in i)if(M.call(i,l)){const t=i[l];typeof t=="object"&&!Object.isFrozen(t)&&!(0,w.$Gf)(t)&&n.push(t)}}return r}e.$hn=k;const M=Object.prototype.hasOwnProperty;function R(r,n){return E(r,n,new Set)}e.$in=R;function E(r,n,i){if((0,w.$Mf)(r))return r;const l=n(r);if(typeof l<"u")return l;if(Array.isArray(r)){const t=[];for(const o of r)t.push(E(o,n,i));return t}if((0,w.$Ff)(r)){if(i.has(r))throw new Error("Cannot clone recursive data-structure");i.add(r);const t={};for(const o in r)M.call(r,o)&&(t[o]=E(r[o],n,i));return i.delete(r),t}return r}function f(r,n,i=!0){return(0,w.$Ff)(r)?((0,w.$Ff)(n)&&Object.keys(n).forEach(l=>{l in r?i&&((0,w.$Ff)(r[l])&&(0,w.$Ff)(n[l])?f(r[l],n[l],i):r[l]=n[l]):r[l]=n[l]}),r):n}e.$jn=f;function u(r,n){if(r===n)return!0;if(r==null||n===null||n===void 0||typeof r!=typeof n||typeof r!="object"||Array.isArray(r)!==Array.isArray(n))return!1;let i,l;if(Array.isArray(r)){if(r.length!==n.length)return!1;for(i=0;i<r.length;i++)if(!u(r[i],n[i]))return!1}else{const t=[];for(l in r)t.push(l);t.sort();const o=[];for(l in n)o.push(l);if(o.sort(),!u(t,o))return!1;for(i=0;i<t.length;i++)if(!u(r[t[i]],n[t[i]]))return!1}return!0}e.$kn=u;function S(r){const n=new Set;return JSON.stringify(r,(i,l)=>{if((0,w.$Ff)(l)||Array.isArray(l)){if(n.has(l))return"[Circular]";n.add(l)}return l})}e.$ln=S;function g(r,n){const i=Object.create(null);return!r||!n||Object.keys(n).forEach(t=>{const o=r[t],p=n[t];u(o,p)||(i[t]=p)}),i}e.$mn=g;function y(r,n){const i=n.toLowerCase(),l=Object.keys(r).find(t=>t.toLowerCase()===i);return l?r[l]:r[n]}e.$nn=y;function s(r,n){const i=Object.create(null);for(const[l,t]of Object.entries(r))n(l,t)&&(i[l]=t);return i}e.$on=s;function m(r){let n=[];for(;Object.prototype!==r;)n=n.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return n}e.$pn=m;function h(r){const n=[];for(const i of m(r))typeof r[i]=="function"&&n.push(i);return n}e.$qn=h;function a(r,n){const i=t=>function(){const o=Array.prototype.slice.call(arguments,0);return n(t,o)},l={};for(const t of r)l[t]=i(t);return l}e.$rn=a}),define(le[52],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(k){return w.test(k)}e.$kg=L,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let f=0;f<E.length;f++)E[f]=Math.floor(Math.random()*256);return E};const M=new Uint8Array(16),R=[];for(let E=0;E<256;E++)R.push(E.toString(16).padStart(2,"0"));return function(){k(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,u="";return u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u}}()}),define(le[31],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oU=void 0;function w(L){return!!L.parentPort}e.$oU=w}),define(le[53],he([13,12]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(le[54],he([0,1,53]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0;const L=60,k=L*60,M=k*24,R=M*7,E=M*30,f=M*365;function u(g,y,s,m){typeof g!="number"&&(g=g.getTime());const h=Math.round((new Date().getTime()-g)/1e3);if(h<-30)return(0,w.localize)(0,null,u(new Date().getTime()+h*1e3,!1));if(!m&&h<30)return(0,w.localize)(1,null);let a;return h<L?(a=h,y?a===1?s?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):s?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a):a===1?s?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):s?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):h<k?(a=Math.floor(h/L),y?a===1?s?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):s?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a):a===1?s?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):s?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):h<M?(a=Math.floor(h/k),y?a===1?s?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):s?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a):a===1?s?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):s?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):h<R?(a=Math.floor(h/M),y?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a)):h<E?(a=Math.floor(h/R),y?a===1?s?(0,w.localize)(30,null,a):(0,w.localize)(31,null,a):s?(0,w.localize)(32,null,a):(0,w.localize)(33,null,a):a===1?s?(0,w.localize)(34,null,a):(0,w.localize)(35,null,a):s?(0,w.localize)(36,null,a):(0,w.localize)(37,null,a)):h<f?(a=Math.floor(h/E),y?a===1?s?(0,w.localize)(38,null,a):(0,w.localize)(39,null,a):s?(0,w.localize)(40,null,a):(0,w.localize)(41,null,a):a===1?s?(0,w.localize)(42,null,a):(0,w.localize)(43,null,a):s?(0,w.localize)(44,null,a):(0,w.localize)(45,null,a)):(a=Math.floor(h/f),y?a===1?s?(0,w.localize)(46,null,a):(0,w.localize)(47,null,a):s?(0,w.localize)(48,null,a):(0,w.localize)(49,null,a):a===1?s?(0,w.localize)(50,null,a):(0,w.localize)(51,null,a):s?(0,w.localize)(52,null,a):(0,w.localize)(53,null,a))}e.$pm=u;function S(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$qm=S}),define(le[55],he([13,12]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(le[56],he([0,1,16,8,55]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function M(g,y){return y&&(g.stack||g.stacktrace)?k.localize(0,null,E(g),R(g.stack)||R(g.stacktrace)):E(g)}function R(g){return Array.isArray(g)?g.join(`
`):g}function E(g){return g.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${g.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?k.localize(1,null,g.message):g.message||k.localize(2,null)}function f(g=null,y=!1){if(!g)return k.localize(3,null);if(Array.isArray(g)){const s=w.$Hb(g),m=f(s[0],y);return s.length>1?k.localize(4,null,m,s.length):m}if(L.$Df(g))return g;if(g.detail){const s=g.detail;if(s.error)return M(s.error,y);if(s.exception)return M(s.exception,y)}return g.stack?M(g,y):g.message?g.message:k.localize(5,null)}e.$Li=f;function u(g){const y=g;return y instanceof Error&&Array.isArray(y.actions)}e.$Mi=u;function S(g,y){let s;return typeof g=="string"?s=new Error(g):s=g,s.actions=y,s}e.$Ni=S}),define(le[57],he([13,12]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(le[3],he([0,1,57]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let L=!1,k=!1,M=!1,R=!1,E=!1,f=!1,u=!1,S=!1,g=!1,y=!1,s,m=e.$g,h=e.$g,a,r;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&(i=process);const l=typeof i?.versions?.electron=="string",t=l&&i?.type==="renderer";if(typeof navigator=="object"&&!t)r=navigator.userAgent,L=r.indexOf("Windows")>=0,k=r.indexOf("Macintosh")>=0,S=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=r.indexOf("Linux")>=0,y=r?.indexOf("Mobi")>=0,f=!0,s=w.getConfiguredDefaultLocale(w.localize(0,null))||e.$g,m=s,h=navigator.language;else if(typeof i=="object"){L=i.platform==="win32",k=i.platform==="darwin",M=i.platform==="linux",R=M&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,u=l,g=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=e.$g,m=e.$g;const c=i.env.VSCODE_NLS_CONFIG;if(c)try{const $=JSON.parse(c),P=$.availableLanguages["*"];s=$.locale,h=$.osLocale,m=P||e.$g,a=$._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var o;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(o||(e.Platform=o={}));function p(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=p;let I=0;k?I=1:L?I=3:M&&(I=2),e.$i=L,e.$j=k,e.$k=M,e.$l=R,e.$m=E,e.$n=u,e.$o=f,e.$p=f&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=S,e.$s=y,e.$t=g,e.$u=I,e.$v=r,e.$w=m;var b;(function(c){function $(){return e.$w}c.value=$;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}c.isDefaultVariant=P;function T(){return e.$w==="en"}c.isDefault=T})(b||(e.Language=b={})),e.$x=s,e.$y=h,e.$z=a,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const c=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let T=0,A=c.length;T<A;T++){const z=c[T];if(z.id===P.data.vscodeScheduleAsyncWork){c.splice(T,1),z.callback();return}}});let $=0;return P=>{const T=++$;c.push({id:T,callback:P}),n.postMessage({vscodeScheduleAsyncWork:T},"*")}}return c=>setTimeout(c)})();var C;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(C||(e.OperatingSystem=C={})),e.OS=k||S?2:L?1:3;let v=!0,D=!1;function H(){if(!D){D=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,v=new Uint16Array(c.buffer)[0]===(2<<8)+1}return v}e.$D=H,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function W(c){return parseFloat(c)>=20}e.$J=W}),define(le[15],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const M=k.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return w.$i?"win32":w.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[7],he([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,k=97,M=90,R=122,E=46,f=47,u=92,S=58,g=63;class y extends Error{constructor(p,I,b){let C;typeof I=="string"&&I.indexOf("not ")===0?(C="must not be",I=I.replace(/^not /,"")):C="must be";const v=p.indexOf(".")!==-1?"property":"argument";let D=`The "${p}" ${v} ${C} of type ${I}`;D+=`. Received type ${typeof b}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function s(o,p){if(o===null||typeof o!="object")throw new y(p,"Object",o)}function m(o,p){if(typeof o!="string")throw new y(p,"string",o)}const h=w.$dc==="win32";function a(o){return o===f||o===u}function r(o){return o===f}function n(o){return o>=L&&o<=M||o>=k&&o<=R}function i(o,p,I,b){let C="",v=0,D=-1,H=0,W=0;for(let c=0;c<=o.length;++c){if(c<o.length)W=o.charCodeAt(c);else{if(b(W))break;W=f}if(b(W)){if(!(D===c-1||H===1))if(H===2){if(C.length<2||v!==2||C.charCodeAt(C.length-1)!==E||C.charCodeAt(C.length-2)!==E){if(C.length>2){const $=C.lastIndexOf(I);$===-1?(C="",v=0):(C=C.slice(0,$),v=C.length-1-C.lastIndexOf(I)),D=c,H=0;continue}else if(C.length!==0){C="",v=0,D=c,H=0;continue}}p&&(C+=C.length>0?`${I}..`:"..",v=2)}else C.length>0?C+=`${I}${o.slice(D+1,c)}`:C=o.slice(D+1,c),v=c-D-1;D=c,H=0}else W===E&&H!==-1?++H:H=-1}return C}function l(o,p){s(p,"pathObject");const I=p.dir||p.root,b=p.base||`${p.name||""}${p.ext||""}`;return I?I===p.root?`${I}${b}`:`${I}${o}${b}`:b}e.$fc={resolve(...o){let p="",I="",b=!1;for(let C=o.length-1;C>=-1;C--){let v;if(C>=0){if(v=o[C],m(v,"path"),v.length===0)continue}else p.length===0?v=w.cwd():(v=w.env[`=${p}`]||w.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==p.toLowerCase()&&v.charCodeAt(2)===u)&&(v=`${p}\\`));const D=v.length;let H=0,W="",c=!1;const $=v.charCodeAt(0);if(D===1)a($)&&(H=1,c=!0);else if(a($))if(c=!0,a(v.charCodeAt(1))){let P=2,T=P;for(;P<D&&!a(v.charCodeAt(P));)P++;if(P<D&&P!==T){const A=v.slice(T,P);for(T=P;P<D&&a(v.charCodeAt(P));)P++;if(P<D&&P!==T){for(T=P;P<D&&!a(v.charCodeAt(P));)P++;(P===D||P!==T)&&(W=`\\\\${A}\\${v.slice(T,P)}`,H=P)}}}else H=1;else n($)&&v.charCodeAt(1)===S&&(W=v.slice(0,2),H=2,D>2&&a(v.charCodeAt(2))&&(c=!0,H=3));if(W.length>0)if(p.length>0){if(W.toLowerCase()!==p.toLowerCase())continue}else p=W;if(b){if(p.length>0)break}else if(I=`${v.slice(H)}\\${I}`,b=c,c&&p.length>0)break}return I=i(I,!b,"\\",a),b?`${p}\\${I}`:`${p}${I}`||"."},normalize(o){m(o,"path");const p=o.length;if(p===0)return".";let I=0,b,C=!1;const v=o.charCodeAt(0);if(p===1)return r(v)?"\\":o;if(a(v))if(C=!0,a(o.charCodeAt(1))){let H=2,W=H;for(;H<p&&!a(o.charCodeAt(H));)H++;if(H<p&&H!==W){const c=o.slice(W,H);for(W=H;H<p&&a(o.charCodeAt(H));)H++;if(H<p&&H!==W){for(W=H;H<p&&!a(o.charCodeAt(H));)H++;if(H===p)return`\\\\${c}\\${o.slice(W)}\\`;H!==W&&(b=`\\\\${c}\\${o.slice(W,H)}`,I=H)}}}else I=1;else n(v)&&o.charCodeAt(1)===S&&(b=o.slice(0,2),I=2,p>2&&a(o.charCodeAt(2))&&(C=!0,I=3));let D=I<p?i(o.slice(I),!C,"\\",a):"";return D.length===0&&!C&&(D="."),D.length>0&&a(o.charCodeAt(p-1))&&(D+="\\"),b===void 0?C?`\\${D}`:D:C?`${b}\\${D}`:`${b}${D}`},isAbsolute(o){m(o,"path");const p=o.length;if(p===0)return!1;const I=o.charCodeAt(0);return a(I)||p>2&&n(I)&&o.charCodeAt(1)===S&&a(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let p,I;for(let v=0;v<o.length;++v){const D=o[v];m(D,"path"),D.length>0&&(p===void 0?p=I=D:p+=`\\${D}`)}if(p===void 0)return".";let b=!0,C=0;if(typeof I=="string"&&a(I.charCodeAt(0))){++C;const v=I.length;v>1&&a(I.charCodeAt(1))&&(++C,v>2&&(a(I.charCodeAt(2))?++C:b=!1))}if(b){for(;C<p.length&&a(p.charCodeAt(C));)C++;C>=2&&(p=`\\${p.slice(C)}`)}return e.$fc.normalize(p)},relative(o,p){if(m(o,"from"),m(p,"to"),o===p)return"";const I=e.$fc.resolve(o),b=e.$fc.resolve(p);if(I===b||(o=I.toLowerCase(),p=b.toLowerCase(),o===p))return"";let C=0;for(;C<o.length&&o.charCodeAt(C)===u;)C++;let v=o.length;for(;v-1>C&&o.charCodeAt(v-1)===u;)v--;const D=v-C;let H=0;for(;H<p.length&&p.charCodeAt(H)===u;)H++;let W=p.length;for(;W-1>H&&p.charCodeAt(W-1)===u;)W--;const c=W-H,$=D<c?D:c;let P=-1,T=0;for(;T<$;T++){const z=o.charCodeAt(C+T);if(z!==p.charCodeAt(H+T))break;z===u&&(P=T)}if(T!==$){if(P===-1)return b}else{if(c>$){if(p.charCodeAt(H+T)===u)return b.slice(H+T+1);if(T===2)return b.slice(H+T)}D>$&&(o.charCodeAt(C+T)===u?P=T:T===2&&(P=3)),P===-1&&(P=0)}let A="";for(T=C+P+1;T<=v;++T)(T===v||o.charCodeAt(T)===u)&&(A+=A.length===0?"..":"\\..");return H+=P,A.length>0?`${A}${b.slice(H,W)}`:(b.charCodeAt(H)===u&&++H,b.slice(H,W))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const p=e.$fc.resolve(o);if(p.length<=2)return o;if(p.charCodeAt(0)===u){if(p.charCodeAt(1)===u){const I=p.charCodeAt(2);if(I!==g&&I!==E)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(n(p.charCodeAt(0))&&p.charCodeAt(1)===S&&p.charCodeAt(2)===u)return`\\\\?\\${p}`;return o},dirname(o){m(o,"path");const p=o.length;if(p===0)return".";let I=-1,b=0;const C=o.charCodeAt(0);if(p===1)return a(C)?o:".";if(a(C)){if(I=b=1,a(o.charCodeAt(1))){let H=2,W=H;for(;H<p&&!a(o.charCodeAt(H));)H++;if(H<p&&H!==W){for(W=H;H<p&&a(o.charCodeAt(H));)H++;if(H<p&&H!==W){for(W=H;H<p&&!a(o.charCodeAt(H));)H++;if(H===p)return o;H!==W&&(I=b=H+1)}}}}else n(C)&&o.charCodeAt(1)===S&&(I=p>2&&a(o.charCodeAt(2))?3:2,b=I);let v=-1,D=!0;for(let H=p-1;H>=b;--H)if(a(o.charCodeAt(H))){if(!D){v=H;break}}else D=!1;if(v===-1){if(I===-1)return".";v=I}return o.slice(0,v)},basename(o,p){p!==void 0&&m(p,"ext"),m(o,"path");let I=0,b=-1,C=!0,v;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===S&&(I=2),p!==void 0&&p.length>0&&p.length<=o.length){if(p===o)return"";let D=p.length-1,H=-1;for(v=o.length-1;v>=I;--v){const W=o.charCodeAt(v);if(a(W)){if(!C){I=v+1;break}}else H===-1&&(C=!1,H=v+1),D>=0&&(W===p.charCodeAt(D)?--D===-1&&(b=v):(D=-1,b=H))}return I===b?b=H:b===-1&&(b=o.length),o.slice(I,b)}for(v=o.length-1;v>=I;--v)if(a(o.charCodeAt(v))){if(!C){I=v+1;break}}else b===-1&&(C=!1,b=v+1);return b===-1?"":o.slice(I,b)},extname(o){m(o,"path");let p=0,I=-1,b=0,C=-1,v=!0,D=0;o.length>=2&&o.charCodeAt(1)===S&&n(o.charCodeAt(0))&&(p=b=2);for(let H=o.length-1;H>=p;--H){const W=o.charCodeAt(H);if(a(W)){if(!v){b=H+1;break}continue}C===-1&&(v=!1,C=H+1),W===E?I===-1?I=H:D!==1&&(D=1):I!==-1&&(D=-1)}return I===-1||C===-1||D===0||D===1&&I===C-1&&I===b+1?"":o.slice(I,C)},format:l.bind(null,"\\"),parse(o){m(o,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return p;const I=o.length;let b=0,C=o.charCodeAt(0);if(I===1)return a(C)?(p.root=p.dir=o,p):(p.base=p.name=o,p);if(a(C)){if(b=1,a(o.charCodeAt(1))){let P=2,T=P;for(;P<I&&!a(o.charCodeAt(P));)P++;if(P<I&&P!==T){for(T=P;P<I&&a(o.charCodeAt(P));)P++;if(P<I&&P!==T){for(T=P;P<I&&!a(o.charCodeAt(P));)P++;P===I?b=P:P!==T&&(b=P+1)}}}}else if(n(C)&&o.charCodeAt(1)===S){if(I<=2)return p.root=p.dir=o,p;if(b=2,a(o.charCodeAt(2))){if(I===3)return p.root=p.dir=o,p;b=3}}b>0&&(p.root=o.slice(0,b));let v=-1,D=b,H=-1,W=!0,c=o.length-1,$=0;for(;c>=b;--c){if(C=o.charCodeAt(c),a(C)){if(!W){D=c+1;break}continue}H===-1&&(W=!1,H=c+1),C===E?v===-1?v=c:$!==1&&($=1):v!==-1&&($=-1)}return H!==-1&&(v===-1||$===0||$===1&&v===H-1&&v===D+1?p.base=p.name=o.slice(D,H):(p.name=o.slice(D,v),p.base=o.slice(D,H),p.ext=o.slice(v,H))),D>0&&D!==b?p.dir=o.slice(0,D-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(h){const o=/\\/g;return()=>{const p=w.cwd().replace(o,"/");return p.slice(p.indexOf("/"))}}return()=>w.cwd()})();e.$gc={resolve(...o){let p="",I=!1;for(let b=o.length-1;b>=-1&&!I;b--){const C=b>=0?o[b]:t();m(C,"path"),C.length!==0&&(p=`${C}/${p}`,I=C.charCodeAt(0)===f)}return p=i(p,!I,"/",r),I?`/${p}`:p.length>0?p:"."},normalize(o){if(m(o,"path"),o.length===0)return".";const p=o.charCodeAt(0)===f,I=o.charCodeAt(o.length-1)===f;return o=i(o,!p,"/",r),o.length===0?p?"/":I?"./":".":(I&&(o+="/"),p?`/${o}`:o)},isAbsolute(o){return m(o,"path"),o.length>0&&o.charCodeAt(0)===f},join(...o){if(o.length===0)return".";let p;for(let I=0;I<o.length;++I){const b=o[I];m(b,"path"),b.length>0&&(p===void 0?p=b:p+=`/${b}`)}return p===void 0?".":e.$gc.normalize(p)},relative(o,p){if(m(o,"from"),m(p,"to"),o===p||(o=e.$gc.resolve(o),p=e.$gc.resolve(p),o===p))return"";const I=1,b=o.length,C=b-I,v=1,D=p.length-v,H=C<D?C:D;let W=-1,c=0;for(;c<H;c++){const P=o.charCodeAt(I+c);if(P!==p.charCodeAt(v+c))break;P===f&&(W=c)}if(c===H)if(D>H){if(p.charCodeAt(v+c)===f)return p.slice(v+c+1);if(c===0)return p.slice(v+c)}else C>H&&(o.charCodeAt(I+c)===f?W=c:c===0&&(W=0));let $="";for(c=I+W+1;c<=b;++c)(c===b||o.charCodeAt(c)===f)&&($+=$.length===0?"..":"/..");return`${$}${p.slice(v+W)}`},toNamespacedPath(o){return o},dirname(o){if(m(o,"path"),o.length===0)return".";const p=o.charCodeAt(0)===f;let I=-1,b=!0;for(let C=o.length-1;C>=1;--C)if(o.charCodeAt(C)===f){if(!b){I=C;break}}else b=!1;return I===-1?p?"/":".":p&&I===1?"//":o.slice(0,I)},basename(o,p){p!==void 0&&m(p,"ext"),m(o,"path");let I=0,b=-1,C=!0,v;if(p!==void 0&&p.length>0&&p.length<=o.length){if(p===o)return"";let D=p.length-1,H=-1;for(v=o.length-1;v>=0;--v){const W=o.charCodeAt(v);if(W===f){if(!C){I=v+1;break}}else H===-1&&(C=!1,H=v+1),D>=0&&(W===p.charCodeAt(D)?--D===-1&&(b=v):(D=-1,b=H))}return I===b?b=H:b===-1&&(b=o.length),o.slice(I,b)}for(v=o.length-1;v>=0;--v)if(o.charCodeAt(v)===f){if(!C){I=v+1;break}}else b===-1&&(C=!1,b=v+1);return b===-1?"":o.slice(I,b)},extname(o){m(o,"path");let p=-1,I=0,b=-1,C=!0,v=0;for(let D=o.length-1;D>=0;--D){const H=o.charCodeAt(D);if(H===f){if(!C){I=D+1;break}continue}b===-1&&(C=!1,b=D+1),H===E?p===-1?p=D:v!==1&&(v=1):p!==-1&&(v=-1)}return p===-1||b===-1||v===0||v===1&&p===b-1&&p===I+1?"":o.slice(p,b)},format:l.bind(null,"/"),parse(o){m(o,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return p;const I=o.charCodeAt(0)===f;let b;I?(p.root="/",b=1):b=0;let C=-1,v=0,D=-1,H=!0,W=o.length-1,c=0;for(;W>=b;--W){const $=o.charCodeAt(W);if($===f){if(!H){v=W+1;break}continue}D===-1&&(H=!1,D=W+1),$===E?C===-1?C=W:c!==1&&(c=1):C!==-1&&(c=-1)}if(D!==-1){const $=v===0&&I?1:v;C===-1||c===0||c===1&&C===D-1&&C===v+1?p.base=p.name=o.slice($,D):(p.name=o.slice($,C),p.base=o.slice($,D),p.ext=o.slice(C,D))}return v>0?p.dir=o.slice(0,v-1):I&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(le[32],he([0,1,7,3,11,8]),function(oe,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function R(v){return v===47||v===92}e.$Vf=R;function E(v){return v.replace(/[\\/]/g,w.$gc.sep)}e.$Wf=E;function f(v){return v.indexOf("/")===-1&&(v=E(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}e.$Xf=f;function u(v,D=w.$gc.sep){if(!v)return"";const H=v.length,W=v.charCodeAt(0);if(R(W)){if(R(v.charCodeAt(1))&&!R(v.charCodeAt(2))){let $=3;const P=$;for(;$<H&&!R(v.charCodeAt($));$++);if(P!==$&&!R(v.charCodeAt($+1))){for($+=1;$<H;$++)if(R(v.charCodeAt($)))return v.slice(0,$+1).replace(/[\\/]/g,D)}}return D}else if(r(W)&&v.charCodeAt(1)===58)return R(v.charCodeAt(2))?v.slice(0,2)+D:v.slice(0,2);let c=v.indexOf("://");if(c!==-1){for(c+=3;c<H;c++)if(R(v.charCodeAt(c)))return v.slice(0,c+1)}return""}e.$Yf=u;function S(v){if(!L.$i||!v||v.length<5)return!1;let D=v.charCodeAt(0);if(D!==92||(D=v.charCodeAt(1),D!==92))return!1;let H=2;const W=H;for(;H<v.length&&(D=v.charCodeAt(H),D!==92);H++);return!(W===H||(D=v.charCodeAt(H+1),isNaN(D)||D===92))}e.$Zf=S;const g=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(v,D=L.$i){const H=D?g:y;return!(!v||v.length===0||/^\s+$/.test(v)||(H.lastIndex=0,H.test(v))||D&&s.test(v)||v==="."||v===".."||D&&v[v.length-1]==="."||D&&v.length!==v.trim().length||v.length>255)}e.$1f=m;function h(v,D,H){const W=v===D;return!H||W?W:!v||!D?!1:(0,k.$7e)(v,D)}e.$2f=h;function a(v,D,H,W=w.sep){if(v===D)return!0;if(!v||!D||D.length>v.length)return!1;if(H){if(!(0,k.$8e)(v,D))return!1;if(D.length===v.length)return!0;let $=D.length;return D.charAt(D.length-1)===W&&$--,v.charAt($)===W}return D.charAt(D.length-1)!==W&&(D+=W),v.indexOf(D)===0}e.$3f=a;function r(v){return v>=65&&v<=90||v>=97&&v<=122}e.$4f=r;function n(v,D){return L.$i&&v.endsWith(":")&&(v+=w.sep),(0,w.$ic)(v)||(v=(0,w.$jc)(D,v)),v=(0,w.$hc)(v),L.$i?(v=(0,k.$Pe)(v,w.sep),v.endsWith(":")&&(v+=w.sep)):(v=(0,k.$Pe)(v,w.sep),v||(v=w.sep)),v}e.$5f=n;function i(v){const D=(0,w.$hc)(v);return L.$i?v.length>3?!1:l(D)&&(v.length===2||D.charCodeAt(2)===92):D===w.$gc.sep}e.$6f=i;function l(v,D=L.$i){return D?r(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}e.$7f=l;function t(v,D=L.$i){return l(v,D)?v[0]:void 0}e.$8f=t;function o(v,D,H){return D.length>v.length?-1:v===D?0:(H&&(v=v.toLowerCase(),D=D.toLowerCase()),v.indexOf(D))}e.$9f=o;function p(v){const D=v.split(":");let H,W,c;for(const $ of D){const P=Number($);(0,M.$Hf)(P)?W===void 0?W=P:c===void 0&&(c=P):H=H?[H,$].join(":"):$}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:W!==void 0?W:void 0,column:c!==void 0?c:W!==void 0?1:void 0}}e.$0f=p;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",b="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(v,D,H=8){let W="";for(let $=0;$<H;$++){let P;$===0&&L.$i&&!D&&(H===3||H===4)?P=b:P=I,W+=P.charAt(Math.floor(Math.random()*P.length))}let c;return D?c=`${D}-${W}`:c=W,v?(0,w.$jc)(v,c):c}e.$$f=C}),define(le[33],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0;var L;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(L||(e.Source=L={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function M(E,...f){const u=f.reduce((y,s)=>(y[s]=!0,y),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!u[y]).forEach(y=>{for(let s=0;s<S.length;s++)if(y.search(S[s])!==-1){delete E[y];break}})}e.$Ll=M;function R(E){E&&(delete E.DEBUG,w.$j&&delete E.DYLD_LIBRARY_PATH,w.$k&&delete E.LD_PRELOAD)}e.$Ml=R}),define(le[5],he([0,1,7,3]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,R=/^\/\//;function E(b,C){if(!b.scheme&&C)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${b.authority}", path: "${b.path}", query: "${b.query}", fragment: "${b.fragment}"}`);if(b.scheme&&!k.test(b.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(b.path){if(b.authority){if(!M.test(b.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(b.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(b,C){return!b&&!C?"file":b}function u(b,C){switch(b){case"https":case"http":case"file":C?C[0]!==g&&(C=g+C):C=g;break}return C}const S="",g="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(C){return C instanceof s?!0:C?typeof C.authority=="string"&&typeof C.fragment=="string"&&typeof C.path=="string"&&typeof C.query=="string"&&typeof C.scheme=="string"&&typeof C.fsPath=="string"&&typeof C.with=="function"&&typeof C.toString=="function":!1}constructor(C,v,D,H,W,c=!1){typeof C=="object"?(this.scheme=C.scheme||S,this.authority=C.authority||S,this.path=C.path||S,this.query=C.query||S,this.fragment=C.fragment||S):(this.scheme=f(C,c),this.authority=v||S,this.path=u(this.scheme,D||S),this.query=H||S,this.fragment=W||S,E(this,c))}get fsPath(){return l(this,!1)}with(C){if(!C)return this;let{scheme:v,authority:D,path:H,query:W,fragment:c}=C;return v===void 0?v=this.scheme:v===null&&(v=S),D===void 0?D=this.authority:D===null&&(D=S),H===void 0?H=this.path:H===null&&(H=S),W===void 0?W=this.query:W===null&&(W=S),c===void 0?c=this.fragment:c===null&&(c=S),v===this.scheme&&D===this.authority&&H===this.path&&W===this.query&&c===this.fragment?this:new a(v,D,H,W,c)}static parse(C,v=!1){const D=y.exec(C);return D?new a(D[2]||S,I(D[4]||S),I(D[5]||S),I(D[7]||S),I(D[9]||S),v):new a(S,S,S,S,S)}static file(C){let v=S;if(L.$i&&(C=C.replace(/\\/g,g)),C[0]===g&&C[1]===g){const D=C.indexOf(g,2);D===-1?(v=C.substring(2),C=g):(v=C.substring(2,D),C=C.substring(D)||g)}return new a("file",v,C,S,S)}static from(C,v){return new a(C.scheme,C.authority,C.path,C.query,C.fragment,v)}static joinPath(C,...v){if(!C.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return L.$i&&C.scheme==="file"?D=s.file(w.$fc.join(l(C,!0),...v)).path:D=w.$gc.join(C.path,...v),C.with({path:D})}toString(C=!1){return t(this,C)}toJSON(){return this}static revive(C){if(C){if(C instanceof s)return C;{const v=new a(C);return v._formatted=C.external??null,v._fsPath=C._sep===h?C.fsPath??null:null,v}}else return C}}e.URI=s;function m(b){return!b||typeof b!="object"?!1:typeof b.scheme=="string"&&(typeof b.authority=="string"||typeof b.authority>"u")&&(typeof b.path=="string"||typeof b.path>"u")&&(typeof b.query=="string"||typeof b.query>"u")&&(typeof b.fragment=="string"||typeof b.fragment>"u")}e.$vc=m;const h=L.$i?1:void 0;class a extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(C=!1){return C?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const C={$mid:1};return this._fsPath&&(C.fsPath=this._fsPath,C._sep=h),this._formatted&&(C.external=this._formatted),this.path&&(C.path=this.path),this.scheme&&(C.scheme=this.scheme),this.authority&&(C.authority=this.authority),this.query&&(C.query=this.query),this.fragment&&(C.fragment=this.fragment),C}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(b,C,v){let D,H=-1;for(let W=0;W<b.length;W++){const c=b.charCodeAt(W);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||C&&c===47||v&&c===91||v&&c===93||v&&c===58)H!==-1&&(D+=encodeURIComponent(b.substring(H,W)),H=-1),D!==void 0&&(D+=b.charAt(W));else{D===void 0&&(D=b.substr(0,W));const $=r[c];$!==void 0?(H!==-1&&(D+=encodeURIComponent(b.substring(H,W)),H=-1),D+=$):H===-1&&(H=W)}}return H!==-1&&(D+=encodeURIComponent(b.substring(H))),D!==void 0?D:b}function i(b){let C;for(let v=0;v<b.length;v++){const D=b.charCodeAt(v);D===35||D===63?(C===void 0&&(C=b.substr(0,v)),C+=r[D]):C!==void 0&&(C+=b[v])}return C!==void 0?C:b}function l(b,C){let v;return b.authority&&b.path.length>1&&b.scheme==="file"?v=`//${b.authority}${b.path}`:b.path.charCodeAt(0)===47&&(b.path.charCodeAt(1)>=65&&b.path.charCodeAt(1)<=90||b.path.charCodeAt(1)>=97&&b.path.charCodeAt(1)<=122)&&b.path.charCodeAt(2)===58?C?v=b.path.substr(1):v=b.path[1].toLowerCase()+b.path.substr(2):v=b.path,L.$i&&(v=v.replace(/\//g,"\\")),v}e.$wc=l;function t(b,C){const v=C?i:n;let D="",{scheme:H,authority:W,path:c,query:$,fragment:P}=b;if(H&&(D+=H,D+=":"),(W||H==="file")&&(D+=g,D+=g),W){let T=W.indexOf("@");if(T!==-1){const A=W.substr(0,T);W=W.substr(T+1),T=A.lastIndexOf(":"),T===-1?D+=v(A,!1,!1):(D+=v(A.substr(0,T),!1,!1),D+=":",D+=v(A.substr(T+1),!1,!0)),D+="@"}W=W.toLowerCase(),T=W.lastIndexOf(":"),T===-1?D+=v(W,!1,!0):(D+=v(W.substr(0,T),!1,!0),D+=W.substr(T))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const T=c.charCodeAt(1);T>=65&&T<=90&&(c=`/${String.fromCharCode(T+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const T=c.charCodeAt(0);T>=65&&T<=90&&(c=`${String.fromCharCode(T+32)}:${c.substr(2)}`)}D+=v(c,!0,!1)}return $&&(D+="?",D+=v($,!1,!1)),P&&(D+="#",D+=C?P:n(P,!1,!1)),D}function o(b){try{return decodeURIComponent(b)}catch{return b.length>3?b.substr(0,3)+o(b.substr(3)):b}}const p=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function I(b){return b.match(p)?b.replace(p,C=>o(C)):b}}),define(le[58],he([0,1,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$_p=e.$$p=e.$0p=void 0;function L(u){const S=u;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.$0p=L;function k(u){const S=[];let g;try{const y=JSON.parse(u.arguments),s=y[y.length-1];s&&s.__$stack&&(y.pop(),g=s.__$stack),S.push(...y)}catch{S.push("Unable to log remote console arguments",u.arguments)}return{args:S,stack:g}}e.$$p=k;function M(u){if(typeof u!="string")return M(k(u).stack);const S=u;if(S){const g=R(S),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(y&&y.length===4)return{uri:w.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$_p=M;function R(u){if(!u)return u;const S=u.indexOf(`
`);return S===-1?u:u.substring(0,S)}function E(u,S){const{args:g,stack:y}=k(u),s=typeof g[0]=="string"&&g.length===1;let m=R(y);m&&(m=`(${m.trim()})`);let h=[];if(typeof g[0]=="string"?m&&s?h=[`%c[${S}] %c${g[0]} %c${m}`,f("blue"),f(""),f("grey")]:h=[`%c[${S}] %c${g[0]}`,f("blue"),f(""),...g.slice(1)]:h=[`%c[${S}]%`,f("blue"),...g],m&&!s&&h.push(m),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,h)}e.log=E;function f(u){return`color: ${u}`}}),define(le[59],he([0,1,18,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function k(f){return JSON.stringify(f,R)}e.$vh=k;function M(f){let u=JSON.parse(f);return u=E(u),u}e.$wh=M;function R(f,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function E(f,u=0){if(!f||u>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof w.$ge||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let S=0;S<f.length;++S)f[S]=E(f[S],u+1);else for(const S in f)Object.hasOwnProperty.call(f,S)&&(f[S]=E(f[S],u+1))}return f}e.$xh=E}),define(le[19],he([0,1,6,3,11,5]),function(oe,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var R;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function E(y,s){return M.URI.isUri(y)?(0,k.$7e)(y.scheme,s):(0,k.$8e)(y,s+":")}e.$_f=E;function f(y,...s){return s.some(m=>E(y,m))}e.$ag=f,e.$bg="vscode-tkn",e.$cg="tkn";class u{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s){this.f=`${s}/${R.vscodeRemoteResource}`}set(s,m,h){this.a[s]=m,this.b[s]=h}setConnectionToken(s,m){this.c[s]=m}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(i){return w.$1(i),s}const m=s.authority;let h=this.a[m];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const a=this.b[m],r=this.c[m];let n=`path=${encodeURIComponent(s.path)}`;return typeof r=="string"&&(n+=`&${e.$cg}=${encodeURIComponent(r)}`),M.URI.from({scheme:L.$o?this.d:R.vscodeRemoteResource,authority:`${h}:${a}`,path:this.f,query:n})}}e.$dg=new u,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class S{static{this.a=e.$ig}asBrowserUri(s){const m=this.b(s,oe);return this.uriToBrowserUri(m)}uriToBrowserUri(s){return s.scheme===R.vscodeRemote?e.$dg.rewrite(s):s.scheme===R.file&&(L.$m||L.$q===`${R.vscodeFileResource}://${S.a}`)?s.with({scheme:R.vscodeFileResource,authority:s.authority||S.a,query:null,fragment:null}):s}asFileUri(s){const m=this.b(s,oe);return this.uriToFileUri(m)}uriToFileUri(s){return s.scheme===R.vscodeFileResource?s.with({scheme:R.file,authority:s.authority!==S.a?s.authority:null,query:null,fragment:null}):s}b(s,m){return M.URI.isUri(s)?s:M.URI.parse(m.toUrl(s))}}e.$jg=new S;var g;(function(y){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(s.get("3"));const m="vscode-coi";function h(r){let n;typeof r=="string"?n=new URL(r).searchParams:r instanceof URL?n=r.searchParams:M.URI.isUri(r)&&(n=new URL(r.toString(!0)).searchParams);const i=n?.get(m);if(i)return s.get(i)}y.getHeadersFromQuery=h;function a(r,n,i){if(!globalThis.crossOriginIsolated)return;const l=n&&i?"3":i?"2":"1";r instanceof URLSearchParams?r.set(m,l):r[m]=l}y.addSearchParam=a})(g||(e.COI=g={}))}),define(le[23],he([0,1,32,19,7,3,11,5]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function f(s){return(0,E.$wc)(s,!0)}e.$qg=f;class u{constructor(m){this.a=m}compare(m,h,a=!1){return m===h?0:(0,R.$Ze)(this.getComparisonKey(m,a),this.getComparisonKey(h,a))}isEqual(m,h,a=!1){return m===h?!0:!m||!h?!1:this.getComparisonKey(m,a)===this.getComparisonKey(h,a)}getComparisonKey(m,h=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,h,a=!1){if(m.scheme===h.scheme){if(m.scheme===L.Schemas.file)return w.$3f(f(m),f(h),this.a(m))&&m.query===h.query&&(a||m.fragment===h.fragment);if((0,e.$Hg)(m.authority,h.authority))return w.$3f(m.path,h.path,this.a(m),"/")&&m.query===h.query&&(a||m.fragment===h.fragment)}return!1}joinPath(m,...h){return E.URI.joinPath(m,...h)}basenameOrAuthority(m){return(0,e.$zg)(m)||m.authority}basename(m){return k.$gc.basename(m.path)}extname(m){return k.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let h;return m.scheme===L.Schemas.file?h=E.URI.file(k.$mc(f(m))).path:(h=k.$gc.dirname(m.path),m.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),h="/")),m.with({path:h})}normalizePath(m){if(!m.path.length)return m;let h;return m.scheme===L.Schemas.file?h=E.URI.file(k.$hc(f(m))).path:h=k.$gc.normalize(m.path),m.with({path:h})}relativePath(m,h){if(m.scheme!==h.scheme||!(0,e.$Hg)(m.authority,h.authority))return;if(m.scheme===L.Schemas.file){const n=k.$lc(f(m),f(h));return M.$i?w.$Wf(n):n}let a=m.path||"/";const r=h.path||"/";if(this.a(m)){let n=0;for(const i=Math.min(a.length,r.length);n<i&&!(a.charCodeAt(n)!==r.charCodeAt(n)&&a.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);a=r.substr(0,n)+a.substr(n)}return k.$gc.relative(a,r)}resolvePath(m,h){if(m.scheme===L.Schemas.file){const a=E.URI.file(k.$kc(f(m),h));return m.with({authority:a.authority,path:a.path})}return h=w.$Xf(h),m.with({path:k.$gc.resolve(m.path,h)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,h){return m===h||m!==void 0&&h!==void 0&&(0,R.$7e)(m,h)}hasTrailingPathSeparator(m,h=k.sep){if(m.scheme===L.Schemas.file){const a=f(m);return a.length>w.$Yf(a).length&&a[a.length-1]===h}else{const a=m.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,h=k.sep){return(0,e.$Ig)(m,h)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,h=k.sep){let a=!1;if(m.scheme===L.Schemas.file){const r=f(m);a=r!==void 0&&r.length===w.$Yf(r).length&&r[r.length-1]===h}else{h="/";const r=m.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Ig)(m,h)?m.with({path:m.path+"/"}):m}}e.$rg=u,e.$sg=new u(()=>!1),e.$tg=new u(s=>s.scheme===L.Schemas.file?!M.$k:!0),e.$ug=new u(s=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function S(s,m){const h=[];for(let a=0;a<s.length;a++){const r=m(s[a]);s.some((n,i)=>i===a?!1:(0,e.$wg)(r,m(n)))||h.push(s[a])}return h}e.$Lg=S;var g;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function m(h){const a=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[l,t]=i.split(":");l&&t&&a.set(l,t)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&a.set(s.META_DATA_MIME,n),a}s.parseMetaData=m})(g||(e.DataUri=g={}));function y(s,m,h){if(m){let a=s.path;return a&&a[0]!==k.$gc.sep&&(a=k.$gc.sep+a),s.with({scheme:h,authority:m,path:a})}return s.with({scheme:h})}e.$Mg=y}),define(le[9],he([0,1,17,6,4,2,23,3,50,22]),function(oe,e,w,L,k,M,R,E,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function S(N){return!!N&&typeof N.then=="function"}e.$Ng=S;function g(N){const O=new w.$3d,V=N(O.token),X=new Promise((G,re)=>{const ce=O.token.onCancellationRequested(()=>{ce.dispose(),O.dispose(),re(new L.$5)});Promise.resolve(V).then(me=>{ce.dispose(),O.dispose(),G(me)},me=>{ce.dispose(),O.dispose(),re(me)})});return new class{cancel(){O.cancel()}then(G,re){return X.then(G,re)}catch(G){return this.then(void 0,G)}finally(G){return X.finally(G)}}}e.$Og=g;function y(N,O,V){return new Promise((X,G)=>{const re=O.onCancellationRequested(()=>{re.dispose(),X(V)});N.then(X,G).finally(()=>re.dispose())})}e.$Pg=y;function s(N,O){return new Promise((V,X)=>{const G=O.onCancellationRequested(()=>{G.dispose(),X(new L.$5)});N.then(V,X).finally(()=>G.dispose())})}e.$Qg=s;async function m(N){let O=-1;const V=N.map((X,G)=>X.then(re=>(O=G,re)));try{return await Promise.race(V)}finally{N.forEach((X,G)=>{G!==O&&X.cancel()})}}e.$Rg=m;function h(N,O,V){let X;const G=setTimeout(()=>{X?.(void 0),V?.()},O);return Promise.race([N.finally(()=>clearTimeout(G)),new Promise(re=>X=re)])}e.$Sg=h;function a(N){return new Promise((O,V)=>{const X=N();S(X)?X.then(O,V):O(X)})}e.$Tg=a;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const V=()=>{if(this.b=null,this.f)return;const X=this.queue(this.d);return this.d=null,X};this.b=new Promise(X=>{this.a.then(V,V).then(X)})}return new Promise((V,X)=>{this.b.then(V,X)})}return this.a=O(),new Promise((V,X)=>{this.a.then(G=>{this.a=null,V(G)},G=>{this.a=null,X(G)})})}dispose(){this.f=!0}}e.$Ug=r;class n{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$Vg=n;class i{constructor(){this.a=new Map}queue(O,V){const G=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(O)===G&&this.a.delete(O)});return this.a.set(O,G),G}}e.$Wg=i;const l=(N,O)=>{let V=!0;const X=setTimeout(()=>{V=!1,O()},N);return{isTriggered:()=>V,dispose:()=>{clearTimeout(X),V=!1}}},t=N=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,N())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class o{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,V=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((G,re)=>{this.d=G,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const X=()=>{this.a=null,this.d?.(null)};return this.a=V===f.$Pd?t(X):l(V,X),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=o;class p{constructor(O){this.a=new o(O),this.b=new r}trigger(O,V){return this.a.trigger(()=>this.b.queue(O),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=p;class I{constructor(){this.a=!1,this.b=new Promise((O,V)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=I;class b extends I{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$1g=b;function C(N,O){return O?new Promise((V,X)=>{const G=setTimeout(()=>{re.dispose(),V()},N),re=O.onCancellationRequested(()=>{clearTimeout(G),re.dispose(),X(new L.$5)})}):g(V=>C(N,V))}e.$2g=C;function v(N,O=0,V){const X=setTimeout(()=>{N(),V&&G.dispose()},O),G=(0,M.$Qc)(()=>{clearTimeout(X),V?.deleteAndLeak(G)});return V?.add(G),G}e.$3g=v;function D(N){const O=[];let V=0;const X=N.length;function G(){return V<X?N[V++]():null}function re(ce){ce!=null&&O.push(ce);const me=G();return me?me.then(re):Promise.resolve(O)}return Promise.resolve(null).then(re)}e.$4g=D;function H(N,O=X=>!!X,V=null){let X=0;const G=N.length,re=()=>{if(X>=G)return Promise.resolve(V);const ce=N[X++];return Promise.resolve(ce()).then(be=>O(be)?Promise.resolve(be):re())};return re()}e.$5g=H;function W(N,O=X=>!!X,V=null){if(N.length===0)return Promise.resolve(V);let X=N.length;const G=()=>{X=-1;for(const re of N)re.cancel?.()};return new Promise((re,ce)=>{for(const me of N)me.then(be=>{--X>=0&&O(be)?(G(),re(be)):X===0&&re(V)}).catch(be=>{--X>=0&&(G(),ce(be))})})}e.$6g=W;class c{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new k.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((V,X)=>{this.f.push({factory:O,c:V,e:X}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const V=O.factory();V.then(O.c,O.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=c;class $ extends c{constructor(){super(1)}}e.$8g=$;class P{constructor(){this.a=new B,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$9g=P;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new q;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,V=R.$sg){const X=V.getComparisonKey(O);let G=this.a.get(X);if(!G){G=new $;const re=this.f++,ce=k.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(X),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$2c),this.d.set(re,ce),this.a.set(X,G)}return G}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=T;class A{constructor(O,V){this.a=-1,typeof O=="function"&&typeof V=="number"&&this.setIfNotSet(O,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},V)}setIfNotSet(O,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},V))}}e.$$g=A;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,V,X=globalThis){this.cancel();const G=X.setInterval(()=>{O()},V);this.d=(0,M.$Qc)(()=>{X.clearInterval(G),this.d=void 0})}dispose(){this.cancel()}}e.$_g=z;class ee{constructor(O,V){this.b=-1,this.a=O,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=ee;class ie{constructor(O,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=O,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=ie;class Q extends ee{constructor(O,V){super(O,V),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$ch=Q;class se extends M.$Sc{constructor(O,V){super(),this.g=O,this.h=V,this.a=[],this.b=this.B(new M.$Tc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of O)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(N,O)=>{(0,E.$B)(()=>{if(V)return;const X=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$fh=(N,O,V)=>{const X=N.requestIdleCallback(O,typeof V=="number"?{timeout:V}:void 0);let G=!1;return{dispose(){G||(G=!0,N.cancelIdleCallback(X))}}},e.$eh=N=>(0,e.$fh)(globalThis,N)}();class ue{constructor(O,V){this.g=!1,this.d=()=>{try{this.j=V()}catch(X){this.l=X}finally{this.g=!0}},this.f=(0,e.$fh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=ue;class fe extends ue{constructor(O){super(globalThis,O)}}e.$hh=fe;async function J(N,O,V){let X;for(let G=0;G<V;G++)try{return await N()}catch(re){X=re,await C(O)}throw X}e.$ih=J;class B{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,V,X){return this.a={taskId:O,cancel:()=>X?.(),promise:V},V.then(()=>this.d(O),()=>this.d(O)),V}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{let V,X;const G=new Promise((re,ce)=>{V=re,X=ce});this.b={run:O,promise:G,promiseResolve:V,promiseReject:X}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=B;class Z{constructor(O,V=()=>Date.now()){this.d=O,this.f=V,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$kh=Z;var te;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(te||(te={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((O,V)=>{this.a=O,this.b=V})}complete(O){return new Promise(V=>{this.a(O),this.d={outcome:0,value:O},V()})}error(O){return new Promise(V=>{this.b(O),this.d={outcome:1,value:O},V()})}cancel(){return this.error(new L.$5)}}e.$lh=q;var _;(function(N){async function O(X){let G;const re=await Promise.all(X.map(ce=>ce.then(me=>me,me=>{G||(G=me)})));if(typeof G<"u")throw G;return re}N.settled=O;function V(X){return new Promise(async(G,re)=>{try{await X(G,re)}catch(ce){re(ce)}})}N.withAsyncBody=V})(_||(e.Promises=_={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(V=>(this.a=V,this.d=!0,V),V=>{throw this.b=V,this.d=!0,V})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=ge;class K{constructor(O){this.b=O,this.a=new u.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=K;var d;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(d||(d={}));class F{static fromArray(O){return new F(V=>{V.emitMany(O)})}static fromPromise(O){return new F(async V=>{V.emitMany(await O)})}static fromPromises(O){return new F(async V=>{await Promise.all(O.map(async X=>V.emitOne(await X)))})}static merge(O){return new F(async V=>{await Promise.all(O.map(async X=>{for await(const G of X)V.emitOne(G)}))})}static{this.EMPTY=F.fromArray([])}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new k.$Sd,queueMicrotask(async()=>{const V={emitOne:X=>this.g(X),emitMany:X=>this.h(X),reject:X=>this.k(X)};try{await Promise.resolve(O(V)),this.j()}catch(X){this.k(X)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(O,V){return new F(async X=>{for await(const G of O)X.emitOne(V(G))})}map(O){return F.map(this,O)}static filter(O,V){return new F(async X=>{for await(const G of O)V(G)&&X.emitOne(G)})}filter(O){return F.filter(this,O)}static coalesce(O){return F.filter(O,V=>!!V)}coalesce(){return F.coalesce(this)}static async toPromise(O){const V=[];for await(const X of O)V.push(X);return V}toPromise(){return F.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.$oh=F;class ne extends F{constructor(O,V){super(V),this.l=O}cancel(){this.l.cancel()}}e.$ph=ne;function j(N){const O=new w.$3d,V=N(O.token);return new ne(O,async X=>{const G=O.token.onCancellationRequested(()=>{G.dispose(),O.dispose(),X.reject(new L.$5)});try{for await(const re of V){if(O.token.isCancellationRequested)return;X.emitOne(re)}G.dispose(),O.dispose()}catch(re){G.dispose(),O.dispose(),X.reject(re)}})}e.$qh=j;class Y{constructor(){this.a=new q,this.b=new F(X=>{if(O){X.reject(O);return}return V&&X.emitMany(V),this.d=G=>X.reject(G),this.f=G=>X.emitOne(G),this.a.p});let O,V;this.f=X=>{V||(V=[]),V.push(X)},this.d=X=>{O||(O=X)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$rh=Y}),define(le[60],he([0,1,18,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function k(g){return g.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const s=this.a.transformIncoming(y);return s===y?y:k(L.URI.from(s))}transformOutgoing(y){const s=this.a.transformOutgoing(y);return s===y?y:k(L.URI.from(s))}transformOutgoingURI(y){const s=this.a.transformOutgoing(y);return s===y?y:L.URI.from(s)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Xm=M,e.$Ym=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function R(g,y,s){if(!g||s>200)return null;if(typeof g=="object"){if(g instanceof L.URI)return y.transformOutgoing(g);for(const m in g)if(Object.hasOwnProperty.call(g,m)){const h=R(g[m],y,s+1);h!==null&&(g[m]=h)}}return null}function E(g,y){const s=R(g,y,0);return s===null?g:s}e.$Zm=E;function f(g,y,s,m){if(!g||m>200)return null;if(typeof g=="object"){if(g.$mid===1)return s?L.URI.revive(y.transformIncoming(g)):y.transformIncoming(g);if(g instanceof w.$ge)return null;for(const h in g)if(Object.hasOwnProperty.call(g,h)){const a=f(g[h],y,s,m+1);a!==null&&(g[h]=a)}}return null}function u(g,y){const s=f(g,y,!1,0);return s===null?g:s}e.$1m=u;function S(g,y){const s=f(g,y,!0,0);return s===null?g:s}e.$2m=S}),define(le[24],he([0,1,103,20,104,9,32,45,7,3,23,5]),function(oe,e,w,L,k,M,R,E,f,u,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function s(Q,se=y.UNLINK,ue){if((0,R.$6f)(Q))throw new Error("rimraf - will refuse to recursively delete root");return se===y.UNLINK?h(Q):m(Q,ue)}async function m(Q,se=(0,R.$$f)((0,L.tmpdir)())){try{try{await w.promises.rename(Q,se)}catch(ue){return ue.code==="ENOENT"?void 0:h(Q)}h(se).catch(ue=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function h(Q){return(0,k.promisify)(w.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function a(Q){if((0,R.$6f)(Q))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function r(Q,se){return l(await(se?n(Q):(0,k.promisify)(w.readdir)(Q)))}async function n(Q){try{return await(0,k.promisify)(w.readdir)(Q,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const se=[],ue=await r(Q);for(const fe of ue){let J=!1,B=!1,Z=!1;try{const te=await e.Promises.lstat((0,f.$jc)(Q,fe));J=te.isFile(),B=te.isDirectory(),Z=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}se.push({name:fe,isFile:()=>J,isDirectory:()=>B,isSymbolicLink:()=>Z})}return se}function i(Q){return l(w.readdirSync(Q))}e.readdirSync=i;function l(Q){return Q.map(se=>typeof se=="string"?u.$j?(0,E.$Al)(se):se:(se.name=u.$j?(0,E.$Al)(se.name):se.name,se))}async function t(Q){const se=await r(Q),ue=[];for(const fe of se)await p.existsDirectory((0,f.$jc)(Q,fe))&&ue.push(fe);return ue}function o(Q,se=1e3){return new Promise(ue=>{let fe=!1;const J=setInterval(()=>{fe||(fe=!0,w.access(Q,B=>{fe=!1,B&&(clearInterval(J),ue(void 0))}))},se)})}e.whenDeleted=o;var p;(function(Q){async function se(J){let B;try{if(B=await e.Promises.lstat(J),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(u.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw te}throw Z}}Q.stat=se;async function ue(J){try{const{stat:B,symbolicLink:Z}=await Q.stat(J);return B.isFile()&&Z?.dangling!==!0}catch{}return!1}Q.existsFile=ue;async function fe(J){try{const{stat:B,symbolicLink:Z}=await Q.stat(J);return B.isDirectory()&&Z?.dangling!==!0}catch{}return!1}Q.existsDirectory=fe})(p||(e.SymlinkSupport=p={}));const I=new M.$0g;function b(Q,se,ue){return I.queueFor(g.URI.file(Q),S.$tg).queue(()=>{const fe=W(ue);return new Promise((J,B)=>D(Q,se,fe,Z=>Z?B(Z):J()))})}let C=!0;function v(Q){C=Q}e.configureFlushOnWrite=v;function D(Q,se,ue,fe){if(!C)return w.writeFile(Q,se,{mode:ue.mode,flag:ue.flag},fe);w.open(Q,ue.flag,ue.mode,(J,B)=>{if(J)return fe(J);w.writeFile(B,se,Z=>{if(Z)return w.close(B,()=>fe(Z));w.fdatasync(B,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),v(!1)),w.close(B,q=>fe(q))))})})}function H(Q,se,ue){const fe=W(ue);if(!C)return w.writeFileSync(Q,se,{mode:fe.mode,flag:fe.flag});const J=w.openSync(Q,fe.flag,fe.mode);try{w.writeFileSync(J,se);try{w.fdatasyncSync(J)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),v(!1)}}finally{w.closeSync(J)}}e.writeFileSync=H;function W(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function c(Q,se,ue=6e4){if(Q!==se)try{u.$i&&typeof ue=="number"?await $(Q,se,Date.now(),ue):await(0,k.promisify)(w.rename)(Q,se)}catch(fe){if(Q.toLowerCase()!==se.toLowerCase()&&fe.code==="EXDEV"||Q.endsWith("."))await P(Q,se,{preserveSymlinks:!1}),await s(Q,y.MOVE);else throw fe}}async function $(Q,se,ue,fe,J=0){try{return await(0,k.promisify)(w.rename)(Q,se)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-ue>=fe)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${B}`),B;if(J===0){let Z=!1;try{const{stat:te}=await p.stat(se);te.isFile()||(Z=!0)}catch{}if(Z)throw B}return await(0,M.$2g)(Math.min(100,J*10)),$(Q,se,ue,fe,J+1)}}async function P(Q,se,ue){return A(Q,se,{root:{source:Q,target:se},options:ue,handledSourcePaths:new Set})}const T=511;async function A(Q,se,ue){if(ue.handledSourcePaths.has(Q))return;ue.handledSourcePaths.add(Q);const{stat:fe,symbolicLink:J}=await p.stat(Q);if(J){if(ue.options.preserveSymlinks)try{return await ie(Q,se,ue)}catch{}if(J.dangling)return}return fe.isDirectory()?z(Q,se,fe.mode&T,ue):ee(Q,se,fe.mode&T)}async function z(Q,se,ue,fe){await e.Promises.mkdir(se,{recursive:!0,mode:ue});const J=await r(Q);for(const B of J)await A((0,f.$jc)(Q,B),(0,f.$jc)(se,B),fe)}async function ee(Q,se,ue){await e.Promises.copyFile(Q,se),await e.Promises.chmod(se,ue)}async function ie(Q,se,ue){let fe=await e.Promises.readlink(Q);(0,R.$3f)(fe,ue.root.source,!u.$k)&&(fe=(0,f.$jc)(ue.root.target,fe.substr(ue.root.source.length+1))),await e.Promises.symlink(fe,se)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(Q,se,ue,fe,J)=>new Promise((B,Z)=>{w.read(Q,se,ue,fe,J,(te,q,_)=>te?Z(te):B({bytesRead:q,buffer:_}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(Q,se,ue,fe,J)=>new Promise((B,Z)=>{w.write(Q,se,ue,fe,J,(te,q,_)=>te?Z(te):B({bytesWritten:q,buffer:_}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return r}get readDirsInDir(){return t}get writeFile(){return b}get rm(){return s}get rename(){return c}get copy(){return P}}}),define(le[61],he([0,1,20,7,24]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=void 0;const M=/^\d+$/,R=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var f;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class g{constructor(t,o,p){this.exePath=t,this.displayName=o,this.a=p}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:l=!1}={}){return l?u===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function s({useAlternateBitness:l=!1,findPreview:t=!1}={}){const o=y({useAlternateBitness:l});if(!o)return null;const p=L.$jc(o,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(p))return null;let I=-1,b=null;for(const D of await k.Promises.readdir(p)){let H=-1;if(t){const c=D.indexOf("-");if(c<0)continue;const $=D.substring(0,c);if(!M.test($)||D.substring(c+1)!=="preview")continue;H=parseInt($,10)}else{if(!M.test(D))continue;H=parseInt(D,10)}if(H<=I)continue;const W=L.$jc(p,D,"pwsh.exe");await k.SymlinkSupport.existsFile(W)&&(b=W,I=H)}if(!b)return null;const C=o.includes("x86")?" (x86)":"",v=t?" Preview":"";return new g(b,`PowerShell${v}${C}`,!0)}async function m({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const t=L.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:o,pwshMsixName:p}=l?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const I of await k.Promises.readdir(t))if(o.test(I)){const b=L.$jc(t,I,"pwsh.exe");return new g(b,p)}return null}function h(){const l=L.$jc(w.homedir(),".dotnet","tools","pwsh.exe");return new g(l,".NET Core PowerShell Global Tool")}function a(){const l=L.$jc(process.env.windir,u===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(l,"Windows PowerShell",!0)}async function*r(){let l=await s();l&&(yield l),l=await s({useAlternateBitness:!0}),l&&(yield l),l=await m(),l&&(yield l),l=h(),l&&(yield l),l=await s({findPreview:!0}),l&&(yield l),l=await m({findPreview:!0}),l&&(yield l),l=await s({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=a(),l&&(yield l)}async function*n(){for await(const l of r())await l.exists()&&(yield l)}e.$Jl=n;async function i(){for await(const l of n())return l;return null}e.$Kl=i}),define(le[34],he([0,1,7,3,15,33,8,24]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(g=k.env){return g.comspec||"cmd.exe"}e.$Nl=f;function u(g){let y=[],s=!1;const m=function(h){if(s){y.push(h);return}(!g.send(h,r=>{if(r&&console.error(r),s=!1,y.length>0){const n=y.slice(0);y=[],n.forEach(i=>m(i))}})||L.$i)&&(s=!0)};return{send:m}}e.$Ol=u;var S;(function(g){async function y(s,m,h){if(w.$ic(s))return s;if(m===void 0&&(m=k.cwd()),w.$mc(s)!=="."||(h===void 0&&R.$Df(k.env.PATH)&&(h=k.env.PATH.split(w.$tc)),h===void 0||h.length===0))return w.$jc(m,s);async function r(n){if(await E.Promises.exists(n)){let i;try{i=await E.Promises.stat(n)}catch(l){l.message.startsWith("EACCES")&&(i=await E.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(w.$ic(n)?i=w.$jc(n,s):i=w.$jc(m,n,s),await r(i))return i;let l=i+".com";if(await r(l)||(l=i+".exe",await r(l)))return l}return w.$jc(m,s)}g.findExecutable=y})(S||(e.win32=S={}))}),define(le[62],he([0,1,26,19]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;function k(R){return new Promise((E,f)=>{let u;const S=new Map;function g(s,m,h,a,r){const n=S.get(m);if(s===R||n){const i={name:y(h),cmd:h,pid:s,ppid:m,load:a,mem:r};S.set(s,i),s===R&&(u=i),n&&(n.children||(n.children=[]),n.children.push(i),n.children.length>1&&(n.children=n.children.sort((l,t)=>l.pid-t.pid)))}}function y(s){const m=/--utility-sub-type=network/i,h=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,r=/\\pipe\\winpty-control/i,n=/conhost\.exe.+--headless/i,i=/--type=([a-zA-Z-]+)/;if(a.exec(s))return"electron-crash-reporter";if(r.exec(s))return"winpty-agent";if(n.exec(s))return"conpty-agent";let l=i.exec(s);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?m.exec(s)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const t=/[a-zA-Z-]+\.js/g;let o="";do l=t.exec(s),l&&(o+=l+" ");while(l);return o&&s.indexOf("node ")<0&&s.indexOf("node.exe")<0?`electron-nodejs (${o})`:h.exec(s)?`electron-nodejs (${s})`:s}if(process.platform==="win32"){const s=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,h)=>{oe(["@vscode/windows-process-tree"],m,h)}).then(m=>{m.getProcessList(R,h=>{if(!h){f(new Error(`Root process ${R} not found`));return}m.getProcessCpuUsage(h,a=>{const r=new Map;a.forEach(n=>{const i=s(n.commandLine||"");r.set(n.pid,{name:y(i),cmd:i,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),u=r.get(R),u?(r.forEach(n=>{const i=r.get(n.ppid);i&&(i.children||(i.children=[]),i.children.push(n))}),r.forEach(n=>{n.children&&(n.children=n.children.sort((i,l)=>i.pid-l.pid))}),E(u)):f(new Error(`Root process ${R} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let s=function(){let m=[u];const h=[];for(;m.length;){const r=m.shift();r&&(h.push(r.pid),r.children&&(m=m.concat(r.children)))}let a=JSON.stringify(L.$jg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+h.join(" "),(0,w.exec)(a,{},(r,n,i)=>{if(r||i)f(r||new Error(i.toString()));else{const l=n.toString().split(`
`);for(let t=0;t<h.length;t++){const o=S.get(h[t]);o.load=parseFloat(l[t])}if(!u){f(new Error(`Root process ${R} not found`));return}E(u)}})};(0,w.exec)("which ps",{},(m,h,a)=>{if(m||a)if(process.platform!=="linux")f(m||new Error(a.toString()));else{const r=JSON.stringify(L.$jg.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(r,{},(n,i,l)=>{n||l?f(n||new Error(l.toString())):(M(i,g),s())})}else{const r=h.toString().trim(),n="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${r} ${n}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(i,l,t)=>{i||t&&!t.includes("screen size is bogus")?f(i||new Error(t.toString())):(M(l,g),process.platform==="linux"?s():u?E(u):f(new Error(`Root process ${R} not found`)))})}})}})}e.$Or=k;function M(R,E){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=R.toString().split(`
`);for(const S of u){const g=f.exec(S.trim());g&&g.length===6&&E(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(le[63],he([0,1,20,3,61,34]),function(oe,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0;async function R(g,y){return g===1?L.$i?S():M.$Nl(y):f(g,y)}e.$Pl=R;let E=null;function f(g,y){if(L.$k&&g===2||L.$j&&g===3)return"/bin/bash";if(!E){let s;if(L.$i)s="/bin/bash";else{if(s=y.SHELL,!s)try{s=(0,w.userInfo)().shell}catch{}s||(s="sh"),s==="/bin/false"&&(s="/bin/bash")}E=s}return E}let u=null;async function S(){return u||(u=(await(0,k.$Kl)()).exePath),u}});var $e=this&&this.__decorate||function(oe,e,w,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(oe,e,w,L);else for(var E=oe.length-1;E>=0;E--)(R=oe[E])&&(M=(k<3?R(M):k>3?R(e,w,M):R(e,w))||M);return k>3&&M&&Object.defineProperty(e,w,M),M};define(le[27],he([0,1,16,9,18,17,14,6,4,2,59,11,8]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.ProxyChannel=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.RequestInitiator=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0;var s;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(s||(s={}));function m(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(h||(h={}));function a(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var r;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(r||(r={}));function n(J){let B=0;for(let Z=0;;Z+=7){const te=J.read(1);if(B|=(te.buffer[0]&127)<<Z,!(te.buffer[0]&128))return B}}const i=I(0);function l(J,B){if(B===0){J.write(i);return}let Z=0;for(let q=B;q!==0;q=q>>>7)Z++;const te=k.$ge.alloc(Z);for(let q=0;B!==0;q++)te.buffer[q]=B&127,B=B>>>7,B>0&&(te.buffer[q]|=128);J.write(te)}class t{constructor(B){this.b=B,this.a=0}read(B){const Z=this.b.slice(this.a,this.a+B);return this.a+=Z.byteLength,Z}}e.$yh=t;class o{constructor(){this.a=[]}get buffer(){return k.$ge.concat(this.a)}write(B){this.a.push(B)}}e.$zh=o;var p;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(p||(p={}));function I(J){const B=k.$ge.alloc(1);return B.writeUInt8(J,0),B}const b={Undefined:I(p.Undefined),String:I(p.String),Buffer:I(p.Buffer),VSBuffer:I(p.VSBuffer),Array:I(p.Array),Object:I(p.Object),Uint:I(p.Int)},C=typeof Buffer<"u";function v(J,B){if(typeof B>"u")J.write(b.Undefined);else if(typeof B=="string"){const Z=k.$ge.fromString(B);J.write(b.String),l(J,Z.byteLength),J.write(Z)}else if(C&&Buffer.isBuffer(B)){const Z=k.$ge.wrap(B);J.write(b.Buffer),l(J,Z.byteLength),J.write(Z)}else if(B instanceof k.$ge)J.write(b.VSBuffer),l(J,B.byteLength),J.write(B);else if(Array.isArray(B)){J.write(b.Array),l(J,B.length);for(const Z of B)v(J,Z)}else if(typeof B=="number"&&(B|0)===B)J.write(b.Uint),l(J,B);else{const Z=k.$ge.fromString(JSON.stringify(B));J.write(b.Object),l(J,Z.byteLength),J.write(Z)}}e.$Ah=v;function D(J){switch(J.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return J.read(n(J)).toString();case p.Buffer:return J.read(n(J)).buffer;case p.VSBuffer:return J.read(n(J));case p.Array:{const Z=n(J),te=[];for(let q=0;q<Z;q++)te.push(D(J));return te}case p.Object:return JSON.parse(J.read(n(J)).toString());case p.Int:return n(J)}}e.$Bh=D;class H{constructor(B,Z,te=null,q=1e3){this.h=B,this.j=Z,this.k=te,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(B,Z){this.b.set(B,Z),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const Z=this.o([B.type]);this.k?.logOutgoing(Z,0,1,a(B.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([B.type,B.id],B.data);this.k?.logOutgoing(Z,B.id,1,a(B.type),B.data);return}}}o(B,Z=void 0){const te=new o;return v(te,B),v(te,Z),this.p(te.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const Z=new t(B),te=D(Z),q=D(Z),_=te[0];switch(_){case 100:return this.k?.logIncoming(B.byteLength,te[1],1,`${m(_)}: ${te[2]}.${te[3]}`,q),this.s({type:_,id:te[1],channelName:te[2],name:te[3],arg:q});case 102:return this.k?.logIncoming(B.byteLength,te[1],1,`${m(_)}: ${te[2]}.${te[3]}`,q),this.t({type:_,id:te[1],channelName:te[2],name:te[3],arg:q});case 101:return this.k?.logIncoming(B.byteLength,te[1],1,`${m(_)}`),this.u({type:_,id:te[1]});case 103:return this.k?.logIncoming(B.byteLength,te[1],1,`${m(_)}`),this.u({type:_,id:te[1]})}}s(B){const Z=this.b.get(B.channelName);if(!Z){this.v(B);return}const te=new M.$3d;let q;try{q=Z.call(this.j,B.name,B.arg,te.token)}catch(K){q=Promise.reject(K)}const _=B.id;q.then(K=>{this.m({id:_,data:K,type:201})},K=>{K instanceof Error?this.m({id:_,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:_,data:K,type:203})}).finally(()=>{ge.dispose(),this.d.delete(B.id)});const ge=(0,u.$Qc)(()=>te.cancel());this.d.set(B.id,ge)}t(B){const Z=this.b.get(B.channelName);if(!Z){this.v(B);return}const te=B.id,_=Z.listen(this.j,B.name,B.arg)(ge=>this.m({id:te,data:ge,type:204}));this.d.set(B.id,_)}u(B){const Z=this.d.get(B.id);Z&&(Z.dispose(),this.d.delete(B.id))}v(B){let Z=this.g.get(B.channelName);Z||(Z=[],this.g.set(B.channelName,Z));const te=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:B,timeoutTimer:te})}w(B){const Z=this.g.get(B);if(Z){for(const te of Z)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Nc)(this.d.values()),this.d.clear()}}e.$Ch=H;var W;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(W||(e.RequestInitiator=W={}));class c{constructor(B,Z=null){this.l=B,this.a=!1,this.b=r.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=Z}getChannel(B){const Z=this;return{call(te,q,_){return Z.a?Promise.reject(new E.$5):Z.m(B,te,q,_)},listen(te,q){return Z.a?f.Event.None:Z.o(B,te,q)}}}m(B,Z,te,q=M.CancellationToken.None){const _=this.g++,K={id:_,type:100,channelName:B,name:Z,arg:te};if(q.isCancellationRequested)return Promise.reject(new E.$5);let d;return new Promise((ne,j)=>{if(q.isCancellationRequested)return j(new E.$5);const Y=()=>{const X=G=>{switch(G.type){case 201:this.f.delete(_),ne(G.data);break;case 202:{this.f.delete(_);const re=new Error(G.data.message);re.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,re.name=G.data.name,j(re);break}case 203:this.f.delete(_),j(G.data);break}};this.f.set(_,X),this.p(K)};let N=null;this.b===r.Idle?Y():(N=(0,L.$Og)(X=>this.u()),N.then(()=>{N=null,Y()}));const O=()=>{N?(N.cancel(),N=null):this.p({id:_,type:101}),j(new E.$5)},V=q.onCancellationRequested(O);d=(0,u.$Pc)((0,u.$Qc)(O),V),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(B,Z,te){const q=this.g++,ge={id:q,type:102,channelName:B,name:Z,arg:te};let K=null;const d=new f.$Sd({onWillAddFirstListener:()=>{K=(0,L.$Og)(ne=>this.u()),K.then(()=>{K=null,this.d.add(d),this.p(ge)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(d),this.p({id:q,type:103}))}}),F=ne=>d.fire(ne.data);return this.f.set(q,F),d.event}p(B){switch(B.type){case 100:case 102:{const Z=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(Z,B.id,0,`${m(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Z=this.q([B.type,B.id]);this.j?.logOutgoing(Z,B.id,0,m(B.type));return}}}q(B,Z=void 0){const te=new o;return v(te,B),v(te,Z),this.r(te.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const Z=new t(B),te=D(Z),q=D(Z),_=te[0];switch(_){case 200:return this.j?.logIncoming(B.byteLength,0,0,a(_)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,te[1],0,a(_),q),this.t({type:te[0],id:te[1],data:q})}}t(B){if(B.type===200){this.b=r.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===r.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=c,$e([R.$sh],c.prototype,"onDidInitializePromise",null);class ${get connections(){const B=[];return this.f.forEach(Z=>B.push(Z)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new f.$Sd,this.onDidAddConnection=this.g.event,this.h=new f.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new u.$Rc,this.j.add(B(({protocol:Z,onDidClientDisconnect:te})=>{const q=f.Event.once(Z.onMessage);this.j.add(q(_=>{const ge=new t(_),K=D(ge),d=new H(Z,K),F=new c(Z);this.a.forEach((j,Y)=>d.registerChannel(Y,j));const ne={channelServer:d,channelClient:F,ctx:K};this.f.add(ne),this.g.fire(ne),this.j.add(te(()=>{d.dispose(),F.dispose(),this.f.delete(ne),this.h.fire(ne)}))}))}))}getChannel(B,Z){const te=this;return{call(q,_,ge){let K;if((0,y.$Rf)(Z)){const F=(0,w.$4b)(te.connections.filter(Z));K=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(te.onDidAddConnection,Z))}else K=Z.routeCall(te,q,_);const d=K.then(F=>F.channelClient.getChannel(B));return T(d).call(q,_,ge)},listen(q,_){if((0,y.$Rf)(Z))return te.k(B,Z,q,_);const ge=Z.routeEvent(te,q,_).then(K=>K.channelClient.getChannel(B));return T(ge).listen(q,_)}}}k(B,Z,te,q){const _=this;let ge;const K=new f.$Sd({onWillAddFirstListener:()=>{ge=new u.$Rc;const d=new f.$Yd,F=new Map,ne=Y=>{const O=Y.channelClient.getChannel(B).listen(te,q),V=d.add(O);F.set(Y,V)},j=Y=>{const N=F.get(Y);N&&(N.dispose(),F.delete(Y))};_.connections.filter(Z).forEach(ne),f.Event.filter(_.onDidAddConnection,Z)(ne,void 0,ge),_.onDidRemoveConnection(j,void 0,ge),d.event(K.fire,K,ge),ge.add(d)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return K.event}registerChannel(B,Z){this.a.set(B,Z);for(const te of this.f)te.channelServer.registerChannel(B,Z)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Eh=$;class P{constructor(B,Z,te=null){const q=new o;v(q,Z),B.send(q.buffer),this.a=new c(B,te),this.d=new H(B,Z,te)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,Z){this.d.registerChannel(B,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Fh=P;function T(J){return{call(B,Z,te){return J.then(q=>q.call(B,Z,te))},listen(B,Z){const te=new f.$2d;return J.then(q=>te.input=q.listen(B,Z)),te.event}}}e.$Gh=T;function A(J){let B=!1;return{call(Z,te,q){return B?J.call(Z,te,q):(0,L.$2g)(0).then(()=>B=!0).then(()=>J.call(Z,te,q))},listen(Z,te){if(B)return J.listen(Z,te);const q=new f.$2d;return(0,L.$2g)(0).then(()=>B=!0).then(()=>q.input=J.listen(Z,te)),q.event}}}e.$Hh=A;class z{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const Z of B.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await f.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$Ih=z;var ee;(function(J){function B(_,ge,K){const d=_,F=K&&K.disableMarshalling,ne=new Map;for(const j in d)te(j)&&ne.set(j,f.Event.buffer(d[j],!0,void 0,ge));return new class{listen(j,Y,N){const O=ne.get(Y);if(O)return O;if(q(Y)){const V=d[Y];if(typeof V=="function")return V.call(d,N)}throw new E.$bb(`Event not found: ${Y}`)}call(j,Y,N){const O=d[Y];if(typeof O=="function"){if(!F&&Array.isArray(N))for(let X=0;X<N.length;X++)N[X]=(0,S.$xh)(N[X]);let V=O.apply(d,N);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new E.$bb(`Method not found: ${Y}`)}}}J.fromService=B;function Z(_,ge){const K=ge&&ge.disableMarshalling;return new Proxy({},{get(d,F){if(typeof F=="string")return ge?.properties?.has(F)?ge.properties.get(F):q(F)?function(ne){return _.listen(F,ne)}:te(F)?_.listen(F):async function(...ne){let j;ge&&!(0,y.$Mf)(ge.context)?j=[ge.context,...ne]:j=ne;const Y=await _.call(F,j);return K?Y:(0,S.$xh)(Y)};throw new E.$bb(`Property not found: ${String(F)}`)}})}J.toService=Z;function te(_){return _[0]==="o"&&_[1]==="n"&&g.$6e(_.charCodeAt(2))}function q(_){return/^onDynamic/.test(_)&&g.$6e(_.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const B=J.toString();if(B!=="[object Object]")return B}return J}function se(J){return Array.isArray(J)?J.map(Q):Q(J)}function ue(J,B,Z,te,q,_,ge){ge=se(ge);const K=ie[q],d=K[te%K.length];let F=[`%c[${J}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(_)?(F=F.concat(ge),F.push(")")):F.push(ge),console.log.apply(console,F)}class fe{constructor(B,Z){this.d=B,this.f=Z,this.a=0,this.b=0}logOutgoing(B,Z,te,q,_){this.b+=B,ue(this.d,this.b,B,Z,te,q,_)}logIncoming(B,Z,te,q,_){this.a+=B,ue(this.f,this.a,B,Z,te,q,_)}}e.$Jh=fe}),define(le[64],he([0,1,26,9,18,17,58,6,4,2,30,34,33,27]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class m extends s.$Ch{constructor(r){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",n=>k.$ge.wrap(Buffer.from(n,"base64")))},r),process.once("disconnect",()=>this.dispose())}}e.$bq=m;class h{constructor(r,n){this.i=r,this.j=n,this.c=new Set,this.g=new Map,this.h=new f.$Sd,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$Xg(i),this.d=null,this.f=null}getChannel(r){const n=this;return{call(i,l,t){return n.k(r,i,l,t)},listen(i,l){return n.l(r,i,l)}}}k(r,n,i,l=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const t=this.n(r),o=(0,L.$Og)(b=>t.call(n,i,b)),p=l.onCancellationRequested(()=>o.cancel()),I=(0,u.$Qc)(()=>o.cancel());return this.c.add(I),o.finally(()=>{p.dispose(),this.c.delete(I),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l(r,n,i){if(!this.b)return f.Event.None;this.b.cancel();let l;const t=new f.$Sd({onWillAddFirstListener:()=>{l=this.n(r).listen(n,i)(t.fire,t),this.c.add(l)},onDidRemoveLastListener:()=>{this.c.delete(l),l.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const r=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,S.$gn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(C=>!/^--inspect(-brk)?=/.test(C)).filter(C=>!C.startsWith("--vscode-"))),(0,y.$Ml)(n.env),this.d=(0,w.fork)(this.i,r,n);const i=new f.$Sd;f.Event.fromNodeEventEmitter(this.d,"message",C=>C)(C=>{if((0,R.$0p)(C)){(0,R.log)(C,`IPC Library: ${this.j.serverName}`);return}i.fire(k.$ge.wrap(Buffer.from(C,"base64")))});const t=this.j.useQueue?(0,g.$Ol)(this.d):this.d,o=C=>this.d&&this.d.connected&&t.send(C.buffer.toString("base64")),p=i.event,I={send:o,onMessage:p};this.f=new s.$Dh(I);const b=()=>this.o();process.once("exit",b),this.d.on("error",C=>console.warn('IPC "'+this.j.serverName+'" errored with '+C)),this.d.on("exit",(C,v)=>{process.removeListener("exit",b),this.c.forEach(D=>(0,u.$Nc)(D)),this.c.clear(),C!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+C+" and signal "+v),this.b?.cancel(),this.o(),this.h.fire({code:C,signal:v})})}return this.f}n(r){let n=this.g.get(r);return n||(n=this.m.getChannel(r),this.g.set(r,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cq=h}),define(le[65],he([0,1,31,18,27,4,8,16]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=e.$pU=void 0;class f{constructor(y){this.a=y,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",s=>L.$ge.wrap(s.data)),y.start()}send(y){this.a.postMessage(y.buffer)}disconnect(){this.a.close()}}class u extends k.$Eh{static b(y){(0,R.$Nf)((0,w.$oU)(process),"Electron Utility Process");const s=new M.$Sd;return process.parentPort.on("message",m=>{if(y?.handledClientConnection(m))return;const h=(0,E.$Ob)(m.ports);h&&s.fire(h)}),M.Event.map(s.event,m=>({protocol:new f(m),onDidClientDisconnect:M.Event.fromNodeEventEmitter(m,"close")}))}constructor(y){super(u.b(y))}}e.$pU=u;function S(g,y,s){const m=h=>{h.data===y&&(g.removeListener("message",m),s())};g.on("message",m)}e.$qU=S}),define(le[66],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(le[67],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(le[68],he([13,12]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(le[69],he([13,12]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(le[70],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(le[71],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(le[72],he([0,1,6,67]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var k;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(k||(e.TokenType=k={}));function M(...u){switch(u.length){case 1:return(0,L.localize)(0,null,u[0]);case 2:return(0,L.localize)(1,null,u[0],u[1]);case 3:return(0,L.localize)(2,null,u[0],u[1],u[2]);default:return}}const R=(0,L.localize)(3,null),E=(0,L.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,w.$8)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const g=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:g})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const g=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:g})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const g=this.d,y=this.c.substring(this.d,this.e),s={type:19,offset:this.d,lexeme:y};this.g.push({offset:g,lexeme:y,additionalInfo:S}),this.f.push(s)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const g=this.c.substring(this.d,this.e),y=f.b.get(g);y?this.k(y):this.f.push({type:17,lexeme:g,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,g=!1,y=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(E);return}const m=this.c.charCodeAt(S);if(g)g=!1;else if(m===47&&!y){S++;break}else m===91?y=!0:m===92?g=!0:m===93&&(y=!1);S++}for(;S<this.c.length&&f.a.has(this.c.charCodeAt(S));)S++;this.e=S;const s=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:s,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=f}),define(le[73],he([0,1,54,14,19,7,15,23,5]),function(oe,e,w,L,k,M,R,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=void 0,e.$rm=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,M.$mc)(k.$jg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Cg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Cg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const s=(0,w.$qm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",s)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Cg)(f.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Cg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Cg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Cg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const s=R.env.VSCODE_PORTABLE;return s?f.URI.file((0,M.$jc)(s,"argv.json")):(0,E.$Cg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const s=this.args["builtin-extensions-dir"];return s?(0,M.$kc)(s):(0,M.$hc)((0,M.$jc)(k.$jg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const s=this.args["extensions-download-dir"];return s?f.URI.file((0,M.$kc)(s)):f.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const s=this.args["extensions-dir"];if(s)return(0,M.$kc)(s);const m=R.env.VSCODE_EXTENSIONS;if(m)return m;const h=R.env.VSCODE_PORTABLE;return h?(0,M.$jc)(h,"extensions"):(0,E.$Cg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const s=this.args.extensionDevelopmentPath;if(Array.isArray(s))return s.map(m=>/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,M.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(s=>s==="ui"||s==="workspace"||s==="web"?s:"workspace")}get extensionTestsLocationURI(){const s=this.args.extensionTestsPath;if(s)return/^[^:/?#]+?:\/\//.test(s)?f.URI.parse(s):f.URI.file((0,M.$hc)(s))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const s=this.args["disable-extension"];if(s){if(typeof s=="string")return[s];if(Array.isArray(s)&&s.length>0)return s}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(s=>!e.$rm.test(s))}get extensionLogLevel(){const s=[];for(const m of this.args.log||[]){const h=e.$rm.exec(m);h&&h[1]&&h[2]&&s.push([h[1],h[2]])}return s.length?s:void 0}get serviceMachineIdResource(){return(0,E.$Cg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const s=R.env.VSCODE_PORTABLE;return s?f.URI.file((0,M.$jc)(s,"policy.json")):(0,E.$Cg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(s){this.args.continueOn=s}get args(){return this.a}constructor(s,m,h){this.a=s,this.b=m,this.c=h,this.editSessionId=this.args.editSessionId}}e.$sm=u,$e([L.$sh],u.prototype,"appRoot",null),$e([L.$sh],u.prototype,"userHome",null),$e([L.$sh],u.prototype,"userDataPath",null),$e([L.$sh],u.prototype,"appSettingsHome",null),$e([L.$sh],u.prototype,"tmpDir",null),$e([L.$sh],u.prototype,"cacheHome",null),$e([L.$sh],u.prototype,"stateResource",null),$e([L.$sh],u.prototype,"userRoamingDataHome",null),$e([L.$sh],u.prototype,"userDataSyncHome",null),$e([L.$sh],u.prototype,"sync",null),$e([L.$sh],u.prototype,"machineSettingsResource",null),$e([L.$sh],u.prototype,"workspaceStorageHome",null),$e([L.$sh],u.prototype,"localHistoryHome",null),$e([L.$sh],u.prototype,"keyboardLayoutResource",null),$e([L.$sh],u.prototype,"argvResource",null),$e([L.$sh],u.prototype,"isExtensionDevelopment",null),$e([L.$sh],u.prototype,"untitledWorkspacesHome",null),$e([L.$sh],u.prototype,"builtinExtensionsPath",null),$e([L.$sh],u.prototype,"extensionsPath",null),$e([L.$sh],u.prototype,"extensionDevelopmentLocationURI",null),$e([L.$sh],u.prototype,"extensionDevelopmentKind",null),$e([L.$sh],u.prototype,"extensionTestsLocationURI",null),$e([L.$sh],u.prototype,"debugExtensionHost",null),$e([L.$sh],u.prototype,"logLevel",null),$e([L.$sh],u.prototype,"extensionLogLevel",null),$e([L.$sh],u.prototype,"serviceMachineIdResource",null),$e([L.$sh],u.prototype,"disableTelemetry",null),$e([L.$sh],u.prototype,"disableWorkspaceTrust",null),$e([L.$sh],u.prototype,"useInMemorySecretStorage",null),$e([L.$sh],u.prototype,"policyFile",null);function S(y,s){return g(y["inspect-extensions"],y["inspect-brk-extensions"],5870,s,y.debugId,y.extensionEnvironment)}e.$tm=S;function g(y,s,m,h,a,r){const i=Number(s||y)||(h?null:m),l=i?!!s:!1;let t;if(r)try{t=JSON.parse(r)}catch{}return{port:i,break:l,debugId:a,env:t}}e.$um=g}),define(le[74],he([0,1,105,3,68]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$Ql=["tunnel","serve-web"],e.$Rl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(h,a,r=R){const n=h.find(v=>v.length>0&&v[0]!=="-"),i={},l=["_"],t=[],o={};let p;for(const v in a){const D=a[v];D.type==="subcommand"?v===n&&(p=D):(D.alias&&(i[v]=D.alias),D.type==="string"||D.type==="string[]"?(l.push(v),D.deprecates&&l.push(...D.deprecates)):D.type==="boolean"&&(t.push(v),D.deprecates&&t.push(...D.deprecates)),D.global&&(o[v]=D))}if(p&&n){const v=o;for(const c in p.options)v[c]=p.options[c];const D=h.filter(c=>c!==n),H=r.getSubcommandReporter?r.getSubcommandReporter(n):void 0,W=E(D,v,H);return{[n]:W,_:[]}}const I=w(h,{string:l,boolean:t,alias:i}),b={},C=I;b._=I._.map(v=>String(v)).filter(v=>v.length>0),delete C._;for(const v in a){const D=a[v];if(D.type==="subcommand")continue;D.alias&&delete C[D.alias];let H=C[v];if(D.deprecates)for(const W of D.deprecates)C.hasOwnProperty(W)&&(H||(H=C[W],H&&r.onDeprecatedOption(W,D.deprecationMessage||(0,k.localize)(37,null,v))),delete C[W]);if(typeof H<"u"){if(D.type==="string[]"){if(Array.isArray(H)||(H=[H]),!D.allowEmptyValue){const W=H.filter(c=>c.length>0);W.length!==H.length&&(r.onEmptyValue(v),H=W.length>0?W:void 0)}}else D.type==="string"&&(Array.isArray(H)?(H=H.pop(),r.onMultipleValues(v,H)):!H&&!D.allowEmptyValue&&(r.onEmptyValue(v),H=void 0));b[v]=H,D.deprecationMessage&&r.onDeprecatedOption(v,D.deprecationMessage)}delete C[v]}for(const v in C)r.onUnknownOption(v);return b}e.$Sl=E;function f(h,a){let r="";return a.args&&(Array.isArray(a.args)?r=` <${a.args.join("> <")}>`:r=` <${a.args}>`),a.alias?`-${a.alias} --${h}${r}`:`--${h}${r}`}function u(h,a){const r=[];for(const n in h){const i=h[n],l=f(n,i);r.push([l,i.description])}return S(r,a)}e.$Tl=u;function S(h,a){const n=h.reduce((t,o)=>Math.max(t,o[0].length),12)+2+1;if(a-n<25)return h.reduce((t,o)=>t.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);const i=a-n-1,l=[];for(const t of h){const o=t[0],p=y(t[1],i),I=g(n-o.length-2);l.push("  "+o+I+p[0]);for(let b=1;b<p.length;b++)l.push(g(n)+p[b])}return l}function g(h){return" ".repeat(h)}function y(h,a){const r=[];for(;h.length;){const n=h.length<a?h.length:h.lastIndexOf(" ",a),i=h.slice(0,n).trim();h=h.slice(n),r.push(i)}return r}function s(h,a,r,n,i){const l=process.stdout.isTTY&&process.stdout.columns||80,t=i?.noInputFiles!==!0?`[${(0,k.localize)(38,null)}...]`:"",o=[`${h} ${r}`];o.push(""),o.push(`${(0,k.localize)(39,null)}: ${a} [${(0,k.localize)(40,null)}]${t}`),o.push(""),i?.noPipe!==!0&&(L.$i?o.push((0,k.localize)(41,null,a)):o.push((0,k.localize)(42,null,a)),o.push(""));const p={},I=[];for(const b in n){const C=n[b];if(C.type==="subcommand")C.description&&I.push({command:b,description:C.description});else if(C.description&&C.cat){let v=p[C.cat];v||(p[C.cat]=v={}),v[b]=C}}for(const b in p){const C=b,v=p[C];v&&(o.push(M[C]),o.push(...u(v,l)),o.push(""))}return I.length&&(o.push((0,k.localize)(43,null)),o.push(...S(I.map(b=>[b.command,b.description]),l)),o.push("")),o.join(`
`)}e.$Ul=s;function m(h,a){return`${h||(0,k.localize)(44,null)}
${a||(0,k.localize)(45,null)}
${process.arch}`}e.$Vl=m}),function(){"use strict";function oe(e,w,L){function k(R,E){const f=M(R,E),u=[f];return e.isAbsolute(f)||u.unshift(L),e.resolve(...u)}function M(R,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,E);const S=R["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(g,"AppData","Roaming")}break;case"darwin":u=e.join(w.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,E)}return{getUserDataPath:k}}if(typeof define=="function")define(le[75],he([76,20,15]),function(e,w,L){return oe(e,w,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[77],he([0,1,20,73,75]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=void 0;class M extends L.$sm{constructor(u,S){super(u,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(u,S.nameShort)},S)}}e.$vm=M;function R(f,u){return(0,L.$um)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.$wm=R;function E(f,u){return(0,L.$um)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.$xm=E}),define(le[21],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var w;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function E(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=E})(w||(e._util=w={})),e.$Zh=k("instantiationService");function L(R,E,f){E[w.DI_TARGET]===E?E[w.DI_DEPENDENCIES].push({id:R,index:f}):(E[w.DI_DEPENDENCIES]=[{id:R,index:f}],E[w.DI_TARGET]=E)}function k(R){if(w.serviceIds.has(R))return w.serviceIds.get(R);const E=function(f,u,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(E,f,S)};return E.toString=()=>R,w.serviceIds.set(R,E),E}e.$1h=k;function M(R){return R}e.$2h=M}),define(le[35],he([0,1,3,11,72,21,66,6]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",w.$j),f.set("isLinux",w.$k),f.set("isWindows",w.$i),f.set("isWeb",w.$o),f.set("isMacNative",w.$j&&!w.$o),f.set("isEdge",w.$H),f.set("isFirefox",w.$F),f.set("isChrome",w.$E),f.set("isSafari",w.$G);function u(K,d){if(f.get(K)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(K,d)}e.$Wi=u;const S=Object.prototype.hasOwnProperty;var g;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const y={regexParsingWithErrorRecovery:!0},s=(0,R.localize)(0,null),m=(0,R.localize)(1,null),h=(0,R.localize)(2,null),a=(0,R.localize)(3,null),r=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),l=(0,R.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=y){this.k=d,this.d=new k.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:s,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const ne=this.D(),j=ne.type===17?n:void 0;throw this.h.push({message:r,offset:ne.offset,lexeme:k.$Vi.getLexeme(ne),additionalInfo:j}),t.c}return F}catch(F){if(F!==t.c)throw F;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const F=this.o();d.push(F)}return d.length===1?d[0]:o.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const F=this.s();d.push(F)}return d.length===1?d[0]:o.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),C.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,a),F?.negate()}case 17:return this.z(),P.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),o.true();case 12:return this.z(),o.false();case 0:{this.z();const F=this.l();return this.A(1,a),F}case 17:{const F=d.lexeme;if(this.z(),this.y(9)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==10)throw this.B("REGEX",j);const Y=j.lexeme,N=Y.lastIndexOf("/"),O=N===Y.length-1?void 0:this.w(Y.substring(N+1));let V;try{V=new RegExp(Y.substring(1,N),O)}catch{throw this.B("REGEX",j)}return Q.create(F,V)}switch(j.type){case 10:case 19:{const Y=[j.lexeme];this.z();let N=this.D(),O=0;for(let ce=0;ce<j.lexeme.length;ce++)j.lexeme.charCodeAt(ce)===40?O++:j.lexeme.charCodeAt(ce)===41&&O--;for(;!this.E()&&N.type!==15&&N.type!==16;){switch(N.type){case 0:O++;break;case 1:O--;break;case 10:case 18:for(let ce=0;ce<N.lexeme.length;ce++)N.lexeme.charCodeAt(ce)===40?O++:j.lexeme.charCodeAt(ce)===41&&O--}if(O<0)break;Y.push(k.$Vi.getLexeme(N)),this.z(),N=this.D()}const V=Y.join(""),X=V.lastIndexOf("/"),G=X===V.length-1?void 0:this.w(V.substring(X+1));let re;try{re=new RegExp(V.substring(1,X),G)}catch{throw this.B("REGEX",j)}return o.regex(F,re)}case 18:{const Y=j.lexeme;this.z();let N=null;if(!(0,L.$Ge)(Y)){const O=Y.indexOf("/"),V=Y.lastIndexOf("/");if(O!==V&&O>=0){const X=Y.slice(O+1,V),G=Y[V+1]==="i"?"i":"";try{N=new RegExp(X,G)}catch{throw this.B("REGEX",j)}}}if(N===null)throw this.B("REGEX",j);return Q.create(F,N)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const j=this.u();return o.notIn(F,j)}switch(this.D().type){case 3:{this.z();const j=this.u();if(this.x().type===18)return o.equals(F,j);switch(j){case"true":return o.has(F);case"false":return o.not(F);default:return o.equals(F,j)}}case 4:{this.z();const j=this.u();if(this.x().type===18)return o.notEquals(F,j);switch(j){case"true":return o.not(F);case"false":return o.has(F);default:return o.notEquals(F,j)}}case 5:return this.z(),ee.create(F,this.u());case 6:return this.z(),ie.create(F,this.u());case 7:return this.z(),A.create(F,this.u());case 8:return this.z(),z.create(F,this.u());case 13:return this.z(),o.in(F,this.u());default:return o.has(F)}}case 20:throw this.h.push({message:i,offset:d.offset,lexeme:"",additionalInfo:l}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,F){if(this.C(d))return this.z();throw this.B(F,this.D())}B(d,F,ne){const j=(0,R.localize)(8,null,d,k.$Vi.getLexeme(F)),Y=F.offset,N=k.$Vi.getLexeme(F);return this.h.push({message:j,offset:Y,lexeme:N,additionalInfo:ne}),t.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=t;class o{static false(){return C.INSTANCE}static true(){return v.INSTANCE}static has(d){return D.create(d)}static equals(d,F){return H.create(d,F)}static notEquals(d,F){return $.create(d,F)}static regex(d,F){return Q.create(d,F)}static in(d,F){return W.create(d,F)}static notIn(d,F){return c.create(d,F)}static not(d){return P.create(d)}static and(...d){return fe.create(d,null,!0)}static or(...d){return J.create(d,null,!0)}static greater(d,F){return A.create(d,F)}static greaterEquals(d,F){return z.create(d,F)}static smaller(d,F){return ee.create(d,F)}static smallerEquals(d,F){return ie.create(d,F)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$Yi=o;function p(K){const d=new t({regexParsingWithErrorRecovery:!1});return K.map(F=>(d.parse(F),d.lexingErrors.length>0?d.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,R.localize)(9,null,ne.additionalInfo):(0,R.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}e.$Zi=p;function I(K,d){const F=K?K.substituteConstants():void 0,ne=d?d.substituteConstants():void 0;return!F&&!ne?!0:!F||!ne?!1:F.equals(ne)}e.$1i=I;function b(K,d){return K.cmp(d)}class C{static{this.INSTANCE=new C}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return v.INSTANCE}}e.$2i=C;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return C.INSTANCE}}e.$3i=v;class D{static create(d,F=null){const ne=f.get(d);return typeof ne=="boolean"?ne?v.INSTANCE:C.INSTANCE:new D(d,F)}constructor(d,F){this.key=d,this.c=F,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=f.get(this.key);return typeof d=="boolean"?d?v.INSTANCE:C.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$4i=D;class H{static create(d,F,ne=null){if(typeof F=="boolean")return F?D.create(d,ne):P.create(d,ne);const j=f.get(d);return typeof j=="boolean"?F===(j?"true":"false")?v.INSTANCE:C.INSTANCE:new H(d,F,ne)}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=f.get(this.c);if(typeof d=="boolean"){const F=d?"true":"false";return this.d===F?v.INSTANCE:C.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$5i=H;class W{static create(d,F){return new W(d,F)}constructor(d,F){this.d=d,this.f=F,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:te(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const F=d.getValue(this.f),ne=d.getValue(this.d);return Array.isArray(F)?F.includes(ne):typeof ne=="string"&&typeof F=="object"&&F!==null?S.call(F,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.$6i=W;class c{static create(d,F){return new c(d,F)}constructor(d,F){this.d=d,this.f=F,this.type=11,this.c=W.create(d,F)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=c;class ${static create(d,F,ne=null){if(typeof F=="boolean")return F?P.create(d,ne):D.create(d,ne);const j=f.get(d);return typeof j=="boolean"?F===(j?"true":"false")?C.INSTANCE:v.INSTANCE:new $(d,F,ne)}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=f.get(this.c);if(typeof d=="boolean"){const F=d?"true":"false";return this.d===F?C.INSTANCE:v.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$8i=$;class P{static create(d,F=null){const ne=f.get(d);return typeof ne=="boolean"?ne?C.INSTANCE:v.INSTANCE:new P(d,F)}constructor(d,F){this.c=d,this.d=F,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:Z(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=f.get(this.c);return typeof d=="boolean"?d?C.INSTANCE:v.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$9i=P;function T(K,d){if(typeof K=="string"){const F=parseFloat(K);isNaN(F)||(K=F)}return typeof K=="string"||typeof K=="number"?d(K):C.INSTANCE}class A{static create(d,F,ne=null){return T(F,j=>new A(d,j,ne))}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$0i=A;class z{static create(d,F,ne=null){return T(F,j=>new z(d,j,ne))}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$$i=z;class ee{static create(d,F,ne=null){return T(F,j=>new ee(d,j,ne))}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$_i=ee;class ie{static create(d,F,ne=null){return T(F,j=>new ie(d,j,ne))}constructor(d,F,ne){this.c=d,this.d=F,this.f=ne,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:te(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$aj=ie;class Q{static create(d,F){return new Q(d,F)}constructor(d,F){this.d=d,this.f=F,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const F=this.f?this.f.source:"",ne=d.f?d.f.source:"";return F<ne?-1:F>ne?1:0}equals(d){if(d.type===this.type){const F=this.f?this.f.source:"",ne=d.f?d.f.source:"";return this.d===d.d&&F===ne}return!1}substituteConstants(){return this}evaluate(d){const F=d.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.$bj=Q;class se{static create(d){return new se(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new se(this.c.map(d))}negate(){return this.c}}e.$cj=se;function ue(K){let d=null;for(let F=0,ne=K.length;F<ne;F++){const j=K[F].substituteConstants();if(K[F]!==j&&d===null){d=[];for(let Y=0;Y<F;Y++)d[Y]=K[Y]}d!==null&&(d[F]=j)}return d===null?K:d}class fe{static create(d,F,ne){return fe.d(d,F,ne)}constructor(d,F){this.expr=d,this.c=F,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let F=0,ne=this.expr.length;F<ne;F++){const j=b(this.expr[F],d.expr[F]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].equals(d.expr[F]))return!1;return!0}return!1}substituteConstants(){const d=ue(this.expr);return d===this.expr?this:fe.create(d,this.c,!1)}evaluate(d){for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].evaluate(d))return!1;return!0}static d(d,F,ne){const j=[];let Y=!1;for(const N of d)if(N){if(N.type===1){Y=!0;continue}if(N.type===0)return C.INSTANCE;if(N.type===6){j.push(...N.expr);continue}j.push(N)}if(j.length===0&&Y)return v.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(b);for(let N=1;N<j.length;N++)j[N-1].equals(j[N])&&(j.splice(N,1),N--);if(j.length===1)return j[0];for(;j.length>1;){const N=j[j.length-1];if(N.type!==9)break;j.pop();const O=j.pop(),V=j.length===0,X=J.create(N.expr.map(G=>fe.create([G,O],null,ne)),null,V);X&&(j.push(X),j.sort(b))}if(j.length===1)return j[0];if(ne){for(let N=0;N<j.length;N++)for(let O=N+1;O<j.length;O++)if(j[N].negate().equals(j[O]))return C.INSTANCE;if(j.length===1)return j[0]}return new fe(j,F)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const F of this.expr)d.push(...F.keys());return d}map(d){return new fe(this.expr.map(F=>F.map(d)),null)}negate(){if(!this.c){const d=[];for(const F of this.expr)d.push(F.negate());this.c=J.create(d,this,!0)}return this.c}}e.$dj=fe;class J{static create(d,F,ne){return J.d(d,F,ne)}constructor(d,F){this.expr=d,this.c=F,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let F=0,ne=this.expr.length;F<ne;F++){const j=b(this.expr[F],d.expr[F]);if(j!==0)return j}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].equals(d.expr[F]))return!1;return!0}return!1}substituteConstants(){const d=ue(this.expr);return d===this.expr?this:J.create(d,this.c,!1)}evaluate(d){for(let F=0,ne=this.expr.length;F<ne;F++)if(this.expr[F].evaluate(d))return!0;return!1}static d(d,F,ne){let j=[],Y=!1;if(d){for(let N=0,O=d.length;N<O;N++){const V=d[N];if(V){if(V.type===0){Y=!0;continue}if(V.type===1)return v.INSTANCE;if(V.type===9){j=j.concat(V.expr);continue}j.push(V)}}if(j.length===0&&Y)return C.INSTANCE;j.sort(b)}if(j.length!==0){if(j.length===1)return j[0];for(let N=1;N<j.length;N++)j[N-1].equals(j[N])&&(j.splice(N,1),N--);if(j.length===1)return j[0];if(ne){for(let N=0;N<j.length;N++)for(let O=N+1;O<j.length;O++)if(j[N].negate().equals(j[O]))return v.INSTANCE;if(j.length===1)return j[0]}return new J(j,F)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const F of this.expr)d.push(...F.keys());return d}map(d){return new J(this.expr.map(F=>F.map(d)),null)}negate(){if(!this.c){const d=[];for(const F of this.expr)d.push(F.negate());for(;d.length>1;){const F=d.shift(),ne=d.shift(),j=[];for(const Y of ge(F))for(const N of ge(ne))j.push(fe.create([Y,N],null,!1));d.unshift(J.create(j,null,!1))}this.c=J.create(d,this,!0)}return this.c}}e.$ej=J;class B extends D{static{this.d=[]}static all(){return B.d.values()}constructor(d,F,ne){super(d,null),this.f=F,typeof ne=="object"?B.d.push({...ne,key:d}):ne!==!0&&B.d.push({key:d,description:ne,type:F!=null?typeof F:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return H.create(this.key,d)}notEqualsTo(d){return $.create(this.key,d)}}e.$fj=B,e.$gj=(0,M.$1h)("contextKeyService");function Z(K,d){return K<d?-1:K>d?1:0}function te(K,d,F,ne){return K<F?-1:K>F?1:d<ne?-1:d>ne?1:0}function q(K,d){if(K.type===0||d.type===1)return!0;if(K.type===9)return d.type===9?_(K.expr,d.expr):!1;if(d.type===9){for(const F of d.expr)if(q(K,F))return!0;return!1}if(K.type===6){if(d.type===6)return _(d.expr,K.expr);for(const F of K.expr)if(q(F,d))return!0;return!1}return K.equals(d)}e.$hj=q;function _(K,d){let F=0,ne=0;for(;F<K.length&&ne<d.length;){const j=K[F].cmp(d[ne]);if(j<0)return!1;j===0&&F++,ne++}return F===K.length}function ge(K){return K.type===9?K.expr:[K]}}),define(le[78],he([0,1,51,7,11,8,5,69,21,3,19,22]),function(oe,e,w,L,k,M,R,E,f,u,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileKind=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileOperationResult=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileChangeType=e.$Ck=e.FileOperation=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileSystemProviderErrorCode=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderCapabilities=e.$mk=e.FilePermission=e.FileType=e.$lk=e.$kk=void 0,e.$kk=(0,f.$1h)("fileService");function y(q){return q.create===!0}e.$lk=y;var s;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(s||(e.FileType=s={}));var m;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function h(q){const _=q;return!!_&&typeof _.onDidChange=="function"}e.$mk=h;var a;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(q){return!!(q.capabilities&2)}e.$nk=r;function n(q){return!!(q.capabilities&8)}e.$ok=n;function i(q){return!!(q.capabilities&131072)}e.$pk=i;function l(q){return!!(q.capabilities&4)}e.$qk=l;function t(q){return!!(q.capabilities&16)}e.$rk=t;function o(q){return r(q)?!!(q.capabilities&16384):!1}e.$sk=o;function p(q){return r(q)?!!(q.capabilities&32768):!1}e.$tk=p;function I(q){return!!(q.capabilities&65536)}e.$uk=I;function b(q){return!!(q.capabilities&2048)}e.$vk=b;var C;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class v extends Error{static create(_,ge){const K=new v(_.toString(),ge);return W(K,ge),K}constructor(_,ge){super(_),this.code=ge}}e.$wk=v;function D(q,_){return v.create(q,_)}e.$xk=D;function H(q){return q||D((0,E.localize)(0,null),C.Unknown)}e.$yk=H;function W(q,_){return q.name=_?`${_} (FileSystemError)`:"FileSystemError",q}e.$zk=W;function c(q){if(!q)return C.Unknown;if(q instanceof v)return q.code;const _=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!_)return C.Unknown;switch(_[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.$Ak=c;function $(q){if(q instanceof ie)return q.fileOperationResult;switch(c(q)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}e.$Bk=$;var P;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class T{constructor(_,ge,K){this.resource=_,this.operation=ge,this.target=K}isOperation(_){return this.operation===_}}e.$Ck=T;var A;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class z{static{this.a=null}constructor(_,ge){this.c=ge,this.b=void 0,this.d=new g.$V(()=>{const K=w.$7h.forUris(()=>this.c);return K.fill(this.rawAdded.map(d=>[d,!0])),K}),this.f=new g.$V(()=>{const K=w.$7h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(d=>[d,!0])),K}),this.g=new g.$V(()=>{const K=w.$7h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(d=>[d,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of _){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==z.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(_,...ge){return this.h(_,{includeChildren:!1},...ge)}affects(_,...ge){return this.h(_,{includeChildren:!0},...ge)}h(_,ge,...K){if(!_)return!1;const d=K.length>0;return!!((!d||K.includes(1))&&(this.d.value.get(_)||ge.includeChildren&&this.d.value.findSuperstr(_))||(!d||K.includes(0))&&(this.f.value.get(_)||ge.includeChildren&&this.f.value.findSuperstr(_))||(!d||K.includes(2))&&(this.g.value.findSubstr(_)||ge.includeChildren&&this.g.value.findSuperstr(_)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_){return this.b===_}hasCorrelation(){return typeof this.b=="number"}}e.$Dk=z;function ee(q,_,ge){return!q||!_||q===_||_.length>q.length?!1:(_.charAt(_.length-1)!==L.sep&&(_+=L.sep),ge?(0,k.$8e)(q,_):q.indexOf(_)===0)}e.$Ek=ee;class ie extends Error{constructor(_,ge,K){super(_),this.fileOperationResult=ge,this.options=K}}e.$Fk=ie;class Q extends ie{constructor(_,ge,K,d){super(_,ge,d),this.fileOperationResult=ge,this.size=K}}e.$Gk=Q;class se extends ie{constructor(_,ge,K){super(_,2,K),this.stat=ge}}e.$Hk=se;var ue;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$Ik={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Jk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Kk="files.associations",e.$Lk="files.exclude",e.$Mk="files.readonlyInclude",e.$Nk="files.readonlyExclude",e.$Ok="files.readonlyFromPermissions";var fe;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Pk="";function J(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Qk=J;async function B(q,_){if(!_.hasProvider(R.URI.from({scheme:q.scheme})))return new Promise(ge=>{const K=_.onDidChangeFileSystemProviderRegistrations(d=>{d.scheme===q.scheme&&d.added&&(K.dispose(),ge())})})}e.$Rk=B;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(_){return(0,M.$Hf)(_)||(_=0),_<Z.KB?(0,E.localize)(1,null,_.toFixed(0)):_<Z.MB?(0,E.localize)(2,null,(_/Z.KB).toFixed(2)):_<Z.GB?(0,E.localize)(3,null,(_/Z.MB).toFixed(2)):_<Z.TB?(0,E.localize)(4,null,(_/Z.GB).toFixed(2)):(0,E.localize)(5,null,(_/Z.TB).toFixed(2))}}e.$Sk=Z;function te(q){const _=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*Z.MB:_?10*Z.MB:u.$o?50*Z.MB:1024*Z.MB}e.$Tk=te}),define(le[10],he([0,1,56,4,49,2,25,3,23,8,5,35,21]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,y.$1h)("logService"),e.$jj=(0,y.$1h)("loggerService");function s(){return new Date().toISOString()}function m(W){return(0,u.$Hf)(W)}e.$kj=m;var h;(function(W){W[W.Off=0]="Off",W[W.Trace=1]="Trace",W[W.Debug=2]="Debug",W[W.Info=3]="Info",W[W.Warning=4]="Warning",W[W.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$lj=h.Info;function a(W,c,$){switch(c){case h.Trace:W.trace($);break;case h.Debug:W.debug($);break;case h.Info:W.info($);break;case h.Warning:W.warn($);break;case h.Error:W.error($);break;case h.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=a;function r(W,c=!1){let $="";for(let P=0;P<W.length;P++){let T=W[P];if(T instanceof Error&&(T=(0,w.$Li)(T,c)),typeof T=="object")try{T=JSON.stringify(T)}catch{}$+=(P>0?" ":"")+T}return $}class n extends M.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new L.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==h.Off&&this.b<=c}}e.$nj=n;class i extends n{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...$){this.f(h.Trace)&&this.g(h.Trace,r([c,...$],!0))}debug(c,...$){this.f(h.Debug)&&this.g(h.Debug,r([c,...$]))}info(c,...$){this.f(h.Info)&&this.g(h.Info,r([c,...$]))}warn(c,...$){this.f(h.Warning)&&this.g(h.Warning,r([c,...$]))}error(c,...$){if(this.f(h.Error))if(c instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=c.stack,this.g(h.Error,r(P))}else this.g(h.Error,r([c,...$]))}flush(){}}e.$oj=i;class l extends n{constructor(c=e.$lj){super(),this.setLevel(c),this.g=!E.$i}trace(c,...$){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...$):console.log(`[main ${s()}]`,c,...$))}debug(c,...$){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...$):console.log(`[main ${s()}]`,c,...$))}info(c,...$){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...$):console.log(`[main ${s()}]`,c,...$))}warn(c,...$){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${s()}]\x1B[0m`,c,...$):console.warn(`[main ${s()}]`,c,...$))}error(c,...$){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${s()}]\x1B[0m`,c,...$):console.error(`[main ${s()}]`,c,...$))}dispose(){}flush(){}}e.$pj=l;class t extends n{constructor(c=e.$lj,$=!0){super(),this.g=$,this.setLevel(c)}trace(c,...$){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",c,...$):console.log(c,...$))}debug(c,...$){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",c,...$):console.log(c,...$))}info(c,...$){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",c,...$):console.log(c,...$))}warn(c,...$){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",c,...$):console.log(c,...$))}error(c,...$){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",c,...$):console.error(c,...$))}dispose(){}flush(){}}e.$qj=t;class o extends n{constructor(c,$=e.$lj){super(),this.g=c,this.setLevel($)}trace(c,...$){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(c),...$])}debug(c,...$){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(c),...$])}info(c,...$){this.f(h.Info)&&this.g.log(h.Info,[this.h(c),...$])}warn(c,...$){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(c),...$])}error(c,...$){this.f(h.Error)&&this.g.log(h.Error,[this.h(c),...$])}h(c){return typeof c=="string"?c:(0,w.$Li)(c,this.f(h.Trace))}dispose(){}flush(){}}e.$rj=o;class p extends n{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const $ of this.g)$.setLevel(c);super.setLevel(c)}trace(c,...$){for(const P of this.g)P.trace(c,...$)}debug(c,...$){for(const P of this.g)P.debug(c,...$)}info(c,...$){for(const P of this.g)P.info(c,...$)}warn(c,...$){for(const P of this.g)P.warn(c,...$)}error(c,...$){for(const P of this.g)P.error(c,...$)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.$sj=p;class I extends M.$Sc{constructor(c,$,P){if(super(),this.h=c,this.j=$,this.b=new R.$Ac,this.c=this.B(new L.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Sd),this.onDidChangeVisibility=this.g.event,P)for(const T of P)this.b.set(T.resource,{logger:void 0,info:T})}m(c){return(0,u.$Df)(c)?[...this.b.values()].find($=>$.info.id===c):this.b.get(c)}getLogger(c){return this.m(c)?.logger}createLogger(c,$){const P=this.n(c),T=(0,u.$Df)(c)?c:$?.id??(0,k.$Oi)(P.toString()).toString(16);let A=this.b.get(P)?.logger;const z=$?.logLevel==="always"?h.Trace:$?.logLevel;A||(A=this.s(P,z??this.getLogLevel(P)??this.h,{...$,id:T}));const ee={logger:A,info:{resource:P,id:T,logLevel:z,name:$?.name,hidden:$?.hidden,extensionId:$?.extensionId,when:$?.when}};return this.registerLogger(ee.info),this.b.set(P,ee),A}n(c){return(0,u.$Df)(c)?(0,f.$Cg)(this.j,`${c}.log`):c}setLogLevel(c,$){if(S.URI.isUri(c)){const P=c,T=$,A=this.b.get(P);A&&T!==A.info.logLevel&&(A.info.logLevel=T===this.h?void 0:T,A.logger?.setLevel(T),this.b.set(A.info.resource,A),this.f.fire([P,T]))}else{this.h=c;for(const[P,T]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(c,$){const P=this.m(c);P&&$!==!P.info.hidden&&(P.info.hidden=!$,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,$]))}getLogLevel(c){let $;return c&&($=this.b.get(c)?.info.logLevel),$??this.h}registerLogger(c){const $=this.b.get(c.resource);$?$.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.b.set(c.resource,{info:c,logger:void 0}),this.c.fire({added:[c],removed:[]}))}deregisterLogger(c){const $=this.b.get(c);$&&($.logger&&$.logger.dispose(),this.b.delete(c),this.c.fire({added:[],removed:[$.info]}))}*getRegisteredLoggers(){for(const c of this.b.values())yield c.info}getRegisteredLogger(c){return this.b.get(c)?.info}dispose(){this.b.forEach(c=>c.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=I;class b{constructor(){this.onDidChangeLogLevel=new L.$Sd().event}setLevel(c){}getLevel(){return h.Info}trace(c,...$){}debug(c,...$){}info(c,...$){}warn(c,...$){}error(c,...$){}critical(c,...$){}dispose(){}flush(){}}e.$uj=b;class C extends b{}e.$vj=C;function v(W){if(W.verbose)return h.Trace;if(typeof W.logLevel=="string"){const c=H(W.logLevel.toLowerCase());if(c!==void 0)return c}return e.$lj}e.$wj=v;function D(W){switch(W){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$xj=D;function H(W){switch(W){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$yj=H,e.$zj=new g.$fj("logLevel",D(h.Info))}),define(le[79],he([0,1,5,4,10,2]),function(oe,e,w,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=void 0;class R extends k.$tj{constructor(g,y,s,m,h){super(y,s,m),this.r=g,this.t=h,this.B(h.listen("onDidChangeLogLevel",g)(a=>{(0,k.$kj)(a)?super.setLogLevel(a):super.setLogLevel(w.URI.revive(a[0]),a[1])})),this.B(h.listen("onDidChangeVisibility",g)(([a,r])=>super.setVisibility(w.URI.revive(a),r))),this.B(h.listen("onDidChangeLoggers",g)(({added:a,removed:r})=>{for(const n of a)super.registerLogger({...n,resource:w.URI.revive(n.resource)});for(const n of r)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new k.$rj({log:(g,y)=>{this.t.call("consoleLog",[g,y])}})}registerLogger(g){super.registerLogger(g),this.t.call("registerLogger",[g,this.r])}deregisterLogger(g){super.deregisterLogger(g),this.t.call("deregisterLogger",[g,this.r])}setLogLevel(g,y){super.setLogLevel(g,y),this.t.call("setLogLevel",[g,y])}setVisibility(g,y){super.setVisibility(g,y),this.t.call("setVisibility",[this.n(g),y])}s(g,y,s){return new E(this.t,g,y,s,this.r)}static setLogLevel(g,y,s){return g.call("setLogLevel",[y,s])}}e.$kr=R;class E extends k.$oj{constructor(g,y,s,m,h){super(m?.logLevel==="always"),this.r=g,this.s=y,this.m=!1,this.n=[],this.setLevel(s),this.r.call("createLogger",[y,m,h]).then(()=>{this.u(this.n),this.m=!0})}g(g,y){const s=[[g,y]];this.m?this.u(s):this.n.push(...s)}u(g){this.r.call("log",[this.s,g])}}class f{constructor(g,y){this.a=g,this.b=y}listen(g,y){const s=this.b(g);switch(y){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(h=>this.c(h,s)),removed:[...m.removed].map(h=>this.c(h,s))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,m=>[s.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,m=>(0,k.$kj)(m)?m:[s.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${y}`)}async call(g,y,s){const m=this.b(g);switch(y){case"setLogLevel":return(0,k.$kj)(s[0])?this.a.setLogLevel(s[0]):this.a.setLogLevel(w.URI.revive(m.transformIncoming(s[0][0])),s[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(h=>this.c(h,m)))}throw new Error(`Call not found: ${y}`)}c(g,y){return{...g,resource:y.transformOutgoingURI(g.resource)}}}e.$lr=f;class u extends M.$Sc{constructor(g,y){super(),y.call("setLogLevel",[g.getLogLevel()]),this.B(g.onDidChangeLogLevel(s=>y.call("setLogLevel",[s]))),y.call("getRegisteredLoggers").then(s=>{for(const m of s)g.registerLogger({...m,resource:w.URI.revive(m.resource)})}),this.B(y.listen("onDidChangeVisibility")(([s,m])=>g.setVisibility(w.URI.revive(s),m))),this.B(y.listen("onDidChangeLoggers")(({added:s,removed:m})=>{for(const h of s)g.registerLogger({...h,resource:w.URI.revive(h.resource)});for(const h of m)g.deregisterLogger(h.resource)}))}}e.$mr=u}),define(le[80],he([0,1,2,10]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;class k extends w.$Sc{constructor(R,E=[]){super(),this.a=new L.$sj([R,...E]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...E){this.a.trace(R,...E)}debug(R,...E){this.a.debug(R,...E)}info(R,...E){this.a.info(R,...E)}warn(R,...E){this.a.warn(R,...E)}error(R,...E){this.a.error(R,...E)}flush(){this.a.flush()}}e.$_N=k}),define(le[81],he([0,1,78,10]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function M(u,S,g,y,s){try{const m=await new Promise((a,r)=>{oe(["@vscode/spdlog"],a,r)});m.setFlushOn(k.Trace);const h=await m.createAsyncRotatingLogger(u,S,g,y);return s?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(m){console.error(m)}return null}function R(u,S,g){switch(S){case L.LogLevel.Trace:u.trace(g);break;case L.LogLevel.Debug:u.debug(g);break;case L.LogLevel.Info:u.info(g);break;case L.LogLevel.Warning:u.warn(g);break;case L.LogLevel.Error:u.error(g);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function E(u,S){switch(S){case L.LogLevel.Trace:u.setLevel(k.Trace);break;case L.LogLevel.Debug:u.setLevel(k.Debug);break;case L.LogLevel.Info:u.setLevel(k.Info);break;case L.LogLevel.Warning:u.setLevel(k.Warning);break;case L.LogLevel.Error:u.setLevel(k.Error);break;case L.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class f extends L.$oj{constructor(S,g,y,s,m){super(),this.m=[],this.setLevel(m),this.n=this.s(S,g,y,s),this.B(this.onDidChangeLogLevel(h=>{this.r&&E(this.r,h)}))}async s(S,g,y,s){const m=y?6:1,h=30/m*w.$Sk.MB,a=await M(S,g,h,m,s);if(a){this.r=a,E(this.r,this.getLevel());for(const{level:r,message:n}of this.m)R(this.r,r,n);this.m=[]}}g(S,g){this.r?R(this.r,S,g):this.getLevel()<=S&&this.m.push({level:S,message:g})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$1N=f}),define(le[82],he([0,1,52,10,81]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class M extends L.$tj{s(E,f,u){return new k.$1N((0,w.$lg)(),E.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.$2N=M}),define(le[83],he([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const M=k.context.configuration();if(M)L=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,w.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:M.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[84],he([0,1,21]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,w.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"}),define(le[85],he([0,1,42,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;class k{constructor(){this.a=new Map}add(R,E){w.ok(L.$Df(R)),w.ok(L.$Ff(E)),w.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,E)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$sn=new k}),define(le[86],he([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rob=void 0;class k extends L.$Sc{constructor(R){super(),this.f=R,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new w.$Sd),this.onMarkAdded=this.c.event}*markers(){for(const R of this.a.values())yield R;for(const R of this.b.values())yield R}addMark(R){const E=R?.marker||this.f.registerMarker(),f=R?.id;E&&(f?(this.a.set(f,E),E.onDispose(()=>this.a.delete(f))):(this.b.set(E.id,E),E.onDispose(()=>this.b.delete(E.id))),this.c.fire({marker:E,id:f,hidden:R?.hidden,hoverMessage:R?.hoverMessage}))}getMark(R){return this.a.get(R)}}e.$Rob=k}),define(le[87],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class w{get command(){return this.b.command}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(u){this.b.endMarker=u}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(u,S){this.a=u,this.b=S}static deserialize(u,S,g){const y=u.buffer.normal,s=S.startLine!==void 0?u.registerMarker(S.startLine-(y.baseY+y.cursorY)):void 0;if(!s)return;const m=S.promptStartLine!==void 0?u.registerMarker(S.promptStartLine-(y.baseY+y.cursorY)):void 0,h=S.endLine!==void 0?u.registerMarker(S.endLine-(y.baseY+y.cursorY)):void 0,a=S.executedLine!==void 0?u.registerMarker(S.executedLine-(y.baseY+y.cursorY)):void 0;return new w(u,{command:g?"":S.command,isTrusted:S.isTrusted,promptStartMarker:m,marker:s,startX:S.startX,endMarker:h,executedMarker:a,executedX:S.executedX,timestamp:S.timestamp,cwd:S.cwd,commandStartLineContent:S.commandStartLineContent,exitCode:S.exitCode,markProperties:S.markProperties,aliases:void 0,wasReplayed:!0})}serialize(u){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:u?"":this.command,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,markProperties:this.markProperties}}getOutput(){if(!this.executedMarker||!this.endMarker)return;const u=this.executedMarker.line,S=this.endMarker.line;if(u===S)return;let g="",y;for(let s=u;s<S;s++)y=this.a.buffer.active.getLine(s),y&&(g+=y.translateToString(!y.isWrapped)+(y.isWrapped?"":`
`));return g===""?void 0:g}getOutputMatch(u){if(!this.executedMarker||!this.endMarker)return;const S=this.endMarker.line;if(S===-1)return;const g=this.a.buffer.active,y=Math.max(this.executedMarker.line,0),s=u.lineMatcher,m=typeof s=="string"?1:u.length||M(s),h=[];let a;if(u.anchor==="bottom")for(let r=S-(u.offset||0);r>=y;r--){let n=r;const i=r;for(;n>=y&&g.getLine(n)?.isWrapped;)n--;if(r=n,h.unshift(k(g,n,i,this.a.cols)),a||(a=h[0].match(s)),h.length>=m)break}else for(let r=y+(u.offset||0);r<S;r++){const n=r;let i=r;for(;i+1<S&&g.getLine(i+1)?.isWrapped;)i++;if(r=i,h.push(k(g,n,i,this.a.cols)),a||(a=h[h.length-1].match(s)),h.length>=m)break}return a?{regexMatch:a,outputLines:h}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return R(this,this.a.buffer.active)}getCommandRowCount(){return E(this)}}e.$dr=w;class L{constructor(u){this.a=u}serialize(u){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",isTrusted:!0,cwd:u,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,markProperties:void 0}}promoteToFullCommand(u,S,g,y){if(S===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||g)return new w(this.a,{command:g?"":this.command||"",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),cwd:u,exitCode:S,commandStartLineContent:this.commandStartLineContent,markProperties:y})}getPromptRowCount(){return R(this,this.a.buffer.active)}getCommandRowCount(){return E(this)}}e.$er=L;function k(f,u,S,g){const y=Math.max(2048/g*2);S=Math.min(S,u+y);let s="";for(let m=u;m<=S;m++){const h=f.getLine(m);h&&(s+=h.translateToString(!0,0,g))}return s}function M(f){if(!f.multiline)return 1;const u=f.source;let S=1,g=u.indexOf("\\n");for(;g!==-1;)S++,g=u.indexOf("\\n",g+1);return S}function R(f,u){const S="hasOutput"in f?f.marker:f.commandStartMarker;if(!S||!f.promptStartMarker)return 1;let g=1,y=f.promptStartMarker.line;for(;y<S.line&&(u.getLine(y)?.translateToString(!0)??"").length===0;)y++;return g=S.line-y+1,g}function E(f){const u="hasOutput"in f?f.marker:f.commandStartMarker,S="hasOutput"in f?f.executedMarker:f.commandExecutedMarker;if(!u||!S)return 1;let y=Math.max(S.line,u.line)-u.line+1;return("hasOutput"in f?f.executedX:f.commandExecutedX)===0&&y--,y}});var je=this&&this.__param||function(oe,e){return function(w,L){e(w,L,oe)}};define(le[88],he([0,1,9,14,4,2,10,87]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oob=e.$Nob=void 0;class f extends M.$Sc{get commands(){return this.c}get executingCommand(){return this.g.command}get executingCommandObject(){if(this.g.commandStartMarker)return{marker:this.g.commandStartMarker}}get currentCommand(){return this.g}get cwd(){return this.f}get z(){return!!(this.g.commandStartMarker&&!this.g.commandExecutedMarker)}get hasInput(){if(!(!this.z||!this.g?.commandStartMarker)){if(this.J.buffer.active.baseY+this.J.buffer.active.cursorY===this.g.commandStartMarker?.line){const a=this.J.buffer.active.getLine(this.J.buffer.active.cursorY)?.translateToString(!0,this.g.commandStartX);return a===void 0?void 0:a.length>0}return!0}}constructor(a,r){super(),this.J=a,this.L=r,this.type=2,this.c=[],this.g=new E.$er(this.J),this.h=[],this.r=!1,this.C=this.B(new k.$Sd),this.onCommandStarted=this.C.event,this.D=this.B(new k.$Sd),this.onBeforeCommandFinished=this.D.event,this.F=this.B(new k.$Sd),this.onCommandFinished=this.F.event,this.G=this.B(new k.$Sd),this.onCommandExecuted=this.G.event,this.H=this.B(new k.$Sd),this.onCommandInvalidated=this.H.event,this.I=this.B(new k.$Sd),this.onCurrentCommandInvalidated=this.I.event;const n=this;this.u=new class{get onCurrentCommandInvalidatedEmitter(){return n.I}get onCommandStartedEmitter(){return n.C}get onCommandExecutedEmitter(){return n.G}get dimensions(){return n.n}get isCommandStorageDisabled(){return n.r}get commandMarkers(){return n.h}set commandMarkers(i){n.h=i}get clearCommandsInViewport(){return n.O.bind(n)}commitCommandFinished(){n.t?.flush(),n.t=void 0}},this.w=this.B(new M.$Uc(new u(this.J,this,this.u,this.L))),this.n={cols:this.J.cols,rows:this.J.rows},this.B(this.J.onResize(i=>this.M(i))),this.B(this.J.onCursorMove(()=>this.N()))}M(a){this.w.value.preHandleResize?.(a),this.n.cols=a.cols,this.n.rows=a.rows}N(){this.J.buffer.active===this.J.buffer.normal&&this.g.commandStartMarker&&this.J.buffer.active.baseY+this.J.buffer.active.cursorY<this.g.commandStartMarker.line&&(this.O(),this.g.isInvalid=!0,this.I.fire({reason:"windows"}))}O(){let a=0;for(let r=this.c.length-1;r>=0;r--){const n=this.c[r].marker?.line;if(n&&n<this.J.buffer.active.baseY)break;a++}a>0&&this.H.fire(this.c.splice(this.c.length-a,a))}setCwd(a){this.f=a}setIsWindowsPty(a){if(a&&!(this.w.value instanceof g)){const r=this;this.w.value=new g(this.J,this,new class{get onCurrentCommandInvalidatedEmitter(){return r.I}get onCommandStartedEmitter(){return r.C}get onCommandExecutedEmitter(){return r.G}get dimensions(){return r.n}get isCommandStorageDisabled(){return r.r}get commandMarkers(){return r.h}set commandMarkers(n){r.h=n}get clearCommandsInViewport(){return r.O.bind(r)}commitCommandFinished(){r.t?.flush(),r.t=void 0}},this.L)}else!a&&!(this.w.value instanceof u)&&(this.w.value=new u(this.J,this,this.u,this.L))}setIsCommandStorageDisabled(){this.r=!0}getCommandForLine(a){if(this.g.promptStartMarker&&a>=this.g.promptStartMarker?.line)return this.g;if(this.c.length!==0&&!((this.c[0].promptStartMarker??this.c[0].marker).line>a)){for(let r=this.commands.length-1;r>=0;r--)if((this.commands[r].promptStartMarker??this.commands[r].marker).line<=a)return this.commands[r]}}getCwdForLine(a){if(this.g.promptStartMarker&&a>=this.g.promptStartMarker?.line)return this.f;const r=this.getCommandForLine(a);if(r&&"cwd"in r)return r.cwd}handlePromptStart(a){const r=this.commands.at(-1);r?.endMarker&&r?.executedMarker&&r.endMarker.line===r.executedMarker.line&&(this.L.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${r.endMarker.line} -> ${r.executedMarker.line+1}`),r.endMarker=m(this.J,r.executedMarker,1)),this.g.promptStartMarker=a?.marker||(r?.endMarker?m(this.J,r.endMarker):this.J.registerMarker(0)),this.L.debug("CommandDetectionCapability#handlePromptStart",this.J.buffer.active.cursorX,this.g.promptStartMarker?.line)}handleContinuationStart(){this.g.currentContinuationMarker=this.J.registerMarker(0),this.L.debug("CommandDetectionCapability#handleContinuationStart",this.g.currentContinuationMarker)}handleContinuationEnd(){if(!this.g.currentContinuationMarker){this.L.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.g.continuations||(this.g.continuations=[]),this.g.continuations.push({marker:this.g.currentContinuationMarker,end:this.J.buffer.active.cursorX}),this.g.currentContinuationMarker=void 0,this.L.debug("CommandDetectionCapability#handleContinuationEnd",this.g.continuations[this.g.continuations.length-1])}handleRightPromptStart(){this.g.commandRightPromptStartX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleRightPromptStart",this.g.commandRightPromptStartX)}handleRightPromptEnd(){this.g.commandRightPromptEndX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleRightPromptEnd",this.g.commandRightPromptEndX)}handleCommandStart(a){if(this.s=a,this.g.commandStartMarker=a?.marker||this.g.commandStartMarker,this.g.commandStartMarker?.line===this.J.buffer.active.cursorY){this.g.commandStartX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleCommandStart",this.g.commandStartX,this.g.commandStartMarker?.line);return}this.w.value.handleCommandStart(a)}handleGenericCommand(a){a?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(a),this.handleCommandStart(a),this.handleCommandExecuted(a),this.handleCommandFinished(void 0,a)}handleCommandExecuted(a){this.w.value.handleCommandExecuted(a)}handleCommandFinished(a,r){if(this.w.value.preHandleCommandFinished?.(),this.L.debug("CommandDetectionCapability#handleCommandFinished",this.J.buffer.active.cursorX,r?.marker?.line,this.g.command,this.g),a===void 0){const i=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.g.command&&this.g.command.length>0&&i?.command===this.g.command&&(a=i.exitCode)}if(this.g.commandStartMarker===void 0||!this.J.buffer.active)return;this.g.commandFinishedMarker=r?.marker||this.J.registerMarker(0),this.w.value.postHandleCommandFinished?.();const n=this.g.promoteToFullCommand(this.f,a,this.s?.ignoreCommandLine??!1,r?.markProperties);n&&(this.c.push(n),this.t=new w.$ah(()=>{this.D.fire(n),this.g.isInvalid||(this.L.debug("CommandDetectionCapability#onCommandFinished",n),this.F.fire(n))},50),this.t.schedule()),this.g=new E.$er(this.J),this.s=void 0}setCommandLine(a,r){this.L.debug("CommandDetectionCapability#setCommandLine",a,r),this.g.command=a,this.g.isTrusted=r}serialize(){const a=this.commands.map(n=>n.serialize(this.r)),r=this.g.serialize(this.f);return r&&a.push(r),{isWindowsPty:this.w.value instanceof g,commands:a}}deserialize(a){a.isWindowsPty&&this.setIsWindowsPty(a.isWindowsPty);const r=this.J.buffer.normal;for(const n of a.commands){if(!n.endLine){const l=n.startLine!==void 0?this.J.registerMarker(n.startLine-(r.baseY+r.cursorY)):void 0;if(!l)continue;this.g.commandStartMarker=n.startLine!==void 0?this.J.registerMarker(n.startLine-(r.baseY+r.cursorY)):void 0,this.g.commandStartX=n.startX,this.g.promptStartMarker=n.promptStartLine!==void 0?this.J.registerMarker(n.promptStartLine-(r.baseY+r.cursorY)):void 0,this.f=n.cwd,this.C.fire({marker:l});continue}const i=E.$dr.deserialize(this.J,n,this.r);i&&(this.c.push(i),this.L.debug("CommandDetectionCapability#onCommandFinished",i),this.F.fire(i))}}}e.$Nob=f,$e([(0,L.$th)(500)],f.prototype,"N",null);class u extends M.$Sc{constructor(a,r,n,i){super(),this.c=a,this.f=r,this.g=n,this.h=i,this.B(a.parser.registerCsiHandler({final:"J"},l=>(l.length>=1&&(l[0]===2||l[0]===3)&&n.clearCommandsInViewport(),!1)))}async handleCommandStart(a){this.g.commitCommandFinished();const r=this.f.currentCommand;r.commandStartX=this.c.buffer.active.cursorX,r.commandStartMarker=a?.marker||this.c.registerMarker(0),r.commandExecutedMarker?.dispose(),r.commandExecutedMarker=void 0,r.commandExecutedX=void 0;for(const n of this.g.commandMarkers)n.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:a?.marker||r.commandStartMarker,markProperties:a?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",r.commandStartX,r.commandStartMarker?.line)}handleCommandExecuted(a){const r=this.f.currentCommand;if(r.commandExecutedMarker=a?.marker||this.c.registerMarker(0),r.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",r.commandExecutedX,r.commandExecutedMarker?.line),!r.commandStartMarker||!r.commandExecutedMarker||r.commandStartX===void 0)return;r.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(r.commandStartMarker.line)?.translateToString(!0,r.commandStartX,r.commandRightPromptStartX).trim();let n=r.commandStartMarker.line+1;const i=r.commandExecutedMarker.line;for(;n<i;n++){const l=this.c.buffer.active.getLine(n);if(l){const t=r.continuations?.find(p=>p.marker.line===n);t&&(r.command+=`
`);const o=t?.end??0;r.command+=l.translateToString(!0,o)}}n===i&&(r.command+=this.c.buffer.active.getLine(i)?.translateToString(!0,void 0,r.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire()}}var S;(function(h){h[h.MaxCheckLineCount=5]="MaxCheckLineCount",h[h.Interval=20]="Interval",h[h.MaximumPollCount=50]="MaximumPollCount"})(S||(S={}));let g=class extends M.$Sc{constructor(a,r,n,i){super(),this.r=a,this.s=r,this.t=n,this.u=i,this.c=this.B(new M.$Tc),this.f=!1,this.h=0,this.n=0,this.B(a.parser.registerCsiHandler({final:"J"},l=>(l.length>=1&&(l[0]===2||l[0]===3)&&(this.f=!0,this.t.clearCommandsInViewport()),!1))),this.B(this.s.onBeforeCommandFinished(l=>{if(this.f){this.f=!1;return}(l.command.trim().toLowerCase()==="clear"||l.command.trim().toLowerCase()==="cls")&&(this.g?.cancel(),this.g=void 0,this.t.clearCommandsInViewport(),this.s.currentCommand.isInvalid=!0,this.t.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(a){const r=this.r.buffer.active.baseY,n=a.rows-this.t.dimensions.rows;n>0&&this.F().then(()=>{const i=Math.min(n,r);for(let l=this.s.commands.length-1;l>=0;l--){const t=this.s.commands[l];if(!t.marker||t.marker.line<r||t.commandStartLineContent===void 0)break;const o=this.r.buffer.active.getLine(t.marker.line);if(!o||o.translateToString(!0)===t.commandStartLineContent)continue;const p=t.marker.line-i;this.r.buffer.active.getLine(p)?.translateToString(!0)===t.commandStartLineContent&&this.r._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.r.buffer.active.baseY,amount:i})}})}async handleCommandStart(){this.s.currentCommand.commandStartX=this.r.buffer.active.cursorX,this.t.commandMarkers.length=0;const a=this.s.currentCommand.commandStartMarker=this.s.currentCommand.promptStartMarker?m(this.r,this.s.currentCommand.promptStartMarker):this.r.registerMarker(0);this.s.currentCommand.commandStartX=0,this.h=0,this.n=0,this.g=new w.$ah(()=>this.w(a),20),this.g.schedule()}w(a){if(this.q.isDisposed)return;const r=this.r.buffer.active;let n=this.h;for(;n<5&&a.line+n<r.baseY+this.r.rows;){if(this.D()){const i=this.G(a.line+n);if(i){const l=typeof i=="string"?i:i.prompt;if(this.s.currentCommand.commandStartMarker=this.r.registerMarker(0),typeof i=="object"&&i.likelySingleLine){this.u.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.s.currentCommand.promptStartMarker?.line} -> ${this.s.currentCommand.commandStartMarker.line}`),this.s.currentCommand.promptStartMarker?.dispose(),this.s.currentCommand.promptStartMarker=m(this.r,this.s.currentCommand.commandStartMarker);const t=this.s.commands.at(-1);t&&this.s.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=m(this.r,this.s.currentCommand.commandStartMarker))}this.s.currentCommand.commandStartX=l.length,this.u.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${a.line} -> ${this.s.currentCommand.commandStartMarker.line}:${this.s.currentCommand.commandStartX}`),this.z();return}}n++}n<5?(this.h=n,this.n<50?this.g?.schedule():this.z()):this.z()}z(){if(this.g&&(this.n=50,this.g.flush(),this.g=void 0),this.t.commitCommandFinished(),this.s.currentCommand.commandExecutedMarker||(this.c.value=this.r.onCursorMove(()=>{if(this.t.commandMarkers.length===0||this.t.commandMarkers[this.t.commandMarkers.length-1].line!==this.r.buffer.active.cursorY){const a=this.r.registerMarker(0);a&&this.t.commandMarkers.push(a)}})),this.s.currentCommand.commandStartMarker){const a=this.r.buffer.active.getLine(this.s.currentCommand.commandStartMarker.line);a&&(this.s.currentCommand.commandStartLineContent=a.translateToString(!0))}this.t.onCommandStartedEmitter.fire({marker:this.s.currentCommand.commandStartMarker}),this.u.debug("CommandDetectionCapability#_handleCommandStartWindows",this.s.currentCommand.commandStartX,this.s.currentCommand.commandStartMarker?.line)}handleCommandExecuted(a){this.g&&this.z(),this.c.clear(),this.C(),this.s.currentCommand.commandExecutedX=this.r.buffer.active.cursorX,this.t.onCommandExecutedEmitter.fire(),this.u.debug("CommandDetectionCapability#handleCommandExecuted",this.s.currentCommand.commandExecutedX,this.s.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.s.currentCommand.commandExecutedMarker||(this.t.commandMarkers.length===0&&(this.s.currentCommand.commandStartMarker||(this.s.currentCommand.commandStartMarker=this.r.registerMarker(0)),this.s.currentCommand.commandStartMarker&&this.t.commandMarkers.push(this.s.currentCommand.commandStartMarker)),this.C())}postHandleCommandFinished(){const a=this.s.currentCommand,r=a.command,n=a.commandStartMarker?.line,i=a.commandExecutedMarker?.line;if(!r||r.length===0||n===void 0||n===-1||i===void 0||i===-1)return;let l=0,t=!1;for(let o=n;o<=i;o++){const p=this.r.buffer.active.getLine(o);if(!p)break;const I=p.translateToString(!0);for(let b=0;b<I.length;b++){for(;r.length<l&&r[l]===" ";)l++;if(I[b]===r[l]&&l++,l===r.length){const C=b>=this.r.cols-1;a.commandExecutedMarker=this.r.registerMarker(o-(this.r.buffer.active.baseY+this.r.buffer.active.cursorY)+(C?1:0)),a.commandExecutedX=C?0:b+1,t=!0;break}}if(t)break}}C(){if(this.t.commandMarkers.length!==0){if(this.t.commandMarkers=this.t.commandMarkers.sort((a,r)=>a.line-r.line),this.s.currentCommand.commandStartMarker=this.t.commandMarkers[0],this.s.currentCommand.commandStartMarker){const a=this.r.buffer.active.getLine(this.s.currentCommand.commandStartMarker.line);a&&(this.s.currentCommand.commandStartLineContent=a.translateToString(!0))}this.s.currentCommand.commandExecutedMarker=this.t.commandMarkers[this.t.commandMarkers.length-1],this.t.onCommandExecutedEmitter.fire()}}D(){const a=this.s.commands.at(-1);if(!a)return!0;const r=this.r.buffer.active.baseY+this.r.buffer.active.cursorY,n=(a.endMarker?a.endMarker.line:a.marker?.line)??-1;return r>n}F(){const a=this.r.buffer.active.cursorX,r=this.r.buffer.active.cursorY;let n=0;return new Promise((i,l)=>{const t=setInterval(()=>{if(a!==this.r.buffer.active.cursorX||r!==this.r.buffer.active.cursorY){i(),clearInterval(t);return}n+=10,n>1e3&&(clearInterval(t),i())},10)})}G(a=this.r.buffer.active.baseY+this.r.buffer.active.cursorY){const r=this.r.buffer.active.getLine(a);if(!r)return;const n=r.translateToString(!0);if(!n)return;const i=n.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(i){const o=this.H(i,n,">");if(o)return{prompt:o,likelySingleLine:!0}}const l=n.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(l){const o=this.H(l,n,"\u276F");if(o)return o}const t=n.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return t?.groups?.prompt?{prompt:t.groups.prompt,likelySingleLine:!0}:void 0}H(a,r,n){if(a)return r===a&&a.endsWith(n)&&(a+=" "),a}};g=$e([je(3,R.$ij)],g);function y(h,a,r,n){if(!n)return;const i=a.executedMarker,l=a.endMarker;if(!i||!l)return;const t=i.line,o=l.line,p=n.length,I=[];if(n.anchor==="bottom")for(let b=o-(n.offset||0);b>=t;b--){let C=b;const v=b;for(;C>=t&&h.getLine(C)?.isWrapped;)C--;b=C,I.unshift(s(h,C,v,r)),I.length>p&&I.pop()}else for(let b=t+(n.offset||0);b<o;b++){const C=b;let v=b;for(;v+1<o&&h.getLine(v+1)?.isWrapped;)v++;b=v,I.push(s(h,C,v,r)),I.length===p&&I.shift()}return I}e.$Oob=y;function s(h,a,r,n){const i=Math.max(2048/n*2);r=Math.min(r,a+i);let l="";for(let t=a;t<=r;t++){const o=h.getLine(t);o&&(l+=o.translateToString(!0,0,n))}return l}function m(h,a,r=0){return h.registerMarker(a.line-(h.buffer.active.baseY+h.buffer.active.cursorY)+r)}}),define(le[89],he([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pob=void 0;class k extends L.$Sc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new w.$Sd),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(R){const E=this.a!==R;this.a=R;const f=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,f+1),E&&this.c.fire(R)}}e.$Pob=k}),define(le[90],he([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qob=void 0;var k;(function(R){R[R.MinimumPromptLength=2]="MinimumPromptLength"})(k||(k={}));class M extends L.$Rc{get commands(){return this.a}constructor(E){super(),this.c=E,this.type=3,this.a=[],this.b=this.add(new w.$Sd),this.onCommandFinished=this.b.event,this.add(this.c.onData(f=>this.h(f))),this.add(this.c.parser.registerCsiHandler({final:"J"},f=>(f.length>=1&&(f[0]===2||f[0]===3)&&this.m(),!1)))}h(E){E==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const E=this.c.registerMarker(0);E&&(this.a.push(E),this.b.fire(E))}}m(){let E=0;for(let f=this.a.length-1;f>=0&&!(this.a[f].line<this.c.buffer.active.baseY);f--)E++;this.a.splice(this.a.length-E,E)}}e.$Qob=M}),define(le[91],he([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mob=e.$Lob=void 0;class k extends L.$Sc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new w.$Sd),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new w.$Sd),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new w.$Sd),this.onDidRemoveCapability=this.g.event,this.h=this.B(new w.$Sd),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(E,f){this.a.set(E,f),this.f.fire(E),this.h.fire({id:E,capability:f})}get(E){return this.a.get(E)}remove(E){const f=this.a.get(E);f&&(this.a.delete(E),this.b.fire(E),this.h.fire({id:E,capability:f}))}has(E){return this.a.has(E)}}e.$Lob=k;class M extends L.$Sc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new w.$Sd),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new w.$Sd),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new w.$Sd),this.onDidRemoveCapability=this.f.event,this.g=this.B(new w.$Sd),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const E of this._stores)for(const f of E.items)yield f}has(E){for(const f of this._stores)for(const u of f.items)if(u===E)return!0;return!1}get(E){for(const f of this._stores){const u=f.get(E);if(u)return u}}add(E){this._stores.push(E);for(const f of E.items)this.b.fire(f),this.g.fire({id:f,capability:E.get(f)});this.B(E.onDidAddCapabilityType(f=>this.b.fire(f))),this.B(E.onDidAddCapability(f=>this.g.fire(f))),this.B(E.onDidRemoveCapabilityType(f=>this.a.fire(f))),this.B(E.onDidRemoveCapability(f=>this.f.fire(f)))}}e.$Mob=M}),define(le[36],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(le[92],he([0,1,3,36]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;const k=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(S){this.collections=S,this.a=new Map,this.b=new Map,S.forEach((g,y)=>{this.d(g,y);const s=g.map.entries();let m=s.next();for(;!m.done;){const h=m.value[1],a=m.value[0];let r=this.a.get(a);if(r||(r=[],this.a.set(a,r)),r.length>0&&r[0].type===L.EnvironmentVariableMutatorType.Replace){m=s.next();continue}const n={extensionIdentifier:y,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};n.scope||delete n.scope,r.unshift(n),m=s.next()}})}async applyToProcessEnvironment(S,g,y){let s;w.$i&&(s={},Object.keys(S).forEach(m=>s[m.toLowerCase()]=m));for(const[m,h]of this.getVariableMap(g)){const a=w.$i&&s[m.toLowerCase()]||m;for(const r of h){const n=y?await y(r.value):r.value;if(r.options?.applyAtProcessCreation??!0)switch(r.type){case L.EnvironmentVariableMutatorType.Append:S[a]=(S[a]||"")+n;break;case L.EnvironmentVariableMutatorType.Prepend:S[a]=n+(S[a]||"");break;case L.EnvironmentVariableMutatorType.Replace:S[a]=n;break}if(r.options?.applyAtShellIntegration??!1){const i=`VSCODE_ENV_${k.get(r.type)}`;S[i]=(S[i]?S[i]+":":"")+m+"="+this.c(n)}}}}c(S){return S.replaceAll(":","\\x3a")}diff(S,g){const y=new Map,s=new Map,m=new Map;if(S.getVariableMap(g).forEach((h,a)=>{const r=this.getVariableMap(g).get(a),n=E(h,r);n&&y.set(a,n)}),this.getVariableMap(g).forEach((h,a)=>{const r=S.getVariableMap(g).get(a),n=E(h,r);n&&m.set(a,n)}),this.getVariableMap(g).forEach((h,a)=>{const r=S.getVariableMap(g).get(a),n=f(h,r);n&&s.set(a,n)}),!(y.size===0&&s.size===0&&m.size===0))return{added:y,changed:s,removed:m}}getVariableMap(S){const g=new Map;for(const y of this.a.values()){const s=y.filter(m=>R(m,S));s.length>0&&g.set(s[0].variable,s)}return g}getDescriptionMap(S){const g=new Map;for(const y of this.b.values()){const s=y.filter(m=>R(m,S,!0));for(const m of s)g.set(m.extensionIdentifier,m.description)}return g}d(S,g){if(!S.descriptionMap)return;const y=S.descriptionMap.entries();let s=y.next();for(;!s.done;){const m=s.value[1],h=s.value[0];let a=this.b.get(h);a||(a=[],this.b.set(h,a));const r={extensionIdentifier:g,scope:m.scope,description:m.description};r.scope||delete r.scope,a.push(r),s=y.next()}}}e.$Cr=M;function R(u,S,g=!1){return u.scope?!!(u.scope.workspaceFolder&&S?.workspaceFolder&&u.scope.workspaceFolder.index===S.workspaceFolder.index):g?S===u.scope:!0}function E(u,S){if(!S)return u;const g=new Set;S.forEach(s=>g.add(s.extensionIdentifier));const y=[];return u.forEach(s=>{g.has(s.extensionIdentifier)||y.push(s)}),y.length===0?void 0:y}function f(u,S){if(!S)return;const g=new Map;S.forEach(s=>g.set(s.extensionIdentifier,s));const y=[];return u.forEach(s=>{const m=g.get(s.extensionIdentifier);m&&(s.type!==m.type||s.value!==m.value||s.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&y.push(m)}),y.length===0?void 0:y}}),define(le[93],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=void 0;function w(f){return[...f.entries()]}e.$wr=w;function L(f){return f?[...f.entries()]:[]}e.$xr=L;function k(f){return new Map(f)}e.$yr=k;function M(f){return new Map(f??[])}e.$zr=M;function R(f){return Array.from(f.entries()).map(u=>[u[0],w(u[1].map),L(u[1].descriptionMap)])}e.$Ar=R;function E(f){return new Map(f.map(u=>[u[0],{map:k(u[1]),descriptionMap:M(u[2])}]))}e.$Br=E}),define(le[94],he([0,1,9,17,4,2,10]),function(oe,e,w,L,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;let E=class extends M.$Sc{constructor(u,S){super(),this.h=S,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$Sd),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$Qc)(()=>{for(const g of this.f.values())(0,M.$Nc)(g)}))}createRequest(u){return new Promise((S,g)=>{const y=++this.a;this.c.set(y,S),this.g.fire({requestId:y,...u});const s=new L.$3d;(0,w.$2g)(this.b,s.token).then(()=>g(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Qc)(()=>s.cancel())])})}acceptReply(u,S){const g=this.c.get(u);g?(this.c.delete(u),(0,M.$Nc)(this.f.get(u)||[]),this.f.delete(u),g(S)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$nr=E,e.$nr=E=$e([je(1,R.$ij)],E)}),define(le[28],he([0,1,21,35,85]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fr=void 0,e.$fr=new L.$fj("terminalTabFocusMode",!1,!0);var M;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",t.LocalEchoEnabled="terminal.integrated.localEchoEnabled",t.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",t.LocalEchoStyle="terminal.integrated.localEchoStyle",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",t.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",t.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",t.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var E;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh"})(E||(e.PosixShellType=E={}));var f;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var u;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var S;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(S||(e.TerminalIpcChannels=S={}));var g;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(g||(e.ProcessPropertyType=g={})),e.$gr=(0,w.$1h)("ptyService");var y;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var s;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(s||(e.TerminalLocation=s={}));var m;(function(t){t.TerminalView="view",t.Editor="editor"})(m||(e.TerminalLocationString=m={}));var h;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var a;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(a||(e.FlowControlConstants=a={}));var r;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(r||(e.ProfileSource=r={}));var n;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$hr={Backend:"workbench.contributions.terminal.processBackend"};class l{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const p=this.b(o.remoteAuthority);if(this.a.has(p))throw new Error(`A terminal backend with remote authority '${p}' was already registered.`);this.a.set(p,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}k.$sn.add(e.$hr.Backend,new l),e.$ir=(0,w.$1h)("localPtyService"),e.$jr=(0,w.$1h)("terminalLogService")}),define(le[95],he([0,1,9,2,3]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class M extends L.$Sc{constructor(E,f,u,S){super(),this.a=0,this.b=!1,this.c=!1,this.B(E.onProcessData(g=>{if(this.b||this.c)return;const y=typeof g=="string"?g:g.data;for(let s=0;s<y.length;s++)y[s]===f[this.a]?this.a++:this.f(),this.a===f.length&&(S.debug(`Auto reply match: "${f}", response: "${u}"`),E.input(u),this.c=!0,(0,w.$2g)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){k.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$rcc=M}),define(le[96],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orb=void 0;class w{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,M,R=5){const E=M(f=>{const u=typeof f=="string"?f:f.data;let S=this.a.get(k);if(S){S.data.push(u);return}const g=setTimeout(()=>this.flushBuffer(k),R);S={data:[u],timeoutId:g,dispose:()=>{clearTimeout(g),this.flushBuffer(k),E.dispose()}},this.a.set(k,S)});return E}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const M=this.a.get(k);M&&(this.a.delete(k),this.b(k,M.data.join("")))}}e.$orb=w}),define(le[37],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=void 0;function L(R){let E=R;E.includes("\\")&&(E=E.replace(/\\/g,"\\\\"));const f=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return E=E.replace(f,""),`'${E}'`}e.$CN=L;function k(R,E,f){if(!R)return"";if(!E)return R;E.match(/[\/\\]$/)&&(E=E.slice(0,E.length-1));const u=R.replace(/\\/g,"/").toLowerCase(),S=E.replace(/\\/g,"/").toLowerCase();return u.includes(S)?`~${f}${R.slice(E.length+1)}`:R}e.$DN=k;function M(R){return R.match(/^['"].*['"]$/)&&(R=R.substring(1,R.length-1)),w.OS===1&&R&&R[1]===":"?R[0].toUpperCase()+R.substring(1):R}e.$EN=M}),define(le[97],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CNb=void 0;function w(L,k={}){let M="";return k.excludeLeadingNewLine||(M+=`\r
`),M+="\x1B[0m\x1B[7m * ",k.loudFormatting?M+="\x1B[0;104m":M+="\x1B[0m",M+=` ${L} \x1B[0m
\r`,M}e.$CNb=w}),define(le[98],he([0,1,2,91,88,89,90,4,86,5,37]),function(oe,e,w,L,k,M,R,E,f,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vob=e.$Uob=e.$Tob=e.$Sob=void 0;var g;(function(n){n[n.FinalTerm=133]="FinalTerm",n[n.VSCode=633]="VSCode",n[n.ITerm=1337]="ITerm",n[n.SetCwd=7]="SetCwd",n[n.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(g||(g={}));var y;(function(n){n.PromptStart="A",n.CommandStart="B",n.CommandExecuted="C",n.CommandFinished="D",n.CommandLine="E",n.ContinuationStart="F",n.ContinuationEnd="G",n.RightPromptStart="H",n.RightPromptEnd="I",n.Property="P",n.SetMark="SetMark"})(y||(y={}));var s;(function(n){n.SetMark="SetMark",n.CurrentDir="CurrentDir"})(s||(s={}));class m extends w.$Sc{get status(){return this.g}constructor(i,l,t,o){super(),this.j=i,this.m=l,this.n=t,this.r=o,this.capabilities=this.B(new L.$Lob),this.b=!1,this.f=[],this.g=0,this.h=new E.$Sd,this.onDidChangeStatus=this.h.event,this.B((0,w.$Qc)(()=>{this.z(),this.s()}))}s(){(0,w.$Nc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(3,this.B(new R.$Qob(this.a))),this.B(i.parser.registerOscHandler(633,l=>this.w(l))),this.B(i.parser.registerOscHandler(1337,l=>this.F(l))),this.f.push(i.parser.registerOscHandler(133,l=>this.t(l))),this.B(i.parser.registerOscHandler(7,l=>this.H(l))),this.B(i.parser.registerOscHandler(9,l=>this.G(l))),this.y()}getMarkerId(i,l){this.L(i).getMark(l)}t(i){const l=this.u(i);return this.g===0&&(this.g=1,this.h.fire(this.g)),l}u(i){if(!this.a)return!1;const[l,...t]=i.split(";");switch(l){case"A":return this.J(this.a).handlePromptStart(),!0;case"B":return this.J(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.J(this.a).handleCommandExecuted(),!0;case"D":{const o=t.length===1?parseInt(t[0]):void 0;return this.J(this.a).handleCommandFinished(o),!0}}return!1}w(i){const l=this.C(i);return!this.b&&l&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),l}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const l=i.indexOf(";"),t=l===-1?i:i.substring(0,l),o=l===-1?[]:i.substring(l+1).split(";");switch(t){case"A":return this.J(this.a).handlePromptStart(),!0;case"B":return this.J(this.a).handleCommandStart(),!0;case"C":return this.J(this.a).handleCommandExecuted(),!0;case"D":{const p=o[0],I=p!==void 0?parseInt(p):void 0;return this.J(this.a).handleCommandFinished(I),!0}case"E":{const p=o[0],I=o[1];let b;return p!==void 0?b=h(p):b="",this.J(this.a).setCommandLine(b,I===this.j),!0}case"F":return this.J(this.a).handleContinuationStart(),!0;case"G":return this.J(this.a).handleContinuationEnd(),!0;case"H":return this.J(this.a).handleRightPromptStart(),!0;case"I":return this.J(this.a).handleRightPromptEnd(),!0;case"P":{const p=o[0],I=p!==void 0?h(p):"",{key:b,value:C}=a(I);if(C===void 0)return!0;switch(b){case"Cwd":return this.D(C),!0;case"IsWindows":return this.J(this.a).setIsWindowsPty(C==="True"),!0;case"Task":return this.L(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.L(this.a).addMark(r(o)),!0}return!1}D(i){i=(0,S.$EN)(i),this.I().updateCwd(i),this.capabilities.get(2)?.setCwd(i)}F(i){if(!this.a)return!1;const[l]=i.split(";");switch(l){case"SetMark":this.L(this.a).addMark();default:{const{key:t,value:o}=a(l);if(o===void 0)return!0;switch(t){case"CurrentDir":return this.D(o),!0}}}return!1}G(i){if(!this.a)return!1;const[l,...t]=i.split(";");switch(l){case"9":return t.length&&this.D(t[0]),!0}return!1}H(i){if(!this.a)return!1;const[l]=i.split(";");if(l.match(/^file:\/\/.*\//)){const t=u.URI.parse(l);if(t.path&&t.path.length>0)return this.D(t.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.J(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.J(this.a).deserialize(i)}I(){let i=this.capabilities.get(0);return i||(i=this.B(new M.$Pob),this.capabilities.add(0,i)),i}J(i){let l=this.capabilities.get(2);return l||(l=this.B(new k.$Nob(i,this.r)),this.capabilities.add(2,l)),l}L(i){let l=this.capabilities.get(4);return l||(l=this.B(new f.$Rob(i)),this.capabilities.add(4,l)),l}}e.$Sob=m;function h(n){return n.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,l,t)=>t?String.fromCharCode(parseInt(t,16)):l)}e.$Tob=h;function a(n){const i=n.indexOf("=");return i===-1?{key:n,value:void 0}:{key:n.substring(0,i),value:n.substring(1+i)}}e.$Uob=a;function r(n){let i,l=!1;for(const t of n)t!==void 0&&(t==="Hidden"&&(l=!0),t.startsWith("Id=")&&(i=t.substring(3)));return{id:i,hidden:l}}e.$Vob=r}),define(le[38],he([0,1,7,14,4,2,62,10]),function(oe,e,w,L,k,M,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=void 0;var f;(function(S){S[S.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",S[S.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(f||(f={})),e.$scc=[];let u=class extends M.$Sc{set hasChildProcesses(g){this.a!==g&&(this.a=g,this.f.debug("ChildProcessMonitor: Has child processes changed",g),this.b.fire(g))}get hasChildProcesses(){return this.a}constructor(g,y){super(),this.c=g,this.f=y,this.a=!1,this.b=this.B(new k.$Sd),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const g=await(0,R.$Or)(this.c);this.hasChildProcesses=this.j(g)}catch(g){this.f.debug("ChildProcessMonitor: Fetching process tree failed",g)}}h(){this.g()}j(g){if(!g.children)return!1;if(g.children.length===1){const y=g.children[0];let s;if(y.cmd.startsWith('"'))s=y.cmd.substring(1,y.cmd.indexOf('"',1));else{const m=y.cmd.indexOf(" ");m===-1?s=y.cmd:s=y.cmd.substring(0,m)}return e.$scc.indexOf((0,w.$qc)(s).name)===-1}return g.children.length>0}};e.$tcc=u,$e([(0,L.$th)(1e3)],u.prototype,"g",null),$e([(0,L.$uh)(5e3)],u.prototype,"h",null),e.$tcc=u=$e([je(1,E.$ij)],u)}),define(le[99],he([0,1,4,2,28]),function(oe,e,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class M extends L.$Sc{constructor(){super(),this.a=this.B(new w.$Sd),this.onBeat=this.a.event;const E=setInterval(()=>{this.a.fire()},k.HeartbeatConstants.BeatInterval);this.B((0,L.$Qc)(()=>clearInterval(E)))}}e.$ucc=M}),define(le[39],he([0,1,20,19,30,7,3,15,11,8,24,36,93,92]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.$Dr=void 0;function m(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let C=0;return b&&b.length===4&&(C=parseInt(b[3])),C}e.$Dr=m;async function h(b,C,v,D=E.env,H=S.Promises.exists){if(M.$ic(b))return await H(b)?b:void 0;if(C===void 0&&(C=E.cwd()),M.$mc(b)!=="."){const P=M.$jc(C,b);return await H(P)?P:void 0}const c=(0,k.$nn)(D,"PATH");if(v===void 0&&(0,u.$Df)(c)&&(v=c.split(M.$tc)),v===void 0||v.length===0){const P=M.$jc(C,b);return await H(P)?P:void 0}for(const P of v){let T;if(M.$ic(P)?T=M.$jc(P,b):T=M.$jc(C,P,b),await H(T))return T;if(R.$i){let A=T+".com";if(await H(A)||(A=T+".exe",await H(A)))return A}}const $=M.$jc(C,b);return await H($)?$:void 0}e.$Er=h;function a(b,C,v,D,H){const W=R.$i&&(!C.windowsEnableConpty||m()<18309);if(!C.shellIntegration.enabled||!b.executable||b.isFeatureTerminal||b.hideFromUser||b.ignoreShellIntegration||W)return;const c=b.args,$=E.$dc==="win32"?M.$nc(b.executable).toLowerCase():M.$nc(b.executable),P=M.$mc(L.$jg.asFileUri("").fsPath);let T;const A={VSCODE_INJECTION:"1"};if(C.shellIntegration.nonce&&(A.VSCODE_NONCE=C.shellIntegration.nonce),R.$i){if($==="pwsh.exe"||$==="powershell.exe")return!c||p(c)?T=i.get(n.WindowsPwsh):o(c)&&(T=i.get(n.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$He)(T[T.length-1],P,""),{newArgs:T,envMixin:A}):void 0;D.warn(`Shell integration cannot be enabled for executable "${b.executable}" and args`,b.args);return}switch($){case"bash":return!c||c.length===0?T=i.get(n.Bash):I(c)&&(A.VSCODE_SHELL_LOGIN="1",r(C,A),T=i.get(n.Bash)),T?(T=[...T],T[T.length-1]=(0,f.$He)(T[T.length-1],P),{newArgs:T,envMixin:A}):void 0;case"fish":{const z=v?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$jc(P,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return A.XDG_DATA_DIRS=`${z}:${ee}`,r(C,A),{newArgs:void 0,envMixin:A}}case"pwsh":return!c||p(c)?T=i.get(n.Pwsh):o(c)&&(T=i.get(n.PwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$He)(T[T.length-1],P,""),{newArgs:T,envMixin:A}):void 0;case"zsh":{if(!c||c.length===0?T=i.get(n.Zsh):I(c)?(T=i.get(n.ZshLogin),r(C,A)):(c===i.get(n.Zsh)||c===i.get(n.ZshLogin))&&(T=c),!T)return;T=[...T],T[T.length-1]=(0,f.$He)(T[T.length-1],P);let z;try{z=w.userInfo().username}catch{z="unknown"}const ee=M.$jc(w.tmpdir(),`${z}-${H.applicationName}-zsh`);A.ZDOTDIR=ee;const ie=v?.ZDOTDIR??w.homedir()??"~";A.USER_ZDOTDIR=ie;const Q=[];return Q.push({source:M.$jc(P,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(ee,".zshrc")}),Q.push({source:M.$jc(P,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(ee,".zprofile")}),Q.push({source:M.$jc(P,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(ee,".zshenv")}),Q.push({source:M.$jc(P,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(ee,".zlogin")}),{newArgs:T,envMixin:A,filesToCopy:Q}}}D.warn(`Shell integration cannot be enabled for executable "${b.executable}" and args`,b.args)}e.$Fr=a;function r(b,C){if(R.$j&&b.environmentVariableCollections){const v=(0,y.$Br)(b.environmentVariableCollections),H=new s.$Cr(v).getVariableMap({workspaceFolder:b.workspaceFolder}).get("PATH"),W=[];if(H)for(const c of H)c.type===g.EnvironmentVariableMutatorType.Prepend&&W.push(c.value);W.length>0&&(C.VSCODE_PATH_PREFIX=W.join(""))}}var n;(function(b){b.WindowsPwsh="windows-pwsh",b.WindowsPwshLogin="windows-pwsh-login",b.Pwsh="pwsh",b.PwshLogin="pwsh-login",b.Zsh="zsh",b.ZshLogin="zsh-login",b.Bash="bash"})(n||(n={}));const i=new Map;i.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),i.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),i.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),i.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),i.set(n.Zsh,["-i"]),i.set(n.ZshLogin,["-il"]),i.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const l=["-login","-l"],t=["-nol","-nologo"];function o(b){return typeof b=="string"?l.includes(b.toLowerCase()):b.length===1&&l.includes(b[0].toLowerCase())||b.length===2&&(l.includes(b[0].toLowerCase())||l.includes(b[1].toLowerCase()))&&(t.includes(b[0].toLowerCase())||t.includes(b[1].toLowerCase()))}function p(b){return typeof b=="string"?t.includes(b.toLowerCase()):b.length===0||b?.length===1&&t.includes(b[0].toLowerCase())}function I(b){return b==="string"&&l.includes(b.toLowerCase())||typeof b!="string"&&b.length===1&&l.includes(b[0].toLowerCase())}}),define(le[100],he([0,1,9,14,4,2,3]),function(oe,e,w,L,k,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;const E=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let f;class u extends M.$Sc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(g){if(super(),this.h=g,this.c="",this.f=new k.$Sd,this.g=new k.$Sd,!R.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${R.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){R.$i&&(await(0,w.$2g)(300),this.getShellName().then(g=>{const y=this.getShellType(g);y!==this.b&&(this.g.fire(y),this.f.fire(g),this.b=y,this.c=g)}))}m(g){if(!g)return"";if(E.indexOf(g.name)===-1||!g.children||g.children.length===0)return g.name;let y=0;for(;y<g.children.length;y++){const s=g.children[y];if(!s.children||s.children.length===0||s.children[0].name!=="conhost.exe")break}return y>=g.children.length?g.name:this.m(g.children[y])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(f||(f=await new Promise((g,y)=>{oe(["@vscode/windows-process-tree"],g,y)})),this.a=new Promise(g=>{f.getProcessTree(this.h,y=>{const s=this.m(y);this.a=void 0,g(s)})}),this.a)}getShellType(g){switch(g.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return}}}e.$vcc=u,$e([(0,L.$th)(500)],u.prototype,"checkShell",null)}),define(le[101],he([0,1,26,9,4,2,7,3,5,24,71,10,84,38,39,100,106]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y,s,m,h,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;var n;(function(p){p[p.DataFlushTimeout=250]="DataFlushTimeout",p[p.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(n||(n={}));var i;(function(p){p[p.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",p[p.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",p[p.WriteMaxChunkSize=50]="WriteMaxChunkSize",p[p.WriteInterval=5]="WriteInterval"})(i||(i={}));const l=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["zsh","zsh"]]);let t=class extends M.$Sc{static{r=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return E.$i?this.t?.shellType:l.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(I,b,C,v,D,H,W,c,$){super(),this.shellLaunchConfig=I,this.N=H,this.O=W,this.P=c,this.Q=$,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new k.$Sd),this.onProcessData=this.I.event,this.J=this.B(new k.$Sd),this.onProcessReady=this.J.event,this.L=this.B(new k.$Sd),this.onDidChangeProperty=this.L.event,this.M=this.B(new k.$Sd),this.onProcessExit=this.M.event;let P;E.$i?P=R.$nc(this.shellLaunchConfig.executable||""):P="xterm-256color",this.D=b,this.a.initialCwd=this.D,this.a.cwd=this.D;const T=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,m.$Dr)()>=18309;this.F={name:P,cwd:b,env:D,cols:C,rows:v,useConpty:T,conptyInheritCursor:T&&!!I.initialText},E.$i&&(T&&C===0&&v===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new o,this.B(this.C.onTrigger(A=>{this.C?.dispose(),this.C=void 0,A.cols&&A.rows&&this.resize(A.cols,A.rows)}))),this.onProcessReady(A=>{this.t=this.B(new h.$vcc(A.pid)),this.B(this.t.onShellTypeChanged(z=>this.L.fire({type:"shellType",value:z}))),this.B(this.t.onShellNameChanged(z=>this.L.fire({type:"title",value:z})))})),this.B((0,M.$Qc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const b=(await Promise.all([this.R(),this.S()])).find(v=>v!==void 0);if(b)return b;let C;if(this.O.shellIntegration.enabled)if(C=(0,m.$Fr)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),C){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),C.envMixin)for(const[v,D]of Object.entries(C.envMixin))this.F.env||={},this.F.env[v]=D;if(C.filesToCopy)for(const v of C.filesToCopy){await u.Promises.mkdir(R.$mc(v.dest),{recursive:!0});try{await u.Promises.copyFile(v.source,v.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,C),C?.newArgs?{injectedArgs:C.newArgs}:void 0}catch(v){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",v),{message:`A native exception occurred during launch (${v.message})`}}}async R(){try{if(!(await u.Promises.stat(this.D)).isDirectory())return{message:(0,S.localize)(0,null,this.D.toString())}}catch(I){if(I?.code==="ENOENT")return{message:(0,S.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const I=this.shellLaunchConfig;if(!I.executable)throw new Error("IShellLaunchConfig.executable not set");const b=I.cwd instanceof f.URI?I.cwd.path:I.cwd,C=I.env&&I.env.PATH?I.env.PATH.split(R.$tc):void 0,v=await(0,m.$Er)(I.executable,b,C,this.N);if(!v)return{message:(0,S.localize)(2,null,I.executable)};try{const D=await u.Promises.stat(v);if(!D.isFile()&&!D.isSymbolicLink())return{message:(0,S.localize)(3,null,I.executable)};I.executable=v}catch(D){if(D?.code!=="EACCES")throw D}}async U(I,b,C){const v=C?.newArgs||I.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",I.executable,v,b);const D=(0,a.spawn)(I.executable,v,b);this.m=D,this.u=this.B(new s.$tcc(D.pid,this.P)),this.u.onDidChangeHasChildProcesses(H=>this.L.fire({type:"hasChildProcesses",value:H})),this.s=new Promise(H=>{this.onProcessReady(()=>H())}),D.onData(H=>{this.H+=H.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,D.pause()),this.P.trace("node-pty.IPty#onData",H),this.I.fire(H),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),D.onExit(H=>{this.g=H.exitCode,this.X()}),this.$(D.pid),this.W(D)}W(I){setTimeout(()=>this.ab(I)),E.$i||(this.w=setInterval(()=>{this.n!==I.process&&this.ab(I)},200))}X(){this.P.getLevel()===g.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!E.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-r.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,L.$2g)(250-(Date.now()-r.b)+50);r.b=Date.now()}}$(I){this.J.fire({pid:I,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(I){if(this.q.isDisposed)return;this.n=I.process,this.L.fire({type:"title",value:this.n});const b=this.currentTitle.replace(/ \(figterm\)$/g,"");this.L.fire({type:"shellType",value:l.get(b)})}shutdown(I){this.P.getLevel()===g.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),I&&!E.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(I,b){if(!(this.q.isDisposed||!this.m)){for(let C=0;C<=Math.floor(I.length/50);C++){const v={isBinary:b||!1,data:I.substr(C*50,50)};this.y.push(v)}this.bb()}}async processBinary(I){this.input(I,!0)}async refreshProperty(I){switch(I){case"cwd":{const b=await this.getCwd();return b!==this.a.cwd&&(this.a.cwd=b,this.L.fire({type:"cwd",value:this.a.cwd})),b}case"initialCwd":{const b=await this.getInitialCwd();return b!==this.a.initialCwd&&(this.a.initialCwd=b,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),b}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(I,b){I==="fixedDimensions"&&(this.a.fixedDimensions=b)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const I=this.y.shift();this.P.trace("node-pty.IPty#write",I.data),I.isBinary?this.m.write(Buffer.from(I.data,"binary")):this.m.write(I.data),this.u?.handleInput()}resize(I,b){if(!this.q.isDisposed&&!(typeof I!="number"||typeof b!="number"||isNaN(I)||isNaN(b))&&this.m){if(I=Math.max(I,1),b=Math.max(b,1),this.C){this.C.cols=I,this.C.rows=b;return}this.P.trace("node-pty.IPty#resize",I,b);try{this.m.resize(I,b)}catch(C){if(this.P.trace("node-pty.IPty#resize exception "+C.message),this.g!==void 0&&C.message!=="ioctl(2) failed, EBADF"&&C.message!=="Cannot resize a pty that has already exited")throw C}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(I){this.H=Math.max(this.H-I,0),this.P.trace(`Flow control: Ack ${I} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(I){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(E.$j)return new Promise(I=>{if(!this.m){I(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,w.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(b,C,v)=>{!b&&C!==""?I(C.substring(C.indexOf("/"),C.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",b,C,v),I(this.D))})});if(E.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await u.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return E.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,m.$Dr)()}:void 0}};e.$wcc=t,e.$wcc=t=r=$e([je(7,g.$ij),je(8,y.$Aj)],t);class o extends M.$Sc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new k.$Sd),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,M.$Qc)(()=>clearTimeout(this.a)))}}}),define(le[102],he([0,1,26,9,4,2,3,63,10,94,28,96,37,107,39,101,70,38,95,6,98,97,76,14,108]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y,s,m,h,a,r,n,i,l,t,o,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;function b(T,A,z){if(typeof z.value!="function")throw new Error("not supported");const ee="value",ie=z.value;z[ee]=async function(...Q){this.traceRpcArgs.logService.getLevel()===f.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${ie.name}(${Q.map(ue=>JSON.stringify(ue)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,L.$2g)(this.traceRpcArgs.simulatedLatency);let se;try{se=await ie.apply(this,Q)}catch(ue){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${ie.name}`,ue),ue}return this.traceRpcArgs.logService.getLevel()===f.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${ie.name}`,se),se}}e.$xcc=b;let C,v;class D extends M.$Sc{H(A,z){return z(ee=>{this.I.getLevel()===f.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${A}.fire(${JSON.stringify(ee)})`)}),z}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(A,z,ee,ie){super(),this.I=A,this.J=z,this.L=ee,this.M=ie,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new k.$Sd),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new k.$Sd),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new k.$Sd),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new k.$Sd),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new k.$Sd),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new k.$Sd),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new k.$Sd),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new k.$Sd),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,M.$Qc)(()=>{for(const Q of this.a.values())Q.shutdown(!0);this.a.clear()})),this.f=this.B(new u.$nr(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(A){r.$scc.length=0,r.$scc.push(...A)}async requestDetachInstance(A,z){return this.f.createRequest({workspaceId:A,instanceId:z})}async acceptDetachInstanceReply(A,z){let ee;const ie=this.a.get(z);ie&&(ee=await this.S(z,ie)),this.f.acceptReply(A,ee)}async freePortKillProcess(A){const ee=(await new Promise((ie,Q)=>{(0,w.exec)(R.$i?`netstat -ano | findstr "${A}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${A}`,{},(se,ue)=>{if(se)return Q("Problem occurred when listing active processes");ie(ue)})})).split(/\r?\n/).filter(ie=>!!ie.trim());if(ee.length>=1){const ie=/\s+(\d+)(?:\s+|$)/,Q=ee[0].match(ie)?.[1];if(Q)try{process.kill(Number.parseInt(Q))}catch{}else throw new Error(`Processes for port ${A} were not found`);return{port:A,processId:Q}}throw new Error(`Could not kill process with port ${A}`)}async serializeTerminalState(A){const z=[];for(const[ie,Q]of this.a.entries())Q.hasWrittenData&&A.indexOf(ie)!==-1&&z.push(L.Promises.withAsyncBody(async se=>{se({id:ie,shellLaunchConfig:Q.shellLaunchConfig,processDetails:await this.S(ie,Q),processLaunchConfig:Q.processLaunchOptions,unicodeVersion:Q.unicodeVersion,replayEvent:await Q.serializeNormalBuffer(),timestamp:Date.now()})}));const ee={version:1,state:await Promise.all(z)};return JSON.stringify(ee)}async reviveTerminalProcesses(A,z,ee){const ie=[];for(const Q of z)ie.push(this.N(A,Q));await Promise.all(ie)}async N(A,z){const ee=(0,a.localize)(0,null),ie=await this.createProcess({...z.shellLaunchConfig,cwd:z.processDetails.cwd,color:z.processDetails.color,icon:z.processDetails.icon,name:z.processDetails.titleSource===S.TitleEventSource.Api?z.processDetails.title:void 0,initialText:z.replayEvent.events[0].data+(0,t.$CNb)(ee,{loudFormatting:!0})},z.processDetails.cwd,z.replayEvent.events[0].cols,z.replayEvent.events[0].rows,z.unicodeVersion,z.processLaunchConfig.env,z.processLaunchConfig.executableEnv,z.processLaunchConfig.options,!0,z.processDetails.workspaceId,z.processDetails.workspaceName,!0,z.replayEvent.events[0].data),Q=this.R(A,z.id);this.g.set(Q,{newId:ie,state:z}),this.I.info(`Revived process, old id ${Q} -> new id ${ie}`)}async shutdownAll(){this.dispose()}async createProcess(A,z,ee,ie,Q,se,ue,fe,J,B,Z,te,q){if(A.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const _=++this.n,ge=new h.$wcc(A,z,ee,ie,se,ue,fe,this.I,this.J),K={env:se,executableEnv:ue,options:fe},d=new W(_,ge,B,Z,J,ee,ie,K,Q,this.L,this.I,te&&typeof A.initialText=="string"?A.initialText:void 0,q,A.icon,A.color,A.name,A.fixedDimensions);return ge.onProcessExit(F=>{d.dispose(),this.a.delete(_),this.C.fire({id:_,event:F})}),d.onProcessData(F=>this.w.fire({id:_,event:F})),d.onProcessReplay(F=>this.y.fire({id:_,event:F})),d.onProcessReady(F=>this.z.fire({id:_,event:F})),d.onProcessOrphanQuestion(()=>this.D.fire({id:_})),d.onDidChangeProperty(F=>this.G.fire({id:_,property:F})),d.onPersistentProcessReady(()=>{for(const F of this.j.entries())d.installAutoReply(F[0],F[1])}),this.a.set(_,d),_}async attachToProcess(A){try{await this.U(A).attach(),this.I.info(`Persistent process reconnection "${A}"`)}catch(z){throw this.I.warn(`Persistent process reconnection "${A}" failed`,z.message),z}}async updateTitle(A,z,ee){this.U(A).setTitle(z,ee)}async updateIcon(A,z,ee,ie){this.U(A).setIcon(z,ee,ie)}async clearBuffer(A){this.U(A).clearBuffer()}async refreshProperty(A,z){return this.U(A).refreshProperty(z)}async updateProperty(A,z,ee){return this.U(A).updateProperty(z,ee)}async detachFromProcess(A,z){return this.U(A).detach(z)}async reduceConnectionGraceTime(){for(const A of this.a.values())A.reduceGraceTime()}async listProcesses(){const A=Array.from(this.a.entries()).filter(([ie,Q])=>Q.shouldPersistTerminal);this.I.info(`Listing ${A.length} persistent terminals, ${this.a.size} total terminals`);const z=A.map(async([ie,Q])=>this.S(ie,Q));return(await Promise.all(z)).filter(ie=>ie.isOrphan)}async getPerformanceMarks(){return I.getMarks()}async start(A){const z=this.a.get(A);return z?z.start():{message:`Could not find pty with id "${A}"`}}async shutdown(A,z){return this.a.get(A)?.shutdown(z)}async input(A,z){return this.U(A).input(z)}async processBinary(A,z){return this.U(A).writeBinary(z)}async resize(A,z,ee){return this.U(A).resize(z,ee)}async getInitialCwd(A){return this.U(A).getInitialCwd()}async getCwd(A){return this.U(A).getCwd()}async acknowledgeDataEvent(A,z){return this.U(A).acknowledgeDataEvent(z)}async setUnicodeVersion(A,z){return this.U(A).setUnicodeVersion(z)}async getLatency(){return[]}async orphanQuestionReply(A){return this.U(A).orphanQuestionReply()}async installAutoReply(A,z){this.j.set(A,z);for(const ee of this.a.values())ee.installAutoReply(A,z)}async uninstallAllAutoReplies(){for(const A of this.j.keys())for(const z of this.a.values())z.uninstallAutoReply(A)}async uninstallAutoReply(A){for(const z of this.a.values())z.uninstallAutoReply(A)}async getDefaultSystemShell(A=R.OS){return(0,E.$Pl)(A,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(A,z){if(z==="win-to-unix"){if(!R.$i)return A;if((0,m.$Dr)()<17063)return A.replace(/\\/g,"/");const ee=this.O();return ee?new Promise(ie=>{(0,w.execFile)(ee,["-e","wslpath",A],{},(se,ue,fe)=>{ie(se?A:(0,y.$CN)(ue.trim()))}).stdin.end()}):A}if(z==="unix-to-win"&&R.$i){if((0,m.$Dr)()<17063)return A;const ee=this.O();return ee?new Promise(ie=>{(0,w.execFile)(ee,["-e","wslpath","-w",A],{},(se,ue,fe)=>{ie(se?A:ue.trim())}).stdin.end()}):A}return A}O(){const A=(0,m.$Dr)()>=16299,z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ee=process.env.SystemRoot;if(ee)return(0,o.join)(ee,z?"Sysnative":"System32",A?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(A,z){try{return this.g.get(this.R(A,z))?.newId}catch(ee){this.I.warn(`Couldn't find terminal ID ${A}-${z}`,ee.message)}}async setTerminalLayoutInfo(A){this.b.set(A.workspaceId,A)}async getTerminalLayoutInfo(A){I.mark("code/willGetTerminalLayoutInfo");const z=this.b.get(A.workspaceId);if(z){const ee=new Set,Q=(await Promise.all(z.tabs.map(async se=>this.P(A.workspaceId,se,ee)))).filter(se=>se.terminals.length>0);return I.mark("code/didGetTerminalLayoutInfo"),{tabs:Q}}I.mark("code/didGetTerminalLayoutInfo")}async P(A,z,ee){const Q=(await Promise.all(z.terminals.map(se=>this.Q(A,se,ee)))).filter(se=>se.terminal!==null);return{isActive:z.isActive,activePersistentProcessId:z.activePersistentProcessId,terminals:Q}}async Q(A,z,ee){try{const ie=this.R(A,z.terminal),Q=this.g.get(ie)?.newId;this.I.info(`Expanding terminal instance, old id ${ie} -> new id ${Q}`),this.g.delete(ie);const se=Q??z.terminal;if(ee.has(se))throw new Error(`Terminal ${se} has already been expanded`);ee.add(se);const ue=this.U(se);return{terminal:{...ue&&await this.S(z.terminal,ue,Q!==void 0),id:se},relativeSize:z.relativeSize}}catch(ie){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",ie.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",z),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:z.relativeSize}}}R(A,z){return`${A}-${z}`}async S(A,z,ee=!1){I.mark(`code/willBuildProcessDetails/${A}`);const[ie,Q]=await Promise.all([z.getCwd(),ee?!0:z.isOrphaned()]),se={id:A,title:z.title,titleSource:z.titleSource,pid:z.pid,workspaceId:z.workspaceId,workspaceName:z.workspaceName,cwd:ie,isOrphan:Q,icon:z.icon,color:z.color,fixedDimensions:z.fixedDimensions,environmentVariableCollections:z.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:z.shellLaunchConfig.reconnectionProperties,waitOnExit:z.shellLaunchConfig.waitOnExit,hideFromUser:z.shellLaunchConfig.hideFromUser,isFeatureTerminal:z.shellLaunchConfig.isFeatureTerminal,type:z.shellLaunchConfig.type,hasChildProcesses:z.hasChildProcesses,shellIntegrationNonce:z.processLaunchOptions.options.shellIntegration.nonce};return I.mark(`code/didBuildProcessDetails/${A}`),se}U(A){const z=this.a.get(A);if(!z)throw new i.$bb("Could not find pty on pty host");return z}}e.$ycc=D,$e([p.$sh],D.prototype,"traceRpcArgs",null),$e([b],D.prototype,"refreshIgnoreProcessNames",null),$e([b],D.prototype,"requestDetachInstance",null),$e([b],D.prototype,"acceptDetachInstanceReply",null),$e([b],D.prototype,"freePortKillProcess",null),$e([b],D.prototype,"serializeTerminalState",null),$e([b],D.prototype,"reviveTerminalProcesses",null),$e([b],D.prototype,"shutdownAll",null),$e([b],D.prototype,"createProcess",null),$e([b],D.prototype,"attachToProcess",null),$e([b],D.prototype,"updateTitle",null),$e([b],D.prototype,"updateIcon",null),$e([b],D.prototype,"clearBuffer",null),$e([b],D.prototype,"refreshProperty",null),$e([b],D.prototype,"updateProperty",null),$e([b],D.prototype,"detachFromProcess",null),$e([b],D.prototype,"reduceConnectionGraceTime",null),$e([b],D.prototype,"listProcesses",null),$e([b],D.prototype,"getPerformanceMarks",null),$e([b],D.prototype,"start",null),$e([b],D.prototype,"shutdown",null),$e([b],D.prototype,"input",null),$e([b],D.prototype,"processBinary",null),$e([b],D.prototype,"resize",null),$e([b],D.prototype,"getInitialCwd",null),$e([b],D.prototype,"getCwd",null),$e([b],D.prototype,"acknowledgeDataEvent",null),$e([b],D.prototype,"setUnicodeVersion",null),$e([b],D.prototype,"getLatency",null),$e([b],D.prototype,"orphanQuestionReply",null),$e([b],D.prototype,"installAutoReply",null),$e([b],D.prototype,"uninstallAllAutoReplies",null),$e([b],D.prototype,"uninstallAutoReply",null),$e([b],D.prototype,"getDefaultSystemShell",null),$e([b],D.prototype,"getEnvironment",null),$e([b],D.prototype,"getWslPath",null),$e([b],D.prototype,"getRevivedPtyNewId",null),$e([b],D.prototype,"setTerminalLayoutInfo",null),$e([b],D.prototype,"getTerminalLayoutInfo",null);var H;(function(T){T.None="None",T.ReplayOnly="ReplayOnly",T.Session="Session"})(H||(H={}));class W extends M.$Sc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(A,z){z===S.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=A,this.O=z}setIcon(A,z,ee){(!this.Y||"id"in z&&"id"in this.Y&&z.id!==this.Y.id||!this.color||ee!==this.Z)&&(this.P.freeRawReviveBuffer(),A&&this.j.setValue("Session","setIcon")),this.Y=z,this.Z=ee}S(A){this.R=A}constructor(A,z,ee,ie,Q,se,ue,fe,J,B,Z,te,q,_,ge,K,d){super(),this.U=A,this.W=z,this.workspaceId=ee,this.workspaceName=ie,this.shouldPersistTerminal=Q,this.processLaunchOptions=fe,this.unicodeVersion=J,this.X=Z,this.Y=_,this.Z=ge,this.b=new Map,this.f=new Map,this.g=!1,this.w=new L.$8g,this.C=this.B(new k.$Sd),this.onProcessReplay=this.C.event,this.D=this.B(new k.$Sd),this.onProcessReady=this.D.event,this.F=this.B(new k.$Sd),this.onPersistentProcessReady=this.F.event,this.G=this.B(new k.$Sd),this.onProcessData=this.G.event,this.H=this.B(new k.$Sd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new k.$Sd),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=S.TitleEventSource.Process,this.j=new c(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=te!==void 0,this.P=new $(se,ue,B.scrollback,J,te,fe.options.shellIntegration.nonce,Q?q:void 0,this.X),K&&this.setTitle(K,S.TitleEventSource.Api),this.R=d,this.n=null,this.u=0,this.y=this.B(new L.$bh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${P(B.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},B.graceTime)),this.z=this.B(new L.$bh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${P(B.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},B.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(F=>{this.L=F.pid,this.M=F.cwd,this.D.fire(F)})),this.B(this.W.onDidChangeProperty(F=>{this.I.fire(F)})),this.a=new g.$orb((F,ne)=>this.G.fire(ne)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(F=>this.P.handleData(F))),this.B((0,M.$Qc)(()=>{for(const F of this.b.values())F.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(A){this.shouldPersistTerminal&&(this.j.value!=="None"||A)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(A){return this.W.refreshProperty(A)}async updateProperty(A,z){if(A==="fixedDimensions")return this.S(z)}async start(){if(!this.g){const A=await this.W.start();return A&&"message"in A||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),A}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(A){return this.W.shutdown(A)}input(A){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const z of this.b.values())z.handleInput();return this.W.input(A)}}writeBinary(A){return this.W.processBinary(A)}resize(A,z){if(!this.J){this.P.handleResize(A,z),this.a.flushBuffer(this.U);for(const ee of this.b.values())ee.handleResize();return this.W.resize(A,z)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(A){this.unicodeVersion=A,this.P.setUnicodeVersion?.(A)}acknowledgeDataEvent(A){if(!this.J)return this.W.acknowledgeDataEvent(A)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const A=await this.P.generateReplayEvent();let z=0;for(const ee of A.events)z+=ee.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${z} chars and ${A.events.length} size events`),this.C.fire(A),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(A,z){this.b.get(A)?.dispose(),this.b.set(A,new n.$rcc(this.W,A,z,this.X))}uninstallAutoReply(A){this.b.get(A)?.dispose(),this.b.delete(A)}sendCommandResult(A,z,ee){this.f.get(A)&&this.f.delete(A)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const A=this.n;this.n=null,A.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new L.$1g(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class c{get value(){return this.b}setValue(A,z){this.b!==A&&(this.b=A,this.f(z))}constructor(A,z,ee){this.a=A,this.b=z,this.d=ee,this.f("initialized")}f(A){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${A}`)}}class ${constructor(A,z,ee,ie,Q,se,ue,fe){this.f=ue,this.a=new s.Terminal({cols:A,rows:z,scrollback:ee,allowProposedApi:!0}),Q&&this.a.writeln(Q),this.setUnicodeVersion(ie),this.b=new l.$Sob(se,!0,void 0,fe),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(A){this.a.write(A)}handleResize(A,z){this.a.resize(A,z)}clearBuffer(){this.a.clear()}async generateReplayEvent(A,z){const ee=new(await this._getSerializeConstructor());this.a.loadAddon(ee);const ie={scrollback:this.a.options.scrollback};A&&(ie.excludeAltBuffer=!0,ie.excludeModes=!0);let Q;return z&&this.f?Q=this.f:Q=ee.serialize(ie),{events:[{cols:this.a.cols,rows:this.a.rows,data:Q}],commands:this.b.serialize()}}async setUnicodeVersion(A){this.a.unicode.activeVersion!==A&&(A==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=A)}async _getUnicode11Constructor(){return v||(v=(await new Promise((A,z)=>{oe(["@xterm/addon-unicode11"],A,z)})).Unicode11Addon),v}async _getSerializeConstructor(){return C||(C=(await new Promise((A,z)=>{oe(["@xterm/addon-serialize"],A,z)})).SerializeAddon),C}}function P(T){let A=0,z=0,ee=0;T>=1e3&&(ee=Math.floor(T/1e3),T-=ee*1e3),ee>=60&&(z=Math.floor(ee/60),ee-=z*60),z>=60&&(A=Math.floor(z/60),z-=A*60);const ie=A?`${A}h`:"",Q=z?`${z}m`:"",se=ee?`${ee}s`:"",ue=T?`${T}ms`:"";return`${ie}${Q}${se}${ue}`}}),define(le[109],he([0,1,60,27,64,65,12,74,77,10,79,80,82,83,28,99,102,31,9,2]),function(oe,e,w,L,k,M,R,E,f,u,S,g,y,s,m,h,a,r,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),l();async function l(){const t=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),o=parseInt(process.env.VSCODE_LATENCY??"0"),p={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,t&&await(0,n.$2g)(t);const I=(0,r.$oU)(process);let b;I?b=new M.$pU:b=new k.$bq(m.TerminalIpcChannels.PtyHost);const C={_serviceBrand:void 0,...s.default},v=new f.$vm((0,E.$Sl)(process.argv,E.$Rl),C),D=new y.$2N((0,u.$wj)(v),v.logsHome);b.registerChannel(m.TerminalIpcChannels.Logger,new S.$lr(D,()=>w.$Ym));const H=D.createLogger("ptyhost",{name:(0,R.localize)(0,null)}),W=new g.$_N(H);t&&W.warn(`Pty Host startup is delayed ${t}ms`),o&&W.warn(`Pty host is simulating ${o}ms latency`);const c=new i.$Rc,$=new h.$ucc;b.registerChannel(m.TerminalIpcChannels.Heartbeat,L.ProxyChannel.fromService($,c));const P=new a.$ycc(W,C,p,o),T=L.ProxyChannel.fromService(P,c);b.registerChannel(m.TerminalIpcChannels.PtyHost,T),I&&b.registerChannel(m.TerminalIpcChannels.PtyHostWindow,T),process.once("exit",()=>{W.trace("Pty host exiting"),W.dispose(),$.dispose(),P.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42053f37e98a2dbaa0d108807491e716105dccd2/core/vs/platform/terminal/node/ptyHostMain.js.map
