/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(me){for(var e=[],D=0,N=me.length;D<N;D++)e[D]=Se[me[D]];return e};define(Se[157],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,R=new Map,b=new Map;function $(v,k){v.has(k.detail)||v.set(k.detail,-k.timestamp)}function y(v,k){const u=v.get(k.detail);u&&(u>=0||v.set(k.detail,u+k.timestamp))}let M=[];typeof me=="function"&&typeof me.getStats=="function"&&(M=me.getStats().slice(0).sort((v,k)=>v.timestamp-k.timestamp));for(const v of M)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(I,v);break;case 22:y(I,v);break;case 33:$(R,v);break;case 34:y(R,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;R.forEach(v=>C+=v);function m(v){const k=[];return v.forEach((u,f)=>k.push([f,u])),k}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(R),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let R="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,M)=>{typeof y>"u"&&(y=$[M]="-");const C=y.toString().length;b[M]=Math.max(C,b[M])})}),g.forEach(($,y)=>{R+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),R+=`|
`,g.forEach(($,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,I.forEach($=>{$.forEach((y,M)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[M]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(Se[158],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(u,f,s){const i=N(u,f);if(i!==-1)return u[i]}e.$fb=D;function N(u,f,s=u.length-1){for(let i=s;i>=0;i--){const n=u[i];if(f(n))return i}return-1}e.$gb=N;function g(u,f){const s=I(u,f);return s===-1?void 0:u[s]}e.$hb=g;function I(u,f,s=0,i=u.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(u[a])?n=a+1:o=a}return n-1}e.$ib=I;function R(u,f){const s=b(u,f);return s===u.length?void 0:u[s]}e.$jb=R;function b(u,f,s=0,i=u.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(u[a])?o=a:n=a+1}return n}e.$kb=b;function $(u,f,s=0,i=u.length){const n=b(u,f,s,i);return n===u.length?-1:n}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=I(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=y;function M(u,f){if(u.length===0)return;let s=u[0];for(let i=1;i<u.length;i++){const n=u[i];f(n,s)>0&&(s=n)}return s}e.$nb=M;function C(u,f){if(u.length===0)return;let s=u[0];for(let i=1;i<u.length;i++){const n=u[i];f(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(u,f){return M(u,(s,i)=>-f(s,i))}e.$pb=m;function v(u,f){if(u.length===0)return-1;let s=0;for(let i=1;i<u.length;i++){const n=u[i];f(n,u[s])>0&&(s=i)}return s}e.$qb=v;function k(u,f){for(const s of u){const i=f(s);if(i!==void 0)return i}}e.$rb=k}),define(Se[73],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(R,b){const $=Object.create(null);for(const y of R){const M=b(y);let C=$[M];C||(C=$[M]=[]),C.push(y)}return $}e.$K=D;function N(R,b){const $=[],y=[];for(const M of R)b.has(M)||$.push(M);for(const M of b)R.has(M)||y.push(M);return{removed:$,added:y}}e.$L=N;function g(R,b){const $=[],y=[];for(const[M,C]of R)b.has(M)||$.push(C);for(const[M,C]of b)R.has(M)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(R,b){const $=new Set;for(const y of b)R.has(y)&&$.add(y);return $}e.$N=I}),define(Se[59],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function D(R){return(b,$,y)=>{let M=null,C=null;if(typeof y.value=="function"?(M="value",C=y.value):typeof y.get=="function"&&(M="get",C=y.get),!C)throw new Error("not supported");y[M]=R(C,$)}}function N(R,b,$){let y=null,M=null;if(typeof $.value=="function"?(y="value",M=$.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",M=$.get),!M)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[C]}}e.$sh=N;function g(R,b,$){return D((y,M)=>{const C=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},R)}})}e.$th=g;function I(R,b,$){return D((y,M)=>{const C=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,v=`$throttle$lastRun$${M}`,k=`$throttle$pending$${M}`;return function(...u){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...u)),this[k])return;const f=this[v]+R;f<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$uh=I}),define(Se[8],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=N;function g(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(a){y(a)||e.$X.onUnexpectedError(a)}e.$1=I;function R(a){y(a)||e.$X.onUnexpectedExternalError(a)}e.$2=R;function b(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=b;const $="Canceled";function y(a){return a instanceof M?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=y;class M extends Error{constructor(){super($),this.name=this.message}}e.$5=M;function C(){const a=new Error($);return a.name=a.message,a}e.$6=C;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=m;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=v;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function u(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=u;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(Se[19],ke([1,0,8,158]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(he,ge=0){return he[he.length-(1+ge)]}e.$sb=g;function I(he){if(he.length===0)throw new Error("Invalid tail call");return[he.slice(0,he.length-1),he[he.length-1]]}e.$tb=I;function R(he,ge,_=(ie,G)=>ie===G){if(he===ge)return!0;if(!he||!ge||he.length!==ge.length)return!1;for(let ie=0,G=he.length;ie<G;ie++)if(!_(he[ie],ge[ie]))return!1;return!0}e.$ub=R;function b(he,ge){const _=he.length-1;ge<_&&(he[ge]=he[_]),he.pop()}e.$vb=b;function $(he,ge,_){return y(he.length,ie=>_(he[ie],ge))}e.$wb=$;function y(he,ge){let _=0,ie=he-1;for(;_<=ie;){const G=(_+ie)/2|0,te=ge(G);if(te<0)_=G+1;else if(te>0)ie=G-1;else return G}return-(_+1)}e.$xb=y;function M(he,ge,_){if(he=he|0,he>=ge.length)throw new TypeError("invalid index");const ie=ge[Math.floor(ge.length*Math.random())],G=[],te=[],fe=[];for(const we of ge){const Ae=_(we,ie);Ae<0?G.push(we):Ae>0?te.push(we):fe.push(we)}return he<G.length?M(he,G,_):he<G.length+fe.length?fe[0]:M(he-(G.length+fe.length),te,_)}e.$yb=M;function C(he,ge){const _=[];let ie;for(const G of he.slice(0).sort(ge))!ie||ge(ie[0],G)!==0?(ie=[G],_.push(ie)):ie.push(G);return _}e.$zb=C;function*m(he,ge){let _,ie;for(const G of he)ie!==void 0&&ge(ie,G)?_.push(G):(_&&(yield _),_=[G]),ie=G;_&&(yield _)}e.$Ab=m;function v(he,ge){for(let _=0;_<=he.length;_++)ge(_===0?void 0:he[_-1],_===he.length?void 0:he[_])}e.$Bb=v;function k(he,ge){for(let _=0;_<he.length;_++)ge(_===0?void 0:he[_-1],he[_],_+1===he.length?void 0:he[_+1])}e.$Cb=k;function u(he,ge,_){const ie=[];function G(we,Ae,be){if(Ae===0&&be.length===0)return;const De=ie[ie.length-1];De&&De.start+De.deleteCount===we?(De.deleteCount+=Ae,De.toInsert.push(...be)):ie.push({start:we,deleteCount:Ae,toInsert:be})}let te=0,fe=0;for(;;){if(te===he.length){G(te,0,ge.slice(fe));break}if(fe===ge.length){G(te,he.length-te,[]);break}const we=he[te],Ae=ge[fe],be=_(we,Ae);be===0?(te+=1,fe+=1):be<0?(G(te,1,[]),te+=1):be>0&&(G(te,0,[Ae]),fe+=1)}return ie}e.$Db=u;function f(he,ge,_){const ie=u(he,ge,_),G=[],te=[];for(const fe of ie)G.push(...he.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:G,added:te}}e.$Eb=f;function s(he,ge,_){if(_===0)return[];const ie=he.slice(0,_).sort(ge);return n(he,ge,ie,_,he.length),ie}e.top=s;function i(he,ge,_,ie,G){return _===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const we=he.length,Ae=he.slice(0,_).sort(ge);for(let be=_,De=Math.min(_+ie,we);be<we;be=De,De=Math.min(De+ie,we)){if(be>_&&await new Promise(z=>setTimeout(z)),G&&G.isCancellationRequested)throw new D.$5;n(he,ge,Ae,be,De)}return Ae})().then(te,fe)})}e.$Gb=i;function n(he,ge,_,ie,G){for(const te=_.length;ie<G;ie++){const fe=he[ie];if(ge(fe,_[te-1])<0){_.pop();const we=(0,N.$kb)(_,Ae=>ge(fe,Ae)<0);_.splice(we,0,fe)}}}function o(he){return he.filter(ge=>!!ge)}e.$Hb=o;function a(he){let ge=0;for(let _=0;_<he.length;_++)he[_]&&(he[ge]=he[_],ge+=1);he.length=ge}e.$Ib=a;function t(he,ge,_){he.splice(_,0,he.splice(ge,1)[0])}e.$Jb=t;function r(he){return!Array.isArray(he)||he.length===0}e.$Kb=r;function d(he){return Array.isArray(he)&&he.length>0}e.$Lb=d;function l(he,ge=_=>_){const _=new Set;return he.filter(ie=>{const G=ge(ie);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=l;function c(he){const ge=new Set;return _=>{const ie=he(_);return ge.has(ie)?!1:(ge.add(ie),!0)}}e.$Nb=c;function h(he,ge){return he.length>0?he[0]:ge}e.$Ob=h;function S(he,ge){return he.length>0?he[he.length-1]:ge}e.$Pb=S;function L(he,ge,_=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(he.length,ge.length);G<te&&_(he[G],ge[G]);G++)ie++;return ie}e.$Qb=L;function w(he){return[].concat(...he)}e.$Rb=w;function p(he,ge){let _=typeof ge=="number"?he:0;typeof ge=="number"?_=he:(_=0,ge=he);const ie=[];if(_<=ge)for(let G=_;G<ge;G++)ie.push(G);else for(let G=_;G>ge;G--)ie.push(G);return ie}e.$Sb=p;function E(he,ge,_){return he.reduce((ie,G)=>(ie[ge(G)]=_?_(G):G,ie),Object.create(null))}e.$Tb=E;function A(he,ge){return he.push(ge),()=>B(he,ge)}e.$Ub=A;function B(he,ge){const _=he.indexOf(ge);if(_>-1)return he.splice(_,1),ge}e.$Vb=B;function O(he,ge,_){const ie=he.slice(0,ge),G=he.slice(ge);return ie.concat(_,G)}e.$Wb=O;function P(he,ge){let _;if(typeof ge=="number"){let ie=ge;_=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ie=he.length-1;ie>0;ie-=1){const G=Math.floor(_()*(ie+1)),te=he[ie];he[ie]=he[G],he[G]=te}}e.$Xb=P;function j(he,ge){const _=he.indexOf(ge);_>-1&&(he.splice(_,1),he.unshift(ge))}e.$Yb=j;function T(he,ge){const _=he.indexOf(ge);_>-1&&(he.splice(_,1),he.push(ge))}e.$Zb=T;function F(he,ge){for(const _ of ge)he.push(_)}e.$1b=F;function W(he,ge){return Array.isArray(he)?he.map(ge):ge(he)}e.$2b=W;function X(he){return Array.isArray(he)?he:[he]}e.$3b=X;function ce(he){return he[Math.floor(Math.random()*he.length)]}e.$4b=ce;function J(he,ge,_){const ie=x(he,ge),G=he.length,te=_.length;he.length=G+te;for(let fe=G-1;fe>=ie;fe--)he[fe+te]=he[fe];for(let fe=0;fe<te;fe++)he[fe+ie]=_[fe]}e.$5b=J;function Y(he,ge,_,ie){const G=x(he,ge);let te=he.splice(G,_);return te===void 0&&(te=[]),J(he,G,ie),te}e.$6b=Y;function x(he,ge){return ge<0?Math.max(ge+he.length,0):Math.min(ge,he.length)}var se;(function(he){function ge(te){return te<0}he.isLessThan=ge;function _(te){return te<=0}he.isLessThanOrEqual=_;function ie(te){return te>0}he.isGreaterThan=ie;function G(te){return te===0}he.isNeitherLessOrGreaterThan=G,he.greaterThan=1,he.lessThan=-1,he.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function Z(he,ge){return(_,ie)=>ge(he(_),he(ie))}e.$7b=Z;function ve(...he){return(ge,_)=>{for(const ie of he){const G=ie(ge,_);if(!se.isNeitherLessOrGreaterThan(G))return G}return se.neitherLessOrGreaterThan}}e.$8b=ve;const de=(he,ge)=>he-ge;e.$9b=de;const H=(he,ge)=>(0,e.$9b)(he?1:0,ge?1:0);e.$0b=H;function U(he){return(ge,_)=>-he(ge,_)}e.$$b=U;class ne{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=ne;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(ie=>ge(ie)?_(ie):!0))}map(ge){return new ye(_=>this.iterate(ie=>_(ge(ie))))}some(ge){let _=!1;return this.iterate(ie=>(_=ge(ie),!_)),_}findFirst(ge){let _;return this.iterate(ie=>ge(ie)?(_=ie,!1):!0),_}findLast(ge){let _;return this.iterate(ie=>(ge(ie)&&(_=ie),!0)),_}findLastMaxBy(ge){let _,ie=!0;return this.iterate(G=>((ie||se.isGreaterThan(ge(G,_)))&&(ie=!1,_=G),!0)),_}}e.$ac=ye}),define(Se[60],ke([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function N($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=N;function g($,y="Unreachable"){throw new Error(y)}e.$5c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$6c=I;function R($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=R;function b($,y){let M=0;for(;M<$.length-1;){const C=$[M],m=$[M+1];if(!y(C,m))return!1;M++}return!0}e.$8c=b}),define(Se[74],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,g){const I=this;let R=!1,b;return function(){if(R)return b;if(R=!0,g)try{b=N.apply(I,arguments)}finally{g()}else b=N.apply(I,arguments);return b}}e.$db=D}),define(Se[121],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$TM=D,e.$UM=new D("id#")}),define(Se[52],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}N.is=g;const I=Object.freeze([]);function R(){return I}N.empty=R;function*b(a){yield a}N.single=b;function $(a){return g(a)?a:b(a)}N.wrap=$;function y(a){return a||I}N.from=y;function*M(a){for(let t=a.length-1;t>=0;t--)yield a[t]}N.reverse=M;function C(a){return!a||a[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(a){return a[Symbol.iterator]().next().value}N.first=m;function v(a,t){for(const r of a)if(t(r))return!0;return!1}N.some=v;function k(a,t){for(const r of a)if(t(r))return r}N.find=k;function*u(a,t){for(const r of a)t(r)&&(yield r)}N.filter=u;function*f(a,t){let r=0;for(const d of a)yield t(d,r++)}N.map=f;function*s(...a){for(const t of a)yield*t}N.concat=s;function i(a,t,r){let d=r;for(const l of a)d=t(d,l);return d}N.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}N.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let l=0;l<t;l++){const c=d.next();if(c.done)return[r,N.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return d}}]}N.consume=o})(D||(e.Iterable=D={}))}),define(Se[159],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,r=!1){let d=0;const l=t.length;let c="",h=0,S=16,L=0;function w(j){let T=0,F=0;for(;T<j;){const W=t.charCodeAt(d);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;d++,T++}return T<j&&(F=-1),F}function p(j){d=j,c="",h=0,S=16,L=0}function E(){const j=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&y(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&y(t.charCodeAt(d)))for(d++;d<t.length&&y(t.charCodeAt(d));)d++;else return L=3,t.substring(j,d);let T=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&y(t.charCodeAt(d))){for(d++;d<t.length&&y(t.charCodeAt(d));)d++;T=d}else L=3;return t.substring(j,T)}function A(){let j="",T=d;for(;;){if(d>=l){j+=t.substring(T,d),L=2;break}const F=t.charCodeAt(d);if(F===34){j+=t.substring(T,d),d++;break}if(F===92){if(j+=t.substring(T,d),d++,d>=l){L=2;break}switch(t.charCodeAt(d++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=w(4);X>=0?j+=String.fromCharCode(X):L=4;break}default:L=5}T=d;continue}if(F>=0&&F<=31)if($(F)){j+=t.substring(T,d),L=2;break}else L=6;d++}return j}function B(){if(c="",L=0,h=d,d>=l)return h=l,S=17;let j=t.charCodeAt(d);if(b(j)){do d++,c+=String.fromCharCode(j),j=t.charCodeAt(d);while(b(j));return S=15}if($(j))return d++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),S=14;switch(j){case 123:return d++,S=1;case 125:return d++,S=2;case 91:return d++,S=3;case 93:return d++,S=4;case 58:return d++,S=6;case 44:return d++,S=5;case 34:return d++,c=A(),S=10;case 47:{const T=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!$(t.charCodeAt(d));)d++;return c=t.substring(T,d),S=12}if(t.charCodeAt(d+1)===42){d+=2;const F=l-1;let W=!1;for(;d<F;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,L=1),c=t.substring(T,d),S=13}return c+=String.fromCharCode(j),d++,S=16}case 45:if(c+=String.fromCharCode(j),d++,d===l||!y(t.charCodeAt(d)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),S=11;default:for(;d<l&&O(j);)d++,j=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return c+=String.fromCharCode(j),d++,S=16}}function O(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let j;do j=B();while(j>=12&&j<=15);return j}return{setPosition:p,getPosition:()=>d,scan:r?P:B,getToken:()=>S,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>L}}e.$7m=R;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function C(t,r){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(w,p,E,A){h.value=w,h.offset=p,h.length=E,h.type=A,h.colonOffset=void 0,c=h}try{n(t,{onObjectBegin:(w,p)=>{if(r<=w)throw l;c=void 0,S=r>w,d.push("")},onObjectProperty:(w,p,E)=>{if(r<p||(L(w,p,E,"property"),d[d.length-1]=w,r<=p+E))throw l},onObjectEnd:(w,p)=>{if(r<=w)throw l;c=void 0,d.pop()},onArrayBegin:(w,p)=>{if(r<=w)throw l;c=void 0,d.push(0)},onArrayEnd:(w,p)=>{if(r<=w)throw l;c=void 0,d.pop()},onLiteralValue:(w,p,E)=>{if(r<p||(L(w,p,E,a(w)),r<=p+E))throw l},onSeparator:(w,p,E)=>{if(r<=p)throw l;if(w===":"&&c&&c.type==="property")c.colonOffset=p,S=!1,c=void 0;else if(w===","){const A=d[d.length-1];typeof A=="number"?d[d.length-1]=A+1:(S=!0,d[d.length-1]=""),c=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:c,isAtPropertyKey:S,matches:w=>{let p=0;for(let E=0;p<w.length&&E<d.length;E++)if(w[p]===d[E]||w[p]==="*")p++;else if(w[p]!=="**")return!1;return p===w.length}}}e.$8m=C;function m(t,r=[],d=I.DEFAULT){let l=null,c=[];const h=[];function S(w){Array.isArray(c)?c.push(w):l!==null&&(c[l]=w)}return n(t,{onObjectBegin:()=>{const w={};S(w),h.push(c),c=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const w=[];S(w),h.push(c),c=w,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:S,onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},d),c[0]}e.$9m=m;function v(t,r=[],d=I.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}n(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,p,E)=>{l=h({type:"property",offset:p,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:p,length:E,parent:l})},onObjectEnd:(w,p)=>{l.length=w+p-l.offset,l=l.parent,c(w+p)},onArrayBegin:(w,p)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,p)=>{l.length=w+p-l.offset,l=l.parent,c(w+p)},onLiteralValue:(w,p,E)=>{h({type:a(w),offset:p,length:E,parent:l,value:w}),c(p+E)},onSeparator:(w,p,E)=>{l.type==="property"&&(w===":"?l.colonOffset=p:w===","&&c(p))},onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},d);const L=l.children[0];return L&&delete L.parent,L}e.$0m=v;function k(t,r){if(!t)return;let d=t;for(const l of r)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}e.$$m=k;function u(t){if(!t.parent||!t.parent.children)return[];const r=u(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$_m=u;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(r[d.children[0].value]=f(l))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$an=f;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$bn=s;function i(t,r,d=!1){if(s(t,r,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=r;c++){const h=i(l[c],r,d);if(h)return h}return t}}e.$cn=i;function n(t,r,d=I.DEFAULT){const l=R(t,!1);function c(Z){return Z?()=>Z(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(Z){return Z?ve=>Z(ve,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=c(r.onObjectBegin),L=h(r.onObjectProperty),w=c(r.onObjectEnd),p=c(r.onArrayBegin),E=c(r.onArrayEnd),A=h(r.onLiteralValue),B=h(r.onSeparator),O=c(r.onComment),P=h(r.onError),j=d&&d.disallowComments,T=d&&d.allowTrailingComma;function F(){for(;;){const Z=l.scan();switch(l.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:j||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:j?W(10):O();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,ve=[],de=[]){if(P(Z),ve.length+de.length>0){let H=l.getToken();for(;H!==17;){if(ve.indexOf(H)!==-1){F();break}else if(de.indexOf(H)!==-1)break;H=F()}}}function X(Z){const ve=l.getTokenValue();return Z?A(ve):L(ve),F(),!0}function ce(){switch(l.getToken()){case 11:{let Z=0;try{Z=JSON.parse(l.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}A(Z);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return F(),!0}function J(){return l.getToken()!==10?(W(3,[],[2,5]),!1):(X(!1),l.getToken()===6?(B(":"),F(),se()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Y(){S(),F();let Z=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Z||W(4,[],[]),B(","),F(),l.getToken()===2&&T)break}else Z&&W(6,[],[]);J()||W(4,[],[2,5]),Z=!0}return w(),l.getToken()!==2?W(7,[2],[]):F(),!0}function x(){p(),F();let Z=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Z||W(4,[],[]),B(","),F(),l.getToken()===4&&T)break}else Z&&W(6,[],[]);se()||W(4,[],[4,5]),Z=!0}return E(),l.getToken()!==4?W(8,[4],[]):F(),!0}function se(){switch(l.getToken()){case 3:return x();case 1:return Y();case 10:return X(!0);default:return ce()}}return F(),l.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):se()?(l.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$dn=n;function o(t,r){const d=R(t),l=[];let c,h=0,S;do switch(S=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==S&&l.push(t.substring(h,S)),r!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(c!==17);return l.join("")}e.$en=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$fn=a}),define(Se[43],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const R=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(R){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$3c=N}),define(Se[28],ke([1,0]),function(me,e){"use strict";var D,N,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$xc=I;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$yc=R;function b(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class M{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof M)this.b=new Map(n.b),this.c=o??M.a;else if(y(n)){this.b=new Map,this.c=o??M.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??M.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$Ac=M;class C{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this.a=new M(n):(this.a=new M(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Cc=v;class k extends v{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class u{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Ec=u;class f{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=f;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Gc=s}),define(Se[3],ke([1,0,19,73,28,74,52]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(A){let B=this.b.get(A);return B||(B={parent:null,source:null,isSingleton:!1,value:A,idx:y.a++},this.b.set(A,B)),B}trackDisposable(A){const B=this.c(A);B.source||(B.source=new Error().stack)}setParent(A,B){const O=this.c(A);O.parent=B}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,B){const O=B.get(A);if(O)return O;const P=A.parent?this.f(this.c(A.parent),B):A;return B.set(A,P),P}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,A).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(A=10,B){let O;if(B)O=B;else{const W=new Map,X=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,W).isSingleton);if(X.length===0)return;const ce=new Set(X.map(J=>J.value));if(O=X.filter(J=>!(J.parent&&ce.has(J.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function P(W){function X(J,Y){for(;J.length>0&&Y.some(x=>typeof x=="string"?x===J[0]:J[0].match(x));)J.shift()}const ce=W.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return X(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const j=new g.$Gc;for(const W of O){const X=P(W);for(let ce=0;ce<=X.length;ce++)j.add(X.slice(0,ce).join(`
`),W)}O.sort((0,D.$7b)(W=>W.idx,D.$9b));let T="",F=0;for(const W of O.slice(0,A)){F++;const X=P(W),ce=[];for(let J=0;J<X.length;J++){let Y=X[J];Y=`(shared with ${j.get(X.slice(0,J+1).join(`
`)).size}/${O.length} leaks) at ${Y}`;const se=j.get(X.slice(0,J).join(`
`)),Z=(0,N.$K)([...se].map(ve=>P(ve)[J]),ve=>ve);delete Z[X[J]];for(const[ve,de]of Object.entries(Z))ce.unshift(`    - stacktraces of ${de.length} other leaks continue with ${ve}`);ce.unshift(Y)}T+=`


==================== Leaking disposable ${F}/${O.length}: ${W.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return O.length>A&&(T+=`


... and ${O.length-A} more leaking disposables

`),{leaks:O,details:T}}}e.$Hc=y;function M(E){$=E}if(e.$Ic=M,b){const E="__is_disposable_tracked__";M(new class{trackDisposable(A){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[E]||console.log(B)},3e3)}setParent(A,B){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsSingleton(A){}})}function C(E){return $?.trackDisposable(E),E}e.$Jc=C;function m(E){$?.markAsDisposed(E)}e.$Kc=m;function v(E,A){$?.setParent(E,A)}function k(E,A){if($)for(const B of E)$.setParent(B,A)}function u(E){return $?.markAsSingleton(E),E}e.$Lc=u;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=f;function s(E){if(R.Iterable.is(E)){const A=[];for(const B of E)if(B)try{B.dispose()}catch(O){A.push(O)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=s;function i(E){for(const A of E)f(A)&&A.dispose();return[]}e.$Oc=i;function n(...E){const A=o(()=>s(E));return k(E,A),A}e.$Pc=n;function o(E){const A=C({dispose:(0,I.$db)(()=>{m(A),E()})});return A}e.$Qc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return v(A,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),v(A,null))}}e.$Rc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Sc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&v(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&v(A,null),A}}e.$Tc=r;class d{constructor(A){this.a=new r,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=d;class l{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(A){let B=A;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,m(this))},this}}e.$Wc=c;class h{constructor(){this.a=new Map}acquire(A,...B){let O=this.a.get(A);O||(O={counter:0,object:this.b(A,...B)},this.a.set(A,O));const{object:P}=O,j=(0,I.$db)(()=>{--O.counter===0&&(this.c(A,O.object),this.a.delete(A))});return O.counter++,{object:P,dispose:j}}}e.$Xc=h;class S{constructor(A){this.a=A}async acquire(A,...B){const O=this.a.acquire(A,...B);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(P){throw O.dispose(),P}}}e.$Yc=S;class L{constructor(A){this.object=A}dispose(){}}e.$Zc=L;function w(E){const A=new a;try{E(A)}finally{A.dispose()}}e.$1c=w;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,B,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(A)?.dispose(),this.a.set(A,B)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=p}),function(me,e){typeof define=="function"&&define.amd?define(Se[160],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var ie=0;ie<_.length;ie++){var G=_[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,_,ie){return _&&e(ge.prototype,_),ie&&e(ge,ie),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function N(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var ie=Object.prototype.toString.call(ge).slice(8,-1);if(ie==="Object"&&ge.constructor&&(ie=ge.constructor.name),ie==="Map"||ie==="Set")return Array.from(ge);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var ie=0,G=new Array(_);ie<_;ie++)G[ie]=ge[ie];return G}function I(ge,_){var ie=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(ie)return(ie=ie.call(ge)).next.bind(ie);if(Array.isArray(ge)||(ie=N(ge))||_&&ge&&typeof ge.length=="number"){ie&&(ge=ie);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(_){return m[_]};function k(ge,_){if(_){if($.test(ge))return ge.replace(y,v)}else if(M.test(ge))return ge.replace(C,v);return ge}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(u,function(_,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var ie={replace:function(te,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),ge=ge.replace(te,fe),ie},getRegex:function(){return new RegExp(ge,_)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(ge,_,ie){if(ge){var G;try{G=decodeURIComponent(f(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!o.test(ie)&&(ie=c(_,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ge,_){t[" "+ge]||(r.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=w(ge,"/",!0)),ge=t[" "+ge];var ie=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?ie?_:ge.replace(d,"$1")+_:_.charAt(0)==="/"?ie?_:ge.replace(l,"$1")+_:ge+_}var h={exec:function(){}};function S(ge){for(var _=1,ie,G;_<arguments.length;_++){ie=arguments[_];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(ge[G]=ie[G])}return ge}function L(ge,_){var ie=ge.replace(/\|/g,function(fe,we,Ae){for(var be=!1,De=we;--De>=0&&Ae[De]==="\\";)be=!be;return be?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function w(ge,_,ie){var G=ge.length;if(G===0)return"";for(var te=0;te<G;){var fe=ge.charAt(G-te-1);if(fe===_&&!ie)te++;else if(fe!==_&&ie)te++;else break}return ge.slice(0,G-te)}function p(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var ie=ge.length,G=0,te=0;te<ie;te++)if(ge[te]==="\\")te++;else if(ge[te]===_[0])G++;else if(ge[te]===_[1]&&(G--,G<0))return te;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ge,_){if(_<1)return"";for(var ie="";_>1;)_&1&&(ie+=ge),_>>=1,ge+=ge;return ie+ge}function B(ge,_,ie,G){var te=_.href,fe=_.title?k(_.title):null,we=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:ie,href:te,title:fe,text:we,tokens:G.inlineTokens(we)};return G.state.inLink=!1,Ae}return{type:"image",raw:ie,href:te,title:fe,text:k(we)}}function O(ge,_){var ie=ge.match(/^(\s+)(?:```)/);if(ie===null)return _;var G=ie[1];return _.split(`
`).map(function(te){var fe=te.match(/^\s+/);if(fe===null)return te;var we=fe[0];return we.length>=G.length?te.slice(G.length):te}).join(`
`)}var P=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},_.code=function(G){var te=this.rules.block.code.exec(G);if(te){var fe=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:w(fe,`
`)}}},_.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var fe=te[0],we=O(fe,te[3]||"");return{type:"code",raw:fe,lang:te[2]?te[2].trim():te[2],text:we}}},_.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var fe=te[2].trim();if(/#$/.test(fe)){var we=w(fe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(fe=we.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},_.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var fe=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(G){var te=this.rules.block.list.exec(G);if(te){var fe,we,Ae,be,De,z,Q,ee,V,oe,le,Le,je=te[1].trim(),He=je.length>1,Ye={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Le=!1,!(!(te=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=te[0],G=G.substring(fe.length),ee=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(be=2,le=ee.trimLeft()):(be=te[2].search(/[^ ]/),be=be>4?1:be,le=ee.slice(be),be+=te[1].length),z=!1,!ee&&/^ *$/.test(V)&&(fe+=V+`
`,G=G.substring(V.length+1),Le=!0),!Le)for(var at=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Pe=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(oe=G.split(`
`,1)[0],ee=oe,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(ee)||qe.test(ee)||at.test(ee)||Pe.test(G)));){if(ee.search(/[^ ]/)>=be||!ee.trim())le+=`
`+ee.slice(be);else if(!z)le+=`
`+ee;else break;!z&&!ee.trim()&&(z=!0),fe+=oe+`
`,G=G.substring(oe.length+1)}Ye.loose||(Q?Ye.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(le),we&&(Ae=we[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:fe,task:!!we,checked:Ae,loose:!1,text:le}),Ye.raw+=fe}Ye.items[Ye.items.length-1].raw=fe.trimRight(),Ye.items[Ye.items.length-1].text=le.trimRight(),Ye.raw=Ye.raw.trimRight();var Xe=Ye.items.length;for(De=0;De<Xe;De++){this.lexer.state.top=!1,Ye.items[De].tokens=this.lexer.blockTokens(Ye.items[De].text,[]);var Fe=Ye.items[De].tokens.filter(function(ae){return ae.type==="space"}),nt=Fe.every(function(ae){for(var ue=ae.raw.split(""),Ie=0,Ke=I(ue),Qe;!(Qe=Ke()).done;){var rt=Qe.value;if(rt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Ye.loose&&Fe.length&&nt&&(Ye.loose=!0,Ye.items[De].loose=!0)}return Ye}},_.html=function(G){var te=this.rules.block.html.exec(G);if(te){var fe={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]);fe.type="paragraph",fe.text=we,fe.tokens=this.lexer.inline(we)}return fe}},_.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var fe=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:te[0],href:te[2],title:te[3]}}},_.table=function(G){var te=this.rules.block.table.exec(G);if(te){var fe={type:"table",header:L(te[1]).map(function(Q){return{text:Q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=te[0];var we=fe.align.length,Ae,be,De,z;for(Ae=0;Ae<we;Ae++)/^ *-+: *$/.test(fe.align[Ae])?fe.align[Ae]="right":/^ *:-+: *$/.test(fe.align[Ae])?fe.align[Ae]="center":/^ *:-+ *$/.test(fe.align[Ae])?fe.align[Ae]="left":fe.align[Ae]=null;for(we=fe.rows.length,Ae=0;Ae<we;Ae++)fe.rows[Ae]=L(fe.rows[Ae],fe.header.length).map(function(Q){return{text:Q}});for(we=fe.header.length,be=0;be<we;be++)fe.header[be].tokens=this.lexer.inline(fe.header[be].text);for(we=fe.rows.length,be=0;be<we;be++)for(z=fe.rows[be],De=0;De<z.length;De++)z[De].tokens=this.lexer.inline(z[De].text);return fe}}},_.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},_.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var fe=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},_.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:k(te[1])}},_.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]}},_.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var fe=te[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var we=w(fe.slice(0,-1),"\\");if((fe.length-we.length)%2===0)return}else{var Ae=p(te[2],"()");if(Ae>-1){var be=te[0].indexOf("!")===0?5:4,De=be+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var z=te[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);ee&&(z=ee[1],Q=ee[3])}else Q=te[3]?te[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(fe)?z=z.slice(1):z=z.slice(1,-1)),B(te,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},_.reflink=function(G,te){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var we=(fe[2]||fe[1]).replace(/\s+/g," ");if(we=te[we.toLowerCase()],!we||!we.href){var Ae=fe[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return B(fe,we,fe[0],this.lexer)}},_.emStrong=function(G,te,fe){fe===void 0&&(fe="");var we=this.rules.inline.emStrong.lDelim.exec(G);if(we&&!(we[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=we[1]||we[2]||"";if(!Ae||Ae&&(fe===""||this.rules.inline.punctuation.exec(fe))){var be=we[0].length-1,De,z,Q=be,ee=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+be);(we=V.exec(te))!=null;)if(De=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!De){if(z=De.length,we[3]||we[4]){Q+=z;continue}else if((we[5]||we[6])&&be%3&&!((be+z)%3)){ee+=z;continue}if(Q-=z,!(Q>0)){if(z=Math.min(z,z+Q+ee),Math.min(be,z)%2){var oe=G.slice(1,be+we.index+z);return{type:"em",raw:G.slice(0,be+we.index+z+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}var le=G.slice(2,be+we.index+z-1);return{type:"strong",raw:G.slice(0,be+we.index+z+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},_.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var fe=te[2].replace(/\n/g," "),we=/[^ ]/.test(fe),Ae=/^ /.test(fe)&&/ $/.test(fe);return we&&Ae&&(fe=fe.substring(1,fe.length-1)),fe=k(fe,!0),{type:"codespan",raw:te[0],text:fe}}},_.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},_.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},_.autolink=function(G,te){var fe=this.rules.inline.autolink.exec(G);if(fe){var we,Ae;return fe[2]==="@"?(we=k(this.options.mangle?te(fe[1]):fe[1]),Ae="mailto:"+we):(we=k(fe[1]),Ae=we),{type:"link",raw:fe[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.url=function(G,te){var fe;if(fe=this.rules.inline.url.exec(G)){var we,Ae;if(fe[2]==="@")we=k(this.options.mangle?te(fe[0]):fe[0]),Ae="mailto:"+we;else{var be;do be=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(be!==fe[0]);we=k(fe[0]),fe[1]==="www."?Ae="http://"+we:Ae=we}return{type:"link",raw:fe[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.inlineText=function(G,te){var fe=this.rules.inline.text.exec(G);if(fe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]:we=k(this.options.smartypants?te(fe[0]):fe[0]),{type:"text",raw:fe[0],text:we}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=i(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=i(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=i(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=i(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=i(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=i(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=i(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=i(T.reflink).replace("label",T._label).replace("ref",j._label).getRegex(),T.nolink=i(T.nolink).replace("ref",j._label).getRegex(),T.reflinkSearch=i(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=S({},T),T.pedantic=S({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=S({},T.normal,{escape:i(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=i(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=S({},T.gfm,{br:i(T.br).replace("{2,}","*").getRegex(),text:i(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ge){var _="",ie,G,te=ge.length;for(ie=0;ie<te;ie++)G=ge.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var X=function(){function ge(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:T.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=T.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=T.breaks:G.inline=T.gfm),this.tokenizer.rules=G}ge.lex=function(G,te){var fe=new ge(te);return fe.lex(G)},ge.lexInline=function(G,te){var fe=new ge(te);return fe.inlineTokens(G)};var _=ge.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},_.blockTokens=function(G,te){var fe=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,V){return ee+"    ".repeat(V.length)});for(var we,Ae,be,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(we=Q.call({lexer:fe},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.space(G)){G=G.substring(we.raw.length),we.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(we);continue}if(we=this.tokenizer.code(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we);continue}if(we=this.tokenizer.fences(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.heading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.hr(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.blockquote(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.list(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.html(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.def(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.lheading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(oe){V=oe.call({lexer:this},ee),typeof V=="number"&&V>=0&&(Q=Math.min(Q,V))}),Q<1/0&&Q>=0&&(be=G.substring(0,Q+1))}(),this.state.top&&(we=this.tokenizer.paragraph(be))){Ae=te[te.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we),De=be.length!==G.length,G=G.substring(we.raw.length);continue}if(we=this.tokenizer.text(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(we);continue}if(G){var z="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,te},_.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},_.inlineTokens=function(G,te){var fe=this;te===void 0&&(te=[]);var we,Ae,be,De=G,z,Q,ee;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,z.index)+"["+A("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,z.index)+"["+A("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,z.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(we=le.call({lexer:fe},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.escape(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.tag(G)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(we=this.tokenizer.link(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(we.raw.length),Ae=te[te.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(we=this.tokenizer.emStrong(G,De,ee)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.codespan(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.br(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.del(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.autolink(G,W)){G=G.substring(we.raw.length),te.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(G,W))){G=G.substring(we.raw.length),te.push(we);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Le=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Le),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(be=G.substring(0,le+1))}(),we=this.tokenizer.inlineText(be,F)){G=G.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ee=we.raw.slice(-1)),Q=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):te.push(we);continue}if(G){var oe="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return te},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:T}}}]),ge}(),ce=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.code=function(G,te,fe){var we=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,we);Ae!=null&&Ae!==G&&(fe=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+k(we,!0)+'">'+(fe?G:k(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:k(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,te,fe,we){if(this.options.headerIds){var Ae=this.options.headerPrefix+we.slug(fe);return"<h"+te+' id="'+Ae+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,te,fe){var we=te?"ol":"ul",Ae=te&&fe!==1?' start="'+fe+'"':"";return"<"+we+Ae+`>
`+G+"</"+we+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,te){var fe=te.header?"th":"td",we=te.align?"<"+fe+' align="'+te.align+'">':"<"+fe+">";return we+G+("</"+fe+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,te,fe){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var we='<a href="'+k(G)+'"';return te&&(we+=' title="'+te+'"'),we+=">"+fe+"</a>",we},_.image=function(G,te,fe){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var we='<img src="'+G+'" alt="'+fe+'"';return te&&(we+=' title="'+te+'"'),we+=this.options.xhtml?"/>":">",we},_.text=function(G){return G},ge}(),J=function(){function ge(){}var _=ge.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,te,fe){return""+fe},_.image=function(G,te,fe){return""+fe},_.br=function(){return""},ge}(),Y=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,te){var fe=G,we=0;if(this.seen.hasOwnProperty(fe)){we=this.seen[G];do we++,fe=G+"-"+we;while(this.seen.hasOwnProperty(fe))}return te||(this.seen[G]=we,this.seen[fe]=0),fe},_.slug=function(G,te){te===void 0&&(te={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,te.dryrun)},ge}(),x=function(){function ge(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new Y}ge.parse=function(G,te){var fe=new ge(te);return fe.parse(G)},ge.parseInline=function(G,te){var fe=new ge(te);return fe.parseInline(G)};var _=ge.prototype;return _.parse=function(G,te){te===void 0&&(te=!0);var fe="",we,Ae,be,De,z,Q,ee,V,oe,le,Le,je,He,Ye,_e,at,Pe,Oe,qe,Xe=G.length;for(we=0;we<Xe;we++){if(le=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(qe=this.options.extensions.renderers[le.type].call({parser:this},le),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){fe+=qe||"";continue}switch(le.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(le.tokens),le.depth,f(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(V="",ee="",De=le.header.length,Ae=0;Ae<De;Ae++)ee+=this.renderer.tablecell(this.parseInline(le.header[Ae].tokens),{header:!0,align:le.align[Ae]});for(V+=this.renderer.tablerow(ee),oe="",De=le.rows.length,Ae=0;Ae<De;Ae++){for(Q=le.rows[Ae],ee="",z=Q.length,be=0;be<z;be++)ee+=this.renderer.tablecell(this.parseInline(Q[be].tokens),{header:!1,align:le.align[be]});oe+=this.renderer.tablerow(ee)}fe+=this.renderer.table(V,oe);continue}case"blockquote":{oe=this.parse(le.tokens),fe+=this.renderer.blockquote(oe);continue}case"list":{for(Le=le.ordered,je=le.start,He=le.loose,De=le.items.length,oe="",Ae=0;Ae<De;Ae++)_e=le.items[Ae],at=_e.checked,Pe=_e.task,Ye="",_e.task&&(Oe=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=Oe+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=Oe+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(_e.tokens,He),oe+=this.renderer.listitem(Ye,Pe,at);fe+=this.renderer.list(oe,Le,je);continue}case"html":{fe+=this.renderer.html(le.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(oe=le.tokens?this.parseInline(le.tokens):le.text;we+1<Xe&&G[we+1].type==="text";)le=G[++we],oe+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);fe+=te?this.renderer.paragraph(oe):oe;continue}default:{var Fe='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return fe},_.parseInline=function(G,te){te=te||this.renderer;var fe="",we,Ae,be,De=G.length;for(we=0;we<De;we++){if(Ae=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(be=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){fe+=be||"";continue}switch(Ae.type){case"escape":{fe+=te.text(Ae.text);break}case"html":{fe+=te.html(Ae.text);break}case"link":{fe+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{fe+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{fe+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{fe+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{fe+=te.codespan(Ae.text);break}case"br":{fe+=te.br();break}case"del":{fe+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{fe+=te.text(Ae.text);break}default:{var z='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return fe},ge}();function se(ge,_,ie){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(ie=_,_=null),_=S({},se.defaults,_||{}),E(_),ie){var G=_.highlight,te;try{te=X.lex(ge,_)}catch(De){return ie(De)}var fe=function(z){var Q;if(!z)try{_.walkTokens&&se.walkTokens(te,_.walkTokens),Q=x.parse(te,_)}catch(ee){z=ee}return _.highlight=G,z?ie(z):ie(null,Q)};if(!G||G.length<3||(delete _.highlight,!te.length))return fe();var we=0;se.walkTokens(te,function(De){De.type==="code"&&(we++,setTimeout(function(){G(De.text,De.lang,function(z,Q){if(z)return fe(z);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),we--,we===0&&fe()})},0))}),we===0&&fe();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(De.message+"",!0)+"</pre>";throw De}try{var be=X.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(se.walkTokens(be,_.walkTokens)).then(function(){return x.parse(be,_)}).catch(Ae);se.walkTokens(be,_.walkTokens)}return x.parse(be,_)}catch(De){Ae(De)}}se.options=se.setOptions=function(ge){return S(se.defaults,ge),b(se.defaults),se},se.getDefaults=R,se.defaults=me.defaults,se.use=function(){for(var ge=arguments.length,_=new Array(ge),ie=0;ie<ge;ie++)_[ie]=arguments[ie];var G=S.apply(void 0,[{}].concat(_)),te=se.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(we){if(we.extensions&&(fe=!0,we.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var De=te.renderers?te.renderers[be.name]:null;De?te.renderers[be.name]=function(){for(var z=arguments.length,Q=new Array(z),ee=0;ee<z;ee++)Q[ee]=arguments[ee];var V=be.renderer.apply(this,Q);return V===!1&&(V=De.apply(this,Q)),V}:te.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[be.level]?te[be.level].unshift(be.tokenizer):te[be.level]=[be.tokenizer],be.start&&(be.level==="block"?te.startBlock?te.startBlock.push(be.start):te.startBlock=[be.start]:be.level==="inline"&&(te.startInline?te.startInline.push(be.start):te.startInline=[be.start]))}be.childTokens&&(te.childTokens[be.name]=be.childTokens)})),we.renderer&&function(){var be=se.defaults.renderer||new ce,De=function(ee){var V=be[ee];be[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Le=0;Le<oe;Le++)le[Le]=arguments[Le];var je=we.renderer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in we.renderer)De(z);G.renderer=be}(),we.tokenizer&&function(){var be=se.defaults.tokenizer||new P,De=function(ee){var V=be[ee];be[ee]=function(){for(var oe=arguments.length,le=new Array(oe),Le=0;Le<oe;Le++)le[Le]=arguments[Le];var je=we.tokenizer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in we.tokenizer)De(z);G.tokenizer=be}(),we.walkTokens){var Ae=se.defaults.walkTokens;G.walkTokens=function(be){var De=[];return De.push(we.walkTokens.call(this,be)),Ae&&(De=De.concat(Ae.call(this,be))),De}}fe&&(G.extensions=te),se.setOptions(G)})},se.walkTokens=function(ge,_){for(var ie=[],G=function(){var Ae=fe.value;switch(ie=ie.concat(_.call(se,Ae)),Ae.type){case"table":{for(var be=I(Ae.header),De;!(De=be()).done;){var z=De.value;ie=ie.concat(se.walkTokens(z.tokens,_))}for(var Q=I(Ae.rows),ee;!(ee=Q()).done;)for(var V=ee.value,oe=I(V),le;!(le=oe()).done;){var Le=le.value;ie=ie.concat(se.walkTokens(Le.tokens,_))}break}case"list":{ie=ie.concat(se.walkTokens(Ae.items,_));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Ae.type]?se.defaults.extensions.childTokens[Ae.type].forEach(function(je){ie=ie.concat(se.walkTokens(Ae[je],_))}):Ae.tokens&&(ie=ie.concat(se.walkTokens(Ae.tokens,_)))}},te=I(ge),fe;!(fe=te()).done;)G();return ie},se.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=S({},se.defaults,_||{}),E(_);try{var ie=X.lexInline(ge,_);return _.walkTokens&&se.walkTokens(ie,_.walkTokens),x.parseInline(ie,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+k(G.message+"",!0)+"</pre>";throw G}},se.Parser=x,se.parser=x.parse,se.Renderer=ce,se.TextRenderer=J,se.Lexer=X,se.lexer=X.lex,se.Tokenizer=P,se.Slugger=Y,se.parse=se;var Z=se.options,ve=se.setOptions,de=se.use,H=se.walkTokens,U=se.parseInline,ne=se,ye=x.parse,he=X.lex;me.Lexer=X,me.Parser=x,me.Renderer=ce,me.Slugger=Y,me.TextRenderer=J,me.Tokenizer=P,me.getDefaults=R,me.lexer=he,me.marked=se,me.options=Z,me.parse=ne,me.parseInline=U,me.parser=ye,me.setOptions=ve,me.use=de,me.walkTokens=H,Object.defineProperty(me,"__esModule",{value:!0})}),define(Se[161],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0;function D(u){const f=I(u);if(f&&f.length>0)return new Uint32Array(f)}e.$Mj=D;let N=0;const g=new Uint32Array(10);function I(u){if(N=0,R(u,C,4352),N>0||(R(u,m,4449),N>0)||(R(u,v,4520),N>0)||(R(u,k,12593),N))return g.subarray(0,N);if(u>=44032&&u<=55203){const f=u-44032,s=f%588,i=Math.floor(f/588),n=Math.floor(s/28),o=s%28-1;if(i<C.length?R(i,C,0):4352+i-12593<k.length&&R(4352+i,k,12593),n<m.length?R(n,m,0):4449+n-12593<k.length&&R(4449+n-12593,k,12593),o>=0&&(o<v.length?R(o,v,0):4520+o-12593<k.length&&R(4520+o-12593,k,12593)),N>0)return g.subarray(0,N)}}function R(u,f,s){u>=s&&u<s+f.length&&b(f[u-s])}function b(u){u!==0&&(g[N++]=u&255,u>>8&&(g[N++]=u>>8&255),u>>16&&(g[N++]=u>>16&255))}var $;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(y||(y={}));var M;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(M||(M={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[76],ke([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=void 0;const N=new D.$Dc(1e4);function g(y){return $(y,"NFC",N)}e.$Al=g;const I=new D.$Dc(1e4);function R(y){return $(y,"NFD",I)}e.$Bl=R;const b=/[^\u0000-\u0080]/;function $(y,M,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(M):v=y,C.set(y,v),v}e.$Cl=function(){const y=/[\u0300-\u036f]/g;return function(M){return R(M).replace(y,"")}}()}),define(Se[122],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.rot=e.$1l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$1l=D;function N(b,$){return($+b%$)%$}e.rot=N;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$3l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$4l=I;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$5l=R}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function R($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(g+R.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:me)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(N){if(e[N])return e[N].exports;var g=e[N]={i:N,l:!1,exports:{}};return me[N].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(N,g,I){D.o(N,g)||Object.defineProperty(N,g,{enumerable:!0,get:I})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,g){if(1&g&&(N=D(N)),8&g||4&g&&typeof N=="object"&&N&&N.__esModule)return N;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:N}),2&g&&typeof N!="string")for(var R in N)D.d(I,R,function(b){return N[b]}.bind(null,R));return I},D.n=function(N){var g=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(g,"a",g),g},D.o=function(N,g){return Object.prototype.hasOwnProperty.call(N,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(N){var g;e=me.exports=de,g=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,M=y++;$[M]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[M]+")\\.("+$[M]+")\\.("+$[M]+")";var k=y++;$[k]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var u=y++;$[u]="(?:"+$[M]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[u]+"(?:\\."+$[u]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var a=y++,t="v?"+$[v]+$[s]+"?"+$[o]+"?";$[a]="^"+t+"$";var r="[v=\\s]*"+$[k]+$[i]+"?"+$[o]+"?",d=y++;$[d]="^"+r+"$";var l=y++;$[l]="((?:<|>)?=?)";var c=y++;$[c]=$[C]+"|x|X|\\*";var h=y++;$[h]=$[M]+"|x|X|\\*";var S=y++;$[S]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var L=y++;$[L]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var w=y++;$[w]="^"+$[l]+"\\s*"+$[S]+"$";var p=y++;$[p]="^"+$[l]+"\\s*"+$[L]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=y++;$[A]="(?:~>?)";var B=y++;$[B]="(\\s*)"+$[A]+"\\s+",b[B]=new RegExp($[B],"g");var O=y++;$[O]="^"+$[A]+$[S]+"$";var P=y++;$[P]="^"+$[A]+$[L]+"$";var j=y++;$[j]="(?:\\^)";var T=y++;$[T]="(\\s*)"+$[j]+"\\s+",b[T]=new RegExp($[T],"g");var F=y++;$[F]="^"+$[j]+$[S]+"$";var W=y++;$[W]="^"+$[j]+$[L]+"$";var X=y++;$[X]="^"+$[l]+"\\s*("+r+")$|^$";var ce=y++;$[ce]="^"+$[l]+"\\s*("+t+")$|^$";var J=y++;$[J]="(\\s*)"+$[l]+"\\s*("+r+"|"+$[S]+")",b[J]=new RegExp($[J],"g");var Y=y++;$[Y]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var x=y++;$[x]="^\\s*("+$[L]+")\\s+-\\s+("+$[L]+")\\s*$";var se=y++;$[se]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)g(Z,$[Z]),b[Z]||(b[Z]=new RegExp($[Z]));function ve(V,oe){if(V instanceof de)return V;if(typeof V!="string"||V.length>I||!(oe?b[d]:b[a]).test(V))return null;try{return new de(V,oe)}catch{return null}}function de(V,oe){if(V instanceof de){if(V.loose===oe)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof de))return new de(V,oe);g("SemVer",V,oe),this.loose=oe;var le=V.trim().match(oe?b[d]:b[a]);if(!le)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<R)return je}return Le}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=ve,e.valid=function(V,oe){var le=ve(V,oe);return le?le.version:null},e.clean=function(V,oe){var le=ve(V.trim().replace(/^[=v]+/,""),oe);return le?le.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(V){return g("SemVer.compare",this.version,this.loose,V),V instanceof de||(V=new de(V,this.loose)),this.compareMain(V)||this.comparePre(V)},de.prototype.compareMain=function(V){return V instanceof de||(V=new de(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},de.prototype.comparePre=function(V){if(V instanceof de||(V=new de(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var oe=0;do{var le=this.prerelease[oe],Le=V.prerelease[oe];if(g("prerelease compare",oe,le,Le),le===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(le===void 0)return-1;if(le!==Le)return U(le,Le)}while(++oe)},de.prototype.inc=function(V,oe){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,oe,le,Le){typeof le=="string"&&(Le=le,le=void 0);try{return new de(V,le).inc(oe,Le).version}catch{return null}},e.diff=function(V,oe){if(ge(V,oe))return null;var le=ve(V),Le=ve(oe);if(le.prerelease.length||Le.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Le[je])return je},e.compareIdentifiers=U;var H=/^[0-9]+$/;function U(V,oe){var le=H.test(V),Le=H.test(oe);return le&&Le&&(V=+V,oe=+oe),le&&!Le?-1:Le&&!le?1:V<oe?-1:V>oe?1:0}function ne(V,oe,le){return new de(V,le).compare(new de(oe,le))}function ye(V,oe,le){return ne(V,oe,le)>0}function he(V,oe,le){return ne(V,oe,le)<0}function ge(V,oe,le){return ne(V,oe,le)===0}function _(V,oe,le){return ne(V,oe,le)!==0}function ie(V,oe,le){return ne(V,oe,le)>=0}function G(V,oe,le){return ne(V,oe,le)<=0}function te(V,oe,le,Le){var je;switch(oe){case"===":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V===le;break;case"!==":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V!==le;break;case"":case"=":case"==":je=ge(V,le,Le);break;case"!=":je=_(V,le,Le);break;case">":je=ye(V,le,Le);break;case">=":je=ie(V,le,Le);break;case"<":je=he(V,le,Le);break;case"<=":je=G(V,le,Le);break;default:throw new TypeError("Invalid operator: "+oe)}return je}function fe(V,oe){if(V instanceof fe){if(V.loose===oe)return V;V=V.value}if(!(this instanceof fe))return new fe(V,oe);g("comparator",V,oe),this.loose=oe,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(V,oe){return U(oe,V)},e.major=function(V,oe){return new de(V,oe).major},e.minor=function(V,oe){return new de(V,oe).minor},e.patch=function(V,oe){return new de(V,oe).patch},e.compare=ne,e.compareLoose=function(V,oe){return ne(V,oe,!0)},e.rcompare=function(V,oe,le){return ne(oe,V,le)},e.sort=function(V,oe){return V.sort(function(le,Le){return e.compare(le,Le,oe)})},e.rsort=function(V,oe){return V.sort(function(le,Le){return e.rcompare(le,Le,oe)})},e.gt=ye,e.lt=he,e.eq=ge,e.neq=_,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=fe;var we={};function Ae(V,oe){if(V instanceof Ae)return V.loose===oe?V:new Ae(V.raw,oe);if(V instanceof fe)return new Ae(V.value,oe);if(!(this instanceof Ae))return new Ae(V,oe);if(this.loose=oe,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function be(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,oe,le,Le,je,He,Ye,_e,at,Pe,Oe,qe,Xe){return((oe=be(le)?"":be(Le)?">="+le+".0.0":be(je)?">="+le+"."+Le+".0":">="+oe)+" "+(_e=be(at)?"":be(Pe)?"<"+(+at+1)+".0.0":be(Oe)?"<"+at+"."+(+Pe+1)+".0":qe?"<="+at+"."+Pe+"."+Oe+"-"+qe:"<="+_e)).trim()}function z(V,oe){for(var le=0;le<V.length;le++)if(!V[le].test(oe))return!1;if(oe.prerelease.length){for(le=0;le<V.length;le++)if(g(V[le].semver),V[le].semver!==we&&V[le].semver.prerelease.length>0){var Le=V[le].semver;if(Le.major===oe.major&&Le.minor===oe.minor&&Le.patch===oe.patch)return!0}return!1}return!0}function Q(V,oe,le){try{oe=new Ae(oe,le)}catch{return!1}return oe.test(V)}function ee(V,oe,le,Le){var je,He,Ye,_e,at;switch(V=new de(V,Le),oe=new Ae(oe,Le),le){case">":je=ye,He=G,Ye=he,_e=">",at=">=";break;case"<":je=he,He=ie,Ye=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(V,oe,Le))return!1;for(var Pe=0;Pe<oe.set.length;++Pe){var Oe=oe.set[Pe],qe=null,Xe=null;if(Oe.forEach(function(Fe){Fe.semver===we&&(Fe=new fe(">=0.0.0")),qe=qe||Fe,Xe=Xe||Fe,je(Fe.semver,qe.semver,Le)?qe=Fe:Ye(Fe.semver,Xe.semver,Le)&&(Xe=Fe)}),qe.operator===_e||qe.operator===at||(!Xe.operator||Xe.operator===_e)&&He(V,Xe.semver)||Xe.operator===at&&Ye(V,Xe.semver))return!1}return!0}fe.prototype.parse=function(V){var oe=this.loose?b[X]:b[ce],le=V.match(oe);if(!le)throw new TypeError("Invalid comparator: "+V);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new de(le[2],this.loose):this.semver=we},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return g("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new de(V,this.loose)),te(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,oe){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ae(V.value,oe),Q(this.value,le,oe);if(V.operator==="")return le=new Ae(this.value,oe),Q(V.semver,le,oe);var Le=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),He=this.semver.version===V.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),_e=te(this.semver,"<",V.semver,oe)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),at=te(this.semver,">",V.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Le||je||He&&Ye||_e||at},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var oe=this.loose;V=V.trim(),g("range",V,oe);var le=oe?b[x]:b[Y];V=V.replace(le,De),g("hyphen replace",V),V=V.replace(b[J],"$1$2$3"),g("comparator trim",V,b[J]),V=(V=(V=V.replace(b[B],"$1~")).replace(b[T],"$1^")).split(/\s+/).join(" ");var Le=oe?b[X]:b[ce],je=V.split(" ").map(function(He){return function(Ye,_e){return g("comp",Ye),Ye=function(at,Pe){return at.trim().split(/\s+/).map(function(Oe){return function(qe,Xe){g("caret",qe,Xe);var Fe=Xe?b[W]:b[F];return qe.replace(Fe,function(nt,ae,ue,Ie,Ke){var Qe;return g("caret",qe,nt,ae,ue,Ie,Ke),be(ae)?Qe="":be(ue)?Qe=">="+ae+".0.0 <"+(+ae+1)+".0.0":be(Ie)?Qe=ae==="0"?">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+".0 <"+(+ae+1)+".0.0":Ke?(g("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Qe=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+Ie+Ke+" <"+ae+"."+ue+"."+(+Ie+1):">="+ae+"."+ue+"."+Ie+Ke+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+Ie+Ke+" <"+(+ae+1)+".0.0"):(g("no pr"),Qe=ae==="0"?ue==="0"?">="+ae+"."+ue+"."+Ie+" <"+ae+"."+ue+"."+(+Ie+1):">="+ae+"."+ue+"."+Ie+" <"+ae+"."+(+ue+1)+".0":">="+ae+"."+ue+"."+Ie+" <"+(+ae+1)+".0.0"),g("caret return",Qe),Qe})}(Oe,Pe)}).join(" ")}(Ye,_e),g("caret",Ye),Ye=function(at,Pe){return at.trim().split(/\s+/).map(function(Oe){return function(qe,Xe){var Fe=Xe?b[P]:b[O];return qe.replace(Fe,function(nt,ae,ue,Ie,Ke){var Qe;return g("tilde",qe,nt,ae,ue,Ie,Ke),be(ae)?Qe="":be(ue)?Qe=">="+ae+".0.0 <"+(+ae+1)+".0.0":be(Ie)?Qe=">="+ae+"."+ue+".0 <"+ae+"."+(+ue+1)+".0":Ke?(g("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Qe=">="+ae+"."+ue+"."+Ie+Ke+" <"+ae+"."+(+ue+1)+".0"):Qe=">="+ae+"."+ue+"."+Ie+" <"+ae+"."+(+ue+1)+".0",g("tilde return",Qe),Qe})}(Oe,Pe)}).join(" ")}(Ye,_e),g("tildes",Ye),Ye=function(at,Pe){return g("replaceXRanges",at,Pe),at.split(/\s+/).map(function(Oe){return function(qe,Xe){qe=qe.trim();var Fe=Xe?b[p]:b[w];return qe.replace(Fe,function(nt,ae,ue,Ie,Ke,Qe){g("xRange",qe,nt,ae,ue,Ie,Ke,Qe);var rt=be(ue),ot=rt||be(Ie),Be=ot||be(Ke);return ae==="="&&Be&&(ae=""),rt?nt=ae===">"||ae==="<"?"<0.0.0":"*":ae&&Be?(ot&&(Ie=0),Be&&(Ke=0),ae===">"?(ae=">=",ot?(ue=+ue+1,Ie=0,Ke=0):Be&&(Ie=+Ie+1,Ke=0)):ae==="<="&&(ae="<",ot?ue=+ue+1:Ie=+Ie+1),nt=ae+ue+"."+Ie+"."+Ke):ot?nt=">="+ue+".0.0 <"+(+ue+1)+".0.0":Be&&(nt=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0"),g("xRange return",nt),nt})}(Oe,Pe)}).join(" ")}(Ye,_e),g("xrange",Ye),Ye=function(at,Pe){return g("replaceStars",at,Pe),at.trim().replace(b[se],"")}(Ye,_e),g("stars",Ye),Ye}(He,oe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Le)})),je=je.map(function(He){return new fe(He,oe)})},Ae.prototype.intersects=function(V,oe){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Le){return V.set.some(function(je){return je.every(function(He){return Le.intersects(He,oe)})})})})},e.toComparators=function(V,oe){return new Ae(V,oe).set.map(function(le){return le.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new de(V,this.loose));for(var oe=0;oe<this.set.length;oe++)if(z(this.set[oe],V))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(V,oe,le){var Le=null,je=null;try{var He=new Ae(oe,le)}catch{return null}return V.forEach(function(Ye){He.test(Ye)&&(Le&&je.compare(Ye)!==-1||(je=new de(Le=Ye,le)))}),Le},e.minSatisfying=function(V,oe,le){var Le=null,je=null;try{var He=new Ae(oe,le)}catch{return null}return V.forEach(function(Ye){He.test(Ye)&&(Le&&je.compare(Ye)!==1||(je=new de(Le=Ye,le)))}),Le},e.validRange=function(V,oe){try{return new Ae(V,oe).range||"*"}catch{return null}},e.ltr=function(V,oe,le){return ee(V,oe,"<",le)},e.gtr=function(V,oe,le){return ee(V,oe,">",le)},e.outside=ee,e.prerelease=function(V,oe){var le=ve(V,oe);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(V,oe,le){return V=new Ae(V,le),oe=new Ae(oe,le),V.intersects(oe)},e.coerce=function(V){if(V instanceof de)return V;if(typeof V!="string")return null;var oe=V.match(b[E]);return oe==null?null:ve((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(me,e){var D,N,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var $,y=[],M=!1,C=-1;function m(){M&&$&&(M=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!M){var f=b(m);M=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,M=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(f)}}function k(f,s){this.fun=f,this.array=s}function u(){}g.nextTick=function(f){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new k(f,s)),y.length!==1||M||b(v)},k.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=u,g.addListener=u,g.once=u,g.off=u,g.removeListener=u,g.removeAllListeners=u,g.emit=u,g.prependListener=u,g.prependOnceListener=u,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[38],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(I){return new N(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=N}),define(Se[4],ke([1,0,8,74,3,75,38]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const b=!1,$=!1;var y;(function(w){w.None=()=>g.$Sc.None;function p(te){if($){const{onDidAddListener:fe}=te,we=k.create();let Ae=0;te.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),fe?.()}}}function E(te,fe){return ce(te,()=>{},0,void 0,!0,void 0,fe)}w.defer=E;function A(te){return(fe,we=null,Ae)=>{let be=!1,De;return De=te(z=>{if(!be)return De?De.dispose():be=!0,fe.call(we,z)},null,Ae),be&&De.dispose(),De}}w.once=A;function B(te,fe,we){return W((Ae,be=null,De)=>te(z=>Ae.call(be,fe(z)),null,De),we)}w.map=B;function O(te,fe,we){return W((Ae,be=null,De)=>te(z=>{fe(z),Ae.call(be,z)},null,De),we)}w.forEach=O;function P(te,fe,we){return W((Ae,be=null,De)=>te(z=>fe(z)&&Ae.call(be,z),null,De),we)}w.filter=P;function j(te){return te}w.signal=j;function T(...te){return(fe,we=null,Ae)=>{const be=(0,g.$Pc)(...te.map(De=>De(z=>fe.call(we,z))));return X(be,Ae)}}w.any=T;function F(te,fe,we,Ae){let be=we;return B(te,De=>(be=fe(be,De),be),Ae)}w.reduce=F;function W(te,fe){let we;const Ae={onWillAddFirstListener(){we=te(be.fire,be)},onDidRemoveLastListener(){we?.dispose()}};fe||p(Ae);const be=new n(Ae);return fe?.add(be),be.event}function X(te,fe){return fe instanceof Array?fe.push(te):fe&&fe.add(te),te}function ce(te,fe,we=100,Ae=!1,be=!1,De,z){let Q,ee,V,oe=0,le;const Le={leakWarningThreshold:De,onWillAddFirstListener(){Q=te(He=>{oe++,ee=fe(ee,He),Ae&&!V&&(je.fire(ee),ee=void 0),le=()=>{const Ye=ee;ee=void 0,V=void 0,(!Ae||oe>1)&&je.fire(Ye),oe=0},typeof we=="number"?(clearTimeout(V),V=setTimeout(le,we)):V===void 0&&(V=0,queueMicrotask(le))})},onWillRemoveListener(){be&&oe>0&&le?.()},onDidRemoveLastListener(){le=void 0,Q.dispose()}};z||p(Le);const je=new n(Le);return z?.add(je),je.event}w.debounce=ce;function J(te,fe=0,we){return w.debounce(te,(Ae,be)=>Ae?(Ae.push(be),Ae):[be],fe,void 0,!0,void 0,we)}w.accumulate=J;function Y(te,fe=(Ae,be)=>Ae===be,we){let Ae=!0,be;return P(te,De=>{const z=Ae||!fe(De,be);return Ae=!1,be=De,z},we)}w.latch=Y;function x(te,fe,we){return[w.filter(te,fe,we),w.filter(te,Ae=>!fe(Ae),we)]}w.split=x;function se(te,fe=!1,we=[],Ae){let be=we.slice(),De=te(ee=>{be?be.push(ee):Q.fire(ee)});Ae&&Ae.add(De);const z=()=>{be?.forEach(ee=>Q.fire(ee)),be=null},Q=new n({onWillAddFirstListener(){De||(De=te(ee=>Q.fire(ee)),Ae&&Ae.add(De))},onDidAddFirstListener(){be&&(fe?setTimeout(z):z())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Ae&&Ae.add(Q),Q.event}w.buffer=se;function Z(te,fe){return(Ae,be,De)=>{const z=fe(new de);return te(function(Q){const ee=z.evaluate(Q);ee!==ve&&Ae.call(be,ee)},void 0,De)}}w.chain=Z;const ve=Symbol("HaltChainable");class de{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(we=>(fe(we),we)),this}filter(fe){return this.f.push(we=>fe(we)?we:ve),this}reduce(fe,we){let Ae=we;return this.f.push(be=>(Ae=fe(Ae,be),Ae)),this}latch(fe=(we,Ae)=>we===Ae){let we=!0,Ae;return this.f.push(be=>{const De=we||!fe(be,Ae);return we=!1,Ae=be,De?be:ve}),this}evaluate(fe){for(const we of this.f)if(fe=we(fe),fe===ve)break;return fe}}function H(te,fe,we=Ae=>Ae){const Ae=(...Q)=>z.fire(we(...Q)),be=()=>te.on(fe,Ae),De=()=>te.removeListener(fe,Ae),z=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}w.fromNodeEventEmitter=H;function U(te,fe,we=Ae=>Ae){const Ae=(...Q)=>z.fire(we(...Q)),be=()=>te.addEventListener(fe,Ae),De=()=>te.removeEventListener(fe,Ae),z=new n({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}w.fromDOMEventEmitter=U;function ne(te){return new Promise(fe=>A(te)(fe))}w.toPromise=ne;function ye(te){const fe=new n;return te.then(we=>{fe.fire(we)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}w.fromPromise=ye;function he(te,fe,we){return fe(we),te(Ae=>fe(Ae))}w.runAndSubscribe=he;function ge(te,fe){let we=null;function Ae(De){we?.dispose(),we=new g.$Rc,fe(De,we)}Ae(void 0);const be=te(De=>Ae(De));return(0,g.$Qc)(()=>{be.dispose(),we?.dispose()})}w.runAndSubscribeWithStore=ge;class _{constructor(fe,we){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};we||p(Ae),this.emitter=new n(Ae),we&&we.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,we){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,fe){return new _(te,fe).emitter.event}w.fromObservable=ie;function G(te){return(fe,we,Ae)=>{let be=0,De=!1;const z={beginUpdate(){be++},endUpdate(){be--,be===0&&(te.reportChanges(),De&&(De=!1,fe.call(we)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(z),te.reportChanges();const Q={dispose(){te.removeObserver(z)}};return Ae instanceof g.$Rc?Ae.add(Q):Array.isArray(Ae)&&Ae.push(Q),Q}}w.fromObservableLight=G})(y||(e.Event=y={}));class M{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${M.f++}`,M.all.add(this)}start(p){this.g=new R.$Od,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Qd=M;let C=-1;function m(w){const p=C;return C=w,{dispose(){C=p}}}e.$Rd=m;class v{constructor(p,E=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=E,this.g=0}dispose(){this.f?.clear()}check(p,E){const A=this.threshold;if(A<=0||E<A)return;this.f||(this.f=new Map);const B=this.f.get(p.value)||0;if(this.f.set(p.value,B+1),this.g-=1,this.g<=0){this.g=A*.5;let O,P=0;for(const[j,T]of this.f)(!O||P<T)&&(O=j,P=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${P}):`),console.warn(O)}return()=>{const O=this.f.get(p.value)||0;this.f.set(p.value,O-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class f{constructor(p){this.value=p,this.id=u++}}const s=2,i=(w,p)=>{if(w instanceof f)p(w);else for(let E=0;E<w.length;E++){const A=w[E];A&&p(A)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,E,A)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Sc.None;if(this.m)return g.$Sc.None;E&&(p=p.bind(E));const B=new f(p);let O,P;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=k.create(),O=this.g.check(B.stack,this.w+1)),b&&(B.stack=P??k.create()),this.t?this.t instanceof f?(this.u??=new a,this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Qc)(()=>{O?.(),this.x(B)});return A instanceof g.$Rc?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,A=E.indexOf(p);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[A]=void 0;const B=this.u.current===this;if(this.w*s<=E.length){let O=0;for(let P=0;P<E.length;P++)E[P]?E[O++]=E[P]:B&&(this.u.end--,O<this.u.i&&this.u.i--);E.length=O}}y(p,E){if(!p)return;const A=this.f?.onListenerError||D.$1;if(!A){p.value(E);return}try{p.value(E)}catch(B){A(B)}}z(p){const E=p.current.t;for(;p.i<p.end;)this.y(E[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,p);else{const E=this.u;E.enqueue(this,p,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=n;const o=()=>new a;e.$Td=o;class a{constructor(){this.i=-1,this.end=0}enqueue(p,E,A){this.i=0,this.end=A,this.current=p,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,E,A){if(this.t)for(this.h||(this.h=new I.$3c),i(this.t,B=>this.h.push([B.value,p]));this.h.size>0&&!E.isCancellationRequested;){const[B,O]=this.h.shift(),P=[],j={...O,token:E,waitUntil:T=>{if(Object.isFrozen(P))throw new Error("waitUntil can NOT be called asynchronous");A&&(T=A(T,B)),P.push(T)}};try{B(j)}catch(T){(0,D.$1)(T);continue}Object.freeze(P),await Promise.allSettled(P).then(T=>{for(const F of T)F.status==="rejected"&&(0,D.$1)(F.reason)})}}}e.$Ud=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new I.$3c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Vd=r;class d extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Wd=d;class l extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Xd=l;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const E={event:p,listener:null};this.h.push(E),this.g&&this.m(E);const A=()=>{this.g&&this.o(E);const B=this.h.indexOf(E);this.h.splice(B,1)};return(0,g.$Qc)((0,N.$db)(A))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(E=>this.f.fire(E))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Yd=c;class h{constructor(p,E,A,B){this.f=new g.$Rc;const O=this.f.add(new c),P=this.f.add(new g.$2c);function j(T){P.set(T,O.add(B(T)))}for(const T of p)j(T);this.f.add(E(T=>{j(T)})),this.f.add(A(T=>{P.deleteAndDispose(T)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Zd=h;class S{constructor(){this.f=[]}wrapEvent(p){return(E,A,B)=>p(O=>{const P=this.f[this.f.length-1];P?P.push(()=>E.call(A,O)):E.call(A,O)},void 0,B)}bufferEvents(p){const E=[];this.f.push(E);const A=p();return this.f.pop(),E.forEach(B=>B()),A}}e.$1d=S;class L{constructor(){this.f=!1,this.g=y.None,this.h=g.$Sc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=L}),define(Se[21],ke([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const N=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$3d=R}),define(Se[162],ke([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$3d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Be=N;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ce=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$De=I}),define(Se[98],ke([1,0,8,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function g(o){const a=o;return a?typeof a.read=="function":!1}e.$4d=g;function I(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$5d=I;function R(o){const a=o;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$6d=R;function b(o,a){return new $(o,a)}e.$7d=b;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$8d=y;function M(o,a,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return o.read()}}}e.$9d=M;function C(o,a){return new Promise((t,r)=>{const d=[];m(o,{onData:l=>{a&&d.push(l)},onError:l=>{a?r(l):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$0d=C;function m(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$$d=m;function v(o,a){return new Promise((t,r)=>{const d=new N.$Rc,l=[],c=L=>{if(l.push(L),l.length>a)return d.dispose(),o.pause(),t({stream:o,buffer:l,ended:!1})},h=L=>(d.dispose(),r(L)),S=()=>(d.dispose(),t({stream:o,buffer:l,ended:!0}));d.add((0,N.$Qc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,N.$Qc)(()=>o.removeListener("end",S))),o.on("end",S),d.add((0,N.$Qc)(()=>o.removeListener("data",c))),o.on("data",c)})}e.$_d=v;function k(o,a){const t=b(a);return t.end(o),t}e.$ae=k;function u(){const o=b(()=>{throw new Error("not supported")});return o.end(),o}e.$be=u;function f(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$ce=f;function s(o,a,t){const r=b(t);return m(o,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$de=s;function i(o,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ee=i;function n(o,a,t){let r=!1;const d=b(t);return m(a,{onData:l=>r?d.write(l):(r=!0,d.write(t([o,l]))),onError:l=>d.error(l),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$fe=n}),define(Se[22],ke([1,0,43,98]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,A){return!(A?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const A=$.alloc(E.length);for(let B=0,O=E.length;B<O;B++)A.buffer[B]=E[B];return A}static concat(E,A){if(typeof A>"u"){A=0;for(let P=0,j=E.length;P<j;P++)A+=E[P].byteLength}const B=$.alloc(A);let O=0;for(let P=0,j=E.length;P<j;P++){const T=E[P];B.set(T,O),O+=T.byteLength}return B}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,A){return new $(this.buffer.subarray(E,A))}set(E,A){if(E instanceof $)this.buffer.set(E.buffer,A);else if(E instanceof Uint8Array)this.buffer.set(E,A);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),A);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,A){v(this.buffer,E,A)}readUInt32LE(E){return k(this.buffer,E)}writeUInt32LE(E,A){u(this.buffer,E,A)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,A){s(this.buffer,E,A)}indexOf(E,A=0){return y(this.buffer,E instanceof $?E.buffer:E,A)}}e.$ge=$;function y(p,E,A=0){const B=E.byteLength,O=p.byteLength;if(B===0)return 0;if(B===1)return p.indexOf(E[0]);if(B>O-A)return-1;const P=I.value;P.fill(E.length);for(let W=0;W<E.length;W++)P[E[W]]=E.length-W-1;let j=A+E.length-1,T=j,F=-1;for(;j<O;)if(p[j]===E[T]){if(T===0){F=j;break}j--,T--}else j+=Math.max(E.length-T,P[p[j]]),T=E.length-1;return F}e.$he=y;function M(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0}e.$ie=M;function C(p,E,A){p[A+0]=E&255,E=E>>>8,p[A+1]=E&255}e.$je=C;function m(p,E){return p[E]*2**24+p[E+1]*2**16+p[E+2]*2**8+p[E+3]}e.$ke=m;function v(p,E,A){p[A+3]=E,E=E>>>8,p[A+2]=E,E=E>>>8,p[A+1]=E,E=E>>>8,p[A]=E}e.$le=v;function k(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0|p[E+2]<<16>>>0|p[E+3]<<24>>>0}e.$me=k;function u(p,E,A){p[A+0]=E&255,E=E>>>8,p[A+1]=E&255,E=E>>>8,p[A+2]=E&255,E=E>>>8,p[A+3]=E&255}e.$ne=u;function f(p,E){return p[E]}e.$oe=f;function s(p,E,A){p[A]=E}e.$pe=s;function i(p){return N.$8d(p,E=>$.concat(E))}e.$qe=i;function n(p){return N.$ce(p)}e.$re=n;function o(p){return N.$0d(p,E=>$.concat(E))}e.$se=o;async function a(p){return p.ended?$.concat(p.buffer):$.concat([...p.buffer,await o(p.stream)])}e.$te=a;function t(p){return N.$ae(p,E=>$.concat(E))}e.$ue=t;function r(p){return N.$de(p,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ve=r;function d(p){return N.$7d(E=>$.concat(E),p)}e.$we=d;function l(p,E){return N.$ee(p,E,A=>$.concat(A))}e.$xe=l;function c(p,E){return N.$fe(p,E,A=>$.concat(A))}e.$ye=c;function h(p){let E=0,A=0,B=0;const O=new Uint8Array(Math.floor(p.length/4*3)),P=T=>{switch(A){case 3:O[B++]=E|T,A=0;break;case 2:O[B++]=E|T>>>2,E=T<<6,A=3;break;case 1:O[B++]=E|T>>>4,E=T<<4,A=2;break;default:E=T<<2,A=1}};for(let T=0;T<p.length;T++){const F=p.charCodeAt(T);if(F>=65&&F<=90)P(F-65);else if(F>=97&&F<=122)P(F-97+26);else if(F>=48&&F<=57)P(F-48+52);else if(F===43||F===45)P(62);else if(F===47||F===95)P(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${p[T]}`)}}const j=B;for(;A>0;)P(0);return $.wrap(O).slice(0,j)}e.$ze=h;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:p},E=!0,A=!1){const B=A?L:S;let O="";const P=p.byteLength%3;let j=0;for(;j<p.byteLength-P;j+=3){const T=p[j+0],F=p[j+1],W=p[j+2];O+=B[T>>>2],O+=B[(T<<4|F>>>4)&63],O+=B[(F<<2|W>>>6)&63],O+=B[W&63]}if(P===1){const T=p[j+0];O+=B[T>>>2],O+=B[T<<4&63],E&&(O+="==")}else if(P===2){const T=p[j+0],F=p[j+1];O+=B[T>>>2],O+=B[(T<<4|F>>>4)&63],O+=B[F<<2&63],E&&(O+="=")}return O}e.$Ae=w}),define(Se[13],ke([1,0,162,43]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cf=e.$Bf=e.$Af=e.$zf=e.GraphemeBreakType=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function g(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Ge=g;const I=/{(\d+)}/g;function R(Pe,...Oe){return Oe.length===0?Pe:Pe.replace(I,function(qe,Xe){const Fe=parseInt(Xe,10);return isNaN(Fe)||Fe<0||Fe>=Oe.length?qe:Oe[Fe]})}e.$He=R;const b=/{([^}]+)}/g;function $(Pe,Oe){return Object.keys(Oe).length===0?Pe:Pe.replace(b,(qe,Xe)=>Oe[Xe]??qe)}e.$Ie=$;function y(Pe){return Pe.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Je=y;function M(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=M;function C(Pe,Oe){let qe=0;const Xe=Oe.charCodeAt(0);for(let Fe=Pe.length-1;Fe>=0;Fe--)Pe.charCodeAt(Fe)===Xe&&qe++;return qe}e.$Le=C;function m(Pe,Oe,qe="\u2026"){return Pe.length<=Oe?Pe:`${Pe.substr(0,Oe)}${qe}`}e.$Me=m;function v(Pe,Oe=" "){const qe=k(Pe,Oe);return u(qe,Oe)}e.$Ne=v;function k(Pe,Oe){if(!Pe||!Oe)return Pe;const qe=Oe.length;if(qe===0||Pe.length===0)return Pe;let Xe=0;for(;Pe.indexOf(Oe,Xe)===Xe;)Xe=Xe+qe;return Pe.substring(Xe)}e.$Oe=k;function u(Pe,Oe){if(!Pe||!Oe)return Pe;const qe=Oe.length,Xe=Pe.length;if(qe===0||Xe===0)return Pe;let Fe=Xe,nt=-1;for(;nt=Pe.lastIndexOf(Oe,Fe-1),!(nt===-1||nt+qe!==Fe);){if(nt===0)return"";Fe=nt}return Pe.substring(0,Fe)}e.$Pe=u;function f(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Qe=f;function s(Pe){return Pe.replace(/\*/g,"")}e.$Re=s;function i(Pe,Oe,qe={}){if(!Pe)throw new Error("Cannot create regex from empty string");Oe||(Pe=M(Pe)),qe.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Xe="";return qe.global&&(Xe+="g"),qe.matchCase||(Xe+="i"),qe.multiline&&(Xe+="m"),qe.unicode&&(Xe+="u"),new RegExp(Pe,Xe)}e.$Se=i;function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Te=n;function o(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Ue=o;function a(Pe){for(let Oe=0,qe=Pe.length;Oe<qe;Oe++){const Xe=Pe.charCodeAt(Oe);if(Xe!==32&&Xe!==9)return Oe}return-1}e.$Ve=a;function t(Pe,Oe=0,qe=Pe.length){for(let Xe=Oe;Xe<qe;Xe++){const Fe=Pe.charCodeAt(Xe);if(Fe!==32&&Fe!==9)return Pe.substring(Oe,Xe)}return Pe.substring(Oe,qe)}e.$We=t;function r(Pe,Oe=Pe.length-1){for(let qe=Oe;qe>=0;qe--){const Xe=Pe.charCodeAt(qe);if(Xe!==32&&Xe!==9)return qe}return-1}e.$Xe=r;function d(Pe,Oe,qe){const Xe=[];let Fe=0;for(const nt of Pe.matchAll(Oe)){if(Xe.push(Pe.slice(Fe,nt.index)),nt.index===void 0)throw new Error("match.index should be defined");Fe=nt.index+nt[0].length,Xe.push(qe(nt[0],...nt.slice(1),nt.index,Pe,nt.groups))}return Xe.push(Pe.slice(Fe)),Promise.all(Xe).then(nt=>nt.join(""))}e.$Ye=d;function l(Pe,Oe){return Pe<Oe?-1:Pe>Oe?1:0}e.$Ze=l;function c(Pe,Oe,qe=0,Xe=Pe.length,Fe=0,nt=Oe.length){for(;qe<Xe&&Fe<nt;qe++,Fe++){const Ie=Pe.charCodeAt(qe),Ke=Oe.charCodeAt(Fe);if(Ie<Ke)return-1;if(Ie>Ke)return 1}const ae=Xe-qe,ue=nt-Fe;return ae<ue?-1:ae>ue?1:0}e.$1e=c;function h(Pe,Oe){return S(Pe,Oe,0,Pe.length,0,Oe.length)}e.$2e=h;function S(Pe,Oe,qe=0,Xe=Pe.length,Fe=0,nt=Oe.length){for(;qe<Xe&&Fe<nt;qe++,Fe++){let Ie=Pe.charCodeAt(qe),Ke=Oe.charCodeAt(Fe);if(Ie===Ke)continue;if(Ie>=128||Ke>=128)return c(Pe.toLowerCase(),Oe.toLowerCase(),qe,Xe,Fe,nt);w(Ie)&&(Ie-=32),w(Ke)&&(Ke-=32);const Qe=Ie-Ke;if(Qe!==0)return Qe}const ae=Xe-qe,ue=nt-Fe;return ae<ue?-1:ae>ue?1:0}e.$3e=S;function L(Pe){return Pe>=48&&Pe<=57}e.$4e=L;function w(Pe){return Pe>=97&&Pe<=122}e.$5e=w;function p(Pe){return Pe>=65&&Pe<=90}e.$6e=p;function E(Pe,Oe){return Pe.length===Oe.length&&S(Pe,Oe)===0}e.$7e=E;function A(Pe,Oe){const qe=Oe.length;return Oe.length>Pe.length?!1:S(Pe,Oe,0,qe)===0}e.$8e=A;function B(Pe,Oe){const qe=Math.min(Pe.length,Oe.length);let Xe;for(Xe=0;Xe<qe;Xe++)if(Pe.charCodeAt(Xe)!==Oe.charCodeAt(Xe))return Xe;return qe}e.$9e=B;function O(Pe,Oe){const qe=Math.min(Pe.length,Oe.length);let Xe;const Fe=Pe.length-1,nt=Oe.length-1;for(Xe=0;Xe<qe;Xe++)if(Pe.charCodeAt(Fe-Xe)!==Oe.charCodeAt(nt-Xe))return Xe;return qe}e.$0e=O;function P(Pe){return 55296<=Pe&&Pe<=56319}e.$$e=P;function j(Pe){return 56320<=Pe&&Pe<=57343}e.$_e=j;function T(Pe,Oe){return(Pe-55296<<10)+(Oe-56320)+65536}e.$af=T;function F(Pe,Oe,qe){const Xe=Pe.charCodeAt(qe);if(P(Xe)&&qe+1<Oe){const Fe=Pe.charCodeAt(qe+1);if(j(Fe))return T(Xe,Fe)}return Xe}e.$bf=F;function W(Pe,Oe){const qe=Pe.charCodeAt(Oe-1);if(j(qe)&&Oe>1){const Xe=Pe.charCodeAt(Oe-2);if(P(Xe))return T(Xe,qe)}return qe}class X{get offset(){return this.e}constructor(Oe,qe=0){this.c=Oe,this.d=Oe.length,this.e=qe}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=W(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=F(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$cf=X;class ce{get offset(){return this.c.offset}constructor(Oe,qe=0){this.c=new X(Oe,qe)}nextGraphemeLength(){const Oe=oe.getInstance(),qe=this.c,Xe=qe.offset;let Fe=Oe.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const nt=qe.offset,ae=Oe.getGraphemeBreakType(qe.nextCodePoint());if(ee(Fe,ae)){qe.setOffset(nt);break}Fe=ae}return qe.offset-Xe}prevGraphemeLength(){const Oe=oe.getInstance(),qe=this.c,Xe=qe.offset;let Fe=Oe.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const nt=qe.offset,ae=Oe.getGraphemeBreakType(qe.prevCodePoint());if(ee(ae,Fe)){qe.setOffset(nt);break}Fe=ae}return Xe-qe.offset}eol(){return this.c.eol()}}e.$df=ce;function J(Pe,Oe){return new ce(Pe,Oe).nextGraphemeLength()}e.$ef=J;function Y(Pe,Oe){return new ce(Pe,Oe).prevGraphemeLength()}e.$ff=Y;function x(Pe,Oe){Oe>0&&j(Pe.charCodeAt(Oe))&&Oe--;const qe=Oe+J(Pe,Oe);return[qe-Y(Pe,qe),qe]}e.$gf=x;function se(Pe){const Oe=new ce(Pe);let qe=0;for(;!Oe.eol();)qe++,Oe.nextGraphemeLength();return qe}e.$hf=se;let Z;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function de(Pe){return Z||(Z=ve()),Z.test(Pe)}e.$if=de;const H=/^[\t\n\r\x20-\x7E]*$/;function U(Pe){return H.test(Pe)}e.$jf=U,e.$kf=/[\u2028\u2029]/;function ne(Pe){return e.$kf.test(Pe)}e.$lf=ne;function ye(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$mf=ye;function he(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$nf=he;function ge(Pe,Oe){if(Pe.length<Oe)return Pe;const qe=/\b/g;let Xe=0;for(;qe.test(Pe)&&!(Pe.length-qe.lastIndex<Oe);)Xe=qe.lastIndex,qe.lastIndex+=1;return Pe.substring(Xe).replace(/^\s/,"")}e.$of=ge;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function G(Pe){return Pe&&(Pe=Pe.replace(_,"").replace(ie,"")),Pe}e.$pf=G,e.$qf=String.fromCharCode(65279);function te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$rf=te;function fe(Pe){return te(Pe)?Pe.substr(1):Pe}e.$sf=fe;function we(Pe,Oe){if(!Pe||!Oe||Pe.length<Oe.length)return!1;const qe=Oe.length,Xe=Pe.toLowerCase();let Fe=0,nt=-1;for(;Fe<qe;){const ae=Xe.indexOf(Oe[Fe],nt+1);if(ae<0)return!1;nt=ae,Fe++}return!0}e.$tf=we;function Ae(Pe,Oe=!1){return Pe?(Oe&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$uf=Ae;function be(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$vf=be;function De(Pe,Oe=1){if(Oe===0)return"";let qe=-1;do qe=Pe.indexOf(`
`,qe+1),Oe--;while(Oe>0&&qe>=0);return qe===-1?Pe:(Pe[qe-1]==="\r"&&qe--,Pe.substr(0,qe))}e.$wf=De;function z(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$xf=z;function Q(Pe){return oe.getInstance().getGraphemeBreakType(Pe)}e.$yf=Q;function ee(Pe,Oe){return Pe===0?Oe!==5&&Oe!==7:Pe===2&&Oe===3?!1:Pe===4||Pe===2||Pe===3||Oe===4||Oe===2||Oe===3?!0:!(Pe===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Pe===11||Pe===9)&&(Oe===9||Oe===10)||(Pe===12||Pe===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Pe===1||Pe===13&&Oe===14||Pe===6&&Oe===6)}var V;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(V||(e.GraphemeBreakType=V={}));class oe{static{this.c=null}static getInstance(){return oe.c||(oe.c=new oe),oe.c}constructor(){this.d=le()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const qe=this.d,Xe=qe.length/3;let Fe=1;for(;Fe<=Xe;)if(Oe<qe[3*Fe])Fe=2*Fe;else if(Oe>qe[3*Fe+1])Fe=2*Fe+1;else return qe[3*Fe+2];return 0}}function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(Pe,Oe){if(Pe===0)return 0;const qe=je(Pe,Oe);if(qe!==void 0)return qe;const Xe=new X(Oe,Pe);return Xe.prevCodePoint(),Xe.offset}e.$zf=Le;function je(Pe,Oe){const qe=new X(Oe,Pe);let Xe=qe.prevCodePoint();for(;He(Xe)||Xe===65039||Xe===8419;){if(qe.offset===0)return;Xe=qe.prevCodePoint()}if(!he(Xe))return;let Fe=qe.offset;return Fe>0&&qe.prevCodePoint()===8205&&(Fe=qe.offset),Fe}function He(Pe){return 127995<=Pe&&Pe<=127999}var Ye;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$Af="\xA0";class _e{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(Oe=>{function qe(Qe){const rt=new Map;for(let ot=0;ot<Qe.length;ot+=2)rt.set(Qe[ot],Qe[ot+1]);return rt}function Xe(Qe,rt){const ot=new Map(Qe);for(const[Be,yt]of rt)ot.set(Be,yt);return ot}function Fe(Qe,rt){if(!Qe)return rt;const ot=new Map;for(const[Be,yt]of Qe)rt.has(Be)&&ot.set(Be,yt);return ot}const nt=this.c.value;let ae=Oe.filter(Qe=>!Qe.startsWith("_")&&Qe in nt);ae.length===0&&(ae=["_default"]);let ue;for(const Qe of ae){const rt=qe(nt[Qe]);ue=Fe(ue,rt)}const Ie=qe(nt._common),Ke=Xe(Ie,ue);return new _e(Ke)})}static getInstance(Oe){return _e.d.get(Array.from(Oe))}static{this.e=new N.$V(()=>Object.keys(_e.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return _e.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Bf=_e;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(Oe){return at.e().has(Oe)}static get codePoints(){return at.e()}}e.$Cf=at}),define(Se[123],ke([1,0,28,161,13]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.FuzzyScore=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.or=void 0;function I(...be){return function(De,z){for(let Q=0,ee=be.length;Q<ee;Q++){const V=be[Q](De,z);if(V)return V}return null}}e.or=I,e.$Oj=R.bind(void 0,!1),e.$Pj=R.bind(void 0,!0);function R(be,De,z){if(!z||z.length<De.length)return null;let Q;return be?Q=g.$8e(z,De):Q=z.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function b(be,De){const z=De.toLowerCase().indexOf(be.toLowerCase());return z===-1?null:[{start:z,end:z+be.length}]}e.$Qj=b;function $(be,De){return y(be.toLowerCase(),De.toLowerCase(),0,0)}e.$Rj=$;function y(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]===De[Q]){let ee=null;return(ee=y(be,De,z+1,Q+1))?o({start:Q,end:Q+1},ee):null}return y(be,De,z,Q+1)}function M(be){return 97<=be&&be<=122}function C(be){return 65<=be&&be<=90}e.$Sj=C;function m(be){return 48<=be&&be<=57}function v(be){return be===32||be===9||be===10||be===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>k.add(be.charCodeAt(0)));function u(be){return v(be)||k.has(be)}function f(be,De){return be===De||u(be)&&u(De)}const s=new Map;function i(be){if(s.has(be))return s.get(be);let De;const z=(0,N.$Mj)(be);return z&&(De=z),s.set(be,De),De}function n(be){return M(be)||C(be)||m(be)}function o(be,De){return De.length===0?De=[be]:be.end===De[0].start?De[0].start=be.start:De.unshift(be),De}function a(be,De){for(let z=De;z<be.length;z++){const Q=be.charCodeAt(z);if(C(Q)||m(Q)||z>0&&!n(be.charCodeAt(z-1)))return z}return be.length}function t(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]!==De[Q].toLowerCase())return null;{let ee=null,V=Q+1;for(ee=t(be,De,z+1,Q+1);!ee&&(V=a(De,V))<De.length;)ee=t(be,De,z+1,V),V++;return ee===null?null:o({start:Q,end:Q+1},ee)}}function r(be){let De=0,z=0,Q=0,ee=0,V=0;for(let He=0;He<be.length;He++)V=be.charCodeAt(He),C(V)&&De++,M(V)&&z++,n(V)&&Q++,m(V)&&ee++;const oe=De/be.length,le=z/be.length,Le=Q/be.length,je=ee/be.length;return{upperPercent:oe,lowerPercent:le,alphaPercent:Le,numericPercent:je}}function d(be){const{upperPercent:De,lowerPercent:z}=be;return z===0&&De>.6}function l(be){const{upperPercent:De,lowerPercent:z,alphaPercent:Q,numericPercent:ee}=be;return z>.2&&De<.8&&Q>.6&&ee<.2}function c(be){let De=0,z=0,Q=0,ee=0;for(let V=0;V<be.length;V++)Q=be.charCodeAt(V),C(Q)&&De++,M(Q)&&z++,v(Q)&&ee++;return(De===0||z===0)&&ee===0?be.length<=30:De<=5}function h(be,De){if(!De||(De=De.trim(),De.length===0)||!c(be)||De.length>60)return null;const z=r(De);if(!l(z)){if(!d(z))return null;De=De.toLowerCase()}let Q=null,ee=0;for(be=be.toLowerCase();ee<De.length&&(Q=t(be,De,0,ee))===null;)ee=a(De,ee+1);return Q}e.$Tj=h;function S(be,De,z=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(be=be.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=L(be,De,0,ee,z),Q===null);)ee=w(De,ee+1);return Q}e.$Uj=S;function L(be,De,z,Q,ee){let V=0;if(z===be.length)return[];if(Q===De.length)return null;if(!f(be.charCodeAt(z),De.charCodeAt(Q))){const Le=i(be.charCodeAt(z));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],De.charCodeAt(Q+je)))return null;V+=Le.length-1}let oe=null,le=Q+V+1;if(oe=L(be,De,z+1,le,ee),!ee)for(;!oe&&(le=w(De,le))<De.length;)oe=L(be,De,z+1,le,ee),le++;if(!oe)return null;if(be.charCodeAt(z)!==De.charCodeAt(Q)){const Le=i(be.charCodeAt(z));if(!Le)return oe;for(let je=0;je<Le.length;je++)if(Le[je]!==De.charCodeAt(Q+je))return oe}return o({start:Q,end:Q+V+1},oe)}function w(be,De){for(let z=De;z<be.length;z++)if(u(be.charCodeAt(z))||z>0&&u(be.charCodeAt(z-1)))return z;return be.length}const p=I(e.$Pj,h,b),E=I(e.$Pj,h,$),A=new D.$Dc(1e4);function B(be,De,z=!1){if(typeof be!="string"||typeof De!="string")return null;let Q=A.get(be);Q||(Q=new RegExp(g.$Qe(be),"i"),A.set(be,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?E(be,De):p(be,De)}e.$Vj=B;function O(be,De){const z=_(be,be.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.$Wj=O;function P(be,De,z,Q,ee,V){const oe=Math.min(13,be.length);for(;z<oe;z++){const le=_(be,De,z,Q,ee,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,V]}e.$Xj=P;function j(be){if(typeof be>"u")return[];const De=[],z=be[1];for(let Q=be.length-1;Q>1;Q--){const ee=be[Q]+z,V=De[De.length-1];V&&V.end===ee?V.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$Yj=j;const T=128;function F(){const be=[],De=[];for(let z=0;z<=T;z++)De[z]=0;for(let z=0;z<=T;z++)be.push(De.slice(0));return be}function W(be){const De=[];for(let z=0;z<=be;z++)De[z]=0;return De}const X=W(2*T),ce=W(2*T),J=F(),Y=F(),x=F(),se=!1;function Z(be,De,z,Q,ee){function V(le,Le,je=" "){for(;le.length<Le;)le=je+le;return le}let oe=` |   |${Q.split("").map(le=>V(le,3)).join("|")}
`;for(let le=0;le<=z;le++)le===0?oe+=" |":oe+=`${De[le-1]}|`,oe+=be[le].slice(0,ee+1).map(Le=>V(Le.toString(),3)).join("|")+`
`;return oe}function ve(be,De,z,Q){be=be.substr(De),z=z.substr(Q),console.log(Z(Y,be,be.length,z,z.length)),console.log(Z(x,be,be.length,z,z.length)),console.log(Z(J,be,be.length,z,z.length))}function de(be,De){if(De<0||De>=be.length)return!1;const z=be.codePointAt(De);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$nf(z)}}function H(be,De){if(De<0||De>=be.length)return!1;switch(be.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function U(be,De,z){return De[be]!==z[be]}function ne(be,De,z,Q,ee,V,oe=!1){for(;De<z&&ee<V;)be[De]===Q[ee]&&(oe&&(X[De]=ee),De+=1),ee+=1;return De===z}e.$Zj=ne;var ye;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var he;(function(be){be.Default=[-100,0];function De(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}be.isDefault=De})(he||(e.FuzzyScore=he={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,z){this.firstMatchCanBeWeak=De,this.boostFullMatch=z}}e.$1j=ge;function _(be,De,z,Q,ee,V,oe=ge.default){const le=be.length>T?T:be.length,Le=Q.length>T?T:Q.length;if(z>=le||V>=Le||le-z>Le-V||!ne(De,z,le,ee,V,Le,!0))return;ie(le,Le,z,V,De,ee);let je=1,He=1,Ye=z,_e=V;const at=[!1];for(je=1,Ye=z;Ye<le;je++,Ye++){const Fe=X[Ye],nt=ce[Ye],ae=Ye+1<le?ce[Ye+1]:Le;for(He=Fe-V+1,_e=Fe;_e<ae;He++,_e++){let ue=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=nt&&(ue=G(be,De,Ye,z,Q,ee,_e,Le,V,J[je-1][He-1]===0,at));let Ke=0;ue!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ke=ue+Y[je-1][He-1]);const Qe=_e>Fe,rt=Qe?Y[je][He-1]+(J[je][He-1]>0?-5:0):0,ot=_e>Fe+1&&J[je][He-1]>0,Be=ot?Y[je][He-2]+(J[je][He-2]>0?-5:0):0;if(ot&&(!Qe||Be>=rt)&&(!Ie||Be>=Ke))Y[je][He]=Be,x[je][He]=3,J[je][He]=0;else if(Qe&&(!Ie||rt>=Ke))Y[je][He]=rt,x[je][He]=2,J[je][He]=0;else if(Ie)Y[je][He]=Ke,x[je][He]=1,J[je][He]=J[je-1][He-1]+1;else throw new Error("not possible")}}if(se&&ve(be,z,Q,V),!at[0]&&!oe.firstMatchCanBeWeak)return;je--,He--;const Pe=[Y[je][He],V];let Oe=0,qe=0;for(;je>=1;){let Fe=He;do{const nt=x[je][Fe];if(nt===3)Fe=Fe-2;else if(nt===2)Fe=Fe-1;else break}while(Fe>=1);Oe>1&&De[z+je-1]===ee[V+He-1]&&!U(Fe+V-1,Q,ee)&&Oe+1>J[je][Fe]&&(Fe=He),Fe===He?Oe++:Oe=1,qe||(qe=Fe),je--,He=Fe-1,Pe.push(He)}Le===le&&oe.boostFullMatch&&(Pe[0]+=2);const Xe=qe-le;return Pe[0]-=Xe,Pe}e.$2j=_;function ie(be,De,z,Q,ee,V){let oe=be-1,le=De-1;for(;oe>=z&&le>=Q;)ee[oe]===V[le]&&(ce[oe]=le,oe--),le--}function G(be,De,z,Q,ee,V,oe,le,Le,je,He){if(De[z]!==V[oe])return Number.MIN_SAFE_INTEGER;let Ye=1,_e=!1;return oe===z-Q?Ye=be[z]===ee[oe]?7:5:U(oe,ee,V)&&(oe===0||!U(oe-1,ee,V))?(Ye=be[z]===ee[oe]?7:5,_e=!0):de(V,oe)&&(oe===0||!de(V,oe-1))?Ye=5:(de(V,oe-1)||H(V,oe-1))&&(Ye=5,_e=!0),Ye>1&&z===Q&&(He[0]=!0),_e||(_e=U(oe,ee,V)||de(V,oe-1)||H(V,oe-1)),z===Q?oe>Le&&(Ye-=_e?3:5):je?Ye+=_e?2:0:Ye+=_e?0:1,oe+1===le&&(Ye-=_e?3:5),Ye}function te(be,De,z,Q,ee,V,oe){return we(be,De,z,Q,ee,V,!0,oe)}e.$3j=te;function fe(be,De,z,Q,ee,V,oe){return we(be,De,z,Q,ee,V,!1,oe)}e.$4j=fe;function we(be,De,z,Q,ee,V,oe,le){let Le=_(be,De,z,Q,ee,V,le);if(Le&&!oe)return Le;if(be.length>=3){const je=Math.min(7,be.length-1);for(let He=z+1;He<je;He++){const Ye=Ae(be,He);if(Ye){const _e=_(Ye,Ye.toLowerCase(),z,Q,ee,V,le);_e&&(_e[0]-=3,(!Le||_e[0]>Le[0])&&(Le=_e))}}}return Le}function Ae(be,De){if(De+1>=be.length)return;const z=be[De],Q=be[De+1];if(z!==Q)return be.slice(0,De)+Q+z+be.slice(De+2)}}),define(Se[53],ke([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=void 0;function N(s){return g(s,0)}e.$Oi=N;function g(s,i){switch(typeof s){case"object":return s===null?I(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return b(s,i);case"boolean":return R(s,i);case"number":return I(s,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Pi=g;function I(s,i){return(i<<5)-i+s|0}e.$Qi=I;function R(s,i){return I(s?433:863,i)}function b(s,i){i=I(149417,i);for(let n=0,o=s.length;n<o;n++)i=I(s.charCodeAt(n),i);return i}e.$Ri=b;function $(s,i){return i=I(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=I(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=b(o,n),g(s[o],n)),i)}class M{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Si=M;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function v(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function k(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function u(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((s>>>0).toString(16),i/4)}e.$Ti=u;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let l=r;if(D.$$e(r))if(d+1<n){const c=i.charCodeAt(d+1);D.$_e(c)?(d++,l=D.$af(r,c)):l=65533}else{t=r;break}else D.$_e(r)&&(l=65533);if(a=this.w(o,a,l),d++,d<n)r=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,n=this.q;for(let S=0;S<64;S+=4)i.setUint32(S,n.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)i.setUint32(S,m(i.getUint32(S-12,!1)^i.getUint32(S-32,!1)^i.getUint32(S-56,!1)^i.getUint32(S-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,d=this.o,l,c,h;for(let S=0;S<80;S++)S<20?(l=a&t|~a&r,c=1518500249):S<40?(l=a^t^r,c=1859775393):S<60?(l=a&t|a&r|t&r,c=2400959708):(l=a^t^r,c=3395469782),h=m(o,5)+l+d+c+i.getUint32(S*4,!1)&4294967295,d=r,r=t,t=m(a,30),a=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Ui=f}),define(Se[39],ke([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(N||(N={})),function(g){const I="error",R="warning",b="warn",$="info",y="ignore";function M(m){return m?D.$7e(I,m)?g.Error:D.$7e(R,m)||D.$7e(b,m)?g.Warning:D.$7e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=M;function C(m){switch(m){case g.Error:return I;case g.Warning:return R;case g.Info:return $;default:return y}}g.toString=C}(N||(N={})),e.default=N}),define(Se[163],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Se[77],ke([1,0,19,13]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const k=v.charCodeAt(0),u=this.b.charCodeAt(this.c);return k-u}value(){return this.b[this.c]}}e.$3h=g;class I{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$1e)(v,this.b,0,v.length,this.c,this.d):(0,N.$3e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=I;class R{constructor(v=!0,k=!0){this.f=v,this.g=k}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let k=v.length-1;k>=0;k--,this.c--){const u=this.b.charCodeAt(k);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$1e)(v,this.b,0,v.length,this.d,this.e):(0,N.$3e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=R;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,k){this.f=v,this.g=k,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$2e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$2e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$Ze)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$Ze)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class C{static forUris(v=()=>!1,k=()=>!1){return new C(new $(v,k))}static forPaths(v=!1){return new C(new R(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,k){if(k){const u=k.slice(0);(0,D.$Xb)(u);for(const f of u)this.set(f,v)}else{const u=v.slice(0);(0,D.$Xb)(u);for(const f of u)this.set(f[0],f[1])}}set(v,k){const u=this.b.reset(v);let f;this.c||(this.c=new y,this.c.segment=u.value());const s=[];for(f=this.c;;){const n=u.cmp(f.segment);if(n>0)f.left||(f.left=new y,f.left.segment=u.value()),s.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new y,f.right.segment=u.value()),s.push([1,f]),f=f.right;else if(u.hasNext())u.next(),f.mid||(f.mid=new y,f.mid.segment=u.value()),s.push([0,f]),f=f.mid;else break}const i=f.value;f.value=k,f.key=v;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const k=this.b.reset(v);let u=this.c;for(;u;){const f=k.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(k.hasNext())k.next(),u=u.mid;else break}return u}has(v){const k=this.d(v);return!(k?.value===void 0&&k?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,k){const u=this.b.reset(v),f=[];let s=this.c;for(;s;){const i=u.cmp(s.segment);if(i>0)f.push([-1,s]),s=s.left;else if(i<0)f.push([1,s]),s=s.right;else if(u.hasNext())u.next(),f.push([0,s]),s=s.mid;else break}if(s){if(k?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(f.length>0){const[n,o]=f[f.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const k=this.b.reset(v);let u=this.c,f;for(;u;){const s=k.cmp(u.segment);if(s>0)u=u.left;else if(s<0)u=u.right;else if(k.hasNext())k.next(),f=u.value||f,u=u.mid;else break}return u&&u.value||f}findSuperstr(v){return this.g(v,!1)}g(v,k){const u=this.b.reset(v);let f=this.c;for(;f;){const s=u.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else return f.mid?this.h(f.mid):k?f.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[k,u]of this)v(u,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const k=[];return this.j(v,k),k[Symbol.iterator]()}j(v,k){v&&(v.left&&this.j(v.left,k),v.value&&k.push([v.key,v.value]),v.mid&&this.j(v.mid,k),v.right&&this.j(v.right,k))}_isBalanced(){const v=k=>{if(!k)return!0;const u=k.balanceFactor();return u<-1||u>1?!1:v(k.left)&&v(k.right)};return v(this.c)}}e.$7h=C}),define(Se[18],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=void 0;function D(a){return typeof a=="string"}e.$Df=D;function N(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Ef=N;function g(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ff=g;function I(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Gf=I;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Hf=R;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$If=b;function $(a){return a===!0||a===!1}e.$Jf=$;function y(a){return typeof a>"u"}e.$Kf=y;function M(a){return!C(a)}e.$Lf=M;function C(a){return y(a)||a===null}e.$Mf=C;function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Nf=m;function v(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Of=v;function k(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(C(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Pf=k;const u=Object.prototype.hasOwnProperty;function f(a){if(!g(a))return!1;for(const t in a)if(u.call(a,t))return!1;return!0}e.$Qf=f;function s(a){return typeof a=="function"}e.$Rf=s;function i(...a){return a.length>0&&a.every(s)}e.$Sf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)o(a[d],t[d])}e.$Tf=n;function o(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Uf=o}),define(Se[78],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=e.$5j=void 0;const N=Object.create(null);function g(b,$){if((0,D.$Df)($)){const y=N[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return N[b]=$,{id:b}}function I(){return N}e.$5j=I;function R(){return Object.values(e.$7j)}e.$6j=R,e.$7j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[24],ke([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function N(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?N(o):o}),i}e.$gn=N;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(I.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Gf)(a)&&i.push(a)}}return s}e.$hn=g;const I=Object.prototype.hasOwnProperty;function R(s,i){return b(s,i,new Set)}e.$in=R;function b(s,i,n){if((0,D.$Mf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(b(t,i,n));return a}if((0,D.$Ff)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)I.call(s,t)&&(a[t]=b(s[t],i,n));return n.delete(s),a}return s}function $(s,i,n=!0){return(0,D.$Ff)(s)?((0,D.$Ff)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Ff)(s[o])&&(0,D.$Ff)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$jn=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(a,t))return!1;for(n=0;n<a.length;n++)if(!y(s[a[n]],i[a[n]]))return!1}return!0}e.$kn=y;function M(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Ff)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$ln=M;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];y(t,r)||(n[a]=r)}),n}e.$mn=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$nn=m;function v(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$on=v;function k(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$pn=k;function u(s){const i=[];for(const n of k(s))typeof s[n]=="function"&&i.push(n);return i}e.$qn=u;function f(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$rn=f}),define(Se[61],ke([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$8j=e.ThemeColor=void 0;var N;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(N||(e.ThemeColor=N={}));function g(R){return{id:R}}e.$8j=g;var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(D.$7j.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=$;function y(i){return $(i).join(" ")}R.asClassName=y;function M(i){return"."+$(i).join(".")}R.asCSSSelector=M;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=v;function k(i){return{id:i}}R.fromId=k;function u(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=u;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=f;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(I||(e.ThemeIcon=I={}))}),define(Se[164],ke([1,0,123,13,61]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=void 0;const I="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}e.$9j=$;const y=new RegExp(`\\\\${R.source}`,"g");function M(s){return s.replace(y,i=>`\\${i}`)}e.$0j=M;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(s){return s.indexOf(I)===-1?s:s.replace(C,(i,n,o,a)=>o?i:n||a||"")}e.$$j=m;function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$_j=v;const k=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(s){k.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=k.lastIndex,t=k.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$ak=u;function f(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Vj)(s,o,n);const t=(0,N.$Oe)(o," "),r=o.length-t.length,d=(0,D.$Vj)(s,t,n);if(d)for(const l of d){const c=a[l.start+r]+r;l.start+=c,l.end+=c}return d}e.$bk=f}),define(Se[124],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(I){return I<0?0:I>255?255:I|0}e.$Ee=N;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Fe=g}),define(Se[30],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(g){return D.test(g)}e.$kg=N,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y}}()}),define(Se[165],ke([1,0,19,52,30]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=e.$_s=e.$$s=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$$s=I;function R(C,m,v){const k={id:(0,g.$lg)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$_s=R;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return N.Iterable.some(this,([k,u])=>u.asFile())&&v.push("files"),M($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const k=this.a.get(m);k?k.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const k of v)yield[m,k]}b(m){return $(m)}}e.$at=b;function $(C){return C.toLowerCase()}function y(C,m){return M($(C),m.map($))}e.$bt=y;function M(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[k,u,f]=v;return f==="*"?m.some(s=>s.startsWith(u+"/")):!1}e.$ct=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$ct.split(C).filter(m=>!m.startsWith("#"))})}),define(Se[166],ke([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=e.$ng=void 0;function N(b,$,y,M=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,M,k=>{if(!C)return C=!0,clearTimeout(v),m(k)})})}e.$ng=N;function g(b,$,y,M){if($===0)return M(0);const C=new D.Socket;C.once("connect",()=>(R(C),g(b+y,$-1,y,M))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,M):M(b))),C.connect(b,"127.0.0.1")}e.$og={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,M="127.0.0.1"){let C=!1,m,v=1;const k=D.createServer({pauseOnConnect:!0});function u(f,s){C||(C=!0,k.removeAllListeners(),k.close(),m&&clearTimeout(m),s(f))}return new Promise(f=>{m=setTimeout(()=>{u(0,f)},y),k.on("listening",()=>{u(b,f)}),k.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&v<$?(b++,v++,k.listen(b,M)):u(0,f)}),k.on("close",()=>{u(0,f)}),k.listen(b,M)})}e.$pg=I;function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[125],ke([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;class N{constructor(b){const $=(0,D.$Ee)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$Ee)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$3s=N;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$4s=I}),define(Se[167],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(g){let I=0,R=0,b=0,$=0;for(let y=0,M=g.length;y<M;y++){const C=g.charCodeAt(y);C===13?(I===0&&(R=y),I++,y+1<M&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(R=y),I++,b=y+1)}return I===0&&(R=g.length),[I,R,g.length-b,$]}e.$ft=N}),define(Se[49],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const R=g.lineNumber|0,b=I.lineNumber|0;if(R===b){const $=g.column|0,y=I.column|0;return $-y}return R-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Es=D}),define(Se[29],ke([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class N{constructor(I,R,b,$){I>b||I===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return N.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return N.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return N.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return N.plusRange(this,I)}static plusRange(I,R){let b,$,y,M;return R.startLineNumber<I.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===I.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),R.endLineNumber>I.endLineNumber?(y=R.endLineNumber,M=R.endColumn):R.endLineNumber===I.endLineNumber?(y=R.endLineNumber,M=Math.max(R.endColumn,I.endColumn)):(y=I.endLineNumber,M=I.endColumn),new N(b,$,y,M)}intersectRanges(I){return N.intersectRanges(this,I)}static intersectRanges(I,R){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,M=I.endColumn;const C=R.startLineNumber,m=R.startColumn,v=R.endLineNumber,k=R.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,M=k):y===v&&(M=Math.min(M,k)),b>y||b===y&&$>M?null:new N(b,$,y,M)}equalsRange(I){return N.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(I){return new D.$Es(I.endLineNumber,I.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(I){return new D.$Es(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new N(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new N(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(I){return new N(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(I){return new N(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new N(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new N(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new N(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const y=I.startLineNumber|0,M=R.startLineNumber|0;if(y===M){const C=I.startColumn|0,m=R.startColumn|0;if(C===m){const v=I.endLineNumber|0,k=R.endLineNumber|0;if(v===k){const u=I.endColumn|0,f=R.endColumn|0;return u-f}return v-k}return C-m}return y-M}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Fs=N}),define(Se[168],ke([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class N{static insert(I,R){return{range:new D.$Fs(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Gs=N}),define(Se[169],ke([1,0,49,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends N.$Fs{constructor(b,$,y,M){super(b,$,y,M),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Es(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Es(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,M=b.length;y<M;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,M,C){return C===0?new I(b,$,y,M):new I(y,M,b,$)}}e.$Hs=I}),define(Se[170],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$cs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[171],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.WordCharacterClass=void 0;var N;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class g extends D.$3s{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$5s=g;function I(R){const b={};return $=>(b.hasOwnProperty($)||(b[$]=R($)),b[$])}e.$6s=I(R=>new g(R))}),define(Se[126],ke([1,0,52,3,75]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.$es=e.$ds=void 0,e.$ds="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$ds)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$es=I();function R(C){let m=e.$es;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$fs=R;const b=new g.$3c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,N.$Qc)(m)}e.$gs=$;function y(C,m,v,k,u){if(m=R(m),u||(u=D.Iterable.first(b)),v.length>u.maxLen){let o=C-u.maxLen/2;return o<0?o=0:k+=o,v=v.substring(o,C+u.maxLen/2),y(C,m,v,k,u)}const f=Date.now(),s=C-1-k;let i=-1,n=null;for(let o=1;!(Date.now()-f>=u.timeBudget);o++){const a=s-u.windowSize*o;m.lastIndex=Math.max(0,a);const t=M(m,v,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$hs=y;function M(C,m,v,k){let u;for(;u=C.exec(m);){const f=u.index||0;if(f<=v&&C.lastIndex>=v)return u;if(k>0&&f>k)return null}return null}}),define(Se[172],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),M=b.getStandardTokenType(y);return this.isOK(M)}g(b,$){for(let y=b;y<=$;y++){const M=String.fromCharCode(y);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Ct=N;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Dt=g;function I(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(Se[173],ke([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jZ=e.$iZ=e.$hZ=e.State=void 0;var N;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class g{constructor(k,u,f){const s=new Uint8Array(k*u);for(let i=0,n=k*u;i<n;i++)s[i]=f;this.a=s,this.rows=k,this.cols=u}get(k,u){return this.a[k*this.cols+u]}set(k,u,f){this.a[k*this.cols+u]=f}}class I{constructor(k){let u=0,f=0;for(let i=0,n=k.length;i<n;i++){const[o,a,t]=k[i];a>u&&(u=a),o>f&&(f=o),t>f&&(f=t)}u++,f++;const s=new g(f,u,0);for(let i=0,n=k.length;i<n;i++){const[o,a,t]=k[i];s.set(o,a,t)}this.a=s,this.b=u}nextState(k,u){return u<0||u>=this.b?0:this.a.get(k,u)}}e.$hZ=I;let R=null;function b(){return R===null&&(R=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function M(){if(y===null){y=new D.$3s(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<v.length;u++)y.set(v.charCodeAt(u),1);const k=".,;:";for(let u=0;u<k.length;u++)y.set(k.charCodeAt(u),2)}return y}class C{static a(k,u,f,s,i){let n=i-1;do{const o=u.charCodeAt(n);if(k.get(o)!==2)break;n--}while(n>s);if(s>0){const o=u.charCodeAt(s-1),a=u.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:f,startColumn:s+1,endLineNumber:f,endColumn:n+2},url:u.substring(s,n+1)}}static computeLinks(k,u=b()){const f=M(),s=[];for(let i=1,n=k.getLineCount();i<=n;i++){const o=k.getLineContent(i),a=o.length;let t=0,r=0,d=0,l=1,c=!1,h=!1,S=!1,L=!1;for(;t<a;){let w=!1;const p=o.charCodeAt(t);if(l===13){let E;switch(p){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:S=!0,h=!0,E=0;break;case 93:S=!1,E=h?0:1;break;case 123:L=!0,E=0;break;case 125:E=L?0:1;break;case 39:case 34:case 96:d===p?E=1:d===39||d===34||d===96?E=0:E=1;break;case 42:E=d===42?1:0;break;case 124:E=d===124?1:0;break;case 32:E=S?0:1;break;default:E=f.get(p)}E===1&&(s.push(C.a(f,o,i,r,t)),w=!0)}else if(l===12){let E;p===91?(h=!0,E=0):E=f.get(p),E===1?w=!0:l=13}else l=u.nextState(l,p),l===0&&(w=!0);w&&(l=1,c=!1,h=!1,L=!1,r=t+1,d=p),t++}l===13&&s.push(C.a(f,o,i,r,a))}return s}}e.$iZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$jZ=m}),define(Se[79],ke([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.$1u=e.$Zu=e.ModelConstants=e.PositionAffinity=e.$Yu=e.TrackedRangeStickiness=e.$Xu=e.$Wu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$kn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Wu=M;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Xu=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(o){return o&&typeof o.read=="function"}e.$Yu=v;var k;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var u;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class f{constructor(a,t,r,d,l,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=l,this._isTracked=c}}e.$Zu=f;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$1u=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$2u=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$3u=n}),define(Se[174],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.NodeColor=e.$yB=void 0;class D{constructor(f,s){this.piece=f,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$zB)return g(this.right);let f=this;for(;f.parent!==e.$zB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$zB?e.$zB:f.parent}prev(){if(this.left!==e.$zB)return I(this.left);let f=this;for(;f.parent!==e.$zB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$zB?e.$zB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$yB=D;var N;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$zB=new D(null,0),e.$zB.parent=e.$zB,e.$zB.left=e.$zB,e.$zB.right=e.$zB,e.$zB.color=0;function g(u){for(;u.left!==e.$zB;)u=u.left;return u}e.$AB=g;function I(u){for(;u.right!==e.$zB;)u=u.right;return u}e.$BB=I;function R(u){return u===e.$zB?0:u.size_left+u.piece.length+R(u.right)}function b(u){return u===e.$zB?0:u.lf_left+u.piece.lineFeedCnt+b(u.right)}function $(){e.$zB.parent=e.$zB}function y(u,f){const s=f.right;s.size_left+=f.size_left+(f.piece?f.piece.length:0),s.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=s.left,s.left!==e.$zB&&(s.left.parent=f),s.parent=f.parent,f.parent===e.$zB?u.root=s:f.parent.left===f?f.parent.left=s:f.parent.right=s,s.left=f,f.parent=s}e.$CB=y;function M(u,f){const s=f.left;f.left=s.right,s.right!==e.$zB&&(s.right.parent=f),s.parent=f.parent,f.size_left-=s.size_left+(s.piece?s.piece.length:0),f.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),f.parent===e.$zB?u.root=s:f===f.parent.right?f.parent.right=s:f.parent.left=s,s.right=f,f.parent=s}e.$DB=M;function C(u,f){let s,i;if(f.left===e.$zB?(i=f,s=i.right):f.right===e.$zB?(i=f,s=i.left):(i=g(f.right),s=i.right),i===u.root){u.root=s,s.color=0,f.detach(),$(),u.root.parent=e.$zB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===f?(s.parent=i.parent,k(u,s)):(i.parent===f?s.parent=i:s.parent=i.parent,k(u,s),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===u.root?u.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$zB&&(i.left.parent=i),i.right!==e.$zB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,k(u,i)),f.detach(),s.parent.left===s){const a=R(s),t=b(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,v(u,s.parent,r,d)}}if(k(u,s.parent),n){$();return}let o;for(;s!==u.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(u,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,M(u,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(u,s.parent),s=u.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,M(u,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(u,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,M(u,s.parent),s=u.root));s.color=0,$()}e.$EB=C;function m(u,f){for(k(u,f);f!==u.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const s=f.parent.parent.right;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(u,f)),f.parent.color=0,f.parent.parent.color=1,M(u,f.parent.parent))}else{const s=f.parent.parent.left;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,M(u,f)),f.parent.color=0,f.parent.parent.color=1,y(u,f.parent.parent))}u.root.color=0}e.$FB=m;function v(u,f,s,i){for(;f!==u.root&&f!==e.$zB;)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}e.$GB=v;function k(u,f){let s=0,i=0;if(f!==u.root){for(;f!==u.root&&f===f.parent.right;)f=f.parent;if(f!==u.root)for(f=f.parent,s=R(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=s,f.lf_left+=i;f!==u.root&&(s!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}}e.$HB=k}),define(Se[175],ke([1,0,19,124]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.$6u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,N.$Fe)($);const M=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(M.length+m),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,N.$Fe)($),y=(0,N.$Fe)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,N.$Fe)($),y=(0,N.$Fe)(y);const M=this.a,C=this.b;if($>=M.length)return!1;const m=M.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(M.length-y),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Fe)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let M=y;M<=$;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,M=this.a.length-1,C=0,m=0,v=0;for(;y<=M;)if(C=y+(M-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)M=C-1;else if($>=m)y=C+1;else break;return new R(C,$-v)}}e.$6u=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],M=y>0?this.d[y-1]:0;return new R(y,$-M)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const M=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+M;for(let m=0;m<M;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$7u=I;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$8u=R}),define(Se[176],ke([1,0,13,49,175]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=void 0;class I{constructor(b,$,y,M){this.d=b,this.f=$,this.g=y,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new N.$Es(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let M=0;M<$;M++)y[M]=this.f[M].length+b;this.j=new g.$6u(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ue)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const M=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),M[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,M)}}e.$9u=I}),define(Se[99],ke([1,0,13,171,49,29,79]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=void 0;const b=999;class ${constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Se(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$1u(n,this.wordSeparators?(0,N.$6s)(this.wordSeparators):null,o?this.searchString:null)}}e.$IB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$JB=y;function M(s,i,n){if(!n)return new R.$Xu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.$Xu(s,o)}e.$KB=M;class C{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new f(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let d,l=0;a?(l=a.findLineFeedCountBeforeOffset(t),d=n+t+l):d=n+t;let c;if(a){const w=a.findLineFeedCountBeforeOffset(t+r.length)-l;c=d+r.length+w}else c=d+r.length;const h=i.getPositionAt(d),S=i.getPositionAt(c);return new I.$Fs(h.lineNumber,h.column,S.lineNumber,S.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),l=i.getEOL()===`\r
`?new C(d):null,c=[];let h=0,S;for(o.reset(0);S=o.next(d);)if(c[h++]=M(this.a(i,r,d,l,S.index,S[0]),S,a),h>=t)return c;return c}static c(i,n,o,a,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,c,n.startLineNumber,n.startColumn-1,d,r,a,t),r}const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,l,n.startLineNumber,n.startColumn-1,d,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&d<t;c++)d=this.d(o,i.getLineContent(c),c,0,d,r,a,t);if(d<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,c,n.endLineNumber,0,d,r,a,t)}return r}static d(i,n,o,a,t,r,d,l){const c=i.wordSeparators;if(!d&&i.simpleSearch){const L=i.simpleSearch,w=L.length,p=n.length;let E=-w;for(;(E=n.indexOf(L,E+w))!==-1;)if((!c||u(c,n,p,E,w))&&(r[t++]=new R.$Xu(new I.$Fs(o,E+1+a,o,E+1+w+a),null),t>=l))return t;return t}const h=new f(i.wordSeparators,i.regex);let S;h.reset(0);do if(S=h.next(n),S&&(r[t++]=M(new I.$Fs(o,S.index+1+a,o,S.index+1+S[0].length+a),S,d),t>=l))return t;while(S);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new g.$Es(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),l=i.getValueInRange(new I.$Fs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),c=i.getEOL()===`\r
`?new C(l):null;o.reset(n.column-1);const h=o.next(l);return h?M(this.a(i,r,l,c,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Es(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),l=this.g(o,d,r,n.column,a);if(l)return l;for(let c=1;c<=t;c++){const h=(r+c-1)%t,S=i.getLineContent(h+1),L=this.g(o,S,h+1,1,a);if(L)return L}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?M(new I.$Fs(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new I.$Fs(1,1,n.lineNumber,n.column),o,a,10*b);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Es(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),l=this.k(o,d,r,a);if(l)return l;for(let c=1;c<=t;c++){const h=(t+r-c-1)%t,S=i.getLineContent(h+1),L=this.k(o,S,h+1,a);if(L)return L}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=M(new I.$Fs(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$LB=m;function v(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function k(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function u(s,i,n,o,a){return v(s,i,n,o,a)&&k(s,i,n,o,a)}e.$MB=u;class f{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){D.$bf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$NB=f}),define(Se[127],ke([1,0,49,29,79,174,99]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=e.$RB=e.$QB=e.$PB=e.$OB=void 0;const b=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function M(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?$(n):n}e.$OB=M;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let l=0,c=i.length;l<c;l++){const h=i.charCodeAt(l);h===13?l+1<c&&i.charCodeAt(l+1)===10?(t++,s[n++]=l+2,l++):(o++,s[n++]=l+1):h===10?(a++,s[n++]=l+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new y($(s),o,a,t,r);return s.length=0,d}e.$PB=C;class m{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$QB=m;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$RB=v;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==I.$zB&&i.iterate(i.root,o=>(o!==I.$zB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class f{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=I.$zB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=M(i[t].buffer));const d=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(r<=o||r+h<a)return t+=c,r+=h,!0;const S=t.replace(/\r\n|\r|\n/g,i);return d.push(new v(S,M(S))),t=c,r=h,!0}),r>0){const l=t.replace(/\r\n|\r|\n/g,i);d.push(new v(l,M(l)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===I.$zB)return!0;const t=this.R(a),r=t.length,d=i.G(n),l=i.G(n+r),c=i.getValueInRange2(d,l);return n+=r,t===c})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==I.$zB;)if(a.left!==I.$zB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==I.$zB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=a-r;return new D.$Es(o+1,d+1)}return new D.$Es(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===I.$zB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new D.$Es(o+1,r+1)}else n=n.right;return new D.$Es(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+i.remainder,c+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==I.$zB;){const d=this.a[o.piece.bufferIndex].buffer,l=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(l,l+n.remainder);break}else r+=d.substr(l,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===I.$zB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const l=this.a[r.bufferIndex].buffer,c=this.a[r.bufferIndex].lineStarts,h=r.start.line,S=r.end.line;let L=c[h]+r.start.column;if(a&&(l.charCodeAt(L)===10&&(L++,d--),i[n++]=o,o="",a=!1,d===0))return!0;if(h===S)return!this.f&&l.charCodeAt(L+d-1)===13?(a=!0,o+=l.substr(L,d-1)):o+=l.substr(L,d),!0;o+=this.f?l.substring(L,Math.max(L,c[h+1]-this.e)):l.substring(L,c[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let w=h+1;w<S;w++)o=this.f?l.substring(c[w],c[w+1]-this.e):l.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&l.charCodeAt(c[S]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=l.substr(c[S],r.end.column-1)):o=l.substr(c[S],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,d,l,c,h,S){const L=this.a[i.piece.bufferIndex],w=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,r);let A;const B={line:0,column:0};let O,P;n._wordSeparators?(O=L.buffer.substring(p,E),P=j=>j+p,n.reset(0)):(O=L.buffer,P=j=>j,n.reset(p));do if(A=n.next(O),A){if(P(A.index)>=E)return h;this.s(i,P(A.index)-w,B);const j=this.t(i.piece.bufferIndex,t,B),T=B.line===t.line?B.column-t.column+a:B.column+1,F=T+A[0].length;if(S[h++]=(0,R.$KB)(new N.$Fs(o+j,T,o+j,F),A,l),P(A.index)+A[0].length>=E||h>=c)return h}while(A);return h}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const d=new R.$NB(n.wordSeparators,n.regex);let l=this.H(i.startLineNumber,i.startColumn);if(l===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const S=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,i.startLineNumber,i.startColumn,h,S,n,o,a,r,t),t;let L=i.startLineNumber,w=l.node;for(;w!==c.node;){const E=this.t(w.piece.bufferIndex,h,w.piece.end);if(E>=1){const B=this.a[w.piece.bufferIndex].lineStarts,O=this.u(w.piece.bufferIndex,w.piece.start),P=B[h.line+E],j=L===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(w,d,L,j,h,this.s(w,P-O),n,o,a,r,t),r>=a)return t;L+=E}const A=L===i.startLineNumber?i.startColumn-1:0;if(L===i.endLineNumber){const B=this.getLineContent(L).substring(A,i.endColumn-1);return r=this.n(n,d,B,i.endLineNumber,A,r,t,o,a),t}if(r=this.n(n,d,this.getLineContent(L).substr(A),L,A,r,t,o,a),r>=a)return t;L++,l=this.H(L,1),w=l.node,h=this.s(l.node,l.remainder)}if(L===i.endLineNumber){const E=L===i.startLineNumber?i.startColumn-1:0,A=this.getLineContent(L).substring(E,i.endColumn-1);return r=this.n(n,d,A,i.endLineNumber,E,r,t,o,a),t}const p=L===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,d,L,p,h,S,n,o,a,r,t),t}n(i,n,o,a,t,r,d,l,c){const h=i.wordSeparators;if(!l&&i.simpleSearch){const L=i.simpleSearch,w=L.length,p=o.length;let E=-w;for(;(E=o.indexOf(L,E+w))!==-1;)if((!h||(0,R.$MB)(h,o,p,E,w))&&(d[r++]=new g.$Xu(new N.$Fs(a,E+1+t,a,E+1+w+t),null),r>=c))return r;return r}let S;n.reset(0);do if(S=n.next(o),S&&(d[r++]=(0,R.$KB)(new N.$Fs(a,S.index+1+t,a,S.index+1+S[0].length+t),S,l),r>=c))return r;while(S);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==I.$zB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),d=a.piece,l=d.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<b){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const h=[];let S=new m(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const E={line:S.start.line+1,column:0};S=new m(S.bufferIndex,E,S.end,this.t(S.bufferIndex,E,S.end),S.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const E=this.s(a,t-1);this.C(a,E),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,c);else this.C(a,c);const L=this.w(n);S.length>0&&this.S(a,S);let w=a;for(let p=0;p<L.length;p++)w=this.S(w,L[p]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===I.$zB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const L=this.s(t,o.remainder),w=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,I.$EB)(this,t),this.N(p),this.y();return}this.D(t,w),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,L),this.O(t),this.y();return}this.E(t,L,w),this.y();return}const d=[],l=this.s(t,o.remainder);this.C(t,l),this.h.validate(i),t.piece.length===0&&d.push(t);const c=this.s(r,a.remainder);this.D(r,c),r.piece.length===0&&d.push(r);const h=t.next();for(let L=h;L!==I.$zB&&L!==r;L=L.next())d.push(L);const S=t.piece.length===0?t.prev():t;this.v(d),this.O(S),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},l=new m(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=l,i+=`
`,(0,I.$GB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,l=r[a.start.line]+a.start.column+n;let c=a.start.line,h=a.end.line,S=0,L=0,w=0;for(;c<=h&&(S=c+(h-c)/2|0,w=r[S],S!==h);)if(L=r[S+1],l<w)h=S-1;else if(l>=L)c=S+1;else break;return o?(o.line=S,o.column=l-w,null):{line:S,column:l-w}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,I.$EB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const L=i.charCodeAt(b-1);let w;L===13||L>=55296&&L<=56319?(w=i.substring(0,b-1),i=i.substring(b-1)):(w=i.substring(0,b),i=i.substring(b));const p=M(w);h.push(new m(this.a.length,{line:0,column:0},{line:p.length-1,column:w.length-p[p.length-1]},p.length-1,w.length)),this.a.push(new v(w,p))}const S=M(i);return h.push(new m(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new v(i,S)),h}let n=this.a[0].buffer.length;const o=M(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],l={line:r,column:d},c=new m(0,a,l,this.t(0,a,l),t-n);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,l=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=d.substring(l+r,l+o.piece.length);else{const c=this.B(o,i-t.nodeStartLineNumber);return d.substring(l+r,l+c-n)}}else{let r=0;const d=i;for(;o!==I.$zB;)if(o.left!==I.$zB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const l=this.B(o,i-o.lf_left-2),c=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(S+l,S+c-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const l=this.B(o,i-o.lf_left-2),c=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);a=c.substring(h+l,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==I.$zB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),l=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(l,l+d-n),a}else{const d=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(d,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==I.$zB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),l=this.t(o.bufferIndex,o.start,r),c=l-a,h=d-t,S=o.length+h;i.piece=new m(o.bufferIndex,o.start,r,l,S),(0,I.$GB)(this,i,h,c)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),l=this.u(o.bufferIndex,r),c=d-a,h=t-l,S=o.length+h;i.piece=new m(o.bufferIndex,r,o.end,d,S),(0,I.$GB)(this,i,h,c)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,d=a.length,l=a.lineFeedCnt,c=n,h=this.t(a.bufferIndex,a.start,c),S=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new m(a.bufferIndex,a.start,c,h,S),(0,I.$GB)(this,i,S-d,h-l);const L=new m(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),w=this.S(i,L);this.N(w)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=M(n,!1);for(let w=0;w<t.length;w++)t[w]+=a;if(o){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],l={line:r,column:d},c=i.piece.length+n.length,h=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,l),L=S-h;i.piece=new m(i.piece.bufferIndex,i.piece.start,l,S,c),this.g=l,(0,I.$GB)(this,i,n.length,L)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==I.$zB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==I.$zB;)if(o.left!==I.$zB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==I.$zB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$zB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$zB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,d,r),(0,I.$GB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const l={line:n.piece.start.line+1,column:0},c=n.piece.length-1,h=this.t(n.piece.bufferIndex,l,n.piece.end);n.piece=new m(n.piece.bufferIndex,l,n.piece.end,h,c),(0,I.$GB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const S=this.w(`\r
`);this.S(i,S[0]);for(let L=0;L<o.length;L++)(0,I.$EB)(this,o[L])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,I.$EB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);o.piece=new m(a.bufferIndex,t,a.end,d,r),(0,I.$GB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===I.$zB)return n(I.$zB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===I.$zB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new I.$yB(n,1);if(o.left=I.$zB,o.right=I.$zB,o.parent=I.$zB,o.size_left=0,o.lf_left=0,this.root===I.$zB)this.root=o,o.color=0;else if(i.right===I.$zB)i.right=o,o.parent=i;else{const t=(0,I.$AB)(i.right);t.left=o,o.parent=t}return(0,I.$FB)(this,o),o}T(i,n){const o=new I.$yB(n,1);if(o.left=I.$zB,o.right=I.$zB,o.parent=I.$zB,o.size_left=0,o.lf_left=0,this.root===I.$zB)this.root=o,o.color=0;else if(i.left===I.$zB)i.left=o,o.parent=i;else{const a=(0,I.$BB)(i.left);a.right=o,o.parent=a}return(0,I.$FB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$SB=f}),define(Se[177],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97=e.$87=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const R=this.a.get(I);return this.a.delete(I),R}}addDragOperationTransfer(I,R){this.a.set(I,R)}}e.$87=D;class N{constructor(I){this.identifier=I}}e.$97=N}),define(Se[178],ke([1,0,4,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Qc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,N.$Qc)(()=>{const M=this.b.get(b);!M||M!==y||(this.b.delete(b),M.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$et=g;class I extends N.$Sc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[179],ke([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Se[180],ke([1,0,4,3,179]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class I extends N.$Sc{constructor(m,v="",k="",u=!0,f){super(),this.h=this.B(new D.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=v,this.u=k,this.w=u,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,v){this.C&&await this.C(m)}}e.$Fi=I;class R extends N.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Sd),this.onWillRun=this.f.event,this.m=this.B(new D.$Sd),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let k;try{await this.u(m,v)}catch(u){k=u}this.m.fire({action:m,error:k})}async u(m,v){await m.run(v)}}e.$Gi=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const k of m)k.length&&(v.length?v=[...v,new b,...k]:v=k);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Hi=b;class ${get actions(){return this.a}constructor(m,v,k,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=u,this.a=k}async run(){}}e.$Ii=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ji=y;function M(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Ki=M}),define(Se[181],ke([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Se[182],ke([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0;const N=60,g=N*60,I=g*24,R=I*7,b=I*30,$=I*365;function y(C,m,v,k){typeof C!="number"&&(C=C.getTime());const u=Math.round((new Date().getTime()-C)/1e3);if(u<-30)return(0,D.localize)(0,null,y(new Date().getTime()+u*1e3,!1));if(!k&&u<30)return(0,D.localize)(1,null);let f;return u<N?(f=u,m?f===1?v?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):v?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?v?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):v?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):u<g?(f=Math.floor(u/N),m?f===1?v?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):v?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?v?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):v?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):u<I?(f=Math.floor(u/g),m?f===1?v?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):v?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?v?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):v?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):u<R?(f=Math.floor(u/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):u<b?(f=Math.floor(u/R),m?f===1?v?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):v?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?v?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):v?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):u<$?(f=Math.floor(u/b),m?f===1?v?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):v?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?v?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):v?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(u/$),m?f===1?v?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):v?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?v?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):v?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$pm=y;function M(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$qm=M}),define(Se[183],ke([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Se[44],ke([1,0,19,18,183]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),R(C.stack)||R(C.stacktrace)):b(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Hb(C),k=$(v[0],m);return v.length>1?g.localize(4,null,k,v.length):k}if(N.$Df(C))return C;if(C.detail){const v=C.detail;if(v.error)return I(v.error,m);if(v.exception)return I(v.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Li=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Mi=y;function M(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Ni=M}),define(Se[184],ke([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Se[11],ke([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,g=!1,I=!1,R=!1,b=!1,$=!1,y=!1,M=!1,C=!1,m=!1,v,k=e.$g,u=e.$g,f,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,N=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,M=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,k=v,u=navigator.language;else if(typeof n=="object"){N=n.platform==="win32",g=n.platform==="darwin",I=n.platform==="linux",R=I&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,k=e.$g;const p=n.env.VSCODE_NLS_CONFIG;if(p)try{const E=JSON.parse(p),A=E.availableLanguages["*"];v=E.locale,u=E.osLocale,k=A||e.$g,f=E._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;g?d=1:N?d=3:I&&(d=2),e.$i=N,e.$j=g,e.$k=I,e.$l=R,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=M,e.$s=m,e.$t=C,e.$u=d,e.$v=s,e.$w=k;var l;(function(p){function E(){return e.$w}p.value=E;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}p.isDefaultVariant=A;function B(){return e.$w==="en"}p.isDefault=B})(l||(e.Language=l={})),e.$x=v,e.$y=u,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const p=[];i.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let B=0,O=p.length;B<O;B++){const P=p[B];if(P.id===A.data.vscodeScheduleAsyncWork){p.splice(B,1),P.callback();return}}});let E=0;return A=>{const B=++E;p.push({id:B,callback:A}),i.postMessage({vscodeScheduleAsyncWork:B},"*")}}return p=>setTimeout(p)})();var c;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=g||M?2:N?1:3;let h=!0,S=!1;function L(){if(!S){S=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,h=new Uint16Array(p.buffer)[0]===(2<<8)+1}return h}e.$D=L,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(p){return parseFloat(p)>=20}e.$J=w}),define(Se[50],ke([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;N={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(Se[16],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,g=97,I=90,R=122,b=46,$=47,y=92,M=58,C=63;class m extends Error{constructor(r,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=r.indexOf(".")!==-1?"property":"argument";let S=`The "${r}" ${h} ${c} of type ${d}`;S+=`. Received type ${typeof l}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function k(t,r){if(typeof t!="string")throw new m(r,"string",t)}const u=D.$dc==="win32";function f(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=N&&t<=I||t>=g&&t<=R}function n(t,r,d,l){let c="",h=0,S=-1,L=0,w=0;for(let p=0;p<=t.length;++p){if(p<t.length)w=t.charCodeAt(p);else{if(l(w))break;w=$}if(l(w)){if(!(S===p-1||L===1))if(L===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const E=c.lastIndexOf(d);E===-1?(c="",h=0):(c=c.slice(0,E),h=c.length-1-c.lastIndexOf(d)),S=p,L=0;continue}else if(c.length!==0){c="",h=0,S=p,L=0;continue}}r&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(S+1,p)}`:c=t.slice(S+1,p),h=p-S-1;S=p,L=0}else w===b&&L!==-1?++L:L=-1}return c}function o(t,r){v(r,"pathObject");const d=r.dir||r.root,l=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${l}`:`${d}${t}${l}`:l}e.$fc={resolve(...t){let r="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],k(h,"path"),h.length===0)continue}else r.length===0?h=D.cwd():(h=D.env[`=${r}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===y)&&(h=`${r}\\`));const S=h.length;let L=0,w="",p=!1;const E=h.charCodeAt(0);if(S===1)f(E)&&(L=1,p=!0);else if(f(E))if(p=!0,f(h.charCodeAt(1))){let A=2,B=A;for(;A<S&&!f(h.charCodeAt(A));)A++;if(A<S&&A!==B){const O=h.slice(B,A);for(B=A;A<S&&f(h.charCodeAt(A));)A++;if(A<S&&A!==B){for(B=A;A<S&&!f(h.charCodeAt(A));)A++;(A===S||A!==B)&&(w=`\\\\${O}\\${h.slice(B,A)}`,L=A)}}}else L=1;else i(E)&&h.charCodeAt(1)===M&&(w=h.slice(0,2),L=2,S>2&&f(h.charCodeAt(2))&&(p=!0,L=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(l){if(r.length>0)break}else if(d=`${h.slice(L)}\\${d}`,l=p,p&&r.length>0)break}return d=n(d,!l,"\\",f),l?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){k(t,"path");const r=t.length;if(r===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(f(h))if(c=!0,f(t.charCodeAt(1))){let L=2,w=L;for(;L<r&&!f(t.charCodeAt(L));)L++;if(L<r&&L!==w){const p=t.slice(w,L);for(w=L;L<r&&f(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&!f(t.charCodeAt(L));)L++;if(L===r)return`\\\\${p}\\${t.slice(w)}\\`;L!==w&&(l=`\\\\${p}\\${t.slice(w,L)}`,d=L)}}}else d=1;else i(h)&&t.charCodeAt(1)===M&&(l=t.slice(0,2),d=2,r>2&&f(t.charCodeAt(2))&&(c=!0,d=3));let S=d<r?n(t.slice(d),!c,"\\",f):"";return S.length===0&&!c&&(S="."),S.length>0&&f(t.charCodeAt(r-1))&&(S+="\\"),l===void 0?c?`\\${S}`:S:c?`${l}\\${S}`:`${l}${S}`},isAbsolute(t){k(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return f(d)||r>2&&i(d)&&t.charCodeAt(1)===M&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const S=t[h];k(S,"path"),S.length>0&&(r===void 0?r=d=S:r+=`\\${S}`)}if(r===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++c;const h=d.length;h>1&&f(d.charCodeAt(1))&&(++c,h>2&&(f(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<r.length&&f(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$fc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r)return"";const d=e.$fc.resolve(t),l=e.$fc.resolve(r);if(d===l||(t=d.toLowerCase(),r=l.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===y;)h--;const S=h-c;let L=0;for(;L<r.length&&r.charCodeAt(L)===y;)L++;let w=r.length;for(;w-1>L&&r.charCodeAt(w-1)===y;)w--;const p=w-L,E=S<p?S:p;let A=-1,B=0;for(;B<E;B++){const P=t.charCodeAt(c+B);if(P!==r.charCodeAt(L+B))break;P===y&&(A=B)}if(B!==E){if(A===-1)return l}else{if(p>E){if(r.charCodeAt(L+B)===y)return l.slice(L+B+1);if(B===2)return l.slice(L+B)}S>E&&(t.charCodeAt(c+B)===y?A=B:B===2&&(A=3)),A===-1&&(A=0)}let O="";for(B=c+A+1;B<=h;++B)(B===h||t.charCodeAt(B)===y)&&(O+=O.length===0?"..":"\\..");return L+=A,O.length>0?`${O}${l.slice(L,w)}`:(l.charCodeAt(L)===y&&++L,l.slice(L,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const d=r.charCodeAt(2);if(d!==C&&d!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===M&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){k(t,"path");const r=t.length;if(r===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(r===1)return f(c)?t:".";if(f(c)){if(d=l=1,f(t.charCodeAt(1))){let L=2,w=L;for(;L<r&&!f(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&f(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&!f(t.charCodeAt(L));)L++;if(L===r)return t;L!==w&&(d=l=L+1)}}}}else i(c)&&t.charCodeAt(1)===M&&(d=r>2&&f(t.charCodeAt(2))?3:2,l=d);let h=-1,S=!0;for(let L=r-1;L>=l;--L)if(f(t.charCodeAt(L))){if(!S){h=L;break}}else S=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,L=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(f(w)){if(!c){d=h+1;break}}else L===-1&&(c=!1,L=h+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(l=h):(S=-1,l=L))}return d===l?l=L:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(f(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){k(t,"path");let r=0,d=-1,l=0,c=-1,h=!0,S=0;t.length>=2&&t.charCodeAt(1)===M&&i(t.charCodeAt(0))&&(r=l=2);for(let L=t.length-1;L>=r;--L){const w=t.charCodeAt(L);if(f(w)){if(!h){l=L+1;break}continue}c===-1&&(h=!1,c=L+1),w===b?d===-1?d=L:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||c===-1||S===0||S===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:o.bind(null,"\\"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return f(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(c)){if(l=1,f(t.charCodeAt(1))){let A=2,B=A;for(;A<d&&!f(t.charCodeAt(A));)A++;if(A<d&&A!==B){for(B=A;A<d&&f(t.charCodeAt(A));)A++;if(A<d&&A!==B){for(B=A;A<d&&!f(t.charCodeAt(A));)A++;A===d?l=A:A!==B&&(l=A+1)}}}}else if(i(c)&&t.charCodeAt(1)===M){if(d<=2)return r.root=r.dir=t,r;if(l=2,f(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;l=3}}l>0&&(r.root=t.slice(0,l));let h=-1,S=l,L=-1,w=!0,p=t.length-1,E=0;for(;p>=l;--p){if(c=t.charCodeAt(p),f(c)){if(!w){S=p+1;break}continue}L===-1&&(w=!1,L=p+1),c===b?h===-1?h=p:E!==1&&(E=1):h!==-1&&(E=-1)}return L!==-1&&(h===-1||E===0||E===1&&h===L-1&&h===S+1?r.base=r.name=t.slice(S,L):(r.name=t.slice(S,h),r.base=t.slice(S,L),r.ext=t.slice(h,L))),S>0&&S!==l?r.dir=t.slice(0,S-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(u){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:a();k(c,"path"),c.length!==0&&(r=`${c}/${r}`,d=c.charCodeAt(0)===$)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const l=t[d];k(l,"path"),l.length>0&&(r===void 0?r=l:r+=`/${l}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const d=1,l=t.length,c=l-d,h=1,S=r.length-h,L=c<S?c:S;let w=-1,p=0;for(;p<L;p++){const A=t.charCodeAt(d+p);if(A!==r.charCodeAt(h+p))break;A===$&&(w=p)}if(p===L)if(S>L){if(r.charCodeAt(h+p)===$)return r.slice(h+p+1);if(p===0)return r.slice(h+p)}else c>L&&(t.charCodeAt(d+p)===$?w=p:p===0&&(w=0));let E="";for(p=d+w+1;p<=l;++p)(p===l||t.charCodeAt(p)===$)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!l){d=c;break}}else l=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let d=0,l=-1,c=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,L=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===$){if(!c){d=h+1;break}}else L===-1&&(c=!1,L=h+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(l=h):(S=-1,l=L))}return d===l?l=L:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){k(t,"path");let r=-1,d=0,l=-1,c=!0,h=0;for(let S=t.length-1;S>=0;--S){const L=t.charCodeAt(S);if(L===$){if(!c){d=S+1;break}continue}l===-1&&(c=!1,l=S+1),L===b?r===-1?r=S:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||l===-1||h===0||h===1&&r===l-1&&r===d+1?"":t.slice(r,l)},format:o.bind(null,"/"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===$;let l;d?(r.root="/",l=1):l=0;let c=-1,h=0,S=-1,L=!0,w=t.length-1,p=0;for(;w>=l;--w){const E=t.charCodeAt(w);if(E===$){if(!L){h=w+1;break}continue}S===-1&&(L=!1,S=w+1),E===b?c===-1?c=w:p!==1&&(p=1):c!==-1&&(p=-1)}if(S!==-1){const E=h===0&&d?1:h;c===-1||p===0||p===1&&c===S-1&&c===h+1?r.base=r.name=t.slice(E,S):(r.name=t.slice(E,c),r.base=t.slice(E,S),r.ext=t.slice(c,S))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Se[128],ke([1,0,43,16]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=void 0;const g=new D.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(L,w,p=!1){const E=L||"",A=w||"",B=g.value.collator.compare(E,A);return g.value.collatorIsNumeric&&B===0&&E!==A?E<A?-1:1:B}e.$tq=b;function $(L,w){const p=I.value.collator;return L=L||"",w=w||"",o(p,L,w)}e.$uq=$;function y(L,w){const p=I.value.collator;return L=L||"",w=w||"",d(L,w)||o(p,L,w)}e.$vq=y;function M(L,w){const p=I.value.collator;return L=L||"",w=w||"",r(L,w)||o(p,L,w)}e.$wq=M;function C(L,w){return L=L||"",w=w||"",L===w?0:L<w?-1:1}e.$xq=C;function m(L,w){const[p,E]=i(L),[A,B]=i(w);let O=g.value.collator.compare(E,B);if(O===0){if(g.value.collatorIsNumeric&&E!==B)return E<B?-1:1;if(O=g.value.collator.compare(p,A),g.value.collatorIsNumeric&&O===0&&p!==A)return p<A?-1:1}return O}e.$yq=m;function v(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=I.value.collator,B=R.value.collator;return o(B,p,E)||o(A,L,w)}e.$zq=v;function k(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=I.value.collator,B=R.value.collator;return o(B,p,E)||d(L,w)||o(A,L,w)}e.$Aq=k;function u(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=I.value.collator,B=R.value.collator;return o(B,p,E)||r(L,w)||o(A,L,w)}e.$Bq=u;function f(L,w){L=L||"",w=w||"";const p=n(L).toLowerCase(),E=n(w).toLowerCase();return p!==E?p<E?-1:1:L!==w?L<w?-1:1:0}e.$Cq=f;const s=/^(.*?)(\.([^.]*))?$/;function i(L,w=!1){const p=L?s.exec(L):[];let E=[p&&p[1]||"",p&&p[3]||""];return w&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(L){const w=L?s.exec(L):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function o(L,w,p){const E=L.compare(w,p);return E!==0?E:w.length!==p.length?w.length<p.length?-1:1:0}function a(L){const w=L.charAt(0);return w.toLocaleUpperCase()!==w}function t(L){const w=L.charAt(0);return w.toLocaleLowerCase()!==w}function r(L,w){return a(L)&&t(w)?-1:t(L)&&a(w)?1:0}function d(L,w){return t(L)&&a(w)?-1:a(L)&&t(w)?1:0}function l(L,w,p=!1){return p||(L=L&&L.toLowerCase(),w=w&&w.toLowerCase()),L===w?0:L<w?-1:1}function c(L,w,p=!1){const E=L.split(N.sep),A=w.split(N.sep),B=E.length-1,O=A.length-1;let P,j;for(let T=0;;T++){if(P=B===T,j=O===T,P&&j)return b(E[T],A[T],p);if(P)return-1;if(j)return 1;const F=l(E[T],A[T],p);if(F!==0)return F}}e.$Dq=c;function h(L,w,p){const E=L.toLowerCase(),A=w.toLowerCase(),B=S(L,w,p);if(B)return B;const O=E.endsWith(p),P=A.endsWith(p);if(O!==P)return O?-1:1;const j=b(E,A);return j!==0?j:E.localeCompare(A)}e.$Eq=h;function S(L,w,p){const E=L.toLowerCase(),A=w.toLowerCase(),B=E.startsWith(p),O=A.startsWith(p);if(B!==O)return B?-1:1;if(B&&O){if(E.length<A.length)return-1;if(E.length>A.length)return 1}return 0}e.$Fq=S}),define(Se[33],ke([1,0,16,11,13,18]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function R(h){return h===47||h===92}e.$Vf=R;function b(h){return h.replace(/[\\/]/g,D.$gc.sep)}e.$Wf=b;function $(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Xf=$;function y(h,S=D.$gc.sep){if(!h)return"";const L=h.length,w=h.charCodeAt(0);if(R(w)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let E=3;const A=E;for(;E<L&&!R(h.charCodeAt(E));E++);if(A!==E&&!R(h.charCodeAt(E+1))){for(E+=1;E<L;E++)if(R(h.charCodeAt(E)))return h.slice(0,E+1).replace(/[\\/]/g,S)}}return S}else if(s(w)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+S:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<L;p++)if(R(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Yf=y;function M(h){if(!N.$i||!h||h.length<5)return!1;let S=h.charCodeAt(0);if(S!==92||(S=h.charCodeAt(1),S!==92))return!1;let L=2;const w=L;for(;L<h.length&&(S=h.charCodeAt(L),S!==92);L++);return!(w===L||(S=h.charCodeAt(L+1),isNaN(S)||S===92))}e.$Zf=M;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,S=N.$i){const L=S?C:m;return!(!h||h.length===0||/^\s+$/.test(h)||(L.lastIndex=0,L.test(h))||S&&v.test(h)||h==="."||h===".."||S&&h[h.length-1]==="."||S&&h.length!==h.trim().length||h.length>255)}e.$1f=k;function u(h,S,L){const w=h===S;return!L||w?w:!h||!S?!1:(0,g.$7e)(h,S)}e.$2f=u;function f(h,S,L,w=D.sep){if(h===S)return!0;if(!h||!S||S.length>h.length)return!1;if(L){if(!(0,g.$8e)(h,S))return!1;if(S.length===h.length)return!0;let E=S.length;return S.charAt(S.length-1)===w&&E--,h.charAt(E)===w}return S.charAt(S.length-1)!==w&&(S+=w),h.indexOf(S)===0}e.$3f=f;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$4f=s;function i(h,S){return N.$i&&h.endsWith(":")&&(h+=D.sep),(0,D.$ic)(h)||(h=(0,D.$jc)(S,h)),h=(0,D.$hc)(h),N.$i?(h=(0,g.$Pe)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Pe)(h,D.sep),h||(h=D.sep)),h}e.$5f=i;function n(h){const S=(0,D.$hc)(h);return N.$i?h.length>3?!1:o(S)&&(h.length===2||S.charCodeAt(2)===92):S===D.$gc.sep}e.$6f=n;function o(h,S=N.$i){return S?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$7f=o;function a(h,S=N.$i){return o(h,S)?h[0]:void 0}e.$8f=a;function t(h,S,L){return S.length>h.length?-1:h===S?0:(L&&(h=h.toLowerCase(),S=S.toLowerCase()),h.indexOf(S))}e.$9f=t;function r(h){const S=h.split(":");let L,w,p;for(const E of S){const A=Number(E);(0,I.$Hf)(A)?w===void 0?w=A:p===void 0&&(p=A):L=L?[L,E].join(":"):E}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:w!==void 0?w:void 0,column:p!==void 0?p:w!==void 0?1:void 0}}e.$0f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,S,L=8){let w="";for(let E=0;E<L;E++){let A;E===0&&N.$i&&!S&&(L===3||L===4)?A=l:A=d,w+=A.charAt(Math.floor(Math.random()*A.length))}let p;return S?p=`${S}-${w}`:p=w,h?(0,D.$jc)(h,p):p}e.$$f=c}),define(Se[129],ke([1,0,128,123,53,16,11,13]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.$Iq=e.$Hq=e.$Gq=void 0;const $=0,y=[$,[]];function M(W,X,ce,J){if(!W||!X)return y;const Y=W.length,x=X.length;if(Y<x)return y;const se=W.toLowerCase();return C(X,ce,x,W,se,Y,J)}e.$Gq=M;function C(W,X,ce,J,Y,x,se){const Z=[],ve=[];for(let ne=0;ne<ce;ne++){const ye=ne*x,he=ye-x,ge=ne>0,_=W[ne],ie=X[ne];for(let G=0;G<x;G++){const te=G>0,fe=ye+G,we=fe-1,Ae=he+G-1,be=te?Z[we]:0,De=ge&&te?Z[Ae]:0,z=ge&&te?ve[Ae]:0;let Q;!De&&ge?Q=0:Q=m(_,ie,J,Y,G,z),Q&&De+Q>=be&&(se||ge||Y.startsWith(X,G))?(ve[fe]=z+1,Z[fe]=De+Q):(ve[fe]=$,Z[fe]=be)}}const de=[];let H=ce-1,U=x-1;for(;H>=0&&U>=0;){const ne=H*x+U;ve[ne]===$||(de.push(U),H--),U--}return[Z[ce*x-1],de.reverse()]}function m(W,X,ce,J,Y,x){let se=0;if(!v(X,J[Y]))return se;if(se+=1,x>0&&(se+=x*5),W===ce[Y]&&(se+=1),Y===0)se+=8;else{const Z=k(ce.charCodeAt(Y-1));Z?se+=Z:(0,N.$Sj)(ce.charCodeAt(Y))&&x===0&&(se+=2)}return se}function v(W,X){return W===X?!0:W==="/"||W==="\\"?X==="/"||X==="\\":!1}function k(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function f(W,X,ce=0,J=0){const Y=X;return Y.values&&Y.values.length>1?s(W,Y.values,ce,J):i(W,X,ce,J)}e.$Hq=f;function s(W,X,ce,J){let Y=0;const x=[];for(const se of X){const[Z,ve]=i(W,se,ce,J);if(typeof Z!="number")return u;Y+=Z,x.push(...ve)}return[Y,L(x)]}function i(W,X,ce,J){const Y=(0,N.$2j)(X.original,X.originalLowercase,ce,W,W.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,N.$Yj)(Y)]:u}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,X,ce,J){const Y=J.values?J.values:[J];return(0,g.$Oi)({[J.normalized]:{values:Y.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:W,description:X,allowNonContiguousMatches:ce}})}function d(W,X,ce,J,Y){if(!W||!X.normalized)return n;const x=J.getItemLabel(W);if(!x)return n;const se=J.getItemDescription(W),Z=r(x,se,ce,X),ve=Y[Z];if(ve)return ve;const de=l(x,se,J.getItemPath(W),X,ce);return Y[Z]=de,de}e.$Iq=d;function l(W,X,ce,J,Y){const x=!ce||!J.containsPathSeparator;return ce&&(R.$k?J.pathNormalized===ce:(0,b.$7e)(J.pathNormalized,ce))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:J.values&&J.values.length>1?c(W,X,ce,J.values,x,Y):h(W,X,ce,J,x,Y)}function c(W,X,ce,J,Y,x){let se=0;const Z=[],ve=[];for(const de of J){const{score:H,labelMatch:U,descriptionMatch:ne}=h(W,X,ce,de,Y,x);if(H===$)return n;se+=H,U&&Z.push(...U),ne&&ve.push(...ne)}return{score:se,labelMatch:L(Z),descriptionMatch:L(ve)}}function h(W,X,ce,J,Y,x){if(Y||!X){const[se,Z]=M(W,J.normalized,J.normalizedLowercase,x&&!J.expectContiguousMatch);if(se){const ve=(0,N.$Pj)(J.normalized,W);let de;if(ve){de=a;const H=Math.round(J.normalized.length/W.length*100);de+=H}else de=t;return{score:de+se,labelMatch:ve||S(Z)}}}if(X){let se=X;ce&&(se=`${X}${I.sep}`);const Z=se.length,ve=`${se}${W}`,[de,H]=M(ve,J.normalized,J.normalizedLowercase,x&&!J.expectContiguousMatch);if(de){const U=S(H),ne=[],ye=[];return U.forEach(he=>{he.start<Z&&he.end>Z?(ne.push({start:0,end:he.end-Z}),ye.push({start:he.start,end:Z})):he.start>=Z?ne.push({start:he.start-Z,end:he.end-Z}):ye.push(he)}),{score:de,labelMatch:ne,descriptionMatch:ye}}}return n}function S(W){const X=[];if(!W)return X;let ce;for(const J of W)ce&&ce.end===J?ce.end+=1:(ce={start:J,end:J+1},X.push(ce));return X}function L(W){const X=W.sort((Y,x)=>Y.start-x.start),ce=[];let J;for(const Y of X)!J||!w(J,Y)?(J=Y,ce.push(Y)):(J.start=Math.min(J.start,Y.start),J.end=Math.max(J.end,Y.end));return ce}function w(W,X){return!(W.end<X.start||X.end<W.start)}function p(W,X,ce,J,Y,x){const se=d(W,ce,J,Y,x),Z=d(X,ce,J,Y,x),ve=se.score,de=Z.score;if((ve===o||de===o)&&ve!==de)return ve===o?-1:1;if(ve>t||de>t){if(ve!==de)return ve>de?-1:1;if(ve<a&&de<a){const _=A(se.labelMatch,Z.labelMatch);if(_!==0)return _}const he=Y.getItemLabel(W)||"",ge=Y.getItemLabel(X)||"";if(he.length!==ge.length)return he.length-ge.length}if(ve!==de)return ve>de?-1:1;const H=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,U=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(H&&!U)return-1;if(U&&!H)return 1;const ne=E(W,se,Y),ye=E(X,Z,Y);return ne&&ye&&ne!==ye?ye>ne?-1:1:B(W,X,ce,Y)}e.$Jq=p;function E(W,X,ce){let J=-1,Y=-1;if(X.descriptionMatch&&X.descriptionMatch.length?J=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(J=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(Y=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const x=ce.getItemDescription(W);x&&(Y+=x.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(Y=X.descriptionMatch[X.descriptionMatch.length-1].end);return Y-J}function A(W,X){if(!W&&!X||(!W||!W.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!W||!W.length)return 1;const ce=W[0].start,Y=W[W.length-1].end-ce,x=X[0].start,Z=X[X.length-1].end-x;return Y===Z?0:Z<Y?1:-1}function B(W,X,ce,J){const Y=J.getItemLabel(W)||"",x=J.getItemLabel(X)||"",se=J.getItemDescription(W),Z=J.getItemDescription(X),ve=Y.length+(se?se.length:0),de=x.length+(Z?Z.length:0);if(ve!==de)return ve-de;const H=J.getItemPath(W),U=J.getItemPath(X);return H&&U&&H.length!==U.length?H.length-U.length:Y!==x?(0,D.$Eq)(Y,x,ce.normalized):se&&Z&&se!==Z?(0,D.$Eq)(se,Z,ce.normalized):H&&U&&H!==U?(0,D.$Eq)(H,U,ce.normalized):0}function O(W){return W.startsWith('"')&&W.endsWith('"')}const P=" ";function j(W){typeof W!="string"&&(W="");const X=W.toLowerCase(),{pathNormalized:ce,normalized:J,normalizedLowercase:Y}=T(W),x=ce.indexOf(I.sep)>=0,se=O(W);let Z;const ve=W.split(P);if(ve.length>1)for(const de of ve){const H=O(de),{pathNormalized:U,normalized:ne,normalizedLowercase:ye}=T(de);ne&&(Z||(Z=[]),Z.push({original:de,originalLowercase:de.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:H}))}return{original:W,originalLowercase:X,pathNormalized:ce,normalized:J,normalizedLowercase:Y,values:Z,containsPathSeparator:x,expectContiguousMatch:se}}e.$Kq=j;function T(W){let X;R.$i?X=W.replace(/\//g,I.sep):X=W.replace(/\\/g,I.sep);const ce=(0,b.$Re)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:ce,normalizedLowercase:ce.toLowerCase()}}function F(W){return Array.isArray(W)?j(W.map(X=>X.original).join(P)):j(W.original)}e.$Lq=F}),define(Se[100],ke([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0,e.$2r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(M){const C=(0,D.$oc)(M),m=N[C.toLowerCase()];return m!==void 0?m:R(M)}e.$3r=I;function R(M){const C=(0,D.$oc)(M);return g[C.toLowerCase()]}e.$4r=R;function b(M){for(const C in g)if(g[C]===M)return C}e.$5r=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(M,C){const m=$.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:M}e.$6r=y}),define(Se[101],ke([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<M.length;v++)if(m.search(M[v])!==-1){delete b[m];break}})}e.$Ll=I;function R(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Ml=R}),define(Se[2],ke([1,0,16,11]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,R=/^\/\//;function b(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!g.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,c){return!l&&!c?"file":l}function y(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==C&&(c=C+c):c=C;break}return c}const M="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,S,L,w,p=!1){typeof c=="object"?(this.scheme=c.scheme||M,this.authority=c.authority||M,this.path=c.path||M,this.query=c.query||M,this.fragment=c.fragment||M):(this.scheme=$(c,p),this.authority=h||M,this.path=y(this.scheme,S||M),this.query=L||M,this.fragment=w||M,b(this,p))}get fsPath(){return o(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:S,path:L,query:w,fragment:p}=c;return h===void 0?h=this.scheme:h===null&&(h=M),S===void 0?S=this.authority:S===null&&(S=M),L===void 0?L=this.path:L===null&&(L=M),w===void 0?w=this.query:w===null&&(w=M),p===void 0?p=this.fragment:p===null&&(p=M),h===this.scheme&&S===this.authority&&L===this.path&&w===this.query&&p===this.fragment?this:new f(h,S,L,w,p)}static parse(c,h=!1){const S=m.exec(c);return S?new f(S[2]||M,d(S[4]||M),d(S[5]||M),d(S[7]||M),d(S[9]||M),h):new f(M,M,M,M,M)}static file(c){let h=M;if(N.$i&&(c=c.replace(/\\/g,C)),c[0]===C&&c[1]===C){const S=c.indexOf(C,2);S===-1?(h=c.substring(2),c=C):(h=c.substring(2,S),c=c.substring(S)||C)}return new f("file",h,c,M,M)}static from(c,h){return new f(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return N.$i&&c.scheme==="file"?S=v.file(D.$fc.join(o(c,!0),...h)).path:S=D.$gc.join(c.path,...h),c.with({path:S})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const h=new f(c);return h._formatted=c.external??null,h._fsPath=c._sep===u?c.fsPath??null:null,h}}else return c}}e.URI=v;function k(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$vc=k;const u=N.$i?1:void 0;class f extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=u),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(l,c,h){let S,L=-1;for(let w=0;w<l.length;w++){const p=l.charCodeAt(w);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||c&&p===47||h&&p===91||h&&p===93||h&&p===58)L!==-1&&(S+=encodeURIComponent(l.substring(L,w)),L=-1),S!==void 0&&(S+=l.charAt(w));else{S===void 0&&(S=l.substr(0,w));const E=s[p];E!==void 0?(L!==-1&&(S+=encodeURIComponent(l.substring(L,w)),L=-1),S+=E):L===-1&&(L=w)}}return L!==-1&&(S+=encodeURIComponent(l.substring(L))),S!==void 0?S:l}function n(l){let c;for(let h=0;h<l.length;h++){const S=l.charCodeAt(h);S===35||S===63?(c===void 0&&(c=l.substr(0,h)),c+=s[S]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function o(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,N.$i&&(h=h.replace(/\//g,"\\")),h}e.$wc=o;function a(l,c){const h=c?n:i;let S="",{scheme:L,authority:w,path:p,query:E,fragment:A}=l;if(L&&(S+=L,S+=":"),(w||L==="file")&&(S+=C,S+=C),w){let B=w.indexOf("@");if(B!==-1){const O=w.substr(0,B);w=w.substr(B+1),B=O.lastIndexOf(":"),B===-1?S+=h(O,!1,!1):(S+=h(O.substr(0,B),!1,!1),S+=":",S+=h(O.substr(B+1),!1,!0)),S+="@"}w=w.toLowerCase(),B=w.lastIndexOf(":"),B===-1?S+=h(w,!1,!0):(S+=h(w.substr(0,B),!1,!0),S+=w.substr(B))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const B=p.charCodeAt(1);B>=65&&B<=90&&(p=`/${String.fromCharCode(B+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const B=p.charCodeAt(0);B>=65&&B<=90&&(p=`${String.fromCharCode(B+32)}:${p.substr(2)}`)}S+=h(p,!0,!1)}return E&&(S+="?",S+=h(E,!1,!1)),A&&(S+="#",S+=c?A:i(A,!1,!1)),S}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(r)?l.replace(r,c=>t(c)):l}}),define(Se[185],ke([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$_p=e.$$p=e.$0p=void 0;function N(y){const M=y;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.$0p=N;function g(y){const M=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),M.push(...m)}catch{M.push("Unable to log remote console arguments",y.arguments)}return{args:M,stack:C}}e.$$p=g;function I(y){if(typeof y!="string")return I(g(y).stack);const M=y;if(M){const C=R(M),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$_p=I;function R(y){if(!y)return y;const M=y.indexOf(`
`);return M===-1?y:y.substring(0,M)}function b(y,M){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let k=R(m);k&&(k=`(${k.trim()})`);let u=[];if(typeof C[0]=="string"?k&&v?u=[`%c[${M}] %c${C[0]} %c${k}`,$("blue"),$(""),$("grey")]:u=[`%c[${M}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:u=[`%c[${M}]%`,$("blue"),...C],k&&!v&&u.push(k),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,u)}e.log=b;function $(y){return`color: ${y}`}}),define(Se[54],ke([1,0,22,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function g($){return JSON.stringify($,R)}e.$vh=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$wh=I;function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let M=0;M<$.length;++M)$[M]=b($[M],y+1);else for(const M in $)Object.hasOwnProperty.call($,M)&&($[M]=b($[M],y+1))}return $}e.$xh=b}),define(Se[17],ke([1,0,8,11,13,2]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function b(m,v){return I.URI.isUri(m)?(0,g.$7e)(m.scheme,v):(0,g.$8e)(m,v+":")}e.$_f=b;function $(m,...v){return v.some(k=>b(m,k))}e.$ag=$,e.$bg="vscode-tkn",e.$cg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,k,u){this.a[v]=k,this.b[v]=u}setConnectionToken(v,k){this.c[v]=k}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return D.$1(n),v}const k=v.authority;let u=this.a[k];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const f=this.b[k],s=this.c[k];let i=`path=${encodeURIComponent(v.path)}`;return typeof s=="string"&&(i+=`&${e.$cg}=${encodeURIComponent(s)}`),I.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${u}:${f}`,path:this.f,query:i})}}e.$dg=new y,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class M{static{this.a=e.$ig}asBrowserUri(v){const k=this.b(v,me);return this.uriToBrowserUri(k)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$dg.rewrite(v):v.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${M.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||M.a,query:null,fragment:null}):v}asFileUri(v){const k=this.b(v,me);return this.uriToFileUri(k)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==M.a?v.authority:null,query:null,fragment:null}):v}b(v,k){return I.URI.isUri(v)?v:I.URI.parse(k.toUrl(v))}}e.$jg=new M;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const k="vscode-coi";function u(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:I.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(k);if(n)return v.get(n)}m.getHeadersFromQuery=u;function f(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(k,o):s[k]=o}m.addSearchParam=f})(C||(e.COI=C={}))}),define(Se[186],ke([1,0,157,17,11,2]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=void 0;class R{constructor(m,v,k){this.id=m,this.dependencies=v,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,k)=>{typeof m!="string"&&(k=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(k=v,v=null),this.c.push(new R(m,v,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,k)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const f=()=>{u.removeEventListener("load",s),u.removeEventListener("error",i)},s=n=>{f(),v(this.c.pop())},i=n=>{f(),k(n)};u.addEventListener("load",s),u.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),u.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(m){return new Promise((v,k)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(u){k(u)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,s=v.readFileSync(f).toString(),i=u.wrap(s.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function M(C,m,v){if(D.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const k=`${C}/${m}`;if($.has(k))return $.get(k);let u;if(/^\w[\w\d+.-]*:\/\//.test(k))u=k;else{const n=`${v&&!g.$o?N.$gg:N.$fg}/${k}`;u=N.$jg.asBrowserUri(n).toString(!0)}const f=b.INSTANCE.load(u);return $.set(k,f),f}else return await new Promise((k,u)=>{me([C],k,u)})}e.$WC=M}),define(Se[23],ke([1,0,33,17,16,11,13,2]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function $(v){return(0,b.$wc)(v,!0)}e.$qg=$;class y{constructor(k){this.a=k}compare(k,u,f=!1){return k===u?0:(0,R.$Ze)(this.getComparisonKey(k,f),this.getComparisonKey(u,f))}isEqual(k,u,f=!1){return k===u?!0:!k||!u?!1:this.getComparisonKey(k,f)===this.getComparisonKey(u,f)}getComparisonKey(k,u=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,u,f=!1){if(k.scheme===u.scheme){if(k.scheme===N.Schemas.file)return D.$3f($(k),$(u),this.a(k))&&k.query===u.query&&(f||k.fragment===u.fragment);if((0,e.$Hg)(k.authority,u.authority))return D.$3f(k.path,u.path,this.a(k),"/")&&k.query===u.query&&(f||k.fragment===u.fragment)}return!1}joinPath(k,...u){return b.URI.joinPath(k,...u)}basenameOrAuthority(k){return(0,e.$zg)(k)||k.authority}basename(k){return g.$gc.basename(k.path)}extname(k){return g.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let u;return k.scheme===N.Schemas.file?u=b.URI.file(g.$mc($(k))).path:(u=g.$gc.dirname(k.path),k.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),u="/")),k.with({path:u})}normalizePath(k){if(!k.path.length)return k;let u;return k.scheme===N.Schemas.file?u=b.URI.file(g.$hc($(k))).path:u=g.$gc.normalize(k.path),k.with({path:u})}relativePath(k,u){if(k.scheme!==u.scheme||!(0,e.$Hg)(k.authority,u.authority))return;if(k.scheme===N.Schemas.file){const i=g.$lc($(k),$(u));return I.$i?D.$Wf(i):i}let f=k.path||"/";const s=u.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(f.length,s.length);i<n&&!(f.charCodeAt(i)!==s.charCodeAt(i)&&f.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);f=s.substr(0,i)+f.substr(i)}return g.$gc.relative(f,s)}resolvePath(k,u){if(k.scheme===N.Schemas.file){const f=b.URI.file(g.$kc($(k),u));return k.with({authority:f.authority,path:f.path})}return u=D.$Xf(u),k.with({path:g.$gc.resolve(k.path,u)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,u){return k===u||k!==void 0&&u!==void 0&&(0,R.$7e)(k,u)}hasTrailingPathSeparator(k,u=g.sep){if(k.scheme===N.Schemas.file){const f=$(k);return f.length>D.$Yf(f).length&&f[f.length-1]===u}else{const f=k.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,u=g.sep){return(0,e.$Ig)(k,u)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,u=g.sep){let f=!1;if(k.scheme===N.Schemas.file){const s=$(k);f=s!==void 0&&s.length===D.$Yf(s).length&&s[s.length-1]===u}else{u="/";const s=k.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$Ig)(k,u)?k.with({path:k.path+"/"}):k}}e.$rg=y,e.$sg=new y(()=>!1),e.$tg=new y(v=>v.scheme===N.Schemas.file?!I.$k:!0),e.$ug=new y(v=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function M(v,k){const u=[];for(let f=0;f<v.length;f++){const s=k(v[f]);v.some((i,n)=>n===f?!1:(0,e.$wg)(s,k(i)))||u.push(v[f])}return u}e.$Lg=M;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function k(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&f.set(o,a)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&f.set(v.META_DATA_MIME,i),f}v.parseMetaData=k})(C||(e.DataUri=C={}));function m(v,k,u){if(k){let f=v.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),v.with({scheme:u,authority:k,path:f})}return v.with({scheme:u})}e.$Mg=m}),define(Se[12],ke([1,0,21,8,4,3,23,11,163,43]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function M(_){return!!_&&typeof _.then=="function"}e.$Ng=M;function C(_){const ie=new D.$3d,G=_(ie.token),te=new Promise((fe,we)=>{const Ae=ie.token.onCancellationRequested(()=>{Ae.dispose(),ie.dispose(),we(new N.$5)});Promise.resolve(G).then(be=>{Ae.dispose(),ie.dispose(),fe(be)},be=>{Ae.dispose(),ie.dispose(),we(be)})});return new class{cancel(){ie.cancel()}then(fe,we){return te.then(fe,we)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.$Og=C;function m(_,ie,G){return new Promise((te,fe)=>{const we=ie.onCancellationRequested(()=>{we.dispose(),te(G)});_.then(te,fe).finally(()=>we.dispose())})}e.$Pg=m;function v(_,ie){return new Promise((G,te)=>{const fe=ie.onCancellationRequested(()=>{fe.dispose(),te(new N.$5)});_.then(G,te).finally(()=>fe.dispose())})}e.$Qg=v;async function k(_){let ie=-1;const G=_.map((te,fe)=>te.then(we=>(ie=fe,we)));try{return await Promise.race(G)}finally{_.forEach((te,fe)=>{fe!==ie&&te.cancel()})}}e.$Rg=k;function u(_,ie,G){let te;const fe=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(we=>te=we)])}e.$Sg=u;function f(_){return new Promise((ie,G)=>{const te=_();M(te)?te.then(ie,G):ie(te)})}e.$Tg=f;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,te(fe)})})}dispose(){this.f=!0}}e.$Ug=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Vg=i;class n{constructor(){this.a=new Map}queue(ie,G){const fe=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===fe&&this.a.delete(ie)});return this.a.set(ie,fe),fe}}e.$Wg=n;const o=(_,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},a=_=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,_())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((fe,we)=>{this.d=fe,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Pd?a(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=r;class d{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=d;class l extends d{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$1g=l;function c(_,ie){return ie?new Promise((G,te)=>{const fe=setTimeout(()=>{we.dispose(),G()},_),we=ie.onCancellationRequested(()=>{clearTimeout(fe),we.dispose(),te(new N.$5)})}):C(G=>c(_,G))}e.$2g=c;function h(_,ie=0,G){const te=setTimeout(()=>{_(),G&&fe.dispose()},ie),fe=(0,I.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$3g=h;function S(_){const ie=[];let G=0;const te=_.length;function fe(){return G<te?_[G++]():null}function we(Ae){Ae!=null&&ie.push(Ae);const be=fe();return be?be.then(we):Promise.resolve(ie)}return Promise.resolve(null).then(we)}e.$4g=S;function L(_,ie=te=>!!te,G=null){let te=0;const fe=_.length,we=()=>{if(te>=fe)return Promise.resolve(G);const Ae=_[te++];return Promise.resolve(Ae()).then(De=>ie(De)?Promise.resolve(De):we())};return we()}e.$5g=L;function w(_,ie=te=>!!te,G=null){if(_.length===0)return Promise.resolve(G);let te=_.length;const fe=()=>{te=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ae)=>{for(const be of _)be.then(De=>{--te>=0&&ie(De)?(fe(),we(De)):te===0&&we(G)}).catch(De=>{--te>=0&&(fe(),Ae(De))})})}e.$6g=w;class p{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=p;class E extends p{constructor(){super(1)}}e.$8g=E;class A{constructor(){this.a=new Y,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$9g=A;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new Z;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=R.$sg){const te=G.getComparisonKey(ie);let fe=this.a.get(te);if(!fe){fe=new E;const we=this.f++,Ae=g.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$2c),this.d.set(we,Ae),this.a.set(te,fe)}return fe}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=B;class O{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$$g=O;class P{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const fe=te.setInterval(()=>{ie()},G);this.d=(0,I.$Qc)(()=>{te.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$_g=P;class j{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=j;class T{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=T;class F extends j{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$ch=F;class W extends I.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new I.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(_,ie)=>{(0,b.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$fh=(_,ie,G)=>{const te=_.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(te))}}},e.$eh=_=>(0,e.$fh)(globalThis,_)}();class X{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$fh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=X;class ce extends X{constructor(ie){super(globalThis,ie)}}e.$hh=ce;async function J(_,ie,G){let te;for(let fe=0;fe<G;fe++)try{return await _()}catch(we){te=we,await c(ie)}throw te}e.$ih=J;class Y{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const fe=new Promise((we,Ae)=>{G=we,te=Ae});this.b={run:ie,promise:fe,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=Y;class x{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$kh=x;var se;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(se||(se={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new N.$5)}}e.$lh=Z;var ve;(function(_){async function ie(te){let fe;const we=await Promise.all(te.map(Ae=>Ae.then(be=>be,be=>{fe||(fe=be)})));if(typeof fe<"u")throw fe;return we}_.settled=ie;function G(te){return new Promise(async(fe,we)=>{try{await te(fe,we)}catch(Ae){we(Ae)}})}_.withAsyncBody=G})(ve||(e.Promises=ve={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=de;class H{constructor(ie){this.b=ie,this.a=new y.$V(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=H;var U;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(U||(U={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>{for await(const fe of te)G.emitOne(fe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new ne(async te=>{for await(const fe of ie)te.emitOne(G(fe))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async te=>{for await(const fe of ie)G(fe)&&te.emitOne(fe)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$oh=ne;class ye extends ne{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$ph=ye;function he(_){const ie=new D.$3d,G=_(ie.token);return new ye(ie,async te=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),te.reject(new N.$5)});try{for await(const we of G){if(ie.token.isCancellationRequested)return;te.emitOne(we)}fe.dispose(),ie.dispose()}catch(we){fe.dispose(),ie.dispose(),te.reject(we)}})}e.$qh=he;class ge{constructor(){this.a=new Z,this.b=new ne(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=fe=>te.reject(fe),this.f=fe=>te.emitOne(fe),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$rh=ge}),define(Se[34],ke([1,0,19,12,33,28,16,11,13]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;function y(){return Object.create(null)}e.$Cj=y,e.$Dj="**",e.$Ej="/";const M="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(ce,J){switch(ce){case 0:return"";case 1:return`${C}*?`;default:return`(?:${M}|${C}+${M}${J?`|${M}${C}+`:""})*?`}}function k(ce,J){if(!ce)return[];const Y=[];let x=!1,se=!1,Z="";for(const ve of ce){switch(ve){case J:if(!x&&!se){Y.push(Z),Z="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":se=!0;break;case"]":se=!1;break}Z+=ve}return Z&&Y.push(Z),Y}e.$Fj=k;function u(ce){if(!ce)return"";let J="";const Y=k(ce,e.$Ej);if(Y.every(x=>x===e.$Dj))J=".*";else{let x=!1;Y.forEach((se,Z)=>{if(se===e.$Dj){if(x)return;J+=v(2,Z===Y.length-1)}else{let ve=!1,de="",H=!1,U="";for(const ne of se){if(ne!=="}"&&ve){de+=ne;continue}if(H&&(ne!=="]"||!U)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!U?ye="^":ne===e.$Ej?ye="":ye=(0,$.$Ke)(ne),U+=ye;continue}switch(ne){case"{":ve=!0;continue;case"[":H=!0;continue;case"}":{const he=`(?:${k(de,",").map(ge=>u(ge)).join("|")})`;J+=he,ve=!1,de="";break}case"]":{J+="["+U+"]",H=!1,U="";break}case"?":J+=C;continue;case"*":J+=v(1);continue;default:J+=(0,$.$Ke)(ne)}}Z<Y.length-1&&(Y[Z+1]!==e.$Dj||Z+2<Y.length)&&(J+=M)}x=se===e.$Dj})}return J}const f=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),r=function(){return!1},d=function(){return null};function l(ce,J){if(!ce)return d;let Y;typeof ce!="string"?Y=ce.pattern:Y=ce,Y=Y.trim();const x=`${Y}_${!!J.trimForExclusions}`;let se=t.get(x);if(se)return c(se,ce);let Z;return f.test(Y)?se=S(Y.substr(4),Y):(Z=s.exec(h(Y,J)))?se=L(Z[1],Y):(J.trimForExclusions?n:i).test(Y)?se=w(Y,J):(Z=o.exec(h(Y,J)))?se=p(Z[1].substr(1),Y,!0):(Z=a.exec(h(Y,J)))?se=p(Z[1],Y,!1):se=E(Y),t.set(x,se),c(se,ce)}function c(ce,J){if(typeof J=="string")return ce;const Y=function(x,se){return(0,g.$3f)(x,J.base,!b.$k)?ce((0,$.$Oe)(x.substr(J.base.length),R.sep),se):null};return Y.allBasenames=ce.allBasenames,Y.allPaths=ce.allPaths,Y.basenames=ce.basenames,Y.patterns=ce.patterns,Y}function h(ce,J){return J.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function S(ce,J){return function(Y,x){return typeof Y=="string"&&Y.endsWith(ce)?J:null}}function L(ce,J){const Y=`/${ce}`,x=`\\${ce}`,se=function(ve,de){return typeof ve!="string"?null:de?de===ce?J:null:ve===ce||ve.endsWith(Y)||ve.endsWith(x)?J:null},Z=[ce];return se.basenames=Z,se.patterns=[J],se.allBasenames=Z,se}function w(ce,J){const Y=W(ce.slice(1,-1).split(",").map(de=>l(de,J)).filter(de=>de!==d),ce),x=Y.length;if(!x)return d;if(x===1)return Y[0];const se=function(de,H){for(let U=0,ne=Y.length;U<ne;U++)if(Y[U](de,H))return ce;return null},Z=Y.find(de=>!!de.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const ve=Y.reduce((de,H)=>H.allPaths?de.concat(H.allPaths):de,[]);return ve.length&&(se.allPaths=ve),se}function p(ce,J,Y){const x=R.sep===R.$gc.sep,se=x?ce:ce.replace(m,R.sep),Z=R.sep+se,ve=R.$gc.sep+ce;let de;return Y?de=function(H,U){return typeof H=="string"&&(H===se||H.endsWith(Z)||!x&&(H===ce||H.endsWith(ve)))?J:null}:de=function(H,U){return typeof H=="string"&&(H===se||!x&&H===ce)?J:null},de.allPaths=[(Y?"*/":"./")+ce],de}function E(ce){try{const J=new RegExp(`^${u(ce)}$`);return function(Y){return J.lastIndex=0,typeof Y=="string"&&J.test(Y)?ce:null}}catch{return d}}function A(ce,J,Y){return!ce||typeof J!="string"?!1:B(ce)(J,void 0,Y)}e.$Gj=A;function B(ce,J={}){if(!ce)return r;if(typeof ce=="string"||O(ce)){const Y=l(ce,J);if(Y===d)return r;const x=function(se,Z){return!!Y(se,Z)};return Y.allBasenames&&(x.allBasenames=Y.allBasenames),Y.allPaths&&(x.allPaths=Y.allPaths),x}return T(ce,J)}e.$Hj=B;function O(ce){const J=ce;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Ij=O;function P(ce){return ce.allBasenames||[]}e.$Jj=P;function j(ce){return ce.allPaths||[]}e.$Kj=j;function T(ce,J){const Y=W(Object.getOwnPropertyNames(ce).map(de=>F(de,ce[de],J)).filter(de=>de!==d)),x=Y.length;if(!x)return d;if(!Y.some(de=>!!de.requiresSiblings)){if(x===1)return Y[0];const de=function(ne,ye){let he;for(let ge=0,_=Y.length;ge<_;ge++){const ie=Y[ge](ne,ye);if(typeof ie=="string")return ie;(0,N.$Ng)(ie)&&(he||(he=[]),he.push(ie))}return he?(async()=>{for(const ge of he){const _=await ge;if(typeof _=="string")return _}return null})():null},H=Y.find(ne=>!!ne.allBasenames);H&&(de.allBasenames=H.allBasenames);const U=Y.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return U.length&&(de.allPaths=U),de}const se=function(de,H,U){let ne,ye;for(let he=0,ge=Y.length;he<ge;he++){const _=Y[he];_.requiresSiblings&&U&&(H||(H=(0,R.$nc)(de)),ne||(ne=H.substr(0,H.length-(0,R.$oc)(de).length)));const ie=_(de,H,ne,U);if(typeof ie=="string")return ie;(0,N.$Ng)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const he of ye){const ge=await he;if(typeof ge=="string")return ge}return null})():null},Z=Y.find(de=>!!de.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const ve=Y.reduce((de,H)=>H.allPaths?de.concat(H.allPaths):de,[]);return ve.length&&(se.allPaths=ve),se}function F(ce,J,Y){if(J===!1)return d;const x=l(ce,Y);if(x===d)return d;if(typeof J=="boolean")return x;if(J){const se=J.when;if(typeof se=="string"){const Z=(ve,de,H,U)=>{if(!U||!x(ve,de))return null;const ne=se.replace("$(basename)",()=>H),ye=U(ne);return(0,N.$Ng)(ye)?ye.then(he=>he?ce:null):ye?ce:null};return Z.requiresSiblings=!0,Z}}return x}function W(ce,J){const Y=ce.filter(de=>!!de.basenames);if(Y.length<2)return ce;const x=Y.reduce((de,H)=>{const U=H.basenames;return U?de.concat(U):de},[]);let se;if(J){se=[];for(let de=0,H=x.length;de<H;de++)se.push(J)}else se=Y.reduce((de,H)=>{const U=H.patterns;return U?de.concat(U):de},[]);const Z=function(de,H){if(typeof de!="string")return null;if(!H){let ne;for(ne=de.length;ne>0;ne--){const ye=de.charCodeAt(ne-1);if(ye===47||ye===92)break}H=de.substr(ne)}const U=x.indexOf(H);return U!==-1?se[U]:null};Z.basenames=x,Z.patterns=se,Z.allBasenames=x;const ve=ce.filter(de=>!de.basenames);return ve.push(Z),ve}function X(ce,J){return(0,D.$ub)(ce,J,(Y,x)=>typeof Y=="string"&&typeof x=="string"?Y===x:typeof Y!="string"&&typeof x!="string"?Y.base===x.base&&Y.pattern===x.pattern:!1)}e.$Lj=X}),define(Se[80],ke([1,0,8,164,23,13,2]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,D.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=m(this.supportThemeIcons?(0,N.$9j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,I.$Ke)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$ck=$;function y(f){return M(f)?!f.value:Array.isArray(f)?f.every(y):!0}e.$dk=y;function M(f){return f instanceof $?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}e.$ek=M;function C(f,s){return f===s?!0:!f||!s?!1:f.value===s.value&&f.isTrusted===s.isTrusted&&f.supportThemeIcons===s.supportThemeIcons&&f.supportHtml===s.supportHtml&&(f.baseUri===s.baseUri||!!f.baseUri&&!!s.baseUri&&(0,g.$vg)(R.URI.from(f.baseUri),R.URI.from(s.baseUri)))}e.$fk=C;function m(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$gk=m;function v(f){return f.replace(/"/g,"&quot;")}e.$hk=v;function k(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ik=k;function u(f){const s=[],i=f.split("|").map(o=>o.trim());f=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),l=isFinite(parseInt(t));d&&s.push(`width="${r}"`),l&&s.push(`height="${t}"`)}return{href:f,dimensions:s}}e.$jk=u}),define(Se[102],ke([1,0,19,33,16,11,23,13]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=void 0;function $(l,c){const{os:h,tildify:S,relative:L}=c;if(L){const E=y(l,L,h);if(typeof E=="string")return E}let w=l.fsPath;if(h===1&&!I.$i?w=w.replace(/\//g,"\\"):h!==1&&I.$i&&(w=w.replace(/\\/g,"/")),h!==1&&S?.userHome){const E=S.userHome.fsPath;let A;l.scheme!==S.userHome.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep?A=S.userHome.with({path:l.path}).fsPath:A=w,w=m(A,E,h)}return(h===1?g.$fc:g.$gc).normalize(M(w,h===1))}e.$Fv=$;function y(l,c,h){const S=h===1?g.$fc:g.$gc,L=h===3?R.$sg:R.$ug,w=c.getWorkspace(),p=(0,D.$Ob)(w.folders);if(!p)return;l.scheme!==p.uri.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep&&(l=p.uri.with({path:l.path}));const E=c.getWorkspaceFolder(l);if(!E)return;let A;if(L.isEqual(E.uri,l)?A="":A=L.relativePath(E.uri,l)??"",A&&(A=S.normalize(A)),w.folders.length>1&&!c.noPrefix){const B=E.name?E.name:L.basenameOrAuthority(E.uri);A=A?`${B} \u2022 ${A}`:B}return A}function M(l,c=I.$i){return(0,N.$7f)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$Gv=M;let C=Object.create(null);function m(l,c,h=I.OS){if(h===1||!l||!c)return l;let S=C.original===c?C.normalized:void 0;S||(S=c,I.$i&&(S=(0,N.$Wf)(S)),S=`${(0,b.$Pe)(S,g.$gc.sep)}${g.$gc.sep}`,C={original:c,normalized:S});let L=l;return I.$i&&(L=(0,N.$Wf)(L)),(h===3?L.startsWith(S):(0,b.$8e)(L,S))?`~/${L.substr(S.length)}`:l}e.$Hv=m;function v(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Iv=v;const k="\u2026",u="\\\\",f="~";function s(l,c=g.sep){const h=new Array(l.length);let S=!1;for(let L=0;L<l.length;L++){const w=l[L];if(w===""){h[L]=`.${c}`;continue}if(!w){h[L]=w;continue}S=!0;let p="",E=w;E.indexOf(u)===0?(p=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length)):E.indexOf(c)===0?(p=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(f)===0&&(p=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const A=E.split(c);for(let B=1;S&&B<=A.length;B++)for(let O=A.length-B;S&&O>=0;O--){S=!1;let P=A.slice(O,O+B).join(c);for(let j=0;!S&&j<l.length;j++)if(j!==L&&l[j]&&l[j].indexOf(P)>-1){const T=O+B===A.length,F=O>0&&l[j].indexOf(c)>-1?c+P:P,W=l[j].endsWith(F);S=!T||W}if(!S){let j="";(A[0].endsWith(":")||p!=="")&&(O===1&&(O=0,B++,P=A[0]+c+P),O>0&&(j=A[0]+c),j=p+j),O>0&&(j=j+k+c),j=j+P,O+B<A.length&&(j=j+c+k),h[L]=j}}S&&(h[L]=w)}return h}e.$Jv=s;var i;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(l,c=Object.create(null)){const h=[];let S=!1,L="";for(const w of l)if(w==="$"||S&&w==="{")L&&h.push({value:L,type:i.TEXT}),L="",S=!0;else if(w==="}"&&S){const p=c[L];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const E=h[h.length-1];(!E||E.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}L="",S=!1}else L+=w;return L&&!S&&h.push({value:L,type:i.TEXT}),h.filter((w,p)=>{if(w.type===i.SEPARATOR){const E=h[p-1],A=h[p+1];return[E,A].every(B=>B&&(B.type===i.VARIABLE||B.type===i.TEXT)&&B.value.length>0)}return!0}).map(w=>w.value).join("")}e.$Kv=n;function o(l,c){return I.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Lv=o;function a(l,c){return I.$j||c?l.replace(/\(&&\w\)|&&/g,""):I.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$Mv=a;function t(l){return l.replace(/&/g,"&&")}e.$Nv=t;function r(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c));return{name:h.name,parentPath:h.parentPath+l.substring(c)}}}return d(l)}e.$Ov=r;function d(l){const c=l.indexOf("/")!==-1?g.$gc:g.$fc,h=c.basename(l),S=c.dirname(l);return h.length?{name:h,parentPath:S}:{name:S,parentPath:""}}}),define(Se[130],ke([1,0,22,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(N.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(N.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:N.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Xm=I,e.$Ym=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const u=R(C[k],m,v+1);u!==null&&(C[k]=u)}}return null}function b(C,m){const v=R(C,m,0);return v===null?C:v}e.$Zm=b;function $(C,m,v,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ge)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const f=$(C[u],m,v,k+1);f!==null&&(C[u]=f)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$1m=y;function M(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$2m=M}),define(Se[31],ke([1,0,55,63,385,12,33,76,16,11,23,2]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(F,W=m.UNLINK,X){if((0,R.$6f)(F))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?u(F):k(F,X)}async function k(F,W=(0,R.$$f)((0,N.tmpdir)())){try{try{await D.promises.rename(F,W)}catch(X){return X.code==="ENOENT"?void 0:u(F)}u(W).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function u(F){return(0,g.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,R.$6f)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function s(F,W){return o(await(W?i(F):(0,g.promisify)(D.readdir)(F)))}async function i(F){try{return await(0,g.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const W=[],X=await s(F);for(const ce of X){let J=!1,Y=!1,x=!1;try{const se=await e.Promises.lstat((0,$.$jc)(F,ce));J=se.isFile(),Y=se.isDirectory(),x=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}W.push({name:ce,isFile:()=>J,isDirectory:()=>Y,isSymbolicLink:()=>x})}return W}function n(F){return o(D.readdirSync(F))}e.readdirSync=n;function o(F){return F.map(W=>typeof W=="string"?y.$j?(0,b.$Al)(W):W:(W.name=y.$j?(0,b.$Al)(W.name):W.name,W))}async function a(F){const W=await s(F),X=[];for(const ce of W)await r.existsDirectory((0,$.$jc)(F,ce))&&X.push(ce);return X}function t(F,W=1e3){return new Promise(X=>{let ce=!1;const J=setInterval(()=>{ce||(ce=!0,D.access(F,Y=>{ce=!1,Y&&(clearInterval(J),X(void 0))}))},W)})}e.whenDeleted=t;var r;(function(F){async function W(J){let Y;try{if(Y=await e.Promises.lstat(J),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(y.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw se}throw x}}F.stat=W;async function X(J){try{const{stat:Y,symbolicLink:x}=await F.stat(J);return Y.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=X;async function ce(J){try{const{stat:Y,symbolicLink:x}=await F.stat(J);return Y.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=ce})(r||(e.SymlinkSupport=r={}));const d=new I.$0g;function l(F,W,X){return d.queueFor(C.URI.file(F),M.$tg).queue(()=>{const ce=w(X);return new Promise((J,Y)=>S(F,W,ce,x=>x?Y(x):J()))})}let c=!0;function h(F){c=F}e.configureFlushOnWrite=h;function S(F,W,X,ce){if(!c)return D.writeFile(F,W,{mode:X.mode,flag:X.flag},ce);D.open(F,X.flag,X.mode,(J,Y)=>{if(J)return ce(J);D.writeFile(Y,W,x=>{if(x)return D.close(Y,()=>ce(x));D.fdatasync(Y,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),h(!1)),D.close(Y,Z=>ce(Z))))})})}function L(F,W,X){const ce=w(X);if(!c)return D.writeFileSync(F,W,{mode:ce.mode,flag:ce.flag});const J=D.openSync(F,ce.flag,ce.mode);try{D.writeFileSync(J,W);try{D.fdatasyncSync(J)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{D.closeSync(J)}}e.writeFileSync=L;function w(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function p(F,W,X=6e4){if(F!==W)try{y.$i&&typeof X=="number"?await E(F,W,Date.now(),X):await(0,g.promisify)(D.rename)(F,W)}catch(ce){if(F.toLowerCase()!==W.toLowerCase()&&ce.code==="EXDEV"||F.endsWith("."))await A(F,W,{preserveSymlinks:!1}),await v(F,m.MOVE);else throw ce}}async function E(F,W,X,ce,J=0){try{return await(0,g.promisify)(D.rename)(F,W)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-X>=ce)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${Y}`),Y;if(J===0){let x=!1;try{const{stat:se}=await r.stat(W);se.isFile()||(x=!0)}catch{}if(x)throw Y}return await(0,I.$2g)(Math.min(100,J*10)),E(F,W,X,ce,J+1)}}async function A(F,W,X){return O(F,W,{root:{source:F,target:W},options:X,handledSourcePaths:new Set})}const B=511;async function O(F,W,X){if(X.handledSourcePaths.has(F))return;X.handledSourcePaths.add(F);const{stat:ce,symbolicLink:J}=await r.stat(F);if(J){if(X.options.preserveSymlinks)try{return await T(F,W,X)}catch{}if(J.dangling)return}return ce.isDirectory()?P(F,W,ce.mode&B,X):j(F,W,ce.mode&B)}async function P(F,W,X,ce){await e.Promises.mkdir(W,{recursive:!0,mode:X});const J=await s(F);for(const Y of J)await O((0,$.$jc)(F,Y),(0,$.$jc)(W,Y),ce)}async function j(F,W,X){await e.Promises.copyFile(F,W),await e.Promises.chmod(W,X)}async function T(F,W,X){let ce=await e.Promises.readlink(F);(0,R.$3f)(ce,X.root.source,!y.$k)&&(ce=(0,$.$jc)(X.root.target,ce.substr(X.root.source.length+1))),await e.Promises.symlink(ce,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(F,W,X,ce,J)=>new Promise((Y,x)=>{D.read(F,W,X,ce,J,(se,Z,ve)=>se?x(se):Y({bytesRead:Z,buffer:ve}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(F,W,X,ce,J)=>new Promise((Y,x)=>{D.write(F,W,X,ce,J,(se,Z,ve)=>se?x(se):Y({bytesWritten:Z,buffer:ve}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return l}get rm(){return v}get rename(){return p}get copy(){return A}}}),define(Se[103],ke([1,0,55,16,11,13,31]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.$eq=void 0;function b(m){if(g.$k)return m;const v=(0,N.$mc)(m);if(m===v)return m;const k=((0,N.$nc)(m)||m).toLowerCase();try{const f=(0,R.readdirSync)(v).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=b(v);if(s)return(0,N.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=b(v);if(i)return(0,N.$jc)(i,f[s])}}}catch{}return null}e.$eq=b;async function $(m){if(g.$k)return m;const v=(0,N.$mc)(m);if(m===v)return m;const k=((0,N.$nc)(m)||m).toLowerCase();try{const f=(await R.Promises.readdir(v)).filter(s=>s.toLowerCase()===k);if(f.length===1){const s=await $(v);if(s)return(0,N.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(k);if(s>=0){const i=await $(v);if(i)return(0,N.$jc)(i,f[s])}}}catch{}return null}e.$fq=$;async function y(m){try{return await R.Promises.realpath(m)}catch{const k=C(m);return await R.Promises.access(k,D.constants.R_OK),k}}e.$gq=y;function M(m){try{return D.realpathSync(m)}catch{const k=C(m);return D.accessSync(k,D.constants.R_OK),k}}e.$hq=M;function C(m){return(0,I.$Pe)((0,N.$hc)(m),N.sep)}}),define(Se[104],ke([1,0,16,11,50,101,18,31]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ol=e.$Nl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Nl=$;function y(C){let m=[],v=!1;const k=function(u){if(v){m.push(u);return}(!C.send(u,s=>{if(s&&console.error(s),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>k(n))}})||N.$i)&&(v=!0)};return{send:k}}e.$Ol=y;var M;(function(C){async function m(v,k,u){if(D.$ic(v))return v;if(k===void 0&&(k=g.cwd()),D.$mc(v)!=="."||(u===void 0&&R.$Df(g.env.PATH)&&(u=g.env.PATH.split(D.$tc)),u===void 0||u.length===0))return D.$jc(k,v);async function s(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of u){let n;if(D.$ic(i)?n=D.$jc(i,v):n=D.$jc(k,i,v),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$jc(k,v)}C.findExecutable=m})(M||(e.win32=M={}))});var Je=this&&this.__decorate||function(me,e,D,N){var g=arguments.length,I=g<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,N);else for(var b=me.length-1;b>=0;b--)(R=me[b])&&(I=(g<3?R(I):g>3?R(e,D,I):R(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(Se[81],ke([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.ProxyChannel=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.RequestInitiator=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0;var v;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(v||(v={}));function k(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(u||(u={}));function f(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(s||(s={}));function i(J){let Y=0;for(let x=0;;x+=7){const se=J.read(1);if(Y|=(se.buffer[0]&127)<<x,!(se.buffer[0]&128))return Y}}const n=d(0);function o(J,Y){if(Y===0){J.write(n);return}let x=0;for(let Z=Y;Z!==0;Z=Z>>>7)x++;const se=g.$ge.alloc(x);for(let Z=0;Y!==0;Z++)se.buffer[Z]=Y&127,Y=Y>>>7,Y>0&&(se.buffer[Z]|=128);J.write(se)}class a{constructor(Y){this.b=Y,this.a=0}read(Y){const x=this.b.slice(this.a,this.a+Y);return this.a+=x.byteLength,x}}e.$yh=a;class t{constructor(){this.a=[]}get buffer(){return g.$ge.concat(this.a)}write(Y){this.a.push(Y)}}e.$zh=t;var r;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(r||(r={}));function d(J){const Y=g.$ge.alloc(1);return Y.writeUInt8(J,0),Y}const l={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},c=typeof Buffer<"u";function h(J,Y){if(typeof Y>"u")J.write(l.Undefined);else if(typeof Y=="string"){const x=g.$ge.fromString(Y);J.write(l.String),o(J,x.byteLength),J.write(x)}else if(c&&Buffer.isBuffer(Y)){const x=g.$ge.wrap(Y);J.write(l.Buffer),o(J,x.byteLength),J.write(x)}else if(Y instanceof g.$ge)J.write(l.VSBuffer),o(J,Y.byteLength),J.write(Y);else if(Array.isArray(Y)){J.write(l.Array),o(J,Y.length);for(const x of Y)h(J,x)}else if(typeof Y=="number"&&(Y|0)===Y)J.write(l.Uint),o(J,Y);else{const x=g.$ge.fromString(JSON.stringify(Y));J.write(l.Object),o(J,x.byteLength),J.write(x)}}e.$Ah=h;function S(J){switch(J.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return J.read(i(J)).toString();case r.Buffer:return J.read(i(J)).buffer;case r.VSBuffer:return J.read(i(J));case r.Array:{const x=i(J),se=[];for(let Z=0;Z<x;Z++)se.push(S(J));return se}case r.Object:return JSON.parse(J.read(i(J)).toString());case r.Int:return i(J)}}e.$Bh=S;class L{constructor(Y,x,se=null,Z=1e3){this.h=Y,this.j=x,this.k=se,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ve=>this.q(ve)),this.m({type:200})}registerChannel(Y,x){this.b.set(Y,x),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const x=this.o([Y.type]);this.k?.logOutgoing(x,0,1,f(Y.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(x,Y.id,1,f(Y.type),Y.data);return}}}o(Y,x=void 0){const se=new t;return h(se,Y),h(se,x),this.p(se.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const x=new a(Y),se=S(x),Z=S(x),ve=se[0];switch(ve){case 100:return this.k?.logIncoming(Y.byteLength,se[1],1,`${k(ve)}: ${se[2]}.${se[3]}`,Z),this.s({type:ve,id:se[1],channelName:se[2],name:se[3],arg:Z});case 102:return this.k?.logIncoming(Y.byteLength,se[1],1,`${k(ve)}: ${se[2]}.${se[3]}`,Z),this.t({type:ve,id:se[1],channelName:se[2],name:se[3],arg:Z});case 101:return this.k?.logIncoming(Y.byteLength,se[1],1,`${k(ve)}`),this.u({type:ve,id:se[1]});case 103:return this.k?.logIncoming(Y.byteLength,se[1],1,`${k(ve)}`),this.u({type:ve,id:se[1]})}}s(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const se=new I.$3d;let Z;try{Z=x.call(this.j,Y.name,Y.arg,se.token)}catch(H){Z=Promise.reject(H)}const ve=Y.id;Z.then(H=>{this.m({id:ve,data:H,type:201})},H=>{H instanceof Error?this.m({id:ve,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ve,data:H,type:203})}).finally(()=>{de.dispose(),this.d.delete(Y.id)});const de=(0,y.$Qc)(()=>se.cancel());this.d.set(Y.id,de)}t(Y){const x=this.b.get(Y.channelName);if(!x){this.v(Y);return}const se=Y.id,ve=x.listen(this.j,Y.name,Y.arg)(de=>this.m({id:se,data:de,type:204}));this.d.set(Y.id,ve)}u(Y){const x=this.d.get(Y.id);x&&(x.dispose(),this.d.delete(Y.id))}v(Y){let x=this.g.get(Y.channelName);x||(x=[],this.g.set(Y.channelName,x));const se=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Y,timeoutTimer:se})}w(Y){const x=this.g.get(Y);if(x){for(const se of x)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Ch=L;var w;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class p{constructor(Y,x=null){this.l=Y,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=x}getChannel(Y){const x=this;return{call(se,Z,ve){return x.a?Promise.reject(new b.$5):x.m(Y,se,Z,ve)},listen(se,Z){return x.a?$.Event.None:x.o(Y,se,Z)}}}m(Y,x,se,Z=I.CancellationToken.None){const ve=this.g++,H={id:ve,type:100,channelName:Y,name:x,arg:se};if(Z.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((ye,he)=>{if(Z.isCancellationRequested)return he(new b.$5);const ge=()=>{const te=fe=>{switch(fe.type){case 201:this.f.delete(ve),ye(fe.data);break;case 202:{this.f.delete(ve);const we=new Error(fe.data.message);we.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,we.name=fe.data.name,he(we);break}case 203:this.f.delete(ve),he(fe.data);break}};this.f.set(ve,te),this.p(H)};let _=null;this.b===s.Idle?ge():(_=(0,N.$Og)(te=>this.u()),_.then(()=>{_=null,ge()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ve,type:101}),he(new b.$5)},G=Z.onCancellationRequested(ie);U=(0,y.$Pc)((0,y.$Qc)(ie),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,x,se){const Z=this.g++,de={id:Z,type:102,channelName:Y,name:x,arg:se};let H=null;const U=new $.$Sd({onWillAddFirstListener:()=>{H=(0,N.$Og)(ye=>this.u()),H.then(()=>{H=null,this.d.add(U),this.p(de)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(U),this.p({id:Z,type:103}))}}),ne=ye=>U.fire(ye.data);return this.f.set(Z,ne),U.event}p(Y){switch(Y.type){case 100:case 102:{const x=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(x,Y.id,0,`${k(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const x=this.q([Y.type,Y.id]);this.j?.logOutgoing(x,Y.id,0,k(Y.type));return}}}q(Y,x=void 0){const se=new t;return h(se,Y),h(se,x),this.r(se.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const x=new a(Y),se=S(x),Z=S(x),ve=se[0];switch(ve){case 200:return this.j?.logIncoming(Y.byteLength,0,0,f(ve)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,se[1],0,f(ve),Z),this.t({type:se[0],id:se[1],data:Z})}}t(Y){if(Y.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=p,Je([R.$sh],p.prototype,"onDidInitializePromise",null);class E{get connections(){const Y=[];return this.f.forEach(x=>Y.push(x)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Rc,this.j.add(Y(({protocol:x,onDidClientDisconnect:se})=>{const Z=$.Event.once(x.onMessage);this.j.add(Z(ve=>{const de=new a(ve),H=S(de),U=new L(x,H),ne=new p(x);this.a.forEach((he,ge)=>U.registerChannel(ge,he));const ye={channelServer:U,channelClient:ne,ctx:H};this.f.add(ye),this.g.fire(ye),this.j.add(se(()=>{U.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Y,x){const se=this;return{call(Z,ve,de){let H;if((0,m.$Rf)(x)){const ne=(0,D.$4b)(se.connections.filter(x));H=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(se.onDidAddConnection,x))}else H=x.routeCall(se,Z,ve);const U=H.then(ne=>ne.channelClient.getChannel(Y));return B(U).call(Z,ve,de)},listen(Z,ve){if((0,m.$Rf)(x))return se.k(Y,x,Z,ve);const de=x.routeEvent(se,Z,ve).then(H=>H.channelClient.getChannel(Y));return B(de).listen(Z,ve)}}}k(Y,x,se,Z){const ve=this;let de;const H=new $.$Sd({onWillAddFirstListener:()=>{de=new y.$Rc;const U=new $.$Yd,ne=new Map,ye=ge=>{const ie=ge.channelClient.getChannel(Y).listen(se,Z),G=U.add(ie);ne.set(ge,G)},he=ge=>{const _=ne.get(ge);_&&(_.dispose(),ne.delete(ge))};ve.connections.filter(x).forEach(ye),$.Event.filter(ve.onDidAddConnection,x)(ye,void 0,de),ve.onDidRemoveConnection(he,void 0,de),U.event(H.fire,H,de),de.add(U)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return H.event}registerChannel(Y,x){this.a.set(Y,x);for(const se of this.f)se.channelServer.registerChannel(Y,x)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Eh=E;class A{constructor(Y,x,se=null){const Z=new t;h(Z,x),Y.send(Z.buffer),this.a=new p(Y,se),this.d=new L(Y,x,se)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,x){this.d.registerChannel(Y,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Fh=A;function B(J){return{call(Y,x,se){return J.then(Z=>Z.call(Y,x,se))},listen(Y,x){const se=new $.$2d;return J.then(Z=>se.input=Z.listen(Y,x)),se.event}}}e.$Gh=B;function O(J){let Y=!1;return{call(x,se,Z){return Y?J.call(x,se,Z):(0,N.$2g)(0).then(()=>Y=!0).then(()=>J.call(x,se,Z))},listen(x,se){if(Y)return J.listen(x,se);const Z=new $.$2d;return(0,N.$2g)(0).then(()=>Y=!0).then(()=>Z.input=J.listen(x,se)),Z.event}}}e.$Hh=O;class P{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const x of Y.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$Ih=P;var j;(function(J){function Y(ve,de,H){const U=ve,ne=H&&H.disableMarshalling,ye=new Map;for(const he in U)se(he)&&ye.set(he,$.Event.buffer(U[he],!0,void 0,de));return new class{listen(he,ge,_){const ie=ye.get(ge);if(ie)return ie;if(Z(ge)){const G=U[ge];if(typeof G=="function")return G.call(U,_)}throw new b.$bb(`Event not found: ${ge}`)}call(he,ge,_){const ie=U[ge];if(typeof ie=="function"){if(!ne&&Array.isArray(_))for(let te=0;te<_.length;te++)_[te]=(0,M.$xh)(_[te]);let G=ie.apply(U,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}J.fromService=Y;function x(ve,de){const H=de&&de.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return de?.properties?.has(ne)?de.properties.get(ne):Z(ne)?function(ye){return ve.listen(ne,ye)}:se(ne)?ve.listen(ne):async function(...ye){let he;de&&!(0,m.$Mf)(de.context)?he=[de.context,...ye]:he=ye;const ge=await ve.call(ne,he);return H?ge:(0,M.$xh)(ge)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}J.toService=x;function se(ve){return ve[0]==="o"&&ve[1]==="n"&&C.$6e(ve.charCodeAt(2))}function Z(ve){return/^onDynamic/.test(ve)&&C.$6e(ve.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const T=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const Y=J.toString();if(Y!=="[object Object]")return Y}return J}function W(J){return Array.isArray(J)?J.map(F):F(J)}function X(J,Y,x,se,Z,ve,de){de=W(de);const H=T[Z],U=H[se%H.length];let ne=[`%c[${J}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${ve}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ve)?(ne=ne.concat(de),ne.push(")")):ne.push(de),console.log.apply(console,ne)}class ce{constructor(Y,x){this.d=Y,this.f=x,this.a=0,this.b=0}logOutgoing(Y,x,se,Z,ve){this.b+=Y,X(this.d,this.b,Y,x,se,Z,ve)}logIncoming(Y,x,se,Z,ve){this.a+=Y,X(this.f,this.a,Y,x,se,Z,ve)}}e.$Jh=ce}),define(Se[82],ke([1,0,22,4,3,81]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.ProtocolConstants=e.$Kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function S(w,p){if(!c.has(w)){const E=String(++h);c.set(w,E)}return c.get(w)}function L(w,p,E,A){if(!l.enableDiagnostics)return;const B=S(w,p);if(A instanceof D.$ge||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const O=D.$ge.alloc(A.byteLength);O.set(A),l.records.push({timestamp:Date.now(),id:B,label:p,type:E,buff:O})}else l.records.push({timestamp:Date.now(),id:B,label:p,type:E,data:A})}l.traceSocketEvent=L})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function M(){return y||(y=D.$ge.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return M();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const p=this.a[0];return h&&(this.a.shift(),this.b-=c),p}if(this.a[0].byteLength>c){const p=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),p}const S=D.$ge.alloc(c);let L=0,w=0;for(;c>0;){const p=this.a[w];if(p.byteLength>c){const E=p.slice(0,c);S.set(E,L),L+=c,h&&(this.a[w]=p.slice(c),this.b-=c),c-=c}else S.set(p,L),L+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):w++,c-=p.byteLength}return S}}e.$Kh=C;var m;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class u{constructor(c,h,S,L){this.type=c,this.id=h,this.ack=S,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Sc{constructor(c){super(),this.f=this.B(new N.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,L=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new u(S,L,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$ge.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const S=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,S}h(){const c=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends g.$Sc{constructor(c){super(),this.f=new N.$Sd,this.onMessage=this.f.event,this.g=new N.$Sd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new u(1,0,0,c))}}e.$Lh=i;class n extends I.$Fh{static fromSocket(c,h){return new n(new i(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,S=null){super(c,h,S),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Mh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Nh=o;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,S=this.a;for(;S;)c[h++]=S.data,S=S.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new a(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<r.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+r.a)*1e3;let S=0;for(let L=0;L<r.a;L++)c-this.c[L]<=h&&S++;return 1-S/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Rc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new u(5,0,0,M());this.p.write(c),this.p.flush()}sendPause(){const c=new u(7,0,0,M());this.p.write(c)}sendResume(){const c=new u(8,0,0,M());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new g.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new u(3,0,this.h,M());this.p.write(c);const h=this.b.toArray();for(let S=0,L=h.length;S<L;S++)this.p.write(h[S]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new u(6,0,0,M())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let S=0,L=h.length;S<L;S++)this.p.write(h[S]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const S=new u(1,h,this.h,c);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(c){const h=new u(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,S=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(h>=2e4&&S>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:S});return}const w=Math.max(2e4-h,2e4-S,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new u(3,0,this.h,M());this.p.write(c)}D(){this.h=this.g;const c=new u(9,0,this.h,M());this.p.write(c)}}e.$Oh=d}),define(Se[187],ke([1,0,51,12,22,21,185,8,4,3,24,104,101,81]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class k extends v.$Ch{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ge.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$bq=k;class u{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Sd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new N.$Xg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const a=this.n(s),t=(0,N.$Og)(l=>a.call(i,n,l)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,y.$Qc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const a=new $.$Sd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,M.$gn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,m.$Ml)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Sd;$.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$0p)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$ge.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,C.$Ol)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new v.$Dh(d);const l=()=>this.o();process.once("exit",l),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",l),this.c.forEach(S=>(0,y.$Nc)(S)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cq=u}),define(Se[188],ke([1,0,12,4,3,54,18]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.StorageState=e.$ap=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$ap=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class M extends g.$Sc{static{this.a=100}constructor(v,k=Object.create(null)){super(),this.r=v,this.s=k,this.b=this.B(new N.$Vd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Yg(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((k,u)=>this.w(u,k)),v.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(v,k){if(this.c===y.Closed)return;let u=!1;(0,R.$Mf)(k)?u=this.f.delete(v):this.f.get(v)!==k&&(this.f.set(v,k),u=!0),u&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,k){const u=this.f.get(v);return(0,R.$Mf)(u)?k:u}getBoolean(v,k){const u=this.get(v);return(0,R.$Mf)(u)?k:u==="true"}getNumber(v,k){const u=this.get(v);return(0,R.$Mf)(u)?k:parseInt(u,10)}getObject(v,k){const u=this.get(v);return(0,R.$Mf)(u)?k:(0,I.$wh)(u)}async set(v,k,u=!1){if(this.c===y.Closed)return;if((0,R.$Mf)(k))return this.delete(v,u);const f=(0,R.$Ff)(k)||Array.isArray(k)?(0,I.$vh)(k):String(k);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire({key:v,external:u}),this.D()}async delete(v,k=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:k}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$bp=M;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((k,u)=>this.a.set(u,k)),v.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$cp=C}),define(Se[189],ke([1,0,13,11,22]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.$Xs=void 0;let I;function R(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function M(){return y||(y=N.$D()?R():$()),y}e.$Xs=M;function C(k,u,f){const s=new Uint16Array(k.buffer,u,f);return f>0&&(s[0]===65279||s[0]===65534)?m(k,u,f):R().decode(s)}e.$Ys=C;function m(k,u,f){const s=[];let i=0;for(let n=0;n<f;n++){const o=g.$ie(k,u);u+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class v{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return M().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const f=this.a-this.d;f<=1&&(f===0||D.$$e(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const f=u.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=u;return}for(let s=0;s<f;s++)this.b[this.d++]=u.charCodeAt(s)}}e.$Zs=v}),define(Se[190],ke([1,0,22,189]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,M,C,m){this.oldPosition=y,this.oldText=M,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,M,C){const m=M.length;D.$le(y,m,C),C+=4;for(let v=0;v<m;v++)D.$je(y,M.charCodeAt(v),C),C+=2;return C}static d(y,M){const C=D.$ke(y,M);return M+=4,(0,N.$Ys)(y,M,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,M){return D.$le(y,this.oldPosition,M),M+=4,D.$le(y,this.newPosition,M),M+=4,M=I.c(y,this.oldText,M),M=I.c(y,this.newText,M),M}static read(y,M,C){const m=D.$ke(y,M);M+=4;const v=D.$ke(y,M);M+=4;const k=I.d(y,M);M+=I.a(k);const u=I.d(y,M);return M+=I.a(u),C.push(new I(m,k,v,u)),M}}e.$1s=I;function R($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$2s=R;class b{constructor(y,M){this.a=y,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,M=0,C=this.n(y),m=this.l(M);for(;y<this.f||M<this.h;){if(C===null){this.k(m),m=this.l(++M);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++M);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=b.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=b.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let u,f;if(m.oldEnd===C.newEnd)u=C,f=m,C=this.n(++y),m=this.l(++M);else if(m.oldEnd<C.newEnd){const[s,i]=b.q(C,m.oldLength);u=s,f=m,C=i,m=this.l(++M)}else{const[s,i]=b.r(m,C.newLength);u=C,f=s,C=this.n(++y),m=i}this.d[this.e++]=new I(u.oldPosition,u.oldText,f.newPosition,f.newText),this.g+=u.newLength-u.oldLength,this.j+=f.newLength-f.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,M){return new I(M.oldPosition-y,M.oldText,M.newPosition,M.newText)}static p(y,M){return new I(M.oldPosition,M.oldText,M.newPosition+y,M.newText)}static q(y,M){const C=y.newText.substr(0,M),m=y.newText.substr(M);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+M,m)]}static r(y,M){const C=y.oldText.substr(0,M),m=y.oldText.substr(M);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+M,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const M=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const k=y[v];m.oldEnd===k.oldPosition?m=new I(m.oldPosition,m.oldText+k.oldText,m.newPosition,m.newText+k.newText):(M[C++]=m,m=k)}return M[C++]=m,M}static t(y){if(y.length===0)return y;const M=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(M[C++]=v)}return M}}}),define(Se[191],ke([1,0,34,16]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0;function g(I,R,b,$,y,M){if(Array.isArray(I)){let C=0;for(const m of I){const v=g(m,R,b,$,y,M);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:k,notebookType:u}=I;if(!$&&!k)return 0;u&&y&&(R=y);let f=0;if(v)if(v===R.scheme)f=10;else if(v==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(u)if(u===M)f=10;else if(u==="*"&&M!==void 0)f=Math.max(f,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,N.$hc)(m.base)},s===R.fsPath||(0,D.$Gj)(s,R.fsPath))f=10;else return 0}return f}else return 0}}e.$mt=g}),define(Se[192],ke([1,0,4,13,29,79,127,167,190,3]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=void 0;class M extends y.$Sc{constructor(m,v,k,u,f,s,i){super(),this.m=this.B(new D.$Sd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=u,this.h=f,this.c=new R.$SB(m,k,i)}equals(m){return!(m instanceof M)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const k=m+v,u=this.getPositionAt(m),f=this.getPositionAt(k);return new g.$Fs(u.lineNumber,u.column,f.lineNumber,f.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const k=this.n(v);return this.c.getValueInRange(m,k)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const k=this.getOffsetAt(m.startLineNumber,m.startColumn),u=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;f=n*o}return u-k+f}getCharacterCountInRange(m,v=0){if(this.j){let k=0;const u=m.startLineNumber,f=m.endLineNumber;for(let s=u;s<=f;s++){const i=this.getLineContent(s),n=s===u?m.startColumn-1:0,o=s===f?m.endColumn-1:i.length;for(let a=n;a<o;a++)N.$$e(i.charCodeAt(a))?(k=k+1,a=a+1):k=k+1}return k+=this.n(v).length*(f-u),k}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=N.$Ve(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=N.$Xe(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,k){let u=this.g,f=this.h,s=this.j,i=!0,n=[];for(let c=0;c<m.length;c++){const h=m[c];i&&h._isTracked&&(i=!1);const S=h.range;if(h.text){let A=!0;s||(A=!N.$jf(h.text),s=A),!u&&A&&(u=N.$if(h.text)),!f&&A&&(f=N.$lf(h.text))}let L="",w=0,p=0,E=0;if(h.text){let A;[w,p,E,A]=(0,b.$ft)(h.text);const B=this.getEOL();A===0||A===(B===`\r
`?2:1)?L=h.text:L=h.text.replace(/\r\n|\r|\n/g,B)}n[c]={sortIndex:c,identifier:h.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:w,firstLineLength:p,lastLineLength:E,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(M.u);let o=!1;for(let c=0,h=n.length-1;c<h;c++){const S=n[c].range.getEndPosition(),L=n[c+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=k||v?M._getInverseEditRanges(n):[],t=[];if(v)for(let c=0;c<n.length;c++){const h=n[c],S=a[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let w="";L===S.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),N.$Ve(w)!==-1)||t.push({lineNumber:L,oldContent:w})}}let r=null;if(k){let c=0;r=[];for(let h=0;h<n.length;h++){const S=n[h],L=a[h],w=this.getValueInRange(S.range),p=S.rangeOffset+c;c+=S.text.length-w.length,r[h]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:w,textChange:new $.$1s(S.rangeOffset,w,p,S.text)}}o||r.sort((h,S)=>h.sortIndex-S.sortIndex)}this.g=u,this.h=f,this.j=s;const d=this.t(n);let l=null;if(v&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const S=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===S)continue;const L=t[c].oldContent,w=this.getLineContent(S);w.length===0||w===L||N.$Ve(w)!==-1||l.push(S)}}return this.m.fire(),new I.$2u(r,d,l)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const k=m[0].range,u=m[m.length-1].range,f=new g.$Fs(k.startLineNumber,k.startColumn,u.endLineNumber,u.endColumn);let s=k.startLineNumber,i=k.startColumn;const n=[];for(let d=0,l=m.length;d<l;d++){const c=m[d],h=c.range;v=v||c.forceMoveMarkers,n.push(this.getValueInRange(new g.$Fs(s,i,h.startLineNumber,h.startColumn))),c.text.length>0&&n.push(c.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[a,t,r]=(0,b.$ft)(o);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(M.w);const v=[];for(let k=0;k<m.length;k++){const u=m[k],f=u.range.startLineNumber,s=u.range.startColumn,i=u.range.endLineNumber,n=u.range.endColumn;if(f===i&&s===n&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const o=new g.$Fs(f,s,i,n);v.push({range:o,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,k,u){return this.c.findMatchesLineByLine(m,v,k,u)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const k=m.startLineNumber,u=m.startColumn,[f,s,i]=(0,b.$ft)(v);let n;if(v.length>0){const o=f+1;o===1?n=new g.$Fs(k,u,k,u+s):n=new g.$Fs(k,u,k+o-1,i+1)}else n=new g.$Fs(k,u,k,u);return n}static _getInverseEditRanges(m){const v=[];let k=0,u=0,f=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,a;f?f.range.endLineNumber===n.range.startLineNumber?(o=k,a=u+(n.range.startColumn-f.range.endColumn)):(o=k+(n.range.startLineNumber-f.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Fs(o,a,o,a+n.firstLineLength):t=new g.$Fs(o,a,o+r-1,n.lastLineLength+1)}else t=new g.$Fs(o,a,o,a);k=t.endLineNumber,u=t.endColumn,v.push(t),f=n}return v}static u(m,v){const k=g.$Fs.compareRangesUsingEnds(m.range,v.range);return k===0?m.sortIndex-v.sortIndex:k}static w(m,v){const k=g.$Fs.compareRangesUsingEnds(m.range,v.range);return k===0?v.sortIndex-m.sortIndex:-k}}e.$TB=M}),define(Se[193],ke([1,0,13,127,192]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UB=void 0;class I{constructor($,y,M,C,m,v,k,u,f){this.a=$,this.b=y,this.c=M,this.d=C,this.e=m,this.f=v,this.g=k,this.h=u,this.j=f}k($){const y=this.c+this.d+this.e,M=this.c+this.e;return y===0?$===1?`
`:`\r
`:M>y/2?`\r
`:`
`}create($){const y=this.k($),M=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=M.length;m<v;m++){const k=M[m].buffer.replace(/\r\n|\r|\n/g,y),u=(0,N.$OB)(k);M[m]=new N.$RB(k,u)}const C=new g.$TB(M,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$rf($)&&(this.b=D.$qf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,N.$PB)(this.e,$);this.a.push(new N.$RB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$if($)),this.k||(this.k=D.$lf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,N.$OB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$UB=R}),define(Se[131],ke([1,0,22,11]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$=e.$e$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,v=C.length;m<v;m+=4){const k=C[m+0],u=C[m+1],f=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=f,C[m+2]=u,C[m+3]=k}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||I(m),D.$ge.wrap(m)}function b(C){const m=C.buffer;if(N.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const k of C.deltas)m[v++]=k.start,m[v++]=k.deleteCount,k.data?(m[v++]=k.data.length,m.set(k.data,v),v+=k.data.length):m[v++]=0}return R(m)}e.$e$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function M(C){const m=b(C);let v=0;const k=m[v++];if(m[v++]===1){const i=m[v++],n=m.subarray(v,v+i);return v+=i,{id:k,type:"full",data:n}}const f=m[v++],s=[];for(let i=0;i<f;i++){const n=m[v++],o=m[v++],a=m[v++];let t;a>0&&(t=m.subarray(v,v+a),v+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:k,type:"delta",deltas:s}}e.$f$=M}),define(Se[194],ke([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Se[132],ke([1,0,19,24,11,170,126,194]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=y;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class C{constructor(ue,Ie,Ke,Qe){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Qe}applyUpdate(ue,Ie){return v(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class m{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=m;function v(ae,ue){if(typeof ae!="object"||typeof ue!="object"||!ae||!ue)return new m(ue,ae!==ue);if(Array.isArray(ae)||Array.isArray(ue)){const Ke=Array.isArray(ae)&&Array.isArray(ue)&&D.$ub(ae,ue);return new m(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Qe=v(ae[Ke],ue[Ke]);Qe.didChange&&(ae[Ke]=Qe.newValue,Ie=!0)}return new m(ae,Ie)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return v(ue,Ie)}validate(ue){return this.defaultValue}}class u{constructor(ue,Ie,Ke,Qe){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Qe}applyUpdate(ue,Ie){return v(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function f(ae,ue){return typeof ae>"u"?ue:ae==="false"?!1:!!ae}e.boolean=f;class s extends u{constructor(ue,Ie,Ke,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ke),super(ue,Ie,Ke,Qe)}validate(ue){return f(ue,this.defaultValue)}}function i(ae,ue,Ie,Ke){if(typeof ae>"u")return ue;let Qe=parseInt(ae,10);return isNaN(Qe)?ue:(Qe=Math.max(Ie,Qe),Qe=Math.min(Ke,Qe),Qe|0)}e.clampedInt=i;class n extends u{static clampedInt(ue,Ie,Ke,Qe){return i(ue,Ie,Ke,Qe)}constructor(ue,Ie,Ke,Qe,rt,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Ke,ot.minimum=Qe,ot.maximum=rt),super(ue,Ie,Ke,ot),this.minimum=Qe,this.maximum=rt}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function o(ae,ue,Ie,Ke){if(typeof ae>"u")return ue;const Qe=a.float(ae,ue);return a.clamp(Qe,Ie,Ke)}e.clampedFloat=o;class a extends u{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Qe,rt){typeof rt<"u"&&(rt.type="number",rt.default=Ke),super(ue,Ie,Ke,rt),this.validationFn=Qe}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends u{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ke),super(ue,Ie,Ke,Qe)}validate(ue){return t.string(ue,this.defaultValue)}}function r(ae,ue,Ie,Ke){return typeof ae!="string"?ue:Ke&&ae in Ke?Ke[ae]:Ie.indexOf(ae)===-1?ue:ae}e.stringSet=r;class d extends u{constructor(ue,Ie,Ke,Qe,rt=void 0){typeof rt<"u"&&(rt.type="string",rt.enum=Qe,rt.default=Ke),super(ue,Ie,Ke,rt),this.c=Qe}validate(ue){return r(ue,this.defaultValue,this.c)}}class l extends C{constructor(ue,Ie,Ke,Qe,rt,ot,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=rt,Be.default=Qe),super(ue,Ie,Ke,Be),this.c=rt,this.d=ot}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class S extends C{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function w(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function E(ae){switch(ae){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function A(ae){switch(ae){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class B extends k{constructor(){super(140)}compute(ue,Ie,Ke){const Qe=["monaco-editor"];return Ie.get(39)&&Qe.push(Ie.get(39)),ue.extraEditorClassName&&Qe.push(ue.extraEditorClassName),Ie.get(73)==="default"?Qe.push("mouse-default"):Ie.get(73)==="copy"&&Qe.push("mouse-copy"),Ie.get(110)&&Qe.push("showUnused"),Ie.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class O extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class P extends C{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.ON:ue:ue?j.ON:j.OFF}}e.EditorFontLigatures=j;class T extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?T.OFF:ue==="true"?T.TRANSLATE:ue:ue?T.TRANSLATE:T.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class F extends k{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class W extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ie=a.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class X extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ce extends C{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends C{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var Y;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class x extends k{constructor(){super(143)}compute(ue,Ie,Ke){return x.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Qe=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Qe=Math.max(Qe,Ie-1));const rt=(Ke+ue.viewLineCount+Qe)/(ue.pixelRatio*ue.height),ot=Math.floor(ue.viewLineCount/rt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Qe,desiredRatio:rt,minimapLineCount:ot}}static c(ue,Ie){const Ke=ue.outerWidth,Qe=ue.outerHeight,rt=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ot=Ie.stableMinimapLayoutInput,Be=ot&&ue.outerHeight===ot.outerHeight&&ue.lineHeight===ot.lineHeight&&ue.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ot.pixelRatio&&ue.scrollBeyondLastLine===ot.scrollBeyondLastLine&&ue.paddingTop===ot.paddingTop&&ue.paddingBottom===ot.paddingBottom&&ue.minimap.enabled===ot.minimap.enabled&&ue.minimap.side===ot.minimap.side&&ue.minimap.size===ot.minimap.size&&ue.minimap.showSlider===ot.minimap.showSlider&&ue.minimap.renderCharacters===ot.minimap.renderCharacters&&ue.minimap.maxColumn===ot.minimap.maxColumn&&ue.minimap.scale===ot.minimap.scale&&ue.verticalScrollbarWidth===ot.verticalScrollbarWidth&&ue.isViewportWrapping===ot.isViewportWrapping,yt=ue.lineHeight,Mt=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,zt=ue.minimap.renderCharacters;let vt=rt>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Vt=ue.minimap.maxColumn,Ft=ue.minimap.size,Qt=ue.minimap.side,Ot=ue.verticalScrollbarWidth,It=ue.viewLineCount,tt=ue.remainingWidth,Ht=ue.isViewportWrapping,Gt=zt?2:3;let lt=Math.floor(rt*Qe);const $t=lt/rt;let jt=!1,Ut=!1,St=Gt*vt,dt=vt/rt,Pt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Rt,extraLinesBeyondLastLine:Re,desiredRatio:Ne,minimapLineCount:Ce}=x.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Qe,lineHeight:yt,pixelRatio:rt});if(It/Ce>1)jt=!0,Ut=!0,vt=1,St=1,dt=vt/rt;else{let Te=!1,Ve=vt+1;if(Ft==="fit"){const et=Math.ceil((Rt+It+Re)*St);Ht&&Be&&tt<=Ie.stableFitRemainingWidth?(Te=!0,Ve=Ie.stableFitMaxMinimapScale):Te=et>lt}if(Ft==="fill"||Te){jt=!0;const et=vt;St=Math.min(yt*rt,Math.max(1,Math.floor(1/Ne))),Ht&&Be&&tt<=Ie.stableFitRemainingWidth&&(Ve=Ie.stableFitMaxMinimapScale),vt=Math.min(Ve,Math.max(1,Math.floor(St/Gt))),vt>et&&(Pt=Math.min(2,vt/et)),dt=vt/rt/Pt,lt=Math.ceil(Math.max(gt,Rt+It+Re)*St),Ht?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=tt,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Xt=Math.floor(Vt*dt),kt=Math.min(Xt,Math.max(0,Math.floor((tt-Ot-2)*dt/(Mt+dt)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(rt*kt);const Lt=Ze/rt;Ze=Math.floor(Ze*Pt);const Wt=zt?1:2,Jt=Qt==="left"?0:Ke-kt-Ot;return{renderMinimap:Wt,minimapLeft:Jt,minimapWidth:kt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Ut,minimapScale:vt,minimapLineHeight:St,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:$t}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Qe=Ie.outerHeight|0,rt=Ie.lineHeight|0,ot=Ie.lineNumbersDigitCount|0,Be=Ie.typicalHalfwidthCharacterWidth,yt=Ie.maxDigitWidth,Mt=Ie.pixelRatio,Kt=Ie.viewLineCount,zt=ue.get(135),vt=zt==="inherit"?ue.get(134):zt,Vt=vt==="inherit"?ue.get(130):vt,Ft=ue.get(133),Qt=Ie.isDominatedByLongLines,Ot=ue.get(57),It=ue.get(67).renderType!==0,tt=ue.get(68),Ht=ue.get(104),Gt=ue.get(83),lt=ue.get(72),$t=ue.get(102),jt=$t.verticalScrollbarSize,Ut=$t.verticalHasArrows,St=$t.arrowSize,dt=$t.horizontalScrollbarSize,Pt=ue.get(43),Xt=ue.get(109)!=="never";let kt=ue.get(65);Pt&&Xt&&(kt+=16);let Ze=0;if(It){const st=Math.max(ot,tt);Ze=Math.round(st*yt)}let Lt=0;Ot&&(Lt=rt*Ie.glyphMarginDecorationLaneCount);let Wt=0,Jt=Wt+Lt,gt=Jt+Ze,Rt=gt+kt;const Re=Ke-Lt-Ze-kt;let Ne=!1,Ce=!1,re=-1;vt==="inherit"&&Qt?(Ne=!0,Ce=!0):Vt==="on"||Vt==="bounded"?Ce=!0:Vt==="wordWrapColumn"&&(re=Ft);const Te=x.c({outerWidth:Ke,outerHeight:Qe,lineHeight:rt,typicalHalfwidthCharacterWidth:Be,pixelRatio:Mt,scrollBeyondLastLine:Ht,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:lt,verticalScrollbarWidth:jt,viewLineCount:Kt,remainingWidth:Re,isViewportWrapping:Ce},Ie.memory||new M);Te.renderMinimap!==0&&Te.minimapLeft===0&&(Wt+=Te.minimapWidth,Jt+=Te.minimapWidth,gt+=Te.minimapWidth,Rt+=Te.minimapWidth);const Ve=Re-Te.minimapWidth,et=Math.max(1,Math.floor((Ve-jt-2)/Be)),Ge=Ut?St:0;return Ce&&(re=Math.max(1,et),Vt==="bounded"&&(re=Math.min(re,Ft))),{width:Ke,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Jt,lineNumbersWidth:Ze,decorationsLeft:gt,decorationsWidth:kt,contentLeft:Rt,contentWidth:Ve,minimap:Te,viewportColumn:et,isWordWrapMinified:Ne,isViewportWrapping:Ce,wrappingColumn:re,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ge,width:jt,height:Qe-2*Ge,right:0}}}}e.EditorLayoutInfoComputer=x;class se extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return r(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}var Z;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(Z||(e.ShowAiIconMode=Z={}));class ve extends C{constructor(){const ue={enabled:!0,experimental:{showAiIcon:Z.Off}};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:b.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[Z.Off,Z.OnCode,Z.On],default:ue.experimental.showAiIcon,enumDescriptions:[b.localize(51,null),b.localize(52,null),b.localize(53,null)],description:b.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(Ie.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[Z.Off,Z.OnCode,Z.On])}}}}class de extends C{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:b.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(58,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class H extends C{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(60,null),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(66,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ne extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:b.localize(67,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class ye extends C{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(70,null),b.localize(71,null),b.localize(72,null)],default:ue.size,description:b.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(75,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(ae){return ae==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends C{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class ie extends k{constructor(){super(141)}compute(ue,Ie,Ke){return ue.pixelRatio}}class G extends C{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(83,null),b.localize(84,null),b.localize(85,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:b.localize(86,null)},comments:{anyOf:Ie,default:ue.comments,description:b.localize(87,null)},other:{anyOf:Ie,default:ue.other,description:b.localize(88,null)}},default:ue,markdownDescription:b.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Mt=ue?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Qe}=ue,rt=["on","inline","off"];let ot,Be,yt;return typeof Ie=="boolean"?ot=Ie?"on":"off":ot=r(Ie,this.defaultValue.other,rt),typeof Ke=="boolean"?Be=Ke?"on":"off":Be=r(Ke,this.defaultValue.comments,rt),typeof Qe=="boolean"?yt=Qe?"on":"off":yt=r(Qe,this.defaultValue.strings,rt),{other:ot,comments:Be,strings:yt}}}var te;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(90,null),b.localize(91,null),b.localize(92,null),b.localize(93,null)],default:"on",description:b.localize(94,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function we(ae){const ue=ae.get(97);return ue==="editable"?ae.get(90):ue!=="on"}e.filterValidationDecorations=we;class Ae extends C{constructor(){const ue=[],Ie={type:"number",description:b.localize(95,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(96,null),format:"color-hex"}}}]},default:ue,description:b.localize(97,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Qe=Ke;Ie.push({column:n.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return Ie.sort((Ke,Qe)=>Ke.column-Qe.column),Ie}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function De(ae,ue){if(typeof ae!="string")return ue;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends C{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(102,null),b.localize(103,null),b.localize(104,null)],default:"auto",description:b.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(109,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Qe,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(116,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(N.$kn(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(N.$kn(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Qe=super.applyUpdate(ue,Ie);return Ke?new m(Qe.newValue,!0):Qe}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Qe,rt]of Object.entries(ue))rt===!0&&(Ke[Qe]=!0);return Ke}}class ee extends C{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(118,null),b.localize(119,null),b.localize(120,null)],description:b.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(122,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class V extends C{constructor(){const ue={enabled:I.$cs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$cs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(124,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class oe extends C{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:ue.bracketPairs,description:b.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:ue.bracketPairsHorizontal,description:b.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.highlightActiveIndentation,description:b.localize(138,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ae,ue,Ie){const Ke=Ie.indexOf(ae);return Ke===-1?ue:Ie[Ke]}class Le extends C{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(139,null),b.localize(140,null)],default:ue.insertMode,description:b.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null),b.localize(148,null)],default:ue.selectionMode,markdownDescription:b.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(188,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Ye extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(189,null),b.localize(190,null),b.localize(191,null),b.localize(192,null)],description:b.localize(193,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class _e extends k{constructor(){super(144)}compute(ue,Ie,Ke){const Qe=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class at extends C{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Pe extends C{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(200,null),b.localize(201,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Oe="Consolas, 'Courier New', monospace",qe="Menlo, Monaco, 'Courier New', monospace",Xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?qe:g.$k?Xe:Oe,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var nt;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.letterSpacing=63]="letterSpacing",ae[ae.lightbulb=64]="lightbulb",ae[ae.lineDecorationsWidth=65]="lineDecorationsWidth",ae[ae.lineHeight=66]="lineHeight",ae[ae.lineNumbers=67]="lineNumbers",ae[ae.lineNumbersMinChars=68]="lineNumbersMinChars",ae[ae.linkedEditing=69]="linkedEditing",ae[ae.links=70]="links",ae[ae.matchBrackets=71]="matchBrackets",ae[ae.minimap=72]="minimap",ae[ae.mouseStyle=73]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=75]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=77]="multiCursorModifier",ae[ae.multiCursorPaste=78]="multiCursorPaste",ae[ae.multiCursorLimit=79]="multiCursorLimit",ae[ae.occurrencesHighlight=80]="occurrencesHighlight",ae[ae.overviewRulerBorder=81]="overviewRulerBorder",ae[ae.overviewRulerLanes=82]="overviewRulerLanes",ae[ae.padding=83]="padding",ae[ae.pasteAs=84]="pasteAs",ae[ae.parameterHints=85]="parameterHints",ae[ae.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=88]="quickSuggestions",ae[ae.quickSuggestionsDelay=89]="quickSuggestionsDelay",ae[ae.readOnly=90]="readOnly",ae[ae.readOnlyMessage=91]="readOnlyMessage",ae[ae.renameOnType=92]="renameOnType",ae[ae.renderControlCharacters=93]="renderControlCharacters",ae[ae.renderFinalNewline=94]="renderFinalNewline",ae[ae.renderLineHighlight=95]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=97]="renderValidationDecorations",ae[ae.renderWhitespace=98]="renderWhitespace",ae[ae.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ae[ae.roundedSelection=100]="roundedSelection",ae[ae.rulers=101]="rulers",ae[ae.scrollbar=102]="scrollbar",ae[ae.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=104]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=105]="scrollPredominantAxis",ae[ae.selectionClipboard=106]="selectionClipboard",ae[ae.selectionHighlight=107]="selectionHighlight",ae[ae.selectOnLineNumbers=108]="selectOnLineNumbers",ae[ae.showFoldingControls=109]="showFoldingControls",ae[ae.showUnused=110]="showUnused",ae[ae.snippetSuggestions=111]="snippetSuggestions",ae[ae.smartSelect=112]="smartSelect",ae[ae.smoothScrolling=113]="smoothScrolling",ae[ae.stickyScroll=114]="stickyScroll",ae[ae.stickyTabStops=115]="stickyTabStops",ae[ae.stopRenderingLineAfter=116]="stopRenderingLineAfter",ae[ae.suggest=117]="suggest",ae[ae.suggestFontSize=118]="suggestFontSize",ae[ae.suggestLineHeight=119]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ae[ae.suggestSelection=121]="suggestSelection",ae[ae.tabCompletion=122]="tabCompletion",ae[ae.tabIndex=123]="tabIndex",ae[ae.unicodeHighlighting=124]="unicodeHighlighting",ae[ae.unusualLineTerminators=125]="unusualLineTerminators",ae[ae.useShadowDOM=126]="useShadowDOM",ae[ae.useTabStops=127]="useTabStops",ae[ae.wordBreak=128]="wordBreak",ae[ae.wordSeparators=129]="wordSeparators",ae[ae.wordWrap=130]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=133]="wordWrapColumn",ae[ae.wordWrapOverride1=134]="wordWrapOverride1",ae[ae.wordWrapOverride2=135]="wordWrapOverride2",ae[ae.wrappingIndent=136]="wrappingIndent",ae[ae.wrappingStrategy=137]="wrappingStrategy",ae[ae.showDeprecated=138]="showDeprecated",ae[ae.inlayHints=139]="inlayHints",ae[ae.editorClassName=140]="editorClassName",ae[ae.pixelRatio=141]="pixelRatio",ae[ae.tabFocusMode=142]="tabFocusMode",ae[ae.layoutInfo=143]="layoutInfo",ae[ae.wrappingInfo=144]="wrappingInfo",ae[ae.defaultColorDecorators=145]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(nt||(e.EditorOption=nt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(202,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(203,null),""],markdownDescription:b.localize(204,null)})),accessibilitySupport:Fe(new h),accessibilityPageSize:Fe(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(205,null),tags:["accessibility"]})),ariaLabel:Fe(new t(4,"ariaLabel",b.localize(206,null))),ariaRequired:Fe(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Fe(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Fe(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(208,null),b.localize(209,null),""],description:b.localize(210,null)})),autoClosingComments:Fe(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(211,null),b.localize(212,null),""],description:b.localize(213,null)})),autoClosingDelete:Fe(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(214,null),""],description:b.localize(215,null)})),autoClosingOvertype:Fe(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(216,null),""],description:b.localize(217,null)})),autoClosingQuotes:Fe(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(218,null),b.localize(219,null),""],description:b.localize(220,null)})),autoIndent:Fe(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null),b.localize(225,null)],description:b.localize(226,null)})),automaticLayout:Fe(new s(13,"automaticLayout",!1)),autoSurround:Fe(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(227,null),b.localize(228,null),b.localize(229,null),""],description:b.localize(230,null)})),bracketPairColorization:Fe(new V),bracketPairGuides:Fe(new oe),stickyTabStops:Fe(new s(115,"stickyTabStops",!1,{description:b.localize(231,null)})),codeLens:Fe(new s(17,"codeLens",!0,{description:b.localize(232,null)})),codeLensFontFamily:Fe(new t(18,"codeLensFontFamily","",{description:b.localize(233,null)})),codeLensFontSize:Fe(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(234,null)})),colorDecorators:Fe(new s(20,"colorDecorators",!0,{description:b.localize(235,null)})),colorDecoratorActivatedOn:Fe(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(236,null),b.localize(237,null),b.localize(238,null)],description:b.localize(239,null)})),colorDecoratorsLimit:Fe(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(240,null)})),columnSelection:Fe(new s(22,"columnSelection",!1,{description:b.localize(241,null)})),comments:Fe(new S),contextmenu:Fe(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(242,null)})),cursorBlinking:Fe(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(243,null)})),cursorSmoothCaretAnimation:Fe(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(244,null),b.localize(245,null),b.localize(246,null)],description:b.localize(247,null)})),cursorStyle:Fe(new l(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:b.localize(248,null)})),cursorSurroundingLines:Fe(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(249,null)})),cursorSurroundingLinesStyle:Fe(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(250,null),b.localize(251,null)],markdownDescription:b.localize(252,null)})),cursorWidth:Fe(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(253,null)})),disableLayerHinting:Fe(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new s(34,"domReadOnly",!1)),dragAndDrop:Fe(new s(35,"dragAndDrop",!0,{description:b.localize(254,null)})),emptySelectionClipboard:Fe(new O),dropIntoEditor:Fe(new at),stickyScroll:Fe(new de),experimentalWhitespaceRendering:Fe(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(255,null),b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),extraEditorClassName:Fe(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Fe(new a(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(259,null)})),find:Fe(new P),fixedOverflowWidgets:Fe(new s(42,"fixedOverflowWidgets",!1)),folding:Fe(new s(43,"folding",!0,{description:b.localize(260,null)})),foldingStrategy:Fe(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(261,null),b.localize(262,null)],description:b.localize(263,null)})),foldingHighlight:Fe(new s(45,"foldingHighlight",!0,{description:b.localize(264,null)})),foldingImportsByDefault:Fe(new s(46,"foldingImportsByDefault",!1,{description:b.localize(265,null)})),foldingMaximumRegions:Fe(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(266,null)})),unfoldOnClickAfterEndOfLine:Fe(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(267,null)})),fontFamily:Fe(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(268,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new j),fontSize:Fe(new W),fontWeight:Fe(new X),fontVariations:Fe(new T),formatOnPaste:Fe(new s(55,"formatOnPaste",!1,{description:b.localize(269,null)})),formatOnType:Fe(new s(56,"formatOnType",!1,{description:b.localize(270,null)})),glyphMargin:Fe(new s(57,"glyphMargin",!0,{description:b.localize(271,null)})),gotoLocation:Fe(new ce),hideCursorInOverviewRuler:Fe(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(272,null)})),hover:Fe(new J),inDiffEditor:Fe(new s(61,"inDiffEditor",!1)),letterSpacing:Fe(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>a.clamp(ae,-5,20),{description:b.localize(273,null)})),lightbulb:Fe(new ve),lineDecorationsWidth:Fe(new U),lineHeight:Fe(new ne),lineNumbers:Fe(new fe),lineNumbersMinChars:Fe(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new s(69,"linkedEditing",!1,{description:b.localize(274,null)})),links:Fe(new s(70,"links",!0,{description:b.localize(275,null)})),matchBrackets:Fe(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(276,null)})),minimap:Fe(new ye),mouseStyle:Fe(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new a(74,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(277,null)})),mouseWheelZoom:Fe(new s(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(278,null)})),multiCursorMergeOverlapping:Fe(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Fe(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Fe(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Fe(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Fe(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Fe(new s(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Fe(new n(82,"overviewRulerLanes",3,0,3)),padding:Fe(new ge),pasteAs:Fe(new Pe),parameterHints:Fe(new _),peekWidgetDefaultFocus:Fe(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Fe(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Fe(new G),quickSuggestionsDelay:Fe(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Fe(new s(90,"readOnly",!1)),readOnlyMessage:Fe(new be),renameOnType:Fe(new s(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Fe(new s(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Fe(new d(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Fe(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Fe(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Fe(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Fe(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new s(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Fe(new Ae),scrollbar:Fe(new z),scrollBeyondLastColumn:Fe(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Fe(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Fe(new s(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Fe(new s(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Fe(new s(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Fe(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Fe(new s(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Fe(new s(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Fe(new H),snippetSuggestions:Fe(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Fe(new je),smoothScrolling:Fe(new s(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Fe(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new Le),inlineSuggest:Fe(new ee),inlineCompletionsAccessibilityVerbose:Fe(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Fe(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Fe(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Fe(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Fe(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new Q),unusualLineTerminators:Fe(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Fe(new s(126,"useShadowDOM",!0)),useTabStops:Fe(new s(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Fe(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Fe(new t(129,"wordSeparators",R.$ds,{description:b.localize(346,null)})),wordWrap:Fe(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Fe(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Fe(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new B),defaultColorDecorators:Fe(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Fe(new ie),tabFocusMode:Fe(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Fe(new x),wrappingInfo:Fe(new _e),wrappingIndent:Fe(new Ye),wrappingStrategy:Fe(new se)}}),define(Se[195],ke([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Se[83],ke([1,0,78,2,168,29,178,195]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$xt=e.$wt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$vt=e.$ut=e.SymbolKinds=e.SymbolTag=e.$tt=e.$st=e.SymbolKind=e.$rt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$qt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$pt=e.$ot=e.$nt=void 0;class ${constructor(j,T,F){this.offset=j,this.type=T,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$nt=$;class y{constructor(j,T){this.tokens=j,this.endState=T,this._tokenizationResultBrand=void 0}}e.$ot=y;class M{constructor(j,T){this.tokens=j,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$pt=M;var C;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(P){const j=new Map;j.set(0,D.$7j.symbolMethod),j.set(1,D.$7j.symbolFunction),j.set(2,D.$7j.symbolConstructor),j.set(3,D.$7j.symbolField),j.set(4,D.$7j.symbolVariable),j.set(5,D.$7j.symbolClass),j.set(6,D.$7j.symbolStruct),j.set(7,D.$7j.symbolInterface),j.set(8,D.$7j.symbolModule),j.set(9,D.$7j.symbolProperty),j.set(10,D.$7j.symbolEvent),j.set(11,D.$7j.symbolOperator),j.set(12,D.$7j.symbolUnit),j.set(13,D.$7j.symbolValue),j.set(15,D.$7j.symbolEnum),j.set(14,D.$7j.symbolConstant),j.set(15,D.$7j.symbolEnum),j.set(16,D.$7j.symbolEnumMember),j.set(17,D.$7j.symbolKeyword),j.set(27,D.$7j.symbolSnippet),j.set(18,D.$7j.symbolText),j.set(19,D.$7j.symbolColor),j.set(20,D.$7j.symbolFile),j.set(21,D.$7j.symbolReference),j.set(22,D.$7j.symbolCustomColor),j.set(23,D.$7j.symbolFolder),j.set(24,D.$7j.symbolTypeParameter),j.set(25,D.$7j.account),j.set(26,D.$7j.issues);function T(X){let ce=j.get(X);return ce||(console.info("No codicon found for CompletionItemKind "+X),ce=D.$7j.symbolProperty),ce}P.toIcon=T;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function W(X,ce){let J=F.get(X);return typeof J>"u"&&!ce&&(J=9),J}P.fromString=W})(m||(e.CompletionItemKinds=m={}));var v;(function(P){P[P.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var k;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var u;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var f;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class s{constructor(j,T,F,W){this.range=j,this.text=T,this.completionKind=F,this.isSnippetText=W}equals(j){return I.$Fs.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$qt=s;var i;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(P){return P&&N.URI.isUri(P.uri)&&I.$Fs.isIRange(P.range)&&(I.$Fs.isIRange(P.originSelectionRange)||I.$Fs.isIRange(P.targetSelectionRange))}e.$rt=a;var t;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$st={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(P,j){return(0,b.localize)(26,null,P,e.$st[j])}e.$tt=r;var d;(function(P){P[P.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var l;(function(P){const j=new Map;j.set(0,D.$7j.symbolFile),j.set(1,D.$7j.symbolModule),j.set(2,D.$7j.symbolNamespace),j.set(3,D.$7j.symbolPackage),j.set(4,D.$7j.symbolClass),j.set(5,D.$7j.symbolMethod),j.set(6,D.$7j.symbolProperty),j.set(7,D.$7j.symbolField),j.set(8,D.$7j.symbolConstructor),j.set(9,D.$7j.symbolEnum),j.set(10,D.$7j.symbolInterface),j.set(11,D.$7j.symbolFunction),j.set(12,D.$7j.symbolVariable),j.set(13,D.$7j.symbolConstant),j.set(14,D.$7j.symbolString),j.set(15,D.$7j.symbolNumber),j.set(16,D.$7j.symbolBoolean),j.set(17,D.$7j.symbolArray),j.set(18,D.$7j.symbolObject),j.set(19,D.$7j.symbolKey),j.set(20,D.$7j.symbolNull),j.set(21,D.$7j.symbolEnumMember),j.set(22,D.$7j.symbolStruct),j.set(23,D.$7j.symbolEvent),j.set(24,D.$7j.symbolOperator),j.set(25,D.$7j.symbolTypeParameter);function T(F){let W=j.get(F);return W||(console.info("No codicon found for SymbolKind "+F),W=D.$7j.symbolProperty),W}P.toIcon=T})(l||(e.SymbolKinds=l={}));class c{static asEditOperation(j){return g.$Gs.replace(I.$Fs.lift(j.range),j.text)}}e.$ut=c;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(j){switch(j){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(j)}constructor(j){this.value=j}}e.$vt=h;var S;(function(P){function j(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}P.is=j})(S||(e.Command=S={}));var L;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var w;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var p;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var E;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(E||(e.CommentState=E={}));var A;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class B{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$wt=B,e.$xt=new R.$et;var O;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(Se[196],ke([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[197],ke([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[198],ke([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Se[199],ke([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[200],ke([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[201],ke([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[202],ke([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[203],ke([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Se[204],ke([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Se[205],ke([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[206],ke([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Se[207],ke([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[208],ke([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[209],ke([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Se[210],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[211],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[212],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[213],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[214],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[215],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[216],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[217],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[218],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[219],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[220],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[221],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[222],ke([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[223],ke([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[224],ke([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Se[225],ke([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Se[226],ke([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Se[227],ke([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[228],ke([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[229],ke([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[230],ke([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[231],ke([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[232],ke([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[233],ke([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[234],ke([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[235],ke([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[236],ke([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[237],ke([1,0,8,198]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,N.localize)(0,null,y[0]);case 2:return(0,N.localize)(1,null,y[0],y[1]);case 3:return(0,N.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:M}),this.f.push(v)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,C=!1,m=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(b);return}const k=this.c.charCodeAt(M);if(C)C=!1;else if(k===47&&!m){M++;break}else k===91?m=!0:k===92?C=!0:k===93&&(m=!1);M++}for(;M<this.c.length&&$.a.has(this.c.charCodeAt(M));)M++;this.e=M;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=$}),define(Se[238],ke([1,0,23,39,201,386]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||R.test(s)}e.$Xo=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Yo=y;function M(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let d=0;if(s.preRelease){const l=b.exec(s.preRelease);if(l){const[,c,h,S]=l;d=Date.UTC(Number(c),Number(h)-1,Number(S))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$Zo=M;function C(s,i,n){let o;typeof s=="string"?o=M(y(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=M(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,l=o.patchBase;let c=t.majorBase,h=t.minorBase,S=t.patchBase;const L=t.notBefore;let w=t.majorMustEqual,p=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:d>h?!0:d<h||a&&a<L?!1:l>=S:(r===1&&c===0&&(!w||!p||!E)&&(c=1,h=0,S=0,w=!0,p=!1,E=!1),r<c?!1:r>c?!w:d<h?!1:d>h?!p:l<S?!1:l>S?!E:!(a&&a<L))}e.$1o=C;function m(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([N.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([N.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([N.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([N.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([N.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return t.push([N.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return t.push([N.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([N.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([N.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([N.default.Error,g.localize(9,null,"main")]),t;{const l=(0,D.$Cg)(n,o.main);(0,D.$wg)(l,n)||t.push([N.default.Warning,g.localize(10,null,l.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([N.default.Error,g.localize(11,null,"browser")]),t;{const l=(0,D.$Cg)(n,o.browser);(0,D.$wg)(l,n)||t.push([N.default.Warning,g.localize(12,null,l.path,n.path)])}}if(!I.valid(o.version))return t.push([N.default.Error,g.localize(13,null)]),t;const r=[];if(!v(s,i,o,a,r))for(const l of r)t.push([N.default.Error,l]);return t}e.$2o=m;function v(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(s,i,n.engines.vscode,a)}e.$3o=v;function k(s,i,n){return s==="*"||u(i,n,s)}e.$4o=k;function u(s,i,n,o=[]){const a=M(y(n));if(!a)return o.push(g.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,a)?!0:(o.push(g.localize(17,null,s,n)),!1)}function f(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Se[105],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class D{constructor(g,I=[],R=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$Xh=D}),define(Se[106],ke([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.InstantiationType=void 0;const N=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$Xh||($=new D.$Xh($,[],!!y)),N.push([b,$])}e.$Ir=I;function R(){return N}e.$Jr=R}),define(Se[239],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;class D{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$nq=D;class N{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let b=this.a.get(R);return b||(b=new D(R,I),this.a.set(R,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,b]of this.a)I.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const b=new Set([I]),$=this.c(R,b);if($)return $}}c(I,R){for(const[b,$]of I.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this.c($,R);if(y)return y;R.delete(b)}}}e.$oq=N}),define(Se[5],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(D||(e._util=D={})),e.$Zh=g("instantiationService");function N(R,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:R,index:$}):(b[D.DI_DEPENDENCIES]=[{id:R,index:$}],b[D.DI_TARGET]=b)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const b=function($,y,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,M)};return b.toString=()=>R,D.serviceIds.set(R,b),b}e.$1h=g;function I(R){return R}e.$2h=I}),define(Se[45],ke([1,0,18,2,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,g.$1h)("configurationService");function I(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}e.$vi=I;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}e.$wi=R;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$yi=y;function M(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$zi=M;function C(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let d=0;d<a.length;d++){const l=a[d];let c=r[l];switch(typeof c){case"undefined":c=r[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$Ai=C;function m(s,i){const n=i.split(".");v(s,n)}e.$Bi=m;function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete s[n])}}function k(s,i,n){function o(r,d){let l=r;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$Ci=k;function u(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Ff(s[o])&&D.$Ff(i[o])?u(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Di=u;function f(s){return s.replace(/[\[\]]/g,"")}e.$Ei=f}),define(Se[46],ke([1,0,11,13,237,5,197,8]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(H,U){if($.get(H)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(H,U)}e.$Wi=y;const M=Object.prototype.hasOwnProperty;var C;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),k=(0,R.localize)(1,null),u=(0,R.localize)(2,null),f=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new g.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),he=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Vi.getLexeme(ye),additionalInfo:he}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),A.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const ge=he.lexeme,_=ge.lastIndexOf("/"),ie=_===ge.length-1?void 0:this.w(ge.substring(_+1));let G;try{G=new RegExp(ge.substring(1,_),ie)}catch{throw this.B("REGEX",he)}return F.create(ne,G)}switch(he.type){case 10:case 19:{const ge=[he.lexeme];this.z();let _=this.D(),ie=0;for(let Ae=0;Ae<he.lexeme.length;Ae++)he.lexeme.charCodeAt(Ae)===40?ie++:he.lexeme.charCodeAt(Ae)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Ae=0;Ae<_.lexeme.length;Ae++)_.lexeme.charCodeAt(Ae)===40?ie++:he.lexeme.charCodeAt(Ae)===41&&ie--}if(ie<0)break;ge.push(g.$Vi.getLexeme(_)),this.z(),_=this.D()}const G=ge.join(""),te=G.lastIndexOf("/"),fe=te===G.length-1?void 0:this.w(G.substring(te+1));let we;try{we=new RegExp(G.substring(1,te),fe)}catch{throw this.B("REGEX",he)}return t.regex(ne,we)}case 18:{const ge=he.lexeme;this.z();let _=null;if(!(0,N.$Ge)(ge)){const ie=ge.indexOf("/"),G=ge.lastIndexOf("/");if(ie!==G&&ie>=0){const te=ge.slice(ie+1,G),fe=ge[G+1]==="i"?"i":"";try{_=new RegExp(te,fe)}catch{throw this.B("REGEX",he)}}}if(_===null)throw this.B("REGEX",he);return F.create(ne,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const he=this.u();return t.notIn(ne,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return t.equals(ne,he);switch(he){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return t.notEquals(ne,he);switch(he){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,he)}}case 5:return this.z(),j.create(ne,this.u());case 6:return this.z(),T.create(ne,this.u());case 7:return this.z(),O.create(ne,this.u());case 8:return this.z(),P.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,ye){const he=(0,R.localize)(8,null,U,g.$Vi.getLexeme(ne)),ge=ne.offset,_=g.$Vi.getLexeme(ne);return this.h.push({message:he,offset:ge,lexeme:_,additionalInfo:ye}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=a;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return S.create(U)}static equals(U,ne){return L.create(U,ne)}static notEquals(U,ne){return E.create(U,ne)}static regex(U,ne){return F.create(U,ne)}static in(U,ne){return w.create(U,ne)}static notIn(U,ne){return p.create(U,ne)}static not(U){return A.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return J.create(U,null,!0)}static greater(U,ne){return O.create(U,ne)}static greaterEquals(U,ne){return P.create(U,ne)}static smaller(U,ne){return j.create(U,ne)}static smallerEquals(U,ne){return T.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Yi=t;function r(H){const U=new a({regexParsingWithErrorRecovery:!1});return H.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$Zi=r;function d(H,U){const ne=H?H.substituteConstants():void 0,ye=U?U.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$1i=d;function l(H,U){return H.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$2i=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$3i=h;class S{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?h.INSTANCE:c.INSTANCE:new S(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$4i=S;class L{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?S.create(U,ye):A.create(U,ye);const he=$.get(U);return typeof he=="boolean"?ne===(he?"true":"false")?h.INSTANCE:c.INSTANCE:new L(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$5i=L;class w{static create(U,ne){return new w(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:se(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),ye=U.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?M.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$6i=w;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=w.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=p;class E{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?A.create(U,ye):S.create(U,ye);const he=$.get(U);return typeof he=="boolean"?ne===(he?"true":"false")?c.INSTANCE:h.INSTANCE:new E(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$8i=E;class A{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?c.INSTANCE:h.INSTANCE:new A(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$9i=A;function B(H,U){if(typeof H=="string"){const ne=parseFloat(H);isNaN(ne)||(H=ne)}return typeof H=="string"||typeof H=="number"?U(H):c.INSTANCE}class O{static create(U,ne,ye=null){return B(ne,he=>new O(U,he,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$0i=O;class P{static create(U,ne,ye=null){return B(ne,he=>new P(U,he,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$$i=P;class j{static create(U,ne,ye=null){return B(ne,he=>new j(U,he,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$_i=j;class T{static create(U,ne,ye=null){return B(ne,he=>new T(U,he,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:se(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$aj=T;class F{static create(U,ne){return new F(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return this.d===U.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$bj=F;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$cj=W;function X(H){let U=null;for(let ne=0,ye=H.length;ne<ye;ne++){const he=H[ne].substituteConstants();if(H[ne]!==he&&U===null){U=[];for(let ge=0;ge<ne;ge++)U[ge]=H[ge]}U!==null&&(U[ne]=he)}return U===null?H:U}class ce{static create(U,ne,ye){return ce.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const he=l(this.expr[ne],U.expr[ne]);if(he!==0)return he}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,ye){const he=[];let ge=!1;for(const _ of U)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return c.INSTANCE;if(_.type===6){he.push(..._.expr);continue}he.push(_)}if(he.length===0&&ge)return h.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(l);for(let _=1;_<he.length;_++)he[_-1].equals(he[_])&&(he.splice(_,1),_--);if(he.length===1)return he[0];for(;he.length>1;){const _=he[he.length-1];if(_.type!==9)break;he.pop();const ie=he.pop(),G=he.length===0,te=J.create(_.expr.map(fe=>ce.create([fe,ie],null,ye)),null,G);te&&(he.push(te),he.sort(l))}if(he.length===1)return he[0];if(ye){for(let _=0;_<he.length;_++)for(let ie=_+1;ie<he.length;ie++)if(he[_].negate().equals(he[ie]))return c.INSTANCE;if(he.length===1)return he[0]}return new ce(he,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ce(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=J.create(U,this,!0)}return this.c}}e.$dj=ce;class J{static create(U,ne,ye){return J.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const he=l(this.expr[ne],U.expr[ne]);if(he!==0)return he}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:J.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,ye){let he=[],ge=!1;if(U){for(let _=0,ie=U.length;_<ie;_++){const G=U[_];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){he=he.concat(G.expr);continue}he.push(G)}}if(he.length===0&&ge)return c.INSTANCE;he.sort(l)}if(he.length!==0){if(he.length===1)return he[0];for(let _=1;_<he.length;_++)he[_-1].equals(he[_])&&(he.splice(_,1),_--);if(he.length===1)return he[0];if(ye){for(let _=0;_<he.length;_++)for(let ie=_+1;ie<he.length;ie++)if(he[_].negate().equals(he[ie]))return h.INSTANCE;if(he.length===1)return he[0]}return new J(he,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new J(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),ye=U.shift(),he=[];for(const ge of de(ne))for(const _ of de(ye))he.push(ce.create([ge,_],null,!1));U.unshift(J.create(he,null,!1))}this.c=J.create(U,this,!0)}return this.c}}e.$ej=J;class Y extends S{static{this.d=[]}static all(){return Y.d.values()}constructor(U,ne,ye){super(U,null),this.f=ne,typeof ye=="object"?Y.d.push({...ye,key:U}):ye!==!0&&Y.d.push({key:U,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return L.create(this.key,U)}notEqualsTo(U){return E.create(this.key,U)}}e.$fj=Y,e.$gj=(0,I.$1h)("contextKeyService");function x(H,U){return H<U?-1:H>U?1:0}function se(H,U,ne,ye){return H<ne?-1:H>ne?1:U<ye?-1:U>ye?1:0}function Z(H,U){if(H.type===0||U.type===1)return!0;if(H.type===9)return U.type===9?ve(H.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(Z(H,ne))return!0;return!1}if(H.type===6){if(U.type===6)return ve(U.expr,H.expr);for(const ne of H.expr)if(Z(ne,U))return!0;return!1}return H.equals(U)}e.$hj=Z;function ve(H,U){let ne=0,ye=0;for(;ne<H.length&&ye<U.length;){const he=H[ne].cmp(U[ye]);if(he<0)return!1;he===0&&ne++,ye++}return ne===H.length}function de(H){return H.type===9?H.expr:[H]}}),define(Se[240],ke([1,0,23,39,199,5,102,11,24]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.ConfirmResult=e.$Rv=e.$Qv=e.$Pv=void 0,e.$Pv=(0,I.$1h)("dialogService");var y;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(y||(y={}));class M{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,s){const i=[];switch(s){case y.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===N.default.Info?"info":f===N.default.Error?"error":f===N.default.Warning?"warning":"none"}f(f,s,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Qv=M,e.$Rv=(0,I.$1h)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(u){const f=[];return f.push(...u.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$zg)(s))),u.length>m&&(u.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,u.length-m))),f.push(""),f.join(`
`)}e.$Sv=v;function k(u,f){const s=(0,$.$gn)(u);let i=(s.buttons??[]).map(t=>(0,R.$Mv)(t)),n=(u.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||f.nameLong,{options:s,buttonIndeces:n}}e.$Tv=k}),define(Se[133],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,D.$1h)("environmentService"),e.$9h=(0,D.$2h)(e.$8h)}),define(Se[134],ke([1,0,200,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$jo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0,e.$0n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$n=new RegExp(e.$0n),e.$_n="__web_extension",e.$ao="skipWalkthrough",e.$bo="extensionsSync",e.$co="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$do=g;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$eo=I;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$fo=R;function b(s,i){return i==="web"&&!s.includes("web")}e.$go=b;function $(s,i,n){return b(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$ho=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$io=y;var M;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$jo=(0,N.$1h)("extensionGalleryService");var k;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var u;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class f extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$ko=f,e.$lo=(0,N.$1h)("extensionManagementService"),e.$mo="extensionsIdentifiers/disabled",e.$no="extensionsIdentifiers/enabled",e.$oo=(0,N.$1h)("IGlobalExtensionEnablementService"),e.$po=(0,N.$1h)("IExtensionTipsService"),e.$qo=(0,D.localize)(0,null),e.$ro={value:e.$qo,original:"Extensions"},e.$so={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[241],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U1b=e.$T1b=void 0,e.$T1b=(0,D.$1h)("externalTerminal"),e.$U1b="Terminal.app"}),define(Se[242],ke([1,0,51,17,16,11,101,31,104,202,241]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=e.$P9b=void 0;const C=y.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends m{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(D,o,$.$Nl(),a)}spawnTerminal(o,a,t,r){const d=a.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const l=g.$nc(d,".exe").toLowerCase();if(l==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return d.indexOf(" ")>=0&&c.push('""'),c.push(d),l==="wt"&&c.push("-d ."),new Promise((h,S)=>{const L=f(process),w=o.spawn(t,c,{cwd:r,env:L});w.on("error",S),w.on("exit",()=>h())})}runInTerminal(o,a,t,r,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,h)=>{const S=`"${a} - ${C}"`,L=`""${t.join('" "')}" & pause"`,w=Object.assign({},f(process),r);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const p={cwd:a,env:w,windowsVerbatimArguments:!0};let E,A;g.$nc(l,".exe")==="wt"?(E=l,A=["-d",".",v.b,"/c",L]):(E=v.b,A=["/c","start",S,"/wait",l,"/c",L]),D.spawn(E,A,p).on("error",O=>{h(s(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$P9b=v;class k extends m{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,d){const l=d.osxExec||M.$U1b;return new Promise((c,h)=>{if(l===M.$U1b||l==="iTerm.app"){const S=l===M.$U1b?"TerminalHelper":"iTermHelper",w=[N.$jg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",o||C,"-w",a];for(const A of t)w.push("-a"),w.push(A);if(r){const A=Object.assign({},f(process),r);for(const B in A){const O=A[B];O===null?(w.push("-u"),w.push(B)):(w.push("-e"),w.push(`${B}=${O}`))}}let p="";const E=D.spawn(k.b,w);E.on("error",A=>{h(s(A))}),E.stderr.on("data",A=>{p+=A.toString()}),E.on("exit",A=>{if(A===0)c(void 0);else if(p){const B=p.split(`
`,1);h(new Error(B[0]))}else h(new Error(y.localize(1,null,S,A)))})}else h(new Error(y.localize(2,null,l)))})}spawnTerminal(o,a,t){const r=a.osxExec||M.$U1b;return new Promise((d,l)=>{const c=["-a",r];t&&c.push(t);const h=f(process),S=o.spawn("/usr/bin/open",c,{cwd:t,env:h});S.on("error",l),S.on("exit",()=>d())})}}e.$Q9b=k;class u extends m{static{this.b=y.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{const S=[];l.then(L=>{L.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const w=`${i(t)}; echo; read -p "${u.b}" -n1;`;S.push(`''${w}''`);const p=Object.assign({},f(process),r);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const E={cwd:a,env:p};let A="";const B=D.spawn(L,S,E);B.on("error",O=>{h(s(O))}),B.stderr.on("data",O=>{A+=O.toString()}),B.on("exit",O=>{if(O===0)c(void 0);else if(A){const P=A.split(`
`,1);h(new Error(P[0]))}else h(new Error(y.localize(4,null,L,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!u.d)if(!I.$k)u.d=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");u.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return u.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{r.then(c=>{const h=f(process),S=o.spawn(c,[],{cwd:t,env:h});S.on("error",l),S.on("exit",()=>d())})})}}e.$R9b=u;function f(n){const o={...n.env};return(0,R.$Ll)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(Se[32],ke([1,0,77,16,13,18,2,203,5,11,17,43]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileKind=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileOperationResult=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileChangeType=e.$Ck=e.FileOperation=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileSystemProviderErrorCode=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderCapabilities=e.$mk=e.FilePermission=e.FileType=e.$lk=e.$kk=void 0,e.$kk=(0,$.$1h)("fileService");function m(Z){return Z.create===!0}e.$lk=m;var v;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var k;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function u(Z){const ve=Z;return!!ve&&typeof ve.onDidChange=="function"}e.$mk=u;var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function s(Z){return!!(Z.capabilities&2)}e.$nk=s;function i(Z){return!!(Z.capabilities&8)}e.$ok=i;function n(Z){return!!(Z.capabilities&131072)}e.$pk=n;function o(Z){return!!(Z.capabilities&4)}e.$qk=o;function a(Z){return!!(Z.capabilities&16)}e.$rk=a;function t(Z){return s(Z)?!!(Z.capabilities&16384):!1}e.$sk=t;function r(Z){return s(Z)?!!(Z.capabilities&32768):!1}e.$tk=r;function d(Z){return!!(Z.capabilities&65536)}e.$uk=d;function l(Z){return!!(Z.capabilities&2048)}e.$vk=l;var c;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(ve,de){const H=new h(ve.toString(),de);return w(H,de),H}constructor(ve,de){super(ve),this.code=de}}e.$wk=h;function S(Z,ve){return h.create(Z,ve)}e.$xk=S;function L(Z){return Z||S((0,b.localize)(0,null),c.Unknown)}e.$yk=L;function w(Z,ve){return Z.name=ve?`${ve} (FileSystemError)`:"FileSystemError",Z}e.$zk=w;function p(Z){if(!Z)return c.Unknown;if(Z instanceof h)return Z.code;const ve=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ve)return c.Unknown;switch(ve[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$Ak=p;function E(Z){if(Z instanceof T)return Z.fileOperationResult;switch(p(Z)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$Bk=E;var A;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class B{constructor(ve,de,H){this.resource=ve,this.operation=de,this.target=H}isOperation(ve){return this.operation===ve}}e.$Ck=B;var O;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class P{static{this.a=null}constructor(ve,de){this.c=de,this.b=void 0,this.d=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawAdded.map(U=>[U,!0])),H}),this.f=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawUpdated.map(U=>[U,!0])),H}),this.g=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawDeleted.map(U=>[U,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ve){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==P.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=P.a):this.b!==void 0&&(this.b=P.a))}}contains(ve,...de){return this.h(ve,{includeChildren:!1},...de)}affects(ve,...de){return this.h(ve,{includeChildren:!0},...de)}h(ve,de,...H){if(!ve)return!1;const U=H.length>0;return!!((!U||H.includes(1))&&(this.d.value.get(ve)||de.includeChildren&&this.d.value.findSuperstr(ve))||(!U||H.includes(0))&&(this.f.value.get(ve)||de.includeChildren&&this.f.value.findSuperstr(ve))||(!U||H.includes(2))&&(this.g.value.findSubstr(ve)||de.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$Dk=P;function j(Z,ve,de){return!Z||!ve||Z===ve||ve.length>Z.length?!1:(ve.charAt(ve.length-1)!==N.sep&&(ve+=N.sep),de?(0,g.$8e)(Z,ve):Z.indexOf(ve)===0)}e.$Ek=j;class T extends Error{constructor(ve,de,H){super(ve),this.fileOperationResult=de,this.options=H}}e.$Fk=T;class F extends T{constructor(ve,de,H,U){super(ve,de,U),this.fileOperationResult=de,this.size=H}}e.$Gk=F;class W extends T{constructor(ve,de,H){super(ve,2,H),this.stat=de}}e.$Hk=W;var X;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Ik={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Jk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Kk="files.associations",e.$Lk="files.exclude",e.$Mk="files.readonlyInclude",e.$Nk="files.readonlyExclude",e.$Ok="files.readonlyFromPermissions";var ce;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Pk="";function J(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Qk=J;async function Y(Z,ve){if(!ve.hasProvider(R.URI.from({scheme:Z.scheme})))return new Promise(de=>{const H=ve.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Z.scheme&&U.added&&(H.dispose(),de())})})}e.$Rk=Y;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(ve){return(0,I.$Hf)(ve)||(ve=0),ve<x.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<x.MB?(0,b.localize)(2,null,(ve/x.KB).toFixed(2)):ve<x.GB?(0,b.localize)(3,null,(ve/x.MB).toFixed(2)):ve<x.TB?(0,b.localize)(4,null,(ve/x.GB).toFixed(2)):(0,b.localize)(5,null,(ve/x.TB).toFixed(2))}}e.$Sk=x;function se(Z){const ve=typeof Z=="string"||Z?.scheme===M.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===M.Schemas.file?1024*x.MB:ve?10*x.MB:y.$o?50*x.MB:1024*x.MB}e.$Tk=se}),define(Se[243],ke([1,0,22,8,204,32]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;async function R(M,C,m,v,k,u){let f;try{await b(M,C,m,v,k,u)}catch(s){f=s}finally{f&&k.errorTransformer&&(f=k.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$Yp=R;async function b(M,C,m,v,k,u){$(u);const f=await M.open(C,{create:!1});try{$(u);let s=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),a=k&&typeof k.position=="number"?k.position:0,t=0;do i=await M.read(f,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(v(o)),o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(u)&&y(s,k));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(v(o.slice(0,r)))}}catch(s){throw(0,I.$yk)(s)}finally{await M.close(f)}}function $(M){if(M.isCancellationRequested)throw(0,N.$6)();return!0}function y(M,C){if(typeof C?.limits?.size=="number"&&M>C.limits.size)throw(0,I.$xk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],ke([1,0,34,3,16,11,2,32]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=void 0;function $(s){return s.recursive===!0}e.$1p=$;class y extends N.$Sc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new N.$Tc),this.f=void 0,this.g=0}s(){const i=new N.$Rc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$2p=y;class M extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$3p=M;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$4p=C;function m(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$5p=m;function v(s){const i=new f;for(const n of s)i.processEvent(n);return i.coalesce()}e.$6p=v;function k(s,i){return typeof i=="string"&&!i.startsWith(D.$Dj)&&!(0,g.$ic)(i)?{base:s,pattern:i}:i}e.$7p=k;function u(s,i){const n=[];for(const o of i)n.push((0,D.$Hj)(k(s,o)));return n}e.$8p=u;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,b.$Ek)(o.resource.fsPath,a,!I.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(Se[244],ke([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;class u extends R.$Sc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new N.$dh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$ch(t=>this.z(t),u.b)),this.g=(0,k.$8p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$8p)(this.m.path,this.m.includes):void 0,this.j=new g.$3d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$fq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,I.$3f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Sc.None;const o=new g.$3d(this.j.token),a=new R.$Rc;try{const t=C.URI.file(this.m.path),r=(0,$.$nc)(i),d=(0,D.watch)(i);a.add((0,R.$Qc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const l=new Set;if(n)try{for(const h of await v.Promises.readdir(i))l.add(h)}catch(h){this.D(h)}const c=new Map;a.add((0,R.$Qc)(()=>{for(const[,h]of c)h.dispose();c.clear()})),d.on("error",(h,S)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${S})`),this.dispose()}),d.on("change",(h,S)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${S}`);let L="";if(S&&(L=S.toString(),y.$j&&(L=(0,b.$Al)(L))),!(!L||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){c.get(L)?.dispose();const w=setTimeout(async()=>{if(c.delete(L),L===r&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,$.$jc)(i,L));if(o.token.isCancellationRequested)return;let E;p?l.has(L)?E=0:(E=1,l.add(L)):(l.delete(L),E=2),this.y({resource:(0,M.$Cg)(t,L),type:E,cId:this.m.correlationId})},u.a);c.set(L,(0,R.$Qc)(()=>clearTimeout(w)))}else{let w;l.has(L)?w=0:(w=1,l.add(L)),this.y({resource:(0,M.$Cg)(t,L),type:w,cId:this.m.correlationId})}else if(h==="rename"||L!==r){const w=setTimeout(async()=>{const p=await v.Promises.exists(i);o.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);a.clear(),a.add((0,R.$Qc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Qc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$6p)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await v.Promises.readdir((0,$.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$iq=u;async function f(s,i,n,o,a=512){const t=await v.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),d=new g.$3d(o);let l,c=!1;const h={path:s,excludes:[],recursive:!1},S=new u(h,L=>{(async()=>{for(const{type:w}of L)if(w===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,r,0,a,null);if(!p||d.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){l=new Error(p),d.dispose(!0)}finally{c=!1}}})()});return await S.ready,n(),new Promise((L,w)=>{d.token.onCancellationRequested(async()=>{S.dispose();try{await v.Promises.close(t)}catch(p){l=new Error(p)}l?w(l):L()})})}e.$jq=f}),define(Se[245],ke([1,0,4,34,3,11,244]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class b extends g.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const M=this.j(y),C=M.filter(v=>{const k=this.c.get(v.path);return k?!(0,N.$Lj)(k.request.excludes,v.excludes)||!(0,N.$Lj)(k.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!M.find(k=>k.path===v.path&&(0,N.$Lj)(k.excludes,v.excludes)&&(0,N.$Lj)(k.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const M=new R.$iq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:M};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const M=this.c.get(y);M&&(this.c.delete(y),M.instance.dispose())}j(y){const M=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let v=M.get(C.correlationId);v||(v=new Map,M.set(C.correlationId,v)),v.set(m,C)}return Array.from(M.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,M]of this.c)M.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,M){return M?`[File Watcher (node.js)] ${y} (path: ${M.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$kq=b}),define(Se[246],ke([1,0,84,245]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class g extends D.$3p{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new N.$kq)}}e.$lq=g}),define(Se[247],ke([1,0,17,81,187,84]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class R extends I.$4p{constructor($,y,M){super($,y,M),this.s()}r($){const y=$.add(new g.$cq(D.$jg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:M,signal:C})=>this.t(`terminated by itself with code ${M}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Hh)(y.getChannel("watcher")))}}e.$dq=R}),define(Se[107],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class D{constructor(...g){this.a=new Map;for(const[I,R]of g)this.set(I,R)}set(g,I){const R=this.a.get(g);return this.a.set(g,I),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Yh=D}),define(Se[248],ke([1,0,12,8,3,105,239,5,107,75]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;const M=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$Yh,s=!1,i,n=M){this.f=f,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Zh,this),this._globalGraph=n?i?._globalGraph??new R.$oq(o=>o):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...s){const i=k.traceInvocation(this.i,f);let n=!1;try{return f({get:a=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(f,...s){let i,n;return f instanceof I.$Xh?(i=k.traceCreation(this.i,f.ctor),n=this.j(f.ctor,f.staticArguments.concat(s),i)):(i=k.traceCreation(this.i,f),n=this.j(f,s,i)),i.stop(),n}j(f,s=[],i){const n=b._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${f.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(f,s.concat(o))}k(f,s){if(this.f.get(f)instanceof I.$Xh)this.f.set(f,s);else if(this.h)this.h.k(f,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const s=this.f.get(f);return!s&&this.h?this.h.l(f):s}m(f,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$Xh?this.q(f,i,s.branch(f,!0)):(s.branch(f,!1),i)}q(f,s,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,s,i)}finally{this.o.delete(f)}}r(f,s,i){const n=new R.$oq(t=>t.id.toString());let o=0;const a=[{id:f,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof I.$Xh){const l={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,l),a.push(l)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.$Xh){const l=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,l)}n.removeNode(r)}}return this.l(f)}s(f,s,i=[],n,o){if(this.f.get(f)instanceof I.$Xh)return this.t(f,s,i,n,o);if(this.h)return this.h.s(f,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(f,s,i=[],n,o){if(n){const a=new m(void 0,this.g,this,this.i);a.c=String(f);const t=new Map,r=new D.$hh(()=>{const d=a.j(s,i,o);for(const[l,c]of t){const h=d[l];if(typeof h=="function")for(const S of c)h.apply(d,S)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!r.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let S=t.get(l);return S||(S=new y.$3c,t.set(l,S)),(w,p,E)=>{const A=S.push([w,p,E]);return(0,g.$Qc)(A)}}if(l in d)return d[l];const c=r.value;let h=c[l];return typeof h!="function"||(h=h.bind(c),d[l]=h),h},set(d,l,c){return r.value[l]=c,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(f,s){if(s&&console.warn(f),this.g)throw new Error(f)}}e.$pq=m;var v;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(v||(v={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,s){return f?new k(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(f,s){return f?new k(1,s.name):k.c}static{this.f=0}constructor(f,s){this.type=f,this.name=s,this.g=Date.now(),this.h=[]}branch(f,s){const i=new k(3,f.toString());return this.h.push([f,s,i]),i}stop(){const f=Date.now()-this.g;k.f+=f;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[d,l,c]of a.h)if(l&&c){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,c);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(f>2||s)&&k.all.add(n.join(`
`))}}e.$qq=k}),define(Se[14],ke([1,0,44,4,53,3,28,11,23,18,2,46,5]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,m.$1h)("logService"),e.$jj=(0,m.$1h)("loggerService");function v(){return new Date().toISOString()}function k(w){return(0,y.$Hf)(w)}e.$kj=k;var u;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$lj=u.Info;function f(w,p,E){switch(p){case u.Trace:w.trace(E);break;case u.Debug:w.debug(E);break;case u.Info:w.info(E);break;case u.Warning:w.warn(E);break;case u.Error:w.error(E);break;case u.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=f;function s(w,p=!1){let E="";for(let A=0;A<w.length;A++){let B=w[A];if(B instanceof Error&&(B=(0,D.$Li)(B,p)),typeof B=="object")try{B=JSON.stringify(B)}catch{}E+=(A>0?" ":"")+B}return E}class i extends I.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new N.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==u.Off&&this.b<=p}}e.$nj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...E){this.f(u.Trace)&&this.g(u.Trace,s([p,...E],!0))}debug(p,...E){this.f(u.Debug)&&this.g(u.Debug,s([p,...E]))}info(p,...E){this.f(u.Info)&&this.g(u.Info,s([p,...E]))}warn(p,...E){this.f(u.Warning)&&this.g(u.Warning,s([p,...E]))}error(p,...E){if(this.f(u.Error))if(p instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=p.stack,this.g(u.Error,s(A))}else this.g(u.Error,s([p,...E]))}flush(){}}e.$oj=n;class o extends i{constructor(p=e.$lj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...E){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}debug(p,...E){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}info(p,...E){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}warn(p,...E){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...E):console.warn(`[main ${v()}]`,p,...E))}error(p,...E){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...E):console.error(`[main ${v()}]`,p,...E))}dispose(){}flush(){}}e.$pj=o;class a extends i{constructor(p=e.$lj,E=!0){super(),this.g=E,this.setLevel(p)}trace(p,...E){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...E):console.log(p,...E))}debug(p,...E){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...E):console.log(p,...E))}info(p,...E){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...E):console.log(p,...E))}warn(p,...E){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...E):console.log(p,...E))}error(p,...E){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...E):console.error(p,...E))}dispose(){}flush(){}}e.$qj=a;class t extends i{constructor(p,E=e.$lj){super(),this.g=p,this.setLevel(E)}trace(p,...E){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(p),...E])}debug(p,...E){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(p),...E])}info(p,...E){this.f(u.Info)&&this.g.log(u.Info,[this.h(p),...E])}warn(p,...E){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(p),...E])}error(p,...E){this.f(u.Error)&&this.g.log(u.Error,[this.h(p),...E])}h(p){return typeof p=="string"?p:(0,D.$Li)(p,this.f(u.Trace))}dispose(){}flush(){}}e.$rj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const E of this.g)E.setLevel(p);super.setLevel(p)}trace(p,...E){for(const A of this.g)A.trace(p,...E)}debug(p,...E){for(const A of this.g)A.debug(p,...E)}info(p,...E){for(const A of this.g)A.info(p,...E)}warn(p,...E){for(const A of this.g)A.warn(p,...E)}error(p,...E){for(const A of this.g)A.error(p,...E)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$sj=r;class d extends I.$Sc{constructor(p,E,A){if(super(),this.h=p,this.j=E,this.b=new R.$Ac,this.c=this.B(new N.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeVisibility=this.g.event,A)for(const B of A)this.b.set(B.resource,{logger:void 0,info:B})}m(p){return(0,y.$Df)(p)?[...this.b.values()].find(E=>E.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,E){const A=this.n(p),B=(0,y.$Df)(p)?p:E?.id??(0,g.$Oi)(A.toString()).toString(16);let O=this.b.get(A)?.logger;const P=E?.logLevel==="always"?u.Trace:E?.logLevel;O||(O=this.s(A,P??this.getLogLevel(A)??this.h,{...E,id:B}));const j={logger:O,info:{resource:A,id:B,logLevel:P,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(A,j),O}n(p){return(0,y.$Df)(p)?(0,$.$Cg)(this.j,`${p}.log`):p}setLogLevel(p,E){if(M.URI.isUri(p)){const A=p,B=E,O=this.b.get(A);O&&B!==O.info.logLevel&&(O.info.logLevel=B===this.h?void 0:B,O.logger?.setLevel(B),this.b.set(O.info.resource,O),this.f.fire([A,B]))}else{this.h=p;for(const[A,B]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,E){const A=this.m(p);A&&E!==!A.info.hidden&&(A.info.hidden=!E,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,E]))}getLogLevel(p){let E;return p&&(E=this.b.get(p)?.info.logLevel),E??this.h}registerLogger(p){const E=this.b.get(p.resource);E?E.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const E=this.b.get(p);E&&(E.logger&&E.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=d;class l{constructor(){this.onDidChangeLogLevel=new N.$Sd().event}setLevel(p){}getLevel(){return u.Info}trace(p,...E){}debug(p,...E){}info(p,...E){}warn(p,...E){}error(p,...E){}critical(p,...E){}dispose(){}flush(){}}e.$uj=l;class c extends l{}e.$vj=c;function h(w){if(w.verbose)return u.Trace;if(typeof w.logLevel=="string"){const p=L(w.logLevel.toLowerCase());if(p!==void 0)return p}return e.$lj}e.$wj=h;function S(w){switch(w){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$xj=S;function L(w){switch(w){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$yj=L,e.$zj=new C.$fj("logLevel",S(u.Info))}),define(Se[249],ke([1,0,19,12,8,4,3,16,84,14]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class M extends R.$Sc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new I.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Yg(0)),this.w=[],this.y=this.B(new N.$Yg(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},u=(0,D.$Ub)(this.j,k);return this.r(),(0,R.$Qc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$5p)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$1p)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$1p)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},u=(0,D.$Ub)(this.w,k);return this.C(),(0,R.$Qc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$5p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$9p=M}),define(Se[250],ke([1,0,55,387,12,28,22,4,33,3,16,11,23,98,31,205,32,243,249,44,247,246]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Li)(r)}`)}})();class t extends i.$9p{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(c=>m.$tg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:c}=await k.SymlinkSupport.stat(this.H(d));return{type:this.M(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:f.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await k.Promises.readdir(this.H(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let S;h.isSymbolicLink()?S=(await this.stat((0,m.$Cg)(d,h.name))).type:S=this.M(h),c.push([h.name,S])}catch(S){this.a.trace(S)}})),c}catch(l){throw this.fb(l)}}M(d,l){let c;return l?.dangling?c=f.FileType.Unknown:d.isFile()?c=f.FileType.File:d.isDirectory()?c=f.FileType.Directory:c=f.FileType.Unknown,l&&(c|=f.FileType.SymbolicLink),c}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new g.$Zg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,y.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),c=await this.O(d));const h=this.H(d);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{c?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,v.$7d)(S=>R.$ge.concat(S.map(L=>R.$ge.wrap(L))).buffer);return(0,s.$Yp)(this,d,h,S=>S.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,m.$Cg)((0,m.$Bg)(d),`${(0,m.$zg)(d)}${c.atomic.postfix}`),l,c):this.S(d,l,c)}async Q(d){try{const l=this.H(d),{symbolicLink:c}=await k.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async R(d,l,c,h){const S=new y.$Rc;try{S.add(await this.O(d)),S.add(await this.O(l)),await this.S(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(L){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{S.dispose()}}async S(d,l,c,h){let S;try{const L=this.H(d);if(!c.create||!c.overwrite){if(await k.Promises.exists(L)){if(!c.overwrite)throw(0,f.$xk)((0,u.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,f.$xk)((0,u.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(S,0,l,0,l.byteLength)}catch(L){throw await this.gb(d,L)}finally{typeof S=="number"&&await this.close(S)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,c){const h=this.H(d);let S;(0,f.$lk)(l)&&!c&&(S=await this.O(d));let L;try{if((0,f.$lk)(l)&&l.unlock)try{const{stat:p}=await k.SymlinkSupport.stat(h);p.mode&128||await k.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let w;if((0,f.$lk)(l)){if(C.$i)try{await k.Promises.truncate(h,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}w||(w="w")}else w="r";L=await k.Promises.open(h,w)}catch(w){throw S?.dispose(),(0,f.$lk)(l)?await this.gb(d,w):this.fb(w)}if(this.U.set(L,0),(0,f.$lk)(l)&&this.X.set(L,d),S){const w=this.W.get(L);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${h})`),this.W.set(L,S),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${h})`),w.dispose())}return L}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await k.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await k.Promises.close(d)}catch(c){throw this.fb(c)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,S){const L=this.Z(d,l);let w=null;try{w=(await k.Promises.read(d,c,h,S,L)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,L,w)}return w}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,c){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.U.set(d,h+c):this.U.delete(d)))}async write(d,l,c,h,S){return(0,g.$ih)(()=>this.ab(d,l,c,h,S),100,3)}async ab(d,l,c,h,S){const L=this.Z(d,l);let w=null;try{w=(await k.Promises.write(d,c,h,S,L)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,L,w)}return w}async mkdir(d){try{await k.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const c=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,M.$jc)((0,M.$mc)(c),`${(0,M.$nc)(c)}${l.atomic.postfix}`)),await k.Promises.rm(c,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let S=!1;try{const{stat:L,symbolicLink:w}=await k.SymlinkSupport.stat(c);S=L.isDirectory()&&!w}catch{}if(S)await k.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.fb(c)}}async rename(d,l,c){const h=this.H(d),S=this.H(l);if(h!==S)try{await this.bb(d,l,"move",c.overwrite),await k.Promises.rename(h,S)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,u.localize)(2,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(S)),L.toString()))),this.fb(L)}}async copy(d,l,c){const h=this.H(d),S=this.H(l);if(h!==S)try{await this.bb(d,l,"copy",c.overwrite),await k.Promises.copy(h,S,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,u.localize)(3,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(S)),L.toString()))),this.fb(L)}}async bb(d,l,c,h){const S=this.H(d),L=this.H(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$2f)(S,L,!0)),w){if(c==="copy")throw(0,f.$xk)((0,u.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const E=await this.L(d);if(!E)throw(0,f.$xk)((0,u.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(l);if(A){if(!h)throw(0,f.$xk)((0,u.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&A.type&f.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,c){const h=this.H(d),S=this.H(l),L=!!(this.capabilities&1024);if((0,$.$2f)(h,S,!L))return;const w=new y.$Rc;try{w.add(await this.O(d)),w.add(await this.O(l)),c&&await k.Promises.mkdir((0,M.$mc)(S),{recursive:!0}),await k.Promises.copyFile(h,S)}catch(p){if(p.code==="ENOENT"&&!c)return this.cb(d,l,!0);throw this.fb(p)}finally{w.dispose()}}t(d,l,c){return new o.$dq(h=>d(h),h=>l(h),c)}F(d,l,c){return new a.$lq(h=>d(h),h=>l(h),c)}fb(d){if(d instanceof f.$wk)return d;let l=d,c;switch(d.code){case"ENOENT":c=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=f.FileSystemProviderErrorCode.Unknown;break;default:c=f.FileSystemProviderErrorCode.Unknown}return(0,f.$xk)(l,c)}async gb(d,l){let c=this.fb(l);if(d&&c.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(d));h.mode&128||(c=(0,f.$xk)(l,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$mq=t}),define(Se[251],ke([1,0,3,14]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;class g extends D.$Sc{constructor(R,b=[]){super(),this.a=new N.$sj([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$_N=g}),define(Se[252],ke([1,0,32,14]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,M,C,m,v){try{const k=await new Promise((f,s)=>{me(["@vscode/spdlog"],f,s)});k.setFlushOn(g.Trace);const u=await k.createAsyncRotatingLogger(y,M,C,m);return v?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(k){console.error(k)}return null}function R(y,M,C){switch(M){case N.LogLevel.Trace:y.trace(C);break;case N.LogLevel.Debug:y.debug(C);break;case N.LogLevel.Info:y.info(C);break;case N.LogLevel.Warning:y.warn(C);break;case N.LogLevel.Error:y.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function b(y,M){switch(M){case N.LogLevel.Trace:y.setLevel(g.Trace);break;case N.LogLevel.Debug:y.setLevel(g.Debug);break;case N.LogLevel.Info:y.setLevel(g.Info);break;case N.LogLevel.Warning:y.setLevel(g.Warning);break;case N.LogLevel.Error:y.setLevel(g.Error);break;case N.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class $ extends N.$oj{constructor(M,C,m,v,k){super(),this.m=[],this.setLevel(k),this.n=this.s(M,C,m,v),this.B(this.onDidChangeLogLevel(u=>{this.r&&b(this.r,u)}))}async s(M,C,m,v){const k=m?6:1,u=30/k*D.$Sk.MB,f=await I(M,C,u,k,v);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(M,C){this.r?R(this.r,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$1N=$}),define(Se[135],ke([1,0,39,206,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(k,u){return u-k}$.compare=y;const M=Object.create(null);M[$.Error]=(0,N.localize)(0,null),M[$.Warning]=(0,N.localize)(1,null),M[$.Info]=(0,N.localize)(2,null);function C(k){return M[k]||""}$.toString=C;function m(k){switch(k){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(k){switch(k){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(R||(e.MarkerSeverity=R={}));var b;(function($){const y="";function M(m){return C(m,!0)}$.makeKey=M;function C(m,v){const k=[y];return m.source?k.push(m.source.replace("\xA6","\\\xA6")):k.push(y),m.code?typeof m.code=="string"?k.push(m.code.replace("\xA6","\\\xA6")):k.push(m.code.value.replace("\xA6","\\\xA6")):k.push(y),m.severity!==void 0&&m.severity!==null?k.push(R.toString(m.severity)):k.push(y),m.message&&v?k.push(m.message.replace("\xA6","\\\xA6")):k.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?k.push(m.startLineNumber.toString()):k.push(y),m.startColumn!==void 0&&m.startColumn!==null?k.push(m.startColumn.toString()):k.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?k.push(m.endLineNumber.toString()):k.push(y),m.endColumn!==void 0&&m.endColumn!==null?k.push(m.endColumn.toString()):k.push(y),k.push(y),k.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$lt=(0,g.$1h)("markerService")}),define(Se[253],ke([1,0,4,39,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$av=e.Severity=void 0,e.Severity=N.default,e.$av=(0,g.$1h)("notificationService");var I;(function(M){M[M.DEFAULT=0]="DEFAULT",M[M.SILENT=1]="SILENT",M[M.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var R;(function(M){M[M.WORKSPACE=0]="WORKSPACE",M[M.PROFILE=1]="PROFILE",M[M.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var b;(function(M){M[M.OFF=0]="OFF",M[M.SILENT=1]="SILENT",M[M.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$bv=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$cv=y}),define(Se[254],ke([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)N=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:I.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Se[136],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,D.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,N){e(D,N,me)}};define(Se[85],ke([1,0,12,21,3,5]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProgressLocation=e.$dv=void 0,e.$dv=(0,I.$1h)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$ev=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$fv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$gv=$;let y=class extends g.$Sc{constructor(m,v){super(),this.a=new D.$lh,v.withProgress(m,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,g.$Qc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$hv=y,e.$hv=y=Je([We(1,e.$dv)],y);class M extends g.$Sc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Rc)}start(m){this.stop();const v=++this.a,k=new N.$3d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Qc)(()=>k.cancel())),this.b.add((0,g.$Qc)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$iv=M,e.$jv=(0,I.$1h)("editorProgressService")}),define(Se[37],ke([1,0,60,18]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;class g{constructor(){this.a=new Map}add(R,b){D.ok(N.$Df(R)),D.ok(N.$Ff(b)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$sn=new g}),define(Se[108],ke([1,0,4,37]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0,e.$tn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;N.$sn.add(e.$tn.JSONContribution,R)}),define(Se[86],ke([1,0,19,4,18,196,45,108,37]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.ConfigurationScope=e.$xn=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$xn={Configuration:"base.contributions.configuration"};var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En="vscode://schemas/settings/resourceLanguage",e.$Fn="vscode://schemas/settings/configurationDefaults";const C=$.$sn.as(b.$tn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$Sd,this.onDidSchemaChange=this.i.event,this.j=new N.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$En,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),C.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),C.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(r.add(h),e.$Hn.test(h)){const S=this.a.get(h),L=S?.valuesSources??new Map;if(c)for(const A of Object.keys(l[h]))L.set(A,c);const w={...S?.value||{},...l[h]};this.a.set(h,{source:c,value:w,valuesSources:L});const p=(0,R.$Ei)(h),E={type:"object",default:w,description:I.localize(1,null,p),$ref:e.$En,defaultDefaultValue:w,source:g.$Df(c)?void 0:c,defaultValueSource:c};d.push(...u(h)),this.d[h]=E,this.b.properties[h]=E}else{this.a.set(h,{value:l[h],source:c});const S=this.d[h];S&&(this.w(h,S),this.r(h,S))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),S=g.$Df(l)?l:l?.id,L=g.$Df(h?.source)?h?.source:h?.source?.id;if(S===L)if(r.add(c),this.a.delete(c),e.$Hn.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(l=>{this.p(l,r,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,r){const d=l=>{if(l.properties)for(const c in l.properties){r.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,d,l,c=3,h){c=g.$Mf(t.scope)?c:t.scope;const S=t.properties;if(S)for(const w in S){const p=S[w];if(r&&n(w,p)){delete S[w];continue}if(p.source=d,p.defaultDefaultValue=S[w].default,this.w(w,p),e.$Hn.test(w)?p.scope=void 0:(p.scope=g.$Mf(p.scope)?c:p.scope,p.restricted=g.$Mf(p.restricted)?!!l?.includes(w):p.restricted),S[w].hasOwnProperty("included")&&!S[w].included){this.f[w]=S[w],delete S[w];continue}else this.d[w]=S[w],S[w].policy?.name&&this.e.set(S[w].policy.name,w);!S[w].deprecationMessage&&S[w].markdownDeprecationMessage&&(S[w].deprecationMessage=S[w].markdownDeprecationMessage),h.add(w)}const L=t.allOf;if(L)for(const w of L)this.p(w,r,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$yn.properties[t]=r,r.scope){case 1:e.$zn.properties[t]=r;break;case 2:e.$An.properties[t]=r;break;case 6:e.$Bn.properties[t]=r;break;case 3:e.$Cn.properties[t]=r;break;case 4:e.$Dn.properties[t]=r;break;case 5:e.$Dn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$yn.properties[t],r.scope){case 1:delete e.$zn.properties[t];break;case 2:delete e.$An.properties[t];break;case 6:delete e.$Bn.properties[t];break;case 3:delete e.$Cn.properties[t];break;case 4:case 5:delete e.$Dn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$En};this.w(r,d),e.$yn.properties[r]=d,e.$zn.properties[r]=d,e.$An.properties[r]=d,e.$Bn.properties[r]=d,e.$Cn.properties[r]=d,e.$Dn.properties[r]=d}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$En};e.$yn.patternProperties[e.$Gn]=t,e.$zn.patternProperties[e.$Gn]=t,e.$An.patternProperties[e.$Gn]=t,e.$Bn.patternProperties[e.$Gn]=t,e.$Cn.patternProperties[e.$Gn]=t,e.$Dn.patternProperties[e.$Gn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let l=d?.value,c=d?.source;g.$Kf(l)&&(l=r.defaultDefaultValue,c=void 0),g.$Kf(l)&&(l=s(r.type)),r.default=l,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",k=new RegExp(v,"g");e.$Gn=`^(${v})+$`,e.$Hn=new RegExp(e.$Gn);function u(a){const t=[];if(e.$Hn.test(a)){let r=k.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=k.exec(a)}}return(0,D.$Mb)(t)}e.$In=u;function f(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Jn=f;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Kn=s;const i=new m;$.$sn.add(e.$xn.Configuration,i);function n(a,t){return a.trim()?e.$Hn.test(a)?I.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?I.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$Ln=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Mn=o}),define(Se[255],ke([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0;function v(r){return Object.isFrozen(r)?r:b.$hn(r)}class k{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof k)return l;const c=new u("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,M.$Ci)(this.contents,d):this.contents}inspect(d,l){const c=this.rawConfiguration.getValue(d),h=l?this.rawConfiguration.getOverrideValue(d,l):void 0,S=l?this.rawConfiguration.override(l).getValue(d):c;return{value:c,override:h,merged:S}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,M.$Ci)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return D.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return D.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$gn(this.contents),c=b.$gn(this.overrides),h=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of d)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(l,L.contents);for(const w of L.overrides){const[p]=c.filter(E=>D.$ub(E.identifiers,w.identifiers));p?(this.h(p.contents,w.contents),p.keys.push(...w.keys),p.keys=D.$Mb(p.keys)):c.push(b.$gn(w))}for(const w of L.keys)h.indexOf(w)===-1&&h.push(w)}return new k(l,h,c,S.every(L=>L instanceof k)?void 0:S)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of D.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let S=this.contents[h];const L=l[h];L&&(typeof S=="object"&&typeof L=="object"?(S=b.$gn(S),this.h(S,L)):S=L),c[h]=S}return new k(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&$.$Ff(d[c])&&$.$Ff(l[c])){this.h(d[c],l[c]);continue}d[c]=b.$gn(l[c])}}i(d){let l=null,c=null;const h=S=>{S&&(c?this.h(c,S):c=b.$gn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===d?l=S.contents:S.identifiers.includes(d)&&h(S.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,M.$Bi)(this.contents,d),C.$Hn.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>D.$ub(c.identifiers,(0,C.$In)(d))),1))}j(d,l,c){(0,M.$Ai)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),C.$Hn.test(d)&&this.overrides.push({identifiers:(0,C.$In)(d),keys:Object.keys(this.contents[d]),contents:(0,M.$zi)(this.contents[d],h=>console.error(h))})}}e.$Nn=k;class u{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!$.$Mf(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:S,restricted:L,hasExcludedProperties:w}=this.h(d,l);this.b=new k(c,h,S,w?[d]:void 0),this.c=L||[]}g(d){let l={},c=null,h=[];const S=[],L=[];function w(E){Array.isArray(h)?h.push(E):c!==null&&(h[c]=E)}const p={onObjectBegin:()=>{const E={};w(E),S.push(h),h=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{h=S.pop()},onArrayBegin:()=>{const E=[];w(E),S.push(h),h=E,c=null},onArrayEnd:()=>{h=S.pop()},onLiteralValue:w,onError:(E,A,B)=>{L.push({error:E,offset:A,length:B})}};if(d)try{g.$dn(d,p),l=h[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return l}h(d,l){const c=m.$sn.as(C.$xn.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const S=(0,M.$zi)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),L=Object.keys(d),w=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:S,keys:L,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let S=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:S};const L={},w=[];for(const p in d)if(C.$Hn.test(p)&&c){const E=this.i(d[p],l,!1,h);L[p]=E.raw,S=S||E.hasExcludedProperties,w.push(...E.restricted)}else{const E=l[p],A=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&w.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(A===void 0||h.scopes===void 0||h.scopes.includes(A))&&!(h.skipRestricted&&E?.restricted))?L[p]=d[p]:S=!0}return{raw:L,restricted:w,hasExcludedProperties:S}}j(d,l){const c=[];for(const h of Object.keys(d))if(C.$Hn.test(h)){const S={};for(const L in d[h])S[L]=d[h][L];c.push({identifiers:(0,C.$In)(h),keys:Object.keys(S),contents:(0,M.$zi)(S,l)})}return c}}e.$On=u;class f extends I.$Sc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new N.$Sd),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&c.isEqual(S.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Pn=f;class s{constructor(d,l,c,h,S,L,w,p,E,A,B,O,P){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=S,this.f=L,this.g=w,this.h=p,this.i=E,this.j=A,this.k=B,this.l=O,this.m=P}get value(){return v(this.c)}n(d,l,c){const h=d.inspect(l,c);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,l,c,h,S=new k,L=new k,w=new R.$Ac,p=new k,E=new R.$Ac){this.c=d,this.d=l,this.f=c,this.g=h,this.h=S,this.i=L,this.j=w,this.l=p,this.m=E,this.a=null,this.b=new R.$Ac,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new k,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),S=this.t(l.resource,c),L=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const p of h.overrides)for(const E of p.identifiers)h.getOverrideValue(d,E)!==void 0&&w.add(E);return new s(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,S||void 0,L)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:S,removed:L}=a(this.c,d);l=[...h,...S,...L]}for(const h of l)for(const S of(0,C.$In)(h)){const L=this.c.getKeysForOverrideIdentifier(S),w=d.getKeysForOverrideIdentifier(S),p=[...w.filter(E=>L.indexOf(E)===-1),...L.filter(E=>w.indexOf(E)===-1),...L.filter(E=>!b.$kn(this.c.override(S).getValue(E),d.override(S).getValue(E)))];c.push([S,p])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=a(this.d,d),S=[...l,...c,...h];return S.length&&this.updatePolicyConfiguration(d),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:S}=a(this.applicationConfiguration,d),L=[...l,...c,...h];return L.length&&this.updateApplicationConfiguration(d),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:S}=a(this.localUserConfiguration,d),L=[...l,...c,...h];return L.length&&this.updateLocalUserConfiguration(d),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:S}=a(this.remoteUserConfiguration,d),L=[...l,...c,...h];return L.length&&this.updateRemoteUserConfiguration(d),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:S}=a(this.workspaceConfiguration,d),L=[...l,...c,...h];return L.length&&this.updateWorkspaceConfiguration(d),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:S,removed:L,overrides:w}=a(c,l),p=[...h,...S,...L];return(p.length||!c)&&this.updateFolderConfiguration(d,l),{keys:p,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:S,overrides:L}=a(l,void 0);return{keys:[...c,...h,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const S=this.m.get(d);S&&(c=c.merge(S))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:S}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:S}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),S=this.w(d.user),L=this.w(d.workspace),w=d.folders.reduce((p,E)=>(p.set(y.URI.revive(E[0]),this.w(E[1])),p),new R.$Ac);return new i(l,c,h,S,new k,L,w,new k,new R.$Ac)}static w(d){return new k(d.contents,d.keys,d.overrides)}}e.$Qn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,l=new Map;for(const h of r)h.keys.forEach(S=>d.add(S)),h.overrides.forEach(([S,L])=>{const w=(0,R.$xc)(l,S,new Set);L.forEach(p=>w.add(p))});const c=[];return l.forEach((h,S)=>c.push([S,[...h.values()]])),{keys:[...d.values()],overrides:c}}e.$Rn=n;class o{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of d.keys)this.affectedKeys.add(S);for(const[,S]of d.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const S=h+c.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,p=this.g.getValue(d,l,this.h);return!b.$kn(w,p)}return!0}}e.$Sn=o;function a(r,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),S=[],L=r?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const p=w.filter(E=>!L.includes(E));for(const E of p)S.push([E,d.getKeysForOverrideIdentifier(E)])}if(r){const p=L.filter(E=>!w.includes(E));for(const E of p)S.push([E,r.getKeysForOverrideIdentifier(E)])}if(d&&r){for(const p of L)if(w.includes(p)){const E=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});S.push([p,[...E.added,...E.removed,...E.updated]])}}return{added:l,removed:c,updated:h,overrides:S}}function t(r,d){const l=r?d?r.keys.filter(S=>d.keys.indexOf(S)===-1):[...r.keys]:[],c=d?r?d.keys.filter(S=>r.keys.indexOf(S)===-1):[...d.keys]:[],h=[];if(r&&d){for(const S of d.keys)if(r.keys.indexOf(S)!==-1){const L=(0,M.$Ci)(d.contents,S),w=(0,M.$Ci)(r.contents,S);b.$kn(L,w)||h.push(S)}}return{added:l,removed:c,updated:h}}}),define(Se[256],ke([1,0,22,4,3,82]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qb=e.$9qb=e.$8qb=e.$7qb=void 0;const R=(y,M,C)=>{const m=new Uint8Array(16);for(let u=0;u<16;u++)m[u]=Math.round(Math.random()*256);const v=(0,D.$Ae)(D.$ge.wrap(m));return[`GET ws://localhost${y}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$7qb=R,e.$8qb=D.$ge.fromString(`\r
\r
`);async function b(y,M,C,m,v){y.write(D.$ge.fromString((0,e.$7qb)(M,C,m)));const k=new g.$Rc;try{return await new Promise((u,f)=>{let s;k.add(y.onData(i=>{s?s=D.$ge.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$8qb);if(n===-1)return;u(y),y.pauseData();const o=s.slice(n+e.$8qb.byteLength);o.byteLength&&v.onData.fire(o)})),k.add(y.onClose(i=>f(i??new Error("socket closed")))),k.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(u){throw y.dispose(),u}finally{k.dispose()}}e.$9qb=b;class $ extends g.$Sc{constructor(M,C){super(),this.g=M,this.a=this.B(new N.$Vd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,M,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$0qb=$}),define(Se[64],ke([1,0,8,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.RemoteAuthorityResolverErrorCode=e.$4k=e.$3k=e.RemoteConnectionType=e.$2k=void 0,e.$2k=(0,N.$1h)("remoteAuthorityResolverService");var g;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$3k=I;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$4k=R;var b;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$5k=$;function y(M){const C=M.indexOf("+");return C===-1?M:M.substring(0,C)}e.$6k=y}),define(Se[65],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0;function N(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$7k=N;function g(y){if(!y)return;const M=y.indexOf("+");return M<0?y:y.substr(0,M)}e.$8k=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$9k=I;function R(y){const{host:M,port:C}=$(y);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:C}}e.$0k=R;function b(y,M){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=M),{host:C,port:m}}e.$$k=b;function $(y){const M=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Se[26],ke([1,0,13,5,65]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.TargetPlatform=e.ExtensionType=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l="extensions.user.cache",e.$am="extensions.builtin.cache",e.$bm="undefined_publisher",e.$cm=["ui","workspace","web"];function I(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$dm=I,e.$em=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f>"u"||f===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){const i=typeof f=="string"?f:f.value,n=typeof s=="string"?s:s.value;return D.$7e(i,n)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$fm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const s of f)this.add(s)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$gm=y;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,s){this.c.set($.toKey(f),s)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$hm=M;function C(u){return m(u)}e.$im=C;function m(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$jm=m;function v(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$km=v;function k(u,f){if(f){const s=`onResolveRemoteAuthority:${(0,g.$8k)(f)}`;return!!u.activationEvents?.includes(s)}return!1}e.$lm=k,e.$mm=(0,N.$1h)("IBuiltinExtensionsScannerService")}),define(Se[137],ke([1,0,8,26]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.$YE=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(b[N.$fm.toKey($.identifier)]=y)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$fm.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const M=R.contributes[$],C=Array.isArray(M)?M:[M];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$YE=g,e.$ZE=new g}),define(Se[257],ke([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.PersistentConnectionEventType=e.$fl=e.$el=e.$dl=e.ConnectionType=void 0;const k=30*1e3;var u;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function f(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(H){const U=new g.$3d;return setTimeout(()=>U.cancel(),H),U.token}function i(H,U){if(H.isCancellationRequested||U.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$3d;return H.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Rc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(H,U){const ne=new n(U);return ne.registerDisposable(H.onControlMessage(ye=>{const he=JSON.parse(ye.toString()),ge=Y(he);ge?ne.reject(ge):ne.resolve(he)})),ne.promise}function a(H,U,ne,ye,he,ge,_,ie){const G=new n(ie),te=y.$Od.create(!1);return H.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),U.connect(ne,ye,he,_).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),H.info(`Creating a socket (${_}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),H.info(`Creating a socket (${_}) was successful after ${te.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),H.info(`Creating a socket (${_}) returned an error after ${te.elapsed()} ms.`),H.error(fe),G.reject(fe)}),G.promise}function t(H,U){const ne=new n(U);return H.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function r(H,U,ne,ye){const he=ve(H,U);H.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await a(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,v.$9k)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,f(U),`renderer-${f(U)}-${H.reconnectionToken}`,ye)}catch(fe){throw H.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),H.logService.error(fe),fe}H.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let _,ie;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(ge,null),_=H.reconnectionProtocol,ie=!1):(_=new C.$Oh({socket:ge}),ie=!0),H.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const G=await t(H.signService.createNewMessage((0,M.$lg)()),ye),te={type:"auth",auth:H.connectionToken||"00000000000000000000",data:G.data};_.sendControl(N.$ge.fromString(JSON.stringify(te)));try{const fe=await o(_,i(ye,s(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(H.logService.trace(`${he} 4/6. received SignRequest control message.`),!await t(H.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(H.signService.sign(fe.data),ye),be={type:"connectionType",commit:H.commit,signedData:Ae,desiredConnectionType:U};return ne&&(be.args=ne),H.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$ge.fromString(JSON.stringify(be))),{protocol:_,ownsProtocol:ie}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(H.logService.error(`${he} the handshake timed out. Error:`),H.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${he} received error control message when negotiating connection. Error:`),H.logService.error(fe)),ie&&J(_),fe}}async function d(H,U,ne,ye){const he=Date.now(),ge=ve(H,U),{protocol:_,ownsProtocol:ie}=await r(H,U,ne,ye),G=new n(ye);return G.registerDisposable(_.onControlMessage(te=>{const fe=JSON.parse(te.toString()),we=Y(fe);we?(H.logService.error(`${ge} received error control message when negotiating connection. Error:`),H.logService.error(we),ie&&J(_),G.reject(we)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${de(he)}!`),G.resolve({protocol:_,firstMessage:fe}))})),G.promise}async function l(H,U){const{protocol:ne}=await d(H,1,void 0,U);return{protocol:ne}}async function c(H,U,ne){const{protocol:ye,firstMessage:he}=await d(H,2,U,ne),ge=he&&he.debugPort;return{protocol:ye,debugPort:ge}}async function h(H,U,ne){const ye=Date.now(),he=ve(H,3),{protocol:ge}=await r(H,3,U,ne);return H.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${de(ye)}!`),ge}async function S(H,U,ne){const{connectTo:ye,connectionToken:he}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:ye,connectionToken:he,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function L(H,U,ne){return p(H,async ye=>{const{protocol:he}=await l(ye,g.CancellationToken.None);return new X(H,U,ne,ye.reconnectionToken,he)})}e.$dl=L;async function w(H,U){return p(H,async ne=>{const{protocol:ye,debugPort:he}=await c(ne,U,g.CancellationToken.None);return new ce(H,U,ne.reconnectionToken,ye,he)})}e.$el=w;async function p(H,U){for(let ye=1;;ye++)try{const he=(0,M.$lg)(),ge=await S(H,he,null);return await U(ge)}catch(he){if(ye<5)H.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(he);else throw H.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(he),W.triggerPermanentFailure(0,0,m.$5k.isHandled(he)),he}}async function E(H,U,ne){const ye=await S(H,(0,M.$lg)(),null);return await h(ye,{host:U,port:ne},g.CancellationToken.None)}e.$fl=E;function A(H){return(0,D.$Og)(U=>new Promise((ne,ye)=>{const he=setTimeout(ne,H*1e3);U.onCancellationRequested(()=>{clearTimeout(he),ne()})}))}var B;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(B||(e.PersistentConnectionEventType=B={}));class O{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$gl=O;class P{constructor(U,ne,ye,he){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=he,this.type=1}skipWait(){this.c.cancel()}}e.$hl=P;class j{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$il=j;class T{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$jl=T;class F{constructor(U,ne,ye,he){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=he,this.type=3}}e.$kl=F;class W extends b.$Sc{static triggerPermanentFailure(U,ne,ye){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=ye,this.j.forEach(he=>he.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,ye,he,ge){super(),this.t=U,this.u=ne,this.reconnectionToken=ye,this.protocol=he,this.w=ge,this.m=this.B(new R.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new T(this.reconnectionToken,0,0)),this.B(he.onSocketClose(_=>{const ie=Z(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(he.onSocketTimeout(_=>{const ie=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Qc)(()=>{const _=W.j.indexOf(this);_>=0&&W.j.splice(_,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const he=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(he>0){const _=A(he);this.m.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,_)),this.u.logService.info(`${U} waiting for ${he} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${U} resolving connection...`);const ge=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ge.connectTo}...`),await this.G(ge,s(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$5k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$5k){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$5k.isHandled(ge));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,ye){this.w?W.triggerPermanentFailure(U,ne,ye):this.D(U,ne,ye)}D(U,ne,ye){this.m.fire(new F(this.reconnectionToken,U,ne,ye)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ll=W;class X extends W{constructor(U,ne,ye,he,ge){super(1,U,he,ge,!0),this.client=this.B(new C.$Mh(ge,{remoteAuthority:ne,clientId:ye},U.ipcLogger))}async G(U,ne){await l(U,ne)}}e.$ml=X;class ce extends W{constructor(U,ne,ye,he,ge){super(2,U,ye,he,!1),this.H=ne,this.debugPort=ge}async G(U,ne){await c(U,this.H,ne)}}e.$nl=ce;function J(H){try{H.acceptDisconnect();const U=H.getSocket();H.dispose(),U.dispose()}catch(U){(0,I.$1)(U)}}function Y(H){if(H&&H.type==="error"){const U=new Error(`Connection error: ${H.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(H,U){for(;H.length<U;)H+=" ";return H}function se(H,U){return`[remote-connection][${x(f(H),13)}][${U.substr(0,5)}\u2026]`}function Z(H,U,ne){return`${se(H,U)}[${ne?"reconnect":"initial"}]`}function ve(H,U){return`${Z(U,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function de(H){return`${Date.now()-H} ms`}}),define(Se[258],ke([1,0,3,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0,e.$_k=(0,N.$1h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,D.$Qc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,y){const M=this.b(R);if(!M)throw new Error(`No socket factory found for ${R}`);return M.connect(R,b,$,y)}}e.$al=g}),define(Se[259],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const R=String(D.a++);return this.b.set(R,I),{id:R,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(I)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$95b=D}),define(Se[109],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=void 0,e.$bl="signService",e.$cl=(0,D.$1h)(e.$bl)}),define(Se[138],ke([1,0,259]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=void 0;class N extends D.$95b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(R=>new R.signer().sign(I))}h(){return new Promise((I,R)=>me(["vsda"],I,R))}}e.$40b=N}),define(Se[260],ke([1,0,11,50,30]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,M,C,m,v,k,u,f){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=k,s.sessionID=(0,g.$lg)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=N.$dc,s["common.nodeArch"]=M,s["common.product"]=f||"desktop",u&&(s["common.msftInternal"]=u);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=I(y);return o&&(s["common.platformDetail"]=o),s}e.$to=R;function b($){const y=N.env.USERDNSDOMAIN;if(!y)return!1;const M=y.toLowerCase();return $.some(C=>M===C)}e.$uo=b}),define(Se[261],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=void 0,e.$ol=(0,D.$1h)("telemetryService"),e.$pl=(0,D.$1h)("customEndpointTelemetryService"),e.$ql="telemetry.currentSessionDate",e.$rl="telemetry.firstSessionDate",e.$sl="telemetry.lastSessionDate",e.$tl="telemetry.machineId",e.$ul="telemetry.sqmId",e.$vl="telemetry",e.$wl="telemetry.telemetryLevel",e.$xl="telemetry.enableCrashReporter",e.$yl="telemetry.enableTelemetry";var N;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[87],ke([1,0,24,18,4,45,65,260,261]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;class y{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$vo=y;class M{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wo=M,e.$xo=new M;class C{async publicLog(c,h,S){}async publicLogError(c,h,S){}}e.$yo=C,e.$zo="telemetry",e.$Ao="extensionTelemetryLog",e.$Bo={log:()=>null,flush:()=>Promise.resolve(null)};function m(l,c){return g.Event.debounce(c.onDidChangeConfiguration,(S,L)=>{const w=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:w}},1e3,!0)(S=>{S.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,I.$xi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Co=m;function v(l,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!l.enableTelemetry)}e.$Do=v;function k(l,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.$Eo=k;function u(l){const c=l.getValue($.$wl),h=l.getValue($.$xl);if(l.getValue($.$yl)===!1||h===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Fo=u;function f(l){const c={},h={},S={};n(l,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const w=S[L];typeof w=="number"?h[L]=w:typeof w=="boolean"?h[L]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${w.length}`),c[L]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(c[L]=w)}return{properties:c,measurements:h}}e.$Go=f;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(l){if(!l)return"none";const c=(0,R.$8k)(l);return s.has(c)?c:"other"}e.$Ho=i;function n(l,c,h=0,S){if(l)for(const L of Object.getOwnPropertyNames(l)){const w=l[L],p=S?S+L:L;Array.isArray(w)?c[p]=(0,D.$ln)(w):w instanceof Date?c[p]=w.toISOString():(0,N.$Ff)(w)?h<2?n(w,c,h+1,p+"."):c[p]=(0,D.$ln)(w):c[p]=w}}function o(l,c){const h=l.msftInternalDomains||[],S=c.getValue("telemetry.internalTesting");return(0,b.$uo)(h)||S}e.$Io=o;function a(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.$Jo=a;function t(l,c){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let h=l;const S=[];for(const E of c)for(;;){const A=E.exec(l);if(!A)break;S.push([A.index,E.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const E=w.exec(l);if(!E)break;const A=S.some(([B,O])=>E.index<O&&B<w.lastIndex);!L.test(E[0])&&!A&&(h+=l.substring(p,E.index)+"<REDACTED: user-file-path>",p=w.lastIndex)}return p<l.length&&(h+=l.substr(p)),h}function r(l){if(!l)return l;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(l))return`<REDACTED: ${h.label}>`;return l}function d(l,c){return(0,D.$in)(l,h=>{if(h instanceof y||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let S=h.replaceAll("%20"," ");S=t(S,c);for(const L of c)S=S.replace(L,"");return S=r(S),S}})}e.$Ko=d}),define(Se[262],ke([1,0,13,134,26,11,2,8,50,87]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;function M(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,D.$2e)(d.id,l.id)===0}e.$Lo=M;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new m(l.identifier,c,h)}static parse(l){const c=C.exec(l);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof m?M(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Mo=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(d){const l=v.exec(d);return l&&l[1]?[f(l[1]),l[2]]:[f(d),void 0]}e.$No=k;function u(d,l){return`${d}.${l}`}e.$Oo=u;function f(d){return d.toLowerCase()}e.$Po=f;function s(d,l){return f(u(d??g.$bm,l))}e.$Qo=s;function i(d,l){const c=[],h=S=>{for(const L of c)if(L.some(w=>M(l(w),l(S))))return L;return null};for(const S of d){const L=h(S);L?L.push(S):c.push([S])}return c}e.$Ro=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$So=n;function o(d){return{id:new y.$vo(d.identifier.id),name:new y.$vo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$To=o,e.$Uo=new g.$fm("pprice.better-merge");function a(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const S=h.shift();if(S&&c.every(L=>!M(L.identifier,{id:S}))){const L=d.filter(w=>M(w.identifier,{id:S}));L.length===1&&(c.push(L[0]),h.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$Vo=a;async function t(d,l){if(!I.$k)return!1;let c;try{c=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,b.$0)(S))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,l){const c=await t(d,l),h=(0,N.$fo)(c?"alpine":I.$u,$.$ec);return l.debug("ComputeTargetPlatform:",h),h}e.$Wo=r}),define(Se[263],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=void 0;function D($){return[...$.entries()]}e.$wr=D;function N($){return $?[...$.entries()]:[]}e.$xr=N;function g($){return new Map($)}e.$yr=g;function I($){return new Map($??[])}e.$zr=I;function R($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),N(y[1].descriptionMap)])}e.$Ar=R;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Br=b}),define(Se[264],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,R=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let M=this.a.get(g);if(M){M.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),R);M={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,M)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$orb=D}),define(Se[265],ke([1,0,12,78,61,4,18,2,207,108,37]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.IconFontDefinition=e.IconContribution=e.$gw=void 0,e.$gw={IconContribution:"base.contributions.icons"};var C;(function(o){function a(t,r){let d=t.defaults;for(;g.ThemeIcon.isThemeIcon(d);){const l=k.getIcon(d.id);if(!l)return;d=l.defaults}return d}o.getDefinition=a})(C||(e.IconContribution=C={}));var m;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=a;function t(r){const d=l=>(0,R.$Df)(l)?l:void 0;if(r&&Array.isArray(r.src)&&r.src.every(l=>(0,R.$Df)(l.format)&&(0,R.$Df)(l.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(l=>({format:l.format,location:b.URI.parse(l.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new I.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const l=this.b[a];if(l){if(r&&!l.description){l.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const S=this.e.enum.indexOf(a);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return l}const c={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=c;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(l,c)=>l.id.localeCompare(c.id),t=l=>{for(;g.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(l=>this.b[l]);for(const l of d.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(l)}"></i>|${l.id}|${g.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const l of d.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(l)}"></i>|${l.id}|`);return r.join(`
`)}}const k=new v;M.$sn.add(e.$gw.IconContribution,k);function u(o,a,t,r){return k.registerIcon(o,a,t,r)}e.$hw=u;function f(){return k}e.$iw=f;function s(){const o=(0,N.$5j)();for(const a in o){const t="\\"+o[a].toString(16);k.registerIcon(a,{fontCharacter:t})}}s(),e.$jw="vscode://schemas/icons";const i=M.$sn.as(y.$tn.JSONContribution);i.registerSchema(e.$jw,k.getIconSchema());const n=new D.$ah(()=>i.notifySchemaChanged(e.$jw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$kw=u("widget-close",N.$7j.close,(0,$.localize)(2,null)),e.$lw=u("goto-previous-location",N.$7j.arrowUp,(0,$.localize)(3,null)),e.$mw=u("goto-next-location",N.$7j.arrowDown,(0,$.localize)(4,null)),e.$nw=g.ThemeIcon.modify(N.$7j.sync,"spin"),e.$ow=g.ThemeIcon.modify(N.$7j.loading,"spin")}),define(Se[88],ke([1,0,4,45,5,14]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.ProvidedOnAutoForward=e.$mv=e.TunnelPrivacyId=e.TunnelProtocol=e.$lv=e.$kv=void 0,e.$kv=(0,g.$1h)("tunnelService"),e.$lv=(0,g.$1h)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$mv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function M(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(s)return{address:s[1],port:+s[2]}}e.$nv=M,e.$ov=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$ov.indexOf(f)>=0}e.$pv=C,e.$qv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$qv.indexOf(f)>=0}e.$rv=m;function v(f,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return f<1024}e.$sv=v;class k{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$tv=k;let u=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$ov[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const l=this.f??s;if(!l)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(l,i,n,o,a,t,r,d);return c?c.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$ov),n.push(...e.$qv)):m(s)&&n.push(...e.$qv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!M(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const l=o===void 0?n:o,c={elevationRequired:a?this.isPortPrivileged(l):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==b.Private:void 0,protocol:r},S=s.forwardPort(h,c);return S?(this.p(i,n,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),S}};e.$uv=u,e.$uv=u=Je([We(0,I.$ij),We(1,N.$ui)],u)}),define(Se[266],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=void 0,e.$Uk=(0,D.$1h)("IUriIdentityService")}),define(Se[267],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$vv=void 0,e.$vv=(0,D.$1h)("editSessionIdentityService");var N;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Se[268],ke([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=void 0;function N($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$hK=N;function g($){if($.folders.length)return $.folders.every(y=>N(y.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}e.$iK=g;function I($){return g($)?.scheme}e.$jK=I;function R($){return g($)?.authority}e.$kK=R;function b($){return g($)!==void 0}e.$lK=b}),define(Se[40],ke([1,0,209,16,77,23,2,5,17]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,b.$1h)("contextService");function y(l){const c=l;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$$h=y;function M(l){return typeof l?.id=="string"&&!y(l)&&!m(l)}e.$_h=M,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function C(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$nc)(l)}:c?e.$ai:e.$bi;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$ci=C;function m(l){const c=l;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$di=m;function v(l){const c=l;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}e.$ei=v;var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function u(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$fi=u;function f(l){const c=l;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$gi=f;class s{constructor(c,h,S,L,w){this.h=c,this.j=S,this.k=L,this.l=w,this.c=g.$7h.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$7h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=s;class i{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,I.$Cg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=i;function n(l){return new i({uri:l,index:0,name:(0,I.$yg)(l)},{uri:l.toString()})}e.$ji=n,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,D.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function o(l,c){return I.$tg.isEqualOrParent(l,c.untitledWorkspacesHome)}e.$oi=o;function a(l){let c;return R.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===$.Schemas.tmp}e.$pi=a,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$qi}e.$ri=t;function r(l,c){return!o(l,c)&&!a(l)}e.$si=r;function d(l){return(typeof l=="string"?(0,N.$oc)(l):(0,I.$Ag)(l))===e.$li}e.$ti=d}),define(Se[269],ke([1,0,53,4,3,23,2,208,133,32,5,14,40,28,266,12,30,13,18]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.ProfileResourceType=void 0;var n;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Vk=o,e.$Wk=(0,M.$1h)("IUserDataProfilesService");function a(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:R.URI.revive(l.location).with({scheme:c}),globalStorageHome:R.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$Xk=a;function t(l,c,h,S,L,w){return{id:l,name:c,location:h,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:w&&L?.useDefaultFlags?.globalState?w.globalStorageHome:(0,I.$Cg)(h,"globalStorage"),settingsResource:w&&L?.useDefaultFlags?.settings?w.settingsResource:(0,I.$Cg)(h,"settings.json"),keybindingsResource:w&&L?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,I.$Cg)(h,"keybindings.json"),tasksResource:w&&L?.useDefaultFlags?.tasks?w.tasksResource:(0,I.$Cg)(h,"tasks.json"),snippetsHome:w&&L?.useDefaultFlags?.snippets?w.snippetsHome:(0,I.$Cg)(h,"snippets"),extensionsResource:w&&L?.useDefaultFlags?.extensions?w.extensionsResource:(0,I.$Cg)(h,"extensions.json"),cacheHome:(0,I.$Cg)(S,l),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}e.$Yk=t;let r=class extends g.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,S,L){super(),this.t=c,this.u=h,this.w=S,this.y=L,this.f=!0,this.h=this.B(new N.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Cg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Cg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,i.$Df)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,I.$zg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const S=new v.$Ac,L=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[p,E]of Object.entries(w.workspaces)){const A=R.URI.parse(p),B=h.find(O=>O.id===E);B&&S.set(A,B)}if(w.emptyWindows)for(const[p,E]of Object.entries(w.emptyWindows)){const A=h.find(B=>B.id===E);A&&L.set(p,A)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:S,emptyWindows:L}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",S=new RegExp(`${(0,s.$Ke)(h)}\\s(\\d+)`);let L=0;for(const p of this.profiles){const E=S.exec(p.name),A=E?parseInt(E[1]):0;L=A>L?A:L}const w=`${h} ${L+1}`;return this.createProfile((0,D.$Oi)((0,f.$lg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,h,S){return this.createProfile((0,D.$Oi)((0,f.$lg)()).toString(16),c,h,S)}async createProfile(c,h,S,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,h,S);return L&&await this.setProfileForWorkspace(L,w),w}async F(c,h,S){if(!(0,i.$Df)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(h);return L||(L=(async()=>{try{const w=this.profiles.find(A=>A.name===h||A.id===c);if(w)return w;const p=t(c,h,(0,I.$Cg)(this.profilesHome,c),this.g,S,this.defaultProfile);await this.u.createFolder(p.location);const E=[];return this.j.fire({profile:p,join(A){E.push(A)}}),await u.Promises.settled(E),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,L)),L}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(L=>L.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);return S=t(S.id,h.name??S.name,S.location,this.g,{shortName:h.shortName??S.shortName,icon:h.icon===null?void 0:h.icon??S.icon,transient:h.transient??S.isTransient,useDefaultFlags:h.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(L=>L.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const S=[];this.m.fire({profile:h,join(L){S.push(L)}});try{await Promise.allSettled(S)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(L){(0,y.$Bk)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(L=>L.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,S)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,m.$$h)(c)?c.uri:(0,m.$di)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,S){const L=[...this.profiles,...c],w=[];this.s.profiles=[];for(let p of L)p.isDefault||h.some(E=>p.id===E.id)||(p=S.find(E=>p.id===E.id)??p,p.isTransient?this.s.profiles.push(p):w.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,h,S)}J(c,h,S){this.h.fire({added:c,removed:h,updated:S,all:this.profiles})}L(c,h,S){S=h?.isTransient?!0:S,S||this.L(c,void 0,!0);const L=this.G(c),w=S?this.s:this.C;R.URI.isUri(L)?(w.workspaces.delete(L),h&&w.workspaces.set(L,h)):(w.emptyWindows.delete(L),h&&w.emptyWindows.set(L,h)),S||this.M()}M(){const c={};for(const[S,L]of this.C.workspaces.entries())c[S.toString()]=L.id;const h={};for(const[S,L]of this.C.emptyWindows.entries())h[S.toString()]=L.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},S=this.D();if(c.workspaces)for(const[w,p]of Object.entries(c.workspaces)){const E=R.URI.parse(p);h[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}const L={};if(c.emptyWindows)for(const[w,p]of Object.entries(c.emptyWindows)){const E=R.URI.parse(p);L[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}return{workspaces:h,emptyWindows:L}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Zk=r,e.$Zk=r=Je([We(0,$.$8h),We(1,y.$kk),We(2,k.$Uk),We(3,C.$ij)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$1k=d}),define(Se[270],ke([1,0,12,4,3,56,18,188,5,269]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fp=e.$ep=e.$dp=void 0,e.$dp="__$__isNewStorageMarker",e.$ep="__$__targetStorageMarker",e.$fp=(0,$.$1h)("storageService");var M;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const n=i.get(e.$ep);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$gp=v;class k extends g.$Sc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new N.$Vd),this.c=this.B(new N.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$ah(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return N.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,D.$eh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$ep){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.$Mf)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$ep,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$ep,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?v(o):Object.create(null)}isNew(n){return this.getBoolean(e.$dp,n)===!0}async flush(n=M.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case M.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(M.NONE),(0,y.$Vk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||u(o)&&u(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$hp=k;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$ip=u;class f extends k{constructor(){super(),this.U=this.B(new b.$bp(new b.$cp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$bp(new b.$cp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$bp(new b.$cp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$jp=f;async function s(i,n,o,a,t,r){const d=A=>{try{return JSON.parse(A)}catch{return A}},l=new Map,c=new Map;i.forEach((A,B)=>{l.set(B,A),c.set(B,d(A))});const h=new Map,S=new Map;n.forEach((A,B)=>{h.set(B,A),S.set(B,d(A))});const L=new Map,w=new Map;o.forEach((A,B)=>{L.set(B,A),w.set(B,d(A))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(l.forEach((A,B)=>{p.push({key:B,value:A})}),console.table(p),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];h.forEach((B,O)=>{A.push({key:O,value:B})}),console.table(A),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${r})`);const E=[];L.forEach((A,B)=>{E.push({key:B,value:A})}),console.table(E),console.groupEnd(),console.log(w)}e.$kp=s}),define(Se[110],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Wec=D}),define(Se[57],ke([1,0,17,23,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=e.$Zec=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new N.$rg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Zec=I,e.$1ec=(0,g.$1h)("IExtHostFileSystemInfo")}),define(Se[27],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0,e.$5M=(0,D.$1h)("IExtHostInitDataService")}),define(Se[271],ke([1,0,214,14,251,27]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;let R=class extends g.$_N{constructor($,y,M){const C=M.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=M.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$7gc=R,e.$7gc=R=Je([We(1,N.$jj),We(2,I.$5M)],R)}),define(Se[272],ke([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;class N{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$ah(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of y.values())M.complete()}catch(M){for(const C of y.values())C.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const y=new D.$lh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Ifc=N;class g extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$Jfc=g}),define(Se[273],ke([1,0,4,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,y){const C=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$wgc=g}),define(Se[20],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0,e.$OM=(0,D.$1h)("IExtHostRpcService");class N{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$PM=N}),define(Se[274],ke([1,0,26,4]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class g{#e;constructor(R,b){this.b=new N.$Sd,this.onDidChange=this.b.event,this.a=D.$fm.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$Qfc=g}),define(Se[66],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,D.$1h)("IURITransformerService");class N{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$hfc=N}),define(Se[275],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=e.$Rkb=void 0;class N{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new N,C=JSON.stringify(b,(v,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k)};if(ArrayBuffer.isView(k)){const u=I(k);if(u)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k.buffer),view:{type:u,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),m=y.buffers.map(v=>{const k=new Uint8Array(v);return D.$ge.wrap(k)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$Rkb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),M=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const k=v,{index:u}=k,f=y[u];if(k.view)switch(k.view.type){case 1:return new Int8Array(f,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return v}:void 0;return{message:JSON.parse(b,M),arrayBuffers:y}}e.$Skb=R}),define(Se[276],ke([1,0,277,388,389,62,2,14,390]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;const y=!1;function M(n,o,a,t,r,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>n.resolveProxy(w),lookupProxyAuthorization:f.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>v(o),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return p(w)}function p(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),w.push(p)}return(await Promise.all(w)).flat()},env:process.env},S=(0,$.createProxyResolver)(h),L=C(h,S);return u(a,L)}e.$Chc=M;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(N,(0,$.createHttpPatch)(n,N,o)),net:Object.assign(I,(0,$.createNetPatch)(n,I)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function v(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const k=new Map;function u(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(l,c,h){if(l==="net")return o.net;if(l==="tls")return o.tls;if(l!=="http"&&l!=="https")return r.apply(this,arguments);const S=a.findSubstr(R.URI.file(c.filename));let L=k.get(S);if(L||k.set(S,L={}),!L[l]){const w=o[l];L[l]={...w}}return L[l]}})}async function f(n,o,a,t,r,d,l,c){const h=t[d];l&&(t[d]=l),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const S=l||h,L=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(i(o,L,r),L.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((O,P)=>{me(["kerberos"],O,P)}),p=new URL(d),E=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${E}`),"Negotiate "+await(await w.initializeClient(E)).step("")}catch(w){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Se[278],ke([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;function N(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(I){return new D.$Xm(N(I))}e.$Mr=g}),define(Se[139],ke([1,0,225,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.$HE=e.EditorsOrder=e.$GE=e.CloseDirection=e.$FE=e.$EE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.EditorInputCapabilities=e.$vE=e.SaveReason=e.Verbosity=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=void 0,e.$iE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$jE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$kE="workbench.editor.sidebysideEditor",e.$lE="workbench.editors.textDiffEditor",e.$mE="workbench.editors.binaryResourceDiffEditor";var v;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var k;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function u(de){const H=de;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.$nE=u;function f(de,H,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===H&&de.matches(ne.input))return ne.getViewState()}e.$oE=f;function s(de){if(S(de))return!1;const H=de;return g.URI.isUri(H?.resource)}e.$pE=s;function i(de){if(S(de))return!1;const H=de;return H?.original!==void 0&&H.modified!==void 0}e.$qE=i;function n(de){if(S(de))return!1;const H=de;return Array.isArray(H?.resources)}e.$rE=n;function o(de){if(S(de)||i(de))return!1;const H=de;return H?.primary!==void 0&&H.secondary!==void 0}e.$sE=o;function a(de){if(S(de))return!1;const H=de;return H?H.resource===void 0||H.resource.scheme===y.Schemas.untitled||H.forceUntitled===!0:!1}e.$tE=a;function t(de){if(S(de))return!1;const H=de;return g.URI.isUri(H?.base?.resource)&&g.URI.isUri(H?.input1?.resource)&&g.URI.isUri(H?.input2?.resource)&&g.URI.isUri(H?.result?.resource)}e.$uE=t;var r;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class l{constructor(){this.a=new Map}registerSource(H,U){let ne=this.a.get(H);return ne||(ne={source:H,label:U},this.a.set(H,ne)),ne.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$vE=new l;var c;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors",de[de.Scratchpad=512]="Scratchpad",de[de.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class h extends I.$Sc{}e.$wE=h;function S(de){return de instanceof h}e.$xE=S;function L(de){const H=de;return g.URI.isUri(H?.preferredResource)}function w(de){const H=de;return S(H?.primary)&&S(H?.secondary)}e.$yE=w;function p(de){const H=de;return S(H?.modified)&&S(H?.original)}e.$zE=p;function E(de,H,U,ne,ye){return ve(ne,[(0,C.$Ki)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const he={...U,limits:{size:Number.MAX_VALUE}};de.openEditor(H,he)}}),(0,C.$Ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$AE=E;function A(de){return S(de?.editor)}e.$BE=A;function B(de){const H=de;return A(de)&&H?.group!==void 0}e.$CE=B;function O(de){const H=de;return typeof H?.groupId=="number"&&S(H.editor)}e.$DE=O;var P;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(P||(e.EditorCloseContext=P={}));var j;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LABEL=2]="GROUP_LABEL",de[de.GROUP_LOCKED=3]="GROUP_LOCKED",de[de.EDITOR_OPEN=4]="EDITOR_OPEN",de[de.EDITOR_CLOSE=5]="EDITOR_CLOSE",de[de.EDITOR_MOVE=6]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=8]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=10]="EDITOR_PIN",de[de.EDITOR_STICKY=11]="EDITOR_STICKY",de[de.EDITOR_DIRTY=12]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var T;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class F{getOriginalUri(H,U){if(!H)return;if(t(H))return e.$FE.getOriginalUri(H.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:he}=this.a(H);if(ye&&he){if(U?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getOriginalUri(ye,{filterByScheme:U.filterByScheme})??this.getOriginalUri(he,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===T.PRIMARY?ye:he}}if(i(H)||n(H)||o(H)||t(H))return;const ne=L(H)?H.preferredResource:H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(H){return w(H)||o(H)?{primary:H.primary,secondary:H.secondary}:p(H)||i(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,U){if(!H)return;if(t(H))return e.$FE.getCanonicalUri(H.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:he}=this.a(H);if(ye&&he){if(U?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===T.PRIMARY?ye:he}}if(i(H)||n(H)||o(H)||t(H))return;const ne=H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(H,U){if(Array.isArray(U)){if(U.some(ne=>H.scheme===ne))return H}else if(U===H.scheme)return H}}var W;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.KEYBOARD=1]="KEYBOARD",de[de.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(de,H,U,ne){if(!de.isSticky(H))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$EE=X,e.$FE=new F;var ce;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class J{constructor(){this.c=new Map,this.d=new Map}start(H){const U=this.a=H.get(R.$Zh);for(const[ne,ye]of this.c)this.e(ne,ye,U);this.c.clear()}e(H,U,ne){const ye=ne.createInstance(U);this.d.set(H,ye)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,N.$Of)(this.b)}registerEditorSerializer(H,U){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,U,this.a):this.c.set(H,U),(0,I.$Qc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}b.$sn.add(e.$iE.EditorFactory,new J);async function Y(de,H,U){return!de||!de.length?[]:await Promise.all(de.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await H.canHandleResource(ye)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let ge=ne.exists,_=ne.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await H.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){U.error(G),ge=!1}if(!ge&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(_===$.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return ge?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$GE=Y;var x;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function se(de){const H=de;if(!H)return!1;const U=H;if(U.modified)return se(U.modified);const ne=H;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$HE=se;function Z(de){return(0,M.$Mi)(de)}e.$IE=Z;function ve(de,H,U){const ne=(0,M.$Ni)(de,H);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$JE=ve}),define(Se[279],ke([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SE=e.$RE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$QE=e.$PE=e.ViewContentGroups=e.$OE=e.$NE=e.ViewContainerLocation=e.Extensions=e.$ME=e.$LE=e.$KE=void 0,e.$KE="views",e.$LE=(0,N.localize)(0,null),e.$ME=(0,C.$hw)("default-view-icon",M.$7j.window,(0,N.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$NE=[0,1,2];function k(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$OE=k;class u extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const S=d;return S.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,l,[]).push(S),c?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:l}),S}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$sn.add(m.ViewContainersRegistry,new u);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f||(e.ViewContentGroups=f={}));function s(r,d){const l=r.group??f.More,c=d.group??f.More;return l!==c?l.localeCompare(c):(r.order??5)-(d.order??5)}class i extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,I.$Qc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,S]of l)this.n.add(d,S),c.set(h,(0,I.$Qc)(()=>{this.n.delete(d,S),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(s)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,N.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],S=[];for(const L of c)d.includes(L)?h.push(L):S.push(L);return h.length&&(S.length?this.m.set(l,S):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$sn.add(m.ViewsRegistry,new i),e.$PE=(0,g.$1h)("viewsService"),e.$QE=(0,g.$1h)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(d,l){this.c=!1,this.d=!1,(0,y.$jn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$RE=a;class t extends Error{constructor(d){super((0,N.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$SE=t}),define(Se[280],ke([1,0,2,29,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$JF=e.$IF=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(N.$Fs.isIRange)}e.$IF=I;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$JF=R;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.InteractiveSessionCopyKind=$={})),e.$KF=(0,g.$1h)("IChatService")}),define(Se[140],ke([1,0,4,12,227]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Sd,this.n=new D.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,M){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,M,b)};v(k)}},M)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,N.$2g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,N.$2g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$llb=I}),define(Se[281],ke([1,0,228,46,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$tH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$sH=e.MemoryRangeType=e.$rH=e.State=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0,e.$oG="workbench.view.debug",e.$pG="workbench.debug.variablesView",e.$qG="workbench.debug.watchExpressionsView",e.$rG="workbench.debug.callStackView",e.$sG="workbench.debug.loadedScriptsView",e.$tG="workbench.debug.breakPointsView",e.$uG="workbench.debug.disassemblyView",e.$vG="workbench.panel.repl",e.$wG="workbench.panel.repl.view",e.$xG=new N.$fj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$yG=new N.$fj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$zG=new N.$fj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$AG="debugUx",e.$BG=new N.$fj(e.$AG,"default",{type:"string",description:D.localize(3,null)}),e.$CG=new N.$fj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$DG=new N.$fj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$EG=new N.$fj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$FG=new N.$fj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$GG=new N.$fj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$HG=new N.$fj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$IG=new N.$fj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$JG=new N.$fj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$KG=new N.$fj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$LG=new N.$fj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$MG=new N.$fj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$NG=new N.$fj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$OG=new N.$fj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$PG=new N.$fj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$QG=new N.$fj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$RG=new N.$fj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$SG=new N.$fj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$TG=new N.$fj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$UG=new N.$fj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$VG=new N.$fj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$WG=new N.$fj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$XG=new N.$fj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$YG=new N.$fj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$ZG=new N.$fj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$1G=new N.$fj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$2G=new N.$fj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$3G=new N.$fj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$4G=new N.$fj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$5G=new N.$fj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$6G=new N.$fj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$7G=new N.$fj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$8G=new N.$fj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$9G=new N.$fj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$0G=new N.$fj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$$G=new N.$fj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$_G=new N.$fj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$aH=new N.$fj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$bH=new N.$fj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$cH=new N.$fj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$dH=new N.$fj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$eH=new N.$fj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$fH=new N.$fj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$gH=new N.$fj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$hH=new N.$fj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$iH=new N.$fj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$jH=new N.$fj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$kH=new N.$fj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$lH=new N.$fj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$mH=I,e.$nH="editor.contrib.debug",e.$oH="editor.contrib.breakpoint",e.$pH="debug",e.$qH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$rH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$sH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var M;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(M||(e.DebuggerString=M={})),e.$tH=(0,g.$1h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Se[282],ke([1,0,13,2,16,24,17,29,21,19]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=void 0;const M=/{([^}]+)}/g;function C(L,w,p){return L.replace(M,function(E,A){return w&&A.length>0&&A[0]!=="_"?E:p&&p.hasOwnProperty(A)?p[A]:E})}e.$PF=C;function m(L){const w={};for(const p of Object.keys(L))p.startsWith("!")||(w[p]=L[p]);return w}e.$QF=m;function v(L){return L.configuration.request==="attach"&&!k(L)&&(!L.parentSession||v(L.parentSession))}e.$RF=v;function k(L){let w=L.configuration.type;if(w)return w==="vslsShare"&&(w=L.configuration.adapterProxy.configuration.type),(0,D.$7e)(w,"extensionhost")||(0,D.$7e)(w,"pwa-extensionhost")?L:L.parentSession?k(L.parentSession):void 0}e.$SF=k;function u(L){return L.type&&(L.label||L.program||L.runtime)}e.$TF=u;function f(L,w,p){let E,A=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=B.exec(L);){const P=O.index+1,j=P+O[0].length;if(P<=w&&j>=p){E=O[0],A=P;break}}if(E){const P=/\w+/g;let j=null;for(;(j=P.exec(E))&&!(j.index+1+A+j[0].length>=p););j&&(E=E.substring(0,P.lastIndex))}return E?{start:A,end:A+E.length-1}:{start:0,end:0}}e.$UF=f;async function s(L,w,p,E){if(L.evaluatableExpressionProvider.has(w)){const A=L.evaluatableExpressionProvider.ordered(w),B=(0,y.$Hb)(await Promise.all(A.map(async O=>{try{return await O.provideEvaluatableExpression(w,p,E??$.CancellationToken.None)}catch{return}})));if(B.length>0){let O=B[0].expression;const P=B[0].range;return O||(O=w.getLineContent(p.lineNumber).substring(P.startColumn-1,P.endColumn-1)),{range:P,matchingExpression:O}}}else{const A=w.getLineContent(p.lineNumber),{start:B,end:O}=f(A,p.column,p.column),P=A.substring(B-1,O);return{matchingExpression:P,range:new b.$Fs(p.lineNumber,B,p.lineNumber,B+P.length)}}return null}e.$VF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(L){return!!(L&&L.match(i))}e.$WF=n;function o(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(n(L.path))return N.URI.parse(L.path);if((0,g.$ic)(L.path))return N.URI.file(L.path)}return L.path}function a(L){if(typeof L.path=="object"){const w=N.URI.revive(L.path);if(w)return w.scheme===R.Schemas.file?w.fsPath:w.toString()}return L.path}function t(L,w){const p=w?o:a,E=(0,I.$gn)(L);return d(E,(A,B)=>{A&&B&&(B.path=p(B))}),E}e.$XF=t;function r(L,w){const p=w?o:a,E=(0,I.$gn)(L);return d(E,(A,B)=>{!A&&B&&(B.path=p(B))}),E}e.$YF=r;function d(L,w){switch(L.type){case"event":{const p=L;switch(p.event){case"output":w(!1,p.body.source);break;case"loadedSource":w(!1,p.body.source);break;case"breakpoint":w(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=L;switch(p.command){case"setBreakpoints":w(!0,p.arguments.source);break;case"breakpointLocations":w(!0,p.arguments.source);break;case"source":w(!0,p.arguments.source);break;case"gotoTargets":w(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(E=>w(!1,E));break;default:break}break}case"response":{const p=L;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(E=>w(!1,E.source));break;case"loadedSources":p.body.sources.forEach(E=>w(!1,E));break;case"scopes":p.body.scopes.forEach(E=>w(!1,E.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"setBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"disassemble":p.body?.instructions.forEach(A=>w(!1,A.location));break;default:break}break}}}function l(L){return L.filter(w=>!w.presentation?.hidden).sort((w,p)=>w.presentation?p.presentation?w.presentation.group?p.presentation.group?w.presentation.group!==p.presentation.group?w.presentation.group.localeCompare(p.presentation.group):c(w.presentation.order,p.presentation.order):-1:p.presentation.group?1:c(w.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$ZF=l;function c(L,w){return typeof L!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:L-w}async function h(L,w){const p=L.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(p!=="none"&&(await w.saveAll(),p==="allEditorsInActiveGroup")){const E=w.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await w.save({editor:E.input,groupId:E.group.id})}await L.reloadConfiguration()}e.$1F=h;const S=(L,w)=>!L||!w?L===w:L.name===w.name&&L.path===w.path&&L.sourceReference===w.sourceReference;e.$2F=S}),define(Se[283],ke([1,0,51,62,24,16,11,13,31,229,140]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=e.$chc=e.$bhc=e.$ahc=void 0;class C extends M.$llb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const a of o){const t=a.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$ahc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$bhc=m;class v extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$chc=v;class k extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.path,s)}}e.$dhc=k;class u extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(I.$ic(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$jn(g.$gn(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=I.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(I.$ic(s.program)?n.program=s.program:n.program=I.$jc(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=u.A(o.win,i)),o.winx86&&(n.winx86=u.A(o.winx86,i)),o.windows&&(n.windows=u.A(o.windows,i)),o.osx&&(n.osx=u.A(o.osx,i)),o.linux&&(n.linux=u.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const l of s)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$7e(h.type,i)).forEach(h=>{const S=u.A(h,l.extensionLocation.fsPath);n=g.$jn(n,S,l.isBuiltin)})}let o;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$i?o=n.win||n.windows:R.$j?o=n.osx:R.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$ehc=u}),define(Se[284],ke([1,0,51,33,11]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;function I(y,M){return new Promise((C,m)=>{let v="";const k=D.spawn(y,M);k.pid&&k.stdout.on("data",u=>{v+=u.toString()}),k.on("error",u=>{m(u)}),k.on("close",u=>{C(v)})})}async function R(y){if(y)if(g.$i){const M=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{M.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(M=>{const C=M.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}e.$fhc=R;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,M,C,m,v){y=y.trim().toLowerCase();let k;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?k=1:y.indexOf("cmd.exe")>=0?k=0:y.indexOf("bash")>=0?k=2:g.$i?k=0:k=2;let u,f=" ";switch(k){case 1:if(u=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,N.$8f)(m);s&&(f+=`${s}:; `),f+=`cd ${u(m)}; `}if(v)for(const s in v){const i=v[s];i===null?f+=`Remove-Item env:${s}; `:f+=`\${env:${s}}='${i}'; `}if(M.length>0){const s=M.shift(),i=C?s:u(s);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of M)f+=n==="<"||n===">"||C?n:u(n),f+=" "}break;case 0:if(u=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,N.$8f)(m);s&&(f+=`${s}: && `),f+=`cd ${u(m)} && `}if(v){f+='cmd /C "';for(const s in v){let i=v[s];i===null?f+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${s}=${i}" && `)}}for(const s of M)f+=s==="<"||s===">"||C?s:u(s),f+=" ";v&&(f+='"');break;case 2:{u=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${u(m)} ; `),v){f+="/usr/bin/env";for(const i in v){const n=v[i];n===null?f+=` -u ${s(i)}`:f+=` ${s(`${i}=${n}`)}`}f+=" "}for(const i of M)f+=i==="<"||i===">"||C?i:u(i),f+=" ";break}}return f}e.$ghc=$}),define(Se[111],ke([1,0,22,34,52,100,17,16,11,46]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.$PI=e.$OI=e.$NI=e.CellStatusbarAlignment=e.$MI=e.$LI=e.$KI=e.NotebookEditorPriority=e.$JI=e.$II=e.$HI=e.$GI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$FI=e.$EI=e.$DI=e.$CI=e.CellKind=e.$BI=e.$AI=e.$zI=void 0,e.$zI="workbench.editor.notebook",e.$AI="workbench.editor.notebookTextDiffEditor",e.$BI="workbench.editor.interactive";var M;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(M||(e.CellKind=M={})),e.$CI=["application/json","application/javascript","text/html","image/svg+xml",I.$2r.latex,I.$2r.markdown,"image/png","image/jpeg",I.$2r.text],e.$DI=[I.$2r.latex,I.$2r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$2r.text],e.$EI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$FI="_notAvailable";var C;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var k;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var u;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var f;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(F){F.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${W.join("")}]+`),ce=7;function J(de,H){const U=H.toString(ce),ye=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,D.$Ae)(D.$ge.fromString(de.scheme),!0,!0)}`;return de.with({scheme:F.scheme,fragment:ye})}F.generate=J;function Y(de){if(de.scheme!==F.scheme)return;const H=de.fragment.indexOf("s");if(H<0)return;const U=parseInt(de.fragment.substring(0,H).replace(X,""),ce),ne=(0,D.$ze)(de.fragment.substring(H+1)).toString();if(!isNaN(U))return{handle:U,notebook:de.with({scheme:ne,fragment:null})}}F.parse=Y;function x(de,H){return de.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${de.scheme!==R.Schemas.file?de.scheme:""}`})}F.generateCellOutputUri=x;function se(de){if(de.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!H)return;const U=H[1]&&H[1]!==""?H[1]:void 0,ne=H[2];return{outputId:U,notebook:de.with({scheme:ne||R.Schemas.file,fragment:null})}}F.parseCellOutputUri=se;function Z(de,H,U){return F.generate(de,H).with({scheme:U})}F.generateCellPropertyUri=Z;function ve(de,H){if(de.scheme===H)return F.parse(de.with({scheme:F.scheme}))}F.parseCellPropertyUri=ve})(n||(e.CellUri=n={}));const o=F=>$.$i?F.replace(/\//g,"\\"):F;class a{constructor(W=[],X=e.$CI){this.e=X,this.d=[...new Set(W)].map(ce=>({pattern:ce,matches:N.$Hj(o(ce))}))}sort(W){const X=new Map(g.Iterable.map(W,J=>[J,o(J)]));let ce=[];for(const{matches:J}of this.d)for(const[Y,x]of X)if(J(x)){ce.push(Y),X.delete(Y);break}return X.size&&(ce=ce.concat([...X.keys()].sort((J,Y)=>this.e.indexOf(J)-this.e.indexOf(Y)))),ce}prioritize(W,X){const ce=this.f(W);if(ce===-1){this.d.unshift({pattern:W,matches:N.$Hj(o(W))});return}const J=new Set(X.map(x=>this.f(x,ce)));J.delete(-1);const Y=Array.from(J).sort();this.d.splice(ce+1,0,...Y.map(x=>this.d[x]));for(let x=Y.length-1;x>=0;x--)this.d.splice(Y[x],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const ce=o(W);for(let J=0;J<X;J++)if(this.d[J].matches(ce))return J;return-1}}e.$GI=a;function t(F,W,X,ce=(J,Y)=>J===Y){const J=[];function Y(Z,ve,de){if(ve===0&&de.length===0)return;const H=J[J.length-1];H&&H.start+H.deleteCount===Z?(H.deleteCount+=ve,H.toInsert.push(...de)):J.push({start:Z,deleteCount:ve,toInsert:de})}let x=0,se=0;for(;;){if(x===F.length){Y(x,0,W.slice(se));break}if(se===W.length){Y(x,F.length-x,[]);break}const Z=F[x],ve=W[se];if(ce(Z,ve)){x+=1,se+=1;continue}X(ve)?(Y(x,1,[]),x+=1):(Y(x,0,[ve]),se+=1)}return J}e.$HI=t,e.$II=new y.$fj("notebookEditorCursorAtBoundary","none"),e.$JI=new y.$fj("notebookEditorCursorAtLineBoundary","none");var r;(function(F){F.default="default",F.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(F){const W=F;return!!((typeof W.include=="string"||N.$Ij(W.include))&&(typeof W.exclude=="string"||N.$Ij(W.exclude)))}e.$KI=d;function l(F,W,X){if(Array.isArray(F.viewType)&&F.viewType.indexOf(W)>=0||F.viewType===W)return!0;if(F.filenamePattern){const ce=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,J=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(N.$Gj(ce,(0,b.$nc)(X.fsPath).toLowerCase()))return!(J&&N.$Gj(J,(0,b.$nc)(X.fsPath).toLowerCase()))}return!1}e.$LI=l,e.$MI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$NI=h;function S(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$OI=S;const L=new TextDecoder;function w(F){const W=[];let X=!1;for(const x of F)(W.length===0||X)&&(W.push(x),X=!0);let ce=A(W);const J=D.$ge.concat(W.map(x=>D.$ge.wrap(x))),Y=T(J);return ce=ce||Y.byteLength!==J.byteLength,{data:Y,didCompression:ce}}e.$PI=w,e.$QI=`${String.fromCharCode(27)}[A`;const p=e.$QI.split("").map(F=>F.charCodeAt(0)),E=10;function A(F){let W=!1;return F.forEach((X,ce)=>{if(ce===0||X.length<e.$QI.length)return;const J=F[ce-1],Y=X.subarray(0,e.$QI.length);if(Y[0]===p[0]&&Y[1]===p[1]&&Y[2]===p[2]){const x=J.lastIndexOf(E);if(x===-1)return;W=!0,F[ce-1]=J.subarray(0,x),F[ce]=X.subarray(e.$QI.length)}}),W}function B(F){let W=F;do F=W,W=F.replace(/[^\n]\x08/gm,"");while(W.length<F.length);return F}function O(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const W=F.match(/^(.*)\r+/m)[1];let X=F.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return F}const P="\b".charCodeAt(0),j="\r".charCodeAt(0);function T(F){return!F.buffer.includes(P)&&!F.buffer.includes(j)?F:D.$ge.fromString(O(B(L.decode(F.buffer))))}}),define(Se[7],ke([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k){"use strict";var u,f,s,i,n,o,a,t,r,d,l,c,h,S,L,w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$DM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$CM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.TestRunProfileKind=e.TestResultState=e.$iM=e.$hM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$gM=e.NotebookVariablesRequestKind=e.$fM=e.$eM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$dM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.ColorThemeKind=e.$0L=e.$9L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$8L=e.DebugConsoleMode=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$2L=e.$1L=e.FileChangeType=e.$ZL=e.$YL=e.$XL=e.$WL=e.InlineCompletionTriggerKind=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.ConfigurationTarget=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zL=e.ViewBadge=e.ProgressLocation=e.$yL=e.$xL=e.TaskScope=e.ShellQuoting=e.$wL=e.$vL=e.$uL=e.TaskPanelKind=e.TaskRevealKind=e.$tL=e.TerminalLocation=e.$sL=e.$rL=e.$qL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pL=e.$oL=e.$nL=e.$mL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$lL=e.StatusBarAlignment=e.ViewColumn=e.$kL=e.$jL=e.$iL=e.$hL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gL=e.$fL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.LanguageStatusSeverity=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.CodeActionTriggerKind=e.$6K=e.$5K=e.SymbolTag=e.SymbolKind=e.$4K=e.$3K=e.DocumentHighlightKind=e.$2K=e.$1K=e.$ZK=e.$YK=e.DiagnosticSeverity=e.DiagnosticTag=e.$XK=e.$WK=e.FileEditType=e.$VK=e.$UK=e.$TK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(K){return Object.assign(K,{apply:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const Me=pe.length===1?[]:pe[1];return Reflect.construct(K,Me,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const[Me,...xe]=pe;return Reflect.construct(K,xe,Me.constructor)}}})}var A;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var B;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(B||(e.TerminalQuickFixType=B={}));let O=u=class{static from(...q){let pe=q;return new u(function(){if(pe){for(const Me of pe)Me&&typeof Me.dispose=="function"&&Me.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$MK=O,e.$MK=O=u=Je([E],O);let P=f=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const xe=q[Me];xe.isBefore(pe)&&(pe=xe)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const xe=q[Me];xe.isAfter(pe)&&(pe=xe)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:pe,character:Me}=q;return typeof pe=="number"&&typeof Me=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("line must be non-negative");if(pe<0)throw(0,N.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,N.$7)();let Me;return typeof q>"u"?Me=0:typeof q=="number"?Me=q:(Me=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Me===0&&pe===0?this:new f(this.line+Me,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,N.$7)();let Me;return typeof q>"u"?Me=this.line:typeof q=="number"?Me=q:(Me=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Me===this.line&&pe===this.character?this:new f(Me,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$NK=P,e.$NK=P=f=Je([E],P);let j=s=class{static isRange(q){return q instanceof s?!0:q?P.isPosition(q.start)&&P.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Me,xe){let it,ut;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof xe=="number"?(it=new P(q,pe),ut=new P(Me,xe)):P.isPosition(q)&&P.isPosition(pe)&&(it=P.of(q),ut=P.of(pe)),!it||!ut)throw new Error("Invalid arguments");it.isBefore(ut)?(this.c=it,this.e=ut):(this.c=ut,this.e=it)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):P.isPosition(q)?!(P.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=P.Max(q.start,this.c),Me=P.Min(q.end,this.e);if(!pe.isAfter(Me))return new s(pe,Me)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=P.Min(q.start,this.c),Me=P.Max(q.end,this.end);return new s(pe,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,N.$7)();let Me;return q?P.isPosition(q)?Me=q:(Me=q.start||this.start,pe=q.end||this.end):Me=this.start,Me.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Me,pe)}toJSON(){return[this.start,this.end]}};e.$OK=j,e.$OK=j=s=Je([E],j);let T=i=class extends j{static isSelection(q){return q instanceof i?!0:q?j.isRange(q)&&P.isPosition(q.anchor)&&P.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Me,xe){let it,ut;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof xe=="number"?(it=new P(q,pe),ut=new P(Me,xe)):P.isPosition(q)&&P.isPosition(pe)&&(it=P.of(q),ut=P.of(pe)),!it||!ut)throw new Error("Invalid arguments");super(it,ut),this.f=it,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$PK=T,e.$PK=T=i=Je([E],T);const F=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,N.$7)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Me){if(typeof q!="string"||q.length===0)throw(0,N.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,N.$7)("port");typeof Me<"u"&&F(Me),this.host=q,this.port=Math.round(pe),this.connectionToken=Me}}e.$QK=W;class X{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&F(pe)}}e.$RK=X;class ce extends Error{static NotAvailable(q,pe){return new ce(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new ce(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=v.RemoteAuthorityResolverErrorCode.Unknown,Me){super(q),this._message=q,this._code=pe,this._detail=Me,Object.setPrototypeOf(this,ce.prototype)}}e.$SK=ce;var J;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var Y;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let x=n=class{static isTextEdit(q){return q instanceof n?!0:q?j.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new n(q,pe)}static insert(q,pe){return n.replace(new j(q,q),pe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const pe=new n(new j(new P(0,0),new P(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!j.isRange(q))throw(0,N.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$TK=x,e.$TK=x=n=Je([E],x);let se=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?_t.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new o(q,pe)}static insertCells(q,pe){return new o(new _t(q,q),pe)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,pe){const Me=new o(new _t(q,q),[]);return Me.newCellMetadata=pe,Me}static updateNotebookMetadata(q){const pe=new o(new _t(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$UK=se,e.$UK=se=o=Je([E],se);class Z{static isSnippetTextEdit(q){return q instanceof Z?!0:q?j.isRange(q.range)&&H.isSnippetString(q.snippet):!1}static replace(q,pe){return new Z(q,pe)}static insert(q,pe){return Z.replace(new j(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$VK=Z;var ve;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let de=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Me,xe){this.c.push({_type:1,from:q,to:pe,options:Me,metadata:xe})}createFile(q,pe,Me){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Me})}deleteFile(q,pe,Me){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Me})}e(q,pe,Me){this.c.push({_type:3,metadata:Me,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Me,xe){const it=pe.start,ut=pe.end;(it!==ut||Me.length>0)&&this.c.push({_type:5,uri:q,index:it,count:ut-it,cells:Me,metadata:xe})}g(q,pe,Me,xe){this.c.push({_type:3,metadata:xe,uri:q,edit:{editType:3,index:pe,metadata:Me}})}replace(q,pe,Me,xe){this.c.push({_type:2,uri:q,edit:new x(pe,Me),metadata:xe})}insert(q,pe,Me,xe){this.replace(q,new j(pe,pe),Me,xe)}delete(q,pe,Me){this.replace(q,pe,"",Me)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Me of pe){if(!Me)continue;let xe,it;Array.isArray(Me)?(xe=Me[0],it=Me[1]):xe=Me,se.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(q,xe.range.start,xe.newCellMetadata,it):xe.newNotebookMetadata?this.e(q,xe.newNotebookMetadata,it):this.f(q,xe.range,xe.newCells,it):Z.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:q,range:xe.range,edit:xe.snippet,metadata:it}):this.c.push({_type:2,uri:q,edit:xe,metadata:it})}else{for(let Me=0;Me<this.c.length;Me++){const xe=this.c[Me];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===q.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const pe=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===q.toString()&&pe.push(Me.edit);return pe}entries(){const q=new I.$Ac;for(const pe of this.c)if(pe._type===2){let Me=q.get(pe.uri);Me||(Me=[pe.uri,[]],q.set(pe.uri,Me)),Me[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$WK=de,e.$WK=de=Je([E],de);let H=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Me=new a;Me.e=this.e,q(Me),this.e=Me.e,q=Me.value}else q=a.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Me=q.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Me=new a;Me.e=this.e,pe(Me),this.e=Me.e,pe=Me.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$XK=H,e.$XK=H=a=Je([E],H);var U;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?j.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(j.isRange(pe))this.range=j.of(pe);else if(P.isPosition(pe))this.range=new j(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$YK=ye,e.$YK=ye=t=Je([E],ye);let he=class{static is(q){return q?typeof q.message=="string"&&q.location&&j.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$ZK=he,e.$ZK=he=Je([E],he);let ge=class{constructor(q,pe,Me=ne.Error){if(!j.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Me}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$ub)(q.tags,pe.tags)&&(0,D.$ub)(q.relatedInformation,pe.relatedInformation,he.isEqual)}};e.$1K=ge,e.$1K=ge=Je([E],ge);let _=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$2K=_,e.$2K=_=Je([E],_);var ie;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,pe=ie.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$3K=G,e.$3K=G=Je([E],G);let te=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$4K=te,e.$4K=te=Je([E],te);var fe;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var we;(function(K){K[K.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ae=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Me,xe,it){this.name=q,this.kind=pe,this.containerName=it,typeof Me=="string"&&(this.containerName=Me),xe instanceof ye?this.location=xe:Me instanceof j&&(this.location=new ye(xe,Me)),r.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$5K=Ae,e.$5K=Ae=r=Je([E],Ae);let be=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,pe,Me,xe,it){this.name=q,this.detail=pe,this.kind=Me,this.range=xe,this.selectionRange=it,this.children=[],d.validate(this)}};e.$6K=be,e.$6K=be=d=Je([E],be);var De;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let z=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$7K=z,e.$7K=z=Je([E],z);let Q=class{static{l=this}static{this.c="."}constructor(q){this.value=q}append(q){return new l(this.value?this.value+l.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+l.c)}};e.$8K=Q,e.$8K=Q=l=Je([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9K=ee,e.$9K=ee=Je([E],ee);class V{constructor(q,pe,Me,xe,it,ut){this.kind=q,this.name=pe,this.detail=Me,this.uri=xe,this.range=it,this.selectionRange=ut}}e.$0K=V;class oe{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$$K=oe;class le{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$_K=le;var Le;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$aL=je,e.$aL=je=Je([E],je);let He=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new g.$ck(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$bL=He,e.$bL=He=c=Je([E],He);let Ye=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$cL=Ye,e.$cL=Ye=Je([E],Ye);let _e=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$dL=_e,e.$dL=_e=Je([E],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eL=at,e.$eL=at=Je([E],at);var Pe;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Pe||(e.SignatureHelpTriggerKind=Pe={}));var Oe;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let qe=class{constructor(q){this.value=q}};e.$fL=qe,e.$fL=qe=Je([E],qe);let Xe=class{constructor(q,pe,Me){this.position=q,this.label=pe,this.kind=Me}};e.$gL=Xe,e.$gL=Xe=Je([E],Xe);var Fe;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Fe||(e.CompletionTriggerKind=Fe={}));var nt;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(nt||(e.CompletionItemKind=nt={}));var ae;(function(K){K[K.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let ue=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&nt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hL=ue,e.$hL=ue=Je([E],ue);let Ie=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$iL=Ie,e.$iL=Ie=Je([E],Ie);let Ke=class{constructor(q,pe,Me){this.insertText=q,this.range=pe,this.command=Me}};e.$jL=Ke,e.$jL=Ke=Je([E],Ke);let Qe=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$kL=Qe,e.$kL=Qe=Je([E],Qe);var rt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function Be(K,q){return`${C.$fm.toKey(K)}.${q}`}e.$lL=Be;var yt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Mt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Kt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var zt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var vt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(vt||(e.TextDocumentChangeReason=vt={}));var Vt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Vt||(e.DecorationRangeBehavior=Vt={})),function(K){function q(pe){switch(pe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ft;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Ft||(e.SyntaxTokenType=Ft={})),function(K){function q(pe){switch(pe){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(Ft||(e.SyntaxTokenType=Ft={}));let Qt=class{constructor(q,pe){if(pe&&!y.URI.isUri(pe))throw(0,N.$7)("target");if(!j.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.target=pe}};e.$mL=Qt,e.$mL=Qt=Je([E],Qt);let Ot=class{constructor(q,pe,Me,xe){this.red=q,this.green=pe,this.blue=Me,this.alpha=xe}};e.$nL=Ot,e.$nL=Ot=Je([E],Ot);let It=class{constructor(q,pe){if(pe&&!(pe instanceof Ot))throw(0,N.$7)("color");if(!j.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.color=pe}};e.$oL=It,e.$oL=It=Je([E],It);let tt=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$7)("label");this.label=q}};e.$pL=tt,e.$pL=tt=Je([E],tt);var Ht;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Gt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var lt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(q,pe,Me){if(this.startIndex=q,this.length=pe,this.tooltip=Me,typeof q!="number"||q<0)throw(0,N.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,N.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,N.$7)("tooltip")}}e.$qL=$t;class jt{constructor(q){this.uri=q}}e.$rL=jt;class Ut{constructor(q){this.terminalCommand=q}}e.$sL=Ut;var St;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class dt{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$7)("options")}}e.$tL=dt;var Pt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Xt;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let kt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,N.$7)("name");this.c=q}get id(){return this.c}};e.$uL=kt,e.$uL=kt=h=Je([E],kt);function Ze(K){let q="";for(let pe=0;pe<K.length;pe++)q+=K[pe].replace(/,/g,",,")+",";return q}let Lt=class{constructor(q,pe,Me){if(typeof q!="string")throw(0,N.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Me):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Ze(q)}};e.$vL=Lt,e.$vL=Lt=Je([E],Lt);let Wt=class{constructor(q,pe,Me){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,N.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q,this.f=pe,this.g=Me}else{if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Ze(q)}};e.$wL=Wt,e.$wL=Wt=Je([E],Wt);var Jt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var gt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Rt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,M.$lg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$xL=Rt;let Re=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Me,xe,it,ut){this.k=!1,this.l=this.definition=q;let ft;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Me,this.execution=xe,ft=it,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.n=this.name=Me,this.u=this.source=xe,this.execution=it,ft=ut):(this.target=pe,this.n=this.name=Me,this.u=this.source=xe,this.execution=it,ft=ut),typeof ft=="string"?(this.q=[ft],this.r=!0):Array.isArray(ft)?(this.q=ft,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Lt?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Rt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,M.$lg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,N.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const pe=this.l.type;(S.g===pe||S.e===pe||S.f===pe||S.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$yL=Re,e.$yL=Re=S=Je([E],Re);var Ne;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Ne||(e.ProgressLocation=Ne={}));var Ce;(function(K){function q(pe){const Me=pe;return(0,$.$Hf)(Me.value)?Me.tooltip&&!(0,$.$Df)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}K.isViewBadge=q})(Ce||(e.ViewBadge=Ce={}));let re=L=class{static isTreeItem(q,pe){const Me=q;if(Me.checkboxState!==void 0){const xe=(0,$.$Hf)(Me.checkboxState)?Me.checkboxState:(0,$.$Ff)(Me.checkboxState)&&(0,$.$Hf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,it=!(0,$.$Hf)(Me.checkboxState)&&(0,$.$Ff)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(xe===void 0||xe!==Ve.Checked&&xe!==Ve.Unchecked||it!==void 0&&!(0,$.$Df)(it))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(q instanceof L)return!0;if(Me.label!==void 0&&!(0,$.$Df)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$Df)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$Df)(Me.iconPath)&&!y.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$Df)(Me.iconPath.id))){const xe=Me.iconPath;if(!xe||!(0,$.$Df)(xe.light)&&!y.URI.isUri(xe.light)&&!(0,$.$Df)(xe.dark)&&!y.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$Df)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!y.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$Df)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Te.None&&Me.collapsibleState>Te.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$Df)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(q,pe=Te.None){this.collapsibleState=pe,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$zL=re,e.$zL=re=L=Je([E],re);var Te;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Te||(e.TreeItemCollapsibleState=Te={}));var Ve;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Ve||(e.TreeItemCheckboxState=Ve={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$AL=et,e.$AL=et=Je([E],et);class Ge extends et{}e.$BL=Ge;class st extends Ge{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$CL=st;class mt{constructor(q,pe,Me,xe){this.name=q,this.uri=pe,this._itemId=Me,this.c=xe}data(){return this.c()}}e.$DL=mt;let Bt=class{#e=new Map;constructor(q){for(const[pe,Me]of q??[]){const xe=this.#e.get(this.#t(pe));xe?xe.push(Me):this.#e.set(this.#t(pe),[Me])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Me,xe]of this.#e)for(const it of xe)q.call(pe,it,Me,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Me of pe)yield[q,Me]}#t(q){return q.toLowerCase()}};e.$EL=Bt,e.$EL=Bt=Je([E],Bt);let Et=class{constructor(q){this.insertText=q}};e.$FL=Et,e.$FL=Et=Je([E],Et);let Dt=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$GL=Dt,e.$GL=Dt=Je([E],Dt);let wt=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$HL=wt,e.$HL=wt=Je([E],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let mi=class{constructor(q){this.id=q}};e.$IL=mi,e.$IL=mi=Je([E],mi);var At;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let ki=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,N.$7)("base");if(typeof pe!="string")throw(0,N.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$JL=ki,e.$JL=ki=Je([E],ki);const qi=new WeakMap;function Ct(K,q){qi.set(K,q)}e.$KL=Ct;let ni=class{constructor(q,pe,Me,xe){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Me=="string"&&(this.hitCondition=Me),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=qi.get(this)??(0,M.$lg)()),this.c}};e.$LL=ni,e.$LL=ni=Je([E],ni);let $i=class extends ni{constructor(q,pe,Me,xe,it){if(super(pe,Me,xe,it),q===null)throw(0,N.$7)("location");this.location=q}};e.$ML=$i,e.$ML=$i=Je([E],$i);let ai=class extends ni{constructor(q,pe,Me,xe,it){super(pe,Me,xe,it),this.functionName=q}};e.$NL=ai,e.$NL=ai=Je([E],ai);let Di=class extends ni{constructor(q,pe,Me,xe,it,ut,ft){if(super(xe,it,ut,ft),!pe)throw(0,N.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Me}};e.$OL=Di,e.$OL=Di=Je([E],Di);let Ci=class{constructor(q,pe,Me){this.command=q,this.args=pe||[],this.options=Me}};e.$PL=Ci,e.$PL=Ci=Je([E],Ci);let Tt=class{constructor(q,pe){this.port=q,this.host=pe}};e.$QL=Tt,e.$QL=Tt=Je([E],Tt);let bi=class{constructor(q){this.path=q}};e.$RL=bi,e.$RL=bi=Je([E],bi);let Ii=class{constructor(q){this.implementation=q}};e.$SL=Ii,e.$SL=Ii=Je([E],Ii);let ci=class{constructor(q,pe,Me){this.session=q,this.threadId=pe,this.frameId=Me}};e.$TL=ci,e.$TL=ci=Je([E],ci);let ui=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$UL=ui,e.$UL=ui=Je([E],ui);let ht=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$VL=ht,e.$VL=ht=Je([E],ht);var Vi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let xt=class{constructor(q,pe){this.range=q,this.text=pe}};e.$WL=xt,e.$WL=xt=Je([E],xt);let ri=class{constructor(q,pe,Me=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Me}};e.$XL=ri,e.$XL=ri=Je([E],ri);let di=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$YL=di,e.$YL=di=Je([E],di);let Pi=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$ZL=Pi,e.$ZL=Pi=Je([E],Pi);var Ki;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ai=w=class extends Error{static FileExists(q){return new w(q,m.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,m.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,m.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,m.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,pe=m.FileSystemProviderErrorCode.Unknown,Me){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Me?.name??"Unknown",(0,m.$zk)(this,pe),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$1L=Ai,e.$1L=Ai=w=Je([E],Ai);let pi=class{constructor(q,pe,Me){this.start=q,this.end=pe,this.kind=Me}};e.$2L=pi,e.$2L=pi=Je([E],pi);var Hi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Li;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var li;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var wi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$3L=Ri;function cn(K){return typeof K>"u"||(0,$.$Ef)(K)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Me=q.tokenTypes.length;pe<Me;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Me=q.tokenModifiers.length;pe<Me;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Me,xe,it){if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof xe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.o(q,pe,Me,xe,it);if(j.isRange(q)&&typeof pe=="string"&&cn(Me))return this.n(q,pe,Me);throw(0,N.$7)()}n(q,pe,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const xe=q.start.line,it=q.start.character,ut=q.end.character-q.start.character,ft=this.k.get(pe);let qt=0;if(Me)for(const Zt of Me){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Zt);qt|=1<<ti>>>0}this.o(xe,it,ut,ft,qt)}o(q,pe,Me,xe,it){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const qt=this.g.length/5|0;let Zt=0,ti=0;for(let ii=0;ii<qt;ii++){let oi=this.g[5*ii],Ui=this.g[5*ii+1];oi===0?(oi=Zt,Ui+=ti):oi+=Zt,this.g[5*ii]=oi,this.g[5*ii+1]=Ui,Zt=oi,ti=Ui}}let ut=q,ft=pe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(ft-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=ft,this.g[this.j++]=Me,this.g[this.j++]=xe,this.g[this.j++]=it,this.c=q,this.e=pe}static q(q){const pe=[],Me=q.length/5|0;for(let ft=0;ft<Me;ft++)pe[ft]=ft;pe.sort((ft,qt)=>{const Zt=q[5*ft],ti=q[5*qt];if(Zt===ti){const ii=q[5*ft+1],oi=q[5*qt+1];return ii-oi}return Zt-ti});const xe=new Uint32Array(q.length);let it=0,ut=0;for(let ft=0;ft<Me;ft++){const qt=5*pe[ft],Zt=q[qt+0],ti=q[qt+1],ii=q[qt+2],oi=q[qt+3],Ui=q[qt+4],kn=Zt-it,On=kn===0?ti-ut:ti,Wi=5*ft;xe[Wi+0]=kn,xe[Wi+1]=On,xe[Wi+2]=ii,xe[Wi+3]=oi,xe[Wi+4]=Ui,it=Zt,ut=ti}return xe}build(q){return this.f?new si(new Uint32Array(this.g),q):new si(Mi.q(this.g),q)}}e.$4L=Mi;class si{constructor(q,pe){this.resultId=pe,this.data=q}}e.$5L=si;class un{constructor(q,pe,Me){this.start=q,this.deleteCount=pe,this.data=Me}}e.$6L=un;class ln{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$7L=ln;var Ji;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$8L=fi,e.$8L=fi=Je([E],fi);var Qi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var gi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Zi{static validate(q){if(typeof q.badge=="string"){let pe=(0,b.$ef)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,b.$ef)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!wt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Me){this.badge=q,this.tooltip=pe,this.color=Me}}e.$9L=Zi;let Fi=class{constructor(q){this.kind=q}};e.$0L=Fi,e.$0L=Fi=Je([E],Fi);var Ti;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(q){return q instanceof _t?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,N.$7)("start must be positive");if(pe<0)throw(0,N.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Me=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Me=q.end),pe===this.c&&Me===this.e?this:new _t(pe,Me)}}e.$$L=_t;class vi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>vi.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Me,xe,it,ut,ft){this.kind=q,this.value=pe,this.languageId=Me,this.mime=xe,this.outputs=it??[],this.metadata=ut,this.executionSummary=ft,vi.validate(this)}}e.$_L=vi;class hn{constructor(q){this.cells=q}}e.$aM=hn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Yt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Yt(q,pe)}static#e=new TextEncoder;static text(q,pe=R.$2r.text){const Me=Yt.#e.encode(String(q));return new Yt(Me,pe)}static json(q,pe="text/x-json"){const Me=JSON.stringify(q,void 0,"	");return Yt.text(Me,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Me=(0,R.$6r)(pe,!0);if(!Me)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$bM=Yt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Me=new Set,xe=new Set;for(let it=0;it<q.length;it++){const ut=q[it],ft=(0,R.$6r)(ut.mime);if(!Me.has(ft)||(0,k.$OI)(ft)){Me.add(ft);continue}xe.add(it),pe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return xe.size===0?q:q.filter((it,ut)=>!xe.has(ut))}constructor(q,pe,Me){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Me):(this.id=(0,M.$lg)(),this.metadata=pe??Me)}}e.$cM=yi;var Ei;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Ni;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var Ue;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ei;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(q,pe){this.text=q,this.alignment=pe}}e.$dM=Xi;var bt;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var xi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$3b)(pe)}}e.$eM=dn;class _i{constructor(q){this.label=q}}e.$fM=_i;var en;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$gM=hi,e.$gM=hi=Je([E],hi);var tn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$hM=sn;class fn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$iM=fn;var on;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(q=void 0,pe=void 0,Me=void 0,xe=!1){this.include=q,this.exclude=pe,this.profile=Me,this.continuous=xe}};e.$jM=Oi,e.$jM=Oi=Je([E],Oi);let ji=p=class{static diff(q,pe,Me){const xe=new p(q);return xe.expectedOutput=pe,xe.actualOutput=Me,xe}constructor(q){this.message=q}};e.$kM=ji,e.$kM=ji=p=Je([E],ji);let Bi=class{constructor(q){this.id=q}};e.$lM=Bi,e.$lM=Bi=Je([E],Bi);class Si{constructor(q,pe){this.covered=q,this.total=pe}}e.$mM=Si;class zi{static fromDetails(q,pe){const Me=new Si(0,0),xe=new Si(0,0),it=new Si(0,0);for(const ft of pe)if("branches"in ft){Me.total+=1,Me.covered+=ft.executionCount>0?1:0;for(const qt of ft.branches)xe.total+=1,xe.covered+=qt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ut=new zi(q,Me,xe.total>0?xe:void 0,it.total>0?it:void 0);return ut.detailedCoverage=pe,ut}constructor(q,pe,Me,xe){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Me,this.functionCoverage=xe}}e.$nM=zi;class gn{constructor(q,pe,Me=[]){this.executionCount=q,this.location=pe,this.branches=Me}}e.$oM=gn;class mn{constructor(q,pe){this.executionCount=q,this.location=pe}}e.$pM=mn;class $e{constructor(q,pe,Me){this.name=q,this.executionCount=pe,this.location=Me}}e.$qM=$e;var Ee;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var ze;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var ct;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(ct||(e.PortAutoForwardAction=ct={}));class pt{constructor(q,pe,Me,xe,it,ut){this.kind=q,this.name=pe,this.detail=Me,this.uri=xe,this.range=it,this.selectionRange=ut}}e.$rM=pt;class Nt{constructor(q){this.uri=q}}e.$sM=Nt;class Dn{constructor(q,pe){this.original=q,this.modified=pe}}e.$tM=Dn;class Cn{constructor(q,pe,Me,xe){this.base=q,this.input1=pe,this.input2=Me,this.result=xe}}e.$uM=Cn;class In{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$vM=In;class Pn{constructor(q){this.viewType=q}}e.$wM=Pn;class An{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$xM=An;class Ln{constructor(q,pe,Me){this.original=q,this.modified=pe,this.notebookType=Me}}e.$yM=Ln;class Rn{constructor(){}}e.$zM=Rn;class Mn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$AM=Mn;class Fn{constructor(q){this.providerId=q}}e.$BM=Fn;var $n;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var pn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Tn{constructor(q,pe){this.label=q,this.values=pe}}e.$CM=Tn;var wn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));class Nn{constructor(q,pe){this.role=q,this.content=pe}}e.$DM=Nn;var yn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Sn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Se[141],ke([1,0,60,17,13,176,126,7,19]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0;const y=new Map;function M(k,u){u?y.set(k,u):y.delete(k)}e.$QM=M;function C(k){return y.get(k)}class m extends I.$9u{constructor(u,f,s,i,n,o,a,t){super(f,s,i,n),this.c=u,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,$.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===N.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(f){return f?u.s(f):u.getText()},get eol(){return u.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(f){return u.t(f)},offsetAt(f){return u.u(f)},positionAt(f){return u.v(f)},validateRange(f){return u.w(f)},validatePosition(f){return u.x(f)},getWordRangeAtPosition(f,s){return u.y(f,s)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,D.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,D.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const f=this.w(u);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const s=this.g,i=f.start.line,n=f.end.line,o=[];o.push(this.f[i].substring(f.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,f.end.character)),o.join(s)}t(u){let f;if(u instanceof b.$NK?f=u.line:typeof u=="number"&&(f=u),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new v(f,this.f[f],f===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const f=this.j.getIndexOf(u),s=this.f[f.index].length;return new b.$NK(f.index,Math.min(f.remainder,s))}w(u){if(!(u instanceof b.$OK))throw new Error("Invalid argument");const f=this.x(u.start),s=this.x(u.end);return f===u.start&&s===u.end?u:new b.$OK(f.line,f.character,s.line,s.character)}x(u){if(!(u instanceof b.$NK))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:f,character:s}=u,i=!1;if(f<0)f=0,s=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,s=this.f[f].length,i=!0;else{const n=this.f[f].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$NK(f,s):u}y(u,f){const s=this.x(u);if(!f)f=C(this.m);else if((0,g.$Te)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.$hs)(s.character+1,(0,R.$fs)(f),this.f[s.line],0);if(i)return new b.$OK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$RM=m;class v{constructor(u,f,s){this.a=u,this.b=f,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$OK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$OK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SM=v}),define(Se[285],ke([1,0,7,20,4]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;let I=class{constructor(b){this.a=new D.$0L(D.ColorThemeKind.Dark),this.b=new g.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$0L($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ugc=I,e.$Ugc=I=Je([We(0,N.$OM)],I)}),define(Se[286],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.CellExecutionUpdateType=void 0;var N;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$SI=(0,D.$1h)("INotebookExecutionService")}),define(Se[287],ke([1,0,3,29,193,99]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XPb=void 0;class R extends D.$Sc{constructor($,y,M){super(),this._source=$,this.b=y,this.c=M,this.a=void 0}f($){const y=$.getLineCount();return new N.$Fs(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$UB;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:M,disposable:C}=y.create(1);this.b=M,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$UB;y.acceptChunk($);const M=y.finish(!0),{textBuffer:C,disposable:m}=M.create(1);return this.B(m),C})),this.a}findInInputs($){const M=new I.$IB($,!1,!1,null).parseSearchRequest();if(!M)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,M,!0,5e3)}findInOutputs($){const M=new I.$IB($,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),M,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$XPb=R}),define(Se[67],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class g{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new g([b]);const y=[R.id];for(let M=$;M&&M.id!==b;M=M.parent)y.push(M.id);return y.push(b),new g(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new g(R.split("\0"))}static join(R,b){return new g([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:g.isChild(R,b)?2:g.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$CJ=g}),define(Se[89],ke([1,0,2,49,29,67]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$IJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HJ=e.$GJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EJ=e.$DJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var b;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$DJ=[2,4,8,16,32,64];const y=T=>"runId"in T;e.$EJ=y;var M;(function(T){T.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),T.deserialize=F=>({range:g.$Fs.lift(F.range),uri:D.URI.revive(F.uri)})})(M||(e.IRichLocation=M={}));var C;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(T){T.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.serialize(F.location)}),T.deserialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.deserialize(F.location)})})(m||(e.ITestErrorMessage=m={}));const v=(T,F)=>`${F?"s":"e"}${T}`;e.$FJ=v;var k;(function(T){T.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.serialize(F.location)}),T.deserialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.deserialize(F.location)})})(k||(e.ITestOutputMessage=k={}));var u;(function(T){T.serialize=F=>F.type===0?m.serialize(F):k.serialize(F),T.deserialize=F=>F.type===0?m.deserialize(F):k.deserialize(F)})(u||(e.ITestMessage=u={}));var f;(function(T){T.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),T.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(u.serialize)}),T.deserialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(u.deserialize)})})(f||(e.ITestTaskState=f={}));const s="\0",i=(T,F)=>T+s+F;e.$GJ=i;const n=T=>{const F=T.indexOf(s);return{ctrlId:T.slice(0,F),tagId:T.slice(F+1)}};e.$HJ=n;var o;(function(T){T.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),T.deserialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?D.URI.revive(F.uri):void 0,range:F.range?g.$Fs.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(o||(e.ITestItem=o={}));var a;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(T){T.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),T.deserialize=F=>({controllerId:I.$CJ.root(F.item.extId),expand:F.expand,item:o.deserialize(F.item)})})(t||(e.InternalTestItem=t={}));var r;(function(T){T.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},T.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?g.$Fs.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const d=(T,F)=>{F.expand!==void 0&&(T.expand=F.expand),F.item!==void 0&&(T.item=T.item?Object.assign(T.item,F.item):F.item)};e.$IJ=d;var l;(function(T){T.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serializeWithoutMessages)}),T.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serialize)}),T.deserialize=F=>({...t.deserialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.deserialize),retired:!0})})(l||(e.TestResultItem=l={}));var c;(function(T){T.empty=()=>({covered:0,total:0}),T.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(c||(e.ICoveredCount=c={}));var h;(function(T){T.serialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(p.serialize),uri:F.uri.toJSON()}),T.deserialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(p.deserialize),uri:D.URI.from(F.uri)})})(h||(e.IFileCoverage=h={}));function S(T){return{...T,location:T.location?.toJSON()}}function L(T){return T.location=T.location?N.$Es.isIPosition(T.location)?N.$Es.lift(T.location):g.$Fs.lift(T.location):void 0,T}e.$JJ=3;var w;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(w||(e.DetailType=w={}));var p;(function(T){T.serialize=F=>F.type===0?A.serialize(F):B.serialize(F),T.deserialize=F=>F.type===0?A.deserialize(F):B.deserialize(F)})(p||(e.CoverageDetails=p={}));var E;(function(T){T.serialize=S,T.deserialize=L})(E||(e.IBranchCoverage=E={}));var A;(function(T){T.serialize=S,T.deserialize=L})(A||(e.IFunctionCoverage=A={}));var B;(function(T){T.serialize=F=>({...S(F),branches:F.branches?.map(E.serialize)}),T.deserialize=F=>({...L(F),branches:F.branches?.map(E.deserialize)})})(B||(e.IStatementCoverage=B={}));var O;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var P;(function(T){T.deserialize=F=>F.op===0?{op:F.op,item:t.deserialize(F.item)}:F.op===1?{op:F.op,item:r.deserialize(F.item)}:F.op===2?{op:F.op,uri:D.URI.revive(F.uri),docv:F.docv}:F,T.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:r.serialize(F.item)}:F})(P||(e.TestsDiffOp=P={}));class j{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(F){const W=this.o();for(const X of F)switch(X.op){case 0:this.j(t.deserialize(X.item),W);break;case 1:this.k(r.deserialize(X.item),W);break;case 3:this.l(X.itemId,W);break;case 5:this.m(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}W.complete?.()}j(F,W){const X=I.$CJ.parentId(F.item.extId)?.toString();let ce;if(!X)ce=this.p(F),this.f.add(ce),this.d.set(F.item.extId,ce);else if(this.d.has(X)){const J=this.d.get(X);J.children.add(F.item.extId),ce=this.p(F,J),this.d.set(F.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(ce),F.expand===2&&this.g++,ce}k(F,W){const X=this.d.get(F.extId);if(X)return F.expand!==void 0&&(X.expand===2&&this.g--,F.expand===2&&this.g++),(0,e.$IJ)(X,F),W.update?.(X),X}l(F,W){const X=this.d.get(F);if(!X)return;const ce=I.$CJ.parentId(X.item.extId)?.toString();ce?this.d.get(ce).children.delete(X.item.extId):this.f.delete(X);const J=[[F]];for(;J.length;)for(const Y of J.pop()){const x=this.d.get(Y);x&&(J.push(x.children),this.d.delete(Y),W.remove?.(x,x!==X),x.expand===2&&this.g--)}}m(F){}updatePendingRoots(F){this.h+=F}o(){return{}}}e.$KJ=j}),define(Se[112],ke([1,0,12,4,3,60,89,67]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[a,t]of C)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class v extends g.$Sc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$ah(()=>this.flushDiff(),200)),this.g=this.B(new N.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$IJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$IJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(b.$CJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,I.$5c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=b.$CJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const d=this.s.getChildren(r.actual),l=r.actual,c=m(this.s.toITestItem(l),this.s.toITestItem(n));this.s.getApiFor(l).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,l.tags,a.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(n,r,o);for(const[h,S]of d)this.s.getChildren(n).get(S.id)||this.N(b.$CJ.joinToString(a,S.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$GJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$GJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$GJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(b.$CJ.joinToString(n.fullId,r.id),o);(0,D.$Ng)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$Zg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new D.$Zg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.$Ng)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$CJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$EM=v;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$FM=k;class u extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GM=u;class f extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$HM=f;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof o))throw new u(c.id);const h=n(c).controllerId;if(h!==i.controllerId)throw new f(c.id,h,i.controllerId);if(r.has(c.id))throw new k(c.id);r.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});i.listener?.(l),a=r},add(t){if(!(t instanceof o))throw new u(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$IM=s}),define(Se[142],ke([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;const N=new WeakMap,g=(R,b)=>{const $={controllerId:b};return N.set(R,$),$};e.$JM=g;const I=R=>{const b=N.get(R);if(!b)throw new D.$GM(R?.id||"<unknown>");return b};e.$KM=I}),define(Se[113],ke([1,0,17,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bvb=e.$avb=e.$_ub=e.$$ub=e.$0ub=void 0,e.$0ub="vscode-cdn.net",e.$$ub=`vscode-resource.${e.$0ub}`,e.$_ub=`'self' https://*.${e.$0ub}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$$ub}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$avb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$bvb=R}),define(Se[288],ke([1,0,4,3,113]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new N.$Rc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const M=$.getVisibleTextEditors();for(const C of this.c.values())M.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,M,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const v=this,k=this.a++,u=new D.$Sd,f=new D.$Sd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$avb)(n,v.f)}get cspSource(){return g.$_ub}set options(n){this.b=n,v.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(n){return v.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=s,this.onDidDispose=f.event}dispose(){v.c.has(k)&&(v.c.delete(k),v.d.$disposeEditorInset(k),f.fire(),f.dispose(),u.dispose())}};return this.d.$createEditorInset(k,m.id,m.value.document.uri,$+1,y,M||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:b,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$efc=I}),define(Se[289],ke([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.VariableKind=e.$AN=void 0,e.$AN=(0,D.$1h)("configurationResolverService");var N;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(N||(e.VariableKind=N={}));class g extends Error{constructor(R,b){super(b),this.variable=R}}e.$BN=g}),define(Se[290],ke([1,0,16,50,18,24,11,102,232,289,13]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,k,u,f){this.h=new Map,this.a=v,this.b=k,this.g=u,f&&(this.c=f.then(s=>this.i(s)))}i(v){if(R.$i){const k=Object.create(null);return Object.keys(v).forEach(u=>{k[u.toLowerCase()]=v[u]}),k}return v}resolveWithEnvironment(v,k,u){return this.l({env:this.i(v),userHome:void 0},k?k.uri:void 0,u)}async resolveAsync(v,k){const u={env:await this.c,userHome:await this.g};return this.l(u,v?v.uri:void 0,k)}async j(v,k,u,f){const s=I.$gn(k);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,u,f)}async resolveAnyAsync(v,k,u){return this.j(v,k,u)}async resolveAnyMap(v,k,u){const f=new Map;return{newConfig:await this.j(v,k,u,f),resolvedVariables:f}}resolveWithInteractionReplace(v,k,u,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,k,u,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,k){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,k)}async l(v,k,u,f,s){if(g.$Df(u))return this.m(v,k,u,f,s);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(v,k,i,f,s)));if(g.$Ff(u)){const i=Object.create(null),n=await Promise.all(Object.keys(u).map(async o=>[await this.m(v,k,o,f,s),await this.l(v,k,u[o],f,s)]));for(const[o,a]of n)i[o]=a;return i}return u}m(v,k,u,f,s){return(0,M.$Ye)(u,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(v,i,n,k,f);return s?.set(n,o),o!==i&&g.$Df(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(v,k,o,f,s)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,k,u,f,s){let i;const n=u.split(":");n.length>1&&(u=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,b.$Gv)(d);throw new y.$BN(r,(0,$.localize)(0,null,k))},a=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$Gv)(l)}throw new y.$BN(r,(0,$.localize)(1,null,k,D.$nc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new y.$BN(r,(0,$.localize)(2,null,k,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$BN(r,(0,$.localize)(3,null,k)):new y.$BN(r,(0,$.localize)(4,null,k))};switch(u){case"env":if(i){if(v.env){const r=v.env[R.$i?i.toLowerCase():i];if(g.$Df(r))return r}return""}throw new y.$BN(y.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(i){const r=this.a.getConfigurationValue(f,i);if(g.$Mf(r))throw new y.$BN(y.VariableKind.Config,(0,$.localize)(6,null,k,i));if(g.$Ff(r))throw new y.$BN(y.VariableKind.Config,(0,$.localize)(7,null,k,i));return r}throw new y.$BN(y.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(y.VariableKind.Command,k,i,s,"command");case"input":return this.p(y.VariableKind.Input,k,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$BN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,i));return this.n(r.extensionLocation)}throw new y.$BN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,b.$Gv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Gv)(this.n(t(y.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Gv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$BN(y.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$BN(y.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$BN(y.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$mc(o(y.VariableKind.RelativeFileDirname));if(f||i){const d=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return D.$mc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$nc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$oc(r).length)}case"fileDirnameBasename":return D.$nc(D.$mc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||k}case"execInstallFolder":{const r=this.a.getAppRoot();return r||k}case"pathSeparator":return D.sep;default:try{const r=i?`${u}:${i}`:u;return this.p(y.VariableKind.Unknown,k,r,s,void 0)}catch{return k}}}}p(v,k,u,f,s){if(u&&f){const i=s===void 0?f[u]:f[s+":"+u];if(typeof i=="string")return i;throw new y.$BN(v,(0,$.localize)(14,null,k))}return k}}e.$PN=C}),define(Se[143],ke([1,0,5,139]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.OpenEditorContext=e.GroupsOrder=e.$PC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OC=void 0,e.$OC=(0,D.$1h)("editorGroupsService");var g;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(k){const u=k;return(0,N.$xE)(u?.editor)&&(0,N.$xE)(u?.replacement)}e.$PC=y;var M;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(k){const u=k;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$QC=m;function v(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$RC=v}),define(Se[291],ke([1,0,5,143]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$UC=e.$TC=e.$SC=void 0,e.$SC=(0,D.$1h)("editorService"),e.$TC=-1,e.$UC=-2;function g(I){const R=I;return typeof I=="number"||(0,N.$QC)(R)}e.$VC=g}),define(Se[144],ke([1,0,5,133]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=void 0,e.$8J=(0,D.$2h)(N.$8h)}),define(Se[145],ke([1,0,26,4,16,3]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=e.$06b=e.$96b=e.$86b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$86b=R;class b{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new N.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(k),this.f=new D.$hm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=u(this.e,i),this.e=this.e.concat(s);const n=b.l(this.e);return this.e=u(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const l=i.getArcs(r);for(let c=0;c<l.length;c++)if(!d.has(l[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$hm;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(D.$fm.toKey(r.identifier),D.$fm.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];i.hasOnlyGoodArcs(d,o)&&(a.splice(r,1),r--,o.add(d),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$96b=b;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$06b=$;class y{constructor(s){this.d=new m,this.c=new b(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new M(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$$6b=y;class M extends I.$Sc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$_6b=M;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,I.$Qc)(o))}}var v;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(v||(v={}));function k(f,s){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$gc.basename(f.extensionLocation.path),a=g.$gc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function u(f,s){const i=new D.$gm(s);return f.filter(n=>!i.has(n.identifier))}}),define(Se[292],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ExtHostConnectionType=void 0;var D;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$Jm=N;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Km=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Lm=I;function R(M){delete M[N.ENV_KEY],delete M[g.ENV_KEY],delete M[I.ENV_KEY]}function b(M,C){R(C),M.serialize(C)}e.$Mm=b;function $(M){if(M[N.ENV_KEY])return y(M,new N(M[N.ENV_KEY]));if(M[g.ENV_KEY])return y(M,new g);if(M[I.ENV_KEY])return y(M,new I);throw new Error("No connection information defined in environment!")}e.$Nm=$;function y(M,C){return R(M),C}}),define(Se[114],ke([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$om=e.$nm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(N||(e.UIKind=N={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(y){const M=D.$ge.alloc(1);switch(y){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$nm=R;function b(y,M){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$om=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],ke([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=e.$8M=e.$7M=e.$6M=void 0;let v=class extends C.$Sc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new N.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Ao,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,g.$kj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new k(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$8k)((0,$.$Ho)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$6M=v,e.$6M=v=Je([We(0,I.$5M),We(1,g.$jj)],v);class k{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new N.$Sd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$Ko)(i,[]),this.c&&(i=(0,y.$jn)(i,this.c)),this.b||(i=(0,y.$jn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$Ko)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$7M=k;function u(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$8M=u,e.$9M=(0,D.$1h)("IExtHostTelemetry")}),define(Se[25],ke([1,0,4,2,262,137,26,5]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.$lF=e.ActivationKind=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.ExtensionHostStartup=e.$fF=e.$eF=e.$dF=e.$cF=void 0,e.$cF=Object.freeze({identifier:new R.$fm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$dF="extensions.webWorker",e.$eF=(0,b.$1h)("extensionService");class ${constructor(a){this.dependency=a}}e.$fF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$ZE.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],l=[],c=[],h=[],S=C(this.d),L=C(t),w=(O,P)=>O.extensionLocation.toString()===P.extensionLocation.toString()||O.isBuiltin===P.isBuiltin||O.isUserBuiltin===P.isUserBuiltin||O.isUnderDevelopment===P.isUnderDevelopment;for(const O of this.d){const P=L.get(O.identifier);if(!P){d.push(O.identifier),S.delete(O.identifier);continue}if(!w(O,P)){d.push(O.identifier),S.delete(O.identifier);continue}}for(const O of t){const P=S.get(O.identifier);if(!P){l.push(O);continue}if(!w(P,O)){d.push(P.identifier),S.delete(P.identifier);continue}}const p=new R.$gm(this.e),E=new R.$gm(r);for(const O of this.e)E.has(O)||c.push(O);for(const O of r)p.has(O)||h.push(O);const A=I.$ZE.createActivationEventsMap(l),B={versionId:a,toRemove:d,toAdd:l,addActivationEvents:A,myToRemove:c,myToAdd:h};return this.delta(B),B}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:l}=a,c=new R.$gm(t),h=new R.$gm(d);for(let S=0;S<this.d.length;S++)c.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)h.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of r)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$fm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=I.$ZE.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$gF=M;function C(o){const a=new R.$hm;for(const t of o)a.set(t.identifier,t);return a}function m(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$hF=m;function v(o,a){if(!m(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$iF=v;class k{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$jF=k;class u{constructor(a,t){this.description=a,this.value=t}}e.$kF=u;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$Qo)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$lF=s;function i(o,a){return{identifier:new R.$fm((0,g.$Oo)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$mF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$nF=n}),define(Se[293],ke([1,0,8,145,26,25,14,12]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=e.$Afc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Afc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Bfc=y;class M{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$Cfc=M;class C extends M{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Dfc=C;class m extends M{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Efc=m;class v extends M{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$hm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(a));return this.c.onExtensionActivationError(s.id,a,new I.$fF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),c=this.k(s,i.displayName,[],new v(l));return this.c.onExtensionActivationError(i.identifier,l,new I.$fF(a)),c}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new u(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return N.$96b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Ffc=k,e.$Ffc=k=Je([We(3,R.$ij)],k);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new b.$Zg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&D.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};u=Je([We(6,R.$ij)],u)}),define(Se[15],ke([1,0,19,22,165,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,291,7,25]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$NM=e.$MM=e.MarkdownString=e.$LM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Re){function Ne(re){const{selectionStartLineNumber:Te,selectionStartColumn:Ve,positionLineNumber:et,positionColumn:Ge}=re,st=new r.$NK(Te-1,Ve-1),mt=new r.$NK(et-1,Ge-1);return new r.$PK(st,mt)}Re.to=Ne;function Ce(re){const{anchor:Te,active:Ve}=re;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Re.from=Ce})(l||(e.Selection=l={}));var c;(function(Re){function Ne(re){if(!re)return;const{start:Te,end:Ve}=re;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Re.from=Ne;function Ce(re){if(!re)return;const{startLineNumber:Te,startColumn:Ve,endLineNumber:et,endColumn:Ge}=re;return new r.$OK(Te-1,Ve-1,et-1,Ge-1)}Re.to=Ce})(c||(e.Range=c={}));var h;(function(Re){function Ne(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Re.to=Ne})(h||(e.TokenType=h={}));var S;(function(Re){function Ne(re){return new r.$NK(re.lineNumber-1,re.column-1)}Re.to=Ne;function Ce(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Ce})(S||(e.Position=S={}));var L;(function(Re){function Ne(Te,Ve,et){return(0,D.$Hb)((0,D.$3b)(Te).map(Ge=>Ce(Ge,Ve,et)))}Re.from=Ne;function Ce(Te,Ve,et){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:et?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:re(Te.scheme,Ve),pattern:ae.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:et?.isBuiltin}}function re(Te,Ve){return Ve&&typeof Te=="string"?Ve.transformOutgoingScheme(Te):Te}})(L||(e.DocumentSelector=L={}));var w;(function(Re){function Ne(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function Ce(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Re.to=Ce})(w||(e.DiagnosticTag=w={}));var p;(function(Re){function Ne(re){let Te;return re.code&&((0,m.$Df)(re.code)||(0,m.$Hf)(re.code)?Te=String(re.code):Te={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Te,severity:A.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,D.$Hb)(re.tags.map(w.from)):void 0}}Re.from=Ne;function Ce(re){const Te=new r.$1K(c.to(re),re.message,A.to(re.severity));return Te.source=re.source,Te.code=(0,m.$Df)(re.code)?re.code:re.code?.value,Te.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Te.tags=re.tags&&(0,D.$Hb)(re.tags.map(w.to)),Te}Re.to=Ce})(p||(e.Diagnostic=p={}));var E;(function(Re){function Ne(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Ne;function Ce(re){return new r.$ZK(new r.$YK(re.resource,c.to(re)),re.message)}Re.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var A;(function(Re){function Ne(re){switch(re){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Re.from=Ne;function Ce(re){switch(re){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Re.to=Ce})(A||(e.DiagnosticSeverity=A={}));var B;(function(Re){function Ne(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$UC:t.$TC}Re.from=Ne;function Ce(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Ce})(B||(e.ViewColumn=B={}));function O(Re){return typeof Re.range<"u"}function P(Re){return Re.length===0?!0:!!O(Re[0])}e.$LM=P;var j;(function(Re){function Ne(Ge){return Ge.map(Re.from)}Re.fromMany=Ne;function Ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function re(Ge){let st;if(Ce(Ge)){const{language:Dt,value:wt}=Ge;st={value:"```"+Dt+`
`+wt+"\n```\n"}}else r.$bL.isMarkdownString(Ge)?st={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?st={value:Ge}:st={value:""};const mt=Object.create(null);st.uris=mt;const Bt=Dt=>{try{let wt=v.URI.parse(Dt,!0);wt=wt.with({query:Te(wt.query,mt)}),mt[Dt]=wt}catch{}return""},Et=new $.marked.Renderer;return Et.link=Bt,Et.image=Dt=>typeof Dt=="string"?Bt(R.$jk(Dt).href):"",(0,$.marked)(st.value,{renderer:Et}),st}Re.from=re;function Te(Ge,st){if(!Ge)return Ge;let mt;try{mt=(0,y.$wh)(Ge)}catch{}if(!mt)return Ge;let Bt=!1;return mt=(0,C.$in)(mt,Et=>{if(v.URI.isUri(Et)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Dt]=Et,Bt=!0,Dt}else return}),Bt?JSON.stringify(mt):Ge}function Ve(Ge){const st=new r.$bL(Ge.value,Ge.supportThemeIcons);return st.isTrusted=Ge.isTrusted,st.supportHtml=Ge.supportHtml,st.baseUri=Ge.baseUri?v.URI.from(Ge.baseUri):void 0,st}Re.to=Ve;function et(Ge){if(Ge)return typeof Ge=="string"?Ge:Re.from(Ge)}Re.fromStrict=et})(j||(e.MarkdownString=j={}));function T(Re){return P(Re)?Re.map(Ne=>({range:c.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?j.fromMany(Ne.hoverMessage):Ne.hoverMessage?j.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:c.from(Ne)}))}e.$MM=T;function F(Re){return typeof Re>"u"?Re:typeof Re=="string"?v.URI.file(Re):Re}e.$NM=F;var W;(function(Re){function Ne(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?F(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Re.from=Ne})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var X;(function(Re){function Ne(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Re.from=Ne})(X||(e.ThemableDecorationRenderOptions=X={}));var ce;(function(Re){function Ne(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(ce||(e.DecorationRangeBehavior=ce={}));var J;(function(Re){function Ne(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ce.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?X.from(Ce.light):void 0,dark:Ce.dark?X.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Re.from=Ne})(J||(e.DecorationRenderOptions=J={}));var Y;(function(Re){function Ne(re){return{text:re.newText,eol:re.newEol&&Oe.from(re.newEol),range:c.from(re.range)}}Re.from=Ne;function Ce(re){const Te=new r.$TK(c.to(re.range),re.text);return Te.newEol=typeof re.eol>"u"?void 0:Oe.to(re.eol),Te}Re.to=Ce})(Y||(e.TextEdit=Y={}));var x;(function(Re){function Ne(re,Te){const Ve={edits:[]};if(re instanceof r.$WK){const et=new b.$Bc;for(const Ge of re._allEntries())Ge._type===1&&v.URI.isUri(Ge.to)&&Ge.from===void 0&&et.add(Ge.to);for(const Ge of re._allEntries())if(Ge._type===1){let st;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?st={type:"base64",value:(0,N.$Ae)(N.$ge.wrap(Ge.options.contents))}:st={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:st},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:Y.from(Ge.edit),versionId:et.has(Ge.uri)?void 0:Te?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:c.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:et.has(Ge.uri)?void 0:Te?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(yt.from)}})}return Ve}Re.from=Ne;function Ce(re){const Te=new r.$WK,Ve=new b.$Ac;for(const et of re.edits)if(et.textEdit){const Ge=et,st=v.URI.revive(Ge.resource),mt=c.to(Ge.textEdit.range),Bt=Ge.textEdit.text,Et=Ge.textEdit.insertAsSnippet;let Dt;Et?Dt=r.$VK.replace(mt,new r.$XK(Bt)):Dt=r.$TK.replace(mt,Bt);const wt=Ve.get(st);wt?wt.push(Dt):Ve.set(st,[Dt])}else Te.renameFile(v.URI.revive(et.oldResource),v.URI.revive(et.newResource),et.options);for(const[et,Ge]of Ve)Te.set(et,Ge);return Te}Re.to=Ce})(x||(e.WorkspaceEdit=x={}));var se;(function(Re){const Ne=Object.create(null);Ne[r.SymbolKind.File]=0,Ne[r.SymbolKind.Module]=1,Ne[r.SymbolKind.Namespace]=2,Ne[r.SymbolKind.Package]=3,Ne[r.SymbolKind.Class]=4,Ne[r.SymbolKind.Method]=5,Ne[r.SymbolKind.Property]=6,Ne[r.SymbolKind.Field]=7,Ne[r.SymbolKind.Constructor]=8,Ne[r.SymbolKind.Enum]=9,Ne[r.SymbolKind.Interface]=10,Ne[r.SymbolKind.Function]=11,Ne[r.SymbolKind.Variable]=12,Ne[r.SymbolKind.Constant]=13,Ne[r.SymbolKind.String]=14,Ne[r.SymbolKind.Number]=15,Ne[r.SymbolKind.Boolean]=16,Ne[r.SymbolKind.Array]=17,Ne[r.SymbolKind.Object]=18,Ne[r.SymbolKind.Key]=19,Ne[r.SymbolKind.Null]=20,Ne[r.SymbolKind.EnumMember]=21,Ne[r.SymbolKind.Struct]=22,Ne[r.SymbolKind.Event]=23,Ne[r.SymbolKind.Operator]=24,Ne[r.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Ne[Te]=="number"?Ne[Te]:6}Re.from=Ce;function re(Te){for(const Ve in Ne)if(Ne[Ve]===Te)return Number(Ve);return r.SymbolKind.Property}Re.to=re})(se||(e.SymbolKind=se={}));var Z;(function(Re){function Ne(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Re.from=Ne;function Ce(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Re.to=Ce})(Z||(e.SymbolTag=Z={}));var ve;(function(Re){function Ne(re){return{name:re.name,kind:se.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:ye.from(re.location)}}Re.from=Ne;function Ce(re){const Te=new r.$5K(re.name,se.to(re.kind),re.containerName,ye.to(re.location));return Te.tags=re.tags&&re.tags.map(Z.to),Te}Re.to=Ce})(ve||(e.WorkspaceSymbol=ve={}));var de;(function(Re){function Ne(re){const Te={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:se.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Te.children=re.children.map(Ne)),Te}Re.from=Ne;function Ce(re){const Te=new r.$6K(re.name,re.detail,se.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.$Lb)(re.tags)&&(Te.tags=re.tags.map(Z.to)),re.children&&(Te.children=re.children.map(Ce)),Te}Re.to=Ce})(de||(e.DocumentSymbol=de={}));var H;(function(Re){function Ne(re){const Te=new r.$0K(se.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Te._sessionId=re._sessionId,Te._itemId=re._itemId,Te}Re.to=Ne;function Ce(re,Te,Ve){if(Te=Te??re._sessionId,Ve=Ve??re._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,name:re.name,detail:re.detail,kind:se.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Ce})(H||(e.CallHierarchyItem=H={}));var U;(function(Re){function Ne(Ce){return new r.$$K(H.to(Ce.from),Ce.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Re){function Ne(Ce){return new r.$_K(H.to(Ce.to),Ce.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(ne||(e.CallHierarchyOutgoingCall=ne={}));var ye;(function(Re){function Ne(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Re.from=Ne;function Ce(re){return new r.$YK(v.URI.revive(re.uri),c.to(re.range))}Re.to=Ce})(ye||(e.location=ye={}));var he;(function(Re){function Ne(re){const Te=re,Ve=re;return{originSelectionRange:Te.originSelectionRange?c.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Ve.uri,range:c.from(Te.targetRange?Te.targetRange:Ve.range),targetSelectionRange:Te.targetSelectionRange?c.from(Te.targetSelectionRange):void 0}}Re.from=Ne;function Ce(re){return{targetUri:v.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Re.to=Ce})(he||(e.DefinitionLink=he={}));var ge;(function(Re){function Ne(re){return{range:c.from(re.range),contents:j.fromMany(re.contents)}}Re.from=Ne;function Ce(re){return new r.$2K(re.contents.map(j.to),c.to(re.range))}Re.to=Ce})(ge||(e.Hover=ge={}));var _;(function(Re){function Ne(re){return{range:c.from(re.range),expression:re.expression}}Re.from=Ne;function Ce(re){return new r.$VL(c.to(re.range),re.expression)}Re.to=Ce})(_||(e.EvaluatableExpression=_={}));var ie;(function(Re){function Ne(re){if(re instanceof r.$WL)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.$XL)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$YL)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function Ce(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Re.to=Ce})(ie||(e.InlineValue=ie={}));var G;(function(Re){function Ne(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Re.from=Ne;function Ce(re){return new r.$ZL(re.frameId,c.to(re.stoppedLocation))}Re.to=Ce})(G||(e.InlineValueContext=G={}));var te;(function(Re){function Ne(re){return{range:c.from(re.range),kind:re.kind}}Re.from=Ne;function Ce(re){return new r.$3K(c.to(re.range),re.kind)}Re.to=Ce})(te||(e.DocumentHighlight=te={}));var fe;(function(Re){function Ne(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Re.from=Ne;function Ce(re){return new r.$4K(v.URI.revive(re.uri),re.highlights.map(te.to))}Re.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var we;(function(Re){function Ne(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Re.to=Ne})(we||(e.CompletionTriggerKind=we={}));var Ae;(function(Re){function Ne(Ce){return{triggerKind:we.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Re.to=Ne})(Ae||(e.CompletionContext=Ae={}));var be;(function(Re){function Ne(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function Ce(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Re.to=Ce})(be||(e.CompletionItemTag=be={}));var De;(function(Re){const Ne=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Ne.get(Ve)??9}Re.from=Ce;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(Ve){return re.get(Ve)??r.CompletionItemKind.Property}Re.to=Te})(De||(e.CompletionItemKind=De={}));var z;(function(Re){function Ne(Ce,re){const Te=new r.$hL(Ce.label);return Te.insertText=Ce.insertText,Te.kind=De.to(Ce.kind),Te.tags=Ce.tags?.map(be.to),Te.detail=Ce.detail,Te.documentation=R.$ek(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,k.$Fs.isIRange(Ce.range)?Te.range=c.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:c.to(Ce.range.insert),replacing:c.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new r.$XK(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof r.$OK?new r.$TK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>Y.to(Ve))),Te.command=re&&Ce.command?re.fromInternal(Ce.command):void 0,Te}Re.to=Ne})(z||(e.CompletionItem=z={}));var Q;(function(Re){function Ne(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:j.fromStrict(re.documentation)}}Re.from=Ne;function Ce(re){return{label:re.label,documentation:R.$ek(re.documentation)?j.to(re.documentation):re.documentation}}Re.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Re){function Ne(re){return{label:re.label,documentation:j.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Q.from):[],activeParameter:re.activeParameter}}Re.from=Ne;function Ce(re){return{label:re.label,documentation:R.$ek(re.documentation)?j.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Q.to):[],activeParameter:re.activeParameter}}Re.to=Ce})(ee||(e.SignatureInformation=ee={}));var V;(function(Re){function Ne(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.from):[]}}Re.from=Ne;function Ce(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.to):[]}}Re.to=Ce})(V||(e.SignatureHelp=V={}));var oe;(function(Re){function Ne(Ce,re){const Te=new r.$gL(S.to(re.position),typeof re.label=="string"?re.label:re.label.map(le.to.bind(void 0,Ce)),re.kind&&Le.to(re.kind));return Te.textEdits=re.textEdits&&re.textEdits.map(Y.to),Te.tooltip=R.$ek(re.tooltip)?j.to(re.tooltip):re.tooltip,Te.paddingLeft=re.paddingLeft,Te.paddingRight=re.paddingRight,Te}Re.to=Ne})(oe||(e.InlayHint=oe={}));var le;(function(Re){function Ne(Ce,re){const Te=new r.$fL(re.label);return Te.tooltip=R.$ek(re.tooltip)?j.to(re.tooltip):re.tooltip,u.Command.is(re.command)&&(Te.command=Ce.fromInternal(re.command)),re.location&&(Te.location=ye.to(re.location)),Te}Re.to=Ne})(le||(e.InlayHintLabelPart=le={}));var Le;(function(Re){function Ne(re){return re}Re.from=Ne;function Ce(re){return re}Re.to=Ce})(Le||(e.InlayHintKind=Le={}));var je;(function(Re){function Ne(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Ne;function Ce(re){let Te;if(re.url)try{Te=typeof re.url=="string"?v.URI.parse(re.url,!0):v.URI.revive(re.url)}catch{}return new r.$mL(c.to(re.range),Te)}Re.to=Ce})(je||(e.DocumentLink=je={}));var He;(function(Re){function Ne(re){const Te=new r.$pL(re.label);return re.textEdit&&(Te.textEdit=Y.to(re.textEdit)),re.additionalTextEdits&&(Te.additionalTextEdits=re.additionalTextEdits.map(Ve=>Y.to(Ve))),Te}Re.to=Ne;function Ce(re){return{label:re.label,textEdit:re.textEdit?Y.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Te=>Y.from(Te)):void 0}}Re.from=Ce})(He||(e.ColorPresentation=He={}));var Ye;(function(Re){function Ne(re){return new r.$nL(re[0],re[1],re[2],re[3])}Re.to=Ne;function Ce(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Ce})(Ye||(e.Color=Ye={}));var _e;(function(Re){function Ne(re){return{range:c.from(re.range)}}Re.from=Ne;function Ce(re){return new r.$9K(c.to(re.range))}Re.to=Ce})(_e||(e.SelectionRange=_e={}));var at;(function(Re){function Ne(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(at||(e.TextDocumentSaveReason=at={}));var Pe;(function(Re){function Ne(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function Ce(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Re.to=Ce})(Pe||(e.TextEditorLineNumbersStyle=Pe={}));var Oe;(function(Re){function Ne(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Re.from=Ne;function Ce(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Re.to=Ce})(Oe||(e.EndOfLine=Oe={}));var qe;(function(Re){function Ne(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(qe||(e.ProgressLocation=qe={}));var Xe;(function(Re){function Ne(re){const Te={start:re.start+1,end:re.end+1};return re.kind&&(Te.kind=Fe.from(re.kind)),Te}Re.from=Ne;function Ce(re){const Te={start:re.start-1,end:re.end-1};return re.kind&&(Te.kind=Fe.to(re.kind)),Te}Re.to=Ce})(Xe||(e.FoldingRange=Xe={}));var Fe;(function(Re){function Ne(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return u.$vt.Comment;case r.FoldingRangeKind.Imports:return u.$vt.Imports;case r.FoldingRangeKind.Region:return u.$vt.Region}}Re.from=Ne;function Ce(re){if(re)switch(re.value){case u.$vt.Comment.value:return r.FoldingRangeKind.Comment;case u.$vt.Imports.value:return r.FoldingRangeKind.Imports;case u.$vt.Region.value:return r.FoldingRangeKind.Region}}Re.to=Ce})(Fe||(e.FoldingRangeKind=Fe={}));var nt;(function(Re){function Ne(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?c.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$jE.id:void 0}}Re.from=Ne})(nt||(e.TextEditorOpenOptions=nt={}));var ae;(function(Re){function Ne(Ve){return Ve instanceof r.$JL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||re(Ve)?new r.$JL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Re.from=Ne;function Ce(Ve){const et=Ve;return et?v.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function re(Ve){const et=Ve;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Te(Ve){return typeof Ve=="string"?Ve:new r.$JL(v.URI.revive(Ve.baseUri),Ve.pattern)}Re.to=Te})(ae||(e.GlobPattern=ae={}));var ue;(function(Re){function Ne(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Ne);if(typeof Ce=="string")return Ce;{const re=Ce;return{language:re.language,scheme:re.scheme,pattern:ae.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Ne})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Re){function Ne(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Te=>Array.isArray(Te)&&Te.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&v.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(et=>et instanceof r.$OK)))}Re.is=Ne;function Ce(re){return{documents:re.documents.map(Te=>Te.map(Ve=>({uri:v.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>c.from(et))})))}}Re.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Re){function Ne(re){return{start:re.start,end:re.end}}Re.from=Ne;function Ce(re){return new r.$$L(re.start,re.end)}Re.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Qe;(function(Re){function Ne(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Ne;function Ce(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Ce})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var rt;(function(Re){function Ne(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Re.to=Ne})(rt||(e.NotebookCellExecutionState=rt={}));var ot;(function(Re){function Ne(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Re.from=Ne;function Ce(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Re.to=Ce})(ot||(e.NotebookCellKind=ot={}));var Be;(function(Re){function Ne(re){const Te={metadata:re.metadata??Object.create(null),cells:[]};for(const Ve of re.cells)r.$_L.validate(Ve),Te.cells.push(yt.from(Ve));return Te}Re.from=Ne;function Ce(re){const Te=new r.$aM(re.cells.map(yt.to));return(0,m.$Qf)(re.metadata)||(Te.metadata=re.metadata),Te}Re.to=Ce})(Be||(e.NotebookData=Be={}));var yt;(function(Re){function Ne(re){return{cellKind:ot.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Qe.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Kt.from):[]}}Re.from=Ne;function Ce(re){return new r.$_L(ot.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Kt.to):void 0,re.metadata,re.internalMetadata?Qe.to(re.internalMetadata):void 0)}Re.to=Ce})(yt||(e.NotebookCellData=yt={}));var Mt;(function(Re){function Ne(re){return{mime:re.mime,valueBytes:N.$ge.wrap(re.data)}}Re.from=Ne;function Ce(re){return new r.$bM(re.valueBytes.buffer,re.mime)}Re.to=Ce})(Mt||(e.NotebookCellOutputItem=Mt={}));var Kt;(function(Re){function Ne(re){return{outputId:re.id,items:re.items.map(Mt.from),metadata:re.metadata}}Re.from=Ne;function Ce(re){const Te=re.items.map(Mt.to);return new r.$cM(Te,re.outputId,re.metadata)}Re.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var zt;(function(Re){function Ne(Te){return re(Te)?{include:ae.from(Te.include)??void 0,exclude:ae.from(Te.exclude)??void 0}:ae.from(Te)??void 0}Re.from=Ne;function Ce(Te){return re(Te)?{include:ae.to(Te.include),exclude:ae.to(Te.exclude)}:ae.to(Te)}Re.to=Ce;function re(Te){const Ve=Te;return Ve?!(0,m.$Mf)(Ve.include)&&!(0,m.$Mf)(Ve.exclude):!1}})(zt||(e.NotebookExclusiveDocumentPattern=zt={}));var vt;(function(Re){function Ne(Ce,re,Te){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(Ve,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Re.from=Ne})(vt||(e.NotebookStatusBarItem=vt={}));var Vt;(function(Re){function Ne(Ce,re,Te){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:re.toInternal(Ve,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Re.from=Ne})(Vt||(e.NotebookKernelSourceAction=Vt={}));var Ft;(function(Re){function Ne(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Re.from=Ne})(Ft||(e.NotebookDocumentContentOptions=Ft={}));var Qt;(function(Re){function Ne(re){return{uri:re.uri,provides:re.provides}}Re.from=Ne;function Ce(re){return new r.$eM(v.URI.revive(re.uri),re.provides)}Re.to=Ce})(Qt||(e.NotebookRendererScript=Qt={}));var Ot;(function(Re){function Ne(re){return{message:j.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Re.from=Ne;function Ce(re){const Te=new r.$kM(typeof re.message=="string"?re.message:j.to(re.message));return Te.actualOutput=re.actual,Te.expectedOutput=re.expected,Te.contextValue=re.contextValue,Te.location=re.location?ye.to(re.location):void 0,Te}Re.to=Ce})(Ot||(e.TestMessage=Ot={}));var It;(function(Re){Re.namespace=a.$GJ,Re.denamespace=a.$HJ})(It||(e.TestTag=It={}));var tt;(function(Re){function Ne(re){const Te=(0,s.$KM)(re).controllerId;return{extId:o.$CJ.fromExtHostTestItem(re,Te).toString(),label:re.label,uri:v.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(Ve=>It.namespace(Te,Ve.id)),range:k.$Fs.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&j.fromStrict(re.error)||null}}Re.from=Ne;function Ce(re){return{parent:void 0,error:void 0,id:o.$CJ.fromString(re.extId).localId,label:re.label,uri:v.URI.revive(re.uri),tags:(re.tags||[]).map(Te=>{const{tagId:Ve}=It.denamespace(Te);return new r.$lM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Ce})(tt||(e.TestItem=tt={})),function(Re){function Ne(re){return{id:re.id}}Re.from=Ne;function Ce(re){return new r.$lM(re.id)}Re.to=Ce}(It||(e.TestTag=It={}));var Ht;(function(Re){const Ne=(re,Te)=>{const Ve=[];for(const[Ge,st]of Te)o.$CJ.compare(st.item.extId,Ge)===2&&(Te.delete(Ge),Ve.push(st));const et={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(st=>st.type===0).map(Ot.to)})),children:Ve.map(Ge=>Ne(Ge,Te))};for(const Ge of et.children)Ge.parent=et;return et};function Ce(re){const Te=[],Ve=new Map;for(const et of re.items){Ve.set(et.item.extId,et);const Ge=o.$CJ.root(et.item.extId);re.request.targets.some(st=>st.controllerId===Ge&&st.testIds.includes(et.item.extId))&&Te.push(et)}return{completedAt:re.completedAt,results:Te.map(et=>Ne(et,Ve))}}Re.to=Ce})(Ht||(e.TestResults=Ht={}));var Gt;(function(Re){function Ne(Ve){return{covered:Ve.covered,total:Ve.total}}function Ce(Ve){return"line"in Ve?S.from(Ve):c.from(Ve)}function re(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(et=>({count:et.executionCount,location:et.location&&Ce(et.location)})):void 0}:{type:0,name:Ve.name,count:Ve.executionCount,location:Ce(Ve.location)}}Re.fromDetailed=re;function Te(Ve){return{uri:Ve.uri,statement:Ne(Ve.statementCoverage),branch:Ve.branchCoverage&&Ne(Ve.branchCoverage),function:Ve.functionCoverage&&Ne(Ve.functionCoverage),details:Ve.detailedCoverage?.map(re)}}Re.fromFile=Te})(Gt||(e.TestCoverage=Gt={}));var lt;(function(Re){function Ne(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Re.to=Ne})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Re){function Ne(re){const Te=new r.$rM(se.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Te._sessionId=re._sessionId,Te._itemId=re._itemId,Te}Re.to=Ne;function Ce(re,Te,Ve){if(Te=Te??re._sessionId,Ve=Ve??re._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,kind:se.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Ce})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Re){function Ne(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Re.from=Ne})(jt||(e.ViewBadge=jt={}));var Ut;(function(Re){function Ne(Ve,et,Ge){const st=et.fileData;return st?new r.$CL(new r.$DL(st.name,v.URI.revive(st.uri),st.id,(0,I.$db)(()=>Ge(st.id)))):Ve===M.$2r.uriList&&et.uriListData?new r.$BL(Te(et.uriListData)):new r.$BL(et.asString)}Re.to=Ne;async function Ce(Ve,et){const Ge=await et.asString();if(Ve===M.$2r.uriList)return{asString:Ge,fileData:void 0,uriListData:re(Ge)};const st=et.asFile();return{asString:Ge,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Re.from=Ce;function re(Ve){return g.$ct.split(Ve).map(et=>{if(et.startsWith("#"))return et;try{return v.URI.parse(et)}catch{}return et})}function Te(Ve){return g.$ct.create(Ve.map(et=>typeof et=="string"?et:v.URI.revive(et)))}})(Ut||(e.DataTransferItem=Ut={}));var St;(function(Re){function Ne(re,Te){const Ve=re.items.map(([et,Ge])=>[et,Ut.to(et,Ge,Te)]);return new r.$EL(Ve)}Re.toDataTransfer=Ne;async function Ce(re){const Te={items:[]},Ve=[];for(const[et,Ge]of re)Ve.push((async()=>{Te.items.push([et,await Ut.from(et,Ge)])})());return await Promise.all(Ve),Te}Re.from=Ce})(St||(e.DataTransfer=St={}));var dt;(function(Re){function Ne(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Re.from=Ne})(dt||(e.ChatReplyFollowup=dt={}));var Pt;(function(Re){function Ne(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:dt.from(Ce)}Re.from=Ne})(Pt||(e.ChatFollowup=Pt={}));var Xt;(function(Re){function Ne(re){const Te=new r.$DM(kt.to(re.role),re.content);return Te.name=re.name,Te}Re.to=Ne;function Ce(re){return{role:kt.from(re.role),content:re.content,name:re.name}}Re.from=Ce})(Xt||(e.ChatMessage=Xt={}));var kt;(function(Re){function Ne(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Re.to=Ne;function Ce(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Re.from=Ce})(kt||(e.ChatMessageRole=kt={}));var Ze;(function(Re){function Ne(Te){const Ve={};for(const et of Object.keys(Te))Ve[et]=Te[et].map(Re.to);return Ve}Re.objectTo=Ne;function Ce(Te){return{level:Lt.to(Te.level),kind:Te.kind,value:(0,y.$xh)(Te.value),description:Te.description}}Re.to=Ce;function re(Te){return{level:Lt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Re.from=re})(Ze||(e.ChatVariable=Ze={}));var Lt;(function(Re){function Ne(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Re.to=Ne;function Ce(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Re.from=Ce})(Lt||(e.ChatVariableLevel=Lt={}));var Wt;(function(Re){function Ne(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Ne})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Jt;(function(Re){function Ne(Ce,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,d.$iF)(Ce,"chatAgents2Additions"),{content:j.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,d.$iF)(Ce,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,d.$iF)(Ce,"chatAgents2Additions"),{content:j.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(Ve=>c.from(Ve))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,d.$iF)(Ce,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Re.from=Ne})(Jt||(e.ChatResponseProgress=Jt={}));var gt;(function(Re){function Ne(Ce){return{label:Ce.label,values:Ce.values.map(Ze.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Re.from=Ne})(gt||(e.ChatAgentCompletionItem=gt={}));var Rt;(function(Re){function Ne(Ce,re,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:re.toInternal(Ce,Te)}Re.from=Ne})(Rt||(e.TerminalQuickFix=Rt={}))}),define(Se[294],ke([1,0,2,8,7,15,75]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class b{constructor(y,M,C,m={timeout:1500,errors:3}){this.c=y,this.d=M,this.f=C,this.g=m,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(M,C,m)=>{const k={dispose:this.a.push([M,C,y])};return Array.isArray(m)&&m.push(k),k}}async $participateInSave(y,M){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),k=[];try{for(const u of[...this.a]){if(m)break;const f=this.d.getDocument(C),s=await this.h(u,{document:f,reason:I.TextDocumentSaveReason.to(M)});k.push(s)}}finally{clearTimeout(v)}return k}h([y,M,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,M,m).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const u=this.b.get(y);this.b.set(y,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,M,C,m){const v=[],k=Date.now(),{document:u,reason:f}=m,{version:s}=u,i=Object.freeze({document:u,reason:f,waitUntil(n){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{M.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof g.$TK))for(const{newText:t,newEol:r,range:d}of a)o.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:d&&I.Range.from(d),text:t,eol:r&&I.EndOfLine.from(r)}});if(o.edits.length!==0)return s===u.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$_fc=b}),define(Se[295],ke([1,0,17,2,15,7,111]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;class b{constructor(C,m,v,k){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=k}asApiEvent(){return{range:new I.$$L(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const k=v.map(g.NotebookCellOutputItem.to),u=this.a.find(f=>f.id===C);if(u&&(m||(u.items.length=0),u.items.push(...k),u.items.length>1&&u.items.every(f=>R.$OI(f.mime)))){const f=new Map,s=[];u.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),u.items.length=0,s.forEach(i=>{const n=R.$PI(f.get(i));u.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$egc=$;class y{static{this.a=0}constructor(C,m,v,k,u){this.k=C,this.l=m,this.m=v,this.uri=k,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const k={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},u=[];for(const s of C.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,k.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,k.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),u.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),u.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),u.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),u.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),u.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const f=new Map;for(let s=0;s<u.length;s++){const i=u[s],n=f.get(i.cell);if(n===void 0){const o=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,o-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const k=[],u=[],f=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||u.push($.asModelAddData(this.apiNotebook,t)),r}),o=new b(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)f.push(t.uri),o.deletedItems.push(t.apiCell);k.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:f}),v)for(const s of k)v.push(s.asApiEvent())}s(C,m,v,k){const u=this.b.splice(C,m);this.b.splice(v,0,...u);const f=[new b(C,m,u.map(s=>s.apiCell),[]),new b(v,0,[],u)];for(const s of f)k.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,k){this.b[C].setOutputItems(m,v,k)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$fgc=y}),define(Se[296],ke([1,0,4,2,15,7]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class R{constructor($,y,M,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=M,this.f=C,this.a=new D.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,M,C)=>{const m=function(k){y.call(M,k)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,M){const C=N.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},M,async(u,f)=>{const s=Date.now(),i=await await Promise.resolve(u);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!M.isCancellationRequested&&i&&(i instanceof I.$WK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(v.length===0)return!0;const k={edits:[]};for(const u of v){const{edits:f}=g.WorkspaceEdit.from(u);k.edits=k.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$vgc=R}),define(Se[146],ke([1,0,8,15,7]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,M,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=M,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$$L.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$ggc=I}),define(Se[297],ke([1,0,8,4,14,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let R=class{constructor($,y){this.c=$,this.d=y,this.a=new N.$Sd({onListenerError:D.$2}),this.b=new N.$Sd({onListenerError:D.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,y);const M=this.d.getEditorById($);y.visibleRanges&&M._acceptVisibleRanges(y.visibleRanges.ranges.map(I.NotebookRange.to)),y.selections&&M._acceptSelections(y.selections.selections.map(I.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:M.apiEditor,visibleRanges:M.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:M.apiEditor,selections:M.apiEditor.selections}))}$acceptEditorViewColumns($){for(const y in $)this.d.getEditorById(y)._acceptViewColumn(I.ViewColumn.to($[y]))}};e.$xgc=R,e.$xgc=R=Je([We(0,g.$ij)],R)}),define(Se[298],ke([1,0,15,85,216,21,59,8]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,k){const u=this.b++,{title:f,location:s,cancellable:i}=v,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(u,{location:D.ProgressLocation.from(s),title:f,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(b.$2),this.d(u,k,!!i)}d(m,v,k){let u;k&&(u=new I.$3d,this.c.set(m,u));const f=i=>{this.a.$progressEnd(i),this.c.delete(i),u?.dispose()};let s;try{s=v(new M(this.a,m),k&&u?u.token:I.CancellationToken.None)}catch(i){throw f(m),i}return s.then(i=>f(m),i=>f(m)),s}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.$Egc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class M extends N.$fv{constructor(m,v){super(k=>this.throttledReport(k)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}Je([(0,R.$uh)(100,(C,m)=>y(C,m),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Se[147],ke([1,0,29,142,67,112,89,15,2]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=void 0;const y=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const l=r;r=d,n.listener?.(t(d,l))}}}},M=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let a;const t=m(r=>({range:D.$Fs.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),C.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(a=>({label:a}))),description:y(n,void 0,C.description,m(a=>({description:a}))),sortText:y(n,void 0,C.sortText,m(a=>({sortText:a}))),canResolveChildren:y(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:y(n,!1,C.busy,m(a=>({busy:a}))),error:y(n,void 0,C.error,m(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:y(n,[],C.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=n=>{const o=g.$CJ.fromString(n.extId),a=new f(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,R.$HJ)(t).tagId})),a},u=n=>{let o;for(const a of n.tests){const t=k(a.item);(0,N.$KM)(t).parent=o,o=t}return o};e.$1M=u;class f{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,N.$JM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,I.$IM)(d,N.$KM,f),enumerable:!0,writable:!1},...v(d,t)})}}e.$2M=f;class s extends f{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$3M=s;class i extends I.$EM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:N.$KM,getChildren:r=>r.children,root:new s(o,a),toITestItem:b.TestItem.from})}}e.$4M=i}),define(Se[148],ke([1,0,60,8,121,15,7]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=e.$VM=void 0;class b{static{this.c=new g.$TM("TextEditorDecorationType")}constructor(m,v,k){const u=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,u,I.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:u,dispose(){m.$removeTextEditorDecorationType(u)}})}}e.$VM=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let k=null;if(m instanceof R.$NK)k=new R.$OK(m,m);else if(m instanceof R.$OK)k=m;else throw new Error("Unrecognized location");this.l(k,v,!1)}insert(m,v){this.k(),this.l(new R.$OK(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof R.$OK)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,k){const u=this.c.validateRange(m);this.g.push({range:u,text:v,forceMoveMarkers:k})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=m}}class y{constructor(m,v,k,u){this.c=m,this.d=v,this._accept(k),this.e=u;const f=this;this.value={get tabSize(){return f.f},set tabSize(s){f.m(s)},get indentSize(){return f.g},set indentSize(s){f.o(s)},get insertSpaces(){return f.h},set insertSpaces(s){f.q(s)},get cursorStyle(){return f.j},set cursorStyle(s){f.s(s)},get lineNumbers(){return f.k},set lineNumbers(s){f.t(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:!!m}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let k=!1;if(typeof m.tabSize<"u"){const u=this.l(m.tabSize);u==="auto"?(k=!0,v.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,k=!0,v.tabSize=u)}if(typeof m.indentSize<"u"){const u=this.n(m.indentSize);u==="tabSize"?(k=!0,v.indentSize=u):typeof u=="number"&&this.g!==u&&(this.g=u,k=!0,v.indentSize=u)}if(typeof m.insertSpaces<"u"){const u=this.p(m.insertSpaces);u==="auto"?(k=!0,v.insertSpaces=u):this.h!==u&&(this.h=u,k=!0,v.insertSpaces=u)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,k=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,k=!0,v.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(k)})}}e.$WM=y;class M{constructor(m,v,k,u,f,s,i,n){this.id=m,this.j=v,this.k=k,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,s,k),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return u.value},set document(a){throw new N.$9("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof R.$PK))throw(0,N.$7)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$PK)))throw(0,N.$7)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new N.$9("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new N.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(u.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(l=>I.Range.from(l));else if(t instanceof R.$NK){const{lineNumber:l,column:c}=I.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof R.$OK)d=[I.Range.from(t)];else{d=[];for(const l of t)if(l instanceof R.$OK)d.push(I.Range.from(l));else{const{lineNumber:c,column:h}=I.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return v.$tryInsertSnippet(m,u.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(I.$LM(t))return v.$trySetDecorations(m,a.key,I.$MM(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return v.$trySetDecorationsFast(m,a.key,d)}}))},revealRange(a,t){o.n(()=>v.$tryRevealRange(m,I.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){v.$tryShowEditor(m,I.ViewColumn.from(a))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const k=v.edits.map(f=>f.range);k.sort((f,s)=>f.end.line===s.end.line?f.end.character===s.end.character?f.start.line===s.start.line?f.start.character-s.start.character:f.start.line-s.start.line:f.end.character-s.end.character:f.end.line-s.end.line);for(let f=0,s=k.length-1;f<s;f++){const i=k[f].end;if(k[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=v.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,u,{setEndOfLine:typeof v.setEndOfLine=="number"?I.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$XM=M}),define(Se[299],ke([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;function s(o,a){if((0,M.$Df)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Sc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new u.$87;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,S=this.m(a,t,r),L={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(a,L),p={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,f.$iF)(r,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,f.$iF)(r,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(E){(0,v.$ek)(E)&&(0,f.$iF)(r,"treeViewMarkdownMessage"),S.message=E},get title(){return S.title},set title(E){S.title=E},get description(){return S.description},set description(E){S.description=E},get badge(){return S.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?S.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(S.badge=void 0)},reveal:(E,A)=>S.reveal(E,A),dispose:async()=>{await w,this.a.delete(a),S.dispose()}};return this.B(p),p}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new b.$SE(a))}async $handleDrop(a,t,r,d,l,c,h,S){const L=this.a.get(a);if(!L)return Promise.reject(new b.$SE(a));const w=m.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return h===a&&S&&await this.j(w,L,S,l,c),L.onDrop(w,d,l)}async j(a,t,r,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,S)=>{h&&a.set(S,h)});else if(l&&t.handleDrag){const h=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(l,h),await h}return a}async $handleDrag(a,t,r,d){const l=this.a.get(a);if(!l)return Promise.reject(new b.$SE(a));const c=await this.j(new y.$EL,l,t,d,r);if(!(!c||d.isCancellationRequested))return m.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$SE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new b.$SE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new b.$SE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new b.$SE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new b.$SE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new b.$SE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Xgc=i;class n extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,M.$Mf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,l,c){if(super(),this.I=a,this.J=r,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$3d,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const p of c.contributes.views[w])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,S;const L=I.Event.debounce(this.F.event,(w,p)=>(w||(w={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(E=>S=E),this.G=this.G.then(()=>h)),Array.isArray(p.element)?w.elements.push(...p.element):w.elements.push(p.element)),p.message&&(w.message=!0),w),200,!0);this.B(L(({message:w,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const E=S;return h=null,this.$(p).then(()=>E())})),w&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,M.$Mf)(t.select)?!0:t.select,d=(0,M.$Mf)(t.focus)?!1:t.focus,l=(0,M.$Mf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(S=>S.item)},{select:r,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:l})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=m.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,C.$ub)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const l of a){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$Tg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Tg)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,$.$Tg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new k.$3d(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,C.$Hb)(d||[]).map(async c=>{const h=await this.f.getTreeItem(c);return h&&!t.token.isCancellationRequested?this.db(c,h,r):null}));return t.token.isCancellationRequested?void 0:(0,C.$Hb)(l)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new k.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(l=>this.m.get(l));for(const l of r)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&r.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Tg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,r.parent);return this.pb(t,l,r,r.parent),r.dispose(),l}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return y.$bL.isMarkdownString(a)?m.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!y.$zL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new R.$Rc),l=this.kb(a,t,r),c=this.lb(t);return{item:{handle:l,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,M.$Mf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof y.$HL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},l,c){if(t)return`${n.b}/${t}`;const h=s(r,this.N),S=l?l.item.handle:n.a;let L=h?h.label:d?(0,N.$zg)(d):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const w=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(l)||[];let E,A=0;do{if(E=`${S}/${A}:${L}`,c||!this.j.has(E)||w===E)break;A++}while(A<=p.length);return E}lb(a){if(a.iconPath&&!(a.iconPath instanceof y.$HL))return typeof a.iconPath=="string"||g.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof y.$HL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return g.URI.isUri(a)?a:g.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===r.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[300],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[301],ke([1,0,234,8,39,134,108,37,26,300,136,137]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0;const m=b.$sn.as(R.$tn.JSONContribution);class v{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(g.default.Error,a)}warn(a){this.d(g.default.Warning,a)}info(a){this.d(g.default.Info,a)}}e.$9E=v;class k{static a(a){const t=new $.$gm;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new k(t,[]);if(!t||!t.length)return new k([],a);const r=this.a(a),d=this.a(t),l=t.filter(h=>!r.has(h.description.identifier)),c=a.filter(h=>!d.has(h.description.identifier));return new k(l,c)}constructor(a,t){this.added=a,this.removed=t}}e.$0E=k;class u{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=k.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,N.$1)(a)}}}e.$$E=u;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$_E={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$em},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$0n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$0n}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new u(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$ZE.register(a.extensionPoint,a.activationEventsGenerator),e.$_E.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,m.registerSchema(s,e.$_E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$aF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$sn.add(n.ExtensionsRegistry,new i),e.$bF=b.$sn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$_E),m.registerSchema(M.$Bj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[302],ke([1,0,230,18,24,301,46,4]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(k,u,f){if(!k)return;const s=N.$Df(k.type)?k.type:void 0;if(!s||s.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)N.$Df(n)&&i.push(n);return{extensionId:u.value,taskType:s,required:i,properties:k.properties?g.$gn(k.properties):{},when:k.when?R.$Yi.deserialize(k.when):void 0}}m.from=v})(y||(y={}));const M=I.$bF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const k of m)k.type&&v.push(`onTaskType:${k.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,k)=>{M.setHandler((u,f)=>{this.c=void 0;try{for(const s of f.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of f.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const k of this.all()){const u={type:"object",additionalProperties:!1};k.required.length>0&&(u.required=k.required.slice(0)),k.properties!==void 0?u.properties=g.$gn(k.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[k.taskType]},v.push(u)}this.c={oneOf:v}}return this.c}}e.$dG=new C}),define(Se[303],ke([1,0,231,18,23,24,46,302]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$nG=e.JsonSchemaVersion=e.ExecutionEngine=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$hG=e.ShellQuoting=e.$gG=e.$fG=e.$eG=void 0,e.$eG="settings",e.$fG=new R.$fj("taskRunning",!1,D.localize(0,null)),e.$gG={value:D.localize(1,null),original:"Tasks"};var $;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$hG="$customized",function(T){function F(W){if(!W)return T.Strong;switch(W.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=F}($||(e.ShellQuoting=$={}));var y;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var M;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(M||(e.RevealKind=M={})),function(T){function F(W){switch(W.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=F}(M||(e.RevealKind=M={}));var C;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(T){function F(W){switch(W.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=F}(C||(e.RevealProblemKind=C={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m||(e.PanelKind=m={})),function(T){function F(W){switch(W.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=F}(m||(e.PanelKind=m={}));var v;(function(T){T.defaults={echo:!0,reveal:M.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var k;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(T){function F(X){switch(X.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=F;function W(X){switch(X){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=W}(k||(e.RuntimeType=k={}));var u;(function(T){function F(W){return N.$Df(W)?W:W.value}T.value=F})(u||(e.CommandString=u={}));var f;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function F(X){return X===T.Clean._id||X===T.Build._id||X===T.Rebuild._id||X===T.Test._id}T.is=F;function W(X){if(X!==void 0)return N.$Df(X)?F(X)?{_id:X,isDefault:!1}:void 0:X}T.from=W})(f||(e.TaskGroup=f={}));var s;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function F(W){switch(W){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(T){T.parallel="parallel",T.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(F,W,X,ce,J,Y){this._label="",this._id=F,W&&(this._label=W),X&&(this.type=X),this.runOptions=ce,this.configurationProperties=J,this._source=Y}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(N.$Df(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$iG=t;class r extends t{constructor(F,W,X,ce,J,Y,x,se){super(F,X,void 0,x,se,W),this.command={},this._source=W,this.hasDefinedMatchers=Y,J&&(this.command=J)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case k.Shell:W="shell";break;case k.Process:W="process";break;case k.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof r}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$eG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.$hG,folder:F,id:W};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$zg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new r(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$jG=r;class d extends t{constructor(F,W,X,ce,J,Y,x){super(F,X,ce,Y,x,W),this._source=W,this.configures=J}static is(F){return F instanceof d}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$zg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$eG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.$hG,folder:F,id:W};return JSON.stringify(X)}}e.$kG=d;class l extends t{constructor(F,W,X,ce,J,Y,x,se,Z){super(F,X,ce,se,Z,W),this.defines=J,this.hasDefinedMatchers=x,this.command=Y,this.icon=Z.icon,this.hide=Z.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof l}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new l(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$lG=l;class c extends t{constructor(F,W,X,ce,J,Y){super(F,X,ce,J,Y,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$mG=c;var h;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(T){T._default=T.Terminal}(h||(e.ExecutionEngine=h={}));var S;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const X=F.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(X&&ce){let J=this.c.get(X.uri.toString());J=J===void 0?0:J+1;let Y=this.c.get(ce.uri.toString());return Y=Y===void 0?0:Y+1,J===Y?F._label.localeCompare(W._label):J-Y}else return!X&&ce?-1:X&&!ce?1:0}}e.$nG=L;var w;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(w||(e.TaskEventKind=w={}));var p;(function(T){T.SingleRun="singleRun",T.Background="background"})(p||(e.TaskRunType=p={}));var E;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var A;(function(T){function F(se){return{taskId:se._id,taskName:se.configurationProperties.name,runType:se.configurationProperties.isBackground?"background":"singleRun",group:se.configurationProperties.group,__task:se}}function W(se,Z,ve){return{...F(se),kind:"start",terminalId:Z,resolvedVariables:ve}}T.start=W;function X(se,Z,ve){return{...F(se),kind:"processStarted",terminalId:Z,processId:ve}}T.processStarted=X;function ce(se,Z,ve){return{...F(se),kind:"processEnded",terminalId:Z,exitCode:ve}}T.processEnded=ce;function J(se,Z,ve){return{...F(se),kind:"terminated",exitReason:ve,terminalId:Z}}T.terminated=J;function Y(se,Z,ve){return{...F(Z),kind:se,terminalId:ve}}T.general=Y;function x(){return{kind:"changed"}}T.changed=x})(A||(e.TaskEvent=A={}));var B;(function(T){function F(X){const ce=Object.keys(X).sort();let J="";for(const Y of ce){let x=X[Y];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),J+=Y+","+x+","}return J}function W(X){const J={_key:F(X),type:X.taskType};return Object.assign(J,X),J}T.create=W})(B||(e.KeyedTaskIdentifier=B={}));var O;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection",T.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var P;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(P||(e.TasksSchemaProperties=P={}));var j;(function(T){function F(W,X){const ce=b.$dG.get(W.type);if(ce===void 0){const se=I.$gn(W);return delete se._key,B.create(se)}const J=Object.create(null);J.type=ce.taskType;const Y=new Set;ce.required.forEach(se=>Y.add(se));const x=ce.properties;for(const se of Object.keys(x)){const Z=W[se];if(Z!=null)J[se]=Z;else if(Y.has(se)){const ve=x[se];if(ve.default!==void 0)J[se]=I.$gn(ve.default);else switch(ve.type){case"boolean":J[se]=!1;break;case"number":case"integer":J[se]=0;break;case"string":J[se]="";break;default:X.error(D.localize(2,null,JSON.stringify(W,void 0,0),se));return}}}return B.create(J)}T.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(Se[304],ke([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=e.$a7b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$a7b=N;class g extends N{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$b7b=g}),define(Se[68],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Av=D;const N=[];function g(b){const $=new D(b);return N[$.nid]=$,$}e.$Bv=g;function I(b){return N[b].sid}e.$Cv=I;class R{constructor($){this.value=$}}e.$Dv=R}),define(Se[6],ke([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$KK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var g;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var M;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$JK=C;var m;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var k;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$KK={MainThreadAuthentication:(0,D.$Bv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Bv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Bv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Bv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Bv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Bv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Bv)("MainThreadCommands"),MainThreadComments:(0,D.$Bv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Bv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Bv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Bv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Bv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Bv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Bv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Bv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Bv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Bv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Bv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Bv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Bv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Bv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Bv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Bv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Bv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Bv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Bv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Bv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Bv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Bv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Bv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Bv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Bv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Bv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Bv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Bv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Bv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Bv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Bv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Bv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Bv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Bv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Bv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Bv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Bv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Bv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Bv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Bv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Bv)("MainThreadSCM"),MainThreadSearch:(0,D.$Bv)("MainThreadSearch"),MainThreadShare:(0,D.$Bv)("MainThreadShare"),MainThreadTask:(0,D.$Bv)("MainThreadTask"),MainThreadWindow:(0,D.$Bv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Bv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Bv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Bv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Bv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Bv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Bv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Bv)("MainThreadInteractive"),MainThreadChat:(0,D.$Bv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Bv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Bv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Bv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Bv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Bv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Bv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Bv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Bv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Bv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Bv)("MainThreadIssueReporter")},e.$LK={ExtHostCommands:(0,D.$Bv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Bv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Bv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Bv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Bv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Bv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Bv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Bv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Bv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Bv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Bv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Bv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Bv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Bv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Bv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Bv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Bv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Bv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Bv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Bv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Bv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Bv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Bv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Bv)("ExtHostSCM"),ExtHostSearch:(0,D.$Bv)("ExtHostSearch"),ExtHostTask:(0,D.$Bv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Bv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Bv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Bv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Bv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Bv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Bv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Bv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Bv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Bv)("ExtHostProgress"),ExtHostComments:(0,D.$Bv)("ExtHostComments"),ExtHostSecretState:(0,D.$Bv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Bv)("ExtHostStorage"),ExtHostUrls:(0,D.$Bv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Bv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Bv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Bv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$Bv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Bv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Bv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Bv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Bv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Bv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Bv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Bv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Bv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Bv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Bv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Bv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Bv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Bv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Bv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Bv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Bv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Bv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Bv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Bv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Bv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Bv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Bv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Bv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Bv)("ExtHostIssueReporter")}}),define(Se[305],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$KK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new N.$MK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$Xec=g}),define(Se[91],ke([1,0,5,14,6,20]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=e.$5ec=e.$4ec=void 0,e.$4ec=(0,D.$1h)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$KK.MainThreadTelemetry)}report($,y,M){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$5ec=R,e.$5ec=R=Je([We(0,I.$OM),We(1,N.$ij)],R),e.$6ec=Object.freeze(new class{report(b,$,y){}})}),define(Se[306],ke([1,0,4,6,7,26]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class R{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Sd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=y.getProxy(N.$KK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,M,C,m={}){const v=I.$fm.toKey(y.identifier),k=[...C].sort().join(" ");return await this.f.getOrCreate(`${v} ${M} ${k}`,async()=>{await this.a.$ensureProvider(M);const u=y.displayName||y.name;return this.a.$getSession(M,C,v,u,m)})}async getSessions(y,M,C){const m=I.$fm.toKey(y.identifier),v=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(M);const k=y.displayName||y.name;return this.a.$getSessions(M,C,m,k)})}async removeSession(y,M){const C=this.b.get(y);return C?C.provider.removeSession(M):this.a.$removeSession(y,M)}registerAuthenticationProvider(y,M,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:M,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:M});const v=C.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,M,m?.supportsMultipleAccounts??!1),new g.$MK(()=>{v.dispose(),this.b.delete(y);const k=this.c.findIndex(u=>u.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,M,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(M,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,M){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,M){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,M){return this.d.fire({provider:{id:y,label:M}}),Promise.resolve()}}e.$9ec=R;class b{constructor(){this.a=new Map}getOrCreate(y,M){const C=this.a.get(y);if(C)return C;const m=M().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(Se[307],ke([1,0,6,20,15]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$KK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const M=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,y?.isRefactoring??!1)}};e.$0ec=I,e.$0ec=I=Je([We(0,N.$OM)],I)}),define(Se[308],ke([1,0,4,52,3,6,15]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class b{static{this.a=0}constructor(M,C){this.extension=M,this.provider=C,this.handle=b.a++}}class ${static{this.a=0}constructor(M){this.b=new Map,this.c=new Map,this.d=new D.$Sd,this.onDidPerformUserAction=this.d.event,this.e=M.getProxy(I.$KK.MainThreadChat)}registerChatProvider(M,C,m){const v=new b(M,m);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,C),(0,g.$Qc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(M,C){const m=N.Iterable.find(this.c.keys(),v=>this.c.get(v)===M)??0;typeof m=="number"&&this.e.$transferChatSession(m,C)}sendInteractiveRequestToProvider(M,C){this.e.$sendRequestToProvider(M,C)}async $prepareChat(M,C){const m=this.b.get(M);if(!m)return;const v=await m.provider.prepareSession(C);if(!v)return;const k=$.a++;return this.c.set(k,v),{id:k,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(M,C){const m=this.b.get(M);if(!m||!m.provider.provideWelcomeMessage)return;const v=await m.provider.provideWelcomeMessage(C);if(v)return v.map(k=>typeof k=="string"?k:Array.isArray(k)?k.map(u=>R.ChatReplyFollowup.from(u)):R.MarkdownString.from(k))}async $provideSampleQuestions(M,C){const m=this.b.get(M);if(!m||!m.provider.provideSampleQuestions)return;const v=await m.provider.provideSampleQuestions(C);if(v)return v?.map(k=>R.ChatReplyFollowup.from(k))}$releaseSession(M){this.c.delete(M)}async $onDidPerformUserAction(M){this.d.fire(M)}}e.$$ec=$}),define(Se[309],ke([1,0,12,21,44,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class f{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$KK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=f.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,d){this.g.delete(o);const l=this.b.get(n);if(!l)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function h(){if(c)throw new Error("Only valid while executing the command")}const S=new D.$lh;d.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(l.extension.identifier,S.p);const L=t.command?await l.validateSlashCommand(t.command):void 0,w=R.$Od.create(!1);let p;try{const E=l.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:L},{history:r.history.map(m.ChatMessage.to)},new M.$fv(A=>{h(),typeof p>"u"&&"content"in A&&(p=w.elapsed());const B=m.ChatResponseProgress.from(l.extension,A);if(!B){this.j.error("Unknown progress type: "+JSON.stringify(A));return}if("placeholder"in A&&"resolvedContent"in A){const O=Promise.all([this.d.$handleProgressChunk(a,B),A.resolvedContent]);(0,D.$Pg)(O,d).then(P=>{if(!P)return;const[j,T]=P,F=m.ChatResponseProgress.from(l.extension,T);if(!F){this.j.error("Unknown progress type: "+JSON.stringify(T));return}this.d.$handleProgressChunk(a,F,j??void 0)})}else this.d.$handleProgressChunk(a,B)}),d);return await(0,D.$Pg)(Promise.resolve(E).then(A=>{if(A){this.g.set(o,A);let B=this.h.get(o);B||(B=new Map,this.h.set(o,B)),B.set(a,A);const O={firstProgress:p,totalElapsed:w.elapsed()};return{errorDetails:A.errorDetails,timings:O}}else this.g.delete(o)}),d)}catch(E){return this.j.error(E,l.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Li)(E)),responseIsIncomplete:!0}}}finally{c=!0,S.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t,r){const d=this.b.get(n);if(!d)return;const l=this.h.get(o)?.get(a);if(!l)return;let c;switch(t){case k.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(r?{result:l,kind:c,reportIssue:r}:{result:l,kind:c}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}async $invokeCompletionProvider(n,o,a){const t=this.b.get(n);return t?(await t.invokeCompletionProvider(o,a)).map(m.ChatAgentCompletionItem.from):[]}}e.$afc=f;class s{constructor(n,o,a,t,r){this.extension=n,this.t=o,this.u=a,this.w=t,this.x=r,this.o=new I.$Sd,this.q=new I.$Sd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(N.CancellationToken.None),(0,b.$Nf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$HL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,u.$iF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,u.$iF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,u.$iF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,u.$iF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,u.$iF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,u.$iF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,u.$iF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,u.$iF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,u.$iF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,u.$iF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,u.$hF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(n,o,a,t){return this.x(n,o,a,t)}}}),define(Se[310],ke([1,0,21,3,6,15,85,26,12,4]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class M{constructor(k,u){this.stream=new $.$rh,this.stream=u??new $.$rh;const f=this;this.apiObj={option:k,response:f.stream.asyncIterable}}}class C{constructor(k,u){this.a=new y.$Sd,this.b=new Map,this.c=new $.$rh,this.d=!1;const f=this;this.apiObject={result:k,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){u.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let u=this.b.get(k.index);u||(this.b.size===0?u=new M(k.index,this.c):u=new M(k.index),this.b.set(k.index,u),this.a.fire(u.apiObj)),u.stream.emitOne(k.part)}}class m{static{this.a=1}constructor(k,u){this.d=u,this.c=new Map,this.e=new Map,this.f=new b.$hm,this.b=k.getProxy(g.$KK.MainThreadChatProvider)}registerProvider(k,u,f,s){const i=m.a++;return this.c.set(i,{extension:k,provider:f}),this.b.$registerProvider(i,u,{extension:k,model:s.name??""}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(k,u,f,s,i){const n=this.c.get(k);if(!n)return;const o=new R.$fv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(u,{index:a.index,part:a.part})});return n.provider.provideChatResponse(f.map(I.ChatMessage.to),s,o,i)}allowListExtensionWhile(k,u){this.f.set(k,u),u.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,u){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(u);if(!f)throw new Error(`ChatAccess '${u}' NOT found`);const s=this;return{get model(){return f.model},get isRevoked(){return!s.f.has(k)},makeRequest(i,n,o){if(!s.f.has(k))throw new Error("Access to chat has been revoked");const a=new D.$3d(o),t=Math.random()*1e6|0,r=s.b.$fetchResponse(k,u,t,i.map(I.ChatMessage.from),n??{},a.token),d=new C(r,a);return s.e.set(t,{res:d}),r.finally(()=>{s.e.delete(t)}),d.apiObject}}}async $handleResponseFragment(k,u){const f=this.e.get(k);f&&f.res.handleFragment(u)}}e.$_ec=m}),define(Se[311],ke([1,0,3,6,8,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(N.$KK.MainThreadChatVariables)}async $resolveVariable($,y,M){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},M);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,M,C){const m=R.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:M},resolver:C}),this.c.$registerVariable(m,{name:y,description:M}),(0,D.$Qc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$bfc=R}),define(Se[312],ke([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class N{constructor(I){const R=I.getProxy(D.$KK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$cfc=N}),define(Se[35],ke([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=void 0;let d=class{#e;#t;#i;constructor(w,p,E){this.b=new Map,this.c=new Map,this.#e=w.getProxy(R.$KK.MainThreadCommands),this.d=p,this.#i=E,this.#t=w.getProxy(R.$KK.MainThreadTelemetry),this.converter=new l(this,A=>{const B=this.c.get(A);return B?.result===h.Void?B:void 0},p),this.f=[{processArgument(A){return(0,y.$xh)(A)}},{processArgument(A){return(0,I.$in)(A,function(B){if(M.$Fs.isIRange(B))return g.Range.to(B);if(C.$Es.isIPosition(B))return g.Position.to(B);if(M.$Fs.isIRange(B.range)&&m.URI.isUri(B.uri))return g.location.to(B);if(B instanceof s.$ge)return B.buffer.buffer;if(!Array.isArray(B))return B})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const p=this.registerCommand(!1,w.id,async(...E)=>{const A=w.args.map((O,P)=>{if(!O.validate(E[P]))throw new Error(`Invalid argument '${O.name}' when running '${w.id}', received: ${typeof E[P]=="object"?JSON.stringify(E[P],null,"	"):E[P]} `);return O.convert(E[P])}),B=await this.executeCommand(w.internalId,...A);return w.result.convert(B,E,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$MK(()=>{p.dispose(),this.c.delete(w.id)})}registerCommand(w,p,E,A,B,O){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:E,thisArg:A,metadata:B,extension:O}),w&&this.#e.$registerCommand(p),new N.$MK(()=>{this.b.delete(p)&&w&&this.#e.$unregisterCommand(p)})}executeCommand(w,...p){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,p,!0)}async g(w,p,E){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,p,!1);{let A=!1;const B=(0,I.$in)(p,function(O){if(O instanceof N.$NK)return g.Position.from(O);if(O instanceof N.$OK)return g.Range.from(O);if(O instanceof N.$YK)return g.location.from(O);if(N.$$L.isNotebookRange(O))return g.NotebookRange.from(O);if(O instanceof ArrayBuffer)return A=!0,s.$ge.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return A=!0,s.$ge.wrap(O);if(O instanceof s.$ge)return A=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(w,A?new i.$Dv(B):B,E);return(0,y.$xh)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(w,p,!1);throw O}}}async h(w,p,E){const A=this.b.get(w);if(!A)throw new Error("Unknown command");const{callback:B,thisArg:O,metadata:P}=A;if(P?.args)for(let T=0;T<P.args.length;T++)try{(0,D.$Uf)(p[T],P.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${P.args[T].name}' - ${P.args[T].description}`)}const j=o.$Od.create();try{return await B.apply(O,p)}catch(T){if(w===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...p);F&&(w=F.command)}if(this.d.error(T,w,A.extension?.identifier),!E)throw T;if(A.extension?.identifier){const F=this.#i.onExtensionError(A.extension.identifier,T);this.d.trace("forwarded error to extension?",F,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Li)(T)),this.id=w,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,w,j.elapsed())}}j(w,p,E){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new a.$vo(p),duration:E})}$executeContributedCommand(w,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const E=this.b.get(w);return E?(p=p.map(A=>this.f.reduce((B,O)=>O.processArgument(B,E.extension?.identifier),A)),this.h(w,p,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(p=>(w&&(p=p.filter(E=>E[0]!=="_")),p))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[p,E]of this.b){const{metadata:A}=E;A&&(w[p]=A)}return Promise.resolve(w)}};e.$0M=d,e.$0M=d=Je([We(0,u.$OM),We(1,$.$ij),We(2,t.$9M)],d),e.$$M=(0,k.$1h)("IExtHostCommands");class l{constructor(w,p,E){this.d=w,this.f=p,this.g=E,this.delegatingCommandId=`__vsc${(0,r.$lg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,p){if(!w)return;const E={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return E;const A=this.f(w.command);if(A)E.id=A.internalId,E.arguments=A.args.map((B,O)=>B.convert(w.arguments&&w.arguments[O]));else if((0,b.$Lb)(w.arguments)){const B=`${w.command} /${++this.c}`;this.b.set(B,w),p.add((0,v.$Qc)(()=>{this.b.delete(B),this.g.trace("CommandsConverter#DISPOSE",B)})),E.$ident=B,E.id=this.delegatingCommandId,E.arguments=[B],this.g.trace("CommandsConverter#CREATE",w.command,B)}return E}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const p=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$_M=l;class c{static{this.Uri=new c("uri","Uri of a text document",w=>m.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>N.$NK.isPosition(w),g.Position.from)}static{this.Range=new c("range","A range in a text document",w=>N.$OK.isRange(w),g.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>N.$PK.isSelection(w),g.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,p=>Array.isArray(p)&&p.every(E=>w.validate(E)),p=>p.map(E=>w.convert(E)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof N.$0K,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof N.$rM,g.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof f.$2M,g.TestItem.from)}constructor(w,p,E,A){this.name=w,this.description=p,this.validate=E,this.convert=A}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,p){return new c(w??this.name,p??this.description,this.validate,this.convert)}}e.$aN=c;class h{static{this.Void=new h("no result",w=>w)}constructor(w,p){this.description=w,this.convert=p}}e.$bN=h;class S{constructor(w,p,E,A,B){this.id=w,this.internalId=p,this.description=E,this.args=A,this.result=B}}e.$cN=S}),define(Se[313],ke([1,0,19,17,2,83,131,46,35,15,7]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;const C=[new $.$cN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$cN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$aN.Uri],new $.$bN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,f)=>{if((0,D.$Kb)(u))return;class s extends M.$5K{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new M.$YK(f[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return u.map(s.to)})),new $.$cN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$aN.Uri,new $.$aN("options","Formatting options",u=>!0,u=>u)],new $.$bN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$cN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$aN.Uri,$.$aN.Range,new $.$aN("options","Formatting options",u=>!0,u=>u)],new $.$bN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$cN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$aN.Uri,$.$aN.Position,new $.$aN("ch","Trigger character",u=>typeof u=="string",u=>u),new $.$aN("options","Formatting options",u=>!0,u=>u)],new $.$bN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$cN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$cN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$cN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$cN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$cN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$cN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$cN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$aN.Uri,new $.$aN("position","A position in a text document",u=>Array.isArray(u)&&u.every(f=>M.$NK.isPosition(f)),u=>u.map(y.Position.from))],new $.$bN("A promise that resolves to an array of ranges.",u=>u.map(f=>{let s;for(const i of f.reverse())s=new M.$9K(y.Range.to(i),s);return s}))),new $.$cN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$aN.String.with("query","Search string")],new $.$bN("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(y.WorkspaceSymbol.to))),new $.$cN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(y.CallHierarchyItem.to))),new $.$cN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$aN.CallHierarchyItem],new $.$bN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(y.CallHierarchyIncomingCall.to))),new $.$cN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$aN.CallHierarchyItem],new $.$bN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(y.CallHierarchyOutgoingCall.to))),new $.$cN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:y.Range.to(u.range),placeholder:u.text}})),new $.$cN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$aN.Uri,$.$aN.Position,$.$aN.String.with("newName","The new symbol name")],new $.$bN("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return y.WorkspaceEdit.to(u)}})),new $.$cN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$aN.Uri,$.$aN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$bN("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(y.DocumentLink.to))),new $.$cN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$aN.Uri],new $.$bN("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$3L(u.tokenTypes,u.tokenModifiers)})),new $.$cN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$aN.Uri],new $.$bN("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,R.$f$)(u);if(f.type==="full")return new M.$5L(f.data,void 0)})),new $.$cN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$aN.Uri,$.$aN.Range.optional()],new $.$bN("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$3L(u.tokenTypes,u.tokenModifiers)})),new $.$cN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$aN.Uri,$.$aN.Range],new $.$bN("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const f=(0,R.$f$)(u);if(f.type==="full")return new M.$5L(f.data,void 0)})),new $.$cN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$aN.Uri,$.$aN.Position,$.$aN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$aN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$bN("A promise that resolves to a CompletionList-instance.",(u,f,s)=>{if(!u)return new M.$iL([]);const i=u.suggestions.map(n=>y.CompletionItem.to(n,s));return new M.$iL(i,u.incomplete)})),new $.$cN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$aN.Uri,$.$aN.Position,$.$aN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$bN("A promise that resolves to SignatureHelp.",u=>{if(u)return y.SignatureHelp.to(u)})),new $.$cN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$aN.Uri,$.$aN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$bN("A promise that resolves to an array of CodeLens-instances.",(u,f,s)=>v(i=>new M.$aL(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(u))),new $.$cN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$aN.Uri,new $.$aN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>M.$OK.isRange(u),u=>M.$PK.isSelection(u)?y.Selection.from(u):y.Range.from(u)),$.$aN.String.with("kind","Code action kind to return code actions for").optional(),$.$aN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$bN("A promise that resolves to an array of Command-instances.",(u,f,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new M.$7K(i.title,i.kind?new M.$8K(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(u))),new $.$cN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$aN.Uri],new $.$bN("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(f=>new M.$oL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$cN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$aN("color","The color to show and insert",u=>u instanceof M.$nL,y.Color.from),new $.$aN("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:y.Range.from(u.range)}))],new $.$bN("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(y.ColorPresentation.to):[])),new $.$cN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$aN.Uri,$.$aN.Range],new $.$bN("A promise that resolves to an array of Inlay objects",(u,f,s)=>u.map(y.InlayHint.to.bind(void 0,s)))),new $.$cN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$aN.Uri],new $.$bN("A promise that resolves to an array of FoldingRange objects",(u,f)=>{if(u)return u.map(y.FoldingRange.to)})),new $.$cN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$bN("A promise that resolves to an array of NotebookContentProvider static info objects.",v(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$cN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$aN.Uri,$.$aN.Range,new $.$aN("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof M.$OK,u=>y.InlineValueContext.from(u))],new $.$bN("A promise that resolves to an array of InlineValue objects",u=>u.map(y.InlineValue.to))),new $.$cN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$aN("uriOrString","Uri-instance or string (only http/https)",u=>g.URI.isUri(u)||typeof u=="string"&&(0,N.$ag)(u,N.Schemas.http,N.Schemas.https),u=>u),new $.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[y.ViewColumn.from(u),void 0]:[y.ViewColumn.from(u.viewColumn),y.TextEditorOpenOptions.from(u)])).optional(),$.$aN.String.with("label","").optional()],$.$bN.Void),new $.$cN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$aN.Uri.with("resource","Resource to open"),$.$aN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[y.ViewColumn.from(u),void 0]:[y.ViewColumn.from(u.viewColumn),y.TextEditorOpenOptions.from(u)])).optional()],$.$bN.Void),new $.$cN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$aN.Uri.with("left","Left-hand side resource of the diff editor"),$.$aN.Uri.with("right","Right-hand side resource of the diff editor"),$.$aN.String.with("title","Human readable title for the diff editor").optional(),new $.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[y.ViewColumn.from(u.viewColumn),y.TextEditorOpenOptions.from(u)]).optional()],$.$bN.Void),new $.$cN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$aN.String.with("title","Human readable title for the changes editor"),new $.$aN("resourceList","List of resources to compare",u=>{for(const f of u){if(f.length!==3)return!1;const[s,i,n]=f;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},u=>u)],$.$bN.Void),new $.$cN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$aN.Uri,$.$aN.Position],new $.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(y.TypeHierarchyItem.to))),new $.$cN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$aN.TypeHierarchyItem],new $.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(y.TypeHierarchyItem.to))),new $.$cN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$aN.TypeHierarchyItem],new $.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(y.TypeHierarchyItem.to))),new $.$cN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$aN.TestItem],$.$bN.Void),new $.$cN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$aN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$bN.Void),new $.$cN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$aN.String.with("name","The context key name"),new $.$aN("value","The context key value",()=>!0,u=>u)],$.$bN.Void),new $.$cN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$aN.Uri,$.$aN.StringArray,new $.$aN("MappedEditsContext","Mapped Edits Context",u=>y.MappedEditsContext.is(u),u=>y.MappedEditsContext.from(u))],new $.$bN("A promise that resolves to a workspace edit or null",u=>u?y.WorkspaceEdit.to(u):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$Zi)}}e.$8ec=m;function v(u){return f=>{if(Array.isArray(f))return f.map(u)}}function k(u){if(!Array.isArray(u))return;const f=[];for(const s of u)I.$rt(s)?f.push(y.DefinitionLink.to(s)):f.push(y.location.to(s));return f}}),define(Se[314],ke([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function v(k,u,f){const s=k.getProxy(C.$KK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$hm,u.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const S=this.b.get(h.handle);return S?S.value:h}else if(h&&h.$mid===7){const S=this.b.get(h.commentControlHandle);if(!S)return h;const L=S.getCommentThread(h.commentThreadHandle);return L?L.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const L=S.getCommentThread(h.thread.commentThreadHandle);return L?h.$mid===8?L.value:{thread:L.value,text:h.text}:h}else if(h&&h.$mid===10){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const L=S.getCommentThread(h.thread.commentThreadHandle);if(!L)return h;const w=h.commentUniqueId,p=L.getCommentByUniqueId(w);return p||h}else if(h&&h.$mid===11){const S=this.b.get(h.thread.commentControlHandle);if(!S)return h;const L=S.getCommentThread(h.thread.commentThreadHandle);if(!L)return h;const w=h.text,p=h.commentUniqueId,E=L.getCommentByUniqueId(p);return E?(typeof E.body=="string"?E.body=w:E.body=new M.$bL(w),E):h}return h}})}createCommentController(h,S,L){const w=i.a++,p=new o(h,w,S,L);this.b.set(p.handle,p);const E=this.c.get(h.identifier)||[];return E.push(p),this.c.set(h.identifier,E),p.value}async $createCommentThreadTemplate(h,S,L){const w=this.b.get(h);w&&w.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(h,S,L){const w=this.b.get(h);w&&w.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(h,S){this.b.get(h)?.$deleteCommentThread(S)}$provideCommentingRanges(h,S,L){const w=this.b.get(h);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const p=f.getDocument(R.URI.revive(S));return(0,D.$Tg)(async()=>{const E=await w.commentingRangeProvider.provideCommentingRanges(p,L);let A;return Array.isArray(E)?A={ranges:E,fileComments:!1}:E?A={ranges:E.ranges||[],fileComments:E.fileComments||!1}:A=E??void 0,A}).then(E=>{let A;return E&&(A={ranges:E.ranges.map(B=>y.Range.from(B)),fileComments:E.fileComments}),A})}$toggleReaction(h,S,L,w,p){const E=this.b.get(h);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Tg)(()=>{const A=E.getCommentThread(S);if(A){const B=A.getCommentByUniqueId(w.uniqueIdInThread);if(E!==void 0&&B&&E.reactionHandler)return E.reactionHandler(B,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,S,L,w,p,E,A,B){this.m=S,this.n=L,this.o=w,this.p=p,this.q=E,this.extensionDescription=A,this.r=B,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Tc,this.l.value=new I.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(S,this.handle,this.n,this.o,y.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(S,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(P){O.range=P},get comments(){return O.comments},set comments(P){O.comments=P},get collapsibleState(){return O.collapsibleState},set collapsibleState(P){O.collapsibleState=P},get canReply(){return O.canReply},set canReply(P){O.canReply=P},get contextValue(){return O.contextValue},set contextValue(P){O.contextValue=P},get label(){return O.label},set label(P){O.label=P},get state(){return O.state},set state(P){O.state=P},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Rc);const h=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};h("range")&&(S.range=y.Range.from(this.p)),h("label")&&(S.label=this.label),h("contextValue")&&(S.contextValue=this.contextValue??null),h("comments")&&(S.comments=this.q.map(L=>a(this,L,this.k,this.extensionDescription))),h("collapsibleState")&&(S.collapseState=d(this.g)),h("canReply")&&(S.canReply=this.canReply),h("state")&&(S.state=l(this.h)),h("isTemplate")&&(S.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(h){for(const S of this.k){const L=S[0],w=S[1];if(h===w)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,N.$th)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,S,L,w){this.f=h,this.g=S,this.h=L,this.i=w,this.a=new Map,s.$registerCommentController(this.handle,L,w,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,A,B){return p.createCommentThread(E,A,B).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,S,L){S===void 0&&(0,m.$iF)(this.f,"fileComments");const w=new n(this.id,this.handle,void 0,h,S,L,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(h,S){const L=new n(this.id,this.handle,void 0,R.URI.revive(h),y.Range.to(S),[],this.f,!0);return L.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(h,S){const L=this.a.get(h);L&&(L.range=y.Range.to(S))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(c,h,S,L){let w=S.get(h);return w||(w=++c.commentHandle,S.set(h,w)),h.state!==void 0&&(0,m.$iF)(L,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:w,body:typeof h.body=="string"?h.body:y.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?y.$NM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function d(c){if(c!==void 0)switch(c){case M.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(c){if(c!==void 0)switch(c){case M.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$ffc=v}),define(Se[315],ke([1,0,24,6,27,20]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let R=class{constructor(M,C){this.a=M.getProxy(N.$KK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,C){const m=this,v=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,C,v,arguments)}})}e(M,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(M,m,v)}};e.$6gc=R,e.$6gc=R=Je([We(0,I.$OM),We(1,g.$5M)],R);const b=1e5;function $(y,M){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const k=v;k.stack?v=k.stack:v=k.toString()}C.push(v)}if(M){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$ln)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Se[149],ke([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(u,f){this.h=f,this.f=new Map,this.g=u.getProxy(N.$KK.MainThreadDecorations)}registerFileDecorationProvider(u,f){const s=m.c++;this.f.set(s,{provider:u,extensionDescription:f}),this.g.$registerDecorationProvider(s,f.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$3b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const a=o.map(d=>({uri:d,rank:(0,y.$Le)(d.path,"/")})),t=(0,$.$zb)(a,(d,l)=>d.rank-l.rank||(0,y.$Ze)(d.uri.path,l.uri.path)),r=[];e:for(const d of t){let l;for(const c of d){const h=(0,M.$mc)(c.uri.path);if(l!==h&&(l=h,r.push(c.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$MK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(u,f,s){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(u);return await Promise.all(f.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!d)return;try{g.$9L.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$iF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),i}};e.$8fc=v,e.$8fc=v=m=Je([We(0,R.$OM),We(1,b.$ij)],v),e.$9fc=(0,I.$1h)("IExtHostDecorations")}),define(Se[316],ke([1,0,211,135,2,6,7,15,4,14,28,57]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0;class v{#e;#t;#i;constructor(f,s,i,n,o,a,t,r){this.d=f,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new M.$Ac(d=>a.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,s){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!s){this.delete(f);return}this.#i.set(f,s.slice()),i=[f]}else if(Array.isArray(f)){i=[];let a;f=[...f].sort(v.k);for(const t of f){const[r,d]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const l=this.#i.get(r);l&&(l.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of r)if(c.severity===d[l]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,s){this.j();for(const[i,n]of this)f.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const s=this.#i.get(f);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,s){return f[0].toString()<s[0].toString()?-1:f[0].toString()>s[0].toString()?1:0}}e.$2ec=v;let k=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const s=new M.$Ac;for(const i of f)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(f,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Wd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$KK.MainThreadDiagnostics)}createDiagnosticCollection(f,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,d=new class{$changeMany(h,S){n.$changeMany(h,S),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,h,S.length===0?"CLEARING":S)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,h)}dispose(){n.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,l=s;else if(!i.has(s))l=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+m.c++;while(i.has(l))}return new class extends v{constructor(){super(s,l,m.e,m.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(l,this)}dispose(){super.dispose(),i.delete(l)}}}getDiagnostics(f){if(f)return this.m(f);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(f){let s=[];for(const i of this.g.values())i.has(f)&&(s=s.concat(i.get(f)));return s}$acceptMarkersChange(f){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of f)this.n.set(g.URI.revive(s),i.map(b.Diagnostic.to))}};e.$3ec=k,e.$3ec=k=m=Je([We(1,y.$ij),We(2,C.$1ec)],k)}),define(Se[317],ke([1,0,2,6,25]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class I{constructor(b){this.a=b.getProxy(N.$KK.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$iF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(M=>D.URI.revive(M)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$0fc=I}),define(Se[318],ke([1,0,8,2,7,6,17,21,13]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(I.$KK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let k;return typeof m.onDidChange=="function"&&(k=m.onDidChange(u=>{if(u.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this.d.getDocument(u)&&this.$provideTextDocumentContent(v,u).then(f=>{if(!f&&typeof f!="string")return;const s=this.d.getDocument(u);if(!s)return;const i=(0,$.$Ue)(f);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(u,f)},D.$1)})),new g.$MK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$$fc=y}),define(Se[319],ke([1,0,4,3,2,6,141,15,18,24,7,8]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class m{constructor(k,u){this.a=new D.$Sd({onListenerError:C.$2}),this.b=new D.$Sd({onListenerError:C.$2}),this.c=new D.$Sd({onListenerError:C.$2}),this.d=new D.$Sd({onListenerError:C.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Rc,this.h=new Map,this.f=k.getProxy(I.$KK.MainThreadDocuments),this.g=u,this.g.onDidRemoveDocuments(f=>{for(const s of f)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const s of f)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const u=this.g.getDocument(k);if(u)return u}getDocument(k){const u=this.getDocumentData(k);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return u.document}ensureDocumentData(k){const u=this.g.getDocument(k);if(u)return Promise.resolve(u);let f=this.h.get(k.toString());return f||(f=this.f.$tryOpenDocument(k).then(s=>{this.h.delete(k.toString());const i=g.URI.revive(s);return(0,$.$Of)(this.g.getDocument(i))},s=>(this.h.delete(k.toString()),Promise.reject(s))),this.h.set(k.toString(),f)),f}createDocumentData(k){return this.f.$tryCreateDocument(k).then(u=>g.URI.revive(u))}$acceptModelLanguageChanged(k,u){const f=g.URI.revive(k),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(u),this.a.fire(s.document)}$acceptModelSaved(k){const u=g.URI.revive(k),f=this.g.getDocument(u);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(k,u){const f=g.URI.revive(k),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");s._acceptIsDirty(u),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,u,f){const s=g.URI.revive(k),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),i.onEvents(u);let n;u.isUndoing?n=M.TextDocumentChangeReason.Undo:u.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,y.$hn)({document:i.document,contentChanges:u.changes.map(o=>({range:b.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(k,u){(0,R.$QM)(k,u)}}e.$Yec=m}),define(Se[69],ke([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new N.$Sd,this.e=new N.$Sd,this.f=new N.$Sd,this.g=new N.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const l=I.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),a.push(c.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const l=I.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==k.Schemas.vscodeNotebookCell&&l.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new s(new $.$RM(this.h.getProxy(b.$KK.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(l,c),t.push(c.value)),c.ref()}if(o.removedEditors)for(const d of o.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&r.push(l)}if(o.addedEditors)for(const d of o.addedEditors){const l=I.URI.revive(d.documentUri);D.ok(this.c.has(l),`document '${l}' does not exist`),D.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new M.$XM(d.id,this.h.getProxy(b.$KK.MainThreadTextEditors),this.i,new f.$V(()=>c.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(S=>C.Range.to(S)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Nc)(a),(0,g.$Nc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return u.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$YM=i,e.$YM=i=Je([We(0,y.$OM),We(1,m.$ij)],i),e.$ZM=(0,R.$1h)("IExtHostDocumentsAndEditors")}),define(Se[70],ke([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0,e.$yfc=(0,R.$1h)("IExtHostEditorTabs");class C{constructor(f,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$sM(I.URI.revive(this.b.input.uri));case 2:return new M.$tM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new M.$uM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new M.$vM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$wM(this.b.input.viewType);case 4:return new M.$xM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$yM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$zM;case 9:return new M.$AM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$BM(this.b.input.providerId);default:return}}}class m{constructor(f,s){this.c=[],this.d="",this.b=f,this.e=s;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const s=this.c.find(i=>i.tabId===f.tabDto.id);if(!s)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(f.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(f){this.b=new N.$Sd,this.c=new N.$Sd,this.e=[],this.a=f.getProxy(b.$KK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,s={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Of)(f.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?k(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(f){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(f.map(d=>d.groupId)),n=(0,D.$L)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=f.map(d=>{const l=new m(d,()=>this.d);return n.added.includes(l.groupId)?a.push(l.apiObject):t.push(l.apiObject),l});const r=(0,g.$Of)(f.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(f){const s=this.e.find(i=>i.groupId===f.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const s=this.e.find(n=>n.groupId===f.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(s=>s.apiObject===f)}async i(f,s){const i=[];for(const n of f){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(f,s){const i=[];for(const n of f){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$zfc=v,e.$zfc=v=Je([We(0,$.$OM)],v);function k(u){return u.tabs!==void 0}}),define(Se[320],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$KK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const M=await y.provideEmbeddingVector(b,$);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new N.$MK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$agc=g}),define(Se[321],ke([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class m{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const f=this.a.indexOf(u);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),f=[];let s,i,n=14,o=14;for(const a of u){let t=s?(0,$.$9e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,f.push([i,a.toUpperCase().charCodeAt(t),o]),f.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$hZ(f)}}provideDocumentLinks(u){this.c();const f=[],s=b.$iZ.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&f.push(n)}return f}}class v{constructor(u,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(N.$KK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,f,s,i={}){if(v.j(s),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const n=this.h++;this.b.add(f),this.d.add(f),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,M.$iF)(u,"fsChunks"),o+=4);let a;i.isReadonly&&(0,C.$ek)(i.isReadonly)&&((0,M.$iF)(u,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,f,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${f}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const l of r){const{uri:c,type:h}=l;if(c.scheme!==f)continue;let S;switch(h){case I.FileChangeType.Changed:S=0;break;case I.FileChangeType.Created:S=1;break;case I.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:S})}this.a.$onFileSystemChange(n,d)});return(0,g.$Qc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:f,ctime:s,mtime:i,size:n,permissions:o}=u;return{type:f,ctime:s,mtime:i,size:n,permissions:o}}$stat(u,f){return Promise.resolve(this.l(u).stat(D.URI.revive(f))).then(s=>v.k(s))}$readdir(u,f){return Promise.resolve(this.l(u).readDirectory(D.URI.revive(f)))}$readFile(u,f){return Promise.resolve(this.l(u).readFile(D.URI.revive(f))).then(s=>y.$ge.wrap(s))}$writeFile(u,f,s,i){return Promise.resolve(this.l(u).writeFile(D.URI.revive(f),s.buffer,i))}$delete(u,f,s){return Promise.resolve(this.l(u).delete(D.URI.revive(f),s))}$rename(u,f,s,i){return Promise.resolve(this.l(u).rename(D.URI.revive(f),D.URI.revive(s),i))}$copy(u,f,s,i){const n=this.l(u);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(f),D.URI.revive(s),i))}$mkdir(u,f){return Promise.resolve(this.l(u).createDirectory(D.URI.revive(f)))}$watch(u,f,s,i){const n=this.l(u).watch(D.URI.revive(s),i);this.f.set(f,n)}$unwatch(u,f){const s=this.f.get(f);s&&(s.dispose(),this.f.delete(f))}$open(u,f,s){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),s))}$close(u,f){const s=this.l(u);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(f))}$read(u,f,s,i){const n=this.l(u);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$ge.alloc(i);return Promise.resolve(n.read(f,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(u,f,s,i){const n=this.l(u);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,s,i.buffer,0,i.byteLength))}l(u){const f=this.c.get(u);if(!f){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return f}}e.$bgc=v}),define(Se[71],ke([1,0,6,32,7,22,5,20,57,3,12,23,17]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0;let k=v=class{constructor(f,s){this.b=new Map,this.c=new M.$0g,this.a=f.getProxy(D.$KK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===N.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,I.$ge.wrap(o))}catch(a){return v.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return v.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(f,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await f.stat(i)).type&N.FileType.Directory))throw g.$1L.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(N.$Ak(o)!==N.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await f.createDirectory(i)}catch(a){if(N.$Ak(a)!==N.FileSystemProviderErrorCode.FileExists)throw a}}}static e(f){if(f instanceof g.$1L)throw f;if(f instanceof N.$wk)switch(f.code){case N.FileSystemProviderErrorCode.FileExists:throw g.$1L.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$1L.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$1L.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$1L.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$1L.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$1L.Unavailable(f.message);default:throw new g.$1L(f.message,f.name)}if(!(f instanceof Error))throw new g.$1L(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$1L.Unavailable(f.message);switch(f.name){case N.FileSystemProviderErrorCode.FileExists:throw g.$1L.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$1L.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$1L.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$1L.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$1L.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$1L.Unavailable(f.message);default:throw new g.$1L(f.message,f.name)}}addFileSystemProvider(f,s,i){return this.b.set(f,{impl:s,extUri:i?.isCaseSensitive?C.$sg:C.$ug,isReadonly:!!i?.isReadonly}),(0,y.$Qc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$sg}};e.$nfc=k,e.$nfc=k=v=Je([We(0,b.$OM),We(1,$.$1ec)],k),e.$ofc=(0,R.$1h)("IExtHostConsumerFileSystem")}),define(Se[322],ke([1,0,4,34,2,6,15,7,43]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,k,u,f,s,i){this.a=Math.random(),this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$Hj)(s),o=typeof s=="string",a=i?.correlate,t=f(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const l=g.URI.revive(d);n(l.fsPath)&&(!o||k.getWorkspaceFolder(l))&&this.b.fire(l)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const l=g.URI.revive(d);n(l.fsPath)&&(!o||k.getWorkspaceFolder(l))&&this.c.fire(l)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const l=g.URI.revive(d);n(l.fsPath)&&(!o||k.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$MK.from(this.i(v,u,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,k,u,f,s){const i=b.$MK.from();if(typeof u=="string")return i;const n=v.getProxy(I.$KK.MainThreadFileSystemEventService);let o=!1;return(u.pattern.includes(N.$Dj)||u.pattern.includes(N.$Ej))&&(o=!0),n.$watch(k.identifier.value,this.a,u.baseUri,{recursive:o,excludes:f?.excludes??[]},!!s),b.$MK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,k,u){this.j=v,this.k=k,this.l=u,this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.g=new D.$Ud,this.h=new D.$Ud,this.i=new D.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,k,u,f){return new y(this.j,v,k,this.a.event,R.GlobPattern.from(u),f)}$onFileEvent(v){this.a.fire(new M(v))}$onDidRunFileOperation(v,k){switch(v){case 2:this.b.fire(Object.freeze({files:k.map(u=>({oldUri:g.URI.revive(u.source),newUri:g.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(u=>g.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(u=>g.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,k){return(u,f,s)=>{const i=function(o){u.call(f,o)};return i.extension=v,k.event(i,void 0,s)}}async $onWillRunFileOperation(v,k,u,f){switch(v){case 2:return await this.n(this.g,{files:k.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},u,f);case 1:return await this.n(this.i,{files:k.map(s=>g.URI.revive(s.target))},u,f);case 0:case 3:return await this.n(this.h,{files:k.map(s=>g.URI.revive(s.target))},u,f)}}async n(v,k,u,f){const s=new Set,i=[];if(await v.fireAsync(k,f,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof b.$WK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",a.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$cgc=C}),define(Se[323],ke([1,0,3,2,6,15,7,35,12]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class y{static{this.a=0}constructor(v,k){this.extension=v,this.provider=k,this.handle=y.a++}}class M{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,k,u,f){this.f=u,this.g=f,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$KK.MainThreadInlineChat),k.registerApiCommand(new b.$cN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$aN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?I.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?I.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?I.Position.from(s.position):void 0}})],b.$bN.Void))}registerProvider(v,k,u){const f=new y(v,k);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,u?.label??v.displayName??v.name,v.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",u?.supportReportIssue??!1),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(v,k,u,f){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(N.URI.revive(k)),n=I.Selection.to(u),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new M(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,k,u,f){const s=this.b.get(v);if(!s)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:u.prompt,selection:I.Selection.to(u.selection),wholeRange:I.Range.to(u.wholeRange),attempt:u.attempt,live:u.live};let o=!1;const a={report:async c=>{if(!u.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||f.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:c.message,edits:c.edits?.map(I.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:R.$bL.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,f));let r;try{r=await(0,$.$Pg)(t,f)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,l={wholeRange:I.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:c,contents:h}=r,S=h!==void 0?I.MarkdownString.from(h):void 0;return c instanceof R.$WK?{...l,id:d,type:"bulkEdit",edits:I.WorkspaceEdit.from(c),message:S}:{...l,id:d,type:"editorEdit",edits:c.map(I.TextEdit.from),message:S}}return{...l,id:d,type:"message",message:I.MarkdownString.from(r.contents)}}async $provideFollowups(v,k,u,f){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[u];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,f));return(await(0,$.$Pg)(o,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(v,k,u,f){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[u];if(s&&n){const o=I.InteractiveEditorResponseFeedbackKind.to(f);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,k){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$dgc=C}),define(Se[324],ke([1,0,2,35]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class g{constructor(R,b,$,y,M){this.a=b,this.b=$,this.c=y;const C=new N.$cN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$aN("showOptions","Show Options",m=>!0,m=>m),new N.$aN("resource","Interactive resource Uri",m=>!0,m=>m),new N.$aN("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$aN("title","Interactive editor title",m=>!0,m=>m)],new N.$bN("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$qgc=g}),define(Se[325],ke([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class g{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$KK.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,b){const $=R.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new N.$MK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,b){const $=R.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new N.$MK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$rgc=g}),define(Se[326],ke([1,0,3,6]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(N.$KK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$sgc=g}),define(Se[327],ke([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,131,121,110,38,8,12,25,213]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class d{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentSymbols(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentSymbols(ee,Q);if(!(0,M.$Kb)(V))return V[0]instanceof I.$6K?V.map(g.DocumentSymbol.from):d.f(V)}static f(z){z=z.slice(0).sort((V,oe)=>{let le=V.location.range.start.compareTo(oe.location.range.start);return le===0&&(le=oe.location.range.end.compareTo(V.location.range.end)),le});const Q=[],ee=[];for(const V of z){const oe={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(ee.length===0){ee.push(oe),Q.push(oe);break}const le=ee[ee.length-1];if(y.$Fs.containsRange(le.range,oe.range)&&!y.$Fs.equalsRange(le.range,oe.range)){le.children?.push(oe),ee.push(oe);break}ee.pop()}}return Q}}class l{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,Q,ee){this.g=z,this.h=Q,this.j=ee,this.e=new i.$Wec("CodeLens"),this.f=new Map}async provideCodeLenses(z,Q){const ee=this.g.getDocument(z),V=await this.j.provideCodeLenses(ee,Q);if(!V||Q.isCancellationRequested)return;const oe=this.e.add(V),le=new u.$Rc;this.f.set(oe,le);const Le={cacheId:oe,lenses:[]};for(let je=0;je<V.length;je++)Le.lenses.push({cacheId:[oe,je],range:g.Range.from(V[je].range),command:this.h.toInternal(V[je].command,le)});return Le}async resolveCodeLens(z,Q){const ee=z.cacheId&&this.e.get(...z.cacheId);if(!ee)return;let V;if(typeof this.j.resolveCodeLens!="function"||ee.isResolved?V=ee:V=await this.j.resolveCodeLens(ee,Q),V||(V=ee),Q.isCancellationRequested)return;const oe=z.cacheId&&this.f.get(z.cacheId[0]);if(oe)return z.command=this.h.toInternal(V.command??l.d,oe),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function c(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class h{constructor(z,Q){this.d=z,this.e=Q}async provideDefinition(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDefinition(V,oe,ee);return c(le)}}class S{constructor(z,Q){this.d=z,this.e=Q}async provideDeclaration(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDeclaration(V,oe,ee);return c(le)}}class L{constructor(z,Q){this.d=z,this.e=Q}async provideImplementation(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideImplementation(V,oe,ee);return c(le)}}class w{constructor(z,Q){this.d=z,this.e=Q}async provideTypeDefinition(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideTypeDefinition(V,oe,ee);return c(le)}}class p{constructor(z,Q){this.d=z,this.e=Q}async provideHover(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideHover(V,oe,ee);if(!(!le||(0,M.$Kb)(le.contents)))return le.range||(le.range=V.getWordRangeAtPosition(oe)),le.range||(le.range=new I.$OK(oe,oe)),g.Hover.from(le)}}class E{constructor(z,Q){this.d=z,this.e=Q}async provideEvaluatableExpression(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideEvaluatableExpression(V,oe,ee);if(le)return g.EvaluatableExpression.from(le)}}class A{constructor(z,Q){this.d=z,this.e=Q}async provideInlineValues(z,Q,ee,V){const oe=this.d.getDocument(z),le=await this.e.provideInlineValues(oe,g.Range.to(Q),g.InlineValueContext.to(ee),V);if(Array.isArray(le))return le.map(Le=>g.InlineValue.from(Le))}}class B{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentHighlights(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideDocumentHighlights(V,oe,ee);if(Array.isArray(le))return le.map(g.DocumentHighlight.from)}}class O{constructor(z,Q){this.d=z,this.e=Q}async provideMultiDocumentHighlights(z,Q,ee,V){const oe=this.d.getDocument(z),le=ee.map(He=>this.d.getDocument(He)),Le=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(oe,Le,le,V);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class P{constructor(z,Q){this.d=z,this.e=Q}async provideLinkedEditingRanges(z,Q,ee){const V=this.d.getDocument(z),oe=g.Position.to(Q),le=await this.e.provideLinkedEditingRanges(V,oe,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,M.$Hb)(le.ranges.map(g.Range.from)),wordPattern:le.wordPattern}}}class j{constructor(z,Q){this.d=z,this.e=Q}async provideReferences(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Position.to(Q),Le=await this.e.provideReferences(oe,le,ee,V);if(Array.isArray(Le))return Le.map(g.location.from)}}class T{static{this.d=1e3}constructor(z,Q,ee,V,oe,le,Le){this.g=z,this.h=Q,this.j=ee,this.k=V,this.l=oe,this.m=le,this.n=Le,this.e=new i.$Wec("CodeAction"),this.f=new Map}async provideCodeActions(z,Q,ee,V){const oe=this.g.getDocument(z),le=m.$Hs.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Le=[];for(const Pe of this.j.getDiagnostics(z))if(le.intersection(Pe.range)&&Le.push(Pe)>T.d)break;const je={diagnostics:Le,only:ee.only?new I.$8K(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(oe,le,je,V);if(!(0,M.$Lb)(He)||V.isCancellationRequested)return;const Ye=this.e.add(He),_e=new u.$Rc;this.f.set(Ye,_e);const at=[];for(let Pe=0;Pe<He.length;Pe++){const Oe=He[Pe];Oe&&(T.o(Oe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Oe.title,command:this.h.toInternal(Oe,_e)})):(je.only&&(Oe.kind?je.only.contains(Oe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),at.push({cacheId:[Ye,Pe],title:Oe.title,command:Oe.command&&this.h.toInternal(Oe.command,_e),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(g.Diagnostic.from),edit:Oe.edit&&g.WorkspaceEdit.from(Oe.edit,void 0),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,isAI:(0,t.$hF)(this.m,"codeActionAI")?Oe.isAI:!1,disabled:Oe.disabled?.reason})))}return{cacheId:Ye,actions:at}}async resolveCodeAction(z,Q){const[ee,V]=z,oe=this.e.get(ee,V);if(!oe||T.o(oe))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(oe,Q)??oe;let Le;le.edit&&(Le=g.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Le,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class F{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,oe){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=oe}async prepareDocumentPaste(z,Q,ee,V){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(z),le=Q.map(He=>g.Range.to(He)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new o.$$});if(await this.f.prepareDocumentPaste(oe,le,Le,V),V.isCancellationRequested)return;const je=Array.from(Le).filter(([,He])=>!(He instanceof I.$BL));return g.DataTransfer.from(je)}async providePasteEdits(z,Q,ee,V,oe){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Le=ee.map(Ye=>g.Range.to(Ye)),je=g.DataTransfer.toDataTransfer(V,async Ye=>(await this.d.$resolvePasteFileData(this.g,z,Ye)).buffer),He=await this.f.provideDocumentPasteEdits(le,Le,je,oe);if(He)return{label:He.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:F.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class W{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentFormattingEdits(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideDocumentFormattingEdits(V,Q,ee);if(Array.isArray(oe))return oe.map(g.TextEdit.from)}}class X{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeFormattingEdits(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Range.to(Q),Le=await this.e.provideDocumentRangeFormattingEdits(oe,le,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,Q,ee,V){(0,C.$Nf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(z),le=Q.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(oe,le,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class ce{constructor(z,Q){this.d=z,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,Q,ee,V,oe){const le=this.d.getDocument(z),Le=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Le,ee,V,oe);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class J{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Wec("WorkspaceSymbols")}async provideWorkspaceSymbols(z,Q){const ee=await this.e.provideWorkspaceSymbols(z,Q);if(!(0,M.$Lb)(ee))return{symbols:[]};const V=this.d.add(ee),oe={cacheId:V,symbols:[]};for(let le=0;le<ee.length;le++){const Le=ee[le];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}oe.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[V,le]})}return oe}async resolveWorkspaceSymbol(z,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const ee=this.d.get(...z.cacheId);if(ee){const V=await this.e.resolveWorkspaceSymbol(ee,Q);return V&&(0,N.$jn)(z,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Y{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideRenameEdits(z,Q,ee,V){const oe=this.d.getDocument(z),le=g.Position.to(Q);try{const Le=await this.e.provideRenameEdits(oe,le,ee,V);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=Y.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(z,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(z),oe=g.Position.to(Q);try{const le=await this.e.prepareRename(V,oe,ee);let Le,je;if(I.$OK.isRange(le)?(Le=le,je=V.getText(le)):(0,C.$Ff)(le)&&(Le=le.range,je=le.placeholder),!Le||!je)return;if(Le.start.line>oe.line||Le.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(le){const Le=Y.g(le);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(le)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class x{constructor(z,Q){this.resultId=z,this.tokens=Q}}class se{constructor(z,Q){this.f=z,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,Q,ee){const V=this.f.getDocument(z),oe=Q!==0?this.d.get(Q):null;let le=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,oe.resultId,ee):await this.g.provideDocumentSemanticTokens(V,ee);return oe&&this.d.delete(Q),le?(le=se.h(le),this.o(se.n(oe,le),le)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return se.j(z)?se.k(z)?z:new I.$5L(new Uint32Array(z.data),z.resultId):se.l(z)?se.m(z)?z:new I.$7L(z.edits.map(Q=>new I.$6L(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(z,Q){if(!se.j(Q)||!z||!z.tokens)return Q;const ee=z.tokens,V=ee.length,oe=Q.data,le=oe.length;let Le=0;const je=Math.min(V,le);for(;Le<je&&ee[Le]===oe[Le];)Le++;if(Le===V&&Le===le)return new I.$7L([],Q.resultId);let He=0;const Ye=je-Le;for(;He<Ye&&ee[V-He-1]===oe[le-He-1];)He++;return new I.$7L([{start:Le,deleteCount:V-Le-He,data:oe.subarray(Le,le-He)}],Q.resultId)}o(z,Q){if(se.j(z)){const ee=this.e++;return this.d.set(ee,new x(z.resultId,z.data)),(0,f.$e$)({id:ee,type:"full",data:z.data})}if(se.l(z)){const ee=this.e++;return se.j(Q)?this.d.set(ee,new x(Q.resultId,Q.data)):this.d.set(ee,new x(z.resultId)),(0,f.$e$)({id:ee,type:"delta",deltas:(z.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class Z{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeSemanticTokens(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideDocumentRangeSemanticTokens(V,g.Range.to(Q),ee);return oe?this.f(oe):null}f(z){return(0,f.$e$)({id:0,type:"full",data:z.data})}}class ve{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,Q,ee,V,oe){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=oe,this.d=new i.$Wec("CompletionItem"),this.e=new Map}async provideCompletionItems(z,Q,ee,V){const oe=this.f.getDocument(z),le=g.Position.to(Q),Le=oe.getWordRangeAtPosition(le)||new I.$OK(le,le),je=Le.with({end:le}),He=new n.$Od,Ye=await this.h.provideCompletionItems(oe,le,V,g.CompletionContext.to(ee));if(!Ye||V.isCancellationRequested)return;const _e=Array.isArray(Ye)?new I.$iL(Ye):Ye,at=ve.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),Pe=new u.$Rc;this.e.set(at,Pe);const Oe=[],qe={x:at,b:Oe,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let Xe=0;Xe<_e.items.length;Xe++){const Fe=_e.items[Xe],nt=this.l(Fe,[at,Xe],je,Le);Oe.push(nt)}return qe}async resolveCompletionItem(z,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=this.l(ee,z),oe=await this.h.resolveCompletionItem(ee,Q);if(!oe)return;const le=this.l(oe,z);return(V.h!==le.h||V.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==le.n||V.o!==le.o||!(0,N.$kn)(V.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q,ee,V){const oe=this.e.get(Q[0]);if(!oe)throw Error("DisposableStore is missing...");const le=this.g.toInternal(z.command,oe),Le={x:Q,a:z.label,b:z.kind!==void 0?g.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(g.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:g.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(g.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=z.textEdit.newText):typeof z.insertText=="string"?Le.h=z.insertText:z.insertText instanceof I.$XK&&(Le.h=z.insertText.value,Le.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),I.$OK.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class de{async provideInlineCompletions(z,Q,ee,V){}disposeCompletions(z){}handleDidShowCompletionItem(z,Q,ee){}handlePartialAccept(z,Q,ee){}}class H extends de{constructor(z,Q,ee,V){super(),this.f=z,this.g=Q,this.h=ee,this.j=V,this.d=new U,this.e=(0,t.$hF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$hF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,Q,ee,V){const oe=this.g.getDocument(z),le=g.Position.to(Q),Le=await this.h.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},V);if(!Le||V.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,He=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Ye=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((Pe,Oe)=>{let qe;Pe.command&&(_e||(_e=new u.$Rc),qe=this.j.toInternal(Pe.command,_e));const Xe=Pe.insertText;return{insertText:typeof Xe=="string"?Xe:{snippet:Xe.value},filterText:Pe.filterText,range:Pe.range?g.Range.from(Pe.range):void 0,command:qe,idx:Oe,completeBracketPairs:this.e?Pe.completeBracketPairs:!1}}),commands:He.map(Pe=>(_e||(_e=new u.$Rc),this.j.toInternal(Pe,_e))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,ee)}handlePartialAccept(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,ee)}}class U{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const Q=this.e++;return this.d.set(Q,z),Q}disposeReferenceId(z){const Q=this.d.get(z);return this.d.delete(z),Q}get(z){return this.d.get(z)}}class ne{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Wec("SignatureHelp")}async provideSignatureHelp(z,Q,ee,V){const oe=this.e.getDocument(z),le=g.Position.to(Q),Le=this.g(ee),je=await this.f.provideSignatureHelp(oe,le,V,Le);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(z){let Q;if(z.activeSignatureHelp){const ee=g.SignatureHelp.to(z.activeSignatureHelp),V=this.d.get(z.activeSignatureHelp.id,0);V?(Q=V,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...z,activeSignatureHelp:Q}}releaseSignatureHelp(z){this.d.delete(z)}}class ye{constructor(z,Q,ee,V,oe){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=oe,this.d=new i.$Wec("InlayHints"),this.e=new Map}async provideInlayHints(z,Q,ee){const V=this.f.getDocument(z),oe=g.Range.to(Q),le=await this.h.provideInlayHints(V,oe,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(le);this.e.set(Le,new u.$Rc);const je={hints:[],cacheId:Le};for(let He=0;He<le.length;He++)this.l(le[He],oe)&&je.hints.push(this.m(le[He],[Le,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(z,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.h.resolveInlayHint(ee,Q);if(V&&this.l(V))return this.m(V,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q){return z.label.length===0||Array.isArray(z.label)&&z.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(Q&&!Q.contains(z.position))}m(z,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const V={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(z.tooltip),position:g.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(g.TextEdit.from),kind:z.kind&&g.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?V.label=z.label:V.label=z.label.map(oe=>{const le={label:oe.value};return le.tooltip=g.MarkdownString.fromStrict(oe.tooltip),I.$YK.isLocation(oe.location)&&(le.location=g.location.from(oe.location)),oe.command&&(le.command=this.g.toInternal(oe.command,ee)),le}),V}}class he{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Wec("DocumentLink")}async provideLinks(z,Q){const ee=this.e.getDocument(z),V=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(V)||V.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(he.g).map(g.DocumentLink.from)};{const oe=this.d.add(V),le={links:[],cacheId:oe};for(let Le=0;Le<V.length;Le++){if(!he.g(V[Le]))continue;const je=g.DocumentLink.from(V[Le]);je.cacheId=[oe,Le],le.links.push(je)}return le}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.f.resolveDocumentLink(ee,Q);if(!(!V||!he.g(V)))return g.DocumentLink.from(V)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,Q){this.d=z,this.e=Q}async provideColors(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentColors(ee,Q);return Array.isArray(V)?V.map(le=>({color:g.Color.from(le.color),range:g.Range.from(le.range)})):[]}async provideColorPresentations(z,Q,ee){const V=this.d.getDocument(z),oe=g.Range.to(Q.range),le=g.Color.to(Q.color),Le=await this.e.provideColorPresentations(le,{document:V,range:oe},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class _{constructor(z,Q){this.d=z,this.e=Q}async provideFoldingRanges(z,Q,ee){const V=this.d.getDocument(z),oe=await this.e.provideFoldingRanges(V,Q,ee);if(Array.isArray(oe))return oe.map(g.FoldingRange.from)}}class ie{constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideSelectionRanges(z,Q,ee){const V=this.d.getDocument(z),oe=Q.map(g.Position.to),le=await this.e.provideSelectionRanges(V,oe,ee);if(!(0,M.$Lb)(le))return[];if(le.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<oe.length;je++){const He=[];Le.push(He);let Ye=oe[je],_e=le[je];for(;;){if(!_e.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Ye=_e.range,_e=_e.parent}}return Le}}class G{constructor(z,Q){this.f=z,this.g=Q,this.d=new s.$TM(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),oe=g.Position.to(Q),le=await this.g.prepareCallHierarchy(V,oe,ee);if(!le)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(le)?le.map(je=>this.h(Le,je)):[this.h(Le,le)]}async provideCallsTo(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(V,ee);if(oe)return oe.map(le=>({from:this.h(z,le.from),fromRanges:le.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(V,ee);if(oe)return oe.map(le=>({to:this.h(z,le.to),fromRanges:le.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.CallHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class te{constructor(z,Q){this.f=z,this.g=Q,this.d=new s.$TM(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),oe=g.Position.to(Q),le=await this.g.prepareTypeHierarchy(V,oe,ee);if(!le)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(le)?le.map(je=>this.h(Le,je)):[this.h(Le,le)]}async provideSupertypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(V,ee);if(oe)return oe.map(le=>this.h(z,le))}async provideSubtypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(V,ee);if(oe)return oe.map(le=>this.h(z,le))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.TypeHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class fe{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,oe){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=oe}async provideDocumentOnDropEdits(z,Q,ee,V,oe){const le=this.e.getDocument(Q),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(V,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Ye)).buffer),He=await this.f.provideDocumentDropEdits(le,Le,je,oe);if(He)return{label:He.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:fe.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class we{constructor(z,Q){this.d=z,this.e=Q}async provideMappedEdits(z,Q,ee,V){const oe=D.URI.revive(z),le=this.d.getDocument(oe),Le=ee.documents.map(Ye=>Ye.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>g.Range.to(at))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,V);return He?g.WorkspaceEdit.from(He):null}}class Ae{constructor(z,Q){this.adapter=z,this.extension=Q}}class be{static{this.d=0}constructor(z,Q,ee,V,oe,le,Le,je){this.g=Q,this.h=ee,this.j=V,this.k=oe,this.l=le,this.m=Le,this.n=je,this.f=new Map,this.e=z.getProxy(b.$KK.MainThreadLanguageFeatures)}o(z,Q){return g.DocumentSelector.from(z,this.g,Q)}p(z){return new I.$MK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,Q,ee,V,oe,le=!1){const Le=this.f.get(z);if(!Le||!(Le.adapter instanceof Q))return V;const je=Date.now();le||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Le.adapter,Le.extension);return Promise.resolve(He).catch(Ye=>{(0,o.$4)(Ye)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Le.extension.identifier,Ye))}).finally(()=>{le||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),v.CancellationToken.isCancellationToken(oe)?(0,a.$Qg)(He,oe):He}t(z,Q){const ee=this.q();return this.f.set(ee,new Ae(z,Q)),ee}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,ee,V){const oe=this.t(new d(this.h,ee),z),le=V&&V.label||be.u(z);return this.e.$registerDocumentSymbolProvider(oe,this.o(Q,z),le),this.p(oe)}$provideDocumentSymbols(z,Q,ee){return this.s(z,d,V=>V.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(z,Q,ee){const V=this.q(),oe=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ae(new l(this.h,this.j.converter,ee),z)),this.e.$registerCodeLensSupport(V,this.o(Q,z),oe);let le=this.p(V);if(oe!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(oe));le=I.$MK.from(le,Le)}return le}$provideCodeLenses(z,Q,ee){return this.s(z,l,V=>V.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(z,Q,ee){return this.s(z,l,V=>V.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(z,Q){this.s(z,l,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(z,Q,ee){const V=this.t(new h(this.h,ee),z);return this.e.$registerDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideDefinition(z,Q,ee,V){return this.s(z,h,oe=>oe.provideDefinition(D.URI.revive(Q),ee,V),[],V)}registerDeclarationProvider(z,Q,ee){const V=this.t(new S(this.h,ee),z);return this.e.$registerDeclarationSupport(V,this.o(Q,z)),this.p(V)}$provideDeclaration(z,Q,ee,V){return this.s(z,S,oe=>oe.provideDeclaration(D.URI.revive(Q),ee,V),[],V)}registerImplementationProvider(z,Q,ee){const V=this.t(new L(this.h,ee),z);return this.e.$registerImplementationSupport(V,this.o(Q,z)),this.p(V)}$provideImplementation(z,Q,ee,V){return this.s(z,L,oe=>oe.provideImplementation(D.URI.revive(Q),ee,V),[],V)}registerTypeDefinitionProvider(z,Q,ee){const V=this.t(new w(this.h,ee),z);return this.e.$registerTypeDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideTypeDefinition(z,Q,ee,V){return this.s(z,w,oe=>oe.provideTypeDefinition(D.URI.revive(Q),ee,V),[],V)}registerHoverProvider(z,Q,ee,V){const oe=this.t(new p(this.h,ee),z);return this.e.$registerHoverProvider(oe,this.o(Q,z)),this.p(oe)}$provideHover(z,Q,ee,V){return this.s(z,p,oe=>oe.provideHover(D.URI.revive(Q),ee,V),void 0,V)}registerEvaluatableExpressionProvider(z,Q,ee,V){const oe=this.t(new E(this.h,ee),z);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(Q,z)),this.p(oe)}$provideEvaluatableExpression(z,Q,ee,V){return this.s(z,E,oe=>oe.provideEvaluatableExpression(D.URI.revive(Q),ee,V),void 0,V)}registerInlineValuesProvider(z,Q,ee,V){const oe=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new A(this.h,ee),z);this.e.$registerInlineValuesProvider(le,this.o(Q,z),oe);let Le=this.p(le);if(oe!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(oe));Le=I.$MK.from(Le,je)}return Le}$provideInlineValues(z,Q,ee,V,oe){return this.s(z,A,le=>le.provideInlineValues(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerDocumentHighlightProvider(z,Q,ee){const V=this.t(new B(this.h,ee),z);return this.e.$registerDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}registerMultiDocumentHighlightProvider(z,Q,ee){const V=this.t(new O(this.h,ee),z);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentHighlights(z,Q,ee,V){return this.s(z,B,oe=>oe.provideDocumentHighlights(D.URI.revive(Q),ee,V),void 0,V)}$provideMultiDocumentHighlights(z,Q,ee,V,oe){return this.s(z,O,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,V.map(Le=>D.URI.revive(Le)),oe),void 0,oe)}registerLinkedEditingRangeProvider(z,Q,ee){const V=this.t(new P(this.h,ee),z);return this.e.$registerLinkedEditingRangeProvider(V,this.o(Q,z)),this.p(V)}$provideLinkedEditingRanges(z,Q,ee,V){return this.s(z,P,async oe=>{const le=await oe.provideLinkedEditingRanges(D.URI.revive(Q),ee,V);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?be.w(le.wordPattern):void 0}},void 0,V)}registerReferenceProvider(z,Q,ee){const V=this.t(new j(this.h,ee),z);return this.e.$registerReferenceSupport(V,this.o(Q,z)),this.p(V)}$provideReferences(z,Q,ee,V,oe){return this.s(z,j,le=>le.provideReferences(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerCodeActionProvider(z,Q,ee,V){const oe=new u.$Rc,le=this.t(new T(this.h,this.j.converter,this.k,ee,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(le,this.o(Q,z),{providedKinds:V?.providedCodeActionKinds?.map(Le=>Le.value),documentation:V?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,oe)}))},be.u(z),!!ee.resolveCodeAction),oe.add(this.p(le)),oe}$provideCodeActions(z,Q,ee,V,oe){return this.s(z,T,le=>le.provideCodeActions(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveCodeAction(z,Q,ee){return this.s(z,T,V=>V.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(z,Q){this.s(z,T,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(z,Q,ee){const V=this.t(new W(this.h,ee),z);return this.e.$registerDocumentFormattingSupport(V,this.o(Q,z),z.identifier,z.displayName||z.name),this.p(V)}$provideDocumentFormattingEdits(z,Q,ee,V){return this.s(z,W,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentRangeFormattingEditProvider(z,Q,ee){const V=typeof ee.provideDocumentRangesFormattingEdits=="function",oe=this.t(new X(this.h,ee),z);return this.e.$registerRangeFormattingSupport(oe,this.o(Q,z),z.identifier,z.displayName||z.name,V),this.p(oe)}$provideDocumentRangeFormattingEdits(z,Q,ee,V,oe){return this.s(z,X,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(z,Q,ee,V,oe){return this.s(z,X,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}registerOnTypeFormattingEditProvider(z,Q,ee,V){const oe=this.t(new ce(this.h,ee),z);return this.e.$registerOnTypeFormattingSupport(oe,this.o(Q,z),V,z.identifier),this.p(oe)}$provideOnTypeFormattingEdits(z,Q,ee,V,oe,le){return this.s(z,ce,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,V,oe,le),void 0,le)}registerWorkspaceSymbolProvider(z,Q){const ee=this.t(new J(Q,this.l),z);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(z,Q,ee){return this.s(z,J,V=>V.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(z,Q,ee){return this.s(z,J,V=>V.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(z,Q){this.s(z,J,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(z,Q,ee){const V=this.t(new Y(this.h,ee,this.l),z);return this.e.$registerRenameSupport(V,this.o(Q,z),Y.supportsResolving(ee)),this.p(V)}$provideRenameEdits(z,Q,ee,V,oe){return this.s(z,Y,le=>le.provideRenameEdits(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveRenameLocation(z,Q,ee,V){return this.s(z,Y,oe=>oe.resolveRenameLocation(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentSemanticTokensProvider(z,Q,ee,V){const oe=this.t(new se(this.h,ee),z),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(Q,z),V,le);let Le=this.p(oe);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Le=I.$MK.from(Le,je)}return Le}$provideDocumentSemanticTokens(z,Q,ee,V){return this.s(z,se,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(Q),ee,V),null,V)}$releaseDocumentSemanticTokens(z,Q){this.s(z,se,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,ee,V){const oe=this.t(new Z(this.h,ee),z);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(Q,z),V),this.p(oe)}$provideDocumentRangeSemanticTokens(z,Q,ee,V){return this.s(z,Z,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,V),null,V)}registerCompletionItemProvider(z,Q,ee,V){const oe=this.t(new ve(this.h,this.j.converter,ee,this.m,z),z);return this.e.$registerCompletionsProvider(oe,this.o(Q,z),V,ve.supportsResolving(ee),z.identifier),this.p(oe)}$provideCompletionItems(z,Q,ee,V,oe){return this.s(z,ve,le=>le.provideCompletionItems(D.URI.revive(Q),ee,V,oe),void 0,oe)}$resolveCompletionItem(z,Q,ee){return this.s(z,ve,V=>V.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(z,Q){this.s(z,ve,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(z,Q,ee,V){const oe=new H(z,this.h,ee,this.j.converter),le=this.t(oe,z);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,z),oe.supportsHandleEvents,k.$fm.toKey(z.identifier.value),V?.yieldTo?.map(Le=>k.$fm.toKey(Le))||[]),this.p(le)}$provideInlineCompletions(z,Q,ee,V,oe){return this.s(z,de,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,V,oe),void 0,oe)}$handleInlineCompletionDidShow(z,Q,ee,V){this.s(z,de,async oe=>{oe.handleDidShowCompletionItem(Q,ee,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,Q,ee,V){this.s(z,de,async oe=>{oe.handlePartialAccept(Q,ee,V)},void 0,void 0)}$freeInlineCompletionsList(z,Q){this.s(z,de,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(z,Q,ee,V){const oe=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,le=this.t(new ne(this.h,ee),z);return this.e.$registerSignatureHelpProvider(le,this.o(Q,z),oe),this.p(le)}$provideSignatureHelp(z,Q,ee,V,oe){return this.s(z,ne,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,V,oe),void 0,oe)}$releaseSignatureHelp(z,Q){this.s(z,ne,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(z,Q,ee){const V=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new ye(this.h,this.j.converter,ee,this.l,z),z);this.e.$registerInlayHintsProvider(oe,this.o(Q,z),typeof ee.resolveInlayHint=="function",V,be.u(z));let le=this.p(oe);if(V!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));le=I.$MK.from(le,Le)}return le}$provideInlayHints(z,Q,ee,V){return this.s(z,ye,oe=>oe.provideInlayHints(D.URI.revive(Q),ee,V),void 0,V)}$resolveInlayHint(z,Q,ee){return this.s(z,ye,V=>V.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(z,Q){this.s(z,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(z,Q,ee){const V=this.t(new he(this.h,ee),z);return this.e.$registerDocumentLinkProvider(V,this.o(Q,z),typeof ee.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(z,Q,ee){return this.s(z,he,V=>V.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(z,Q,ee){return this.s(z,he,V=>V.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(z,Q){this.s(z,he,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(z,Q,ee){const V=this.t(new ge(this.h,ee),z);return this.e.$registerDocumentColorProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentColors(z,Q,ee){return this.s(z,ge,V=>V.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(z,Q,ee,V){return this.s(z,ge,oe=>oe.provideColorPresentations(D.URI.revive(Q),ee,V),void 0,V)}registerFoldingRangeProvider(z,Q,ee){const V=this.q(),oe=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ae(new _(this.h,ee),z)),this.e.$registerFoldingRangeProvider(V,this.o(Q,z),z.identifier,oe);let le=this.p(V);if(oe!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));le=I.$MK.from(le,Le)}return le}$provideFoldingRanges(z,Q,ee,V){return this.s(z,_,oe=>oe.provideFoldingRanges(D.URI.revive(Q),ee,V),void 0,V)}registerSelectionRangeProvider(z,Q,ee){const V=this.t(new ie(this.h,ee,this.l),z);return this.e.$registerSelectionRangeProvider(V,this.o(Q,z)),this.p(V)}$provideSelectionRanges(z,Q,ee,V){return this.s(z,ie,oe=>oe.provideSelectionRanges(D.URI.revive(Q),ee,V),[],V)}registerCallHierarchyProvider(z,Q,ee){const V=this.t(new G(this.h,ee),z);return this.e.$registerCallHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareCallHierarchy(z,Q,ee,V){return this.s(z,G,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideCallHierarchyIncomingCalls(z,Q,ee,V){return this.s(z,G,oe=>oe.provideCallsTo(Q,ee,V),void 0,V)}$provideCallHierarchyOutgoingCalls(z,Q,ee,V){return this.s(z,G,oe=>oe.provideCallsFrom(Q,ee,V),void 0,V)}$releaseCallHierarchy(z,Q){this.s(z,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(z,Q,ee){const V=this.t(new te(this.h,ee),z);return this.e.$registerTypeHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareTypeHierarchy(z,Q,ee,V){return this.s(z,te,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideTypeHierarchySupertypes(z,Q,ee,V){return this.s(z,te,oe=>oe.provideSupertypes(Q,ee,V),void 0,V)}$provideTypeHierarchySubtypes(z,Q,ee,V){return this.s(z,te,oe=>oe.provideSubtypes(Q,ee,V),void 0,V)}$releaseTypeHierarchy(z,Q){this.s(z,te,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(z,Q,ee,V){const oe=this.q();this.f.set(oe,new Ae(new fe(this.e,this.h,ee,oe,z),z));const le=(0,t.$hF)(z,"dropMetadata")&&V?fe.toInternalProviderId(z.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(Q,z),le,(0,t.$hF)(z,"dropMetadata")?V:void 0),this.p(oe)}$provideDocumentOnDropEdits(z,Q,ee,V,oe,le){return this.s(z,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(Q,D.URI.revive(ee),V,oe,le)),void 0,void 0)}registerMappedEditsProvider(z,Q,ee){const V=this.t(new we(this.h,ee),z);return this.e.$registerMappedEditsProvider(V,this.o(Q,z)),this.p(V)}$provideMappedEdits(z,Q,ee,V,oe){return this.s(z,we,le=>Promise.resolve(le.provideMappedEdits(Q,ee,V,oe)),null,oe)}registerDocumentPasteEditProvider(z,Q,ee,V){const oe=this.q();this.f.set(oe,new Ae(new F(this.e,this.h,ee,oe,z),z));const le=F.toInternalProviderId(z.identifier.value,V.id);return this.e.$registerPasteEditProvider(oe,this.o(Q,z),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(z,Q,ee,V,oe){return this.s(z,F,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,V,oe),void 0,oe)}$providePasteEdits(z,Q,ee,V,oe,le){return this.s(z,F,Le=>Le.providePasteEdits(Q,D.URI.revive(ee),V,oe,le),void 0,le)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,Q,ee){const{wordPattern:V}=ee;if(V&&(0,$.$Te)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(Q,V):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const oe=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?be.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,Q,le),this.p(oe)}$setWordDefinitions(z){for(const Q of z)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$7ec=be}),define(Se[328],ke([1,0,6,15,7,39,12,3,25]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class y{constructor(C,m,v,k){this.c=m,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$KK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,k=N.Position.from(m),u=await this.a.$tokensAtPosition(C.uri,k),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$OK(m.line,m.character,m.line,m.character)};if(!u)return f;const s={range:N.Range.to(u.range),type:N.TokenType.to(u.type)};return!s.range.contains(m)||v!==C.version?f:s}createLanguageStatusItem(C,m,v){const k=this.f++,u=this.a,f=this.g,s=`${C.identifier.value}/${m}`;if(f.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(s);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new b.$Rc,a=()=>{if(n?.dispose(),!f.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$3g)(()=>{o.clear(),this.a.$setLanguageStatus(k,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),u.$removeLanguageStatus(k),f.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,$.$iF)(C,"languageStatusText"),i.text=r,a()},get text2(){return(0,$.$iF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$tgc=y}),define(Se[115],ke([1,0,11,13,2,5,14,6,27,20]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0;let M=class{constructor(m,v,k){this.f=k,this.d=new Map,this.a=v.getProxy(b.$KK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:k,args:u,comment:f}=v;if(this.c)return(0,N.$Ie)(k,u??{});let s=k;f&&f.length>0&&(s+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$Ie)(i??k,u??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const k=await this.g(m);if(!k){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(k),f=JSON.parse(u);v=m.isBuiltin?f.contents?.bundle:f}catch(u){this.f.error(`Failed to load translations for ${m.identifier.value} from ${k}: ${u.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:k})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Rfc=M,e.$Rfc=M=Je([We(0,$.$5M),We(1,y.$OM),We(2,R.$ij)],M),e.$Sfc=(0,I.$1h)("IExtHostLocalizationService")}),define(Se[150],ke([1,0,14,6,27,20,2,54]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;let $=class extends D.$tj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$xh)(v))),this.r=C.getProxy(N.$KK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$5gc=$,e.$5gc=$=Je([We(0,I.$OM),We(1,g.$5M)],$);class y extends D.$oj{constructor(C,m,v,k){super(k?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,k).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],ke([1,0,6,5,3,20,22]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,N.$1h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$KK.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),k=new g.$Rc;return this.d.set(m,new y(m,v,k)),k.add((0,g.$Qc)(()=>this.d.delete(m))),k.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),k.dispose()})),k.add(v.onDidClose(u=>{this.a.$onDidManagedSocketClose(m,u?.stack??u?.message),k.dispose()})),k.add(v.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(m,R.$ge.wrap(u)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Ufc=b,e.$Ufc=b=Je([We(0,I.$OM)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Sc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(Se[329],ke([1,0,6,14,25]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;function I(b){return b&&b.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$KK.MainThreadMessageService)}showMessage($,y,M,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof C=="string"||I(C)?k=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,k=m),v.useCustom&&(0,g.$iF)($,"resolvers");const u=[];for(let f=0;f<k.length;f++){const s=k[f];if(typeof s=="string")u.push({title:s,handle:f,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;u.push({title:i,isCloseAffordance:!!n,handle:f})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(y,M,v,u).then(f=>{if(typeof f=="number")return k[f]})}};e.$ugc=R,e.$ugc=R=Je([We(1,N.$ij)],R)}),define(Se[330],ke([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;let n=class{constructor(h,S,L,w,p){this.m=S,this.n=L,this.o=w,this.q=p,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=h.getProxy(C.$KK.MainThreadNotebookKernels);const E=new m.$cN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$aN("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const B=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:B}}else if(A&&"notebookEditor"in A){const B=this.n.getIdByEditor(A.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return A})],m.$bN.Void);this.o.registerApiCommand(E)}createNotebookController(h,S,L,w,p,E){for(const Z of this.j.values())if(Z.controller.id===S&&y.$fm.equals(h.identifier,Z.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const A=this.k++,B=this;this.q.trace(`NotebookController[${A}], CREATED by ${h.identifier.value}, ${S}`);const O=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${h.identifier}'`);let P=!1;const j=new I.$Sd,T=new I.$Sd,F={id:l(h.identifier,S),notebookType:L,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:w||h.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let W=p??O,X,ce;this.a.$addKernel(A,F).catch(Z=>{console.log(Z),P=!0});let J=0;const Y=()=>{if(P)return;const Z=++J;Promise.resolve().then(()=>{Z===J&&this.a.$updateKernel(A,F)})},x=new b.$Ac,se={get id(){return S},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(Z){F.label=Z??h.displayName??h.name,Y()},get detail(){return F.detail??""},set detail(Z){F.detail=Z,Y()},get description(){return F.description??""},set description(Z){F.description=Z,Y()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Z){F.supportedLanguages=Z,Y()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){F.supportsExecutionOrder=Z,Y()},get rendererScripts(){return F.preloads?F.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??O},get interruptHandler(){return X},set interruptHandler(Z){X=Z,F.supportsInterrupt=!!Z,Y()},set variableProvider(Z){(0,s.$iF)(h,"notebookVariableProvider"),ce=Z,F.hasVariableProvider=!!Z,Z?.onDidChangeVariables(ve=>B.a.$variablesUpdated(ve.uri)),Y()},get variableProvider(){return ce},createNotebookCellExecution(Z){if(P)throw new Error("notebook controller is DISPOSED");if(!x.has(Z.notebook.uri))throw B.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return B._createNotebookCellExecution(Z,l(h.identifier,this.id))},createNotebookExecution(Z){if((0,s.$iF)(h,"notebookExecution"),P)throw new Error("notebook controller is DISPOSED");if(!x.has(Z.uri))throw B.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return B._createNotebookExecution(Z,l(h.identifier,this.id))},dispose:()=>{P||(this.q.trace(`NotebookController[${A}], DISPOSED`),P=!0,this.j.delete(A),j.dispose(),T.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(Z,ve){ve===k.NotebookControllerAffinity2.Hidden&&(0,s.$iF)(h,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(A,Z.uri,ve)},onDidReceiveMessage:T.event,postMessage(Z,ve){return(0,s.$iF)(h,"notebookMessaging"),B.a.$postMessage(A,ve&&B.n.getIdByEditor(ve),Z)},asWebviewUri(Z){return(0,s.$iF)(h,"notebookMessaging"),(0,u.$avb)(Z,B.m.remote)}};return this.j.set(A,{extensionId:h.identifier,controller:se,onDidReceiveMessage:T,onDidChangeSelection:j,associatedNotebooks:x}),se}getIdByController(h){for(const[S,L]of this.j)if(L.controller===h)return l(L.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,S){const L=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const p={dispose:()=>{this.f.delete(L),w.a.$removeKernelDetectionTask(L)}};return this.f.set(L,p),p}registerKernelSourceActionProvider(h,S,L){const w=this.i++,p=typeof L.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,E=this;this.h.set(w,L),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,S);let A;return p!==void 0&&(A=L.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(w),E.a.$removeKernelSourceActionProvider(w,w),A?.dispose()}}}async $provideKernelSourceActions(h,S){const L=this.h.get(h);if(L){const w=new R.$Rc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,w))}return[]}$acceptNotebookAssociation(h,S,L){const w=this.j.get(h);if(w){const p=this.n.getNotebookDocument($.URI.revive(S));L?w.associatedNotebooks.set(p.uri,!0):w.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),L),w.onDidChangeSelection.fire({selected:L,notebook:p.apiNotebook})}}async $executeCells(h,S,L){const w=this.j.get(h);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S)),E=[];for(const A of L){const B=p.getCell(A);B&&E.push(B.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),E.length),await w.controller.executeHandler.call(w.controller,E,p.apiNotebook,w.controller)}catch(A){this.q.error(`NotebookController[${h}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(h,S,L){const w=this.j.get(h);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,p.apiNotebook);else for(const E of L){const A=p.getCell(E);A&&this.b.get(A.uri)?.cancel()}if(w.controller.interruptHandler){const E=this.c.get(p.uri);L.length&&Array.isArray(E)&&E.length&&E.forEach(A=>A.dispose())}}async $provideVariables(h,S,L,w,p,E,A){const B=this.j.get(h);if(!B)return;const O=this.n.getNotebookDocument($.URI.revive(L)),P=B.controller.variableProvider;if(!P)return;const j=w?{name:w,value:""}:void 0,T=p==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,F=P.provideVariables(O.apiNotebook,j,T,E,A);for await(const W of F){if(A.isCancellationRequested)return;this.a.$receiveVariable(S,W)}}$acceptKernelMessageFromRenderer(h,S,L){const w=this.j.get(h);if(!w)return;const p=this.n.getEditorById(S);w.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:L}))}$cellExecutionChanged(h,S,L){const p=this.n.getNotebookDocument($.URI.revive(h)).getCell(S);if(p){const E=L?v.NotebookCellExecutionState.to(L):k.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:p.apiCell,state:E})}}_createNotebookCellExecution(h,S){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const p=new a(S,w,this.a);this.b.set(w.uri,p);const E=p.onDidChangeState(()=>{p.state===o.Resolved&&(p.dispose(),E.dispose(),this.b.delete(w.uri))});return p.asApiObject()}_createNotebookExecution(h,S){const L=this.n.getNotebookDocument(h.uri),w=h.getCells().find(A=>{const B=L.getCellFromApiCell(A);return B&&this.b.has(B.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const p=new r(S,L,this.a),E=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),E.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[p,E]),p.asApiObject()}};e.$ygc=n,e.$ygc=n=Je([We(4,M.$ij)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,S,L){super(),this.m=S,this.n=L,this.b=a.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$3d),this.h=new d(10,w=>this.s(w)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const S=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$Dv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let S=this.m;if(h&&(S=this.m.notebook.getCellFromApiCell(h)),!S)throw new Error("INVALID cell");return S.handle}y(h){return h.map(S=>{const L=k.$cM.ensureUniqueMimeTypes(S.items,!0);return L===S.items?v.NotebookCellOutput.from(S):v.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(h,S,L){const w=this.w(S),p=this.y((0,D.$3b)(h));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:w,append:L,outputs:p})}async C(h,S,L){return h=k.$cM.ensureUniqueMimeTypes((0,D.$3b)(h),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(L){h.j=L,h.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(L){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,w){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$Dv({runEndTime:w,lastRunSuccess:L}))},clearOutput(L){return h.t(),h.z([],L,!1)},appendOutput(L,w){return h.t(),h.z(L,w,!0)},replaceOutput(L,w){return h.t(),h.z(L,w,!1)},appendOutputItems(L,w){return h.t(),h.C(L,w,!0)},replaceOutputItems(L,w){return h.t(),h.C(L,w,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,S,L){super(),this.h=S,this.j=L,this.b=r.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$3d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,S){this.f=h,this.g=S,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new N.$lh,this.b=Date.now(),(0,N.$2g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>h.complete())}}function l(c,h){return`${c.value}/${h}`}e.$zgc=l}),define(Se[331],ke([1,0,4,6,146]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$KK.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const M=this.c.getEditorById(b);this.a.get($)?.fire({editor:M.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(M=>M.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(M,C,m)=>this.d($).event(M,C,m),postMessage:(M,C)=>{g.$ggc.apiEditorsToExtHost.has(M)&&([M,C]=[C,M]);const m=C&&g.$ggc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,M)}}}d(b){let $=this.a.get(b);return $||($=new D.$Sd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Agc=I}),define(Se[332],ke([1,0,3,18,2,25,6]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(R.$KK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,M,C){if((0,I.$iF)(y,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,C),this.a.$registerProfileContentHandler(M,C.name,C.description,y.identifier.value),(0,D.$Qc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(y,M,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(M,C,m)}async $readProfile(y,M,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,N.$Df)(M)?M:g.URI.revive(M),C)}}e.$Dgc=b}),define(Se[333],ke([1,0,2,6,12,15]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(N.$KK.MainThreadQuickDiff)}$provideOriginalResource($,y,M){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Tg)(()=>m.provideOriginalResource(C,M)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,M,C){const m=R.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),M,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Fgc=R}),define(Se[334],ke([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;function k(u,f,s){const i=u.getProxy(I.$KK.MainThreadQuickOpen);class n{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,w,p=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(L),A=++this.f,B=i.$show(A,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},p),O={},P=B.then(()=>O);return Promise.race([P,E]).then(j=>{if(j===O)return;const T=(0,m.$hF)(S,"quickPickItemTooltip");return E.then(F=>{const W=[];for(let X=0;X<F.length;X++){const ce=F[X];if(typeof ce=="string")W.push({label:ce,handle:X});else if(ce.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!T&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const J=ce.iconPath?d(ce.iconPath):void 0;W.push({label:ce.label,iconPath:J?.iconPath,iconClass:J?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:T?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:X})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=X=>{w.onDidSelectItem(F[X])}),i.$setItems(A,W),B.then(X=>{if(typeof X=="number")return F[X];if(Array.isArray(X))return X.map(ce=>F[ce])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(A,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=D.CancellationToken.None){return this.d=S?.validateInput,i.$input(S,typeof this.d=="function",L).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let w;switch(L.severity){case b.InputBoxValidationSeverity.Info:w=M.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=M.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=M.default.Error;break;default:w=L.message?M.default.Error:M.default.Ignore;break}return{content:L.message,severity:w}}async showWorkspaceFolderPick(S,L=D.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!w)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(E=>E.uri.toString()===w.uri.toString())}createQuickPick(S){const L=new l(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new c(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const w=this.e.get(S);w instanceof l&&w._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const w=this.e.get(S);w instanceof l&&w._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,w){const p=this.e.get(S);p instanceof l&&p._fireDidTriggerItemButton(L,w)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Sd,this.q=new N.$Sd,this.r=new N.$Sd,this.s=new N.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,w)=>{const p=L===b.$8L.Back?-1:w;this.o.set(p,L)}),this.z({buttons:S.map((L,w)=>({...d(L.iconPath),tooltip:L.tooltip,handle:L===b.$8L.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const w=S[L];this.u[L]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof b.$HL)return{id:h.id};const S=r(h),L=t(h);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof L=="string"?R.URI.file(L):L}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const S=a(h);let L,w;return"id"in S?w=C.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:w}}class l extends o{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Sd,this.L=[],this.M=new N.$Sd,this.N=new N.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((p,E)=>{this.C.set(E,p),this.D.set(p,E)});const L=(0,m.$hF)(this.O,"quickPickItemTooltip"),w=[];for(let p=0;p<S.length;p++){const E=S[p];if(E.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:E.label});else{E.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=E.iconPath?d(E.iconPath):void 0;w.push({handle:p,label:E.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:L?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((B,O)=>({...d(B.iconPath),tooltip:B.tooltip,handle:O}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const w=this.C.get(S);if(!w||!w.buttons||!w.buttons.length)return;const p=w.buttons[L];p&&this.N.fire({button:p,item:w})}}class c extends o{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:M.default.Error}):this.z({validationMessage:S.message,severity:S.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new n(f,s)}e.$Ggc=k}),define(Se[335],ke([1,0,2,4,59,3,12,6,19,128,14,26,61,15,25,17,11]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0;function i(O){return O instanceof D.URI}function n(O,P){return O.scheme===u.Schemas.file&&P.scheme===u.Schemas.file&&f.$k?O.toString()===P.toString():O.toString().toLowerCase()===P.toString().toLowerCase()}function o(O){if(O)return typeof O.iconPath=="string"?D.URI.file(O.iconPath):D.URI.isUri(O.iconPath)||m.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function a(O){if(O?.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function t(O){if(O.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function r(O){if(O.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function d(O,P){if(!O.iconPath&&!P.iconPath)return 0;if(O.iconPath){if(!P.iconPath)return 1}else return-1;const j=typeof O.iconPath=="string"?O.iconPath:D.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,T=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,y.$Dq)(j,T)}function l(O,P){let j=0;if(O.strikeThrough!==P.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==P.faded)return O.faded?1:-1;if(O.tooltip!==P.tooltip)return(O.tooltip||"").localeCompare(P.tooltip||"");if(j=d(O,P),j!==0)return j;if(O.light&&P.light)j=d(O.light,P.light);else{if(O.light)return 1;if(P.light)return-1}if(j!==0)return j;if(O.dark&&P.dark)j=d(O.dark,P.dark);else{if(O.dark)return 1;if(P.dark)return-1}return j}function c(O,P){if(O.command!==P.command)return O.command<P.command?-1:1;if(O.title!==P.title)return O.title<P.title?-1:1;if(O.tooltip!==P.tooltip){if(O.tooltip!==void 0&&P.tooltip!==void 0)return O.tooltip<P.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(O.arguments===P.arguments)return 0;if(O.arguments)if(P.arguments){if(O.arguments.length!==P.arguments.length)return O.arguments.length-P.arguments.length}else return 1;else return-1;for(let j=0;j<O.arguments.length;j++){const T=O.arguments[j],F=P.arguments[j];if(T!==F&&!(i(T)&&i(F)&&n(T,F)))return T<F?-1:1}return 0}function h(O,P){let j=(0,y.$Dq)(O.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(j!==0)return j;if(O.command&&P.command)j=c(O.command,P.command);else{if(O.command)return 1;if(P.command)return-1}if(j!==0)return j;if(O.decorations&&P.decorations)j=l(O.decorations,P.decorations);else{if(O.decorations)return 1;if(P.decorations)return-1}return j}function S(O,P){for(let j=0;j<O.length;j++)if(O[j]!==P[j])return!1;return!0}function L(O,P){return O.command===P.command&&O.title===P.title&&O.tooltip===P.tooltip&&(O.arguments&&P.arguments?S(O.arguments,P.arguments):O.arguments===P.arguments)}function w(O,P){return(0,$.$ub)(O,P,L)}class p{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.o,P),this.q(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.o,P),this.f=P}get validateInput(){return(0,k.$iF)(this.m,"scmValidation"),this.g}set validateInput(P){if((0,k.$iF)(this.m,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.o,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.o,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.o,P))}get actionButton(){return(0,k.$iF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(P){(0,k.$iF)(this.m,"scmInputBoxActionButton"),this.l.value=new I.$Rc,this.k=P;const j=P!==void 0?{command:this.n.converter.toInternal(P.command,this.l.value),icon:a(P),enabled:P.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,j??null)}get document(){return(0,k.$iF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(P,j,T,F,W,X){this.m=P,this.n=j,this.o=W,this.p=X,this.d="",this.e=new N.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new I.$Tc,this.#t=T,this.#e=F}showValidationMessage(P,j){(0,k.$iF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,P,j)}$onInputBoxValueChange(P){this.q(P)}q(P){this.d=P,this.e.fire(P)}}e.$Hgc=p;class E{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,j,T,F,W){this.q=P,this.s=j,this.t=T,this.u=F,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=E.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,j){const T=this.h.get(P);return T?(0,R.$Tg)(()=>this.s.executeCommand(T.command,...T.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(h),T=(0,$.$Db)(this.o,P,h).map(X=>{const ce=X.toInsert.map(J=>{const Y=this.e++;this.g.set(Y,J);const x=J.resourceUri;let se;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const _=new I.$Rc;se=this.s.converter.toInternal(J.command,_),this.j.set(Y,_)}else this.h.set(Y,J.command);const Z=o(J.decorations),ve=J.decorations&&o(J.decorations.light)||Z,de=J.decorations&&o(J.decorations.dark)||Z,H=[ve,de],U=J.decorations&&J.decorations.tooltip||"",ne=J.decorations&&!!J.decorations.strikeThrough,ye=J.decorations&&!!J.decorations.faded,he=J.contextValue||"";return{rawResource:[Y,x,H,U,ne,ye,he,se],handle:Y}});return{start:X.start,deleteCount:X.deleteCount,toInsert:ce}}),F=T.map(({start:X,deleteCount:ce,toInsert:J})=>[X,ce,J.map(Y=>Y.rawResource)]),W=T.reverse();for(const{start:X,deleteCount:ce,toInsert:J}of W){const Y=J.map(se=>se.handle),x=this.n.splice(X,ce,...Y);for(const se of x)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=P,F}dispose(){this.l=!0,this.m.fire()}}class A{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.x,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let j;(0,k.$hF)(this.y,"quickDiffProvider")&&(j=P?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!P,quickDiffLabel:j})}get historyProvider(){return(0,k.$iF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(P){(0,k.$iF)(this.y,"scmHistoryProvider"),this.j=P,this.k.value=new I.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!P}),P&&(this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(P.onDidChangeActionButton(()=>{(0,k.$iF)(this.y,"scmActionButton"),this.m.value=new I.$Rc;const j=P.actionButton!==void 0?{command:this.z.converter.toInternal(P.actionButton.command,this.m.value),description:P.actionButton.description,enabled:P.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,j??null)})))}get commitTemplate(){return this.n}set commitTemplate(P){P!==this.n&&(this.n=P,this.#e.$updateSourceControl(this.x,{commitTemplate:P}))}get acceptInputCommand(){return this.p}set acceptInputCommand(P){this.o.value=new I.$Rc,this.p=P;const j=this.z.converter.toInternal(P,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,k.$iF)(this.y,"scmActionButton"),this.s}set actionButton(P){(0,k.$iF)(this.y,"scmActionButton"),this.q.value=new I.$Rc,this.s=P;const j=P!==void 0?{command:this.z.converter.toInternal(P.command,this.q.value),secondaryCommands:P.secondaryCommands?.map(T=>T.map(F=>this.z.converter.toInternal(F,this.q.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(P){if(this.u&&P&&w(this.u,P))return;this.t.value=new I.$Rc,this.u=P;const j=(P||[]).map(T=>this.z.converter.toInternal(T,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(P,j,T,F,W,X,ce){this.y=P,this.z=F,this.A=W,this.B=X,this.C=ce,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Tc,this.m=new I.$Tc,this.n=void 0,this.o=new I.$Tc,this.p=void 0,this.q=new I.$Tc,this.t=new I.$Tc,this.u=void 0,this.v=!1,this.w=new N.$Sd,this.onDidChangeSelection=this.w.event,this.x=A.d++,this.D=new Map,this.E=new Set,this.#e=T;const J=D.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:ce?`rootUri=${encodeURIComponent(ce.toString())}`:void 0});this.f=new p(P,F,j,this.#e,this.x,J),this.#e.$registerSourceControl(this.x,W,X,ce,J)}createResourceGroup(P,j){const T=new E(this.#e,this.z,this.x,P,j),F=N.Event.once(T.onDidDispose)(()=>this.D.delete(T));return this.D.set(T,F),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const P=[],j=[];for(const[T,F]of this.D){F.dispose();const W=T.onDidUpdateResourceStates(()=>{this.E.add(T),this.eventuallyUpdateResourceStates()});N.Event.once(T.onDidDispose)(()=>{this.E.delete(T),W.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.x,T.handle)}),P.push([T.handle,T.id,T.label,T.features]);const X=T._takeResourceStateSnapshot();X.length>0&&j.push([T.handle,X]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.x,P,j),this.D.clear()}eventuallyUpdateResourceStates(){const P=[];this.E.forEach(j=>{const T=j._takeResourceStateSnapshot();T.length!==0&&P.push([j.handle,T])}),P.length>0&&this.#e.$spliceResourceStates(this.x,P),this.E.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.v=P,this.w.fire(P)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,g.$th)(100)],A.prototype,"eventuallyAddResourceGroups",null),Je([(0,g.$th)(100)],A.prototype,"eventuallyUpdateResourceStates",null);let B=class{static{s=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(P,j,T,F){this.n=j,this.o=T,this.p=F,this.h=new Map,this.j=new C.$hm,this.k=new N.$Sd,this.l=new Map,this.f=P.getProxy(b.$KK.MainThreadSCM),this.g=P.getProxy(b.$KK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const X=this.h.get(W.sourceControlHandle);if(!X)return W;const ce=X.getResourceGroup(W.groupHandle);return ce?ce.getResourceState(W.handle):W}else if(W&&W.$mid===4){const X=this.h.get(W.sourceControlHandle);return X?X.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const X=this.h.get(W.handle);return X||W}return W}})}createSourceControl(P,j,T,F){this.p.trace("ExtHostSCM#createSourceControl",P.identifier.value,j,T,F),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const W=s.d++,X=new A(P,this.o,this.f,this.n,j,T,F);this.h.set(W,X);const ce=this.j.get(P.identifier)||[];return ce.push(X),this.j.set(P.identifier,ce),X}registerSourceControlInputBoxValueProvider(P,j,T){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",P.identifier.value,T.label);const F=s.e++;return this.l.set(F,T),this.f.$registerSourceControlInputBoxValueProvider(F,j,T.label,r(T)),(0,I.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(F),this.l.delete(F)})}async $provideInputBoxValue(P,j,T,F){const W=this.l.get(P);if(W)return await W.provideValue(D.URI.revive(j),T,F)??void 0}getLastInputBox(P){this.p.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const j=this.j.get(P.identifier),T=j&&j[j.length-1];return T&&T.inputBox}$provideOriginalResource(P,j,T){const F=D.URI.revive(j);this.p.trace("ExtHostSCM#$provideOriginalResource",P,F.toString());const W=this.h.get(P);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Tg)(()=>W.quickDiffProvider.provideOriginalResource(F,T)).then(X=>X||null)}$onInputBoxValueChange(P,j){this.p.trace("ExtHostSCM#$onInputBoxValueChange",P);const T=this.h.get(P);return T&&T.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(P,j,T,F){this.p.trace("ExtHostSCM#$executeResourceCommand",P,j,T);const W=this.h.get(P);if(!W)return Promise.resolve(void 0);const X=W.getResourceGroup(j);return X?X.$executeResourceCommand(T,F):Promise.resolve(void 0)}$validateInput(P,j,T){this.p.trace("ExtHostSCM#$validateInput",P);const F=this.h.get(P);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Tg)(()=>F.inputBox.validateInput(j,T)).then(W=>{if(!W)return Promise.resolve(void 0);const X=v.MarkdownString.fromStrict(W.message);return X?Promise.resolve([X,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.h.get(P)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(P,j,T){return await this.h.get(P)?.historyProvider?.resolveHistoryItemGroupBase(j,T)??void 0}async $resolveHistoryItemGroupCommonAncestor(P,j,T,F){return await this.h.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,T,F)??void 0}async $provideHistoryItems(P,j,T,F){return(await this.h.get(P)?.historyProvider?.provideHistoryItems(j,T,F))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemChanges(P,j,T){return await this.h.get(P)?.historyProvider?.provideHistoryItemChanges(j,T)??void 0}};e.$Igc=B,e.$Igc=B=s=Je([We(3,M.$ij)],B)}),define(Se[117],ke([1,0,6,4,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0;class I{constructor(b){this.b=new N.$Sd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$KK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Ofc=I,e.$Pfc=(0,g.$1h)("IExtHostSecretState")}),define(Se[336],ke([1,0,6,15,2]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$KK.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Jgc=I}),define(Se[337],ke([1,0,21,3,6]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$KK.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const M=new N.$Rc,C=new D.$3d;this.d.set($,C);const m=M.add(y.provideSpeechToTextSession(C.token));M.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),M.add(C.token.onCancellationRequested(()=>M.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const M=I.a++;return this.c.set(M,y),this.b.$registerProvider(M,$,{extension:b,displayName:b.value}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$Kgc=I}),define(Se[338],ke([1,0,7,6,217,3,15,18]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$IL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$IL("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,k,u,f,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Rc,this.#e=m,this.#t=v,f&&u){this.c=(0,D.$lL)(u.identifier,f);const n=k.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=u,this.f=f,this.g=s,this.h=this.u(i)}u(m){if((0,b.$Hf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Rc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const u=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,u,this.r?.internal,k,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Lgc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$MK(()=>{const k=this.b.indexOf(v);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(m,v){this.e=new Map,this.a=m.getProxy(N.$KK.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,k,u){return new $(this.a,this.b,this.e,m,v,k,u)}setStatusBarMessage(m,v){const k=this.c.setMessage(m);let u;return typeof v=="number"?u=setTimeout(()=>k.dispose(),v):typeof v<"u"&&v.then(()=>k.dispose(),()=>k.dispose()),new D.$MK(()=>{k.dispose(),clearTimeout(u)})}}e.$Mgc=M}),define(Se[118],ke([1,0,6,4,5]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;class I{constructor(b,$){this.c=$,this.b=new N.$Sd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$KK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const M=await this.a.$initializeExtensionStorage(b,$);let C;return M&&(C=this.d(b,$,M)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const M=this.d(b,$,y);M&&this.b.fire({shared:b,key:$,value:M})}d(b,$,y){try{return JSON.parse(y)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${M}`)}}}e.$Gfc=I,e.$Hfc=(0,g.$1h)("IExtHostStorage")}),define(Se[92],ke([1,0,5,27,14,71,2]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,D.$1h)("IExtensionStoragePaths");let b=class{constructor(y,M,C){this.d=M,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,M=await this.g(y);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$qfc=b,e.$qfc=b=Je([We(0,N.$5M),We(1,g.$ij),We(2,I.$ofc)],b)}),define(Se[47],ke([1,0,4,6,5,2,20,3,7,219,8,263,21,30,264,61,12,15,35]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=void 0,e.$Kfc=(0,g.$1h)("IExtHostTerminalService");class n{constructor(w,p,E,A){this.l=w,this._id=p,this.m=E,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(O,P=!0){B.q(),B.l.$sendText(B._id,O,P)},show(O){B.q(),B.l.$show(B._id,O)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(w,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??p?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:u.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(w.location,p?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,p,E,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:E,color:u.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.o(w,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,p){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in w?{viewColumn:s.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,p){this.h=Object.freeze({code:w,reason:p})}setDimensions(w,p){return w===this.d&&p===this.g||w===0||p===0?!1:(this.d=w,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(p=>{p!==w&&(this.b=Promise.resolve(w))})}}e.$Lfc=n;class o{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new D.$Sd,this.onProcessData=this.a.event,this.b=new D.$Sd,this.d=new D.$Sd,this.onDidChangeProperty=this.d.event,this.f=new D.$Sd,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,p){this.g.setDimensions?.({columns:w,rows:p})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,p,E){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Sd,this.onDidChangeShell=this.N.event,this.O=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(N.$KK.MainThreadTerminalService),this.y=new k.$orb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:A=>{const B=O=>{const P=O;return this.W(P.instanceId)?.value};switch(A?.$mid){case 15:return B(A);default:{if(Array.isArray(A))for(let O=0;O<A.length&&A[O].$mid===15;O++)A[O]=B(A[O]);return A}}}}),this.B({dispose:()=>{for(const[A,B]of this.g)B.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,p){const E=new n(this.a,(0,v.$lg)(),w,w.name),A=new o(w.pty);return E.createExtensionTerminal(w.location,this.R(w,p).resolvedExtHostIdentifier,c(w.iconPath),h(w.color)).then(B=>{const O=this.S(B,A);this.h[B]=O}),this.f.push(E),E.value}R(w,p){if(p=p||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const E=w.location.parentTerminal;if(E){const A=this.f.find(B=>B.value===E);A&&(p.resolvedExtHostIdentifier=A._id)}}else w.location&&typeof w.location!="object"?p.location=w.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(w,p){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const A=new o(p),B=this.S(w,A);this.h[w]=B}async $acceptActiveTerminalChanged(w){const p=this.b;if(w===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const E=this.W(w);E&&(this.b=E,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,p){const E=this.W(w);E&&this.O.fire({terminal:E.value,data:p})}async $acceptTerminalDimensions(w,p,E){const A=this.W(w);A&&A.setDimensions(p,E)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(w,p){const E=this.W(w);E&&this.P.fire({terminal:E.value,...p})}async $acceptTerminalMaximumDimensions(w,p,E){this.g.get(w)?.resize(p,E)}async $acceptTerminalTitleChange(w,p){const E=this.W(w);E&&(E.name=p)}async $acceptTerminalClosed(w,p,E){const A=this.Y(this.f,w);if(A!==null){const B=this.f.splice(A,1)[0];B.setExitStatus(p,E),this.H.fire(B.value)}}$acceptTerminalOpened(w,p,E,A){if(p){const P=this.Y(this.f,p);if(P!==null){this.f[P]._id=w,this.I.fire(this.terminals[P]),this.f[P].isOpen=!0;return}}const B={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:I.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},O=new n(this.a,w,B,E);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(w,p){this.W(w)?._setProcessId(p)}async $startExtensionTerminal(w,p){const E=this.W(w);if(!E)return{message:(0,y.localize)(0,null,w)};E.isOpen||await new Promise(B=>{const O=this.onDidOpenTerminal(async P=>{P===E.value&&(O.dispose(),B())})});const A=this.g.get(w);A?A.startSendingEvents(p):this.j[w]={initialDimensions:p}}S(w,p){const E=new b.$Rc;E.add(p.onProcessReady(B=>this.a.$sendProcessReady(w,B.pid,B.cwd,B.windowsPty))),E.add(p.onDidChangeProperty(B=>this.a.$sendProcessProperty(w,B))),this.y.startBuffering(w,p.onProcessData),E.add(p.onProcessExit(B=>this.U(w,B))),this.g.set(w,p);const A=this.j[w];return A&&p instanceof o&&(p.startSendingEvents(A.initialDimensions),delete this.j[w]),E}$acceptProcessAckDataEvent(w,p){this.g.get(w)?.acknowledgeDataEvent(p)}$acceptProcessInput(w,p){this.g.get(w)?.input(p)}$acceptTerminalInteraction(w){const p=this.W(w);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(w,p){this.W(w)?.setSelection(p)}$acceptProcessResize(w,p,E){try{this.g.get(w)?.resize(p,E)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(w,p){this.g.get(w)?.shutdown(p)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(p=>this.a.$sendProcessProperty(w,{type:"cwd",value:p}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$MK(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,p,E){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,E),this.a.$registerProfileProvider(p,w.identifier.value),new $.$MK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(w,p,E){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,E),this.a.$registerQuickFixProvider(w,p),new $.$MK(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,p){const E=new m.$3d().token;if(E.isCancellationRequested)return;const A=this.D.get(w);if(!A)return;const B=await A.provideTerminalQuickFixes(p,E);if(B===null||Array.isArray(B)&&B.length===0)return;const O=new b.$Rc;if(this.w.value=O,!Array.isArray(B))return B?s.TerminalQuickFix.from(B,this.Q.converter,O):void 0;const P=[];for(const j of B){const T=s.TerminalQuickFix.from(j,this.Q.converter,O);T&&P.push(T)}return P}async $createContributedProfileTerminal(w,p){const E=new m.$3d().token;let A=await this.C.get(w)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,p);return}this.createTerminalFromOptions(A.options,p)}}async $provideLinks(w,p){const E=this.W(w);if(!E)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const B=new m.$3d;this.G.set(w,B);const O=[],P={terminal:E.value,line:p},j=[];for(const W of this.z)j.push(f.Promises.withAsyncBody(async X=>{B.token.onCancellationRequested(()=>X({provider:W,links:[]}));const ce=await W.provideTerminalLinks(P,B.token)||[];B.token.isCancellationRequested||X({provider:W,links:ce})}));const T=await Promise.all(j);if(B.token.isCancellationRequested)return[];const F=new Map;for(const W of T)W&&W.links.length>0&&O.push(...W.links.map(X=>{const ce={id:a++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return F.set(ce.id,{provider:W.provider,link:X}),ce}));return this.F.set(w,F),O}$activateLink(w,p){const E=this.F.get(w)?.get(p);E&&E.provider.handleTerminalLink(E.link)}U(w,p){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const E=this.h[w];E&&(E.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,p)}W(w){return this.X(this.f,w)}X(w,p){const E=this.Y(w,p);return E!==null?w[E]:null}Y(w,p){const E=w.findIndex(A=>A._id===p);return E===-1?null:E}getEnvironmentVariableCollection(w){let p=this.n.get(w.identifier.value);return p||(p=new r,this.$(w.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(w,p){const E=(0,C.$wr)(p.map),A=(0,C.$xr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(w,p.persistent,E.length===0?void 0:E,A)}$initEnvironmentVariableCollections(w){w.forEach(p=>{const E=p[0],A=new r(p[1]);this.$(E,A)})}$acceptDefaultProfile(w,p){const E=this.s;this.s=w,this.u=p,E?.path!==w.path&&this.N.fire(w.path)}$(w,p){this.n.set(w,p),p.onDidChangeCollection(()=>{this.Z(w,p)})}};e.$Mfc=t,e.$Mfc=t=Je([We(1,i.$$M),We(2,R.$OM)],t);class r{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Sd,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const p=this.h(w);let E=this.a.get(p);return E||(E=new d(this,w),this.a.set(p,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:A})}append(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:A})}prepend(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:A})}f(w,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(w,p.scope),A=this.map.get(E),B=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==p.value||A.type!==p.type||A.options?.applyAtProcessCreation!==B.applyAtProcessCreation||A.options?.applyAtShellIntegration!==B.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const O=this.g(w,p.scope),P={variable:w,...p,options:B};this.map.set(O,P),this.d.fire()}}get(w,p){const E=this.g(w,p),A=this.map.get(E);return A?S(A):void 0}g(w,p){const E=this.h(p);return E.length?`${w}:::${E}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const p=new Map;for(const[E,A]of this.map)this.h(A.scope)===this.h(w)&&p.set(A.variable,S(A));return p}delete(w,p){const E=this.g(w,p);this.map.delete(E),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[p,E]of this.map)E.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(p);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,p){const E=this.h(p),A=this.descriptionMap.get(E);if(!A||A.description!==w){let B;typeof w=="string"?B=w:B=w?.value.split(`

`)[0];const O={description:B,scope:p};this.descriptionMap.set(E,O),this.d.fire()}}getDescription(w){const p=this.h(w);return this.descriptionMap.get(p)?.description}k(w){const p=this.h(w);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,p){this.b=w,this.d=p,this.a=new D.$Sd}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,p,E){this.b.replace(w,p,E,this.d)}append(w,p,E){this.b.append(w,p,E,this.d)}prepend(w,p,E){this.b.prepend(w,p,E,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,p){this.b.getVariableMap(this.d).forEach((E,A)=>w.call(p,A,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,p){super(!1,w,p)}createTerminal(w,p,E){throw new M.$_}createTerminalFromOptions(w,p){throw new M.$_}};e.$Nfc=l,e.$Nfc=l=Je([We(0,i.$$M),We(1,R.$OM)],l);function c(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function h(L){return u.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const w={...L};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Se[339],ke([1,0,12,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0;let a=class extends $.$Sc{constructor(O,P,j){super(),this.u=j,this.f=this.B(new I.$Sd),this.g=new Map,this.s=this.B(new I.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(m.$KK.MainThreadTesting),this.m=new p(this.h),this.j=new l(this.h),P.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const F=T,W=F.tests[F.tests.length-1].item.extId;return this.g.get(s.$CJ.root(W))?.collection.tree.get(W)?.actual??(0,k.$1M)(T)}case 18:{const{extId:F,message:W}=T;return{test:this.g.get(s.$CJ.root(F))?.collection.tree.get(F)?.actual,message:u.TestMessage.to(W)}}default:return T}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await P.executeCommand("_testing.getExplorerSelection"),F=W=>{const X=this.g.get(s.$CJ.root(W));if(X)return s.$CJ.isRoot(W)?X.controller:X.collection.tree.get(W)?.actual};return{include:T?.include.map(F).filter(M.$Lf)||[],exclude:T?.exclude.map(F).filter(M.$Lf)||[]}})}createTestController(O,P,j,T){if(this.g.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const F=new $.$Rc,W=F.add(new k.$4M(P,j,this.u));W.root.label=j;const X=new Map,ce=new Set,J=this.h,Y={items:W.root.children,get label(){return j},set label(se){j=se,W.root.label=se,J.$updateController(P,{label:j})},get refreshHandler(){return T},set refreshHandler(se){T=se,J.$updateController(P,{canRefresh:!!se})},get id(){return P},createRunProfile:(se,Z,ve,de,H,U)=>{let ne=(0,b.$Oi)(se);for(;X.has(ne);)ne++;return new E(this.h,X,O,ce,this.s.event,P,ne,se,Z,ve,de,H,U)},createTestItem(se,Z,ve){return new k.$2M(P,se,Z,ve)},createTestRun:(se,Z,ve=!0)=>this.j.createTestRun(O,P,W,se,Z,ve),invalidateTestResults:se=>{if(se===void 0)this.h.$markTestRetired(void 0);else{const Z=se instanceof Array?se:[se];this.h.$markTestRetired(Z.map(ve=>s.$CJ.fromExtHostTestItem(ve,P).toString()))}},set resolveHandler(se){W.resolveHandler=se},get resolveHandler(){return W.resolveHandler},dispose:()=>{F.dispose()}};J.$registerTestController(P,j,!!T),F.add((0,$.$Qc)(()=>J.$unregisterTestController(P)));const x={controller:Y,collection:W,profiles:X,extension:O,activeProfiles:ce};return this.g.set(P,x),F.add((0,$.$Qc)(()=>this.g.delete(P))),F.add(W.onDidGenerateDiff(se=>J.$publishDiff(P,se.map(n.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.m.checkout()}async runTests(O,P=g.CancellationToken.None){const j=c(O);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(j.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(F=>s.$CJ.fromExtHostTestItem(F,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:A[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:O.exclude?.map(F=>F.id)},P)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,P,j){return await this.j.getCoverageReport(O,P)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(O,P,j,T){return await this.j.getCoverageReport(O,P)?.resolveFileCoverage(j,T)??[]}$configureRunProfile(O,P){this.g.get(O)?.profiles.get(P)?.configureHandler?.()}$setActiveRunProfiles(O){const P=new Map;for(const[j,T]of Object.entries(O)){const F=this.g.get(j);if(!F)continue;const W=new Map,X=T.filter(J=>!F.activeProfiles.has(J)),ce=[...F.activeProfiles].filter(J=>!T.includes(J));for(const J of X)W.set(J,!0),F.activeProfiles.add(J);for(const J of ce)W.set(J,!1),F.activeProfiles.delete(J);W.size&&P.set(j,W)}this.s.fire(P)}async $refreshTests(O,P){await this.g.get(O)?.controller.refreshHandler?.(P)}$publishTestResults(O){this.results=Object.freeze(O.map(P=>(0,y.$hn)(u.TestResults.to(P))).concat(this.results).sort((P,j)=>j.completedAt-P.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,P){const j=this.g.get(s.$CJ.fromString(O).controllerId)?.collection;j&&(await j.expand(O,P<0?1/0:P),j.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(n.TestsDiffOp.deserialize))}async $runControllerTests(O,P){return Promise.all(O.map(j=>this.w(j,!1,P)))}async $startContinuousRun(O,P){const j=new g.$3d(P),T=await Promise.all(O.map(F=>this.w(F,!0,j.token)));return!P.isCancellationRequested&&!T.some(F=>F.error)&&await new Promise(F=>P.onCancellationRequested(F)),j.dispose(!0),T}async w(O,P,j){const T=this.g.get(O.controllerId);if(!T)return{};const{collection:F,profiles:W,extension:X}=T,ce=W.get(O.profileId);if(!ce)return{};const J=O.testIds.map(Z=>F.tree.get(Z)).filter(M.$Lf),Y=O.excludeExtIds.map(Z=>T.collection.tree.get(Z)).filter(M.$Lf).filter(Z=>J.some(ve=>ve.fullId.compare(Z.fullId)===2));if(!J.length)return{};const x=new f.$jM(J.some(Z=>Z.actual instanceof k.$3M)?void 0:J.map(Z=>Z.actual),Y.map(Z=>Z.actual),ce,P),se=(0,n.$EJ)(O)&&this.j.prepareForMainThreadTestRun(x,h.fromInternal(O,T.collection),X,j);try{return await ce.runHandler(x,j),{}}catch(Z){return{error:String(Z)}}finally{se&&(se.hasRunningTasks&&!j.isCancellationRequested&&await I.Event.toPromise(se.onEnd),se.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$Qgc=a,e.$Qgc=a=Je([We(0,v.$OM)],a);const t=1e4;var r;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(r||(r={}));class d extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,P,j,T){super(),this.s=O,this.u=P,this.w=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Sd),this.m=this.B(new I.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$3d(T));const F=this.B(new D.$ah(()=>this.y(),t));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(O){const P=this.s.id,j=this.s.controllerId,T=(0,C.$lg)(),F=this.w,W=this.m;let X;const ce=se=>(Z,...ve)=>{if(Y){console.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.s.isIncluded(Z)&&(this.C(Z),se(Z,...ve))},J=(se,Z)=>{const ve=Z instanceof Array?Z.map(u.TestMessage.from):[u.TestMessage.from(Z)];if(se.uri&&se.range){const de={range:u.Range.from(se.range),uri:se.uri};for(const H of ve)H.location=H.location||de}this.u.$appendTestMessagesInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),ve)};let Y=!1;const x={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return X?.provider},set coverageProvider(se){(0,o.$iF)(F,"testCoverage"),X=se&&new S(se),W.fire({taskId:T,runId:P,coverage:X})},enqueued:ce(se=>{this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),1)}),skipped:ce(se=>{this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),5)}),started:ce(se=>{this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),2)}),errored:ce((se,Z,ve)=>{J(se,Z),this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),6,ve)}),failed:ce((se,Z,ve)=>{J(se,Z),this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,j).toString(),4,ve)}),passed:ce((se,Z)=>{this.u.$updateTestStateInRun(P,T,s.$CJ.fromExtHostTestItem(se,this.s.controllerId).toString(),3,Z)}),appendOutput:(se,Z,ve)=>{Y||(ve&&(this.s.isIncluded(ve)?this.C(ve):ve=void 0),this.u.$appendOutputToRun(P,T,N.$ge.fromString(se),Z&&u.location.from(Z),ve&&s.$CJ.fromExtHostTestItem(ve,j).toString()))},end:()=>{Y||(Y=!0,this.u.$finishedTestRunTask(P,T),this.f.delete(T),this.f.size||this.z())}};return this.f.set(T,{run:x}),this.u.$startedTestRunTask(P,{id:T,name:O,running:!0}),x}y(){for(const{run:O}of this.f.values())O.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(O){if(!(O instanceof k.$2M))throw new i.$GM(O.id);if(this.g.has(s.$CJ.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const P=[],j=this.s.colllection.root;for(;;){const T=u.TestItem.from(O);if(P.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),O===j))break;O=O.parent||j}this.u.$addTestsToRun(this.s.controllerId,this.s.id,P)}dispose(){this.z(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(O){this.f=O,this.c=new Map,this.d=[]}getCoverageReport(O,P){return this.d.find(j=>j.runId===O)?.coverage.get(P)}prepareForMainThreadTestRun(O,P,j,T){return this.g(O,P,j,T)}cancelRunById(O){for(const P of this.c.values())if(P.id===O){P.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,P,j,T,F,W){const X=this.c.get(T);if(X)return X.createRun(F);const ce=h.fromPublic(P,j,T,W),J=c(T);this.f.$startedExtensionTestRun({controllerId:P,continuous:!!T.continuous,profile:J&&{group:A[J.kind],id:J.profileId},exclude:T.exclude?.map(x=>s.$CJ.fromExtHostTestItem(x,j.root.id).toString())??[],id:ce.id,include:T.include?.map(x=>s.$CJ.fromExtHostTestItem(x,j.root.id).toString())??[j.root.id],persist:W});const Y=this.g(T,ce,O);return I.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(ce.id),Y.dispose()}),Y.createRun(F)}g(O,P,j,T){const F=new d(P,this.f,j,T);this.c.set(O,F);let W;const X=F.onDidCoverage(({runId:ce,taskId:J,coverage:Y})=>{W||(W={runId:ce,coverage:new Map},this.d.unshift(W),this.d.length>n.$JJ&&this.d.pop()),W.coverage.set(J,Y),this.f.$signalCoverageAvailable(ce,J,!!Y)});return I.Event.once(F.onEnd)(()=>{this.c.delete(O),X.dispose()}),F}}e.$Rgc=l;const c=B=>{if(B.profile){if(!(B.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class h{static fromPublic(O,P,j,T){return new h(O,(0,C.$lg)(),j.include?.map(F=>s.$CJ.fromExtHostTestItem(F,O).toString())??[O],j.exclude?.map(F=>s.$CJ.fromExtHostTestItem(F,O).toString())??[],T,P)}static fromInternal(O,P){return new h(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,P)}constructor(O,P,j,T,F,W){this.controllerId=O,this.id=P,this.isPersisted=F,this.colllection=W,this.c=j.map(X=>X+"\0"),this.d=T.map(X=>X+"\0")}isIncluded(O){const P=s.$CJ.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const j of this.d)if(P===j||P.startsWith(j))return!1;for(const j of this.c)if(P===j||P.startsWith(j))return!0;return!1}}e.$Sgc=h;class S{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(u.TestCoverage.fromFile)??[]}catch(P){throw this.c=void 0,P}}async resolveFileCoverage(O,P){const j=await this.c;let T=j?.[O];return!this.provider||!j||!T?[]:(T.detailedCoverage||(T=j[O]=await this.provider.resolveFileCoverage?.(T,P)??T),T.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class L{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,u.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const P=s.$CJ.parentId(O.item.extId);if(P&&this.g.has(P.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:P,f:j}=this;return{get added(){return[...O].map(T=>T.revived)},get updated(){return[...P].map(T=>T.revived)},get removed(){return[...j].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends n.$KJ{constructor(){super(...arguments),this.q=new I.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,P){return{...O,revived:u.TestItem.toPlain(O.item),depth:P?P.depth+1:0,children:new Set}}o(){return new L(this.q)}}class p{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(P=>P.revived)},dispose:(0,R.$db)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class E{#e;#t;#i;#o;#r;get label(){return this.d}set label(O){O!==this.d&&(this.d=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?u.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}get isSelected(){return(0,o.$iF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.$iF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,O=>O.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(M.$Lf))}constructor(O,P,j,T,F,W,X,ce,J,Y,x=!1,se=void 0,Z=!1){this.controllerId=W,this.profileId=X,this.d=ce,this.kind=J,this.runHandler=Y,this.f=x,this._tag=se,this.g=Z,this.#e=O,this.#r=P,this.#t=j,this.#i=T,this.#o=F,P.set(X,this);const ve=A[J];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:X,controllerId:W,tag:se?u.TestTag.namespace(this.controllerId,se.id):null,label:ce,group:ve,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Tgc=E;const A={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(Se[340],ke([1,0,19,8,4,6,148,15,7]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class y{constructor(C,m){this.i=m,this.a=new g.$Sd({onListenerError:N.$2}),this.b=new g.$Sd({onListenerError:N.$2}),this.c=new g.$Sd({onListenerError:N.$2}),this.d=new g.$Sd({onListenerError:N.$2}),this.f=new g.$Sd({onListenerError:N.$2}),this.g=new g.$Sd({onListenerError:N.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(I.$KK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const m=this.i.allEditors();return C?m:m.map(v=>v.value)}async showTextDocument(C,m,v){let k;typeof m=="number"?k={position:b.ViewColumn.from(m),preserveFocus:v}:typeof m=="object"?k={position:b.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?b.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:k={preserveFocus:!1};const u=await this.h.$tryShowTextDocument(C.uri,k),f=u&&this.i.getEditor(u);if(f)return f.value;throw u?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,m){return new R.$VM(this.h,C,m).value}$acceptEditorPropertiesChanged(C,m){const v=this.i.getEditor(C);if(!v)throw new Error("unknown text editor");if(m.options&&v._acceptOptions(m.options),m.selections){const k=m.selections.selections.map(b.Selection.to);v._acceptSelections(k)}if(m.visibleRanges){const k=D.$Hb(m.visibleRanges.map(b.Range.to));v._acceptVisibleRanges(k)}if(m.options&&this.b.fire({textEditor:v.value,options:{...m.options,lineNumbers:b.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const k=$.TextEditorSelectionChangeKind.fromValue(m.selections.source),u=m.selections.selections.map(b.Selection.to);this.a.fire({textEditor:v.value,selections:u,kind:k})}if(m.visibleRanges){const k=D.$Hb(m.visibleRanges.map(b.Range.to));this.c.fire({textEditor:v.value,visibleRanges:k})}}$acceptEditorPositionData(C){for(const m in C){const v=this.i.getEditor(m);if(!v)throw new Error("Unknown text editor");const k=b.ViewColumn.to(C[m]);v.value.viewColumn!==k&&(v._acceptViewColumn(k),this.d.fire({textEditor:v.value,viewColumn:k}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$dfc=y}),define(Se[341],ke([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0,e.$Vgc=(0,N.$1h)("IExtHostTimeline");class M{constructor(v,k){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$KK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(u,f)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&$.$fm.equals(f,this.b.get(u.source)?.extension)){const s=u.uri===void 0?void 0:D.URI.revive(u.uri);return this.c.get(u.source)?.get(C(s))?.get(u.handle)}else return;return u}})}async $getTimeline(v,k,u,f){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(k),u,f)}registerTimelineProvider(v,k,u,f){const s=new I.$Rc,i=this.d(k.id,f,s).bind(this);let n;k.onDidChange&&(n=k.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const o=this.c;return this.f({...k,scheme:v,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(k.id)?.clear());const d=await k.provideTimeline(a,t,r);if(d==null)return;const l=i(a,t);return{...d,source:k.id,items:d.items.map(l)}},dispose(){for(const a of o.values())a.get(k.id)?.clear();n?.dispose(),s.dispose()}},u)}d(v,k,u){return(f,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=C(f);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,l;n.iconPath&&(o instanceof R.$HL?l={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let c;return R.$bL.isMarkdownString(a.tooltip)?c=b.MarkdownString.from(a.tooltip):(0,y.$Df)(a.tooltip)?c=a.tooltip:R.$bL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(a.detail)):(0,y.$Df)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?k.toInternal(n.command,u):void 0,icon:r,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(v,k){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:k}),(0,I.$Qc)(()=>{for(const f of this.c.values())f.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Wgc=M;function C(m){return m?.toString()}}),define(Se[72],ke([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5xb=e.$4xb=e.TunnelDtoConverter=void 0;class v extends $.$tv{}var k;(function(f){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$4xb=(0,R.$1h)("IExtHostTunnelService");let u=class extends g.$Sc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$KK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$MK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const d of s){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(i.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:n,commandLine:o},a)}catch{h=await l.provider.providePortAttributes(c,n,o,a)}return{providedAttributes:h,port:c}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new D.$3d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,g.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),k.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$5xb=u,e.$5xb=u=Je([We(0,C.$OM),We(1,M.$5M),We(2,b.$ij)],u)}),define(Se[342],ke([1,0,3,17,2,6]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$KK.MainThreadUriOpeners)}registerExternalUriOpener($,y,M,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!R.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,M),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Qc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,M){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,M)}async $openUri($,y,M){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},M)}}e.$Ygc=R}),define(Se[343],ke([1,0,6,2,3,8,26]),function(me,e,D,N,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class b{static{this.a=0}constructor(y){this.c=new R.$gm,this.d=new Map,this.b=y.getProxy(D.$KK.MainThreadUrls)}registerUriHandler(y,M){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,M),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Qc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,M){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(M))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return N.URI.revive(await this.b.$createAppUri(y))}}e.$Zgc=b}),define(Se[93],ke([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=e.$tfc=e.$sfc=e.$rfc=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Sd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=d,this.#n=l,this.#l=m(l),this.#d=v(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,y.$avb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+y.$_ub}return y.$_ub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),I.$kn(this.#s,o)||this.#t.$setOptions(this.#e,f(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,$.$Rkb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,l,c,h,S)=>{const L=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,y.$avb)(L,{isRemote:a,authority:t}).toString();return`${d}${w}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,l,c,h,S)=>{const L=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,y.$avb)(L,{isRemote:a,authority:t}).toString();return`${d}${w}${S}`})}}e.$rfc=C;function m(n){try{const o=(0,b.$Zo)((0,b.$Yo)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$sfc=m;function v(n){try{const o=(0,b.$Zo)((0,b.$Yo)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class k extends N.$Sc{constructor(o,a,t,r,d){super(),this.c=a,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(M.$KK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:d}=(0,$.$Skb)(a,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new C(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$tfc=k;function u(n){return{id:n.identifier,location:n.extensionLocation}}e.$ufc=u;function f(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$vfc=f;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Se[344],ke([1,0,21,53,3,17,23,2,15,93,110,6,7]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class v{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new M.$Wec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$Cg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class k{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,l){const c=this.b(r,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new v(d,l);return this.a.set(c,h),h}delete(r,d){const l=this.b(r,d.uri);this.a.delete(l)}b(r,d){return`${r}@@@${d}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class f{constructor(){this.a=new Map}addTextProvider(r,d,l){return this.b(0,r,d,l)}addCustomProvider(r,d,l){return this.b(1,r,d,l)}get(r){return this.a.get(r)}b(r,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:l,provider:c}),new m.$MK(()=>this.a.delete(d))}}class s{constructor(r,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new f,this.c=new k,this.a=r.getProxy(C.$KK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,l,c){const h=new g.$Rc;return n(l)?(h.add(this.b.addTextProvider(d,r,l)),this.a.$registerTextEditorProvider((0,y.$ufc)(r),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,y.$sfc)(r))):(h.add(this.b.addCustomProvider(d,r,l)),i(l)&&h.add(l.onDidChangeCustomDocument(S=>{const L=this.i(d,S.document.uri);if(o(S)){const w=L.addEdit(S);this.a.$onDidEdit(S.document.uri,d,w,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,y.$ufc)(r),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$sfc)(r))),m.$MK.from(h,new m.$MK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,l,c,h){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${d}'`);const L=b.URI.revive(r),w=await S.provider.openCustomDocument(L,{backupId:l,untitledDocumentData:c?.buffer},h);let p;return i(S.provider)&&this.f&&(p=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,w,p),{editable:i(S.provider)}}async $disposeCustomDocument(r,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=b.URI.revive(r),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,l,c,h,S){const L=this.b.get(l);if(!L)throw new Error(`No provider found for '${l}'`);const w=$.ViewColumn.to(h),p=this.g.createNewWebview(d,c.contentOptions,L.extension),E=this.h.createNewWebviewPanel(d,l,c.title,w,c.options,p,c.active),A=b.URI.revive(r);switch(L.type){case 1:{const{document:B}=this.i(l,A);return L.provider.resolveCustomEditor(B,E,S)}case 0:{const B=this.d.getDocument(A);return L.provider.resolveCustomTextEditor(B,E,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,l){this.i(d,r).disposeEdits(l)}async $onMoveCustomEditor(r,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const S=b.URI.revive(d),L=this.d.getDocument(S);await c.provider.moveCustomTextEditor(L,h,D.CancellationToken.None)}async $undo(r,d,l,c){return this.i(d,r).undo(l,c)}async $redo(r,d,l,c){return this.i(d,r).redo(l,c)}async $revert(r,d,l){const c=this.i(d,r);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(r,d,l){const c=this.i(d,r);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(r,d,l,c){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),c)}async $backup(r,d,l){const c=this.i(d,r),S=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(S),S.id}i(r,d){const l=this.c.get(r,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(r){const l=this.b.get(r)?.provider;if(!l||!i(l))throw new Error("Custom document is not editable");return l}}e.$xfc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Oi)(r)+""}}),define(Se[345],ke([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class M extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(k,u,f,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=u,this.#o=f,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,g.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#s=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:R.ViewColumn.from(k),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Sc{static c(){return(0,I.$lg)()}constructor(k,u,f){super(),this.j=u,this.m=f,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$KK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,u,f,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,b.$sfc)(k),t=C.c();this.f.$createWebviewPanel((0,b.$ufc)(k),t,u,{title:f,panelOptions:m(i),webviewOptions:(0,b.$vfc)(k,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,u,f,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(k){const u=Object.keys(k);u.sort((f,s)=>{const i=k[f],n=k[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of u){const s=this.getWebviewPanel(f);if(!s)continue;const i=k[f];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,u,f){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:f,extension:k}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,b.$sfc)(k)}),new y.$MK(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(k,u,f,s){const i=this.h.get(u);if(!i)throw new Error(`No serializer found for '${u}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(k,f.webviewOptions,o),t=this.createNewWebviewPanel(k,u,f.title,s,f.panelOptions,a,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(k,u,f,s,i,n,o){const a=new M(k,this.f,n,{viewType:u,title:f,viewColumn:s,panelOptions:i,active:o});return this.g.set(k,a),a}getWebviewPanel(k){return this.g.get(k)}}e.$wfc=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Se[346],ke([1,0,4,3,93,15,6,7]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class $ extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,v,k,u,f){super(),this.#r=!1,this.#u=this.B(new D.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Sd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=k,this.#e=C,this.#t=m,this.#o=u,this.#n=f}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$KK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,k){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$ufc)(C),m,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$sfc)(C)}),new b.$MK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,k,u){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=f,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,v,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:k},u)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$1gc=y}),define(Se[151],ke([1,0,4,6,2,17,13,5,20,25]),function(me,e,D,N,g,I,R,b,$,y){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=void 0;let C=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(v){const k=this.d;return{get focused(){return k.focused},get active(){return(0,y.$iF)(v,"windowActivity"),k.active}}}constructor(v){this.c=new D.$Sd,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=v.getProxy(N.$KK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:u})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,k){k!==this.d[v]&&(this.d={...this.d,[v]:k},this.c.fire(this.d))}openUri(v,k){let u;if(typeof v=="string"){u=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Ge)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,u,k)}async asExternalUri(v,k){if((0,R.$Ge)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(v,k);return g.URI.from(u)}};e.$2gc=C,e.$2gc=C=M=Je([We(0,$.$OM)],C),e.$3gc=(0,b.$1h)("IExtHostWindow")}),define(Se[347],ke([1,0,315,27,20]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;const I=1024*1024;let R=class extends D.$6gc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,M){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,M),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const M=process[$],C=M.write;let m="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(v,k,u)=>{if(!this.g){m+=v.toString(k);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(M,v,k,u)}})}};e.$Ehc=R,e.$Ehc=R=Je([We(0,g.$OM),We(1,N.$5M)],R)}),define(Se[348],ke([1,0,71,17,14,250,32,11]),function(me,e,D,N,g,I,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Fhc=$,e.$Fhc=$=Je([We(0,D.$ofc),We(1,g.$ij)],$);class y{constructor(C){this.b=C,this.a=new I.$mq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Se[349],ke([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;let M=class extends R.$Sc{constructor(m,v){super();const k=m.getProxy(b.$KK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async u=>{const f=$.URI.file((0,D.$jc)((0,N.tmpdir)(),(0,g.$lg)()));return await k.$download(u,f),f})}};e.$Dhc=M,e.$Dhc=M=Je([We(0,y.$OM),We(1,I.$$M)],M)}),define(Se[350],ke([1,0,150,17,252,30]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class R extends D.$5gc{s($,y,M){return $.scheme===N.Schemas.file?new g.$1N(M?.name||(0,I.$lg)(),$.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,y):super.s($,y,M)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Qhc=R}),define(Se[351],ke([1,0,55,16,2,92,3,17,12,31]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class M extends I.$qfc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await C(c);const h=N.$jc(c,"vscode.lock"),S=await u(this.d,h,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),g.URI.file(c);l++}while(l<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Phc=M;async function C(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class k extends R.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$_g),this.a.cancelAndSet(async()=>{const d=await f(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function u(a,t,r){try{const l={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){a.error(l)}const d=await f(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new k(a,t))}async function f(a,t){let r;try{r=await y.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function s(a,t){let r;try{r=await y.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await f(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let S=r.willReleaseAt-Date.now();if(S<5e3){for(S>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,$.$2g)(Math.min(100,S)),await s(a,t)===0)return o(a,t);S=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const d=await s(a,t),l=Date.now()-d;if(l<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$2g)(2e3);const c=await s(a,t),h=Date.now()-c;return h<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return u(a,t,!0)}}),define(Se[352],ke([1,0,30,20,47,35]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;let R=class extends g.$Mfc{constructor($,y){super(!0,$,y)}createTerminal($,y,M){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:M})}createTerminalFromOptions($,y){const M=new g.$Lfc(this.a,(0,D.$lg)(),$,$.name);return this.f.push(M),M.create($,this.R($,y)),M.value}};e.$$gc=R,e.$$gc=R=Je([We(0,I.$$M),We(1,N.$OM)],R)}),define(Se[353],ke([1,0,12,22,21,8,4,3,130,304,68]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.ResponsiveState=e.RequestInitiator=e.$d7b=e.$c7b=void 0;function m(E,A){try{return JSON.stringify(E,A)}catch{return"null"}}const v="$$ref$$",k={[v]:-1};class u{constructor(A,B){this.jsonString=A,this.referencedBuffers=B}}function f(E,A=null,B=!1){const O=[];return{jsonString:(B?m:JSON.stringify)(E,(j,T)=>{if(typeof T>"u")return k;if(typeof T=="object"){if(T instanceof N.$ge){const F=O.push(T)-1;return{[v]:F}}if(A)return A(j,T)}return T}),referencedBuffers:O}}e.$c7b=f;function s(E,A,B){return JSON.parse(E,(O,P)=>{if(P){const j=P[v];if(typeof j=="number")return A[j];if(B&&P.$mid===1)return B.transformIncoming(P)}return P})}e.$d7b=s;function i(E,A){return JSON.stringify(E,A)}function n(E){return E?(A,B)=>B&&B.$mid===1?E.transformOutgoing(B):B:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Sc{static{C=r}static{this.a=3*1e3}constructor(A,B=null,O=null){super(),this[C]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=B,this.g=O,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let P=0,j=M.$Av.count;P<j;P++)this.m[P]=null,this.s[P]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$ah(()=>this.H(),1e3)),this.c.onMessage(P=>this.L(P))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const B=this.w[A];delete this.w[A],B.resolveErr(I.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,$.$1m)(A,this.g):A}getProxy(A){const{nid:B,sid:O}=A;return this.s[B]||(this.s[B]=this.J(B,O)),this.s[B]}J(A,B){const O={get:(P,j)=>(typeof j=="string"&&!P[j]&&j.charCodeAt(0)===36&&(P[j]=(...T)=>this.U(A,j,T)),j===d?B:P[j])};return new Proxy(Object.create(null),O)}set(A,B){return this.m[A.nid]=B,B}assertRegistered(A){for(let B=0,O=A.length;B<O;B++){const P=A[B];if(!this.m[P.nid])throw new Error(`Missing proxy instance ${P.sid}`)}}L(A){if(this.j)return;const B=A.byteLength,O=h.read(A,0),P=O.readUInt8(),j=O.readUInt32();switch(P){case 1:case 2:{let{rpcId:T,method:F,args:W}=L.deserializeRequestJSONArgs(O);this.g&&(W=(0,$.$1m)(W,this.g)),this.M(B,j,T,F,W,P===2);break}case 3:case 4:{let{rpcId:T,method:F,args:W}=L.deserializeRequestMixedArgs(O);this.g&&(W=(0,$.$1m)(W,this.g)),this.M(B,j,T,F,W,P===4);break}case 5:{this.f?.logIncoming(B,j,0,"ack"),this.G(j);break}case 6:{this.N(B,j);break}case 7:{this.O(B,j,void 0);break}case 9:{let T=L.deserializeReplyOKJSON(O);this.g&&(T=(0,$.$1m)(T,this.g)),this.O(B,j,T);break}case 10:{const T=L.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(B,j,T);break}case 8:{const T=L.deserializeReplyOKVSBuffer(O);this.O(B,j,T);break}case 11:{let T=L.deserializeReplyErrError(O);this.g&&(T=(0,$.$1m)(T,this.g)),this.P(B,j,T);break}case 12:{this.P(B,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,B,O,P,j,T){this.f?.logIncoming(A,B,1,`receiveRequest ${(0,M.$Cv)(O)}.${P}(`,j);const F=String(B);let W,X;if(T){const J=new g.$3d;j.push(J.token),W=this.Q(O,P,j),X=()=>J.cancel()}else W=this.Q(O,P,j),X=t;this.u[F]=X;const ce=L.serializeAcknowledged(B);this.f?.logOutgoing(ce.byteLength,B,1,"ack"),this.c.send(ce),W.then(J=>{delete this.u[F];const Y=L.serializeReplyOK(B,J,this.h);this.f?.logOutgoing(Y.byteLength,B,1,"reply:",J),this.c.send(Y)},J=>{delete this.u[F];const Y=L.serializeReplyErr(B,J);this.f?.logOutgoing(Y.byteLength,B,1,"replyErr:",J),this.c.send(Y)})}N(A,B){this.f?.logIncoming(A,B,1,"receiveCancel");const O=String(B);this.u[O]?.()}O(A,B,O){this.f?.logIncoming(A,B,0,"receiveReply:",O);const P=String(B);if(!this.w.hasOwnProperty(P))return;const j=this.w[P];delete this.w[P],j.resolveOk(O)}P(A,B,O){this.f?.logIncoming(A,B,0,"receiveReplyErr:",O);const P=String(B);if(!this.w.hasOwnProperty(P))return;const j=this.w[P];delete this.w[P];let T;O&&(O.$isError?(T=new Error,T.name=O.name,T.message=O.message,T.stack=O.stack):T=O),j.resolveErr(T)}Q(A,B,O){try{return Promise.resolve(this.S(A,B,O))}catch(P){return Promise.reject(P)}}S(A,B,O){const P=this.m[A];if(!P)throw new Error("Unknown actor "+(0,M.$Cv)(A));const j=P[B];if(typeof j!="function")throw new Error("Unknown method "+B+" on actor "+(0,M.$Cv)(A));return j.apply(P,O)}U(A,B,O){if(this.j)return new y.$b7b;let P=null;if(O.length>0&&g.CancellationToken.isCancellationToken(O[O.length-1])&&(P=O.pop()),P&&P.isCancellationRequested)return Promise.reject(I.$6());const j=L.serializeRequestArguments(O,this.h),T=++this.t,F=String(T),W=new y.$a7b,X=new b.$Rc;P&&X.add(P.onCancellationRequested(()=>{const J=L.serializeCancel(T);this.f?.logOutgoing(J.byteLength,T,0,"cancel"),this.c.send(L.serializeCancel(T))})),this.w[F]=new c(W,X),this.F(T);const ce=L.serializeRequest(T,A,B,j,!!P);return this.f?.logOutgoing(ce.byteLength,T,0,`request: ${(0,M.$Cv)(A)}.${B}(`,O),this.c.send(ce),W}}e.$e7b=l;class c{constructor(A,B){this.a=A,this.b=B}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class h{static alloc(A,B,O){const P=new h(N.$ge.alloc(O+1+4),0);return P.writeUInt8(A),P.writeUInt32(B),P}static read(A,B){return new h(A,B)}get buffer(){return this.a}constructor(A,B){this.a=A,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+A);return this.b+=A,B}static sizeMixedArray(A){let B=0;B+=1;for(let O=0,P=A.length;O<P;O++){const j=A[O];switch(B+=1,j.type){case 1:B+=this.sizeLongString(j.value);break;case 2:B+=this.sizeVSBuffer(j.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(j.value);for(let T=0;T<j.buffers.length;++T)B+=this.sizeVSBuffer(j.buffers[T]);break;case 4:break}}return B}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let B=0,O=A.length;B<O;B++){const P=A[B];switch(P.type){case 1:this.writeUInt8(1),this.writeLongString(P.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(P.value);break;case 3:this.writeUInt8(3),this.writeUInt32(P.buffers.length),this.writeLongString(P.value);for(let j=0;j<P.buffers.length;++j)this.writeBuffer(P.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const B=new Array(A);for(let O=0;O<A;O++)switch(this.readUInt8()){case 1:B[O]=this.readLongString();break;case 2:B[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),T=this.readLongString(),F=[];for(let W=0;W<j;++W)F.push(this.readVSBuffer());B[O]=new M.$Dv(s(T,F,null));break}case 4:B[O]=void 0;break}return B}}var S;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(S||(S={}));class L{static a(A){for(let B=0,O=A.length;B<O;B++)if(A[B]instanceof N.$ge||A[B]instanceof M.$Dv||typeof A[B]>"u")return!0;return!1}static serializeRequestArguments(A,B){if(this.a(A)){const O=[];for(let P=0,j=A.length;P<j;P++){const T=A[P];if(T instanceof N.$ge)O[P]={type:2,value:T};else if(typeof T>"u")O[P]={type:4};else if(T instanceof M.$Dv){const{jsonString:F,referencedBuffers:W}=f(T.value,B);O[P]={type:3,value:N.$ge.fromString(F),buffers:W}}else O[P]={type:1,value:N.$ge.fromString(i(T,B))}}return{type:1,args:O}}return{type:0,args:i(A,B)}}static serializeRequest(A,B,O,P,j){switch(P.type){case 0:return this.b(A,B,O,P.args,j);case 1:return this.c(A,B,O,P.args,j)}}static b(A,B,O,P,j){const T=N.$ge.fromString(O),F=N.$ge.fromString(P);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(T),W+=h.sizeLongString(F);const X=h.alloc(j?2:1,A,W);return X.writeUInt8(B),X.writeShortString(T),X.writeLongString(F),X.buffer}static deserializeRequestJSONArgs(A){const B=A.readUInt8(),O=A.readShortString(),P=A.readLongString();return{rpcId:B,method:O,args:JSON.parse(P)}}static c(A,B,O,P,j){const T=N.$ge.fromString(O);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(T),F+=h.sizeMixedArray(P);const W=h.alloc(j?4:3,A,F);return W.writeUInt8(B),W.writeShortString(T),W.writeMixedArray(P),W.buffer}static deserializeRequestMixedArgs(A){const B=A.readUInt8(),O=A.readShortString(),P=A.readMixedArray(),j=new Array(P.length);for(let T=0,F=P.length;T<F;T++){const W=P[T];typeof W=="string"?j[T]=JSON.parse(W):j[T]=W}return{rpcId:B,method:O,args:j}}static serializeAcknowledged(A){return h.alloc(5,A,0).buffer}static serializeCancel(A){return h.alloc(6,A,0).buffer}static serializeReplyOK(A,B,O){if(typeof B>"u")return this.d(A);if(B instanceof N.$ge)return this.e(A,B);if(B instanceof M.$Dv){const{jsonString:P,referencedBuffers:j}=f(B.value,O,!0);return this.g(A,P,j)}else return this.f(A,m(B,O))}static d(A){return h.alloc(7,A,0).buffer}static e(A,B){let O=0;O+=h.sizeVSBuffer(B);const P=h.alloc(8,A,O);return P.writeVSBuffer(B),P.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,B){const O=N.$ge.fromString(B);let P=0;P+=h.sizeLongString(O);const j=h.alloc(9,A,P);return j.writeLongString(O),j.buffer}static g(A,B,O){const P=N.$ge.fromString(B);let j=0;j+=h.sizeUInt32,j+=h.sizeLongString(P);for(const F of O)j+=h.sizeVSBuffer(F);const T=h.alloc(10,A,j);T.writeUInt32(O.length),T.writeLongString(P);for(const F of O)T.writeBuffer(F);return T.buffer}static deserializeReplyOKJSON(A){const B=A.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(A,B){const O=A.readUInt32(),P=A.readLongString(),j=[];for(let T=0;T<O;++T)j.push(A.readVSBuffer());return new M.$Dv(s(P,j,B))}static serializeReplyErr(A,B){const O=B?m(I.$3(B),null):void 0;if(typeof O!="string")return this.h(A);const P=N.$ge.fromString(O);let j=0;j+=h.sizeLongString(P);const T=h.alloc(11,A,j);return T.writeLongString(P),T.buffer}static deserializeReplyErrError(A){const B=A.readLongString();return JSON.parse(B)}static h(A){return h.alloc(12,A,0).buffer}}var w;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var p;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[354],ke([1,0,4,37,46,5]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=e.OutputChannelUpdateMode=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=void 0,e.$VJ="text/x-code-output",e.$WJ="output",e.$XJ="Log",e.$YJ="text/x-code-log-output",e.$ZJ="log",e.$1J="workbench.panel.output",e.$2J=new g.$fj("inOutput",!1),e.$3J=new g.$fj("activeLogOutput",!1),e.$4J=new g.$fj("outputView.scrollLock",!1),e.$5J=(0,I.$1h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$6J={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(M=>y.push(M)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}N.$sn.add(e.$6J.OutputChannels,new b),e.$7J=new g.$fj("activeOutputChannel","")}),define(Se[152],ke([1,0,6,5,20,26,14,354,71,27,57,182,22,18,32,4,3]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=void 0;class s extends R.$oj{get disposed(){return this.n}constructor(a,t,r,d,l){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=m.$ge.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,d,l,c){this.i=t,this.j=r,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$KK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$qm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,v.$Df)(t)?t:void 0;if((0,v.$Df)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([L])=>I.$fm.equals(r.identifier,L))?.[1];h&&(c=(0,R.$yj)(h));const S=d?this.o(a,c,r):this.n(a,l,r);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),d?this.r(a,c??this.m.getLevel(),S):this.q(a,S)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,l,t,r.identifier.value);return new s(h,a,c,this.a,r)}async o(a,t,r){const d=await this.p(r),l=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${r.identifier.value}.${l}`,S=this.l.createLogger(c,{id:h,name:a,logLevel:t,extensionId:r.identifier.value});return new i(h,a,S,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,k.$Ak)(d)!==k.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){r=!0,t.then(l=>l.dispose())}}}r(a,t,r){const d=new f.$Rc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new u.$Sd);function h(S){t=S,c.fire(S)}return r.then(S=>{d.add(S),S.logLevel!==t&&h(S.logLevel),d.add(S.onDidChangeLogLevel(L=>h(L)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(S,...L){l(),r.then(w=>w.trace(S,...L))},debug(S,...L){l(),r.then(w=>w.debug(S,...L))},info(S,...L){l(),r.then(w=>w.info(S,...L))},warn(S,...L){l(),r.then(w=>w.warn(S,...L))},error(S,...L){l(),r.then(w=>w.error(S,...L))},dispose(){d.dispose()}}}};e.$Bgc=n,e.$Bgc=n=Je([We(0,g.$OM),We(1,y.$5M),We(2,$.$ofc),We(3,M.$1ec),We(4,R.$jj),We(5,R.$ij)],n),e.$Cgc=(0,N.$1h)("IExtHostOutputService")}),define(Se[153],ke([1,0,5,12]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=void 0,e.$Fm=(0,D.$1h)("remoteAgentService"),e.$Gm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,N.$2g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(I):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[355],ke([1,0,224,86,37,40,45,3,4,153,11,24]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=void 0,e.$xH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$yH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$zH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$AH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const v=new m;g.$sn.add(e.$AH.ConfigurationMigration,v);let k=class extends b.$Sc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of o){const r=[];for(const l of n.overrideIdentifiers??[]){const c=await this.h(s,{resource:i,overrideIdentifier:l},a);for(const h of c??[]){let S=r.find(([[L,w]])=>L===h[0]&&(0,C.$kn)(w.value,h[1].value));S||r.push(S=[h,[]]),S[1].push(l)}}const d=await this.h(s,{resource:i},a,n);for(const l of d??[])r.push([l,[]]);r.length&&await Promise.allSettled(r.map(async([[l,c],h])=>this.a.updateValue(l,c.value,{resource:i,overrideIdentifiers:h},t)))}}async h(s,i,n,o){const a=(o??this.a.inspect(s.key,i))[n];if(a===void 0)return;const t=d=>this.a.inspect(d,i)[n],r=await s.migrateFn(a,t);return Array.isArray(r)?r:[[s.key,r]]}};e.$BH=k,e.$BH=k=Je([We(0,R.$ui),We(1,I.$0h)],k);let u=class extends b.$Sc{constructor(s){super(),(async()=>{if(!M.$i&&(await s.getEnvironment())?.os!==1)return;g.$sn.as(N.$xn.Configuration).registerConfiguration({...e.$zH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$CH=u,e.$CH=u=Je([We(0,y.$Fm)],u)}),define(Se[356],ke([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cb=e.$2cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$1cb=e.$Zcb=void 0,e.$Zcb=(0,y.$1h)("editorResolverService"),e.$1cb="workbench.editorAssociations";const C=M.$sn.as($.$xn.Configuration),m={...b.$yH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var k;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function u(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$2cb=u;function f(s,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$zg)(i);return D.$Gj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$3cb=f}),define(Se[357],ke([1,0,33,17,16,11,23,2,5,268,40,144,153]),function(me,e,D,N,g,I,R,b,$,y,M,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.$mK=void 0,e.$mK=(0,$.$1h)("pathService");let k=v=class{constructor(f,s,i,n){this.d=f,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??f})()}hasValidBasename(f,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(f,n,s)):this.h(f,s,i)}h(f,s,i){return f.scheme===N.Schemas.file||f.scheme===N.Schemas.vscodeRemote?(0,D.$1f)(i??(0,R.$zg)(f),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,y.$jK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:N.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let s="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(s=f.substring(2),f="/"):(s=f.substring(2,n),f=f.substring(n)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:s,path:f,query:"",fragment:""})}};e.$nK=k,e.$nK=k=v=Je([We(1,m.$Fm),We(2,C.$8J),We(3,M.$0h)],k)}),define(Se[358],ke([1,0,235,19,59,4,53,3,2,45,240,14,64,270,88,40,144,25,21,18,24,46]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.$fK=e.$eK=e.OnPortForward=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.TunnelSource=e.TunnelCloseReason=e.$$J=e.$0J=e.$9J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$9J="onTunnel",e.$0J=new a.$fj("forwardedPortsViewEnabled",!1,D.localize(0,null));function d(B){const O=B.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$$J=d;var l;(function(B){B.Other="Other",B.User="User",B.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var c;(function(B){B[B.User=0]="User",B[B.Auto=1]="Auto",B[B.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$_J={source:c.User,description:D.localize(1,null)},e.$aK={source:c.Auto,description:D.localize(2,null)};function h(B,O,P){const j=B.get(L(O,P));if(j)return j;if((0,k.$pv)(O))for(const T of k.$ov){const F=L(T,P);if(B.has(F))return B.get(F)}else if((0,k.$rv)(O))for(const T of k.$qv){const F=L(T,P);if(B.has(F))return B.get(F)}}e.$bK=h;function S(B,O,P){const j=h(B,O,P);if(j)return j;const T=(0,k.$rv)(O)?"localhost":(0,k.$pv)(O)?"0.0.0.0":void 0;if(T)return h(B,T,P)}e.$cK=S;function L(B,O){return B+":"+O}e.$dK=L;var w;(function(B){B.Notify="notify",B.OpenBrowser="openBrowser",B.OpenBrowserOnce="openBrowserOnce",B.OpenPreview="openPreview",B.Silent="silent",B.Ignore="ignore"})(w||(e.OnPortForward=w={}));function p(B){return B&&"host"in B&&typeof B.host=="string"&&"port"in B&&typeof B.port=="number"&&(!("detail"in B)||typeof B.detail=="string")&&(!("pid"in B)||typeof B.pid=="string")}e.$eK=p;class E extends b.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new I.$Sd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(P=>{(P.affectsConfiguration(E.c)||P.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,P,j){let T=this.w(O,P,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;T>=0;){const W=this.j[T];W.key===O?(F.onAutoForward=W.onAutoForward??F.onAutoForward,F.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:F.elevateIfNeeded,F.label=W.label??F.label,F.requireLocalPort=W.requireLocalPort,F.protocol=W.protocol):(F.onAutoForward=F.onAutoForward??W.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:W.elevateIfNeeded,F.label=F.label??W.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??W.protocol),T=this.w(O,P,j,this.j,T+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,n.$Df)(O.host)&&(0,n.$Hf)(O.port)}w(O,P,j,T,F){if(F>=T.length)return-1;const W=!(0,k.$pv)(P)&&!(0,k.$rv)(P),ce=T.slice(F).findIndex(J=>(0,n.$Hf)(J.key)?W?!1:J.key===O:this.t(J.key)?W?!1:O>=J.key.start&&O<=J.key.end:this.u(J.key)?O===J.key.port&&P===J.key.host:j?J.key.test(j):!1);return ce>=0?ce+F:-1}y(){const O=this.r.getValue(E.c);if(!O||!(0,n.$Ff)(O))return[];const P=[];for(const T in O){if(T===void 0)continue;const F=O[T];let W;if(Number(T))W=Number(T);else if((0,n.$Df)(T))if(E.g.test(T)){const X=T.match(E.g);W={start:Number(X[1]),end:Number(X[2])}}else if(E.h.test(T)){const X=T.match(E.h);W={host:X[1],port:Number(X[2])}}else{let X;try{X=RegExp(T)}catch{}X&&(W=X)}W&&P.push({key:W,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(P)}z(O){function P(j,T){return(0,n.$Hf)(j.key)?j.key:T.t(j.key)?j.key.start:T.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,T)=>P(j,this)-P(T,this))}C(){return this.m}static providedActionToAction(O){switch(O){case k.ProvidedOnAutoForward.Notify:return w.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case k.ProvidedOnAutoForward.Silent:return w.Silent;case k.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(O,P,j){const F=this.r.inspect(E.c).userRemoteValue;let W;!F||!(0,n.$Ff)(F)?W={}:W=(0,o.$gn)(F),W[`${O}`]||(W[`${O}`]={});for(const X in P)W[`${O}`][X]=P[X];return this.r.updateValue(E.c,W,j)}}e.$fK=E;let A=class extends b.$Sc{constructor(O,P,j,T,F,W,X,ce,J,Y){super(),this.H=O,this.I=P,this.J=j,this.L=T,this.M=F,this.N=W,this.O=X,this.P=ce,this.Q=J,this.R=Y,this.c=new Map,this.g=new I.$Sd,this.onForwardPort=this.g.event,this.h=new I.$Sd,this.onClosePort=this.h.event,this.j=new I.$Sd,this.onPortName=this.j.event,this.n=new I.$Sd,this.onCandidatesChanged=this.n.event,this.t=new I.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const se=await this.getAttributes(x.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of x)if(Z.localAddress){const ve=L(Z.tunnelRemoteHost,Z.tunnelRemotePort),de=S(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(ve,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:se?.get(Z.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,se?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:de?.detail,hasRunningProcess:!!de,pid:de?.pid,privacy:Z.privacy,source:e.$_J}),this.f.set(ve,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const se=L(x.tunnelRemoteHost,x.tunnelRemotePort);if(!S(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const Z=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),ve=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(se,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:ve?.protocol??k.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ve),localPort:x.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:x.privacy,source:e.$_J})}await this.$(),this.f.set(se,x),this.g.fire(this.forwarded.get(se))})),this.B(this.H.onTunnelClosed(x=>this.W(x,l.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$9J))?(this.R.createKey(e.$0J.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,P){const j=L(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,P){if(O.startsWith("http"))return $.URI.parse(O);const j=P?.protocol??"http";return $.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),P=O.configuration?(0,R.$Oi)(O.configuration.path):O.folders.length>0?(0,R.$Oi)(O.folders[0].uri.path):void 0;if(P===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${P}`}async Z(){const O=this.I.get(r,1);if(O)return this.I.remove(r,1),await this.$(),O;const P=await this.Y();if(P)return this.I.get(P,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const P=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${P.map(j=>j.remotePort).join(", ")}`);for(const j of P){const T=S(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!T||j.source.source===c.Extension&&T?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!T&&this.D.set(L(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new b.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async P=>{P.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const P=await this.Y();P&&this.I.store(P,this.y,0,0)}}}async bb(O,P,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===P)return;const T=new Date;if(this.ab.getTime()+t>T.getTime())return;this.ab=T;const F=D.localize(3,null,P,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(F)}async forward(O,P){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(O,P)}async cb(O,P){await this.Q.activateByEvent(e.$9J);const j=S(this.forwarded,O.remote.host,O.remote.port);P=P??(P!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const T=O.local!==void 0?O.local:O.remote.port;let F;if(j)return this.eb(j,O,P);{const W=this.L.remoteAuthority,X=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ce=L(O.remote.host,O.remote.port);this.c.set(ce,!0),O=this.db(ce,O);const J=await this.H.openTunnel(X,O.remote.host,O.remote.port,void 0,T,O.elevateIfNeeded?O.elevateIfNeeded:P?.elevateIfNeeded,O.privacy,P?.protocol);if(typeof J=="string")F=J;else if(J&&J.localAddress){const Y=S(this.m??new Map,O.remote.host,O.remote.port),x=J.protocol?J.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:P?.protocol??k.TunnelProtocol.Http,se={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:P?.label??O.name,closeable:!0,localAddress:J.localAddress,protocol:x,localUri:await this.X(J.localAddress,P),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:O.source??e.$_J,privacy:J.privacy};return this.forwarded.set(ce,se),this.f.set(ce,J),this.c.delete(ce),await this.$(),await this.bb(J,T,P),this.g.fire(se),J}this.c.delete(ce)}return F}db(O,P){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const T=j.get(O);j.delete(O),T&&(P.name=T.name??P.name,P.local=("local"in T?T.local:"localPort"in T?T.localPort:void 0)??P.local,P.privacy=T.privacy??P.privacy)}return P}async eb(O,P,j){const T=j?.label??P.name;let F;(function(X){X[X.None=0]="None",X[X.Fire=1]="Fire",X[X.Reopen=2]="Reopen"})(F||(F={}));let W=F.None;switch(T!==O.name&&(O.name=T,W=F.Fire),(j?.protocol||O.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(P.source=O.source,W=F.Reopen),P.privacy&&O.privacy!==P.privacy&&(W=F.Reopen),W){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(O.remoteHost,O.remotePort,l.User),await this.cb(P,j)}return S(this.f,P.remote.host,P.remote.port)}async name(O,P,j){const T=S(this.forwarded,O,P),F=L(O,P);if(T){T.name=j,await this.$(),this.j.fire({host:O,port:P});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:O,port:P}))}async close(O,P,j){const T=L(O,P),F=this.forwarded.get(T);return j===l.AutoForwardEnd&&F&&F.source.source===c.Auto&&this.F.set(T,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(O,P),this.W({host:O,port:P},j)}address(O,P){const j=L(O,P);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const P of O){const j=S(this.m??new Map,P.remoteAddress.host,P.remoteAddress.port),T=typeof P.localAddress=="string"?P.localAddress:L(P.localAddress.host,P.localAddress.port);this.detected.set(L(P.remoteAddress.host,P.remoteAddress.port),{remoteHost:P.remoteAddress.host,remotePort:P.remoteAddress.port,localAddress:T,protocol:k.TunnelProtocol.Http,localUri:this.X(T),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(P.remoteAddress.host,P.remoteAddress.port,T,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let P=O;this.r&&(P=await this.r(O));const j=this.fb(P);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(T=>T.port).join(", ")}`),this.n.fire(j)}fb(O){const P=this.m??new Map,j=new Map;return this.m=j,O.forEach(T=>{const F=L(T.host,T.port);j.set(F,{host:T.host,port:T.port,detail:T.detail,pid:T.pid}),P.has(F)&&P.delete(F);const W=S(this.forwarded,T.host,T.port);W&&(W.runningProcess=T.detail,W.hasRunningProcess=!0,W.pid=T.pid)}),P.forEach((T,F)=>{const W=d(F);if(!W)return;const X=S(this.forwarded,W.host,W.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0);const ce=S(this.detected,W.host,W.port);ce&&(ce.runningProcess=void 0,ce.hasRunningProcess=!1,ce.pid=void 0)}),P}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),P=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(P)for(const j of O){const T=P.get(j.remotePort);(T?.protocol||j.protocol!==k.TunnelProtocol.Http)&&T?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},T),T&&T.label&&T.label!==j.name&&await this.name(j.remoteHost,j.remotePort,T.label)}}async getAttributes(O,P=!0){const j=new Map,T=new Map;O.forEach(J=>{const Y=S(this.m??new Map,k.$ov[0],J.port)??J;if(Y){j.set(J.port,Y);const x=p(Y)?Y.pid:void 0;T.has(x)||T.set(x,[]),T.get(x)?.push(J.port)}});const F=new Map;if(O.forEach(J=>{const Y=this.configPortsAttributes.getAttributes(J.port,J.host,j.get(J.port)?.detail);Y&&F.set(J.port,Y)}),this.G.length===0||!P)return F.size>0?F:void 0;const W=await Promise.all((0,N.$Rb)(this.G.map(J=>Array.from(T.entries()).map(Y=>{const x=Y[1],se=j.get(x[0]);return J.providePortAttributes(x,se?.pid,se?.detail,new i.$3d().token)})))),X=new Map;if(W.forEach(J=>J.forEach(Y=>{Y&&X.set(Y.port,Y)})),!F&&!X)return;const ce=new Map;return O.forEach(J=>{const Y=F.get(J.port),x=X.get(J.port);ce.set(J.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??E.providedActionToAction(x?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),ce}addAttributesProvider(O){this.G.push(O)}};e.$gK=A,Je([(0,g.$th)(1e3)],A.prototype,"$",null),e.$gK=A=Je([We(0,k.$kv),We(1,v.$fp),We(2,y.$ui),We(3,f.$8J),We(4,m.$2k),We(5,u.$0h),We(6,C.$ij),We(7,M.$Pv),We(8,s.$eF),We(9,a.$gj)],A)}),define(Se[94],ke([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$2I=e.$1I=void 0;class D{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new D(0,0)}with(R){return new D(0,0)}}e.$1I=D;class N{constructor(R,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,b),this.end=new D($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$2I=N;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],ke([1,0,19,34,24,33,13,5,16,8,94,12]),function(me,e,D,N,g,I,R,b,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.SearchErrorCode=e.$eJ=e.$dJ=e.SearchSortOrder=e.ViewMode=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.SearchCompletionExitCode=e.$$I=e.$0I=e.$9I=e.QueryType=e.SearchProviderType=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$3I="workbench.view.search",e.$4I="workbench.panel.search",e.$5I="workbench.view.search",e.$6I="search-result",e.$7I="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",k=(m.length+v.length+5)*2;e.$8I=(0,b.$1h)("searchService");var u;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(u||(e.SearchProviderType=u={}));var f;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(f||(e.QueryType=f={}));function s(x){return!!x.preview}e.$9I=s;function i(x){return!!x.resource}e.$0I=i;function n(x){return!!x.message}e.$$I=n;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(se){this.resource=se,this.results=[]}}e.$_I=a;class t{constructor(se,Z,ve,de){this.ranges=Z,this.webviewIndex=de;const H=Array.isArray(Z)?Z:[Z];if(ve&&ve.matchLines===1&&r(H)){se=(0,R.$wf)(se,ve.matchLines);let U="",ne=0,ye=0;const he=Math.floor(ve.charsPerLine/5),ge=[];for(const _ of H){const ie=Math.max(_.startColumn-he,0),G=_.startColumn+ve.charsPerLine;if(ie>ye+he+k){const te=m+(ie-ye)+v;U+=te+se.slice(ie,G),ne+=ie-(ye+te.length)}else U+=se.slice(ye,G);ge.push(new l(0,_.startColumn-ne,_.endColumn-ne)),ye=G}this.preview={text:U,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const U=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:se,matches:(0,D.$2b)(Z,ne=>new d(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$aJ=t;function r(x){const se=x[0].startLineNumber;for(const Z of x)if(Z.startLineNumber!==se||Z.endLineNumber!==se)return!1;return!0}class d{constructor(se,Z,ve,de){this.startLineNumber=se,this.startColumn=Z,this.endLineNumber=ve,this.endColumn=de}}e.$bJ=d;class l extends d{constructor(se,Z,ve){super(se,Z,se,ve)}}e.$cJ=l;var c;(function(x){x.List="list",x.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function S(x,se=!0){const Z=x&&x.files&&x.files.exclude,ve=se&&x&&x.search&&x.search.exclude;if(!Z&&!ve)return;if(!Z||!ve)return Z||ve;let de=Object.create(null);return de=g.$jn(de,g.$gn(Z)),de=g.$jn(de,g.$gn(ve),!0),de}e.$dJ=S;function L(x,se){return x.excludePattern&&N.$Gj(x.excludePattern,se)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$Gj(x.includePattern,se)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(Z=>{const ve=Z.folder.fsPath;if(I.$3f(se,ve)){const de=$.$lc(ve,se);return!Z.includePattern||!!N.$Gj(Z.includePattern,de)}else return!1}):!1:!0}e.$eJ=L;var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class p extends Error{constructor(se,Z){super(se),this.code=Z}}e.$fJ=p;function E(x){const se=x.message;if((0,y.$4)(x))return new p(se,w.canceled);try{const Z=JSON.parse(se);return new p(Z.message,Z.code)}catch{return new p(se,w.other)}}e.$gJ=E;function A(x){const se={message:x.message,code:x.code};return new Error(JSON.stringify(se))}e.$hJ=A;function B(x){return x.type==="error"?!0:x.type==="success"}e.$iJ=B;function O(x){return x.type==="success"}e.$jJ=O;function P(x){return!!x.path}e.$kJ=P;function j(x,se){const Z=x.searchPath?x.searchPath:x.relativePath;return(0,R.$tf)(Z,se)}e.$lJ=j;class T{constructor(se){this.path=se,this.results=[]}addMatch(se){this.results.push(se)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mJ=T;function F(x,se){const Z={...x||{},...se||{}};return Object.keys(Z).filter(ve=>{const de=Z[ve];return typeof de=="boolean"&&de})}e.$nJ=F;class W{constructor(se,Z){this.c=null,this.a={...se.excludePattern||{},...Z.excludePattern||{}},this.b=N.$Hj(this.a);let ve=se.includePattern;Z.includePattern&&(ve?ve={...ve,...Z.includePattern}:ve=Z.includePattern),ve&&(this.c=N.$Hj(ve))}matchesExcludesSync(se,Z,ve){return!!(this.b&&this.b(se,Z,ve))}includedInQuerySync(se,Z,ve){return!(this.b&&this.b(se,Z,ve)||this.c&&!this.c(se,Z,ve))}includedInQuery(se,Z,ve){const de=this.b(se,Z,ve),H=()=>this.c?!!this.c(se,Z,ve):!0;return(0,C.$Ng)(de)?de.then(U=>U?!1:H()):H()}hasSiblingExcludeClauses(){return X(this.a)}}e.$oJ=W;function X(x){for(const se in x)if(typeof x[se]!="boolean")return!0;return!1}function ce(x){if(!x)return;let se;return Z=>(se||(se=(x()||Promise.resolve([])).then(ve=>ve?Y(ve):{})),se.then(ve=>!!ve[Z]))}e.$pJ=ce;function J(x){if(!x)return;let se;return Z=>{if(!se){const ve=x();se=ve?Y(ve):{}}return!!se[Z]}}e.$qJ=J;function Y(x){const se={};for(const Z of x)se[Z]=!0;return se}}),define(Se[41],ke([1,0,19,12,21,4,3,77,17,122,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;function h(O,P,j){return new M.$rg(T=>p(T,j)).isEqual(O,P)}function S(O,P,j){return h(O.uri,P.uri,j)?0:(0,C.$Ze)(O.uri.toString(),P.uri.toString())}function L(O,P,j){return O.index!==P.index?O.index<P.index?-1:1:h(O.uri,P.uri,j)?(0,C.$Ze)(O.name,P.name):(0,C.$Ze)(O.uri.toString(),P.uri.toString())}function w(O,P,j,T){const F=O.slice(0).sort((X,ce)=>j(X,ce,T)),W=P.slice(0).sort((X,ce)=>j(X,ce,T));return(0,D.$Eb)(F,W,(X,ce)=>j(X,ce,T))}function p(O,P){const j=P.getCapabilities(O.scheme);return!(j&&j&1024)}class E extends s.$hi{static toExtHostWorkspace(P,j,T,F){if(!P)return{workspace:null,added:[],removed:[]};const{id:W,name:X,folders:ce,configuration:J,transient:Y,isUntitled:x}=P,se=[],Z=j;j?ce.forEach((U,ne)=>{const ye=m.URI.revive(U.uri),he=E.o(T||j,ye,F);he?(he.name=U.name,he.index=U.index,se.push(he)):se.push({uri:ye,name:U.name,index:ne})}):se.push(...ce.map(({uri:U,name:ne,index:ye})=>({uri:m.URI.revive(U),name:ne,index:ye}))),se.sort((U,ne)=>U.index<ne.index?-1:1);const ve=new E(W,X,se,!!Y,J?m.URI.revive(J):null,!!x,U=>p(U,F)),{added:de,removed:H}=w(Z?Z.workspaceFolders:[],ve.workspaceFolders,S,F);return{workspace:ve,added:de,removed:H}}static o(P,j,T){for(let F=0;F<P.folders.length;F++){const W=P.workspaceFolders[F];if(h(W.uri,j,T))return W}}constructor(P,j,T,F,W,X,ce){super(P,T.map(J=>new s.$ii(J)),F,W,ce),this.t=j,this.u=X,this.q=[],this.s=b.$7h.forUris(ce),T.forEach(J=>{this.q.push(J),this.s.set(J.uri,J)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(P,j){return j&&this.s.get(P)&&(P=(0,M.$Bg)(P)),this.s.findSubstr(P)}resolveWorkspaceFolder(P){return this.s.get(P)}}let A=class{constructor(P,j,T,F,W){this.c=new I.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Ud,this.B=new Map,this.h=F,this.s=T,this.t=W,this.j=new y.$3l,this.k=new N.$Zg,this.o=P.getProxy(l.$KK.MainThreadWorkspace),this.q=P.getProxy(l.$KK.MainThreadMessageService);const X=j.workspace;this.l=X?new E(X.id,X.name,[],!!X.transient,X.configuration?m.URI.revive(X.configuration):null,!!X.isUntitled,ce=>p(ce,T)):void 0}$initializeWorkspace(P,j){this.v=j,this.$acceptWorkspaceData(P),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,M.$zg)((0,M.$Bg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(P,j,T,...F){const W=[];if(Array.isArray(F)&&F.forEach(x=>{m.URI.isUri(x.uri)&&!W.some(se=>h(se.uri,x.uri,this.s))&&W.push({uri:x.uri,name:x.name||(0,M.$yg)(x.uri)})}),this.n||[j,T].some(x=>typeof x!="number"||x<0)||T===0&&W.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(j+T>X.length)return!1;const ce=X.slice(0);ce.splice(j,T,...W.map(x=>({uri:x.uri,name:x.name||(0,M.$yg)(x.uri),index:void 0})));for(let x=0;x<ce.length;x++){const se=ce[x];if(ce.some((Z,ve)=>ve!==x&&h(se.uri,Z.uri,this.s)))return!1}ce.forEach((x,se)=>x.index=se);const{added:J,removed:Y}=w(X,ce,L,this.s);if(J.length===0&&Y.length===0)return!1;if(this.o){const x=P.displayName||P.name;this.o.$updateWorkspaceFolders(x,j,T,W).then(void 0,se=>{this.n=void 0;const Z={source:{identifier:P.identifier,label:P.displayName||P.name}};this.q.$showMessage(f.Severity.Error,(0,v.localize)(0,null,x,se.toString()),Z,[])})}return this.y(ce),!0}getWorkspaceFolder(P,j){if(this.x)return this.x.getWorkspaceFolder(P,j)}async getWorkspaceFolder2(P,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(P,j)}async resolveWorkspaceFolder(P){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(P)}getPath(){if(!this.x)return;const{folders:P}=this.x;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,j){let T,F="";if(typeof P=="string"?(T=m.URI.file(P),F=P):typeof P<"u"&&(T=P,F=P.fsPath),!T)return F;const W=this.getWorkspaceFolder(T,!0);if(!W)return F;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let X=(0,M.$Eg)(W.uri,T);return j&&W.name&&(X=`${W.name}/${X}`),X}y(P){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:P,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:j,added:T,removed:F}=E.toExtHostWorkspace(P,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:F}))}findFiles(P,j,T,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let X;if(j===null?X=!1:j&&(typeof j=="string"?X=j:X=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ce,folder:J}=B(a.GlobPattern.from(P));return this.o.$startFileSearch(ce??null,J??null,X??null,T??null,W).then(Y=>Array.isArray(Y)?Y.map(x=>m.URI.revive(x)):[])}async findTextInFiles(P,j,T,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ce=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:J,folder:Y}=B(a.GlobPattern.from(j.include)),x=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,se={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ce,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:J,excludePattern:x},Z=!1;if(this.u[X]=ve=>{if(Z)return;const de=m.URI.revive(ve.resource);ve.results.forEach(H=>{const U=(0,c.$xh)(H);(0,d.$9I)(U)?T({uri:de,preview:{text:U.preview.text,matches:(0,D.$2b)(U.preview.matches,ne=>new t.$OK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$2b)(U.ranges,ne=>new t.$OK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):T({uri:de,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(P,Y??null,se,X,W);return delete this.u[X],ve||{}}catch(ve){throw delete this.u[X],ve}}$handleTextSearchResult(P,j){this.u[j]?.(P)}async save(P){const j=await this.o.$save(P,{saveAs:!1});return m.URI.revive(j)}async saveAs(P){const j=await this.o.$save(P,{saveAs:!0});return m.URI.revive(j)}saveAll(P){return this.o.$saveAll(P)}resolveProxy(P){return this.o.$resolveProxy(P)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(P){return this.o.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(P,j){if(this.w.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.w.set(P,j);const T=this.t.transformOutgoingScheme(P),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,T),(0,R.$Qc)(()=>{this.w.delete(P),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(P,j){this.h.info("Getting edit session identifier for workspaceFolder",P);const T=await this.resolveWorkspaceFolder(m.URI.revive(P));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const F=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(T,j);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(P,j,T,F){this.h.info("Getting edit session identifier for workspaceFolder",P);const W=await this.resolveWorkspaceFolder(m.URI.revive(P));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const X=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!X),!X)return;const ce=await X.provideEditSessionIdentityMatch?.(j,T,F);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(P){return(j,T,F)=>{const W=function(ce){j.call(T,ce)};return W.extension=P,this.A.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(P,j,T){const F=await this.resolveWorkspaceFolder(m.URI.revive(P));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},j,async(W,X)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>T&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(P,j){if(this.B.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.B.set(P,j);const T=this.t.transformOutgoingScheme(P),F=this.z++;return this.o.$registerCanonicalUriProvider(F,T),(0,R.$Qc)(()=>{this.B.delete(P),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(P,j,T){const F=this.B.get(P.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(m.URI.revive(P),j,T);if(W)return W}async $provideCanonicalUri(P,j,T){return this.provideCanonicalUri(m.URI.revive(P),{targetScheme:j},T)}};e.$ifc=A,e.$ifc=A=Je([We(0,o.$OM),We(1,n.$5M),We(2,i.$1ec),We(3,u.$ij),We(4,r.$gfc)],A),e.$jfc=(0,k.$1h)("IExtHostWorkspace");function B(O){let P,j;return O&&(typeof O=="string"?P=O:(P=O.pattern,j=m.URI.revive(O.baseUri))),{includePattern:P,folder:j}}}),define(Se[42],ke([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=void 0;function u(r,d){if(d){const l=d.split(".");let c=r;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function f(r){return r instanceof k.URI}function s(r){return r&&r.uri instanceof k.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof k.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(f(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,l,c){this.a=d.getProxy(I.$KK.MainThreadConfiguration),this.c=l,this.b=c,this.d=new M.$Zg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$kfc=a,e.$kfc=a=Je([We(0,m.$OM),We(1,g.$jfc),We(2,v.$ij)],a);class t{constructor(d,l,c,h){this.a=new N.$Sd,this.b=d,this.f=h,this.c=l,this.e=b.$Qn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Qn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=o(l)||{},S=this.g(d?u(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function L(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(p){return typeof u(S,p)<"u"},get:(p,E)=>{this.h(d?`${d}.${p}`:p,h,c?.identifier);let A=u(S,p);if(typeof A>"u")A=E;else{let B;const O=(P,j)=>{if((0,y.$Ff)(P)){let T;const F=()=>{B=B||(0,D.$gn)(S),T=T||u(B,j)};return new Proxy(P,{get:(W,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return F(),()=>T;if(B)return T=T||u(B,j),T[X];const ce=W[X];return typeof X=="string"?O(ce,`${j}.${X}`):ce},set:(W,X,ce)=>(F(),T&&(T[X]=ce),!0),deleteProperty:(W,X)=>(F(),T&&delete T[X],!0),defineProperty:(W,X,ce)=>(F(),T&&Object.defineProperty(T,X,ce),!0)})}return Array.isArray(P)?(0,D.$gn)(P):P};A=O(A,p)}return A},update:(p,E,A,B)=>{p=d?`${d}.${p}`:p;const O=L(A);return E!==void 0?this.b.$updateConfigurationOption(O,p,E,h,B):this.b.$removeConfigurationOption(O,p,h,B)},inspect:p=>{p=d?`${d}.${p}`:p;const E=this.e.inspect(p,h,this.c.workspace);if(E)return{key:p,defaultValue:(0,D.$gn)(E.policy?.value??E.default?.value),globalValue:(0,D.$gn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$gn)(E.workspace?.value),workspaceFolderValue:(0,D.$gn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$gn)(E.default?.override),globalLanguageValue:(0,D.$gn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$gn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$gn)(E.workspaceFolder?.override),languageIds:(0,D.$gn)(E.overrideIdentifiers)}}};return typeof S=="object"&&(0,D.$jn)(w,S,!1),Object.freeze(w)}g(d){const l=c=>(0,y.$Ff)(c)?new Proxy(c,{get:(h,S)=>l(h[S]),set:(h,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(h,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(h,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=$.$Hn.test(d)?4:this.d.get(d),S=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new b.$Sn(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,S)=>c.affectsConfiguration(h,o(S))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$lfc=t,e.$mfc=(0,C.$1h)("IExtHostConfiguration")}),define(Se[95],ke([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,303,8]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=e.$Ngc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(O){function P(T){if(T!=null)return T}O.from=P;function j(T){if(T!=null)return T}O.to=j})(a||(a={}));var t;(function(O){function P(T){if(T!=null)return T}O.from=P;function j(T){if(T!=null)return T}O.to=j})(t||(t={}));var r;(function(O){function P(T){if(T!=null)return T}O.from=P;function j(T){if(T!=null)return T}O.to=j})(r||(r={}));var d;(function(O){function P(F){if(F){const W=F;return W&&!!W.process}else return!1}O.is=P;function j(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=r.from(F.options)),W}O.from=j;function T(F){if(F!=null)return new R.$vL(F.process,F.args,F.options)}O.to=T})(d||(d={}));var l;(function(O){function P(T){if(T!=null)return T}O.from=P;function j(T){if(T!=null)return T}O.to=j})(l||(l={}));var c;(function(O){function P(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}O.is=P;function j(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=l.from(F.options)),W}O.from=j;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$wL(F.commandLine,F.options):new R.$wL(F.command,F.args?F.args:[],F.options)}O.to=T})(c||(c={}));var h;(function(O){function P(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}O.is=P;function j(F){return{customExecution:"customExecution"}}O.from=j;function T(F,W){return W.get(F)}O.to=T})(h||(e.CustomExecutionDTO=h={}));var S;(function(O){function P(j,T){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=n.$eG),{id:j._id,workspaceFolder:F}}O.from=P})(S||(e.TaskHandleDTO=S={}));var L;(function(O){function P(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=P})(L||(L={}));var w;(function(O){function P(F,W){if(F==null)return[];const X=[];for(const ce of F){const J=j(ce,W);J&&X.push(J)}return X}O.fromMany=P;function j(F,W){if(F==null)return;let X;F.execution instanceof R.$vL?X=d.from(F.execution):F.execution instanceof R.$wL?X=c.from(F.execution):F.execution&&F.execution instanceof R.$xL&&(X=h.from(F.execution));const ce=a.from(F.definition);let J;return F.scope?typeof F.scope=="number"?J=F.scope:J=F.scope.uri:J=R.TaskScope.Workspace,!ce||!J?void 0:{_id:F._id,definition:ce,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:J},execution:X,isBackground:F.isBackground,group:L.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function T(F,W,X){if(F==null)return;let ce;d.is(F.execution)?ce=d.to(F.execution):c.is(F.execution)?ce=c.to(F.execution):h.is(F.execution)&&(ce=h.to(F._id,X));const J=a.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await W.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Y=R.TaskScope.Workspace),!J||!Y)return;const x=new R.$yL(J,Y,F.name,F.source.label,ce,F.problemMatchers);return F.isBackground!==void 0&&(x.isBackground=F.isBackground),F.group!==void 0&&(x.group=R.$uL.from(F.group._id),x.group&&F.group.isDefault&&(x.group=new R.$uL(x.group.id,x.group.label),F.group.isDefault===!0&&(x.group.isDefault=F.group.isDefault))),F.presentationOptions&&(x.presentationOptions=t.to(F.presentationOptions)),F._id&&(x._id=F._id),F.detail&&(x.detail=F.detail),x}O.to=T})(w||(e.TaskDTO=w={}));var p;(function(O){function P(T){return T}O.from=P;function j(T){if(T)return Object.assign(Object.create(null),T)}O.to=j})(p||(p={}));class E{#e;constructor(P,j,T){this._id=j,this.a=T,this.#e=P}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(P){}fireDidEndProcess(P){}}let A=class{constructor(P,j,T,F,W,X,ce,J){this.q=new g.$Sd,this.r=new g.$Sd,this.s=new g.$Sd,this.t=new g.$Sd,this.a=P.getProxy(I.$KK.MainThreadTask),this.b=T,this.c=F,this.d=W,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(P,j,T){if(!T)return new R.$MK(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:T,extension:P}),this.a.$registerTaskProvider(F,j),new R.$MK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(P,j){this.a.$registerTaskSystem(P,j)}fetchTasks(P){return this.a.$fetchTasks(p.from(P)).then(async j=>{const T=[];for(const F of j){const W=await w.to(F,this.b,this.m);W&&T.push(W)}return T})}get taskExecutions(){const P=[];return this.k.forEach(j=>P.push(j)),P}terminateTask(P){if(!(P instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(P._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(P,j,T){const F=this.m.get(P.id);F&&(this.o.set(P.id,F),this.e.attachPtyToTerminal(j,await F.callback(T))),this.p=P.id,this.q.fire({execution:await this.y(P)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(P){const j=await this.y(P);this.l.delete(P.id),this.k.delete(P.id),this.A(P),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(P){const j=await this.y(P.id);this.s.fire({execution:j,processId:P.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(P){const j=await this.y(P.id);this.t.fire({execution:j,exitCode:P.exitCode})}$provideTasks(P,j){const T=this.j.get(P);if(!T)return Promise.reject(new Error("no handler found"));const F=[],W=(0,N.$Tg)(()=>T.provider.provideTasks(M.CancellationToken.None)).then(X=>this.u(j,F,T,X));return new Promise(X=>{W.then(ce=>{Promise.all(F).then(()=>{X(ce)})})})}async $resolveTask(P,j){const T=this.j.get(P);if(!T)return Promise.reject(new Error("no handler found"));if(j.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await w.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await T.provider.resolveTask(F,M.CancellationToken.None);if(!W)return;this.z(W,T);const X=w.from(W,T.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(X.execution)&&await this.x(X,W,!0),await this.v(X)}w(){return this.h++}async x(P,j,T){const F=await this.a.$createTaskId(P);!T&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(P,j){if(typeof P=="string"){const W=this.l.get(P);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const T=this.l.get(P.id);if(T)return T;const F=new Promise((W,X)=>{function ce(J,Y,x){x?W(new E(J,Y.id,x)):X("Unexpected: Task does not exist.")}j?ce(this,P,j):w.to(P.task,this.b,this.m).then(J=>ce(this,P,J))});return this.l.set(P.id,F),F.then(W=>(this.k.set(P.id,W),W),W=>Promise.reject(W))}z(P,j){P._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(P){this.o.get(P.id)&&this.o.delete(P.id),this.n.has(P.id)&&this.p!==P.id&&(this.m.delete(P.id),this.n.delete(P.id));const T=this.n.values();let F=T.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=T.next()}};e.$Ngc=A,e.$Ngc=A=Je([We(0,m.$OM),We(1,v.$5M),We(2,b.$jfc),We(3,$.$ZM),We(4,y.$mfc),We(5,C.$Kfc),We(6,s.$ij),We(7,i.$4ec)],A);let B=class extends A{constructor(P,j,T,F,W,X,ce,J){super(P,j,T,F,W,X,ce,J),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(P,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const T=w.from(j,P);if(T===void 0)throw new Error("Task is not valid");if(h.is(T.execution))await this.x(T,j,!1);else throw new o.$_;const F=await this.y(await this.a.$getTaskExecution(T),j);return this.a.$executeTask(T).catch(W=>{throw new Error(W)}),F}u(P,j,T,F){const W=[];if(F)for(const X of F){if(this.z(X,T),!X.definition||!P[X.definition.type]){const J=X.source?X.source:"No task source";this.f.warn(`The task [${J}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=w.from(X,T.extension);ce&&h.is(ce.execution)?(W.push(ce),j.push(this.x(ce,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:T.extension}}async v(P){if(h.is(P.execution))return P;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(P,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(P,j,T){}};e.$Ogc=B,e.$Ogc=B=Je([We(0,m.$OM),We(1,v.$5M),We(2,b.$jfc),We(3,$.$ZM),We(4,y.$mfc),We(5,C.$Kfc),We(6,s.$ij),We(7,i.$4ec)],B),e.$Pgc=(0,k.$1h)("IExtHostTask")}),define(Se[359],ke([1,0,36,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.$wJ=void 0;function g(R){return"cellResults"in R}e.$wJ=g,e.$xJ="rawCell#";function I(R,b){let $=-1;const y=[];let M=[];return R.forEach(m=>{m.range.startLineNumber!==$&&M.length>0&&(y.push([...M]),M=[]),M.push(m),$=m.range.endLineNumber}),M.length>0&&y.push([...M]),y.map(m=>{const v=[],k=m[0].range.startLineNumber,u=m[m.length-1].range.endLineNumber;for(let f=k;f<=u;f++)v.push(b.getLineContent(f));return new D.$aJ(v.join(`
`)+`
`,m.map(f=>new N.$Fs(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$yJ=I}),define(Se[360],ke([1,0,215,22,4,3,28,13,18,2,32,110,6,35,15,7,68,295,146,8,24,17,287,359,356]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class l{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,S,L,w,p,E){this.q=L,this.r=w,this.s=p,this.t=E,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new g.$Sd({onListenerError:n.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Sd({onListenerError:n.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Sd({onListenerError:n.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Sd({onListenerError:n.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Wec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(m.$KK.MainThreadNotebook),this.c=h.getProxy(m.$KK.MainThreadNotebookDocuments),this.d=h.getProxy(m.$KK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===13){const B=A.notebookEditor?.notebookUri,O=A.cell.handle,j=this.g.get(B)?.getCell(O);if(j)return j.apiCell}if(A&&A.$mid===14){const B=A.uri,O=this.g.get(B);if(O)return O.apiNotebook}return A}}),l.B(S)}getEditorById(h){const S=this.h.get(h);if(!S)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(h){for(const[S,L]of this.h)if(L.apiEditor===h)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,S){const L=this.g.get(h);if(!L&&!S)throw new Error(`NO notebook document for '${h}'`);return L}static u(h,S){if(!S)return;const L=S.filenamePattern.map(w=>k.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(S.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:S.displayName,filenamePattern:L,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,S,L){const w=l.a++,p=typeof L.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(w,L),this.b.$registerNotebookCellStatusBarItemProvider(w,p,S);let E;return p!==void 0&&(E=L.onDidChangeCellStatusBarItems(A=>this.b.$emitCellStatusBarEvent(p))),new u.$MK(()=>{this.f.delete(w),this.b.$unregisterNotebookCellStatusBarItemProvider(w,p),E?.dispose()})}async createNotebookDocument(h){const S=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&k.NotebookData.from(h.content)});return y.URI.revive(S)}async openNotebookDocument(h){const S=this.g.get(h);if(S)return S.apiNotebook;const L=await this.c.$tryOpenNotebook(h),w=this.g.get(y.URI.revive(L));return(0,$.$Of)(w?.apiNotebook)}async showNotebookDocument(h,S){y.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let L;typeof S=="object"?L={position:k.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(k.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:L={preserveFocus:!1};const w=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,L),p=w&&this.h.get(w)?.apiEditor;if(p)return p;throw w?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,S,L,w){const p=this.f.get(h),E=y.URI.revive(S),A=this.g.get(E);if(!A||!p)return;const B=A.getCellFromIndex(L);if(!B)return;const O=await p.provideCellStatusBarItems(B.apiCell,w);if(!O)return;const P=new I.$Rc,j=this.p.add([P]),F=(Array.isArray(O)?O:[O]).map(W=>k.NotebookStatusBarItem.from(W,this.i,P));return{cacheId:j,items:F}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,S,L,w,p){if((0,b.$Ge)(S))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:S,serializer:L,options:w}),this.b.$registerNotebookSerializer(E,{id:h.identifier,location:h.extensionLocation},S,k.NotebookDocumentContentOptions.from(w),l.u(h,p)),(0,I.$Qc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(h,S,L){const w=this.x.get(h);if(!w)throw new Error("NO serializer found");const p=await w.serializer.deserializeNotebook(S.buffer,L);return new f.$Dv(k.NotebookData.from(p))}async $notebookToData(h,S,L){const w=this.x.get(h);if(!w)throw new Error("NO serializer found");const p=await w.serializer.serializeNotebook(k.NotebookData.to(S.value),L);return N.$ge.wrap(p)}async $saveNotebook(h,S,L,w,p){const E=y.URI.revive(S),A=this.x.get(h);if(!A)throw new Error("NO serializer found");const B=this.g.get(E);if(!B)throw new Error("Document NOT found");if(B.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new M.$Fk((0,D.localize)(0,null,this.z(E)),6);await this.y(E,w);const O={metadata:(0,o.$on)(B.apiNotebook.metadata,W=>!(A.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of B.apiNotebook.getCells()){const X=new u.$_L(W.kind,W.document.getText(),W.document.languageId,W.mime,A.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);X.metadata=(0,o.$on)(W.metadata,ce=>!(A.options?.transientCellMetadata??{})[ce]),O.cells.push(X)}const P=await A.serializer.serializeNotebook(O,p);await this.s.value.writeFile(E,P);const j=this.s.getFileSystemProviderExtUri(E.scheme),T=await this.s.value.stat(E);return{name:j.basename(E),isFile:(T.type&M.FileType.File)!==0,isDirectory:(T.type&M.FileType.Directory)!==0,isSymbolicLink:(T.type&M.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((T.permissions??0)&M.FilePermission.Locked),etag:M.$Qk({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(h,S,L,w,p){const E=this.x.get(h)?.serializer;if(!E)return{limitHit:!1,results:[]};const A=new R.$Bc;await(async(T,F,W)=>{await Promise.all(T.map(async X=>await Promise.all(X.filenamePatterns.map(ce=>{const J={...W,type:1,filePattern:ce};return this.t.doInternalFileSearchWithCustomCallback(J,F,Y=>{Y.forEach(x=>{A.has(x)||w.some(Z=>X.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some(ve=>(0,d.$3cb)(ve,x)))||A.add(x)})})}))))})(L,p,S);const O=new R.$Ac;let P=!1;const j=Array.from(A).map(async T=>{const F=[];try{if(p.isCancellationRequested)return;if(S.maxResults&&[...O.values()].reduce((J,Y)=>J+Y.cellResults.length,0)>S.maxResults){P=!0;return}const W=[],X=this.g.get(T);if(X)X.apiNotebook.getCells().forEach(Y=>W.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(x=>x.items.map(se=>se.data.toString()))}));else{const J=await this.s.value.readFile(T),Y=N.$ge.fromString(J.toString()),x=await E.deserializeNotebook(Y.buffer,p);if(p.isCancellationRequested)return;k.NotebookData.from(x).cells.forEach(Z=>W.push({input:Z.source,outputs:Z.outputs.flatMap(ve=>ve.items.map(de=>de.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((J,Y)=>{const x=S.contentPattern.pattern,se=new t.$XPb(J.input,void 0,J.outputs),Z=se.findInInputs(x),ve=se.findInOutputs(x),de=ve.flatMap(H=>(0,r.$yJ)(H.matches,H.textBuffer)).map((H,U)=>(H.webviewIndex=U,H));if(Z.length>0||ve.length>0){const H={index:Y,contentResults:(0,r.$yJ)(Z,se.inputTextBuffer),webviewResults:de};F.push(H)}});const ce={resource:T,cellResults:F};O.set(T,ce);return}catch{return}});return await Promise.all(j),{limitHit:P,results:[...O.values()]}}async y(h,S){const L=await this.s.value.stat(h);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==M.$Pk&&typeof L.mtime=="number"&&typeof L.size=="number"&&S.mtime<L.mtime&&S.etag!==M.$Qk({mtime:S.mtime,size:L.size}))throw new M.$Fk((0,D.localize)(1,null),3,S)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,S,L){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const w=new i.$ggc(S,this.d,h,L.visibleRanges.map(k.NotebookRange.to),L.selections.map(k.NotebookRange.to),typeof L.viewColumn=="number"?k.ViewColumn.to(L.viewColumn):void 0);this.h.set(S,w)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const L of h.value.removedDocuments){const w=y.URI.revive(L),p=this.g.get(w);p&&(p.dispose(),this.g.delete(w),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(p.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===w.toString()&&this.h.delete(E.id)}if(h.value.addedDocuments){const L=[];for(const w of h.value.addedDocuments){const p=y.URI.revive(w.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const E=new s.$fgc(this.c,this.q,this.r,p,w);L.push(...w.cells.map(A=>s.$egc.asModelAddData(E.apiNotebook,A))),this.g.get(p)?.dispose(),this.g.set(p,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(E.apiNotebook)}}if(h.value.addedEditors)for(const L of h.value.addedEditors){if(this.h.has(L.id))return;const w=y.URI.revive(L.documentUri),p=this.g.get(w);p&&this.A(p,L.id,L)}const S=[];if(h.value.removedEditors)for(const L of h.value.removedEditors){const w=this.h.get(L);w&&(this.h.delete(L),this.k?.id===w.id&&(this.k=void 0),S.push(w))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(w=>this.h.get(w)).filter(w=>!!w);const L=new Set;this.l.forEach(w=>L.add(w.id));for(const w of this.h.values()){const p=L.has(w.id);w._acceptVisibility(p)}this.l=[...this.h.values()].map(w=>w).filter(w=>w.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const S=v.$aN.String.with("notebookType","A notebook type"),L=new v.$cN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$aN("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$ge.wrap(p))],new v.$bN("Notebook Data",p=>k.NotebookData.to(p.value))),w=new v.$cN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$aN("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$Dv(k.NotebookData.from(p)))],new v.$bN("Bytes",p=>p.buffer));h.registerApiCommand(L),h.registerApiCommand(w)}}e.$pgc=l}),define(Se[361],ke([1,0,16,21,44,34,23,38,36]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class y{constructor(m,v,k){this.k=m,this.l=v,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Hj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Hj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((k,u)=>{const f=s=>{this.f++,m(s)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(f,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,f))).then(s=>{k({limitHit:this.e,stats:s[0]||void 0})},s=>{u(new Error((0,g.$Li)(s)))})})}async p(m,v){const k=new N.$3d,u=this.q(m),f=this.r(),s=new $.$oJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=b.$Od.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,k.token),a=n.elapsed(),t=b.$Od.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=D.$gc.relative(m.folder.path,r.path);if(i){const l=D.$nc(r.path);this.v(v,{base:m.folder,relativePath:d,basename:l});return}this.s(f,m.folder,d,v)}),this.g&&!this.e)?null:(this.u(f,s,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(m){const v=(0,$.$nJ)(this.k.includePattern,m.includePattern),k=(0,$.$nJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:k,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,k,u){if(k===this.a){const s=D.$nc(this.a);this.v(u,{base:v,relativePath:this.a,basename:s})}function f(s){const i=D.$nc(s),n=D.$mc(s);let o=m[n];o||(o=m[n]=[],f(n)),o.push({base:v,relativePath:s,basename:i})}f(k)}u({rootEntries:m,pathToEntries:v},k,u){const f=this,s=this.a;function i(n){const o=(0,$.$qJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:d,basename:l}=r;if(k.matchesExcludesSync(d,l,s!==l?o:void 0))continue;const c=v[d];if(c)i(c);else{if(d===s)continue;f.v(u,r)}if(f.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,k,u){const f=this.c(m.cacheKey),s=new y(m,v,f&&f.token);let i=0;const n=o=>{i+=o.length,k(o.map(a=>this.d(a)))};return this.e(s,M.a,n,u).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$3d),this.b.get(m)}d(m){return m.relativePath?{resource:R.$Cg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,k,u){const f=u.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(k(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&k(i),f.dispose(),n),n=>(i.length&&k(i),f.dispose(),Promise.reject(n)))}}e.$hgc=M}),define(Se[362],ke([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,45,14,40,143,357,36]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=void 0;let a=class{constructor(p,E,A,B,O){this.a=p,this.b=E,this.c=A,this.d=B,this.e=O}text(p,E,A={}){p=this.f(p,A);const B=this.a.getValue(),O=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(s.$ji),A),type:2,contentPattern:p,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:B.search.usePCRE2||O||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(p,E){const A=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const B={...p,wordSeparators:A.editor.wordSeparators};return this.j(p,E)&&(B.isCaseSensitive=!0),this.k(p)&&(B.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),B}file(p,E={}){return{...this.h(p,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(p,E){return p?(p=Array.isArray(p)?p.map(c):c(p),E?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],E={}){const A=this.g(E.includePattern,E.expandPatterns),B=this.g(E.excludePattern,E.expandPatterns),O=p.length>1,P=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(F=>this.q(F,E,B)):p.map(F=>this.r(F,E,B,O))).filter(F=>!!F),j={_reason:E._reason,folderQueries:P,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:B.pattern,includePattern:A.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=D.$Hb(D.$Rb(this.c.groups.map(ce=>ce.editors.map(J=>J.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(ce=>(0,o.$eJ)(j,ce.fsPath)),X=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const T=E.extraFileResources&&E.extraFileResources.filter(F=>(0,o.$eJ)(j,F.fsPath));return j.extraFileResources=T&&T.length?T:void 0,j}i(p){const E=[],A=new R.$Ac,B={};let O=!1;return p.forEach(P=>{if(P.scheme===b.Schemas.walkThrough)return;if((0,y.$Gg)(P)){const T=this.b.getWorkspaceFolder(P)?.uri??P.with({path:$.$mc(P.fsPath)});let F=A.get(T);F||(O=!0,F={folder:T,includePattern:{}},E.push(F),A.set(T,F));const W=$.$lc(T.fsPath,P.fsPath);(0,C.$Of)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else P.fsPath&&(O=!0,B[P.fsPath]=!0)}),{folderQueries:E,includePattern:B,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(p,E){if(E.isSmartCase){if(p.isRegExp){if(M.$uf(p.pattern,!0))return!0}else if(M.$uf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$JB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const E=X=>$.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),B=(Array.isArray(p)?p:d(p)).map(X=>{const ce=this.e.resolvedUserHome;return ce?(0,I.$Iv)(X,ce.scheme===b.Schemas.file?ce.fsPath:ce.path):X}),O=N.$K(B,X=>E(X)?"searchPaths":"exprSegments"),P=(O.exprSegments||[]).map(X=>M.$Pe(X,"/")).map(X=>M.$Pe(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),l(X))),j={},T=this.m(O.searchPaths||[]);T&&T.length&&(j.searchPaths=T);const F=D.$Rb(P),W=r(...F);return W&&(j.pattern=W),j}l(p,E){return E.disregardExcludeSettings?void 0:(0,o.$dJ)(p,!E.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const E=p.flatMap(B=>{let{pathPortion:O,globPortion:P}=t(B);return P&&(P=h(P)),this.n(O).flatMap(T=>this.o(T,P))}),A=new Map;return E.forEach(B=>{const O=B.searchPath.toString(),P=A.get(O);P?B.pattern&&(P.pattern=P.pattern||{},P.pattern[B.pattern]=!0):A.set(O,{searchPath:B.searchPath,pattern:B.pattern?r(B.pattern):void 0})}),Array.from(A.values())}n(p){if($.$ic(p)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:p})}]:[{searchPath:m.URI.file($.$hc(p))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const B=$.$gc.resolve(E.path,p);return[{searchPath:E.with({path:B})}]}const A=h(p);return[{searchPath:E,pattern:A}]}else{if(p==="./"||p===".\\")return[];{const E=p.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(O=>{const P=E.match(new RegExp(`^${M.$Ke(O.name)}(?:/(.*)|$)`));return P?{match:P,folder:O}:null}).filter(C.$Lf);if(B.length)return B.map(O=>{const P=O.match[1];return{searchPath:O.folder.uri,pattern:P&&h(P)}});{const O=p.match(/\.[\/\\](.+)[\/\\]?/),P=O?O[1]:p,j=k.localize(0,null,P);throw new Error(j)}}}}o(p,E){const A=p.pattern&&E?`${p.pattern}/${E}`:p.pattern||E,B=[{searchPath:p.searchPath,pattern:A}];return A&&!A.endsWith("**")&&B.push({searchPath:p.searchPath,pattern:A+"/**"}),B}q(p,E,A){const B=this.r((0,s.$ji)(p.searchPath),E,A,!1);return B?{...B,includePattern:p.pattern}:null}r(p,E,A,B){let O;const P=m.URI.isUri(p)?p:p.uri;if(A.searchPaths){const X=A.searchPaths.filter(ce=>(0,y.$vg)(ce.searchPath,P))[0];if(X&&!X.pattern)return null;X&&(O=X.pattern)}const j=this.a.getValue({resource:P}),F={...this.l(j,E)||{},...O||{}},W=m.URI.isUri(p)?(0,y.$zg)(p):p.name;return{folder:P,folderName:B?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$oK=a,e.$oK=a=Je([We(0,u.$ui),We(1,s.$0h),We(2,i.$OC),We(3,f.$ij),We(4,n.$mK)],a);function t(w){const p=w.match(/[\*\{\}\(\)\[\]\?]/);if(p){const E=p.index,A=w.substr(0,E).match(/[/|\\][^/\\]*$/);if(A){let B=w.substr(0,A.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:w.substr((A.index||0)+1)}}}return{pathPortion:w}}function r(...w){return w.length?w.reduce((p,E)=>(p[E]=!0,p),Object.create(null)):void 0}function d(w){return g.$Fj(w,",").map(p=>p.trim()).filter(p=>!!p.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function h(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(w){return w.replace(/([?*[\]])/g,"[$1]")}function L(w,p){w=D.$Mb(w,B=>B.toString());const E=[],A=p.getWorkspace();return w&&w.forEach(B=>{let O;if(p.getWorkbenchState()===2)O=(0,y.$Eg)(A.folders[0].uri,B),O&&O!=="."&&(O="./"+O);else{const P=p.getWorkspaceFolder(B);if(P){const j=P.name;if(A.folders.filter(F=>F.name===j).length===1){const F=(0,y.$Eg)(P.uri,B);F===""?O=`./${P.name}`:O=`./${P.name}/${F}`}else O=B.fsPath}}O&&E.push(S(O))}),E}e.$pK=L}),define(Se[363],ke([1,0,23,2,21,8,5,362,36,40]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rb=e.$7rb=void 0;const M=7e3;function C(u,f){const s=f.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const l of s)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||u.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((l,c)=>{o=l}),t=l=>o({activationEvent:l}),r=Promise.all(i.map(l=>m(u,l,t))).then(()=>{}),d=v(u,f.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),a}e.$7rb=C;async function m(u,f,s){for(const i of u.folders)if(await u.exists(D.$Cg(N.URI.revive(i),f))){s(`workspaceContains:${f}`);return}}async function v(u,f,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$3d,o=u.checkExists(u.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),u.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},M);let t=!1;try{t=await o}catch(r){I.$4(r)||I.$1(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function k(u,f,s,i){const n=u.get(R.$Zh),o=u.get($.$8I),t=n.createInstance(b.$oK).file(f.map(r=>(0,y.$ji)(N.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>I.$4(r)?!1:Promise.reject(r))}e.$8rb=k}),define(Se[48],ke([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,145,8,26,22,272,7,64,5,27,92,20,107,72,47,4,363,117,274,17,115,38,11,116]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d,l,c,h,S,L,w,p,E,A,B,O,P,j,T,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=e.$Xfc=e.$Wfc=e.$Vfc=void 0,e.$Vfc=(0,d.$1h)("IHostUtils");let X=W=class extends b.$Sc{constructor(H,U,ne,ye,he,ge,_,ie,G,te,fe,we){super(),this.X=we,this.a=this.B(new p.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=_,this.j=ye,this.m=he,this.s=ge,this.t=G,this.u=te,this.w=fe,this.y=this.g.getProxy(C.$KK.MainThreadWorkspace),this.z=this.g.getProxy(C.$KK.MainThreadTelemetry),this.C=this.g.getProxy(C.$KK.MainThreadExtensionService),this.D=new R.$Zg,this.F=new R.$Zg,this.G=new R.$Zg,this.H=new R.$Zg,this.I=new ve(this.f.extensions.activationEvents),this.L=new s.$96b(this.I,this.f.extensions.allExtensions);const Ae=new n.$gm(this.f.extensions.myExtensions);this.J=new s.$96b(this.I,se(this.L,Ae)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new k.$Gfc(this.g,this.s),this.N=new A.$Ofc(this.g),this.O=ie,this.h=H.createChild(new S.$Yh([k.$Hfc,this.M],[A.$Pfc,this.N])),this.P=this.B(new v.$Ffc(this.J,this.L,{onExtensionActivationError:(be,De,z)=>{this.C.$onExtensionActivationError(be,i.$3(De),z)},actualActivateExtension:async(be,De)=>{if(s.$96b.isHostExtension(be,this.J,this.L))return await this.C.$activateExtension(be,De),new v.$Efc;const z=this.J.getExtensionDescription(be);return this.db(z,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){i.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.cb(he))}catch{}await Promise.all(H)}terminate(H,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$2g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const U=await this.C.$getExtension(H);return U&&{...U,identifier:new n.$fm(U.identifier.value),extensionLocation:y.URI.revive(U.extensionLocation)}}Z(H,U){return this.P.activateByEvent(H,U)}$(H,U){return this.P.activateById(H,U)}activateByIdWithErrors(H,U){return this.$(H,U).then(()=>{const ne=this.P.getActivatedExtension(H);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===O.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(H.fsPath);return y.URI.file(U)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new Z(H))),this.Q}async bb(H){const U=$.$7h.forUris(ne=>I.$tg.ignorePathCasing(ne));return await Promise.all(H.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);U.set(ye,ne)}})),U}cb(H){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return U;const ne=this.P.getActivatedExtension(H);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(ye)}try{(0,b.$Nc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(ye)}return U}async db(H,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,U).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(H.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,U),this.eb(H,U,"success",ye),ne},ne=>{throw this.eb(H,U,"failure"),ne})}eb(H,U,ne,ye){const he=J(H,U);this.z.$publicLog2("extensionActivationTimes",{...he,...ye||{},outcome:ne})}fb(H,U){const ne=J(H,U);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(H);if(!ye)return Promise.resolve(new v.$Dfc(v.$Afc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${H.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const he=new v.$Bfc(U.startup);return Promise.all([this.vb(H,(0,I.$Cg)(H.extensionLocation,ye),he),this.gb(H)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),W.hb(this.s,H.identifier,ge[0],ge[1],he))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),ge))}gb(H){const U=new a.$Jfc(H,this.M),ne=new a.$Ifc(H.identifier.value,!1,this.M),ye=new B.$Qfc(H,this.N),he=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const _=this;let ie,G;const te=(0,f.$hF)(H,"ipc")?this.f.messagePorts?.get(n.$fm.toKey(H.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(fe){return N.$jc(H.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return _.O.globalValue(H).fsPath},get logPath(){return N.$jc(_.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,H.identifier.value)},get storageUri(){return _.O.workspaceValue(H)},get globalStorageUri(){return _.O.globalValue(H)},get extensionMode(){return he},get extension(){return ie===void 0&&(ie=new x(_,H.identifier,H,ge,!1)),ie},get extensionRuntime(){return(0,f.$iF)(H,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!G){if(!te)return;const fe=p.Event.buffer(p.Event.fromDOMEventEmitter(te,"message",we=>we.data));te.start(),G={onDidReceiveMessage:fe,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(H,U,ne,ye,he){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(H,U,ne,ye,he).then(ge=>new v.$Cfc(!1,null,he.build(),ne,ge,ye.subscriptions))}static ib(H,U,ne,ye,he){if(typeof ne.activate=="function")try{he.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ge=typeof global=="object"?global:self,_=ne.activate.apply(ge,[ye]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(_).then(ie=>(he.activateResolveStop(),ie))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(ne)}jb(H,U){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(H,U=0){const ye=Date.now();(0,T.$B)(()=>{for(let he=U;he<H.length;he+=1){const ge=H[he];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(H,he);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(H=>{const U=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const he of ye.activationEvents)he==="onStartupFinished"&&this.jb(ye,he)})}mb(){const H=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),ye=this.pb(),he=Promise.all([ye,H,ne]).then(()=>{});return Promise.race([he,(0,R.$2g)(1e4)]).then(()=>{this.lb()}),he}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(H,U))).then(()=>{})}async ob(H,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:H.map(ge=>ge.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,ie)=>this.y.$checkExists(ge,_,ie)},he=await(0,E.$7rb)(ye,U);if(he)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:he.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:U}=this.f.environment;if(!H||!U)throw new Error(D.localize(0,null));const ne=await this.vb(null,U,new v.$Bfc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((ye,he)=>{const ge=(G,te)=>{G?(T.$t&&this.s.error("Test runner called back with error",G),he(G)):(T.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},_=(0,I.$qg)(U),ie=ne.run(_,ge);ie&&ie.then&&ie.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{T.$t&&this.s.error("Test runner finished with error",G),he(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$2g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,U){return this.R[H]=U,(0,b.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:U}=await this.sb(H);return U?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const U=H.indexOf("+");if(U===-1)throw new t.$SK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=H.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(H,U){const ne=j.$Od.create(!1),ye=()=>`[resolveAuthority(${(0,r.$6k)(H)},${U})][${ne.elapsed()}ms] `,he=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,V=void 0)=>this.s.error(`${ye()}${ee}`,V),ie=ee=>{if(ee instanceof t.$SK)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{he(`activating resolver for ${ee}...`);const{resolver:V,authorityPrefix:oe}=await this.sb(ee);if(!V)throw _(`no resolver for ${oe}`),new t.$SK(`No remote extension installed to resolve ${oe}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:oe,remoteAuthority:ee}},te=H.split(/@|%40/g).reverse();he(`activating remote resolvers ${te.join(" -> ")}`);let fe;try{fe=await Promise.all(te.map(G)).catch(async ee=>{if(!(ee instanceof t.$SK)||ee._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(H)]})}catch(ee){return ie(ee)}const we=new R.$_g;we.cancelAndSet(()=>he("waiting..."),1e3);let Ae,be;for(const[ee,{authorityPrefix:V,resolver:oe,remoteAuthority:le}]of fe.entries())try{if(ee===fe.length-1)he("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${V}`),Ae=await oe.resolve(le,{resolveAttempt:U,execServer:be}),g.mark(`code/extHost/didResolveAuthorityOK/${V}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(oe,t.$RK.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(he(`invoking resolveExecServer() for ${le}`),g.mark(`code/extHost/willResolveExecServer/${V}`),be=await oe.resolveExecServer?.(le,{resolveAttempt:U,execServer:be}),!be)throw new t.$SK(`Exec server was not available for ${le}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${V}`),_("returned an error",Le),we.dispose(),ie(Le)}we.dispose();const De={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures},z={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.$RK.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let Q;if(t.$RK.isManagedResolvedAuthority(Ae)){const ee=U;this.X.setFactory(ee,Ae.makeConnection),Q={authority:H,connectTo:new r.$3k(ee),connectionToken:Ae.connectionToken}}else Q={authority:H,connectTo:new r.$4k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:Q,options:z,tunnelInformation:De}}}async $getCanonicalURI(H,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$6k)(H)})`);const{resolver:ne}=await this.sb(H);if(!ne)return null;const ye=y.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return ye;const he=await(0,R.$Tg)(()=>ne.getCanonicalURI(ye));return he||ye}$startExtensionHost(H){H.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ce(this.I,this.L,this.J,H);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.rb()}$activateByEvent(H,U){return U===1?this.D.wait().then(ne=>this.Z(H,!1)):this.G.wait().then(ne=>this.Z(H,!1))}async $activate(H,U){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,U),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ce(this.I,this.L,this.J,H),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const U=o.$ge.alloc(H),ne=Math.random()%256;for(let ye=0;ye<H;ye++)U.writeUInt8(ne,ye);return U}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$Wfc=X,e.$Wfc=X=W=Je([We(0,d.$Zh),We(1,e.$Vfc),We(2,h.$OM),We(3,u.$jfc),We(4,m.$mfc),We(5,M.$ij),We(6,l.$5M),We(7,c.$pfc),We(8,L.$4xb),We(9,w.$Kfc),We(10,P.$Sfc),We(11,F.$Tfc)],X);function ce(de,H,U,ne){de.addActivationEvents(ne.addActivationEvents);const ye=new s.$96b(de,H.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const he=new n.$gm(U.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ne.myToRemove)he.delete(_);for(const _ of ne.myToAdd)he.add(_);const ge=se(ye,he);return{globalRegistry:ye,myExtensions:ge}}function J(de,H){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function Y(de){return de.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$Xfc=(0,d.$1h)("IExtHostExtensionService");class x{#e;#t;#i;constructor(H,U,ne,ye,he){this.#e=H,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=N.$hc((0,I.$qg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Yfc=x;function se(de,H){return de.getAllExtensionDescriptions().filter(U=>H.has(U.identifier))}class Z{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$Zfc=Z;class ve{constructor(H){this.a=new n.$hm,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)??[]}addActivationEvents(H){for(const U of Object.keys(H))this.a.set(U,H[U])}}}),define(Se[364],ke([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;let u=class{constructor(o,a,t,r,d,l,c){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$8gc=u,e.$8gc=u=Je([We(2,M.$Zh),We(3,I.$mfc),We(4,C.$Xfc),We(5,y.$5M),We(6,m.$ij)],u);let f=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&k.a.size){const a=(0,v.$Ke)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,d]=a,l=k.a.get(r);if(l!==void 0)return console.warn(`${r} as been renamed to ${l}, please update your imports`),t+l+d}c(o){return o.replace(/\\/g,"/")}};f=k=Je([We(0,y.$5M)],f);class s{constructor(o,a,t,r,d){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new b.$hm}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,l)=>r+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$cF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$KK.MainThreadTelemetry);const r=t.getProxy(g.$KK.MainThreadWindow);this.c=(d,l)=>{const c=N.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,d,{}):this.g(d,l)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,$.$OM)],i)}),define(Se[58],ke([1,0,43,3,16,50,5,69,70,48,7,41,290,42]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0,e.$1fc=(0,R.$1h)("IExtHostVariableResolverProvider");class k extends m.$PN{constructor(s,i,n,o,a,t,r){function d(){if(n){const l=n.activeEditor();if(l)return l.document.uri;const c=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof M.$tM||c.input instanceof M.$yM)return c.input.modified;if(c.input instanceof M.$sM||c.input instanceof M.$xM||c.input instanceof M.$vM)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>a.getConfiguration(void 0,l).get(c),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return g.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const l=d();if(l){const c=i.getWorkspaceFolder(l);if(c)return g.$hc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const l=n.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(n){const l=n.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>s.getExtension(l)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(I.env))}}let u=class extends N.$Sc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$2fc=u,e.$2fc=u=Je([We(0,y.$Xfc),We(1,C.$jfc),We(2,b.$ZM),We(3,v.$mfc),We(4,$.$yfc)],u)}),define(Se[96],ke([1,0,12,4,2,5,6,70,48,20,7,41,140,282,42,58]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=e.$4fc=e.$3fc=void 0,e.$3fc=(0,I.$1h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,l,c,h,S){this.E=d,this.F=l,this.G=c,this.H=h,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new N.$Sd,this.n=new N.$Sd,this.o=new N.$Sd,this.u=new N.$Sd,this.k=r.getProxy(R.$KK.MainThreadDebugService),this.y=new N.$Sd,this.A=new N.$Sd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(w=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,d){const l=r;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let c=`debug:${encodeURIComponent(l.path||"")}`,h="?";return d&&(c+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),c+=`${h}ref=${l.sourceReference}`,g.URI.parse(c)}else{if(l.path)return g.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const l of r.getAllExtensionDescriptions())if(l.contributes){const c=l.contributes.debuggers;if(c&&c.length>0)for(const h of c)(0,v.$TF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const S=h.id;return this.w.has(S)?!1:(this.w.set(S,h),!0)});this.U(d,[],[]);const l=[],c=new Map;for(const h of d)if(h instanceof M.$ML){let S=c.get(h.location.uri.toString());S||(S={type:"sourceMulti",uri:h.location.uri,lines:[]},c.set(h.location.uri.toString(),S),l.push(S)),S.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof M.$NL&&l.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(r){const d=r.filter(S=>this.w.delete(S.id));this.U([],d,[]);const l=d.filter(S=>S instanceof M.$ML).map(S=>S.id),c=d.filter(S=>S instanceof M.$NL).map(S=>S.id),h=d.filter(S=>S instanceof M.$OL).map(S=>S.id);return this.k.$unregisterBreakpoints(l,c,h)}startDebugging(r,d,l){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===M.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,l){if(!d)return new M.$MK(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:d}),this.k.$registerDebugConfigurationProvider(r,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,c),new M.$MK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,d,l){if(!l)return new M.$MK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:d,handle:c,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(d,c),new M.$MK(()=>{this.h=this.h.filter(h=>h.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new M.$MK(()=>{});const l=this.i++;return this.j.push({type:r,handle:l,factory:d}),new M.$MK(()=>{this.j=this.j.filter(c=>c.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let l;const c=await this.W(r);return c&&(l={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const l=this,c=await this.V(d);return this.S(this.N(c.type),c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const S=this.M(h),L=this.K(S,c);if(!L)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const w=L;return this.B.set(r,w),this.R(c).then(p=>(p&&this.C.set(r,p),w.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const A=E,B={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(A.arguments.value);B.body={signature:O},w.sendResponse(B)}else throw new Error("no signer")}catch(O){B.success=!1,B.message=O.message,w.sendResponse(B)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(E),E=(0,v.$YF)(E,!0),l.k.$acceptDAMessage(r,E)}),w.onError(E=>{p&&p.onError&&p.onError(E),this.k.$acceptDAError(r,E.name,E.message,E.stack)}),w.onExit(E=>{p&&p.onExit&&p.onExit(E??void 0,void 0),this.k.$acceptDAExit(r,E??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,d){d=(0,v.$XF)(d,!1);const l=this.C.get(r);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const l=this.B.get(r);return this.B.delete(r),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],l=[],c=[];if(r.added)for(const h of r.added){const S=h.id;if(S&&!this.w.has(S)){let L;if(h.type==="function")L=new M.$NL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")L=new M.$OL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const w=g.URI.revive(h.uri);L=new M.$ML(new M.$YK(w,new M.$NK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,M.$KL)(L,S),this.w.set(S,L),d.push(L)}}if(r.removed)for(const h of r.removed){const S=this.w.get(h);S&&(this.w.delete(h),l.push(S))}if(r.changed){for(const h of r.changed)if(h.id){const S=this.w.get(h.id);if(S){if(S instanceof M.$NL&&h.type==="function"){const L=S;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.functionName=h.functionName}else if(S instanceof M.$ML&&h.type==="source"){const L=S;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.location=new M.$YK(g.URI.revive(h.uri),new M.$NK(h.line,h.character))}c.push(S)}}}this.U(d,l,c)}async $acceptStackFrameFocus(r){let d;const l=r.sessionId?await this.V(r.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new M.$UL(l,r.threadId):d=new M.$TL(l,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,l){return(0,D.$Tg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return c.provideDebugConfigurations(h,l)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,d,l,c){return(0,D.$Tg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(d);return h.resolveDebugConfiguration(S,l,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,l,c){return(0,D.$Tg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(S,l,c)})}async $provideDebugAdapter(r,d){const l=this.O(r);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(d);return this.S(l,c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const c={session:await this.V(r),event:d.event,body:d.body};this.u.fire(c)}M(r){if(r instanceof M.$PL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof M.$QL)return{type:"server",port:r.port,host:r.host};if(r instanceof M.$RL)return{type:"pipeServer",path:r.path};if(r instanceof M.$SL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(l=>l.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(l=>l.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(l=>l.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const l=r.contributes.debuggers;if(l&&l.length>0){for(const c of l)if(c.label&&c.type&&c.type===d)return!0}}return!1}R(r){const l=r.configuration.type,c=this.j.filter(h=>h.type===l||h.type==="*").map(h=>(0,D.$Tg)(()=>h.factory.createDebugAdapterTracker(r)).then(S=>S,S=>null));return Promise.race([Promise.all(c).then(h=>{const S=h.filter(L=>!!L);if(S.length>0)return new n(S)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new M.$QL(l));if(r){const h=await this.F.getExtensionRegistry();return(0,D.$Tg)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(S=>{if(S)return S})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,c))}T(r,d){}U(r,d,l){(r.length>0||d.length>0||l.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:l}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const l=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,l,r.configuration,c),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=g.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$4fc=f,e.$4fc=f=Je([We(0,y.$OM),We(1,C.$jfc),We(2,$.$Xfc),We(3,k.$mfc),We(4,b.$yfc),We(5,u.$1fc)],f);class s{constructor(r,d,l,c,h,S,L){this.d=r,this.f=d,this.g=l,this.h=c,this.i=h,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$5fc=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$6fc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(l=>l.onExit?l.onExit(r,d):void 0)}}class o extends m.$llb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(r,d,l,c,h,S){super(r,d,l,c,h,S)}};e.$7fc=a,e.$7fc=a=Je([We(0,y.$OM),We(1,C.$jfc),We(2,$.$Xfc),We(3,k.$mfc),We(4,b.$yfc),We(5,u.$1fc)],a)}),define(Se[365],ke([1,0,8,56,2,6,353,14,106,107,27,248,20,66,48,90]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(b.$ij),t=n.get(m.$OM).getProxy(I.$KK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const d=D.$3(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(b.$ij),a=n.get(m.$OM),t=n.get(k.$Xfc),r=n.get(u.$9M),d=a.getProxy(I.$KK.MainThreadExtensionService),l=a.getProxy(I.$KK.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function S(p,E){if(h.has(p))return h.get(p).stack;let A="",B,O;for(const j of E)A+=`
	at ${j.toString()}`,O=j.getFileName(),!B&&O&&(B=c.findSubstr(g.URI.file(O)));const P=`${p.name||"Error"}: ${p.message||""}${A}`;return h.set(p,{extensionIdentifier:B?.identifier,stack:P}),P}const L=Symbol("prepareStackTrace wrapped");let w=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(p){if(p===S||!p||p[L]){w=p||S;return}w=function(E,A){return S(E,A),p.call(Error,E,A)},Object.assign(w,{[L]:!0})}}),D.setUnexpectedErrorHandler(p=>{o.error(p);const E=D.$3(p),A=h.get(p);if(!A?.extensionIdentifier){l.$onUnexpectedError(E);return}d.$onExtensionRuntimeError(A.extensionIdentifier,E);const B=r.onExtensionError(A.extensionIdentifier,p);o.trace("forwarded error to extension?",B,A)})}}e.$9gc=f;class s{constructor(n,o,a,t,r){this.a=a,this.b=new R.$e7b(n,null,t),o=s.e(o,this.b);const d=new y.$Yh(...(0,$.$Jr)());d.set(M.$5M,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(m.$OM,new m.$PM(this.b)),d.set(v.$gfc,new v.$hfc(t)),d.set(k.$Vfc,a);const l=new C.$pq(d,!0);l.invokeFunction(f.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(b.$ij)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=l.invokeFunction(c=>c.get(k.$Xfc)),this.c.initialize(),l.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(I.$KK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$0gc=s}),define(Se[366],ke([1,0,12,11,223,242,138,96,70,48,20,47,7,58,41,283,284,42]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let i=class extends b.$4fc{constructor(r,d,l,c,h,S,L){super(r,d,l,c,S,L),this.Z=h,this.X=new a}K(r,d){switch(r.type){case"server":return new u.$chc(r);case"pipeServer":return new u.$dhc(r);case"executable":return new u.$ehc(r,d.type)}return super.K(r,d)}T(r,d){const l=u.$ehc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(l)return new m.$PL(l.command,l.args,l.options)}L(){return new R.$40b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(P=>{this.X.onTerminalClosed(P)}));const l=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),S=r.title||g.localize(0,null),L=JSON.stringify({shell:c,shellArgs:h});let w=await this.X.checkout(L,S),p,E=!1;if(w)p=r.cwd;else{const P={shellPath:c,shellArgs:h,cwd:r.cwd,name:S,iconPath:new m.$HL("debug")};E=!0,w=this.Z.createTerminalFromOptions(P,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,L)}w.show(!0);const A=await w.processId;E?await new Promise(P=>setTimeout(P,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?w.sendText("cls"):c.indexOf("bash")>=0?w.sendText("clear"):N.$i?w.sendText("cls"):w.sendText("clear"));const B=(0,f.$ghc)(c,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);w.sendText(B);const O=this.onDidTerminateDebugSession(P=>{P.id===d&&(this.X.free(w),O.dispose())});return A}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$hhc=i,e.$hhc=i=Je([We(0,M.$OM),We(1,k.$jfc),We(2,y.$Xfc),We(3,s.$mfc),We(4,C.$Kfc),We(5,$.$yfc),We(6,v.$1fc)],i);let n;function o(t,r){if(!n)if(N.$i)n=new I.$P9b;else if(N.$j)n=new I.$Q9b;else if(N.$k)n=new I.$R9b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const c=[...this.b.entries()].map(([h,S])=>(0,D.$Og)(async L=>{if(h.name!==d||S.lastUsedAt!==-1&&await(0,f.$fhc)(await h.processId))return null;const w=Date.now();return S.lastUsedAt+a.a>w||L.isCancellationRequested||S.config!==r?null:(S.lastUsedAt=w,h)}));return await(0,D.$6g)(c,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[367],ke([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;let n=class extends m.$Ngc{constructor(a,t,r,d,l,c,h,S,L){super(a,t,r,d,l,c,h,S),this.B=r,this.C=L,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=m.TaskHandleDTO.from(r,this.B),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=m.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const l=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}u(a,t,r,d){const l=[];if(d)for(const c of d){this.z(c,r),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(c,r.extension);h&&(l.push(h),m.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,c,!0)))}return{tasks:l,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=N.URI.file((0,s.homedir)());t=new $.$ii({uri:r,name:f.$zg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=N.URI.revive(a),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),S=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const L of t.variables)d.variables[L]=await h.resolveAsync(S,L);if(t.process!==void 0){let L;if(t.process.path!==void 0){L=t.process.path.split(D.$tc);for(let w=0;w<L.length;w++)L[w]=await h.resolveAsync(S,L[w])}d.process=await g.win32.findExecutable(await h.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(S,t.process.cwd):void 0,L)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return g.win32.findExecutable(a,t,r)}};e.$_gc=n,e.$_gc=n=Je([We(0,M.$OM),We(1,C.$5M),We(2,I.$jfc),We(3,R.$ZM),We(4,b.$mfc),We(5,y.$Kfc),We(6,k.$ij),We(7,u.$4ec),We(8,i.$1fc)],n)}),define(Se[368],ke([1,0,63,58]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class g extends N.$2fc{m(){return(0,D.homedir)()}}e.$Rhc=g}),define(Se[154],ke([1,0,19,12,21,44,17,16,23,2,36]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=e.$jgc=e.$igc=void 0;class C{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new g.$3d(n);return new Promise((t,r)=>{this.a=new v(i);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const S=this.h(c);u(c)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const L=this.h(c);this.c+=L,(L>0||!u(c))&&this.a.add(c,h)}};Promise.all(o.map((c,h)=>this.k(c,S=>l(S,h),a.token))).then(c=>{a.dispose(),this.a.flush();const h=c.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||h,messages:(0,D.$Rb)(c.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const h=(0,I.$Li)(c);r(new Error(h))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new M.$oJ(this.d,i),t=[],r={report:c=>{if(!this.l(c))return;const h=i.folder.scheme===R.Schemas.file?(0,M.$pJ)(()=>this.f.readdir($.$Bg(c.uri))):void 0,S=$.$Eg(i.folder,c.uri);if(S){const L=a.includedInQuery(S,b.$nc(S),h);(0,N.$Ng)(L)?t.push(L.then(w=>{w&&n(c)})):L&&n(c)}}},d=this.n(i),l=await this.e.provideTextSearchResults(m(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),l}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,M.$nJ)(this.d.includePattern,i.includePattern),o=(0,M.$nJ)(this.d.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$igc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$vg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$jgc=v;function k(s){return u(s)?{preview:{matches:(0,D.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function u(s){return!!s.preview}e.$kgc=u;class f{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$lgc=f}),define(Se[97],ke([1,0,3,6,5,361,20,66,14,2,154]),function(me,e,D,N,g,I,R,b,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=void 0,e.$mgc=(0,g.$1h)("IExtHostSearch");let C=class{constructor(u,f,s){this.k=u,this.l=f,this.n=s,this.c=this.k.getProxy(N.$KK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$hgc}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,f){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const s=this.d++;return this.e.set(s,f),this.c.$registerTextSearchProvider(s,this.o(u)),(0,D.$Qc)(()=>{this.g.delete(u),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(u,f){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const s=this.d++;return this.h.set(s,f),this.c.$registerFileSearchProvider(s,this.o(u)),(0,D.$Qc)(()=>{this.i.delete(u),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(u,f,s,i){const n=m(s),o=this.h.get(u);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(u,f,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,f,s){return{messages:[]}}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,f,s,i){const n=this.e.get(u);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(u,f,t),i)}$enableExtensionHostSearch(){}q(u,f){return new M.$igc(u,f,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$ngc=C,e.$ngc=C=Je([We(0,R.$OM),We(1,b.$gfc),We(2,$.$ij)],C);function m(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(v),extraFileResources:k.extraFileResources&&k.extraFileResources.map(u=>y.URI.revive(u))}}e.$ogc=m;function v(k){return{...k,folder:y.URI.revive(k.folder)}}}),define(Se[369],ke([1,0,21,8,4,3,17,39,2,132,191,172,79,26,32,14,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,149,316,317,318,294,319,69,70,320,48,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,152,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,47,339,340,285,341,299,72,15,7,342,66,343,93,345,346,151,41,281,114,25,94]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d,l,c,h,S,L,w,p,E,A,B,O,P,j,T,F,W,X,ce,J,Y,x,se,Z,ve,de,H,U,ne,ye,he,ge,_,ie,G,te,fe,we,Ae,be,De,z,Q,ee,V,oe,le,Le,je,He,Ye,_e,at,Pe,Oe,qe,Xe,Fe,nt,ae,ue,Ie,Ke,Qe,rt,ot,Be,yt,Mt,Kt,zt,vt,Vt,Ft,Qt,Ot,It,tt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;function Gt(lt){const $t=lt.get(H.$5M),jt=lt.get(de.$1ec),Ut=lt.get(Z.$ofc),St=lt.get(x.$Xfc),dt=lt.get(Qt.$jfc),Pt=lt.get(Fe.$9M),Xt=lt.get(A.$mfc),kt=lt.get(Mt.$gfc),Ze=lt.get(Le.$OM),Lt=lt.get(Oe.$Hfc),Wt=lt.get(qe.$pfc),Jt=lt.get(u.$jj),gt=lt.get(u.$ij),Rt=lt.get(rt.$4xb),Re=lt.get(t.$4ec),Ne=lt.get(Ft.$3gc),Ce=lt.get(Ye.$Pfc),re=lt.get(J.$yfc),Te=lt.get(G.$Tfc);Ze.set(n.$LK.ExtHostFileSystemInfo,jt),Ze.set(n.$LK.ExtHostLogLevelServiceShape,Jt),Ze.set(n.$LK.ExtHostWorkspace,dt),Ze.set(n.$LK.ExtHostConfiguration,Xt),Ze.set(n.$LK.ExtHostExtensionService,St),Ze.set(n.$LK.ExtHostStorage,Lt),Ze.set(n.$LK.ExtHostTunnelService,Rt),Ze.set(n.$LK.ExtHostWindow,Ne),Ze.set(n.$LK.ExtHostSecretState,Ce),Ze.set(n.$LK.ExtHostTelemetry,Pt),Ze.set(n.$LK.ExtHostEditorTabs,re),Ze.set(n.$LK.ExtHostManagedSockets,Te);const Ve=Ze.set(n.$LK.ExtHostDecorations,lt.get(P.$9fc)),et=Ze.set(n.$LK.ExtHostDocumentsAndEditors,lt.get(ce.$ZM)),Ge=Ze.set(n.$LK.ExtHostCommands,lt.get(p.$$M)),st=Ze.set(n.$LK.ExtHostTerminalService,lt.get(nt.$Kfc)),mt=Ze.set(n.$LK.ExtHostDebugService,lt.get(O.$3fc)),Bt=Ze.set(n.$LK.ExtHostSearch,lt.get(He.$mgc)),Et=Ze.set(n.$LK.ExtHostTask,lt.get(Xe.$Pgc)),Dt=Ze.set(n.$LK.ExtHostOutputService,lt.get(Q.$Cgc)),wt=Ze.set(n.$LK.ExtHostLocalization,lt.get(ie.$Sfc)),mi=Ze.set(n.$LK.ExtHostUrls,new Kt.$Zgc(Ze)),At=Ze.set(n.$LK.ExtHostDocuments,new X.$Yec(Ze,et)),ki=Ze.set(n.$LK.ExtHostDocumentContentProviders,new F.$$fc(Ze,et,gt)),qi=Ze.set(n.$LK.ExtHostDocumentSaveParticipant,new W.$_fc(gt,At,Ze.getProxy(n.$KK.MainThreadBulkEdits))),Ct=Ze.set(n.$LK.ExtHostNotebook,new fe.$pgc(Ze,Ge,et,At,Ut,Bt)),ni=Ze.set(n.$LK.ExtHostNotebookDocuments,new Ae.$wgc(Ct)),$i=Ze.set(n.$LK.ExtHostNotebookEditors,new be.$xgc(gt,Ct)),ai=Ze.set(n.$LK.ExtHostNotebookKernels,new De.$ygc(Ze,$t,Ct,Ge,gt)),Di=Ze.set(n.$LK.ExtHostNotebookRenderers,new z.$Agc(Ze,Ct)),Ci=Ze.set(n.$LK.ExtHostNotebookDocumentSaveParticipant,new we.$vgc(gt,Ct,Ze.getProxy(n.$KK.MainThreadBulkEdits))),Tt=Ze.set(n.$LK.ExtHostEditors,new ue.$dfc(Ze,et)),bi=Ze.set(n.$LK.ExtHostTreeViews,new Qe.$Xgc(Ze.getProxy(n.$KK.MainThreadTreeViews),Ge,gt)),Ii=Ze.set(n.$LK.ExtHostEditorInsets,new w.$efc(Ze.getProxy(n.$KK.MainThreadEditorInsets),Tt,$t.remote)),ci=Ze.set(n.$LK.ExtHostDiagnostics,new j.$3ec(Ze,gt,jt,et)),ui=Ze.set(n.$LK.ExtHostLanguages,new _.$tgc(Ze,At,Ge.converter,kt)),ht=Ze.set(n.$LK.ExtHostLanguageFeatures,new ge.$7ec(Ze,kt,At,Ge,ci,gt,Re,Pt)),Vi=Ze.set(n.$LK.ExtHostFileSystem,new se.$bgc(Ze,ht)),xt=Ze.set(n.$LK.ExtHostFileSystemEventService,new ve.$cgc(Ze,gt,et)),ri=Ze.set(n.$LK.ExtHostQuickOpen,(0,le.$Ggc)(Ze,dt,Ge)),di=Ze.set(n.$LK.ExtHostSCM,new je.$Igc(Ze,Ge,At,gt)),Pi=Ze.set(n.$LK.ExtHostQuickDiff,new oe.$Fgc(Ze,kt)),Ki=Ze.set(n.$LK.ExtHostShare,new _e.$Jgc(Ze,kt)),Ai=Ze.set(n.$LK.ExtHostComments,(0,E.$ffc)(Ze,Ge,At)),pi=Ze.set(n.$LK.ExtHostProgress,new V.$Egc(Ze.getProxy(n.$KK.MainThreadProgress))),Hi=Ze.set(n.$LK.ExtHosLabelService,new he.$sgc(Ze)),Li=Ze.set(n.$LK.ExtHostTheming,new Ie.$Ugc(Ze)),li=Ze.set(n.$LK.ExtHostAuthentication,new r.$9ec(Ze)),Gi=Ze.set(n.$LK.ExtHostTimeline,new Ke.$Wgc(Ze,Ge)),wi=Ze.set(n.$LK.ExtHostWebviews,new zt.$tfc(Ze,$t.remote,dt,gt,Re)),Ri=Ze.set(n.$LK.ExtHostWebviewPanels,new vt.$wfc(Ze,wi,dt)),cn=Ze.set(n.$LK.ExtHostCustomEditors,new B.$xfc(Ze,At,Wt,wi,Ri)),Mi=Ze.set(n.$LK.ExtHostWebviewViews,new Vt.$1gc(Ze,wi)),si=Ze.set(n.$LK.ExtHostTesting,new ae.$Qgc(Ze,Ge,et)),un=Ze.set(n.$LK.ExtHostUriOpeners,new yt.$Ygc(Ze)),ln=Ze.set(n.$LK.ExtHostProfileContentHandlers,new ee.$Dgc(Ze));Ze.set(n.$LK.ExtHostInteractive,new ne.$qgc(Ze,Ct,et,Ge,gt));const Ji=Ze.set(n.$LK.ExtHostInlineChat,new U.$dgc(Ze,Ge,At,gt)),fi=Ze.set(n.$LK.ExtHostChatProvider,new h.$_ec(Ze,gt)),Qi=Ze.set(n.$LK.ExtHostChatAgents2,new c.$afc(Ze,fi,gt)),Yi=Ze.set(n.$LK.ExtHostChatVariables,new S.$bfc(Ze)),gi=Ze.set(n.$LK.ExtHostChat,new l.$$ec(Ze)),Zi=Ze.set(n.$LK.ExtHostAiRelatedInformation,new o.$Xec(Ze)),Fi=Ze.set(n.$LK.ExtHostAiEmbeddingVector,new Y.$agc(Ze)),Ti=Ze.set(n.$LK.ExtHostIssueReporter,new ye.$rgc(Ze)),_t=Ze.set(n.$LK.ExtHostStatusBar,new Pe.$Mgc(Ze,Ge.converter)),vi=Ze.set(n.$LK.ExtHostSpeech,new at.$Kgc(Ze)),hn=Object.values(n.$LK);Ze.assertRegistered(hn);const Yt=new d.$0ec(Ze,et),yi=new L.$cfc(Ze),Ei=new te.$ugc(Ze,gt),Ni=new T.$0fc(Ze);return a.$8ec.register(Ge),function(Ue,ei,Xi){const bt=function(){let $e=!Ue.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function ze(ct){if(Array.isArray(ct))ct.forEach(ze);else if(typeof ct=="string")Ee();else{const pt=ct;typeof pt.scheme>"u"&&Ee(),typeof pt.exclusive=="boolean"&&(0,tt.$iF)(Ue,"documentFiltersExclusive")}return ct}}(),xi={getSession($e,Ee,ze){return li.getSession(Ue,$e,Ee,ze)},getSessions($e,Ee){return(0,tt.$iF)(Ue,"authGetSessions"),li.getSessions(Ue,$e,Ee)},async hasSession($e,Ee){return(0,tt.$iF)(Ue,"authSession"),!!await li.getSession(Ue,$e,Ee,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider($e,Ee,ze,ct){return li.registerAuthenticationProvider($e,Ee,ze,ct)}},dn={registerCommand($e,Ee,ze){return Ge.registerCommand(!0,$e,Ee,ze,void 0,Ue)},registerTextEditorCommand($e,Ee,ze){return Ge.registerCommand(!0,$e,(...ct)=>{const pt=Tt.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return pt.edit(Nt=>{Ee.apply(ze,[pt,Nt,...ct])}).then(Nt=>{Nt||gt.warn("Edits from command "+$e+" were not applied.")},Nt=>{gt.warn("An error occurred while running command "+$e,Nt)})},void 0,void 0,Ue)},registerDiffInformationCommand:($e,Ee,ze)=>((0,tt.$iF)(Ue,"diffCommand"),Ge.registerCommand(!0,$e,async(...ct)=>{const pt=et.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Nt=await Tt.getDiffInformation(pt.id);Ee.apply(ze,[Nt,...ct])},void 0,void 0,Ue)),executeCommand($e,...Ee){return Ge.executeCommand($e,...Ee)},getCommands($e=!1){return Ge.getCommands($e)}},_i={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return st.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$iF)(Ue,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$iF)(Ue,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Fe.$8M)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Fe.$7M.validateSender($e),Pt.instantiateLogger(Ue,$e,Ee)},openExternal($e,Ee){return Ne.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return mi.createAppUri($e);try{return await Ne.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$_f)($e,R.Schemas.http)||(0,R.$_f)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$8k)($t.remote.authority)},get remoteAuthority(){return(0,tt.$iF)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel},registerIssueUriRequestHandler($e){return(0,tt.$iF)(Ue,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ue,$e)},registerIssueDataProvider($e){return(0,tt.$iF)(Ue,"handleIssueUri"),Ti.registerIssueDataProvider(Ue,$e)},get appQuality(){return(0,tt.$iF)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,tt.$iF)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController($e,Ee,ze){return si.createTestController(Ue,$e,Ee,ze)},createTestObserver(){return(0,tt.$iF)(Ue,"testObserver"),si.createTestObserver()},runTests($e){return(0,tt.$iF)(Ue,"testObserver"),si.runTests($e)},get onDidChangeTestResults(){return(0,tt.$iF)(Ue,"testObserver"),si.onResultsChanged},get testResults(){return(0,tt.$iF)(Ue,"testObserver"),si.results}},hi=$t.remote.isRemote?Be.ExtensionKind.Workspace:Be.ExtensionKind.UI,tn={getExtension($e,Ee){(0,tt.$hF)(Ue,"extensionsAny")||(Ee=!1);const ze=ei.mine.getExtensionDescription($e);if(ze)return new x.$Yfc(St,Ue.identifier,ze,hi,!1);if(Ee){const ct=ei.all.getExtensionDescription($e);if(ct)return new x.$Yfc(St,Ue.identifier,ct,hi,!0)}},get all(){const $e=[];for(const Ee of ei.mine.getAllExtensionDescriptions())$e.push(new x.$Yfc(St,Ue.identifier,Ee,hi,!1));return $e},get allAcrossExtensionHosts(){(0,tt.$iF)(Ue,"extensionsAny");const $e=new v.$gm(ei.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of ei.all.getAllExtensionDescriptions()){const ct=!$e.has(ze.identifier);Ee.push(new x.$Yfc(St,Ue.identifier,ze,hi,ct))}return Ee},get onDidChange(){return(0,tt.$hF)(Ue,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection($e){return ci.createDiagnosticCollection(Ue.identifier,$e)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:$e=>ci.getDiagnostics($e),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage($e,Ee){return ui.changeLanguage($e.uri,Ee)},match($e,Ee){const ze=At.getDocumentData(Ee.uri)?.notebook;return(0,M.$mt)(ot.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider($e,Ee,ze){return ht.registerCodeActionProvider(Ue,bt($e),Ee,ze)},registerDocumentPasteEditProvider($e,Ee,ze){return(0,tt.$iF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,bt($e),Ee,ze)},registerCodeLensProvider($e,Ee){return ht.registerCodeLensProvider(Ue,bt($e),Ee)},registerDefinitionProvider($e,Ee){return ht.registerDefinitionProvider(Ue,bt($e),Ee)},registerDeclarationProvider($e,Ee){return ht.registerDeclarationProvider(Ue,bt($e),Ee)},registerImplementationProvider($e,Ee){return ht.registerImplementationProvider(Ue,bt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return ht.registerTypeDefinitionProvider(Ue,bt($e),Ee)},registerHoverProvider($e,Ee){return ht.registerHoverProvider(Ue,bt($e),Ee,Ue.identifier)},registerEvaluatableExpressionProvider($e,Ee){return ht.registerEvaluatableExpressionProvider(Ue,bt($e),Ee,Ue.identifier)},registerInlineValuesProvider($e,Ee){return ht.registerInlineValuesProvider(Ue,bt($e),Ee,Ue.identifier)},registerDocumentHighlightProvider($e,Ee){return ht.registerDocumentHighlightProvider(Ue,bt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return ht.registerMultiDocumentHighlightProvider(Ue,bt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return ht.registerLinkedEditingRangeProvider(Ue,bt($e),Ee)},registerReferenceProvider($e,Ee){return ht.registerReferenceProvider(Ue,bt($e),Ee)},registerRenameProvider($e,Ee){return ht.registerRenameProvider(Ue,bt($e),Ee)},registerDocumentSymbolProvider($e,Ee,ze){return ht.registerDocumentSymbolProvider(Ue,bt($e),Ee,ze)},registerWorkspaceSymbolProvider($e){return ht.registerWorkspaceSymbolProvider(Ue,$e)},registerDocumentFormattingEditProvider($e,Ee){return ht.registerDocumentFormattingEditProvider(Ue,bt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return ht.registerDocumentRangeFormattingEditProvider(Ue,bt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,ze,...ct){return ht.registerOnTypeFormattingEditProvider(Ue,bt($e),Ee,[ze].concat(ct))},registerDocumentSemanticTokensProvider($e,Ee,ze){return ht.registerDocumentSemanticTokensProvider(Ue,bt($e),Ee,ze)},registerDocumentRangeSemanticTokensProvider($e,Ee,ze){return ht.registerDocumentRangeSemanticTokensProvider(Ue,bt($e),Ee,ze)},registerSignatureHelpProvider($e,Ee,ze,...ct){return typeof ze=="object"?ht.registerSignatureHelpProvider(Ue,bt($e),Ee,ze):ht.registerSignatureHelpProvider(Ue,bt($e),Ee,typeof ze>"u"?[]:[ze,...ct])},registerCompletionItemProvider($e,Ee,...ze){return ht.registerCompletionItemProvider(Ue,bt($e),Ee,ze)},registerInlineCompletionItemProvider($e,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,tt.$iF)(Ue,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$iF)(Ue,"inlineCompletionsAdditions"),ze&&(0,tt.$iF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,bt($e),Ee,ze)},registerDocumentLinkProvider($e,Ee){return ht.registerDocumentLinkProvider(Ue,bt($e),Ee)},registerColorProvider($e,Ee){return ht.registerColorProvider(Ue,bt($e),Ee)},registerFoldingRangeProvider($e,Ee){return ht.registerFoldingRangeProvider(Ue,bt($e),Ee)},registerSelectionRangeProvider($e,Ee){return ht.registerSelectionRangeProvider(Ue,$e,Ee)},registerCallHierarchyProvider($e,Ee){return ht.registerCallHierarchyProvider(Ue,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return ht.registerTypeHierarchyProvider(Ue,$e,Ee)},setLanguageConfiguration:($e,Ee)=>ht.setLanguageConfiguration(Ue,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,tt.$iF)(Ue,"tokenInformation"),ui.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return ht.registerInlayHintsProvider(Ue,$e,Ee)},createLanguageStatusItem($e,Ee){return ui.createLanguageStatusItem(Ue,$e,Ee)},registerDocumentDropEditProvider($e,Ee,ze){return ht.registerDocumentOnDropEditProvider(Ue,$e,Ee,(0,tt.$hF)(Ue,"dropMetadata")?ze:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument($e,Ee,ze){const ct=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return Tt.showTextDocument(ct,Ee,ze)},createTextEditorDecorationType($e){return Tt.createTextEditorDecorationType(Ue,$e)},onDidChangeActiveTextEditor($e,Ee,ze){return Tt.onDidChangeActiveTextEditor($e,Ee,ze)},onDidChangeVisibleTextEditors($e,Ee,ze){return Tt.onDidChangeVisibleTextEditors($e,Ee,ze)},onDidChangeTextEditorSelection($e,Ee,ze){return Tt.onDidChangeTextEditorSelection($e,Ee,ze)},onDidChangeTextEditorOptions($e,Ee,ze){return Tt.onDidChangeTextEditorOptions($e,Ee,ze)},onDidChangeTextEditorVisibleRanges($e,Ee,ze){return Tt.onDidChangeTextEditorVisibleRanges($e,Ee,ze)},onDidChangeTextEditorViewColumn($e,Ee,ze){return Tt.onDidChangeTextEditorViewColumn($e,Ee,ze)},onDidCloseTerminal($e,Ee,ze){return st.onDidCloseTerminal($e,Ee,ze)},onDidOpenTerminal($e,Ee,ze){return st.onDidOpenTerminal($e,Ee,ze)},onDidChangeActiveTerminal($e,Ee,ze){return st.onDidChangeActiveTerminal($e,Ee,ze)},onDidChangeTerminalDimensions($e,Ee,ze){return(0,tt.$iF)(Ue,"terminalDimensions"),st.onDidChangeTerminalDimensions($e,Ee,ze)},onDidChangeTerminalState($e,Ee,ze){return st.onDidChangeTerminalState($e,Ee,ze)},onDidWriteTerminalData($e,Ee,ze){return(0,tt.$iF)(Ue,"terminalDataWriteEvent"),st.onDidWriteTerminalData($e,Ee,ze)},onDidExecuteTerminalCommand($e,Ee,ze){return(0,tt.$iF)(Ue,"terminalExecuteCommandEvent"),st.onDidExecuteTerminalCommand($e,Ee,ze)},get state(){return Ne.getState(Ue)},onDidChangeWindowState($e,Ee,ze){return Ne.onDidChangeWindowState($e,Ee,ze)},showInformationMessage($e,...Ee){return Ei.showMessage(Ue,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return Ei.showMessage(Ue,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return Ei.showMessage(Ue,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,ze){return ri.showQuickPick(Ue,$e,Ee,ze)},showWorkspaceFolderPick($e){return ri.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return ri.showInput($e,Ee)},showOpenDialog($e){return Ni.showOpenDialog(Ue,$e)},showSaveDialog($e){return Ni.showSaveDialog($e)},createStatusBarItem($e,Ee,ze){let ct,pt,Nt;return typeof $e=="string"?(ct=$e,pt=Ee,Nt=ze):(pt=$e,Nt=Ee),_t.createStatusBarEntry(Ue,ct,pt,Nt)},setStatusBarMessage($e,Ee){return _t.setStatusBarMessage($e,Ee)},withScmProgress($e){return Re.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pi.withProgress(Ue,{location:Be.ProgressLocation.SourceControl},(Ee,ze)=>$e({report(ct){}}))},withProgress($e,Ee){return pi.withProgress(Ue,$e,Ee)},createOutputChannel($e,Ee){return Dt.createOutputChannel($e,Ee,Ue)},createWebviewPanel($e,Ee,ze,ct){return Ri.createWebviewPanel(Ue,$e,Ee,ze,ct)},createWebviewTextEditorInset($e,Ee,ze,ct){return(0,tt.$iF)(Ue,"editorInsets"),Ii.createWebviewEditorInset($e,Ee,ze,ct,Ue)},createTerminal($e,Ee,ze){return typeof $e=="object"?"pty"in $e?st.createExtensionTerminal($e):st.createTerminalFromOptions($e):st.createTerminal($e,Ee,ze)},registerTerminalLinkProvider($e){return st.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return st.registerProfileProvider(Ue,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,tt.$iF)(Ue,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider($e,Ue.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return bi.registerTreeDataProvider($e,Ee,Ue)},createTreeView($e,Ee){return bi.createTreeView($e,Ee,Ue)},registerWebviewPanelSerializer:($e,Ee)=>Ri.registerWebviewPanelSerializer(Ue,$e,Ee),registerCustomEditorProvider:($e,Ee,ze={})=>cn.registerCustomEditorProvider(Ue,$e,Ee,ze),registerFileDecorationProvider($e){return Ve.registerFileDecorationProvider($e,Ue)},registerUriHandler($e){return mi.registerUriHandler(Ue,$e)},createQuickPick(){return ri.createQuickPick(Ue)},createInputBox(){return ri.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,ze){return Li.onDidChangeActiveColorTheme($e,Ee,ze)},registerWebviewViewProvider($e,Ee,ze){return Mi.registerWebviewViewProvider(Ue,$e,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,ze){return Ct.onDidChangeActiveNotebookEditor($e,Ee,ze)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection($e,Ee,ze){return $i.onDidChangeNotebookEditorSelection($e,Ee,ze)},onDidChangeNotebookEditorVisibleRanges($e,Ee,ze){return $i.onDidChangeNotebookEditorVisibleRanges($e,Ee,ze)},showNotebookDocument($e,Ee){return Ct.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,ze){return(0,tt.$iF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,$e,Ee,ze)},registerProfileContentHandler($e,Ee){return(0,tt.$iF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,$e,Ee)},registerQuickDiffProvider($e,Ee,ze,ct){return(0,tt.$iF)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt($e),Ee,ze,ct)},get tabGroups(){return re.tabGroups},registerShareProvider($e,Ee){return(0,tt.$iF)(Ue,"shareProvider"),Ki.registerShareProvider(bt($e),Ee)}},sn={get rootPath(){return Re.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath($e){throw new N.$9("rootPath")},getWorkspaceFolder($e){return dt.getWorkspaceFolder($e)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name($e){throw new N.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile($e){throw new N.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...ze)=>dt.updateWorkspaceFolders(Ue,$e,Ee||0,...ze),onDidChangeWorkspaceFolders:function($e,Ee,ze){return dt.onDidChangeWorkspace($e,Ee,ze)},asRelativePath:($e,Ee)=>dt.getRelativePath($e,Ee),findFiles:($e,Ee,ze,ct)=>dt.findFiles($e,Ee,ze,Ue.identifier,ct),findTextInFiles:($e,Ee,ze,ct)=>{(0,tt.$iF)(Ue,"findTextInFiles");let pt,Nt;return typeof Ee=="object"?(pt=Ee,Nt=ze):(pt={},Nt=Ee,ct=ze),dt.findTextInFiles($e,pt||{},Nt,Ue.identifier,ct)},save:$e=>((0,tt.$iF)(Ue,"saveEditor"),dt.save($e)),saveAs:$e=>((0,tt.$iF)(Ue,"saveEditor"),dt.saveAs($e)),saveAll:$e=>dt.saveAll($e),applyEdit($e,Ee){return Yt.applyWorkspaceEdit($e,Ue,Ee)},createFileSystemWatcher:($e,Ee,ze,ct)=>{let pt;return typeof Ee=="boolean"?pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,tt.$iF)(Ue,"createFileSystemWatcher"),pt={...Ee,correlate:!0}),xt.createFileSystemWatcher(dt,Ue,$e,pt)},get textDocuments(){return At.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new N.$9("textDocuments")},openTextDocument($e){let Ee;const ze=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!ze||typeof ze=="object")Ee=At.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>At.ensureDocumentData(ct).then(pt=>pt.document))},onDidOpenTextDocument:($e,Ee,ze)=>At.onDidAddDocument($e,Ee,ze),onDidCloseTextDocument:($e,Ee,ze)=>At.onDidRemoveDocument($e,Ee,ze),onDidChangeTextDocument:($e,Ee,ze)=>At.onDidChangeDocument($e,Ee,ze),onDidSaveTextDocument:($e,Ee,ze)=>At.onDidSaveDocument($e,Ee,ze),onWillSaveTextDocument:($e,Ee,ze)=>qi.getOnWillSaveTextDocumentEvent(Ue)($e,Ee,ze),get notebookDocuments(){return Ct.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let ze;if($.URI.isUri($e))ze=$e,await Ct.openNotebookDocument($e);else if(typeof $e=="string")ze=$.URI.revive(await Ct.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument($e,Ee,ze){return ni.onDidSaveNotebookDocument($e,Ee,ze)},onDidChangeNotebookDocument($e,Ee,ze){return ni.onDidChangeNotebookDocument($e,Ee,ze)},onWillSaveNotebookDocument($e,Ee,ze){return Ci.getOnWillSaveNotebookDocumentEvent(Ue)($e,Ee,ze)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer($e,Ee,ze,ct){return Ct.registerNotebookSerializer(Ue,$e,Ee,ze,(0,tt.$hF)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:($e,Ee,ze)=>Xi.onDidChangeConfiguration($e,Ee,ze),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,Xi.getConfiguration($e,Ee,Ue)},registerTextDocumentContentProvider($e,Ee){return ki.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Re.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,$e,Ee)),registerFileSystemProvider($e,Ee,ze){return(0,I.$Pc)(Vi.registerFileSystemProvider(Ue,$e,Ee,ze),Ut.addFileSystemProvider($e,Ee,ze))},get fs(){return Ut.value},registerFileSearchProvider:($e,Ee)=>((0,tt.$iF)(Ue,"fileSearchProvider"),Bt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,tt.$iF)(Ue,"textSearchProvider"),Bt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,tt.$iF)(Ue,"resolvers"),St.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,tt.$iF)(Ue,"resolvers"),Hi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,tt.$iF)(Ue,"resolvers"),St.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,ze)=>xt.onDidCreateFile($e,Ee,ze),onDidDeleteFiles:($e,Ee,ze)=>xt.onDidDeleteFile($e,Ee,ze),onDidRenameFiles:($e,Ee,ze)=>xt.onDidRenameFile($e,Ee,ze),onWillCreateFiles:($e,Ee,ze)=>xt.getOnWillCreateFileEvent(Ue)($e,Ee,ze),onWillDeleteFiles:($e,Ee,ze)=>xt.getOnWillDeleteFileEvent(Ue)($e,Ee,ze),onWillRenameFiles:($e,Ee,ze)=>xt.getOnWillRenameFileEvent(Ue)($e,Ee,ze),openTunnel:$e=>((0,tt.$iF)(Ue,"tunnels"),Rt.openTunnel(Ue,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$iF)(Ue,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:($e,Ee,ze)=>((0,tt.$iF)(Ue,"tunnels"),Rt.onDidChangeTunnels($e,Ee,ze)),registerPortAttributesProvider:($e,Ee)=>((0,tt.$iF)(Ue,"portsAttributes"),Rt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,tt.$iF)(Ue,"tunnelFactory"),Rt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,tt.$iF)(Ue,"timeline"),Gi.registerTimelineProvider($e,Ee,Ue.identifier,Ge.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:$e=>((0,tt.$iF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,ze)=>dt.onDidGrantWorkspaceTrust($e,Ee,ze),registerEditSessionIdentityProvider:($e,Ee)=>((0,tt.$iF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,ze)=>((0,tt.$iF)(Ue,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ue)($e,Ee,ze)),registerCanonicalUriProvider:($e,Ee)=>((0,tt.$iF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,ze)=>((0,tt.$iF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri($e,Ee,ze))},fn={get inputBox(){return Re.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ue)},createSourceControl($e,Ee,ze){return di.createSourceControl(Ue,$e,Ee,ze)},registerSourceControlInputBoxValueProvider($e,Ee){return(0,tt.$iF)(Ue,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Ue,$e,Ee)}},on={createCommentController($e,Ee){return Ai.createCommentController(Ue,$e,Ee)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession($e,Ee,ze){return mt.onDidStartDebugSession($e,Ee,ze)},onDidTerminateDebugSession($e,Ee,ze){return mt.onDidTerminateDebugSession($e,Ee,ze)},onDidChangeActiveDebugSession($e,Ee,ze){return mt.onDidChangeActiveDebugSession($e,Ee,ze)},onDidReceiveDebugSessionCustomEvent($e,Ee,ze){return mt.onDidReceiveDebugSessionCustomEvent($e,Ee,ze)},onDidChangeBreakpoints($e,Ee,ze){return mt.onDidChangeBreakpoints($e,Ee,ze)},onDidChangeStackFrameFocus($e,Ee,ze){return(0,tt.$iF)(Ue,"debugFocus"),mt.onDidChangeStackFrameFocus($e,Ee,ze)},registerDebugConfigurationProvider($e,Ee,ze){return mt.registerDebugConfigurationProvider($e,Ee,ze||Ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return mt.registerDebugAdapterDescriptorFactory(Ue,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return mt.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?mt.startDebugging($e,Ee,{parentSession:ze}):mt.startDebugging($e,Ee,ze||{})},stopDebugging($e){return mt.stopDebugging($e)},addBreakpoints($e){return mt.addBreakpoints($e)},removeBreakpoints($e){return mt.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return mt.asDebugSourceUri($e,Ee)}},Oi={registerTaskProvider:($e,Ee)=>Et.registerTaskProvider(Ue,$e,Ee),fetchTasks:$e=>Et.fetchTasks($e),executeTask:$e=>Et.executeTask(Ue,$e),get taskExecutions(){return Et.taskExecutions},onDidStartTask:($e,Ee,ze)=>Et.onDidStartTask($e,Ee,ze),onDidEndTask:($e,Ee,ze)=>Et.onDidEndTask($e,Ee,ze),onDidStartTaskProcess:($e,Ee,ze)=>Et.onDidStartTaskProcess($e,Ee,ze),onDidEndTaskProcess:($e,Ee,ze)=>Et.onDidEndTaskProcess($e,Ee,ze)},ji={createNotebookController($e,Ee,ze,ct,pt){return ai.createNotebookController(Ue,$e,Ee,ze,ct,(0,tt.$hF)(Ue,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Ct.registerNotebookCellStatusBarItemProvider(Ue,$e,Ee),createRendererMessaging($e){return Di.createRendererMessaging(Ue,$e)},createNotebookControllerDetectionTask($e){return(0,tt.$iF)(Ue,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Ue,$e)},registerKernelSourceActionProvider($e,Ee){return(0,tt.$iF)(Ue,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Ue,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,ze){return(0,tt.$iF)(Ue,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState($e,Ee,ze)}},Bi={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),ze=!$e||typeof $e[0]!="object"?$e:$e[0];return wt.getMessage(Ue.identifier.value,{message:Ee,args:ze})}return wt.getMessage(Ue.identifier.value,$e[0])},get bundle(){return wt.getBundle(Ue.identifier.value)},get uri(){return wt.getBundleUri(Ue.identifier.value)}},Si={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,tt.$iF)(Ue,"interactive"),Ji.registerProvider(Ue,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,tt.$iF)(Ue,"interactive"),gi.registerChatProvider(Ue,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,tt.$iF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider($e,Ee)},get onDidPerformUserAction(){return(0,tt.$iF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession($e,Ee){return(0,tt.$iF)(Ue,"interactive"),gi.transferChatSession($e,Ee)}},zi={getRelatedInformation($e,Ee){return(0,tt.$iF)(Ue,"aiRelatedInformation"),Zi.getRelatedInformation(Ue,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,tt.$iF)(Ue,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Ue,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,tt.$iF)(Ue,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ue,$e,Ee)}},gn={registerChatResponseProvider($e,Ee,ze){return(0,tt.$iF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,$e,Ee,ze)},requestChatAccess($e){return(0,tt.$iF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,$e)},registerVariable($e,Ee,ze){return(0,tt.$iF)(Ue,"chatVariables"),Yi.registerVariableResolver(Ue,$e,Ee,ze)},registerMappedEditsProvider($e,Ee){return(0,tt.$iF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,$e,Ee)},createChatAgent($e,Ee){return(0,tt.$iF)(Ue,"chatAgents2"),Qi.createChatAgent(Ue,$e,Ee)}},mn={registerSpeechProvider($e,Ee){return(0,tt.$iF)(Ue,"speech"),vi.registerProvider(Ue.identifier,$e,Ee)}};return{version:$t.version,ai:zi,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Si,l10n:Bi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Oi,tests:en,window:rn,workspace:sn,Breakpoint:Be.$LL,TerminalOutputAnchor:Be.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Be.ChatAgentResultFeedbackKind,ChatMessage:Be.$DM,ChatMessageRole:Be.ChatMessageRole,ChatVariableLevel:Be.ChatVariableLevel,ChatAgentCompletionItem:Be.$CM,CallHierarchyIncomingCall:Be.$$K,CallHierarchyItem:Be.$0K,CallHierarchyOutgoingCall:Be.$_K,CancellationError:N.$5,CancellationTokenSource:D.$3d,CandidatePortSource:n.CandidatePortSource,CodeAction:Be.$7K,CodeActionKind:Be.$8K,CodeActionTriggerKind:Be.CodeActionTriggerKind,CodeLens:Be.$aL,Color:Be.$nL,ColorInformation:Be.$oL,ColorPresentation:Be.$pL,ColorThemeKind:Be.ColorThemeKind,CommentMode:Be.CommentMode,CommentState:Be.CommentState,CommentThreadCollapsibleState:Be.CommentThreadCollapsibleState,CommentThreadState:Be.CommentThreadState,CompletionItem:Be.$hL,CompletionItemKind:Be.CompletionItemKind,CompletionItemTag:Be.CompletionItemTag,CompletionList:Be.$iL,CompletionTriggerKind:Be.CompletionTriggerKind,ConfigurationTarget:Be.ConfigurationTarget,CustomExecution:Be.$xL,DebugAdapterExecutable:Be.$PL,DebugAdapterInlineImplementation:Be.$SL,DebugAdapterNamedPipeServer:Be.$RL,DebugAdapterServer:Be.$QL,DebugConfigurationProviderTriggerKind:Ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Be.DebugConsoleMode,DecorationRangeBehavior:Be.DecorationRangeBehavior,Diagnostic:Be.$1K,DiagnosticRelatedInformation:Be.$ZK,DiagnosticSeverity:Be.DiagnosticSeverity,DiagnosticTag:Be.DiagnosticTag,Disposable:Be.$MK,DocumentHighlight:Be.$3K,DocumentHighlightKind:Be.DocumentHighlightKind,MultiDocumentHighlight:Be.$4K,DocumentLink:Be.$mL,DocumentSymbol:Be.$6K,EndOfLine:Be.EndOfLine,EnvironmentVariableMutatorType:Be.EnvironmentVariableMutatorType,EvaluatableExpression:Be.$VL,InlineValueText:Be.$WL,InlineValueVariableLookup:Be.$XL,InlineValueEvaluatableExpression:Be.$YL,InlineCompletionTriggerKind:Be.InlineCompletionTriggerKind,EventEmitter:g.$Sd,ExtensionKind:Be.ExtensionKind,ExtensionMode:Be.ExtensionMode,ExternalUriOpenerPriority:Be.ExternalUriOpenerPriority,FileChangeType:Be.FileChangeType,FileDecoration:Be.$9L,FileDecoration2:Be.$9L,FileSystemError:Be.$1L,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Be.$2L,FoldingRangeKind:Be.FoldingRangeKind,FunctionBreakpoint:Be.$NL,InlineCompletionItem:Be.$jL,InlineCompletionList:Be.$kL,Hover:Be.$2K,IndentAction:C.IndentAction,Location:Be.$YK,MarkdownString:Be.$bL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Be.$cL,PortAutoForwardAction:Be.PortAutoForwardAction,Position:Be.$NK,ProcessExecution:Be.$vL,ProgressLocation:Be.ProgressLocation,QuickInputButtons:Be.$8L,Range:Be.$OK,RelativePattern:Be.$JL,Selection:Be.$PK,SelectionRange:Be.$9K,SemanticTokens:Be.$5L,SemanticTokensBuilder:Be.$4L,SemanticTokensEdit:Be.$6L,SemanticTokensEdits:Be.$7L,SemanticTokensLegend:Be.$3L,ShellExecution:Be.$wL,ShellQuoting:Be.ShellQuoting,SignatureHelp:Be.$eL,SignatureHelpTriggerKind:Be.SignatureHelpTriggerKind,SignatureInformation:Be.$dL,SnippetString:Be.$XK,SourceBreakpoint:Be.$ML,StandardTokenType:Be.StandardTokenType,StatusBarAlignment:Be.StatusBarAlignment,SymbolInformation:Be.$5K,SymbolKind:Be.SymbolKind,SymbolTag:Be.SymbolTag,Task:Be.$yL,TaskGroup:Be.$uL,TaskPanelKind:Be.TaskPanelKind,TaskRevealKind:Be.TaskRevealKind,TaskScope:Be.TaskScope,TerminalLink:Be.$qL,TerminalQuickFixTerminalCommand:Be.$sL,TerminalQuickFixOpener:Be.$rL,TerminalLocation:Be.TerminalLocation,TerminalProfile:Be.$tL,TerminalExitReason:Be.TerminalExitReason,TextDocumentSaveReason:Be.TextDocumentSaveReason,TextEdit:Be.$TK,SnippetTextEdit:Be.$VK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Be.TextEditorLineNumbersStyle,TextEditorRevealType:Be.TextEditorRevealType,TextEditorSelectionChangeKind:Be.TextEditorSelectionChangeKind,SyntaxTokenType:Be.SyntaxTokenType,TextDocumentChangeReason:Be.TextDocumentChangeReason,ThemeColor:Be.$IL,ThemeIcon:Be.$HL,TreeItem:Be.$zL,TreeItemCheckboxState:Be.TreeItemCheckboxState,TreeItemCollapsibleState:Be.TreeItemCollapsibleState,TypeHierarchyItem:Be.$rM,UIKind:It.UIKind,Uri:$.URI,ViewColumn:Be.ViewColumn,WorkspaceEdit:Be.$WK,DocumentDropEdit:Be.$FL,DocumentPasteEdit:Be.$GL,InlayHint:Be.$gL,InlayHintLabelPart:Be.$fL,InlayHintKind:Be.InlayHintKind,RemoteAuthorityResolverError:Be.$SK,ResolvedAuthority:Be.$QK,ManagedResolvedAuthority:Be.$RK,SourceControlInputBoxValidationType:Be.SourceControlInputBoxValidationType,ExtensionRuntime:Be.ExtensionRuntime,TimelineItem:Be.$gM,NotebookRange:Be.$$L,NotebookCellKind:Be.NotebookCellKind,NotebookCellExecutionState:Be.NotebookCellExecutionState,NotebookCellData:Be.$_L,NotebookData:Be.$aM,NotebookRendererScript:Be.$eM,NotebookCellStatusBarAlignment:Be.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Be.NotebookEditorRevealType,NotebookCellOutput:Be.$cM,NotebookCellOutputItem:Be.$bM,NotebookCellStatusBarItem:Be.$dM,NotebookControllerAffinity:Be.NotebookControllerAffinity,NotebookControllerAffinity2:Be.NotebookControllerAffinity2,NotebookEdit:Be.$UK,NotebookKernelSourceAction:Be.$fM,NotebookVariablesRequestKind:Be.NotebookVariablesRequestKind,PortAttributes:Be.$iM,LinkedEditingRanges:Be.$hM,TestResultState:Be.TestResultState,TestRunRequest:Be.$jM,TestMessage:Be.$kM,TestMessage2:Be.$kM,TestTag:Be.$lM,TestRunProfileKind:Be.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Be.$EL,DataTransferItem:Be.$AL,CoveredCount:Be.$mM,FileCoverage:Be.$nM,StatementCoverage:Be.$oM,BranchCoverage:Be.$pM,FunctionCoverage:Be.$qM,WorkspaceTrustState:Be.WorkspaceTrustState,LanguageStatusSeverity:Be.LanguageStatusSeverity,QuickPickItemKind:Be.QuickPickItemKind,InputBoxValidationSeverity:Be.InputBoxValidationSeverity,TabInputText:Be.$sM,TabInputTextDiff:Be.$tM,TabInputTextMerge:Be.$uM,TabInputCustom:Be.$vM,TabInputNotebook:Be.$xM,TabInputNotebookDiff:Be.$yM,TabInputWebview:Be.$wM,TabInputTerminal:Be.$zM,TabInputInteractiveWindow:Be.$AM,TabInputChat:Be.$BM,TelemetryTrustedValue:s.$vo,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Be.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Be.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Be.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Be.$TL,ThreadFocus:Be.$UL,RelatedInformationType:Be.RelatedInformationType,SpeechToTextStatus:Be.SpeechToTextStatus}}}e.$4gc=Gt}),define(Se[370],ke([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Ir)(l.$Sfc,l.$Rfc,1),(0,D.$Ir)(r.$jj,t.$5gc,1),(0,D.$Ir)(u.$4ec,u.$5ec,1),(0,D.$Ir)(b.$$M,b.$0M,0),(0,D.$Ir)(R.$mfc,R.$kfc,0),(0,D.$Ir)(s.$ofc,s.$nfc,0),(0,D.$Ir)(C.$3fc,C.$7fc,0),(0,D.$Ir)(I.$9fc,I.$8fc,0),(0,D.$Ir)($.$ZM,$.$YM,0),(0,D.$Ir)(c.$Tfc,c.$Ufc,0),(0,D.$Ir)(i.$1ec,i.$Zec,0),(0,D.$Ir)(N.$Cgc,N.$Bgc,1),(0,D.$Ir)(m.$mgc,m.$ngc,0),(0,D.$Ir)(v.$Hfc,v.$Gfc,0),(0,D.$Ir)(M.$Pgc,M.$Ogc,0),(0,D.$Ir)(y.$Kfc,y.$Nfc,0),(0,D.$Ir)(k.$4xb,k.$5xb,0),(0,D.$Ir)(f.$3gc,f.$2gc,0),(0,D.$Ir)(g.$jfc,g.$ifc,0),(0,D.$Ir)(n.$Pfc,n.$Ofc,0),(0,D.$Ir)(o.$9M,o.$6M,0),(0,D.$Ir)(a.$yfc,a.$zfc,0),(0,D.$Ir)(d.$1fc,d.$2fc,0)}),define(Se[119],ke([1,0,19,14,36,94]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$ihc=R;function b(C,m,v,k){const u=(0,D.$2b)(v,$),f=new g.$aJ(m,u,k),s=f.preview.matches;return{ranges:(0,D.$2b)(u,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(s,y)}}}e.$jhc=b;function $(C){return new g.$bJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$2I(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let M=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$khc=M,e.$khc=M=Je([We(1,N.$ij)],M)}),define(Se[371],ke([1,0,51,16,76,33,11,13,119,372]),function(me,e,D,N,g,I,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=void 0;const M=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,a,t){const r=m(n,o,a,t),d=o.folder.fsPath;return{cmd:D.spawn(M,r.args,{cwd:d}),rgDiskPath:M,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$lhc=C;function m(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];k([o],a,!1).forEach(l=>{const c=(0,$.$ihc)(l);if(r.push("-g",c),R.$j){const h=(0,g.$Bl)(c);h!==c&&r.push("-g",h)}});const d=v([o],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,$.$ihc)(l)}`;if(r.push("-g",c),R.$j){const h=(0,g.$Bl)(c);h!==c&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function v(n,o,a,t=!0){const r=[];let d={};return n.forEach(l=>{const c=Object.assign({},l.excludePattern||{},o||{}),h=u(c,t?l.folder.fsPath:void 0,a);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function k(n,o,a=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),l=u(d,a?r.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function u(n,o,a){const t=[],r={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const l=n[d];d=s(o?f(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):l&&l.when&&(r[d]=l)}),{globArgs:t,siblingClauses:r}}function f(n,o){return N.$ic(o)?o:N.$jc(n,o)}e.$mhc=f;function s(n){return n=b.$Pe(n,"\\"),b.$Pe(n,"/")}function i(n){return I.$Yf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$nhc=i}),define(Se[373],ke([1,0,51,55,16,374,19,44,34,76,33,11,38,13,18,31,36,371,129]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$Hj(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Kq)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$Hj(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),S=c.folder.fsPath;l.folderQueries.map(L=>L.folder.fsPath).filter(L=>L!==S).forEach(L=>{(0,M.$3f)(L,S)&&(h[g.$lc(S,L)]=!0)}),this.t.set(S,new t(h,S))})}cancel(){this.l=!0,n.forEach(l=>l())}walk(l,c,h,S,L){if(this.m=m.$Od.create(!1),this.l)return L(null,this.j);c.forEach(w=>{const p=g.$nc(w.fsPath);this.u&&this.u(w.fsPath,p)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=m.$Od.create(!1),this.w(l,(w,p)=>{this.x(this.y,this,w,h,S,E=>{if(E){const A=(0,b.$Li)(E);console.error(A),this.q.push(A),p(E,void 0)}else p(null,void 0)})},(w,p)=>{this.m.stop();const E=w?R.$Hb(w)[0]:null;L(E,this.j)})}w(l,c,h){const S=new Array(l.length),L=new Array(l.length);let w=!1,p=0;if(l.length===0)return h(null,[]);l.forEach((E,A)=>{c(E,(B,O)=>{if(B?(w=!0,S[A]=null,L[A]=B):(S[A]=O,L[A]=null),++p===l.length)return h(w?L:null,S)})})}x(l,c,...h){try{l.apply(c,h)}catch(S){h[h.length-1](S)}}y(l,c,h,S){const L=l.folder.fsPath,w=C.$j,p=()=>P&&P.kill();n.add(p);let E=W=>{n.delete(p),E=()=>{},S(W)},A="";const B=this.D(),O=(0,s.$lhc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),P=O.cmd,j=!Object.keys(O.siblingClauses).length,T=O.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let F=`${O.rgDiskPath} ${T}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),h({message:F}),this.s=0,this.z(P,"utf8",h,(W,X,ce)=>{if(W){E(W);return}if(this.j){E();return}const Y=(A+(w?y.$Al(X||""):X)).split(`
`);if(ce){const x=Y.length;Y[x-1]=Y[x-1].trim(),Y[x-1]||Y.pop()}else A=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=Y.length,j){for(const x of Y)if(this.J(c,{base:L,relativePath:x,searchPath:this.N(l,x)}),this.j){p();break}(ce||this.j)&&E();return}this.G(l,B,L,Y,c),ce&&(this.H(B,L,c),E())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),S=c.getPathTerms(),L=["-L","."];if(h.length||S.length){L.push("-not","(","(");for(const w of h)L.push("-name",w),L.push("-o");for(const w of S)L.push("-path",w),L.push("-o");L.pop(),L.push(")","-prune",")")}return L.push("-type","f"),D.spawn("find",L,{cwd:l.folder.fsPath})}readStdout(l,c,h){let S="";this.z(l,c,()=>{},(L,w,p)=>{if(L){h(L);return}S+=w,p&&h(null,S)})}z(l,c,h,S){let L=(E,A,B)=>{(E||B)&&(L=()=>{},this.r?.stop()),S(E,A,B)},w=!1;l.stdout?(this.A(l.stdout,c,L),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let p;l.stderr?p=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",E=>{L(E)}),l.on("close",E=>{let A;!w&&(A=this.C(p,c))&&r(A)?L(new Error(`command failed with error code ${E}: ${this.C(p,c)}`)):(this.g&&E===0&&(this.j=!0),L(null,"",!0))})}A(l,c,h){const S=new I.StringDecoder(c);return l.on("data",L=>{h(null,S.write(L))}),S}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new I.StringDecoder(c);return l.map(S=>h.write(S)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,S,L){S.indexOf(this.b)!==-1&&this.J(L,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=p=>{const E=g.$nc(p),A=g.$mc(p);let B=c[A];B||(B=c[A]=[],w(A)),B.push({base:h,relativePath:p,basename:E,searchPath:this.N(l,p)})};S.forEach(w)}H({rootEntries:l,pathToEntries:c},h,S){const L=this,w=this.t.get(h),p=this.b;function E(A){L.o++;const B=(0,f.$qJ)(()=>A.map(O=>O.basename));for(let O=0,P=A.length;O<P;O++){const j=A[O],{relativePath:T,basename:F}=j;if(w.test(T,F,p!==F?B:void 0))continue;const W=c[T];if(W)E(W);else{if(L.p++,T===p)continue;L.J(S,j)}if(L.j)break}}E(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,S,L){const w=l.folder,p=(0,f.$qJ)(()=>h);this.w(h,(E,A)=>{if(this.l||this.j)return A(null);const B=c?[c,E].join(g.sep):E;if(this.t.get(l.folder.fsPath).test(B,E,this.a.filePattern!==E?p:void 0))return A(null);const O=[w.fsPath,B].join(g.sep);N.lstat(O,(P,j)=>{if(P||this.l||this.j)return A(null);this.L(O,j,(T,F)=>T||this.l||this.j?A(null):F.isDirectory()?(this.o++,this.M(O,j,(W,X)=>W||this.l||this.j||(X=X||"",this.v[X])?A(null):(this.v[X]=!0,u.Promises.readdir(O).then(ce=>{if(this.l||this.j)return A(null);this.I(l,B,ce,S,J=>A(J||null))},ce=>{A(null)})))):(this.p++,B===this.b||this.h&&k.$Hf(F.size)&&F.size>this.h||this.J(S,{base:w.fsPath,relativePath:B,searchPath:this.N(l,B)}),A(null,void 0)))})},E=>{const A=E&&R.$Hb(E);return L(A&&A.length>0?A[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$nc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$lJ)(l,this.c)}return!0}L(l,c,h){return c.isSymbolicLink()?N.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?N.realpath(l,(S,L)=>S?h(S):h(null,L)):h(null,l)}N(l,c){return l.folderName?g.$jc(l.folderName,c):c}}e.$ohc=o;class a{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new o(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(S,L)=>{h(S,{limitHit:L,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$phc=a;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(S=>l[S]).forEach(S=>{g.$ic(S)?(c=c||$.$Cj(),c[S]=l[S]):(h=h||$.$Cj(),h[S]=l[S])}),this.a=c&&$.$Hj(c,{trimForExclusions:!0}),this.b=h&&$.$Hj(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(g.$jc(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$Jj(this.a)),this.b&&l.push(...$.$Jj(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$Kj(this.a)),this.b&&l.push(...$.$Kj(this.b)),l}}function r(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.$vf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[375],ke([1,0,98,22,186,21]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.DecodeStreamErrorKind=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC="utf8",e.$YC="utf8bom",e.$ZC="utf16be",e.$1C="utf16le";function R(c){return[e.$XC,e.$YC,e.$ZC,e.$1C].some(h=>h===c)}e.$2C=R,e.$3C=[254,255],e.$4C=[255,254],e.$5C=[239,187,191];const b=512,$=512,y=512*8,M=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(h,S){super(h),this.decodeStreamErrorKind=S}}e.$6C=m;class v{static async create(h){let S;if(h!==e.$XC)S=(await(0,g.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const L=new TextDecoder;S={write(w){return L.decode(w,{stream:!0})},end(){return L.decode()}}}return new v(S)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(c,h){const S=h.minBytesRequiredForDetection??h.guessEncoding?y:$;return new Promise((L,w)=>{const p=(0,D.$7d)(j=>j.join("")),E=[];let A=0,B;const O=new I.$3d,P=async()=>{try{const j=await l({buffer:N.$ge.concat(E),bytesRead:A},h.guessEncoding);if(j.seemsBinary&&h.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await h.overwriteEncoding(j.encoding),B=await v.create(j.encoding);const T=B.write(N.$ge.concat(E).buffer);p.write(T),E.length=0,A=0,L({stream:p,detected:j})}catch(j){O.cancel(),p.destroy(),w(j)}};(0,D.$$d)(c,{onData:async j=>{B?p.write(B.write(j.buffer)):(E.push(j),A+=j.byteLength,A>=S&&(c.pause(),await P(),setTimeout(()=>c.resume())))},onError:j=>p.error(j),onEnd:async()=>{B||await P(),p.end(B?.end())}},O.token)})}e.$7C=k;async function u(c,h,S){const w=(await(0,g.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),S);let p=!1,E=!1;return{read(){if(E)return null;const A=c.read();if(typeof A!="string"){if(E=!0,!p&&S?.addBOM)switch(h){case e.$XC:case e.$YC:return N.$ge.wrap(Uint8Array.from(e.$5C));case e.$ZC:return N.$ge.wrap(Uint8Array.from(e.$3C));case e.$1C:return N.$ge.wrap(Uint8Array.from(e.$4C))}const B=w.end();return B&&B.length>0?(p=!0,N.$ge.wrap(B)):null}return p=!0,N.$ge.wrap(w.write(A))}}}e.$8C=u;async function f(c){return(await(0,g.$WC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$9C=f;function s(c){return c===e.$YC||c===null?e.$XC:c}e.$0C=s;function i(c,h){if(!c||h<e.$3C.length)return null;const S=c.readUInt8(0),L=c.readUInt8(1);if(S===e.$3C[0]&&L===e.$3C[1])return e.$ZC;if(S===e.$4C[0]&&L===e.$4C[1])return e.$1C;if(h<e.$5C.length)return null;const w=c.readUInt8(2);return S===e.$5C[0]&&L===e.$5C[1]&&w===e.$5C[2]?e.$YC:null}e.$$C=i;const n=["ascii","utf-16","utf-32"];async function o(c){const h=await(0,g.$WC)("jschardet","dist/jschardet.min.js"),S=c.slice(0,M),L=r(S.buffer),w=h.detect(L);if(!w||!w.encoding)return null;const p=w.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(w.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function r(c){let h="";for(let S=0;S<c.length;S++)h+=String.fromCharCode(c[S]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$_C=d;function l({buffer:c,bytesRead:h},S){let L=i(c,h),w=!1;if(L!==e.$ZC&&L!==e.$1C&&c){let p=!0,E=!0,A=!1;for(let B=0;B<h&&B<b;B++){const O=B%2===1,P=c.readUInt8(B)===0;if(P&&(A=!0),p&&(O&&!P||!O&&P)&&(p=!1),E&&(O&&P||!O&&!P)&&(E=!1),P&&!p&&!E)break}A&&(p?L=e.$1C:E?L=e.$ZC:w=!0)}return S&&!w&&!L&&c?o(c.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:w,encoding:L}}e.$aD=l,e.$bD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[155],ke([1,0,375,31,154]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class I extends g.$igc{constructor(b,$,y=N,M="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$_C)(C)},M)}}e.$xhc=I}),define(Se[156],ke([1,0,51,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=e.$vhc=e.$uhc=e.$thc=e.$shc=e.$rhc=e.$qhc=void 0;const f=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(E){this.a=E}provideTextSearchResults(E,A,B,O){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...A,folder:A.folder.toString()})}`),new Promise((P,j)=>{O.onCancellationRequested(()=>x());const T=r(E,A),F=A.folder.fsPath,W=T.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${f} ${W}
 - cwd: ${F}`);let X=D.spawn(f,T,{cwd:F});X.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),j((0,C.$hJ)(new C.$fJ(H&&H.message,C.SearchErrorCode.rgProcessError)))});let ce=!1;const J=new o(A.maxResults,F,A.previewOptions);J.on("result",H=>{ce=!0,Z="",B.report(H)});let Y=!1;const x=()=>{Y=!0,X?.kill(),J?.cancel()};let se=!1;J.on("hitLimit",()=>{se=!0,x()});let Z="";X.stdout.on("data",H=>{J.handleData(H),ce||(Z+=H)});let ve=!1;X.stdout.once("data",()=>ve=!0);let de="";X.stderr.on("data",H=>{const U=H.toString();this.a.appendLine(U),de.length+U.length<1e6&&(de+=U)}),X.on("close",()=>{if(this.a.appendLine(ve?"Got data from stdout":"No data from stdout"),this.a.appendLine(ce?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),Y)P({limitHit:se});else{J.flush(),X=null;let H;de&&!ve&&(H=i(de))?j((0,C.$hJ)(new C.$fJ(H.message,H.code))):P({limitHit:se})}})})}}e.$qhc=s;function i(p){const E=p.split(`
`),A=E[0].trim();if(E.some(O=>O.startsWith("regex parse error")))return new C.$fJ(n(E),C.SearchErrorCode.regexParseError);const B=A.match(/grep config error: unknown encoding: (.*)/);if(B)return new C.$fJ(`Unknown encoding: ${B[1]}`,C.SearchErrorCode.unknownEncoding);if(A.startsWith("error parsing glob"))return new C.$fJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.globParseError);if(A.startsWith("the literal"))return new C.$fJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.invalidLiteral);if(A.startsWith("PCRE2: error compiling pattern"))return new C.$fJ(A,C.SearchErrorCode.regexParseError)}function n(p){const E=["Regex parse error"],A=p.filter(B=>B.startsWith("PCRE2:"));if(A.length>=1){const B=A[0].replace("PCRE2:","");if(B.indexOf(":")!==-1&&B.split(":").length>=2){const O=B.split(":")[1];E.push(":"+O)}}return E.join("")}class o extends N.EventEmitter{constructor(E,A,B){super(),this.g=E,this.h=A,this.j=B,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,A){return super.on(E,A),this}handleData(E){if(this.b)return;const A=typeof E=="string"?E:this.d.write(E);this.k(A)}k(E){let A=E.indexOf(`
`);const B=this.a+E;if(A>=0)A+=this.a.length;else{this.a=B;return}let O=0;for(;A>=0;)this.m(B.substring(O,A).trim()),O=A+1,A=B.indexOf(`
`,O);this.a=B.substring(O)}m(E){if(this.b||!E)return;let A;try{A=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(A.type==="match"){const B=a(A.data.path),O=M.URI.file($.$jc(this.h,B)),P=this.n(A.data,O);this.p(P),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(A.type==="context"){const B=a(A.data.path),O=M.URI.file($.$jc(this.h,B));this.o(A.data,O).forEach(j=>this.p(j))}}n(E,A){const B=E.line_number-1,O=a(E.lines),P=Buffer.from(O);let j=0,T=0,F=B;E.submatches.length===0&&E.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const W=(0,I.$Hb)(E.submatches.map((X,ce)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const J=a(X.match),Y=P.slice(j,X.start).toString(),x=t(Y),se=x.numLines>0?x.lastLineLength:x.lastLineLength+T,Z=t(J),ve=x.numLines+F,de=Z.numLines+ve,H=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+se;return j=X.end,T=H,F=de,new m.$2I(ve,se,de,H)}));return(0,u.$jhc)(A,O,W,this.j)}o(E,A){const B=a(E.lines),O=E.line_number;return B.replace(/\r?\n$/,"").split(`
`).map((P,j)=>({text:P,uri:A,lineNumber:O+j}))}p(E){this.emit("result",E)}}e.$rhc=o;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const E=/\n/g;let A=0,B=-1,O;for(;O=E.exec(p);)A++,B=O.index;const P=B>=0?p.length-B-1:p.length;return{numLines:A,lastLineLength:P}}function r(p,E){const A=["--hidden","--no-require-git"];A.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:B,otherIncludes:O}=(0,R.$K)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(T=>{j.add(T)}),A.push("-g","!*"),j.forEach(T=>{d(T).map(u.$ihc).forEach(F=>{A.push("-g",F)})})}B&&B.length&&B.forEach(j=>{A.push("-g",j)}),E.excludes.map(u.$ihc).forEach(j=>A.push("-g",`!${j}`)),E.maxFileSize&&A.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||A.push("--no-ignore-parent"):A.push("--no-ignore"),E.followSymlinks&&A.push("--follow"),E.encoding&&E.encoding!=="utf8"&&A.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,y.$Ke)(p.pattern),p.isRegExp=!0),E.usePCRE2&&A.push("--pcre2"),A.push("--crlf"),p.isRegExp&&(p.pattern=l(p.pattern),A.push("--engine","auto"));let P;if(p.isWordMatch){const T=(0,y.$Se)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");A.push("--regexp",T)}else if(p.isRegExp){let j=h(p.pattern);j=S(j),A.push("--regexp",j)}else P=p.pattern,A.push("--fixed-strings");return A.push("--no-config"),E.useGlobalIgnoreFiles||A.push("--no-ignore-global"),A.push("--json"),p.isMultiline&&A.push("--multiline"),E.beforeContext&&A.push("--before-context",E.beforeContext+""),E.afterContext&&A.push("--after-context",E.afterContext+""),A.push("--"),P&&A.push(P),A.push("."),A}e.$shc=r;function d(p){return w(p).flatMap(A=>{const B=(0,b.$Fj)(A,"/");return B.map((O,P)=>B.slice(0,P+1).join("/"))})}function l(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const A=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(A);)p=p.replace(A,"$1\\x{$2}");return p}e.$thc=l;const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let E;try{E=new v.RegExpParser().parsePattern(p)}catch{return p}let A="",B=0;const O=(T,F,W)=>{A+=p.slice(B,T)+W,B=F},P=[];return new v.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const F=P[0];if(!F)O(T.start,T.end,"\\r?\\n");else if(!P.some(c))if(F.type==="CharacterClass")if(F.negate){const W=p.slice(F.start+2,T.start)+p.slice(T.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,W?`[^${W}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(F.start+1,T.start)+p.slice(T.end,F.end-1);O(F.start,F.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){P.unshift(T)},onQuantifierLeave(){P.shift()},onCharacterClassRangeEnter(T){P.unshift(T)},onCharacterClassRangeLeave(){P.shift()},onCharacterClassEnter(T){P.unshift(T)},onCharacterClassLeave(){P.shift()},onAssertionEnter(T){c(T)&&P.push(T)},onAssertionLeave(T){P[0]===T&&P.shift()}}).visit(E),A+=p.slice(B),A}e.$uhc=h;function S(p){return p.replace(/\n/g,"\\r?\\n")}e.$vhc=S;function L(p){let E=!1,A=!1,B="",O="";for(let P=0;P<p.length;P++){const j=p[P];switch(j){case"\\":A?(E?O+="\\"+j:B+="\\"+j,A=!1):A=!0;break;case"{":if(A)E?O+=j:B+=j,A=!1;else{if(E)return{strInBraces:B+"{"+O+"{"+p.substring(P+1)};E=!0}break;case"}":if(A)E?O+=j:B+=j,A=!1;else{if(E)return{fixedStart:B,strInBraces:O,fixedEnd:p.substring(P+1)};B+=j}break;default:E?O+=(A?"\\":"")+j:B+=(A?"\\":"")+j,A=!1;break}}return{strInBraces:B+(E?"{"+O:"")}}function w(p){const{fixedStart:E,strInBraces:A,fixedEnd:B}=L(p);if(E===void 0||B===void 0)return[A];let O=(0,b.$Fj)(A,",");O.length||(O=[""]);const P=w(B);return O.flatMap(j=>{const T=E+j;return P.map(F=>T+F)})}e.$whc=w}),define(Se[376],ke([1,0,21,156,85,17]),function(me,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,M,C,m){const v=new N.$qhc(this.b);if(M.folder.scheme===I.Schemas.vscodeUserData){const k={...M,folder:M.folder.with({scheme:I.Schemas.file})},u=new g.$fv(f=>C.report({...f,uri:f.uri.with({scheme:M.folder.scheme})}));return this.c(m,f=>v.provideTextSearchResults(y,k,u,f))}else return this.c(m,k=>v.provideTextSearchResults(y,M,C,k))}async c(y,M){const C=b(y);this.a.add(C);const m=await M(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Ahc=R;function b($){const y=new D.$3d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(Se[377],ke([1,0,31,156,155]),function(me,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class I{constructor($){this.a=$}search($,y,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){M({message:v})}},m=new g.$xhc(this.a,new N.$qhc(C),D);return new Promise((v,k)=>m.search(u=>{y(u.map(R))},$).then(u=>v({limitHit:u.limitHit,type:"success",stats:u.stats}),k))}}e.$yhc=I;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const M=y;return $+(Array.isArray(M.ranges)?M.ranges.length:1)}else return $+1},0)}}}),define(Se[378],ke([1,0,19,12,8,4,129,16,38,2,32,36,373,377]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class k{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{a=(0,N.$Og)(d=>this.doFileSearchWithEngine(m.$phc,t,l=>r.fire(l),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{a=(0,N.$Og)(d=>this.f(t,l=>r.fire(l),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new v.$yhc(o).search(t,a,a)}g(){return{maxFileSize:16*M.$Sk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(m.$phc,o,a,t)}doFileSearchWithEngine(o,a,t,r,d=k.a){let l=0;const c=S=>{Array.isArray(S)?(l+=S.length,t(S.map(L=>this.h(L)))):S.relativePath?(l++,t(this.h(S))):t(S)};if(a.sortByScore){let S=this.l(a,c,r);if(!S){const L=a.maxResults?Object.assign({},a,{maxResults:null}):a,w=new o(L);S=this.j(w,a,t,c,r)}return new Promise((L,w)=>{S.then(([p,E])=>{const A=E.map(B=>this.h(B));this.o(A,t,d),L(p)},w)})}const h=new o(a);return this.r(h,c,d,r).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(o){return{path:o.base?(0,b.$jc)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,d){const l=new I.$Sd;let c=(0,N.$Og)(S=>{let L=[];const w=p=>{Array.isArray(p)?L=p:(r(p),l.fire(p))};return this.r(o,w,-1,S).then(p=>[p,L])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const S={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=S,c.then(()=>{S.resolved=!0},L=>{delete h.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([S,L])=>{const w=h?h.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Od.create(!1);return this.n(a,L,w,d).then(E=>{const A=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:E.length},messages:S.messages,limitHit:S.limitHit||typeof a.maxResults=="number"&&L.length>a.maxResults},E]})})}k(o){const a=this.b[o];return a||(this.b[o]=new u)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",a,t);if(d)return d.then(([l,c,h])=>{const S=$.$Od.create(!1);return this.n(o,c,r.scorerCache,t).then(L=>{const w=S.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof o.maxResults=="number"&&c.length>o.maxResults,stats:p},L]})})}n(o,a,t,r){const d=(0,R.$Kq)(o.filePattern||""),l=(h,S)=>(0,R.$Jq)(h,S,d,!0,f,t),c=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Gb(a,l,c,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const d=$.$Od.create(!1),l=a.indexOf(b.sep)>=0;let c;for(const w in o.resultsToSearchCache)if(a.startsWith(w)){if(l&&w.indexOf(b.sep)<0&&w!=="")continue;const p=o.resultsToSearchCache[w];c={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!c)return null;const h=d.elapsed(),S=$.$Od.create(!1),L=c.event(t);return r&&r.onCancellationRequested(()=>{L.dispose()}),c.promise.then(([w,p])=>{if(r&&r.isCancellationRequested)throw(0,g.$6)();const E=[],A=(0,R.$Kq)(a).normalizedLowercase;for(const B of p)(0,C.$lJ)(B,A)&&E.push(B);return[w,E,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:S.elapsed(),cacheEntryCount:p.length}]})}r(o,a,t,r){return new Promise((d,l)=>{let c=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(a(c),c=[])):a(h))},h=>{a(h)},(h,S)=>{c.length&&a(c),h?l(h):d(S)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$zhc=k;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,b.$nc)(n.relativePath)}getItemDescription(n){return(0,b.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(Se[379],ke([1,0,3,17,2,31,14,27,20,97,66,36,378,376,119,155]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;let f=class extends y.$ngc{constructor(i,n,o,a){super(i,o,a),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new k.$khc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new v.$Ahc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$khc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new v.$Ahc(i))),this.x.add(this.z(N.Schemas.file,new m.$zhc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,y.$ogc)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,C.$kJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new u.$xhc(i,n,void 0,"textSearchProvider")}};e.$Bhc=f,e.$Bhc=f=Je([We(0,$.$OM),We(1,b.$5M),We(2,M.$gfc),We(3,R.$ij)],f)}),define(Se[120],ke([1,0,393,62,63,394,22,8,4,3,16,11,30,81,82]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class u{traceSocketEvent(p,E){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,E)}constructor(p,E=""){this.f=!0,this.debugLabel=E,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,b.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const E=A=>{this.traceSocketEvent("read",A),p(R.$ge.wrap(A))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){const E=A=>{p({type:0,hadError:A,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(p){const E=()=>{p()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$Ph=u;var f;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var s;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(s||(s={}));class i extends y.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,E){this.socket.traceSocketEvent(p,E)}constructor(p,E,A,B){super(),this.f=this.B(new $.$Sd),this.g=this.B(new $.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:A?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new n(this,E,A,B,this.f,(O,P)=>this.m(O,P))),this.B(this.a.onError(O=>{console.error(O),(0,b.$1)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new k.$Kh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let E=0;for(;E<p.byteLength;)this.a.writeMessage(p.slice(E,Math.min(E+262144,p.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(p,{compressed:E,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let B=2;p.byteLength<126?B+=0:p.byteLength<2**16?B+=2:B+=8;const O=R.$ge.alloc(B),P=E?64:0,j=A&15;if(O.writeUInt8(128|P|j,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let T=1;O.writeUInt8(p.byteLength>>>8&255,++T),O.writeUInt8(p.byteLength>>>0&255,++T)}else{O.writeUInt8(127,1);let T=1;O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(0,++T),O.writeUInt8(p.byteLength>>>24&255,++T),O.writeUInt8(p.byteLength>>>16&255,++T),O.writeUInt8(p.byteLength>>>8&255,++T),O.writeUInt8(p.byteLength>>>0&255,++T)}this.socket.write(R.$ge.concat([O,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),A=E.readUInt8(0),B=(A&128)>>>7,O=(A&64)>>>6,P=A&15,j=E.readUInt8(1),T=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(T?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=P,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),A=E.readUInt8(1),B=(A&128)>>>7;let O=A&127,P=1;O===126?O=E.readUInt8(++P)*2**8+E.readUInt8(++P):O===127&&(O=E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*2**24+E.readUInt8(++P)*2**16+E.readUInt8(++P)*2**8+E.readUInt8(++P));let j=0;B&&(j=E.readUInt8(++P)*2**24+E.readUInt8(++P)*2**16+E.readUInt8(++P)*2**8+E.readUInt8(++P)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Qh=i;class n extends y.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ge.alloc(0)}constructor(p,E,A,B,O,P){super(),this.n=p,this.r=O,this.s=P,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,B,A,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(p,E){this.g.push({data:p,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:E}=this.g.shift();if(this.f&&E.compressed){const A=await this.w(this.f,p);this.s(A,E)}else this.s(p,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,E){return new Promise((A,B)=>{p.write(E),p.flush(O=>A(O))})}acceptFrame(p,E,A){this.h.push({data:p,isCompressed:E,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const E=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,E,A){return new Promise((B,O)=>{p.write(E),A&&p.write(R.$ge.fromByteArray([0,0,255,255])),p.flush(P=>B(P))})}}class o extends y.$Sc{get recordedInflateBytes(){return this.j?R.$ge.concat(this.f):R.$ge.alloc(0)}constructor(p,E,A,B){super(),this.h=p,this.j=E,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(B),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(R.$ge.wrap(O))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$ge.concat(this.g);this.g.length=0,p(E)})}}class a extends y.$Sc{constructor(p,E){super(),this.g=p,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(R.$ge.wrap(A))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$ge.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),p(E)})}}function t(w,p){if(p===0)return;const E=w.byteLength>>>2;for(let T=0;T<E;T++){const F=w.readUInt32BE(T*4);w.writeUInt32BE(F^p,T*4)}const A=E*4,B=w.byteLength-A,O=p>>>24&255,P=p>>>16&255,j=p>>>8&255;B>=1&&w.writeUInt8(w.readUInt8(A)^O,A),B>=2&&w.writeUInt8(w.readUInt8(A+1)^P,A+1),B>=3&&w.writeUInt8(w.readUInt8(A+2)^j,A+2)}e.$Rh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const w=(0,m.$lg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const p=process.platform!=="darwin"&&e.$Rh?e.$Rh:(0,g.tmpdir)(),E=(0,M.$jc)(p,`vscode-ipc-${w}.sock`);return c(E),E}e.$Sh=d;function l(w,p,E){const A=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${E}-${p}-sock`;const B=E.substr(0,4),O=p.substr(0,6),P=A.substr(0,8);let j;return process.platform!=="darwin"&&e.$Rh&&!process.env.VSCODE_PORTABLE?j=(0,M.$jc)(e.$Rh,`vscode-${P}-${B}-${O}.sock`):j=(0,M.$jc)(w,`${B}-${O}.sock`),c(j),j}e.$Th=l;function c(w){const p=r[C.$u];typeof p=="number"&&w.length>=p&&console.warn(`WARNING: IPC handle "${w}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends v.$Eh{static b(p){const E=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(E,A=>({protocol:new k.$Lh(new u(A,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(A,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Uh=h;function S(w){return new Promise((p,E)=>{const A=(0,N.createServer)();A.on("error",E),A.listen(w,()=>{A.removeListener("error",E),p(new h(A))})})}e.$Vh=S;function L(w,p){return new Promise((E,A)=>{const B=(0,N.createConnection)(w,()=>{B.removeListener("error",A),E(k.$Mh.fromSocket(new u(B,`ipc-client${p}`),p))});B.once("error",A)})}e.$Wh=L}),define(Se[380],ke([1,0,62,63,166,120,12,3,11,45,14,136,257,258,109,88,22]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.$10b=e.$Z0b=e.$Y0b=void 0;async function s(t,r,d,l,c){let h;for(let S=3;S&&(h?.dispose(),h=await new i(t,r,d,l,c).waitForReady(),!(c&&g.$og[c]||!g.$og[h.tunnelLocalPort]));S--);return h}class i extends b.$Sc{constructor(r,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new R.$Zg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,u.$rv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,g.$pg)(r,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const d=(0,u.$pv)(this.tunnelRemoteHost)||(0,u.$rv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,m.$fl)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof I.$Ph?c.socket.destroy():c.end()}),c instanceof I.$Ph?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(l=>r.write(l.buffer)),r.on("data",l=>d.write(f.$ge.wrap(l))),r.resume()}t(r,d){const l=d.socket;l.on("end",()=>r.end()),l.on("close",()=>r.end()),l.on("error",()=>{r.destroy()}),l.pipe(r),r.pipe(l)}}e.$Y0b=i;let n=class extends u.$uv{constructor(r,d,l,c,h){super(d,h),this.u=r,this.v=l,this.w=c}isPortPrivileged(r){return(0,u.$sv)(r,this.l,$.OS,N.release())}s(r,d,l,c,h,S,L,w){const p=this.r(d,l);if(p)return++p.refcount,p.value;if((0,u.$mv)(r))return this.t(r,d,l,h,S,L,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},A=s(E,c,d,l,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,l,A),A}}};e.$Z0b=n,e.$Z0b=n=Je([We(0,v.$_k),We(1,M.$ij),We(2,k.$cl),We(3,C.$Aj),We(4,y.$ui)],n);let o=class extends n{constructor(r,d,l,c,h){super(r,d,l,c,h)}};e.$10b=o,e.$10b=o=Je([We(0,v.$_k),We(1,M.$ij),We(2,k.$cl),We(3,C.$Aj),We(4,y.$ui)],o);let a=class extends b.$Sc{constructor(r,d,l,c,h){super(),this.b=r,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(r,d,l,c,h,S,L,w,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${S}.`),!this.a.has(r)){const E=new o(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,l,c,h,S,L,w,p)}};e.$20b=a,e.$20b=a=Je([We(0,v.$_k),We(1,M.$ij),We(2,C.$Aj),We(3,k.$cl),We(4,y.$ui)],a)}),define(Se[381],ke([1,0,120,277,55,35,2,14,40]),function(me,e,D,N,g,I,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0;class y{constructor(m,v,k){this.b=m,this.c=v,this.f=k,this.a=N.createServer((u,f)=>this.h(u,f)),this.g().catch(u=>(v.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const k=(f,s)=>{v.writeHead(f,{"content-type":"application/json"}),v.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},u=[];m.setEncoding("utf8"),m.on("data",f=>u.push(f)),m.on("end",async()=>{try{const f=JSON.parse(u.join(""));let s;switch(f.type){case"open":s=await this.i(f);break;case"openExternal":s=await this.j(f);break;case"status":s=await this.l(f);break;case"extensionManagement":s=await this.k(f);break;default:k(404,`Unknown message type: ${f.type}`);break}k(200,s)}catch(f){const s=f instanceof Error?f.message:JSON.stringify(f);k(500,s),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:v,folderURIs:k,forceNewWindow:u,diffMode:f,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=m,r=[];if(Array.isArray(k))for(const h of k)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(v))for(const h of v)try{(0,$.$ti)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=a?R.URI.file(a):void 0,c={forceNewWindow:u,diffMode:f,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(m){for(const v of m.uris){const k=R.URI.parse(v),u=k.scheme==="file"?k:v;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(m){const v=u=>u?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),k={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$dN=y;let M=class extends y{constructor(m,v){super(m,v,(0,D.$Sh)())}};e.$eN=M,e.$eN=M=Je([We(0,I.$$M),We(1,b.$ij)],M)}),define(Se[382],ke([1,0,56,369,364,276,48,349,2,17,7,381,103,347,348]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class u extends g.$8gc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,l,c){return d=t(d),i.a.has(d)?i.a.get(d).load(d,$.URI.file((0,m.$hq)(l.filename)),h=>o.apply(this,[h,l,c])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>a.call(this,t(r),d);const t=r=>{for(const d of i.b){const l=d(r);if(l){r=l;break}}return r}}}class f extends R.$Wfc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$Ehc);const i=this.h.invokeFunction(N.$4gc);if(this.h.createInstance(b.$Dhc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$eN);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(k.$Fhc),await this.h.createInstance(u,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,I.$Chc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Ghc=f}),define(Se[383],ke([1,0,51,22,4,3,122,11,23,2,31,14,256,64,109,88,380,27,20,72,358]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=e.$Mhc=e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=e.$Hhc=void 0;function a(p){const E=p.trim().split(`
`),A=[];return E.forEach(O=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);P&&P.length>=3&&A.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),A.reduce((O,P)=>(O[P.socket]=P,O),{})}e.$Hhc=a;function t(...p){const E=[].concat(...p.map(d));return[...new Map(E.filter(A=>A.st==="0A").map(A=>{const B=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:r(B[0]),port:parseInt(B[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$Ihc=t;function r(p){let E="";if(p.length===8)for(let A=p.length-2;A>=0;A-=2)E+=parseInt(p.substr(A,2),16),A!==0&&(E+=".");else for(let A=0;A<p.length;A+=8){const B=p.substring(A,A+8);let O="";for(let P=8;P>=2;P-=2)O+=B.substring(P-2,P),(P===6||P===2)&&(O=parseInt(O,16).toString(16),E+=`${O}`,O="",A+P!==p.length-6&&(E+=":"))}return E}e.$Jhc=r;function d(p){const E=p.trim().split(`
`),A=E.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return E.map(O=>O.trim().split(/\s+/).reduce((P,j,T)=>(P[A[T]||T]=j,P),{}))}e.$Khc=d;function l(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function c(p){const E=p.trim().split(`
`),A=[];return E.forEach(B=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(B);O&&O.length>=4&&A.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),A}e.$Lhc=c;async function h(p,E,A){const B=A.reduce((P,j)=>(P[j.pid]=j,P),{}),O=[];return p.forEach(({socket:P,ip:j,port:T})=>{const F=E[P]?E[P].pid:void 0,W=F?B[F]?.cmd:void 0;F&&W&&!l(W)&&O.push({host:j,port:T,detail:W,pid:F})}),O}e.$Mhc=h;function S(p,E,A){const B=new Map,O=c(E);for(const P of p){const j=A.get(P.port);if(j){B.set(P.port,j);continue}const T=O.find(F=>F.cmd.includes(`${P.port}`));if(T){let F=T,W;do W=O.find(X=>X.ppid===F.pid),W&&(F=W);while(W);B.set(P.port,{host:P.ip,port:P.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else B.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return B}e.$Nhc=S;let L=class extends n.$5xb{constructor(E,A,B,O){super(E,A,B),this.D=A,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const B=new R.$4l;let O=0;for(;this.C;){const P=new Date().getTime(),j=(await this.I()).filter(W=>(0,u.$pv)(W.host)||(0,u.$rv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(W=>W.port).join(", ")}`);const T=new Date().getTime()-P;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${T} ms.`),O++>3&&B.update(T),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const F=this.G(B.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(W=>setTimeout(()=>W(),F))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",A="";try{E=await M.Promises.readFile("/proc/net/tcp","utf8"),A=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const B=t(E,A),O=await new Promise(J=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,x,se)=>{J(x)})}),P=a(O),j=await M.Promises.readdir("/proc"),T=[];for(const J of j)try{const Y=Number(J),x=$.$Cg(y.URI.file("/proc"),J);if((await M.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Y)){const Z=await M.Promises.readlink($.$Cg(x,"cwd").fsPath),ve=await M.Promises.readFile($.$Cg(x,"cmdline").fsPath,"utf8");T.push({pid:Y,cwd:Z,cmd:ve})}}catch{}const F=[],W=B.filter(J=>{const Y=P[J.socket];return Y||F.push(J),Y}),X=h(W,P,T);let ce;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const J=await new Promise(Y=>{(0,D.exec)("ps -F -A -l | grep root",(x,se,Z)=>{Y(se)})});this.z=S(F,J,this.z),ce=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ce.map(Y=>Y.port).join(", ")}`)}return X.then(J=>ce?J.concat(ce):J)}w(E){return async A=>{const B=new f.$Y0b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(P,j,T,F){const W=await E.makeConnection();return w.connect(W,j,T,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$3k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await B.waitForReady();const O=new g.$Sd;return{localAddress:(0,o.$$J)(B.localAddress)??B.localAddress,remoteAddress:{port:B.tunnelRemotePort,host:B.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{B.dispose(),O.fire(),O.dispose()}}}}};e.$Ohc=L,e.$Ohc=L=Je([We(0,i.$OM),We(1,s.$5M),We(2,C.$ij),We(3,k.$cl)],L);class w extends m.$0qb{static connect(E,A,B,O){const P=new I.$Rc,j={onClose:P.add(new g.$Sd),onData:P.add(new g.$Sd),onEnd:P.add(new g.$Sd)};P.add(E.onDidReceiveMessage(F=>j.onData.fire(N.$ge.wrap(F)))),P.add(E.onDidEnd(()=>j.onEnd.fire())),P.add(E.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const T=new w(E,O,j);return T.B(P),(0,m.$9qb)(T,A,B,O,j)}constructor(E,A,B){super(A,B),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[384],ke([1,0,106,352,367,366,379,382,383,96,48,97,95,47,72,92,351,350,14,368,58,271,105,109,138]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Ir)(M.$Xfc,b.$Ghc,0),(0,D.$Ir)(i.$jj,s.$Qhc,1),(0,D.$Ir)(i.$ij,new t.$Xh(a.$7gc,[!1],!0)),(0,D.$Ir)(r.$cl,d.$40b,1),(0,D.$Ir)(u.$pfc,f.$Phc,0),(0,D.$Ir)(y.$3fc,I.$hhc,0),(0,D.$Ir)(C.$mgc,R.$Bhc,0),(0,D.$Ir)(m.$Pgc,g.$_gc,0),(0,D.$Ir)(v.$Kfc,N.$$gc,0),(0,D.$Ir)(k.$4xb,$.$Ohc,0),(0,D.$Ir)(o.$1fc,n.$Rhc,0)}),define(Se[395],ke([1,0,62,396,56,8,82,120,254,114,365,22,31,103,12,132,278,292,370,384]),function(me,e,D,N,g,I,R,b,$,y,M,C,m,v,k,u,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function o(c){process.exit=function(h){if(c)n(h);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,s.$Nm)(process.env);if(c.type===3)return new Promise((h,S)=>{const L=w=>{const p=w[0],E=new R.$Nh;p.on("message",A=>E.fire(C.$ge.wrap(A.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),h({onMessage:E.event,send:A=>p.postMessage(A.buffer)})};process.parentPort.on("message",w=>L(w.ports))});if(c.type===2)return new Promise((h,S)=>{let L=null;const w=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,E=3e5,A=new k.$bh(()=>a("renderer disconnected for too long (1)"),p),B=new k.$bh(()=>a("renderer disconnected for too long (2)"),E);process.on("message",(P,j)=>{if(P&&P.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const T=C.$ge.wrap(Buffer.from(P.initialDataChunk,"base64"));let F;if(P.skipWebSocketFrames)F=new b.$Ph(j,"extHost-socket");else{const W=C.$ge.wrap(Buffer.from(P.inflateBytes,"base64"));F=new b.$Qh(new b.$Ph(j,"extHost-socket"),P.permessageDeflate,W,!1)}L?(A.cancel(),B.cancel(),L.beginAcceptReconnection(F,T),L.endAcceptReconnection(),L.sendResume()):(clearTimeout(w),L=new R.$Oh({socket:F,initialChunk:T}),L.sendResume(),L.onDidDispose(()=>a("renderer disconnected")),h(L),L.onSocketClose(()=>{A.schedule()}))}if(P&&P.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;A.isScheduled()&&B.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const h=c.pipeName;return new Promise((S,L)=>{const w=D.createConnection(h,()=>{w.removeListener("error",L);const p=new R.$Oh({socket:new b.$Ph(w,"extHost-renderer")});p.sendResume(),S(p)});w.once("error",L),w.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new R.$Nh,this.onMessage=this.a.event,this.b=!1,c.onMessage(h=>{(0,y.$om)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||c.send(h)}async drain(){if(c.drain)return c.drain()}}}function d(c){return new Promise(h=>{const S=c.onMessage(L=>{S.dispose();const w=JSON.parse(L.toString()),p=w.commit,E=$.default.commit;if(p&&E&&p!==E&&n(55),w.parentPid){let A=0;setInterval(function(){try{process.kill(w.parentPid,0),A=0}catch(O){O&&O.code==="EPERM"?(A++,A>=3&&a(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):a(`parent process ${w.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let B;try{B=globalThis._VSCODE_NODE_MODULES["native-watchdog"],B.start(w.parentPid)}catch(O){(0,I.$1)(O)}}c.send((0,y.$nm)(0)),h({protocol:c,initData:w})});c.send((0,y.$nm)(1))})}async function l(){const c=[];process.on("unhandledRejection",(A,B)=>{c.push(B),setTimeout(()=>{const O=c.indexOf(B);O>=0&&B.catch(P=>{c.splice(O,1),(0,I.$4)(P)||(console.warn(`rejected promise not handled within 1 second: ${P}`),P&&P.stack&&console.warn(`stack trace: ${P.stack}`),A&&(0,I.$1)(A))})},1e3)}),process.on("rejectionHandled",A=>{const B=c.indexOf(A);B>=0&&c.splice(B,1)}),process.on("uncaughtException",function(A){(0,I.$Z)(A)||(0,I.$1)(A)}),g.mark("code/extHost/willConnectToRenderer");const h=await r();g.mark("code/extHost/didConnectToRenderer");const S=await d(h);g.mark("code/extHost/didWaitForInitData");const{initData:L}=S;o(!!L.environment.extensionTestsLocationURI),L.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,L.environment.skipWorkspaceStorageLock=(0,u.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(B){n(B)}fsExists(B){return m.Promises.exists(B)}fsRealpath(B){return(0,v.$gq)(B)}};let p=null;L.remote.authority&&i.transformURIs&&(p=(0,f.$Mr)(L.remote.authority));const E=new M.$0gc(S.protocol,L,w,p);a=A=>E.terminate(A)}l().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42053f37e98a2dbaa0d108807491e716105dccd2/core/vs/workbench/api/node/extensionHostProcess.js.map
