/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(me){for(var e=[],E=0,T=me.length;E<T;E++)e[E]=Pe[me[E]];return e};define(Pe[66],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function E(A){return(m,g,w)=>{let R=null,S=null;if(typeof w.value=="function"?(R="value",S=w.value):typeof w.get=="function"&&(R="get",S=w.get),!S)throw new Error("not supported");w[R]=A(S,g)}}function T(A,m,g){let w=null,R=null;if(typeof g.value=="function"?(w="value",R=g.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",R=g.get),!R)throw new Error("not supported");const S=`$memoize$${m}`;g[w]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[S]}}e.$sh=T;function I(A,m,g){return E((w,R)=>{const S=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...$){this[l]||(this[l]=g?g():void 0),clearTimeout(this[S]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[S]=setTimeout(()=>{w.apply(this,$),this[l]=g?g():void 0},A)}})}e.$th=I;function L(A,m,g){return E((w,R)=>{const S=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...n){if(this[l]||(this[l]=g?g():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...n)),this[v])return;const o=this[$]+A;o<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[v]=!0,this[S]=setTimeout(()=>{this[v]=!1,this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$uh=L}),define(Pe[89],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$TM=E,e.$UM=new E("id#")}),define(Pe[119],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,s=!1){let u=0;const d=i.length;let b="",f=0,k=16,F=0;function p(B){let C=0,P=0;for(;C<B;){const X=i.charCodeAt(u);if(X>=48&&X<=57)P=P*16+X-48;else if(X>=65&&X<=70)P=P*16+X-65+10;else if(X>=97&&X<=102)P=P*16+X-97+10;else break;u++,C++}return C<B&&(P=-1),P}function y(B){u=B,b="",f=0,k=16,F=0}function D(){const B=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return F=3,i.substring(B,u);let C=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;C=u}else F=3;return i.substring(B,C)}function O(){let B="",C=u;for(;;){if(u>=d){B+=i.substring(C,u),F=2;break}const P=i.charCodeAt(u);if(P===34){B+=i.substring(C,u),u++;break}if(P===92){if(B+=i.substring(C,u),u++,u>=d){F=2;break}switch(i.charCodeAt(u++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const ae=p(4);ae>=0?B+=String.fromCharCode(ae):F=4;break}default:F=5}C=u;continue}if(P>=0&&P<=31)if(g(P)){B+=i.substring(C,u),F=2;break}else F=6;u++}return B}function K(){if(b="",F=0,f=u,u>=d)return f=d,k=17;let B=i.charCodeAt(u);if(m(B)){do u++,b+=String.fromCharCode(B),B=i.charCodeAt(u);while(m(B));return k=15}if(g(B))return u++,b+=String.fromCharCode(B),B===13&&i.charCodeAt(u)===10&&(u++,b+=`
`),k=14;switch(B){case 123:return u++,k=1;case 125:return u++,k=2;case 91:return u++,k=3;case 93:return u++,k=4;case 58:return u++,k=6;case 44:return u++,k=5;case 34:return u++,b=O(),k=10;case 47:{const C=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return b=i.substring(C,u),k=12}if(i.charCodeAt(u+1)===42){u+=2;const P=d-1;let X=!1;for(;u<P;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,X=!0;break}u++}return X||(u++,F=1),b=i.substring(C,u),k=13}return b+=String.fromCharCode(B),u++,k=16}case 45:if(b+=String.fromCharCode(B),u++,u===d||!w(i.charCodeAt(u)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=D(),k=11;default:for(;u<d&&U(B);)u++,B=i.charCodeAt(u);if(f!==u){switch(b=i.substring(f,u),b){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return b+=String.fromCharCode(B),u++,k=16}}function U(B){if(m(B)||g(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=K();while(B>=12&&B<=15);return B}return{setPosition:y,getPosition:()=>u,scan:s?M:K,getToken:()=>k,getTokenValue:()=>b,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>F}}e.$7m=A;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,s){const u=[],d=new Object;let b;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function F(p,y,D,O){f.value=p,f.offset=y,f.length=D,f.type=O,f.colonOffset=void 0,b=f}try{a(i,{onObjectBegin:(p,y)=>{if(s<=p)throw d;b=void 0,k=s>p,u.push("")},onObjectProperty:(p,y,D)=>{if(s<y||(F(p,y,D,"property"),u[u.length-1]=p,s<=y+D))throw d},onObjectEnd:(p,y)=>{if(s<=p)throw d;b=void 0,u.pop()},onArrayBegin:(p,y)=>{if(s<=p)throw d;b=void 0,u.push(0)},onArrayEnd:(p,y)=>{if(s<=p)throw d;b=void 0,u.pop()},onLiteralValue:(p,y,D)=>{if(s<y||(F(p,y,D,h(p)),s<=y+D))throw d},onSeparator:(p,y,D)=>{if(s<=y)throw d;if(p===":"&&b&&b.type==="property")b.colonOffset=y,k=!1,b=void 0;else if(p===","){const O=u[u.length-1];typeof O=="number"?u[u.length-1]=O+1:(k=!0,u[u.length-1]=""),b=void 0}}})}catch(p){if(p!==d)throw p}return{path:u,previousNode:b,isAtPropertyKey:k,matches:p=>{let y=0;for(let D=0;y<p.length&&D<u.length;D++)if(p[y]===u[D]||p[y]==="*")y++;else if(p[y]!=="**")return!1;return y===p.length}}}e.$8m=S;function l(i,s=[],u=L.DEFAULT){let d=null,b=[];const f=[];function k(p){Array.isArray(b)?b.push(p):d!==null&&(b[d]=p)}return a(i,{onObjectBegin:()=>{const p={};k(p),f.push(b),b=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const p=[];k(p),f.push(b),b=p,d=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:k,onError:(p,y,D)=>{s.push({error:p,offset:y,length:D})}},u),b[0]}e.$9m=l;function $(i,s=[],u=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(p){d.type==="property"&&(d.length=p-d.offset,d=d.parent)}function f(p){return d.children.push(p),p}a(i,{onObjectBegin:p=>{d=f({type:"object",offset:p,length:-1,parent:d,children:[]})},onObjectProperty:(p,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:p,offset:y,length:D,parent:d})},onObjectEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onArrayBegin:(p,y)=>{d=f({type:"array",offset:p,length:-1,parent:d,children:[]})},onArrayEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onLiteralValue:(p,y,D)=>{f({type:h(p),offset:y,length:D,parent:d,value:p}),b(y+D)},onSeparator:(p,y,D)=>{d.type==="property"&&(p===":"?d.colonOffset=y:p===","&&b(y))},onError:(p,y,D)=>{s.push({error:p,offset:y,length:D})}},u);const F=d.children[0];return F&&delete F.parent,F}e.$0m=$;function v(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let b=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],b=!0;break}if(!b)return}else{const b=d;if(u.type!=="array"||b<0||!Array.isArray(u.children)||b>=u.children.length)return;u=u.children[b]}return u}e.$$m=v;function n(i){if(!i.parent||!i.parent.children)return[];const s=n(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$_m=n;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$an=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$bn=t;function r(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let b=0;b<d.length&&d[b].offset<=s;b++){const f=r(d[b],s,u);if(f)return f}return i}}e.$cn=r;function a(i,s,u=L.DEFAULT){const d=A(i,!1);function b(te){return te?()=>te(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(te){return te?Se=>te(Se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const k=b(s.onObjectBegin),F=f(s.onObjectProperty),p=b(s.onObjectEnd),y=b(s.onArrayBegin),D=b(s.onArrayEnd),O=f(s.onLiteralValue),K=f(s.onSeparator),U=b(s.onComment),M=f(s.onError),B=u&&u.disallowComments,C=u&&u.allowTrailingComma;function P(){for(;;){const te=d.scan();switch(d.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:B||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(te){case 12:case 13:B?X(10):U();break;case 16:X(1);break;case 15:case 14:break;default:return te}}}function X(te,Se=[],oe=[]){if(M(te),Se.length+oe.length>0){let Y=d.getToken();for(;Y!==17;){if(Se.indexOf(Y)!==-1){P();break}else if(oe.indexOf(Y)!==-1)break;Y=P()}}}function ae(te){const Se=d.getTokenValue();return te?O(Se):F(Se),P(),!0}function ge(){switch(d.getToken()){case 11:{let te=0;try{te=JSON.parse(d.getTokenValue()),typeof te!="number"&&(X(2),te=0)}catch{X(2)}O(te);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return P(),!0}function ve(){return d.getToken()!==10?(X(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(K(":"),P(),he()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function ke(){k(),P();let te=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(te||X(4,[],[]),K(","),P(),d.getToken()===2&&C)break}else te&&X(6,[],[]);ve()||X(4,[],[2,5]),te=!0}return p(),d.getToken()!==2?X(7,[2],[]):P(),!0}function de(){y(),P();let te=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(te||X(4,[],[]),K(","),P(),d.getToken()===4&&C)break}else te&&X(6,[],[]);he()||X(4,[],[4,5]),te=!0}return D(),d.getToken()!==4?X(8,[4],[]):P(),!0}function he(){switch(d.getToken()){case 3:return de();case 1:return ke();case 10:return ae(!0);default:return ge()}}return P(),d.getToken()===17?u.allowEmptyContent?!0:(X(4,[],[]),!1):he()?(d.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$dn=a;function c(i,s){const u=A(i),d=[];let b,f=0,k;do switch(k=u.getPosition(),b=u.scan(),b){case 12:case 13:case 17:f!==k&&d.push(i.substring(f,k)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(b!==17);return d.join("")}e.$en=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$fn=h}),function(me,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Ce,ce){for(var ie=0;ie<ce.length;ie++){var Q=ce[ie];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function E(Ce,ce,ie){return ce&&e(Ce.prototype,ce),ie&&e(Ce,ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return I(Ce,ce);var ie=Object.prototype.toString.call(Ce).slice(8,-1);if(ie==="Object"&&Ce.constructor&&(ie=Ce.constructor.name),ie==="Map"||ie==="Set")return Array.from(Ce);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return I(Ce,ce)}}function I(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var ie=0,Q=new Array(ce);ie<ce;ie++)Q[ie]=Ce[ie];return Q}function L(Ce,ce){var ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ie)return(ie=ie.call(Ce)).next.bind(ie);if(Array.isArray(Ce)||(ie=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){ie&&(Ce=ie);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function m(Ce){me.defaults=Ce}var g=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(ce){return l[ce]};function v(Ce,ce){if(ce){if(g.test(Ce))return Ce.replace(w,$)}else if(R.test(Ce))return Ce.replace(S,$);return Ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(n,function(ce,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function r(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var ie={replace:function(ee,$e){return $e=$e.source||$e,$e=$e.replace(t,"$1"),Ce=Ce.replace(ee,$e),ie},getRegex:function(){return new RegExp(Ce,ce)}};return ie}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,ie){if(Ce){var Q;try{Q=decodeURIComponent(o(ie)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(ie)&&(ie=b(ce,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Ce,ce){i[" "+Ce]||(s.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=p(Ce,"/",!0)),Ce=i[" "+Ce];var ie=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?ie?ce:Ce.replace(u,"$1")+ce:ce.charAt(0)==="/"?ie?ce:Ce.replace(d,"$1")+ce:Ce+ce}var f={exec:function(){}};function k(Ce){for(var ce=1,ie,Q;ce<arguments.length;ce++){ie=arguments[ce];for(Q in ie)Object.prototype.hasOwnProperty.call(ie,Q)&&(Ce[Q]=ie[Q])}return Ce}function F(Ce,ce){var ie=Ce.replace(/\|/g,function($e,be,Me){for(var le=!1,we=be;--we>=0&&Me[we]==="\\";)le=!le;return le?"|":" |"}),Q=ie.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function p(Ce,ce,ie){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var $e=Ce.charAt(Q-ee-1);if($e===ce&&!ie)ee++;else if($e!==ce&&ie)ee++;else break}return Ce.slice(0,Q-ee)}function y(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var ie=Ce.length,Q=0,ee=0;ee<ie;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(Ce,ce){if(ce<1)return"";for(var ie="";ce>1;)ce&1&&(ie+=Ce),ce>>=1,Ce+=Ce;return ie+Ce}function K(Ce,ce,ie,Q){var ee=ce.href,$e=ce.title?v(ce.title):null,be=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Me={type:"link",raw:ie,href:ee,title:$e,text:be,tokens:Q.inlineTokens(be)};return Q.state.inLink=!1,Me}return{type:"image",raw:ie,href:ee,title:$e,text:v(be)}}function U(Ce,ce){var ie=Ce.match(/^(\s+)(?:```)/);if(ie===null)return ce;var Q=ie[1];return ce.split(`
`).map(function(ee){var $e=ee.match(/^\s+/);if($e===null)return ee;var be=$e[0];return be.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var M=function(){function Ce(ie){this.options=ie||me.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var $e=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:p($e,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var $e=ee[0],be=U($e,ee[3]||"");return{type:"code",raw:$e,lang:ee[2]?ee[2].trim():ee[2],text:be}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var $e=ee[2].trim();if(/#$/.test($e)){var be=p($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:$e,tokens:this.lexer.inline($e)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var $e=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var $e,be,Me,le,we,N,q,H,j,J,_,ye,Te=ee[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ye=!1,!(!(ee=Xe.exec(Q))||this.rules.block.hr.test(Q)));){if($e=ee[0],Q=Q.substring($e.length),H=ee[2].split(`
`,1)[0],j=Q.split(`
`,1)[0],this.options.pedantic?(le=2,_=H.trimLeft()):(le=ee[2].search(/[^ ]/),le=le>4?1:le,_=H.slice(le),le+=ee[1].length),N=!1,!H&&/^ *$/.test(j)&&($e+=j+`
`,Q=Q.substring(j.length+1),ye=!0),!ye)for(var rt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(J=Q.split(`
`,1)[0],H=J,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(H)||ot.test(H)||rt.test(H)||it.test(Q)));){if(H.search(/[^ ]/)>=le||!H.trim())_+=`
`+H.slice(le);else if(!N)_+=`
`+H;else break;!N&&!H.trim()&&(N=!0),$e+=J+`
`,Q=Q.substring(J.length+1)}He.loose||(q?He.loose=!0:/\n *\n *$/.test($e)&&(q=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(_),be&&(Me=be[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:$e,task:!!be,checked:Me,loose:!1,text:_}),He.raw+=$e}He.items[He.items.length-1].raw=$e.trimRight(),He.items[He.items.length-1].text=_.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(we=0;we<at;we++){this.lexer.state.top=!1,He.items[we].tokens=this.lexer.blockTokens(He.items[we].text,[]);var Be=He.items[we].tokens.filter(function(Z){return Z.type==="space"}),pt=Be.every(function(Z){for(var x=Z.raw.split(""),pe=0,Ue=L(x),Qe;!(Qe=Ue()).done;){var tt=Qe.value;if(tt===`
`&&(pe+=1),pe>1)return!0}return!1});!He.loose&&Be.length&&pt&&(He.loose=!0,He.items[we].loose=!0)}return He}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var $e={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var $e=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var $e={type:"table",header:F(ee[1]).map(function(q){return{text:q}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ee[0];var be=$e.align.length,Me,le,we,N;for(Me=0;Me<be;Me++)/^ *-+: *$/.test($e.align[Me])?$e.align[Me]="right":/^ *:-+: *$/.test($e.align[Me])?$e.align[Me]="center":/^ *:-+ *$/.test($e.align[Me])?$e.align[Me]="left":$e.align[Me]=null;for(be=$e.rows.length,Me=0;Me<be;Me++)$e.rows[Me]=F($e.rows[Me],$e.header.length).map(function(q){return{text:q}});for(be=$e.header.length,le=0;le<be;le++)$e.header[le].tokens=this.lexer.inline($e.header[le].text);for(be=$e.rows.length,le=0;le<be;le++)for(N=$e.rows[le],we=0;we<N.length;we++)N[we].tokens=this.lexer.inline(N[we].text);return $e}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var $e=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:$e,tokens:this.lexer.inline($e)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:v(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var $e=ee[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=p($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Me=y(ee[2],"()");if(Me>-1){var le=ee[0].indexOf("!")===0?5:4,we=le+ee[1].length+Me;ee[2]=ee[2].substring(0,Me),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var N=ee[2],q="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(N);H&&(N=H[1],q=H[3])}else q=ee[3]?ee[3].slice(1,-1):"";return N=N.trim(),/^</.test(N)&&(this.options.pedantic&&!/>$/.test($e)?N=N.slice(1):N=N.slice(1,-1)),K(ee,{href:N&&N.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var $e;if(($e=this.rules.inline.reflink.exec(Q))||($e=this.rules.inline.nolink.exec(Q))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=ee[be.toLowerCase()],!be||!be.href){var Me=$e[0].charAt(0);return{type:"text",raw:Me,text:Me}}return K($e,be,$e[0],this.lexer)}},ce.emStrong=function(Q,ee,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(Q);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=be[1]||be[2]||"";if(!Me||Me&&($e===""||this.rules.inline.punctuation.exec($e))){var le=be[0].length-1,we,N,q=le,H=0,j=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,ee=ee.slice(-1*Q.length+le);(be=j.exec(ee))!=null;)if(we=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!we){if(N=we.length,be[3]||be[4]){q+=N;continue}else if((be[5]||be[6])&&le%3&&!((le+N)%3)){H+=N;continue}if(q-=N,!(q>0)){if(N=Math.min(N,N+q+H),Math.min(le,N)%2){var J=Q.slice(1,le+be.index+N);return{type:"em",raw:Q.slice(0,le+be.index+N+1),text:J,tokens:this.lexer.inlineTokens(J)}}var _=Q.slice(2,le+be.index+N-1);return{type:"strong",raw:Q.slice(0,le+be.index+N+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var $e=ee[2].replace(/\n/g," "),be=/[^ ]/.test($e),Me=/^ /.test($e)&&/ $/.test($e);return be&&Me&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:ee[0],text:$e}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var $e=this.rules.inline.autolink.exec(Q);if($e){var be,Me;return $e[2]==="@"?(be=v(this.options.mangle?ee($e[1]):$e[1]),Me="mailto:"+be):(be=v($e[1]),Me=be),{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(Q,ee){var $e;if($e=this.rules.inline.url.exec(Q)){var be,Me;if($e[2]==="@")be=v(this.options.mangle?ee($e[0]):$e[0]),Me="mailto:"+be;else{var le;do le=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(le!==$e[0]);be=v($e[0]),$e[1]==="www."?Me="http://"+be:Me=be}return{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(Q,ee){var $e=this.rules.inline.text.exec(Q);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:be=v(this.options.smartypants?ee($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},Ce}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=r(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=r(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=r(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=r(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=r(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=r(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=k({},B),B.gfm=k({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=r(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=r(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=k({},B.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:r(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=r(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=r(B._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=r(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=r(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=r(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=r(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=r(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=r(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=r(C.reflink).replace("label",C._label).replace("ref",B._label).getRegex(),C.nolink=r(C.nolink).replace("ref",B._label).getRegex(),C.reflinkSearch=r(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=k({},C),C.pedantic=k({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=k({},C.normal,{escape:r(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=r(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=k({},C.gfm,{br:r(C.br).replace("{2,}","*").getRegex(),text:r(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function P(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(Ce){var ce="",ie,Q,ee=Ce.length;for(ie=0;ie<ee;ie++)Q=Ce.charCodeAt(ie),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:B.normal,inline:C.normal};this.options.pedantic?(Q.block=B.pedantic,Q.inline=C.pedantic):this.options.gfm&&(Q.block=B.gfm,this.options.breaks?Q.inline=C.breaks:Q.inline=C.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var $e=new Ce(ee);return $e.lex(Q)},Ce.lexInline=function(Q,ee){var $e=new Ce(ee);return $e.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,H,j){return H+"    ".repeat(j.length)});for(var be,Me,le,we;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(be=q.call({lexer:$e},Q,ee))?(Q=Q.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.space(Q)){Q=Q.substring(be.raw.length),be.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(be);continue}if(be=this.tokenizer.code(Q)){Q=Q.substring(be.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(be);continue}if(be=this.tokenizer.fences(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.heading(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.hr(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.blockquote(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.list(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.html(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.def(Q)){Q=Q.substring(be.raw.length),Me=ee[ee.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.lheading(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,H=Q.slice(1),j=void 0;$e.options.extensions.startBlock.forEach(function(J){j=J.call({lexer:this},H),typeof j=="number"&&j>=0&&(q=Math.min(q,j))}),q<1/0&&q>=0&&(le=Q.substring(0,q+1))}(),this.state.top&&(be=this.tokenizer.paragraph(le))){Me=ee[ee.length-1],we&&Me.type==="paragraph"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(be),we=le.length!==Q.length,Q=Q.substring(be.raw.length);continue}if(be=this.tokenizer.text(Q)){Q=Q.substring(be.raw.length),Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ee.push(be);continue}if(Q){var N="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(N);break}else throw new Error(N)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]);var be,Me,le,we=Q,N,q,H;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(N=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)j.includes(N[0].slice(N[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,N.index)+"["+O("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(N=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,N.index)+"["+O("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(N=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,N.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(H=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(be=_.call({lexer:$e},Q,ee))?(Q=Q.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.escape(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.tag(Q)){Q=Q.substring(be.raw.length),Me=ee[ee.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.link(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(be.raw.length),Me=ee[ee.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.emStrong(Q,we,H)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.codespan(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.br(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.del(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.autolink(Q,X)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Q,X))){Q=Q.substring(be.raw.length),ee.push(be);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,ye=Q.slice(1),Te=void 0;$e.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},ye),typeof Te=="number"&&Te>=0&&(_=Math.min(_,Te))}),_<1/0&&_>=0&&(le=Q.substring(0,_+1))}(),be=this.tokenizer.inlineText(le,P)){Q=Q.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(H=be.raw.slice(-1)),q=!0,Me=ee[ee.length-1],Me&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ee.push(be);continue}if(Q){var J="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ee},E(Ce,null,[{key:"rules",get:function(){return{block:B,inline:C}}}]),Ce}(),ge=function(){function Ce(ie){this.options=ie||me.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,$e){var be=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Q,be);Me!=null&&Me!==Q&&($e=!0,Q=Me)}return Q=Q.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+v(be,!0)+'">'+($e?Q:v(Q,!0))+`</code></pre>
`:"<pre><code>"+($e?Q:v(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,$e,be){if(this.options.headerIds){var Me=this.options.headerPrefix+be.slug($e);return"<h"+ee+' id="'+Me+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,$e){var be=ee?"ol":"ul",Me=ee&&$e!==1?' start="'+$e+'"':"";return"<"+be+Me+`>
`+Q+"</"+be+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var $e=ee.header?"th":"td",be=ee.align?"<"+$e+' align="'+ee.align+'">':"<"+$e+">";return be+Q+("</"+$e+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var be='<a href="'+v(Q)+'"';return ee&&(be+=' title="'+ee+'"'),be+=">"+$e+"</a>",be},ce.image=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var be='<img src="'+Q+'" alt="'+$e+'"';return ee&&(be+=' title="'+ee+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(Q){return Q},Ce}(),ve=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,$e){return""+$e},ce.image=function(Q,ee,$e){return""+$e},ce.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var $e=Q,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[Q];do be++,$e=Q+"-"+be;while(this.seen.hasOwnProperty($e))}return ee||(this.seen[Q]=be,this.seen[$e]=0),$e},ce.slug=function(Q,ee){ee===void 0&&(ee={});var $e=this.serialize(Q);return this.getNextSafeSlug($e,ee.dryrun)},Ce}(),de=function(){function Ce(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new ke}Ce.parse=function(Q,ee){var $e=new Ce(ee);return $e.parse(Q)},Ce.parseInline=function(Q,ee){var $e=new Ce(ee);return $e.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var $e="",be,Me,le,we,N,q,H,j,J,_,ye,Te,We,He,Xe,rt,it,et,ot,at=Q.length;for(be=0;be<at;be++){if(_=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(ot=this.options.extensions.renderers[_.type].call({parser:this},_),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){$e+=ot||"";continue}switch(_.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(_.tokens),_.depth,o(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(j="",H="",we=_.header.length,Me=0;Me<we;Me++)H+=this.renderer.tablecell(this.parseInline(_.header[Me].tokens),{header:!0,align:_.align[Me]});for(j+=this.renderer.tablerow(H),J="",we=_.rows.length,Me=0;Me<we;Me++){for(q=_.rows[Me],H="",N=q.length,le=0;le<N;le++)H+=this.renderer.tablecell(this.parseInline(q[le].tokens),{header:!1,align:_.align[le]});J+=this.renderer.tablerow(H)}$e+=this.renderer.table(j,J);continue}case"blockquote":{J=this.parse(_.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(ye=_.ordered,Te=_.start,We=_.loose,we=_.items.length,J="",Me=0;Me<we;Me++)Xe=_.items[Me],rt=Xe.checked,it=Xe.task,He="",Xe.task&&(et=this.renderer.checkbox(rt),We?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=et+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=et+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:et}):He+=et),He+=this.parse(Xe.tokens,We),J+=this.renderer.listitem(He,it,rt);$e+=this.renderer.list(J,ye,Te);continue}case"html":{$e+=this.renderer.html(_.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(J=_.tokens?this.parseInline(_.tokens):_.text;be+1<at&&Q[be+1].type==="text";)_=Q[++be],J+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);$e+=ee?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return $e},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var $e="",be,Me,le,we=Q.length;for(be=0;be<we;be++){if(Me=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(le=this.options.extensions.renderers[Me.type].call({parser:this},Me),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){$e+=le||"";continue}switch(Me.type){case"escape":{$e+=ee.text(Me.text);break}case"html":{$e+=ee.html(Me.text);break}case"link":{$e+=ee.link(Me.href,Me.title,this.parseInline(Me.tokens,ee));break}case"image":{$e+=ee.image(Me.href,Me.title,Me.text);break}case"strong":{$e+=ee.strong(this.parseInline(Me.tokens,ee));break}case"em":{$e+=ee.em(this.parseInline(Me.tokens,ee));break}case"codespan":{$e+=ee.codespan(Me.text);break}case"br":{$e+=ee.br();break}case"del":{$e+=ee.del(this.parseInline(Me.tokens,ee));break}case"text":{$e+=ee.text(Me.text);break}default:{var N='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(N);return}else throw new Error(N)}}}return $e},Ce}();function he(Ce,ce,ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(ie=ce,ce=null),ce=k({},he.defaults,ce||{}),D(ce),ie){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(we){return ie(we)}var $e=function(N){var q;if(!N)try{ce.walkTokens&&he.walkTokens(ee,ce.walkTokens),q=de.parse(ee,ce)}catch(H){N=H}return ce.highlight=Q,N?ie(N):ie(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return $e();var be=0;he.walkTokens(ee,function(we){we.type==="code"&&(be++,setTimeout(function(){Q(we.text,we.lang,function(N,q){if(N)return $e(N);q!=null&&q!==we.text&&(we.text=q,we.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Me(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(we.message+"",!0)+"</pre>";throw we}try{var le=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(he.walkTokens(le,ce.walkTokens)).then(function(){return de.parse(le,ce)}).catch(Me);he.walkTokens(le,ce.walkTokens)}return de.parse(le,ce)}catch(we){Me(we)}}he.options=he.setOptions=function(Ce){return k(he.defaults,Ce),m(he.defaults),he},he.getDefaults=A,he.defaults=me.defaults,he.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),ie=0;ie<Ce;ie++)ce[ie]=arguments[ie];var Q=k.apply(void 0,[{}].concat(ce)),ee=he.defaults.extensions||{renderers:{},childTokens:{}},$e;ce.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var we=ee.renderers?ee.renderers[le.name]:null;we?ee.renderers[le.name]=function(){for(var N=arguments.length,q=new Array(N),H=0;H<N;H++)q[H]=arguments[H];var j=le.renderer.apply(this,q);return j===!1&&(j=we.apply(this,q)),j}:ee.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[le.level]?ee[le.level].unshift(le.tokenizer):ee[le.level]=[le.tokenizer],le.start&&(le.level==="block"?ee.startBlock?ee.startBlock.push(le.start):ee.startBlock=[le.start]:le.level==="inline"&&(ee.startInline?ee.startInline.push(le.start):ee.startInline=[le.start]))}le.childTokens&&(ee.childTokens[le.name]=le.childTokens)})),be.renderer&&function(){var le=he.defaults.renderer||new ge,we=function(H){var j=le[H];le[H]=function(){for(var J=arguments.length,_=new Array(J),ye=0;ye<J;ye++)_[ye]=arguments[ye];var Te=be.renderer[H].apply(le,_);return Te===!1&&(Te=j.apply(le,_)),Te}};for(var N in be.renderer)we(N);Q.renderer=le}(),be.tokenizer&&function(){var le=he.defaults.tokenizer||new M,we=function(H){var j=le[H];le[H]=function(){for(var J=arguments.length,_=new Array(J),ye=0;ye<J;ye++)_[ye]=arguments[ye];var Te=be.tokenizer[H].apply(le,_);return Te===!1&&(Te=j.apply(le,_)),Te}};for(var N in be.tokenizer)we(N);Q.tokenizer=le}(),be.walkTokens){var Me=he.defaults.walkTokens;Q.walkTokens=function(le){var we=[];return we.push(be.walkTokens.call(this,le)),Me&&(we=we.concat(Me.call(this,le))),we}}$e&&(Q.extensions=ee),he.setOptions(Q)})},he.walkTokens=function(Ce,ce){for(var ie=[],Q=function(){var Me=$e.value;switch(ie=ie.concat(ce.call(he,Me)),Me.type){case"table":{for(var le=L(Me.header),we;!(we=le()).done;){var N=we.value;ie=ie.concat(he.walkTokens(N.tokens,ce))}for(var q=L(Me.rows),H;!(H=q()).done;)for(var j=H.value,J=L(j),_;!(_=J()).done;){var ye=_.value;ie=ie.concat(he.walkTokens(ye.tokens,ce))}break}case"list":{ie=ie.concat(he.walkTokens(Me.items,ce));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[Me.type]?he.defaults.extensions.childTokens[Me.type].forEach(function(Te){ie=ie.concat(he.walkTokens(Me[Te],ce))}):Me.tokens&&(ie=ie.concat(he.walkTokens(Me.tokens,ce)))}},ee=L(Ce),$e;!($e=ee()).done;)Q();return ie},he.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=k({},he.defaults,ce||{}),D(ce);try{var ie=ae.lexInline(Ce,ce);return ce.walkTokens&&he.walkTokens(ie,ce.walkTokens),de.parseInline(ie,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Q.message+"",!0)+"</pre>";throw Q}},he.Parser=de,he.parser=de.parse,he.Renderer=ge,he.TextRenderer=ve,he.Lexer=ae,he.lexer=ae.lex,he.Tokenizer=M,he.Slugger=ke,he.parse=he;var te=he.options,Se=he.setOptions,oe=he.use,Y=he.walkTokens,V=he.parseInline,ne=he,Ie=de.parse,Le=ae.lex;me.Lexer=ae,me.Parser=de,me.Renderer=ge,me.Slugger=ke,me.TextRenderer=ve,me.Tokenizer=M,me.getDefaults=A,me.lexer=Le,me.marked=he,me.options=te,me.parse=ne,me.parseInline=V,me.parser=Ie,me.setOptions=Se,me.use=oe,me.walkTokens=Y,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0;function E(n){const o=L(n);if(o&&o.length>0)return new Uint32Array(o)}e.$Mj=E;let T=0;const I=new Uint32Array(10);function L(n){if(T=0,A(n,S,4352),T>0||(A(n,l,4449),T>0)||(A(n,$,4520),T>0)||(A(n,v,12593),T))return I.subarray(0,T);if(n>=44032&&n<=55203){const o=n-44032,t=o%588,r=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(r<S.length?A(r,S,0):4352+r-12593<v.length&&A(4352+r,v,12593),a<l.length?A(a,l,0):4449+a-12593<v.length&&A(4449+a-12593,v,12593),c>=0&&(c<$.length?A(c,$,0):4520+c-12593<v.length&&A(4520+c-12593,v,12593)),T>0)return I.subarray(0,T)}}function A(n,o,t){n>=t&&n<t+o.length&&m(o[n-t])}function m(n){n!==0&&(I[T++]=n&255,n>>8&&(I[T++]=n>>8&255),n>>16&&(I[T++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(w||(w={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.rot=e.$1l=void 0;function E(m,g,w){return Math.min(Math.max(m,g),w)}e.$1l=E;function T(m,g){return(g+m%g)%g}e.rot=T;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$3l=I;class L{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$4l=L;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$5l=A}),function(){function me(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function A(g){L.push(g,Date.now())}function m(){const g=[];for(let w=0;w<L.length;w+=2)g.push({name:L[w],startTime:L[w+1]});return g}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(I+A.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:me)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function E(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return me[T].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=me,E.c=e,E.d=function(T,I,L){E.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:L})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,I){if(1&I&&(T=E(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(E.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var A in T)E.d(L,A,function(m){return T[m]}.bind(null,A));return L},E.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(I,"a",I),I},E.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},E.p="",E(E.s=0)}([function(me,e,E){(function(T){var I;e=me.exports=oe,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],w=0,R=w++;g[R]="0|[1-9]\\d*";var S=w++;g[S]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;g[$]="("+g[R]+")\\.("+g[R]+")\\.("+g[R]+")";var v=w++;g[v]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var n=w++;g[n]="(?:"+g[R]+"|"+g[l]+")";var o=w++;g[o]="(?:"+g[S]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[n]+"(?:\\."+g[n]+")*))";var r=w++;g[r]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=w++;g[a]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=w++,i="v?"+g[$]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[v]+g[r]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var b=w++;g[b]=g[S]+"|x|X|\\*";var f=w++;g[f]=g[R]+"|x|X|\\*";var k=w++;g[k]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var F=w++;g[F]="[v=\\s]*("+g[b]+")(?:\\.("+g[b]+")(?:\\.("+g[b]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var p=w++;g[p]="^"+g[d]+"\\s*"+g[k]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[F]+"$";var D=w++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;g[O]="(?:~>?)";var K=w++;g[K]="(\\s*)"+g[O]+"\\s+",m[K]=new RegExp(g[K],"g");var U=w++;g[U]="^"+g[O]+g[k]+"$";var M=w++;g[M]="^"+g[O]+g[F]+"$";var B=w++;g[B]="(?:\\^)";var C=w++;g[C]="(\\s*)"+g[B]+"\\s+",m[C]=new RegExp(g[C],"g");var P=w++;g[P]="^"+g[B]+g[k]+"$";var X=w++;g[X]="^"+g[B]+g[F]+"$";var ae=w++;g[ae]="^"+g[d]+"\\s*("+s+")$|^$";var ge=w++;g[ge]="^"+g[d]+"\\s*("+i+")$|^$";var ve=w++;g[ve]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[k]+")",m[ve]=new RegExp(g[ve],"g");var ke=w++;g[ke]="^\\s*("+g[k]+")\\s+-\\s+("+g[k]+")\\s*$";var de=w++;g[de]="^\\s*("+g[F]+")\\s+-\\s+("+g[F]+")\\s*$";var he=w++;g[he]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,g[te]),m[te]||(m[te]=new RegExp(g[te]));function Se(j,J){if(j instanceof oe)return j;if(typeof j!="string"||j.length>L||!(J?m[u]:m[h]).test(j))return null;try{return new oe(j,J)}catch{return null}}function oe(j,J){if(j instanceof oe){if(j.loose===J)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(j,J);I("SemVer",j,J),this.loose=J;var _=j.trim().match(J?m[u]:m[h]);if(!_)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Te=+ye;if(Te>=0&&Te<A)return Te}return ye}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=Se,e.valid=function(j,J){var _=Se(j,J);return _?_.version:null},e.clean=function(j,J){var _=Se(j.trim().replace(/^[=v]+/,""),J);return _?_.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof oe||(j=new oe(j,this.loose)),this.compareMain(j)||this.comparePre(j)},oe.prototype.compareMain=function(j){return j instanceof oe||(j=new oe(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},oe.prototype.comparePre=function(j){if(j instanceof oe||(j=new oe(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var J=0;do{var _=this.prerelease[J],ye=j.prerelease[J];if(I("prerelease compare",J,_,ye),_===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(_===void 0)return-1;if(_!==ye)return V(_,ye)}while(++J)},oe.prototype.inc=function(j,J){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,J,_,ye){typeof _=="string"&&(ye=_,_=void 0);try{return new oe(j,_).inc(J,ye).version}catch{return null}},e.diff=function(j,J){if(Ce(j,J))return null;var _=Se(j),ye=Se(J);if(_.prerelease.length||ye.prerelease.length){for(var Te in _)if((Te==="major"||Te==="minor"||Te==="patch")&&_[Te]!==ye[Te])return"pre"+Te;return"prerelease"}for(var Te in _)if((Te==="major"||Te==="minor"||Te==="patch")&&_[Te]!==ye[Te])return Te},e.compareIdentifiers=V;var Y=/^[0-9]+$/;function V(j,J){var _=Y.test(j),ye=Y.test(J);return _&&ye&&(j=+j,J=+J),_&&!ye?-1:ye&&!_?1:j<J?-1:j>J?1:0}function ne(j,J,_){return new oe(j,_).compare(new oe(J,_))}function Ie(j,J,_){return ne(j,J,_)>0}function Le(j,J,_){return ne(j,J,_)<0}function Ce(j,J,_){return ne(j,J,_)===0}function ce(j,J,_){return ne(j,J,_)!==0}function ie(j,J,_){return ne(j,J,_)>=0}function Q(j,J,_){return ne(j,J,_)<=0}function ee(j,J,_,ye){var Te;switch(J){case"===":typeof j=="object"&&(j=j.version),typeof _=="object"&&(_=_.version),Te=j===_;break;case"!==":typeof j=="object"&&(j=j.version),typeof _=="object"&&(_=_.version),Te=j!==_;break;case"":case"=":case"==":Te=Ce(j,_,ye);break;case"!=":Te=ce(j,_,ye);break;case">":Te=Ie(j,_,ye);break;case">=":Te=ie(j,_,ye);break;case"<":Te=Le(j,_,ye);break;case"<=":Te=Q(j,_,ye);break;default:throw new TypeError("Invalid operator: "+J)}return Te}function $e(j,J){if(j instanceof $e){if(j.loose===J)return j;j=j.value}if(!(this instanceof $e))return new $e(j,J);I("comparator",j,J),this.loose=J,this.parse(j),this.semver===be?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,J){return V(J,j)},e.major=function(j,J){return new oe(j,J).major},e.minor=function(j,J){return new oe(j,J).minor},e.patch=function(j,J){return new oe(j,J).patch},e.compare=ne,e.compareLoose=function(j,J){return ne(j,J,!0)},e.rcompare=function(j,J,_){return ne(J,j,_)},e.sort=function(j,J){return j.sort(function(_,ye){return e.compare(_,ye,J)})},e.rsort=function(j,J){return j.sort(function(_,ye){return e.rcompare(_,ye,J)})},e.gt=Ie,e.lt=Le,e.eq=Ce,e.neq=ce,e.gte=ie,e.lte=Q,e.cmp=ee,e.Comparator=$e;var be={};function Me(j,J){if(j instanceof Me)return j.loose===J?j:new Me(j.raw,J);if(j instanceof $e)return new Me(j.value,J);if(!(this instanceof Me))return new Me(j,J);if(this.loose=J,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function le(j){return!j||j.toLowerCase()==="x"||j==="*"}function we(j,J,_,ye,Te,We,He,Xe,rt,it,et,ot,at){return((J=le(_)?"":le(ye)?">="+_+".0.0":le(Te)?">="+_+"."+ye+".0":">="+J)+" "+(Xe=le(rt)?"":le(it)?"<"+(+rt+1)+".0.0":le(et)?"<"+rt+"."+(+it+1)+".0":ot?"<="+rt+"."+it+"."+et+"-"+ot:"<="+Xe)).trim()}function N(j,J){for(var _=0;_<j.length;_++)if(!j[_].test(J))return!1;if(J.prerelease.length){for(_=0;_<j.length;_++)if(I(j[_].semver),j[_].semver!==be&&j[_].semver.prerelease.length>0){var ye=j[_].semver;if(ye.major===J.major&&ye.minor===J.minor&&ye.patch===J.patch)return!0}return!1}return!0}function q(j,J,_){try{J=new Me(J,_)}catch{return!1}return J.test(j)}function H(j,J,_,ye){var Te,We,He,Xe,rt;switch(j=new oe(j,ye),J=new Me(J,ye),_){case">":Te=Ie,We=Q,He=Le,Xe=">",rt=">=";break;case"<":Te=Le,We=ie,He=Ie,Xe="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(j,J,ye))return!1;for(var it=0;it<J.set.length;++it){var et=J.set[it],ot=null,at=null;if(et.forEach(function(Be){Be.semver===be&&(Be=new $e(">=0.0.0")),ot=ot||Be,at=at||Be,Te(Be.semver,ot.semver,ye)?ot=Be:He(Be.semver,at.semver,ye)&&(at=Be)}),ot.operator===Xe||ot.operator===rt||(!at.operator||at.operator===Xe)&&We(j,at.semver)||at.operator===rt&&He(j,at.semver))return!1}return!0}$e.prototype.parse=function(j){var J=this.loose?m[ae]:m[ge],_=j.match(J);if(!_)throw new TypeError("Invalid comparator: "+j);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new oe(_[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===be||(typeof j=="string"&&(j=new oe(j,this.loose)),ee(j,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(j,J){if(!(j instanceof $e))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Me(j.value,J),q(this.value,_,J);if(j.operator==="")return _=new Me(this.value,J),q(j.semver,_,J);var ye=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),We=this.semver.version===j.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Xe=ee(this.semver,"<",j.semver,J)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),rt=ee(this.semver,">",j.semver,J)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ye||Te||We&&He||Xe||rt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(j){var J=this.loose;j=j.trim(),I("range",j,J);var _=J?m[de]:m[ke];j=j.replace(_,we),I("hyphen replace",j),j=j.replace(m[ve],"$1$2$3"),I("comparator trim",j,m[ve]),j=(j=(j=j.replace(m[K],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ye=J?m[ae]:m[ge],Te=j.split(" ").map(function(We){return function(He,Xe){return I("comp",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){I("caret",ot,at);var Be=at?m[X]:m[P];return ot.replace(Be,function(pt,Z,x,pe,Ue){var Qe;return I("caret",ot,pt,Z,x,pe,Ue),le(Z)?Qe="":le(x)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le(pe)?Qe=Z==="0"?">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+".0 <"+(+Z+1)+".0.0":Ue?(I("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Qe=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+Ue+" <"+(+Z+1)+".0.0"):(I("no pr"),Qe=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+" <"+(+Z+1)+".0.0"),I("caret return",Qe),Qe})}(et,it)}).join(" ")}(He,Xe),I("caret",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){var Be=at?m[M]:m[U];return ot.replace(Be,function(pt,Z,x,pe,Ue){var Qe;return I("tilde",ot,pt,Z,x,pe,Ue),le(Z)?Qe="":le(x)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le(pe)?Qe=">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":Ue?(I("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Qe=">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+(+x+1)+".0"):Qe=">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0",I("tilde return",Qe),Qe})}(et,it)}).join(" ")}(He,Xe),I("tildes",He),He=function(rt,it){return I("replaceXRanges",rt,it),rt.split(/\s+/).map(function(et){return function(ot,at){ot=ot.trim();var Be=at?m[y]:m[p];return ot.replace(Be,function(pt,Z,x,pe,Ue,Qe){I("xRange",ot,pt,Z,x,pe,Ue,Qe);var tt=le(x),nt=tt||le(pe),Ne=nt||le(Ue);return Z==="="&&Ne&&(Z=""),tt?pt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(nt&&(pe=0),Ne&&(Ue=0),Z===">"?(Z=">=",nt?(x=+x+1,pe=0,Ue=0):Ne&&(pe=+pe+1,Ue=0)):Z==="<="&&(Z="<",nt?x=+x+1:pe=+pe+1),pt=Z+x+"."+pe+"."+Ue):nt?pt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(pt=">="+x+"."+pe+".0 <"+x+"."+(+pe+1)+".0"),I("xRange return",pt),pt})}(et,it)}).join(" ")}(He,Xe),I("xrange",He),He=function(rt,it){return I("replaceStars",rt,it),rt.trim().replace(m[he],"")}(He,Xe),I("stars",He),He}(We,J)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(ye)})),Te=Te.map(function(We){return new $e(We,J)})},Me.prototype.intersects=function(j,J){if(!(j instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ye){return j.set.some(function(Te){return Te.every(function(We){return ye.intersects(We,J)})})})})},e.toComparators=function(j,J){return new Me(j,J).set.map(function(_){return _.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new oe(j,this.loose));for(var J=0;J<this.set.length;J++)if(N(this.set[J],j))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(j,J,_){var ye=null,Te=null;try{var We=new Me(J,_)}catch{return null}return j.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==-1||(Te=new oe(ye=He,_)))}),ye},e.minSatisfying=function(j,J,_){var ye=null,Te=null;try{var We=new Me(J,_)}catch{return null}return j.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==1||(Te=new oe(ye=He,_)))}),ye},e.validRange=function(j,J){try{return new Me(j,J).range||"*"}catch{return null}},e.ltr=function(j,J,_){return H(j,J,"<",_)},e.gtr=function(j,J,_){return H(j,J,">",_)},e.outside=H,e.prerelease=function(j,J){var _=Se(j,J);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(j,J,_){return j=new Me(j,_),J=new Me(J,_),j.intersects(J)},e.coerce=function(j){if(j instanceof oe)return j;if(typeof j!="string")return null;var J=j.match(m[D]);return J==null?null:Se((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,E(1))},function(me,e){var E,T,I=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(o){if(E===setTimeout)return setTimeout(o,0);if((E===L||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:L}catch{E=L}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var g,w=[],R=!1,S=-1;function l(){R&&g&&(R=!1,g.length?w=g.concat(w):S=-1,w.length&&$())}function $(){if(!R){var o=m(l);R=!0;for(var t=w.length;t;){for(g=w,w=[];++S<t;)g&&g[S].run();S=-1,t=w.length}g=null,R=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(o)}}function v(o,t){this.fun=o,this.array=t}function n(){}I.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)t[r-1]=arguments[r];w.push(new v(o,t)),w.length!==1||R||m($)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[123],Ae([1,0,11,6]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=I;function L(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=L;function A(c){const h=c;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=A;function m(c,h){return new g(c,h)}e.$7d=m;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$8d=w;function R(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=R;function S(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=S;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$$d=l;function $(c,h){return new Promise((i,s)=>{const u=new T.$Rc,d=[],b=F=>{if(d.push(F),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=F=>(u.dispose(),s(F)),k=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Qc)(()=>c.removeListener("end",k))),c.on("end",k),u.add((0,T.$Qc)(()=>c.removeListener("data",b))),c.on("data",b)})}e.$_d=$;function v(c,h){const i=m(h);return i.end(c),i}e.$ae=v;function n(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$be=n;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=o;function t(c,h,i){const s=m(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$de=t;function r(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ee=r;function a(c,h,i){let s=!1;const u=m(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$fe=a}),define(Pe[24],Ae([1,0,39,123]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",L=new E.$V(()=>new Uint8Array(256));let A,m;class g{static alloc(D){return I?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,O){return!(O?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(D)):(A||(A=new TextEncoder),new g(A.encode(D)))}static fromByteArray(D){const O=g.alloc(D.length);for(let K=0,U=D.length;K<U;K++)O.buffer[K]=D[K];return O}static concat(D,O){if(typeof O>"u"){O=0;for(let M=0,B=D.length;M<B;M++)O+=D[M].byteLength}const K=g.alloc(O);let U=0;for(let M=0,B=D.length;M<B;M++){const C=D[M];K.set(C,U),U+=C.byteLength}return K}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(D,O){return new g(this.buffer.subarray(D,O))}set(D,O){if(D instanceof g)this.buffer.set(D.buffer,O);else if(D instanceof Uint8Array)this.buffer.set(D,O);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),O);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,O){$(this.buffer,D,O)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,O){n(this.buffer,D,O)}readUInt8(D){return o(this.buffer,D)}writeUInt8(D,O){t(this.buffer,D,O)}indexOf(D,O=0){return w(this.buffer,D instanceof g?D.buffer:D,O)}}e.$ge=g;function w(y,D,O=0){const K=D.byteLength,U=y.byteLength;if(K===0)return 0;if(K===1)return y.indexOf(D[0]);if(K>U-O)return-1;const M=L.value;M.fill(D.length);for(let X=0;X<D.length;X++)M[D[X]]=D.length-X-1;let B=O+D.length-1,C=B,P=-1;for(;B<U;)if(y[B]===D[C]){if(C===0){P=B;break}B--,C--}else B+=Math.max(D.length-C,M[y[B]]),C=D.length-1;return P}e.$he=w;function R(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$ie=R;function S(y,D,O){y[O+0]=D&255,D=D>>>8,y[O+1]=D&255}e.$je=S;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$ke=l;function $(y,D,O){y[O+3]=D,D=D>>>8,y[O+2]=D,D=D>>>8,y[O+1]=D,D=D>>>8,y[O]=D}e.$le=$;function v(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$me=v;function n(y,D,O){y[O+0]=D&255,D=D>>>8,y[O+1]=D&255,D=D>>>8,y[O+2]=D&255,D=D>>>8,y[O+3]=D&255}e.$ne=n;function o(y,D){return y[D]}e.$oe=o;function t(y,D,O){y[O]=D}e.$pe=t;function r(y){return T.$8d(y,D=>g.concat(D))}e.$qe=r;function a(y){return T.$ce(y)}e.$re=a;function c(y){return T.$0d(y,D=>g.concat(D))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return T.$ae(y,D=>g.concat(D))}e.$ue=i;function s(y){return T.$de(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$ve=s;function u(y){return T.$7d(D=>g.concat(D),y)}e.$we=u;function d(y,D){return T.$ee(y,D,O=>g.concat(O))}e.$xe=d;function b(y,D){return T.$fe(y,D,O=>g.concat(O))}e.$ye=b;function f(y){let D=0,O=0,K=0;const U=new Uint8Array(Math.floor(y.length/4*3)),M=C=>{switch(O){case 3:U[K++]=D|C,O=0;break;case 2:U[K++]=D|C>>>2,D=C<<6,O=3;break;case 1:U[K++]=D|C>>>4,D=C<<4,O=2;break;default:D=C<<2,O=1}};for(let C=0;C<y.length;C++){const P=y.charCodeAt(C);if(P>=65&&P<=90)M(P-65);else if(P>=97&&P<=122)M(P-97+26);else if(P>=48&&P<=57)M(P-48+52);else if(P===43||P===45)M(62);else if(P===47||P===95)M(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const B=K;for(;O>0;)M(0);return g.wrap(U).slice(0,B)}e.$ze=f;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:y},D=!0,O=!1){const K=O?F:k;let U="";const M=y.byteLength%3;let B=0;for(;B<y.byteLength-M;B+=3){const C=y[B+0],P=y[B+1],X=y[B+2];U+=K[C>>>2],U+=K[(C<<4|P>>>4)&63],U+=K[(P<<2|X>>>6)&63],U+=K[X&63]}if(M===1){const C=y[B+0];U+=K[C>>>2],U+=K[C<<4&63],D&&(U+="==")}else if(M===2){const C=y[B+0],P=y[B+1];U+=K[C>>>2],U+=K[(C<<4|P>>>4)&63],U+=K[P<<2&63],D&&(U+="=")}return U}e.$Ae=p}),define(Pe[124],Ae([1,0,28,121,12]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.FuzzyScore=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.or=void 0;function L(...le){return function(we,N){for(let q=0,H=le.length;q<H;q++){const j=le[q](we,N);if(j)return j}return null}}e.or=L,e.$Oj=A.bind(void 0,!1),e.$Pj=A.bind(void 0,!0);function A(le,we,N){if(!N||N.length<we.length)return null;let q;return le?q=I.$8e(N,we):q=N.indexOf(we)===0,q?we.length>0?[{start:0,end:we.length}]:[]:null}function m(le,we){const N=we.toLowerCase().indexOf(le.toLowerCase());return N===-1?null:[{start:N,end:N+le.length}]}e.$Qj=m;function g(le,we){return w(le.toLowerCase(),we.toLowerCase(),0,0)}e.$Rj=g;function w(le,we,N,q){if(N===le.length)return[];if(q===we.length)return null;if(le[N]===we[q]){let H=null;return(H=w(le,we,N+1,q+1))?c({start:q,end:q+1},H):null}return w(le,we,N,q+1)}function R(le){return 97<=le&&le<=122}function S(le){return 65<=le&&le<=90}e.$Sj=S;function l(le){return 48<=le&&le<=57}function $(le){return le===32||le===9||le===10||le===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>v.add(le.charCodeAt(0)));function n(le){return $(le)||v.has(le)}function o(le,we){return le===we||n(le)&&n(we)}const t=new Map;function r(le){if(t.has(le))return t.get(le);let we;const N=(0,T.$Mj)(le);return N&&(we=N),t.set(le,we),we}function a(le){return R(le)||S(le)||l(le)}function c(le,we){return we.length===0?we=[le]:le.end===we[0].start?we[0].start=le.start:we.unshift(le),we}function h(le,we){for(let N=we;N<le.length;N++){const q=le.charCodeAt(N);if(S(q)||l(q)||N>0&&!a(le.charCodeAt(N-1)))return N}return le.length}function i(le,we,N,q){if(N===le.length)return[];if(q===we.length)return null;if(le[N]!==we[q].toLowerCase())return null;{let H=null,j=q+1;for(H=i(le,we,N+1,q+1);!H&&(j=h(we,j))<we.length;)H=i(le,we,N+1,j),j++;return H===null?null:c({start:q,end:q+1},H)}}function s(le){let we=0,N=0,q=0,H=0,j=0;for(let We=0;We<le.length;We++)j=le.charCodeAt(We),S(j)&&we++,R(j)&&N++,a(j)&&q++,l(j)&&H++;const J=we/le.length,_=N/le.length,ye=q/le.length,Te=H/le.length;return{upperPercent:J,lowerPercent:_,alphaPercent:ye,numericPercent:Te}}function u(le){const{upperPercent:we,lowerPercent:N}=le;return N===0&&we>.6}function d(le){const{upperPercent:we,lowerPercent:N,alphaPercent:q,numericPercent:H}=le;return N>.2&&we<.8&&q>.6&&H<.2}function b(le){let we=0,N=0,q=0,H=0;for(let j=0;j<le.length;j++)q=le.charCodeAt(j),S(q)&&we++,R(q)&&N++,$(q)&&H++;return(we===0||N===0)&&H===0?le.length<=30:we<=5}function f(le,we){if(!we||(we=we.trim(),we.length===0)||!b(le)||we.length>60)return null;const N=s(we);if(!d(N)){if(!u(N))return null;we=we.toLowerCase()}let q=null,H=0;for(le=le.toLowerCase();H<we.length&&(q=i(le,we,0,H))===null;)H=h(we,H+1);return q}e.$Tj=f;function k(le,we,N=!1){if(!we||we.length===0)return null;let q=null,H=0;for(le=le.toLowerCase(),we=we.toLowerCase();H<we.length&&(q=F(le,we,0,H,N),q===null);)H=p(we,H+1);return q}e.$Uj=k;function F(le,we,N,q,H){let j=0;if(N===le.length)return[];if(q===we.length)return null;if(!o(le.charCodeAt(N),we.charCodeAt(q))){const ye=r(le.charCodeAt(N));if(!ye)return null;for(let Te=0;Te<ye.length;Te++)if(!o(ye[Te],we.charCodeAt(q+Te)))return null;j+=ye.length-1}let J=null,_=q+j+1;if(J=F(le,we,N+1,_,H),!H)for(;!J&&(_=p(we,_))<we.length;)J=F(le,we,N+1,_,H),_++;if(!J)return null;if(le.charCodeAt(N)!==we.charCodeAt(q)){const ye=r(le.charCodeAt(N));if(!ye)return J;for(let Te=0;Te<ye.length;Te++)if(ye[Te]!==we.charCodeAt(q+Te))return J}return c({start:q,end:q+j+1},J)}function p(le,we){for(let N=we;N<le.length;N++)if(n(le.charCodeAt(N))||N>0&&n(le.charCodeAt(N-1)))return N;return le.length}const y=L(e.$Pj,f,m),D=L(e.$Pj,f,g),O=new E.$Dc(1e4);function K(le,we,N=!1){if(typeof le!="string"||typeof we!="string")return null;let q=O.get(le);q||(q=new RegExp(I.$Qe(le),"i"),O.set(le,q));const H=q.exec(we);return H?[{start:H.index,end:H.index+H[0].length}]:N?D(le,we):y(le,we)}e.$Vj=K;function U(le,we){const N=ce(le,le.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?B(N):null}e.$Wj=U;function M(le,we,N,q,H,j){const J=Math.min(13,le.length);for(;N<J;N++){const _=ce(le,we,N,q,H,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return _}return[0,j]}e.$Xj=M;function B(le){if(typeof le>"u")return[];const we=[],N=le[1];for(let q=le.length-1;q>1;q--){const H=le[q]+N,j=we[we.length-1];j&&j.end===H?j.end=H+1:we.push({start:H,end:H+1})}return we}e.$Yj=B;const C=128;function P(){const le=[],we=[];for(let N=0;N<=C;N++)we[N]=0;for(let N=0;N<=C;N++)le.push(we.slice(0));return le}function X(le){const we=[];for(let N=0;N<=le;N++)we[N]=0;return we}const ae=X(2*C),ge=X(2*C),ve=P(),ke=P(),de=P(),he=!1;function te(le,we,N,q,H){function j(_,ye,Te=" "){for(;_.length<ye;)_=Te+_;return _}let J=` |   |${q.split("").map(_=>j(_,3)).join("|")}
`;for(let _=0;_<=N;_++)_===0?J+=" |":J+=`${we[_-1]}|`,J+=le[_].slice(0,H+1).map(ye=>j(ye.toString(),3)).join("|")+`
`;return J}function Se(le,we,N,q){le=le.substr(we),N=N.substr(q),console.log(te(ke,le,le.length,N,N.length)),console.log(te(de,le,le.length,N,N.length)),console.log(te(ve,le,le.length,N,N.length))}function oe(le,we){if(we<0||we>=le.length)return!1;const N=le.codePointAt(we);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$nf(N)}}function Y(le,we){if(we<0||we>=le.length)return!1;switch(le.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function V(le,we,N){return we[le]!==N[le]}function ne(le,we,N,q,H,j,J=!1){for(;we<N&&H<j;)le[we]===q[H]&&(J&&(ae[we]=H),we+=1),H+=1;return we===N}e.$Zj=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(le){le.Default=[-100,0];function we(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}le.isDefault=we})(Le||(e.FuzzyScore=Le={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,N){this.firstMatchCanBeWeak=we,this.boostFullMatch=N}}e.$1j=Ce;function ce(le,we,N,q,H,j,J=Ce.default){const _=le.length>C?C:le.length,ye=q.length>C?C:q.length;if(N>=_||j>=ye||_-N>ye-j||!ne(we,N,_,H,j,ye,!0))return;ie(_,ye,N,j,we,H);let Te=1,We=1,He=N,Xe=j;const rt=[!1];for(Te=1,He=N;He<_;Te++,He++){const Be=ae[He],pt=ge[He],Z=He+1<_?ge[He+1]:ye;for(We=Be-j+1,Xe=Be;Xe<Z;We++,Xe++){let x=Number.MIN_SAFE_INTEGER,pe=!1;Xe<=pt&&(x=Q(le,we,He,N,q,H,Xe,ye,j,ve[Te-1][We-1]===0,rt));let Ue=0;x!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ue=x+ke[Te-1][We-1]);const Qe=Xe>Be,tt=Qe?ke[Te][We-1]+(ve[Te][We-1]>0?-5:0):0,nt=Xe>Be+1&&ve[Te][We-1]>0,Ne=nt?ke[Te][We-2]+(ve[Te][We-2]>0?-5:0):0;if(nt&&(!Qe||Ne>=tt)&&(!pe||Ne>=Ue))ke[Te][We]=Ne,de[Te][We]=3,ve[Te][We]=0;else if(Qe&&(!pe||tt>=Ue))ke[Te][We]=tt,de[Te][We]=2,ve[Te][We]=0;else if(pe)ke[Te][We]=Ue,de[Te][We]=1,ve[Te][We]=ve[Te-1][We-1]+1;else throw new Error("not possible")}}if(he&&Se(le,N,q,j),!rt[0]&&!J.firstMatchCanBeWeak)return;Te--,We--;const it=[ke[Te][We],j];let et=0,ot=0;for(;Te>=1;){let Be=We;do{const pt=de[Te][Be];if(pt===3)Be=Be-2;else if(pt===2)Be=Be-1;else break}while(Be>=1);et>1&&we[N+Te-1]===H[j+We-1]&&!V(Be+j-1,q,H)&&et+1>ve[Te][Be]&&(Be=We),Be===We?et++:et=1,ot||(ot=Be),Te--,We=Be-1,it.push(We)}ye===_&&J.boostFullMatch&&(it[0]+=2);const at=ot-_;return it[0]-=at,it}e.$2j=ce;function ie(le,we,N,q,H,j){let J=le-1,_=we-1;for(;J>=N&&_>=q;)H[J]===j[_]&&(ge[J]=_,J--),_--}function Q(le,we,N,q,H,j,J,_,ye,Te,We){if(we[N]!==j[J])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return J===N-q?He=le[N]===H[J]?7:5:V(J,H,j)&&(J===0||!V(J-1,H,j))?(He=le[N]===H[J]?7:5,Xe=!0):oe(j,J)&&(J===0||!oe(j,J-1))?He=5:(oe(j,J-1)||Y(j,J-1))&&(He=5,Xe=!0),He>1&&N===q&&(We[0]=!0),Xe||(Xe=V(J,H,j)||oe(j,J-1)||Y(j,J-1)),N===q?J>ye&&(He-=Xe?3:5):Te?He+=Xe?2:0:He+=Xe?0:1,J+1===_&&(He-=Xe?3:5),He}function ee(le,we,N,q,H,j,J){return be(le,we,N,q,H,j,!0,J)}e.$3j=ee;function $e(le,we,N,q,H,j,J){return be(le,we,N,q,H,j,!1,J)}e.$4j=$e;function be(le,we,N,q,H,j,J,_){let ye=ce(le,we,N,q,H,j,_);if(ye&&!J)return ye;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=N+1;We<Te;We++){const He=Me(le,We);if(He){const Xe=ce(He,He.toLowerCase(),N,q,H,j,_);Xe&&(Xe[0]-=3,(!ye||Xe[0]>ye[0])&&(ye=Xe))}}}return ye}function Me(le,we){if(we+1>=le.length)return;const N=le[we],q=le[we+1];if(N!==q)return le.slice(0,we)+q+N+le.slice(we+2)}}),define(Pe[31],Ae([1,0,12]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const L="error",A="warning",m="warn",g="info",w="ignore";function R(l){return l?E.$7e(L,l)?I.Error:E.$7e(A,l)||E.$7e(m,l)?I.Warning:E.$7e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function S(l){switch(l){case I.Error:return L;case I.Warning:return A;case I.Info:return g;default:return w}}I.toString=S}(T||(T={})),e.default=T}),define(Pe[125],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class I{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const v=$.charCodeAt(0),n=this.b.charCodeAt(this.c);return v-n}value(){return this.b[this.c]}}e.$3h=I;class L{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,T.$1e)($,this.b,0,$.length,this.c,this.d):(0,T.$3e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=L;class A{constructor($=!0,v=!0){this.f=$,this.g=v}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let v=$.length-1;v>=0;v--,this.c--){const n=this.b.charCodeAt(v);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,T.$1e)($,this.b,0,$.length,this.d,this.e):(0,T.$3e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=A;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor($,v){this.f=$,this.g=v,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,T.$2e)($,this.c.scheme);if(this.d[this.e]===2)return(0,T.$2e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,T.$Ze)($,this.c.query);if(this.d[this.e]===5)return(0,T.$Ze)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class S{static forUris($=()=>!1,v=()=>!1){return new S(new g($,v))}static forPaths($=!1){return new S(new A(void 0,!$))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new L)}constructor($){this.b=$}clear(){this.c=void 0}fill($,v){if(v){const n=v.slice(0);(0,E.$Xb)(n);for(const o of n)this.set(o,$)}else{const n=$.slice(0);(0,E.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set($,v){const n=this.b.reset($);let o;this.c||(this.c=new w,this.c.segment=n.value());const t=[];for(o=this.c;;){const a=n.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=n.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=n.value()),t.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new w,o.mid.segment=n.value()),t.push([0,o]),o=o.mid;else break}const r=o.value;o.value=v,o.key=$;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return r}get($){return this.d($)?.value}d($){const v=this.b.reset($);let n=this.c;for(;n;){const o=v.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(v.hasNext())v.next(),n=n.mid;else break}return n}has($){const v=this.d($);return!(v?.value===void 0&&v?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,v){const n=this.b.reset($),o=[];let t=this.c;for(;t;){const r=n.cmp(t.segment);if(r>0)o.push([-1,t]),t=t.left;else if(r<0)o.push([1,t]),t=t.right;else if(n.hasNext())n.next(),o.push([0,t]),t=t.mid;else break}if(t){if(v?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const r=this.f(t.right);if(r.key){const{key:a,value:c,segment:h}=r;this.e(r.key,!1),t.key=a,t.value=c,t.segment=h}}else{const r=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=r;break;case 0:c.mid=r;break;case 1:c.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const a=o[r][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[r][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[r][1]=a.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const v=this.b.reset($);let n=this.c,o;for(;n;){const t=v.cmp(n.segment);if(t>0)n=n.left;else if(t<0)n=n.right;else if(v.hasNext())v.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr($){return this.g($,!1)}g($,v){const n=this.b.reset($);let o=this.c;for(;o;){const t=n.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):v?o.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[v,n]of this)$(n,v)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const v=[];return this.j($,v),v[Symbol.iterator]()}j($,v){$&&($.left&&this.j($.left,v),$.value&&v.push([$.key,$.value]),$.mid&&this.j($.mid,v),$.right&&this.j($.right,v))}_isBalanced(){const $=v=>{if(!v)return!0;const n=v.balanceFactor();return n<-1||n>1?!1:$(v.left)&&$(v.right)};return $(this.c)}}e.$7h=S}),define(Pe[45],Ae([1,0,90]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$8j=e.ThemeColor=void 0;var T;(function(A){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}A.isThemeColor=m})(T||(e.ThemeColor=T={}));function I(A){return{id:A}}e.$8j=I;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function g(r){const a=m.exec(r.id);if(!a)return g(E.$7j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}A.asClassNameArray=g;function w(r){return g(r).join(" ")}A.asClassName=w;function R(r){return"."+g(r).join(".")}A.asCSSSelector=R;function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=S;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function $(r){const a=l.exec(r);if(!a)return;const[,c]=a;return{id:c}}A.fromString=$;function v(r){return{id:r}}A.fromId=v;function n(r,a){let c=r.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}A.modify=n;function o(r){const a=r.id.lastIndexOf("~");if(a!==-1)return r.id.substring(a+1)}A.getModifier=o;function t(r,a){return r.id===a.id&&r.color?.id===a.color?.id}A.isEqual=t})(L||(e.ThemeIcon=L={}))}),define(Pe[126],Ae([1,0,124,12,45]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=void 0;const L="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function g(t){return t.replace(m,(r,a)=>a?r:`\\${r}`)}e.$9j=g;const w=new RegExp(`\\\\${A.source}`,"g");function R(t){return t.replace(w,r=>`\\${r}`)}e.$0j=R;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(t){return t.indexOf(L)===-1?t:t.replace(S,(r,a,c,h)=>c?r:a||h||"")}e.$$j=l;function $(t){return t?t.replace(/\$\((.*?)\)/g,(r,a)=>` ${a} `).trim():""}e.$_j=$;const v=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(t){v.lastIndex=0;let r="";const a=[];let c=0;for(;;){const h=v.lastIndex,i=v.exec(t),s=t.substring(h,i?.index);if(s.length>0){r+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:r,iconOffsets:a}}e.$ak=n;function o(t,r,a=!1){const{text:c,iconOffsets:h}=r;if(!h||h.length===0)return(0,E.$Vj)(t,c,a);const i=(0,T.$Oe)(c," "),s=c.length-i.length,u=(0,E.$Vj)(t,i,a);if(u)for(const d of u){const b=h[d.start+s]+s;d.start+=b,d.end+=b}return u}e.$bk=o}),define(Pe[33],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return E.test(I)}e.$kg=T,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const L=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,w="";return w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w+="-",w+=A[L[g++]],w+=A[L[g++]],w+="-",w+=A[L[g++]],w+=A[L[g++]],w+="-",w+=A[L[g++]],w+=A[L[g++]],w+="-",w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w+=A[L[g++]],w}}()}),define(Pe[127],Ae([1,0,18,67,33]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=e.$_s=e.$$s=void 0;function L(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$$s=L;function A(S,l,$){const v={id:(0,I.$lg)(),name:S,uri:l,data:$};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$_s=A;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return T.Iterable.some(this,([v,n])=>n.asFile())&&$.push("files"),R(g(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const v=this.a.get(l);v?v.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const v of $)yield[l,v]}b(l){return g(l)}}e.$at=m;function g(S){return S.toLowerCase()}function w(S,l){return R(g(S),l.map(g))}e.$bt=w;function R(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const $=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[v,n,o]=$;return o==="*"?l.some(t=>t.startsWith(n+"/")):!1}e.$ct=Object.freeze({create:S=>(0,E.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$ct.split(S).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(I){let L=0,A=0,m=0,g=0;for(let w=0,R=I.length;w<R;w++){const S=I.charCodeAt(w);S===13?(L===0&&(A=w),L++,w+1<R&&I.charCodeAt(w+1)===10?(g|=2,w++):g|=3,m=w+1):S===10&&(g|=1,L===0&&(A=w),L++,m=w+1)}return L===0&&(A=I.length),[L,A,I.length-m,g]}e.$ft=T}),define(Pe[129],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$cs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.IndentAction=void 0;var E;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,w=m.notIn.length;g<w;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(g-2),R=m.getStandardTokenType(w);return this.isOK(R)}g(m,g){for(let w=m;w<=g;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Ct=T;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)L(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),L(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),L(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),L(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&L(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Dt=I;function L(A,m,g){A.has(m)?A.get(m).push(g):A.set(m,[g])}}),define(Pe[131],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.NodeColor=e.$yB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$zB)return I(this.right);let o=this;for(;o.parent!==e.$zB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$zB?e.$zB:o.parent}prev(){if(this.left!==e.$zB)return L(this.left);let o=this;for(;o.parent!==e.$zB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$zB?e.$zB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$yB=E;var T;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$zB=new E(null,0),e.$zB.parent=e.$zB,e.$zB.left=e.$zB,e.$zB.right=e.$zB,e.$zB.color=0;function I(n){for(;n.left!==e.$zB;)n=n.left;return n}e.$AB=I;function L(n){for(;n.right!==e.$zB;)n=n.right;return n}e.$BB=L;function A(n){return n===e.$zB?0:n.size_left+n.piece.length+A(n.right)}function m(n){return n===e.$zB?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function g(){e.$zB.parent=e.$zB}function w(n,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$zB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$zB?n.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$CB=w;function R(n,o){const t=o.left;o.left=t.right,t.right!==e.$zB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$zB?n.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$DB=R;function S(n,o){let t,r;if(o.left===e.$zB?(r=o,t=r.right):o.right===e.$zB?(r=o,t=r.left):(r=I(o.right),t=r.right),r===n.root){n.root=t,t.color=0,o.detach(),g(),n.root.parent=e.$zB;return}const a=r.color===1;if(r===r.parent.left?r.parent.left=t:r.parent.right=t,r===o?(t.parent=r.parent,v(n,t)):(r.parent===o?t.parent=r:t.parent=r.parent,v(n,t),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$zB&&(r.left.parent=r),r.right!==e.$zB&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,v(n,r)),o.detach(),t.parent.left===t){const h=A(t),i=m(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,$(n,t.parent,s,u)}}if(v(n,t.parent),a){g();return}let c;for(;t!==n.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(n,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(n,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(n,t.parent),t=n.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,R(n,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(n,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,R(n,t.parent),t=n.root));t.color=0,g()}e.$EB=S;function l(n,o){for(v(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(n,o)),o.parent.color=0,o.parent.parent.color=1,R(n,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(n,o)),o.parent.color=0,o.parent.parent.color=1,w(n,o.parent.parent))}n.root.color=0}e.$FB=l;function $(n,o,t,r){for(;o!==n.root&&o!==e.$zB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}e.$GB=$;function v(n,o){let t=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,t=A(o.left)-o.size_left,r=m(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=r;o!==n.root&&(t!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}}e.$HB=v}),define(Pe[91],Ae([1,0,92,29,93,131,94]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=e.$RB=e.$QB=e.$PB=e.$OB=void 0;const m=65535;function g(t){let r;return t[t.length-1]<65536?r=new Uint16Array(t.length):r=new Uint32Array(t.length),r.set(t,0),r}class w{constructor(r,a,c,h,i){this.lineStarts=r,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function R(t,r=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return r?g(a):a}e.$OB=R;function S(t,r){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,b=r.length;d<b;d++){const f=r.charCodeAt(d);f===13?d+1<b&&r.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$PB=S;class l{constructor(r,a,c,h,i){this.bufferIndex=r,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$QB=l;class ${constructor(r,a){this.buffer=r,this.lineStarts=a}}e.$RB=$;class v{constructor(r,a){this.a=[],this.c=r,this.d=a,this.b=0,r.root!==L.$zB&&r.iterate(r.root,c=>(c!==L.$zB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=r&&c.nodeStartOffset+c.node.piece.length>=r)return c}return null}get2(r){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<r&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=r)return c}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=r){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(r,a,c){this.create(r,a,c)}create(r,a,c){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=L.$zB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=r.length;i<s;i++)if(r[i].buffer.length>0){r[i].lineStarts||(r[i].lineStarts=R(r[i].buffer));const u=new l(i+1,{line:0,column:0},{line:r[i].lineStarts.length-1,column:r[i].buffer.length-r[i].lineStarts[r[i].lineStarts.length-1]},r[i].lineStarts.length-1,r[i].buffer.length);this.a.push(r[i]),h=this.S(h,u)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const a=m,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const b=this.R(d),f=b.length;if(s<=c||s+f<h)return i+=b,s+=f,!0;const k=i.replace(/\r\n|\r|\n/g,r);return u.push(new $(k,R(k))),i=b,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,r);u.push(new $(d,R(d)))}this.create(u,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===L.$zB)return!0;const i=this.R(h),s=i.length,u=r.G(a),d=r.G(a+s),b=r.getValueInRange2(u,d);return a+=s,i===b})}getOffsetAt(r,a){let c=0,h=this.root;for(;h!==L.$zB;)if(h.left!==L.$zB&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){c+=h.size_left;const i=this.B(h,r-h.lf_left-2);return c+=i+a-1}else r-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let a=this.root,c=0;const h=r;for(;a!==L.$zB;)if(a.size_left!==0&&a.size_left>=r)a=a.left;else if(a.size_left+a.piece.length>=r){const i=this.A(a,r-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Es(c+1,u+1)}return new E.$Es(c+1,i.remainder+1)}else if(r-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===L.$zB){const i=this.getOffsetAt(c+1,1),s=h-r-i;return new E.$Es(c+1,s+1)}else a=a.right;return new E.$Es(1,1)}getValueInRange(r,a){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const c=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(r,a){if(r.node===a.node){const u=r.node,d=this.a[u.piece.bufferIndex].buffer,b=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(b+r.remainder,b+a.remainder)}let c=r.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+r.remainder,i+c.piece.length);for(c=c.next();c!==L.$zB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const r=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===L.$zB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,b=this.a[s.bufferIndex].lineStarts,f=s.start.line,k=s.end.line;let F=b[f]+s.start.column;if(h&&(d.charCodeAt(F)===10&&(F++,u--),r[a++]=c,c="",h=!1,u===0))return!0;if(f===k)return!this.f&&d.charCodeAt(F+u-1)===13?(h=!0,c+=d.substr(F,u-1)):c+=d.substr(F,u),!0;c+=this.f?d.substring(F,Math.max(F,b[f+1]-this.e)):d.substring(F,b[f+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;for(let p=f+1;p<k;p++)c=this.f?d.substring(b[p],b[p+1]-this.e):d.substring(b[p],b[p+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;return!this.f&&d.charCodeAt(b[k]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(b[k],s.end.column-1)):c=d.substr(b[k],s.end.column),!0}),h&&(r[a++]=c,c=""),r[a++]=c,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const a=r.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(r,a){const c=this.H(r,a+1);return this.l(c)}getLineLength(r){if(r===this.getLineCount()){const a=this.getOffsetAt(r,1);return this.getLength()-a}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const a=this.G(r);return this.l(a)}findMatchesInNode(r,a,c,h,i,s,u,d,b,f,k){const F=this.a[r.piece.bufferIndex],p=this.u(r.piece.bufferIndex,r.piece.start),y=this.u(r.piece.bufferIndex,i),D=this.u(r.piece.bufferIndex,s);let O;const K={line:0,column:0};let U,M;a._wordSeparators?(U=F.buffer.substring(y,D),M=B=>B+y,a.reset(0)):(U=F.buffer,M=B=>B,a.reset(y));do if(O=a.next(U),O){if(M(O.index)>=D)return f;this.s(r,M(O.index)-p,K);const B=this.t(r.piece.bufferIndex,i,K),C=K.line===i.line?K.column-i.column+h:K.column+1,P=C+O[0].length;if(k[f++]=(0,A.$KB)(new T.$Fs(c+B,C,c+B,P),O,d),M(O.index)+O[0].length>=D||f>=b)return f}while(O);return f}findMatchesLineByLine(r,a,c,h){const i=[];let s=0;const u=new A.$NB(a.wordSeparators,a.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const b=this.H(r.endLineNumber,r.endColumn);if(b===null)return[];let f=this.s(d.node,d.remainder);const k=this.s(b.node,b.remainder);if(d.node===b.node)return this.findMatchesInNode(d.node,u,r.startLineNumber,r.startColumn,f,k,a,c,h,s,i),i;let F=r.startLineNumber,p=d.node;for(;p!==b.node;){const D=this.t(p.piece.bufferIndex,f,p.piece.end);if(D>=1){const K=this.a[p.piece.bufferIndex].lineStarts,U=this.u(p.piece.bufferIndex,p.piece.start),M=K[f.line+D],B=F===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(p,u,F,B,f,this.s(p,M-U),a,c,h,s,i),s>=h)return i;F+=D}const O=F===r.startLineNumber?r.startColumn-1:0;if(F===r.endLineNumber){const K=this.getLineContent(F).substring(O,r.endColumn-1);return s=this.n(a,u,K,r.endLineNumber,O,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(F).substr(O),F,O,s,i,c,h),s>=h)return i;F++,d=this.H(F,1),p=d.node,f=this.s(d.node,d.remainder)}if(F===r.endLineNumber){const D=F===r.startLineNumber?r.startColumn-1:0,O=this.getLineContent(F).substring(D,r.endColumn-1);return s=this.n(a,u,O,r.endLineNumber,D,s,i,c,h),i}const y=F===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(b.node,u,F,y,f,k,a,c,h,s,i),i}n(r,a,c,h,i,s,u,d,b){const f=r.wordSeparators;if(!d&&r.simpleSearch){const F=r.simpleSearch,p=F.length,y=c.length;let D=-p;for(;(D=c.indexOf(F,D+p))!==-1;)if((!f||(0,A.$MB)(f,c,y,D,p))&&(u[s++]=new I.$Xu(new T.$Fs(h,D+1+i,h,D+1+p+i),null),s>=b))return s;return s}let k;a.reset(0);do if(k=a.next(c),k&&(u[s++]=(0,A.$KB)(new T.$Fs(h,k.index+1+i,h,k.index+1+k[0].length+i),k,d),s>=b))return s;while(k);return s}insert(r,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==L.$zB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(r),u=h.piece,d=u.bufferIndex,b=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===r&&a.length<m){this.F(h,a),this.y();return}if(s===r)this.o(a,h),this.h.validate(r);else if(s+h.piece.length>r){const f=[];let k=new l(u.bufferIndex,b,u.end,this.t(u.bufferIndex,b,u.end),this.u(d,u.end)-this.u(d,b));if(this.K()&&this.M(a)&&this.I(h,i)===10){const D={line:k.start.line+1,column:0};k=new l(k.bufferIndex,D,k.end,this.t(k.bufferIndex,D,k.end),k.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,b);else this.C(h,b);const F=this.w(a);k.length>0&&this.S(h,k);let p=h;for(let y=0;y<F.length;y++)p=this.S(p,F[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(r,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===L.$zB)return;const c=this.G(r),h=this.G(r+a),i=c.node,s=h.node;if(i===s){const F=this.s(i,c.remainder),p=this.s(i,h.remainder);if(c.nodeStartOffset===r){if(a===i.piece.length){const y=i.next();(0,L.$EB)(this,i),this.N(y),this.y();return}this.D(i,p),this.h.validate(r),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===r+a){this.C(i,F),this.O(i),this.y();return}this.E(i,F,p),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(r),i.piece.length===0&&u.push(i);const b=this.s(s,h.remainder);this.D(s,b),s.piece.length===0&&u.push(s);const f=i.next();for(let F=f;F!==L.$zB&&F!==s;F=F.next())u.push(F);const k=i.piece.length===0?i.prev():i;this.v(u),this.O(k),this.y()}o(r,a){const c=[];if(this.K()&&this.M(r)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,r+=`
`,(0,L.$GB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(r);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(r,a){this.Q(r,a)&&(r+=`
`);const c=this.w(r),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(r,a,c){const h=r.piece,i=r.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let b=h.start.line,f=h.end.line,k=0,F=0,p=0;for(;b<=f&&(k=b+(f-b)/2|0,p=s[k],k!==f);)if(F=s[k+1],d<p)f=k-1;else if(d>=F)b=k+1;else break;return c?(c.line=k,c.column=d-p,null):{line:k,column:d-p}}t(r,a,c){if(c.column===0)return c.line-a.line;const h=this.a[r].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[r].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(r,a){return this.a[r].lineStarts[a.line]+a.column}v(r){for(let a=0;a<r.length;a++)(0,L.$EB)(this,r[a])}w(r){if(r.length>m){const f=[];for(;r.length>m;){const F=r.charCodeAt(m-1);let p;F===13||F>=55296&&F<=56319?(p=r.substring(0,m-1),r=r.substring(m-1)):(p=r.substring(0,m),r=r.substring(m));const y=R(p);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:p.length-y[y.length-1]},y.length-1,p.length)),this.a.push(new $(p,y))}const k=R(r);return f.push(new l(this.a.length,{line:0,column:0},{line:k.length-1,column:r.length-k[k.length-1]},k.length-1,r.length)),this.a.push(new $(r,k)),f}let a=this.a[0].buffer.length;const c=R(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+r,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=r}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},b=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,a=0){let c=this.root,h="";const i=this.h.get2(r);if(i){c=i.node;const s=this.B(c,r-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===r)h=u.substring(d+s,d+c.piece.length);else{const b=this.B(c,r-i.nodeStartLineNumber);return u.substring(d+s,d+b-a)}}else{let s=0;const u=r;for(;c!==L.$zB;)if(c.left!==L.$zB&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const d=this.B(c,r-c.lf_left-2),b=this.B(c,r-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,k=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(r-1-c.lf_left)}),f.substring(k+d,k+b-a)}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const d=this.B(c,r-c.lf_left-2),b=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=b.substring(f+d,f+c.piece.length);break}else r-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==L.$zB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let r=this.root,a=1,c=0;for(;r!==L.$zB;)a+=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;this.b=a,this.c=c,this.h.validate(this.c)}A(r,a){const c=r.piece,h=this.s(r,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(r.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(r,a){if(a<0)return 0;const c=r.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(r,a){const c=r.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),b=d-h,f=u-i,k=c.length+f;r.piece=new l(c.bufferIndex,c.start,s,d,k),(0,L.$GB)(this,r,f,b)}D(r,a){const c=r.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),b=u-h,f=i-d,k=c.length+f;r.piece=new l(c.bufferIndex,s,c.end,u,k),(0,L.$GB)(this,r,f,b)}E(r,a,c){const h=r.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,b=a,f=this.t(h.bufferIndex,h.start,b),k=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);r.piece=new l(h.bufferIndex,h.start,b,f,k),(0,L.$GB)(this,r,k-u,f-d);const F=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),p=this.S(r,F);this.N(p)}F(r,a){this.Q(a,r)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=R(a,!1);for(let p=0;p<i.length;p++)i[p]+=h;if(c){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},b=r.piece.length+a.length,f=r.piece.lineFeedCnt,k=this.t(0,r.piece.start,d),F=k-f;r.piece=new l(r.piece.bufferIndex,r.piece.start,d,k,b),this.g=d,(0,L.$GB)(this,r,a.length,F)}G(r){let a=this.root;const c=this.h.get(r);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:r-c.nodeStartOffset};let h=0;for(;a!==L.$zB;)if(a.size_left>r)a=a.left;else if(a.size_left+a.piece.length>=r){h+=a.size_left;const i={node:a,remainder:r-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else r-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(r,a){let c=this.root,h=0;for(;c!==L.$zB;)if(c.left!==L.$zB&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const i=this.B(c,r-c.lf_left-2),s=this.B(c,r-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const i=this.B(c,r-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else r-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==L.$zB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(r,a){if(r.piece.lineFeedCnt<1)return-1;const c=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+a;return c.buffer.charCodeAt(h)}J(r){if(!r)return 0;let a=r.size_left;for(;r!==this.root;)r.parent.right===r&&(a+=r.parent.size_left+r.parent.piece.length),r=r.parent;return a}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===L.$zB||r.piece.lineFeedCnt===0)return!1;const a=r.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===L.$zB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const a=r.prev();this.M(a)&&this.P(a,r)}}O(r){if(this.K()&&this.M(r)){const a=r.next();this.L(a)&&this.P(r,a)}}P(r,a){const c=[],h=this.a[r.piece.bufferIndex].lineStarts;let i;r.piece.end.column===0?i={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:i={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,u=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,i,u,s),(0,L.$GB)(this,r,-1,-1),r.piece.length===0&&c.push(r);const d={line:a.piece.start.line+1,column:0},b=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,b),(0,L.$GB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const k=this.w(`\r
`);this.S(r,k[0]);for(let F=0;F<c.length;F++)(0,L.$EB)(this,c[F])}Q(r,a){if(this.K()&&this.M(r)){const c=a.next();if(this.L(c)){if(r+=`
`,c.piece.length===1)(0,L.$EB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,L.$GB)(this,c,-1,-1)}return!0}}return!1}iterate(r,a){if(r===L.$zB)return a(L.$zB);const c=this.iterate(r.left,a);return c&&a(r)&&this.iterate(r.right,a)}R(r){if(r===L.$zB)return"";const a=this.a[r.piece.bufferIndex],c=r.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(r){const a=this.a[r.bufferIndex],c=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return a.buffer.substring(c,h)}S(r,a){const c=new L.$yB(a,1);if(c.left=L.$zB,c.right=L.$zB,c.parent=L.$zB,c.size_left=0,c.lf_left=0,this.root===L.$zB)this.root=c,c.color=0;else if(r.right===L.$zB)r.right=c,c.parent=r;else{const i=(0,L.$AB)(r.right);i.left=c,c.parent=i}return(0,L.$FB)(this,c),c}T(r,a){const c=new L.$yB(a,1);if(c.left=L.$zB,c.right=L.$zB,c.parent=L.$zB,c.size_left=0,c.lf_left=0,this.root===L.$zB)this.root=c,c.color=0;else if(r.left===L.$zB)r.left=c,c.parent=r;else{const h=(0,L.$BB)(r.left);h.right=c,c.parent=h}return(0,L.$FB)(this,c),c}U(r){let a="";return this.iterate(r,c=>(a+=this.R(c),!0)),a}}e.$SB=o}),define(Pe[132],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97=e.$87=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$87=E;class T{constructor(L){this.identifier=L}}e.$97=T}),define(Pe[133],Ae([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class L extends T.$Sc{constructor(l,$="",v="",n=!0,o){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=v,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Fi=L;class A extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,$)}catch(n){v=n}this.m.fire({action:l,error:v})}async u(l,$){await l.run($)}}e.$Gi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const v of l)v.length&&($.length?$=[...$,new m,...v]:$=v);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Hi=m;class g{get actions(){return this.a}constructor(l,$,v,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=n,this.a=v}async run(){}}e.$Ii=g;class w extends L{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Ji=w;function R(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Ki=R}),define(Pe[135],Ae([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=void 0;const T=60,I=T*60,L=I*24,A=L*7,m=L*30,g=L*365;function w(S,l,$,v){typeof S!="number"&&(S=S.getTime());const n=Math.round((new Date().getTime()-S)/1e3);if(n<-30)return(0,E.localize)(0,null,w(new Date().getTime()+n*1e3,!1));if(!v&&n<30)return(0,E.localize)(1,null);let o;return n<T?(o=n,l?o===1?$?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):$?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?$?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):$?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):n<I?(o=Math.floor(n/T),l?o===1?$?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):$?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?$?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):$?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):n<L?(o=Math.floor(n/I),l?o===1?$?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):$?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?$?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):$?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):n<A?(o=Math.floor(n/L),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):n<m?(o=Math.floor(n/A),l?o===1?$?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):$?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?$?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):$?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):n<g?(o=Math.floor(n/m),l?o===1?$?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):$?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?$?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):$?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(n/g),l?o===1?$?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):$?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?$?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):$?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$pm=w;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$qm=R}),define(Pe[137],Ae([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,18,16,137]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function L(S,l){return l&&(S.stack||S.stacktrace)?I.localize(0,null,m(S),A(S.stack)||A(S.stacktrace)):m(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function m(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?I.localize(1,null,S.message):S.message||I.localize(2,null)}function g(S=null,l=!1){if(!S)return I.localize(3,null);if(Array.isArray(S)){const $=E.$Hb(S),v=g($[0],l);return $.length>1?I.localize(4,null,v,$.length):v}if(T.$Df(S))return S;if(S.detail){const $=S.detail;if($.error)return L($.error,l);if($.exception)return L($.exception,l)}return S.stack?L(S,l):S.message?S.message:I.localize(5,null)}e.$Li=g;function w(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Mi=w;function R(S,l){let $;return typeof S=="string"?$=new Error(S):$=S,$.actions=l,$}e.$Ni=R}),define(Pe[138],Ae([1,0,39,19]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=void 0;const I=new E.$V(()=>{const F=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:F,collatorIsNumeric:F.resolvedOptions().numeric}}),L=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(F,p,y=!1){const D=F||"",O=p||"",K=I.value.collator.compare(D,O);return I.value.collatorIsNumeric&&K===0&&D!==O?D<O?-1:1:K}e.$tq=m;function g(F,p){const y=L.value.collator;return F=F||"",p=p||"",c(y,F,p)}e.$uq=g;function w(F,p){const y=L.value.collator;return F=F||"",p=p||"",u(F,p)||c(y,F,p)}e.$vq=w;function R(F,p){const y=L.value.collator;return F=F||"",p=p||"",s(F,p)||c(y,F,p)}e.$wq=R;function S(F,p){return F=F||"",p=p||"",F===p?0:F<p?-1:1}e.$xq=S;function l(F,p){const[y,D]=r(F),[O,K]=r(p);let U=I.value.collator.compare(D,K);if(U===0){if(I.value.collatorIsNumeric&&D!==K)return D<K?-1:1;if(U=I.value.collator.compare(y,O),I.value.collatorIsNumeric&&U===0&&y!==O)return y<O?-1:1}return U}e.$yq=l;function $(F,p){F=F||"",p=p||"";const y=a(F),D=a(p),O=L.value.collator,K=A.value.collator;return c(K,y,D)||c(O,F,p)}e.$zq=$;function v(F,p){F=F||"",p=p||"";const y=a(F),D=a(p),O=L.value.collator,K=A.value.collator;return c(K,y,D)||u(F,p)||c(O,F,p)}e.$Aq=v;function n(F,p){F=F||"",p=p||"";const y=a(F),D=a(p),O=L.value.collator,K=A.value.collator;return c(K,y,D)||s(F,p)||c(O,F,p)}e.$Bq=n;function o(F,p){F=F||"",p=p||"";const y=a(F).toLowerCase(),D=a(p).toLowerCase();return y!==D?y<D?-1:1:F!==p?F<p?-1:1:0}e.$Cq=o;const t=/^(.*?)(\.([^.]*))?$/;function r(F,p=!1){const y=F?t.exec(F):[];let D=[y&&y[1]||"",y&&y[3]||""];return p&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function a(F){const p=F?t.exec(F):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function c(F,p,y){const D=F.compare(p,y);return D!==0?D:p.length!==y.length?p.length<y.length?-1:1:0}function h(F){const p=F.charAt(0);return p.toLocaleUpperCase()!==p}function i(F){const p=F.charAt(0);return p.toLocaleLowerCase()!==p}function s(F,p){return h(F)&&i(p)?-1:i(F)&&h(p)?1:0}function u(F,p){return i(F)&&h(p)?-1:h(F)&&i(p)?1:0}function d(F,p,y=!1){return y||(F=F&&F.toLowerCase(),p=p&&p.toLowerCase()),F===p?0:F<p?-1:1}function b(F,p,y=!1){const D=F.split(T.sep),O=p.split(T.sep),K=D.length-1,U=O.length-1;let M,B;for(let C=0;;C++){if(M=K===C,B=U===C,M&&B)return m(D[C],O[C],y);if(M)return-1;if(B)return 1;const P=d(D[C],O[C],y);if(P!==0)return P}}e.$Dq=b;function f(F,p,y){const D=F.toLowerCase(),O=p.toLowerCase(),K=k(F,p,y);if(K)return K;const U=D.endsWith(y),M=O.endsWith(y);if(U!==M)return U?-1:1;const B=m(D,O);return B!==0?B:D.localeCompare(O)}e.$Eq=f;function k(F,p,y){const D=F.toLowerCase(),O=p.toLowerCase(),K=D.startsWith(y),U=O.startsWith(y);if(K!==U)return K?-1:1;if(K&&U){if(D.length<O.length)return-1;if(D.length>O.length)return 1}return 0}e.$Fq=k}),define(Pe[46],Ae([1,0,19,21,12,16]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function A(f){return f===47||f===92}e.$Vf=A;function m(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Wf=m;function g(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Xf=g;function w(f,k=E.$gc.sep){if(!f)return"";const F=f.length,p=f.charCodeAt(0);if(A(p)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let D=3;const O=D;for(;D<F&&!A(f.charCodeAt(D));D++);if(O!==D&&!A(f.charCodeAt(D+1))){for(D+=1;D<F;D++)if(A(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,k)}}return k}else if(t(p)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+k:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<F;y++)if(A(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Yf=w;function R(f){if(!T.$i||!f||f.length<5)return!1;let k=f.charCodeAt(0);if(k!==92||(k=f.charCodeAt(1),k!==92))return!1;let F=2;const p=F;for(;F<f.length&&(k=f.charCodeAt(F),k!==92);F++);return!(p===F||(k=f.charCodeAt(F+1),isNaN(k)||k===92))}e.$Zf=R;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(f,k=T.$i){const F=k?S:l;return!(!f||f.length===0||/^\s+$/.test(f)||(F.lastIndex=0,F.test(f))||k&&$.test(f)||f==="."||f===".."||k&&f[f.length-1]==="."||k&&f.length!==f.trim().length||f.length>255)}e.$1f=v;function n(f,k,F){const p=f===k;return!F||p?p:!f||!k?!1:(0,I.$7e)(f,k)}e.$2f=n;function o(f,k,F,p=E.sep){if(f===k)return!0;if(!f||!k||k.length>f.length)return!1;if(F){if(!(0,I.$8e)(f,k))return!1;if(k.length===f.length)return!0;let D=k.length;return k.charAt(k.length-1)===p&&D--,f.charAt(D)===p}return k.charAt(k.length-1)!==p&&(k+=p),f.indexOf(k)===0}e.$3f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$4f=t;function r(f,k){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(k,f)),f=(0,E.$hc)(f),T.$i?(f=(0,I.$Pe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Pe)(f,E.sep),f||(f=E.sep)),f}e.$5f=r;function a(f){const k=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(k)&&(f.length===2||k.charCodeAt(2)===92):k===E.$gc.sep}e.$6f=a;function c(f,k=T.$i){return k?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$7f=c;function h(f,k=T.$i){return c(f,k)?f[0]:void 0}e.$8f=h;function i(f,k,F){return k.length>f.length?-1:f===k?0:(F&&(f=f.toLowerCase(),k=k.toLowerCase()),f.indexOf(k))}e.$9f=i;function s(f){const k=f.split(":");let F,p,y;for(const D of k){const O=Number(D);(0,L.$Hf)(O)?p===void 0?p=O:y===void 0&&(y=O):F=F?[F,D].join(":"):D}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:p!==void 0?p:void 0,column:y!==void 0?y:p!==void 0?1:void 0}}e.$0f=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(f,k,F=8){let p="";for(let D=0;D<F;D++){let O;D===0&&T.$i&&!k&&(F===3||F===4)?O=d:O=u,p+=O.charAt(Math.floor(Math.random()*O.length))}let y;return k?y=`${k}-${p}`:y=p,f?(0,E.$jc)(f,y):y}e.$$f=b}),define(Pe[68],Ae([1,0,19]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0,e.$2r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const S=(0,E.$oc)(R),l=T[S.toLowerCase()];return l!==void 0?l:A(R)}e.$3r=L;function A(R){const S=(0,E.$oc)(R);return I[S.toLowerCase()]}e.$4r=A;function m(R){for(const S in I)if(I[S]===R)return S}e.$5r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function w(R,S){const l=g.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:R}e.$6r=w}),define(Pe[51],Ae([1,0,24,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function I(g){return JSON.stringify(g,A)}e.$vh=I;function L(g){let w=JSON.parse(g);return w=m(w),w}e.$wh=L;function A(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let R=0;R<g.length;++R)g[R]=m(g[R],w+1);else for(const R in g)Object.hasOwnProperty.call(g,R)&&(g[R]=m(g[R],w+1))}return g}e.$xh=m}),define(Pe[13],Ae([1,0,11,21,12,2]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function m(l,$){return L.URI.isUri(l)?(0,I.$7e)(l.scheme,$):(0,I.$8e)(l,$+":")}e.$_f=m;function g(l,...$){return $.some(v=>m(l,v))}e.$ag=g,e.$bg="vscode-tkn",e.$cg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${A.vscodeRemoteResource}`}set($,v,n){this.a[$]=v,this.b[$]=n}setConnectionToken($,v){this.c[$]=v}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(a){return E.$1(a),$}const v=$.authority;let n=this.a[v];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const o=this.b[v],t=this.c[v];let r=`path=${encodeURIComponent($.path)}`;return typeof t=="string"&&(r+=`&${e.$cg}=${encodeURIComponent(t)}`),L.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${n}:${o}`,path:this.f,query:r})}}e.$dg=new w,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class R{static{this.a=e.$ig}asBrowserUri($){const v=this.b($,me);return this.uriToBrowserUri(v)}uriToBrowserUri($){return $.scheme===A.vscodeRemote?e.$dg.rewrite($):$.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${R.a}`)?$.with({scheme:A.vscodeFileResource,authority:$.authority||R.a,query:null,fragment:null}):$}asFileUri($){const v=this.b($,me);return this.uriToFileUri(v)}uriToFileUri($){return $.scheme===A.vscodeFileResource?$.with({scheme:A.file,authority:$.authority!==R.a?$.authority:null,query:null,fragment:null}):$}b($,v){return L.URI.isUri($)?$:L.URI.parse(v.toUrl($))}}e.$jg=new R;var S;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const v="vscode-coi";function n(t){let r;typeof t=="string"?r=new URL(t).searchParams:t instanceof URL?r=t.searchParams:L.URI.isUri(t)&&(r=new URL(t.toString(!0)).searchParams);const a=r?.get(v);if(a)return $.get(a)}l.getHeadersFromQuery=n;function o(t,r,a){if(!globalThis.crossOriginIsolated)return;const c=r&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(v,c):t[v]=c}l.addSearchParam=o})(S||(e.COI=S={}))}),define(Pe[25],Ae([1,0,46,13,19,21,12,2]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function g($){return(0,m.$wc)($,!0)}e.$qg=g;class w{constructor(v){this.a=v}compare(v,n,o=!1){return v===n?0:(0,A.$Ze)(this.getComparisonKey(v,o),this.getComparisonKey(n,o))}isEqual(v,n,o=!1){return v===n?!0:!v||!n?!1:this.getComparisonKey(v,o)===this.getComparisonKey(n,o)}getComparisonKey(v,n=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,n,o=!1){if(v.scheme===n.scheme){if(v.scheme===T.Schemas.file)return E.$3f(g(v),g(n),this.a(v))&&v.query===n.query&&(o||v.fragment===n.fragment);if((0,e.$Hg)(v.authority,n.authority))return E.$3f(v.path,n.path,this.a(v),"/")&&v.query===n.query&&(o||v.fragment===n.fragment)}return!1}joinPath(v,...n){return m.URI.joinPath(v,...n)}basenameOrAuthority(v){return(0,e.$zg)(v)||v.authority}basename(v){return I.$gc.basename(v.path)}extname(v){return I.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let n;return v.scheme===T.Schemas.file?n=m.URI.file(I.$mc(g(v))).path:(n=I.$gc.dirname(v.path),v.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),n="/")),v.with({path:n})}normalizePath(v){if(!v.path.length)return v;let n;return v.scheme===T.Schemas.file?n=m.URI.file(I.$hc(g(v))).path:n=I.$gc.normalize(v.path),v.with({path:n})}relativePath(v,n){if(v.scheme!==n.scheme||!(0,e.$Hg)(v.authority,n.authority))return;if(v.scheme===T.Schemas.file){const r=I.$lc(g(v),g(n));return L.$i?E.$Wf(r):r}let o=v.path||"/";const t=n.path||"/";if(this.a(v)){let r=0;for(const a=Math.min(o.length,t.length);r<a&&!(o.charCodeAt(r)!==t.charCodeAt(r)&&o.charAt(r).toLowerCase()!==t.charAt(r).toLowerCase());r++);o=t.substr(0,r)+o.substr(r)}return I.$gc.relative(o,t)}resolvePath(v,n){if(v.scheme===T.Schemas.file){const o=m.URI.file(I.$kc(g(v),n));return v.with({authority:o.authority,path:o.path})}return n=E.$Xf(n),v.with({path:I.$gc.resolve(v.path,n)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,n){return v===n||v!==void 0&&n!==void 0&&(0,A.$7e)(v,n)}hasTrailingPathSeparator(v,n=I.sep){if(v.scheme===T.Schemas.file){const o=g(v);return o.length>E.$Yf(o).length&&o[o.length-1]===n}else{const o=v.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,n=I.sep){return(0,e.$Ig)(v,n)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,n=I.sep){let o=!1;if(v.scheme===T.Schemas.file){const t=g(v);o=t!==void 0&&t.length===E.$Yf(t).length&&t[t.length-1]===n}else{n="/";const t=v.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Ig)(v,n)?v.with({path:v.path+"/"}):v}}e.$rg=w,e.$sg=new w(()=>!1),e.$tg=new w($=>$.scheme===T.Schemas.file?!L.$k:!0),e.$ug=new w($=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function R($,v){const n=[];for(let o=0;o<$.length;o++){const t=v($[o]);$.some((r,a)=>a===o?!1:(0,e.$wg)(t,v(r)))||n.push($[o])}return n}e.$Lg=R;var S;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function v(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set($.META_DATA_MIME,r),o}$.parseMetaData=v})(S||(e.DataUri=S={}));function l($,v,n){if(v){let o=$.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),$.with({scheme:n,authority:v,path:o})}return $.with({scheme:n})}e.$Mg=l}),define(Pe[14],Ae([1,0,20,11,5,6,25,21,125,39]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function R(ce){return!!ce&&typeof ce.then=="function"}e.$Ng=R;function S(ce){const ie=new E.$3d,Q=ce(ie.token),ee=new Promise(($e,be)=>{const Me=ie.token.onCancellationRequested(()=>{Me.dispose(),ie.dispose(),be(new T.$5)});Promise.resolve(Q).then(le=>{Me.dispose(),ie.dispose(),$e(le)},le=>{Me.dispose(),ie.dispose(),be(le)})});return new class{cancel(){ie.cancel()}then($e,be){return ee.then($e,be)}catch($e){return this.then(void 0,$e)}finally($e){return ee.finally($e)}}}e.$Og=S;function l(ce,ie,Q){return new Promise((ee,$e)=>{const be=ie.onCancellationRequested(()=>{be.dispose(),ee(Q)});ce.then(ee,$e).finally(()=>be.dispose())})}e.$Pg=l;function $(ce,ie){return new Promise((Q,ee)=>{const $e=ie.onCancellationRequested(()=>{$e.dispose(),ee(new T.$5)});ce.then(Q,ee).finally(()=>$e.dispose())})}e.$Qg=$;async function v(ce){let ie=-1;const Q=ce.map((ee,$e)=>ee.then(be=>(ie=$e,be)));try{return await Promise.race(Q)}finally{ce.forEach((ee,$e)=>{$e!==ie&&ee.cancel()})}}e.$Rg=v;function n(ce,ie,Q){let ee;const $e=setTimeout(()=>{ee?.(void 0),Q?.()},ie);return Promise.race([ce.finally(()=>clearTimeout($e)),new Promise(be=>ee=be)])}e.$Sg=n;function o(ce){return new Promise((ie,Q)=>{const ee=ce();R(ee)?ee.then(ie,Q):ie(ee)})}e.$Tg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=ie(),new Promise((Q,ee)=>{this.a.then($e=>{this.a=null,Q($e)},$e=>{this.a=null,ee($e)})})}dispose(){this.f=!0}}e.$Ug=t;class r{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Vg=r;class a{constructor(){this.a=new Map}queue(ie,Q){const $e=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(ie)===$e&&this.a.delete(ie)});return this.a.set(ie,$e),$e}}e.$Wg=a;const c=(ce,ie)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,ie()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ce())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,Q=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise(($e,be)=>{this.d=$e,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Pd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=i;class s{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,Q){return this.a.trigger(()=>this.b.queue(ie),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=s;class u{constructor(){this.a=!1,this.b=new Promise((ie,Q)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$1g=d;function b(ce,ie){return ie?new Promise((Q,ee)=>{const $e=setTimeout(()=>{be.dispose(),Q()},ce),be=ie.onCancellationRequested(()=>{clearTimeout($e),be.dispose(),ee(new T.$5)})}):S(Q=>b(ce,Q))}e.$2g=b;function f(ce,ie=0,Q){const ee=setTimeout(()=>{ce(),Q&&$e.dispose()},ie),$e=(0,L.$Qc)(()=>{clearTimeout(ee),Q?.deleteAndLeak($e)});return Q?.add($e),$e}e.$3g=f;function k(ce){const ie=[];let Q=0;const ee=ce.length;function $e(){return Q<ee?ce[Q++]():null}function be(Me){Me!=null&&ie.push(Me);const le=$e();return le?le.then(be):Promise.resolve(ie)}return Promise.resolve(null).then(be)}e.$4g=k;function F(ce,ie=ee=>!!ee,Q=null){let ee=0;const $e=ce.length,be=()=>{if(ee>=$e)return Promise.resolve(Q);const Me=ce[ee++];return Promise.resolve(Me()).then(we=>ie(we)?Promise.resolve(we):be())};return be()}e.$5g=F;function p(ce,ie=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const $e=()=>{ee=-1;for(const be of ce)be.cancel?.()};return new Promise((be,Me)=>{for(const le of ce)le.then(we=>{--ee>=0&&ie(we)?($e(),be(we)):ee===0&&be(Q)}).catch(we=>{--ee>=0&&($e(),Me(we))})})}e.$6g=p;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((Q,ee)=>{this.f.push({factory:ie,c:Q,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const Q=ie.factory();Q.then(ie.c,ie.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=y;class D extends y{constructor(){super(1)}}e.$8g=D;class O{constructor(){this.a=new ke,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$9g=O;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new te;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,Q=A.$sg){const ee=Q.getComparisonKey(ie);let $e=this.a.get(ee);if(!$e){$e=new D;const be=this.f++,Me=I.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$2c),this.d.set(be,Me),this.a.set(ee,$e)}return $e}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=K;class U{constructor(ie,Q){this.a=-1,typeof ie=="function"&&typeof Q=="number"&&this.setIfNotSet(ie,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},Q)}setIfNotSet(ie,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},Q))}}e.$$g=U;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,Q,ee=globalThis){this.cancel();const $e=ee.setInterval(()=>{ie()},Q);this.d=(0,L.$Qc)(()=>{ee.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$_g=M;class B{constructor(ie,Q){this.b=-1,this.a=ie,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=B;class C{constructor(ie,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=ie,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=C;class P extends B{constructor(ie,Q){super(ie,Q),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$ch=P;class X extends L.$Sc{constructor(ie,Q){super(),this.g=ie,this.h=Q,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of ie)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(ce,ie)=>{(0,m.$B)(()=>{if(Q)return;const ee=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$fh=(ce,ie,Q)=>{const ee=ce.requestIdleCallback(ie,typeof Q=="number"?{timeout:Q}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ce.cancelIdleCallback(ee))}}},e.$eh=ce=>(0,e.$fh)(globalThis,ce)}();class ae{constructor(ie,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$fh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=ae;class ge extends ae{constructor(ie){super(globalThis,ie)}}e.$hh=ge;async function ve(ce,ie,Q){let ee;for(let $e=0;$e<Q;$e++)try{return await ce()}catch(be){ee=be,await b(ie)}throw ee}e.$ih=ve;class ke{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,Q,ee){return this.a={taskId:ie,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(ie),()=>this.d(ie)),Q}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let Q,ee;const $e=new Promise((be,Me)=>{Q=be,ee=Me});this.b={run:ie,promise:$e,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=ke;class de{constructor(ie,Q=()=>Date.now()){this.d=ie,this.f=Q,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$kh=de;var he;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,Q)=>{this.a=ie,this.b=Q})}complete(ie){return new Promise(Q=>{this.a(ie),this.d={outcome:0,value:ie},Q()})}error(ie){return new Promise(Q=>{this.b(ie),this.d={outcome:1,value:ie},Q()})}cancel(){return this.error(new T.$5)}}e.$lh=te;var Se;(function(ce){async function ie(ee){let $e;const be=await Promise.all(ee.map(Me=>Me.then(le=>le,le=>{$e||($e=le)})));if(typeof $e<"u")throw $e;return be}ce.settled=ie;function Q(ee){return new Promise(async($e,be)=>{try{await ee($e,be)}catch(Me){be(Me)}})}ce.withAsyncBody=Q})(Se||(e.Promises=Se={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=oe;class Y{constructor(ie){this.b=ie,this.a=new w.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=Y;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(ie){return new ne(Q=>{Q.emitMany(ie)})}static fromPromise(ie){return new ne(async Q=>{Q.emitMany(await ie)})}static fromPromises(ie){return new ne(async Q=>{await Promise.all(ie.map(async ee=>Q.emitOne(await ee)))})}static merge(ie){return new ne(async Q=>{await Promise.all(ie.map(async ee=>{for await(const $e of ee)Q.emitOne($e)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(ie(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,Q){return new ne(async ee=>{for await(const $e of ie)ee.emitOne(Q($e))})}map(ie){return ne.map(this,ie)}static filter(ie,Q){return new ne(async ee=>{for await(const $e of ie)Q($e)&&ee.emitOne($e)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const Q=[];for await(const ee of ie)Q.push(ee);return Q}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$oh=ne;class Ie extends ne{constructor(ie,Q){super(Q),this.l=ie}cancel(){this.l.cancel()}}e.$ph=Ie;function Le(ce){const ie=new E.$3d,Q=ce(ie.token);return new Ie(ie,async ee=>{const $e=ie.token.onCancellationRequested(()=>{$e.dispose(),ie.dispose(),ee.reject(new T.$5)});try{for await(const be of Q){if(ie.token.isCancellationRequested)return;ee.emitOne(be)}$e.dispose(),ie.dispose()}catch(be){$e.dispose(),ie.dispose(),ee.reject(be)}})}e.$qh=Le;class Ce{constructor(){this.a=new te,this.b=new ne(ee=>{if(ie){ee.reject(ie);return}return Q&&ee.emitMany(Q),this.d=$e=>ee.reject($e),this.f=$e=>ee.emitOne($e),this.a.p});let ie,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{ie||(ie=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$rh=Ce}),define(Pe[34],Ae([1,0,18,14,46,28,19,21,12]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;function w(){return Object.create(null)}e.$Cj=w,e.$Dj="**",e.$Ej="/";const R="[/\\\\]",S="[^/\\\\]",l=/\//g;function $(ge,ve){switch(ge){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ve?`|${R}${S}+`:""})*?`}}function v(ge,ve){if(!ge)return[];const ke=[];let de=!1,he=!1,te="";for(const Se of ge){switch(Se){case ve:if(!de&&!he){ke.push(te),te="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":he=!0;break;case"]":he=!1;break}te+=Se}return te&&ke.push(te),ke}e.$Fj=v;function n(ge){if(!ge)return"";let ve="";const ke=v(ge,e.$Ej);if(ke.every(de=>de===e.$Dj))ve=".*";else{let de=!1;ke.forEach((he,te)=>{if(he===e.$Dj){if(de)return;ve+=$(2,te===ke.length-1)}else{let Se=!1,oe="",Y=!1,V="";for(const ne of he){if(ne!=="}"&&Se){oe+=ne;continue}if(Y&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Ej?Ie="":Ie=(0,g.$Ke)(ne),V+=Ie;continue}switch(ne){case"{":Se=!0;continue;case"[":Y=!0;continue;case"}":{const Le=`(?:${v(oe,",").map(Ce=>n(Ce)).join("|")})`;ve+=Le,Se=!1,oe="";break}case"]":{ve+="["+V+"]",Y=!1,V="";break}case"?":ve+=S;continue;case"*":ve+=$(1);continue;default:ve+=(0,g.$Ke)(ne)}}te<ke.length-1&&(ke[te+1]!==e.$Dj||te+2<ke.length)&&(ve+=R)}de=he===e.$Dj})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(ge,ve){if(!ge)return u;let ke;typeof ge!="string"?ke=ge.pattern:ke=ge,ke=ke.trim();const de=`${ke}_${!!ve.trimForExclusions}`;let he=i.get(de);if(he)return b(he,ge);let te;return o.test(ke)?he=k(ke.substr(4),ke):(te=t.exec(f(ke,ve)))?he=F(te[1],ke):(ve.trimForExclusions?a:r).test(ke)?he=p(ke,ve):(te=c.exec(f(ke,ve)))?he=y(te[1].substr(1),ke,!0):(te=h.exec(f(ke,ve)))?he=y(te[1],ke,!1):he=D(ke),i.set(de,he),b(he,ge)}function b(ge,ve){if(typeof ve=="string")return ge;const ke=function(de,he){return(0,I.$3f)(de,ve.base,!m.$k)?ge((0,g.$Oe)(de.substr(ve.base.length),A.sep),he):null};return ke.allBasenames=ge.allBasenames,ke.allPaths=ge.allPaths,ke.basenames=ge.basenames,ke.patterns=ge.patterns,ke}function f(ge,ve){return ve.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function k(ge,ve){return function(ke,de){return typeof ke=="string"&&ke.endsWith(ge)?ve:null}}function F(ge,ve){const ke=`/${ge}`,de=`\\${ge}`,he=function(Se,oe){return typeof Se!="string"?null:oe?oe===ge?ve:null:Se===ge||Se.endsWith(ke)||Se.endsWith(de)?ve:null},te=[ge];return he.basenames=te,he.patterns=[ve],he.allBasenames=te,he}function p(ge,ve){const ke=X(ge.slice(1,-1).split(",").map(oe=>d(oe,ve)).filter(oe=>oe!==u),ge),de=ke.length;if(!de)return u;if(de===1)return ke[0];const he=function(oe,Y){for(let V=0,ne=ke.length;V<ne;V++)if(ke[V](oe,Y))return ge;return null},te=ke.find(oe=>!!oe.allBasenames);te&&(he.allBasenames=te.allBasenames);const Se=ke.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return Se.length&&(he.allPaths=Se),he}function y(ge,ve,ke){const de=A.sep===A.$gc.sep,he=de?ge:ge.replace(l,A.sep),te=A.sep+he,Se=A.$gc.sep+ge;let oe;return ke?oe=function(Y,V){return typeof Y=="string"&&(Y===he||Y.endsWith(te)||!de&&(Y===ge||Y.endsWith(Se)))?ve:null}:oe=function(Y,V){return typeof Y=="string"&&(Y===he||!de&&Y===ge)?ve:null},oe.allPaths=[(ke?"*/":"./")+ge],oe}function D(ge){try{const ve=new RegExp(`^${n(ge)}$`);return function(ke){return ve.lastIndex=0,typeof ke=="string"&&ve.test(ke)?ge:null}}catch{return u}}function O(ge,ve,ke){return!ge||typeof ve!="string"?!1:K(ge)(ve,void 0,ke)}e.$Gj=O;function K(ge,ve={}){if(!ge)return s;if(typeof ge=="string"||U(ge)){const ke=d(ge,ve);if(ke===u)return s;const de=function(he,te){return!!ke(he,te)};return ke.allBasenames&&(de.allBasenames=ke.allBasenames),ke.allPaths&&(de.allPaths=ke.allPaths),de}return C(ge,ve)}e.$Hj=K;function U(ge){const ve=ge;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}e.$Ij=U;function M(ge){return ge.allBasenames||[]}e.$Jj=M;function B(ge){return ge.allPaths||[]}e.$Kj=B;function C(ge,ve){const ke=X(Object.getOwnPropertyNames(ge).map(oe=>P(oe,ge[oe],ve)).filter(oe=>oe!==u)),de=ke.length;if(!de)return u;if(!ke.some(oe=>!!oe.requiresSiblings)){if(de===1)return ke[0];const oe=function(ne,Ie){let Le;for(let Ce=0,ce=ke.length;Ce<ce;Ce++){const ie=ke[Ce](ne,Ie);if(typeof ie=="string")return ie;(0,T.$Ng)(ie)&&(Le||(Le=[]),Le.push(ie))}return Le?(async()=>{for(const Ce of Le){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},Y=ke.find(ne=>!!ne.allBasenames);Y&&(oe.allBasenames=Y.allBasenames);const V=ke.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(oe.allPaths=V),oe}const he=function(oe,Y,V){let ne,Ie;for(let Le=0,Ce=ke.length;Le<Ce;Le++){const ce=ke[Le];ce.requiresSiblings&&V&&(Y||(Y=(0,A.$nc)(oe)),ne||(ne=Y.substr(0,Y.length-(0,A.$oc)(oe).length)));const ie=ce(oe,Y,ne,V);if(typeof ie=="string")return ie;(0,T.$Ng)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Le of Ie){const Ce=await Le;if(typeof Ce=="string")return Ce}return null})():null},te=ke.find(oe=>!!oe.allBasenames);te&&(he.allBasenames=te.allBasenames);const Se=ke.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return Se.length&&(he.allPaths=Se),he}function P(ge,ve,ke){if(ve===!1)return u;const de=d(ge,ke);if(de===u)return u;if(typeof ve=="boolean")return de;if(ve){const he=ve.when;if(typeof he=="string"){const te=(Se,oe,Y,V)=>{if(!V||!de(Se,oe))return null;const ne=he.replace("$(basename)",()=>Y),Ie=V(ne);return(0,T.$Ng)(Ie)?Ie.then(Le=>Le?ge:null):Ie?ge:null};return te.requiresSiblings=!0,te}}return de}function X(ge,ve){const ke=ge.filter(oe=>!!oe.basenames);if(ke.length<2)return ge;const de=ke.reduce((oe,Y)=>{const V=Y.basenames;return V?oe.concat(V):oe},[]);let he;if(ve){he=[];for(let oe=0,Y=de.length;oe<Y;oe++)he.push(ve)}else he=ke.reduce((oe,Y)=>{const V=Y.patterns;return V?oe.concat(V):oe},[]);const te=function(oe,Y){if(typeof oe!="string")return null;if(!Y){let ne;for(ne=oe.length;ne>0;ne--){const Ie=oe.charCodeAt(ne-1);if(Ie===47||Ie===92)break}Y=oe.substr(ne)}const V=de.indexOf(Y);return V!==-1?he[V]:null};te.basenames=de,te.patterns=he,te.allBasenames=de;const Se=ge.filter(oe=>!oe.basenames);return Se.push(te),Se}function ae(ge,ve){return(0,E.$ub)(ge,ve,(ke,de)=>typeof ke=="string"&&typeof de=="string"?ke===de:typeof ke!="string"&&typeof de!="string"?ke.base===de.base&&ke.pattern===de.pattern:!1)}e.$Lj=ae}),define(Pe[52],Ae([1,0,11,126,25,12,2]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(t="",r=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(t,r=0){return this.value+=l(this.supportThemeIcons?(0,T.$9j)(t):t).replace(/([ \t]+)/g,(a,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,r){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(t,r,a){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(t),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(t,r){const a=new RegExp((0,L.$Ke)(r),"g");return t.replace(a,(c,h)=>t.charAt(h-1)!=="\\"?`\\${c}`:c)}}e.$ck=g;function w(o){return R(o)?!o.value:Array.isArray(o)?o.every(w):!0}e.$dk=w;function R(o){return o instanceof g?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$ek=R;function S(o,t){return o===t?!0:!o||!t?!1:o.value===t.value&&o.isTrusted===t.isTrusted&&o.supportThemeIcons===t.supportThemeIcons&&o.supportHtml===t.supportHtml&&(o.baseUri===t.baseUri||!!o.baseUri&&!!t.baseUri&&(0,I.$vg)(A.URI.from(o.baseUri),A.URI.from(t.baseUri)))}e.$fk=S;function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$gk=l;function $(o){return o.replace(/"/g,"&quot;")}e.$hk=$;function v(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ik=v;function n(o){const t=[],r=o.split("|").map(c=>c.trim());o=r[0];const a=r[1];if(a){const c=/height=(\d+)/.exec(a),h=/width=(\d+)/.exec(a),i=c?c[1]:"",s=h?h[1]:"",u=isFinite(parseInt(s)),d=isFinite(parseInt(i));u&&t.push(`width="${s}"`),d&&t.push(`height="${i}"`)}return{href:o,dimensions:t}}e.$jk=n}),define(Pe[95],Ae([1,0,18,46,19,21,25,12]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=void 0;function g(d,b){const{os:f,tildify:k,relative:F}=b;if(F){const D=w(d,F,f);if(typeof D=="string")return D}let p=d.fsPath;if(f===1&&!L.$i?p=p.replace(/\//g,"\\"):f!==1&&L.$i&&(p=p.replace(/\\/g,"/")),f!==1&&k?.userHome){const D=k.userHome.fsPath;let O;d.scheme!==k.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?O=k.userHome.with({path:d.path}).fsPath:O=p,p=l(O,D,f)}return(f===1?I.$fc:I.$gc).normalize(R(p,f===1))}e.$Fv=g;function w(d,b,f){const k=f===1?I.$fc:I.$gc,F=f===3?A.$sg:A.$ug,p=b.getWorkspace(),y=(0,E.$Ob)(p.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const D=b.getWorkspaceFolder(d);if(!D)return;let O;if(F.isEqual(D.uri,d)?O="":O=F.relativePath(D.uri,d)??"",O&&(O=k.normalize(O)),p.folders.length>1&&!b.noPrefix){const K=D.name?D.name:F.basenameOrAuthority(D.uri);O=O?`${K} \u2022 ${O}`:K}return O}function R(d,b=L.$i){return(0,T.$7f)(d,b)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Gv=R;let S=Object.create(null);function l(d,b,f=L.OS){if(f===1||!d||!b)return d;let k=S.original===b?S.normalized:void 0;k||(k=b,L.$i&&(k=(0,T.$Wf)(k)),k=`${(0,m.$Pe)(k,I.$gc.sep)}${I.$gc.sep}`,S={original:b,normalized:k});let F=d;return L.$i&&(F=(0,T.$Wf)(F)),(f===3?F.startsWith(k):(0,m.$8e)(F,k))?`~/${F.substr(k.length)}`:d}e.$Hv=l;function $(d,b){return d.replace(/^~($|\/|\\)/,`${b}$1`)}e.$Iv=$;const v="\u2026",n="\\\\",o="~";function t(d,b=I.sep){const f=new Array(d.length);let k=!1;for(let F=0;F<d.length;F++){const p=d[F];if(p===""){f[F]=`.${b}`;continue}if(!p){f[F]=p;continue}k=!0;let y="",D=p;D.indexOf(n)===0?(y=D.substr(0,D.indexOf(n)+n.length),D=D.substr(D.indexOf(n)+n.length)):D.indexOf(b)===0?(y=D.substr(0,D.indexOf(b)+b.length),D=D.substr(D.indexOf(b)+b.length)):D.indexOf(o)===0&&(y=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length));const O=D.split(b);for(let K=1;k&&K<=O.length;K++)for(let U=O.length-K;k&&U>=0;U--){k=!1;let M=O.slice(U,U+K).join(b);for(let B=0;!k&&B<d.length;B++)if(B!==F&&d[B]&&d[B].indexOf(M)>-1){const C=U+K===O.length,P=U>0&&d[B].indexOf(b)>-1?b+M:M,X=d[B].endsWith(P);k=!C||X}if(!k){let B="";(O[0].endsWith(":")||y!=="")&&(U===1&&(U=0,K++,M=O[0]+b+M),U>0&&(B=O[0]+b),B=y+B),U>0&&(B=B+v+b),B=B+M,U+K<O.length&&(B=B+b+v),f[F]=B}}k&&(f[F]=p)}return f}e.$Jv=t;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function a(d,b=Object.create(null)){const f=[];let k=!1,F="";for(const p of d)if(p==="$"||k&&p==="{")F&&f.push({value:F,type:r.TEXT}),F="",k=!0;else if(p==="}"&&k){const y=b[F];if(typeof y=="string")y.length&&f.push({value:y,type:r.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==r.SEPARATOR)&&f.push({value:y.label,type:r.SEPARATOR})}F="",k=!1}else F+=p;return F&&!k&&f.push({value:F,type:r.TEXT}),f.filter((p,y)=>{if(p.type===r.SEPARATOR){const D=f[y-1],O=f[y+1];return[D,O].every(K=>K&&(K.type===r.VARIABLE||K.type===r.TEXT)&&K.value.length>0)}return!0}).map(p=>p.value).join("")}e.$Kv=a;function c(d,b){return L.$j||b?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Lv=c;function h(d,b){return L.$j||b?d.replace(/\(&&\w\)|&&/g,""):L.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Mv=h;function i(d){return d.replace(/&/g,"&&")}e.$Nv=i;function s(d){if(d.endsWith("]")){const b=d.lastIndexOf(" [",d.length-2);if(b!==-1){const f=u(d.substring(0,b));return{name:f.name,parentPath:f.parentPath+d.substring(b)}}}return u(d)}e.$Ov=s;function u(d){const b=d.indexOf("/")!==-1?I.$gc:I.$fc,f=b.basename(d),k=b.dirname(d);return f.length?{name:f,parentPath:k}:{name:k,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=void 0;function I(S){return S.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:I(T.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:I(T.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:T.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Xm=L,e.$Ym=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,l,$){if(!S||$>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const v in S)if(Object.hasOwnProperty.call(S,v)){const n=A(S[v],l,$+1);n!==null&&(S[v]=n)}}return null}function m(S,l){const $=A(S,l,0);return $===null?S:$}e.$Zm=m;function g(S,l,$,v){if(!S||v>200)return null;if(typeof S=="object"){if(S.$mid===1)return $?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$ge)return null;for(const n in S)if(Object.hasOwnProperty.call(S,n)){const o=g(S[n],l,$,v+1);o!==null&&(S[n]=o)}}return null}function w(S,l){const $=g(S,l,!1,0);return $===null?S:$}e.$1m=w;function R(S,l){const $=g(S,l,!0,0);return $===null?S:$}e.$2m=R}),define(Pe[140],Ae([1,0,12,21,24]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.$Xs=void 0;let L;function A(){return L||(L=new TextDecoder("UTF-16LE")),L}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function R(){return w||(w=T.$D()?A():g()),w}e.$Xs=R;function S(v,n,o){const t=new Uint16Array(v.buffer,n,o);return o>0&&(t[0]===65279||t[0]===65534)?l(v,n,o):A().decode(t)}e.$Ys=S;function l(v,n,o){const t=[];let r=0;for(let a=0;a<o;a++){const c=I.$ie(v,n);n+=2,t[r++]=String.fromCharCode(c)}return t.join("")}class ${constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||E.$$e(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let t=0;t<o;t++)this.b[this.d++]=n.charCodeAt(t)}}e.$Zs=$}),define(Pe[141],Ae([1,0,24,140]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,R,S,l){this.oldPosition=w,this.oldText=R,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,R,S){const l=R.length;E.$le(w,l,S),S+=4;for(let $=0;$<l;$++)E.$je(w,R.charCodeAt($),S),S+=2;return S}static d(w,R){const S=E.$ke(w,R);return R+=4,(0,T.$Ys)(w,R,S)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(w,R){return E.$le(w,this.oldPosition,R),R+=4,E.$le(w,this.newPosition,R),R+=4,R=L.c(w,this.oldText,R),R=L.c(w,this.newText,R),R}static read(w,R,S){const l=E.$ke(w,R);R+=4;const $=E.$ke(w,R);R+=4;const v=L.d(w,R);R+=L.a(v);const n=L.d(w,R);return R+=L.a(n),S.push(new L(l,v,$,n)),R}}e.$1s=L;function A(g,w){return g===null||g.length===0?w:new m(g,w).compress()}e.$2s=A;class m{constructor(w,R){this.a=w,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,R=0,S=this.n(w),l=this.l(R);for(;w<this.f||R<this.h;){if(S===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(S),S=this.n(++w);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++R);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++w);continue}if(l.oldPosition<S.newPosition){const[t,r]=m.r(l,S.newPosition-l.oldPosition);this.k(t),l=r;continue}if(S.newPosition<l.oldPosition){const[t,r]=m.q(S,l.oldPosition-S.newPosition);this.m(t),S=r;continue}let n,o;if(l.oldEnd===S.newEnd)n=S,o=l,S=this.n(++w),l=this.l(++R);else if(l.oldEnd<S.newEnd){const[t,r]=m.q(S,l.oldLength);n=t,o=l,S=r,l=this.l(++R)}else{const[t,r]=m.r(l,S.newLength);n=S,o=t,S=this.n(++w),l=r}this.d[this.e++]=new L(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const $=m.s(this.d);return m.t($)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,R){return new L(R.oldPosition-w,R.oldText,R.newPosition,R.newText)}static p(w,R){return new L(R.oldPosition,R.oldText,R.newPosition+w,R.newText)}static q(w,R){const S=w.newText.substr(0,R),l=w.newText.substr(R);return[new L(w.oldPosition,w.oldText,w.newPosition,S),new L(w.oldEnd,"",w.newPosition+R,l)]}static r(w,R){const S=w.oldText.substr(0,R),l=w.oldText.substr(R);return[new L(w.oldPosition,S,w.newPosition,w.newText),new L(w.oldPosition+R,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const R=[];let S=0,l=w[0];for(let $=1;$<w.length;$++){const v=w[$];l.oldEnd===v.oldPosition?l=new L(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(R[S++]=l,l=v)}return R[S++]=l,R}static t(w){if(w.length===0)return w;const R=[];let S=0;for(let l=0;l<w.length;l++){const $=w[l];$.oldText!==$.newText&&(R[S++]=$)}return R}}}),define(Pe[142],Ae([1,0,34,19]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0;function I(L,A,m,g,w,R){if(Array.isArray(L)){let S=0;for(const l of L){const $=I(l,A,m,g,w,R);if($===10)return $;$>S&&(S=$)}return S}else{if(typeof L=="string")return g?L==="*"?5:L===m?10:0:0;if(L){const{language:S,pattern:l,scheme:$,hasAccessToAllModels:v,notebookType:n}=L;if(!g&&!v)return 0;n&&w&&(A=w);let o=0;if($)if($===A.scheme)o=10;else if($==="*")o=5;else return 0;if(S)if(S===m)o=10;else if(S==="*")o=Math.max(o,5);else return 0;if(n)if(n===R)o=10;else if(n==="*"&&R!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===A.fsPath||(0,E.$Gj)(t,A.fsPath))o=10;else return 0}return o}else return 0}}e.$mt=I}),define(Pe[143],Ae([1,0,5,12,29,93,91,128,141,6]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=void 0;class R extends w.$Sc{constructor(l,$,v,n,o,t,r){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!t,this.g=n,this.h=o,this.c=new A.$SB(l,v,r)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const v=l+$,n=this.getPositionAt(l),o=this.getPositionAt(v);return new I.$Fs(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const v=this.n($);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),n=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n($),r=this.getEOL();if(t.length!==r.length){const a=t.length-r.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return n-v+o}getCharacterCountInRange(l,$=0){if(this.j){let v=0;const n=l.startLineNumber,o=l.endLineNumber;for(let t=n;t<=o;t++){const r=this.getLineContent(t),a=t===n?l.startColumn-1:0,c=t===o?l.endColumn-1:r.length;for(let h=a;h<c;h++)T.$$e(r.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n($).length*(o-n),v}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=T.$Ve(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=T.$Xe(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,v){let n=this.g,o=this.h,t=this.j,r=!0,a=[];for(let b=0;b<l.length;b++){const f=l[b];r&&f._isTracked&&(r=!1);const k=f.range;if(f.text){let O=!0;t||(O=!T.$jf(f.text),t=O),!n&&O&&(n=T.$if(f.text)),!o&&O&&(o=T.$lf(f.text))}let F="",p=0,y=0,D=0;if(f.text){let O;[p,y,D,O]=(0,m.$ft)(f.text);const K=this.getEOL();O===0||O===(K===`\r
`?2:1)?F=f.text:F=f.text.replace(/\r\n|\r|\n/g,K)}a[b]={sortIndex:b,identifier:f.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:F,eolCount:p,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(R.u);let c=!1;for(let b=0,f=a.length-1;b<f;b++){const k=a[b].range.getEndPosition(),F=a[b+1].range.getStartPosition();if(F.isBeforeOrEqual(k)){if(F.isBefore(k))throw new Error("Overlapping ranges are not allowed!");c=!0}}r&&(a=this.s(a));const h=v||$?R._getInverseEditRanges(a):[],i=[];if($)for(let b=0;b<a.length;b++){const f=a[b],k=h[b];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let F=k.startLineNumber;F<=k.endLineNumber;F++){let p="";F===k.startLineNumber&&(p=this.getLineContent(f.range.startLineNumber),T.$Ve(p)!==-1)||i.push({lineNumber:F,oldContent:p})}}let s=null;if(v){let b=0;s=[];for(let f=0;f<a.length;f++){const k=a[f],F=h[f],p=this.getValueInRange(k.range),y=k.rangeOffset+b;b+=k.text.length-p.length,s[f]={sortIndex:k.sortIndex,identifier:k.identifier,range:F,text:p,textChange:new g.$1s(k.rangeOffset,p,y,k.text)}}c||s.sort((f,k)=>f.sortIndex-k.sortIndex)}this.g=n,this.h=o,this.j=t;const u=this.t(a);let d=null;if($&&i.length>0){i.sort((b,f)=>f.lineNumber-b.lineNumber),d=[];for(let b=0,f=i.length;b<f;b++){const k=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===k)continue;const F=i[b].oldContent,p=this.getLineContent(k);p.length===0||p===F||T.$Ve(p)!==-1||d.push(k)}}return this.m.fire(),new L.$2u(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const v=l[0].range,n=l[l.length-1].range,o=new I.$Fs(v.startLineNumber,v.startColumn,n.endLineNumber,n.endColumn);let t=v.startLineNumber,r=v.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const b=l[u],f=b.range;$=$||b.forceMoveMarkers,a.push(this.getValueInRange(new I.$Fs(t,r,f.startLineNumber,f.startColumn))),b.text.length>0&&a.push(b.text),t=f.endLineNumber,r=f.endColumn}const c=a.join(""),[h,i,s]=(0,m.$ft)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const $=[];for(let v=0;v<l.length;v++){const n=l[v],o=n.range.startLineNumber,t=n.range.startColumn,r=n.range.endLineNumber,a=n.range.endColumn;if(o===r&&t===a&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const c=new I.$Fs(o,t,r,a);$.push({range:c,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,v,n){return this.c.findMatchesLineByLine(l,$,v,n)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const v=l.startLineNumber,n=l.startColumn,[o,t,r]=(0,m.$ft)($);let a;if($.length>0){const c=o+1;c===1?a=new I.$Fs(v,n,v,n+t):a=new I.$Fs(v,n,v+c-1,r+1)}else a=new I.$Fs(v,n,v,n);return a}static _getInverseEditRanges(l){const $=[];let v=0,n=0,o=null;for(let t=0,r=l.length;t<r;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=v,h=n+(a.range.startColumn-o.range.endColumn)):(c=v+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new I.$Fs(c,h,c,h+a.firstLineLength):i=new I.$Fs(c,h,c+s-1,a.lastLineLength+1)}else i=new I.$Fs(c,h,c,h);v=i.endLineNumber,n=i.endColumn,$.push(i),o=a}return $}static u(l,$){const v=I.$Fs.compareRangesUsingEnds(l.range,$.range);return v===0?l.sortIndex-$.sortIndex:v}static w(l,$){const v=I.$Fs.compareRangesUsingEnds(l.range,$.range);return v===0?$.sortIndex-l.sortIndex:-v}}e.$TB=R}),define(Pe[144],Ae([1,0,12,91,143]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UB=void 0;class L{constructor(g,w,R,S,l,$,v,n,o){this.a=g,this.b=w,this.c=R,this.d=S,this.e=l,this.f=$,this.g=v,this.h=n,this.j=o}k(g){const w=this.c+this.d+this.e,R=this.c+this.e;return w===0?g===1?`
`:`\r
`:R>w/2?`\r
`:`
`}create(g){const w=this.k(g),R=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,$=R.length;l<$;l++){const v=R[l].buffer.replace(/\r\n|\r|\n/g,w),n=(0,T.$OB)(v);R[l]=new T.$RB(v,n)}const S=new I.$TB(R,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$rf(g)&&(this.b=E.$qf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$PB)(this.e,g);this.a.push(new T.$RB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$if(g)),this.k||(this.k=E.$lf(g)))}finish(g=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$OB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$UB=A}),define(Pe[96],Ae([1,0,24,21]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$=e.$e$=void 0;var I;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(I||(I={}));function L(S){for(let l=0,$=S.length;l<$;l+=4){const v=S[l+0],n=S[l+1],o=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=o,S[l+2]=n,S[l+3]=v}}function A(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||L(l),E.$ge.wrap(l)}function m(S){const l=S.buffer;if(T.$D()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function g(S){const l=new Uint32Array(w(S));let $=0;if(l[$++]=S.id,S.type==="full")l[$++]=1,l[$++]=S.data.length,l.set(S.data,$),$+=S.data.length;else{l[$++]=2,l[$++]=S.deltas.length;for(const v of S.deltas)l[$++]=v.start,l[$++]=v.deleteCount,v.data?(l[$++]=v.data.length,l.set(v.data,$),$+=v.data.length):l[$++]=0}return A(l)}e.$e$=g;function w(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const $ of S.deltas)$.data&&(l+=$.data.length)}return l}function R(S){const l=m(S);let $=0;const v=l[$++];if(l[$++]===1){const r=l[$++],a=l.subarray($,$+r);return $+=r,{id:v,type:"full",data:a}}const o=l[$++],t=[];for(let r=0;r<o;r++){const a=l[$++],c=l[$++],h=l[$++];let i;h>0&&(i=l.subarray($,$+h),$+=h),t[r]={start:a,deleteCount:c,data:i}}return{id:v,type:"delta",deltas:t}}e.$f$=R}),define(Pe[145],Ae([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,129,147,145]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(x,pe,Ue,Qe){this.id=x,this.name=pe,this.defaultValue=Ue,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}compute(x,pe,Ue){return Ue}}class l{constructor(x,pe){this.newValue=x,this.didChange=pe}}e.ApplyUpdateResult=l;function $(Z,x){if(typeof Z!="object"||typeof x!="object"||!Z||!x)return new l(x,Z!==x);if(Array.isArray(Z)||Array.isArray(x)){const Ue=Array.isArray(Z)&&Array.isArray(x)&&E.$ub(Z,x);return new l(x,!Ue)}let pe=!1;for(const Ue in x)if(x.hasOwnProperty(Ue)){const Qe=$(Z[Ue],x[Ue]);Qe.didChange&&(Z[Ue]=Qe.newValue,pe=!0)}return new l(Z,pe)}class v{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,pe){return $(x,pe)}validate(x){return this.defaultValue}}class n{constructor(x,pe,Ue,Qe){this.id=x,this.name=pe,this.defaultValue=Ue,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,pe,Ue){return Ue}}function o(Z,x){return typeof Z>"u"?x:Z==="false"?!1:!!Z}e.boolean=o;class t extends n{constructor(x,pe,Ue,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ue),super(x,pe,Ue,Qe)}validate(x){return o(x,this.defaultValue)}}function r(Z,x,pe,Ue){if(typeof Z>"u")return x;let Qe=parseInt(Z,10);return isNaN(Qe)?x:(Qe=Math.max(pe,Qe),Qe=Math.min(Ue,Qe),Qe|0)}e.clampedInt=r;class a extends n{static clampedInt(x,pe,Ue,Qe){return r(x,pe,Ue,Qe)}constructor(x,pe,Ue,Qe,tt,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ue,nt.minimum=Qe,nt.maximum=tt),super(x,pe,Ue,nt),this.minimum=Qe,this.maximum=tt}validate(x){return a.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function c(Z,x,pe,Ue){if(typeof Z>"u")return x;const Qe=h.float(Z,x);return h.clamp(Qe,pe,Ue)}e.clampedFloat=c;class h extends n{static clamp(x,pe,Ue){return x<pe?pe:x>Ue?Ue:x}static float(x,pe){if(typeof x=="number")return x;if(typeof x>"u")return pe;const Ue=parseFloat(x);return isNaN(Ue)?pe:Ue}constructor(x,pe,Ue,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ue),super(x,pe,Ue,tt),this.validationFn=Qe}validate(x){return this.validationFn(h.float(x,this.defaultValue))}}class i extends n{static string(x,pe){return typeof x!="string"?pe:x}constructor(x,pe,Ue,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ue),super(x,pe,Ue,Qe)}validate(x){return i.string(x,this.defaultValue)}}function s(Z,x,pe,Ue){return typeof Z!="string"?x:Ue&&Z in Ue?Ue[Z]:pe.indexOf(Z)===-1?x:Z}e.stringSet=s;class u extends n{constructor(x,pe,Ue,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Ue),super(x,pe,Ue,tt),this.c=Qe}validate(x){return s(x,this.defaultValue,this.c)}}class d extends S{constructor(x,pe,Ue,Qe,tt,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=tt,Ne.default=Qe),super(x,pe,Ue,Ne),this.c=tt,this.d=nt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function b(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,pe,Ue){return Ue===0?x.accessibilitySupport:Ue}}class k extends S{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var F;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(F||(e.TextEditorCursorBlinkingStyle=F={}));function p(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function O(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class K extends v{constructor(){super(140)}compute(x,pe,Ue){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),x.extraEditorClassName&&Qe.push(x.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class U extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,pe,Ue){return Ue&&x.emptySelectionClipboard}}class M extends S{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class B extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?B.OFF:x==="true"?B.ON:x:x?B.ON:B.OFF}}e.EditorFontLigatures=B;class C extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?C.OFF:x==="true"?C.TRANSLATE:x:x?C.TRANSLATE:C.OFF}compute(x,pe,Ue){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class P extends v{constructor(){super(50)}compute(x,pe,Ue){return x.fontInfo}}class X extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const pe=h.float(x,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(x,pe,Ue){return x.fontInfo.fontSize}}class ae extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(a.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class ge extends S{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ue,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ue,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ue,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ue,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ue,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends S{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:a.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var ke;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class de extends v{constructor(){super(143)}compute(x,pe,Ue){return de.computeLayout(pe,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const pe=x.height/x.lineHeight,Ue=Math.floor(x.paddingTop/x.lineHeight);let Qe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const tt=(Ue+x.viewLineCount+Qe)/(x.pixelRatio*x.height),nt=Math.floor(x.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:nt}}static c(x,pe){const Ue=x.outerWidth,Qe=x.outerHeight,tt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const nt=pe.stableMinimapLayoutInput,Ne=nt&&x.outerHeight===nt.outerHeight&&x.lineHeight===nt.lineHeight&&x.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&x.pixelRatio===nt.pixelRatio&&x.scrollBeyondLastLine===nt.scrollBeyondLastLine&&x.paddingTop===nt.paddingTop&&x.paddingBottom===nt.paddingBottom&&x.minimap.enabled===nt.minimap.enabled&&x.minimap.side===nt.minimap.side&&x.minimap.size===nt.minimap.size&&x.minimap.showSlider===nt.minimap.showSlider&&x.minimap.renderCharacters===nt.minimap.renderCharacters&&x.minimap.maxColumn===nt.minimap.maxColumn&&x.minimap.scale===nt.minimap.scale&&x.verticalScrollbarWidth===nt.verticalScrollbarWidth&&x.isViewportWrapping===nt.isViewportWrapping,It=x.lineHeight,Mt=x.typicalHalfwidthCharacterWidth,Kt=x.scrollBeyondLastLine,jt=x.minimap.renderCharacters;let wt=tt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const qt=x.minimap.maxColumn,Ft=x.minimap.size,Qt=x.minimap.side,Ot=x.verticalScrollbarWidth,Ct=x.viewLineCount,Ye=x.remainingWidth,Ht=x.isViewportWrapping,Gt=jt?2:3;let ut=Math.floor(tt*Qe);const mt=ut/tt;let zt=!1,Ut=!1,Et=Gt*wt,ht=wt/tt,Pt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Ee,desiredRatio:Fe,minimapLineCount:fe}=de.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Kt,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Qe,lineHeight:It,pixelRatio:tt});if(Ct/fe>1)zt=!0,Ut=!0,wt=1,Et=1,ht=wt/tt;else{let Re=!1,je=wt+1;if(Ft==="fit"){const Ze=Math.ceil((Lt+Ct+Ee)*Et);Ht&&Ne&&Ye<=pe.stableFitRemainingWidth?(Re=!0,je=pe.stableFitMaxMinimapScale):Re=Ze>ut}if(Ft==="fill"||Re){zt=!0;const Ze=wt;Et=Math.min(It*tt,Math.max(1,Math.floor(1/Fe))),Ht&&Ne&&Ye<=pe.stableFitRemainingWidth&&(je=pe.stableFitMaxMinimapScale),wt=Math.min(je,Math.max(1,Math.floor(Et/Gt))),wt>Ze&&(Pt=Math.min(2,wt/Ze)),ht=wt/tt/Pt,ut=Math.ceil(Math.max(ft,Lt+Ct+Ee)*Et),Ht?(pe.stableMinimapLayoutInput=x,pe.stableFitRemainingWidth=Ye,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Yt=Math.floor(qt*ht),Dt=Math.min(Yt,Math.max(0,Math.floor((Ye-Ot-2)*ht/(Mt+ht)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(tt*Dt);const Rt=qe/tt;qe=Math.floor(qe*Pt);const Wt=jt?1:2,Jt=Qt==="left"?0:Ue-Dt-Ot;return{renderMinimap:Wt,minimapLeft:Jt,minimapWidth:Dt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Ut,minimapScale:wt,minimapLineHeight:Et,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:mt}}static computeLayout(x,pe){const Ue=pe.outerWidth|0,Qe=pe.outerHeight|0,tt=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,Mt=pe.pixelRatio,Kt=pe.viewLineCount,jt=x.get(135),wt=jt==="inherit"?x.get(134):jt,qt=wt==="inherit"?x.get(130):wt,Ft=x.get(133),Qt=pe.isDominatedByLongLines,Ot=x.get(57),Ct=x.get(67).renderType!==0,Ye=x.get(68),Ht=x.get(104),Gt=x.get(83),ut=x.get(72),mt=x.get(102),zt=mt.verticalScrollbarSize,Ut=mt.verticalHasArrows,Et=mt.arrowSize,ht=mt.horizontalScrollbarSize,Pt=x.get(43),Yt=x.get(109)!=="never";let Dt=x.get(65);Pt&&Yt&&(Dt+=16);let qe=0;if(Ct){const _e=Math.max(nt,Ye);qe=Math.round(_e*It)}let Rt=0;Ot&&(Rt=tt*pe.glyphMarginDecorationLaneCount);let Wt=0,Jt=Wt+Rt,ft=Jt+qe,Lt=ft+Dt;const Ee=Ue-Rt-qe-Dt;let Fe=!1,fe=!1,G=-1;wt==="inherit"&&Qt?(Fe=!0,fe=!0):qt==="on"||qt==="bounded"?fe=!0:qt==="wordWrapColumn"&&(G=Ft);const Re=de.c({outerWidth:Ue,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Mt,scrollBeyondLastLine:Ht,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:ut,verticalScrollbarWidth:zt,viewLineCount:Kt,remainingWidth:Ee,isViewportWrapping:fe},pe.memory||new R);Re.renderMinimap!==0&&Re.minimapLeft===0&&(Wt+=Re.minimapWidth,Jt+=Re.minimapWidth,ft+=Re.minimapWidth,Lt+=Re.minimapWidth);const je=Ee-Re.minimapWidth,Ze=Math.max(1,Math.floor((je-zt-2)/Ne)),Ve=Ut?Et:0;return fe&&(G=Math.max(1,Ze),qt==="bounded"&&(G=Math.min(G,Ft))),{width:Ue,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Jt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Dt,contentLeft:Lt,contentWidth:je,minimap:Re,viewportColumn:Ze,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:G,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ht,overviewRuler:{top:Ve,width:zt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=de;class he extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return s(x,"simple",["simple","advanced"])}compute(x,pe,Ue){return pe.get(2)===2?"advanced":Ue}}var te;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(te||(e.ShowAiIconMode=te={}));class Se extends S{constructor(){const x={enabled:!0,experimental:{showAiIcon:te.Off}};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"boolean",default:x.enabled,description:m.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[te.Off,te.OnCode,te.On],default:x.experimental.showAiIcon,enumDescriptions:[m.localize(51,null),m.localize(52,null),m.localize(53,null)],description:m.localize(54,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:s(pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[te.Off,te.OnCode,te.On])}}}}class oe extends S{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(58,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends S{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(60,null),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(66,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class V extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):a.clampedInt(x,this.defaultValue,0,1e3)}compute(x,pe,Ue){return Ue<0?a.clampedInt(-Ue*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>h.clamp(x,0,150),{markdownDescription:m.localize(67,null)})}compute(x,pe,Ue){return x.fontInfo.lineHeight}}class Ie extends S{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:x.size,description:m.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(75,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(78,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(pe.scale,1,1,3),maxColumn:a.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(Z){return Z==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(80,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{top:a.clampedInt(pe.top,0,0,1e3),bottom:a.clampedInt(pe.bottom,0,0,1e3)}}}class ce extends S{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(82,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class ie extends v{constructor(){super(141)}compute(x,pe,Ue){return x.pixelRatio}}class Q extends S{constructor(){const x={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(83,null),m.localize(84,null),m.localize(85,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:x.strings,description:m.localize(86,null)},comments:{anyOf:pe,default:x.comments,description:m.localize(87,null)},other:{anyOf:pe,default:x.other,description:m.localize(88,null)}},default:x,markdownDescription:m.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Mt=x?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!x||typeof x!="object")return this.defaultValue;const{other:pe,comments:Ue,strings:Qe}=x,tt=["on","inline","off"];let nt,Ne,It;return typeof pe=="boolean"?nt=pe?"on":"off":nt=s(pe,this.defaultValue.other,tt),typeof Ue=="boolean"?Ne=Ue?"on":"off":Ne=s(Ue,this.defaultValue.comments,tt),typeof Qe=="boolean"?It=Qe?"on":"off":It=s(Qe,this.defaultValue.strings,tt),{other:nt,comments:Ne,strings:It}}}var ee;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class $e extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(90,null),m.localize(91,null),m.localize(92,null),m.localize(93,null)],default:"on",description:m.localize(94,null)})}validate(x){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(pe=4,Ue=x):x==="interval"?pe=3:x==="relative"?pe=2:x==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function be(Z){const x=Z.get(97);return x==="editable"?Z.get(90):x!=="on"}e.filterValidationDecorations=be;class Me extends S{constructor(){const x=[],pe={type:"number",description:m.localize(95,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(96,null),format:"color-hex"}}}]},default:x,description:m.localize(97,null)})}validate(x){if(Array.isArray(x)){const pe=[];for(const Ue of x)if(typeof Ue=="number")pe.push({column:a.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Qe=Ue;pe.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Ue,Qe)=>Ue.column-Qe.column),pe}return this.defaultValue}}class le extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function we(Z,x){if(typeof Z!="string")return x;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends S{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(102,null),m.localize(103,null),m.localize(104,null)],default:"auto",description:m.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(109,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x,Ue=a.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(pe.vertical,this.defaultValue.vertical),horizontal:we(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:a.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends S{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(116,null)}})}applyUpdate(x,pe){let Ue=!1;pe.allowedCharacters&&x&&(T.$kn(x.allowedCharacters,pe.allowedCharacters)||(x={...x,allowedCharacters:pe.allowedCharacters},Ue=!0)),pe.allowedLocales&&x&&(T.$kn(x.allowedLocales,pe.allowedLocales)||(x={...x,allowedLocales:pe.allowedLocales},Ue=!0));const Qe=super.applyUpdate(x,pe);return Ue?new l(Qe.newValue,!0):Qe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,pe){if(typeof x!="object"||!x)return pe;const Ue={};for(const[Qe,tt]of Object.entries(x))tt===!0&&(Ue[Qe]=!0);return Ue}}class H extends S{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(118,null),m.localize(119,null),m.localize(120,null)],description:m.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class j extends S{constructor(){const x={enabled:L.$cs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$cs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends S{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:x.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:x.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:x.highlightActiveIndentation,description:m.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Z,x,pe){const Ue=pe.indexOf(Z);return Ue===-1?x:pe[Ue]}class ye extends S{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:x.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:x.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(x.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,pe,Ue){return pe.get(2)===2?0:Ue}}class Xe extends v{constructor(){super(144)}compute(x,pe,Ue){const Qe=pe.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class rt extends S{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends S{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?ot:I.$k?at:et,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var pt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(pt||(e.EditorOption=pt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:Be(new f),accessibilityPageSize:Be(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:Be(new i(4,"ariaLabel",m.localize(206,null))),ariaRequired:Be(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:Be(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:Be(new t(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:Be(new j),bracketPairGuides:Be(new J),stickyTabStops:Be(new t(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:Be(new t(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:Be(new i(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:Be(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:Be(new t(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:Be(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:Be(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:Be(new t(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:Be(new k),contextmenu:Be(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:Be(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:Be(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:m.localize(248,null)})),cursorSurroundingLines:Be(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:Be(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:Be(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new t(34,"domReadOnly",!1)),dragAndDrop:Be(new t(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:Be(new U),dropIntoEditor:Be(new rt),stickyScroll:Be(new oe),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:Be(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(259,null)})),find:Be(new M),fixedOverflowWidgets:Be(new t(42,"fixedOverflowWidgets",!1)),folding:Be(new t(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:Be(new t(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:Be(new t(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:Be(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:Be(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:Be(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:Be(new P),fontLigatures2:Be(new B),fontSize:Be(new X),fontWeight:Be(new ae),fontVariations:Be(new C),formatOnPaste:Be(new t(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:Be(new t(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:Be(new t(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:Be(new ge),hideCursorInOverviewRuler:Be(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:Be(new ve),inDiffEditor:Be(new t(61,"inDiffEditor",!1)),letterSpacing:Be(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(273,null)})),lightbulb:Be(new Se),lineDecorationsWidth:Be(new V),lineHeight:Be(new ne),lineNumbers:Be(new $e),lineNumbersMinChars:Be(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new t(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:Be(new t(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:Be(new u(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:Be(new Ie),mouseStyle:Be(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:Be(new t(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(278,null)})),multiCursorMergeOverlapping:Be(new t(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:Be(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:Be(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:Be(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:Be(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:Be(new t(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:Be(new a(82,"overviewRulerLanes",3,0,3)),padding:Be(new Ce),pasteAs:Be(new it),parameterHints:Be(new ce),peekWidgetDefaultFocus:Be(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:Be(new t(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:Be(new Q),quickSuggestionsDelay:Be(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:Be(new t(90,"readOnly",!1)),readOnlyMessage:Be(new le),renameOnType:Be(new t(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:Be(new t(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:Be(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:Be(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Be(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:Be(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:Be(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new t(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:Be(new Me),scrollbar:Be(new N),scrollBeyondLastColumn:Be(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:Be(new t(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:Be(new t(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:Be(new t(106,"selectionClipboard",!0,{description:m.localize(312,null),included:I.$k})),selectionHighlight:Be(new t(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:Be(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:Be(new t(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:Be(new t(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:Be(new Y),snippetSuggestions:Be(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new t(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:Be(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new ye),inlineSuggest:Be(new H),inlineCompletionsAccessibilityVerbose:Be(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:Be(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new t(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:Be(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:Be(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:Be(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new q),unusualLineTerminators:Be(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:Be(new t(126,"useShadowDOM",!0)),useTabStops:Be(new t(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:Be(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:Be(new i(129,"wordSeparators",A.$ds,{description:m.localize(346,null)})),wordWrap:Be(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:Be(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:Be(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new K),defaultColorDecorators:Be(new t(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:Be(new ie),tabFocusMode:Be(new t(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:Be(new de),wrappingInfo:Be(new Xe),wrappingIndent:Be(new He),wrappingStrategy:Be(new he)}}),define(Pe[148],Ae([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[171],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[172],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[173],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Ae([1,0,11,150]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const S=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:R}),this.f.push($)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const S=this.c.substring(this.d,this.e),l=g.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,S=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const v=this.c.charCodeAt(R);if(S)S=!1;else if(v===47&&!l){R++;break}else v===91?l=!0:v===92?S=!0:v===93&&(l=!1);R++}for(;R<this.c.length&&g.a.has(this.c.charCodeAt(R));)R++;this.e=R;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=g}),define(Pe[182],Ae([1,0,25,31,152,294]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||A.test(t)}e.$Xo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=t.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Yo=w;function R(t){if(!t)return null;const r=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(r===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=m.exec(t.preRelease);if(d){const[,b,f,k]=d;u=Date.UTC(Number(b),Number(f)-1,Number(k))}}return{majorBase:r,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$Zo=R;function S(t,r,a){let c;typeof t=="string"?c=R(w(t)):c=t;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let i;if(typeof a=="string"?i=R(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let b=i.majorBase,f=i.minorBase,k=i.patchBase;const F=i.notBefore;let p=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:u>f?!0:u<f||h&&h<F?!1:d>=k:(s===1&&b===0&&(!p||!y||!D)&&(b=1,f=0,k=0,p=!0,y=!1,D=!1),s<b?!1:s>b?!p:u<f?!1:u>f?!y:d<k?!1:d>k?!D:!(h&&h<F))}e.$1o=S;function l(t,r,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Cg)(a,c.main);(0,E.$wg)(d,a)||i.push([T.default.Warning,I.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Cg)(a,c.browser);(0,E.$wg)(d,a)||i.push([T.default.Warning,I.localize(12,null,d.path,a.path)])}}if(!L.valid(c.version))return i.push([T.default.Error,I.localize(13,null)]),i;const s=[];if(!$(t,r,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$2o=l;function $(t,r,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:n(t,r,a.engines.vscode,h)}e.$3o=$;function v(t,r,a){return t==="*"||n(r,a,t)}e.$4o=v;function n(t,r,a,c=[]){const h=R(w(a));if(!h)return c.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,a)),!1;return S(t,r,h)?!0:(c.push(I.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let r=0,a=t.length;r<a;r++)if(typeof t[r]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class E{constructor(I,L=[],A=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Xh=E}),define(Pe[70],Ae([1,0,69]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.InstantiationType=void 0;const T=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L(m,g,w){g instanceof E.$Xh||(g=new E.$Xh(g,[],!!w)),T.push([m,g])}e.$Ir=L;function A(){return T}e.$Jr=A}),define(Pe[183],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;class E{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$nq=E;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const m=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(A);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let m=this.a.get(A);return m||(m=new E(A,L),this.a.set(A,m)),m}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,m]of this.a)L.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const m=new Set([L]),g=this.c(A,m);if(g)return g}}c(L,A){for(const[m,g]of L.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const w=this.c(g,A);if(w)return w;A.delete(m)}}}e.$oq=T}),define(Pe[4],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(E||(e._util=E={})),e.$Zh=I("instantiationService");function T(A,m,g){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:A,index:g}):(m[E.DI_DEPENDENCIES]=[{id:A,index:g}],m[E.DI_TARGET]=m)}function I(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const m=function(g,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,g,R)};return m.toString=()=>A,E.serviceIds.set(A,m),m}e.$1h=I;function L(A){return A}e.$2h=L}),define(Pe[41],Ae([1,0,16,2,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,I.$1h)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$vi=L;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$wi=A;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$yi=w;function R(t,r){const a=Object.create(null);for(const c in t)S(a,c,t[c],r);return a}e.$zi=R;function S(t,r,a,c){const h=r.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let b=s[d];switch(typeof b){case"undefined":b=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Ai=S;function l(t,r){const a=r.split(".");$(t,a)}e.$Bi=l;function $(t,r){const a=r.shift();if(r.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&($(c,r),Object.keys(c).length===0&&delete t[a])}}function v(t,r,a){function c(s,u){let d=s;for(const b of u){if(typeof d!="object"||d===null)return;d=d[b]}return d}const h=r.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Ci=v;function n(t,r,a){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in t?E.$Ff(t[c])&&E.$Ff(r[c])?n(t[c],r[c],a):a&&(t[c]=r[c]):t[c]=r[c])})}e.$Di=n;function o(t){return t.replace(/[\[\]]/g,"")}e.$Ei=o}),define(Pe[35],Ae([1,0,21,12,181,4,149,11]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(Y,V){if(g.get(Y)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(Y,V)}e.$Wi=w;const R=Object.prototype.hasOwnProperty;var S;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},$=(0,A.localize)(0,null),v=(0,A.localize)(1,null),n=(0,A.localize)(2,null),o=(0,A.localize)(3,null),t=(0,A.localize)(4,null),r=(0,A.localize)(5,null),a=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Le=Ie.type===17?r:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Vi.getLexeme(Ie),additionalInfo:Le}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),O.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ce=Le.lexeme,ce=Ce.lastIndexOf("/"),ie=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),ie)}catch{throw this.B("REGEX",Le)}return P.create(ne,Q)}switch(Le.type){case 10:case 19:{const Ce=[Le.lexeme];this.z();let ce=this.D(),ie=0;for(let Me=0;Me<Le.lexeme.length;Me++)Le.lexeme.charCodeAt(Me)===40?ie++:Le.lexeme.charCodeAt(Me)===41&&ie--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Me=0;Me<ce.lexeme.length;Me++)ce.lexeme.charCodeAt(Me)===40?ie++:Le.lexeme.charCodeAt(Me)===41&&ie--}if(ie<0)break;Ce.push(I.$Vi.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),$e=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let be;try{be=new RegExp(Q.substring(1,ee),$e)}catch{throw this.B("REGEX",Le)}return i.regex(ne,be)}case 18:{const Ce=Le.lexeme;this.z();let ce=null;if(!(0,T.$Ge)(Ce)){const ie=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(ie!==Q&&ie>=0){const ee=Ce.slice(ie+1,Q),$e=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,$e)}catch{throw this.B("REGEX",Le)}}}if(ce===null)throw this.B("REGEX",Le);return P.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Le=this.u();return i.notIn(ne,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return i.equals(ne,Le);switch(Le){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return i.notEquals(ne,Le);switch(Le){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Le)}}case 5:return this.z(),B.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),U.create(ne,this.u());case 8:return this.z(),M.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Le=(0,A.localize)(8,null,V,I.$Vi.getLexeme(ne)),Ce=ne.offset,ce=I.$Vi.getLexeme(ne);return this.h.push({message:Le,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=h;class i{static false(){return b.INSTANCE}static true(){return f.INSTANCE}static has(V){return k.create(V)}static equals(V,ne){return F.create(V,ne)}static notEquals(V,ne){return D.create(V,ne)}static regex(V,ne){return P.create(V,ne)}static in(V,ne){return p.create(V,ne)}static notIn(V,ne){return y.create(V,ne)}static not(V){return O.create(V)}static and(...V){return ge.create(V,null,!0)}static or(...V){return ve.create(V,null,!0)}static greater(V,ne){return U.create(V,ne)}static greaterEquals(V,ne){return M.create(V,ne)}static smaller(V,ne){return B.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Yi=i;function s(Y){const V=new h({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,A.localize)(9,null,Ie.additionalInfo):(0,A.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$Zi=s;function u(Y,V){const ne=Y?Y.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$1i=u;function d(Y,V){return Y.cmp(V)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$2i=b;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return b.INSTANCE}}e.$3i=f;class k{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:b.INSTANCE:new k(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:de(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:b.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$4i=k;class F{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?k.create(V,Ie):O.create(V,Ie);const Le=g.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?f.INSTANCE:b.INSTANCE:new F(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?f.INSTANCE:b.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$5i=F;class p{static create(V,ne){return new p(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:he(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$6i=p;class y{static create(V,ne){return new y(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=p.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=y;class D{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?O.create(V,Ie):k.create(V,Ie);const Le=g.get(V);return typeof Le=="boolean"?ne===(Le?"true":"false")?b.INSTANCE:f.INSTANCE:new D(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?b.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$8i=D;class O{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?b.INSTANCE:f.INSTANCE:new O(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?b.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$9i=O;function K(Y,V){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?V(Y):b.INSTANCE}class U{static create(V,ne,Ie=null){return K(ne,Le=>new U(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$0i=U;class M{static create(V,ne,Ie=null){return K(ne,Le=>new M(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$$i=M;class B{static create(V,ne,Ie=null){return K(ne,Le=>new B(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$_i=B;class C{static create(V,ne,Ie=null){return K(ne,Le=>new C(V,Le,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$aj=C;class P{static create(V,ne){return new P(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$bj=P;class X{static create(V){return new X(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new X(this.c.map(V))}negate(){return this.c}}e.$cj=X;function ae(Y){let V=null;for(let ne=0,Ie=Y.length;ne<Ie;ne++){const Le=Y[ne].substituteConstants();if(Y[ne]!==Le&&V===null){V=[];for(let Ce=0;Ce<ne;Ce++)V[Ce]=Y[Ce]}V!==null&&(V[ne]=Le)}return V===null?Y:V}class ge{static create(V,ne,Ie){return ge.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Le=d(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:ge.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Le=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return b.INSTANCE;if(ce.type===6){Le.push(...ce.expr);continue}Le.push(ce)}if(Le.length===0&&Ce)return f.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(d);for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ce=Le[Le.length-1];if(ce.type!==9)break;Le.pop();const ie=Le.pop(),Q=Le.length===0,ee=ve.create(ce.expr.map($e=>ge.create([$e,ie],null,Ie)),null,Q);ee&&(Le.push(ee),Le.sort(d))}if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let ie=ce+1;ie<Le.length;ie++)if(Le[ce].negate().equals(Le[ie]))return b.INSTANCE;if(Le.length===1)return Le[0]}return new ge(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ge(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=ve.create(V,this,!0)}return this.c}}e.$dj=ge;class ve{static create(V,ne,Ie){return ve.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Le=d(this.expr[ne],V.expr[ne]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:ve.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Le=[],Ce=!1;if(V){for(let ce=0,ie=V.length;ce<ie;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&Ce)return b.INSTANCE;Le.sort(d)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ce=1;ce<Le.length;ce++)Le[ce-1].equals(Le[ce])&&(Le.splice(ce,1),ce--);if(Le.length===1)return Le[0];if(Ie){for(let ce=0;ce<Le.length;ce++)for(let ie=ce+1;ie<Le.length;ie++)if(Le[ce].negate().equals(Le[ie]))return f.INSTANCE;if(Le.length===1)return Le[0]}return new ve(Le,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ve(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Le=[];for(const Ce of oe(ne))for(const ce of oe(Ie))Le.push(ge.create([Ce,ce],null,!1));V.unshift(ve.create(Le,null,!1))}this.c=ve.create(V,this,!0)}return this.c}}e.$ej=ve;class ke extends k{static{this.d=[]}static all(){return ke.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?ke.d.push({...Ie,key:V}):Ie!==!0&&ke.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return F.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$fj=ke,e.$gj=(0,L.$1h)("contextKeyService");function de(Y,V){return Y<V?-1:Y>V?1:0}function he(Y,V,ne,Ie){return Y<ne?-1:Y>ne?1:V<Ie?-1:V>Ie?1:0}function te(Y,V){if(Y.type===0||V.type===1)return!0;if(Y.type===9)return V.type===9?Se(Y.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(te(Y,ne))return!0;return!1}if(Y.type===6){if(V.type===6)return Se(V.expr,Y.expr);for(const ne of Y.expr)if(te(ne,V))return!0;return!1}return Y.equals(V)}e.$hj=te;function Se(Y,V){let ne=0,Ie=0;for(;ne<Y.length&&Ie<V.length;){const Le=Y[ne].cmp(V[Ie]);if(Le<0)return!1;Le===0&&ne++,Ie++}return ne===Y.length}function oe(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[184],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,E.$1h)("environmentService"),e.$9h=(0,E.$2h)(e.$8h)}),define(Pe[97],Ae([1,0,151,4]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$jo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0,e.$0n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$n=new RegExp(e.$0n),e.$_n="__web_extension",e.$ao="skipWalkthrough",e.$bo="extensionsSync",e.$co="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$do=I;function L(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$eo=L;function A(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$fo=A;function m(t,r){return r==="web"&&!t.includes("web")}e.$go=m;function g(t,r,a){return m(r,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$ho=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$io=w;var R;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$jo=(0,T.$1h)("extensionGalleryService");var v;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var n;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$ko=o,e.$lo=(0,T.$1h)("extensionManagementService"),e.$mo="extensionsIdentifiers/disabled",e.$no="extensionsIdentifiers/enabled",e.$oo=(0,T.$1h)("IGlobalExtensionEnablementService"),e.$po=(0,T.$1h)("IExtensionTipsService"),e.$qo=(0,E.localize)(0,null),e.$ro={value:e.$qo,original:"Extensions"},e.$so={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[42],Ae([1,0,50,19,12,16,2,153,4,21,13,39]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileKind=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileOperationResult=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileChangeType=e.$Ck=e.FileOperation=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileSystemProviderErrorCode=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderCapabilities=e.$mk=e.FilePermission=e.FileType=e.$lk=e.$kk=void 0,e.$kk=(0,g.$1h)("fileService");function l(te){return te.create===!0}e.$lk=l;var $;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function n(te){const Se=te;return!!Se&&typeof Se.onDidChange=="function"}e.$mk=n;var o;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(te){return!!(te.capabilities&2)}e.$nk=t;function r(te){return!!(te.capabilities&8)}e.$ok=r;function a(te){return!!(te.capabilities&131072)}e.$pk=a;function c(te){return!!(te.capabilities&4)}e.$qk=c;function h(te){return!!(te.capabilities&16)}e.$rk=h;function i(te){return t(te)?!!(te.capabilities&16384):!1}e.$sk=i;function s(te){return t(te)?!!(te.capabilities&32768):!1}e.$tk=s;function u(te){return!!(te.capabilities&65536)}e.$uk=u;function d(te){return!!(te.capabilities&2048)}e.$vk=d;var b;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class f extends Error{static create(Se,oe){const Y=new f(Se.toString(),oe);return p(Y,oe),Y}constructor(Se,oe){super(Se),this.code=oe}}e.$wk=f;function k(te,Se){return f.create(te,Se)}e.$xk=k;function F(te){return te||k((0,m.localize)(0,null),b.Unknown)}e.$yk=F;function p(te,Se){return te.name=Se?`${Se} (FileSystemError)`:"FileSystemError",te}e.$zk=p;function y(te){if(!te)return b.Unknown;if(te instanceof f)return te.code;const Se=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Se)return b.Unknown;switch(Se[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$Ak=y;function D(te){if(te instanceof C)return te.fileOperationResult;switch(y(te)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$Bk=D;var O;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class K{constructor(Se,oe,Y){this.resource=Se,this.operation=oe,this.target=Y}isOperation(Se){return this.operation===Se}}e.$Ck=K;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class M{static{this.a=null}constructor(Se,oe){this.c=oe,this.b=void 0,this.d=new S.$V(()=>{const Y=E.$7h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(V=>[V,!0])),Y}),this.f=new S.$V(()=>{const Y=E.$7h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(V=>[V,!0])),Y}),this.g=new S.$V(()=>{const Y=E.$7h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(V=>[V,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Se){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==M.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Se,...oe){return this.h(Se,{includeChildren:!1},...oe)}affects(Se,...oe){return this.h(Se,{includeChildren:!0},...oe)}h(Se,oe,...Y){if(!Se)return!1;const V=Y.length>0;return!!((!V||Y.includes(1))&&(this.d.value.get(Se)||oe.includeChildren&&this.d.value.findSuperstr(Se))||(!V||Y.includes(0))&&(this.f.value.get(Se)||oe.includeChildren&&this.f.value.findSuperstr(Se))||(!V||Y.includes(2))&&(this.g.value.findSubstr(Se)||oe.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$Dk=M;function B(te,Se,oe){return!te||!Se||te===Se||Se.length>te.length?!1:(Se.charAt(Se.length-1)!==T.sep&&(Se+=T.sep),oe?(0,I.$8e)(te,Se):te.indexOf(Se)===0)}e.$Ek=B;class C extends Error{constructor(Se,oe,Y){super(Se),this.fileOperationResult=oe,this.options=Y}}e.$Fk=C;class P extends C{constructor(Se,oe,Y,V){super(Se,oe,V),this.fileOperationResult=oe,this.size=Y}}e.$Gk=P;class X extends C{constructor(Se,oe,Y){super(Se,2,Y),this.stat=oe}}e.$Hk=X;var ae;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Ik={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Jk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Kk="files.associations",e.$Lk="files.exclude",e.$Mk="files.readonlyInclude",e.$Nk="files.readonlyExclude",e.$Ok="files.readonlyFromPermissions";var ge;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.$Pk="";function ve(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Qk=ve;async function ke(te,Se){if(!Se.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(oe=>{const Y=Se.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===te.scheme&&V.added&&(Y.dispose(),oe())})})}e.$Rk=ke;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Se){return(0,L.$Hf)(Se)||(Se=0),Se<de.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<de.MB?(0,m.localize)(2,null,(Se/de.KB).toFixed(2)):Se<de.GB?(0,m.localize)(3,null,(Se/de.MB).toFixed(2)):Se<de.TB?(0,m.localize)(4,null,(Se/de.GB).toFixed(2)):(0,m.localize)(5,null,(Se/de.TB).toFixed(2))}}e.$Sk=de;function he(te){const Se=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*de.MB:Se?10*de.MB:w.$o?50*de.MB:1024*de.MB}e.$Tk=he}),define(Pe[71],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(...I){this.a=new Map;for(const[L,A]of I)this.set(L,A)}set(I,L){const A=this.a.get(I);return this.a.set(I,L),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Yh=E}),define(Pe[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;const R=!1;class S extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$Yh,t=!1,r,a=R){this.f=o,this.g=t,this.h=r,this.i=a,this.o=new Set,this.f.set(m.$Zh,this),this._globalGraph=a?r?._globalGraph??new A.$oq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const r=v.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,r);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,r.stop()}}createInstance(o,...t){let r,a;return o instanceof L.$Xh?(r=v.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),r)):(r=v.traceCreation(this.i,o),a=this.j(o,t,r)),r.stop(),a}j(o,t=[],r){const a=m._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,r);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof L.$Xh)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.l(o);return r instanceof L.$Xh?this.q(o,r,t.branch(o,!0)):(t.branch(o,!1),r)}q(o,t,r){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,r)}finally{this.o.delete(o)}}r(o,t,r){const a=new A.$oq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:r}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new S(a);for(const s of m._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof L.$Xh){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new S(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof L.$Xh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,r=[],a,c){if(this.f.get(o)instanceof L.$Xh)return this.t(o,t,r,a,c);if(this.h)return this.h.s(o,t,r,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,r=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$hh(()=>{const u=h.j(t,r,c);for(const[d,b]of i){const f=u[d];if(typeof f=="function")for(const k of b)f.apply(u,k)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let k=i.get(d);return k||(k=new w.$3c,i.set(d,k)),(p,y,D)=>{const O=k.push([p,y,D]);return(0,I.$Qc)(O)}}if(d in u)return u[d];const b=s.value;let f=b[d];return typeof f!="function"||(f=f.bind(b),u[d]=f),f},set(u,d,b){return s.value[d]=b,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,r,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$pq=l;var $;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})($||($={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new v(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(o,t){return o?new v(1,t.name):v.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const r=new v(3,o.toString());return this.h.push([o,t,r]),r}stop(){const o=Date.now()-this.g;v.f+=o;let t=!1;function r(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,b]of h.h)if(d&&b){t=!0,i.push(`${s}CREATES -> ${u}`);const f=r(c+1,b);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(o>2||t)&&v.all.add(a.join(`
`))}}e.$qq=v}),define(Pe[15],Ae([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,l.$1h)("logService"),e.$jj=(0,l.$1h)("loggerService");function $(){return new Date().toISOString()}function v(p){return(0,w.$Hf)(p)}e.$kj=v;var n;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(n||(e.LogLevel=n={})),e.$lj=n.Info;function o(p,y,D){switch(y){case n.Trace:p.trace(D);break;case n.Debug:p.debug(D);break;case n.Info:p.info(D);break;case n.Warning:p.warn(D);break;case n.Error:p.error(D);break;case n.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(p,y=!1){let D="";for(let O=0;O<p.length;O++){let K=p[O];if(K instanceof Error&&(K=(0,E.$Li)(K,y)),typeof K=="object")try{K=JSON.stringify(K)}catch{}D+=(O>0?" ":"")+K}return D}class r extends L.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==n.Off&&this.b<=y}}e.$nj=r;class a extends r{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(n.Trace)&&this.g(n.Trace,t([y,...D],!0))}debug(y,...D){this.f(n.Debug)&&this.g(n.Debug,t([y,...D]))}info(y,...D){this.f(n.Info)&&this.g(n.Info,t([y,...D]))}warn(y,...D){this.f(n.Warning)&&this.g(n.Warning,t([y,...D]))}error(y,...D){if(this.f(n.Error))if(y instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=y.stack,this.g(n.Error,t(O))}else this.g(n.Error,t([y,...D]))}flush(){}}e.$oj=a;class c extends r{constructor(y=e.$lj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...D){this.f(n.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}debug(y,...D){this.f(n.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}info(y,...D){this.f(n.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}warn(y,...D){this.f(n.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,y,...D):console.warn(`[main ${$()}]`,y,...D))}error(y,...D){this.f(n.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,y,...D):console.error(`[main ${$()}]`,y,...D))}dispose(){}flush(){}}e.$pj=c;class h extends r{constructor(y=e.$lj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(n.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(n.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(n.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(n.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(n.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}dispose(){}flush(){}}e.$qj=h;class i extends r{constructor(y,D=e.$lj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(n.Trace)&&this.g.log(n.Trace,[this.h(y),...D])}debug(y,...D){this.f(n.Debug)&&this.g.log(n.Debug,[this.h(y),...D])}info(y,...D){this.f(n.Info)&&this.g.log(n.Info,[this.h(y),...D])}warn(y,...D){this.f(n.Warning)&&this.g.log(n.Warning,[this.h(y),...D])}error(y,...D){this.f(n.Error)&&this.g.log(n.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Li)(y,this.f(n.Trace))}dispose(){}flush(){}}e.$rj=i;class s extends r{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const O of this.g)O.trace(y,...D)}debug(y,...D){for(const O of this.g)O.debug(y,...D)}info(y,...D){for(const O of this.g)O.info(y,...D)}warn(y,...D){for(const O of this.g)O.warn(y,...D)}error(y,...D){for(const O of this.g)O.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$sj=s;class u extends L.$Sc{constructor(y,D,O){if(super(),this.h=y,this.j=D,this.b=new A.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,O)for(const K of O)this.b.set(K.resource,{logger:void 0,info:K})}m(y){return(0,w.$Df)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const O=this.n(y),K=(0,w.$Df)(y)?y:D?.id??(0,I.$Oi)(O.toString()).toString(16);let U=this.b.get(O)?.logger;const M=D?.logLevel==="always"?n.Trace:D?.logLevel;U||(U=this.s(O,M??this.getLogLevel(O)??this.h,{...D,id:K}));const B={logger:U,info:{resource:O,id:K,logLevel:M,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(B.info),this.b.set(O,B),U}n(y){return(0,w.$Df)(y)?(0,g.$Cg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(R.URI.isUri(y)){const O=y,K=D,U=this.b.get(O);U&&K!==U.info.logLevel&&(U.info.logLevel=K===this.h?void 0:K,U.logger?.setLevel(K),this.b.set(U.info.resource,U),this.f.fire([O,K]))}else{this.h=y;for(const[O,K]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const O=this.m(y);O&&D!==!O.info.hidden&&(O.info.hidden=!D,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(y){}getLevel(){return n.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$uj=d;class b extends d{}e.$vj=b;function f(p){if(p.verbose)return n.Trace;if(typeof p.logLevel=="string"){const y=F(p.logLevel.toLowerCase());if(y!==void 0)return y}return e.$lj}e.$wj=f;function k(p){switch(p){case n.Trace:return"trace";case n.Debug:return"debug";case n.Info:return"info";case n.Warning:return"warn";case n.Error:return"error";case n.Off:return"off"}}e.$xj=k;function F(p){switch(p){case"trace":return n.Trace;case"debug":return n.Debug;case"info":return n.Info;case"warn":return n.Warning;case"error":return n.Error;case"critical":return n.Error;case"off":return n.Off}}e.$yj=F,e.$zj=new S.$fj("logLevel",k(n.Info))}),define(Pe[187],Ae([1,0,6,15]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;class I extends E.$Sc{constructor(A,m=[]){super(),this.a=new T.$sj([A,...m]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$_N=I}),define(Pe[99],Ae([1,0,31,154,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(g){function w(v,n){return n-v}g.compare=w;const R=Object.create(null);R[g.Error]=(0,T.localize)(0,null),R[g.Warning]=(0,T.localize)(1,null),R[g.Info]=(0,T.localize)(2,null);function S(v){return R[v]||""}g.toString=S;function l(v){switch(v){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function $(v){switch(v){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=$}(A||(e.MarkerSeverity=A={}));var m;(function(g){const w="";function R(l){return S(l,!0)}g.makeKey=R;function S(l,$){const v=[w];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(w),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(w),l.severity!==void 0&&l.severity!==null?v.push(A.toString(l.severity)):v.push(w),l.message&&$?v.push(l.message.replace("\xA6","\\\xA6")):v.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(w),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(w),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(w),v.push(w),v.join("\xA6")}g.makeKeyOptionalMessage=S})(m||(e.IMarkerData=m={})),e.$lt=(0,I.$1h)("markerService")}),define(Pe[188],Ae([1,0,5,31,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$av=e.Severity=void 0,e.Severity=T.default,e.$av=(0,I.$1h)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$bv=g;class w{infinite(){}done(){}total(S){}worked(S){}}e.$cv=w}),define(Pe[189],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,E.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(me,e,E,T){var I=arguments.length,L=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,E,T);else for(var m=me.length-1;m>=0;m--)(A=me[m])&&(L=(I<3?A(L):I>3?A(e,E,L):A(e,E))||L);return I>3&&L&&Object.defineProperty(e,E,L),L},Ke=this&&this.__param||function(me,e){return function(E,T){e(E,T,me)}};define(Pe[72],Ae([1,0,14,20,6,4]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProgressLocation=e.$dv=void 0,e.$dv=(0,L.$1h)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$ev=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$fv=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$gv=g;let w=class extends I.$Sc{constructor(l,$){super(),this.a=new E.$lh,$.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$hv=w,e.$hv=w=Ge([Ke(1,e.$dv)],w);class R extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const $=++this.a,v=new T.$3d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>v.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:$,token:v.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$iv=R,e.$jv=(0,L.$1h)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;class I{constructor(){this.a=new Map}add(A,m){E.ok(T.$Df(A)),E.ok(T.$Ff(m)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$sn=new I}),define(Pe[73],Ae([1,0,5,30]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0,e.$tn={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class L{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[I(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;T.$sn.add(e.$tn.JSONContribution,A)}),define(Pe[54],Ae([1,0,18,5,16,148,41,73,30]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.ConfigurationScope=e.$xn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$xn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En="vscode://schemas/settings/resourceLanguage",e.$Fn="vscode://schemas/settings/configurationDefaults";const S=g.$sn.as(m.$tn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$En,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),S.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),S.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),S.registerSchema(e.$En,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:b}of i)for(const f in d)if(s.add(f),e.$Hn.test(f)){const k=this.a.get(f),F=k?.valuesSources??new Map;if(b)for(const O of Object.keys(d[f]))F.set(O,b);const p={...k?.value||{},...d[f]};this.a.set(f,{source:b,value:p,valuesSources:F});const y=(0,A.$Ei)(f),D={type:"object",default:p,description:L.localize(1,null,y),$ref:e.$En,defaultDefaultValue:p,source:I.$Df(b)?void 0:b,defaultValueSource:b};u.push(...n(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:b});const k=this.d[f];k&&(this.w(f,k),this.r(f,k))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const b in u){const f=this.a.get(b),k=I.$Df(d)?d:d?.id,F=I.$Df(f?.source)?f?.source:f?.source?.id;if(k===F)if(s.add(b),this.a.delete(b),e.$Hn.test(b))delete this.d[b],delete this.b.properties[b];else{const p=this.d[b];p&&(this.w(b,p),this.r(b,p))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const b in d.properties){s.add(b);const f=this.d[b];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[b],this.s(b,d.properties[b])}d.allOf?.forEach(b=>u(b))};for(const d of i){u(d);const b=this.c.indexOf(d);b!==-1&&this.c.splice(b,1)}}p(i,s=!0,u,d,b=3,f){b=I.$Mf(i.scope)?b:i.scope;const k=i.properties;if(k)for(const p in k){const y=k[p];if(s&&a(p,y)){delete k[p];continue}if(y.source=u,y.defaultDefaultValue=k[p].default,this.w(p,y),e.$Hn.test(p)?y.scope=void 0:(y.scope=I.$Mf(y.scope)?b:y.scope,y.restricted=I.$Mf(y.restricted)?!!d?.includes(p):y.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.f[p]=k[p],delete k[p];continue}else this.d[p]=k[p],k[p].policy?.name&&this.e.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),f.add(p)}const F=i.allOf;if(F)for(const p of F)this.p(p,s,u,d,b,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$yn.properties[i]=s,s.scope){case 1:e.$zn.properties[i]=s;break;case 2:e.$An.properties[i]=s;break;case 6:e.$Bn.properties[i]=s;break;case 3:e.$Cn.properties[i]=s;break;case 4:e.$Dn.properties[i]=s;break;case 5:e.$Dn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$yn.properties[i],s.scope){case 1:delete e.$zn.properties[i];break;case 2:delete e.$An.properties[i];break;case 6:delete e.$Bn.properties[i];break;case 3:delete e.$Cn.properties[i];break;case 4:case 5:delete e.$Dn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$En};this.w(s,u),e.$yn.properties[s]=u,e.$zn.properties[s]=u,e.$An.properties[s]=u,e.$Bn.properties[s]=u,e.$Cn.properties[s]=u,e.$Dn.properties[s]=u}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$En};e.$yn.patternProperties[e.$Gn]=i,e.$zn.patternProperties[e.$Gn]=i,e.$An.patternProperties[e.$Gn]=i,e.$Bn.patternProperties[e.$Gn]=i,e.$Cn.patternProperties[e.$Gn]=i,e.$Dn.patternProperties[e.$Gn]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,b=u?.source;I.$Kf(d)&&(d=s.defaultDefaultValue,b=void 0),I.$Kf(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=b}}const $="\\[([^\\]]+)\\]",v=new RegExp($,"g");e.$Gn=`^(${$})+$`,e.$Hn=new RegExp(e.$Gn);function n(h){const i=[];if(e.$Hn.test(h)){let s=v.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=v.exec(h)}}return(0,E.$Mb)(i)}e.$In=n;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Jn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Kn=t;const r=new l;g.$sn.add(e.$xn.Configuration,r);function a(h,i){return h.trim()?e.$Hn.test(h)?L.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):i.policy?.name&&r.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,h,i.policy?.name,r.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$Ln=a;function c(){const h=[],i=r.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Mn=c}),define(Pe[190],Ae([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0;function $(s){return Object.isFrozen(s)?s:m.$hn(s)}class v{constructor(u={},d=[],b=[],f){this.b=u,this.c=d,this.d=b,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof v)return d;const b=new n("");return b.parseRaw(d),b.configurationModel});this.f=u.reduce((d,b)=>b===d?b:d.merge(b),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,R.$Ci)(this.contents,u):this.contents}inspect(u,d){const b=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,k=d?this.rawConfiguration.override(d).getValue(u):b;return{value:b,override:f,merged:k}}getOverrideValue(u,d){const b=this.i(d);return b?u?(0,R.$Ci)(b,u):b:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const b of this.overrides)b.identifiers.includes(u)&&d.push(...b.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=m.$gn(this.contents),b=m.$gn(this.overrides),f=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const F of u)if(k.push(...F.raw?.length?F.raw:[F]),!F.isEmpty()){this.h(d,F.contents);for(const p of F.overrides){const[y]=b.filter(D=>E.$ub(D.identifiers,p.identifiers));y?(this.h(y.contents,p.contents),y.keys.push(...p.keys),y.keys=E.$Mb(y.keys)):b.push(m.$gn(p))}for(const p of F.keys)f.indexOf(p)===-1&&f.push(p)}return new v(d,f,b,k.every(F=>F instanceof v)?void 0:k)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const b={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let k=this.contents[f];const F=d[f];F&&(typeof k=="object"&&typeof F=="object"?(k=m.$gn(k),this.h(k,F)):k=F),b[f]=k}return new v(b,this.keys,this.overrides)}h(u,d){for(const b of Object.keys(d)){if(b in u&&g.$Ff(u[b])&&g.$Ff(d[b])){this.h(u[b],d[b]);continue}u[b]=m.$gn(d[b])}}i(u){let d=null,b=null;const f=k=>{k&&(b?this.h(b,k):b=m.$gn(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===u?d=k.contents:k.identifiers.includes(u)&&f(k.contents);return f(d),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,R.$Bi)(this.contents,u),S.$Hn.test(u)&&this.overrides.splice(this.overrides.findIndex(b=>E.$ub(b.identifiers,(0,S.$In)(u))),1))}j(u,d,b){(0,R.$Ai)(this.contents,u,d,f=>console.error(f)),b=b||this.keys.indexOf(u)===-1,b&&this.keys.push(u),S.$Hn.test(u)&&this.overrides.push({identifiers:(0,S.$In)(u),keys:Object.keys(this.contents[u]),contents:(0,R.$zi)(this.contents[u],f=>console.error(f))})}}e.$Nn=v;class n{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Mf(u)){const b=this.g(u);this.parseRaw(b,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:b,keys:f,overrides:k,restricted:F,hasExcludedProperties:p}=this.h(u,d);this.b=new v(b,f,k,p?[u]:void 0),this.c=F||[]}g(u){let d={},b=null,f=[];const k=[],F=[];function p(D){Array.isArray(f)?f.push(D):b!==null&&(f[b]=D)}const y={onObjectBegin:()=>{const D={};p(D),k.push(f),f=D,b=null},onObjectProperty:D=>{b=D},onObjectEnd:()=>{f=k.pop()},onArrayBegin:()=>{const D=[];p(D),k.push(f),f=D,b=null},onArrayEnd:()=>{f=k.pop()},onLiteralValue:p,onError:(D,O,K)=>{F.push({error:D,offset:O,length:K})}};if(u)try{I.$dn(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const b=l.$sn.as(S.$xn.Configuration).getConfigurationProperties(),f=this.i(u,b,!0,d);u=f.raw;const k=(0,R.$zi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),F=Object.keys(u),p=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:k,keys:F,overrides:p,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,b,f){let k=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:k};const F={},p=[];for(const y in u)if(S.$Hn.test(y)&&b){const D=this.i(u[y],d,!1,f);F[y]=D.raw,k=k||D.hasExcludedProperties,p.push(...D.restricted)}else{const D=d[y],O=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&p.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(O===void 0||f.scopes===void 0||f.scopes.includes(O))&&!(f.skipRestricted&&D?.restricted))?F[y]=u[y]:k=!0}return{raw:F,restricted:p,hasExcludedProperties:k}}j(u,d){const b=[];for(const f of Object.keys(u))if(S.$Hn.test(f)){const k={};for(const F in u[f])k[F]=u[f][F];b.push({identifiers:(0,S.$In)(f),keys:Object.keys(k),contents:(0,R.$zi)(k,d)})}return b}}e.$On=n;class o extends L.$Sc{constructor(u,d,b,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&b.isEqual(k.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Pn=o;class t{constructor(u,d,b,f,k,F,p,y,D,O,K,U,M){this.a=u,this.b=d,this.c=b,this.overrideIdentifiers=f,this.d=k,this.f=F,this.g=p,this.h=y,this.i=D,this.j=O,this.k=K,this.l=U,this.m=M}get value(){return $(this.c)}n(u,d,b){const f=u.inspect(d,b);return{get value(){return $(f.value)},get override(){return $(f.override)},get merged(){return $(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(u,d,b,f,k=new v,F=new v,p=new A.$Ac,y=new v,D=new A.$Ac){this.c=u,this.d=d,this.f=b,this.g=f,this.h=k,this.i=F,this.j=p,this.l=y,this.m=D,this.a=null,this.b=new A.$Ac,this.n=null}getValue(u,d,b){return this.p(u,d,b).getValue(u)}updateValue(u,d,b={}){let f;b.resource?(f=this.m.get(b.resource),f||(f=new v,this.m.set(b.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),b.resource||(this.a=null)}inspect(u,d,b){const f=this.p(u,d,b),k=this.t(d.resource,b),F=d.resource?this.m.get(d.resource)||this.l:this.l,p=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&p.add(D);return new t(u,d,f.getValue(u),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,k||void 0,F)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const b=[];if(!d){const{added:f,updated:k,removed:F}=h(this.c,u);d=[...f,...k,...F]}for(const f of d)for(const k of(0,S.$In)(f)){const F=this.c.getKeysForOverrideIdentifier(k),p=u.getKeysForOverrideIdentifier(k),y=[...p.filter(D=>F.indexOf(D)===-1),...F.filter(D=>p.indexOf(D)===-1),...F.filter(D=>!m.$kn(this.c.override(k).getValue(D),u.override(k).getValue(D)))];b.push([k,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:b}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:b,removed:f}=h(this.d,u),k=[...d,...b,...f];return k.length&&this.updatePolicyConfiguration(u),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:b,removed:f,overrides:k}=h(this.applicationConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateApplicationConfiguration(u),{keys:F,overrides:k}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:k}=h(this.localUserConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateLocalUserConfiguration(u),{keys:F,overrides:k}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:k}=h(this.remoteUserConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateRemoteUserConfiguration(u),{keys:F,overrides:k}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:b,removed:f,overrides:k}=h(this.workspaceConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateWorkspaceConfiguration(u),{keys:F,overrides:k}}compareAndUpdateFolderConfiguration(u,d){const b=this.folderConfigurations.get(u),{added:f,updated:k,removed:F,overrides:p}=h(b,d),y=[...f,...k,...F];return(y.length||!b)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:p}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:b,updated:f,removed:k,overrides:F}=h(d,void 0);return{keys:[...b,...f,...k],overrides:F}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,b){let f=this.q(d,b);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let b=this.r();if(d&&u){const f=d.getFolder(u);f&&(b=this.s(f.uri)||b);const k=this.m.get(u);k&&(b=b.merge(k))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const b=this.r(),f=this.j.get(u);f?(d=b.merge(f),this.b.set(u,d)):d=b}return d}t(u,d){if(d&&u){const b=d.getFolder(u);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:b,overrides:f,keys:k}=this.j.get(d);return u.push([d,{contents:b,overrides:f,keys:k}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(b=>u.add(b))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(b=>u.add(b))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.i.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),b=this.w(u.policy),f=this.w(u.application),k=this.w(u.user),F=this.w(u.workspace),p=u.folders.reduce((y,D)=>(y.set(w.URI.revive(D[0]),this.w(D[1])),y),new A.$Ac);return new r(d,b,f,k,new v,F,p,new v,new A.$Ac)}static w(u){return new v(u.contents,u.keys,u.overrides)}}e.$Qn=r;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(k=>u.add(k)),f.overrides.forEach(([k,F])=>{const p=(0,A.$xc)(d,k,new Set);F.forEach(y=>p.add(y))});const b=[];return d.forEach((f,k)=>b.push([k,[...f.values()]])),{keys:[...u.values()],overrides:b}}e.$Rn=a;class c{constructor(u,d,b,f){this.change=u,this.f=d,this.g=b,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of u.keys)this.affectedKeys.add(k);for(const[,k]of u.overrides)for(const F of k)this.affectedKeys.add(F);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(u,d){const b=this.a+u,f=this.d.indexOf(b);if(f<0)return!1;const k=f+b.length;if(k>=this.d.length)return!1;const F=this.d.charCodeAt(k);if(F!==this.b&&F!==this.c)return!1;if(d){const p=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!m.$kn(p,y)}return!0}}e.$Sn=c;function h(s,u){const{added:d,removed:b,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),k=[],F=s?.getAllOverrideIdentifiers()||[],p=u?.getAllOverrideIdentifiers()||[];if(u){const y=p.filter(D=>!F.includes(D));for(const D of y)k.push([D,u.getKeysForOverrideIdentifier(D)])}if(s){const y=F.filter(D=>!p.includes(D));for(const D of y)k.push([D,s.getKeysForOverrideIdentifier(D)])}if(u&&s){for(const y of F)if(p.includes(y)){const D=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});k.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:b,updated:f,overrides:k}}function i(s,u){const d=s?u?s.keys.filter(k=>u.keys.indexOf(k)===-1):[...s.keys]:[],b=u?s?u.keys.filter(k=>s.keys.indexOf(k)===-1):[...u.keys]:[],f=[];if(s&&u){for(const k of u.keys)if(s.keys.indexOf(k)!==-1){const F=(0,R.$Ci)(u.contents,k),p=(0,R.$Ci)(s.contents,k);m.$kn(F,p)||f.push(k)}}return{added:d,removed:b,updated:f}}}),define(Pe[100],Ae([1,0,11,4]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.RemoteAuthorityResolverErrorCode=e.$4k=e.$3k=e.RemoteConnectionType=e.$2k=void 0,e.$2k=(0,T.$1h)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$3k=L;class A{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$4k=A;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends E.$bb{static isNotAvailable(S){return S instanceof g&&S._code===m.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof g&&S._code===m.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof g&&S._code===m.NoResolverFound}static isInvalidAuthority(S){return S instanceof g&&S._code===m.InvalidAuthority}static isHandled(S){return S instanceof g&&S.isHandled}constructor(S,l=m.Unknown,$){super(S),this._message=S,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,g.prototype)}}e.$5k=g;function w(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.$6k=w}),define(Pe[55],Ae([1,0,13]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$7k=T;function I(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$8k=I;function L(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$9k=L;function A(w){const{host:R,port:S}=g(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.$0k=A;function m(w,R){let{host:S,port:l}=g(w);return typeof l>"u"&&(l=R),{host:S,port:l}}e.$$k=m;function g(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.TargetPlatform=e.ExtensionType=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l="extensions.user.cache",e.$am="extensions.builtin.cache",e.$bm="undefined_publisher",e.$cm=["ui","workspace","web"];function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$dm=L,e.$em=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const r=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$7e(r,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$fm=g;class w{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$gm=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$hm=R;function S(n){return l(n)}e.$im=S;function l(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.$jm=l;function $(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.$km=$;function v(n,o){if(o){const t=`onResolveRemoteAuthority:${(0,I.$8k)(o)}`;return!!n.activationEvents?.includes(t)}return!1}e.$lm=v,e.$mm=(0,T.$1h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.$YE=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const g of A){const w=this.readActivationEvents(g);w.length>0&&(m[T.$fm.toKey(g.identifier)]=w)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${T.$fm.toKey(A.identifier)}`);if(!A.contributes)return m;for(const g in A.contributes){const w=this.a.get(g);if(!w)continue;const R=A.contributes[g],S=Array.isArray(R)?R:[R];try{w(S,m)}catch(l){(0,E.$1)(l)}}return m}}e.$YE=I,e.$ZE=new I}),define(Pe[191],Ae([1,0,21,74,33]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=void 0;function L(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,w,R,S,l,$,v,n,o){const t=Object.create(null);t["common.machineId"]=$,t["common.sqmId"]=v,t.sessionID=(0,I.$lg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=R,t["common.product"]=o||"desktop",n&&(t["common.msftInternal"]=n);let r=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=L(w);return c&&(t["common.platformDetail"]=c),t}e.$to=A;function m(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return g.some(S=>R===S)}e.$uo=m}),define(Pe[192],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=void 0,e.$ol=(0,E.$1h)("telemetryService"),e.$pl=(0,E.$1h)("customEndpointTelemetryService"),e.$ql="telemetry.currentSessionDate",e.$rl="telemetry.firstSessionDate",e.$sl="telemetry.lastSessionDate",e.$tl="telemetry.machineId",e.$ul="telemetry.sqmId",e.$vl="telemetry",e.$wl="telemetry.telemetryLevel",e.$xl="telemetry.enableCrashReporter",e.$yl="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[56],Ae([1,0,26,16,5,41,55,191,192]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=void 0;class w{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$vo=w;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wo=R,e.$xo=new R;class S{async publicLog(b,f,k){}async publicLogError(b,f,k){}}e.$yo=S,e.$zo="telemetry",e.$Ao="extensionTelemetryLog",e.$Bo={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,b){return I.Event.debounce(b.onDidChangeConfiguration,(k,F)=>{const p=k?new Set([...k.affectedKeys,...F.affectedKeys]):F.affectedKeys;return{...F,affectedKeys:p}},1e3,!0)(k=>{k.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.$xi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Co=l;function $(d,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!d.enableTelemetry)}e.$Do=$;function v(d,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Eo=v;function n(d){const b=d.getValue(g.$wl),f=d.getValue(g.$xl);if(d.getValue(g.$yl)===!1||f===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Fo=n;function o(d){const b={},f={},k={};a(d,k);for(let F in k){F=F.length>150?F.substr(F.length-149):F;const p=k[F];typeof p=="number"?f[F]=p:typeof p=="boolean"?f[F]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${F} has been trimmed to 8192, the original length is ${p.length}`),b[F]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(b[F]=p)}return{properties:b,measurements:f}}e.$Go=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const b=(0,A.$8k)(d);return t.has(b)?b:"other"}e.$Ho=r;function a(d,b,f=0,k){if(d)for(const F of Object.getOwnPropertyNames(d)){const p=d[F],y=k?k+F:F;Array.isArray(p)?b[y]=(0,E.$ln)(p):p instanceof Date?b[y]=p.toISOString():(0,T.$Ff)(p)?f<2?a(p,b,f+1,y+"."):b[y]=(0,E.$ln)(p):b[y]=p}}function c(d,b){const f=d.msftInternalDomains||[],k=b.getValue("telemetry.internalTesting");return(0,m.$uo)(f)||k}e.$Io=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Jo=h;function i(d,b){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const k=[];for(const D of b)for(;;){const O=D.exec(d);if(!O)break;k.push([O.index,D.lastIndex])}const F=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=p.exec(d);if(!D)break;const O=k.some(([K,U])=>D.index<U&&K<p.lastIndex);!F.test(D[0])&&!O&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=p.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of b)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,b){return(0,E.$in)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let k=f.replaceAll("%20"," ");k=i(k,b);for(const F of b)k=k.replace(F,"");return k=s(k),k}})}e.$Ko=u}),define(Pe[193],Ae([1,0,12,97,22,21,2,11,74,56]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;function R(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$2e)(u.id,d.id)===0}e.$Lo=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const b=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,b,f)}static parse(d){const b=S.exec(d);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(d,b,f="undefined"){this.version=b,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Mo=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(u){const d=$.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$No=v;function n(u,d){return`${u}.${d}`}e.$Oo=n;function o(u){return u.toLowerCase()}e.$Po=o;function t(u,d){return o(n(u??I.$bm,d))}e.$Qo=t;function r(u,d){const b=[],f=k=>{for(const F of b)if(F.some(p=>R(d(p),d(k))))return F;return null};for(const k of u){const F=f(k);F?F.push(k):b.push([k])}return b}e.$Ro=r;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$So=a;function c(u){return{id:new w.$vo(u.identifier.id),name:new w.$vo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$To=c,e.$Uo=new I.$fm("pprice.better-merge");function h(u,d){const b=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const k=f.shift();if(k&&b.every(F=>!R(F.identifier,{id:k}))){const F=u.filter(p=>R(p.identifier,{id:k}));F.length===1&&(b.push(F[0]),f.push(...F[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$Vo=h;async function i(u,d){if(!L.$k)return!1;let b;try{b=(await u.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await u.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){d.debug("Error while getting the os-release file.",(0,m.$0)(k))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const b=await i(u,d),f=(0,T.$fo)(b?"alpine":L.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Wo=s}),define(Pe[194],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=void 0;function E(g){return[...g.entries()]}e.$wr=E;function T(g){return g?[...g.entries()]:[]}e.$xr=T;function I(g){return new Map(g)}e.$yr=I;function L(g){return new Map(g??[])}e.$zr=L;function A(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$Ar=A;function m(g){return new Map(g.map(w=>[w[0],{map:I(w[1]),descriptionMap:L(w[2])}]))}e.$Br=m}),define(Pe[195],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,L,A=5){const m=L(g=>{const w=typeof g=="string"?g:g.data;let R=this.a.get(I);if(R){R.data.push(w);return}const S=setTimeout(()=>this.flushBuffer(I),A);R={data:[w],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(I),m.dispose()}},this.a.set(I,R)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const L=this.a.get(I);L&&(this.a.delete(I),this.b(I,L.data.join("")))}}e.$orb=E}),define(Pe[196],Ae([1,0,14,90,45,5,16,2,155,73,30]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.IconFontDefinition=e.IconContribution=e.$gw=void 0,e.$gw={IconContribution:"base.contributions.icons"};var S;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=v.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(S||(e.IconContribution=S={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,A.$Df)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,A.$Df)(d.format)&&(0,A.$Df)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new L.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const k=this.e.enum.indexOf(h);k!==-1&&(this.e.enumDescriptions[k]=s),this.a.fire()}return d}const b={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=b;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,b)=>d.id.localeCompare(b.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(b=>!!b.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(b=>!I.ThemeIcon.isThemeIcon(b.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const v=new $;R.$sn.add(e.$gw.IconContribution,v);function n(c,h,i,s){return v.registerIcon(c,h,i,s)}e.$hw=n;function o(){return v}e.$iw=o;function t(){const c=(0,T.$5j)();for(const h in c){const i="\\"+c[h].toString(16);v.registerIcon(h,{fontCharacter:i})}}t(),e.$jw="vscode://schemas/icons";const r=R.$sn.as(w.$tn.JSONContribution);r.registerSchema(e.$jw,v.getIconSchema());const a=new E.$ah(()=>r.notifySchemaChanged(e.$jw),200);v.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$kw=n("widget-close",T.$7j.close,(0,g.localize)(2,null)),e.$lw=n("goto-previous-location",T.$7j.arrowUp,(0,g.localize)(3,null)),e.$mw=n("goto-next-location",T.$7j.arrowDown,(0,g.localize)(4,null)),e.$nw=I.ThemeIcon.modify(T.$7j.sync,"spin"),e.$ow=I.ThemeIcon.modify(T.$7j.loading,"spin")}),define(Pe[197],Ae([1,0,5,41,4,15]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.ProvidedOnAutoForward=e.$mv=e.TunnelPrivacyId=e.TunnelProtocol=e.$lv=e.$kv=void 0,e.$kv=(0,I.$1h)("tunnelService"),e.$lv=(0,I.$1h)("sharedTunnelsService");var A;(function(o){o.Http="http",o.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(o){return!!o.forwardPort}e.$mv=g;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$nv=R,e.$ov=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(o){return e.$ov.indexOf(o)>=0}e.$pv=S,e.$qv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$qv.indexOf(o)>=0}e.$rv=l;function $(o,t,r,a){if(r===1)return!1;if(r===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$sv=$;class v{constructor(t,r,a){this.remoteAddress=t,this.localAddress=r,this.b=a,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$tv=v;let n=class{constructor(t,r){this.j=t,this.k=r,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],r=Array.from(this.e.values());for(const a of r){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:r}of t.values())await r.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,r,a,c,h){this.p(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(l(t)||S(t))&&(t=e.$ov[0]);const a=this.r(t,r);if(a)return++a.refcount,a.value}openTunnel(t,r,a,c,h,i=!1,s,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(r||(r="localhost"),c||(c=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.s(d,r,a,c,h,i,s,u);return b?b.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,a),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(f);return(f.tunnelRemoteHost!==r||f.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.e.get(t.tunnelRemoteHost);if(r){const a=r.get(t.tunnelRemotePort);a&&(a.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async o(t,r,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(r),c}}async closeTunnel(t,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const a=this.e.get(t);if(a&&a.has(r)){const c=a.get(r);c.refcount=0,await this.o(t,r,c)}}p(t,r,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(r,{refcount:1,value:a})}async q(t,r){const a=this.e.get(t);if(a){const c=a.get(r),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(r),a.size===0&&this.e.delete(t)}}r(t,r){const a=[t];S(t)?(a.push(...e.$ov),a.push(...e.$qv)):l(t)&&a.push(...e.$qv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(r);if(i)return i}}canTunnel(t){return!!R(t)}t(t,r,a,c,h,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${a} on local port ${c}.`);const u=a;this.i.add(u);const d=c===void 0?a:c,b={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:r,port:a},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:s},k=t.forwardPort(f,b);return k?(this.p(r,a,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),k}};e.$uv=n,e.$uv=n=Ge([Ke(0,L.$ij),Ke(1,T.$ui)],n)}),define(Pe[198],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$vv=void 0,e.$vv=(0,E.$1h)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[199],Ae([1,0,13]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$hK=T;function I(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$iK=I;function L(g){return I(g)?.scheme}e.$jK=L;function A(g){return I(g)?.authority}e.$kK=A;function m(g){return I(g)!==void 0}e.$lK=m}),define(Pe[47],Ae([1,0,156,19,50,25,2,4,13]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,m.$1h)("contextService");function w(d){const b=d;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}e.$$h=w;function R(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$_h=R,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function S(d,b){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:b?e.$ai:e.$bi;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$ci=S;function l(d){const b=d;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}e.$di=l;function $(d){const b=d;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$ei=$;var v;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function n(d){const b=d;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$fi=n;function o(d){const b=d;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$gi=o;class t{constructor(b,f,k,F,p){this.h=b,this.j=k,this.k=F,this.l=p,this.c=I.$7h.forUris(this.l,()=>!0),this.folders=f}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=I.$7h.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=t;class r{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,L.$Cg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=r;function a(d){return new r({uri:d,index:0,name:(0,L.$yg)(d)},{uri:d.toString()})}e.$ji=a,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,E.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function c(d,b){return L.$tg.isEqualOrParent(d,b.untitledWorkspacesHome)}e.$oi=c;function h(d){let b;return A.URI.isUri(d)?b=d:b=d.configuration,b?.scheme===g.Schemas.tmp}e.$pi=h,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$qi}e.$ri=i;function s(d,b){return!c(d,b)&&!h(d)}e.$si=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,L.$Ag)(d))===e.$li}e.$ti=u}),define(Pe[75],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const L=this.c++;return this.b.set(L,I),this.e(),L}get(I,L){return this.b.has(I)?this.b.get(I)[L]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Wec=E}),define(Pe[43],Ae([1,0,13,25,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=e.$Zec=void 0;class L{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$rg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Zec=L,e.$1ec=(0,I.$1h)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=void 0,e.$5M=(0,E.$1h)("IExtHostInitDataService")}),define(Pe[200],Ae([1,0,161,15,187,27]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;let A=class extends I.$_N{constructor(g,w,R){const S=R.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=R.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(S,{name:l}))}};e.$7gc=A,e.$7gc=A=Ge([Ke(1,T.$jj),Ke(2,L.$5M)],A)}),define(Pe[201],Ae([1,0,14]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;class T{constructor(A,m,g){this.h=new Map,this.a=A,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$ah(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const S of w.values())S.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let g=this.f[A];return typeof g>"u"&&(g=m),g}update(A,m){this.f[A]=m;const g=this.h.get(A);if(g!==void 0)return g.p;const w=new E.$lh;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Ifc=T;class I extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$Jfc=I}),define(Pe[202],Ae([1,0,5,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class I{constructor(A){this.c=A,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,g,w){const S=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(m.value,g,w);this.b.fire(S)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$wgc=I}),define(Pe[17],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0,e.$OM=(0,E.$1h)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$PM=T}),define(Pe[203],Ae([1,0,22,5]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class I{#e;constructor(A,m){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=E.$fm.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$Qfc=I}),define(Pe[57],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,E.$1h)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$hfc=T}),define(Pe[204],Ae([1,0,24]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=e.$Rkb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function I(m,g){if(g.serializeBuffersForPostMessage){const w=new T,S=JSON.stringify(m,($,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v)};if(ArrayBuffer.isView(v)){const n=L(v);if(n)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v.buffer),view:{type:n,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=w.buffers.map($=>{const v=new Uint8Array($);return E.$ge.wrap(v)});return{message:S,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Rkb=I;function L(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,g){const w=g.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),R=g.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const v=$,{index:n}=v,o=w[n];if(v.view)switch(v.view.type){case 1:return new Int8Array(o,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return $}:void 0;return{message:JSON.parse(m,R),arrayBuffers:w}}e.$Skb=A}),define(Pe[102],Ae([1,0,171,16,2,6,4,30,42,13,40,134,31]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.$HE=e.EditorsOrder=e.$GE=e.CloseDirection=e.$FE=e.$EE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.EditorInputCapabilities=e.$vE=e.SaveReason=e.Verbosity=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=void 0,e.$iE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$jE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$kE="workbench.editor.sidebysideEditor",e.$lE="workbench.editors.textDiffEditor",e.$mE="workbench.editors.binaryResourceDiffEditor";var $;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var v;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function n(oe){const Y=oe;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$nE=n;function o(oe,Y,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===Y&&oe.matches(ne.input))return ne.getViewState()}e.$oE=o;function t(oe){if(k(oe))return!1;const Y=oe;return I.URI.isUri(Y?.resource)}e.$pE=t;function r(oe){if(k(oe))return!1;const Y=oe;return Y?.original!==void 0&&Y.modified!==void 0}e.$qE=r;function a(oe){if(k(oe))return!1;const Y=oe;return Array.isArray(Y?.resources)}e.$rE=a;function c(oe){if(k(oe)||r(oe))return!1;const Y=oe;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$sE=c;function h(oe){if(k(oe))return!1;const Y=oe;return Y?Y.resource===void 0||Y.resource.scheme===w.Schemas.untitled||Y.forceUntitled===!0:!1}e.$tE=h;function i(oe){if(k(oe))return!1;const Y=oe;return I.URI.isUri(Y?.base?.resource)&&I.URI.isUri(Y?.input1?.resource)&&I.URI.isUri(Y?.input2?.resource)&&I.URI.isUri(Y?.result?.resource)}e.$uE=i;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(Y,V){let ne=this.a.get(Y);return ne||(ne={source:Y,label:V},this.a.set(Y,ne)),ne.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$vE=new d;var b;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class f extends L.$Sc{}e.$wE=f;function k(oe){return oe instanceof f}e.$xE=k;function F(oe){const Y=oe;return I.URI.isUri(Y?.preferredResource)}function p(oe){const Y=oe;return k(Y?.primary)&&k(Y?.secondary)}e.$yE=p;function y(oe){const Y=oe;return k(Y?.modified)&&k(Y?.original)}e.$zE=y;function D(oe,Y,V,ne,Ie){return Se(ne,[(0,S.$Ki)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};oe.openEditor(Y,Le)}}),(0,S.$Ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$AE=D;function O(oe){return k(oe?.editor)}e.$BE=O;function K(oe){const Y=oe;return O(oe)&&Y?.group!==void 0}e.$CE=K;function U(oe){const Y=oe;return typeof Y?.groupId=="number"&&k(Y.editor)}e.$DE=U;var M;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var B;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var C;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class P{getOriginalUri(Y,V){if(!Y)return;if(i(Y))return e.$FE.getOriginalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===C.PRIMARY?Ie:Le}}if(r(Y)||a(Y)||c(Y)||i(Y))return;const ne=F(Y)?Y.preferredResource:Y.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(Y){return p(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:y(Y)||r(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,V){if(!Y)return;if(i(Y))return e.$FE.getCanonicalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Le}=this.a(Y);if(Ie&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===C.PRIMARY?Ie:Le}}if(r(Y)||a(Y)||c(Y)||i(Y))return;const ne=Y.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(Y,V){if(Array.isArray(V)){if(V.some(ne=>Y.scheme===ne))return Y}else if(V===Y.scheme)return Y}}var X;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function ae(oe,Y,V,ne){if(!oe.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===X.MOUSE||V===X.KEYBOARD;case"mouse":return V===X.MOUSE;case"keyboard":return V===X.KEYBOARD}return!1}e.$EE=ae,e.$FE=new P;var ge;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class ve{constructor(){this.c=new Map,this.d=new Map}start(Y){const V=this.a=Y.get(A.$Zh);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(Y,V,ne){const Ie=ne.createInstance(V);this.d.set(Y,Ie)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Of)(this.b)}registerEditorSerializer(Y,V){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,V,this.a):this.c.set(Y,V),(0,L.$Qc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}m.$sn.add(e.$iE.EditorFactory,new ve);async function ke(oe,Y,V){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,ce=ne.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await Y.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return Ce?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$GE=ke;var de;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function he(oe){const Y=oe;if(!Y)return!1;const V=Y;if(V.modified)return he(V.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$HE=he;function te(oe){return(0,R.$Mi)(oe)}e.$IE=te;function Se(oe,Y,V){const ne=(0,R.$Ni)(oe,Y);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$JE=Se}),define(Pe[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SE=e.$RE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$QE=e.$PE=e.ViewContentGroups=e.$OE=e.$NE=e.ViewContainerLocation=e.Extensions=e.$ME=e.$LE=e.$KE=void 0,e.$KE="views",e.$LE=(0,T.localize)(0,null),e.$ME=(0,S.$hw)("default-view-icon",R.$7j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$NE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$OE=v;class n extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,b){const f=this.get(u.id);if(f)return f;const k=u;return k.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$xc)(this.g,d,[]).push(k),b?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:d}),k}deregisterViewContainer(u){for(const d of this.g.keys()){const b=this.g.get(d),f=b?.indexOf(u);if(f!==-1){b?.splice(f,1),b.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}m.$sn.add(l.ViewContainersRegistry,new n);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,b=u.group??o.More;return d!==b?d.localeCompare(b):(s.order??5)-(u.order??5)}class r extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:b})=>this.r(d,b)),this.c.fire(u)}deregisterViews(u,d){const b=this.s(u,d);b.length&&this.f.fire({views:b,viewContainer:d})}moveViews(u,d){for(const b of this.m.keys())if(b!==d){const f=this.s(u,b);f.length&&(this.r(f,d),this.g.fire({views:f,from:b,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const b=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(b)return b}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,L.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const b=new Map;for(const[f,k]of d)this.n.add(u,k),b.set(f,(0,L.$Qc)(()=>{this.n.delete(u,k),this.h.fire(u)}));return this.h.fire(u),b}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,b=>d.push(b)),d.sort(t)}r(u,d){let b=this.m.get(d);b||(b=[],this.m.set(d,b),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));b.push(f)}}s(u,d){const b=this.m.get(d);if(!b)return[];const f=[],k=[];for(const F of b)u.includes(F)?f.push(F):k.push(F);return f.length&&(k.length?this.m.set(d,k):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}m.$sn.add(l.ViewsRegistry,new r),e.$PE=(0,I.$1h)("viewsService"),e.$QE=(0,I.$1h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$jn)(this,u),this.d=!!d,this.resolve=async b=>{if(d&&!this.c){const f=await d(b);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$RE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$SE=i}),define(Pe[206],Ae([1,0,2,29,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$JF=e.$IF=void 0;function L(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Fs.isIRange)}e.$IF=L;function A(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(L)}e.$JF=A;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.InteractiveSessionCopyKind=g={})),e.$KF=(0,I.$1h)("IChatService")}),define(Pe[207],Ae([1,0,5,14,173]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,w,R){const S={command:m};if(g&&Object.keys(g).length>0&&(S.arguments=g),this.s("request",S),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(S.seq);if($){this.f.delete(S.seq);const v={type:"response",seq:0,request_seq:S.seq,success:!1,command:m,message:(0,I.localize)(0,null,R,m)};$(v)}},R)}return w&&this.f.set(S.seq,w),S.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$2g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,w)=>m.set(w,g)),await(0,T.$2g)(500),m.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$llb=L}),define(Pe[208],Ae([1,0,174,35,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$tH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$sH=e.MemoryRangeType=e.$rH=e.State=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0,e.$oG="workbench.view.debug",e.$pG="workbench.debug.variablesView",e.$qG="workbench.debug.watchExpressionsView",e.$rG="workbench.debug.callStackView",e.$sG="workbench.debug.loadedScriptsView",e.$tG="workbench.debug.breakPointsView",e.$uG="workbench.debug.disassemblyView",e.$vG="workbench.panel.repl",e.$wG="workbench.panel.repl.view",e.$xG=new T.$fj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$yG=new T.$fj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$zG=new T.$fj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$AG="debugUx",e.$BG=new T.$fj(e.$AG,"default",{type:"string",description:E.localize(3,null)}),e.$CG=new T.$fj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$DG=new T.$fj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$EG=new T.$fj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$FG=new T.$fj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$GG=new T.$fj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$HG=new T.$fj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$IG=new T.$fj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$JG=new T.$fj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$KG=new T.$fj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$LG=new T.$fj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$MG=new T.$fj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$NG=new T.$fj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$OG=new T.$fj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$PG=new T.$fj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$QG=new T.$fj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$RG=new T.$fj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$SG=new T.$fj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$TG=new T.$fj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$UG=new T.$fj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$VG=new T.$fj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$WG=new T.$fj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$XG=new T.$fj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$YG=new T.$fj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$ZG=new T.$fj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$1G=new T.$fj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$2G=new T.$fj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$3G=new T.$fj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$4G=new T.$fj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$5G=new T.$fj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$6G=new T.$fj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$7G=new T.$fj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$8G=new T.$fj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$9G=new T.$fj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$0G=new T.$fj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$$G=new T.$fj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$_G=new T.$fj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$aH=new T.$fj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$bH=new T.$fj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$cH=new T.$fj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$dH=new T.$fj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$eH=new T.$fj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$fH=new T.$fj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$gH=new T.$fj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$hH=new T.$fj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$iH=new T.$fj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$jH=new T.$fj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$kH=new T.$fj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$lH=new T.$fj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const L=l=>E.localize(52,null,l);e.$mH=L,e.$nH="editor.contrib.debug",e.$oH="editor.contrib.breakpoint",e.$pH="debug",e.$qH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var A;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(A||(e.State=A={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$rH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$sH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$tH=(0,I.$1h)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[209],Ae([1,0,12,2,19,26,13,29,20,18]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=void 0;const R=/{([^}]+)}/g;function S(F,p,y){return F.replace(R,function(D,O){return p&&O.length>0&&O[0]!=="_"?D:y&&y.hasOwnProperty(O)?y[O]:D})}e.$PF=S;function l(F){const p={};for(const y of Object.keys(F))y.startsWith("!")||(p[y]=F[y]);return p}e.$QF=l;function $(F){return F.configuration.request==="attach"&&!v(F)&&(!F.parentSession||$(F.parentSession))}e.$RF=$;function v(F){let p=F.configuration.type;if(p)return p==="vslsShare"&&(p=F.configuration.adapterProxy.configuration.type),(0,E.$7e)(p,"extensionhost")||(0,E.$7e)(p,"pwa-extensionhost")?F:F.parentSession?v(F.parentSession):void 0}e.$SF=v;function n(F){return F.type&&(F.label||F.program||F.runtime)}e.$TF=n;function o(F,p,y){let D,O=0;const K=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=K.exec(F);){const M=U.index+1,B=M+U[0].length;if(M<=p&&B>=y){D=U[0],O=M;break}}if(D){const M=/\w+/g;let B=null;for(;(B=M.exec(D))&&!(B.index+1+O+B[0].length>=y););B&&(D=D.substring(0,M.lastIndex))}return D?{start:O,end:O+D.length-1}:{start:0,end:0}}e.$UF=o;async function t(F,p,y,D){if(F.evaluatableExpressionProvider.has(p)){const O=F.evaluatableExpressionProvider.ordered(p),K=(0,w.$Hb)(await Promise.all(O.map(async U=>{try{return await U.provideEvaluatableExpression(p,y,D??g.CancellationToken.None)}catch{return}})));if(K.length>0){let U=K[0].expression;const M=K[0].range;return U||(U=p.getLineContent(y.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:U}}}else{const O=p.getLineContent(y.lineNumber),{start:K,end:U}=o(O,y.column,y.column),M=O.substring(K-1,U);return{matchingExpression:M,range:new m.$Fs(y.lineNumber,K,y.lineNumber,K+M.length)}}return null}e.$VF=t;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(F){return!!(F&&F.match(r))}e.$WF=a;function c(F){if(typeof F.path=="string"&&!(typeof F.sourceReference=="number"&&F.sourceReference>0)){if(a(F.path))return T.URI.parse(F.path);if((0,I.$ic)(F.path))return T.URI.file(F.path)}return F.path}function h(F){if(typeof F.path=="object"){const p=T.URI.revive(F.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return F.path}function i(F,p){const y=p?c:h,D=(0,L.$gn)(F);return u(D,(O,K)=>{O&&K&&(K.path=y(K))}),D}e.$XF=i;function s(F,p){const y=p?c:h,D=(0,L.$gn)(F);return u(D,(O,K)=>{!O&&K&&(K.path=y(K))}),D}e.$YF=s;function u(F,p){switch(F.type){case"event":{const y=F;switch(y.event){case"output":p(!1,y.body.source);break;case"loadedSource":p(!1,y.body.source);break;case"breakpoint":p(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=F;switch(y.command){case"setBreakpoints":p(!0,y.arguments.source);break;case"breakpointLocations":p(!0,y.arguments.source);break;case"source":p(!0,y.arguments.source);break;case"gotoTargets":p(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>p(!1,D));break;default:break}break}case"response":{const y=F;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>p(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>p(!1,D));break;case"scopes":y.body.scopes.forEach(D=>p(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>p(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>p(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(O=>p(!1,O.location));break;default:break}break}}}function d(F){return F.filter(p=>!p.presentation?.hidden).sort((p,y)=>p.presentation?y.presentation?p.presentation.group?y.presentation.group?p.presentation.group!==y.presentation.group?p.presentation.group.localeCompare(y.presentation.group):b(p.presentation.order,y.presentation.order):-1:y.presentation.group?1:b(p.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$ZF=d;function b(F,p){return typeof F!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:F-p}async function f(F,p){const y=F.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(y!=="none"&&(await p.saveAll(),y==="allEditorsInActiveGroup")){const D=p.activeEditorPane;D&&D.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:D.input,groupId:D.group.id})}await F.reloadConfiguration()}e.$1F=f;const k=(F,p)=>!F||!p?F===p:F.name===p.name&&F.path===p.path&&F.sourceReference===p.sourceReference;e.$2F=k}),define(Pe[76],Ae([1,0,24,34,67,68,13,19,21,35]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=e.$PI=e.$OI=e.$NI=e.CellStatusbarAlignment=e.$MI=e.$LI=e.$KI=e.NotebookEditorPriority=e.$JI=e.$II=e.$HI=e.$GI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$FI=e.$EI=e.$DI=e.$CI=e.CellKind=e.$BI=e.$AI=e.$zI=void 0,e.$zI="workbench.editor.notebook",e.$AI="workbench.editor.notebookTextDiffEditor",e.$BI="workbench.editor.interactive";var R;(function(P){P[P.Markup=1]="Markup",P[P.Code=2]="Code"})(R||(e.CellKind=R={})),e.$CI=["application/json","application/javascript","text/html","image/svg+xml",L.$2r.latex,L.$2r.markdown,"image/png","image/jpeg",L.$2r.text],e.$DI=[L.$2r.latex,L.$2r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$2r.text],e.$EI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$FI="_notAvailable";var S;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var $;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var v;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var n;(function(P){P.Always="always",P.Never="never",P.Optional="optional"})(n||(e.RendererMessagingSpec=n={}));var o;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.ChangeCellLanguage=5]="ChangeCellLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",P[P.ChangeCellMime=13]="ChangeCellMime",P[P.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var r;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata",P[P.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var a;(function(P){P.scheme=A.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${X.join("")}]+`),ge=7;function ve(oe,Y){const V=Y.toString(ge),Ie=`${V.length<X.length?X[V.length-1]:"z"}${V}s${(0,E.$Ae)(E.$ge.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:P.scheme,fragment:Ie})}P.generate=ve;function ke(oe){if(oe.scheme!==P.scheme)return;const Y=oe.fragment.indexOf("s");if(Y<0)return;const V=parseInt(oe.fragment.substring(0,Y).replace(ae,""),ge),ne=(0,E.$ze)(oe.fragment.substring(Y+1)).toString();if(!isNaN(V))return{handle:V,notebook:oe.with({scheme:ne,fragment:null})}}P.parse=ke;function de(oe,Y){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}P.generateCellOutputUri=de;function he(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Y)return;const V=Y[1]&&Y[1]!==""?Y[1]:void 0,ne=Y[2];return{outputId:V,notebook:oe.with({scheme:ne||A.Schemas.file,fragment:null})}}P.parseCellOutputUri=he;function te(oe,Y,V){return P.generate(oe,Y).with({scheme:V})}P.generateCellPropertyUri=te;function Se(oe,Y){if(oe.scheme===Y)return P.parse(oe.with({scheme:P.scheme}))}P.parseCellPropertyUri=Se})(a||(e.CellUri=a={}));const c=P=>g.$i?P.replace(/\//g,"\\"):P;class h{constructor(X=[],ae=e.$CI){this.e=ae,this.d=[...new Set(X)].map(ge=>({pattern:ge,matches:T.$Hj(c(ge))}))}sort(X){const ae=new Map(I.Iterable.map(X,ve=>[ve,c(ve)]));let ge=[];for(const{matches:ve}of this.d)for(const[ke,de]of ae)if(ve(de)){ge.push(ke),ae.delete(ke);break}return ae.size&&(ge=ge.concat([...ae.keys()].sort((ve,ke)=>this.e.indexOf(ve)-this.e.indexOf(ke)))),ge}prioritize(X,ae){const ge=this.f(X);if(ge===-1){this.d.unshift({pattern:X,matches:T.$Hj(c(X))});return}const ve=new Set(ae.map(de=>this.f(de,ge)));ve.delete(-1);const ke=Array.from(ve).sort();this.d.splice(ge+1,0,...ke.map(de=>this.d[de]));for(let de=ke.length-1;de>=0;de--)this.d.splice(ke[de],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ae=this.d.length){const ge=c(X);for(let ve=0;ve<ae;ve++)if(this.d[ve].matches(ge))return ve;return-1}}e.$GI=h;function i(P,X,ae,ge=(ve,ke)=>ve===ke){const ve=[];function ke(te,Se,oe){if(Se===0&&oe.length===0)return;const Y=ve[ve.length-1];Y&&Y.start+Y.deleteCount===te?(Y.deleteCount+=Se,Y.toInsert.push(...oe)):ve.push({start:te,deleteCount:Se,toInsert:oe})}let de=0,he=0;for(;;){if(de===P.length){ke(de,0,X.slice(he));break}if(he===X.length){ke(de,P.length-de,[]);break}const te=P[de],Se=X[he];if(ge(te,Se)){de+=1,he+=1;continue}ae(Se)?(ke(de,1,[]),de+=1):(ke(de,0,[Se]),he+=1)}return ve}e.$HI=i,e.$II=new w.$fj("notebookEditorCursorAtBoundary","none"),e.$JI=new w.$fj("notebookEditorCursorAtLineBoundary","none");var s;(function(P){P.default="default",P.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(P){const X=P;return!!((typeof X.include=="string"||T.$Ij(X.include))&&(typeof X.exclude=="string"||T.$Ij(X.exclude)))}e.$KI=u;function d(P,X,ae){if(Array.isArray(P.viewType)&&P.viewType.indexOf(X)>=0||P.viewType===X)return!0;if(P.filenamePattern){const ge=u(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,ve=u(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(T.$Gj(ge,(0,m.$nc)(ae.fsPath).toLowerCase()))return!(ve&&T.$Gj(ve,(0,m.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$LI=d,e.$MI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var b;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class f{static{this.d="notebook/"}static create(X){return`${f.d}${X}`}static parse(X){if(X.startsWith(f.d))return X.substring(f.d.length)}}e.$NI=f;function k(P){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(P)}e.$OI=k;const F=new TextDecoder;function p(P){const X=[];let ae=!1;for(const de of P)(X.length===0||ae)&&(X.push(de),ae=!0);let ge=O(X);const ve=E.$ge.concat(X.map(de=>E.$ge.wrap(de))),ke=C(ve);return ge=ge||ke.byteLength!==ve.byteLength,{data:ke,didCompression:ge}}e.$PI=p,e.$QI=`${String.fromCharCode(27)}[A`;const y=e.$QI.split("").map(P=>P.charCodeAt(0)),D=10;function O(P){let X=!1;return P.forEach((ae,ge)=>{if(ge===0||ae.length<e.$QI.length)return;const ve=P[ge-1],ke=ae.subarray(0,e.$QI.length);if(ke[0]===y[0]&&ke[1]===y[1]&&ke[2]===y[2]){const de=ve.lastIndexOf(D);if(de===-1)return;X=!0,P[ge-1]=ve.subarray(0,de),P[ge]=ae.subarray(e.$QI.length)}}),X}function K(P){let X=P;do P=X,X=P.replace(/[^\n]\x08/gm,"");while(X.length<P.length);return P}function U(P){for(P=P.replace(/\r+\n/gm,`
`);P.search(/\r[^$]/g)>-1;){const X=P.match(/^(.*)\r+/m)[1];let ae=P.match(/\r+(.*)$/m)[1];ae=ae+X.slice(ae.length,X.length),P=P.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return P}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function C(P){return!P.buffer.includes(M)&&!P.buffer.includes(B)?P:E.$ge.fromString(U(K(F.decode(P.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v){"use strict";var n,o,t,r,a,c,h,i,s,u,d,b,f,k,F,p,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$DM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$CM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.TestRunProfileKind=e.TestResultState=e.$iM=e.$hM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$gM=e.NotebookVariablesRequestKind=e.$fM=e.$eM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$dM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.ColorThemeKind=e.$0L=e.$9L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$8L=e.DebugConsoleMode=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$2L=e.$1L=e.FileChangeType=e.$ZL=e.$YL=e.$XL=e.$WL=e.InlineCompletionTriggerKind=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.ConfigurationTarget=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zL=e.ViewBadge=e.ProgressLocation=e.$yL=e.$xL=e.TaskScope=e.ShellQuoting=e.$wL=e.$vL=e.$uL=e.TaskPanelKind=e.TaskRevealKind=e.$tL=e.TerminalLocation=e.$sL=e.$rL=e.$qL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pL=e.$oL=e.$nL=e.$mL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$lL=e.StatusBarAlignment=e.ViewColumn=e.$kL=e.$jL=e.$iL=e.$hL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gL=e.$fL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.LanguageStatusSeverity=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.CodeActionTriggerKind=e.$6K=e.$5K=e.SymbolTag=e.SymbolKind=e.$4K=e.$3K=e.DocumentHighlightKind=e.$2K=e.$1K=e.$ZK=e.$YK=e.DiagnosticSeverity=e.DiagnosticTag=e.$XK=e.$WK=e.FileEditType=e.$VK=e.$UK=e.$TK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(W){return Object.assign(W,{apply:function(...se){if(se.length===0)return Reflect.construct(W,[]);{const De=se.length===1?[]:se[1];return Reflect.construct(W,De,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(W,[]);{const[De,...Je]=se;return Reflect.construct(W,Je,De.constructor)}}})}var O;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var K;(function(W){W[W.TerminalCommand=0]="TerminalCommand",W[W.Opener=1]="Opener",W[W.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let U=n=class{static from(...z){let se=z;return new n(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$MK=U,e.$MK=U=n=Ge([D],U);let M=o=class{static Min(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let De=1;De<z.length;De++){const Je=z[De];Je.isBefore(se)&&(se=Je)}return se}static Max(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let De=1;De<z.length;De++){const Je=z[De];Je.isAfter(se)&&(se=Je)}return se}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:se,character:De}=z;return typeof se=="number"&&typeof De=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,se){if(z<0)throw(0,T.$7)("line must be non-negative");if(se<0)throw(0,T.$7)("character must be non-negative");this.c=z,this.e=se}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,se=0){if(z===null||se===null)throw(0,T.$7)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,se=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&se===0?this:new o(this.line+De,this.character+se)}with(z,se=this.character){if(z===null||se===null)throw(0,T.$7)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,se=typeof z.character=="number"?z.character:this.character),De===this.line&&se===this.character?this:new o(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.$NK=M,e.$NK=M=o=Ge([D],M);let B=t=class{static isRange(z){return z instanceof t?!0:z?M.isPosition(z.start)&&M.isPosition(z.end):!1}static of(z){if(z instanceof t)return z;if(this.isRange(z))return new t(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,se,De,Je){let xe,ct;if(typeof z=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new M(z,se),ct=new M(De,Je)):M.isPosition(z)&&M.isPosition(se)&&(xe=M.of(z),ct=M.of(se)),!xe||!ct)throw new Error("Invalid arguments");xe.isBefore(ct)?(this.c=xe,this.e=ct):(this.c=ct,this.e=xe)}contains(z){return t.isRange(z)?this.contains(z.start)&&this.contains(z.end):M.isPosition(z)?!(M.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const se=M.Max(z.start,this.c),De=M.Min(z.end,this.e);if(!se.isAfter(De))return new t(se,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const se=M.Min(z.start,this.c),De=M.Max(z.end,this.end);return new t(se,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,se=this.end){if(z===null||se===null)throw(0,T.$7)();let De;return z?M.isPosition(z)?De=z:(De=z.start||this.start,se=z.end||this.end):De=this.start,De.isEqual(this.c)&&se.isEqual(this.end)?this:new t(De,se)}toJSON(){return[this.start,this.end]}};e.$OK=B,e.$OK=B=t=Ge([D],B);let C=r=class extends B{static isSelection(z){return z instanceof r?!0:z?B.isRange(z)&&M.isPosition(z.anchor)&&M.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,se,De,Je){let xe,ct;if(typeof z=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new M(z,se),ct=new M(De,Je)):M.isPosition(z)&&M.isPosition(se)&&(xe=M.of(z),ct=M.of(se)),!xe||!ct)throw new Error("Invalid arguments");super(xe,ct),this.f=xe,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$PK=C,e.$PK=C=r=Ge([D],C);const P=W=>{if(typeof W!="string"||W.length===0||!/^[0-9A-Za-z_\-]+$/.test(W))throw(0,T.$7)("connectionToken")};class X{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se,De){if(typeof z!="string"||z.length===0)throw(0,T.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,T.$7)("port");typeof De<"u"&&P(De),this.host=z,this.port=Math.round(se),this.connectionToken=De}}e.$QK=X;class ae{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se){this.makeConnection=z,this.connectionToken=se,typeof se<"u"&&P(se)}}e.$RK=ae;class ge extends Error{static NotAvailable(z,se){return new ge(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(z){return new ge(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,se=$.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=se,this._detail=De,Object.setPrototypeOf(this,ge.prototype)}}e.$SK=ge;var ve;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var ke;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let de=a=class{static isTextEdit(z){return z instanceof a?!0:z?B.isRange(z)&&typeof z.newText=="string":!1}static replace(z,se){return new a(z,se)}static insert(z,se){return a.replace(new B(z,z),se)}static delete(z){return a.replace(z,"")}static setEndOfLine(z){const se=new a(new B(new M(0,0),new M(0,0)),"");return se.newEol=z,se}get range(){return this.c}set range(z){if(z&&!B.isRange(z))throw(0,T.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,T.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,T.$7)("newEol");this.f=z}constructor(z,se){this.c=z,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$TK=de,e.$TK=de=a=Ge([D],de);let he=c=class{static isNotebookCellEdit(z){return z instanceof c?!0:z?_t.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,se){return new c(z,se)}static insertCells(z,se){return new c(new _t(z,z),se)}static deleteCells(z){return new c(z,[])}static updateCellMetadata(z,se){const De=new c(new _t(z,z),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(z){const se=new c(new _t(0,0),[]);return se.newNotebookMetadata=z,se}constructor(z,se){this.range=z,this.newCells=se}};e.$UK=he,e.$UK=he=c=Ge([D],he);class te{static isSnippetTextEdit(z){return z instanceof te?!0:z?B.isRange(z.range)&&Y.isSnippetString(z.snippet):!1}static replace(z,se){return new te(z,se)}static insert(z,se){return te.replace(new B(z,z),se)}constructor(z,se){this.range=z,this.snippet=se}}e.$VK=te;var Se;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,se,De,Je){this.c.push({_type:1,from:z,to:se,options:De,metadata:Je})}createFile(z,se,De){this.c.push({_type:1,from:void 0,to:z,options:se,metadata:De})}deleteFile(z,se,De){this.c.push({_type:1,from:z,to:void 0,options:se,metadata:De})}e(z,se,De){this.c.push({_type:3,metadata:De,uri:z,edit:{editType:5,metadata:se},notebookMetadata:se})}f(z,se,De,Je){const xe=se.start,ct=se.end;(xe!==ct||De.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ct-xe,cells:De,metadata:Je})}g(z,se,De,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:se,metadata:De}})}replace(z,se,De,Je){this.c.push({_type:2,uri:z,edit:new de(se,De),metadata:Je})}insert(z,se,De,Je){this.replace(z,new B(se,se),De,Je)}delete(z,se,De){this.replace(z,se,"",De)}has(z){return this.c.some(se=>se._type===2&&se.uri.toString()===z.toString())}set(z,se){if(se)for(const De of se){if(!De)continue;let Je,xe;Array.isArray(De)?(Je=De[0],xe=De[1]):Je=De,he.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,xe):this.f(z,Je.range,Je.newCells,xe):te.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Je,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(z){const se=[];for(const De of this.c)De._type===2&&De.uri.toString()===z.toString()&&se.push(De.edit);return se}entries(){const z=new L.$Ac;for(const se of this.c)if(se._type===2){let De=z.get(se.uri);De||(De=[se.uri,[]],z.set(se.uri,De)),De[1].push(se.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$WK=oe,e.$WK=oe=Ge([D],oe);let Y=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,se=this.e++){if(typeof z=="function"){const De=new h;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=h.c(z);return this.value+="${",this.value+=se,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,se=this.e++){const De=z.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,se){if(typeof se=="function"){const De=new h;De.e=this.e,se(De),this.e=De.e,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$XK=Y,e.$XK=Y=h=Ge([D],Y);var V;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(z){return z instanceof i?!0:z?B.isRange(z.range)&&w.URI.isUri(z.uri):!1}constructor(z,se){if(this.uri=z,se)if(B.isRange(se))this.range=B.of(se);else if(M.isPosition(se))this.range=new B(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$YK=Ie,e.$YK=Ie=i=Ge([D],Ie);let Le=class{static is(z){return z?typeof z.message=="string"&&z.location&&B.isRange(z.location.range)&&w.URI.isUri(z.location.uri):!1}constructor(z,se){this.location=z,this.message=se}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.location.range.isEqual(se.location.range)&&z.location.uri.toString()===se.location.uri.toString()}};e.$ZK=Le,e.$ZK=Le=Ge([D],Le);let Ce=class{constructor(z,se,De=ne.Error){if(!B.isRange(z))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=z,this.message=se,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.severity===se.severity&&z.code===se.code&&z.severity===se.severity&&z.source===se.source&&z.range.isEqual(se.range)&&(0,E.$ub)(z.tags,se.tags)&&(0,E.$ub)(z.relatedInformation,se.relatedInformation,Le.isEqual)}};e.$1K=Ce,e.$1K=Ce=Ge([D],Ce);let ce=class{constructor(z,se){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=se}};e.$2K=ce,e.$2K=ce=Ge([D],ce);var ie;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let Q=class{constructor(z,se=ie.Text){this.range=z,this.kind=se}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$3K=Q,e.$3K=Q=Ge([D],Q);let ee=class{constructor(z,se){this.uri=z,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$4K=ee,e.$4K=ee=Ge([D],ee);var $e;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var be;(function(W){W[W.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Me=s=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,se,De,Je,xe){this.name=z,this.kind=se,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Je instanceof Ie?this.location=Je:De instanceof B&&(this.location=new Ie(Je,De)),s.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$5K=Me,e.$5K=Me=s=Ge([D],Me);let le=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(u.validate)}constructor(z,se,De,Je,xe){this.name=z,this.detail=se,this.kind=De,this.range=Je,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$6K=le,e.$6K=le=u=Ge([D],le);var we;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let N=class{constructor(z,se){this.title=z,this.kind=se}};e.$7K=N,e.$7K=N=Ge([D],N);let q=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$8K=q,e.$8K=q=d=Ge([D],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let H=class{constructor(z,se){if(this.range=z,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9K=H,e.$9K=H=Ge([D],H);class j{constructor(z,se,De,Je,xe,ct){this.kind=z,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$0K=j;class J{constructor(z,se){this.fromRanges=se,this.from=z}}e.$$K=J;class _{constructor(z,se){this.fromRanges=se,this.to=z}}e.$_K=_;var ye;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let Te=class{constructor(z,se){this.range=z,this.command=se}get isResolved(){return!!this.command}};e.$aL=Te,e.$aL=Te=Ge([D],Te);let We=b=class{#e;static isMarkdownString(z){return z instanceof b?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,se=!1){this.#e=new I.$ck(z,{supportThemeIcons:se})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,se){return this.#e.appendCodeblock(se??"",z),this}};e.$bL=We,e.$bL=We=b=Ge([D],We);let He=class{constructor(z,se){this.label=z,this.documentation=se}};e.$cL=He,e.$cL=He=Ge([D],He);let Xe=class{constructor(z,se){this.label=z,this.documentation=se,this.parameters=[]}};e.$dL=Xe,e.$dL=Xe=Ge([D],Xe);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eL=rt,e.$eL=rt=Ge([D],rt);var it;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let ot=class{constructor(z){this.value=z}};e.$fL=ot,e.$fL=ot=Ge([D],ot);let at=class{constructor(z,se,De){this.position=z,this.label=se,this.kind=De}};e.$gL=at,e.$gL=at=Ge([D],at);var Be;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var pt;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var Z;(function(W){W[W.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let x=class{constructor(z,se){this.label=z,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hL=x,e.$hL=x=Ge([D],x);let pe=class{constructor(z=[],se=!1){this.items=z,this.isIncomplete=se}};e.$iL=pe,e.$iL=pe=Ge([D],pe);let Ue=class{constructor(z,se,De){this.insertText=z,this.range=se,this.command=De}};e.$jL=Ue,e.$jL=Ue=Ge([D],Ue);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$kL=Qe,e.$kL=Qe=Ge([D],Qe);var tt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var nt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(W,z){return`${S.$fm.toKey(W)}.${z}`}e.$lL=Ne;var It;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(It||(e.TextEditorLineNumbersStyle=It={}));var Mt;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Kt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var jt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var wt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(wt||(e.TextDocumentChangeReason=wt={}));var qt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(W){function z(se){switch(se){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=z}(jt||(e.TextEditorSelectionChangeKind=jt={}));var Ft;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Ft||(e.SyntaxTokenType=Ft={})),function(W){function z(se){switch(se){case W.Other:return"other";case W.Comment:return"comment";case W.String:return"string";case W.RegEx:return"regex"}return"other"}W.toString=z}(Ft||(e.SyntaxTokenType=Ft={}));let Qt=class{constructor(z,se){if(se&&!w.URI.isUri(se))throw(0,T.$7)("target");if(!B.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.target=se}};e.$mL=Qt,e.$mL=Qt=Ge([D],Qt);let Ot=class{constructor(z,se,De,Je){this.red=z,this.green=se,this.blue=De,this.alpha=Je}};e.$nL=Ot,e.$nL=Ot=Ge([D],Ot);let Ct=class{constructor(z,se){if(se&&!(se instanceof Ot))throw(0,T.$7)("color");if(!B.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.color=se}};e.$oL=Ct,e.$oL=Ct=Ge([D],Ct);let Ye=class{constructor(z){if(!z||typeof z!="string")throw(0,T.$7)("label");this.label=z}};e.$pL=Ye,e.$pL=Ye=Ge([D],Ye);var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Gt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var ut;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class mt{constructor(z,se,De){if(this.startIndex=z,this.length=se,this.tooltip=De,typeof z!="number"||z<0)throw(0,T.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$qL=mt;class zt{constructor(z){this.uri=z}}e.$rL=zt;class Ut{constructor(z){this.terminalCommand=z}}e.$sL=Ut;var Et;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class ht{constructor(z){if(this.options=z,typeof z!="object")throw(0,T.$7)("options")}}e.$tL=ht;var Pt;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Yt;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let Dt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(z){switch(z){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(z,se){if(this.label=se,typeof z!="string"||typeof se!="string")throw(0,T.$7)("name");this.c=z}get id(){return this.c}};e.$uL=Dt,e.$uL=Dt=f=Ge([D],Dt);function qe(W){let z="";for(let se=0;se<W.length;se++)z+=W[se].replace(/,/g,",,")+",";return z}let Rt=class{constructor(z,se,De){if(typeof z!="string")throw(0,T.$7)("process");this.e=[],this.c=z,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=De):this.f=se)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,T.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const se of this.e)z.push(se);return qe(z)}};e.$vL=Rt,e.$vL=Rt=Ge([D],Rt);let Wt=class{constructor(z,se,De){if(this.f=[],Array.isArray(se)){if(!z)throw(0,T.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z,this.f=se,this.g=De}else{if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z,this.g=se}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)z.push(typeof se=="string"?se:se.value);return qe(z)}};e.$wL=Wt,e.$wL=Wt=Ge([D],Wt);var Jt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var ft;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Lt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$lg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$xL=Lt;let Ee=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,se,De,Je,xe,ct){this.k=!1,this.l=this.definition=z;let dt;typeof se=="string"?(this.n=this.name=se,this.u=this.source=De,this.execution=Je,dt=xe,this.k=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,dt=ct):(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,dt=ct),typeof dt=="string"?(this.q=[dt],this.r=!0):Array.isArray(dt)?(this.q=dt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Rt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Lt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,R.$lg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,T.$7)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const se=this.l.type;(k.g===se||k.e===se||k.f===se||k.c===se)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$yL=Ee,e.$yL=Ee=k=Ge([D],Ee);var Fe;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(W){function z(se){const De=se;return(0,g.$Hf)(De.value)?De.tooltip&&!(0,g.$Df)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}W.isViewBadge=z})(fe||(e.ViewBadge=fe={}));let G=F=class{static isTreeItem(z,se){const De=z;if(De.checkboxState!==void 0){const Je=(0,g.$Hf)(De.checkboxState)?De.checkboxState:(0,g.$Ff)(De.checkboxState)&&(0,g.$Hf)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,g.$Hf)(De.checkboxState)&&(0,g.$Ff)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==je.Checked&&Je!==je.Unchecked||xe!==void 0&&!(0,g.$Df)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof F)return!0;if(De.label!==void 0&&!(0,g.$Df)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$Df)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$Df)(De.iconPath)&&!w.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$Df)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,g.$Df)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,g.$Df)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$Df)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!w.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$Df)(De.tooltip)&&!(De.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Re.None&&De.collapsibleState>Re.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$Df)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,se=Re.None){this.collapsibleState=se,w.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$zL=G,e.$zL=G=F=Ge([D],G);var Re;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Re||(e.TreeItemCollapsibleState=Re={}));var je;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(je||(e.TreeItemCheckboxState=je={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$AL=Ze,e.$AL=Ze=Ge([D],Ze);class Ve extends Ze{}e.$BL=Ve;class _e extends Ve{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$CL=_e;class gt{constructor(z,se,De,Je){this.name=z,this.uri=se,this._itemId=De,this.c=Je}data(){return this.c()}}e.$DL=gt;let Bt=class{#e=new Map;constructor(z){for(const[se,De]of z??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(De):this.#e.set(this.#t(se),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,se){this.#e.set(this.#t(z),[se])}forEach(z,se){for(const[De,Je]of this.#e)for(const xe of Je)z.call(se,xe,De,this)}*[Symbol.iterator](){for(const[z,se]of this.#e)for(const De of se)yield[z,De]}#t(z){return z.toLowerCase()}};e.$EL=Bt,e.$EL=Bt=Ge([D],Bt);let yt=class{constructor(z){this.insertText=z}};e.$FL=yt,e.$FL=yt=Ge([D],yt);let kt=class{constructor(z,se){this.label=se,this.insertText=z}};e.$GL=kt,e.$GL=kt=Ge([D],kt);let bt=class{constructor(z,se){this.id=z,this.color=se}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$HL=bt,e.$HL=bt=Ge([D],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let mi=class{constructor(z){this.id=z}};e.$IL=mi,e.$IL=mi=Ge([D],mi);var At;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let ki=class{get base(){return this.c}set base(z){this.c=z,this.e=w.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,se){if(typeof z!="string"&&(!z||!w.URI.isUri(z)&&!w.URI.isUri(z.uri)))throw(0,T.$7)("base");if(typeof se!="string")throw(0,T.$7)("pattern");typeof z=="string"?this.baseUri=w.URI.file(z):w.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$JL=ki,e.$JL=ki=Ge([D],ki);const Vi=new WeakMap;function St(W,z){Vi.set(W,z)}e.$KL=St;let ni=class{constructor(z,se,De,Je){this.enabled=typeof z=="boolean"?z:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,R.$lg)()),this.c}};e.$LL=ni,e.$LL=ni=Ge([D],ni);let $i=class extends ni{constructor(z,se,De,Je,xe){if(super(se,De,Je,xe),z===null)throw(0,T.$7)("location");this.location=z}};e.$ML=$i,e.$ML=$i=Ge([D],$i);let ai=class extends ni{constructor(z,se,De,Je,xe){super(se,De,Je,xe),this.functionName=z}};e.$NL=ai,e.$NL=ai=Ge([D],ai);let Si=class extends ni{constructor(z,se,De,Je,xe,ct,dt){if(super(Je,xe,ct,dt),!se)throw(0,T.$7)("dataId");this.label=z,this.dataId=se,this.canPersist=De}};e.$OL=Si,e.$OL=Si=Ge([D],Si);let Ii=class{constructor(z,se,De){this.command=z,this.args=se||[],this.options=De}};e.$PL=Ii,e.$PL=Ii=Ge([D],Ii);let Tt=class{constructor(z,se){this.port=z,this.host=se}};e.$QL=Tt,e.$QL=Tt=Ge([D],Tt);let pi=class{constructor(z){this.path=z}};e.$RL=pi,e.$RL=pi=Ge([D],pi);let Ci=class{constructor(z){this.implementation=z}};e.$SL=Ci,e.$SL=Ci=Ge([D],Ci);let ci=class{constructor(z,se,De){this.session=z,this.threadId=se,this.frameId=De}};e.$TL=ci,e.$TL=ci=Ge([D],ci);let ui=class{constructor(z,se){this.session=z,this.threadId=se}};e.$UL=ui,e.$UL=ui=Ge([D],ui);let lt=class{constructor(z,se){this.range=z,this.expression=se}};e.$VL=lt,e.$VL=lt=Ge([D],lt);var qi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let xt=class{constructor(z,se){this.range=z,this.text=se}};e.$WL=xt,e.$WL=xt=Ge([D],xt);let ri=class{constructor(z,se,De=!0){this.range=z,this.variableName=se,this.caseSensitiveLookup=De}};e.$XL=ri,e.$XL=ri=Ge([D],ri);let di=class{constructor(z,se){this.range=z,this.expression=se}};e.$YL=di,e.$YL=di=Ge([D],di);let Pi=class{constructor(z,se){this.frameId=z,this.stoppedLocation=se}};e.$ZL=Pi,e.$ZL=Pi=Ge([D],Pi);var Ki;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ai=p=class extends Error{static FileExists(z){return new p(z,l.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(z){return new p(z,l.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(z){return new p(z,l.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(z){return new p(z,l.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(z,se=l.FileSystemProviderErrorCode.Unknown,De){super(w.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,l.$zk)(this,se),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$1L=Ai,e.$1L=Ai=p=Ge([D],Ai);let vi=class{constructor(z,se,De){this.start=z,this.end=se,this.kind=De}};e.$2L=vi,e.$2L=vi=Ge([D],vi);var Hi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ri;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var li;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Li{constructor(z,se=[]){this.tokenTypes=z,this.tokenModifiers=se}}e.$3L=Li;function cn(W){return typeof W>"u"||(0,g.$Ef)(W)}class Mi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let se=0,De=z.tokenTypes.length;se<De;se++)this.k.set(z.tokenTypes[se],se);for(let se=0,De=z.tokenModifiers.length;se<De;se++)this.l.set(z.tokenModifiers[se],se)}}push(z,se,De,Je,xe){if(typeof z=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(z,se,De,Je,xe);if(B.isRange(z)&&typeof se=="string"&&cn(De))return this.n(z,se,De);throw(0,T.$7)()}n(z,se,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,xe=z.start.character,ct=z.end.character-z.start.character,dt=this.k.get(se);let Vt=0;if(De)for(const Xt of De){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Xt);Vt|=1<<ti>>>0}this.o(Je,xe,ct,dt,Vt)}o(z,se,De,Je,xe){if(this.f&&(z<this.c||z===this.c&&se<this.e)){this.f=!1;const Vt=this.g.length/5|0;let Xt=0,ti=0;for(let ii=0;ii<Vt;ii++){let oi=this.g[5*ii],Ui=this.g[5*ii+1];oi===0?(oi=Xt,Ui+=ti):oi+=Xt,this.g[5*ii]=oi,this.g[5*ii+1]=Ui,Xt=oi,ti=Ui}}let ct=z,dt=se;this.f&&this.j>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=dt,this.g[this.j++]=De,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=z,this.e=se}static q(z){const se=[],De=z.length/5|0;for(let dt=0;dt<De;dt++)se[dt]=dt;se.sort((dt,Vt)=>{const Xt=z[5*dt],ti=z[5*Vt];if(Xt===ti){const ii=z[5*dt+1],oi=z[5*Vt+1];return ii-oi}return Xt-ti});const Je=new Uint32Array(z.length);let xe=0,ct=0;for(let dt=0;dt<De;dt++){const Vt=5*se[dt],Xt=z[Vt+0],ti=z[Vt+1],ii=z[Vt+2],oi=z[Vt+3],Ui=z[Vt+4],kn=Xt-xe,On=kn===0?ti-ct:ti,Wi=5*dt;Je[Wi+0]=kn,Je[Wi+1]=On,Je[Wi+2]=ii,Je[Wi+3]=oi,Je[Wi+4]=Ui,xe=Xt,ct=ti}return Je}build(z){return this.f?new si(new Uint32Array(this.g),z):new si(Mi.q(this.g),z)}}e.$4L=Mi;class si{constructor(z,se){this.resultId=se,this.data=z}}e.$5L=si;class un{constructor(z,se,De){this.start=z,this.deleteCount=se,this.data=De}}e.$6L=un;class ln{constructor(z,se){this.resultId=se,this.edits=z}}e.$7L=ln;var Ji;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$8L=fi,e.$8L=fi=Ge([D],fi);var Qi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Xi{static validate(z){if(typeof z.badge=="string"){let se=(0,m.$ef)(z.badge,0);if(se<z.badge.length&&(se+=(0,m.$ef)(z.badge,se)),z.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!bt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,se,De){this.badge=z,this.tooltip=se,this.color=De}}e.$9L=Xi;let Fi=class{constructor(z){this.kind=z}};e.$0L=Fi,e.$0L=Fi=Ge([D],Fi);var Ti;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(z){return z instanceof _t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,se){if(z<0)throw(0,T.$7)("start must be positive");if(se<0)throw(0,T.$7)("end must be positive");z<=se?(this.c=z,this.e=se):(this.c=se,this.e=z)}with(z){let se=this.c,De=this.e;return z.start!==void 0&&(se=z.start),z.end!==void 0&&(De=z.end),se===this.c&&De===this.e?this:new _t(se,De)}}e.$$L=_t;class wi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(z){return!0}constructor(z,se,De,Je,xe,ct,dt){this.kind=z,this.value=se,this.languageId=De,this.mime=Je,this.outputs=xe??[],this.metadata=ct,this.executionSummary=dt,wi.validate(this)}}e.$_L=wi;class hn{constructor(z){this.cells=z}}e.$aM=hn;class Zt{static isNotebookCellOutputItem(z){return z instanceof Zt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const se={name:z.name,message:z.message,stack:z.stack};return Zt.json(se,"application/vnd.code.notebook.error")}static stdout(z){return Zt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Zt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,se="application/octet-stream"){return new Zt(z,se)}static#e=new TextEncoder;static text(z,se=A.$2r.text){const De=Zt.#e.encode(String(z));return new Zt(De,se)}static json(z,se="text/x-json"){const De=JSON.stringify(z,void 0,"	");return Zt.text(De,se)}constructor(z,se){this.data=z,this.mime=se;const De=(0,A.$6r)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$bM=Zt;class yi{static isNotebookCellOutput(z){return z instanceof yi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,se=!1){const De=new Set,Je=new Set;for(let xe=0;xe<z.length;xe++){const ct=z[xe],dt=(0,A.$6r)(ct.mime);if(!De.has(dt)||(0,v.$OI)(dt)){De.add(dt);continue}Je.add(xe),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Je.size===0?z:z.filter((xe,ct)=>!Je.has(ct))}constructor(z,se,De){this.items=yi.ensureUniqueMimeTypes(z,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,R.$lg)(),this.metadata=se??De)}}e.$cM=yi;var Ei;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Ni;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var ze;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ze||(e.NotebookCellStatusBarAlignment=ze={}));var ei;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Yi{constructor(z,se){this.text=z,this.alignment=se}}e.$dM=Yi;var $t;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var xi;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(z,se=[]){this.uri=z,this.provides=(0,E.$3b)(se)}}e.$eM=dn;class _i{constructor(z){this.label=z}}e.$fM=_i;var en;(function(W){W[W.Named=1]="Named",W[W.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(z,se){this.label=z,this.timestamp=se}};e.$gM=hi,e.$gM=hi=Ge([D],hi);var tn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(z,se){this.ranges=z,this.wordPattern=se}}e.$hM=sn;class fn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$iM=fn;var on;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(z=void 0,se=void 0,De=void 0,Je=!1){this.include=z,this.exclude=se,this.profile=De,this.continuous=Je}};e.$jM=Oi,e.$jM=Oi=Ge([D],Oi);let zi=y=class{static diff(z,se,De){const Je=new y(z);return Je.expectedOutput=se,Je.actualOutput=De,Je}constructor(z){this.message=z}};e.$kM=zi,e.$kM=zi=y=Ge([D],zi);let Bi=class{constructor(z){this.id=z}};e.$lM=Bi,e.$lM=Bi=Ge([D],Bi);class Di{constructor(z,se){this.covered=z,this.total=se}}e.$mM=Di;class ji{static fromDetails(z,se){const De=new Di(0,0),Je=new Di(0,0),xe=new Di(0,0);for(const dt of se)if("branches"in dt){De.total+=1,De.covered+=dt.executionCount>0?1:0;for(const Vt of dt.branches)Je.total+=1,Je.covered+=Vt.executionCount>0?1:0}else xe.total+=1,xe.covered+=dt.executionCount>0?1:0;const ct=new ji(z,De,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ct.detailedCoverage=se,ct}constructor(z,se,De,Je){this.uri=z,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Je}}e.$nM=ji;class gn{constructor(z,se,De=[]){this.executionCount=z,this.location=se,this.branches=De}}e.$oM=gn;class mn{constructor(z,se){this.executionCount=z,this.location=se}}e.$pM=mn;class re{constructor(z,se,De){this.name=z,this.executionCount=se,this.location=De}}e.$qM=re;var ue;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var st;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class vt{constructor(z,se,De,Je,xe,ct){this.kind=z,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$rM=vt;class Nt{constructor(z){this.uri=z}}e.$sM=Nt;class Sn{constructor(z,se){this.original=z,this.modified=se}}e.$tM=Sn;class In{constructor(z,se,De,Je){this.base=z,this.input1=se,this.input2=De,this.result=Je}}e.$uM=In;class Cn{constructor(z,se){this.uri=z,this.viewType=se}}e.$vM=Cn;class Pn{constructor(z){this.viewType=z}}e.$wM=Pn;class An{constructor(z,se){this.uri=z,this.notebookType=se}}e.$xM=An;class Rn{constructor(z,se,De){this.original=z,this.modified=se,this.notebookType=De}}e.$yM=Rn;class Ln{constructor(){}}e.$zM=Ln;class Mn{constructor(z,se){this.uri=z,this.inputBoxUri=se}}e.$AM=Mn;class Fn{constructor(z){this.providerId=z}}e.$BM=Fn;var $n;(function(W){W[W.Down=0]="Down",W[W.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(W){W[W.Action=1]="Action",W[W.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(W){W[W.Short=1]="Short",W[W.Medium=2]="Medium",W[W.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(z,se){this.label=z,this.values=se}}e.$CM=Tn;var bn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful",W[W.Undone=2]="Undone",W[W.Accepted=3]="Accepted",W[W.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(W){W[W.System=0]="System",W[W.User=1]="User",W[W.Assistant=2]="Assistant",W[W.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Nn{constructor(z,se){this.role=z,this.content=se}}e.$DM=Nn;var yn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(W){W[W.SymbolInformation=1]="SymbolInformation",W[W.CommandInformation=2]="CommandInformation",W[W.SearchInformation=3]="SearchInformation",W[W.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Dn;(function(W){W[W.Started=1]="Started",W[W.Recognizing=2]="Recognizing",W[W.Recognized=3]="Recognized",W[W.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Pe[103],Ae([1,0,53,13,12,295,147,7,18]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0;const w=new Map;function R(v,n){n?w.set(v,n):w.delete(v)}e.$QM=R;function S(v){return w.get(v)}class l extends L.$9u{constructor(n,o,t,r,a,c,h,i){super(o,t,r,a),this.c=n,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,g.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===T.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,t){return n.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,E.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,E.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,r=o.start.line,a=o.end.line,c=[];c.push(this.f[r].substring(o.start.character));for(let h=r+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(n){let o;if(n instanceof m.$NK?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new $(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),t=this.f[o.index].length;return new m.$NK(o.index,Math.min(o.remainder,t))}w(n){if(!(n instanceof m.$OK))throw new Error("Invalid argument");const o=this.x(n.start),t=this.x(n.end);return o===n.start&&t===n.end?n:new m.$OK(o.line,o.character,t.line,t.character)}x(n){if(!(n instanceof m.$NK))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:t}=n,r=!1;if(o<0)o=0,t=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,r=!0;else{const a=this.f[o].length;t<0?(t=0,r=!0):t>a&&(t=a,r=!0)}return r?new m.$NK(o,t):n}y(n,o){const t=this.x(n);if(!o)o=S(this.m);else if((0,I.$Te)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,A.$hs)(t.character+1,(0,A.$fs)(o),this.f[t.line],0);if(r)return new m.$OK(t.line,r.startColumn-1,t.line,r.endColumn-1)}}e.$RM=l;class ${constructor(n,o,t){this.a=n,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$OK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$OK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SM=$}),define(Pe[210],Ae([1,0,7,17,5]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;let L=class{constructor(m){this.a=new E.$0L(E.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$0L(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ugc=L,e.$Ugc=L=Ge([Ke(0,T.$OM)],L)}),define(Pe[211],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$SI=(0,E.$1h)("INotebookExecutionService")}),define(Pe[212],Ae([1,0,6,29,144,94]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XPb=void 0;class A extends E.$Sc{constructor(g,w,R){super(),this._source=g,this.b=w,this.c=R,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Fs(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new I.$UB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:R,disposable:S}=w.create(1);this.b=R,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new I.$UB;w.acceptChunk(g);const R=w.finish(!0),{textBuffer:S,disposable:l}=R.create(1);return this.B(l),S})),this.a}findInInputs(g){const R=new L.$IB(g,!1,!1,null).parseSearchRequest();if(!R)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,R,!0,5e3)}findInOutputs(g){const R=new L.$IB(g,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),R,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$XPb=A}),define(Pe[48],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(L){L.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(A,m,g=A.parent){if(A._isRoot)return new I([m]);const w=[A.id];for(let R=g;R&&R.id!==m;R=R.parent)w.push(R.id);return w.push(m),new I(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new I(A.split("\0"))}static join(A,m){return new I([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:I.isChild(A,m)?2:I.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$CJ=I}),define(Pe[58],Ae([1,0,2,92,29,48]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$IJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HJ=e.$GJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EJ=e.$DJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$DJ=[2,4,8,16,32,64];const w=C=>"runId"in C;e.$EJ=w;var R;(function(C){C.serialize=P=>({range:P.range.toJSON(),uri:P.uri.toJSON()}),C.deserialize=P=>({range:I.$Fs.lift(P.range),uri:E.URI.revive(P.uri)})})(R||(e.IRichLocation=R={}));var S;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(C){C.serialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&R.serialize(P.location)}),C.deserialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&R.deserialize(P.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,P)=>`${P?"s":"e"}${C}`;e.$FJ=$;var v;(function(C){C.serialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&R.serialize(P.location)}),C.deserialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&R.deserialize(P.location)})})(v||(e.ITestOutputMessage=v={}));var n;(function(C){C.serialize=P=>P.type===0?l.serialize(P):v.serialize(P),C.deserialize=P=>P.type===0?l.deserialize(P):v.deserialize(P)})(n||(e.ITestMessage=n={}));var o;(function(C){C.serializeWithoutMessages=P=>({state:P.state,duration:P.duration,messages:[]}),C.serialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.serialize)}),C.deserialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",r=(C,P)=>C+t+P;e.$GJ=r;const a=C=>{const P=C.indexOf(t);return{ctrlId:C.slice(0,P),tagId:C.slice(P+1)}};e.$HJ=a;var c;(function(C){C.serialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?.toJSON(),range:P.range?.toJSON()||null,description:P.description,error:P.error,sortText:P.sortText}),C.deserialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?E.URI.revive(P.uri):void 0,range:P.range?I.$Fs.lift(P.range):null,description:P.description,error:P.error,sortText:P.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(C){C.serialize=P=>({expand:P.expand,item:c.serialize(P.item)}),C.deserialize=P=>({controllerId:L.$CJ.root(P.item.extId),expand:P.expand,item:c.deserialize(P.item)})})(i||(e.InternalTestItem=i={}));var s;(function(C){C.serialize=P=>{let X;return P.item&&(X={},P.item.label!==void 0&&(X.label=P.item.label),P.item.tags!==void 0&&(X.tags=P.item.tags),P.item.busy!==void 0&&(X.busy=P.item.busy),P.item.uri!==void 0&&(X.uri=P.item.uri?.toJSON()),P.item.range!==void 0&&(X.range=P.item.range?.toJSON()),P.item.description!==void 0&&(X.description=P.item.description),P.item.error!==void 0&&(X.error=P.item.error),P.item.sortText!==void 0&&(X.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:X}},C.deserialize=P=>{let X;return P.item&&(X={},P.item.label!==void 0&&(X.label=P.item.label),P.item.tags!==void 0&&(X.tags=P.item.tags),P.item.busy!==void 0&&(X.busy=P.item.busy),P.item.range!==void 0&&(X.range=P.item.range?I.$Fs.lift(P.item.range):null),P.item.description!==void 0&&(X.description=P.item.description),P.item.error!==void 0&&(X.error=P.item.error),P.item.sortText!==void 0&&(X.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:X}}})(s||(e.ITestItemUpdate=s={}));const u=(C,P)=>{P.expand!==void 0&&(C.expand=P.expand),P.item!==void 0&&(C.item=C.item?Object.assign(C.item,P.item):P.item)};e.$IJ=u;var d;(function(C){C.serializeWithoutMessages=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serializeWithoutMessages)}),C.serialize=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serialize)}),C.deserialize=P=>({...i.deserialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var b;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(P,X)=>{P.covered+=X.covered,P.total+=X.total}})(b||(e.ICoveredCount=b={}));var f;(function(C){C.serialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.serialize),uri:P.uri.toJSON()}),C.deserialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.deserialize),uri:E.URI.from(P.uri)})})(f||(e.IFileCoverage=f={}));function k(C){return{...C,location:C.location?.toJSON()}}function F(C){return C.location=C.location?T.$Es.isIPosition(C.location)?T.$Es.lift(C.location):I.$Fs.lift(C.location):void 0,C}e.$JJ=3;var p;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(p||(e.DetailType=p={}));var y;(function(C){C.serialize=P=>P.type===0?O.serialize(P):K.serialize(P),C.deserialize=P=>P.type===0?O.deserialize(P):K.deserialize(P)})(y||(e.CoverageDetails=y={}));var D;(function(C){C.serialize=k,C.deserialize=F})(D||(e.IBranchCoverage=D={}));var O;(function(C){C.serialize=k,C.deserialize=F})(O||(e.IFunctionCoverage=O={}));var K;(function(C){C.serialize=P=>({...k(P),branches:P.branches?.map(D.serialize)}),C.deserialize=P=>({...F(P),branches:P.branches?.map(D.deserialize)})})(K||(e.IStatementCoverage=K={}));var U;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var M;(function(C){C.deserialize=P=>P.op===0?{op:P.op,item:i.deserialize(P.item)}:P.op===1?{op:P.op,item:s.deserialize(P.item)}:P.op===2?{op:P.op,uri:E.URI.revive(P.uri),docv:P.docv}:P,C.serialize=P=>P.op===0?{op:P.op,item:i.serialize(P.item)}:P.op===1?{op:P.op,item:s.serialize(P.item)}:P})(M||(e.TestsDiffOp=M={}));class B{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(P){const X=this.o();for(const ae of P)switch(ae.op){case 0:this.j(i.deserialize(ae.item),X);break;case 1:this.k(s.deserialize(ae.item),X);break;case 3:this.l(ae.itemId,X);break;case 5:this.m(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}X.complete?.()}j(P,X){const ae=L.$CJ.parentId(P.item.extId)?.toString();let ge;if(!ae)ge=this.p(P),this.f.add(ge),this.d.set(P.item.extId,ge);else if(this.d.has(ae)){const ve=this.d.get(ae);ve.children.add(P.item.extId),ge=this.p(P,ve),this.d.set(P.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(P)}`);return}return X.add?.(ge),P.expand===2&&this.g++,ge}k(P,X){const ae=this.d.get(P.extId);if(ae)return P.expand!==void 0&&(ae.expand===2&&this.g--,P.expand===2&&this.g++),(0,e.$IJ)(ae,P),X.update?.(ae),ae}l(P,X){const ae=this.d.get(P);if(!ae)return;const ge=L.$CJ.parentId(ae.item.extId)?.toString();ge?this.d.get(ge).children.delete(ae.item.extId):this.f.delete(ae);const ve=[[P]];for(;ve.length;)for(const ke of ve.pop()){const de=this.d.get(ke);de&&(ve.push(de.children),this.d.delete(ke),X.remove?.(de,de!==ae),de.expand===2&&this.g--)}}m(P){}updatePendingRoots(P){this.h+=P}o(){return{}}}e.$KJ=B}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.TestItemEventOp=void 0;var g;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(r,a)=>r===a,S=Object.entries({range:(r,a)=>r===a?!0:!r||!a?!1:r.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(r,a)=>!(r.length!==a.length||r.some(c=>!a.includes(c)))}),l=(r,a)=>{let c;for(const[h,i]of S)i(r[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class $ extends I.$Sc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$ah(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,A.$IJ)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,A.$IJ)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.L(h);return i.isOpen()?this.J(h,c-1):i.wait().then(()=>this.J(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,c-1)):this.J(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(a,c){switch(c.op){case 3:this.N(m.$CJ.joinToString(a.fullId,c.id));break;case 0:this.y(c.item,a);break;case 5:for(const h of c.ops)this.u(a,h);break;case 1:this.z(c.new,c.old,a.fullId.toString());break;case 2:this.I(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.w(a.actual.uri);break;default:(0,L.$5c)(c)}}w(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}y(a,c){const h=m.$CJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.H(a,s,c);return}if(s.actual===a){this.G(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.N(h.toString()),this.y(a,c);const u=this.s.getChildren(s.actual),d=s.actual,b=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.z(a.tags,d.tags,h.toString()),delete b.tags),this.u(s,{op:4,update:b})),this.H(a,s,c);for(const[f,k]of u)this.s.getChildren(a).get(k.id)||this.N(m.$CJ.joinToString(h,k.id));this.w(s.actual.uri)}z(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,A.$GJ)(this.s.controllerId,s.id))}}}),i.forEach(this.D,this)}C(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$GJ)(this.s.controllerId,a.id)}}))}D(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,A.$GJ)(this.s.controllerId,a)}))}F(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}G(a,c,h){this.F(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.u(c,s),this.I(c)}H(a,c,h){this.G(a,c,h);for(const[i,s]of this.s.getChildren(a))this.y(s,c)}I(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.L(a))}J(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand(m.$CJ.joinToString(a.fullId,s.id),c);(0,E.$Ng)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}L(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$Zg;return s.open(),s}a.expand=2,this.M(a);const c=a.resolveBarrier=new E.$Zg,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Ng)(i)?i.catch(h).then(()=>{c.open(),this.I(a)}):(c.open(),this.I(a)),a.resolveBarrier}M(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}N(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.D(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$CJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$EM=$;class v extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$FM=v;class n extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GM=n;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$HM=o;const t=(r,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const b of i){if(!(b instanceof c))throw new n(b.id);const f=a(b).controllerId;if(f!==r.controllerId)throw new o(b.id,f,r.controllerId);if(s.has(b.id))throw new v(b.id);s.set(b.id,b),u.delete(b.id),d.ops.push({op:0,item:b})}for(const b of u.keys())d.ops.push({op:3,id:b});r.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new n(i.id);h.set(i.id,i),r.listener?.({op:0,item:i})},delete(i){h.delete(i)&&r.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$IM=t}),define(Pe[104],Ae([1,0,77]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;const T=new WeakMap,I=(A,m)=>{const g={controllerId:m};return T.set(A,g),g};e.$JM=I;const L=A=>{const m=T.get(A);if(!m)throw new E.$GM(A?.id||"<unknown>");return m};e.$KM=L}),define(Pe[78],Ae([1,0,13,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bvb=e.$avb=e.$_ub=e.$$ub=e.$0ub=void 0,e.$0ub="vscode-cdn.net",e.$$ub=`vscode-resource.${e.$0ub}`,e.$_ub=`'self' https://*.${e.$0ub}`;function I(m,g){return m.scheme===E.Schemas.http||m.scheme===E.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===E.Schemas.file&&(m=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:m.path})),T.URI.from({scheme:E.Schemas.https,authority:`${m.scheme}+${L(m.authority)}.${e.$$ub}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$avb=I;function L(m){return m.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$bvb=A}),define(Pe[213],Ae([1,0,5,6,78]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class L{constructor(m,g,w){this.d=m,this.e=g,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const R=g.getVisibleTextEditors();for(const S of this.c.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,w,R,S){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===m){l=a;break}if(!l)throw new Error("not a visible editor");const $=this,v=this.a++,n=new E.$Sd,o=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$avb)(a,$.f)}get cspSource(){return I.$_ub}set options(a){this.b=a,$.d.$setOptions(v,a)}get options(){return this.b}set html(a){this.a=a,$.d.$setHtml(v,a)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(a){return $.d.$postMessage(v,a)}},r=new class{constructor(){this.editor=m,this.line=g,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){$.c.has(v)&&($.c.delete(v),$.d.$disposeEditorInset(v),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,g+1,w,R||{},S.identifier,S.extensionLocation),this.c.set(v,{editor:m,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$efc=L}),define(Pe[214],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.VariableKind=e.$AN=void 0,e.$AN=(0,E.$1h)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class I extends Error{constructor(A,m){super(m),this.variable=A}}e.$BN=I}),define(Pe[215],Ae([1,0,19,74,16,26,21,95,177,214,12]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,v,n,o){this.h=new Map,this.a=$,this.b=v,this.g=n,o&&(this.c=o.then(t=>this.i(t)))}i($){if(A.$i){const v=Object.create(null);return Object.keys($).forEach(n=>{v[n.toLowerCase()]=$[n]}),v}return $}resolveWithEnvironment($,v,n){return this.l({env:this.i($),userHome:void 0},v?v.uri:void 0,n)}async resolveAsync($,v){const n={env:await this.c,userHome:await this.g};return this.l(n,$?$.uri:void 0,v)}async j($,v,n,o){const t=L.$gn(v);A.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):A.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):A.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,$?$.uri:void 0,t,n,o)}async resolveAnyAsync($,v,n){return this.j($,v,n)}async resolveAnyMap($,v,n){const o=new Map;return{newConfig:await this.j($,v,n,o),resolvedVariables:o}}resolveWithInteractionReplace($,v,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,v,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,v){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,v)}async l($,v,n,o,t){if(I.$Df(n))return this.m($,v,n,o,t);if(Array.isArray(n))return Promise.all(n.map(r=>this.l($,v,r,o,t)));if(I.$Ff(n)){const r=Object.create(null),a=await Promise.all(Object.keys(n).map(async c=>[await this.m($,v,c,o,t),await this.l($,v,n[c],o,t)]));for(const[c,h]of a)r[c]=h;return r}return n}m($,v,n,o,t){return(0,R.$Ye)(n,S.VARIABLE_REGEXP,async(r,a)=>{if(a.includes(S.VARIABLE_LHS))return r;let c=await this.o($,r,a,v,o);return t?.set(a,c),c!==r&&I.$Df(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m($,v,c,o,t)),c})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,v,n,o,t){let r;const a=n.split(":");a.length>1&&(n=a[0],r=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,m.$Gv)(u);throw new w.$BN(s,(0,g.localize)(0,null,v))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,m.$Gv)(d)}throw new w.$BN(s,(0,g.localize)(1,null,v,E.$nc(u)))},i=s=>{if(r){const u=this.a.getFolderUri(r);if(u)return u;throw new w.$BN(s,(0,g.localize)(2,null,v,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new w.$BN(s,(0,g.localize)(3,null,v)):new w.$BN(s,(0,g.localize)(4,null,v))};switch(n){case"env":if(r){if($.env){const s=$.env[A.$i?r.toLowerCase():r];if(I.$Df(s))return s}return""}throw new w.$BN(w.VariableKind.Env,(0,g.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(o,r);if(I.$Mf(s))throw new w.$BN(w.VariableKind.Config,(0,g.localize)(6,null,v,r));if(I.$Ff(s))throw new w.$BN(w.VariableKind.Config,(0,g.localize)(7,null,v,r));return s}throw new w.$BN(w.VariableKind.Config,(0,g.localize)(8,null,v));case"command":return this.p(w.VariableKind.Command,v,r,t,"command");case"input":return this.p(w.VariableKind.Input,v,r,t,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new w.$BN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new w.$BN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,v));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$Gv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,m.$Gv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Gv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new w.$BN(w.VariableKind.UserHome,(0,g.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$BN(w.VariableKind.LineNumber,(0,g.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$BN(w.VariableKind.SelectedText,(0,g.localize)(13,null,v))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(o||r){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return E.sep;default:try{const s=r?`${n}:${r}`:n;return this.p(w.VariableKind.Unknown,v,s,t,void 0)}catch{return v}}}}p($,v,n,o,t){if(n&&o){const r=t===void 0?o[n]:o[t+":"+n];if(typeof r=="string")return r;throw new w.$BN($,(0,g.localize)(14,null,v))}return v}}e.$PN=S}),define(Pe[105],Ae([1,0,4,102]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.OpenEditorContext=e.GroupsOrder=e.$PC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OC=void 0,e.$OC=(0,E.$1h)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var L;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(v){const n=v;return(0,T.$xE)(n?.editor)&&(0,T.$xE)(n?.replacement)}e.$PC=w;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var S;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(v){const n=v;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.$QC=l;function $(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$RC=$}),define(Pe[216],Ae([1,0,4,105]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$UC=e.$TC=e.$SC=void 0,e.$SC=(0,E.$1h)("editorService"),e.$TC=-1,e.$UC=-2;function I(L){const A=L;return typeof L=="number"||(0,T.$QC)(A)}e.$VC=I}),define(Pe[217],Ae([1,0,4,184]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=void 0,e.$8J=(0,E.$2h)(T.$8h)}),define(Pe[106],Ae([1,0,22,5,19,6]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=e.$06b=e.$96b=e.$86b=void 0;class A{constructor(t,r){this.versionId=t,this.removedDueToLooping=r}}e.$86b=A;class m{static isHostExtension(t,r,a){if(r.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,r){this.j=t,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new E.$hm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const r=this.j.readActivationEvents(t);for(const a of r)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,r){this.e=n(this.e,r),this.e=this.e.concat(t);const a=m.l(this.e);return this.e=n(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,a)}static l(t){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=r.getArcs(s);for(let b=0;b<d.length;b++)if(!u.has(d[b]))return!1;return!0}getNodes(){return this.e}},a=new E.$hm;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)r.addArc(E.$fm.toKey(s.identifier),E.$fm.toKey(u));const c=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>c.add(s));const h=r.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];r.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this.h.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const r=this.f.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this.g)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$96b=m;class g{constructor(t,r){this.versionId=t,this.extensions=r}}e.$06b=g;class w{constructor(t){this.d=new l,this.c=new m(t,[])}async acquireLock(t){const r=await this.d.acquire(t);return new R(this,r)}deltaExtensions(t,r,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this.c.getExtensionDescriptionByIdOrUUID(t,r)}}e.$$6b=w;class R extends L.$Sc{constructor(t,r){super(),this.f=t,this.c=!1,this.B(r)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$_6b=R;class S{constructor(t){this.name=t,this.promise=new Promise((r,a)=>{this.c=r})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const r=new S(t);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let r=!0;const a=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{r&&(clearTimeout(a),r=!1,this.d=!1,this.e())};t.resolve((0,L.$Qc)(c))}}var $;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})($||($={}));function v(o,t){const r=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==a)return r-a;const c=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function n(o,t){const r=new E.$gm(t);return o.filter(a=>!r.has(a.identifier))}}),define(Pe[79],Ae([1,0,24]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$om=e.$nm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var L;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(w){const R=E.$ge.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$nm=A;function m(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$om=m;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=e.$8M=e.$7M=e.$6M=void 0;let $=class extends S.$Sc{constructor(t,r){super(),this.s=t,this.t=r,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:g.$Ao,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(a=>{(0,I.$kj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,r,a){const c=this.getTelemetryDetails(),h=new v(r,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,r,a){this.f=t,this.g=r,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const r=Object.create(null);switch(r["common.extname"]=`${t.publisher}.${t.name}`,r["common.extversion"]=t.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,m.$8k)((0,g.$Ho)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const r=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,r){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(r),h=!0);return h}};e.$6M=$,e.$6M=$=Ge([Ke(0,L.$5M),Ke(1,I.$jj)],$);class v{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,r,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,r){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let r="properties"in t?t.properties??{}:t;return r=(0,g.$Ko)(r,[]),this.c&&(r=(0,w.$jn)(r,this.c)),this.b||(r=(0,w.$jn)(r,this.j)),"properties"in t?t.properties=r:t=r,t}k(t,r){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(t,r),this.h.trace(t,r))}logUsage(t,r){this.d.isUsageEnabled&&this.k(t,r)}logError(t,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,r);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Ko)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const t=this,r={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$7M=v;function n(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$8M=n,e.$9M=(0,E.$1h)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,193,101,22,4]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.$lF=e.ActivationKind=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.ExtensionHostStartup=e.$fF=e.$eF=e.$dF=e.$cF=void 0,e.$cF=Object.freeze({identifier:new A.$fm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$dF="extensions.webWorker",e.$eF=(0,m.$1h)("extensionService");class g{constructor(h){this.dependency=h}}e.$fF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$ZE.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],b=[],f=[],k=S(this.d),F=S(i),p=(U,M)=>U.extensionLocation.toString()===M.extensionLocation.toString()||U.isBuiltin===M.isBuiltin||U.isUserBuiltin===M.isUserBuiltin||U.isUnderDevelopment===M.isUnderDevelopment;for(const U of this.d){const M=F.get(U.identifier);if(!M){u.push(U.identifier),k.delete(U.identifier);continue}if(!p(U,M)){u.push(U.identifier),k.delete(U.identifier);continue}}for(const U of i){const M=k.get(U.identifier);if(!M){d.push(U);continue}if(!p(M,U)){u.push(M.identifier),k.delete(M.identifier);continue}}const y=new A.$gm(this.e),D=new A.$gm(s);for(const U of this.e)D.has(U)||b.push(U);for(const U of s)y.has(U)||f.push(U);const O=L.$ZE.createActivationEventsMap(d),K={versionId:h,toRemove:u,toAdd:d,addActivationEvents:O,myToRemove:b,myToAdd:f};return this.delta(K),K}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,b=new A.$gm(i),f=new A.$gm(u);for(let k=0;k<this.d.length;k++)b.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)f.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of s)this.d.push(k);for(const k of d)this.e.push(k);return this.f=null,h}containsExtension(h){for(const i of this.e)if(A.$fm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=L.$ZE.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$gF=R;function S(c){const h=new A.$hm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$hF=l;function $(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$iF=$;class v{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$jF=v;class n{constructor(h,i){this.description=h,this.value=i}}e.$kF=n;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$Qo)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$lF=t;function r(c,h){return{identifier:new A.$fm((0,I.$Oo)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$mF=r;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$nF=a}),define(Pe[218],Ae([1,0,11,106,22,23,15,14]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=e.$Afc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,r,a,c){this.startup=t,this.codeLoadingTime=r,this.activateCallTime=a,this.activateResolvedTime=c}}e.$Afc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,r){return t===-1||r===-1?-1:r-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Bfc=w;class R{constructor(t,r,a,c,h,i){this.activationFailed=t,this.activationFailedError=r,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$Cfc=R;class S extends R{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Dfc=S;class l extends R{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Efc=l;class $ extends R{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(t,r,a,c){this.g=c,this.a=t,this.b=r,this.c=a,this.d=new I.$hm,this.f=Object.create(null)}dispose(){for(const[t,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const t=[];for(const[r,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const r=this.d.get(t);return!!(r&&r.value)}getActivatedExtension(t){const r=this.d.get(t);if(!r||!r.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return r.value}async activateByEvent(t,r){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:r,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,r){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:r}])}async h(t){const r=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(r.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const r=this.a.getExtensionDescription(t.id);if(!r){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new $(h));return this.c.onExtensionActivationError(t.id,h,new L.$fF(t.id.value)),i}const a=[],c=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),b=this.k(t,r.displayName,[],new $(d));return this.c.onExtensionActivationError(r.identifier,d,new L.$fF(h)),b}return this.k(t,r.displayName,a,null)}k(t,r,a,c){const h=new n(t.id,r,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$96b.isHostExtension(t,this.a,this.b)}m(t){const r=this.b.getExtensionDescription(t);return r?!r.main&&!r.browser:!1}};e.$Ffc=v,e.$Ffc=v=Ge([Ke(3,A.$ij)],v);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,r,a,c,h,i,s){this.c=t,this.d=r,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new m.$Zg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const r=this.g[t];if(r.value&&!r.value.activationFailed){this.g.splice(t,1),t--;continue}if(r.value&&r.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);a.detail=r.value.activationFailedError,this.h=new $(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const r=new Error;if(t&&t.name&&(r.name=t.name),t&&t.message?r.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(r.stack=t.stack),this.h=new $(r),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};n=Ge([Ke(6,A.$ij)],n)}),define(Pe[8],Ae([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$NM=e.$MM=e.MarkdownString=e.$LM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ee){function Fe(G){const{selectionStartLineNumber:Re,selectionStartColumn:je,positionLineNumber:Ze,positionColumn:Ve}=G,_e=new s.$NK(Re-1,je-1),gt=new s.$NK(Ze-1,Ve-1);return new s.$PK(_e,gt)}Ee.to=Fe;function fe(G){const{anchor:Re,active:je}=G;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ee.from=fe})(d||(e.Selection=d={}));var b;(function(Ee){function Fe(G){if(!G)return;const{start:Re,end:je}=G;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ee.from=Fe;function fe(G){if(!G)return;const{startLineNumber:Re,startColumn:je,endLineNumber:Ze,endColumn:Ve}=G;return new s.$OK(Re-1,je-1,Ze-1,Ve-1)}Ee.to=fe})(b||(e.Range=b={}));var f;(function(Ee){function Fe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ee.to=Fe})(f||(e.TokenType=f={}));var k;(function(Ee){function Fe(G){return new s.$NK(G.lineNumber-1,G.column-1)}Ee.to=Fe;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=fe})(k||(e.Position=k={}));var F;(function(Ee){function Fe(Re,je,Ze){return(0,E.$Hb)((0,E.$3b)(Re).map(Ve=>fe(Ve,je,Ze)))}Ee.from=Fe;function fe(Re,je,Ze){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Ze?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:G(Re.scheme,je),pattern:Z.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Re,je){return je&&typeof Re=="string"?je.transformOutgoingScheme(Re):Re}})(F||(e.DocumentSelector=F={}));var p;(function(Ee){function Fe(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ee.to=fe})(p||(e.DiagnosticTag=p={}));var y;(function(Ee){function Fe(G){let Re;return G.code&&((0,l.$Df)(G.code)||(0,l.$Hf)(G.code)?Re=String(G.code):Re={value:String(G.code.value),target:G.code.target}),{...b.from(G.range),message:G.message,source:G.source,code:Re,severity:O.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(D.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map(p.from)):void 0}}Ee.from=Fe;function fe(G){const Re=new s.$1K(b.to(G),G.message,O.to(G.severity));return Re.source=G.source,Re.code=(0,l.$Df)(G.code)?G.code:G.code?.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(D.to),Re.tags=G.tags&&(0,E.$Hb)(G.tags.map(p.to)),Re}Ee.to=fe})(y||(e.Diagnostic=y={}));var D;(function(Ee){function Fe(G){return{...b.from(G.location.range),message:G.message,resource:G.location.uri}}Ee.from=Fe;function fe(G){return new s.$ZK(new s.$YK(G.resource,b.to(G)),G.message)}Ee.to=fe})(D||(e.DiagnosticRelatedInformation=D={}));var O;(function(Ee){function Fe(G){switch(G){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ee.from=Fe;function fe(G){switch(G){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ee.to=fe})(O||(e.DiagnosticSeverity=O={}));var K;(function(Ee){function Fe(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$UC:i.$TC}Ee.from=Fe;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=fe})(K||(e.ViewColumn=K={}));function U(Ee){return typeof Ee.range<"u"}function M(Ee){return Ee.length===0?!0:!!U(Ee[0])}e.$LM=M;var B;(function(Ee){function Fe(Ve){return Ve.map(Ee.from)}Ee.fromMany=Fe;function fe(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(fe(Ve)){const{language:kt,value:bt}=Ve;_e={value:"```"+kt+`
`+bt+"\n```\n"}}else s.$bL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const gt=Object.create(null);_e.uris=gt;const Bt=kt=>{try{let bt=$.URI.parse(kt,!0);bt=bt.with({query:Re(bt.query,gt)}),gt[kt]=bt}catch{}return""},yt=new g.marked.Renderer;return yt.link=Bt,yt.image=kt=>typeof kt=="string"?Bt(A.$jk(kt).href):"",(0,g.marked)(_e.value,{renderer:yt}),_e}Ee.from=G;function Re(Ve,_e){if(!Ve)return Ve;let gt;try{gt=(0,w.$wh)(Ve)}catch{}if(!gt)return Ve;let Bt=!1;return gt=(0,S.$in)(gt,yt=>{if($.URI.isUri(yt)){const kt=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[kt]=yt,Bt=!0,kt}else return}),Bt?JSON.stringify(gt):Ve}function je(Ve){const _e=new s.$bL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?$.URI.from(Ve.baseUri):void 0,_e}Ee.to=je;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:Ee.from(Ve)}Ee.fromStrict=Ze})(B||(e.MarkdownString=B={}));function C(Ee){return M(Ee)?Ee.map(Fe=>({range:b.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?B.fromMany(Fe.hoverMessage):Fe.hoverMessage?B.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ee.map(Fe=>({range:b.from(Fe)}))}e.$MM=C;function P(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?$.URI.file(Ee):Ee}e.$NM=P;var X;(function(Ee){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?P(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ee.from=Fe})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var ae;(function(Ee){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}Ee.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var ge;(function(Ee){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Fe})(ge||(e.DecorationRangeBehavior=ge={}));var ve;(function(Ee){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ge.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}Ee.from=Fe})(ve||(e.DecorationRenderOptions=ve={}));var ke;(function(Ee){function Fe(G){return{text:G.newText,eol:G.newEol&&et.from(G.newEol),range:b.from(G.range)}}Ee.from=Fe;function fe(G){const Re=new s.$TK(b.to(G.range),G.text);return Re.newEol=typeof G.eol>"u"?void 0:et.to(G.eol),Re}Ee.to=fe})(ke||(e.TextEdit=ke={}));var de;(function(Ee){function Fe(G,Re){const je={edits:[]};if(G instanceof s.$WK){const Ze=new m.$Bc;for(const Ve of G._allEntries())Ve._type===1&&$.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),je.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?je.edits.push({resource:Ve.uri,textEdit:ke.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Re?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?je.edits.push({resource:Ve.uri,textEdit:{range:b.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Re?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?je.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&je.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(It.from)}})}return je}Ee.from=Fe;function fe(G){const Re=new s.$WK,je=new m.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const Ve=Ze,_e=$.URI.revive(Ve.resource),gt=b.to(Ve.textEdit.range),Bt=Ve.textEdit.text,yt=Ve.textEdit.insertAsSnippet;let kt;yt?kt=s.$VK.replace(gt,new s.$XK(Bt)):kt=s.$TK.replace(gt,Bt);const bt=je.get(_e);bt?bt.push(kt):je.set(_e,[kt])}else Re.renameFile($.URI.revive(Ze.oldResource),$.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of je)Re.set(Ze,Ve);return Re}Ee.to=fe})(de||(e.WorkspaceEdit=de={}));var he;(function(Ee){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Fe[Re]=="number"?Fe[Re]:6}Ee.from=fe;function G(Re){for(const je in Fe)if(Fe[je]===Re)return Number(je);return s.SymbolKind.Property}Ee.to=G})(he||(e.SymbolKind=he={}));var te;(function(Ee){function Fe(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ee.to=fe})(te||(e.SymbolTag=te={}));var Se;(function(Ee){function Fe(G){return{name:G.name,kind:he.from(G.kind),tags:G.tags&&G.tags.map(te.from),containerName:G.containerName,location:Ie.from(G.location)}}Ee.from=Fe;function fe(G){const Re=new s.$5K(G.name,he.to(G.kind),G.containerName,Ie.to(G.location));return Re.tags=G.tags&&G.tags.map(te.to),Re}Ee.to=fe})(Se||(e.WorkspaceSymbol=Se={}));var oe;(function(Ee){function Fe(G){const Re={name:G.name||"!!MISSING: name!!",detail:G.detail,range:b.from(G.range),selectionRange:b.from(G.selectionRange),kind:he.from(G.kind),tags:G.tags?.map(te.from)??[]};return G.children&&(Re.children=G.children.map(Fe)),Re}Ee.from=Fe;function fe(G){const Re=new s.$6K(G.name,G.detail,he.to(G.kind),b.to(G.range),b.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Re.tags=G.tags.map(te.to)),G.children&&(Re.children=G.children.map(fe)),Re}Ee.to=fe})(oe||(e.DocumentSymbol=oe={}));var Y;(function(Ee){function Fe(G){const Re=new s.$0K(he.to(G.kind),G.name,G.detail||"",$.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ee.to=Fe;function fe(G,Re,je){if(Re=Re??G._sessionId,je=je??G._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,name:G.name,detail:G.detail,kind:he.from(G.kind),uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(te.from)}}Ee.from=fe})(Y||(e.CallHierarchyItem=Y={}));var V;(function(Ee){function Fe(fe){return new s.$$K(Y.to(fe.from),fe.fromRanges.map(G=>b.to(G)))}Ee.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Ee){function Fe(fe){return new s.$_K(Y.to(fe.to),fe.fromRanges.map(G=>b.to(G)))}Ee.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Ee){function Fe(G){return{range:G.range&&b.from(G.range),uri:G.uri}}Ee.from=Fe;function fe(G){return new s.$YK($.URI.revive(G.uri),b.to(G.range))}Ee.to=fe})(Ie||(e.location=Ie={}));var Le;(function(Ee){function Fe(G){const Re=G,je=G;return{originSelectionRange:Re.originSelectionRange?b.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:je.uri,range:b.from(Re.targetRange?Re.targetRange:je.range),targetSelectionRange:Re.targetSelectionRange?b.from(Re.targetSelectionRange):void 0}}Ee.from=Fe;function fe(G){return{targetUri:$.URI.revive(G.uri),targetRange:b.to(G.range),targetSelectionRange:G.targetSelectionRange?b.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?b.to(G.originSelectionRange):void 0}}Ee.to=fe})(Le||(e.DefinitionLink=Le={}));var Ce;(function(Ee){function Fe(G){return{range:b.from(G.range),contents:B.fromMany(G.contents)}}Ee.from=Fe;function fe(G){return new s.$2K(G.contents.map(B.to),b.to(G.range))}Ee.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Ee){function Fe(G){return{range:b.from(G.range),expression:G.expression}}Ee.from=Fe;function fe(G){return new s.$VL(b.to(G.range),G.expression)}Ee.to=fe})(ce||(e.EvaluatableExpression=ce={}));var ie;(function(Ee){function Fe(G){if(G instanceof s.$WL)return{type:"text",range:b.from(G.range),text:G.text};if(G instanceof s.$XL)return{type:"variable",range:b.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$YL)return{type:"expression",range:b.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Fe;function fe(G){switch(G.type){case"text":return{range:b.to(G.range),text:G.text};case"variable":return{range:b.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:b.to(G.range),expression:G.expression}}}Ee.to=fe})(ie||(e.InlineValue=ie={}));var Q;(function(Ee){function Fe(G){return{frameId:G.frameId,stoppedLocation:b.from(G.stoppedLocation)}}Ee.from=Fe;function fe(G){return new s.$ZL(G.frameId,b.to(G.stoppedLocation))}Ee.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Ee){function Fe(G){return{range:b.from(G.range),kind:G.kind}}Ee.from=Fe;function fe(G){return new s.$3K(b.to(G.range),G.kind)}Ee.to=fe})(ee||(e.DocumentHighlight=ee={}));var $e;(function(Ee){function Fe(G){return{uri:G.uri,highlights:G.highlights.map(ee.from)}}Ee.from=Fe;function fe(G){return new s.$4K($.URI.revive(G.uri),G.highlights.map(ee.to))}Ee.to=fe})($e||(e.MultiDocumentHighlight=$e={}));var be;(function(Ee){function Fe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ee.to=Fe})(be||(e.CompletionTriggerKind=be={}));var Me;(function(Ee){function Fe(fe){return{triggerKind:be.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ee.to=Fe})(Me||(e.CompletionContext=Me={}));var le;(function(Ee){function Fe(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ee.to=fe})(le||(e.CompletionItemTag=le={}));var we;(function(Ee){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(je){return Fe.get(je)??9}Ee.from=fe;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Re(je){return G.get(je)??s.CompletionItemKind.Property}Ee.to=Re})(we||(e.CompletionItemKind=we={}));var N;(function(Ee){function Fe(fe,G){const Re=new s.$hL(fe.label);return Re.insertText=fe.insertText,Re.kind=we.to(fe.kind),Re.tags=fe.tags?.map(le.to),Re.detail=fe.detail,Re.documentation=A.$ek(fe.documentation)?B.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,v.$Fs.isIRange(fe.range)?Re.range=b.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:b.to(fe.range.insert),replacing:b.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new s.$XK(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof s.$OK?new s.$TK(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(je=>ke.to(je))),Re.command=G&&fe.command?G.fromInternal(fe.command):void 0,Re}Ee.to=Fe})(N||(e.CompletionItem=N={}));var q;(function(Ee){function Fe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:B.fromStrict(G.documentation)}}Ee.from=Fe;function fe(G){return{label:G.label,documentation:A.$ek(G.documentation)?B.to(G.documentation):G.documentation}}Ee.to=fe})(q||(e.ParameterInformation=q={}));var H;(function(Ee){function Fe(G){return{label:G.label,documentation:B.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}Ee.from=Fe;function fe(G){return{label:G.label,documentation:A.$ek(G.documentation)?B.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}Ee.to=fe})(H||(e.SignatureInformation=H={}));var j;(function(Ee){function Fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Ee.from=Fe;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Ee.to=fe})(j||(e.SignatureHelp=j={}));var J;(function(Ee){function Fe(fe,G){const Re=new s.$gL(k.to(G.position),typeof G.label=="string"?G.label:G.label.map(_.to.bind(void 0,fe)),G.kind&&ye.to(G.kind));return Re.textEdits=G.textEdits&&G.textEdits.map(ke.to),Re.tooltip=A.$ek(G.tooltip)?B.to(G.tooltip):G.tooltip,Re.paddingLeft=G.paddingLeft,Re.paddingRight=G.paddingRight,Re}Ee.to=Fe})(J||(e.InlayHint=J={}));var _;(function(Ee){function Fe(fe,G){const Re=new s.$fL(G.label);return Re.tooltip=A.$ek(G.tooltip)?B.to(G.tooltip):G.tooltip,n.Command.is(G.command)&&(Re.command=fe.fromInternal(G.command)),G.location&&(Re.location=Ie.to(G.location)),Re}Ee.to=Fe})(_||(e.InlayHintLabelPart=_={}));var ye;(function(Ee){function Fe(G){return G}Ee.from=Fe;function fe(G){return G}Ee.to=fe})(ye||(e.InlayHintKind=ye={}));var Te;(function(Ee){function Fe(G){return{range:b.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Fe;function fe(G){let Re;if(G.url)try{Re=typeof G.url=="string"?$.URI.parse(G.url,!0):$.URI.revive(G.url)}catch{}return new s.$mL(b.to(G.range),Re)}Ee.to=fe})(Te||(e.DocumentLink=Te={}));var We;(function(Ee){function Fe(G){const Re=new s.$pL(G.label);return G.textEdit&&(Re.textEdit=ke.to(G.textEdit)),G.additionalTextEdits&&(Re.additionalTextEdits=G.additionalTextEdits.map(je=>ke.to(je))),Re}Ee.to=Fe;function fe(G){return{label:G.label,textEdit:G.textEdit?ke.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Re=>ke.from(Re)):void 0}}Ee.from=fe})(We||(e.ColorPresentation=We={}));var He;(function(Ee){function Fe(G){return new s.$nL(G[0],G[1],G[2],G[3])}Ee.to=Fe;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=fe})(He||(e.Color=He={}));var Xe;(function(Ee){function Fe(G){return{range:b.from(G.range)}}Ee.from=Fe;function fe(G){return new s.$9K(b.to(G.range))}Ee.to=fe})(Xe||(e.SelectionRange=Xe={}));var rt;(function(Ee){function Fe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ee.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var it;(function(Ee){function Fe(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Fe;function fe(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ee.to=fe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Ee){function Fe(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ee.from=Fe;function fe(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ee.to=fe})(et||(e.EndOfLine=et={}));var ot;(function(Ee){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Fe})(ot||(e.ProgressLocation=ot={}));var at;(function(Ee){function Fe(G){const Re={start:G.start+1,end:G.end+1};return G.kind&&(Re.kind=Be.from(G.kind)),Re}Ee.from=Fe;function fe(G){const Re={start:G.start-1,end:G.end-1};return G.kind&&(Re.kind=Be.to(G.kind)),Re}Ee.to=fe})(at||(e.FoldingRange=at={}));var Be;(function(Ee){function Fe(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return n.$vt.Comment;case s.FoldingRangeKind.Imports:return n.$vt.Imports;case s.FoldingRangeKind.Region:return n.$vt.Region}}Ee.from=Fe;function fe(G){if(G)switch(G.value){case n.$vt.Comment.value:return s.FoldingRangeKind.Comment;case n.$vt.Imports.value:return s.FoldingRangeKind.Imports;case n.$vt.Region.value:return s.FoldingRangeKind.Region}}Ee.to=fe})(Be||(e.FoldingRangeKind=Be={}));var pt;(function(Ee){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?b.from(fe.selection):void 0,override:typeof fe.override=="boolean"?r.$jE.id:void 0}}Ee.from=Fe})(pt||(e.TextEditorOpenOptions=pt={}));var Z;(function(Ee){function Fe(je){return je instanceof s.$JL?je.toJSON():typeof je=="string"?je:fe(je)||G(je)?new s.$JL(je.baseUri??je.base,je.pattern).toJSON():je}Ee.from=Fe;function fe(je){const Ze=je;return Ze?$.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(je){const Ze=je;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Re(je){return typeof je=="string"?je:new s.$JL($.URI.revive(je.baseUri),je.pattern)}Ee.to=Re})(Z||(e.GlobPattern=Z={}));var x;(function(Ee){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:Z.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ee.from=Fe})(x||(e.LanguageSelector=x={}));var pe;(function(Ee){function Fe(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Re=>Array.isArray(Re)&&Re.every(je=>je&&typeof je=="object"&&"uri"in je&&$.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ze=>Ze instanceof s.$OK)))}Ee.is=Fe;function fe(G){return{documents:G.documents.map(Re=>Re.map(je=>({uri:$.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ze=>b.from(Ze))})))}}Ee.from=fe})(pe||(e.MappedEditsContext=pe={}));var Ue;(function(Ee){function Fe(G){return{start:G.start,end:G.end}}Ee.from=Fe;function fe(G){return new s.$$L(G.start,G.end)}Ee.to=fe})(Ue||(e.NotebookRange=Ue={}));var Qe;(function(Ee){function Fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Fe;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ee.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var tt;(function(Ee){function Fe(fe){if(fe===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===a.NotebookCellExecutionState.Pending)return;if(fe===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ee.to=Fe})(tt||(e.NotebookCellExecutionState=tt={}));var nt;(function(Ee){function Fe(G){switch(G){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Ee.from=Fe;function fe(G){switch(G){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Ee.to=fe})(nt||(e.NotebookCellKind=nt={}));var Ne;(function(Ee){function Fe(G){const Re={metadata:G.metadata??Object.create(null),cells:[]};for(const je of G.cells)s.$_L.validate(je),Re.cells.push(It.from(je));return Re}Ee.from=Fe;function fe(G){const Re=new s.$aM(G.cells.map(It.to));return(0,l.$Qf)(G.metadata)||(Re.metadata=G.metadata),Re}Ee.to=fe})(Ne||(e.NotebookData=Ne={}));var It;(function(Ee){function Fe(G){return{cellKind:nt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Kt.from):[]}}Ee.from=Fe;function fe(G){return new s.$_L(nt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Kt.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Ee.to=fe})(It||(e.NotebookCellData=It={}));var Mt;(function(Ee){function Fe(G){return{mime:G.mime,valueBytes:T.$ge.wrap(G.data)}}Ee.from=Fe;function fe(G){return new s.$bM(G.valueBytes.buffer,G.mime)}Ee.to=fe})(Mt||(e.NotebookCellOutputItem=Mt={}));var Kt;(function(Ee){function Fe(G){return{outputId:G.id,items:G.items.map(Mt.from),metadata:G.metadata}}Ee.from=Fe;function fe(G){const Re=G.items.map(Mt.to);return new s.$cM(Re,G.outputId,G.metadata)}Ee.to=fe})(Kt||(e.NotebookCellOutput=Kt={}));var jt;(function(Ee){function Fe(Re){return G(Re)?{include:Z.from(Re.include)??void 0,exclude:Z.from(Re.exclude)??void 0}:Z.from(Re)??void 0}Ee.from=Fe;function fe(Re){return G(Re)?{include:Z.to(Re.include),exclude:Z.to(Re.exclude)}:Z.to(Re)}Ee.to=fe;function G(Re){const je=Re;return je?!(0,l.$Mf)(je.include)&&!(0,l.$Mf)(je.exclude):!1}})(jt||(e.NotebookExclusiveDocumentPattern=jt={}));var wt;(function(Ee){function Fe(fe,G,Re){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(je,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ee.from=Fe})(wt||(e.NotebookStatusBarItem=wt={}));var qt;(function(Ee){function Fe(fe,G,Re){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(je,Re),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ee.from=Fe})(qt||(e.NotebookKernelSourceAction=qt={}));var Ft;(function(Ee){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ee.from=Fe})(Ft||(e.NotebookDocumentContentOptions=Ft={}));var Qt;(function(Ee){function Fe(G){return{uri:G.uri,provides:G.provides}}Ee.from=Fe;function fe(G){return new s.$eM($.URI.revive(G.uri),G.provides)}Ee.to=fe})(Qt||(e.NotebookRendererScript=Qt={}));var Ot;(function(Ee){function Fe(G){return{message:B.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:b.from(G.location.range),uri:G.location.uri}}}Ee.from=Fe;function fe(G){const Re=new s.$kM(typeof G.message=="string"?G.message:B.to(G.message));return Re.actualOutput=G.actual,Re.expectedOutput=G.expected,Re.contextValue=G.contextValue,Re.location=G.location?Ie.to(G.location):void 0,Re}Ee.to=fe})(Ot||(e.TestMessage=Ot={}));var Ct;(function(Ee){Ee.namespace=h.$GJ,Ee.denamespace=h.$HJ})(Ct||(e.TestTag=Ct={}));var Ye;(function(Ee){function Fe(G){const Re=(0,t.$KM)(G).controllerId;return{extId:c.$CJ.fromExtHostTestItem(G,Re).toString(),label:G.label,uri:$.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(je=>Ct.namespace(Re,je.id)),range:v.$Fs.lift(b.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&B.fromStrict(G.error)||null}}Ee.from=Fe;function fe(G){return{parent:void 0,error:void 0,id:c.$CJ.fromString(G.extId).localId,label:G.label,uri:$.URI.revive(G.uri),tags:(G.tags||[]).map(Re=>{const{tagId:je}=Ct.denamespace(Re);return new s.$lM(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ee.toPlain=fe})(Ye||(e.TestItem=Ye={})),function(Ee){function Fe(G){return{id:G.id}}Ee.from=Fe;function fe(G){return new s.$lM(G.id)}Ee.to=fe}(Ct||(e.TestTag=Ct={}));var Ht;(function(Ee){const Fe=(G,Re)=>{const je=[];for(const[Ve,_e]of Re)c.$CJ.compare(_e.item.extId,Ve)===2&&(Re.delete(Ve),je.push(_e));const Ze={...Ye.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(Ot.to)})),children:je.map(Ve=>Fe(Ve,Re))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function fe(G){const Re=[],je=new Map;for(const Ze of G.items){je.set(Ze.item.extId,Ze);const Ve=c.$CJ.root(Ze.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Ze.item.extId))&&Re.push(Ze)}return{completedAt:G.completedAt,results:Re.map(Ze=>Fe(Ze,je))}}Ee.to=fe})(Ht||(e.TestResults=Ht={}));var Gt;(function(Ee){function Fe(je){return{covered:je.covered,total:je.total}}function fe(je){return"line"in je?k.from(je):b.from(je)}function G(je){return"branches"in je?{count:je.executionCount,location:fe(je.location),type:1,branches:je.branches.length?je.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&fe(Ze.location)})):void 0}:{type:0,name:je.name,count:je.executionCount,location:fe(je.location)}}Ee.fromDetailed=G;function Re(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),function:je.functionCoverage&&Fe(je.functionCoverage),details:je.detailedCoverage?.map(G)}}Ee.fromFile=Re})(Gt||(e.TestCoverage=Gt={}));var ut;(function(Ee){function Fe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ee.to=Fe})(ut||(e.CodeActionTriggerKind=ut={}));var mt;(function(Ee){function Fe(G){const Re=new s.$rM(he.to(G.kind),G.name,G.detail||"",$.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ee.to=Fe;function fe(G,Re,je){if(Re=Re??G._sessionId,je=je??G._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,kind:he.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(te.from)}}Ee.from=fe})(mt||(e.TypeHierarchyItem=mt={}));var zt;(function(Ee){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ee.from=Fe})(zt||(e.ViewBadge=zt={}));var Ut;(function(Ee){function Fe(je,Ze,Ve){const _e=Ze.fileData;return _e?new s.$CL(new s.$DL(_e.name,$.URI.revive(_e.uri),_e.id,(0,L.$db)(()=>Ve(_e.id)))):je===R.$2r.uriList&&Ze.uriListData?new s.$BL(Re(Ze.uriListData)):new s.$BL(Ze.asString)}Ee.to=Fe;async function fe(je,Ze){const Ve=await Ze.asString();if(je===R.$2r.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Ze.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ee.from=fe;function G(je){return I.$ct.split(je).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return $.URI.parse(Ze)}catch{}return Ze})}function Re(je){return I.$ct.create(je.map(Ze=>typeof Ze=="string"?Ze:$.URI.revive(Ze)))}})(Ut||(e.DataTransferItem=Ut={}));var Et;(function(Ee){function Fe(G,Re){const je=G.items.map(([Ze,Ve])=>[Ze,Ut.to(Ze,Ve,Re)]);return new s.$EL(je)}Ee.toDataTransfer=Fe;async function fe(G){const Re={items:[]},je=[];for(const[Ze,Ve]of G)je.push((async()=>{Re.items.push([Ze,await Ut.from(Ze,Ve)])})());return await Promise.all(je),Re}Ee.from=fe})(Et||(e.DataTransfer=Et={}));var ht;(function(Ee){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Ee.from=Fe})(ht||(e.ChatReplyFollowup=ht={}));var Pt;(function(Ee){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:ht.from(fe)}Ee.from=Fe})(Pt||(e.ChatFollowup=Pt={}));var Yt;(function(Ee){function Fe(G){const Re=new s.$DM(Dt.to(G.role),G.content);return Re.name=G.name,Re}Ee.to=Fe;function fe(G){return{role:Dt.from(G.role),content:G.content,name:G.name}}Ee.from=fe})(Yt||(e.ChatMessage=Yt={}));var Dt;(function(Ee){function Fe(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ee.to=Fe;function fe(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ee.from=fe})(Dt||(e.ChatMessageRole=Dt={}));var qe;(function(Ee){function Fe(Re){const je={};for(const Ze of Object.keys(Re))je[Ze]=Re[Ze].map(Ee.to);return je}Ee.objectTo=Fe;function fe(Re){return{level:Rt.to(Re.level),kind:Re.kind,value:(0,w.$xh)(Re.value),description:Re.description}}Ee.to=fe;function G(Re){return{level:Rt.from(Re.level),kind:Re.kind,value:Re.value,description:Re.description}}Ee.from=G})(qe||(e.ChatVariable=qe={}));var Rt;(function(Ee){function Fe(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ee.to=Fe;function fe(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ee.from=fe})(Rt||(e.ChatVariableLevel=Rt={}));var Wt;(function(Ee){function Fe(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Jt;(function(Ee){function Fe(fe,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$iF)(fe,"chatAgents2Additions"),{content:B.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$iF)(fe,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$iF)(fe,"chatAgents2Additions"),{content:B.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Re=>({uri:Re.uri,version:Re.version,ranges:Re.ranges.map(je=>b.from(je))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:b.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:b.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$iF)(fe,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Ee.from=Fe})(Jt||(e.ChatResponseProgress=Jt={}));var ft;(function(Ee){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Ee.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Lt;(function(Ee){function Fe(fe,G,Re){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Re)}Ee.from=Fe})(Lt||(e.TerminalQuickFix=Lt={}))}),define(Pe[220],Ae([1,0,2,11,7,8,186]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class m{constructor(w,R,S,l={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=S,this.g=l,this.a=new A.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,S,l)=>{const v={dispose:this.a.push([R,S,w])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(w,R){const S=E.URI.revive(w);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const n of[...this.a]){if(l)break;const o=this.d.getDocument(S),t=await this.h(n,{document:o,reason:L.TextDocumentSaveReason.to(R)});v.push(t)}}finally{clearTimeout($)}return v}h([w,R,S],l){const $=this.b.get(w);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(S,w,R,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const n=this.b.get(w);this.b.set(w,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,S,l){const $=[],v=Date.now(),{document:n,reason:o}=l,{version:t}=n,r=Object.freeze({document:n,reason:o,waitUntil(a){if(Object.isFrozen($))throw(0,T.$8)("waitUntil can not be called async");$.push(Promise.resolve(a))}});try{R.apply(S,[r])}catch(a){return Promise.reject(a)}return Object.freeze($),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all($).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof I.$TK))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:u&&L.Range.from(u),text:i,eol:s&&L.EndOfLine.from(s)}});if(c.edits.length!==0)return t===n.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$_fc=m}),define(Pe[221],Ae([1,0,13,2,8,7,76]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;class m{constructor(S,l,$,v){this.start=S,this.deletedCount=l,this.deletedItems=$,this.items=v}asApiEvent(){return{range:new L.$$L(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,$){this.notebook=S,this.h=l,this.j=$,this.handle=$.handle,this.uri=T.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(I.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(v){S.g=v},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze($)}return this.f}setOutputs(S){this.a=S.map(I.NotebookCellOutput.to)}setOutputItems(S,l,$){const v=$.map(I.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===S);if(n&&(l||(n.items.length=0),n.items.push(...v),n.items.length>1&&n.items.every(o=>A.$OI(o.mime)))){const o=new Map,t=[];n.items.forEach(r=>{let a;o.has(r.mime)?a=o.get(r.mime):(a=[],o.set(r.mime,a),t.push(r.mime)),a.push(r.data)}),n.items.length=0,t.forEach(r=>{const a=A.$PI(o.get(r));n.items.push({mime:r,data:a.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$egc=g;class w{static{this.a=0}constructor(S,l,$,v,n){this.k=S,this.l=l,this.m=$,this.uri=v,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt($){return $=S.n($),S.b[$].apiCell},getCells($){return($?S.p($):S.b).map(n=>n.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,$){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const v={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},n=[];for(const t of S.rawEvents)t.kind===A.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,v.contentChanges):t.kind===A.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,v.contentChanges):t.kind===A.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),n.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),n.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),n.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),n.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),n.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<n.length;t++){const r=n[t],a=o.get(r.cell);if(a===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,c-1)}else v.cellChanges[a]={...v.cellChanges[a],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,$=S.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),S.with({start:l,end:$})}p(S){S=this.o(S);const l=[];for(let $=S.start;$<S.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,$){if(this.j)return;const v=[],n=[],o=[];if(S.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||n.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new m(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),$)for(const t of v)$.push(t.asApiEvent())}s(S,l,$,v){const n=this.b.splice(S,l);this.b.splice($,0,...n);const o=[new m(S,l,n.map(t=>t.apiCell),[]),new m($,0,[],n)];for(const t of o)v.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,$,v){this.b[S].setOutputItems(l,$,v)}v(S,l){const $=this.b[S];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(S,l){const $=this.b[S];$.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$fgc=w}),define(Pe[222],Ae([1,0,5,2,8,7]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class A{constructor(g,w,R,S={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=R,this.f=S,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,R,S)=>{const l=function(v){w.call(R,v)};return l.extension=g,this.a.event(l,void 0,S)}}async $participateInSave(g,w,R){const S=T.URI.revive(g),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},R,async(n,o)=>{const t=Date.now(),r=await await Promise.resolve(n);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof L.$WK?$.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if($.length===0)return!0;const v={edits:[]};for(const n of $){const{edits:o}=I.WorkspaceEdit.from(n);v.edits=v.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$vgc=A}),define(Pe[107],Ae([1,0,11,8,7]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,w,R,S,l){this.id=m,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=R,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$$L.isNotebookRange))throw(0,E.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,w){m.f.$tryRevealRange(m.id,T.NotebookRange.from(g),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$ggc=L}),define(Pe[223],Ae([1,0,11,5,15,8]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let A=class{constructor(g,w){this.c=g,this.d=w,this.a=new T.$Sd({onListenerError:E.$2}),this.b=new T.$Sd({onListenerError:E.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const R=this.d.getEditorById(g);w.visibleRanges&&R._acceptVisibleRanges(w.visibleRanges.ranges.map(L.NotebookRange.to)),w.selections&&R._acceptSelections(w.selections.selections.map(L.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const w in g)this.d.getEditorById(w)._acceptViewColumn(L.ViewColumn.to(g[w]))}};e.$xgc=A,e.$xgc=A=Ge([Ke(0,I.$ij)],A)}),define(Pe[224],Ae([1,0,8,72,163,20,66,11]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,$,v){const n=this.b++,{title:o,location:t,cancellable:r}=$,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(n,{location:E.ProgressLocation.from(t),title:o,source:a,cancellable:r},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$2),this.d(n,v,!!r)}d(l,$,v){let n;v&&(n=new L.$3d,this.c.set(l,n));const o=r=>{this.a.$progressEnd(r),this.c.delete(r),n?.dispose()};let t;try{t=$(new R(this.a,l),v&&n?n.token:L.CancellationToken.None)}catch(r){throw o(l),r}return t.then(r=>o(l),r=>o(l)),t}$acceptProgressCanceled(l){const $=this.c.get(l);$&&($.cancel(),this.c.delete(l))}}e.$Egc=g;function w(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class R extends T.$fv{constructor(l,$){super(v=>this.throttledReport(v)),this.c=l,this.d=$}throttledReport(l){this.c.$progressReport(this.d,l)}}Ge([(0,A.$uh)(100,(S,l)=>w(S,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=void 0;const w=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},R=(a,c)=>a===c,S={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),$=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Fs.lift(m.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),S.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:w(a,c,S.label,l(h=>({label:h}))),description:w(a,void 0,S.description,l(h=>({description:h}))),sortText:w(a,void 0,S.sortText,l(h=>({sortText:h}))),canResolveChildren:w(a,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:w(a,!1,S.busy,l(h=>({busy:h}))),error:w(a,void 0,S.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(a,[],S.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),v=a=>{const c=I.$CJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=m.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>m.TestTag.to({id:(0,A.$HJ)(i).tagId})),h},n=a=>{let c;for(const h of a.tests){const i=v(h.item);(0,T.$KM)(i).parent=c,c=i}return c};e.$1M=n;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$JM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,L.$IM)(u,T.$KM,o),enumerable:!0,writable:!1},...$(u,i)})}}e.$2M=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$3M=t;class r extends L.$EM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$KM,getChildren:s=>s.children,root:new t(c,h),toITestItem:m.TestItem.from})}}e.$4M=r}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=e.$VM=void 0;class m{static{this.c=new I.$TM("TextEditorDecorationType")}constructor(l,$,v){const n=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,n,L.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.$VM=m;class g{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let v=null;if(l instanceof A.$NK)v=new A.$OK(l,l);else if(l instanceof A.$OK)v=l;else throw new Error("Unrecognized location");this.l(v,$,!1)}insert(l,$){this.k(),this.l(new A.$OK(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof A.$OK)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,v){const n=this.c.validateRange(l);this.g.push({range:n,text:$,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,$,v,n){this.c=l,this.d=$,this._accept(v),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.m(t)},get indentSize(){return o.g},set indentSize(t){o.o(t)},get insertSpaces(){return o.h},set insertSpaces(t){o.q(t)},get cursorStyle(){return o.j},set cursorStyle(t){o.s(t)},get lineNumbers(){return o.k},set lineNumbers(t){o.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}m(l){const $=this.l(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}o(l){const $=this.n(l);if($!==null){if(typeof $=="number"){if(this.g===$)return;this.g=$}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const $=this.p(l);if(typeof $=="boolean"){if(this.h===$)return;this.h=$}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let v=!1;if(typeof l.tabSize<"u"){const n=this.l(l.tabSize);n==="auto"?(v=!0,$.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,v=!0,$.tabSize=n)}if(typeof l.indentSize<"u"){const n=this.n(l.indentSize);n==="tabSize"?(v=!0,$.indentSize=n):typeof n=="number"&&this.g!==n&&(this.g=n,v=!0,$.indentSize=n)}if(typeof l.insertSpaces<"u"){const n=this.p(l.insertSpaces);n==="auto"?(v=!0,$.insertSpaces=n):this.h!==n&&(this.h=n,v=!0,$.insertSpaces=n)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,v=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,v=!0,$.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,$))}u(l,$){$.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$WM=w;class R{constructor(l,$,v,n,o,t,r,a){this.id=l,this.j=$,this.k=v,this.g=!1,this.h=new Set,this.c=o,this.d=new w(this.j,this.id,t,v),this.e=r,this.f=a;const c=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof A.$PK))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof A.$PK)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(n.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>L.Range.from(d));else if(i instanceof A.$NK){const{lineNumber:d,column:b}=L.Position.from(i);u=[{startLineNumber:d,startColumn:b,endLineNumber:d,endColumn:b}]}else if(i instanceof A.$OK)u=[L.Range.from(i)];else{u=[];for(const d of i)if(d instanceof A.$OK)u.push(L.Range.from(d));else{const{lineNumber:b,column:f}=L.Position.from(d);u.push({startLineNumber:b,startColumn:f,endLineNumber:b,endColumn:f})}}return $.$tryInsertSnippet(l,n.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(L.$LM(i))return $.$trySetDecorations(l,h.key,L.$MM(i));{const u=new Array(4*i.length);for(let d=0,b=i.length;d<b;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return $.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>$.$tryRevealRange(l,L.Range.from(h),i||A.TextEditorRevealType.Default))},show(h){$.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const v=$.edits.map(o=>o.range);v.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=v.length-1;o<t;o++){const r=v[o].end;if(v[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=$.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,n,{setEndOfLine:typeof $.setEndOfLine=="number"?L.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$XM=R}),define(Pe[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;function t(c,h){if((0,R.$Df)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class r extends A.$Sc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new n.$87;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(b=>u(b)?this.r(b):b):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,k=this.m(h,i,s),F={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:b,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(h,F),y={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,o.$iF)(s,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,o.$iF)(s,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(D){(0,$.$ek)(D)&&(0,o.$iF)(s,"treeViewMarkdownMessage"),k.message=D},get title(){return k.title},set title(D){k.title=D},get description(){return k.description},set description(D){k.description=D},get badge(){return k.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?k.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(k.badge=void 0)},reveal:(D,O)=>k.reveal(D,O),dispose:async()=>{await p,this.a.delete(h),k.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new m.$SE(h))}async $handleDrop(h,i,s,u,d,b,f,k){const F=this.a.get(h);if(!F)return Promise.reject(new m.$SE(h));const p=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&k&&await this.j(p,F,k,d,b),F.onDrop(p,u,d)}async j(h,i,s,u,d){const b=this.b.removeDragOperationTransfer(d);if(b)(await b)?.forEach((f,k)=>{f&&h.set(k,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new m.$SE(h));const b=await this.j(new w.$EL,d,i,u,s);if(!(!b||u.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$SE(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new m.$SE(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new m.$SE(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new m.$SE(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new m.$SE(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new m.$SE(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Xgc=r;class a extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Mf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,b){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$3d,b.contributes&&b.contributes.views)for(const p in b.contributes.views)for(const y of b.contributes.views[p])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let f,k;const F=L.Event.debounce(this.F.event,(p,y)=>(p||(p={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>k=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?p.elements.push(...y.element):p.elements.push(y.element)),y.message&&(p.message=!0),p),200,!0);this.B(F(({message:p,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=k;return f=null,this.$(y).then(()=>D())})),p&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,R.$Mf)(i.select)?!0:i.select,u=(0,R.$Mf)(i.focus)?!1:i.focus,d=(0,R.$Mf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:b.map(k=>k.item)},{select:s,focus:u,expand:d})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,S.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const b=this.getExtensionElement(d);b&&u.push(b)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Tg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Tg)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Tg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const b=this.m.get(d);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new v.$3d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=await Promise.all((0,S.$Hb)(u||[]).map(async b=>{const f=await this.f.getTreeItem(b);return f&&!i.token.isCancellationRequested?this.db(b,f,s):null}));return i.token.isCancellationRequested?void 0:(0,S.$Hb)(d)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$3d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let b=d;for(;b&&b.parent&&s.findIndex(f=>b&&b.parent&&f&&f.item.handle===b.parent.item.handle)===-1;){const f=this.j.get(b.parent.item.handle);b=f?this.m.get(f):void 0}b&&!b.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const b=this.j.get(d);if(b){const f=this.m.get(b);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Tg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$bL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$zL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new A.$Rc),d=this.kb(h,i,s),b=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,R.$Mf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$HL?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,b){if(i)return`${a.b}/${i}`;const f=t(s,this.N),k=d?d.item.handle:a.a;let F=f?f.label:u?(0,T.$zg)(u):"";F=F.indexOf("/")!==-1?F.replace("/","//"):F;const p=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,O=0;do{if(D=`${k}/${O}:${F}`,b||!this.j.has(D)||p===D)break;O++}while(O<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$HL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$HL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],b=d.filter(f=>f.item.handle===s.item.handle)[0];b&&d.splice(d.indexOf(b),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Ae([1,0,179,11,31,97,73,30,22,226,189,101]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=void 0;const l=m.$sn.as(A.$tn.JSONContribution);class ${constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$9E=$;class v{static a(h){const i=new g.$gm;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new v(i,[]);if(!i||!i.length)return new v([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),b=h.filter(f=>!u.has(f.description.identifier));return new v(d,b)}constructor(h,i){this.added=h,this.removed=i}}e.$0E=v;class n{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$$E=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$_E={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$em},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$0n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$0n}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&S.$ZE.register(h.extensionPoint,h.activationEventsGenerator),e.$_E.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$_E),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$aF=r;const a={ExtensionsRegistry:"ExtensionsRegistry"};m.$sn.add(a.ExtensionsRegistry,new r),e.$bF=m.$sn.as(a.ExtensionsRegistry),l.registerSchema(t,e.$_E),l.registerSchema(R.$Bj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[228],Ae([1,0,175,16,26,227,35,5]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function $(v,n,o){if(!v)return;const t=T.$Df(v.type)?v.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const a of v.required)T.$Df(a)&&r.push(a);return{extensionId:n.value,taskType:t,required:r,properties:v.properties?I.$gn(v.properties):{},when:v.when?A.$Yi.deserialize(v.when):void 0}}l.from=$})(w||(w={}));const R=L.$bF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const v of l)v.type&&$.push(`onTaskType:${v.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class S{constructor(){this.d=new m.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,v)=>{R.setHandler((n,o)=>{this.c=void 0;try{for(const t of o.removed){const r=t.value;for(const a of r)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const r=t.value;for(const a of r){const c=w.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const v of this.all()){const n={type:"object",additionalProperties:!1};v.required.length>0&&(n.required=v.required.slice(0)),v.properties!==void 0?n.properties=I.$gn(v.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[v.taskType]},$.push(n)}this.c={oneOf:$}}return this.c}}e.$dG=new S}),define(Pe[229],Ae([1,0,176,16,25,26,35,228]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$nG=e.JsonSchemaVersion=e.ExecutionEngine=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$hG=e.ShellQuoting=e.$gG=e.$fG=e.$eG=void 0,e.$eG="settings",e.$fG=new A.$fj("taskRunning",!1,E.localize(0,null)),e.$gG={value:E.localize(1,null),original:"Tasks"};var g;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$hG="$customized",function(C){function P(X){if(!X)return C.Strong;switch(X.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=P}(g||(e.ShellQuoting=g={}));var w;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(R||(e.RevealKind=R={})),function(C){function P(X){switch(X.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=P}(R||(e.RevealKind=R={}));var S;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(C){function P(X){switch(X.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=P}(S||(e.RevealProblemKind=S={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function P(X){switch(X.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=P}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var v;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(C){function P(ae){switch(ae.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=P;function X(ae){switch(ae){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=X}(v||(e.RuntimeType=v={}));var n;(function(C){function P(X){return T.$Df(X)?X:X.value}C.value=P})(n||(e.CommandString=n={}));var o;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function P(ae){return ae===C.Clean._id||ae===C.Build._id||ae===C.Rebuild._id||ae===C.Test._id}C.is=P;function X(ae){if(ae!==void 0)return T.$Df(ae)?P(ae)?{_id:ae,isDefault:!1}:void 0:ae}C.from=X})(o||(e.TaskGroup=o={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var r;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function P(X){switch(X){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=P})(r||(e.TaskSourceKind=r={}));var a;(function(C){C.parallel="parallel",C.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(P,X,ae,ge,ve,ke){this._label="",this._id=P,X&&(this._label=X),ae&&(this.type=ae),this.runOptions=ge,this.configurationProperties=ve,this._source=ke}getDefinition(P){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const P={folder:this.d(),id:this._id};return JSON.stringify(P)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(P,X=!1){if(P===void 0)return!1;if(T.$Df(P))return P===this._label||P===this.configurationProperties.identifier||X&&P===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===P._key}getQualifiedLabel(){const P=this.getWorkspaceFolder();return P?`${this._label} (${P.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(P){this.c===void 0&&(this.c=[]),P&&(this.c=this.c.concat(P))}get taskLoadMessages(){return this.c}}e.$iG=i;class s extends i{constructor(P,X,ae,ge,ve,ke,de,he){super(P,ae,void 0,de,he,X),this.command={},this._source=X,this.hasDefinedMatchers=ke,ve&&(this.command=ve)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(P=!1){if(P&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case v.Shell:X="shell";break;case v.Process:X="process";break;case v.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(P){return P instanceof s}getMapKey(){const P=this._source.config.workspaceFolder;return P?`${P.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$eG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const P=this.d();if(!P)return;let X=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(X+=this._source.kind);const ae={type:e.$hG,folder:P,id:X};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$zg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(P){return new s(P._id,P._source,P._label,P.type,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$jG=s;class u extends i{constructor(P,X,ae,ge,ve,ke,de){super(P,ae,ge,ke,de,X),this._source=X,this.configures=ve}static is(P){return P instanceof u}f(P){return P}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$zg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$eG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const P=this.d();if(!P)return;let X=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(X+=this._source.kind);const ae={type:e.$hG,folder:P,id:X};return JSON.stringify(ae)}}e.$kG=u;class d extends i{constructor(P,X,ae,ge,ve,ke,de,he,te){super(P,ae,ge,he,te,X),this.defines=ve,this.hasDefinedMatchers=de,this.command=ke,this.icon=te.icon,this.hide=te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(P){return P instanceof d}getMapKey(){const P=this._source.workspaceFolder;return P?`${this._source.scope.toString()}|${P.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const P={type:"contributed",scope:this._source.scope,id:this._id};return P.folder=this.d(),JSON.stringify(P)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(P){return new d(P._id,P._source,P._label,P.type,P.defines,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$lG=d;class b extends i{constructor(P,X,ae,ge,ve,ke){super(P,ae,ge,ve,ke,X),this._source=X}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(P){return P instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(P){return new b(P._id,P._source,P._label,P.type,P.runOptions,P.configurationProperties)}}e.$mG=b;var f;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(C){C._default=C.Terminal}(f||(e.ExecutionEngine=f={}));var k;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class F{constructor(P){this.c=new Map;for(let X=0;X<P.length;X++)this.c.set(P[X].uri.toString(),X)}compare(P,X){const ae=P.getWorkspaceFolder(),ge=X.getWorkspaceFolder();if(ae&&ge){let ve=this.c.get(ae.uri.toString());ve=ve===void 0?0:ve+1;let ke=this.c.get(ge.uri.toString());return ke=ke===void 0?0:ke+1,ve===ke?P._label.localeCompare(X._label):ve-ke}else return!ae&&ge?-1:ae&&!ge?1:0}}e.$nG=F;var p;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(p||(e.TaskEventKind=p={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var O;(function(C){function P(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function X(he,te,Se){return{...P(he),kind:"start",terminalId:te,resolvedVariables:Se}}C.start=X;function ae(he,te,Se){return{...P(he),kind:"processStarted",terminalId:te,processId:Se}}C.processStarted=ae;function ge(he,te,Se){return{...P(he),kind:"processEnded",terminalId:te,exitCode:Se}}C.processEnded=ge;function ve(he,te,Se){return{...P(he),kind:"terminated",exitReason:Se,terminalId:te}}C.terminated=ve;function ke(he,te,Se){return{...P(te),kind:he,terminalId:Se}}C.general=ke;function de(){return{kind:"changed"}}C.changed=de})(O||(e.TaskEvent=O={}));var K;(function(C){function P(ae){const ge=Object.keys(ae).sort();let ve="";for(const ke of ge){let de=ae[ke];de instanceof Object?de=P(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ve+=ke+","+de+","}return ve}function X(ae){const ve={_key:P(ae),type:ae.taskType};return Object.assign(ve,ae),ve}C.create=X})(K||(e.KeyedTaskIdentifier=K={}));var U;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var M;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var B;(function(C){function P(X,ae){const ge=m.$dG.get(X.type);if(ge===void 0){const he=L.$gn(X);return delete he._key,K.create(he)}const ve=Object.create(null);ve.type=ge.taskType;const ke=new Set;ge.required.forEach(he=>ke.add(he));const de=ge.properties;for(const he of Object.keys(de)){const te=X[he];if(te!=null)ve[he]=te;else if(ke.has(he)){const Se=de[he];if(Se.default!==void 0)ve[he]=L.$gn(Se.default);else switch(Se.type){case"boolean":ve[he]=!1;break;case"number":case"integer":ve[he]=0;break;case"string":ve[he]="";break;default:ae.error(E.localize(2,null,JSON.stringify(X,void 0,0),he));return}}}return K.create(ve)}C.createTaskIdentifier=P})(B||(e.TaskDefinition=B={}))}),define(Pe[230],Ae([1,0,11]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=e.$a7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,E.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$a7b=T;class I extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$b7b=I}),define(Pe[49],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Av=E;const T=[];function I(m){const g=new E(m);return T[g.nid]=g,g}e.$Bv=I;function L(m){return T[m].sid}e.$Cv=L;class A{constructor(g){this.value=g}}e.$Dv=A}),define(Pe[3],Ae([1,0,49]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$KK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var L;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class S{static{this.a=0}static mixin(o){return o._id=S.a++,o}}e.$JK=S;var l;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})($||(e.ISuggestResultDtoField=$={}));var v;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$KK={MainThreadAuthentication:(0,E.$Bv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Bv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Bv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Bv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Bv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Bv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Bv)("MainThreadCommands"),MainThreadComments:(0,E.$Bv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Bv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Bv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Bv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Bv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Bv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Bv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Bv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Bv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Bv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Bv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Bv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Bv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Bv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Bv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Bv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Bv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Bv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Bv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Bv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Bv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Bv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Bv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Bv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Bv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Bv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Bv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Bv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Bv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Bv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Bv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Bv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Bv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Bv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Bv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Bv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Bv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Bv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Bv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Bv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Bv)("MainThreadSCM"),MainThreadSearch:(0,E.$Bv)("MainThreadSearch"),MainThreadShare:(0,E.$Bv)("MainThreadShare"),MainThreadTask:(0,E.$Bv)("MainThreadTask"),MainThreadWindow:(0,E.$Bv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Bv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Bv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Bv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Bv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Bv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Bv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Bv)("MainThreadInteractive"),MainThreadChat:(0,E.$Bv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Bv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Bv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Bv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Bv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Bv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Bv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Bv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Bv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Bv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Bv)("MainThreadIssueReporter")},e.$LK={ExtHostCommands:(0,E.$Bv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Bv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Bv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Bv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Bv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Bv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Bv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Bv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Bv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Bv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Bv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Bv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Bv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Bv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Bv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Bv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Bv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Bv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Bv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Bv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Bv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Bv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Bv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Bv)("ExtHostSCM"),ExtHostSearch:(0,E.$Bv)("ExtHostSearch"),ExtHostTask:(0,E.$Bv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Bv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Bv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Bv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Bv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Bv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Bv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Bv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Bv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Bv)("ExtHostProgress"),ExtHostComments:(0,E.$Bv)("ExtHostComments"),ExtHostSecretState:(0,E.$Bv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Bv)("ExtHostStorage"),ExtHostUrls:(0,E.$Bv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Bv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Bv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Bv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$Bv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Bv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Bv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Bv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Bv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Bv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Bv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Bv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Bv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Bv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Bv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Bv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Bv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Bv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Bv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Bv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Bv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Bv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Bv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Bv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Bv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Bv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Bv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Bv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Bv)("ExtHostIssueReporter")}}),define(Pe[231],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$KK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,g)??[]}getRelatedInformation(A,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,m),new T.$MK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Xec=I}),define(Pe[81],Ae([1,0,4,15,3,17]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=e.$5ec=e.$4ec=void 0,e.$4ec=(0,E.$1h)("IExtHostApiDeprecationService");let A=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(I.$KK.MainThreadTelemetry)}report(g,w,R){const S=this.d(g,w);this.a.has(S)||(this.a.add(S),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$5ec=A,e.$5ec=A=Ge([Ke(0,L.$OM),Ke(1,T.$ij)],A),e.$6ec=Object.freeze(new class{report(m,g,w){}})}),define(Pe[232],Ae([1,0,5,3,7,22]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=w.getProxy(T.$KK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,R,S,l={}){const $=L.$fm.toKey(w.identifier),v=[...S].sort().join(" ");return await this.f.getOrCreate(`${$} ${R} ${v}`,async()=>{await this.a.$ensureProvider(R);const n=w.displayName||w.name;return this.a.$getSession(R,S,$,n,l)})}async getSessions(w,R,S){const l=L.$fm.toKey(w.identifier),$=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(R);const v=w.displayName||w.name;return this.a.$getSessions(R,S,l,v)})}async removeSession(w,R){const S=this.b.get(w);return S?S.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,S,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===w)||this.c.push({id:w,label:R});const $=S.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(w,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(w,R,l?.supportsMultipleAccounts??!1),new I.$MK(()=>{$.dispose(),this.b.delete(w);const v=this.c.findIndex(n=>n.id===w);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,S){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(R,S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.d.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$9ec=A;class m{constructor(){this.a=new Map}getOrCreate(w,R){const S=this.a.get(w);if(S)return S;const l=R().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[233],Ae([1,0,3,17,8]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let L=class{constructor(m,g){this.a=m.getProxy(E.$KK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,w){const R=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$0ec=L,e.$0ec=L=Ge([Ke(0,T.$OM)],L)}),define(Pe[234],Ae([1,0,5,67,6,3,8]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class m{static{this.a=0}constructor(R,S){this.extension=R,this.provider=S,this.handle=m.a++}}class g{static{this.a=0}constructor(R){this.b=new Map,this.c=new Map,this.d=new E.$Sd,this.onDidPerformUserAction=this.d.event,this.e=R.getProxy(L.$KK.MainThreadChat)}registerChatProvider(R,S,l){const $=new m(R,l);return this.b.set($.handle,$),this.e.$registerChatProvider($.handle,S),(0,I.$Qc)(()=>{this.e.$unregisterChatProvider($.handle),this.b.delete($.handle)})}transferChatSession(R,S){const l=T.Iterable.find(this.c.keys(),$=>this.c.get($)===R)??0;typeof l=="number"&&this.e.$transferChatSession(l,S)}sendInteractiveRequestToProvider(R,S){this.e.$sendRequestToProvider(R,S)}async $prepareChat(R,S){const l=this.b.get(R);if(!l)return;const $=await l.provider.prepareSession(S);if(!$)return;const v=g.a++;return this.c.set(v,$),{id:v,requesterUsername:$.requester?.name,requesterAvatarIconUri:$.requester?.icon,responderUsername:$.responder?.name,responderAvatarIconUri:$.responder?.icon,inputPlaceholder:$.inputPlaceholder}}async $provideWelcomeMessage(R,S){const l=this.b.get(R);if(!l||!l.provider.provideWelcomeMessage)return;const $=await l.provider.provideWelcomeMessage(S);if($)return $.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(n=>A.ChatReplyFollowup.from(n)):A.MarkdownString.from(v))}async $provideSampleQuestions(R,S){const l=this.b.get(R);if(!l||!l.provider.provideSampleQuestions)return;const $=await l.provider.provideSampleQuestions(S);if($)return $?.map(v=>A.ChatReplyFollowup.from(v))}$releaseSession(R){this.c.delete(R)}async $onDidPerformUserAction(R){this.d.fire(R)}}e.$$ec=g}),define(Pe[235],Ae([1,0,14,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(S.$KK.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let b=!1;function f(){if(b)throw new Error("Only valid while executing the command")}const k=new E.$lh;u.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,k.p);const F=i.command?await d.validateSlashCommand(i.command):void 0,p=A.$Od.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:F},{history:s.history.map(l.ChatMessage.to)},new R.$fv(O=>{f(),typeof y>"u"&&"content"in O&&(y=p.elapsed());const K=l.ChatResponseProgress.from(d.extension,O);if(!K){this.j.error("Unknown progress type: "+JSON.stringify(O));return}if("placeholder"in O&&"resolvedContent"in O){const U=Promise.all([this.d.$handleProgressChunk(h,K),O.resolvedContent]);(0,E.$Pg)(U,u).then(M=>{if(!M)return;const[B,C]=M,P=l.ChatResponseProgress.from(d.extension,C);if(!P){this.j.error("Unknown progress type: "+JSON.stringify(C));return}this.d.$handleProgressChunk(h,P,B??void 0)})}else this.d.$handleProgressChunk(h,K)}),u);return await(0,E.$Pg)(Promise.resolve(D).then(O=>{if(O){this.g.set(c,O);let K=this.h.get(c);K||(K=new Map,this.h.set(c,K)),K.set(h,O);const U={firstProgress:y,totalElapsed:p.elapsed()};return{errorDetails:O.errorDetails,timings:U}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Li)(D)),responseIsIncomplete:!0}}}finally{b=!0,k.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let b;switch(i){case v.InteractiveSessionVoteDirection.Down:b=$.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:b=$.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:b,reportIssue:s}:{result:d,kind:b}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$afc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new L.$Sd,this.q=new L.$Sd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,m.$Nf)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$HL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,n.$iF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,n.$iF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,n.$iF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,n.$iF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,n.$iF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,n.$iF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,n.$iF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,n.$iF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,n.$iF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,n.$iF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,n.$hF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Pe[236],Ae([1,0,20,6,3,8,72,22,14,5]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class R{constructor(v,n){this.stream=new g.$rh,this.stream=n??new g.$rh;const o=this;this.apiObj={option:v,response:o.stream.asyncIterable}}}class S{constructor(v,n){this.a=new w.$Sd,this.b=new Map,this.c=new g.$rh,this.d=!1;const o=this;this.apiObject={result:v,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){n.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let n=this.b.get(v.index);n||(this.b.size===0?n=new R(v.index,this.c):n=new R(v.index),this.b.set(v.index,n),this.a.fire(n.apiObj)),n.stream.emitOne(v.part)}}class l{static{this.a=1}constructor(v,n){this.d=n,this.c=new Map,this.e=new Map,this.f=new m.$hm,this.b=v.getProxy(I.$KK.MainThreadChatProvider)}registerProvider(v,n,o,t){const r=l.a++;return this.c.set(r,{extension:v,provider:o}),this.b.$registerProvider(r,n,{extension:v,model:t.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,n,o,t,r){const a=this.c.get(v);if(!a)return;const c=new A.$fv(async h=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(n,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(L.ChatMessage.to),t,c,r)}allowListExtensionWhile(v,n){this.f.set(v,n),n.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,n){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(n);if(!o)throw new Error(`ChatAccess '${n}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(v)},makeRequest(r,a,c){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const h=new E.$3d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(v,n,i,r.map(L.ChatMessage.from),a??{},h.token),u=new S(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(v,n){const o=this.e.get(v);o&&o.res.handleFragment(n)}}e.$_ec=l}),define(Pe[237],Ae([1,0,6,3,11,8]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class A{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$KK.MainThreadChatVariables)}async $resolveVariable(g,w,R){const S=this.b.get(g);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:w},R);if(l)return l.map(L.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,w,R,S){const l=A.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:R},resolver:S}),this.c.$registerVariable(l,{name:w,description:R}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$bfc=A}),define(Pe[238],Ae([1,0,3]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class T{constructor(L){const A=L.getProxy(E.$KK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$cfc=T}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=void 0;let u=class{#e;#t;#i;constructor(p,y,D){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$KK.MainThreadCommands),this.d=y,this.#i=D,this.#t=p.getProxy(A.$KK.MainThreadTelemetry),this.converter=new d(this,O=>{const K=this.c.get(O);return K?.result===f.Void?K:void 0},y),this.f=[{processArgument(O){return(0,w.$xh)(O)}},{processArgument(O){return(0,L.$in)(O,function(K){if(R.$Fs.isIRange(K))return I.Range.to(K);if(S.$Es.isIPosition(K))return I.Position.to(K);if(R.$Fs.isIRange(K.range)&&l.URI.isUri(K.uri))return I.location.to(K);if(K instanceof t.$ge)return K.buffer.buffer;if(!Array.isArray(K))return K})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const y=this.registerCommand(!1,p.id,async(...D)=>{const O=p.args.map((U,M)=>{if(!U.validate(D[M]))throw new Error(`Invalid argument '${U.name}' when running '${p.id}', received: ${typeof D[M]=="object"?JSON.stringify(D[M],null,"	"):D[M]} `);return U.convert(D[M])}),K=await this.executeCommand(p.internalId,...O);return p.result.convert(K,D,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new T.$MK(()=>{y.dispose(),this.c.delete(p.id)})}registerCommand(p,y,D,O,K,U){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:O,metadata:K,extension:U}),p&&this.#e.$registerCommand(y),new T.$MK(()=>{this.b.delete(y)&&p&&this.#e.$unregisterCommand(y)})}executeCommand(p,...y){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,y,!0)}async g(p,y,D){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,y,!1);{let O=!1;const K=(0,L.$in)(y,function(U){if(U instanceof T.$NK)return I.Position.from(U);if(U instanceof T.$OK)return I.Range.from(U);if(U instanceof T.$YK)return I.location.from(U);if(T.$$L.isNotebookRange(U))return I.NotebookRange.from(U);if(U instanceof ArrayBuffer)return O=!0,t.$ge.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return O=!0,t.$ge.wrap(U);if(U instanceof t.$ge)return O=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(p,O?new r.$Dv(K):K,D);return(0,w.$xh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(p,y,!1);throw U}}}async h(p,y,D){const O=this.b.get(p);if(!O)throw new Error("Unknown command");const{callback:K,thisArg:U,metadata:M}=O;if(M?.args)for(let C=0;C<M.args.length;C++)try{(0,E.$Uf)(y[C],M.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${M.args[C].name}' - ${M.args[C].description}`)}const B=c.$Od.create();try{return await K.apply(U,y)}catch(C){if(p===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...y);P&&(p=P.command)}if(this.d.error(C,p,O.extension?.identifier),!D)throw C;if(O.extension?.identifier){const P=this.#i.onExtensionError(O.extension.identifier,C);this.d.trace("forwarded error to extension?",P,O.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Li)(C)),this.id=p,this.source=O.extension?.displayName??O.extension?.name}}}finally{this.j(O,p,B.elapsed())}}j(p,y,D){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new h.$vo(y),duration:D})}$executeContributedCommand(p,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const D=this.b.get(p);return D?(y=y.map(O=>this.f.reduce((K,U)=>U.processArgument(K,D.extension?.identifier),O)),this.h(p,y,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(y=>(p&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[y,D]of this.b){const{metadata:O}=D;O&&(p[y]=O)}return Promise.resolve(p)}};e.$0M=u,e.$0M=u=Ge([Ke(0,n.$OM),Ke(1,g.$ij),Ke(2,i.$9M)],u),e.$$M=(0,v.$1h)("IExtHostCommands");class d{constructor(p,y,D){this.d=p,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,s.$lg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,y){if(!p)return;const D={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return D;const O=this.f(p.command);if(O)D.id=O.internalId,D.arguments=O.args.map((K,U)=>K.convert(p.arguments&&p.arguments[U]));else if((0,m.$Lb)(p.arguments)){const K=`${p.command} /${++this.c}`;this.b.set(K,p),y.add((0,$.$Qc)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),D.$ident=K,D.id=this.delegatingCommandId,D.arguments=[K],this.g.trace("CommandsConverter#CREATE",p.command,K)}return D}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const y=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$_M=d;class b{static{this.Uri=new b("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p)}static{this.Position=new b("position","A position in a text document",p=>T.$NK.isPosition(p),I.Position.from)}static{this.Range=new b("range","A range in a text document",p=>T.$OK.isRange(p),I.Range.from)}static{this.Selection=new b("selection","A selection in a text document",p=>T.$PK.isSelection(p),I.Selection.from)}static{this.Number=new b("number","",p=>typeof p=="number",p=>p)}static{this.String=new b("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=b.Arr(b.String)}static Arr(p){return new b(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,y=>Array.isArray(y)&&y.every(D=>p.validate(D)),y=>y.map(D=>p.convert(D)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof T.$0K,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof T.$rM,I.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof o.$2M,I.TestItem.from)}constructor(p,y,D,O){this.name=p,this.description=y,this.validate=D,this.convert=O}optional(){return new b(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,y){return new b(p??this.name,y??this.description,this.validate,this.convert)}}e.$aN=b;class f{static{this.Void=new f("no result",p=>p)}constructor(p,y){this.description=p,this.convert=y}}e.$bN=f;class k{constructor(p,y,D,O,K){this.id=p,this.internalId=y,this.description=D,this.args=O,this.result=K}}e.$cN=k}),define(Pe[239],Ae([1,0,18,13,2,80,96,35,32,8,7]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;const S=[new g.$cN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of DocumentHighlight-instances.",$(w.DocumentHighlight.to))),new g.$cN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$aN.Uri],new g.$bN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,E.$Kb)(n))return;class t extends R.$5K{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new R.$YK(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return n.map(t.to)})),new g.$cN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$aN.Uri,new g.$aN("options","Formatting options",n=>!0,n=>n)],new g.$bN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$cN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$aN.Uri,g.$aN.Range,new g.$aN("options","Formatting options",n=>!0,n=>n)],new g.$bN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$cN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$aN.Uri,g.$aN.Position,new g.$aN("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$aN("options","Formatting options",n=>!0,n=>n)],new g.$bN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$cN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$cN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$cN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$cN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$cN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Location-instances.",$(w.location.to))),new g.$cN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of Hover-instances.",$(w.Hover.to))),new g.$cN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$aN.Uri,new g.$aN("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>R.$NK.isPosition(o)),n=>n.map(w.Position.from))],new g.$bN("A promise that resolves to an array of ranges.",n=>n.map(o=>{let t;for(const r of o.reverse())t=new R.$9K(w.Range.to(r),t);return t}))),new g.$cN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$aN.String.with("query","Search string")],new g.$bN("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(w.WorkspaceSymbol.to))),new g.$cN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(w.CallHierarchyItem.to))),new g.$cN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$aN.CallHierarchyItem],new g.$bN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(w.CallHierarchyIncomingCall.to))),new g.$cN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$aN.CallHierarchyItem],new g.$bN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(w.CallHierarchyOutgoingCall.to))),new g.$cN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:w.Range.to(n.range),placeholder:n.text}})),new g.$cN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$aN.Uri,g.$aN.Position,g.$aN.String.with("newName","The new symbol name")],new g.$bN("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return w.WorkspaceEdit.to(n)}})),new g.$cN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$aN.Uri,g.$aN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$bN("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(w.DocumentLink.to))),new g.$cN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$aN.Uri],new g.$bN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$3L(n.tokenTypes,n.tokenModifiers)})),new g.$cN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$aN.Uri],new g.$bN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$f$)(n);if(o.type==="full")return new R.$5L(o.data,void 0)})),new g.$cN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$aN.Uri,g.$aN.Range.optional()],new g.$bN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$3L(n.tokenTypes,n.tokenModifiers)})),new g.$cN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$aN.Uri,g.$aN.Range],new g.$bN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$f$)(n);if(o.type==="full")return new R.$5L(o.data,void 0)})),new g.$cN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$aN.Uri,g.$aN.Position,g.$aN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$aN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$bN("A promise that resolves to a CompletionList-instance.",(n,o,t)=>{if(!n)return new R.$iL([]);const r=n.suggestions.map(a=>w.CompletionItem.to(a,t));return new R.$iL(r,n.incomplete)})),new g.$cN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$aN.Uri,g.$aN.Position,g.$aN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$bN("A promise that resolves to SignatureHelp.",n=>{if(n)return w.SignatureHelp.to(n)})),new g.$cN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$aN.Uri,g.$aN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$bN("A promise that resolves to an array of CodeLens-instances.",(n,o,t)=>$(r=>new R.$aL(w.Range.to(r.range),r.command&&t.fromInternal(r.command)))(n))),new g.$cN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$aN.Uri,new g.$aN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$OK.isRange(n),n=>R.$PK.isSelection(n)?w.Selection.from(n):w.Range.from(n)),g.$aN.String.with("kind","Code action kind to return code actions for").optional(),g.$aN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$bN("A promise that resolves to an array of Command-instances.",(n,o,t)=>$(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(r.command)}else{const a=new R.$7K(r.title,r.kind?new R.$8K(r.kind):void 0);return r.edit&&(a.edit=w.WorkspaceEdit.to(r.edit)),r.command&&(a.command=t.fromInternal(r.command)),a.isPreferred=r.isPreferred,a}})(n))),new g.$cN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$aN.Uri],new g.$bN("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new R.$oL(w.Range.to(o.range),w.Color.to(o.color))):[])),new g.$cN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$aN("color","The color to show and insert",n=>n instanceof R.$nL,w.Color.from),new g.$aN("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:w.Range.from(n.range)}))],new g.$bN("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(w.ColorPresentation.to):[])),new g.$cN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$aN.Uri,g.$aN.Range],new g.$bN("A promise that resolves to an array of Inlay objects",(n,o,t)=>n.map(w.InlayHint.to.bind(void 0,t)))),new g.$cN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$aN.Uri],new g.$bN("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(w.FoldingRange.to)})),new g.$cN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$bN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new g.$cN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$aN.Uri,g.$aN.Range,new g.$aN("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$OK,n=>w.InlineValueContext.from(n))],new g.$bN("A promise that resolves to an array of InlineValue objects",n=>n.map(w.InlineValue.to))),new g.$cN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$aN("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,T.$ag)(n,T.Schemas.http,T.Schemas.https),n=>n),new g.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional(),g.$aN.String.with("label","").optional()],g.$bN.Void),new g.$cN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$aN.Uri.with("resource","Resource to open"),g.$aN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional()],g.$bN.Void),new g.$cN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$aN.Uri.with("left","Left-hand side resource of the diff editor"),g.$aN.Uri.with("right","Right-hand side resource of the diff editor"),g.$aN.String.with("title","Human readable title for the diff editor").optional(),new g.$aN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)]).optional()],g.$bN.Void),new g.$cN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$aN.String.with("title","Human readable title for the changes editor"),new g.$aN("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[t,r,a]=o;if(!I.URI.isUri(t)||!I.URI.isUri(r)&&r!==void 0&&r!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},n=>n)],g.$bN.Void),new g.$cN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$aN.Uri,g.$aN.Position],new g.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$cN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$aN.TypeHierarchyItem],new g.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$cN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$aN.TypeHierarchyItem],new g.$bN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$cN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$aN.TestItem],g.$bN.Void),new g.$cN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$aN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$bN.Void),new g.$cN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$aN.String.with("name","The context key name"),new g.$aN("value","The context key value",()=>!0,n=>n)],g.$bN.Void),new g.$cN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$aN.Uri,g.$aN.StringArray,new g.$aN("MappedEditsContext","Mapped Edits Context",n=>w.MappedEditsContext.is(n),n=>w.MappedEditsContext.from(n))],new g.$bN("A promise that resolves to a workspace edit or null",n=>n?w.WorkspaceEdit.to(n):null))];class l{static register(o){S.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$Zi)}}e.$8ec=l;function $(n){return o=>{if(Array.isArray(o))return o.map(n)}}function v(n){if(!Array.isArray(n))return;const o=[];for(const t of n)L.$rt(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Pe[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function $(v,n,o){const t=v.getProxy(S.$KK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$hm,n.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const k=this.b.get(f.handle);return k?k.value:f}else if(f&&f.$mid===7){const k=this.b.get(f.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.commentThreadHandle);return F?F.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);return F?f.$mid===8?F.value:{thread:F.value,text:f.text}:f}else if(f&&f.$mid===10){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const p=f.commentUniqueId,y=F.getCommentByUniqueId(p);return y||f}else if(f&&f.$mid===11){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const p=f.text,y=f.commentUniqueId,D=F.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=p:D.body=new R.$bL(p),D):f}return f}})}createCommentController(f,k,F){const p=r.a++,y=new c(f,p,k,F);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,k,F){const p=this.b.get(f);p&&p.$createCommentThreadTemplate(k,F)}async $updateCommentThreadTemplate(f,k,F){const p=this.b.get(f);p&&p.$updateCommentThreadTemplate(k,F)}$deleteCommentThread(f,k){this.b.get(f)?.$deleteCommentThread(k)}$provideCommentingRanges(f,k,F){const p=this.b.get(f);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(A.URI.revive(k));return(0,E.$Tg)(async()=>{const D=await p.commentingRangeProvider.provideCommentingRanges(y,F);let O;return Array.isArray(D)?O={ranges:D,fileComments:!1}:D?O={ranges:D.ranges||[],fileComments:D.fileComments||!1}:O=D??void 0,O}).then(D=>{let O;return D&&(O={ranges:D.ranges.map(K=>w.Range.from(K)),fileComments:D.fileComments}),O})}$toggleReaction(f,k,F,p,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Tg)(()=>{const O=D.getCommentThread(k);if(O){const K=O.getCommentByUniqueId(p.uniqueIdInThread);if(D!==void 0&&K&&D.reactionHandler)return D.reactionHandler(K,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,k,F,p,y,D,O,K){this.m=k,this.n=F,this.o=p,this.p=y,this.q=D,this.extensionDescription=O,this.r=K,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(k,this.handle,this.n,this.o,w.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(k,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(M){U.range=M},get comments(){return U.comments},set comments(M){U.comments=M},get collapsibleState(){return U.collapsibleState},set collapsibleState(M){U.collapsibleState=M},get canReply(){return U.canReply},set canReply(M){U.canReply=M},get contextValue(){return U.contextValue},set contextValue(M){U.contextValue=M},get label(){return U.label},set label(M){U.label=M},get state(){return U.state},set state(M){U.state=M},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const f=F=>Object.prototype.hasOwnProperty.call(this.b,F),k={};f("range")&&(k.range=w.Range.from(this.p)),f("label")&&(k.label=this.label),f("contextValue")&&(k.contextValue=this.contextValue??null),f("comments")&&(k.comments=this.q.map(F=>h(this,F,this.k,this.extensionDescription))),f("collapsibleState")&&(k.collapseState=u(this.g)),f("canReply")&&(k.canReply=this.canReply),f("state")&&(k.state=d(this.h)),f("isTemplate")&&(k.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(f){for(const k of this.k){const F=k[0],p=k[1];if(f===p)return F}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ge([(0,T.$th)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,k,F,p){this.f=f,this.g=k,this.h=F,this.i=p,this.a=new Map,t.$registerCommentController(this.handle,F,p,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,O,K){return y.createCommentThread(D,O,K).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,k,F){k===void 0&&(0,l.$iF)(this.f,"fileComments");const p=new a(this.id,this.handle,void 0,f,k,F,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(f,k){const F=new a(this.id,this.handle,void 0,A.URI.revive(f),w.Range.to(k),[],this.f,!0);return F.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(F.handle,F),F}$updateCommentThreadTemplate(f,k){const F=this.a.get(f);F&&(F.range=w.Range.to(k))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(b,f,k,F){let p=k.get(f);return p||(p=++b.commentHandle,k.set(f,p)),f.state!==void 0&&(0,l.$iF)(F,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:p,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(b){return{label:b.label,iconPath:b.iconPath?w.$NM(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function s(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?A.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function u(b){if(b!==void 0)switch(b){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(b){if(b!==void 0)switch(b){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new r}e.$ffc=$}),define(Pe[241],Ae([1,0,26,3,27,17]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let A=class{constructor(R,S){this.a=R.getProxy(T.$KK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,S){const l=this,$=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,S,$,arguments)}})}e(R,S,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:g($,this.b)}),this.c&&this.f(R,l,$)}};e.$6gc=A,e.$6gc=A=Ge([Ke(0,L.$OM),Ke(1,I.$5M)],A);const m=1e5;function g(w,R){const S=[];if(w.length)for(let l=0;l<w.length;l++){let $=w[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const v=$;v.stack?$=v.stack:$=v.toString()}S.push($)}if(R){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$ln)(S);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,19,23]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(T.$KK.MainThreadDecorations)}registerFileDecorationProvider(n,o){const t=l.c++;this.f.set(t,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Le)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$Ze)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const b of u){const f=(0,R.$mc)(b.uri.path);if(d!==f&&(d=f,s.push(b.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$MK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(n,o,t){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$9L.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$iF)(c,"codiconDecoration"),r[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),r}};e.$8fc=$,e.$8fc=$=l=Ge([Ke(0,A.$OM),Ke(1,m.$ij)],$),e.$9fc=(0,L.$1h)("IExtHostDecorations")}),define(Pe[242],Ae([1,0,158,99,2,3,7,8,5,15,28,43]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0;class ${#e;#t;#i;constructor(o,t,r,a,c,h,i,s){this.d=o,this.e=t,this.f=r,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,r),this.#i=new R.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let r=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),r=[o]}else if(Array.isArray(o)){r=[];let h;o=[...o].sort($.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,r.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const a=[];let c=0;for(const h of r){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const b of s)if(b.severity===u[d]&&i.push({...m.Diagnostic.from(b),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[r,a]of this)o.call(t,r,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$2ec=$;let v=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new R.$Ac;for(const r of o)t.set(r,r);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,r,a){this.j=t,this.k=r,this.l=a,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(L.$KK.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:r,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,k){a.$changeMany(f,k),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,k.length===0?"CLEARING":k)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!r.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(r.has(d))}return new class extends ${constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,r=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=r.length,t.set(c.toString(),i),r.push([c,[]])),r[i][1]=r[i][1].concat(...h)});return r}}m(o){let t=[];for(const r of this.g.values())r.has(o)&&(t=t.concat(r.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",r=new $(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,r),this.n=r}for(const[t,r]of o)this.n.set(I.URI.revive(t),r.map(m.Diagnostic.to))}};e.$3ec=v,e.$3ec=v=l=Ge([Ke(1,w.$ij),Ke(2,S.$1ec)],v)}),define(Pe[243],Ae([1,0,2,3,23]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class L{constructor(m){this.a=m.getProxy(T.$KK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,I.$iF)(m,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(R=>E.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?E.URI.revive(g):void 0)}}e.$0fc=L}),define(Pe[244],Ae([1,0,11,2,7,3,13,20,12]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class w{static{this.a=0}constructor(S,l,$){this.d=l,this.e=$,this.b=new Map,this.c=S.getProxy(L.$KK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const $=w.a++;this.b.set($,l),this.c.$registerTextContentProvider($,S);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(n=>{if(n.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this.d.getDocument(n)&&this.$provideTextDocumentContent($,n).then(o=>{if(!o&&typeof o!="string")return;const t=this.d.getDocument(n);if(!t)return;const r=(0,g.$Ue)(o);if(!t.equalLines(r))return this.c.$onVirtualDocumentChange(n,o)},E.$1)})),new I.$MK(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(S,l){const $=this.b.get(S);return $?Promise.resolve($.provideTextDocumentContent(T.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$$fc=w}),define(Pe[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class l{constructor(v,n){this.a=new E.$Sd({onListenerError:S.$2}),this.b=new E.$Sd({onListenerError:S.$2}),this.c=new E.$Sd({onListenerError:S.$2}),this.d=new E.$Sd({onListenerError:S.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=v.getProxy(L.$KK.MainThreadDocuments),this.g=n,this.g.onDidRemoveDocuments(o=>{for(const t of o)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const t of o)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const n=this.g.getDocument(v);if(n)return n}getDocument(v){const n=this.getDocumentData(v);if(!n?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return n.document}ensureDocumentData(v){const n=this.g.getDocument(v);if(n)return Promise.resolve(n);let o=this.h.get(v.toString());return o||(o=this.f.$tryOpenDocument(v).then(t=>{this.h.delete(v.toString());const r=I.URI.revive(t);return(0,g.$Of)(this.g.getDocument(r))},t=>(this.h.delete(v.toString()),Promise.reject(t))),this.h.set(v.toString(),o)),o}createDocumentData(v){return this.f.$tryCreateDocument(v).then(n=>I.URI.revive(n))}$acceptModelLanguageChanged(v,n){const o=I.URI.revive(v),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(n),this.a.fire(t.document)}$acceptModelSaved(v){const n=I.URI.revive(v),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(v,n){const o=I.URI.revive(v),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(n),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,n,o){const t=I.URI.revive(v),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(o),r.onEvents(n);let a;n.isUndoing?a=R.TextDocumentChangeReason.Undo:n.isRedoing&&(a=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$hn)({document:r.document,contentChanges:n.changes.map(c=>({range:m.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:a}))}setWordDefinitionFor(v,n){(0,A.$QM)(v,n)}}e.$Yec=l}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=L.URI.revive(u),b=this.c.get(d);b?.unref()&&(this.c.delete(d),h.push(b.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=L.URI.revive(u.uri);let b=this.c.get(d);if(b&&d.scheme!==v.Schemas.vscodeNotebookCell&&d.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);b||(b=new t(new g.$RM(this.h.getProxy(m.$KK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,b),i.push(b.value)),b.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=L.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const b=this.c.get(d).value,f=new R.$XM(u.id,this.h.getProxy(m.$KK.MainThreadTextEditors),this.i,new o.$V(()=>b.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(k=>S.Range.to(k)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return n.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$YM=r,e.$YM=r=Ge([Ke(0,w.$OM),Ke(1,l.$ij)],r),e.$ZM=(0,A.$1h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0,e.$yfc=(0,A.$1h)("IExtHostEditorTabs");class S{constructor(o,t,r){this.e=r,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$sM(L.URI.revive(this.b.input.uri));case 2:return new R.$tM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new R.$uM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new R.$vM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$wM(this.b.input.viewType);case 4:return new R.$xM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$yM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$zM;case 9:return new R.$AM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$BM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new S(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return w.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new S(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const t=this.c.find(r=>r.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let $=class{constructor(o){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=o.getProxy(m.$KK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,I.$Of)(o.e.find(c=>c.groupId===r)?.apiObject)},close:async(r,a)=>{const c=Array.isArray(r)?r:[r];return c.length?v(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),r=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,r),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Of)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(r=>r.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const r=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const t of this.e)for(const r of t.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const r=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");r.push(c.tabId)}return this.a.$closeTab(r,t)}async j(o,t){const r=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");r.push(c.groupId)}return this.a.$closeGroup(r,t)}};e.$zfc=$,e.$zfc=$=Ge([Ke(0,g.$OM)],$);function v(n){return n.tabs!==void 0}}),define(Pe[247],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$KK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(m,g);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider(m,w),new T.$MK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$agc=I}),define(Pe[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class l{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let t,r,a=14,c=14;for(const h of n){let i=t?(0,g.$9e)(t,h):0;for(i===0?r=1:r=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([r,h.toUpperCase().charCodeAt(i),c]),o.push([r,h.toLowerCase().charCodeAt(i),c]),r=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$hZ(o)}}provideDocumentLinks(n){this.c();const o=[],t=m.$iZ.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of t){const a=A.DocumentLink.to(r);a.target&&o.push(a)}return o}}class ${constructor(n,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(T.$KK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,t,r={}){if($.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;r.isCaseSensitive&&(c+=1024),r.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.$iF)(n,"fsChunks"),c+=4);let h;r.isReadonly&&(0,S.$ek)(r.isReadonly)&&((0,R.$iF)(n,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:b,type:f}=d;if(b.scheme!==o)continue;let k;switch(f){case L.FileChangeType.Changed:k=0;break;case L.FileChangeType.Created:k=1;break;case L.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:b,type:k})}this.a.$onFileSystemChange(a,u)});return(0,I.$Qc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:t,mtime:r,size:a,permissions:c}=n;return{type:o,ctime:t,mtime:r,size:a,permissions:c}}$stat(n,o){return Promise.resolve(this.l(n).stat(E.URI.revive(o))).then(t=>$.k(t))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(E.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(E.URI.revive(o))).then(t=>w.$ge.wrap(t))}$writeFile(n,o,t,r){return Promise.resolve(this.l(n).writeFile(E.URI.revive(o),t.buffer,r))}$delete(n,o,t){return Promise.resolve(this.l(n).delete(E.URI.revive(o),t))}$rename(n,o,t,r){return Promise.resolve(this.l(n).rename(E.URI.revive(o),E.URI.revive(t),r))}$copy(n,o,t,r){const a=this.l(n);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(E.URI.revive(o)))}$watch(n,o,t,r){const a=this.l(n).watch(E.URI.revive(t),r);this.f.set(o,a)}$unwatch(n,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(n,o,t){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(E.URI.revive(o),t))}$close(n,o){const t=this.l(n);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(n,o,t,r){const a=this.l(n);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(r);return Promise.resolve(a.read(o,t,c.buffer,0,r)).then(h=>c.slice(0,h))}$write(n,o,t,r){const a=this.l(n);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$bgc=$}),define(Pe[63],Ae([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0;let v=$=class{constructor(o,t){this.b=new Map,this.c=new R.$0g,this.a=o.getProxy(E.$KK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(a){try{let c;const h=r.b.get(a.scheme);return h?(await r.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await r.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){$.e(c)}},async readDirectory(a){try{const c=r.b.get(a.scheme);return c?(await r.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await r.a.$readdir(a)}catch(c){return $.e(c)}},async createDirectory(a){try{const c=r.b.get(a.scheme);return c&&!c.isReadonly?(await r.a.$ensureActivation(a.scheme),await r.d(c.impl,c.extUri,a)):await r.a.$mkdir(a)}catch(c){return $.e(c)}},async readFile(a){try{const c=r.b.get(a.scheme);return c?(await r.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await r.a.$readFile(a)).buffer}catch(c){return $.e(c)}},async writeFile(a,c){try{const h=r.b.get(a.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(a.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(a)),await r.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await r.a.$writeFile(a,L.$ge.wrap(c))}catch(h){return $.e(h)}},async delete(a,c){try{const h=r.b.get(a.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await r.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return $.e(h)}},async rename(a,c,h){try{return await r.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},async copy(a,c,h){try{return await r.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,r){const a=[];for(;!t.isEqual(r,t.dirname(r));)try{if(!((await o.stat(r)).type&T.FileType.Directory))throw I.$1L.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Ak(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(r)),r=t.dirname(r)}for(let c=a.length-1;c>=0;c--){r=t.joinPath(r,a[c]);try{await o.createDirectory(r)}catch(h){if(T.$Ak(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$1L)throw o;if(o instanceof T.$wk)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw I.$1L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$1L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$1L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$1L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$1L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$1L.Unavailable(o.message);default:throw new I.$1L(o.message,o.name)}if(!(o instanceof Error))throw new I.$1L(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$1L.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw I.$1L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$1L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$1L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$1L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$1L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$1L.Unavailable(o.message);default:throw new I.$1L(o.message,o.name)}}addFileSystemProvider(o,t,r){return this.b.set(o,{impl:t,extUri:r?.isCaseSensitive?S.$sg:S.$ug,isReadonly:!!r?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??S.$sg}};e.$nfc=v,e.$nfc=v=$=Ge([Ke(0,m.$OM),Ke(1,g.$1ec)],v),e.$ofc=(0,A.$1h)("IExtHostConsumerFileSystem")}),define(Pe[249],Ae([1,0,5,34,2,3,8,7,39]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,v,n,o,t,r){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Hj)(t),c=typeof t=="string",h=r?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=m.$MK.from(this.i($,n,t,r,r?.correlate),this.b,this.c,this.d,i)}i($,v,n,o,t){const r=m.$MK.from();if(typeof n=="string")return r;const a=$.getProxy(L.$KK.MainThreadFileSystemEventService);let c=!1;return(n.pattern.includes(T.$Dj)||n.pattern.includes(T.$Ej))&&(c=!0),a.$watch(v.identifier.value,this.a,n.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),m.$MK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor($){this.a=$,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor($,v,n){this.j=$,this.k=v,this.l=n,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,v,n,o){return new w(this.j,$,v,this.a.event,A.GlobPattern.from(n),o)}$onFileEvent($){this.a.fire(new R($))}$onDidRunFileOperation($,v){switch($){case 2:this.b.fire(Object.freeze({files:v.map(n=>({oldUri:I.URI.revive(n.source),newUri:I.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,v){return(n,o,t)=>{const r=function(c){n.call(o,c)};return r.extension=$,v.event(r,void 0,t)}}async $onWillRunFileOperation($,v,n,o){switch($){case 2:return await this.n(this.g,{files:v.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},n,o);case 1:return await this.n(this.i,{files:v.map(t=>I.URI.revive(t.target))},n,o);case 0:case 3:return await this.n(this.h,{files:v.map(t=>I.URI.revive(t.target))},n,o)}}async n($,v,n,o){const t=new Set,r=[];if(await $.fireAsync(v,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof m.$WK&&(r.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const a={edits:[]};for(const[,c]of r){const{edits:h}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$cgc=S}),define(Pe[250],Ae([1,0,6,2,3,8,7,32,14]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class w{static{this.a=0}constructor($,v){this.extension=$,this.provider=v,this.handle=w.a++}}class R{constructor($){this.session=$,this.responses=[]}}class S{static{this.a=0}constructor($,v,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=$.getProxy(I.$KK.MainThreadInlineChat),v.registerApiCommand(new m.$cN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$aN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],m.$bN.Void))}registerProvider($,v,n){const o=new w($,v);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??$.displayName??$.name,$.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",n?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession($,v,n,o){const t=this.b.get($);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(v)),a=L.Selection.to(n),c=await t.provider.prepareInteractiveEditorSession({document:r,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new R(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:L.Range.from(c.wholeRange),message:c.message}}async $provideResponse($,v,n,o){const t=this.b.get($);if(!t)return;const r=this.d.get(v.id);if(!r)return;const a={prompt:n.prompt,selection:L.Selection.to(n.selection),wholeRange:L.Range.to(n.wholeRange),attempt:n.attempt,live:n.live};let c=!1;const h={report:async b=>{if(!n.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:b.message,edits:b.edits?.map(L.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:A.$bL.isMarkdownString(b.content)?b.content.value:b.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(r.session,a,h,o));let s;try{s=await(0,g.$Pg)(i,o)}finally{c=!0}if(!s)return;const u=r.responses.push(s)-1,d={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s)){const{edits:b,contents:f}=s,k=f!==void 0?L.MarkdownString.from(f):void 0;return b instanceof A.$WK?{...d,id:u,type:"bulkEdit",edits:L.WorkspaceEdit.from(b),message:k}:{...d,id:u,type:"editorEdit",edits:b.map(L.TextEdit.from),message:k}}return{...d,id:u,type:"message",message:L.MarkdownString.from(s.contents)}}async $provideFollowups($,v,n,o){const t=this.b.get($),r=this.d.get(v),a=r?.responses[n];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(r.session,a,o));return(await(0,g.$Pg)(c,o))?.map(L.ChatReplyFollowup.from)}}$handleFeedback($,v,n,o){const t=this.b.get($),r=this.d.get(v),a=r?.responses[n];if(t&&a){const c=L.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(r.session,a,c)}}$releaseSession($,v){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$dgc=S}),define(Pe[251],Ae([1,0,2,32]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class I{constructor(A,m,g,w,R){this.a=m,this.b=g,this.c=w;const S=new T.$cN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$aN("showOptions","Show Options",l=>!0,l=>l),new T.$aN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$aN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$aN("title","Interactive editor title",l=>!0,l=>l)],new T.$bN("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,m,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$qgc=I}),define(Pe[252],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class I{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(E.$KK.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(A);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(A,m){const g=A.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new T.$MK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(A,m){const g=A.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new T.$MK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$rgc=I}),define(Pe[253],Ae([1,0,6,3]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(T.$KK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$sgc=I}),define(Pe[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,96,89,75,60,11,14,23,160]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class u{constructor(N,q){this.d=N,this.e=q}async provideDocumentSymbols(N,q){const H=this.d.getDocument(N),j=await this.e.provideDocumentSymbols(H,q);if(!(0,R.$Kb)(j))return j[0]instanceof L.$6K?j.map(I.DocumentSymbol.from):u.f(j)}static f(N){N=N.slice(0).sort((j,J)=>{let _=j.location.range.start.compareTo(J.location.range.start);return _===0&&(_=J.location.range.end.compareTo(j.location.range.end)),_});const q=[],H=[];for(const j of N){const J={name:j.name||"!!MISSING: name!!",kind:I.SymbolKind.from(j.kind),tags:j.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:I.Range.from(j.location.range),selectionRange:I.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(J),q.push(J);break}const _=H[H.length-1];if(w.$Fs.containsRange(_.range,J.range)&&!w.$Fs.equalsRange(_.range,J.range)){_.children?.push(J),H.push(J);break}H.pop()}}return q}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(N,q,H){this.g=N,this.h=q,this.j=H,this.e=new r.$Wec("CodeLens"),this.f=new Map}async provideCodeLenses(N,q){const H=this.g.getDocument(N),j=await this.j.provideCodeLenses(H,q);if(!j||q.isCancellationRequested)return;const J=this.e.add(j),_=new n.$Rc;this.f.set(J,_);const ye={cacheId:J,lenses:[]};for(let Te=0;Te<j.length;Te++)ye.lenses.push({cacheId:[J,Te],range:I.Range.from(j[Te].range),command:this.h.toInternal(j[Te].command,_)});return ye}async resolveCodeLens(N,q){const H=N.cacheId&&this.e.get(...N.cacheId);if(!H)return;let j;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?j=H:j=await this.j.resolveCodeLens(H,q),j||(j=H),q.isCancellationRequested)return;const J=N.cacheId&&this.f.get(N.cacheId[0]);if(J)return N.command=this.h.toInternal(j.command??d.d,J),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}function b(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class f{constructor(N,q){this.d=N,this.e=q}async provideDefinition(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDefinition(j,J,H);return b(_)}}class k{constructor(N,q){this.d=N,this.e=q}async provideDeclaration(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDeclaration(j,J,H);return b(_)}}class F{constructor(N,q){this.d=N,this.e=q}async provideImplementation(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideImplementation(j,J,H);return b(_)}}class p{constructor(N,q){this.d=N,this.e=q}async provideTypeDefinition(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideTypeDefinition(j,J,H);return b(_)}}class y{constructor(N,q){this.d=N,this.e=q}async provideHover(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideHover(j,J,H);if(!(!_||(0,R.$Kb)(_.contents)))return _.range||(_.range=j.getWordRangeAtPosition(J)),_.range||(_.range=new L.$OK(J,J)),I.Hover.from(_)}}class D{constructor(N,q){this.d=N,this.e=q}async provideEvaluatableExpression(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideEvaluatableExpression(j,J,H);if(_)return I.EvaluatableExpression.from(_)}}class O{constructor(N,q){this.d=N,this.e=q}async provideInlineValues(N,q,H,j){const J=this.d.getDocument(N),_=await this.e.provideInlineValues(J,I.Range.to(q),I.InlineValueContext.to(H),j);if(Array.isArray(_))return _.map(ye=>I.InlineValue.from(ye))}}class K{constructor(N,q){this.d=N,this.e=q}async provideDocumentHighlights(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDocumentHighlights(j,J,H);if(Array.isArray(_))return _.map(I.DocumentHighlight.from)}}class U{constructor(N,q){this.d=N,this.e=q}async provideMultiDocumentHighlights(N,q,H,j){const J=this.d.getDocument(N),_=H.map(We=>this.d.getDocument(We)),ye=I.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(J,ye,_,j);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class M{constructor(N,q){this.d=N,this.e=q}async provideLinkedEditingRanges(N,q,H){const j=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideLinkedEditingRanges(j,J,H);if(_&&Array.isArray(_.ranges))return{ranges:(0,R.$Hb)(_.ranges.map(I.Range.from)),wordPattern:_.wordPattern}}}class B{constructor(N,q){this.d=N,this.e=q}async provideReferences(N,q,H,j){const J=this.d.getDocument(N),_=I.Position.to(q),ye=await this.e.provideReferences(J,_,H,j);if(Array.isArray(ye))return ye.map(I.location.from)}}class C{static{this.d=1e3}constructor(N,q,H,j,J,_,ye){this.g=N,this.h=q,this.j=H,this.k=j,this.l=J,this.m=_,this.n=ye,this.e=new r.$Wec("CodeAction"),this.f=new Map}async provideCodeActions(N,q,H,j){const J=this.g.getDocument(N),_=l.$Hs.isISelection(q)?I.Selection.to(q):I.Range.to(q),ye=[];for(const it of this.j.getDiagnostics(N))if(_.intersection(it.range)&&ye.push(it)>C.d)break;const Te={diagnostics:ye,only:H.only?new L.$8K(H.only):void 0,triggerKind:I.CodeActionTriggerKind.to(H.trigger)},We=await this.k.provideCodeActions(J,_,Te,j);if(!(0,R.$Lb)(We)||j.isCancellationRequested)return;const He=this.e.add(We),Xe=new n.$Rc;this.f.set(He,Xe);const rt=[];for(let it=0;it<We.length;it++){const et=We[it];et&&(C.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Xe)})):(Te.only&&(et.kind?Te.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[He,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Xe),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.$hF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:He,actions:rt}}async resolveCodeAction(N,q){const[H,j]=N,J=this.e.get(H,j);if(!J||C.o(J))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(J,q)??J;let ye;_.edit&&(ye=I.WorkspaceEdit.from(_.edit,void 0));let Te;if(_.command){const We=this.f.get(H);We&&(Te=this.h.toInternal(_.command,We))}return{edit:ye,command:Te}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}class P{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,H,j,J){this.d=N,this.e=q,this.f=H,this.g=j,this.h=J}async prepareDocumentPaste(N,q,H,j){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(N),_=q.map(We=>I.Range.to(We)),ye=I.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(J,_,ye,j),j.isCancellationRequested)return;const Te=Array.from(ye).filter(([,We])=>!(We instanceof L.$BL));return I.DataTransfer.from(Te)}async providePasteEdits(N,q,H,j,J){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(q),ye=H.map(He=>I.Range.to(He)),Te=I.DataTransfer.toDataTransfer(j,async He=>(await this.d.$resolvePasteFileData(this.g,N,He)).buffer),We=await this.f.provideDocumentPasteEdits(_,ye,Te,J);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:P.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class X{constructor(N,q){this.d=N,this.e=q}async provideDocumentFormattingEdits(N,q,H){const j=this.d.getDocument(N),J=await this.e.provideDocumentFormattingEdits(j,q,H);if(Array.isArray(J))return J.map(I.TextEdit.from)}}class ae{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeFormattingEdits(N,q,H,j){const J=this.d.getDocument(N),_=I.Range.to(q),ye=await this.e.provideDocumentRangeFormattingEdits(J,_,H,j);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,q,H,j){(0,S.$Nf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(N),_=q.map(I.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(J,_,H,j);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}}class ge{constructor(N,q){this.d=N,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,q,H,j,J){const _=this.d.getDocument(N),ye=I.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(_,ye,H,j,J);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class ve{constructor(N,q){this.e=N,this.f=q,this.d=new r.$Wec("WorkspaceSymbols")}async provideWorkspaceSymbols(N,q){const H=await this.e.provideWorkspaceSymbols(N,q);if(!(0,R.$Lb)(H))return{symbols:[]};const j=this.d.add(H),J={cacheId:j,symbols:[]};for(let _=0;_<H.length;_++){const ye=H[_];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}J.symbols.push({...I.WorkspaceSymbol.from(ye),cacheId:[j,_]})}return J}async resolveWorkspaceSymbol(N,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const H=this.d.get(...N.cacheId);if(H){const j=await this.e.resolveWorkspaceSymbol(H,q);return j&&(0,T.$jn)(N,I.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class ke{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,q,H){this.d=N,this.e=q,this.f=H}async provideRenameEdits(N,q,H,j){const J=this.d.getDocument(N),_=I.Position.to(q);try{const ye=await this.e.provideRenameEdits(J,_,H,j);return ye?I.WorkspaceEdit.from(ye):void 0}catch(ye){const Te=ke.g(ye);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(N,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(N),J=I.Position.to(q);try{const _=await this.e.prepareRename(j,J,H);let ye,Te;if(L.$OK.isRange(_)?(ye=_,Te=j.getText(_)):(0,S.$Ff)(_)&&(ye=_.range,Te=_.placeholder),!ye||!Te)return;if(ye.start.line>J.line||ye.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ye),text:Te}}catch(_){const ye=ke.g(_);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(_)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class de{constructor(N,q){this.resultId=N,this.tokens=q}}class he{constructor(N,q){this.f=N,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,q,H){const j=this.f.getDocument(N),J=q!==0?this.d.get(q):null;let _=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,J.resultId,H):await this.g.provideDocumentSemanticTokens(j,H);return J&&this.d.delete(q),_?(_=he.h(_),this.o(he.n(J,_),_)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return he.j(N)?he.k(N)?N:new L.$5L(new Uint32Array(N.data),N.resultId):he.l(N)?he.m(N)?N:new L.$7L(N.edits.map(q=>new L.$6L(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(N,q){if(!he.j(q)||!N||!N.tokens)return q;const H=N.tokens,j=H.length,J=q.data,_=J.length;let ye=0;const Te=Math.min(j,_);for(;ye<Te&&H[ye]===J[ye];)ye++;if(ye===j&&ye===_)return new L.$7L([],q.resultId);let We=0;const He=Te-ye;for(;We<He&&H[j-We-1]===J[_-We-1];)We++;return new L.$7L([{start:ye,deleteCount:j-ye-We,data:J.subarray(ye,_-We)}],q.resultId)}o(N,q){if(he.j(N)){const H=this.e++;return this.d.set(H,new de(N.resultId,N.data)),(0,o.$e$)({id:H,type:"full",data:N.data})}if(he.l(N)){const H=this.e++;return he.j(q)?this.d.set(H,new de(q.resultId,q.data)):this.d.set(H,new de(N.resultId)),(0,o.$e$)({id:H,type:"delta",deltas:(N.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class te{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeSemanticTokens(N,q,H){const j=this.d.getDocument(N),J=await this.e.provideDocumentRangeSemanticTokens(j,I.Range.to(q),H);return J?this.f(J):null}f(N){return(0,o.$e$)({id:0,type:"full",data:N.data})}}class Se{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,q,H,j,J){this.f=N,this.g=q,this.h=H,this.j=j,this.k=J,this.d=new r.$Wec("CompletionItem"),this.e=new Map}async provideCompletionItems(N,q,H,j){const J=this.f.getDocument(N),_=I.Position.to(q),ye=J.getWordRangeAtPosition(_)||new L.$OK(_,_),Te=ye.with({end:_}),We=new a.$Od,He=await this.h.provideCompletionItems(J,_,j,I.CompletionContext.to(H));if(!He||j.isCancellationRequested)return;const Xe=Array.isArray(He)?new L.$iL(He):He,rt=Se.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),it=new n.$Rc;this.e.set(rt,it);const et=[],ot={x:rt,b:et,a:{replace:I.Range.from(ye),insert:I.Range.from(Te)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let at=0;at<Xe.items.length;at++){const Be=Xe.items[at],pt=this.l(Be,[rt,at],Te,ye);et.push(pt)}return ot}async resolveCompletionItem(N,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...N);if(!H)return;const j=this.l(H,N),J=await this.h.resolveCompletionItem(H,q);if(!J)return;const _=this.l(J,N);return(j.h!==_.h||j.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==_.n||j.o!==_.o||!(0,T.$kn)(j.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q,H,j){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const _=this.g.toInternal(N.command,J),ye={x:q,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=N.textEdit.newText):typeof N.insertText=="string"?ye.h=N.insertText:N.insertText instanceof L.$XK&&(ye.h=N.insertText.value,ye.i|=4);let Te;return N.textEdit?Te=N.textEdit.range:N.range&&(Te=N.range),L.$OK.isRange(Te)?ye.j=I.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!j?.isEqual(Te.replacing))&&(ye.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),ye}}class oe{async provideInlineCompletions(N,q,H,j){}disposeCompletions(N){}handleDidShowCompletionItem(N,q,H){}handlePartialAccept(N,q,H){}}class Y extends oe{constructor(N,q,H,j){super(),this.f=N,this.g=q,this.h=H,this.j=j,this.d=new V,this.e=(0,i.$hF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$hF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,q,H,j){const J=this.g.getDocument(N),_=I.Position.to(q),ye=await this.h.provideInlineCompletionItems(J,_,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:I.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},j);if(!ye||j.isCancellationRequested)return;const Te=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],He=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Te}),items:Te.map((it,et)=>{let ot;it.command&&(Xe||(Xe=new n.$Rc),ot=this.j.toInternal(it.command,Xe));const at=it.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:it.filterText,range:it.range?I.Range.from(it.range):void 0,command:ot,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:We.map(it=>(Xe||(Xe=new n.$Rc),this.j.toInternal(it,Xe))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,q,H){const j=this.d.get(N)?.items[q];j&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(j,H)}handlePartialAccept(N,q,H){const j=this.d.get(N)?.items[q];j&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(j,H)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const q=this.e++;return this.d.set(q,N),q}disposeReferenceId(N){const q=this.d.get(N);return this.d.delete(N),q}get(N){return this.d.get(N)}}class ne{constructor(N,q){this.e=N,this.f=q,this.d=new r.$Wec("SignatureHelp")}async provideSignatureHelp(N,q,H,j){const J=this.e.getDocument(N),_=I.Position.to(q),ye=this.g(H),Te=await this.f.provideSignatureHelp(J,_,j,ye);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(N){let q;if(N.activeSignatureHelp){const H=I.SignatureHelp.to(N.activeSignatureHelp),j=this.d.get(N.activeSignatureHelp.id,0);j?(q=j,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...N,activeSignatureHelp:q}}releaseSignatureHelp(N){this.d.delete(N)}}class Ie{constructor(N,q,H,j,J){this.f=N,this.g=q,this.h=H,this.j=j,this.k=J,this.d=new r.$Wec("InlayHints"),this.e=new Map}async provideInlayHints(N,q,H){const j=this.f.getDocument(N),J=I.Range.to(q),_=await this.h.provideInlayHints(j,J,H);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(H.isCancellationRequested)return;const ye=this.d.add(_);this.e.set(ye,new n.$Rc);const Te={hints:[],cacheId:ye};for(let We=0;We<_.length;We++)this.l(_[We],J)&&Te.hints.push(this.m(_[We],[ye,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(N,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...N);if(!H)return;const j=await this.h.resolveInlayHint(H,q);if(j&&this.l(j))return this.m(j,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q){return N.label.length===0||Array.isArray(N.label)&&N.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(q&&!q.contains(N.position))}m(N,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?j.label=N.label:j.label=N.label.map(J=>{const _={label:J.value};return _.tooltip=I.MarkdownString.fromStrict(J.tooltip),L.$YK.isLocation(J.location)&&(_.location=I.location.from(J.location)),J.command&&(_.command=this.g.toInternal(J.command,H)),_}),j}}class Le{constructor(N,q){this.e=N,this.f=q,this.d=new r.$Wec("DocumentLink")}async provideLinks(N,q){const H=this.e.getDocument(N),j=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(j)||j.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(Le.g).map(I.DocumentLink.from)};{const J=this.d.add(j),_={links:[],cacheId:J};for(let ye=0;ye<j.length;ye++){if(!Le.g(j[ye]))continue;const Te=I.DocumentLink.from(j[ye]);Te.cacheId=[J,ye],_.links.push(Te)}return _}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...N);if(!H)return;const j=await this.f.resolveDocumentLink(H,q);if(!(!j||!Le.g(j)))return I.DocumentLink.from(j)}releaseLinks(N){this.d.delete(N)}}class Ce{constructor(N,q){this.d=N,this.e=q}async provideColors(N,q){const H=this.d.getDocument(N),j=await this.e.provideDocumentColors(H,q);return Array.isArray(j)?j.map(_=>({color:I.Color.from(_.color),range:I.Range.from(_.range)})):[]}async provideColorPresentations(N,q,H){const j=this.d.getDocument(N),J=I.Range.to(q.range),_=I.Color.to(q.color),ye=await this.e.provideColorPresentations(_,{document:j,range:J},H);if(Array.isArray(ye))return ye.map(I.ColorPresentation.from)}}class ce{constructor(N,q){this.d=N,this.e=q}async provideFoldingRanges(N,q,H){const j=this.d.getDocument(N),J=await this.e.provideFoldingRanges(j,q,H);if(Array.isArray(J))return J.map(I.FoldingRange.from)}}class ie{constructor(N,q,H){this.d=N,this.e=q,this.f=H}async provideSelectionRanges(N,q,H){const j=this.d.getDocument(N),J=q.map(I.Position.to),_=await this.e.provideSelectionRanges(j,J,H);if(!(0,R.$Lb)(_))return[];if(_.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Te=0;Te<J.length;Te++){const We=[];ye.push(We);let He=J[Te],Xe=_[Te];for(;;){if(!Xe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Xe)),!Xe.parent)break;He=Xe.range,Xe=Xe.parent}}return ye}}class Q{constructor(N,q){this.f=N,this.g=q,this.d=new t.$TM(""),this.e=new Map}async prepareSession(N,q,H){const j=this.f.getDocument(N),J=I.Position.to(q),_=await this.g.prepareCallHierarchy(j,J,H);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(Te=>this.h(ye,Te)):[this.h(ye,_)]}async provideCallsTo(N,q,H){const j=this.j(N,q);if(!j)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(j,H);if(J)return J.map(_=>({from:this.h(N,_.from),fromRanges:_.fromRanges.map(ye=>I.Range.from(ye))}))}async provideCallsFrom(N,q,H){const j=this.j(N,q);if(!j)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(j,H);if(J)return J.map(_=>({to:this.h(N,_.to),fromRanges:_.fromRanges.map(ye=>I.Range.from(ye))}))}releaseSession(N){this.e.delete(N)}h(N,q){const H=this.e.get(N),j=I.CallHierarchyItem.from(q,N,H.size.toString(36));return H.set(j._itemId,q),j}j(N,q){return this.e.get(N)?.get(q)}}class ee{constructor(N,q){this.f=N,this.g=q,this.d=new t.$TM(""),this.e=new Map}async prepareSession(N,q,H){const j=this.f.getDocument(N),J=I.Position.to(q),_=await this.g.prepareTypeHierarchy(j,J,H);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(Te=>this.h(ye,Te)):[this.h(ye,_)]}async provideSupertypes(N,q,H){const j=this.j(N,q);if(!j)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(j,H);if(J)return J.map(_=>this.h(N,_))}async provideSubtypes(N,q,H){const j=this.j(N,q);if(!j)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(j,H);if(J)return J.map(_=>this.h(N,_))}releaseSession(N){this.e.delete(N)}h(N,q){const H=this.e.get(N),j=I.TypeHierarchyItem.from(q,N,H.size.toString(36));return H.set(j._itemId,q),j}j(N,q){return this.e.get(N)?.get(q)}}class $e{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,H,j,J){this.d=N,this.e=q,this.f=H,this.g=j,this.h=J}async provideDocumentOnDropEdits(N,q,H,j,J){const _=this.e.getDocument(q),ye=I.Position.to(H),Te=I.DataTransfer.toDataTransfer(j,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,He)).buffer),We=await this.f.provideDocumentDropEdits(_,ye,Te,J);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:$e.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class be{constructor(N,q){this.d=N,this.e=q}async provideMappedEdits(N,q,H,j){const J=E.URI.revive(N),_=this.d.getDocument(J),ye=H.documents.map(He=>He.map(Xe=>({uri:E.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(rt=>I.Range.to(rt))}))),Te={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(_,q,Te,j);return We?I.WorkspaceEdit.from(We):null}}class Me{constructor(N,q){this.adapter=N,this.extension=q}}class le{static{this.d=0}constructor(N,q,H,j,J,_,ye,Te){this.g=q,this.h=H,this.j=j,this.k=J,this.l=_,this.m=ye,this.n=Te,this.f=new Map,this.e=N.getProxy(m.$KK.MainThreadLanguageFeatures)}o(N,q){return I.DocumentSelector.from(N,this.g,q)}p(N){return new L.$MK(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return le.d++}async s(N,q,H,j,J,_=!1){const ye=this.f.get(N);if(!ye||!(ye.adapter instanceof q))return j;const Te=Date.now();_||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const We=H(ye.adapter,ye.extension);return Promise.resolve(We).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(ye.extension.identifier,He))}).finally(()=>{_||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),$.CancellationToken.isCancellationToken(J)?(0,h.$Qg)(We,J):We}t(N,q){const H=this.q();return this.f.set(H,new Me(N,q)),H}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,H,j){const J=this.t(new u(this.h,H),N),_=j&&j.label||le.u(N);return this.e.$registerDocumentSymbolProvider(J,this.o(q,N),_),this.p(J)}$provideDocumentSymbols(N,q,H){return this.s(N,u,j=>j.provideDocumentSymbols(E.URI.revive(q),H),void 0,H)}registerCodeLensProvider(N,q,H){const j=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new Me(new d(this.h,this.j.converter,H),N)),this.e.$registerCodeLensSupport(j,this.o(q,N),J);let _=this.p(j);if(J!==void 0){const ye=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(J));_=L.$MK.from(_,ye)}return _}$provideCodeLenses(N,q,H){return this.s(N,d,j=>j.provideCodeLenses(E.URI.revive(q),H),void 0,H)}$resolveCodeLens(N,q,H){return this.s(N,d,j=>j.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(N,q){this.s(N,d,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(N,q,H){const j=this.t(new f(this.h,H),N);return this.e.$registerDefinitionSupport(j,this.o(q,N)),this.p(j)}$provideDefinition(N,q,H,j){return this.s(N,f,J=>J.provideDefinition(E.URI.revive(q),H,j),[],j)}registerDeclarationProvider(N,q,H){const j=this.t(new k(this.h,H),N);return this.e.$registerDeclarationSupport(j,this.o(q,N)),this.p(j)}$provideDeclaration(N,q,H,j){return this.s(N,k,J=>J.provideDeclaration(E.URI.revive(q),H,j),[],j)}registerImplementationProvider(N,q,H){const j=this.t(new F(this.h,H),N);return this.e.$registerImplementationSupport(j,this.o(q,N)),this.p(j)}$provideImplementation(N,q,H,j){return this.s(N,F,J=>J.provideImplementation(E.URI.revive(q),H,j),[],j)}registerTypeDefinitionProvider(N,q,H){const j=this.t(new p(this.h,H),N);return this.e.$registerTypeDefinitionSupport(j,this.o(q,N)),this.p(j)}$provideTypeDefinition(N,q,H,j){return this.s(N,p,J=>J.provideTypeDefinition(E.URI.revive(q),H,j),[],j)}registerHoverProvider(N,q,H,j){const J=this.t(new y(this.h,H),N);return this.e.$registerHoverProvider(J,this.o(q,N)),this.p(J)}$provideHover(N,q,H,j){return this.s(N,y,J=>J.provideHover(E.URI.revive(q),H,j),void 0,j)}registerEvaluatableExpressionProvider(N,q,H,j){const J=this.t(new D(this.h,H),N);return this.e.$registerEvaluatableExpressionProvider(J,this.o(q,N)),this.p(J)}$provideEvaluatableExpression(N,q,H,j){return this.s(N,D,J=>J.provideEvaluatableExpression(E.URI.revive(q),H,j),void 0,j)}registerInlineValuesProvider(N,q,H,j){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new O(this.h,H),N);this.e.$registerInlineValuesProvider(_,this.o(q,N),J);let ye=this.p(_);if(J!==void 0){const Te=H.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(J));ye=L.$MK.from(ye,Te)}return ye}$provideInlineValues(N,q,H,j,J){return this.s(N,O,_=>_.provideInlineValues(E.URI.revive(q),H,j,J),void 0,J)}registerDocumentHighlightProvider(N,q,H){const j=this.t(new K(this.h,H),N);return this.e.$registerDocumentHighlightProvider(j,this.o(q,N)),this.p(j)}registerMultiDocumentHighlightProvider(N,q,H){const j=this.t(new U(this.h,H),N);return this.e.$registerMultiDocumentHighlightProvider(j,this.o(q,N)),this.p(j)}$provideDocumentHighlights(N,q,H,j){return this.s(N,K,J=>J.provideDocumentHighlights(E.URI.revive(q),H,j),void 0,j)}$provideMultiDocumentHighlights(N,q,H,j,J){return this.s(N,U,_=>_.provideMultiDocumentHighlights(E.URI.revive(q),H,j.map(ye=>E.URI.revive(ye)),J),void 0,J)}registerLinkedEditingRangeProvider(N,q,H){const j=this.t(new M(this.h,H),N);return this.e.$registerLinkedEditingRangeProvider(j,this.o(q,N)),this.p(j)}$provideLinkedEditingRanges(N,q,H,j){return this.s(N,M,async J=>{const _=await J.provideLinkedEditingRanges(E.URI.revive(q),H,j);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?le.w(_.wordPattern):void 0}},void 0,j)}registerReferenceProvider(N,q,H){const j=this.t(new B(this.h,H),N);return this.e.$registerReferenceSupport(j,this.o(q,N)),this.p(j)}$provideReferences(N,q,H,j,J){return this.s(N,B,_=>_.provideReferences(E.URI.revive(q),H,j,J),void 0,J)}registerCodeActionProvider(N,q,H,j){const J=new n.$Rc,_=this.t(new C(this.h,this.j.converter,this.k,H,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(_,this.o(q,N),{providedKinds:j?.providedCodeActionKinds?.map(ye=>ye.value),documentation:j?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,J)}))},le.u(N),!!H.resolveCodeAction),J.add(this.p(_)),J}$provideCodeActions(N,q,H,j,J){return this.s(N,C,_=>_.provideCodeActions(E.URI.revive(q),H,j,J),void 0,J)}$resolveCodeAction(N,q,H){return this.s(N,C,j=>j.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(N,q){this.s(N,C,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(N,q,H){const j=this.t(new X(this.h,H),N);return this.e.$registerDocumentFormattingSupport(j,this.o(q,N),N.identifier,N.displayName||N.name),this.p(j)}$provideDocumentFormattingEdits(N,q,H,j){return this.s(N,X,J=>J.provideDocumentFormattingEdits(E.URI.revive(q),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(N,q,H){const j=typeof H.provideDocumentRangesFormattingEdits=="function",J=this.t(new ae(this.h,H),N);return this.e.$registerRangeFormattingSupport(J,this.o(q,N),N.identifier,N.displayName||N.name,j),this.p(J)}$provideDocumentRangeFormattingEdits(N,q,H,j,J){return this.s(N,ae,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(q),H,j,J),void 0,J)}$provideDocumentRangesFormattingEdits(N,q,H,j,J){return this.s(N,ae,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(q),H,j,J),void 0,J)}registerOnTypeFormattingEditProvider(N,q,H,j){const J=this.t(new ge(this.h,H),N);return this.e.$registerOnTypeFormattingSupport(J,this.o(q,N),j,N.identifier),this.p(J)}$provideOnTypeFormattingEdits(N,q,H,j,J,_){return this.s(N,ge,ye=>ye.provideOnTypeFormattingEdits(E.URI.revive(q),H,j,J,_),void 0,_)}registerWorkspaceSymbolProvider(N,q){const H=this.t(new ve(q,this.l),N);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(N,q,H){return this.s(N,ve,j=>j.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(N,q,H){return this.s(N,ve,j=>j.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(N,q){this.s(N,ve,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(N,q,H){const j=this.t(new ke(this.h,H,this.l),N);return this.e.$registerRenameSupport(j,this.o(q,N),ke.supportsResolving(H)),this.p(j)}$provideRenameEdits(N,q,H,j,J){return this.s(N,ke,_=>_.provideRenameEdits(E.URI.revive(q),H,j,J),void 0,J)}$resolveRenameLocation(N,q,H,j){return this.s(N,ke,J=>J.resolveRenameLocation(E.URI.revive(q),H,j),void 0,j)}registerDocumentSemanticTokensProvider(N,q,H,j){const J=this.t(new he(this.h,H),N),_=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(q,N),j,_);let ye=this.p(J);if(_){const Te=H.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(_));ye=L.$MK.from(ye,Te)}return ye}$provideDocumentSemanticTokens(N,q,H,j){return this.s(N,he,J=>J.provideDocumentSemanticTokens(E.URI.revive(q),H,j),null,j)}$releaseDocumentSemanticTokens(N,q){this.s(N,he,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,q,H,j){const J=this.t(new te(this.h,H),N);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(q,N),j),this.p(J)}$provideDocumentRangeSemanticTokens(N,q,H,j){return this.s(N,te,J=>J.provideDocumentRangeSemanticTokens(E.URI.revive(q),H,j),null,j)}registerCompletionItemProvider(N,q,H,j){const J=this.t(new Se(this.h,this.j.converter,H,this.m,N),N);return this.e.$registerCompletionsProvider(J,this.o(q,N),j,Se.supportsResolving(H),N.identifier),this.p(J)}$provideCompletionItems(N,q,H,j,J){return this.s(N,Se,_=>_.provideCompletionItems(E.URI.revive(q),H,j,J),void 0,J)}$resolveCompletionItem(N,q,H){return this.s(N,Se,j=>j.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(N,q){this.s(N,Se,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(N,q,H,j){const J=new Y(N,this.h,H,this.j.converter),_=this.t(J,N);return this.e.$registerInlineCompletionsSupport(_,this.o(q,N),J.supportsHandleEvents,v.$fm.toKey(N.identifier.value),j?.yieldTo?.map(ye=>v.$fm.toKey(ye))||[]),this.p(_)}$provideInlineCompletions(N,q,H,j,J){return this.s(N,oe,_=>_.provideInlineCompletions(E.URI.revive(q),H,j,J),void 0,J)}$handleInlineCompletionDidShow(N,q,H,j){this.s(N,oe,async J=>{J.handleDidShowCompletionItem(q,H,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,q,H,j){this.s(N,oe,async J=>{J.handlePartialAccept(q,H,j)},void 0,void 0)}$freeInlineCompletionsList(N,q){this.s(N,oe,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(N,q,H,j){const J=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,_=this.t(new ne(this.h,H),N);return this.e.$registerSignatureHelpProvider(_,this.o(q,N),J),this.p(_)}$provideSignatureHelp(N,q,H,j,J){return this.s(N,ne,_=>_.provideSignatureHelp(E.URI.revive(q),H,j,J),void 0,J)}$releaseSignatureHelp(N,q){this.s(N,ne,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(N,q,H){const j=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new Ie(this.h,this.j.converter,H,this.l,N),N);this.e.$registerInlayHintsProvider(J,this.o(q,N),typeof H.resolveInlayHint=="function",j,le.u(N));let _=this.p(J);if(j!==void 0){const ye=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(j));_=L.$MK.from(_,ye)}return _}$provideInlayHints(N,q,H,j){return this.s(N,Ie,J=>J.provideInlayHints(E.URI.revive(q),H,j),void 0,j)}$resolveInlayHint(N,q,H){return this.s(N,Ie,j=>j.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(N,q){this.s(N,Ie,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(N,q,H){const j=this.t(new Le(this.h,H),N);return this.e.$registerDocumentLinkProvider(j,this.o(q,N),typeof H.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(N,q,H){return this.s(N,Le,j=>j.provideLinks(E.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(N,q,H){return this.s(N,Le,j=>j.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(N,q){this.s(N,Le,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(N,q,H){const j=this.t(new Ce(this.h,H),N);return this.e.$registerDocumentColorProvider(j,this.o(q,N)),this.p(j)}$provideDocumentColors(N,q,H){return this.s(N,Ce,j=>j.provideColors(E.URI.revive(q),H),[],H)}$provideColorPresentations(N,q,H,j){return this.s(N,Ce,J=>J.provideColorPresentations(E.URI.revive(q),H,j),void 0,j)}registerFoldingRangeProvider(N,q,H){const j=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new Me(new ce(this.h,H),N)),this.e.$registerFoldingRangeProvider(j,this.o(q,N),N.identifier,J);let _=this.p(j);if(J!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));_=L.$MK.from(_,ye)}return _}$provideFoldingRanges(N,q,H,j){return this.s(N,ce,J=>J.provideFoldingRanges(E.URI.revive(q),H,j),void 0,j)}registerSelectionRangeProvider(N,q,H){const j=this.t(new ie(this.h,H,this.l),N);return this.e.$registerSelectionRangeProvider(j,this.o(q,N)),this.p(j)}$provideSelectionRanges(N,q,H,j){return this.s(N,ie,J=>J.provideSelectionRanges(E.URI.revive(q),H,j),[],j)}registerCallHierarchyProvider(N,q,H){const j=this.t(new Q(this.h,H),N);return this.e.$registerCallHierarchyProvider(j,this.o(q,N)),this.p(j)}$prepareCallHierarchy(N,q,H,j){return this.s(N,Q,J=>Promise.resolve(J.prepareSession(E.URI.revive(q),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(N,q,H,j){return this.s(N,Q,J=>J.provideCallsTo(q,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(N,q,H,j){return this.s(N,Q,J=>J.provideCallsFrom(q,H,j),void 0,j)}$releaseCallHierarchy(N,q){this.s(N,Q,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(N,q,H){const j=this.t(new ee(this.h,H),N);return this.e.$registerTypeHierarchyProvider(j,this.o(q,N)),this.p(j)}$prepareTypeHierarchy(N,q,H,j){return this.s(N,ee,J=>Promise.resolve(J.prepareSession(E.URI.revive(q),H,j)),void 0,j)}$provideTypeHierarchySupertypes(N,q,H,j){return this.s(N,ee,J=>J.provideSupertypes(q,H,j),void 0,j)}$provideTypeHierarchySubtypes(N,q,H,j){return this.s(N,ee,J=>J.provideSubtypes(q,H,j),void 0,j)}$releaseTypeHierarchy(N,q){this.s(N,ee,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(N,q,H,j){const J=this.q();this.f.set(J,new Me(new $e(this.e,this.h,H,J,N),N));const _=(0,i.$hF)(N,"dropMetadata")&&j?$e.toInternalProviderId(N.identifier.value,j.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(q,N),_,(0,i.$hF)(N,"dropMetadata")?j:void 0),this.p(J)}$provideDocumentOnDropEdits(N,q,H,j,J,_){return this.s(N,$e,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(q,E.URI.revive(H),j,J,_)),void 0,void 0)}registerMappedEditsProvider(N,q,H){const j=this.t(new be(this.h,H),N);return this.e.$registerMappedEditsProvider(j,this.o(q,N)),this.p(j)}$provideMappedEdits(N,q,H,j,J){return this.s(N,be,_=>Promise.resolve(_.provideMappedEdits(q,H,j,J)),null,J)}registerDocumentPasteEditProvider(N,q,H,j){const J=this.q();this.f.set(J,new Me(new P(this.e,this.h,H,J,N),N));const _=P.toInternalProviderId(N.identifier.value,j.id);return this.e.$registerPasteEditProvider(J,this.o(q,N),_,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(N,q,H,j,J){return this.s(N,P,_=>_.prepareDocumentPaste(E.URI.revive(q),H,j,J),void 0,J)}$providePasteEdits(N,q,H,j,J,_){return this.s(N,P,ye=>ye.providePasteEdits(q,E.URI.revive(H),j,J,_),void 0,_)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:le.w(N.decreaseIndentPattern),increaseIndentPattern:le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:le.w(N.beforeText),afterText:N.afterText?le.w(N.afterText):void 0,previousLineText:N.previousLineText?le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(le.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(q=>L.SyntaxTokenType.toString(q)):void 0}}static D(N){return N.map(le.C)}setLanguageConfiguration(N,q,H){const{wordPattern:j}=H;if(j&&(0,g.$Te)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor(q,j):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const J=this.q(),_={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,q,_),this.p(J)}$setWordDefinitions(N){for(const q of N)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$7ec=le}),define(Pe[255],Ae([1,0,3,8,7,31,14,6,23]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class w{constructor(S,l,$,v){this.c=l,this.d=$,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$KK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const $=this.c.getDocumentData(S);if(!$)throw new Error(`document '${S.toString()}' NOT found`);return $.document}async tokenAtPosition(S,l){const $=S.version,v=T.Position.from(l),n=await this.a.$tokensAtPosition(S.uri,v),o={type:I.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new I.$OK(l.line,l.character,l.line,l.character)};if(!n)return o;const t={range:T.Range.to(n.range),type:T.TokenType.to(n.type)};return!t.range.contains(l)||$!==S.version?o:t}createLanguageStatusItem(S,l,$){const v=this.f++,n=this.a,o=this.g,t=`${S.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const r={selector:$,id:l,name:S.displayName??S.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new m.$Rc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,A.$3g)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:t,name:r.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===I.LanguageStatusSeverity.Error?L.default.Error:r.severity===I.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:r.command&&this.d.toInternal(r.command,c),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),n.$removeLanguageStatus(v),o.delete(t)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,h()},get selector(){return r.selector},set selector(s){r.selector=s,h()},get text(){return r.text},set text(s){r.text=s,h()},set text2(s){(0,g.$iF)(S,"languageStatusText"),r.text=s,h()},get text2(){return(0,g.$iF)(S,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,h()},get severity(){return r.severity},set severity(s){r.severity=s,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,h()},get command(){return r.command},set command(s){r.command=s,h()},get busy(){return r.busy},set busy(s){r.busy=s,h()}};return h(),i}}e.$tgc=w}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0;let R=class{constructor(l,$,v){this.f=v,this.d=new Map,this.a=$.getProxy(m.$KK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,$){const{message:v,args:n,comment:o}=$;if(this.c)return(0,T.$Ie)(v,n??{});let t=v;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(l)?.contents[t];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ie)(r??v,n??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(v),o=JSON.parse(n);$=l.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${n.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:v})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive($)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Rfc=R,e.$Rfc=R=Ge([Ke(0,g.$5M),Ke(1,w.$OM),Ke(2,A.$ij)],R),e.$Sfc=(0,L.$1h)("IExtHostLocalizationService")}),define(Pe[256],Ae([1,0,15,3,27,17,2,51]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;let g=class extends E.$tj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$xh)($))),this.r=S.getProxy(T.$KK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(A.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,$){return new w(this.r,S,l,$)}};e.$5gc=g,e.$5gc=g=Ge([Ke(0,L.$OM),Ke(1,I.$5M)],g);class w extends E.$oj{constructor(S,l,$,v){super(v?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const $=[[S,l]];this.m?this.u($):this.n.push(...$)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,T.$1h)("IExtHostManagedSockets");let m=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$KK.MainThreadManagedSockets)}setFactory(S,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,$=await this.c.makeConnection(),v=new I.$Rc;return this.d.set(l,new w(l,$,v)),v.add((0,I.$Qc)(()=>this.d.delete(l))),v.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add($.onDidClose(n=>{this.a.$onDidManagedSocketClose(l,n?.stack??n?.message),v.dispose()})),v.add($.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(l,A.$ge.wrap(n)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Ufc=m,e.$Ufc=m=Ge([Ke(0,L.$OM)],m);class g{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class w extends I.$Sc{constructor(S,l,$){super(),this.socketId=S,this.actual=l,this.B($)}}}),define(Pe[257],Ae([1,0,3,15,23]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;function L(m){return m&&m.title}let A=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$KK.MainThreadMessageService)}showMessage(g,w,R,S,l){const $={source:{identifier:g.identifier,label:g.displayName||g.name}};let v;typeof S=="string"||L(S)?v=[S,...l]:($.modal=S?.modal,$.useCustom=S?.useCustom,$.detail=S?.detail,v=l),$.useCustom&&(0,I.$iF)(g,"resolvers");const n=[];for(let o=0;o<v.length;o++){const t=v[o];if(typeof t=="string")n.push({title:t,handle:o,isCloseAffordance:!1});else if(typeof t=="object"){const{title:r,isCloseAffordance:a}=t;n.push({title:r,isCloseAffordance:!!a,handle:o})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(w,R,$,n).then(o=>{if(typeof o=="number")return v[o]})}};e.$ugc=A,e.$ugc=A=Ge([Ke(1,T.$ij)],A)}),define(Pe[258],Ae([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;let a=class{constructor(f,k,F,p,y){this.m=k,this.n=F,this.o=p,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(S.$KK.MainThreadNotebookKernels);const D=new l.$cN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$aN("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const K=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:K}}else if(O&&"notebookEditor"in O){const K=this.n.getIdByEditor(O.notebookEditor);if(K===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:K}}return O})],l.$bN.Void);this.o.registerApiCommand(D)}createNotebookController(f,k,F,p,y,D){for(const te of this.j.values())if(te.controller.id===k&&w.$fm.equals(f.identifier,te.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const O=this.k++,K=this;this.q.trace(`NotebookController[${O}], CREATED by ${f.identifier.value}, ${k}`);const U=()=>console.warn(`NO execute handler from notebook controller '${P.id}' of extension: '${f.identifier}'`);let M=!1;const B=new L.$Sd,C=new L.$Sd,P={id:d(f.identifier,k),notebookType:F,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:p||f.identifier.value,preloads:D?D.map($.NotebookRendererScript.from):[]};let X=y??U,ae,ge;this.a.$addKernel(O,P).catch(te=>{console.log(te),M=!0});let ve=0;const ke=()=>{if(M)return;const te=++ve;Promise.resolve().then(()=>{te===ve&&this.a.$updateKernel(O,P)})},de=new m.$Ac,he={get id(){return k},get notebookType(){return P.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return P.label},set label(te){P.label=te??f.displayName??f.name,ke()},get detail(){return P.detail??""},set detail(te){P.detail=te,ke()},get description(){return P.description??""},set description(te){P.description=te,ke()},get supportedLanguages(){return P.supportedLanguages},set supportedLanguages(te){P.supportedLanguages=te,ke()},get supportsExecutionOrder(){return P.supportsExecutionOrder??!1},set supportsExecutionOrder(te){P.supportsExecutionOrder=te,ke()},get rendererScripts(){return P.preloads?P.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(te){X=te??U},get interruptHandler(){return ae},set interruptHandler(te){ae=te,P.supportsInterrupt=!!te,ke()},set variableProvider(te){(0,t.$iF)(f,"notebookVariableProvider"),ge=te,P.hasVariableProvider=!!te,te?.onDidChangeVariables(Se=>K.a.$variablesUpdated(Se.uri)),ke()},get variableProvider(){return ge},createNotebookCellExecution(te){if(M)throw new Error("notebook controller is DISPOSED");if(!de.has(te.notebook.uri))throw K.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return K._createNotebookCellExecution(te,d(f.identifier,this.id))},createNotebookExecution(te){if((0,t.$iF)(f,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!de.has(te.uri))throw K.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return K._createNotebookExecution(te,d(f.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${O}], DISPOSED`),M=!0,this.j.delete(O),B.dispose(),C.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(te,Se){Se===v.NotebookControllerAffinity2.Hidden&&(0,t.$iF)(f,"notebookControllerAffinityHidden"),K.a.$updateNotebookPriority(O,te.uri,Se)},onDidReceiveMessage:C.event,postMessage(te,Se){return(0,t.$iF)(f,"notebookMessaging"),K.a.$postMessage(O,Se&&K.n.getIdByEditor(Se),te)},asWebviewUri(te){return(0,t.$iF)(f,"notebookMessaging"),(0,n.$avb)(te,K.m.remote)}};return this.j.set(O,{extensionId:f.identifier,controller:he,onDidReceiveMessage:C,onDidChangeSelection:B,associatedNotebooks:de}),he}getIdByController(f){for(const[k,F]of this.j)if(F.controller===f)return d(F.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,k){const F=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${F}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(F,k);const y={dispose:()=>{this.f.delete(F),p.a.$removeKernelDetectionTask(F)}};return this.f.set(F,y),y}registerKernelSourceActionProvider(f,k,F){const p=this.i++,y=typeof F.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,D=this;this.h.set(p,F),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,k);let O;return y!==void 0&&(O=F.onDidChangeNotebookKernelSourceActions(K=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(p),D.a.$removeKernelSourceActionProvider(p,p),O?.dispose()}}}async $provideKernelSourceActions(f,k){const F=this.h.get(f);if(F){const p=new A.$Rc;return(await F.provideNotebookKernelSourceActions(k)??[]).map(D=>$.NotebookKernelSourceAction.from(D,this.o.converter,p))}return[]}$acceptNotebookAssociation(f,k,F){const p=this.j.get(f);if(p){const y=this.n.getNotebookDocument(g.URI.revive(k));F?p.associatedNotebooks.set(y.uri,!0):p.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),F),p.onDidChangeSelection.fire({selected:F,notebook:y.apiNotebook})}}async $executeCells(f,k,F){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(k)),D=[];for(const O of F){const K=y.getCell(O);K&&D.push(K.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await p.controller.executeHandler.call(p.controller,D,y.apiNotebook,p.controller)}catch(O){this.q.error(`NotebookController[${f}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(f,k,F){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(k));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,y.apiNotebook);else for(const D of F){const O=y.getCell(D);O&&this.b.get(O.uri)?.cancel()}if(p.controller.interruptHandler){const D=this.c.get(y.uri);F.length&&Array.isArray(D)&&D.length&&D.forEach(O=>O.dispose())}}async $provideVariables(f,k,F,p,y,D,O){const K=this.j.get(f);if(!K)return;const U=this.n.getNotebookDocument(g.URI.revive(F)),M=K.controller.variableProvider;if(!M)return;const B=p?{name:p,value:""}:void 0,C=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,P=M.provideVariables(U.apiNotebook,B,C,D,O);for await(const X of P){if(O.isCancellationRequested)return;this.a.$receiveVariable(k,X)}}$acceptKernelMessageFromRenderer(f,k,F){const p=this.j.get(f);if(!p)return;const y=this.n.getEditorById(k);p.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:F}))}$cellExecutionChanged(f,k,F){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(k);if(y){const D=F?$.NotebookCellExecutionState.to(F):v.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,k){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const y=new h(k,p,this.a);this.b.set(p.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete(p.uri))});return y.asApiObject()}_createNotebookExecution(f,k){const F=this.n.getNotebookDocument(f.uri),p=f.getCells().find(O=>{const K=F.getCellFromApiCell(O);return K&&this.b.has(K.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(F.uri))throw new Error(`duplicate notebook execution for ${F.uri}`);const y=new s(k,F,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(F.uri))});return this.c.set(F.uri,[y,D]),y.asApiObject()}};e.$ygc=a,e.$ygc=a=Ge([Ke(4,R.$ij)],a);var c;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(c||(c={}));class h extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,k,F){super(),this.m=k,this.n=F,this.b=h.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$3d),this.h=new u(10,p=>this.s(p)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const k=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new r.$Dv(k))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let k=this.m;if(f&&(k=this.m.notebook.getCellFromApiCell(f)),!k)throw new Error("INVALID cell");return k.handle}y(f){return f.map(k=>{const F=v.$cM.ensureUniqueMimeTypes(k.items,!0);return F===k.items?$.NotebookCellOutput.from(k):$.NotebookCellOutput.from({items:F,id:k.id,metadata:k.metadata})})}async z(f,k,F){const p=this.w(k),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:p,append:F,outputs:y})}async C(f,k,F){return f=v.$cM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map($.NotebookCellOutputItem.from),outputId:k.id,append:F})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(F){f.j=F,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(F){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:F})},end(F,p){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new r.$Dv({runEndTime:p,lastRunSuccess:F}))},clearOutput(F){return f.t(),f.z([],F,!1)},appendOutput(F,p){return f.t(),f.z(F,p,!0)},replaceOutput(F,p){return f.t(),f.z(F,p,!1)},appendOutputItems(F,p){return f.t(),f.C(F,p,!0)},replaceOutputItems(F,p){return f.t(),f.C(F,p,!1)}})}}var i;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(i||(i={}));class s extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,k,F){super(),this.h=k,this.j=F,this.b=s.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,k){this.f=f,this.g=k,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$lh,this.b=Date.now(),(0,T.$2g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>f.complete())}}function d(b,f){return`${b.value}/${f}`}e.$zgc=d}),define(Pe[259],Ae([1,0,5,3,107]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class L{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(T.$KK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,w){const R=this.c.getEditorById(m);this.a.get(g)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(R=>R.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(R,S,l)=>this.d(g).event(R,S,l),postMessage:(R,S)=>{I.$ggc.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const l=S&&I.$ggc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,g,R)}}}d(m){let g=this.a.get(m);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Agc=L}),define(Pe[260],Ae([1,0,6,16,2,23,3]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(A.$KK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,R,S){if((0,L.$iF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,S),this.a.$registerProfileContentHandler(R,S.name,S.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,S,l){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.saveProfile(R,S,l)}async $readProfile(w,R,S){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Df)(R)?R:I.URI.revive(R),S)}}e.$Dgc=m}),define(Pe[261],Ae([1,0,2,3,14,8]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class A{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$KK.MainThreadQuickDiff)}$provideOriginalResource(g,w,R){const S=E.URI.revive(w),l=this.c.get(g);return l?(0,I.$Tg)(()=>l.provideOriginalResource(S,R)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,R,S){const l=A.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(g,this.d),R,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Fgc=A}),define(Pe[262],Ae([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;function v(n,o,t){const r=n.getProxy(L.$KK.MainThreadQuickOpen);class a{constructor(k,F){this.e=new Map,this.f=0,this.a=k,this.b=F}showQuickPick(k,F,p,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(F),O=++this.f,K=r.$show(O,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},y),U={},M=K.then(()=>U);return Promise.race([M,D]).then(B=>{if(B===U)return;const C=(0,l.$hF)(k,"quickPickItemTooltip");return D.then(P=>{const X=[];for(let ae=0;ae<P.length;ae++){const ge=P[ae];if(typeof ge=="string")X.push({label:ge,handle:ae});else if(ge.kind===m.QuickPickItemKind.Separator)X.push({type:"separator",label:ge.label});else{ge.tooltip&&!C&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ve=ge.iconPath?u(ge.iconPath):void 0;X.push({label:ge.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ae})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=ae=>{p.onDidSelectItem(P[ae])}),r.$setItems(O,X),K.then(ae=>{if(typeof ae=="number")return P[ae];if(Array.isArray(ae))return ae.map(ge=>P[ge])})})}).then(void 0,B=>{if(!(0,g.$4)(B))return r.$setError(O,B),Promise.reject(B)})}$onItemSelected(k){this.c?.(k)}showInput(k,F=E.CancellationToken.None){return this.d=k?.validateInput,r.$input(k,typeof this.d=="function",F).then(void 0,p=>{if(!(0,g.$4)(p))return Promise.reject(p)})}async $validateInput(k){if(!this.d)return;const F=await this.d(k);if(!F||typeof F=="string")return F;let p;switch(F.severity){case m.InputBoxValidationSeverity.Info:p=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=F.message?R.default.Error:R.default.Ignore;break}return{content:F.message,severity:p}}async showWorkspaceFolderPick(k,F=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!p)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===p.uri.toString())}createQuickPick(k){const F=new d(k,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}createInputBox(k){const F=new b(k,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}$onDidChangeValue(k,F){this.e.get(k)?._fireDidChangeValue(F)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,F){const p=this.e.get(k);p instanceof d&&p._fireDidChangeActive(F)}$onDidChangeSelection(k,F){const p=this.e.get(k);p instanceof d&&p._fireDidChangeSelection(F)}$onDidTriggerButton(k,F){this.e.get(k)?._fireDidTriggerButton(F)}$onDidTriggerItemButton(k,F,p){const y=this.e.get(k);y instanceof d&&y._fireDidTriggerItemButton(F,p)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class c{static{this.a=1}constructor(k,F){this.x=k,this.y=F,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((F,p)=>{const y=F===m.$8L.Back?-1:p;this.o.set(y,F)}),this.z({buttons:k.map((F,p)=>({...u(F.iconPath),tooltip:F.tooltip,handle:F===m.$8L.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const F=this.o.get(k);F&&this.r.fire(F)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(k){if(!this.v){for(const F of Object.keys(k)){const p=k[F];this.u[F]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof m.$HL)return{id:f.id};const k=s(f),F=i(f);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof F=="string"?A.URI.file(F):F}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const k=h(f);let F,p;return"id"in k?p=S.ThemeIcon.asClassName(k):F=k,{iconPath:F,iconClass:p}}class d extends c{constructor(k,F){super(k.identifier,F),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const F=(0,l.$hF)(this.O,"quickPickItemTooltip"),p=[];for(let y=0;y<k.length;y++){const D=k[y];if(D.kind===m.QuickPickItemKind.Separator)p.push({type:"separator",label:D.label});else{D.tooltip&&!F&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const O=D.iconPath?u(D.iconPath):void 0;p.push({handle:y,label:D.label,iconPath:O?.iconPath,iconClass:O?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:F?$.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((K,U)=>({...u(K.iconPath),tooltip:K.tooltip,handle:U}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(F=>this.D.has(F)),this.z({activeItems:this.J.map(F=>this.D.get(F))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(F=>this.D.has(F)),this.z({selectedItems:this.L.map(F=>this.D.get(F))})}_fireDidChangeActive(k){const F=(0,w.$Hb)(k.map(p=>this.C.get(p)));this.J=F,this.K.fire(F)}_fireDidChangeSelection(k){const F=(0,w.$Hb)(k.map(p=>this.C.get(p)));this.L=F,this.M.fire(F)}_fireDidTriggerItemButton(k,F){const p=this.C.get(k);if(!p||!p.buttons||!p.buttons.length)return;const y=p.buttons[F];y&&this.N.fire({button:y,item:p})}}class b extends c{constructor(k,F){super(k.identifier,F),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:R.default.Error}):this.z({validationMessage:k.message,severity:k.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new a(o,t)}e.$Ggc=v}),define(Pe[263],Ae([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13,21]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0;function r(U){return U instanceof E.URI}function a(U,M){return U.scheme===n.Schemas.file&&M.scheme===n.Schemas.file&&o.$k?U.toString()===M.toString():U.toString().toLowerCase()===M.toString().toLowerCase()}function c(U){if(U)return typeof U.iconPath=="string"?E.URI.file(U.iconPath):E.URI.isUri(U.iconPath)||l.ThemeIcon.isThemeIcon(U.iconPath)?U.iconPath:void 0}function h(U){if(U?.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const M=U.icon;return{light:M.light,dark:M.dark}}}else return}function i(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const M=U.icon;return{light:M.light,dark:M.dark}}}else return}function s(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const M=U.icon;return{light:M.light,dark:M.dark}}}else return}function u(U,M){if(!U.iconPath&&!M.iconPath)return 0;if(U.iconPath){if(!M.iconPath)return 1}else return-1;const B=typeof U.iconPath=="string"?U.iconPath:E.URI.isUri(U.iconPath)?U.iconPath.fsPath:U.iconPath.id,C=typeof M.iconPath=="string"?M.iconPath:E.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,w.$Dq)(B,C)}function d(U,M){let B=0;if(U.strikeThrough!==M.strikeThrough)return U.strikeThrough?1:-1;if(U.faded!==M.faded)return U.faded?1:-1;if(U.tooltip!==M.tooltip)return(U.tooltip||"").localeCompare(M.tooltip||"");if(B=u(U,M),B!==0)return B;if(U.light&&M.light)B=u(U.light,M.light);else{if(U.light)return 1;if(M.light)return-1}if(B!==0)return B;if(U.dark&&M.dark)B=u(U.dark,M.dark);else{if(U.dark)return 1;if(M.dark)return-1}return B}function b(U,M){if(U.command!==M.command)return U.command<M.command?-1:1;if(U.title!==M.title)return U.title<M.title?-1:1;if(U.tooltip!==M.tooltip){if(U.tooltip!==void 0&&M.tooltip!==void 0)return U.tooltip<M.tooltip?-1:1;if(U.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(U.arguments===M.arguments)return 0;if(U.arguments)if(M.arguments){if(U.arguments.length!==M.arguments.length)return U.arguments.length-M.arguments.length}else return 1;else return-1;for(let B=0;B<U.arguments.length;B++){const C=U.arguments[B],P=M.arguments[B];if(C!==P&&!(r(C)&&r(P)&&a(C,P)))return C<P?-1:1}return 0}function f(U,M){let B=(0,w.$Dq)(U.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(B!==0)return B;if(U.command&&M.command)B=b(U.command,M.command);else{if(U.command)return 1;if(M.command)return-1}if(B!==0)return B;if(U.decorations&&M.decorations)B=d(U.decorations,M.decorations);else{if(U.decorations)return 1;if(M.decorations)return-1}return B}function k(U,M){for(let B=0;B<U.length;B++)if(U[B]!==M[B])return!1;return!0}function F(U,M){return U.command===M.command&&U.title===M.title&&U.tooltip===M.tooltip&&(U.arguments&&M.arguments?k(U.arguments,M.arguments):U.arguments===M.arguments)}function p(U,M){return(0,g.$ub)(U,M,F)}class y{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.o,M),this.q(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.o,M),this.f=M}get validateInput(){return(0,v.$iF)(this.m,"scmValidation"),this.g}set validateInput(M){if((0,v.$iF)(this.m,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.o,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.o,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.o,M))}get actionButton(){return(0,v.$iF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(M){(0,v.$iF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Rc,this.k=M;const B=M!==void 0?{command:this.n.converter.toInternal(M.command,this.l.value),icon:h(M),enabled:M.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,B??null)}get document(){return(0,v.$iF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(M,B,C,P,X,ae){this.m=M,this.n=B,this.o=X,this.p=ae,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new L.$Tc,this.#t=C,this.#e=P}showValidationMessage(M,B){(0,v.$iF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,M,B)}$onInputBoxValueChange(M){this.q(M)}q(M){this.d=M,this.e.fire(M)}}e.$Hgc=y;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(M){this.v=M,this.q.$updateGroupLabel(this.t,this.handle,M)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(M){this.p=M,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,B,C,P,X){this.q=M,this.s=B,this.t=C,this.u=P,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,B){const C=this.h.get(M);return C?(0,A.$Tg)(()=>this.s.executeCommand(C.command,...C.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(f),C=(0,g.$Db)(this.o,M,f).map(ae=>{const ge=ae.toInsert.map(ve=>{const ke=this.e++;this.g.set(ke,ve);const de=ve.resourceUri;let he;if(ve.command)if(ve.command.command==="vscode.open"||ve.command.command==="vscode.diff"||ve.command.command==="vscode.changes"){const ce=new L.$Rc;he=this.s.converter.toInternal(ve.command,ce),this.j.set(ke,ce)}else this.h.set(ke,ve.command);const te=c(ve.decorations),Se=ve.decorations&&c(ve.decorations.light)||te,oe=ve.decorations&&c(ve.decorations.dark)||te,Y=[Se,oe],V=ve.decorations&&ve.decorations.tooltip||"",ne=ve.decorations&&!!ve.decorations.strikeThrough,Ie=ve.decorations&&!!ve.decorations.faded,Le=ve.contextValue||"";return{rawResource:[ke,de,Y,V,ne,Ie,Le,he],handle:ke}});return{start:ae.start,deleteCount:ae.deleteCount,toInsert:ge}}),P=C.map(({start:ae,deleteCount:ge,toInsert:ve})=>[ae,ge,ve.map(ke=>ke.rawResource)]),X=C.reverse();for(const{start:ae,deleteCount:ge,toInsert:ve}of X){const ke=ve.map(he=>he.handle),de=this.n.splice(ae,ge,...ke);for(const he of de)this.g.delete(he),this.h.delete(he),this.j.get(he)?.dispose(),this.j.delete(he)}return this.o=M,P}dispose(){this.l=!0,this.m.fire()}}class O{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let B;(0,v.$hF)(this.y,"quickDiffProvider")&&(B=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:B})}get historyProvider(){return(0,v.$iF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,v.$iF)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&(this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.l=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(M.onDidChangeActionButton(()=>{(0,v.$iF)(this.y,"scmActionButton"),this.m.value=new L.$Rc;const B=M.actionButton!==void 0?{command:this.z.converter.toInternal(M.actionButton.command,this.m.value),description:M.actionButton.description,enabled:M.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,B??null)})))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new L.$Rc,this.p=M;const B=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:B})}get actionButton(){return(0,v.$iF)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,v.$iF)(this.y,"scmActionButton"),this.q.value=new L.$Rc,this.s=M;const B=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(C=>C.map(P=>this.z.converter.toInternal(P,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:B??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&p(this.u,M))return;this.t.value=new L.$Rc,this.u=M;const B=(M||[]).map(C=>this.z.converter.toInternal(C,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:B})}get selected(){return this.v}constructor(M,B,C,P,X,ae,ge){this.y=M,this.z=P,this.A=X,this.B=ae,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=new L.$Tc,this.n=void 0,this.o=new L.$Tc,this.p=void 0,this.q=new L.$Tc,this.t=new L.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Sd,this.onDidChangeSelection=this.w.event,this.x=O.d++,this.D=new Map,this.E=new Set,this.#e=C;const ve=E.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${X}/scm${this.x}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new y(M,P,B,this.#e,this.x,ve),this.#e.$registerSourceControl(this.x,X,ae,ge,ve)}createResourceGroup(M,B){const C=new D(this.#e,this.z,this.x,M,B),P=T.Event.once(C.onDidDispose)(()=>this.D.delete(C));return this.D.set(C,P),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const M=[],B=[];for(const[C,P]of this.D){P.dispose();const X=C.onDidUpdateResourceStates(()=>{this.E.add(C),this.eventuallyUpdateResourceStates()});T.Event.once(C.onDidDispose)(()=>{this.E.delete(C),X.dispose(),this.e.delete(C.handle),this.#e.$unregisterGroup(this.x,C.handle)}),M.push([C.handle,C.id,C.label,C.features]);const ae=C._takeResourceStateSnapshot();ae.length>0&&B.push([C.handle,ae]),this.e.set(C.handle,C)}this.#e.$registerGroups(this.x,M,B),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(B=>{const C=B._takeResourceStateSnapshot();C.length!==0&&M.push([B.handle,C])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ge([(0,I.$th)(100)],O.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$th)(100)],O.prototype,"eventuallyUpdateResourceStates",null);let K=class{static{t=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(M,B,C,P){this.n=B,this.o=C,this.p=P,this.h=new Map,this.j=new S.$hm,this.k=new T.$Sd,this.l=new Map,this.f=M.getProxy(m.$KK.MainThreadSCM),this.g=M.getProxy(m.$KK.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:X=>{if(X&&X.$mid===3){const ae=this.h.get(X.sourceControlHandle);if(!ae)return X;const ge=ae.getResourceGroup(X.groupHandle);return ge?ge.getResourceState(X.handle):X}else if(X&&X.$mid===4){const ae=this.h.get(X.sourceControlHandle);return ae?ae.getResourceGroup(X.groupHandle):X}else if(X&&X.$mid===5){const ae=this.h.get(X.handle);return ae||X}return X}})}createSourceControl(M,B,C,P){this.p.trace("ExtHostSCM#createSourceControl",M.identifier.value,B,C,P),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const X=t.d++,ae=new O(M,this.o,this.f,this.n,B,C,P);this.h.set(X,ae);const ge=this.j.get(M.identifier)||[];return ge.push(ae),this.j.set(M.identifier,ge),ae}registerSourceControlInputBoxValueProvider(M,B,C){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",M.identifier.value,C.label);const P=t.e++;return this.l.set(P,C),this.f.$registerSourceControlInputBoxValueProvider(P,B,C.label,s(C)),(0,L.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(P),this.l.delete(P)})}async $provideInputBoxValue(M,B,C,P){const X=this.l.get(M);if(X)return await X.provideValue(E.URI.revive(B),C,P)??void 0}getLastInputBox(M){this.p.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const B=this.j.get(M.identifier),C=B&&B[B.length-1];return C&&C.inputBox}$provideOriginalResource(M,B,C){const P=E.URI.revive(B);this.p.trace("ExtHostSCM#$provideOriginalResource",M,P.toString());const X=this.h.get(M);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Tg)(()=>X.quickDiffProvider.provideOriginalResource(P,C)).then(ae=>ae||null)}$onInputBoxValueChange(M,B){this.p.trace("ExtHostSCM#$onInputBoxValueChange",M);const C=this.h.get(M);return C&&C.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(M,B,C,P){this.p.trace("ExtHostSCM#$executeResourceCommand",M,B,C);const X=this.h.get(M);if(!X)return Promise.resolve(void 0);const ae=X.getResourceGroup(B);return ae?ae.$executeResourceCommand(C,P):Promise.resolve(void 0)}$validateInput(M,B,C){this.p.trace("ExtHostSCM#$validateInput",M);const P=this.h.get(M);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Tg)(()=>P.inputBox.validateInput(B,C)).then(X=>{if(!X)return Promise.resolve(void 0);const ae=$.MarkdownString.fromStrict(X.message);return ae?Promise.resolve([ae,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.h.get(M)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(M,B,C){return await this.h.get(M)?.historyProvider?.resolveHistoryItemGroupBase(B,C)??void 0}async $resolveHistoryItemGroupCommonAncestor(M,B,C,P){return await this.h.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,C,P)??void 0}async $provideHistoryItems(M,B,C,P){return(await this.h.get(M)?.historyProvider?.provideHistoryItems(B,C,P))?.map(ge=>({...ge,icon:i(ge)}))??void 0}async $provideHistoryItemChanges(M,B,C){return await this.h.get(M)?.historyProvider?.provideHistoryItemChanges(B,C)??void 0}};e.$Igc=K,e.$Igc=K=t=Ge([Ke(3,R.$ij)],K)}),define(Pe[84],Ae([1,0,3,5,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0;class L{constructor(m){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(E.$KK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,w){return this.a.$setPassword(m,g,w)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Ofc=L,e.$Pfc=(0,I.$1h)("IExtHostSecretState")}),define(Pe[264],Ae([1,0,3,8,2]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class L{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(E.$KK.MainThreadShare)}async $provideShare(m,g,w){return await this.c.get(m)?.provideShare({selection:T.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider(m,g){const w=L.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Jgc=L}),define(Pe[265],Ae([1,0,20,6,3]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class L{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$KK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const w=this.c.get(m);if(!w)return;const R=new T.$Rc,S=new E.$3d;this.d.set(g,S);const l=R.add(w.provideSpeechToTextSession(S.token));R.add(l.onDidChange($=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,$)})),R.add(S.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,w){const R=L.a++;return this.c.set(R,w),this.b.$registerProvider(R,g,{extension:m,displayName:m.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Kgc=L}),define(Pe[266],Ae([1,0,7,3,164,6,8,16]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$IL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$IL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,v,n,o,t=E.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=l,this.#t=$,o&&n){this.c=(0,E.$lL)(n.identifier,o);const a=v.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,r=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=n,this.f=o,this.g=t,this.h=this.u(r)}u(l){if((0,m.$Hf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,I.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=g.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,n,this.r?.internal,v,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Lgc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new E.$MK(()=>{const v=this.b.indexOf($);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,$){this.e=new Map,this.a=l.getProxy(T.$KK.MainThreadStatusBar),this.b=$,this.c=new w(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,v,n){return new g(this.a,this.b,this.e,l,$,v,n)}setStatusBarMessage(l,$){const v=this.c.setMessage(l);let n;return typeof $=="number"?n=setTimeout(()=>v.dispose(),$):typeof $<"u"&&$.then(()=>v.dispose(),()=>v.dispose()),new E.$MK(()=>{v.dispose(),clearTimeout(n)})}}e.$Mgc=R}),define(Pe[85],Ae([1,0,3,5,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;class L{constructor(m,g){this.c=g,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(E.$KK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,w){const R=await this.a.$initializeExtensionStorage(m,g);let S;return R&&(S=this.d(m,g,R)),S||w}setValue(m,g,w){return this.a.$setValue(m,g,w)}$acceptValue(m,g,w){const R=this.d(m,g,w);R&&this.b.fire({shared:m,key:g,value:R})}d(m,g,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${R}`)}}}e.$Gfc=L,e.$Hfc=(0,I.$1h)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,E.$1h)("IExtensionStoragePaths");let m=class{constructor(w,R,S){this.d=R,this.f=S,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$qfc=m,e.$qfc=m=Ge([Ke(0,T.$5M),Ke(1,I.$ij),Ke(2,L.$ofc)],m)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,20,33,195,45,14,8,32]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=void 0,e.$Kfc=(0,I.$1h)("IExtHostTerminalService");class a{constructor(p,y,D,O){this.l=p,this._id=y,this.m=D,this.n=O,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const K=this;this.value={get name(){return K.n||""},get processId(){return K.b},get creationOptions(){return K.m},get exitStatus(){return K.h},get state(){return K.j},get selection(){return K.k},sendText(U,M=!0){K.q(),K.l.$sendText(K._id,U,M)},show(U){K.q(),K.l.$show(K._id,U)},hide(){K.q(),K.l.$hide(K._id)},dispose(){K.a||(K.a=!0,K.l.$dispose(K._id))},get dimensions(){if(!(K.d===void 0||K.g===void 0))return{columns:K.d,rows:K.g}}}}async create(p,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??y?.cwd??void 0,env:p.env??void 0,icon:b(p.iconPath)??void 0,color:n.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(p.location,y?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,y,D,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:D,color:n.ThemeColor.isThemeColor(O)?O.id:void 0,location:this.o(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,y){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in p?{viewColumn:t.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,y){this.h=Object.freeze({code:p,reason:y})}setDimensions(p,y){return p===this.d&&y===this.g||p===0||y===0?!1:(this.d=p,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(y=>{y!==p&&(this.b=Promise.resolve(p))})}}e.$Lfc=a;class c{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,y){this.g.setDimensions?.({columns:p,rows:y})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$KK.MainThreadTerminalService),this.y=new v.$orb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:O=>{const K=U=>{const M=U;return this.W(M.instanceId)?.value};switch(O?.$mid){case 15:return K(O);default:{if(Array.isArray(O))for(let U=0;U<O.length&&O[U].$mid===15;U++)O[U]=K(O[U]);return O}}}}),this.B({dispose:()=>{for(const[O,K]of this.g)K.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,y){const D=new a(this.a,(0,$.$lg)(),p,p.name),O=new c(p.pty);return D.createExtensionTerminal(p.location,this.R(p,y).resolvedExtHostIdentifier,b(p.iconPath),f(p.color)).then(K=>{const U=this.S(K,O);this.h[K]=U}),this.f.push(D),D.value}R(p,y){if(y=y||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const D=p.location.parentTerminal;if(D){const O=this.f.find(K=>K.value===D);O&&(y.resolvedExtHostIdentifier=O._id)}}else p.location&&typeof p.location!="object"?y.location=p.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(p,y){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const O=new c(y),K=this.S(p,O);this.h[p]=K}async $acceptActiveTerminalChanged(p){const y=this.b;if(p===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W(p);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,y){const D=this.W(p);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(p,y,D){const O=this.W(p);O&&O.setDimensions(y,D)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(p,y){const D=this.W(p);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(p,y,D){this.g.get(p)?.resize(y,D)}async $acceptTerminalTitleChange(p,y){const D=this.W(p);D&&(D.name=y)}async $acceptTerminalClosed(p,y,D){const O=this.Y(this.f,p);if(O!==null){const K=this.f.splice(O,1)[0];K.setExitStatus(y,D),this.H.fire(K.value)}}$acceptTerminalOpened(p,y,D,O){if(y){const M=this.Y(this.f,y);if(M!==null){this.f[M]._id=p,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const K={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:L.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},U=new a(this.a,p,K,D);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(p,y){this.W(p)?._setProcessId(y)}async $startExtensionTerminal(p,y){const D=this.W(p);if(!D)return{message:(0,w.localize)(0,null,p)};D.isOpen||await new Promise(K=>{const U=this.onDidOpenTerminal(async M=>{M===D.value&&(U.dispose(),K())})});const O=this.g.get(p);O?O.startSendingEvents(y):this.j[p]={initialDimensions:y}}S(p,y){const D=new m.$Rc;D.add(y.onProcessReady(K=>this.a.$sendProcessReady(p,K.pid,K.cwd,K.windowsPty))),D.add(y.onDidChangeProperty(K=>this.a.$sendProcessProperty(p,K))),this.y.startBuffering(p,y.onProcessData),D.add(y.onProcessExit(K=>this.U(p,K))),this.g.set(p,y);const O=this.j[p];return O&&y instanceof c&&(y.startSendingEvents(O.initialDimensions),delete this.j[p]),D}$acceptProcessAckDataEvent(p,y){this.g.get(p)?.acknowledgeDataEvent(y)}$acceptProcessInput(p,y){this.g.get(p)?.input(y)}$acceptTerminalInteraction(p){const y=this.W(p);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(p,y){this.W(p)?.setSelection(y)}$acceptProcessResize(p,y,D){try{this.g.get(p)?.resize(y,D)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(p,y){this.g.get(p)?.shutdown(y)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(y=>this.a.$sendProcessProperty(p,{type:"cwd",value:y}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new g.$MK(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,p.identifier.value),new g.$MK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(p,y,D){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,D),this.a.$registerQuickFixProvider(p,y),new g.$MK(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,y){const D=new l.$3d().token;if(D.isCancellationRequested)return;const O=this.D.get(p);if(!O)return;const K=await O.provideTerminalQuickFixes(y,D);if(K===null||Array.isArray(K)&&K.length===0)return;const U=new m.$Rc;if(this.w.value=U,!Array.isArray(K))return K?t.TerminalQuickFix.from(K,this.Q.converter,U):void 0;const M=[];for(const B of K){const C=t.TerminalQuickFix.from(B,this.Q.converter,U);C&&M.push(C)}return M}async $createContributedProfileTerminal(p,y){const D=new l.$3d().token;let O=await this.C.get(p)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,y);return}this.createTerminalFromOptions(O.options,y)}}async $provideLinks(p,y){const D=this.W(p);if(!D)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const K=new l.$3d;this.G.set(p,K);const U=[],M={terminal:D.value,line:y},B=[];for(const X of this.z)B.push(o.Promises.withAsyncBody(async ae=>{K.token.onCancellationRequested(()=>ae({provider:X,links:[]}));const ge=await X.provideTerminalLinks(M,K.token)||[];K.token.isCancellationRequested||ae({provider:X,links:ge})}));const C=await Promise.all(B);if(K.token.isCancellationRequested)return[];const P=new Map;for(const X of C)X&&X.links.length>0&&U.push(...X.links.map(ae=>{const ge={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return P.set(ge.id,{provider:X.provider,link:ae}),ge}));return this.F.set(p,P),U}$activateLink(p,y){const D=this.F.get(p)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(p,y){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const D=this.h[p];D&&(D.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,y)}W(p){return this.X(this.f,p)}X(p,y){const D=this.Y(p,y);return D!==null?p[D]:null}Y(p,y){const D=p.findIndex(O=>O._id===y);return D===-1?null:D}getEnvironmentVariableCollection(p){let y=this.n.get(p.identifier.value);return y||(y=new s,this.$(p.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(p,y){const D=(0,S.$wr)(y.map),O=(0,S.$xr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(p,y.persistent,D.length===0?void 0:D,O)}$initEnvironmentVariableCollections(p){p.forEach(y=>{const D=y[0],O=new s(y[1]);this.$(D,O)})}$acceptDefaultProfile(p,y){const D=this.s;this.s=p,this.u=y,D?.path!==p.path&&this.N.fire(p.path)}$(p,y){this.n.set(p,y),y.onDidChangeCollection(()=>{this.Z(p,y)})}};e.$Mfc=i,e.$Mfc=i=Ge([Ke(1,r.$$M),Ke(2,A.$OM)],i);class s{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const y=this.h(p);let D=this.a.get(y);return D||(D=new u(this,p),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(p,y,D,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:O})}append(p,y,D,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:O})}prepend(p,y,D,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:O})}f(p,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(p,y.scope),O=this.map.get(D),K=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==y.value||O.type!==y.type||O.options?.applyAtProcessCreation!==K.applyAtProcessCreation||O.options?.applyAtShellIntegration!==K.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const U=this.g(p,y.scope),M={variable:p,...y,options:K};this.map.set(U,M),this.d.fire()}}get(p,y){const D=this.g(p,y),O=this.map.get(D);return O?k(O):void 0}g(p,y){const D=this.h(y);return D.length?`${p}:::${D}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const y=new Map;for(const[D,O]of this.map)this.h(O.scope)===this.h(p)&&y.set(O.variable,k(O));return y}delete(p,y){const D=this.g(p,y);this.map.delete(D),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(y);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,y){const D=this.h(y),O=this.descriptionMap.get(D);if(!O||O.description!==p){let K;typeof p=="string"?K=p:K=p?.value.split(`

`)[0];const U={description:K,scope:y};this.descriptionMap.set(D,U),this.d.fire()}}getDescription(p){const y=this.h(p);return this.descriptionMap.get(y)?.description}k(p){const y=this.h(p);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,y){this.b=p,this.d=y,this.a=new E.$Sd}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,y,D){this.b.replace(p,y,D,this.d)}append(p,y,D){this.b.append(p,y,D,this.d)}prepend(p,y,D){this.b.prepend(p,y,D,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,y){this.b.getVariableMap(this.d).forEach((D,O)=>p.call(y,O,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(p,y){super(!1,p,y)}createTerminal(p,y,D){throw new R.$_}createTerminalFromOptions(p,y){throw new R.$_}};e.$Nfc=d,e.$Nfc=d=Ge([Ke(0,r.$$M),Ke(1,A.$OM)],d);function b(F){if(!(!F||typeof F=="string"))return"id"in F?{id:F.id,color:F.color}:F}function f(F){return n.ThemeColor.isThemeColor(F)?F:void 0}function k(F){const p={...F};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Pe[267],Ae([1,0,14,24,20,5,219,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0;let h=class extends g.$Sc{constructor(U,M,B){super(),this.u=B,this.f=this.B(new L.$Sd),this.g=new Map,this.s=this.B(new L.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(l.$KK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),M.registerArgumentProcessor({processArgument:C=>{switch(C?.$mid){case 16:{const P=C,X=P.tests[P.tests.length-1].item.extId;return this.g.get(t.$CJ.root(X))?.collection.tree.get(X)?.actual??(0,v.$1M)(C)}case 18:{const{extId:P,message:X}=C;return{test:this.g.get(t.$CJ.root(P))?.collection.tree.get(P)?.actual,message:n.TestMessage.to(X)}}default:return C}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const C=await M.executeCommand("_testing.getExplorerSelection"),P=X=>{const ae=this.g.get(t.$CJ.root(X));if(ae)return t.$CJ.isRoot(X)?ae.controller:ae.collection.tree.get(X)?.actual};return{include:C?.include.map(P).filter(R.$Lf)||[],exclude:C?.exclude.map(P).filter(R.$Lf)||[]}})}createTestController(U,M,B,C){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const P=new g.$Rc,X=P.add(new v.$4M(M,B,this.u));X.root.label=B;const ae=new Map,ge=new Set,ve=this.h,ke={items:X.root.children,get label(){return B},set label(he){B=he,X.root.label=he,ve.$updateController(M,{label:B})},get refreshHandler(){return C},set refreshHandler(he){C=he,ve.$updateController(M,{canRefresh:!!he})},get id(){return M},createRunProfile:(he,te,Se,oe,Y,V)=>{let ne=(0,m.$Oi)(he);for(;ae.has(ne);)ne++;return new D(this.h,ae,U,ge,this.s.event,M,ne,he,te,Se,oe,Y,V)},createTestItem(he,te,Se){return new v.$2M(M,he,te,Se)},createTestRun:(he,te,Se=!0)=>this.j.createTestRun(U,M,X,he,te,Se),invalidateTestResults:he=>{if(he===void 0)this.h.$markTestRetired(void 0);else{const te=he instanceof Array?he:[he];this.h.$markTestRetired(te.map(Se=>t.$CJ.fromExtHostTestItem(Se,M).toString()))}},set resolveHandler(he){X.resolveHandler=he},get resolveHandler(){return X.resolveHandler},dispose:()=>{P.dispose()}};ve.$registerTestController(M,B,!!C),P.add((0,g.$Qc)(()=>ve.$unregisterTestController(M)));const de={controller:ke,collection:X,profiles:ae,extension:U,activeProfiles:ge};return this.g.set(M,de),P.add((0,g.$Qc)(()=>this.g.delete(M))),P.add(X.onDidGenerateDiff(he=>ve.$publishDiff(M,he.map(a.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.m.checkout()}async runTests(U,M=I.CancellationToken.None){const B=b(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(B.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(P=>t.$CJ.fromExtHostTestItem(P,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:O[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(P=>P.id)},M)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,M,B){return await this.j.getCoverageReport(U,M)?.provideFileCoverage(B)??[]}async $resolveFileCoverage(U,M,B,C){return await this.j.getCoverageReport(U,M)?.resolveFileCoverage(B,C)??[]}$configureRunProfile(U,M){this.g.get(U)?.profiles.get(M)?.configureHandler?.()}$setActiveRunProfiles(U){const M=new Map;for(const[B,C]of Object.entries(U)){const P=this.g.get(B);if(!P)continue;const X=new Map,ae=C.filter(ve=>!P.activeProfiles.has(ve)),ge=[...P.activeProfiles].filter(ve=>!C.includes(ve));for(const ve of ae)X.set(ve,!0),P.activeProfiles.add(ve);for(const ve of ge)X.set(ve,!1),P.activeProfiles.delete(ve);X.size&&M.set(B,X)}this.s.fire(M)}async $refreshTests(U,M){await this.g.get(U)?.controller.refreshHandler?.(M)}$publishTestResults(U){this.results=Object.freeze(U.map(M=>(0,w.$hn)(n.TestResults.to(M))).concat(this.results).sort((M,B)=>B.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,M){const B=this.g.get(t.$CJ.fromString(U).controllerId)?.collection;B&&(await B.expand(U,M<0?1/0:M),B.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(a.TestsDiffOp.deserialize))}async $runControllerTests(U,M){return Promise.all(U.map(B=>this.w(B,!1,M)))}async $startContinuousRun(U,M){const B=new I.$3d(M),C=await Promise.all(U.map(P=>this.w(P,!0,B.token)));return!M.isCancellationRequested&&!C.some(P=>P.error)&&await new Promise(P=>M.onCancellationRequested(P)),B.dispose(!0),C}async w(U,M,B){const C=this.g.get(U.controllerId);if(!C)return{};const{collection:P,profiles:X,extension:ae}=C,ge=X.get(U.profileId);if(!ge)return{};const ve=U.testIds.map(te=>P.tree.get(te)).filter(R.$Lf),ke=U.excludeExtIds.map(te=>C.collection.tree.get(te)).filter(R.$Lf).filter(te=>ve.some(Se=>Se.fullId.compare(te.fullId)===2));if(!ve.length)return{};const de=new o.$jM(ve.some(te=>te.actual instanceof v.$3M)?void 0:ve.map(te=>te.actual),ke.map(te=>te.actual),ge,M),he=(0,a.$EJ)(U)&&this.j.prepareForMainThreadTestRun(de,f.fromInternal(U,C.collection),ae,B);try{return await ge.runHandler(de,B),{}}catch(te){return{error:String(te)}}finally{he&&(he.hasRunningTasks&&!B.isCancellationRequested&&await L.Event.toPromise(he.onEnd),he.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Qgc=h,e.$Qgc=h=Ge([Ke(0,$.$OM)],h);const i=1e4;var s;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(s||(s={}));class u extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,M,B,C){super(),this.s=U,this.u=M,this.w=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Sd),this.m=this.B(new L.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(C));const P=this.B(new E.$ah(()=>this.y(),i));this.B(this.h.token.onCancellationRequested(()=>P.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(U){const M=this.s.id,B=this.s.controllerId,C=(0,S.$lg)(),P=this.w,X=this.m;let ae;const ge=he=>(te,...Se)=>{if(ke){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.C(te),he(te,...Se))},ve=(he,te)=>{const Se=te instanceof Array?te.map(n.TestMessage.from):[n.TestMessage.from(te)];if(he.uri&&he.range){const oe={range:n.Range.from(he.range),uri:he.uri};for(const Y of Se)Y.location=Y.location||oe}this.u.$appendTestMessagesInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),Se)};let ke=!1;const de={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ae?.provider},set coverageProvider(he){(0,c.$iF)(P,"testCoverage"),ae=he&&new k(he),X.fire({taskId:C,runId:M,coverage:ae})},enqueued:ge(he=>{this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),1)}),skipped:ge(he=>{this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),5)}),started:ge(he=>{this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),2)}),errored:ge((he,te,Se)=>{ve(he,te),this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),6,Se)}),failed:ge((he,te,Se)=>{ve(he,te),this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,B).toString(),4,Se)}),passed:ge((he,te)=>{this.u.$updateTestStateInRun(M,C,t.$CJ.fromExtHostTestItem(he,this.s.controllerId).toString(),3,te)}),appendOutput:(he,te,Se)=>{ke||(Se&&(this.s.isIncluded(Se)?this.C(Se):Se=void 0),this.u.$appendOutputToRun(M,C,T.$ge.fromString(he),te&&n.location.from(te),Se&&t.$CJ.fromExtHostTestItem(Se,B).toString()))},end:()=>{ke||(ke=!0,this.u.$finishedTestRunTask(M,C),this.f.delete(C),this.f.size||this.z())}};return this.f.set(C,{run:de}),this.u.$startedTestRunTask(M,{id:C,name:U,running:!0}),de}y(){for(const{run:U}of this.f.values())U.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(U){if(!(U instanceof v.$2M))throw new r.$GM(U.id);if(this.g.has(t.$CJ.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const M=[],B=this.s.colllection.root;for(;;){const C=n.TestItem.from(U);if(M.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),U===B))break;U=U.parent||B}this.u.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.z(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(U){this.f=U,this.c=new Map,this.d=[]}getCoverageReport(U,M){return this.d.find(B=>B.runId===U)?.coverage.get(M)}prepareForMainThreadTestRun(U,M,B,C){return this.g(U,M,B,C)}cancelRunById(U){for(const M of this.c.values())if(M.id===U){M.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,M,B,C,P,X){const ae=this.c.get(C);if(ae)return ae.createRun(P);const ge=f.fromPublic(M,B,C,X),ve=b(C);this.f.$startedExtensionTestRun({controllerId:M,continuous:!!C.continuous,profile:ve&&{group:O[ve.kind],id:ve.profileId},exclude:C.exclude?.map(de=>t.$CJ.fromExtHostTestItem(de,B.root.id).toString())??[],id:ge.id,include:C.include?.map(de=>t.$CJ.fromExtHostTestItem(de,B.root.id).toString())??[B.root.id],persist:X});const ke=this.g(C,ge,U);return L.Event.once(ke.onEnd)(()=>{this.f.$finishedExtensionTestRun(ge.id),ke.dispose()}),ke.createRun(P)}g(U,M,B,C){const P=new u(M,this.f,B,C);this.c.set(U,P);let X;const ae=P.onDidCoverage(({runId:ge,taskId:ve,coverage:ke})=>{X||(X={runId:ge,coverage:new Map},this.d.unshift(X),this.d.length>a.$JJ&&this.d.pop()),X.coverage.set(ve,ke),this.f.$signalCoverageAvailable(ge,ve,!!ke)});return L.Event.once(P.onEnd)(()=>{this.c.delete(U),ae.dispose()}),P}}e.$Rgc=d;const b=K=>{if(K.profile){if(!(K.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class f{static fromPublic(U,M,B,C){return new f(U,(0,S.$lg)(),B.include?.map(P=>t.$CJ.fromExtHostTestItem(P,U).toString())??[U],B.exclude?.map(P=>t.$CJ.fromExtHostTestItem(P,U).toString())??[],C,M)}static fromInternal(U,M){return new f(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,M)}constructor(U,M,B,C,P,X){this.controllerId=U,this.id=M,this.isPersisted=P,this.colllection=X,this.c=B.map(ae=>ae+"\0"),this.d=C.map(ae=>ae+"\0")}isIncluded(U){const M=t.$CJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if(M===B||M.startsWith(B))return!1;for(const B of this.c)if(M===B||M.startsWith(B))return!0;return!1}}e.$Sgc=f;class k{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(n.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(U,M){const B=await this.c;let C=B?.[U];return!this.provider||!B||!C?[]:(C.detailedCoverage||(C=B[U]=await this.provider.resolveFileCoverage?.(C,M)??C),C.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const M=t.$CJ.parentId(U.item.extId);if(M&&this.g.has(M.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:M,f:B}=this;return{get added(){return[...U].map(C=>C.revived)},get updated(){return[...M].map(C=>C.revived)},get removed(){return[...B].map(C=>C.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends a.$KJ{constructor(){super(...arguments),this.q=new L.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,M){return{...U,revived:n.TestItem.toPlain(U.item),depth:M?M.depth+1:0,children:new Set}}o(){return new F(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(M=>M.revived)},dispose:(0,A.$db)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class D{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,c.$iF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$iF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,U=>U.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(R.$Lf))}constructor(U,M,B,C,P,X,ae,ge,ve,ke,de=!1,he=void 0,te=!1){this.controllerId=X,this.profileId=ae,this.d=ge,this.kind=ve,this.runHandler=ke,this.f=de,this._tag=he,this.g=te,this.#e=U,this.#r=M,this.#t=B,this.#i=C,this.#o=P,M.set(ae,this);const Se=O[ve];if(typeof Se!="number")throw new Error(`Unknown TestRunProfile.group ${ve}`);this.#e.$publishTestRunProfile({profileId:ae,controllerId:X,tag:he?n.TestTag.namespace(this.controllerId,he.id):null,label:ge,group:Se,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Tgc=D;const O={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[268],Ae([1,0,18,11,5,3,109,8,7]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class w{constructor(S,l){this.i=l,this.a=new I.$Sd({onListenerError:T.$2}),this.b=new I.$Sd({onListenerError:T.$2}),this.c=new I.$Sd({onListenerError:T.$2}),this.d=new I.$Sd({onListenerError:T.$2}),this.f=new I.$Sd({onListenerError:T.$2}),this.g=new I.$Sd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(L.$KK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const l=this.i.allEditors();return S?l:l.map($=>$.value)}async showTextDocument(S,l,$){let v;typeof l=="number"?v={position:m.ViewColumn.from(l),preserveFocus:$}:typeof l=="object"?v={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const n=await this.h.$tryShowTextDocument(S.uri,v),o=n&&this.i.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,l){return new A.$VM(this.h,S,l).value}$acceptEditorPropertiesChanged(S,l){const $=this.i.getEditor(S);if(!$)throw new Error("unknown text editor");if(l.options&&$._acceptOptions(l.options),l.selections){const v=l.selections.selections.map(m.Selection.to);$._acceptSelections(v)}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));$._acceptVisibleRanges(v)}if(l.options&&this.b.fire({textEditor:$.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),n=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:$.value,selections:n,kind:v})}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:$.value,visibleRanges:v})}}$acceptEditorPositionData(S){for(const l in S){const $=this.i.getEditor(l);if(!$)throw new Error("Unknown text editor");const v=m.ViewColumn.to(S[l]);$.value.viewColumn!==v&&($._acceptViewColumn(v),this.d.fire({textEditor:$.value,viewColumn:v}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$dfc=w}),define(Pe[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0,e.$Vgc=(0,T.$1h)("IExtHostTimeline");class R{constructor($,v){this.b=new Map,this.c=new Map,this.a=$.getProxy(I.$KK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&g.$fm.equals(o,this.b.get(n.source)?.extension)){const t=n.uri===void 0?void 0:E.URI.revive(n.uri);return this.c.get(n.source)?.get(S(t))?.get(n.handle)}else return;return n}})}async $getTimeline($,v,n,o){return this.b.get($)?.provider.provideTimeline(E.URI.revive(v),n,o)}registerTimelineProvider($,v,n,o){const t=new L.$Rc,r=this.d(v.id,o,t).bind(this);let a;v.onDidChange&&(a=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const c=this.c;return this.f({...v,scheme:$,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(v.id)?.clear());const u=await v.provideTimeline(h,i,s);if(u==null)return;const d=r(h,i);return{...u,source:v.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(v.id)?.clear();a?.dispose(),t.dispose()}},n)}d($,v,n){return(o,t)=>{let r;if(t?.cacheResults){let a=this.c.get($);a===void 0&&(a=new Map,this.c.set($,a));const c=S(o);r=a.get(c),r===void 0&&(r=new Map,a.set(c,r))}return a=>{const{iconPath:c,...h}=a,i=`${$}|${a.id??a.timestamp}`;r?.set(i,a);let s,u,d;a.iconPath&&(c instanceof A.$HL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let b;return A.$bL.isMarkdownString(h.tooltip)?b=m.MarkdownString.from(h.tooltip):(0,w.$Df)(h.tooltip)?b=h.tooltip:A.$bL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=m.MarkdownString.from(h.detail)):(0,w.$Df)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:i,source:$,command:a.command?v.toInternal(a.command,n):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:b,accessibilityInformation:a.accessibilityInformation}}}}f($,v){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:v}),(0,L.$Qc)(()=>{for(const o of this.c.values())o.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$Wgc=R;function S(l){return l?.toString()}}),define(Pe[87],Ae([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5xb=e.$4xb=e.TunnelDtoConverter=void 0;class $ extends g.$tv{}var v;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function r(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$4xb=(0,A.$1h)("IExtHostTunnelService");let n=class extends I.$Sc{constructor(t,r,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$KK.MainThreadTunnelService)}async openTunnel(t,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const a=await this.a.$openTunnel(r,t.displayName);if(a){const c=new $(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,r){const a=this.u();return this.r.set(a,{selector:t,provider:r}),this.a.$registerPortsAttributesProvider(t,a),new l.$MK(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,r,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(r.map(async b=>{let f;try{f=await d.provider.providePortAttributes({port:b,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(b,a,c,h)}return{providedAttributes:f,port:b}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const a=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,r){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(r?this.w(r):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,r){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(r&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const r=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$5xb=n,e.$5xb=n=Ge([Ke(0,S.$OM),Ke(1,R.$5M),Ke(2,m.$ij)],n)}),define(Pe[270],Ae([1,0,6,13,2,3]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(L.$KK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,R,S){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=S.schemes.find($=>!A.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,S.schemes,g,S.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(w);return S.canOpenExternalUri(l,R)}async $openUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener id: '${g}'`);return S.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},R)}}e.$Ygc=A}),define(Pe[271],Ae([1,0,3,2,6,11,22]),function(me,e,E,T,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class m{static{this.a=0}constructor(w){this.c=new A.$gm,this.d=new Map,this.b=w.getProxy(E.$KK.MainThreadUrls)}registerUriHandler(w,R){const S=w.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=m.a++;return this.c.add(S),this.d.set(l,R),this.b.$registerUriHandler(l,S,w.displayName||w.name),(0,I.$Qc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,R){const S=this.d.get(w);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(R))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$Zgc=m}),define(Pe[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=e.$tfc=e.$sfc=e.$rfc=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=$(d),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$avb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$_ub}return w.$_ub}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),L.$kn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$Rkb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,b,f,k)=>{const F=A.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$avb)(F,{isRemote:h,authority:i}).toString();return`${u}${p}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,b,f,k)=>{const F=A.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$avb)(F,{isRemote:h,authority:i}).toString();return`${u}${p}${k}`})}}e.$rfc=S;function l(a){try{const c=(0,m.$Zo)((0,m.$Yo)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$sfc=l;function $(a){try{const c=(0,m.$Zo)((0,m.$Yo)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class v extends T.$Sc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(R.$KK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$Skb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new S(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$tfc=v;function n(a){return{id:a.identifier,location:a.extensionLocation}}e.$ufc=n;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(a,c)}}e.$vfc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>A.URI.from(c))}}function r(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Pe[272],Ae([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class ${constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new R.$Wec("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,A.$Cg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class v{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const b=this.b(s,u.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new $(u,d);return this.a.set(b,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var n;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,b){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:b}),new l.$MK(()=>this.a.delete(u))}}class t{constructor(s,u,d,b,f){this.d=u,this.f=d,this.g=b,this.h=f,this.b=new o,this.c=new v,this.a=s.getProxy(S.$KK.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,b){const f=new I.$Rc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$ufc)(s),u,b.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$sfc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),r(d)&&f.add(d.onDidChangeCustomDocument(k=>{const F=this.i(u,k.document.uri);if(c(k)){const p=F.addEdit(k);this.a.$onDidEdit(k.document.uri,u,p,k.label)}else this.a.$onContentChange(k.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$ufc)(s),u,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,w.$sfc)(s))),l.$MK.from(f,new l.$MK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,b,f){const k=this.b.get(u);if(!k)throw new Error(`No provider found for '${u}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${u}'`);const F=m.URI.revive(s),p=await k.provider.openCustomDocument(F,{backupId:d,untitledDocumentData:b?.buffer},f);let y;return r(k.provider)&&this.f&&(y=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(u,p,y),{editable:r(k.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const b=m.URI.revive(s),{document:f}=this.i(u,b);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,b,f,k){const F=this.b.get(d);if(!F)throw new Error(`No provider found for '${d}'`);const p=g.ViewColumn.to(f),y=this.g.createNewWebview(u,b.contentOptions,F.extension),D=this.h.createNewWebviewPanel(u,d,b.title,p,b.options,y,b.active),O=m.URI.revive(s);switch(F.type){case 1:{const{document:K}=this.i(d,O);return F.provider.resolveCustomEditor(K,D,k)}case 0:{const K=this.d.getDocument(O);return F.provider.resolveCustomTextEditor(K,D,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const b=this.b.get(d);if(!b)throw new Error(`No provider found for '${d}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const k=m.URI.revive(u),F=this.d.getDocument(k);await b.provider.moveCustomTextEditor(F,f,E.CancellationToken.None)}async $undo(s,u,d,b){return this.i(u,s).undo(d,b)}async $redo(s,u,d,b){return this.i(u,s).redo(d,b)}async $revert(s,u,d){const b=this.i(u,s);await this.j(u).revertCustomDocument(b.document,d),b.disposeBackup()}async $onSave(s,u,d){const b=this.i(u,s);await this.j(u).saveCustomDocument(b.document,d),b.disposeBackup()}async $onSaveAs(s,u,d,b){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,m.URI.revive(d),b)}async $backup(s,u,d){const b=this.i(u,s),k=await this.j(u).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},d);return b.updateBackup(k),k.id}i(s,u){const d=this.c.get(s,m.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$xfc=t;function r(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Oi)(s)+""}}),define(Pe[273],Ae([1,0,5,6,2,33,8,65,3,7]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class R extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,n,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=n,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,I.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:A.ViewColumn.from(v),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Sc{static c(){return(0,L.$lg)()}constructor(v,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=v.getProxy(g.$KK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,n,o,t,r={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:A.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,m.$sfc)(v),i=S.c();this.f.$createWebviewPanel((0,m.$ufc)(v),i,n,{title:o,panelOptions:l(r),webviewOptions:(0,m.$vfc)(v,this.m,r),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,r,v);return this.createNewWebviewPanel(i,n,o,a,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const n=Object.keys(v);n.sort((o,t)=>{const r=v[o],a=v[t];return r.active?1:a.active?-1:+r.visible-+a.visible});for(const o of n){const t=this.getWebviewPanel(o);if(!t)continue;const r=v[o];t._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:v}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,m.$sfc)(v)}),new w.$MK(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(v,n,o,t){const r=this.h.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:a,extension:c}=r,h=this.j.createNewWebview(v,o.webviewOptions,c),i=this.createNewWebviewPanel(v,n,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(v,n,o,t,r,a,c){const h=new R(v,this.f,a,{viewType:n,title:o,viewColumn:t,panelOptions:r,active:c});return this.g.set(v,h),h}getWebviewPanel(v){return this.g.get(v)}}e.$wfc=S;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Pe[274],Ae([1,0,5,6,65,8,3,7]),function(me,e,E,T,I,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class g extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,$,v,n,o){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=v,this.#e=S,this.#t=l,this.#o=n,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$KK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,$,v){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:S}),this.a.$registerWebviewViewProvider((0,I.$ufc)(S),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$sfc)(S)}),new m.$MK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,$,v,n){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:r}=o,a=this.d.createNewWebview(S,{},r),c=new g(S,this.a,l,$,a,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:v},n)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$1gc=w}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(me,e,E,T,I,L,A,m,g,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=void 0;let S=class{static{R=this}static{this.a={focused:!0,active:!0}}getState($){const v=this.d;return{get focused(){return v.focused},get active(){return(0,w.$iF)($,"windowActivity"),v.active}}}constructor($){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=$.getProxy(T.$KK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:n})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,v){v!==this.d[$]&&(this.d={...this.d,[$]:v},this.c.fire(this.d))}openUri($,v){let n;if(typeof $=="string"){n=$;try{$=I.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,A.$Ge)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,n,v)}async asExternalUri($,v){if((0,A.$Ge)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri($,v);return I.URI.from(n)}};e.$2gc=S,e.$2gc=S=R=Ge([Ke(0,g.$OM)],S),e.$3gc=(0,m.$1h)("IExtHostWindow")}),define(Pe[275],Ae([1,0,241,27,17]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;let L=class extends E.$6gc{constructor(m,g){super(m,g)}f(m,g,w){g.apply(console,w)}};e.$bjc=L,e.$bjc=L=Ge([Ke(0,I.$OM),Ke(1,T.$5M)],L)}),define(Pe[276],Ae([1,0,14,24,20,11,5,6,139,230,49]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.ResponsiveState=e.RequestInitiator=e.$d7b=e.$c7b=void 0;function l(D,O){try{return JSON.stringify(D,O)}catch{return"null"}}const $="$$ref$$",v={[$]:-1};class n{constructor(O,K){this.jsonString=O,this.referencedBuffers=K}}function o(D,O=null,K=!1){const U=[];return{jsonString:(K?l:JSON.stringify)(D,(B,C)=>{if(typeof C>"u")return v;if(typeof C=="object"){if(C instanceof T.$ge){const P=U.push(C)-1;return{[$]:P}}if(O)return O(B,C)}return C}),referencedBuffers:U}}e.$c7b=o;function t(D,O,K){return JSON.parse(D,(U,M)=>{if(M){const B=M[$];if(typeof B=="number")return O[B];if(K&&M.$mid===1)return K.transformIncoming(M)}return M})}e.$d7b=t;function r(D,O){return JSON.stringify(D,O)}function a(D){return D?(O,K)=>K&&K.$mid===1?D.transformOutgoing(K):K:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends m.$Sc{static{S=s}static{this.a=3*1e3}constructor(O,K=null,U=null){super(),this[S]=!0,this.b=this.B(new A.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=K,this.g=U,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,B=R.$Av.count;M<B;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$ah(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const K=this.w[O];delete this.w[O],K.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,g.$1m)(O,this.g):O}getProxy(O){const{nid:K,sid:U}=O;return this.s[K]||(this.s[K]=this.J(K,U)),this.s[K]}J(O,K){const U={get:(M,B)=>(typeof B=="string"&&!M[B]&&B.charCodeAt(0)===36&&(M[B]=(...C)=>this.U(O,B,C)),B===u?K:M[B])};return new Proxy(Object.create(null),U)}set(O,K){return this.m[O.nid]=K,K}assertRegistered(O){for(let K=0,U=O.length;K<U;K++){const M=O[K];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(O){if(this.j)return;const K=O.byteLength,U=f.read(O,0),M=U.readUInt8(),B=U.readUInt32();switch(M){case 1:case 2:{let{rpcId:C,method:P,args:X}=F.deserializeRequestJSONArgs(U);this.g&&(X=(0,g.$1m)(X,this.g)),this.M(K,B,C,P,X,M===2);break}case 3:case 4:{let{rpcId:C,method:P,args:X}=F.deserializeRequestMixedArgs(U);this.g&&(X=(0,g.$1m)(X,this.g)),this.M(K,B,C,P,X,M===4);break}case 5:{this.f?.logIncoming(K,B,0,"ack"),this.G(B);break}case 6:{this.N(K,B);break}case 7:{this.O(K,B,void 0);break}case 9:{let C=F.deserializeReplyOKJSON(U);this.g&&(C=(0,g.$1m)(C,this.g)),this.O(K,B,C);break}case 10:{const C=F.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(K,B,C);break}case 8:{const C=F.deserializeReplyOKVSBuffer(U);this.O(K,B,C);break}case 11:{let C=F.deserializeReplyErrError(U);this.g&&(C=(0,g.$1m)(C,this.g)),this.P(K,B,C);break}case 12:{this.P(K,B,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,K,U,M,B,C){this.f?.logIncoming(O,K,1,`receiveRequest ${(0,R.$Cv)(U)}.${M}(`,B);const P=String(K);let X,ae;if(C){const ve=new I.$3d;B.push(ve.token),X=this.Q(U,M,B),ae=()=>ve.cancel()}else X=this.Q(U,M,B),ae=i;this.u[P]=ae;const ge=F.serializeAcknowledged(K);this.f?.logOutgoing(ge.byteLength,K,1,"ack"),this.c.send(ge),X.then(ve=>{delete this.u[P];const ke=F.serializeReplyOK(K,ve,this.h);this.f?.logOutgoing(ke.byteLength,K,1,"reply:",ve),this.c.send(ke)},ve=>{delete this.u[P];const ke=F.serializeReplyErr(K,ve);this.f?.logOutgoing(ke.byteLength,K,1,"replyErr:",ve),this.c.send(ke)})}N(O,K){this.f?.logIncoming(O,K,1,"receiveCancel");const U=String(K);this.u[U]?.()}O(O,K,U){this.f?.logIncoming(O,K,0,"receiveReply:",U);const M=String(K);if(!this.w.hasOwnProperty(M))return;const B=this.w[M];delete this.w[M],B.resolveOk(U)}P(O,K,U){this.f?.logIncoming(O,K,0,"receiveReplyErr:",U);const M=String(K);if(!this.w.hasOwnProperty(M))return;const B=this.w[M];delete this.w[M];let C;U&&(U.$isError?(C=new Error,C.name=U.name,C.message=U.message,C.stack=U.stack):C=U),B.resolveErr(C)}Q(O,K,U){try{return Promise.resolve(this.S(O,K,U))}catch(M){return Promise.reject(M)}}S(O,K,U){const M=this.m[O];if(!M)throw new Error("Unknown actor "+(0,R.$Cv)(O));const B=M[K];if(typeof B!="function")throw new Error("Unknown method "+K+" on actor "+(0,R.$Cv)(O));return B.apply(M,U)}U(O,K,U){if(this.j)return new w.$b7b;let M=null;if(U.length>0&&I.CancellationToken.isCancellationToken(U[U.length-1])&&(M=U.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$6());const B=F.serializeRequestArguments(U,this.h),C=++this.t,P=String(C),X=new w.$a7b,ae=new m.$Rc;M&&ae.add(M.onCancellationRequested(()=>{const ve=F.serializeCancel(C);this.f?.logOutgoing(ve.byteLength,C,0,"cancel"),this.c.send(F.serializeCancel(C))})),this.w[P]=new b(X,ae),this.F(C);const ge=F.serializeRequest(C,O,K,B,!!M);return this.f?.logOutgoing(ge.byteLength,C,0,`request: ${(0,R.$Cv)(O)}.${K}(`,U),this.c.send(ge),X}}e.$e7b=d;class b{constructor(O,K){this.a=O,this.b=K}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class f{static alloc(O,K,U){const M=new f(T.$ge.alloc(U+1+4),0);return M.writeUInt8(O),M.writeUInt32(K),M}static read(O,K){return new f(O,K)}get buffer(){return this.a}constructor(O,K){this.a=O,this.b=K}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+O).toString();return this.b+=O,U}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+O).toString();return this.b+=O,U}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+O);return this.b+=O,K}static sizeMixedArray(O){let K=0;K+=1;for(let U=0,M=O.length;U<M;U++){const B=O[U];switch(K+=1,B.type){case 1:K+=this.sizeLongString(B.value);break;case 2:K+=this.sizeVSBuffer(B.value);break;case 3:K+=this.sizeUInt32,K+=this.sizeLongString(B.value);for(let C=0;C<B.buffers.length;++C)K+=this.sizeVSBuffer(B.buffers[C]);break;case 4:break}}return K}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let K=0,U=O.length;K<U;K++){const M=O[K];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let B=0;B<M.buffers.length;++B)this.writeBuffer(M.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const K=new Array(O);for(let U=0;U<O;U++)switch(this.readUInt8()){case 1:K[U]=this.readLongString();break;case 2:K[U]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),C=this.readLongString(),P=[];for(let X=0;X<B;++X)P.push(this.readVSBuffer());K[U]=new R.$Dv(t(C,P,null));break}case 4:K[U]=void 0;break}return K}}var k;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(k||(k={}));class F{static a(O){for(let K=0,U=O.length;K<U;K++)if(O[K]instanceof T.$ge||O[K]instanceof R.$Dv||typeof O[K]>"u")return!0;return!1}static serializeRequestArguments(O,K){if(this.a(O)){const U=[];for(let M=0,B=O.length;M<B;M++){const C=O[M];if(C instanceof T.$ge)U[M]={type:2,value:C};else if(typeof C>"u")U[M]={type:4};else if(C instanceof R.$Dv){const{jsonString:P,referencedBuffers:X}=o(C.value,K);U[M]={type:3,value:T.$ge.fromString(P),buffers:X}}else U[M]={type:1,value:T.$ge.fromString(r(C,K))}}return{type:1,args:U}}return{type:0,args:r(O,K)}}static serializeRequest(O,K,U,M,B){switch(M.type){case 0:return this.b(O,K,U,M.args,B);case 1:return this.c(O,K,U,M.args,B)}}static b(O,K,U,M,B){const C=T.$ge.fromString(U),P=T.$ge.fromString(M);let X=0;X+=f.sizeUInt8(),X+=f.sizeShortString(C),X+=f.sizeLongString(P);const ae=f.alloc(B?2:1,O,X);return ae.writeUInt8(K),ae.writeShortString(C),ae.writeLongString(P),ae.buffer}static deserializeRequestJSONArgs(O){const K=O.readUInt8(),U=O.readShortString(),M=O.readLongString();return{rpcId:K,method:U,args:JSON.parse(M)}}static c(O,K,U,M,B){const C=T.$ge.fromString(U);let P=0;P+=f.sizeUInt8(),P+=f.sizeShortString(C),P+=f.sizeMixedArray(M);const X=f.alloc(B?4:3,O,P);return X.writeUInt8(K),X.writeShortString(C),X.writeMixedArray(M),X.buffer}static deserializeRequestMixedArgs(O){const K=O.readUInt8(),U=O.readShortString(),M=O.readMixedArray(),B=new Array(M.length);for(let C=0,P=M.length;C<P;C++){const X=M[C];typeof X=="string"?B[C]=JSON.parse(X):B[C]=X}return{rpcId:K,method:U,args:B}}static serializeAcknowledged(O){return f.alloc(5,O,0).buffer}static serializeCancel(O){return f.alloc(6,O,0).buffer}static serializeReplyOK(O,K,U){if(typeof K>"u")return this.d(O);if(K instanceof T.$ge)return this.e(O,K);if(K instanceof R.$Dv){const{jsonString:M,referencedBuffers:B}=o(K.value,U,!0);return this.g(O,M,B)}else return this.f(O,l(K,U))}static d(O){return f.alloc(7,O,0).buffer}static e(O,K){let U=0;U+=f.sizeVSBuffer(K);const M=f.alloc(8,O,U);return M.writeVSBuffer(K),M.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,K){const U=T.$ge.fromString(K);let M=0;M+=f.sizeLongString(U);const B=f.alloc(9,O,M);return B.writeLongString(U),B.buffer}static g(O,K,U){const M=T.$ge.fromString(K);let B=0;B+=f.sizeUInt32,B+=f.sizeLongString(M);for(const P of U)B+=f.sizeVSBuffer(P);const C=f.alloc(10,O,B);C.writeUInt32(U.length),C.writeLongString(M);for(const P of U)C.writeBuffer(P);return C.buffer}static deserializeReplyOKJSON(O){const K=O.readLongString();return JSON.parse(K)}static deserializeReplyOKJSONWithBuffers(O,K){const U=O.readUInt32(),M=O.readLongString(),B=[];for(let C=0;C<U;++C)B.push(O.readVSBuffer());return new R.$Dv(t(M,B,K))}static serializeReplyErr(O,K){const U=K?l(L.$3(K),null):void 0;if(typeof U!="string")return this.h(O);const M=T.$ge.fromString(U);let B=0;B+=f.sizeLongString(M);const C=f.alloc(11,O,B);return C.writeLongString(M),C.buffer}static deserializeReplyErrError(O){const K=O.readLongString();return JSON.parse(K)}static h(O){return f.alloc(12,O,0).buffer}}var p;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[277],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;const E=function(L){const A=m=>{globalThis.removeEventListener("message",A);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,R){g.postMessage(w,R)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(L,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${A}'))`,w=new Blob([g],{type:"application/javascript"}),R=URL.createObjectURL(w),S=new MessageChannel,l=R,$={type:"_newWorker",id:l,port:S.port2,url:R,options:m};L($,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(v){S.port1.onmessage=v}},onmessageerror:{get(){return S.port1.onmessageerror},set(v){S.port1.onmessageerror=v}}}),S.port1.addEventListener("messageerror",v=>{const n=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(n)}),S.port1.addEventListener("message",v=>{const n=new MessageEvent("message",{data:v.data});this.dispatchEvent(n)}),S.port1.start()}}e.$djc=T}),define(Pe[278],Ae([1,0,5,30,35,4]),function(me,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=e.OutputChannelUpdateMode=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=void 0,e.$VJ="text/x-code-output",e.$WJ="output",e.$XJ="Log",e.$YJ="text/x-code-log-output",e.$ZJ="log",e.$1J="workbench.panel.output",e.$2J=new I.$fj("inOutput",!1),e.$3J=new I.$fj("activeLogOutput",!1),e.$4J=new I.$fj("outputView.scrollLock",!1),e.$5J=(0,L.$1h)("outputService");var A;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$6J={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$sn.add(e.$6J.OutputChannels,new m),e.$7J=new I.$fj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,278,63,27,43,136,24,16,42,5,6]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=void 0;class t extends A.$oj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,A.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,b){this.i=i,this.j=s,this.k=u,this.l=d,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$KK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$qm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,$.$Df)(i)?i:void 0;if((0,$.$Df)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const f=this.i.environment.extensionLogLevel?.find(([F])=>L.$fm.equals(s.identifier,F))?.[1];f&&(b=(0,A.$yj)(f));const k=u?this.o(h,b,s):this.n(h,d,s);return k.then(F=>{this.g.set(F.id,F),F.visible=F.id===this.h}),u?this.r(h,b??this.m.getLevel(),k):this.q(h,k)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,b,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,k=this.l.createLogger(b,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new r(f,h,k,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,v.$Ak)(u)!==v.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(b=>b.append(d))},appendLine(d){u(),i.then(b=>b.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(b=>b.replace(d))},show(d,b){u(),i.then(f=>f.show(d,b))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},b=u.add(new n.$Sd);function f(k){i=k,b.fire(k)}return s.then(k=>{u.add(k),k.logLevel!==i&&f(k.logLevel),u.add(k.onDidChangeLogLevel(F=>f(F)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(k,...F){d(),s.then(p=>p.trace(k,...F))},debug(k,...F){d(),s.then(p=>p.debug(k,...F))},info(k,...F){d(),s.then(p=>p.info(k,...F))},warn(k,...F){d(),s.then(p=>p.warn(k,...F))},error(k,...F){d(),s.then(p=>p.error(k,...F))},dispose(){u.dispose()}}}};e.$Bgc=a,e.$Bgc=a=Ge([Ke(0,I.$OM),Ke(1,w.$5M),Ke(2,g.$ofc),Ke(3,R.$1ec),Ke(4,A.$jj),Ke(5,A.$ij)],a),e.$Cgc=(0,T.$1h)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=void 0,e.$Fm=(0,E.$1h)("remoteAgentService"),e.$Gm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let L=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await I.getRoundTripTime();if(g===void 0)return;L=Math.min(L,g/2),await(0,T.$2g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Ae([1,0,170,54,30,47,41,6,5,113,21,26]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=void 0,e.$xH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$yH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$zH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$AH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const $=new l;I.$sn.add(e.$AH.ConfigurationMigration,$);let v=class extends m.$Sc{constructor(t,r){super(),this.a=t,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const r of this.b.getWorkspace().folders)await this.f(r,t)}async f(t,r){await Promise.all([r.map(a=>this.g(a,t?.uri))])}async g(t,r){const a=this.a.inspect(t.key,{resource:r}),c=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const b=await this.h(t,{resource:r,overrideIdentifier:d},h);for(const f of b??[]){let k=s.find(([[F,p]])=>F===f[0]&&(0,S.$kn)(p.value,f[1].value));k||s.push(k=[f,[]]),k[1].push(d)}}const u=await this.h(t,{resource:r},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,b],f])=>this.a.updateValue(d,b.value,{resource:r,overrideIdentifiers:f},i)))}}async h(t,r,a,c){const h=(c??this.a.inspect(t.key,r))[a];if(h===void 0)return;const i=u=>this.a.inspect(u,r)[a],s=await t.migrateFn(h,i);return Array.isArray(s)?s:[[t.key,s]]}};e.$BH=v,e.$BH=v=Ge([Ke(0,A.$ui),Ke(1,L.$0h)],v);let n=class extends m.$Sc{constructor(t){super(),(async()=>{if(!R.$i&&(await t.getEnvironment())?.os!==1)return;I.$sn.as(T.$xn.Configuration).registerConfiguration({...e.$zH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$CH=n,e.$CH=n=Ge([Ke(0,w.$Fm)],n)}),define(Pe[280],Ae([1,0,34,13,19,25,178,279,54,4,30]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cb=e.$2cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$1cb=e.$Zcb=void 0,e.$Zcb=(0,w.$1h)("editorResolverService"),e.$1cb="workbench.editorAssociations";const S=R.$sn.as(g.$xn.Configuration),l={...m.$yH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var $;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})($||(e.RegisteredEditorPriority=$={}));var v;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function n(t){switch(t){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$2cb=n;function o(t,r){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${r.scheme}:${r.path}`:(0,L.$zg)(r);return E.$Gj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$3cb=o}),define(Pe[281],Ae([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(me,e,E,T,I,L,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.$mK=void 0,e.$mK=(0,g.$1h)("pathService");let v=$=class{constructor(o,t,r,a){this.d=o,this.e=t,this.f=r,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,r){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,r)}h(o,t,r){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$1f)(r??(0,A.$zg)(o),t===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,w.$jK)(t.getWorkspace());if(r)return r;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$nK=v,e.$nK=v=$=Ge([Ke(1,l.$Fm),Ke(2,S.$8J),Ke(3,R.$0h)],v)}),define(Pe[114],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$2I=e.$1I=void 0;class E{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new E(0,0)}with(A){return new E(0,0)}}e.$1I=E;class T{constructor(A,m,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(A,m),this.end=new E(g,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$2I=T;var I;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[44],Ae([1,0,18,34,26,46,12,4,19,11,114,14]),function(me,e,E,T,I,L,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.SearchErrorCode=e.$eJ=e.$dJ=e.SearchSortOrder=e.ViewMode=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.SearchCompletionExitCode=e.$$I=e.$0I=e.$9I=e.QueryType=e.SearchProviderType=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$3I="workbench.view.search",e.$4I="workbench.panel.search",e.$5I="workbench.view.search",e.$6I="search-result",e.$7I="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",v=(l.length+$.length+5)*2;e.$8I=(0,m.$1h)("searchService");var n;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(n||(e.SearchProviderType=n={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(o||(e.QueryType=o={}));function t(de){return!!de.preview}e.$9I=t;function r(de){return!!de.resource}e.$0I=r;function a(de){return!!de.message}e.$$I=a;var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(he){this.resource=he,this.results=[]}}e.$_I=h;class i{constructor(he,te,Se,oe){this.ranges=te,this.webviewIndex=oe;const Y=Array.isArray(te)?te:[te];if(Se&&Se.matchLines===1&&s(Y)){he=(0,A.$wf)(he,Se.matchLines);let V="",ne=0,Ie=0;const Le=Math.floor(Se.charsPerLine/5),Ce=[];for(const ce of Y){const ie=Math.max(ce.startColumn-Le,0),Q=ce.startColumn+Se.charsPerLine;if(ie>Ie+Le+v){const ee=l+(ie-Ie)+$;V+=ee+he.slice(ie,Q),ne+=ie-(Ie+ee.length)}else V+=he.slice(Ie,Q);Ce.push(new d(0,ce.startColumn-ne,ce.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:he,matches:(0,E.$2b)(te,ne=>new u(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$aJ=i;function s(de){const he=de[0].startLineNumber;for(const te of de)if(te.startLineNumber!==he||te.endLineNumber!==he)return!1;return!0}class u{constructor(he,te,Se,oe){this.startLineNumber=he,this.startColumn=te,this.endLineNumber=Se,this.endColumn=oe}}e.$bJ=u;class d extends u{constructor(he,te,Se){super(he,te,he,Se)}}e.$cJ=d;var b;(function(de){de.List="list",de.Tree="tree"})(b||(e.ViewMode=b={}));var f;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function k(de,he=!0){const te=de&&de.files&&de.files.exclude,Se=he&&de&&de.search&&de.search.exclude;if(!te&&!Se)return;if(!te||!Se)return te||Se;let oe=Object.create(null);return oe=I.$jn(oe,I.$gn(te)),oe=I.$jn(oe,I.$gn(Se),!0),oe}e.$dJ=k;function F(de,he){return de.excludePattern&&T.$Gj(de.excludePattern,he)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&T.$Gj(de.includePattern,he)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(te=>{const Se=te.folder.fsPath;if(L.$3f(he,Se)){const oe=g.$lc(Se,he);return!te.includePattern||!!T.$Gj(te.includePattern,oe)}else return!1}):!1:!0}e.$eJ=F;var p;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class y extends Error{constructor(he,te){super(he),this.code=te}}e.$fJ=y;function D(de){const he=de.message;if((0,w.$4)(de))return new y(he,p.canceled);try{const te=JSON.parse(he);return new y(te.message,te.code)}catch{return new y(he,p.other)}}e.$gJ=D;function O(de){const he={message:de.message,code:de.code};return new Error(JSON.stringify(he))}e.$hJ=O;function K(de){return de.type==="error"?!0:de.type==="success"}e.$iJ=K;function U(de){return de.type==="success"}e.$jJ=U;function M(de){return!!de.path}e.$kJ=M;function B(de,he){const te=de.searchPath?de.searchPath:de.relativePath;return(0,A.$tf)(te,he)}e.$lJ=B;class C{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mJ=C;function P(de,he){const te={...de||{},...he||{}};return Object.keys(te).filter(Se=>{const oe=te[Se];return typeof oe=="boolean"&&oe})}e.$nJ=P;class X{constructor(he,te){this.c=null,this.a={...he.excludePattern||{},...te.excludePattern||{}},this.b=T.$Hj(this.a);let Se=he.includePattern;te.includePattern&&(Se?Se={...Se,...te.includePattern}:Se=te.includePattern),Se&&(this.c=T.$Hj(Se))}matchesExcludesSync(he,te,Se){return!!(this.b&&this.b(he,te,Se))}includedInQuerySync(he,te,Se){return!(this.b&&this.b(he,te,Se)||this.c&&!this.c(he,te,Se))}includedInQuery(he,te,Se){const oe=this.b(he,te,Se),Y=()=>this.c?!!this.c(he,te,Se):!0;return(0,S.$Ng)(oe)?oe.then(V=>V?!1:Y()):Y()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$oJ=X;function ae(de){for(const he in de)if(typeof de[he]!="boolean")return!0;return!1}function ge(de){if(!de)return;let he;return te=>(he||(he=(de()||Promise.resolve([])).then(Se=>Se?ke(Se):{})),he.then(Se=>!!Se[te]))}e.$pJ=ge;function ve(de){if(!de)return;let he;return te=>{if(!he){const Se=de();he=Se?ke(Se):{}}return!!he[te]}}e.$qJ=ve;function ke(de){const he={};for(const te of de)he[te]=!0;return he}}),define(Pe[36],Ae([1,0,18,14,20,5,6,50,13,122,25,12,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=void 0;function f(U,M,B){return new R.$rg(C=>y(C,B)).isEqual(U,M)}function k(U,M,B){return f(U.uri,M.uri,B)?0:(0,S.$Ze)(U.uri.toString(),M.uri.toString())}function F(U,M,B){return U.index!==M.index?U.index<M.index?-1:1:f(U.uri,M.uri,B)?(0,S.$Ze)(U.name,M.name):(0,S.$Ze)(U.uri.toString(),M.uri.toString())}function p(U,M,B,C){const P=U.slice(0).sort((ae,ge)=>B(ae,ge,C)),X=M.slice(0).sort((ae,ge)=>B(ae,ge,C));return(0,E.$Eb)(P,X,(ae,ge)=>B(ae,ge,C))}function y(U,M){const B=M.getCapabilities(U.scheme);return!(B&&B&1024)}class D extends t.$hi{static toExtHostWorkspace(M,B,C,P){if(!M)return{workspace:null,added:[],removed:[]};const{id:X,name:ae,folders:ge,configuration:ve,transient:ke,isUntitled:de}=M,he=[],te=B;B?ge.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Le=D.o(C||B,Ie,P);Le?(Le.name=V.name,Le.index=V.index,he.push(Le)):he.push({uri:Ie,name:V.name,index:ne})}):he.push(...ge.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),he.sort((V,ne)=>V.index<ne.index?-1:1);const Se=new D(X,ae,he,!!ke,ve?l.URI.revive(ve):null,!!de,V=>y(V,P)),{added:oe,removed:Y}=p(te?te.workspaceFolders:[],Se.workspaceFolders,k,P);return{workspace:Se,added:oe,removed:Y}}static o(M,B,C){for(let P=0;P<M.folders.length;P++){const X=M.workspaceFolders[P];if(f(X.uri,B,C))return X}}constructor(M,B,C,P,X,ae,ge){super(M,C.map(ve=>new t.$ii(ve)),P,X,ge),this.t=B,this.u=ae,this.q=[],this.s=m.$7h.forUris(ge),C.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,B){return B&&this.s.get(M)&&(M=(0,R.$Bg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let O=class{constructor(M,B,C,P,X){this.c=new L.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Ud,this.B=new Map,this.h=P,this.s=C,this.t=X,this.j=new w.$3l,this.k=new T.$Zg,this.o=M.getProxy(d.$KK.MainThreadWorkspace),this.q=M.getProxy(d.$KK.MainThreadMessageService);const ae=B.workspace;this.l=ae?new D(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,ge=>y(ge,C)):void 0}$initializeWorkspace(M,B){this.v=B,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,R.$zg)((0,R.$Bg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,C,...P){const X=[];if(Array.isArray(P)&&P.forEach(de=>{l.URI.isUri(de.uri)&&!X.some(he=>f(he.uri,de.uri,this.s))&&X.push({uri:de.uri,name:de.name||(0,R.$yg)(de.uri)})}),this.n||[B,C].some(de=>typeof de!="number"||de<0)||C===0&&X.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(B+C>ae.length)return!1;const ge=ae.slice(0);ge.splice(B,C,...X.map(de=>({uri:de.uri,name:de.name||(0,R.$yg)(de.uri),index:void 0})));for(let de=0;de<ge.length;de++){const he=ge[de];if(ge.some((te,Se)=>Se!==de&&f(he.uri,te.uri,this.s)))return!1}ge.forEach((de,he)=>de.index=he);const{added:ve,removed:ke}=p(ae,ge,F,this.s);if(ve.length===0&&ke.length===0)return!1;if(this.o){const de=M.displayName||M.name;this.o.$updateWorkspaceFolders(de,B,C,X).then(void 0,he=>{this.n=void 0;const te={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(o.Severity.Error,(0,$.localize)(0,null,de,he.toString()),te,[])})}return this.y(ge),!0}getWorkspaceFolder(M,B){if(this.x)return this.x.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let C,P="";if(typeof M=="string"?(C=l.URI.file(M),P=M):typeof M<"u"&&(C=M,P=M.fsPath),!C)return P;const X=this.getWorkspaceFolder(C,!0);if(!X)return P;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let ae=(0,R.$Eg)(X.uri,C);return B&&X.name&&(ae=`${X.name}/${ae}`),ae}y(M){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:C,removed:P}=D.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:P}))}findFiles(M,B,C,P,X=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${P.value}, entryPoint: findFiles`);let ae;if(B===null?ae=!1:B&&(typeof B=="string"?ae=B:ae=B.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:ge,folder:ve}=K(h.GlobPattern.from(M));return this.o.$startFileSearch(ge??null,ve??null,ae??null,C??null,X).then(ke=>Array.isArray(ke)?ke.map(de=>l.URI.revive(de)):[])}async findTextInFiles(M,B,C,P,X=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${P.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),ge=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ve,folder:ke}=K(h.GlobPattern.from(B.include)),de=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,he={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ge,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ve,excludePattern:de},te=!1;if(this.u[ae]=Se=>{if(te)return;const oe=l.URI.revive(Se.resource);Se.results.forEach(Y=>{const V=(0,b.$xh)(Y);(0,u.$9I)(V)?C({uri:oe,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ne=>new i.$OK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(V.ranges,ne=>new i.$OK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:oe,text:V.text,lineNumber:V.lineNumber})})},X.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(M,ke??null,he,ae,X);return delete this.u[ae],Se||{}}catch(Se){throw delete this.u[ae],Se}}$handleTextSearchResult(M,B){this.u[B]?.(M)}async save(M){const B=await this.o.$save(M,{saveAs:!1});return l.URI.revive(B)}async saveAs(M){const B=await this.o.$save(M,{saveAs:!0});return l.URI.revive(B)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,B){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,B);const C=this.t.transformOutgoingScheme(M),P=this.z++;return this.o.$registerEditSessionIdentityProvider(P,C),(0,A.$Qc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(P)})}async $getEditSessionIdentifier(M,B){this.h.info("Getting edit session identifier for workspaceFolder",M);const C=await this.resolveWorkspaceFolder(l.URI.revive(M));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const P=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!P),!P)return;const X=await P.provideEditSessionIdentity(C,B);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(M,B,C,P){this.h.info("Getting edit session identifier for workspaceFolder",M);const X=await this.resolveWorkspaceFolder(l.URI.revive(M));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const ae=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!ae),!ae)return;const ge=await ae.provideEditSessionIdentityMatch?.(B,C,P);if(this.h.info("Provider returned edit session identifier match result: ",ge),!!ge)return ge}getOnWillCreateEditSessionIdentityEvent(M){return(B,C,P)=>{const X=function(ge){B.call(C,ge)};return X.extension=M,this.A.event(X,void 0,P)}}async $onWillCreateEditSessionIdentity(M,B,C){const P=await this.resolveWorkspaceFolder(l.URI.revive(M));if(P===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:P},B,async(X,ae)=>{const ge=Date.now();await Promise.resolve(X),Date.now()-ge>C&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(M,B){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,B);const C=this.t.transformOutgoingScheme(M),P=this.z++;return this.o.$registerCanonicalUriProvider(P,C),(0,A.$Qc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(P)})}async provideCanonicalUri(M,B,C){const P=this.B.get(M.scheme);if(!P)return;const X=await P.provideCanonicalUri?.(l.URI.revive(M),B,C);if(X)return X}async $provideCanonicalUri(M,B,C){return this.provideCanonicalUri(l.URI.revive(M),{targetScheme:B},C)}};e.$ifc=O,e.$ifc=O=Ge([Ke(0,c.$OM),Ke(1,a.$5M),Ke(2,r.$1ec),Ke(3,n.$ij),Ke(4,s.$gfc)],O),e.$jfc=(0,v.$1h)("IExtHostWorkspace");function K(U){let M,B;return U&&(typeof U=="string"?M=U:(M=U.pattern,B=l.URI.revive(U.baseUri))),{includePattern:M,folder:B}}}),define(Pe[37],Ae([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=void 0;function n(s,u){if(u){const d=u.split(".");let b=s;for(let f=0;b&&f<d.length;f++)b=b[d[f]];return b}}function o(s){return s instanceof v.URI}function t(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,b){this.a=u.getProxy(L.$KK.MainThreadConfiguration),this.c=d,this.b=b,this.d=new R.$Zg,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(u,d))}};e.$kfc=h,e.$kfc=h=Ge([Ke(0,l.$OM),Ke(1,I.$jfc),Ke(2,$.$ij)],h);class i{constructor(u,d,b,f){this.a=new T.$Sd,this.b=u,this.f=f,this.c=d,this.e=m.$Qn.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Qn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,b))}getConfiguration(u,d,b){const f=c(d)||{},k=this.g(u?n(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,b?.identifier);function F(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(y){return typeof n(k,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,b?.identifier);let O=n(k,y);if(typeof O>"u")O=D;else{let K;const U=(M,B)=>{if((0,w.$Ff)(M)){let C;const P=()=>{K=K||(0,E.$gn)(k),C=C||n(K,B)};return new Proxy(M,{get:(X,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return P(),()=>C;if(K)return C=C||n(K,B),C[ae];const ge=X[ae];return typeof ae=="string"?U(ge,`${B}.${ae}`):ge},set:(X,ae,ge)=>(P(),C&&(C[ae]=ge),!0),deleteProperty:(X,ae)=>(P(),C&&delete C[ae],!0),defineProperty:(X,ae,ge)=>(P(),C&&Object.defineProperty(C,ae,ge),!0)})}return Array.isArray(M)?(0,E.$gn)(M):M};O=U(O,y)}return O},update:(y,D,O,K)=>{y=u?`${u}.${y}`:y;const U=F(O);return D!==void 0?this.b.$updateConfigurationOption(U,y,D,f,K):this.b.$removeConfigurationOption(U,y,f,K)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$gn)(D.policy?.value??D.default?.value),globalValue:(0,E.$gn)(D.user?.value??D.application?.value),workspaceValue:(0,E.$gn)(D.workspace?.value),workspaceFolderValue:(0,E.$gn)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$gn)(D.default?.override),globalLanguageValue:(0,E.$gn)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$gn)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$gn)(D.workspaceFolder?.override),languageIds:(0,E.$gn)(D.overrideIdentifiers)}}};return typeof k=="object"&&(0,E.$jn)(p,k,!1),Object.freeze(p)}g(u){const d=b=>(0,w.$Ff)(b)?new Proxy(b,{get:(f,k)=>d(f[k]),set:(f,k,F)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(f,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(f,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return d(u)}h(u,d,b){const f=g.$Hn.test(u)?4:this.d.get(u),k=b?`[${b.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const b=new m.$Sn(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,k)=>b.affectsConfiguration(f,c(k))})}k(u){return u.reduce((d,b)=>(d.set(b[0],b[1]),d),new Map)}}e.$lfc=i,e.$mfc=(0,S.$1h)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,229,11]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=e.$Ngc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(U){function M(C){if(C!=null)return C}U.from=M;function B(C){if(C!=null)return C}U.to=B})(h||(h={}));var i;(function(U){function M(C){if(C!=null)return C}U.from=M;function B(C){if(C!=null)return C}U.to=B})(i||(i={}));var s;(function(U){function M(C){if(C!=null)return C}U.from=M;function B(C){if(C!=null)return C}U.to=B})(s||(s={}));var u;(function(U){function M(P){if(P){const X=P;return X&&!!X.process}else return!1}U.is=M;function B(P){if(P==null)return;const X={process:P.process,args:P.args};return P.options&&(X.options=s.from(P.options)),X}U.from=B;function C(P){if(P!=null)return new A.$vL(P.process,P.args,P.options)}U.to=C})(u||(u={}));var d;(function(U){function M(C){if(C!=null)return C}U.from=M;function B(C){if(C!=null)return C}U.to=B})(d||(d={}));var b;(function(U){function M(P){if(P){const X=P;return X&&(!!X.commandLine||!!X.command)}else return!1}U.is=M;function B(P){if(P==null)return;const X={};return P.commandLine!==void 0?X.commandLine=P.commandLine:(X.command=P.command,X.args=P.args),P.options&&(X.options=d.from(P.options)),X}U.from=B;function C(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new A.$wL(P.commandLine,P.options):new A.$wL(P.command,P.args?P.args:[],P.options)}U.to=C})(b||(b={}));var f;(function(U){function M(P){if(P){const X=P;return X&&X.customExecution==="customExecution"}else return!1}U.is=M;function B(P){return{customExecution:"customExecution"}}U.from=B;function C(P,X){return X.get(P)}U.to=C})(f||(e.CustomExecutionDTO=f={}));var k;(function(U){function M(B,C){let P;return B.scope!==void 0&&typeof B.scope!="number"?P=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&C&&C.workspaceFile?P=C.workspaceFile:P=a.$eG),{id:B._id,workspaceFolder:P}}U.from=M})(k||(e.TaskHandleDTO=k={}));var F;(function(U){function M(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}U.from=M})(F||(F={}));var p;(function(U){function M(P,X){if(P==null)return[];const ae=[];for(const ge of P){const ve=B(ge,X);ve&&ae.push(ve)}return ae}U.fromMany=M;function B(P,X){if(P==null)return;let ae;P.execution instanceof A.$vL?ae=u.from(P.execution):P.execution instanceof A.$wL?ae=b.from(P.execution):P.execution&&P.execution instanceof A.$xL&&(ae=f.from(P.execution));const ge=h.from(P.definition);let ve;return P.scope?typeof P.scope=="number"?ve=P.scope:ve=P.scope.uri:ve=A.TaskScope.Workspace,!ge||!ve?void 0:{_id:P._id,definition:ge,name:P.name,source:{extensionId:X.identifier.value,label:P.source,scope:ve},execution:ae,isBackground:P.isBackground,group:F.from(P.group),presentationOptions:i.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}U.from=B;async function C(P,X,ae){if(P==null)return;let ge;u.is(P.execution)?ge=u.to(P.execution):b.is(P.execution)?ge=b.to(P.execution):f.is(P.execution)&&(ge=f.to(P._id,ae));const ve=h.to(P.definition);let ke;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?ke=P.source.scope:ke=await X.resolveWorkspaceFolder(E.URI.revive(P.source.scope)):ke=A.TaskScope.Workspace),!ve||!ke)return;const de=new A.$yL(ve,ke,P.name,P.source.label,ge,P.problemMatchers);return P.isBackground!==void 0&&(de.isBackground=P.isBackground),P.group!==void 0&&(de.group=A.$uL.from(P.group._id),de.group&&P.group.isDefault&&(de.group=new A.$uL(de.group.id,de.group.label),P.group.isDefault===!0&&(de.group.isDefault=P.group.isDefault))),P.presentationOptions&&(de.presentationOptions=i.to(P.presentationOptions)),P._id&&(de._id=P._id),P.detail&&(de.detail=P.detail),de}U.to=C})(p||(e.TaskDTO=p={}));var y;(function(U){function M(C){return C}U.from=M;function B(C){if(C)return Object.assign(Object.create(null),C)}U.to=B})(y||(y={}));class D{#e;constructor(M,B,C){this._id=B,this.a=C,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let O=class{constructor(M,B,C,P,X,ae,ge,ve){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.t=new I.$Sd,this.a=M.getProxy(L.$KK.MainThreadTask),this.b=C,this.c=P,this.d=X,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,B,C){if(!C)return new A.$MK(()=>{});const P=this.w();return this.j.set(P,{type:B,provider:C,extension:M}),this.a.$registerTaskProvider(P,B),new A.$MK(()=>{this.j.delete(P),this.a.$unregisterTaskProvider(P)})}registerTaskSystem(M,B){this.a.$registerTaskSystem(M,B)}fetchTasks(M){return this.a.$fetchTasks(y.from(M)).then(async B=>{const C=[];for(const P of B){const X=await p.to(P,this.b,this.m);X&&C.push(X)}return C})}get taskExecutions(){const M=[];return this.k.forEach(B=>M.push(B)),M}terminateTask(M){if(!(M instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,B,C){const P=this.m.get(M.id);P&&(this.o.set(M.id,P),this.e.attachPtyToTerminal(B,await P.callback(C))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const B=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const B=await this.y(M.id);this.s.fire({execution:B,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const B=await this.y(M.id);this.t.fire({execution:B,exitCode:M.exitCode})}$provideTasks(M,B){const C=this.j.get(M);if(!C)return Promise.reject(new Error("no handler found"));const P=[],X=(0,T.$Tg)(()=>C.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.u(B,P,C,ae));return new Promise(ae=>{X.then(ge=>{Promise.all(P).then(()=>{ae(ge)})})})}async $resolveTask(M,B){const C=this.j.get(M);if(!C)return Promise.reject(new Error("no handler found"));if(B.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${C.type}].`);const P=await p.to(B,this.b,this.m);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const X=await C.provider.resolveTask(P,R.CancellationToken.None);if(!X)return;this.z(X,C);const ae=p.from(X,C.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.x(ae,X,!0),await this.v(ae)}w(){return this.h++}async x(M,B,C){const P=await this.a.$createTaskId(M);!C&&!this.m.has(P)&&(this.n.add(P),this.o.set(P,B.execution)),this.m.set(P,B.execution)}async y(M,B){if(typeof M=="string"){const X=this.l.get(M);if(!X)throw new c.$bb("Unexpected: The specified task is missing an execution");return X}const C=this.l.get(M.id);if(C)return C;const P=new Promise((X,ae)=>{function ge(ve,ke,de){de?X(new D(ve,ke.id,de)):ae("Unexpected: Task does not exist.")}B?ge(this,M,B):p.to(M.task,this.b,this.m).then(ve=>ge(this,M,ve))});return this.l.set(M.id,P),P.then(X=>(this.k.set(M.id,X),X),X=>Promise.reject(X))}z(M,B){M._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const C=this.n.values();let P=C.next();for(;!P.done;)!this.o.has(P.value)&&this.p!==P.value&&(this.m.delete(P.value),this.n.delete(P.value)),P=C.next()}};e.$Ngc=O,e.$Ngc=O=Ge([Ke(0,l.$OM),Ke(1,$.$5M),Ke(2,m.$jfc),Ke(3,g.$ZM),Ke(4,w.$mfc),Ke(5,S.$Kfc),Ke(6,t.$ij),Ke(7,r.$4ec)],O);let K=class extends O{constructor(M,B,C,P,X,ae,ge,ve){super(M,B,C,P,X,ae,ge,ve),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(M,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const C=p.from(B,M);if(C===void 0)throw new Error("Task is not valid");if(f.is(C.execution))await this.x(C,B,!1);else throw new c.$_;const P=await this.y(await this.a.$getTaskExecution(C),B);return this.a.$executeTask(C).catch(X=>{throw new Error(X)}),P}u(M,B,C,P){const X=[];if(P)for(const ae of P){if(this.z(ae,C),!ae.definition||!M[ae.definition.type]){const ve=ae.source?ae.source:"No task source";this.f.warn(`The task [${ve}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=p.from(ae,C.extension);ge&&f.is(ge.execution)?(X.push(ge),B.push(this.x(ge,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:C.extension}}async v(M){if(f.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,B,C){}};e.$Ogc=K,e.$Ogc=K=Ge([Ke(0,l.$OM),Ke(1,$.$5M),Ke(2,m.$jfc),Ke(3,g.$ZM),Ke(4,w.$mfc),Ke(5,S.$Kfc),Ke(6,t.$ij),Ke(7,r.$4ec)],K),e.$Pgc=(0,v.$1h)("IExtHostTask")}),define(Pe[282],Ae([1,0,44,29]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.$wJ=void 0;function I(A){return"cellResults"in A}e.$wJ=I,e.$xJ="rawCell#";function L(A,m){let g=-1;const w=[];let R=[];return A.forEach(l=>{l.range.startLineNumber!==g&&R.length>0&&(w.push([...R]),R=[]),R.push(l),g=l.range.endLineNumber}),R.length>0&&w.push([...R]),w.map(l=>{const $=[],v=l[0].range.startLineNumber,n=l[l.length-1].range.endLineNumber;for(let o=v;o<=n;o++)$.push(m.getLineContent(o));return new E.$aJ($.join(`
`)+`
`,l.map(o=>new T.$Fs(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$yJ=L}),define(Pe[283],Ae([1,0,162,24,5,6,28,12,16,2,42,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,k,F,p,y,D){this.q=F,this.r=p,this.s=y,this.t=D,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new I.$Sd({onListenerError:a.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd({onListenerError:a.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd({onListenerError:a.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd({onListenerError:a.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Wec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(l.$KK.MainThreadNotebook),this.c=f.getProxy(l.$KK.MainThreadNotebookDocuments),this.d=f.getProxy(l.$KK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===13){const K=O.notebookEditor?.notebookUri,U=O.cell.handle,B=this.g.get(K)?.getCell(U);if(B)return B.apiCell}if(O&&O.$mid===14){const K=O.uri,U=this.g.get(K);if(U)return U.apiNotebook}return O}}),d.B(k)}getEditorById(f){const k=this.h.get(f);if(!k)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(f){for(const[k,F]of this.h)if(F.apiEditor===f)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,k){const F=this.g.get(f);if(!F&&!k)throw new Error(`NO notebook document for '${f}'`);return F}static u(f,k){if(!k)return;const F=k.filenamePattern.map(p=>v.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(k.filenamePattern&&!F){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:k.displayName,filenamePattern:F,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,k,F){const p=d.a++,y=typeof F.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(p,F),this.b.$registerNotebookCellStatusBarItemProvider(p,y,k);let D;return y!==void 0&&(D=F.onDidChangeCellStatusBarItems(O=>this.b.$emitCellStatusBarEvent(y))),new n.$MK(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,y),D?.dispose()})}async createNotebookDocument(f){const k=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return w.URI.revive(k)}async openNotebookDocument(f){const k=this.g.get(f);if(k)return k.apiNotebook;const F=await this.c.$tryOpenNotebook(f),p=this.g.get(w.URI.revive(F));return(0,g.$Of)(p?.apiNotebook)}async showNotebookDocument(f,k){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let F;typeof k=="object"?F={position:v.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(v.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:F={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,F),y=p&&this.h.get(p)?.apiEditor;if(y)return y;throw p?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,k,F,p){const y=this.f.get(f),D=w.URI.revive(k),O=this.g.get(D);if(!O||!y)return;const K=O.getCellFromIndex(F);if(!K)return;const U=await y.provideCellStatusBarItems(K.apiCell,p);if(!U)return;const M=new L.$Rc,B=this.p.add([M]),P=(Array.isArray(U)?U:[U]).map(X=>v.NotebookStatusBarItem.from(X,this.i,M));return{cacheId:B,items:P}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,k,F,p,y){if((0,m.$Ge)(k))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:k,serializer:F,options:p}),this.b.$registerNotebookSerializer(D,{id:f.identifier,location:f.extensionLocation},k,v.NotebookDocumentContentOptions.from(p),d.u(f,y)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(f,k,F){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.deserializeNotebook(k.buffer,F);return new o.$Dv(v.NotebookData.from(y))}async $notebookToData(f,k,F){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.serializeNotebook(v.NotebookData.to(k.value),F);return T.$ge.wrap(y)}async $saveNotebook(f,k,F,p,y){const D=w.URI.revive(k),O=this.x.get(f);if(!O)throw new Error("NO serializer found");const K=this.g.get(D);if(!K)throw new Error("Document NOT found");if(K.versionId!==F)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new R.$Fk((0,E.localize)(0,null,this.z(D)),6);await this.y(D,p);const U={metadata:(0,c.$on)(K.apiNotebook.metadata,X=>!(O.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of K.apiNotebook.getCells()){const ae=new n.$_L(X.kind,X.document.getText(),X.document.languageId,X.mime,O.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);ae.metadata=(0,c.$on)(X.metadata,ge=>!(O.options?.transientCellMetadata??{})[ge]),U.cells.push(ae)}const M=await O.serializer.serializeNotebook(U,y);await this.s.value.writeFile(D,M);const B=this.s.getFileSystemProviderExtUri(D.scheme),C=await this.s.value.stat(D);return{name:B.basename(D),isFile:(C.type&R.FileType.File)!==0,isDirectory:(C.type&R.FileType.Directory)!==0,isSymbolicLink:(C.type&R.FileType.SymbolicLink)!==0,mtime:C.mtime,ctime:C.ctime,size:C.size,readonly:!!((C.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((C.permissions??0)&R.FilePermission.Locked),etag:R.$Qk({mtime:C.mtime,size:C.size}),children:void 0}}async $searchInNotebooks(f,k,F,p,y){const D=this.x.get(f)?.serializer;if(!D)return{limitHit:!1,results:[]};const O=new A.$Bc;await(async(C,P,X)=>{await Promise.all(C.map(async ae=>await Promise.all(ae.filenamePatterns.map(ge=>{const ve={...X,type:1,filePattern:ge};return this.t.doInternalFileSearchWithCustomCallback(ve,P,ke=>{ke.forEach(de=>{O.has(de)||p.some(te=>ae.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(Se=>(0,u.$3cb)(Se,de)))||O.add(de)})})}))))})(F,y,k);const U=new A.$Ac;let M=!1;const B=Array.from(O).map(async C=>{const P=[];try{if(y.isCancellationRequested)return;if(k.maxResults&&[...U.values()].reduce((ve,ke)=>ve+ke.cellResults.length,0)>k.maxResults){M=!0;return}const X=[],ae=this.g.get(C);if(ae)ae.apiNotebook.getCells().forEach(ke=>X.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(de=>de.items.map(he=>he.data.toString()))}));else{const ve=await this.s.value.readFile(C),ke=T.$ge.fromString(ve.toString()),de=await D.deserializeNotebook(ke.buffer,y);if(y.isCancellationRequested)return;v.NotebookData.from(de).cells.forEach(te=>X.push({input:te.source,outputs:te.outputs.flatMap(Se=>Se.items.map(oe=>oe.valueBytes.toString()))}))}if(y.isCancellationRequested)return;X.forEach((ve,ke)=>{const de=k.contentPattern.pattern,he=new i.$XPb(ve.input,void 0,ve.outputs),te=he.findInInputs(de),Se=he.findInOutputs(de),oe=Se.flatMap(Y=>(0,s.$yJ)(Y.matches,Y.textBuffer)).map((Y,V)=>(Y.webviewIndex=V,Y));if(te.length>0||Se.length>0){const Y={index:ke,contentResults:(0,s.$yJ)(te,he.inputTextBuffer),webviewResults:oe};P.push(Y)}});const ge={resource:C,cellResults:P};U.set(C,ge);return}catch{return}});return await Promise.all(B),{limitHit:M,results:[...U.values()]}}async y(f,k){const F=await this.s.value.stat(f);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==R.$Pk&&typeof F.mtime=="number"&&typeof F.size=="number"&&k.mtime<F.mtime&&k.etag!==R.$Qk({mtime:k.mtime,size:F.size}))throw new R.$Fk((0,E.localize)(1,null),3,k)}z(f){return f.scheme===h.Schemas.file?f.fsPath:f.toString()}A(f,k,F){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const p=new r.$ggc(k,this.d,f,F.visibleRanges.map(v.NotebookRange.to),F.selections.map(v.NotebookRange.to),typeof F.viewColumn=="number"?v.ViewColumn.to(F.viewColumn):void 0);this.h.set(k,p)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const F of f.value.removedDocuments){const p=w.URI.revive(F),y=this.g.get(p);y&&(y.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(y.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===p.toString()&&this.h.delete(D.id)}if(f.value.addedDocuments){const F=[];for(const p of f.value.addedDocuments){const y=w.URI.revive(p.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const D=new t.$fgc(this.c,this.q,this.r,y,p);F.push(...p.cells.map(O=>t.$egc.asModelAddData(D.apiNotebook,O))),this.g.get(y)?.dispose(),this.g.set(y,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this.m.fire(D.apiNotebook)}}if(f.value.addedEditors)for(const F of f.value.addedEditors){if(this.h.has(F.id))return;const p=w.URI.revive(F.documentUri),y=this.g.get(p);y&&this.A(y,F.id,F)}const k=[];if(f.value.removedEditors)for(const F of f.value.removedEditors){const p=this.h.get(F);p&&(this.h.delete(F),this.k?.id===p.id&&(this.k=void 0),k.push(p))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const F=new Set;this.l.forEach(p=>F.add(p.id));for(const p of this.h.values()){const y=F.has(p.id);p._acceptVisibility(y)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const k=$.$aN.String.with("notebookType","A notebook type"),F=new $.$cN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new $.$aN("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$ge.wrap(y))],new $.$bN("Notebook Data",y=>v.NotebookData.to(y.value))),p=new $.$cN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new $.$aN("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new o.$Dv(v.NotebookData.from(y)))],new $.$bN("Bytes",y=>y.buffer));f.registerApiCommand(F),f.registerApiCommand(p)}}e.$pgc=d}),define(Pe[284],Ae([1,0,19,20,40,34,25,60,44]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class w{constructor(l,$,v){this.k=l,this.l=$,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Hj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Hj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((v,n)=>{const o=t=>{this.f++,l(t)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const r=t.toString(),a=E.$nc(r);this.j&&this.j(r,a)||this.v(o,{base:t,basename:a})}),Promise.all($.map(t=>this.p(t,o))).then(t=>{v({limitHit:this.e,stats:t[0]||void 0})},t=>{n(new Error((0,I.$Li)(t)))})})}async p(l,$){const v=new T.$3d,n=this.q(l),o=this.r(),t=new g.$oJ(this.k,l),r=!t.hasSiblingExcludeClauses();let a;try{this.h.add(v),a=m.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,v.token),h=a.elapsed(),i=m.$Od.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(r){const d=E.$nc(s.path);this.v($,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,$)}),this.g&&!this.e)?null:(this.u(o,t,$),{providerTime:h,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const $=(0,g.$nJ)(this.k.includePattern,l.includePattern),v=(0,g.$nJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,v,n){if(v===this.a){const t=E.$nc(this.a);this.v(n,{base:$,relativePath:this.a,basename:t})}function o(t){const r=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:$,relativePath:t,basename:r})}o(v)}u({rootEntries:l,pathToEntries:$},v,n){const o=this,t=this.a;function r(a){const c=(0,g.$qJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(v.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const b=$[u];if(b)r(b);else{if(u===t)continue;o.v(n,s)}if(o.e)break}}r(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,v,n){const o=this.c(l.cacheKey),t=new w(l,$,o&&o.token);let r=0;const a=c=>{r+=c.length,v(c.map(h=>this.d(h)))};return this.e(t,R.a,a,n).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:A.$Cg(l.base,l.relativePath)}:{resource:l.base}}e(l,$,v,n){const o=n.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(r.push(a),$>0&&r.length>=$&&(v(r),r=[]))};let r=[];return l.search(t).then(a=>(r.length&&v(r),o.dispose(),a),a=>(r.length&&v(r),o.dispose(),Promise.reject(a)))}}e.$hgc=R}),define(Pe[285],Ae([1,0,18,246,34,95,28,13,19,25,12,16,2,94,180,41,15,47,105,281,44]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=void 0;let h=class{constructor(y,D,O,K,U){this.a=y,this.b=D,this.c=O,this.d=K,this.e=U}text(y,D,O={}){y=this.f(y,O);const K=this.a.getValue(),U=D&&D.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(D?.map(t.$ji),O),type:2,contentPattern:y,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:K.search.usePCRE2||U||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(y,D){const O=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const K={...y,wordSeparators:O.editor.wordSeparators};return this.j(y,D)&&(K.isCaseSensitive=!0),this.k(y)&&(K.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),K}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(b):b(y),D?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const O=this.g(D.includePattern,D.expandPatterns),K=this.g(D.excludePattern,D.expandPatterns),U=y.length>1,M=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(P=>this.q(P,D,K)):y.map(P=>this.r(P,D,K,U))).filter(P=>!!P),B={_reason:D._reason,folderQueries:M,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:K.pattern,includePattern:O.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const P=E.$Hb(E.$Rb(this.c.groups.map(ge=>ge.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const X=P.filter(ge=>(0,c.$eJ)(B,ge.fsPath)),ae=this.i(X);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...B,...ae}}const C=D.extraFileResources&&D.extraFileResources.filter(P=>(0,c.$eJ)(B,P.fsPath));return B.extraFileResources=C&&C.length?C:void 0,B}i(y){const D=[],O=new A.$Ac,K={};let U=!1;return y.forEach(M=>{if(M.scheme===m.Schemas.walkThrough)return;if((0,w.$Gg)(M)){const C=this.b.getWorkspaceFolder(M)?.uri??M.with({path:g.$mc(M.fsPath)});let P=O.get(C);P||(U=!0,P={folder:C,includePattern:{}},D.push(P),O.set(C,P));const X=g.$lc(C.fsPath,M.fsPath);(0,S.$Of)(P.includePattern)[X.replace(/\\/g,"/")]=!0}else M.fsPath&&(U=!0,K[M.fsPath]=!0)}),{folderQueries:D,includePattern:K,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(R.$uf(y.pattern,!0))return!0}else if(R.$uf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,$.$JB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),K=(Array.isArray(y)?y:u(y)).map(ae=>{const ge=this.e.resolvedUserHome;return ge?(0,L.$Iv)(ae,ge.scheme===m.Schemas.file?ge.fsPath:ge.path):ae}),U=T.$K(K,ae=>D(ae)?"searchPaths":"exprSegments"),M=(U.exprSegments||[]).map(ae=>R.$Pe(ae,"/")).map(ae=>R.$Pe(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),B={},C=this.m(U.searchPaths||[]);C&&C.length&&(B.searchPaths=C);const P=E.$Rb(M),X=s(...P);return X&&(B.pattern=X),B}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$dJ)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(K=>{let{pathPortion:U,globPortion:M}=i(K);return M&&(M=f(M)),this.n(U).flatMap(C=>this.o(C,M))}),O=new Map;return D.forEach(K=>{const U=K.searchPath.toString(),M=O.get(U);M?K.pattern&&(M.pattern=M.pattern||{},M.pattern[K.pattern]=!0):O.set(U,{searchPath:K.searchPath,pattern:K.pattern?s(K.pattern):void 0})}),Array.from(O.values())}n(y){if(g.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==m.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=b(y),y.startsWith("../")||y===".."){const K=g.$gc.resolve(D.path,y);return[{searchPath:D.with({path:K})}]}const O=f(y);return[{searchPath:D,pattern:O}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),K=this.b.getWorkspace().folders.map(U=>{const M=D.match(new RegExp(`^${R.$Ke(U.name)}(?:/(.*)|$)`));return M?{match:M,folder:U}:null}).filter(S.$Lf);if(K.length)return K.map(U=>{const M=U.match[1];return{searchPath:U.folder.uri,pattern:M&&f(M)}});{const U=y.match(/\.[\/\\](.+)[\/\\]?/),M=U?U[1]:y,B=v.localize(0,null,M);throw new Error(B)}}}}o(y,D){const O=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,K=[{searchPath:y.searchPath,pattern:O}];return O&&!O.endsWith("**")&&K.push({searchPath:y.searchPath,pattern:O+"/**"}),K}q(y,D,O){const K=this.r((0,t.$ji)(y.searchPath),D,O,!1);return K?{...K,includePattern:y.pattern}:null}r(y,D,O,K){let U;const M=l.URI.isUri(y)?y:y.uri;if(O.searchPaths){const ae=O.searchPaths.filter(ge=>(0,w.$vg)(ge.searchPath,M))[0];if(ae&&!ae.pattern)return null;ae&&(U=ae.pattern)}const B=this.a.getValue({resource:M}),P={...this.l(B,D)||{},...U||{}},X=l.URI.isUri(y)?(0,w.$zg)(y):y.name;return{folder:M,folderName:K?X:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!B.search.followSymlinks}}};e.$oK=h,e.$oK=h=Ge([Ke(0,n.$ui),Ke(1,t.$0h),Ke(2,r.$OC),Ke(3,o.$ij),Ke(4,a.$mK)],h);function i(p){const y=p.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,O=p.substr(0,D).match(/[/|\\][^/\\]*$/);if(O){let K=p.substr(0,O.index);return K.match(/[/\\]/)||(K+="/"),{pathPortion:K,globPortion:p.substr((O.index||0)+1)}}}return{pathPortion:p}}function s(...p){return p.length?p.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u(p){return I.$Fj(p,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(p){return[`**/${p}/**`,`**/${p}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function b(p){return p.replace(/\\/g,"/")}function f(p){return b(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(p){return p.replace(/([?*[\]])/g,"[$1]")}function F(p,y){p=E.$Mb(p,K=>K.toString());const D=[],O=y.getWorkspace();return p&&p.forEach(K=>{let U;if(y.getWorkbenchState()===2)U=(0,w.$Eg)(O.folders[0].uri,K),U&&U!=="."&&(U="./"+U);else{const M=y.getWorkspaceFolder(K);if(M){const B=M.name;if(O.folders.filter(P=>P.name===B).length===1){const P=(0,w.$Eg)(M.uri,K);P===""?U=`./${M.name}`:U=`./${M.name}/${P}`}else U=K.fsPath}}U&&D.push(k(U))}),D}e.$pK=F}),define(Pe[286],Ae([1,0,25,2,20,11,4,285,44,47]),function(me,e,E,T,I,L,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rb=e.$7rb=void 0;const R=7e3;function S(n,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const r=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const b=d.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||n.forceUsingSearch?a.push(b):r.push(b)}if(r.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,b)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(r.map(d=>l(n,d,i))).then(()=>{}),u=$(n,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$7rb=S;async function l(n,o,t){for(const r of n.folders)if(await n.exists(E.$Cg(T.URI.revive(r),o))){t(`workspaceContains:${o}`);return}}async function $(n,o,t,r){if(t.length===0)return Promise.resolve(void 0);const a=new I.$3d,c=n.checkExists(n.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),n.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},R);let i=!1;try{i=await c}catch(s){L.$4(s)||L.$1(s)}a.dispose(),clearTimeout(h),i&&r(`workspaceContains:${t.join(",")}`)}function v(n,o,t,r){const a=n.get(A.$Zh),c=n.get(g.$8I),i=a.createInstance(m.$oK).file(o.map(s=>(0,w.$ji)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,r).then(s=>!!s.limitHit,s=>L.$4(s)?!1:Promise.reject(s))}e.$8rb=v}),define(Pe[38],Ae([1,0,159,19,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b,f,k,F,p,y,D,O,K,U,M,B,C,P){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=e.$Xfc=e.$Wfc=e.$Vfc=void 0,e.$Vfc=(0,u.$1h)("IHostUtils");let ae=X=class extends m.$Sc{constructor(Y,V,ne,Ie,Le,Ce,ce,ie,Q,ee,$e,be){super(),this.X=be,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ie,this.m=Le,this.s=Ce,this.t=Q,this.u=ee,this.w=$e,this.y=this.g.getProxy(S.$KK.MainThreadWorkspace),this.z=this.g.getProxy(S.$KK.MainThreadTelemetry),this.C=this.g.getProxy(S.$KK.MainThreadExtensionService),this.D=new A.$Zg,this.F=new A.$Zg,this.G=new A.$Zg,this.H=new A.$Zg,this.I=new Se(this.f.extensions.activationEvents),this.L=new t.$96b(this.I,this.f.extensions.allExtensions);const Me=new a.$gm(this.f.extensions.myExtensions);this.J=new t.$96b(this.I,he(this.L,Me)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$Gfc(this.g,this.s),this.N=new O.$Ofc(this.g),this.O=ie,this.h=Y.createChild(new k.$Yh([v.$Hfc,this.M],[O.$Pfc,this.N])),this.P=this.B(new $.$Ffc(this.J,this.L,{onExtensionActivationError:(le,we,N)=>{this.C.$onExtensionActivationError(le,r.$3(we),N)},actualActivateExtension:async(le,we)=>{if(t.$96b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,we),new $.$Efc;const N=this.J.getExtensionDescription(le);return this.db(N,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){r.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Le=>Le.identifier).filter(Le=>this.isActivated(Le)).map(Le=>this.cb(Le))}catch{}await Promise.all(Y)}terminate(Y,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,A.$2g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const V=await this.C.$getExtension(Y);return V&&{...V,identifier:new a.$fm(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(Y,V){return this.P.activateByEvent(Y,V)}$(Y,V){return this.P.activateById(Y,V)}activateByIdWithErrors(Y,V){return this.$(Y,V).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===U.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Y.fsPath);return w.URI.file(V)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new te(Y))),this.Q}async bb(Y){const V=g.$7h.forUris(ne=>L.$tg.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(Y){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return V;const ne=this.P.getActivatedExtension(Y);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ie)}try{(0,m.$Nc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Ie)}return V}async db(Y,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Y,V,"success",Ie),ne},ne=>{throw this.eb(Y,V,"failure"),ne})}eb(Y,V,ne,Ie){const Le=ve(Y,V);this.z.$publicLog2("extensionActivationTimes",{...Le,...Ie||{},outcome:ne})}fb(Y,V){const ne=ve(Y,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(Y);if(!Ie)return Promise.resolve(new $.$Dfc($.$Afc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Y.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Le=new $.$Bfc(V.startup);return Promise.all([this.vb(Y,(0,L.$Cg)(Y.extensionLocation,Ie),Le),this.gb(Y)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),X.hb(this.s,Y.identifier,Ce[0],Ce[1],Le))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const V=new h.$Jfc(Y,this.M),ne=new h.$Ifc(Y.identifier.value,!1,this.M),Ie=new K.$Qfc(Y,this.N),Le=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ie,Q;const ee=(0,o.$hF)(Y,"ipc")?this.f.messagePorts?.get(a.$fm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath($e){return T.$jc(Y.extensionLocation.fsPath,$e)},get storagePath(){return ce.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Y).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,Y.identifier.value)},get storageUri(){return ce.O.workspaceValue(Y)},get globalStorageUri(){return ce.O.globalValue(Y)},get extensionMode(){return Le},get extension(){return ie===void 0&&(ie=new de(ce,Y.identifier,Y,Ce,!1)),ie},get extensionRuntime(){return(0,o.$iF)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Q){if(!ee)return;const $e=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",be=>be.data));ee.start(),Q={onDidReceiveMessage:$e,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Y,V,ne,Ie,Le){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Y,V,ne,Ie,Le).then(Ce=>new $.$Cfc(!1,null,Le.build(),ne,Ce,Ie.subscriptions))}static ib(Y,V,ne,Ie,Le){if(typeof ne.activate=="function")try{Le.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ne.activate.apply(Ce,[Ie]);return Le.activateCallStop(),Le.activateResolveStart(),Promise.resolve(ce).then(ie=>(Le.activateResolveStop(),ie))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(Y,V){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(Y,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Le=V;Le<Y.length;Le+=1){const Ce=Y[Le];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Y,Le);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(Y=>{const V=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Le of Ie.activationEvents)Le==="onStartupFinished"&&this.jb(Ie,Le)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Le=Promise.all([Ie,Y,ne]).then(()=>{});return Promise.race([Le,(0,A.$2g)(1e4)]).then(()=>{this.lb()}),Le}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Y,V))).then(()=>{})}async ob(Y,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,ie)=>this.y.$checkExists(Ce,ce,ie)},Le=await(0,D.$7rb)(Ie,V);if(Le)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Le.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:V}=this.f.environment;if(!Y||!V)throw new Error(E.localize(0,null));const ne=await this.vb(null,V,new $.$Bfc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Le)=>{const Ce=(Q,ee)=>{Q?(C.$t&&this.s.error("Test runner called back with error",Q),Le(Q)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,L.$qg)(V),ie=ne.run(ce,Ce);ie&&ie.then&&ie.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{C.$t&&this.s.error("Test runner finished with error",Q),Le(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$2g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,V){return this.R[Y]=V,(0,m.$Qc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:V}=await this.sb(Y);return V?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const V=Y.indexOf("+");if(V===-1)throw new i.$SK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Y,V){const ne=B.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$6k)(Y)},${V})][${ne.elapsed()}ms] `,Le=H=>this.s.info(`${Ie()}${H}`),Ce=H=>this.s.warn(`${Ie()}${H}`),ce=(H,j=void 0)=>this.s.error(`${Ie()}${H}`,j),ie=H=>{if(H instanceof i.$SK)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},Q=async H=>{Le(`activating resolver for ${H}...`);const{resolver:j,authorityPrefix:J}=await this.sb(H);if(!j)throw ce(`no resolver for ${J}`),new i.$SK(`No remote extension installed to resolve ${J}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:J,remoteAuthority:H}},ee=Y.split(/@|%40/g).reverse();Le(`activating remote resolvers ${ee.join(" -> ")}`);let $e;try{$e=await Promise.all(ee.map(Q)).catch(async H=>{if(!(H instanceof i.$SK)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Ce(`resolving nested authorities failed: ${H.message}`),[await Q(Y)]})}catch(H){return ie(H)}const be=new A.$_g;be.cancelAndSet(()=>Le("waiting..."),1e3);let Me,le;for(const[H,{authorityPrefix:j,resolver:J,remoteAuthority:_}]of $e.entries())try{if(H===$e.length-1)Le("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${j}`),Me=await J.resolve(_,{resolveAttempt:V,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${j}`),Le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,i.$RK.isManagedResolvedAuthority(Me)?Me:void 0));else{if(Le(`invoking resolveExecServer() for ${_}`),I.mark(`code/extHost/willResolveExecServer/${j}`),le=await J.resolveExecServer?.(_,{resolveAttempt:V,execServer:le}),!le)throw new i.$SK(`Exec server was not available for ${_}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(ye){return I.mark(`code/extHost/didResolveAuthorityError/${j}`),ce("returned an error",ye),be.dispose(),ie(ye)}be.dispose();const we={environmentTunnels:Me.environmentTunnels,features:Me.tunnelFeatures},N={extensionHostEnv:Me.extensionHostEnv,isTrusted:Me.isTrusted,authenticationSession:Me.authenticationSessionForInitializingExtensions?{id:Me.authenticationSessionForInitializingExtensions.id,providerId:Me.authenticationSessionForInitializingExtensions.providerId}:void 0};Le(`returned ${i.$RK.isManagedResolvedAuthority(Me)?"managed authority":`${Me.host}:${Me.port}`}`);let q;if(i.$RK.isManagedResolvedAuthority(Me)){const H=V;this.X.setFactory(H,Me.makeConnection),q={authority:Y,connectTo:new s.$3k(H),connectionToken:Me.connectionToken}}else q={authority:Y,connectTo:new s.$4k(Me.host,Me.port),connectionToken:Me.connectionToken};return{type:"ok",value:{authority:q,options:N,tunnelInformation:we}}}async $getCanonicalURI(Y,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$6k)(Y)})`);const{resolver:ne}=await this.sb(Y);if(!ne)return null;const Ie=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Le=await(0,A.$Tg)(()=>ne.getCanonicalURI(Ie));return Le||Ie}$startExtensionHost(Y){Y.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ge(this.I,this.L,this.J,Y);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Y,V){return V===1?this.D.wait().then(ne=>this.Z(Y,!1)):this.G.wait().then(ne=>this.Z(Y,!1))}async $activate(Y,V){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,V),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ge(this.I,this.L,this.J,Y),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const V=c.$ge.alloc(Y),ne=Math.random()%256;for(let Ie=0;Ie<Y;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$Wfc=ae,e.$Wfc=ae=X=Ge([Ke(0,u.$Zh),Ke(1,e.$Vfc),Ke(2,f.$OM),Ke(3,n.$jfc),Ke(4,l.$mfc),Ke(5,R.$ij),Ke(6,d.$5M),Ke(7,b.$pfc),Ke(8,F.$4xb),Ke(9,p.$Kfc),Ke(10,M.$Sfc),Ke(11,P.$Tfc)],ae);function ge(oe,Y,V,ne){oe.addActivationEvents(ne.addActivationEvents);const Ie=new t.$96b(oe,Y.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Le=new a.$gm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Le.delete(ce);for(const ce of ne.myToAdd)Le.add(ce);const Ce=he(Ie,Le);return{globalRegistry:Ie,myExtensions:Ce}}function ve(oe,Y){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ke(oe){return oe.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Xfc=(0,u.$1h)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Y,V,ne,Ie,Le){this.#e=Y,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,L.$qg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Yfc=de;function he(oe,Y){return oe.getAllExtensionDescriptions().filter(V=>Y.has(V.identifier))}class te{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Zfc=te;class Se{constructor(Y){this.a=new a.$hm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const V of Object.keys(Y))this.a.set(V,Y[V])}}}),define(Pe[287],Ae([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;let n=class{constructor(c,h,i,s,u,d,b){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$8gc=n,e.$8gc=n=Ge([Ke(2,R.$Zh),Ke(3,L.$mfc),Ke(4,S.$Xfc),Ke(5,w.$5M),Ke(6,l.$ij)],n);let o=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&v.a.size){const h=(0,$.$Ke)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=v.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=v=Ge([Ke(0,w.$5M)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new m.$hm}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$cF,this.e,this.f)}return this.b}}let r=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$KK.MainThreadTelemetry);const s=i.getProxy(I.$KK.MainThreadWindow);this.c=(u,d)=>{const b=T.URI.parse(u);return d?this.g(u,d):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,u,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ge([Ke(2,g.$OM)],r)}),define(Pe[116],Ae([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0,e.$1fc=(0,A.$1h)("IExtHostVariableResolverProvider");class v extends l.$PN{constructor(t,r,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const b=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof R.$tM||b.input instanceof R.$yM)return b.input.modified;if(b.input instanceof R.$sM||b.input instanceof R.$xM||b.input instanceof R.$vM)return b.input.uri}}}super({getFolderUri:d=>{const b=i.folders.filter(f=>f.name===d);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,b)=>h.getConfiguration(void 0,d).get(b),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=u();if(d){const b=r.getWorkspaceFolder(d);if(b)return I.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let n=class extends T.$Sc{constructor(t,r,a,c,h){super(),this.b=t,this.c=r,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$2fc=n,e.$2fc=n=Ge([Ke(0,w.$Xfc),Ke(1,S.$jfc),Ke(2,m.$ZM),Ke(3,$.$mfc),Ke(4,g.$yfc)],n)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=e.$5fc=e.$4fc=e.$3fc=void 0,e.$3fc=(0,L.$1h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,b,f,k){this.E=u,this.F=d,this.G=b,this.H=f,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=s.getProxy(A.$KK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(F=>{F.onDidChange(p=>{this.J(F)}),this.J(F)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let b=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(b+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),b+=`${f}ref=${d.sourceReference}`,I.URI.parse(b)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const b=d.contributes.debuggers;if(b&&b.length>0)for(const f of b)(0,$.$TF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const k=f.id;return this.w.has(k)?!1:(this.w.set(k,f),!0)});this.U(u,[],[]);const d=[],b=new Map;for(const f of u)if(f instanceof R.$ML){let k=b.get(f.location.uri.toString());k||(k={type:"sourceMulti",uri:f.location.uri,lines:[]},b.set(f.location.uri.toString(),k),d.push(k)),k.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof R.$NL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(k=>this.w.delete(k.id));this.U([],u,[]);const d=u.filter(k=>k instanceof R.$ML).map(k=>k.id),b=u.filter(k=>k instanceof R.$NL).map(k=>k.id),f=u.filter(k=>k instanceof R.$OL).map(k=>k.id);return this.k.$unregisterBreakpoints(d,b,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new R.$MK(()=>{});const b=this.d++;return this.f.push({type:s,handle:b,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,b),new R.$MK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new R.$MK(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:u,handle:b,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,b),new R.$MK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new R.$MK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new R.$MK(()=>{this.j=this.j.filter(b=>b.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const b=await this.W(s);return b&&(d={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,b=await this.V(u);return this.S(this.N(b.type),b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const k=this.M(f),F=this.K(k,b);if(!F)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const p=F;return this.B.set(s,p),this.R(b).then(y=>(y&&this.C.set(s,y),p.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const O=D,K={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const U=await this.D.sign(O.arguments.value);K.body={signature:U},p.sendResponse(K)}else throw new Error("no signer")}catch(U){K.success=!1,K.message=U.message,p.sendResponse(K)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,$.$YF)(D,!0),d.k.$acceptDAMessage(s,D)}),p.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(s,D.name,D.message,D.stack)}),p.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(s,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),p.startSession()))})}$sendDAMessage(s,u){u=(0,$.$XF)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],b=[];if(s.added)for(const f of s.added){const k=f.id;if(k&&!this.w.has(k)){let F;if(f.type==="function")F=new R.$NL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")F=new R.$OL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const p=I.URI.revive(f.uri);F=new R.$ML(new R.$YK(p,new R.$NK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,R.$KL)(F,k),this.w.set(k,F),u.push(F)}}if(s.removed)for(const f of s.removed){const k=this.w.get(f);k&&(this.w.delete(f),d.push(k))}if(s.changed){for(const f of s.changed)if(f.id){const k=this.w.get(f.id);if(k){if(k instanceof R.$NL&&f.type==="function"){const F=k;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.functionName=f.functionName}else if(k instanceof R.$ML&&f.type==="source"){const F=k;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.location=new R.$YK(I.URI.revive(f.uri),new R.$NK(f.line,f.character))}b.push(k)}}}this.U(u,d,b)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new R.$UL(d,s.threadId):u=new R.$TL(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Tg)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return b.provideDebugConfigurations(f,d)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,u,d,b){return(0,E.$Tg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(u);return f.resolveDebugConfiguration(k,d,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,b){return(0,E.$Tg)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(k,d,b)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(u);return this.S(d,b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const b={session:await this.V(s),event:u.event,body:u.body};this.u.fire(b)}M(s){if(s instanceof R.$PL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof R.$QL)return{type:"server",port:s.port,host:s.host};if(s instanceof R.$RL)return{type:"pipeServer",path:s.path};if(s instanceof R.$SL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const b of d)if(b.label&&b.type&&b.type===u)return!0}}return!1}R(s){const d=s.configuration.type,b=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Tg)(()=>f.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(b).then(f=>{const k=f.filter(F=>!!F);if(k.length>0)return new a(k)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new R.$QL(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Tg)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(k=>{if(k)return k})}const b=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,b))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),b=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,b),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$4fc=o,e.$4fc=o=Ge([Ke(0,w.$OM),Ke(1,S.$jfc),Ke(2,g.$Xfc),Ke(3,v.$mfc),Ke(4,m.$yfc),Ke(5,n.$1fc)],o);class t{constructor(s,u,d,b,f,k,F){this.d=s,this.f=u,this.g=d,this.h=b,this.i=f,this.j=k,this.k=F}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$5fc=t;class r{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$6fc=r;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$llb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,b,f,k){super(s,u,d,b,f,k)}};e.$7fc=h,e.$7fc=h=Ge([Ke(0,w.$OM),Ke(1,S.$jfc),Ke(2,g.$Xfc),Ke(3,v.$mfc),Ke(4,m.$yfc),Ke(5,n.$1fc)],h)}),define(Pe[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get(m.$ij),i=a.get(l.$OM).getProxy(L.$KK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get(m.$ij),h=a.get(l.$OM),i=a.get(v.$Xfc),s=a.get(n.$9M),u=h.getProxy(L.$KK.MainThreadExtensionService),d=h.getProxy(L.$KK.MainThreadErrors),b=await i.getExtensionPathIndex(),f=new WeakMap;function k(y,D){if(f.has(y))return f.get(y).stack;let O="",K,U;for(const B of D)O+=`
	at ${B.toString()}`,U=B.getFileName(),!K&&U&&(K=b.findSubstr(I.URI.file(U)));const M=`${y.name||"Error"}: ${y.message||""}${O}`;return f.set(y,{extensionIdentifier:K?.identifier,stack:M}),M}const F=Symbol("prepareStackTrace wrapped");let p=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(y){if(y===k||!y||y[F]){p=y||k;return}p=function(D,O){return k(D,O),y.call(Error,D,O)},Object.assign(p,{[F]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$3(y),O=f.get(y);if(!O?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(O.extensionIdentifier,D);const K=s.onExtensionError(O.extensionIdentifier,y);c.trace("forwarded error to extension?",K,O)})}}e.$9gc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new A.$e7b(a,null,i),c=t.e(c,this.b);const u=new w.$Yh(...(0,g.$Jr)());u.set(R.$5M,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$OM,new l.$PM(this.b)),u.set($.$gfc,new $.$hfc(i)),u.set(v.$Vfc,h);const d=new S.$pq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(b=>b.get(m.$ij)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(b=>b.get(v.$Xfc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(L.$KK.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=I.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$0gc=t}),define(Pe[289],Ae([1,0,18,14,20,40,13,19,25,2,44]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=e.$jgc=e.$igc=void 0;class S{constructor(r,a,c,h){this.d=r,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,a){const c=this.d.folderQueries||[],h=new I.$3d(a);return new Promise((i,s)=>{this.a=new $(r);let u=!1;const d=(b,f)=>{if(!u&&!this.b){const k=this.h(b);n(b)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),b=this.j(b,this.d.maxResults-this.c));const F=this.h(b);this.c+=F,(F>0||!n(b))&&this.a.add(b,f)}};Promise.all(c.map((b,f)=>this.k(b,k=>d(k,f),h.token))).then(b=>{h.dispose(),this.a.flush();const f=b.some(k=>!!k&&!!k.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(b.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},b=>{h.dispose();const f=(0,L.$Li)(b);s(new Error(f))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,a){const c=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:r.preview.text},uri:r.uri}}async k(r,a,c){const h=new R.$oJ(this.d,r),i=[],s={report:b=>{if(!this.l(b))return;const f=r.folder.scheme===A.Schemas.file?(0,R.$pJ)(()=>this.f.readdir(g.$Bg(b.uri))):void 0,k=g.$Eg(r.folder,b.uri);if(k){const F=h.includedInQuery(k,m.$nc(k),f);(0,T.$Ng)(F)?i.push(F.then(p=>{p&&a(b)})):F&&a(b)}}},u=this.n(r),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const a=(0,R.$nJ)(this.d.includePattern,r.includePattern),c=(0,R.$nJ)(this.d.excludePattern,r.excludePattern),h={folder:w.URI.from(r.folder),excludes:c,includes:a,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$igc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class ${constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(r,a){this.d&&(this.b!==a||!g.$vg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$jgc=$;function v(t){return n(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function n(t){return!!t.preview}e.$kgc=n;class o{static{this.a=4e3}static{this.b=50}constructor(r,a){this.g=r,this.h=a,this.c=0,this.d=[],this.e=0}addItem(r,a){r&&this.j(r,a)}addItems(r,a){r&&this.k(r,a)}j(r,a){this.d.push(r),this.e+=a,this.l()}k(r,a){this.d=this.d.concat(r),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$lgc=o}),define(Pe[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=void 0,e.$mgc=(0,I.$1h)("IExtHostSearch");let S=class{constructor(n,o,t){this.k=n,this.l=o,this.n=t,this.c=this.k.getProxy(T.$KK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$hgc}o(n){return this.l.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(n)),(0,E.$Qc)(()=>{this.g.delete(n),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(n,o){if(this.i.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.i.add(n);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(n)),(0,E.$Qc)(()=>{this.i.delete(n),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,r){const a=l(t),c=this.h.get(n);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(n,o,h.map(i=>i.resource))},r);throw new Error("unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,t){return{messages:[]}}$clearCache(n){return this.j.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,t,r){const a=this.e.get(n);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(n,o,i),r)}$enableExtensionHostSearch(){}q(n,o){return new R.$igc(n,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$ngc=S,e.$ngc=S=Ge([Ke(0,A.$OM),Ke(1,m.$gfc),Ke(2,g.$ij)],S);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map($),extraFileResources:v.extraFileResources&&v.extraFileResources.map(n=>w.URI.revive(n))}}e.$ogc=l;function $(v){return{...v,folder:w.URI.revive(v.folder)}}}),define(Pe[290],Ae([1,0,20,11,5,6,13,31,2,146,142,130,93,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b,f,k,F,p,y,D,O,K,U,M,B,C,P,X,ae,ge,ve,ke,de,he,te,Se,oe,Y,V,ne,Ie,Le,Ce,ce,ie,Q,ee,$e,be,Me,le,we,N,q,H,j,J,_,ye,Te,We,He,Xe,rt,it,et,ot,at,Be,pt,Z,x,pe,Ue,Qe,tt,nt,Ne,It,Mt,Kt,jt,wt,qt,Ft,Qt,Ot,Ct,Ye,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;function Gt(ut){const mt=ut.get(Y.$5M),zt=ut.get(oe.$1ec),Ut=ut.get(te.$ofc),Et=ut.get(de.$Xfc),ht=ut.get(Qt.$jfc),Pt=ut.get(Be.$9M),Yt=ut.get(O.$mfc),Dt=ut.get(Mt.$gfc),qe=ut.get(ye.$OM),Rt=ut.get(et.$Hfc),Wt=ut.get(ot.$pfc),Jt=ut.get(n.$jj),ft=ut.get(n.$ij),Lt=ut.get(tt.$4xb),Ee=ut.get(i.$4ec),Fe=ut.get(Ft.$3gc),fe=ut.get(He.$Pfc),G=ut.get(ve.$yfc),Re=ut.get(Q.$Tfc);qe.set(a.$LK.ExtHostFileSystemInfo,zt),qe.set(a.$LK.ExtHostLogLevelServiceShape,Jt),qe.set(a.$LK.ExtHostWorkspace,ht),qe.set(a.$LK.ExtHostConfiguration,Yt),qe.set(a.$LK.ExtHostExtensionService,Et),qe.set(a.$LK.ExtHostStorage,Rt),qe.set(a.$LK.ExtHostTunnelService,Lt),qe.set(a.$LK.ExtHostWindow,Fe),qe.set(a.$LK.ExtHostSecretState,fe),qe.set(a.$LK.ExtHostTelemetry,Pt),qe.set(a.$LK.ExtHostEditorTabs,G),qe.set(a.$LK.ExtHostManagedSockets,Re);const je=qe.set(a.$LK.ExtHostDecorations,ut.get(M.$9fc)),Ze=qe.set(a.$LK.ExtHostDocumentsAndEditors,ut.get(ge.$ZM)),Ve=qe.set(a.$LK.ExtHostCommands,ut.get(y.$$M)),_e=qe.set(a.$LK.ExtHostTerminalService,ut.get(pt.$Kfc)),gt=qe.set(a.$LK.ExtHostDebugService,ut.get(U.$3fc)),Bt=qe.set(a.$LK.ExtHostSearch,ut.get(We.$mgc)),yt=qe.set(a.$LK.ExtHostTask,ut.get(at.$Pgc)),kt=qe.set(a.$LK.ExtHostOutputService,ut.get(q.$Cgc)),bt=qe.set(a.$LK.ExtHostLocalization,ut.get(ie.$Sfc)),mi=qe.set(a.$LK.ExtHostUrls,new Kt.$Zgc(qe)),At=qe.set(a.$LK.ExtHostDocuments,new ae.$Yec(qe,Ze)),ki=qe.set(a.$LK.ExtHostDocumentContentProviders,new P.$$fc(qe,Ze,ft)),Vi=qe.set(a.$LK.ExtHostDocumentSaveParticipant,new X.$_fc(ft,At,qe.getProxy(a.$KK.MainThreadBulkEdits))),St=qe.set(a.$LK.ExtHostNotebook,new $e.$pgc(qe,Ve,Ze,At,Ut,Bt)),ni=qe.set(a.$LK.ExtHostNotebookDocuments,new Me.$wgc(St)),$i=qe.set(a.$LK.ExtHostNotebookEditors,new le.$xgc(ft,St)),ai=qe.set(a.$LK.ExtHostNotebookKernels,new we.$ygc(qe,mt,St,Ve,ft)),Si=qe.set(a.$LK.ExtHostNotebookRenderers,new N.$Agc(qe,St)),Ii=qe.set(a.$LK.ExtHostNotebookDocumentSaveParticipant,new be.$vgc(ft,St,qe.getProxy(a.$KK.MainThreadBulkEdits))),Tt=qe.set(a.$LK.ExtHostEditors,new x.$dfc(qe,Ze)),pi=qe.set(a.$LK.ExtHostTreeViews,new Qe.$Xgc(qe.getProxy(a.$KK.MainThreadTreeViews),Ve,ft)),Ci=qe.set(a.$LK.ExtHostEditorInsets,new p.$efc(qe.getProxy(a.$KK.MainThreadEditorInsets),Tt,mt.remote)),ci=qe.set(a.$LK.ExtHostDiagnostics,new B.$3ec(qe,ft,zt,Ze)),ui=qe.set(a.$LK.ExtHostLanguages,new ce.$tgc(qe,At,Ve.converter,Dt)),lt=qe.set(a.$LK.ExtHostLanguageFeatures,new Ce.$7ec(qe,Dt,At,Ve,ci,ft,Ee,Pt)),qi=qe.set(a.$LK.ExtHostFileSystem,new he.$bgc(qe,lt)),xt=qe.set(a.$LK.ExtHostFileSystemEventService,new Se.$cgc(qe,ft,Ze)),ri=qe.set(a.$LK.ExtHostQuickOpen,(0,_.$Ggc)(qe,ht,Ve)),di=qe.set(a.$LK.ExtHostSCM,new Te.$Igc(qe,Ve,At,ft)),Pi=qe.set(a.$LK.ExtHostQuickDiff,new J.$Fgc(qe,Dt)),Ki=qe.set(a.$LK.ExtHostShare,new Xe.$Jgc(qe,Dt)),Ai=qe.set(a.$LK.ExtHostComments,(0,D.$ffc)(qe,Ve,At)),vi=qe.set(a.$LK.ExtHostProgress,new j.$Egc(qe.getProxy(a.$KK.MainThreadProgress))),Hi=qe.set(a.$LK.ExtHosLabelService,new Le.$sgc(qe)),Ri=qe.set(a.$LK.ExtHostTheming,new pe.$Ugc(qe)),li=qe.set(a.$LK.ExtHostAuthentication,new s.$9ec(qe)),Gi=qe.set(a.$LK.ExtHostTimeline,new Ue.$Wgc(qe,Ve)),bi=qe.set(a.$LK.ExtHostWebviews,new jt.$tfc(qe,mt.remote,ht,ft,Ee)),Li=qe.set(a.$LK.ExtHostWebviewPanels,new wt.$wfc(qe,bi,ht)),cn=qe.set(a.$LK.ExtHostCustomEditors,new K.$xfc(qe,At,Wt,bi,Li)),Mi=qe.set(a.$LK.ExtHostWebviewViews,new qt.$1gc(qe,bi)),si=qe.set(a.$LK.ExtHostTesting,new Z.$Qgc(qe,Ve,Ze)),un=qe.set(a.$LK.ExtHostUriOpeners,new It.$Ygc(qe)),ln=qe.set(a.$LK.ExtHostProfileContentHandlers,new H.$Dgc(qe));qe.set(a.$LK.ExtHostInteractive,new ne.$qgc(qe,St,Ze,Ve,ft));const Ji=qe.set(a.$LK.ExtHostInlineChat,new V.$dgc(qe,Ve,At,ft)),fi=qe.set(a.$LK.ExtHostChatProvider,new f.$_ec(qe,ft)),Qi=qe.set(a.$LK.ExtHostChatAgents2,new b.$afc(qe,fi,ft)),Zi=qe.set(a.$LK.ExtHostChatVariables,new k.$bfc(qe)),gi=qe.set(a.$LK.ExtHostChat,new d.$$ec(qe)),Xi=qe.set(a.$LK.ExtHostAiRelatedInformation,new c.$Xec(qe)),Fi=qe.set(a.$LK.ExtHostAiEmbeddingVector,new ke.$agc(qe)),Ti=qe.set(a.$LK.ExtHostIssueReporter,new Ie.$rgc(qe)),_t=qe.set(a.$LK.ExtHostStatusBar,new it.$Mgc(qe,Ve.converter)),wi=qe.set(a.$LK.ExtHostSpeech,new rt.$Kgc(qe)),hn=Object.values(a.$LK);qe.assertRegistered(hn);const Zt=new u.$0ec(qe,Ze),yi=new F.$cfc(qe),Ei=new ee.$ugc(qe,ft),Ni=new C.$0fc(qe);return h.$8ec.register(Ve),function(ze,ei,Yi){const $t=function(){let re=!ze.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ue();else{const vt=st;typeof vt.scheme>"u"&&ue(),typeof vt.exclusive=="boolean"&&(0,Ye.$iF)(ze,"documentFiltersExclusive")}return st}}(),xi={getSession(re,ue,Oe){return li.getSession(ze,re,ue,Oe)},getSessions(re,ue){return(0,Ye.$iF)(ze,"authGetSessions"),li.getSessions(ze,re,ue)},async hasSession(re,ue){return(0,Ye.$iF)(ze,"authSession"),!!await li.getSession(ze,re,ue,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(re,ue,Oe,st){return li.registerAuthenticationProvider(re,ue,Oe,st)}},dn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,ze)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...st)=>{const vt=Tt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return vt.edit(Nt=>{ue.apply(Oe,[vt,Nt,...st])}).then(Nt=>{Nt||ft.warn("Edits from command "+re+" were not applied.")},Nt=>{ft.warn("An error occurred while running command "+re,Nt)})},void 0,void 0,ze)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ye.$iF)(ze,"diffCommand"),Ve.registerCommand(!0,re,async(...st)=>{const vt=Ze.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Nt=await Tt.getDiffInformation(vt.id);ue.apply(Oe,[Nt,...st])},void 0,void 0,ze)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},_i={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return _e.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$iF)(ze,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$iF)(ze,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Be.$8M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return Be.$7M.validateSender(re),Pt.instantiateLogger(ze,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===mt.environment.appUriScheme)return mi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!mt.remote.authority})}catch(ue){if((0,A.$_f)(re,A.Schemas.http)||(0,A.$_f)(re,A.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$8k)(mt.remote.authority)},get remoteAuthority(){return(0,Ye.$iF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,Ye.$iF)(ze,"handleIssueUri"),Ti.registerIssueUriRequestHandler(ze,re)},registerIssueDataProvider(re){return(0,Ye.$iF)(ze,"handleIssueUri"),Ti.registerIssueDataProvider(ze,re)},get appQuality(){return(0,Ye.$iF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ye.$iF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(re,ue,Oe){return si.createTestController(ze,re,ue,Oe)},createTestObserver(){return(0,Ye.$iF)(ze,"testObserver"),si.createTestObserver()},runTests(re){return(0,Ye.$iF)(ze,"testObserver"),si.runTests(re)},get onDidChangeTestResults(){return(0,Ye.$iF)(ze,"testObserver"),si.onResultsChanged},get testResults(){return(0,Ye.$iF)(ze,"testObserver"),si.results}},hi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,ue){(0,Ye.$hF)(ze,"extensionsAny")||(ue=!1);const Oe=ei.mine.getExtensionDescription(re);if(Oe)return new de.$Yfc(Et,ze.identifier,Oe,hi,!1);if(ue){const st=ei.all.getExtensionDescription(re);if(st)return new de.$Yfc(Et,ze.identifier,st,hi,!0)}},get all(){const re=[];for(const ue of ei.mine.getAllExtensionDescriptions())re.push(new de.$Yfc(Et,ze.identifier,ue,hi,!1));return re},get allAcrossExtensionHosts(){(0,Ye.$iF)(ze,"extensionsAny");const re=new $.$gm(ei.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ei.all.getAllExtensionDescriptions()){const st=!re.has(Oe.identifier);ue.push(new de.$Yfc(Et,ze.identifier,Oe,hi,st))}return ue},get onDidChange(){return(0,Ye.$hF)(ze,"extensionsAny")?I.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(re){return ci.createDiagnosticCollection(ze.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(re,ue){return ui.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,R.$mt)(nt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return lt.registerCodeActionProvider(ze,$t(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ye.$iF)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,$t(re),ue,Oe)},registerCodeLensProvider(re,ue){return lt.registerCodeLensProvider(ze,$t(re),ue)},registerDefinitionProvider(re,ue){return lt.registerDefinitionProvider(ze,$t(re),ue)},registerDeclarationProvider(re,ue){return lt.registerDeclarationProvider(ze,$t(re),ue)},registerImplementationProvider(re,ue){return lt.registerImplementationProvider(ze,$t(re),ue)},registerTypeDefinitionProvider(re,ue){return lt.registerTypeDefinitionProvider(ze,$t(re),ue)},registerHoverProvider(re,ue){return lt.registerHoverProvider(ze,$t(re),ue,ze.identifier)},registerEvaluatableExpressionProvider(re,ue){return lt.registerEvaluatableExpressionProvider(ze,$t(re),ue,ze.identifier)},registerInlineValuesProvider(re,ue){return lt.registerInlineValuesProvider(ze,$t(re),ue,ze.identifier)},registerDocumentHighlightProvider(re,ue){return lt.registerDocumentHighlightProvider(ze,$t(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return lt.registerMultiDocumentHighlightProvider(ze,$t(re),ue)},registerLinkedEditingRangeProvider(re,ue){return lt.registerLinkedEditingRangeProvider(ze,$t(re),ue)},registerReferenceProvider(re,ue){return lt.registerReferenceProvider(ze,$t(re),ue)},registerRenameProvider(re,ue){return lt.registerRenameProvider(ze,$t(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return lt.registerDocumentSymbolProvider(ze,$t(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(ze,re)},registerDocumentFormattingEditProvider(re,ue){return lt.registerDocumentFormattingEditProvider(ze,$t(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return lt.registerDocumentRangeFormattingEditProvider(ze,$t(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...st){return lt.registerOnTypeFormattingEditProvider(ze,$t(re),ue,[Oe].concat(st))},registerDocumentSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentSemanticTokensProvider(ze,$t(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentRangeSemanticTokensProvider(ze,$t(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(ze,$t(re),ue,Oe):lt.registerSignatureHelpProvider(ze,$t(re),ue,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(re,ue,...Oe){return lt.registerCompletionItemProvider(ze,$t(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ye.$iF)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$iF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ye.$iF)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,$t(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return lt.registerDocumentLinkProvider(ze,$t(re),ue)},registerColorProvider(re,ue){return lt.registerColorProvider(ze,$t(re),ue)},registerFoldingRangeProvider(re,ue){return lt.registerFoldingRangeProvider(ze,$t(re),ue)},registerSelectionRangeProvider(re,ue){return lt.registerSelectionRangeProvider(ze,re,ue)},registerCallHierarchyProvider(re,ue){return lt.registerCallHierarchyProvider(ze,re,ue)},registerTypeHierarchyProvider(re,ue){return lt.registerTypeHierarchyProvider(ze,re,ue)},setLanguageConfiguration:(re,ue)=>lt.setLanguageConfiguration(ze,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ye.$iF)(ze,"tokenInformation"),ui.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return lt.registerInlayHintsProvider(ze,re,ue)},createLanguageStatusItem(re,ue){return ui.createLanguageStatusItem(ze,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return lt.registerDocumentOnDropEditProvider(ze,re,ue,(0,Ye.$hF)(ze,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const st=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Tt.showTextDocument(st,ue,Oe)},createTextEditorDecorationType(re){return Tt.createTextEditorDecorationType(ze,re)},onDidChangeActiveTextEditor(re,ue,Oe){return Tt.onDidChangeActiveTextEditor(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return Tt.onDidChangeVisibleTextEditors(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return Tt.onDidChangeTextEditorSelection(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return Tt.onDidChangeTextEditorOptions(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return Tt.onDidChangeTextEditorVisibleRanges(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return Tt.onDidChangeTextEditorViewColumn(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return _e.onDidCloseTerminal(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return _e.onDidOpenTerminal(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return _e.onDidChangeActiveTerminal(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ye.$iF)(ze,"terminalDimensions"),_e.onDidChangeTerminalDimensions(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return _e.onDidChangeTerminalState(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ye.$iF)(ze,"terminalDataWriteEvent"),_e.onDidWriteTerminalData(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ye.$iF)(ze,"terminalExecuteCommandEvent"),_e.onDidExecuteTerminalCommand(re,ue,Oe)},get state(){return Fe.getState(ze)},onDidChangeWindowState(re,ue,Oe){return Fe.onDidChangeWindowState(re,ue,Oe)},showInformationMessage(re,...ue){return Ei.showMessage(ze,m.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Ei.showMessage(ze,m.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Ei.showMessage(ze,m.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return ri.showQuickPick(ze,re,ue,Oe)},showWorkspaceFolderPick(re){return ri.showWorkspaceFolderPick(re)},showInputBox(re,ue){return ri.showInput(re,ue)},showOpenDialog(re){return Ni.showOpenDialog(ze,re)},showSaveDialog(re){return Ni.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let st,vt,Nt;return typeof re=="string"?(st=re,vt=ue,Nt=Oe):(vt=re,Nt=ue),_t.createStatusBarEntry(ze,st,vt,Nt)},setStatusBarMessage(re,ue){return _t.setStatusBarMessage(re,ue)},withScmProgress(re){return Ee.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(st){}}))},withProgress(re,ue){return vi.withProgress(ze,re,ue)},createOutputChannel(re,ue){return kt.createOutputChannel(re,ue,ze)},createWebviewPanel(re,ue,Oe,st){return Li.createWebviewPanel(ze,re,ue,Oe,st)},createWebviewTextEditorInset(re,ue,Oe,st){return(0,Ye.$iF)(ze,"editorInsets"),Ci.createWebviewEditorInset(re,ue,Oe,st,ze)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(ze,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ye.$iF)(ze,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,ze.identifier.value,ue)},registerTreeDataProvider(re,ue){return pi.registerTreeDataProvider(re,ue,ze)},createTreeView(re,ue){return pi.createTreeView(re,ue,ze)},registerWebviewPanelSerializer:(re,ue)=>Li.registerWebviewPanelSerializer(ze,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>cn.registerCustomEditorProvider(ze,re,ue,Oe),registerFileDecorationProvider(re){return je.registerFileDecorationProvider(re,ze)},registerUriHandler(re){return mi.registerUriHandler(ze,re)},createQuickPick(){return ri.createQuickPick(ze)},createInputBox(){return ri.createInputBox(ze)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return Ri.onDidChangeActiveColorTheme(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Mi.registerWebviewViewProvider(ze,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return St.onDidChangeActiveNotebookEditor(re,ue,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ue,Oe){return $i.onDidChangeNotebookEditorSelection(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(re,ue,Oe)},showNotebookDocument(re,ue){return St.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ye.$iF)(ze,"externalUriOpener"),un.registerExternalUriOpener(ze.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ye.$iF)(ze,"profileContentHandlers"),ln.registrProfileContentHandler(ze,re,ue)},registerQuickDiffProvider(re,ue,Oe,st){return(0,Ye.$iF)(ze,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(re),ue,Oe,st)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Ye.$iF)(ze,"shareProvider"),Ki.registerShareProvider($t(re),ue)}},sn={get rootPath(){return Ee.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw new T.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>ht.updateWorkspaceFolders(ze,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return ht.onDidChangeWorkspace(re,ue,Oe)},asRelativePath:(re,ue)=>ht.getRelativePath(re,ue),findFiles:(re,ue,Oe,st)=>ht.findFiles(re,ue,Oe,ze.identifier,st),findTextInFiles:(re,ue,Oe,st)=>{(0,Ye.$iF)(ze,"findTextInFiles");let vt,Nt;return typeof ue=="object"?(vt=ue,Nt=Oe):(vt={},Nt=ue,st=Oe),ht.findTextInFiles(re,vt||{},Nt,ze.identifier,st)},save:re=>((0,Ye.$iF)(ze,"saveEditor"),ht.save(re)),saveAs:re=>((0,Ye.$iF)(ze,"saveEditor"),ht.saveAs(re)),saveAll:re=>ht.saveAll(re),applyEdit(re,ue){return Zt.applyWorkspaceEdit(re,ze,ue)},createFileSystemWatcher:(re,ue,Oe,st)=>{let vt;return typeof ue=="boolean"?vt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st,correlate:!1}:ue&&((0,Ye.$iF)(ze,"createFileSystemWatcher"),vt={...ue,correlate:!0}),xt.createFileSystemWatcher(ht,ze,re,vt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>At.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(re,ue,Oe)=>At.onDidAddDocument(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>At.onDidRemoveDocument(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>At.onDidChangeDocument(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>At.onDidSaveDocument(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>Vi.getOnWillSaveTextDocumentEvent(ze)(re,ue,Oe),get notebookDocuments(){return St.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await St.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await St.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return ni.onDidSaveNotebookDocument(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return ni.onDidChangeNotebookDocument(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(ze)(re,ue,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(re,ue,Oe,st){return St.registerNotebookSerializer(ze,re,ue,Oe,(0,Ye.$hF)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>Yi.onDidChangeConfiguration(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,Yi.getConfiguration(re,ue,ze)},registerTextDocumentContentProvider(re,ue){return ki.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Ee.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(ze,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,L.$Pc)(qi.registerFileSystemProvider(ze,re,ue,Oe),Ut.addFileSystemProvider(re,ue,Oe))},get fs(){return Ut.value},registerFileSearchProvider:(re,ue)=>((0,Ye.$iF)(ze,"fileSearchProvider"),Bt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ye.$iF)(ze,"textSearchProvider"),Bt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ye.$iF)(ze,"resolvers"),Et.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ye.$iF)(ze,"resolvers"),Hi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.$iF)(ze,"resolvers"),Et.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>xt.onDidCreateFile(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>xt.onDidDeleteFile(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>xt.onDidRenameFile(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>xt.getOnWillCreateFileEvent(ze)(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>xt.getOnWillDeleteFileEvent(ze)(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>xt.getOnWillRenameFileEvent(ze)(re,ue,Oe),openTunnel:re=>((0,Ye.$iF)(ze,"tunnels"),Lt.openTunnel(ze,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$iF)(ze,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ye.$iF)(ze,"tunnels"),Lt.onDidChangeTunnels(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ye.$iF)(ze,"portsAttributes"),Lt.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ye.$iF)(ze,"tunnelFactory"),Lt.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ye.$iF)(ze,"timeline"),Gi.registerTimelineProvider(re,ue,ze.identifier,Ve.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Ye.$iF)(ze,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>ht.onDidGrantWorkspaceTrust(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ye.$iF)(ze,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ye.$iF)(ze,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(ze)(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ye.$iF)(ze,"canonicalUriProvider"),ht.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ye.$iF)(ze,"canonicalUriProvider"),ht.provideCanonicalUri(re,ue,Oe))},fn={get inputBox(){return Ee.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(ze)},createSourceControl(re,ue,Oe){return di.createSourceControl(ze,re,ue,Oe)},registerSourceControlInputBoxValueProvider(re,ue){return(0,Ye.$iF)(ze,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(ze,re,ue)}},on={createCommentController(re,ue){return Ai.createCommentController(ze,re,ue)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return gt.onDidStartDebugSession(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return gt.onDidTerminateDebugSession(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return gt.onDidChangeActiveDebugSession(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return gt.onDidReceiveDebugSessionCustomEvent(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return gt.onDidChangeBreakpoints(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ye.$iF)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return gt.registerDebugConfigurationProvider(re,ue,Oe||Ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return gt.registerDebugAdapterDescriptorFactory(ze,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return gt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?gt.startDebugging(re,ue,{parentSession:Oe}):gt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return gt.asDebugSourceUri(re,ue)}},Oi={registerTaskProvider:(re,ue)=>yt.registerTaskProvider(ze,re,ue),fetchTasks:re=>yt.fetchTasks(re),executeTask:re=>yt.executeTask(ze,re),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(re,ue,Oe)=>yt.onDidStartTask(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>yt.onDidEndTask(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>yt.onDidStartTaskProcess(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>yt.onDidEndTaskProcess(re,ue,Oe)},zi={createNotebookController(re,ue,Oe,st,vt){return ai.createNotebookController(ze,re,ue,Oe,st,(0,Ye.$hF)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>St.registerNotebookCellStatusBarItemProvider(ze,re,ue),createRendererMessaging(re){return Si.createRendererMessaging(ze,re)},createNotebookControllerDetectionTask(re){return(0,Ye.$iF)(ze,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(ze,re)},registerKernelSourceActionProvider(re,ue){return(0,Ye.$iF)(ze,"notebookKernelSource"),ai.registerKernelSourceActionProvider(ze,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ye.$iF)(ze,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(re,ue,Oe)}},Bi={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(ze.identifier.value,{message:ue,args:Oe})}return bt.getMessage(ze.identifier.value,re[0])},get bundle(){return bt.getBundle(ze.identifier.value)},get uri(){return bt.getBundleUri(ze.identifier.value)}},Di={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ye.$iF)(ze,"interactive"),Ji.registerProvider(ze,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ye.$iF)(ze,"interactive"),gi.registerChatProvider(ze,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ye.$iF)(ze,"interactive"),gi.sendInteractiveRequestToProvider(re,ue)},get onDidPerformUserAction(){return(0,Ye.$iF)(ze,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(re,ue){return(0,Ye.$iF)(ze,"interactive"),gi.transferChatSession(re,ue)}},ji={getRelatedInformation(re,ue){return(0,Ye.$iF)(ze,"aiRelatedInformation"),Xi.getRelatedInformation(ze,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ye.$iF)(ze,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(ze,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ye.$iF)(ze,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(ze,re,ue)}},gn={registerChatResponseProvider(re,ue,Oe){return(0,Ye.$iF)(ze,"chatProvider"),fi.registerProvider(ze.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ye.$iF)(ze,"chatRequestAccess"),fi.requestChatResponseProvider(ze.identifier,re)},registerVariable(re,ue,Oe){return(0,Ye.$iF)(ze,"chatVariables"),Zi.registerVariableResolver(ze,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ye.$iF)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,re,ue)},createChatAgent(re,ue){return(0,Ye.$iF)(ze,"chatAgents2"),Qi.createChatAgent(ze,re,ue)}},mn={registerSpeechProvider(re,ue){return(0,Ye.$iF)(ze,"speech"),wi.registerProvider(ze.identifier,re,ue)}};return{version:mt.version,ai:ji,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Di,l10n:Bi,languages:nn,notebooks:zi,scm:fn,speech:mn,tasks:Oi,tests:en,window:rn,workspace:sn,Breakpoint:Ne.$LL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$DM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$CM,CallHierarchyIncomingCall:Ne.$$K,CallHierarchyItem:Ne.$0K,CallHierarchyOutgoingCall:Ne.$_K,CancellationError:T.$5,CancellationTokenSource:E.$3d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$7K,CodeActionKind:Ne.$8K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$aL,Color:Ne.$nL,ColorInformation:Ne.$oL,ColorPresentation:Ne.$pL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$hL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$iL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$xL,DebugAdapterExecutable:Ne.$PL,DebugAdapterInlineImplementation:Ne.$SL,DebugAdapterNamedPipeServer:Ne.$RL,DebugAdapterServer:Ne.$QL,DebugConfigurationProviderTriggerKind:Ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$1K,DiagnosticRelatedInformation:Ne.$ZK,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$MK,DocumentHighlight:Ne.$3K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$4K,DocumentLink:Ne.$mL,DocumentSymbol:Ne.$6K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$VL,InlineValueText:Ne.$WL,InlineValueVariableLookup:Ne.$XL,InlineValueEvaluatableExpression:Ne.$YL,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$9L,FileDecoration2:Ne.$9L,FileSystemError:Ne.$1L,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$2L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$NL,InlineCompletionItem:Ne.$jL,InlineCompletionList:Ne.$kL,Hover:Ne.$2K,IndentAction:S.IndentAction,Location:Ne.$YK,MarkdownString:Ne.$bL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$cL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$NK,ProcessExecution:Ne.$vL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$8L,Range:Ne.$OK,RelativePattern:Ne.$JL,Selection:Ne.$PK,SelectionRange:Ne.$9K,SemanticTokens:Ne.$5L,SemanticTokensBuilder:Ne.$4L,SemanticTokensEdit:Ne.$6L,SemanticTokensEdits:Ne.$7L,SemanticTokensLegend:Ne.$3L,ShellExecution:Ne.$wL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$eL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$dL,SnippetString:Ne.$XK,SourceBreakpoint:Ne.$ML,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$5K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$yL,TaskGroup:Ne.$uL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$qL,TerminalQuickFixTerminalCommand:Ne.$sL,TerminalQuickFixOpener:Ne.$rL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$tL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$TK,SnippetTextEdit:Ne.$VK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$IL,ThemeIcon:Ne.$HL,TreeItem:Ne.$zL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$rM,UIKind:Ct.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$WK,DocumentDropEdit:Ne.$FL,DocumentPasteEdit:Ne.$GL,InlayHint:Ne.$gL,InlayHintLabelPart:Ne.$fL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$SK,ResolvedAuthority:Ne.$QK,ManagedResolvedAuthority:Ne.$RK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$gM,NotebookRange:Ne.$$L,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$_L,NotebookData:Ne.$aM,NotebookRendererScript:Ne.$eM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$cM,NotebookCellOutputItem:Ne.$bM,NotebookCellStatusBarItem:Ne.$dM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$UK,NotebookKernelSourceAction:Ne.$fM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$iM,LinkedEditingRanges:Ne.$hM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$jM,TestMessage:Ne.$kM,TestMessage2:Ne.$kM,TestTag:Ne.$lM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Ne.$EL,DataTransferItem:Ne.$AL,CoveredCount:Ne.$mM,FileCoverage:Ne.$nM,StatementCoverage:Ne.$oM,BranchCoverage:Ne.$pM,FunctionCoverage:Ne.$qM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$sM,TabInputTextDiff:Ne.$tM,TabInputTextMerge:Ne.$uM,TabInputCustom:Ne.$vM,TabInputNotebook:Ne.$xM,TabInputNotebookDiff:Ne.$yM,TabInputWebview:Ne.$wM,TabInputTerminal:Ne.$zM,TabInputInteractiveWindow:Ne.$AM,TabInputChat:Ne.$BM,TelemetryTrustedValue:t.$vo,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$TL,ThreadFocus:Ne.$UL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$4gc=Gt}),define(Pe[291],Ae([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(me,e,E,T,I,L,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Ir)(d.$Sfc,d.$Rfc,1),(0,E.$Ir)(s.$jj,i.$5gc,1),(0,E.$Ir)(n.$4ec,n.$5ec,1),(0,E.$Ir)(m.$$M,m.$0M,0),(0,E.$Ir)(A.$mfc,A.$kfc,0),(0,E.$Ir)(t.$ofc,t.$nfc,0),(0,E.$Ir)(S.$3fc,S.$7fc,0),(0,E.$Ir)(L.$9fc,L.$8fc,0),(0,E.$Ir)(g.$ZM,g.$YM,0),(0,E.$Ir)(b.$Tfc,b.$Ufc,0),(0,E.$Ir)(r.$1ec,r.$Zec,0),(0,E.$Ir)(T.$Cgc,T.$Bgc,1),(0,E.$Ir)(l.$mgc,l.$ngc,0),(0,E.$Ir)($.$Hfc,$.$Gfc,0),(0,E.$Ir)(R.$Pgc,R.$Ogc,0),(0,E.$Ir)(w.$Kfc,w.$Nfc,0),(0,E.$Ir)(v.$4xb,v.$5xb,0),(0,E.$Ir)(o.$3gc,o.$2gc,0),(0,E.$Ir)(I.$jfc,I.$ifc,0),(0,E.$Ir)(a.$Pfc,a.$Ofc,0),(0,E.$Ir)(c.$9M,c.$6M,0),(0,E.$Ir)(h.$yfc,h.$zfc,0),(0,E.$Ir)(u.$1fc,u.$2fc,0)}),define(Pe[292],Ae([1,0,290,38,2,287,7,14,275]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;class w extends L.$8gc{j(){}getModule($,v){for(const n of this.b){const o=n($);if(o){$=o;break}}if(this.a.has($))return this.a.get($).load($,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.$Wfc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$bjc);const $=this.h.invokeFunction(E.$4gc);this.r=this.h.createInstance(w,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,v,n){v=v.with({path:S(v.path,".js")});const o=$?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=I.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const a=await r.text(),c=`${v.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}$&&await this.w.initializeLocalizedMessages($);const s={},u={exports:s},d=b=>{const f=this.r.getModule(b,v);if(f===void 0)throw new Error(`Cannot load module '${b}'`);return f};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+$;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,m.$2g)(10)}}e.$cjc=R;function S(l,$){return l.endsWith($)?l:l+$}}),define(Pe[293],Ae([1,0,69,70,15,38,200,86,292]),function(me,e,E,T,I,L,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Ir)(I.$ij,new E.$Xh(A.$7gc,[!0],!0)),(0,T.$Ir)(L.$Xfc,g.$cjc,0),(0,T.$Ir)(m.$pfc,m.$qfc,0)}),define(Pe[298],Ae([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(me,e,E,T,I,L,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(i){return/^(file|vscode-remote):/i.test(i)}const v=fetch.bind(self);function n(i){self.fetch=async function(s,u){return s instanceof Request||$(String(s))&&(s=(await i(R.URI.parse(String(s)))).toString(!0)),v(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,b,f){(async()=>($(u.toString())&&(u=(await i(R.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,b,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$jg.uriToBrowserUri(R.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(p){function y(K){return typeof K=="string"||K instanceof URL?String(K).replace(/^file:\/\//i,"vscode-file://vscode-app"):K}const D=fetch.bind(self);self.fetch=function(K,U){return K instanceof Request?D(K,U):D(y(K),U)},self.XMLHttpRequest=class extends XMLHttpRequest{open(K,U,M,B,C){return super.open(K,y(U),M??!0,B,C)}};const O=importScripts.bind(self);self.importScripts=(...K)=>{O(...K.map(y))},O(p)}.toString()}('${s}'))`;u=u||{},u.name=u.name||m.$nc(s.toString());const f=new Blob([b],{type:"application/javascript"}),k=URL.createObjectURL(f);return new i(k,u)}}else self.Worker=class extends A.$djc{constructor(i,s){super(l,i,{name:m.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const s=new MessageChannel,u=new T.$Sd;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=b=>{const{data:f}=b;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const k=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$om)(k,2)){d=!0,a("received terminate message from renderer");return}u.fire(k)},this.protocol={onMessage:u.event,send:b=>{if(!d){const f=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function r(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const b=JSON.parse(d.toString());i.send((0,I.$nm)(0)),s({protocol:i,initData:b})});i.send((0,I.$nm)(1))})}let a=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&r(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new L.$0gc(u.protocol,u.initData,o,null,s.data);n(b=>d.asBrowserUri(b)),a=b=>d.terminate(b)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42053f37e98a2dbaa0d108807491e716105dccd2/core/vs/workbench/api/worker/extensionHostWorker.js.map
